// create namespace
Ext.ns('Ext.ux.form');
Ext.ux.form.MultiCombo = Ext.extend(Ext.form.ComboBox, {
    separator:',',
    imageField:'',
    hideTrigger: true,

    constructor:function(config) {
        config = config || {};
        config.listeners = config.listeners || {};
        Ext.applyIf(config.listeners, {
             scope:this
            ,beforequery:this.onBeforeQuery
        });
        Ext.ux.form.MultiCombo.superclass.constructor.call(this, config);
    }
    ,initComponent:function() {
        // template with checkbox
       if (!this.tpl && this.imageField) {
            this.tpl =
                 '<tpl for=".">'
                +'<div class="x-combo-list-item ux-multi-combo-item" style="{[values.' + this.imageField + '?"background-image:url(" + values.' + this.imageField + ' + ")":""' + ']}">'
                +'{' + this.displayField + '}'
                +'</div>'
                +'</tpl>'
            ;
        }
        // call parent
        Ext.ux.form.MultiCombo.superclass.initComponent.apply(this, arguments);

    }
    ,onBeforeQuery:function(qe) {
		var values=this.getRawValue().split(this.separator);
		//console.log(values);
		if (values.length) {
			qe.query = values[values.length-1];
		} else {
			qe.query = '';
		}
    }
    /**
     * Combo's onSelect override
     * @private
     * @param {Ext.data.Record} record record that has been selected in the list
     * @param {Number} index index of selected (clicked) record
     */
    ,onSelect:function(record, index) {
        if(this.fireEvent('beforeselect', this, record, index) !== false){
			var values=this.getRawValue().split(this.separator);
			values[values.length-1]=record.data[this.valueField || this.displayField].replace(this.separator,' ');

            this.setValue(values.join(this.separator));
            this.collapse();
            this.fireEvent('select', this, record, index);
			//this.collapse();
       }
    } // eo function onSelect
    ,setValue : function(v){
        var text = v;
        /*if(this.valueField){
            var r = this.findRecord(this.valueField, v);
            if(r){
                text = r.data[this.displayField];
            }else if(this.valueNotFoundText !== undefined){
                text = this.valueNotFoundText;
            }
        }*/
        this.lastSelectionText = text;
        if(this.hiddenField){
            this.hiddenField.value = v;
        }
        Ext.form.ComboBox.superclass.setValue.call(this, text);
        this.value = v;
    }
    ,getValueCount : function(){
		var value=this.getRawValue();
		if (value.trim()) {
			return value.split(this.separator).length;
		}
		return 0;
    }
	//Ueberschreieben da Fehler in ExtJs Combo keyup event wird nicht weitergegeben
    ,onKeyUp : function(e){
		//console.log(e);
		//console.log(this);
        if(this.editable !== false && !e.isSpecialKey()){
            this.lastKey = e.getKey();
            this.dqTask.delay(this.queryDelay);
        }
		this.fireEvent('keyup', this, e);
    }


}); // eo extend

// register xtype
Ext.reg('multicombo', Ext.ux.form.MultiCombo);


// eof