<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
//echo date('d.m.Y H:i',1233693481);
//echo mktime(0,0,0,3,1,2009);
//phpinfo();
require("cfg/global.inc.php");
defined('PREPEND_FILE')?require(PREPEND_FILE):die('UPS..');
if (PHP_SAPI == 'cli') {
	parse_str(implode('&', array_slice($argv, 1)), $_GET);	
}
require ("lib/ClassGroupieDB.php");
$db=new GroupieDB($CFG["DATABASE_TYPE"]);
if ($CFG['USER_CLASS']=='ldap') {
	require ("lib/ClassGroupieUser_Ldap.php");
} elseif ($CFG['USER_CLASS']=='ldap_full') {
	require ("lib/ClassGroupieUser_FullLdap.php");
} else {
	require ("lib/ClassGroupieUser_Mysql.php");
}
require ("lib/class_frame_work.inc.php");
$frm=new FrameWork();
$frm->setDb($db);
$frm->setFrmCfg($frm->getCfg('global',0,array('cfg/%','ldap/%')));
if (!defined('GE_CHARSET')) define('GE_CHARSET','UTF-8');
if (GE_CHARSET=='UTF-8') {
	$db->query("SET NAMES 'utf8'");
} else {
	$db->query("SET NAMES 'latin1'");
}
define('APP_THEME',$THEME);
require("cfg/$THEME/config.inc.php");

$frm->setUser(0);
$frm->setLang('en');
require("lib/class_translation.inc.php");
$T=new Translation('en',$MASTER_TPL);
require ("lib/class.mtFastTemplate.php");
$t=new mtFastTemplate ('.',$MASTER_TPL);
require ("lib/class_ApplicationErrorGui.php");
$E=new ApplicationErrorGui();


switch($_GET['action']) {
	default:
		require('lib/cal/cron_alarm.php');
		require('lib/rem/ctrl/geRemCtrlCron.php');
		$remCron=new geRemCtrlCron();
		$remCron->process();
	break;
	case 'importExtAddr':
		if (defined('GE_addrCustomImportTest') && GE_addrCustomImportTest) {
			$TEST=true;
		} else {
			$TEST=$_GET['debug']?true:false;
		}
		if ($TEST) echo '<pre>';
		if (defined('GE_addrCustomImportFile') && GE_addrCustomImportFile) {
			$fileArray=glob(GE_addrCustomImportFile);
			if (is_array($fileArray)) {
				foreach($fileArray as $file) {
					if (is_file($file)) {
						$Addr=& $frm->getStaticModul('addr',true);
						$Addr->setCfg($frm->getCfg($Addr->getModul(),0,'cfg/%'));
						$Addr->setLang($frm->getLang());
						$Addr->setRule(1);
						$Addr->loadFields();
						if (!defined('GE_addrCustomImportArchiv') || !GE_addrCustomImportArchiv || !is_dir(GE_addrCustomImportArchiv) || !is_writable(GE_addrCustomImportArchiv)) {
							$archivPath=Framework::getTempPath();
						} else {
							$archivPath=GE_addrCustomImportArchiv;
						}
						$impFile=$archivPath.'/'.date('Ymd-His_').basename($file);
						if ($TEST) 	echo "Moving ".$file." -> ".$impFile."\n";
						if (rename($file,$impFile)) {
							if ($TEST) {
								echo "File moved \n";
								copy($impFile,$file);
							}
							$errors=$Addr->importExport($impFile,$TEST);
							if ($errors) {
								foreach ($errors as $val) {
									echo 'GROUP-E AddrImportError: '.$val."\n";
									syslog(LOG_ERR,'GROUP-E AddrImportError: '.$val);
								}
							}
						}
					}
				}
			}
		} elseif ($TEST) {
			echo "NO Import file\n";
		}
	break;
	case 'crawlVirtualFiles':
		require_once('lib/fmng/header.php');
		$search=array(
			'reconstruct'=>FrameWork::getParam('reconstruct',0),
			'DocType'=>FrameWork::getParam('DocType','ext'),
			'allVersions'=>FrameWork::getParam('allVersions',0),
			'updateFiles'=>FrameWork::getParam('updateFiles',0),
		);
		$num=$Fmng->crawlDocuments($search);
		echo 'Indexed:'.$num;
		
	break;
	case 'syncVirtualFiles':
		if (defined('GE_fmngCustomSyncSource') && defined('GE_fmngCustomSyncTarget') && GE_fmngCustomSyncSource && GE_fmngCustomSyncTarget) {
			set_time_limit(1200);
			$sources=explode(',',GE_fmngCustomSyncSource);
			$targets=explode(',',GE_fmngCustomSyncTarget);
			if (count($sources)!=count($targets)) {
				throw new Exception('syncVirtualFiles: different source and target count');
			}
			echo '<pre>';
			$Fmng=$frm->getStaticModul('fmng');
			$Fmng->setUser(defined('GE_fmngCustomSyncUser')?GE_fmngCustomSyncUser:$GLOBALS['CFG']['SUPERADMIN']);
			$Fmng->setRule(true);
			for($i=0;$i<count($sources);$i++) {
				$num=$Fmng->syncDocuments($sources[$i],$targets[$i],1);
			}
			
		}

	break;
}
?>