Ext.ns('ge.core.view');
ge.core.view.message = Ext.extend(Ext.Window, {
	options: {},
	layout: 'fit',
	title: $T('[[Nachricht versenden]]'),
	height: 480,
	width: 850,
	closeAction: 'hide',
	id:'coreMessage',
	stateful:false,
	initComponent: function() {
		this.stateData = ge.getFormStateData('coreMessage') || {};
		var config={
			border:false,
			items: [{
				id: 'coreMessageTabpanel',
				xtype: 'tabpanel',
				activeTab: 0,
				plain: true,
				//items: [],
				listeners:{
					'beforetabchange' : function (me, newTab, currentTab ) {
						if (currentTab) {
							var win=this.findParentByType(ge.core.view.message);
							win.stateData.activeTab=newTab.getId();
							ge.setFormStateData('coreMessage',win.stateData);
						}
					}
				}
			}],
			buttons: [{
				text     : $T('[[Versenden]]'),
				handler : function () {
					if(Ext.getCmp('coreMessageTabpanel').getActiveTab().geHandleSubmit()) {

					}
				}
			},{
				text     : $T('[[Abbrechen]]'),
				handler : function () {
					this.findParentByType(ge.core.view.message).hide();
				}
			}]
		};
		this.geMsgShow = function(msgParams) {
			var params={
				'msgSendMsg':{
					'msgSendmsgForm':{}
				},
				'smsSendSms':{
					'smsSendsmsForm':{}
				},
				'remSendRem':{
					'remSendremForm':{}
				}
			};
			if (!this.isVisible()) {
				if (msgParams.invReset) {
					params.msgSendMsg.resetForm=true;
					params.smsSendSms.resetForm=true;
					params.remSendRem.resetForm=true;
				}
				if (msgParams.invTab) {
					switch(msgParams.invTab) {
						case 'sms':
							params.activeTab='smsSendSms';
						break;
						case 'msg':
							params.activeTab='msgSendMsg';
						break;
						case 'rem':
							params.activeTab='remSendRem';
						break;
					}
				}
			}
			if (msgParams.reset) {
				params.msgSendMsg.resetForm=true;
				params.smsSendSms.resetForm=true;
				params.remSendRem.resetForm=true;
			}
			if (msgParams.tab) {
				switch(msgParams.tab) {
					case 'sms':
						params.activeTab='smsSendSms';
					break;
					case 'msg':
						params.activeTab='msgSendMsg';
					break;
					case 'rem':
						params.activeTab='remSendRem';
					break;
				}
			}
			if (msgParams.msgTo) {
				params.msgSendMsg.msgSendmsgForm.msg_to=msgParams.msgTo;
			}
			if (msgParams.msgSubject) {
				params.msgSendMsg.msgSendmsgForm.msg_subject=msgParams.msgSubject;
			}
			if (msgParams.msgMessage) {
				params.msgSendMsg.msgSendmsgForm.msg_message=msgParams.msgMessage;
			}
			if (msgParams.msgLink) {
				params.msgSendMsg.msgSendmsgForm.msg_link=msgParams.msgLink;
			}
			if (msgParams.msgImage) {
				params.msgSendMsg.msgSendmsgForm.msg_image=msgParams.msg_image;
			}
			if (msgParams.msgToAdd) {
				params.msgSendMsg.msgSendmsgToAdd=msgParams.msgToAdd;
			}
			if (msgParams.smsTo) {
				params.smsSendSms.smsSendsmsForm.msg_to=msgParams.smsTo;
			}
			if (msgParams.smsMessage) {
				params.smsSendSms.smsSendsmsForm.msg_message=msgParams.smsMessage;
			}
			if (msgParams.smsToAdd) {
				params.smsSendSms.smsSendsmsToAdd=msgParams.smsToAdd;
			}
			if (msgParams.remId) {
				params.remSendRem.remSendremForm.rem_id=msgParams.remId;
			}
			if (msgParams.remSenddate) {
				params.remSendRem.remSendremForm.rem_senddate=msgParams.remSenddate;
			}
			if (msgParams.remMessage) {
				params.remSendRem.remSendremForm.rem_message=msgParams.remMessage;
			}
			if (msgParams.remObjTyp) {
				params.remSendRem.remSendremForm.rem_obj_typ=msgParams.remObjTyp;
			}
			if (msgParams.remObjId) {
				params.remSendRem.remSendremForm.rem_obj_id=msgParams.remObjId;
			}
			if (msgParams.remObjName) {
				params.remSendRem.remSendremForm.rem_obj_name=msgParams.remObjName;
			}
			if (msgParams.remSendby) {
				params.remSendRem.remSendremForm.rem_sendby=msgParams.remSendby;
			}
			if (Ext.getCmp('msgSendMsg')) {
				Ext.getCmp('msgSendMsg').setOptions({init:params.msgSendMsg});
			}
			if (Ext.getCmp('smsSendSms')) {
				Ext.getCmp('smsSendSms').setOptions({init:params.smsSendSms});
			}
			if (Ext.getCmp('remSendRem')) {
				Ext.getCmp('remSendRem').setOptions({init:params.remSendRem});
			}
			if (!this.isVisible()) {
				this.show();
			}
			if (Ext.getCmp('msgSendMsg')) {
				Ext.getCmp('msgSendMsg').renderOptions();
			}
			if (Ext.getCmp('smsSendSms')) {
				Ext.getCmp('smsSendSms').renderOptions();
			}
			if (Ext.getCmp('remSendRem')) {
				Ext.getCmp('remSendRem').renderOptions();
			}
			if (params.activeTab) {
				this.stateData.activeTab=params.activeTab;
			}
			if (this.stateData.activeTab && this.getComponent('coreMessageTabpanel').getItem(this.stateData.activeTab)) {
				this.getComponent('coreMessageTabpanel').setActiveTab(this.stateData.activeTab);
			}
		};
		Ext.applyIf(this, config);
		ge.core.view.message.superclass.initComponent.call(this);
	}
});
