Ext.ns('ge.msg.view');
ge.msg.view.sendmsg = Ext.extend(Ext.Panel, {
	options: {
		init:{}
	},
	layout: 'fit',
	id: 'msgSendMsg',
	title: $T('[[Message]]'),
	initComponent: function() {
		var tplLink = new Ext.XTemplate(
			'<tpl for=".">',
			'<img src="img/ge/omng_goto.gif" vspace="2" hspace="2"><a href="{U}">{N}</a>&nbsp;&nbsp;',
			'</tpl>');
		function handleResult(response) {
			//console.log(response);
			var result;
			try {
				result=Ext.decode(response.responseText);
			} catch (e) {
				result={
					result:{
						error:'BAD'
					}
				};
			}
			//console.log(result);
			switch(result.result.error){
				case 'OK':
					Ext.getCmp('msgSendmsgForm').getForm().reset();
					ge.registry.coreViewMessage.hide();
					ge.info($T('[[ErrorInfo]]'),result.result.error_msg);
					Ext.getCmp('msgSendMsg').fireEvent('geMsgSend',Ext.getCmp('msgSendMsg'));
				break;
				case 'MSG':
					ge.alert($T('[[ErrorError]]'),result.result.error_msg);
				break;
				default:
					ge.alert($T('[[ErrorError]]'),$T('[[ErrorTextGeneric]]'));
				break;
			}


		}
		this.msgUpdateLink = function() {
			var value=this.findById('smsSendmsgLink').getValue();
			//console.log(value);
			try {
				if (value) {
					var links=Ext.decode(value);

					tplLink.overwrite('smsSendmsgLink',links);
				} else {
					Ext.get('smsSendmsgLink').update('');
				}
			} catch(e) {

			}
		};
		this.geHandleSubmit = function() {
			//console.log(this.getComponent('msgSendmsgForm').getForm().getValues());
			if (this.getComponent('msgSendmsgForm').getForm().isValid()) {

				var saveData = this.getComponent('msgSendmsgForm').getForm().getValues();
				saveData.extAction="geMsgCtrlAjax";
				saveData.extMethod="sendMsgMessage";
				Ext.Ajax.request({
					waitMsg: $T('[[Bitte warten]]'),
					url: 'router.php',
					params: saveData,
					success: function(response){
						handleResult(response);
					},
					failure: function(response){
						handleResult(response);
					}
				});
			}
			return false;
		};
		this.setOptions = function(init) {
			Ext.apply(this.options,init);
		};
		this.renderOptions = function() {
			var init=this.options.init;
			//console.log(init);
			ge.addFormState(this.findById('msgSendmsgForm'));

			if (init.resetForm) {
				this.findById('msgSendmsgForm').getForm().reset();
			}
			if (init.msgSendmsgForm) {
				this.findById('msgSendmsgForm').getForm().setValues(init.msgSendmsgForm);
				this.findById('msgSendmsgForm').getForm().clearInvalid();
			} else if (ge.getFormState(this.findById('msgSendmsgForm'))) {
				this.findById('msgSendmsgForm').getForm().setValues(ge.getFormState(this.findById('msgSendmsgForm')));
				this.findById('msgSendmsgForm').getForm().clearInvalid();

			}
			if (init.msgSendmsgToAdd) {
				var fieldVal=this.findById('msgSendmsgTo').getValue();
				if (fieldVal) {
					fieldVal+=',';
				}
				fieldVal+=init.msgSendmsgToAdd;
				this.findById('msgSendmsgTo').setValue(fieldVal);
			}
			ge.clearFormState(this.findById('msgSendmsgForm'));
			this.msgUpdateLink();
		};

		Ext.applyIf(this, {
			border:false,
			items: [
				{
					xtype: 'form',
					id: 'msgSendmsgForm',
					layout: 'fit',
					border:false,
					bodyStyle:'padding:10px',
					labelAlign  : 'left',
					labelWidth:150,
					items: [
						{
							xtype: 'fieldset',
							layout: 'form',
							title: $T('[[Message versenden]]'),
							items: [
								{
									xtype: 'boxselect',
									queryDelay:100,
									minChars:2,
									name: 'msg_to',
									id: 'msgSendmsgTo',
									//anchor:'100%',
									//resizable: true,
									allowBlank: true,
									fieldLabel: '<a id="msgSendmsgToLabelA">' + $T('[[BenutzerIn]]') + '</a>' + '/' + '<a id="msgSendmsgToLabelB">' + $T('[[Gruppe]]') + '</a>',
									store: new ge.msg.store.recipient(),
									width: 600,
									valueField:'value',
									displayField:'name',
									imageField:'img',
									addUniqueValues: true,
									listeners:{
										'render':function(comp) {
											Ext.get('msgSendmsgToLabelA').on('click', function() {
												this.focus();
												this.doQuery('__USERS',true);
											},this);
											Ext.get('msgSendmsgToLabelB').on('click', function() {
												this.focus();
												this.doQuery('__GROUPS',true);
											},this);
											comp.container.first('div.x-form-field-wrap').createChild({
												tag:'img',
												cls:'close',
												src:'img/ge/clear.gif',
												style:'position:absolute;right:0px;top:3px;cursor:pointer;'
											}).on('click',function() {
												comp.setRawValue('');
												comp.setValue('');
												//comp.applyEmptyText();
											});
											
										},
										'expand':function() {
											//alert('expand');
										}
									}

								},{
									xtype: 'textfield',
									name: 'msg_subject',
									id: 'msgSendmsgSubject',
									fieldLabel: $T('[[Betreff]]'),
									allowBlank: false,
									width: 600
								},{
									xtype: 'textarea',
									name: 'msg_message',
									id: 'msgSendmsgMessage',
									fieldLabel: $T('[[Nachricht_sin]]'),
									allowBlank: true,
									height: 170,
									width: 600,
									listeners:{
										'render':function(comp) {
											Ext.DomHelper.insertAfter(comp.el.dom, {
												tag: 'div',
												id: 'smsSendmsgLink',
												html:'&nbsp;'
											});
										}
									}
								},{
									xtype: 'hidden',
									id: 'smsSendmsgLink',
									name: 'msg_link'
								},{
									xtype: 'ux-radiogroup',
									name: 'msg_image',
									id: 'msgSendmsgImage',
									horizontal: true,
									//hideLabel:true,
									//hideLabel:true,
									fieldLabel: '',
									labelSeparator: '',
									allowBlank: false,
									radios: [{
											boxLabel:'<img class="ge-msg-ico" src="img/ge/msg_1.gif">',
											value:'msg_1.gif',
											checked: true
										},{
											boxLabel:'<img class="ge-msg-ico" src="img/ge/msg_0.gif">',
											value:'msg_0.gif'
										},{
											boxLabel:'<img class="ge-msg-ico" src="img/ge/msg_2.gif">',
											value:'msg_2.gif'
										},{
											boxLabel:'<img class="ge-msg-ico" src="img/ge/msg_3.gif">',
											value:'msg_3.gif'
										},{
											boxLabel:'<img class="ge-msg-ico" src="img/ge/msg_4.gif">',
											value:'msg_4.gif'
										},{
											boxLabel:'<img class="ge-msg-ico" src="img/ge/msg_5.gif">',
											value:'msg_5.gif'
										},{
											boxLabel:'<img class="ge-msg-ico" src="img/ge/msg_6.gif">',
											value:'msg_6.gif'
										},{
											boxLabel:'<img class="ge-msg-ico" src="img/ge/msg_7.gif">',
											value:'msg_7.gif'
										},{
											boxLabel:'<img class="ge-msg-ico" src="img/ge/msg_8.gif">',
											value:'msg_8.gif'
										},{
											boxLabel:'<img class="ge-msg-ico" src="img/ge/msg_9.gif">',
											value:'msg_9.gif'
										},{
											boxLabel:'<img class="ge-msg-ico" src="img/ge/msg_10.gif">',
											value:'msg_10.gif'
										},{
											boxLabel:'<img class="ge-msg-ico" src="img/ge/msg_11.gif">',
											value:'msg_11.gif'
										}
									]
								}
							]
						}
					]
				}
			]
		});
		ge.msg.view.sendmsg.superclass.initComponent.call(this);
	}
});
