Ext.ns('ge.rem.view');
ge.rem.view.sendrem = Ext.extend(Ext.Panel, {
	options: {
		timePreset:[],
		defaultIdentity: 0,
		init:{}
	},
	layout: 'fit',
	id: 'remSendRem',
	title: $T('[[remTitle]]'),
	initComponent: function() {
		var tplSub = new Ext.XTemplate(
			'<img src="img/ge/omng_goto.gif" vspace="2" hspace="2">{N}&nbsp;'
		);
		function handleResult(response) {
			//console.log(response);
			var result;
			try {
				result=Ext.decode(response.responseText);
			} catch (e) {
				result={
					result:{
						error:'BAD'
					}
				};
			}
			//console.log(result);
			switch(result.result.error){
				case 'OK':
					Ext.getCmp('remSendremForm').getForm().reset();
					ge.registry.coreViewMessage.hide();
					ge.info($T('[[ErrorInfo]]'),result.result.error_msg);
					Ext.getCmp('remSendRem').fireEvent('geRemSend',Ext.getCmp('remSendRem'));
				break;
				case 'MSG':
					ge.alert($T('[[ErrorError]]'),result.result.error_msg);
				break;
				default:
					ge.alert($T('[[ErrorError]]'),$T('[[ErrorTextGeneric]]'));
				break;
			}


		}
		this.remUpdateSub = function() {
			try {
				if (this.findById('remSendremObjName').getValue()) {
					var obj={
						'N':this.findById('remSendremObjName').getValue()
					}
					tplSub.overwrite('remSendremMessageSub',obj);
				} else {
					Ext.get('remSendremMessageSub').update('');
				}
			} catch(e) {

			}
		};
		this.geHandleSubmit = function() {
			//console.log(this.getComponent('remSendremForm').getForm().getValues());
			if (this.getComponent('remSendremForm').getForm().isValid()) {
				var saveData = this.getComponent('remSendremForm').getForm().getValues();
				saveData.extAction="geRemCtrlAjax";
				saveData.extMethod="sendRemMessage";
				Ext.Ajax.request({
					waitMsg: $T('[[Bitte warten]]'),
					url: 'router.php',
					params: saveData,
					success: function(response){
						handleResult(response);
					},
					failure: function(response){
						handleResult(response);
					}
				});
			}
			return false;
		};
		this.setOptions = function(init) {
			Ext.apply(this.options,init);
		};
		this.renderOptions = function() {
			var init=this.options.init;
			//console.log(init);
			ge.addFormState(this.findById('remSendremForm'));

			if (init.resetForm) {
				this.findById('remSendremForm').getForm().reset();
			}
			if (init.remSendremForm) {
				this.findById('remSendremForm').getForm().setValues(init.remSendremForm);
				if (init.remSendremForm.rem_sendby)  {
					this.findById('remSendremSendby').setValue(init.remSendremForm.rem_sendby);
				}
				this.findById('remSendremForm').getForm().clearInvalid();
			} else {
				if (ge.getFormState(this.findById('remSendremForm'))) {
					this.findById('remSendremForm').getForm().setValues(ge.getFormState(this.findById('remSendremForm')));
					this.findById('remSendremForm').getForm().clearInvalid();
				}

			}
			ge.clearFormState(this.findById('remSendremForm'));
			this.remUpdateSub();
		};

		var fieldItems=[{
				xtype: 'combo',
				id: 'remSendremPreset',
				hiddenName: 'rem_preset',
				fieldLabel: $T('[[remSenddate]]'),
				editable: false,
				forceSelection: true,
				triggerAction: 'all',
				mode: 'local',
				valueField:'n',
				displayField:'n',
				store:new Ext.data.JsonStore({
					data: {'root':this.options.timePreset},
					root: 'root',
					fields: [{name:'n', type: 'string'}, {name:'d', type:'int'}, {name:'m', type:'int'}, {name:'h', type:'int'}, {name:'i', type:'int'}]
				}),
				allowBlank: true,
				width: 250,
				lazyInit:false,
				emptyText: $T('[[-- Bitte waehlen --]]'),
				listeners:{
					focus:function(field) {
						this.doQuery('',true);
					},
					select:function(me,record) {
						//console.log(record.data.email);
						//console.log(Ext.getCmp('smsSendsmsFromEmail'));
						var nd = new Date();
						if (record.data.d > 0 ) {
							nd.setDate(nd.getDate()+ record.data.d);
						} else if (record.data.d < 0) {
							nd.setDate(Math.abs(record.data.d));
						}
						if (record.data.m > 0 ) {
							nd.setMonth(nd.getMonth()+ record.data.m);
						} else if (record.data.m < 0) {
							nd.setMonth(Math.abs(record.data.m) -1 );
						}
						if (record.data.h > 0 ) {
							nd.setHours(nd.getHours()+ record.data.h);
						} else if (record.data.h < 0) {
							nd.setHours(Math.abs(record.data.h));
						}
						if (record.data.i < 0 || record.data.h < 0  ) {
							nd.setMinutes(Math.abs(record.data.i));
						} else if (record.data.i > 0) {
							nd.setMinutes(nd.getMinutes()+ record.data.i);
						}
						Ext.getCmp('remSendremSenddate').setValue(nd);
						Ext.getCmp('remSendremMessage').focus(false,true);
						//this.setValue('kjhjkh');
						//console.log(this.getValue());
						//console.log(this.getRawValue());
					}
				},
				value: this.options.defaultIdentity
			},{
				xtype:'xdatetime',
				//fieldLabel: $T('[[remSenddate]]'),
				labelSeparator: '',
				name: 'rem_senddate',
				id: 'remSendremSenddate',
				dateFormat:'d.m.Y',
				timeFormat:'H:i',
				timeWidth:80,
				selectOnFocus : true,
				width: 250,
				value: new Date(),
				minValue: new Date(),
				timeConfig:{
					hideTrigger:true
				}
			},{
				xtype: 'textarea',
				name: 'rem_message',
				id: 'remSendremMessage',
				fieldLabel: $T('[[Nachricht_sin]]'),
				allowBlank: true,
				height: 200,
				width: 600,
				listeners:{
					'render':function(comp) {
						Ext.DomHelper.insertAfter(comp.el.dom, {
							tag: 'div',
							id: 'remSendremMessageSub',
							html:'&nbsp;'
						});
					}
				}
			},{
				xtype: 'hidden',
				id: 'remSendremObjName',
				name: 'rem_obj_name'
			},{
				xtype: 'hidden',
				id: 'remSendremObjTyp',
				name: 'rem_obj_typ'
			},{
				xtype: 'hidden',
				id: 'remSendremObjId',
				name: 'rem_obj_id'
			},{
				xtype: 'hidden',
				id: 'remSendremId',
				name: 'rem_id'
			}
		];
		if (this.options.showSms || this.options.showMail || this.options.showMsg) {
			var fieldRadios=[];
			if (this.options.showMsg) {
				fieldRadios.push({
					boxLabel:$T('[[remMsg]]'),
					value:'msg',
					bodyStyle: 'font-weight:normal',
					checked: false
				});
			}
			if (this.options.showMail) {
				fieldRadios.push({
					boxLabel:$T('[[remMail]]'),
					value:'mail',
					bodyStyle: 'font-weight:normal',
					checked: false
				});
			}
			if (this.options.showSms) {
				fieldRadios.push({
					boxLabel:$T('[[remSms]]'),
					value:'sms',
					bodyStyle: 'font-weight:normal',
					checked: false
				});
			}
			fieldItems.push({
				xtype: 'ux-checkgroup',
				name: 'rem_sendby[]',
				id: 'remSendremSendby',
				horizontal: true,
				fieldLabel: $T('[[remSendby]]'),
				//labelSeparator: '',
				allowBlank: false,
				radios: fieldRadios
			});
		}
		Ext.applyIf(this, {
			border:false,
			items: [
				{
					xtype: 'form',
					id: 'remSendremForm',
					layout: 'fit',
					border:false,
					bodyStyle:'padding:10px',
					labelAlign  : 'left',
					labelWidth:150,
					items: [
						{
							xtype: 'fieldset',
							layout: 'form',
							title: $T('[[remHeader]]'),
							items: fieldItems
						}
					]
				}
			]
		});
		ge.rem.view.sendrem.superclass.initComponent.call(this);
	}
});
