Ext.ns('ge.sms.view');
ge.sms.view.sendsms = Ext.extend(Ext.Panel, {
	options: {
		storeIdentities:[],
		defaultIdentity: 0,
		storeLists:[{name:'ss',id:4}],
		init:{}
	},
	layout: 'fit',
	id: 'smsSendSms',
	title: $T('[[SMS]]'),
	initComponent: function() {
		var tplCnt = new Ext.XTemplate(
			'<tpl if="cnt_chr == 1">',
				'{cnt_chr} ' + $T('[[Zeichen_sin]]'),
			'</tpl>',
			'<tpl if="cnt_chr != 1">',
				'{cnt_chr} ' + $T('[[Zeichen_mul]]'),
			'</tpl>',
			' / ',
			'<tpl if="cnt_msg == 1">',
				'{cnt_msg} ' + $T('[[Nachricht_sin]]'),
			'</tpl>',
			'<tpl if="cnt_msg != 1">',
				'{cnt_msg} ' + $T('[[Nachricht_mul]]'),
			'</tpl>',
			' / ',
			'<tpl if="cnt_to == 1">',
				'{cnt_to} ' + $T('[[Empfaenger_sin]]'),
			'</tpl>',
			'<tpl if="cnt_to != 1">',
				'{cnt_to} ' + $T('[[Empfaenger_mul]]'),
			'</tpl>');

		function handleResult(response) {
			//console.log(response);
			var result;
			try {
				result=Ext.decode(response.responseText);
			} catch (e) {
				result={
					'result':{
						error:'BAD'
					}
				};
			}
			//console.log(result);
			switch(result.result.error){
				case 'OK':
					Ext.getCmp('smsSendsmsForm').getForm().reset();
					ge.registry.coreViewMessage.hide();
					ge.info($T('[[ErrorInfo]]'),result.result.error_msg);
					Ext.getCmp('smsSendSms').fireEvent('geSmsSend',Ext.getCmp('smsSendSms'));
				break;
				case 'MSG':
					ge.alert($T('[[ErrorError]]'),result.result.error_msg);
				break;
				default:
					ge.alert($T('[[ErrorError]]'),$T('[[ErrorTextGeneric]]'));
				break;
			}

		}

		this.geHandleSubmit = function() {
			if (this.getComponent('smsSendsmsForm').getForm().isValid()) {
				var saveData = this.getComponent('smsSendsmsForm').getForm().getValues();
				saveData.extAction="geSmsCtrlAjax";
				saveData.extMethod="sendSmsMessage";
				Ext.Ajax.request({
					waitMsg: $T('[[Bitte warten]]'),
					url: 'router.php',
					params: saveData,
					success: function(response){
						handleResult(response);
					},
					failure: function(response){
						handleResult(response);
					}
				});
			}
			return false;
		};
		this.smsUpdateCnt = function() {
			var msg_to=this.findById('smsSendsmsTo').getValueCount();
			if (this.options.bulkListObj && this.options.bulkListObj.num) {
				msg_to+=this.options.bulkListObj.num;
			}
			var msg_message=this.findById('smsSendsmsMessage').getValue();
			//if (msg_message) {
				var msg_length=msg_message.length;
				if (msg_length > 160) {
					tplCnt.overwrite('smsSendsmsMessageCnt',{cnt_to:msg_to,cnt_chr:msg_length,cnt_msg:Math.ceil(msg_length/153)});
				} else {
					tplCnt.overwrite('smsSendsmsMessageCnt',{cnt_to:msg_to,cnt_chr:msg_length,cnt_msg:1});
				}
			//}
		};
		this.setOptions = function(init) {
			//console.log(init);
			Ext.apply(this.options,init);
		};
		this.renderOptions = function() {
			//console.log('render options');
			var init=this.options.init;
			//console.log(init);
			ge.addFormState(this.findById('smsSendsmsForm'));

			if (init.resetForm) {
				this.findById('smsSendsmsForm').getForm().reset();
			}
			if (init.smsSendsmsForm) {
				this.findById('smsSendsmsForm').getForm().setValues(init.smsSendsmsForm);
				this.findById('smsSendsmsForm').getForm().clearInvalid();
			} else if (ge.getFormState(this.findById('smsSendsmsForm'))) {
				this.findById('smsSendsmsForm').getForm().setValues(ge.getFormState(this.findById('smsSendsmsForm')));
				this.findById('smsSendsmsForm').getForm().clearInvalid();
			}
			if (init.smsSendsmsToAdd) {
				var fieldVal=this.findById('smsSendsmsTo').getValue();
				//console.log('fieldval' + fieldVal);
				if (fieldVal) {
					fieldVal+=',';
				}
				fieldVal+=init.smsSendsmsToAdd;
				this.findById('smsSendsmsTo').setValue(fieldVal);
			}
			if (!this.options.storeLists.length) {
				Ext.getCmp('smsSendsmsBulk').getEl().parent().parent().parent().remove();
			}

								 
			this.smsUpdateCnt();
			ge.clearFormState(this.findById('smsSendsmsForm'));
		};
		Ext.applyIf(this, {
			border:false,
			items: [
				{
					xtype: 'form',
					id: 'smsSendsmsForm',
					layout: 'fit',
					border:false,
					bodyStyle:'padding:10px',
					labelAlign  : 'left',
					labelWidth:150,
					items: [
						{
							xtype: 'fieldset',
							layout: 'form',
							title: $T('[[SMS versenden]]'),
							items: [
								{
									xtype:'xdatetime',
									fieldLabel: $T('[[Versenden am]]'),
									name: 'msg_senddate',
									id: 'smsSendsmsSenddate',
									dateFormat:'d.m.Y',
									timeFormat:'H:i',
									timeWidth:80,
									selectOnFocus : true,
									width: 250,
									value: new Date(),
									minValue: new Date(),
									timeConfig:{
										hideTrigger:true
									}
								},{
									xtype: 'combo',
									id: 'smsSendsmsFrom',
									hiddenName: 'msg_from',
									fieldLabel: $T('[[Absender]]'),
									editable: false,
									forceSelection: true,
									triggerAction: 'all',
									mode: 'local',
									valueField:'number',
									displayField:'name',
									store:new Ext.data.JsonStore({
										data: {'root':this.options.storeIdentities},
										root: 'root',
										fields: [ {name:'name', type: 'string'}, {name:'number', type:'string'}, {name:'email', type:'string'}]
									}),
									allowBlank: false,
									width: 250,
									lazyInit:false,
									emptyText: $T('[[-- Bitte waehlen --]]'),
									listeners:{
										focus:function(field) {
											this.doQuery('',true);
										},
										select:function(me,record) {
											//console.log(record.data.email);
											//console.log(Ext.getCmp('smsSendsmsFromEmail'));
											Ext.getCmp('smsSendsmsFromEmail').setValue(record.data.email);
											//this.setValue('kjhjkh');
											//console.log(this.getValue());
											//console.log(this.getRawValue());
										}
									},
									value: this.options.defaultIdentity

								},{
									xtype: 'combo',
									id: 'smsSendsmsBulk',
									hiddenName: 'msg_bulk',
									fieldLabel: $T('[[Adresslisten]]'),
									editable: false,
									forceSelection: true,
									triggerAction: 'all',
									mode: 'local',
									valueField:'id',
									displayField:'name',
									store:new Ext.data.JsonStore({
										data: {'root':this.options.storeLists},
										root: 'root',
										fields: [ {name:'name', type: 'string'}, {name:'id', type:'int'}]
									}),
									allowBlank: true,
									width: 250,
									lazyInit:false,
									emptyText: $T('[[-- Bitte waehlen --]]'),
									listeners:{
										render:function() {
											
										},
										focus:function(field) {
											this.doQuery('',true);
										},
										select:function(me,record) {
											Ext.Ajax.request({
												scope: this,
												waitMsg: $T('[[Bitte warten]]'),
												url: 'router.php',
												params: {
													'extAction':"geSmsCtrlAjax",
													'extMethod':"getBulkList",
													'vsrid':record.data.id
												},
												success: function(response){
													try {
														result=Ext.decode(response.responseText);
														this.findParentByType(ge.sms.view.sendsms).setOptions({'bulkListObj':result.result});
														this.findParentByType(ge.sms.view.sendsms).smsUpdateCnt();
														if (result.result.num) {
															Ext.getCmp('smsSendsmsTo').allowBlank=true;
														} else {
															Ext.getCmp('smsSendsmsTo').allowBlank=false;;
														}
														Ext.getCmp('smsSendsmsTo').validate();
														Ext.getCmp('smsSendsmsTo').clearInvalid();
													
													} catch (e) {

													}
												},
												failure: function(response){
													
												}
											});
										}
									}/*,
									value: 0*/

								},{
									xtype: 'hidden',
									id: 'smsSendsmsFromEmail',
									name: 'msg_from_email',
									value: this.options.defaultEmail
								},{
									xtype: 'multicombo',
									queryDelay:100,
									minChars:2,
									name: 'msg_to',
									id: 'smsSendsmsTo',
									//anchor:'100%',
									//resizable: true,
									allowBlank: false,
									fieldLabel: $T('[[Empfaenger_mul]]'),
									store: new ge.sms.store.recipient(),
									width: 600,
									imageField:'img',
									valueField:'value',
									displayField:'name',
									displayFieldTpl: '{name} <{number}>',
									enableKeyEvents: true,
									listeners:{
										'keyup':function() {
											this.findParentByType(ge.sms.view.sendsms).smsUpdateCnt();
										},
										'select':function() {
											this.findParentByType(ge.sms.view.sendsms).smsUpdateCnt();
										},
										'render':function(comp) {
											comp.container.first('div.x-form-field-wrap').createChild({
												tag:'img',
												cls:'close',
												src:'img/ge/clear.gif',
												style:'position:absolute;right:2px;top:2px;cursor:pointer;'
											}).on('click',function() {
												comp.setRawValue('');
												comp.setValue('');
												//comp.applyEmptyText();
											});
											
										}
									}
								},{
									xtype: 'textarea',
									name: 'msg_message',
									id: 'smsSendsmsMessage',
									fieldLabel: $T('[[Nachricht_sin]]'),
									allowBlank: false,
									height: 170,
									width: 600,
									maxLength:1530,
									enableKeyEvents: true,
									listeners:{
										'render':function(comp) {
											Ext.DomHelper.insertAfter(comp.el.dom, {
												tag: 'div',
												id: 'smsSendsmsMessageCnt'
											});
										},
										'keyup':function() {
											this.findParentByType(ge.sms.view.sendsms).smsUpdateCnt();
										}
									}
								}
							]
						}
					]
				}
			]
		});
		ge.sms.view.sendsms.superclass.initComponent.call(this);
	}
});
