<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class GroupieDB extends DB_groupie {
	function GroupieDB ($db_type='') {
		parent::DB_groupie();
		if (!$db_type) $db_type='MySQL';
		$this->_db_type=$db_type;
	}
	function insert ($table,$values,$func=0,$replace=0,$ignore=0) {
		if (!is_array($values) || !count($values)) return false;
		$values=$this->escape($values);
		if (is_array($func)) {
			foreach($func as $key=>$val) {
				$values[$key]=sprintf($val,$values[$key]);
			}
		}
		if ($replace) {
			$query="REPLACE INTO $table ";
		} elseif ($ignore) {
			$query="INSERT IGNORE INTO $table ";
		} else {
			$query="INSERT INTO $table ";
		}
		$query.="(`".implode('`,`',array_keys($values))."`)";
		$query.=" VALUES (".implode(',',$values).")";
		$this->query($query);
		return $this->affected_rows();
	}
	function update($table,$values,$where=0,$func=0) {
		if (!is_array($values) || !count($values)) return false;
		$values=$this->escape($values);
		if (is_array($func) && !empty($func)) {
			foreach($func as $key=>$val) {
				$values[$key]=sprintf($val,$values[$key]);
			}
		}
		$query="UPDATE $table SET";
		$delim=' ';
		foreach ($values as $key=>$val) {
			$query.=$delim."`".$key."`=".$val;
			$delim=',';
		}
		if (is_array($where)) {
			$query.=" WHERE ".$this->getWhere($where);
		} elseif ($where) {
			$query.=" WHERE ".$where;
		}
		//debug($query);
		$this->query($query);
		return $this->affected_rows();
	}
	function delete($table,$where=null) {
		$values=$this->escape($values);
		$query="DELETE FROM $table";
		if (is_array($where)) {
			$query.=" WHERE ".$this->getWhere($where);
		} elseif ($where) {
			$query.=" WHERE ".$where;
		} else {
			return false;
		}
		//echo $query;
		$this->query($query);
		return $this->affected_rows();
	}
	function escape($values,$isLike=false,$noEnc=false) {
		if (is_array($values)) {
			if (empty($values)) return array("''");
			foreach (array_keys($values) as $key) {
				$values[$key]=$this->escape($values[$key],$isLike);
			}
		} else {
			if (!isset($values)) return "''";
			if ($noEnc) return $values;
			if (is_string($values)) {
				if ($isLike) {
					$values="'".str_replace('_','\_',addslashes($values))."'";
				} else {
					$values="'".addslashes($values)."'";
				}
			} else {
				$values='0'.$values;
			}
		}
		return $values;
	}
	function beginWork() {

	}
	function endWork() {

	}
	function formatLimit($b,$limit) {
		return 'LIMIT '.intval($b).','.intval($limit);
	}
	function formatOrder($order) {
		if (is_array($order)) {
			$tmp_order=array();
			foreach ($order as $key=>$val) {
				$tmp_order[]=$key.' '.($val==-1?'DESC':'ASC');
			}
			if (!empty($tmp_order)) {
				return 'ORDER BY '.implode(',',$tmp_order);
			}
		}
	}
	function formatSearch($info,$fields,$use_case=0,$only_words=0) {
		if (is_array($fields)) {
			$concat="CONCAT_WS(' ',";
			$concat.=implode(',',$fields).')';
		} else {
			$concat=$fields;
		}
		if ($use_case) {
				$sql_binary='BINARY ';
		} else  {
				$sql_binary='';
		}
		if (preg_match_all("/\s\"(.+)\"\s/U",' '.$info.' ',$result)) {
			$tmp=preg_replace("/\s\"(.+)\"\s/U","",' '.$info.' ');
			$result[2]=explode(' ',preg_replace('/\s{2,}/',' ',trim($tmp)));
			if (!empty($result[2][0])) {
				$sql_info=array_unique(array_merge($result[1],$result[2]));
			} else {
				$sql_info=$result[1];
			}
		} else {
			$info=preg_replace('/\s{2,}/',' ',$info);
			$sql_info=explode(' ',$info);
		}
		//debug($sql_info);
		if ($only_words) {
			$result='(';
			$sep='';
			foreach($sql_info as $val) {
				if ($val[0]=='-' && strlen($val)>1 && $val[1]!='-') {
					$val=substr($val,1);
					$NOT=' NOT';
				} else {
					$NOT='';
				}
				$result.=$sep.$concat."$NOT REGEXP $sql_binary'[[:<:]]".addslashes(preg_quote($val,''));
				if ($only_words!='S') {
					$result.="[[:>:]]";
				}
				$result.="'";
				$sep=' AND ';
			}
			$result.=')';
		} else {
			$result='(';
			$sep='';
			foreach($sql_info as $val) {
				if ($val[0]=='-' && strlen($val)>1 && $val[1]!='-') {
					$val=substr($val,1);
					$NOT=' NOT';
				} else {
					$NOT='';
				}
				$result.=$sep.$concat."$NOT LIKE $sql_binary'%".addslashes($val)."%'";
				$sep=' AND ';
			}
			$result.=')';
		}
		return $result;
	}
	function DateToSql($time,$sec=1) {
		if ($sec) {
			return date('Y-m-d H:i:s',$time);
		} else {
			return date('Y-m-d H:i:00',$time);
		}
	}
	function SqlToDate($sql,$sec=1) {
		$temp=explode(' ',$sql);
		$date=explode('-',$temp[0]);
		if ($temp[1]) $time=explode(':',$temp[1]); else $time=array(0,0,0);
		if (!$sec) $time[2]=0;
		return mktime($time[0],$time[1],$time[2],$date[1],$date[2],$date[0]);
	}
	function getWhere($searchQuery) {
		$where=array();
		if (is_array($searchQuery)) {
			foreach ($searchQuery as $key=>$val) {
				if (!isset($val['NoEnc'])) $val['NoEnc']=false;
				switch ($val['Typ']) {
					case '=':
						if (is_array($val['Values'])) {
							$where[]=$val['Field'].' IN ('.implode(',',$this->escape($val['Values'],false,$val['NoEnc'])).')';
						} else {
							$where[]=$val['Field'].'='.$this->escape($val['Values'],false,$val['NoEnc']);
						}
					break;
					case '!=':
						if (is_array($val['Values'])) {
							$where[]=$val['Field'].' NOT IN ('.implode(',',$this->escape($val['Values'],false,$val['NoEnc'])).')';
						} else {
							$where[]=$val['Field'].'!='.$this->escape($val['Values'],false,$val['NoEnc']);
						}
					break;
					case 'regexp':
						$where[]=$val['Field'].' REGEXP '.$this->escape($val['Values'],false,$val['NoEnc']);
					break;
					case '!regexp':
						$where[]=$val['Field'].' NOT REGEXP '.$this->escape($val['Values'],false,$val['NoEnc']);
					break;
					case 'like':
						if (is_array($val['Values'])) {
							$tmp=array();
							foreach ($val['Values'] as $tmp_val) {
								$tmp[]=$val['Field'].' LIKE '.$this->escape($tmp_val,true,$val['NoEnc']);
							}
							$where[]='('.implode(' OR ',$tmp).')';
						} else {
							$where[]=$val['Field'].' LIKE '.$this->escape($val['Values'],true,$val['NoEnc']);
						}
					break;
					case '!like':
						if (is_array($val['Values'])) {
							$tmp=array();
							foreach ($val['Values'] as $tmp_val) {
								$tmp[]=$val['Field'].' LIKE '.$this->escape($tmp_val,true,$val['NoEnc']);
							}
							$where[]='NOT ('.implode(' OR ',$tmp).')';
						} else {
							$where[]=$val['Field'].' NOT LIKE '.$this->escape($val['Values'],true,$val['NoEnc']);
						}
					break;
					case 'concat':
						if (is_array($val['Values'])) {
							$tmp=array();
							foreach ($val['Values'] as $tmp_val) {
								$tmp[]=$this->formatSearch($tmp_val,$val['Field'],$val['UseCase'],$val['OnlyWords']);
							}
							$where[]='('.implode(' OR ',$tmp).')';
						} else {
							$where[]=$this->formatSearch($val['Values'],$val['Field'],$val['UseCase'],$val['OnlyWords']);
						}
					break;
					case '!concat':
						if (is_array($val['Values'])) {
							$tmp=array();
							foreach ($val['Values'] as $tmp_val) {
								$tmp[]=$this->formatSearch($tmp_val,$val['Field'],$val['UseCase'],$val['OnlyWords']);
							}
							$where[]='NOT ('.implode(' OR ',$tmp).')';
						} else {
							$where[]='NOT ('.$this->formatSearch($val['Values'],$val['Field'],$val['UseCase'],$val['OnlyWords']).')';
						}
					break;
					case '<':
					case '<=':
					case '>':
					case '>=':
						if (is_array($val['Values'])) {
							$tmp=array();
							foreach ($val['Values'] as $tmp_val) {
								$tmp[]=$val['Field'].$val['Typ'].$this->escape($tmp_val,false,$val['NoEnc']);
							}
							$where[]='('.implode(' OR ',$tmp).')';
						} else {
							$where[]=$val['Field'].$val['Typ'].$this->escape($val['Values'],false,$val['NoEnc']);
						}
					break;
					case 'null':
						$where[]=$val['Field'].' IS NULL';
					break;
					case '!null':
						$where[]=$val['Field'].' IS NOT NULL';
					break;
					case 'OR':
						$tmp=array();
						foreach ($val['Values'] as $tmp_val) {
							$tmp[]='('.$this->getWhere($tmp_val).')';
						}
						$where[]='('.implode(' OR ',$tmp).')';
					break;
					case 'AND':
						$where[]='('.$this->getWhere($val['Values']).')';
					break;
					case 'F=F':
						$where[]=$val['Field'].'='.$val['Values'];
					break;
					case 'F!=F':
						$where[]=$val['Field'].'!='.$val['Values'];
					break;
					case 'SQL':
						$where[]='('.$val['Values'].')';
					break;
					case 'inset':
						if (is_array($val['Values'])) {
							$tmp=array();
							foreach ($val['Values'] as $tmp_val) {
								$tmp[]='FIND_IN_SET('.$this->escape($tmp_val,false,$val['NoEnc']).','.$val['Field'].')';
							}
							$where[]='('.implode(' OR ',$tmp).')';
						} else {
							$where[]='FIND_IN_SET('.$this->escape($val['Values'],false,$val['NoEnc']).','.$val['Field'].')';
						}
					break;
					case '!inset':
						if (is_array($val['Values'])) {
							$tmp=array();
							foreach ($val['Values'] as $tmp_val) {
								$tmp[]='FIND_IN_SET('.$this->escape($tmp_val,false,$val['NoEnc']).','.$val['Field'].')';
							}
							$where[]='NOT ('.implode(' OR ',$tmp).')';
						} else {
							$where[]='NOT FIND_IN_SET('.$this->escape($val['Values'],false,$val['NoEnc']).','.$val['Field'].')';
						}
					break;

				}
			}
		}
		return implode(' AND ',$where);
	}

	function moveEntry ($Table,$IdField,$seqField,$ID,$dir='down',$addWhere = null) {
		$add_where='';
		if (!empty($addWhere)) $add_where=' AND '.$this->getWhere($addWhere);
		$query="SELECT `$seqField` FROM `$Table` WHERE `$IdField`=".$this->escape($ID).$add_where;
		$this->query($query);
		if ($this->next_record()) {
			$oSequence=$this->f($seqField);
			if ($dir=='up'){
				$sign='<';
				$order='DESC';
			}elseif ($dir=='down') {
				$sign='>';
				$order='ASC';
			} elseif ($dir=='first') {
				$sign='<';
				$order='ASC';
			}
			$query="SELECT `$IdField`,`$seqField` FROM `$Table` WHERE ";
			$query.="`$seqField` $sign ".$this->escape($oSequence).$add_where;
			$query.=" ORDER BY `$seqField` $order LIMIT 1";
			$this->query($query);
			if ($this->next_record()) {
				$nID=$this->f($IdField);
				$nSequence=$this->f($seqField);
				$query="UPDATE `$Table` SET `$seqField`=".$this->escape($nSequence)." WHERE ";
				$query.="`$IdField`=".$this->escape($ID).$add_where;
				$this->query($query);
				if ($dir=='first') {
					$query="UPDATE `$Table` SET `$seqField`=`$seqField`+1 WHERE ";
					$query.="`$seqField`<".$this->escape($oSequence)." AND `$IdField`!=".$this->escape($ID).$add_where;
					$this->query($query);
				} else {
					$query="UPDATE `$Table` SET `$seqField`=".$this->escape($oSequence)." WHERE ";
					$query.="`$IdField`=".intval($nID).$add_where;
					$this->query($query);
				}
				return true;
			}
		}
		return false;
	}
	function _parseDateVal($val,$pos,$field,$enc=true) {
		switch ($val) {
			case '%':
				$enc=false;
				switch ($pos) {
					case 0:
						$result="DATE_FORMAT(".$field.",'%d')";
					break;
					case 1:
						$result="DATE_FORMAT(".$field.",'%m')";
					break;
					case 2:
						$result="DATE_FORMAT(".$field.",'%Y')";
					break;
				}
			break;
			case '%d':
				$result=sprintf('%02d',date('d'));
			break;
			case '%m':
				$result=sprintf('%02d',date('m'));
			break;
			case '%y':
				$result=sprintf('%04d',date('Y'));
			break;
			default:
				$val=intval($val);
				if ($enc) {
					switch ($pos) {
						case 0:
							$result=sprintf('%02d',$val);
						break;
						case 1:
							$result=sprintf('%02d',$val);
						break;
						case 2:
							if ($val) {
								if($val < 30) $val+=2000;
								if($val < 999) $val+=1900;
							}
							$result=sprintf('%04d',$val);
						break;
					}
				} else $result=$val;
		}
		if ($enc) {
			return "'".$result."'";
		} else {
			return $result;
		}
	}
	function parseSearchDateSql($date,$field='',$Typ='=') {
		$date=preg_replace('@[^0-9%dmy+-]+@i',"/",$date);
		$temp_val=explode("/",$date);
		if (!trim($temp_val[2])) {
			$temp_val[2]='%';
		}
		if (!trim($temp_val[1])) {
			$temp_val[1]='%';
		}
		$dateAdd=array(0=>'',1=>'');
		$valAdd=array();
		$modif='DATE_ADD';
		foreach ($temp_val as $pos=>$val) {
			$val=strtolower($val);
			$val=preg_replace('/[+]+/','+',$val);
			$val=preg_replace('/[-]+/','-',$val);
			$val=preg_replace('/([-][+])|([+][-])/','+',$val);
			$val=preg_replace('/^[+-]/','',$val);
			$valAdd[$pos]=preg_split('/([+-])/',$val,-1,PREG_SPLIT_DELIM_CAPTURE);
		}
		$parseAdd=false;
		foreach ($valAdd as $pos=>$val_add) {
			for ($j=0;$j<count($val_add);$j++) {
				if ($j==0) {
					$temp_val[$pos]=$this->_parseDateVal($val_add[$j],$pos,$field);
				} else {
					if ($j%2) {
						if ($val_add[$j]=='-') {
							$modif='DATE_SUB';
						} else {
							$modif='DATE_ADD';
						}
					} else {
						switch ($pos) {
							case 0:
								$dateAdd[0]=$modif.'(' . $dateAdd[0];
								$dateAdd[1].=',INTERVAL '.$this->_parseDateVal($val_add[$j],$pos,$field,false).' DAY)';
							break;
							case 1:
								$dateAdd[0]=$modif.'(' . $dateAdd[0];
								$dateAdd[1].=',INTERVAL '.$this->_parseDateVal($val_add[$j],$pos,$field,false).' MONTH)';
							break;
							case 2:
								$dateAdd[0]=$modif.'(' . $dateAdd[0];
								$dateAdd[1].=',INTERVAL '.$this->_parseDateVal($val_add[$j],$pos,$field,false).' YEAR)';
							break;
						}
						$parseAdd=true;
					}
				}
			}
		}

		$result=$dateAdd[0]."CONCAT_WS('-',".$temp_val[2].",".$temp_val[1].",".$temp_val[0].")".$dateAdd[1];
		if ($parseAdd) {
			if ($Typ=='=' || $Typ=='!=') {
				if ($valAdd[2][0]=='%' || $valAdd[1][0]=='%') {
					if ($valAdd[2][0]=='%' && $valAdd[1][0]=='%') {
						$result="CONCAT_WS('-',DATE_FORMAT(".$field.",'%Y-%m'),DATE_FORMAT(".$result.",'%d'))";
					} elseif ($valAdd[2][0]=='%') {
						$result="CONCAT_WS('-',DATE_FORMAT(".$field.",'%Y'),DATE_FORMAT(".$result.",'%m-%d'))";
					} else {
						$result="CONCAT_WS('-',DATE_FORMAT(".$result.",'%Y'),DATE_FORMAT(".$field.",'%m'),DATE_FORMAT(".$result.",'%d'))";
					}
				}
			}
		}
		return $result;
	}
}
?>
