<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class GroupieUser {
	var $_ds;
	var $_ldap_host;
	var $_ldap_port;
	var $_base_dn;
	var $_bind_dn;
	var $_error;
	function GroupieUser() {
		$this->_ldap_host=$GLOBALS['CFG']['LDAP']['host'];
		$this->_ldap_port=$GLOBALS['CFG']['LDAP']['port'];
		$this->_base_dn=$GLOBALS['CFG']['LDAP']['basedn'];
		$this->_pwd_hash=$GLOBALS['CFG']['LDAP']['pwd_hash'];
		$this->_search_dn=$GLOBALS['CFG']['LDAP']['search'];
	}
	function getUserFields() {
		$result=array(
			'g',
			'gb',
			'ge',
		);
		return $result;
	}
	function getError() {
		return "";
	}
	function connect() {
		$this->_ds=false;
		$this->_ds=@ldap_connect($this->_ldap_host, $this->_ldap_port);
		return $this->_ds;
	}
	function bind($binddn,$password) {
		$result=false;
		$result=@ldap_bind($this->_ds, $this->utf8encode($binddn),$this->utf8encode($password));
		return $result;
	}
	function search($search_dn,$search_attr=NULL) {
		if (!$search_attr) $search_attr=array();
		$result=false;
		$sr=ldap_search($this->_ds, $this->_base_dn, $search_dn,$search_attr);
		if ($sr) $result = ldap_get_entries($this->_ds, $sr);
		return $this->utf8decode($result);
	}
	function close() {
		@ldap_close($this->_ds);
	}
	function getLdapUsers($basedn,$ignore_exists=true,$filter=NULL) {
		$result=array();
		$info=array();
		if ($this->connect()) {
			$search_dn=array();
			$search_dn[]='(uid=*)';
			if (is_array($filter)) {
				$search_dn_sub=array();
				foreach ($filter as $key=>$val) {
					$search_dn_sub[]='('.$key.'=*'.$this->ldapEsc($val).'*)';
				}
				if (count($search_dn_sub)>1) {
					$search_dn[]='(|'.implode('',$search_dn_sub).')';
				} else {
					$search_dn[]=implode('',$search_dn_sub);
				}
			}
			if (count($search_dn)>1) {
				$search_dn_txt='(&'.implode('',$search_dn).')';
			} else {
				$search_dn_txt=implode('',$search_dn);
			}
			/*$search_attr=array(
				'uid',
				'sn',
				'cn',
				'givenname',
			);*/
			$sr=ldap_search($this->_ds, $basedn, $search_dn_txt);
			if ($sr) $info = ldap_get_entries($this->_ds, $sr);
			$info=$this->utf8decode($info);
			if (is_array($info)) {
				for ($i=0; $i<$info["count"]; $i++) {
					$domain=GE_DOMAIN;
					if ($info[$i]['ispmandomain'][0]) $domain=$info[$i]['ispmandomain'][0];
					if ($info[$i]['uid'][0]) {
						if ($domain) {
							$username=str_replace('_'.str_replace('.','_',$domain),'',$info[$i]['uid'][0]);
						} else {
							$username=$info[$i]['uid'][0];
						}
						if ($ignore_exists && $this->check_user($username)) continue;
					}
					if ($info[$i]['sn'][0]) {
						$lastname=trim($info[$i]['sn'][0]);
					}
					if ($info[$i]['givenname'][0]) {
						$firstname=trim($info[$i]['givenname'][0]);
					} elseif ($info[$i]['cn'][0]) {
						$firstname=trim(str_replace($lastname,'',$info[$i]['cn'][0]));
					}
					$result[]=array(
						'username'=>$username,
						'lastname'=>$lastname,
						'firstname'=>$firstname,
					);
				}
			}
			$this->close();
		}
		return $result;
	}
	function updateLdapPassword($username,$oldpwd,$newpwd) {
		if ($this->connect()) {
			if (GE_DOMAIN) {
				//echo $this->_uname.'_'.str_replace('.','_',GE_DOMAIN);
				$username=$username.'_'.str_replace('.','_',GE_DOMAIN);
			}
			$strtr=array(
				'{USERNAME}'=>$this->ldapEsc($username),
			);
			$search_dn=strtr($this->_search_dn,$strtr);
			if ($info=$this->search($search_dn)) {
				for ($i=0; $i<$info["count"]; $i++) {
					if ($this->bind($info[$i]["dn"],addslashes($oldpwd))) {
						$ldap_rep['userPassword']=$this->password_hash($newpwd,$this->_pwd_hash );
						ldap_mod_replace($this->_ds,$this->utf8encode($info[$i]["dn"]),$this->utf8encode($ldap_rep));
					}
				}
			}
			$this->close();
		}
		return false;
	}

	function check_user($username,$user_id=0){
		$query="select user_id from auth_user_md5 where username=".$this->db->escape($username);
		if ($user_id) $query.=" AND user_id!=".$this->db->escape($user_id);
		$query.=" AND perms!='deleted'";
		$this->db->query($query);
		if ($this->db->next_record()) {
			return $this->db->f('user_id');
		} else {
			return false;
		}
	}
	function checkPassword($username,$pwd) {
		if (!$pwd) return false;
		if ($this->connect()) {
			if (GE_DOMAIN) {
				//echo $this->_uname.'_'.str_replace('.','_',GE_DOMAIN);
				$ld_username=$username.'_'.str_replace('.','_',GE_DOMAIN);
			} else {
				$ld_username=$username;
			}
			$strtr=array(
				'{USERNAME}'=>$this->ldapEsc($ld_username),
			);
			$search_dn=strtr($this->_search_dn,$strtr);
			if ($info=$this->search($search_dn)) {
				for ($i=0; $i<$info["count"]; $i++) {
					if ($this->bind($info[$i]["dn"],addslashes($pwd))) {
						$query="SELECT user_id FROM auth_user_md5 WHERE username=".$this->db->escape($username);
						$query.=" AND activ=1 and perms!='deleted'";
						$query.=" AND startdate<".time()." AND (enddate>".time()." OR enddate=-1)";
						$this->db->query($query);
						if ($this->db->next_record()) {
							return $this->db->f('user_id');
						}
					}
				}
			}
			$this->close();
		}
		return false;
	}

	function insert_user($field) {
		$id=$this->db->nextid("auth_user_md5");
		$update['user_id']=$id;
		foreach ($field as $key=>$val) {
			switch ($key) {
				case 'password':
					if ($GLOBALS['CFG']['MPASSWD']) {
						$func['password']='PASSWORD(%s)';
						$update["password"]=$val;
					} else {
						$update["password"]=md5($val);
					}
					$update["pwd_time"]=time();
				break;
				case 'groupe':
					$update["activ"]=$val;
				break;
				case 'perms':
					if ($val) $update["perms"]='system'; else $update["perms"]='';
				break;
				case 'shadowMax':
				case 'uidGroup-e':
				case 'deleted':
				break;
				default:
					$update[$key]=$val;
			}
		}
		$this->db->insert('auth_user_md5',$update,$func);
		return $id;
	}
	function update_user($uid,$field) {
		if (!is_array($field)) return 0;
		foreach ($field as $key=>$val) {
			switch ($key) {
				case 'password':
					if ($GLOBALS['CFG']['MPASSWD']) {
						$func['password']='PASSWORD(%s)';
						$update["password"]=$val;
					} else {
						$update["password"]=md5($val);
					}
					if ($GLOBALS['auth']->auth['uid']==$uid) {
						$this->updateLdapPassword($GLOBALS['auth']->auth['uname'],$GLOBALS['auth']->auth['password'],$val);
					}
					$update["pwd_time"]=time();
				break;
				case 'groupe':
					$update["activ"]=$val;
				break;
				case 'perms':
					if ($val) $update["perms"]='system'; else $update["perms"]='';
				break;
				case 'shadowMax':
				case 'uidGroup-e':
				case 'deleted':
				break;
				default:
					$update[$key]=$val;
			}
		}
		$this->db->update('auth_user_md5',$update,"user_id=".$this->db->escape($uid),$func);
		return $uid;
	}
	function read_user($uid) {
		$this->db->query("SELECT * FROM auth_user_md5 WHERE user_id=".$this->db->escape($uid));
		$this->db->next_record();
		$field["groupe"]=$this->db->f("activ");
		$field["firstname"]=$this->db->f("firstname");
		$field["lastname"]=$this->db->f("lastname");
		$field["zip"]=$this->db->f("zip");
		$field["place"]=$this->db->f("place");
		$field["email"]=$this->db->f("email");
		$field["adress"]=$this->db->f("adress");
		$field["tel"]=$this->db->f("tel");
		$field["mobil"]=$this->db->f("mobil");
		$field["fax"]=$this->db->f("fax");
		$field["company"]=$this->db->f("company");
		$field["username"]=$this->db->f("username");
		$field["startdate"]=$this->db->f("startdate");
		$field["enddate"]=$this->db->f("enddate");
		$field["create_time"]=$this->db->f("create_time");
		$field["update_time"]=$this->db->f("update_time");
		$field["perms"]=$this->db->f("perms")=='system'?1:0;
		$field["password"]=$this->db->f("password");
		$field["pwd_time"]=$this->db->f("pwd_time");
		$field["shadowMax"]=$this->getFrmCfg('cfg/usr/MaxPassDays');
		$field["uidGroup-e"]=$this->db->f("user_id");
		$field["deleted"]=$this->db->f("perms")=='deleted'?1:0;
		return $field;
	}

	function deleteGroupieUser($uid) {
		$this->db->query("UPDATE auth_user_md5 SET perms='deleted',activ=0 WHERE user_id=".$this->db->escape($uid));
		return $uid;
	}
	function deleteGroupieGroup($uid) {
		$this->db->query("DELETE FROM user_groups WHERE group_id=".$this->db->escape($uid));
		$this->db->query("DELETE FROM groups where group_id=".$this->db->escape($uid));
	}
	function deleteUserGroups($uid=0,$gid=0,$ldap_uid=true,$no_proj=true) {
		$query="SELECT user_groups.group_id,user_id FROM user_groups,groups WHERE user_groups.group_id=groups.group_id";
		if ($uid) {
			$where[]=" user_groups.user_id=".$this->db->escape($uid);
		}
		if ($gid) {
			$where[]=" user_groups.group_id=".$this->db->escape($gid);
		}
		if ($no_proj) {
			$where[]=" groups.`activGroup-e`<=2";
		}
		if ($where) {
			$query.=' AND '.implode(' AND ',$where);
		}
		$delete_groups=array();
		$this->db->query($query);
		while ($this->db->next_record()) {
			$delete_groups[$this->db->f('user_id')][]=$this->db->f('group_id');
		}
		if (!empty($delete_groups)) {
			foreach ($delete_groups as $duid=>$dgid) {
				$query="DELETE FROM user_groups WHERE user_id=".$this->db->escape($duid);
				$query.=" AND group_id IN (".implode(',',$this->db->escape($dgid)).")";
				$this->db->query($query);
			}
		}
	}
	function insertUserGroups($uid,$user_groups,$ldap_uid=true) {
		if ($uid && is_array($user_groups)) {
			foreach ($user_groups as $val) {
				$this->db->insert('user_groups',array('user_id'=>$uid,'group_id'=>$val),'',1);
			}
		}
	}
	function insertGroupUsers($gid,$user_groups,$ldap_uid=true) {
		if ($gid && is_array($user_groups)) {
			foreach ($user_groups as $val) {
				$this->db->insert('user_groups',array('user_id'=>$val,'group_id'=>$gid),'',1);
			}
		}
	}
	function getUserPwd($uname) {
		$query="SELECT password FROM auth_user_md5 WHERE username=".$this->db->escape($uname);
		$query.=" AND activ=1 and perms!='deleted'";
		$this->db->query($query);
		if ($this->db->next_record()) {
			return $this->db->f("password");
		} else {
			return false;
		}
	}
	function getFullName($uid=0,$short=0,$perms=0,$info='',$limit=0,$strict_info=false) {
		$users=array();
		$searchQuery=array();
		if ($perms==1) {
			$uperms=array('','deleted','system');
		} elseif (is_array($perms)) {
			$uperms=$perms;
		} elseif($perms) {
			$uperms=array($perms);
		} else {
			$uperms=array('');
		}
		if (in_array('super',$uperms)) $super=1; else $super=0;

		$searchQuery[]=array('Field'=>'perms','Typ'=>'=','Values'=>$uperms);
		if (!in_array('deleted',$uperms)) {
			$searchQuery[]=array('Field'=>'activ','Typ'=>'=','Values'=>1);
		}
		if ($uid) {
			if (empty($uid)) return $users;
			$searchQuery[]=array('Field'=>'user_id','Typ'=>'=','Values'=>$uid);
		} else {
			//Einschraenkung auf Obergruppen
			if (!empty($this->_allowedUsers) && !$this->isRuleUser(array('sysadmin'))) {
				$searchQuery[]=array('Field'=>'user_id','Typ'=>'=','Values'=>$this->_allowedUsers);
			}

		}
		if ($info) {
			if ($strict_info) {
				$searchQuery[]=array('Field'=>'username','Typ'=>'=','Values'=>$info);
			} else {
				$searchQuery[]=array('Field'=>array('lastname','firstname','username'),'Typ'=>'concat','Values'=>$info);
			}
		}

		$query="SELECT user_id,firstname,lastname,perms FROM auth_user_md5";
		if (!empty($searchQuery)) {
			$query.=" WHERE ".$this->db->getWhere($searchQuery);
		}
		$query.=" ORDER BY lastname,firstname";
		if ($limit) $query.=' '.$this->db->formatLimit(0,$limit);
		//echo $query.'<br>';
		$this->db->query($query);
		while ($this->db->next_record()) {
			if ($GLOBALS['CFG']['SUPERADMIN']==$this->db->f("user_id") && $this->uid!=$GLOBALS['CFG']['SUPERADMIN'] && !$super) continue;
			if ($short) {
				$users[$this->db->f("user_id")]=$this->db->f("lastname").' '.substr($this->db->f("firstname"),0,1).'.';
			} else {
				$users[$this->db->f("user_id")]=$this->db->f("lastname").' '.$this->db->f("firstname");
			}
			if ($this->db->f("perms")=='deleted') {
				$users[$this->db->f("user_id")]='#'.$users[$this->db->f("user_id")].'#';
			}
		}
		return $users;
	}
	function searchUserByEmail($mail) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'perms','Typ'=>'=','Values'=>array('','system'));
		$searchQuery[]=array('Field'=>'email','Typ'=>'=','Values'=>$mail);
		if (!empty($this->_allowedUsers) && !$this->isRuleUser(array('sysadmin'))) {
			$searchQuery[]=array('Field'=>'user_id','Typ'=>'=','Values'=>$this->_allowedUsers);
		}
		$query="SELECT * FROM auth_user_md5 WHERE ".$this->db->getWhere($searchQuery);
		$query.=" ORDER BY user_id";
		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[]=$this->db->f("user_id");
		}
		return $result;
	}
	function searchUser(&$rows,$info,$uid=0,$perms=0,$b=0,$limit=10,$use_limit=false,$only_groupe=true,$params=array()) {
		$users=array();
		$searchQuery=array();
		if ($perms==1) {
			$uperms=array('','deleted','system');
		} elseif (is_array($perms)) {
			$uperms=$perms;
		} elseif($perms) {
			$uperms=array($perms);
		} else {
			$uperms=array('');
		}
		if (in_array('super',$uperms)) $super=1; else $super=0;

		$searchQuery[]=array('Field'=>'perms','Typ'=>'=','Values'=>$uperms);
		if ($only_groupe && !in_array('deleted',$uperms)) {
			$searchQuery[]=array('Field'=>'activ','Typ'=>'=','Values'=>1);
			$searchQuery[]=array('Field'=>'startdate','Typ'=>'<=','Values'=>time());

			$searchOrQuery=array(
				array(array('Field'=>'enddate','Typ'=>'=','Values'=>-1)),
				array(array('Field'=>'enddate','Typ'=>'>=','Values'=>time())),
			);
			$searchQuery[]=array('Typ'=>'OR','Values'=>$searchOrQuery);
		}
		if ($uid) {
			$searchQuery[]=array('Field'=>'user_id','Typ'=>'=','Values'=>$uid);
		} else {
			if (!empty($this->_allowedUsers) && !$this->isRuleUser(array('sysadmin'))) {
				$searchQuery[]=array('Field'=>'user_id','Typ'=>'=','Values'=>$this->_allowedUsers);
			}
		}
		if ($info) {
			$searchQuery[]=array('Field'=>array('lastname','firstname','username'),'Typ'=>'concat','Values'=>$info);
		}
		if ($params['onlyMobil']) {
			$searchQuery[]=array('Field'=>'mobil','Typ'=>'!=','Values'=>'');
		}
		$query="SELECT * FROM auth_user_md5";
		if (!empty($searchQuery)) {
			$query.=" WHERE ".$this->db->getWhere($searchQuery);
		}
		$query.=" ORDER BY lastname,firstname";
		if ($limit) $query.=' '.$this->db->formatLimit($b,$limit);

		$this->db->query($query);
		$rows=$this->db->num_rows();
		while ($this->db->next_record()) {
			if ($GLOBALS['CFG']['SUPERADMIN']==$this->db->f("user_id") && $this->uid!=$GLOBALS['CFG']['SUPERADMIN'] && !$super) continue;
			$users[$this->db->f("user_id")]=array(
				"username" => $this->db->f("username"),
				"lastname" => $this->db->f("lastname"),
				"firstname" => $this->db->f("firstname"),
				"email" => $this->db->f("email"),
				"mobil" => $this->db->f("mobil"),
				"perms" => $this->db->f("perms")=='system'?1:0,
				"startdate" => $this->db->f("startdate"),
				"enddate" => $this->db->f("enddate"),
				"groupe" => $this->db->f("activ"),
			);
		}
		if ($use_limit && ($rows==$limit || $b!=0)) {
			$query="SELECT count(*) as num FROM auth_user_md5 $where";
			$this->db->query($query);
			$this->db->next_record();
			$rows=$this->db->f('num');
		}
		return ($users);
	}
	function getAllGroupUsers($group_id) {
		$users=array();
		$query="SELECT DISTINCT user_id,group_id FROM user_groups WHERE group_id!=0 AND ";
		if (is_array($group_id)) $query.="group_id IN (".implode(",",$this->db->escape($group_id)).")";
		else $query.="group_id=".$this->db->escape($group_id);
		$this->db->query($query);
		while ($this->db->next_record()) {
			$users[$this->db->f("group_id")][]=$this->db->f("user_id");
		}
		return $users;
	}
	function getGroupUsers($group_id) {
		$users=array();
		$query="SELECT user_id FROM user_groups WHERE group_id!=0 AND ";
		if (is_array($group_id)) $query.="group_id IN (".implode(",",$this->db->escape($group_id)).")";
		else $query.="group_id=".$this->db->escape($group_id);
		$this->db->query($query);
		while ($this->db->next_record()) {
			$users[$this->db->f("user_id")]=$this->db->f("user_id");
		}
		return $users;
	}
	function getUserGroups($user_id,$ldap_uid=false,$noNonAktivPrj=true) {
		$search[]=array();
		$search[]=array('Field'=>'user_groups.group_id','Typ'=>'F=F','Values'=>'groups.group_id');
		$search[]=array('Field'=>'user_groups.user_id','Typ'=>'=','Values'=>$user_id);
		if ($noNonAktivPrj) {
			$search[]=array('Field'=>'`activGroup-e`','Typ'=>'>=','Values'=>1);
		}
		$query="SELECT user_groups.group_id FROM user_groups,groups";
		$query.=" WHERE ".$this->db->getWhere($search);
		$this->db->query($query);
		while ($this->db->next_record()) {
			$users[$this->db->f("group_id")]=$this->db->f("group_id");
		}
		return $users;
	}
	function getAllGroups($uid=0,$perms=0,$info='',$limit=0,$translate=true,$strict_info=false) {
		global $P,$T;
		$result=array();
		$query="SELECT * FROM groups";
		$prj_groups=array();
		$search=array();
		if ($uid) {
			if (empty($uid)) return $result;
			$search[]=array('Field'=>'group_id','Typ'=>'=','Values'=>$uid);
		} else {
			//Einschraenkung auf Obergruppen
			if (!empty($this->_allowedGroups) && !$this->isRuleUser(array('sysadmin'))) {
				$search[]=array('Field'=>'group_id','Typ'=>'=','Values'=>$this->_allowedGroups);
			}
		}
		if ($info) {
			if ($strict_info) {
				$search[]=array('Field'=>'group_name','Typ'=>'=','Values'=>$info);
			} else {
				$search[]=array('Field'=>'group_name','Typ'=>'concat','Values'=>$info);
			}
		}
		if (is_array($perms)) {
			$search[]=array('Field'=>'`activGroup-e`','Typ'=>'=','Values'=>$perms);
		} elseif ($perms!=-1) {
			if ($perms) {
				$search[]=array('Field'=>'`activGroup-e`','Typ'=>'=','Values'=>array(1,$perms));
			} else {
				$search[]=array('Field'=>'`activGroup-e`','Typ'=>'=','Values'=>1);
			}
		}
		if (!empty($search)) {
			$query.=" WHERE ".$this->db->getWhere($search);
		}
		$query.=" ORDER BY group_name";
		if ($limit) $query.=' '.$this->db->formatLimit(0,$limit);
		$this->db->query($query);
		while ($this->db->next_record()) {
			//debug($i++);
			if ($perms && $translate && $this->db->f("activGroup-e")!=1 && $P && $T) {
				$prj_groups[$this->db->f("group_id")]='';
			} else {
				$groups[$this->db->f("group_id")]=$this->db->f("group_name");
			}
		}
		if (!empty($prj_groups)) {
			foreach ($prj_groups as $key=>$val) {
				$prj_groups[$key]=$T->lang($P->getGroupName($key));
			}
			if (is_array($groups)) {
				$groups=$prj_groups+$groups;
			} else {
				$groups=$prj_groups;
			}
		}
		return $groups;
	}

	function insert_group($user_data) {
		$ID=$this->db->nextid('groups');
		$user_data['group_id']=$ID;
		$this->db->insert('groups',$user_data,'',1);
		return $user_data['group_id'];
	}
	function update_group($ID,$user_data) {
		$this->db->update('groups',$user_data,"group_id=".$this->db->escape($ID));
		return $ID;
	}
	function password_hash( $password_clear, $enc_type ){
		$enc_type = strtolower( $enc_type );
		switch( $enc_type )	{
			case 'crypt':
				$new_value = '{CRYPT}' . crypt( $this->utf8encode($password_clear), $this->random_salt(2) );
				break;
			case 'md5crypt':
				$new_value = '{CRYPT}' . crypt( $this->utf8encode($password_clear) , '$1$' . $this->random_salt(9) );
				break;
			case 'blowfish':
				$new_value = '{CRYPT}' . crypt( $this->utf8encode($password_clear) , '$2$' . $this->random_salt(13) );
				break;
			case 'sha':
				$new_value = '{SHA}' . base64_encode( pack( 'H*' , sha1($this->utf8encode($password_clear))));
				break;
			case 'ssha':
				mt_srand( (double) microtime() * 1000000 );
				$salt = substr(pack("H*", sha1(substr( pack( "h*", md5( mt_rand() ) ), 0, 8 ).$this->utf8encode($password_clear))), 0,  4);
				$new_value = "{SSHA}".base64_encode(pack( 'H*' , sha1($this->utf8encode($password_clear).$salt)).$salt);
				break;
			case 'smd5':
				mt_srand( (double) microtime() * 1000000 );
				$salt = substr(pack("H*", md5(substr( pack( "h*", md5(mt_rand() ) ), 0, 8 ) . $this->utf8encode($password_clear))), 0, 4);
				$new_value = "{SMD5}".base64_encode( pack( 'H*' , md5($this->utf8encode($password_clear).$salt)).$salt );
				break;
			case 'clear':
				$new_value = $password_clear;
				break;
			case 'md5':
			default:
				$new_value = '{MD5}' . base64_encode( pack( 'H*' , md5( $this->utf8encode($password_clear)) ) );
				break;
		}
		return $new_value;
	}
	function random_salt($length){
		$possible = '0123456789'.
			'abcdefghijklmnopqrstuvwxyz'.
			'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.
			'./';
		$str = "";
		mt_srand((double)microtime() * 1000000);
		while( strlen( $str ) < $length ) {
				$str .= substr( $possible, ( rand() % strlen( $possible ) ), 1 );
		}
		//$str = "\$1\$".$str."\$";
		return $str;
	}
	function ldapEsc($value) {
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->ldapEsc($val);
			}
		} else {
			$tras=array('*'=>'\\2a','('=> '\\28',')'=>'\\29','\\'=>'\\5c','\0'=>'\\00');
			$value=strtr($value,$tras);
		}
		return $value;
	}
	function ldapEscDN($value) {
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->ldapEscDN($val);
			}
		} else {
			$tras=array(','=>'\,','+'=>'\+');
			$value=strtr($value,$tras);
		}
		return $value;
	}
	function utf8encode($value) {
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->utf8encode($val);
			}
		} else {
			$value=Framework::convertCharset($value,GE_CHARSET,'UTF-8');
		}
		return $value;
	}
	function utf8decode($value) {
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->utf8decode($val);
			}
		} else {
			$value=Framework::convertCharset($value,'UTF-8',GE_CHARSET);
		}
		return $value;
	}

}
?>