<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class AddrObj {
	var $_meta=array();
	var $_pmeta=array();
	var $_hmeta=array();
	var $_acl;
	var $_ID;
	function getID() {
		return $this->_ID;
	}
	function setID($ID) {
		$this->_ID=$ID;
	}
	function getMeta($key,$explode=false) {
		if ($explode) {
			return Addr::AddrExplode($this->_meta[$key]);
		} else {
			return $this->_meta[$key];
		}
	}
	function setMeta($key,$data) {
		$this->_meta[$key]=$data;
	}
	function getParentMeta($key) {
		return $this->_pmeta[$key];
	}
	function setParentMeta($key,$data) {
		$this->_pmeta[$key]=$data;
	}
	function getHotMeta($key) {
		return $this->_hmeta[$key];
	}
	function setHotMeta($key,$data) {
		$this->_hmeta[$key]=$data;
	}
	function getName($lang='') {
		if (!$lang) $lang=$GLOBALS['session_lang'];
		return $this->_meta['Title_'.$lang];
	}
	function getACL($chk=0) {
		$chk=intval($chk);
		if ($chk) {
			return ($this->_acl&$chk)?true:false;
		} else {
			return $this->_acl;
		}
	}
	function setAcl($acl) {
		$this->_acl=$acl;
	}
	function getAction($typ) {
		return $this->_action[$typ];
	}
	function getSite() {
		return $this->_site;
	}
	public function __set($key, $val){
		$this->_meta[$key] = $val;
	}
	public function __get($key){
		return isset($this->_meta[$key])?$this->_meta[$key]:null;
    }
	public function __unset($key) {
		unset($this->_meta[$key]);
    }
	public function __isset($key){
		return array_key_exists($key,$this->_meta);
	}
}

class AObj_fol extends AddrObj   {
	var $_site='addr.php';
	var $_action=array('b','b');
	function AObj_fol($ID=0,$meta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		$this->_ID=$ID;
		$this->_acl=$acl;
	}
	function getImage($open=0,$tree=0) {
		$image='obj_img/';
		if ($tree) $image.='_';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		if ($this->_meta['System']=='t') $image.='trash.gif'; else $image.='tree.gif';
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='fol';
		if ($this->getMeta('Trash')) {
			$ac.='_tr';
		}
		if ($typ) $ac.='_l';
		return $ac;
	}
	function isFolder() {
		return true;
	}
}


class AObj_trash extends AddrObj  {
	var $_site='addr.php';
	var $_action=array('bt','bt');
	function AObj_trash($ID=0,$meta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		$this->_ID=$ID;
		$this->_acl=$acl;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.='trash.gif';
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='trash';
		if ($typ) {
			$ac.='_l';
		}
		return $ac;
	}

	function isFolder() {
		return true;
	}
}
class AObj_addr extends AddrObj   {
	var $_site='addr.php';
	var $_action=array('v','i');
	function AObj_addr($ID=0,$meta=0,$pmeta=0,$hmeta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
		if ($hmeta) $this->_hmeta=$hmeta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($this->_meta['UserID']) {
			$image.='addr_p.gif';
		} else {
			$image.='addr.gif';
		}
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='addr';
		if ($this->getMeta('Trash')) {
			$ac.='_tr';
		}
		return $ac;
	}
	function getName($ol_name=0) {
		switch (GE_addrNameMode) {
			case 'fvn':
			case 'vn':
				$name=trim($this->_meta['Vorname'].' '.$this->_meta['Nachname'].' '.($this->_meta['MaidenName']?$this->_meta['MaidenName'].' ':''));
			break;
			default:
				$name=trim($this->_meta['MaidenName'].' '.($this->_meta['Nachname']?$this->_meta['Nachname'].' ':'').$this->_meta['Vorname']);
				//$name=trim($this->_meta['Nachname'].' '.($this->_meta['MaidenName']?$this->_meta['MaidenName'].' ':'').$this->_meta['Vorname']);
			break;
		}
		if ($ol_name && ($name || $ol_name==2)) return $name;
		if ($this->_meta['Firma']) {
			if ($name) {
				if (strpos(GE_addrNameMode,'f')!==false) {
					$name=$this->_meta['Firma'].', '.$name;
				}
			} else {
				$name=$this->_meta['Firma'];
			}
		}
		if (!$name) $name='No Name';
		return $name;
	}
	function isFolder() {
		return false;
	}
}

class Addr {
	var $_db;
	var $_uid;
	var $_lang;
	var $_gid;
	var $_rule=false;
	var $_sadmin=false;
	var $_locked_obj=array();
	var $_clipboard=array();
	var $_modul='addr';
	var $_list_fields=array(
		'ATel',
		'Fax',
		'Email',
	);
	var $_int_fields=array(
		'TimeVisited'=>array(
			'Typ'=>'unixdate',
			'Name'=>'[[Geoeffnet am]]',
		),
		'UserVisited'=>array(
			'Typ'=>'user',
			'Name'=>'[[Geoeffnet von]]',
		),
		'TimeCreate'=>array(
			'Typ'=>'unixdate',
			'Name'=>'[[Erstellt am]]',
		),
		'UserCreate'=>array(
			'Typ'=>'user',
			'Name'=>'[[Erstellt von]]',
		),
		'TimeModify'=>array(
			'Typ'=>'unixdate',
			'Name'=>'[[Geaendert am]]',
		),
		'UserModify'=>array(
			'Typ'=>'user',
			'Name'=>'[[Geaendert von]]',
		),
	);
	var $_user_fields=array();
	var $_k_fields=array();
	var $_addr_fields=array();
	var $_sfields=array();
	var $_ref_fields=array();
	var $_limit=20;
	var $_rootIDs=array();
	var $_archivCat=0;
	var $_cExportFields=array();
	var $_cacheUname2Id=array();
	var $_Asx=false;
	var $_asxPhone=false;
	function Addr($no_init=false) {
		global $db,$frm,$P,$T;
		$this->_db=&$db;
		$this->_frm=&$frm;
		$this->_P=&$P;
		$this->_T=&$T;
		$this->_Log=& $frm->getStaticModul('core_log');
		if (defined('GE_addrArchivCat')) {
			$this->_archivCat=GE_addrArchivCat;
		}
		if (!$no_init) {
			$this->setUser($frm->getUser());
			$this->setLang($frm->getLang());
			$this->setGroups($frm->getMyGroups());
			$this->setRule($frm->isRuleUser(array('sysadmin','addr')));
			$this->setSuperAdmin($frm->isSuperAdmin());
			$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
			$this->loadFields();
			if ($this->_frm->getMyApps('asx')) {
				$this->_Asx=$this->_frm->getStaticModul('asx');
				if ($this->_Asx->getCfg('cfg/click2dial/addr')) {
					$this->_asxPhone=$this->_Asx->getPhoneFromIP();
				}
			}
		}
	}
	function getModul() {
		return $this->_modul;
	}
	function setUser($uid) {
		$this->_uid=$uid;
		if (!defined('GE_addrNameMode')) {
			define('GE_addrNameMode',$this->_frm->getPrefs($this->getModul(),'nameMode'));
		}
		$this->_sgroups=$this->_frm->getMySuperGroups($this->_uid);
	}
	function getUser() {
		return $this->_uid;
	}
	function setGroups($gid) {
		$this->_gid=$gid;
	}
	function setLang($lang) {
		$this->_lang=$lang;
	}
	function getLang() {
		return $this->_lang;
	}
	function setRule($bool=false) {
		$this->_rule=$bool;
	}
	function setSuperAdmin($bool=false) {
		$this->_sadmin=$bool;
	}
	function setClipboard($what,$content) {
		$this->_clipboard[$what]=$content;
	}
	function getClipboard($what) {
		return $this->_clipboard[$what];
	}
	function isClipboard($what) {
		if ($this->_clipboard[$what]) {
			return true;
		} else {
			return false;
		}
	}
	function isRuleUser() {
		return $this->_rule;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function setCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}
		}
	}
	function getCfg($key) {
		if (isset($this->_cfg[$key])) {
			return $this->_cfg[$key];
		} else {
			return false;
		}
	}
	function setRootObj(&$obj) {
		$this->_root_obj=&$obj;
	}
	function &getRootObj() {
		return $this->_root_obj;
	}
	function setMode($mode) {
		$this->_mode=$mode;
	}
	function getMode() {
		return $this->_mode;
	}
	function getLimit() {
		return $this->_limit;
	}
	function setLimit($limit) {
		$this->_limit=$limit;
	}
	function getRows() {
		return $this->_rows;
	}
	function setRows($rows) {
		$this->_rows=$rows;
	}
	function getlistFields() {
		return $this->_list_fields;
	}
	function setlistFields($fields) {
		$this->_list_fields=$fields;
	}
	function getUserFields() {
		return $this->_user_fields;
	}
	function getKFields() {
		return $this->_k_fields;
	}
	function getRefFields($refID='') {
		if ($refID) {
			return isset($this->_ref_fields[$refID])?$this->_ref_fields[$refID]:false;
		} else {
			return $this->_ref_fields;
		}
	}
	function getFields() {
		return $this->_addr_fields;
	}
	function getIntFields() {
		return $this->_int_fields;
	}
	function getSearchFields() {
		return $this->_sfields;
	}
	function getFieldData($ID,$key=0,$int=0) {
		if (isset($this->_addr_fields[$ID])) {
			if ($key) {
				if (isset($this->_addr_fields[$ID][$key])) return $this->_addr_fields[$ID][$key];
			} else {
				return $this->_addr_fields[$ID];
			}
		} elseif ($int && isset($this->_int_fields[$ID])) {
			if ($key) {
				if (isset($this->_int_fields[$ID][$key])) return $this->_int_fields[$ID][$key];
			} else {
				return $this->_int_fields[$ID];
			}
		}
		return false;
	}
	function getFieldsACL($chk=0) {
		if ($chk) {
			return $this->_user_fields_perms&$chk?true:false;
		} else {
			return $this->_user_fields_perms;
		}
	}
	function getArchivCat() {
		if ($this->_archivCat && !is_array($this->_archivCatIds)) {
			$this->_archivCatIds=array_merge(array($this->_archivCat),$this->getSubNodeIDs($this->_archivCat));
		}
		return $this->_archivCatIds;
	}
	function getAsxPhone() {
		return $this->_asxPhone;
	}
	function loadListFields($uid=0) {
		$result=array();
		if (!$uid) $uid=$this->_uid;
		$query="SELECT * FROM AddrFieldsList WHERE FKUserID=".$this->_db->escape($uid);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('FKFieldID');
		}
		return $result;
	}
	function loadFields($uid=0,$use_perms=true) {
		$this->_user_fields_perms=0;
		$this->_user_fields=array();
		$this->_k_fields=array();
		$this->_addr_fields=array();
		$this->_ldap_field_transform=array();
		$this->_sfields=array();

		if (!$uid) $uid=$this->_uid;
		$avListFields=$this->loadListFields($uid);

		$query="SELECT * FROM AddrFields  WHERE Aktiv=1";
		if (!$this->isRuleUser() && $use_perms) $query.=" AND ((Users='' AND Groups='') OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
		$query.=" ORDER BY Sequence";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			if ($this->isRuleUser() || ($this->_db->f('Users')=='' && $this->_db->f('Groups')=='')) {
				$acl=6;
			} else {
				$acl=$this->_frm->calcAcl($this->_db->f('Users'),$this->_db->f('Groups'),$this->_uid);
			}
			if (!($acl&2)) continue;
			$this->_addr_fields[$this->_db->f("FieldID")]=array(
				'FieldTyp'=>$this->_db->f('FieldTyp'),
				'Title'=>$this->_db->f("Title_".$this->_lang),
				'Card'=>$this->_db->f("Card"),
				'Search'=>$this->_db->f("Search"),
				'Typ'=>$this->_db->f("Typ"),
				'Value'=>$this->_db->f("Value"),
				'Action'=>$this->_db->f("Action"),
				'Multi'=>$this->_db->f("Multi"),
				'Vcard'=>$this->_db->f("Vcard"),
				'Ldap'=>$this->_db->f("Ldap"),
				'Sequence'=>$this->_db->f("Sequence"),
				'Perms'=>$acl,
				'FKUserID'=>$this->_db->f("FKUserID"),
				'F_Required'=>$this->_db->f("F_Required"),
				'F_Default'=>$this->_db->f("F_Default"),
				'F_Unique'=>$this->_db->f("F_Unique"),
				'F_Mode'=>$this->_db->f("F_Mode"),
				'RefID'=>$this->_db->f("RefID"),
			);
			if (in_array($this->_db->f("FieldID"),$avListFields)) {
				$this->_addr_fields[$this->_db->f("FieldID")]['FKUserID']=$uid;
				$list_fields[]=$this->_db->f("FieldID");
			}
			if ($this->_db->f('FieldTyp')=='u') {
				$this->_user_fields[]=$this->_db->f("FieldID");
				$this->_user_fields_perms=$this->_user_fields_perms|$acl;
			}
			if ($this->_db->f('FieldTyp')=='k')	{
				$this->_k_fields[]=$this->_db->f("FieldID");
			}
			if ($this->_db->f('Search')==1) {
				$this->_sfields[]=$this->_db->f("FieldID");
			}
			if ($this->_db->f('Ldap')) {
				$this->_ldap_field_transform[$this->_db->f("FieldID")]=$this->_db->f('Ldap');
			}
			if ($this->_db->f('RefID')) {
				$this->_ref_fields[$this->_db->f("RefID")]=$this->_db->f('FieldID');
			}

		}
		if ($list_fields) {
			$this->_list_fields=$list_fields;
		} else {
			$def=$GLOBALS['frm']->getDefaults('addr');
			$this->_list_fields=explode('|',$def['lfields']);
		}
		foreach ($this->getIntFields() as $key=>$val) {
			if (in_array($key,$avListFields)) {
				$this->_list_fields[]=$key;
			}
		}
	}
	function getVcardFields() {
		$result=array();
		foreach ($this->getFields() as $key=>$val) {
			if ($val['Vcard']) {
				$result[$key]=$val['Vcard'];
			}

		}
		return $result;
	}
	function getLdapFields() {
		$result=array();
		foreach ($this->getFields() as $key=>$val) {
			if ($val['Ldap']) {
				$result[$key]=$val['Ldap'];
			}

		}
		return $result;
	}
	function AddrExplode($val) {
		if ($val) {
			return explode('||',$val);
		} else {
			return array();
		}
	}
	function AddrImplode($val) {
		return implode('||',$val);
	}
	function formatMail(&$aobj,$mail) {
		switch (GE_addrNameMode) {
			case 'fvn':
			case 'vn':
				$m_name=trim($aobj->getMeta('Vorname').' '.$aobj->getMeta('Nachname'));
			break;
			default:
				$m_name=trim($aobj->getMeta('Nachname').' '.$aobj->getMeta('Vorname'));
			break;
		}
		if (!$m_name) $m_name=$aobj->getMeta('Firma');
		$temp=explode('@',trim($mail));
		if (function_exists('imap_rfc822_write_address')) {
			return imap_rfc822_write_address ($temp[0],$temp[1],$m_name);
		} else {
			return $m_name.' <'.$mail.'>';
		}
	}
	function formatFax(&$aobj,$fax) {
		$m_name=trim($aobj->getMeta('Nachname').' '.$aobj->getMeta('Vorname'));
		if (!$m_name) $m_name=$aobj->getMeta('Firma');
		if ($m_name) {
			return trim($m_name.'@'.$this->formatTel($fax));
		} else {
			return $fax;
		}
	}
	function formatWeb(&$aobj,$url) {
		$temp=@parse_url($url);
		if (!$temp['scheme']) {
			$url='http://'.$url;
		}
		return $url;
	}
	function formatCallto(&$aobj,$val) {
		if ($this->_asxPhone) {
			$res="javascript:void(sndReq('callto','ajax.php','ajax_modul=asxCall";
			if (is_object($aobj)) $res.="&AddrID=".$aobj->getID();
			$res.="&number=".$this->formatTel($val,false)."'));";
		} elseif ($this->getCfg('cfg/skype')) {
			$res=($this->getCfg('cfg/skype/handler')?$this->getCfg('cfg/skype/handler'):'callto://').$this->formatTel($val);
		} else {
			$res='';
		}
		return $res;
	}
	function formatSms(&$aobj,$sms) {
		return $this->formatTel($sms);
	}
	function formatTel($tel,$useCfg=true) {
        $tel=preg_replace('/[^0-9+]/','',$tel);
        $tel=str_replace('+','00',$tel);
        if ($useCfg && $this->getCfg('cfg/skype/preg_search')) {
			//debug($this->getCfg('cfg/skype/preg_replace'));
			$tel=preg_replace($this->getCfg('cfg/skype/preg_search'),$this->getCfg('cfg/skype/preg_replace'),$tel);
		}
        return $tel;

	}
	function &ListAllTree($RootID=-1,$ParentID=-1,$order_f='Title_de',$order_d='ASC') {
		$result=array();
		if ($order_f) $order_met="ORDER BY $order_f $order_d";

		$sql_RootID=$this->_db->escape($RootID);
		if (is_array($RootID)) $where[]="RootID IN (".implode(",",$sql_RootID).")";
		elseif ($RootID!=-1)  $where[]="RootID=$sql_RootID";

		$sql_ParentID=$this->_db->escape($ParentID);
		if (is_array($ParentID)) $where[]="ParentID IN (".implode(",",$sql_ParentID).")";
		elseif ($ParentID!=-1)  $where[]="ParentID=$sql_ParentID";

		$where[]="(UserID=0 OR UserID=".$this->_db->escape($this->_uid).')';

		if (!$this->isRuleUser() && !empty($this->_sgroups)) {
			$where[]="(UserID=".$this->_db->escape($this->_uid)." OR SuperGroups LIKE '%|".implode(",%' OR SuperGroups LIKE '%|",$this->_sgroups).",%')";
		}

		$query="SELECT * FROM AddrNodeMetabase ";
		$query.=" WHERE  ".implode(' AND ',$where)." $order_met";
		//echo $query.'<br><br>';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='AObj_fol';
			$result[$this->_db->f("ParentID")][$this->_db->f("NodeID")]=new $class($this->_db->f("NodeID"),$this->fetchObject(),$this->fetchACL());
		}
		return $result;
	}

	function &ListSubEntrys($ParentID,$order_f='Title_de',$order_d='ASC') {
		$result=array();
		if ($order_f) $order_met="ORDER BY $order_f $order_d";

		$sql_ParentID=$this->_db->escape($ParentID);
		if (is_array($ParentID)) $where[]="ParentID IN (".implode(",",$sql_ParentID).")";
		else $where[]="ParentID=$sql_ParentID";

		$where[]="(UserID=0 OR UserID=".$this->_db->escape($this->_uid).')';
		if (!$this->isRuleUser() && !empty($this->_sgroups)) {
			$where[]="(UserID=".$this->_db->escape($this->_uid)." OR SuperGroups LIKE '%|".implode(",%' OR SuperGroups LIKE '%|",$this->_sgroups).",%')";
		}

		$query="SELECT * FROM AddrNodeMetabase ";
		$query.=" WHERE  ".implode(' AND ',$where)." $order_met";
		//echo $query.'<br><br>';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='AObj_fol';
			$result[$this->_db->f("NodeID")]=new $class($this->_db->f("NodeID"),$this->fetchObject(),$this->fetchACL());
		}
		return $result;
	}
	function searchFolders($RootID=null,$search='',$limit=0,$only_names=false) {
		$searchQuery=array();
		if (!$RootID) $RootID=array_keys($this->getRootIDs());
		$searchQuery[]=array('Field'=>'RootID','Typ'=>'=','Values'=>$RootID);
		if ($search['info']) {
			$searchQuery[]=array('Field'=>'Title_'.$this->_lang,'Typ'=>'like','Values'=>'%'.$search['info'].'%');
		}
		if (!$this->isRuleUser() && !empty($this->_sgroups)) {
			$searchQuery[]=array('Typ'=>'SQL','Values'=>"(UserID=".$this->_db->escape($this->_uid)." OR SuperGroups LIKE '%|".implode(",%' OR SuperGroups LIKE '%|",$this->_sgroups).",%')");
		}
		
		$query="SELECT * FROM AddrNodeMetabase WHERE ".$this->_db->getWhere($searchQuery);
		$query.=' ORDER BY Title_'.$this->_lang;
		if ($limit) $query.=' '.$this->_db->formatLimit(0,$limit);
		$entrys=array();
		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='AObj_fol';
			$entrys[$this->_db->f("NodeID")]=new $class($this->_db->f("NodeID"),$this->fetchObject(),$this->fetchACL());
		}
		if ($only_names) {
			foreach ($entrys as $key=>$val) {
				$entrys[$key]=implode('->',$this->getObjTreeNames($val));
			}
		}
		return $entrys;
	}


	function &getTreeIDs($NodeID) {
		if (!is_array($NodeID)) $tmp=array($NodeID); else $tmp=$NodeID;
		while (!empty($tmp)) {
			$query="SELECT ParentID FROM AddrNodeMetabase WHERE NodeID IN (".implode(',',$this->_db->escape($tmp)).")";
			$this->_db->query($query);
			$tmp=array();
			while ($this->_db->next_record()) {
				if ($this->_db->f('ParentID')) {
					$result[]=$this->_db->f('ParentID');
					$tmp[]=$this->_db->f('ParentID');
				}
			}
		}
		return $result;
	}

	function &getAddrNodes($AddrID) {
		$query="SELECT * FROM AddrNodeMetabase,AddrParent WHERE NodeID=FKNodeID AND FKAddressID=".$this->_db->escape($AddrID);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='AObj_fol';
			$result[$this->_db->f("NodeID")]=new $class($this->_db->f("NodeID"),$this->fetchObject(),$this->fetchACL());
		}
		return $result;
	}
	function &getAddrNodesIDs($AddrID) {
		$result=array();
		$query="SELECT FKNodeID FROM AddrParent WHERE FKAddressID=".$this->_db->escape($AddrID)." ORDER BY FKNodeID";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f("FKNodeID");
		}
		return $result;
	}
	function haveAddrEntrys($ParentID) {
		$query="SELECT FKAddressID FROM AddrParent WHERE FKNodeID=".$this->_db->escape($ParentID)." LIMIT 1";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return true;
		} else {
			return false;
		}

	}
	function haveNodeEntrys($ParentID) {
		$query="SELECT NodeID FROM AddrNodeMetabase WHERE ParentID=".$this->_db->escape($ParentID)." LIMIT 1";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return true;
		} else {
			return false;
		}
	}
	function getSystemObj($system,$lang,$user=-1) {
		if ($user==-1) $user=$this->_uid;
		$query="SELECT * FROM AddrNodeMetabase WHERE System=".$this->_db->escape($system);
		$query.=" AND UserID=".$this->_db->escape($user);
		//echo $query;
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='AObj_fol';
			return new $class($this->_db->f("NodeID"),$this->fetchObject($lang),$this->fetchACL());
		}
	}
	function updateMeta(&$obj) {
		$values=$obj->_meta;
		if ($obj->getID()) {
			$this->_db->update('AddrNodeMetabase',$values,"NodeID=".$this->_db->escape($obj->getID()));
			return $obj->getID();
		}
		return false;
	}
	function insertMeta(&$obj) {
		$values=$obj->_meta;
		$values['NodeID']=$this->_db->nextid('AddrNodeMetabase');
		if ($this->_db->insert('AddrNodeMetabase',$values)) {
			$obj->setID($values['NodeID']);
			return $obj->getID();
		}
		return false;
	}
	function deleteMeta(&$obj) {
		$query="DELETE FROM AddrNodeMetabase WHERE NodeID=".$this->_db->escape($obj->getID());
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function getObj($ID,$lang='') {
		$query="SELECT * FROM AddrNodeMetabase ";
		$query.=" WHERE NodeID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='AObj_fol';
			return new $class($this->_db->f("NodeID"),$this->fetchObject($lang),$this->fetchACL());
		}
	}
	function searchObj($search,$lang='') {
		$query="SELECT * FROM AddrNodeMetabase ";
		$query.=" WHERE ".$this->_db->getWhere($search);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='AObj_fol';
			return new $class($this->_db->f("NodeID"),$this->fetchObject($lang),$this->fetchACL());
		}
	}
	function objExists($ID) {
		$query="SELECT NodeID FROM AddrNodeMetabase ";
		$query.=" WHERE NodeID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return true;
		} else {
			return false;
		}
	}
	function getTrashObj() {
		$query="SELECT * FROM AddrNodeMetabase WHERE System='t'";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='AObj_trash';
			return new $class($this->_db->f("NodeID"),$this->fetchObject(),$this->fetchACL());
		}
	}

	function getObjTree($parent_id,$break=0,$lang='') {
		$result=array();
		if (!$lang) $lang=$this->_lang;
		do {
			$query="SELECT Title_".$lang.",ParentID,NodeID FROM AddrNodeMetabase WHERE NodeID=".$this->_db->escape($parent_id);
			$this->_db->query($query);
			if ($this->_db->next_record() && $this->_db->f('NodeID')!=$break) {
				$parent_id=$this->_db->f('ParentID');
				$result[$this->_db->f('NodeID')]=$this->_db->f('Title_'.$lang);
			} else {
				$parent_id=0;
			}

		} while ($parent_id);
		return $result;
	}
	function getObjTreeIDs ($oid,$break=0) {
		if ($oid!=$break) {
			do {
				$query="SELECT ParentID FROM AddrNodeMetabase WHERE NodeID=".$this->_db->escape($oid);
				$this->_db->query($query);
				if ($this->_db->next_record()) {
					$oid=$this->_db->f('ParentID');
					$result[]=$this->_db->f('ParentID');
				} else {
					$oid=0;
				}

			} while ($oid && $oid!=$break);
		} else {
			$result[]=$oid;
		}
		return $result;
	}
	function getObjTreeNames (&$Obj) {
		return array_reverse($this->getObjTree($Obj->getID()));
	}
	function isSubfolder($FolderID,$subFolderID) {
		if ($FolderID==$subFolderID) return true;
		$tree=$this->getObjTreeIDs ($FolderID);
		if (is_array($tree) && in_array($subFolderID,$tree)) {
			return true;
		} else {
			return false;
		}
	}

	function &fetchObject($lang='') {
		$result=array(
			'RootID'=>$this->_db->f('RootID'),
			'ParentID'=>$this->_db->f("ParentID"),
			'TimeCreate'=>$this->_db->f("TimeCreate"),
			'TimeModify'=>$this->_db->f("TimeModify"),
			'UserCreate'=>$this->_db->f("UserCreate"),
			'UserModify'=>$this->_db->f("UserModify"),
			'UserID'=>$this->_db->f("UserID"),
			'System'=>$this->_db->f('System'),
			'SuperGroups'=>$this->_db->f('SuperGroups'),
			'Trash'=>$this->_db->f('Trash'),
		);
		if (!$lang) $lang=$this->_lang;
		if (is_array($lang)) {
			foreach ($lang as $val) {
				$result['Title_'.$val]=$this->_db->f("Title_".$val);
			}

		} else {
			$result['Title_'.$lang]=$this->_db->f("Title_".$lang);
		}
		return $result;
	}
	function isAllowedAction(&$obj,&$action) {
		if (!is_array($action)) return false;
		//debug($obj->getID());
		//debug($obj->getAcl());
		if (!$obj->getAcl($action['Perms'])) return false;
		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkAction($obj,substr($ac_val,1));
				} else {
					$result=$result||$this->_checkAction($obj,$ac_val);
				}
			}
			if (!$result) return false;
		}
		return true;
	}
	function _checkAction(&$obj,$action) {

		switch ($action) {
			case 'sadmin':
				if (!$this->isSuperAdmin()) return false;
			break;
			case 'rule':
				if (!$this->isRuleUser()) return false;
			break;
			case 'root':
				if ($obj->getMeta('RootID')!=$obj->getID()) return false;
			break;
			case 'root_s':
				if ($this->_root_obj->getMeta('System')!='s') return false;
			break;
			case 'root_d':
				if ($this->_root_obj->getMeta('System')!='d') return false;
			break;
			case 'root_u':
				if ($this->_root_obj->getMeta('System')!='u') return false;
			break;
			case 'content':
				return ($this->haveAddrEntrys($obj->getID())|$this->haveNodeEntrys($obj->getID()));
			break;
			case 'app_msg':
				if (!$GLOBALS['app']['msg']) return false;
			break;
			case 'app_mail':
				if (!$GLOBALS['app']['email']) return false;
			break;
			case 'app_sms':
				//debug('ff');
				if (!$GLOBALS['app']['sms']) return false;
			break;
			case 'app_rem':
				//debug('ff');
				if (!$GLOBALS['app']['rem']) return false;
			break;
			case 'app_proj':
				if (!$GLOBALS['app']['proj'] || !$this->_P) return false;
			break;
			case 'mode_src':
				if ($this->getMode()!='src') return false;
			break;
			case 'list_perm':
				if (!$this->getPerms(32)) return false;
			break;
			case 'act_proj':
				 if (!$this->_frm->getPrefs('proj','actualProject')) return false;
			break;
			/*
			case 'limit':
				//echo $this->getRows();
				if (!$this->getLimit() ||  $this->getLimit()>$this->getRows()) return false;
			break;*/
		}
		return true;
	}
	function isAllowedAddrAction(&$obj,&$action) {
		//debug($action)
		if (!is_array($action)) return false;
		if (!$obj->getAcl($action['Perms'])) {
				return false;
		}
		
		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkAddrAction($obj,substr($ac_val,1),$action['Custom']);
				} else {
					$result=$result||$this->_checkAddrAction($obj,$ac_val,$action['Custom']);
				}
			}
			if (!$result) return false;
		}
		return true;
	}
	function _checkAddrAction(&$obj,$action,$custom='') {

		switch ($action) {
			case 'sadmin':
				if (!$this->isSuperAdmin()) return false;
			break;
			case 'rule':
				if (!$this->isRuleUser()) return false;
			break;
			case 'root_s':
				if ($this->_root_obj->getMeta('System')!='s') return false;
			break;
			case 'root_d':
				if ($this->_root_obj->getMeta('System')!='d') return false;
			break;
			case 'root_u':
				if ($this->_root_obj->getMeta('System')!='u') return false;
			break;
			case 'app_msg':
				if (!$GLOBALS['app']['msg']) return false;
			break;
			case 'app_mail':
				if (!$GLOBALS['app']['email']) return false;
			break;
			case 'app_proj':
				if (!$GLOBALS['app']['proj'] || !$this->_P) return false;
			break;
			case 'app_sms':
				if (!$GLOBALS['app']['sms']) return false;
			break;
			case 'fav':
				if (!$obj->getHotMeta('Favorite')) return false;
			break;
			case 'user':
				if (!$obj->getMeta('UserID')) return false;
			break;
			case 'a_write':
				if (!$this->getPerms(1) && !$this->getPerms(4)) return false;
			break;
			case 'act_proj':
				 if (!$this->_frm->getPrefs('proj','actualProject')) return false;
			break;
			case 'proj':
				if (!$this->_P || !$this->_frm->getPrefs('proj','actualProject')) return false;
				$av_proj=$this->getAddrProjects($obj);
				if (!in_array($this->_frm->getPrefs('proj','actualProject'),$av_proj)) return false;
			break;
			case 'app_custom':
				if (!$GLOBALS['app']['custom'] || !defined('GE_CUSTOM_APP')) return false;
				$appCustom=& $this->_frm->getStaticModul('custom');
				if (!is_object($appCustom)) return false;
				return $appCustom->isAllowedAction($custom,$obj,$this->_modul);
			break;

		}
		return true;
	}
	function formatAddrOrder($order,&$join=null) {
		if (is_array($order)) {
			$tmp_order=array();
			foreach ($order as $key=>$val) {
				if (strpos($key,'AddrMeta.')!==false) {
					$key=substr($key,9);
				}
				if (strpos($key,'AddrMetaUser.')!==false) {
					$key=substr($key,13);
				}
				if ($key=='Name') {
					switch (GE_addrNameMode) {
						case 'fvn':
							$tmp_order[]="TRIM(IF (AddrMeta.Firma!='',CONCAT(AddrMeta.Firma,AddrMeta.Vorname,AddrMeta.Nachname),CONCAT(AddrMeta.Vorname,AddrMeta.Nachname))) ".($val==-1?'DESC':'ASC');
						break;
						case 'vn':
							$tmp_order[]="TRIM(IF (AddrMeta.Nachname!='' OR AddrMeta.Vorname!='',CONCAT(AddrMeta.Vorname,AddrMeta.Nachname),AddrMeta.Firma)) ".($val==-1?'DESC':'ASC');
						break;
						case 'nv':
							$tmp_order[]="TRIM(IF (AddrMeta.Nachname!='' OR AddrMeta.Vorname!='',CONCAT(AddrMeta.Nachname,AddrMeta.Vorname),AddrMeta.Firma)) ".($val==-1?'DESC':'ASC');
						break;
						default:
							$tmp_order[]="TRIM(IF (AddrMeta.Firma!='',CONCAT(AddrMeta.Firma,AddrMeta.Nachname,AddrMeta.Vorname),CONCAT(AddrMeta.Nachname,AddrMeta.Vorname))) ".($val==-1?'DESC':'ASC');
						break;
					}
				} elseif($this->getFieldData($key,'Typ',1)) {
					switch($this->getFieldData($key,'Typ',1)) {
						case 'fk_user':
						case 'user':
							if (isset($join) && is_array($join)) {
								$join['tmp_user_'.$key]='LEFT JOIN auth_user_md5 as tmp_user_'.$key.' ON (tmp_user_'.$key.'.user_id='.$key.')';
							}
							$tmp_order[]='tmp_user_'.$key.'.lastname '.($val==-1?'DESC':'ASC');			
							$tmp_order[]='tmp_user_'.$key.'.firstname '.($val==-1?'DESC':'ASC');			
							
							
						break;
						default:
							if ($this->getFieldData($key,'FieldTyp',1)=='u') {
								$tmp_order[]='AddrMetaUser.'.$key.' '.($val==-1?'DESC':'ASC');
							} else {
								$tmp_order[]='AddrMeta.'.$key.' '.($val==-1?'DESC':'ASC');
							}
						break;
					}
				} else {
					$tmp_order[]=''.$key.' '.($val==-1?'DESC':'ASC');
				}
			}
			if (!empty($tmp_order)) {
				//debug($tmp_order);
				return ' ORDER BY '.implode(',',$tmp_order);
			}
		} elseif($order) {
			return ' ORDER BY '.$order;
		}
	}
	function searchSingleAddr($searchAddr) {
		$query="SELECT * FROM AddrMeta LEFT JOIN AddrMetaUser ON ( AddrMetaUser.FKAddressID=AddressID) LEFT JOIN  AddrHotList ON ( AddrHotList.FKAddressID=AddressID AND FKUserID=".$this->_db->escape($this->_uid).") LEFT JOIN AddrPermsProfil ON (ProfilID=FKProfilID)";
		$query.=" WHERE ".$this->_db->getWhere($searchAddr);
		$query.=" ORDER BY Trash,AddrMeta.TimeCreate DESC LIMIT 1";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return new AObj_addr($this->_db->f("AddressID"),$this->fetchAddrObject(array_keys($this->getFields())),0,$this->fetchAddrHot(),$this->fetchAddrACL());
		} else return false;
	}
	function searchAddr($b,$order,$searchAddr=NULL,$searchNode=NULL,$searchHot=NULL,$searchProject=NULL,$use_limit=false,$use_perms=true,$addFields=null,$onlyID=0) {
		$result=array();
		$fFields=array();
		if ($onlyID) {
			$fields=array(
				'AddrMeta.AddressID',
				'AddrMeta.UserID',
				'AddrPermsProfil.Users',
				'AddrPermsProfil.Groups',
			);
		} else {
			$fields=array(
				'AddrMeta.AddressID',
				'AddrMeta.UserID',
				'AddrMeta.Trash',
				'AddrMeta.TrashIDs',
				'AddrMeta.TimeCreate',
				'AddrMeta.TimeModify',
				'AddrMeta.TimeVisited',
				'AddrMeta.UserVisited',
				'AddrMeta.UserCreate',
				'AddrMeta.UserModify',
				'AddrMeta.ExternID',
				'AddrPermsProfil.Users',
				'AddrPermsProfil.Groups',
			);
			foreach($this->getlistFields() as $key) {
				if ($this->getFieldData($key,'FieldTyp',1)=='u') {
					$fields[]='AddrMetaUser.'.$key;
				} else {
					$fields[]='AddrMeta.'.$key;
				}
				$fFields[]=$key;
			}
			if (is_array($addFields)) {
				foreach ($addFields as $key) {
					if (strpos($key,'.')===false) {
						if ($this->getFieldData($key,'FieldTyp',1)=='u') {
							$val='AddrMetaUser.'.$key;
						} else {
							$val='AddrMeta.'.$key;
						}
					} else {
						$val=$key;
					}
					if (!in_array($val,$fields)) {
						$fields[]=$val;
						$fFields[]=$key;
					}
				}
			}
			if (!in_array('AddrMeta.Vorname',$fields)) {
				$fields[]='AddrMeta.Vorname';
				$fFields[]='Vorname';
			}
			if (!in_array('AddrMeta.Nachname',$fields)) {
				$fields[]='AddrMeta.Nachname';
				$fFields[]='Nachname';
			}
			if (!in_array('AddrMeta.Firma',$fields)) {
				$fields[]='AddrMeta.Firma';
				$fFields[]='Firma';
			}
			if (isset($this->_addr_fields['MaidenName']) && !in_array('AddrMeta.MaidenName',$fields)) {
				$fields[]='AddrMeta.MaidenName';
				$fFields[]='MaidenName';
			}
			if ($this->_archivCat) {
				$fields[]='AddrMeta.Archiv';
				$fFields[]='Archiv';
			}
		}
		$orderJoin=array();
		$orderSql=$this->formatAddrOrder($order,$orderJoin);

		$query="SELECT ".implode(',',$fields)." FROM AddrMeta LEFT JOIN AddrMetaUser ON ( AddrMetaUser.FKAddressID=AddressID) LEFT JOIN AddrPermsProfil ON ( FKProfilID=ProfilID) ";
		if (!empty($searchHot)) {
			$query.=" LEFT JOIN  AddrHotList ON ( AddrHotList.FKAddressID=AddressID AND FKUserID=".$this->_db->escape($this->_uid).") ";
			$where[]=$this->_db->getWhere($searchHot);
		}
		if (!empty($searchProject)) {
			$query.=" LEFT JOIN  AddrParentProject ON (AddrParentProject.FKAddressID=AddressID) ";
			$where[]=$this->_db->getWhere($searchProject);
		}
		if (!empty($orderJoin)) {
			$query.=' '.implode(' ',$orderJoin);
		}
		if (!empty($searchNode)) {
			$query.=",AddrParent ";
			$where[]="AddressID=AddrParent.FKAddressID";
			$where[]=$this->_db->getWhere($searchNode);
		}
		//debug($this->getPerms(2));
		if ($use_perms) {
			if (!$this->isRuleUser()) {
				if ($this->getPerms(2)) {
					$where[]="(UserID=".$this->_db->escape($this->_uid)." OR (UserID=0 AND ((AddrPermsProfil.Users IS NULL AND AddrPermsProfil.Groups IS NULL) OR AddrPermsProfil.Users LIKE '%|".$this->_uid.",%' OR AddrPermsProfil.Groups LIKE '%|".implode(",%' OR AddrPermsProfil.Groups LIKE '%|",$this->_gid).",%')))";
				} elseif ($this->havePermsProfilAcl(2)) {
					$where[]="(UserID=".$this->_db->escape($this->_uid)." OR (UserID=0 AND AddrPermsProfil.Users LIKE '%|".$this->_uid.",%' OR AddrPermsProfil.Groups LIKE '%|".implode(",%' OR AddrPermsProfil.Groups LIKE '%|",$this->_gid).",%'))";
				} else {
					$where[]="UserID=".$this->_db->escape($this->_uid);
				}
			} else {
				$where[]="(UserID=".$this->_db->escape($this->_uid)." OR UserID=0)";
			}
		}
		
		
		if (!empty($searchAddr)) $where[]=$this->_db->getWhere($searchAddr);
		if ($where)  $query.=' WHERE ('.implode(') AND (',$where).')';
		$query.=" GROUP BY AddressID";
		$query.=$orderSql;
		if ($this->getLimit()) $query.=' '.$this->_db->formatLimit($b,$this->getLimit()).' ';
		$this->_db->query($query);

		$this->setRows($this->_db->num_rows());
		$class='AObj_addr';
		while ($this->_db->next_record()) {
			if ($onlyID) {
				if (!$use_perms || $this->fetchAddrACL()) {
					$result[]=$this->_db->f("AddressID");
				}
			} else {
				$acl=$this->fetchAddrACL();
				//echo $acl.'<br>';
				if ($acl || !$use_perms) {
					$result[$this->_db->f("AddressID")]=new $class($this->_db->f("AddressID"),$this->fetchAddrObject($fFields),0,$this->fetchAddrHot(),$acl);
				}
			}
		}
		if ($use_limit && $this->getLimit() && ($b!=0 || $this->getLimit()==$this->getRows())) {
			$query="SELECT count(DISTINCT(AddressID)) as num FROM AddrMeta LEFT JOIN AddrMetaUser ON ( AddrMetaUser.FKAddressID=AddressID) LEFT JOIN AddrPermsProfil ON ( FKProfilID=ProfilID) ";
			if (!empty($searchHot)) {
				$query.=" LEFT JOIN  AddrHotList ON ( AddrHotList.FKAddressID=AddressID AND FKUserID=".$this->_db->escape($this->_uid).") ";
			}
			if (!empty($searchProject)) {
				$query.=" LEFT JOIN  AddrParentProject ON (AddrParentProject.FKAddressID=AddressID) ";
			}
			if (!empty($searchNode)) {
				$query.=",AddrParent ";
			}
			if ($where)  $query.=' WHERE '.implode(' AND ',$where);
			$this->_db->query($query);
			$this->_db->next_record();
			$this->setRows($this->_db->f('num'));
		}
		return $result;
	}
	function searchDublicate($search,$user_id) {
		$result=array();
		$count=array();
		$where=array();
		$where[]='Trash='.$this->_db->escape(0);
		if ($this->_archivCat) {
			$where[]='Archiv='.$this->_db->escape(0);
		}
		$where[]='UserID IN ('.implode(",",$this->_db->escape($user_id)).")";

		switch($search) {
			case 'fnv';
				$field='CONCAT(Firma,Nachname,Vorname) as check_field';
			break;
			case 'nv';
				$field='CONCAT(Nachname,Vorname) as check_field';
				$where[]="(Nachname!='' OR Vorname!='')";
			break;
			case 'mail';
				$field='Email as check_field';
				$where[]="Email!=''";
			break;
			case 'mob';
				$field='Mobil as check_field';
				$where[]="Mobil!=''";
			break;
			case 'atel';
				$field='ATel as check_field';
				$where[]="ATel!=''";
			break;
			case 'ptel';
				$field='PTel as check_field';
				$where[]="PTel!=''";
			break;
			case 'fax';
				$field='Fax as check_field';
				$where[]="Fax!=''";
			break;
			default:
			    return $result;
			break;
		}

		$query="SELECT AddressID,$field FROM AddrMeta LEFT JOIN AddrMetaUser ON ( AddrMetaUser.FKAddressID=AddressID) LEFT JOIN AddrPermsProfil ON ( FKProfilID=ProfilID) ";
		//debug($this->getPerms(2));
		if (!$this->isRuleUser()) {
			if ($this->getPerms(2)) {
				$where[]="(UserID=".$this->_db->escape($this->_uid)." OR (UserID=0 AND ((AddrPermsProfil.Users IS NULL AND AddrPermsProfil.Groups IS NULL) OR AddrPermsProfil.Users LIKE '%|".$this->_uid.",%' OR AddrPermsProfil.Groups LIKE '%|".implode(",%' OR AddrPermsProfil.Groups LIKE '%|",$this->_gid).",%')))";
			} elseif ($this->havePermsProfilAcl(2)) {
				$where[]="(UserID=".$this->_db->escape($this->_uid)." OR (UserID=0 AND AddrPermsProfil.Users LIKE '%|".$this->_uid.",%' OR AddrPermsProfil.Groups LIKE '%|".implode(",%' OR AddrPermsProfil.Groups LIKE '%|",$this->_gid).",%'))";
			} else {
				$where[]="UserID=".$this->_db->escape($this->_uid);
			}
		} else {
			$where[]="(UserID=".$this->_db->escape($this->_uid)." OR UserID=0)";
		}
		$query.=' WHERE ('.implode(') AND (',$where).')';
		$query.=" ORDER BY check_field";
		$this->_db->query($query);

		$this->setRows($this->_db->num_rows());
		while ($this->_db->next_record()) {
			switch($search) {
				case 'mail';
					$values=array();
					foreach($this->AddrExplode($this->_db->f('check_field')) as $v)  {
						$values[]=strtolower(preg_replace('/[^0-9a-z.@_-]/iu','',$v));
					}
				break;
				case 'mob';
				case 'atel';
				case 'ptel';
				case 'fax';
					$values=array();
					foreach($this->AddrExplode($this->_db->f('check_field')) as $v) {
						$values[]=preg_replace('/[^0-9]/i','',$v);
					}
				break;
				default:
					$values=array(preg_replace('/[^\pL\pN]/ui','',$this->_db->f('check_field')));
				break;
			}
			foreach($values as $v) {
				if (!$v) continue;
				if (!isset($count[$v])) $count[$v]=array();
				$count[$v][]=$this->_db->f('AddressID');
			}
		}
		foreach($count as $k=>$v) {
			if (count($v) > 1) {
				$result[$k]=$v;
			}
		}
		return $result;
	}	
	function searchAddrAdv($b=0,$order='',$search=array(),$use_limit=false,$use_perms=true,$archiv=0,$trash=0,$onlyID=0) {
		$result=array();

		$fFields=array();
		if ($onlyID) {
			$fields=array(
				'AddrMeta.AddressID',
				'AddrMeta.UserID',
				'AddrPermsProfil.Users',
				'AddrPermsProfil.Groups',
			);
		} else {
			$fields=array(
				'AddrMeta.AddressID',
				'AddrMeta.UserID',
				'AddrMeta.Trash',
				'AddrMeta.TrashIDs',
				'AddrMeta.TimeCreate',
				'AddrMeta.TimeModify',
				'AddrMeta.TimeVisited',
				'AddrMeta.UserVisited',
				'AddrMeta.UserCreate',
				'AddrMeta.UserModify',
				'AddrMeta.ExternID',
				'AddrPermsProfil.Users',
				'AddrPermsProfil.Groups',
			);
			foreach($this->getlistFields() as $key) {
				if ($this->getFieldData($key,'FieldTyp',1)=='u') {
					$fields[]='AddrMetaUser.'.$key;
				} else {
					$fields[]='AddrMeta.'.$key;
				}
				$fFields[]=$key;
			}
			if (!in_array('AddrMeta.Vorname',$fields)) {
				$fields[]='AddrMeta.Vorname';
				$fFields[]='Vorname';
			}
			if (!in_array('AddrMeta.Nachname',$fields)) {
				$fields[]='AddrMeta.Nachname';
				$fFields[]='Nachname';
			}
			if (!in_array('AddrMeta.Firma',$fields)) {
				$fields[]='AddrMeta.Firma';
				$fFields[]='Firma';
			}
			if (isset($this->_addr_fields['MaidenName']) && !in_array('AddrMeta.MaidenName',$fields)) {
				$fields[]='AddrMeta.MaidenName';
				$fFields[]='MaidenName';
			}
			if ($this->_archivCat) {
				$fields[]='AddrMeta.Archiv';
				$fFields[]='Archiv';
			}
		}
	
		
		$where=array();
		if ($trash!=-1) {
			$where[]='Trash='.$this->_db->escape($trash);
		}
		if ($this->_archivCat && $archiv!=-1) {
			$where[]='Archiv='.$this->_db->escape($archiv);
		}

		if ($use_perms) {
			if (!$this->isRuleUser()) {
				if ($this->getPerms(2)) {
					$where[]="(UserID=".$this->_db->escape($this->_uid)." OR (UserID=0 AND ((AddrPermsProfil.Users IS NULL AND AddrPermsProfil.Groups IS NULL) OR AddrPermsProfil.Users LIKE '%|".$this->_uid.",%' OR AddrPermsProfil.Groups LIKE '%|".implode(",%' OR AddrPermsProfil.Groups LIKE '%|",$this->_gid).",%')))";
				} elseif ($this->havePermsProfilAcl(2)) {
					$where[]="(UserID=".$this->_db->escape($this->_uid)." OR (UserID=0 AND AddrPermsProfil.Users LIKE '%|".$this->_uid.",%' OR AddrPermsProfil.Groups LIKE '%|".implode(",%' OR AddrPermsProfil.Groups LIKE '%|",$this->_gid).",%'))";
				} else {
					$where[]="UserID=".$this->_db->escape($this->_uid);
				}
			} else {
				$where[]="(UserID=".$this->_db->escape($this->_uid)." OR UserID=0)";
			}
		}
		$joins=array();
		$joins['AddrMetaUser']='LEFT JOIN AddrMetaUser ON ( AddrMetaUser.FKAddressID=AddressID)';
		$joins['AddrPermsProfil']='LEFT JOIN AddrPermsProfil ON ( FKProfilID=ProfilID)';
		$orderSql=$this->formatAddrOrder($order,$joins);
		$searchQuery=$this->_formatSearchSql($search,$joins,0);
		//debug($searchQuery);
		if (!empty($searchQuery)) $where[]=$this->_db->getWhere($searchQuery);
		//debug($where);

		$query="SELECT ".implode(',',$fields)." FROM AddrMeta ";
		$query.=implode(' ',array_unique($joins));
		if ($where)  $query.=' WHERE '.implode(' AND ',$where).'';


		$query.=" GROUP BY AddressID";
		//$query.=" AND Firma!='' AND AStrasse!='' AND AOrt!='' GROUP BY Firma,AStrasse,AOrt,APlz";

		$query.=$orderSql;
		if ($this->getLimit()) $query.=' '.$this->_db->formatLimit($b,$this->getLimit()).' ';
		//debug($query);
		$this->_db->query($query);

		$this->setRows($this->_db->num_rows());
		$class='AObj_addr';
		while ($this->_db->next_record()) {
			if ($onlyID) {
				if (!$use_perms || $this->fetchAddrACL()) {
					$result[]=$this->_db->f("AddressID");
				}
			} else {
				$acl=$this->fetchAddrACL();
				//echo $acl.'<br>';
				if ($acl || !$use_perms) {
					$result[$this->_db->f("AddressID")]=new $class($this->_db->f("AddressID"),$this->fetchAddrObject($fFields),0,$this->fetchAddrHot(),$acl);
				}
			}
		}
		if ($use_limit && $this->getLimit() && ($b!=0 || $this->getLimit()==$this->getRows())) {
			$query="SELECT count(DISTINCT(AddressID)) as num FROM AddrMeta ";
			$query.=implode(' ',array_unique($joins));
			if ($where)  $query.=' WHERE '.implode(' AND ',$where);
			$this->_db->query($query);
			$this->_db->next_record();
			$this->setRows($this->_db->f('num'));
		}
		return $result;
	}
	function _formatSearchSql(&$search,&$joins,$setID=0) {
		if (is_array($search[$setID]['field'])) {
			$searchQuery=array();
			foreach ($search[$setID]['field'] as $fieldID=>$fieldVal) {
				$Typ='';
				if ($fieldVal['typ']=='crm' && !$this->getFieldData($fieldVal['key'],'Typ',1)) {
					continue;
				}
				switch ($fieldVal['typ']) {
					case 'addr':
					case 'crm':
					case 'int':
						if ($this->getFieldData($fieldVal['key'],'Typ',1)=='stamm') {
							if ($fieldVal['value']) {
								$srcObj=$this->readAddrSearch($fieldVal['value']);
								$tmpSearch=unserialize($srcObj['Sdata']);
								if ($tmpSearch['search']) {
									$subJoins=array();
									$subJoins[]='LEFT JOIN AddrMetaUser ON ( AddrMetaUser.FKAddressID=AddressID)';
									$subQuery=$this->_formatSearchSql($tmpSearch['search'],$subJoins,0);
									$subSql='StammID=ANY (SELECT AddressID FROM  AddrMeta '.implode(' ',array_unique($subJoins)).' WHERE '.$this->_db->getWhere($subQuery).')';
									//debug($subSql);
									$searchQuery[]=array('Typ'=>'SQL','Values'=>$subSql);

								/*
									$subJoins=array();
									$subJoins[]='LEFT JOIN AddrMetaUser ON ( AddrMetaUser.FKAddressID=AddressID)';
									$subQuery=$this->_formatSearchSql($tmpSearch['search'],$subJoins,0);
									$subSql='SELECT AddressID FROM AddrMeta '.implode(' ',array_unique($subJoins)).' WHERE '.$this->_db->getWhere($subQuery);
									$this->_db->query($subSql);
									$StammID=array();
									while($this->_db->next_record()) {
										$StammID[]=$this->_db->f('AddressID');
									}
									//debug($StammID);
									if (!empty($StammID)) {
										$searchQuery[]=array('Field'=>'StammID','Typ'=>'=','Values'=>$StammID);
									}*/
								}



							}

							/*$subSql='EXISTS (SELECT * FROM AddrParent WHERE '.$this->_db->getWhere($subQuery).')';
							$searchQuery[]=array('Typ'=>'SQL','Values'=>$subSql);*/
						} else {
							switch ($fieldVal['mode']) {
								case 'lk':
									$Typ='like';
									if (!$fieldVal['value']) $Typ='';
									$fieldVal['value']='%'.$fieldVal['value'].'%';
								break;
								case 'nlk':
									$Typ='!like';
									if (!$fieldVal['value']) $Typ='';
									$fieldVal['value']='%'.$fieldVal['value'].'%';
								break;
								case 'is':
									$Typ='=';
								break;
								case 'nis':
									$Typ='!=';
								break;
								case 'em':
									$Typ='=';
									$fieldVal['value']='';
								break;
								case 'nem':
									$Typ='!=';
									$fieldVal['value']='';
								break;
								case 'gt':
									$Typ='>=';
								break;
								case 'lt':
									$Typ='<=';
								break;
								case 'bg':
									$Typ='like';
									if (!$fieldVal['value']) $Typ='';
									$fieldVal['value']=$fieldVal['value'].'%';
								break;
								case 'nbg':
									$Typ='!like';
									if (!$fieldVal['value']) $Typ='';
									$fieldVal['value']=$fieldVal['value'].'%';
								break;

							}
							if ($Typ) {
								$noEnc=false;
								if ($fieldVal['key']=='all') {
									$Field=array();
									foreach ($this->getSearchFields() as $v) {
										if ($this->getFieldData($v,'FieldTyp',1)=='u') {
											$Field[]='AddrMetaUser.'.$v;
										} else {
											$Field[]='AddrMeta.'.$v;
										}
									}
									$Field[]='AddrMeta.Name';
									$Field[]='AddrLog.Text';
									$joins['AddrLog']=" LEFT JOIN  AddrLog ON (AddrLog.FKAddressID=AddressID) ";
									$Val=$fieldVal['value'];
								} else {
									$Field='';
									if ($this->getFieldData($fieldVal['key'])) {
										if ($this->getFieldData($fieldVal['key'],'FieldTyp',1)=='u') {
											$Field='AddrMetaUser.'.$fieldVal['key'];
										} else {
											$Field='AddrMeta.'.$fieldVal['key'];
										}
									} else {
										$Field=$fieldVal['key'];
									}
									switch ($this->getFieldData($fieldVal['key'],'Typ',1)) {
										case 'chk':
											if ($fieldVal['value']=='Y') {
												$Val=1;
											} elseif ($fieldVal['value']=='N') {
												$Val=-1;
											} else {
												if ($Typ=='!=') {
													$Val='';
												} else {
													$Val=$Field."='' OR ".$Field.' IS NULL';
													$Typ='SQL';
												}
											}
										break;
										case 'num':
											if ($Typ=='like' || $Typ=='!like') {
												$Val=$fieldVal['value'];
											} else {
												$Val=trim($fieldVal['value']);
												$Val=str_replace(constTHOUSEND,'',$Val);
												$Val=str_replace(constDECIMAL,'.',$Val);
												$Val=floatval($Val);
											}
										break;
										case 'date':
											$Val=$this->_db->parseSearchDateSql($fieldVal['value'],$Field,$Typ);
											$noEnc=true;
											//debug($Val);
											//if ($Typ=='=') $Typ='like';
											//if ($Typ=='!=') $Typ='!like';
											//debug($Val);
										break;
										case 'unixdate':
											if ($Typ=='>=') {
												$Val=Framework::parseDate($fieldVal['value'],0,0,0,true);
											}
											if ($Typ=='<=') {
												$Val=Framework::parseDate($fieldVal['value'],23,59,59,true);
											}
											if ($Typ=='=' || $Typ=='!=') {
												$Val1=Framework::parseDate($fieldVal['value'],0,0,0,true);
												$Val2=Framework::parseDate($fieldVal['value'],23,59,59,true);
												if ($Val1) $Val=$Field.'>='.$this->_db->escape($Val1).' AND '.$Field.'<='.$this->_db->escape($Val2);
												$Typ='SQL';
											}
											if (!$Val) $Typ='';

										break;
										case 'select':
										case 'mselect':
											if (!$fieldVal['value']) {
												if ($Typ=='!=') {
													$Val='';
												} else {
													$Val=$Field."='' OR ".$Field.' IS NULL';
													$Typ='SQL';
												}
											} else {
												if ($Typ=='!=') $Val='NOT '; else $Val="";
												$Val.=$Field." REGEXP '[[:<:]]".addslashes(preg_quote($fieldVal['value'],''))."[[:>:]]'";
												$Typ='SQL';
											}
											//debug($Val);
										break;
										case 'fk_user':
											if (!$fieldVal['value']) {
												if ($Typ=='!=') {
													$Val='';
												} else {
													$Val=$Field."='' OR ".$Field.' IS NULL';
													$Typ='SQL';
												}
											} else {
												if ($Typ=='!=') $Val='NOT '; else $Val="";
												$Val.=$Field." REGEXP '[[:<:]]".addslashes(preg_quote($fieldVal['value'],''))."[[:>:]]'";
												$Typ='SQL';
											}
											//debug($Val);
										break;
										case 'password':
											if ($fieldVal['value']) {
												$Val=md5($fieldVal['value']);
											} else {
												$Val='';
											}
										break;
										default:
											$Val=$fieldVal['value'];
										break;
									}
								}
								if ($Typ) {
									if (is_array($Field)) {
										if ($Typ=='like' && $fieldVal['mode']!='bg') {
											$searchQuery[]=array('Field'=>$Field,'Typ'=>'concat','Values'=>$Val,'UseCase'=>0,'OnlyWords'=>0);
										} elseif ($Typ=='!like' && $fieldVal['mode']!='nbg') {
											$searchQuery[]=array('Field'=>$Field,'Typ'=>'!concat','Values'=>$Val,'UseCase'=>0,'OnlyWords'=>0);
										} else {
											$subQuery=array();
											foreach ($Field as $Fval) {
												$subQuery[]=array(array('Field'=>$Fval,'Typ'=>$Typ,'Values'=>$Val,'NoEnc'=>$noEnc));
											}
											$searchQuery[]=array('Typ'=>'OR','Values'=>$subQuery);
										}
									} else {
										$searchQuery[]=array('Field'=>$Field,'Typ'=>$Typ,'Values'=>$Val,'NoEnc'=>$noEnc);
									}
								}
							}
						}
					break;
					case 'grp':
						$subQuery=$this->_formatSearchSql($search,$joins,$fieldVal['value']);
						if (!empty($subQuery)) {
							$searchQuery[]=array('Typ'=>'AND','Values'=>$subQuery);
						}
					break;
					case 'cat':
						$catIds=array();
						if (trim($fieldVal['value'])) {
							$tmpIds=explode('|',$fieldVal['value']);
							foreach ($tmpIds as $val) {
								$catIds[]=substr($val,2);
							}
							if ($fieldVal['rec']) {

								if (in_array($this->getRootIDs('s'),$catIds)) {
									$catIds=array();
									switch ($fieldVal['mode']) {
										case 'is':
											$searchQuery[]=array('Field'=>'UserID','Typ'=>'=','Values'=>0);
										break;
										case 'nis':
											$searchQuery[]=array('Field'=>'UserID','Typ'=>'!=','Values'=>0);
										break;
									}
								} elseif (in_array($this->getRootIDs('u'),$catIds)) {
									$catIds=array();
									switch ($fieldVal['mode']) {
										case 'is':
											$searchQuery[]=array('Field'=>'UserID','Typ'=>'!=','Values'=>0);
										break;
										case 'nis':
											$searchQuery[]=array('Field'=>'UserID','Typ'=>'=','Values'=>0);
										break;
									}
								} else {
									$catIds=array_merge($catIds,$this->getSubNodeIDs($catIds));
								}
							}
							if (!empty($catIds)) {
								$catIds=array_unique($catIds);
								switch ($fieldVal['mode']) {
									case 'is':
										$subQuery=array();
										$subQuery[]=array('Field'=>'FKAddressID','Typ'=>'F=F','Values'=>'AddressID');
										$subQuery[]=array('Field'=>'FKNodeID','Typ'=>'=','Values'=>$catIds);
										$subSql='EXISTS (SELECT * FROM AddrParent WHERE '.$this->_db->getWhere($subQuery).')';
										$searchQuery[]=array('Typ'=>'SQL','Values'=>$subSql);

										/*$joins[]='INNER JOIN AddrParent ON (AddressID=AddrParent.FKAddressID)';
										$searchQuery[]=array('Field'=>'FKNodeID','Typ'=>'=','Values'=>$catIds);*/
									break;
									case 'nis':
										$subQuery=array();
										$subQuery[]=array('Field'=>'FKAddressID','Typ'=>'F=F','Values'=>'AddressID');
										$subQuery[]=array('Field'=>'FKNodeID','Typ'=>'=','Values'=>$catIds);
										$subSql='NOT EXISTS (SELECT * FROM AddrParent WHERE '.$this->_db->getWhere($subQuery).')';
										$searchQuery[]=array('Typ'=>'SQL','Values'=>$subSql);
									break;
								}
							}
						}
					break;
					case 'prj':
						$prjIds=array();
						if (trim($fieldVal['value'])) {
							$tmpIds=explode('|',$fieldVal['value']);
							foreach ($tmpIds as $val) {
								$prjIds[]=substr($val,2);
							}
							if (!empty($prjIds)) {
								$prjIds=array_unique($prjIds);
								$joins['AddrParentProject']=" LEFT JOIN  AddrParentProject ON (AddrParentProject.FKAddressID=AddressID) ";
								switch ($fieldVal['mode']) {
									case 'is':
										$subQuery=array();
										$subQuery[]=array('Field'=>'FKAddressID','Typ'=>'F=F','Values'=>'AddressID');
										$subQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$prjIds);
										$subSql='EXISTS (SELECT * FROM AddrParentProject WHERE '.$this->_db->getWhere($subQuery).')';
										$searchQuery[]=array('Typ'=>'SQL','Values'=>$subSql);

										//$joins[]=" LEFT JOIN  AddrParentProject ON (AddrParentProject.FKAddressID=AddressID) ";
										//$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$prjIds);
									break;
									case 'nis':
										$subQuery=array();
										$subQuery[]=array('Field'=>'FKAddressID','Typ'=>'F=F','Values'=>'AddressID');
										$subQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$prjIds);
										$subSql='NOT EXISTS (SELECT * FROM AddrParentProject WHERE '.$this->_db->getWhere($subQuery).')';
										$searchQuery[]=array('Typ'=>'SQL','Values'=>$subSql);

									break;
								}
							}
						}
					break;

				}
			}
			if ($search[$setID]['mode']=='and') {
				//debug($searchQuery);
				return $searchQuery;
			} else {
				if (empty($searchQuery)) {
					return $searchQuery;
				} else {
					$subQuery=array();
					foreach ($searchQuery as $val) {
						$subQuery[]=array($val);
					}
					return array(array('Typ'=>'OR','Values'=>$subQuery));
				}

			}
		}
	}
	function getStammAddr($ID,$NoID) {
		$result=array();
		$query="SELECT AddressID FROM AddrMeta WHERE StammID=".$this->_db->escape($ID)." AND AddressID!=".$this->_db->escape($NoID).$this->formatAddrOrder(array('Name'=>1));
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('AddressID');
		}
		return $result;
	}
	function existUserValues($ID) {
		$query="SELECT FKAddressID FROM AddrMetaUser WHERE FKAddressID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return true;
		} else {
			return false;
		}
	}
	function updateAddrMetaVisited($ID) {
		if ($ID && !empty($ID)) {
			$values=array();
			$values['TimeVisited']=time();
			$values['UserVisited']=$this->_uid;
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'AddressID','Typ'=>'=','Values'=>$ID);
			$this->_db->update('AddrMeta',$values,$this->_db->getWhere($searchQuery));
		}
	}
	function updateAddrMeta(&$obj,$export=true,$uid=0,$writeLog=true) {
		if (!$uid) $uid=$this->_uid;
		if ($obj->getID()) {
			$mFields=array();
			$oldObj=$this->getAddrObj($obj->getID());
			$values=$obj->_meta;
			unset($values['AddressID']);
			$values['TimeVisited']=time();
			$values['UserVisited']=$uid;
			$modified=false;
			$uvalues=array();
			$uvaluesFunc=array();
			foreach ($values as $key=>$val) {
				if (isset($this->_addr_fields[$key]) && $oldObj->getMeta($key)!=$val) {
					$mFields[$key]=array($oldObj->getMeta($key),$val);
				}
				if ($this->getFieldData($key,'FieldTyp')=='u') {
					if ($this->getFieldData($key,'Typ')=='num' && (string)$val==='') {
						$uvaluesFunc[$key]='NULL';
					}
					$uvalues[$key]=$val;
					unset($values[$key]);
				}

			}
			if (!empty($mFields)) {
				$values['SearchPhone']=Addr::calcSearchPhone($obj);
			}
			if ($this->_db->update('AddrMeta',$values,"AddressID=".$this->_db->escape($obj->getID()))) {
				if (!empty($uvalues)) {
					//debug($uvalues);
					if ($this->existUserValues($obj->getID())) {
						$this->_db->update('AddrMetaUser',$uvalues,"FKAddressID=".$this->_db->escape($obj->getID()),$uvaluesFunc);
					} else {
						$uvalues['FKAddressID']=$obj->getID();
						$this->_db->insert('AddrMetaUser',$uvalues,$uvaluesFunc);
					}
				}
				if ($writeLog && !empty($mFields)) {
					$modified=true;
					$LogID=$this->_Log->insertLog('addr',$obj->getID(),$uid,'fields');
					foreach ($mFields as $key=>$val) {
						$this->_Log->insertLogValues($LogID,$key,$val[0],$val[1]);
					}

				}
				$mNodes=false;
				$newNodes=$obj->getParentMeta('NodeIDs');
				if (is_array($newNodes) && !empty($newNodes)) {
					$oldNodes=$this->getAddrNodesIDs($obj->getID());
					sort($oldNodes);
					sort($newNodes);
					//debug($newNodes);
					if ($oldNodes!=$newNodes) {
						$modified=true;
						$LogID=$this->_Log->insertLog('addr',$obj->getID(),$uid,'cat');
						$this->_Log->insertLogValues($LogID,'Cat',serialize($oldNodes),serialize($newNodes));
						$this->deleteAddrParentMeta($obj);
						$this->insertAddrParentMeta($obj);
						$mNodes=true;
						/*if (in_array(4,$newNodes) && $obj->getMeta('UserID')==24) {
							mail('mthaler@endo7.com','Adresse geloescht',"ID:".$obj->getID()."\nName:".$obj->getName());

						}*/
					}
				}
				if ($modified) {
					$this->updateAddrMetaTime($obj->getID(),$uid);
				}
				if ($export) {
					$this->writeExport($obj,$oldObj,$mNodes);
				}
				return $obj->getID();
			}
		}
		return false;
	}
	function calcSearchPhone($values) {
		$result=array();
		$fields=array('ATel','PTel','Mobil','Fax','Intern','Iptel');
		if (is_object($values)) {
			$values=$values->_meta;
		}
		foreach ($fields as $f) {
			if (isset($values[$f]) && $values[$f]) {
				foreach (Addr::AddrExplode($values[$f]) as $val) {
					$tmp=Addr::cleanNumber($val);
					if ($tmp) $result[]=$tmp;
				}
			}
		}
		return implode(',',$result);
	}
	function cleanNumber($val) {
		return preg_replace('/[^0-9]/','',str_replace('+','00',$val));
	}
	function updateAddrMetaTime($id,$uid=0) {
		if (!$uid) $uid=$this->_uid;
		$this->_db->update('AddrMeta',array('TimeModify'=>time(),'UserModify'=>$uid),"AddressID=".$this->_db->escape($id));
	}
	function insertAddrMeta(&$obj,$export=true,$uid=0) {
		if (!$uid) $uid=$this->_uid;
		$values=$obj->_meta;
		$values['TimeVisited']=time();
		$values['UserVisited']=$uid;
		if (!$values['TimeCreate']) $values['TimeCreate']=time();
		if (!$values['TimeModify']) $values['TimeModify']=time();

		$uvalues=array();
		$uvaluesFunc=array();
		$values['AddressID']=$this->_db->nextid('AddrMeta');
		foreach ($values as $key=>$val) {
			if ($this->getFieldData($key,'FieldTyp')=='u') {
				if ($this->getFieldData($key,'Typ')=='num' && (string)$val==='') {
					$uvaluesFunc[$key]='NULL';
				}
				$uvalues[$key]=$val;
				unset($values[$key]);
			}
		}
		$values['SearchPhone']=Addr::calcSearchPhone($obj);
		if ($this->_db->insert('AddrMeta',$values)) {
			$obj->setID($values['AddressID']);
			$obj->setMeta('AddressID',$values['AddressID']);

			if (!empty($uvalues)) {
				$uvalues['FKAddressID']=$obj->getID();
				$this->_db->insert('AddrMetaUser',$uvalues,$uvaluesFunc);
			}
			$this->insertAddrParentMeta($obj);
			if ($export) {
				$this->writeExport($obj);
			}
			/*$LogID=$this->_Log->insertLog('addr',$obj->getID(),$uid,'create');
			foreach ($values as $key=>$val) {
				if (isset($this->_addr_fields[$key]) && $obj->getMeta($key) && $obj->getMeta($key)!='0000-00-00') {
					$this->_Log->insertLogValues($LogID,$key,'',$obj->getMeta($key));
				}
			}
			foreach ($uvalues as $key=>$val) {
				if (isset($this->_addr_fields[$key]) && $obj->getMeta($key) && $obj->getMeta($key)!='0000-00-00') {
					$this->_Log->insertLogValues($LogID,$key,'',$obj->getMeta($key));
				}
			}*/
			return $obj->getID();
		}
		return false;
	}
	function deleteAddrMeta(&$obj) {
		$values=$obj->_meta;
		$LogID=$this->_Log->insertLog('addr',$obj->getID(),$uid,'delete');
		foreach ($values as $key=>$val) {
			if (isset($this->_addr_fields[$key]) && $obj->getMeta($key) && $obj->getMeta($key)!='0000-00-00') {
				$this->_Log->insertLogValues($LogID,$key,$obj->getMeta($key),'');
			}
		}
		$query="DELETE FROM AddrMetaUser WHERE FKAddressID=".$this->_db->escape($obj->getID());
		$this->_db->query($query);
		$query="DELETE FROM AddrMeta WHERE AddressID=".$this->_db->escape($obj->getID());
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function insertAddrParentMeta(&$obj) {
		$Archiv=0;
		if ($obj->getID() && is_array($obj->getParentMeta('NodeIDs'))) {
			foreach ($obj->getParentMeta('NodeIDs') as $val) {
				$values=array(
					'FKNodeID'=>$val,
					'FKAddressID'=>$obj->getID(),

				);
				if ($this->_archivCat && in_array($val,$this->getArchivCat())) {
					$Archiv=1;
				}
				$this->_db->insert('AddrParent',$values,0,1);
			}
			if ($this->_archivCat && $Archiv!=$obj->getMeta('Archiv')) {
				$this->_db->update('AddrMeta',array('Archiv'=>$Archiv),"AddressID=".$this->_db->escape($obj->getID()));
			}

			return $obj->getID();
		}
		return false;
	}
	function deleteAddrParentMeta(&$obj) {
		$query="DELETE FROM AddrParent WHERE FKAddressID=".$this->_db->escape($obj->getID());
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function insertHotMeta(&$obj) {
		$values=$obj->_hmeta;
		if ($obj->getID()) {
			$values['FKAddressID']=$obj->getID();
			$values['FKUserID']=$this->_uid;
			$this->_db->insert('AddrHotList',$values,'',1);
			return $obj->getID();
		}
		return false;
	}
	function deleteHotMeta(&$obj) {
		$query="DELETE FROM AddrHotList WHERE FKAddressID=".$this->_db->escape($obj->getID());
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}

	function getAddrObj($ID) {
		$query="SELECT * FROM AddrMeta LEFT JOIN AddrMetaUser ON ( AddrMetaUser.FKAddressID=AddressID) LEFT JOIN  AddrHotList ON ( AddrHotList.FKAddressID=AddressID AND FKUserID=".$this->_db->escape($this->_uid).") LEFT JOIN AddrPermsProfil ON (ProfilID=FKProfilID)";
		if (is_array($ID)) {
			$query.=" WHERE AddressID IN (".implode(",",$this->_db->escape($ID)).")";
			//echo $query;
			$this->_db->query($query);
			$result=array();
			while ($this->_db->next_record()) {
				$result[$this->_db->f("AddressID")]=new AObj_addr($this->_db->f("AddressID"),$this->fetchAddrObject(array_keys($this->getFields())),0,$this->fetchAddrHot(),$this->fetchAddrACL());
			}
			return $result;
		} else {
			$query.=" WHERE AddressID=".$this->_db->escape($ID);
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				return new AObj_addr($this->_db->f("AddressID"),$this->fetchAddrObject(array_keys($this->getFields())),0,$this->fetchAddrHot(),$this->fetchAddrACL());
			} else return false;
		}
	}
	function fetchAddrObject($fields) {
		foreach ($fields as $val) {
			$result[$val]=$this->_db->f($val);
		}
		$result['AddressID']=$this->_db->f('AddressID');
		$result['UserID']=$this->_db->f('UserID');
		$result['Users']=$this->_db->f('Users');
		$result['Groups']=$this->_db->f('Groups');
		$result['Trash']=$this->_db->f('Trash');
		$result['TrashIDs']=$this->_db->f('TrashIDs');
		$result['TimeCreate']=$this->_db->f('TimeCreate');
		$result['TimeModify']=$this->_db->f('TimeModify');
		$result['TimeVisited']=$this->_db->f('TimeVisited');
		$result['UserVisited']=$this->_db->f('UserVisited');
		$result['UserCreate']=$this->_db->f('UserCreate');
		$result['UserModify']=$this->_db->f('UserModify');
		if ($this->_archivCat) {
			$result['Archiv']=$this->_db->f('Archiv');
		}
		$result['ExternID']=$this->_db->f('ExternID');
		if (!isset($result['Nachname'])) $result['Nachname']=$this->_db->f('Nachname');
		if (!isset($result['Vorname'])) $result['Vorname']=$this->_db->f('Vorname');
		if (!isset($result['Firma'])) $result['Firma']=$this->_db->f('Firma');
		return $result;
	}
	function &fetchAddrHot() {
		return array(
			'Favorite'=>$this->_db->f('Favorite'),
			'TimeLast'=>$this->_db->f('TimeLast'),
			'Counter'=>$this->_db->f('Counter'),
		);
	}
	function fetchAddrACL() {
		if ($this->_db->f('UserID')==$this->_uid) {
			return -1;
		} elseif ($this->_db->f('UserID')==0) {
			if ($this->isRuleUser()) {
				$acl=-1;
			} elseif ($this->_db->f('Users')=='' && $this->_db->f('Groups')=='') {
				$acl=$this->_perms[$this->_uid];
			} else {
				$acl=$this->_frm->calcAcl($this->_db->f('Users'),$this->_db->f('Groups'),$this->_uid);;
			}
			if (defined('GE_addrCustomImportNoEdit') && GE_addrCustomImportNoEdit && $this->_db->f('ExternID')) {
				if ($acl==-1) $acl=127;
				if ($acl&4) $acl-=4;
				
			}
			return $acl;
		} else {
			return 0;
		}

	}
	function fetchACL() {
		if ($this->_db->f('UserID')==$this->_uid) {
			return -1;
		} elseif ($this->_db->f('UserID')==0) {
			if ($this->isRuleUser()) {
				return -1;
			} else {
				return ($this->_perms[$this->_uid]|$this->_pperms[$this->_uid]);
			}
		} else {
			return 0;
		}
	}

	function insertLog ($AddrID,$user,$text,$typ,$date=0) {
		$values=array(
			'FKAddressID'=>$AddrID,
			'FKUserID'=>$user,
			'Text'=>$text,
			'Type'=>$typ,
			'Date'=>($date?$date:time()),

		);
		$this->_db->insert('AddrLog',$values);
	}
	function deleteLog($ID=0,$AddrID=0,$UserID=0) {
		if ($ID) $where[]="LogID=".$this->_db->escape($ID);
		if (is_array($AddrID)) $where[]="FKAddressID IN (".implode(",",$this->_db->escape($AddrID)).")";
		elseif ($AddrID) $where[]="FKAddressID=".$this->_db->escape($AddrID);
		if (is_array($UserID)) $where[]="FKUserID IN (".implode(",",$this->_db->escape($UserID)).")";
		elseif ($UserID) $where[]="FKUserID=".$this->_db->escape($UserID);
		if (is_array($where)) {
			$query="DELETE FROM AddrLog WHERE ".implode(' AND ',$where);
			$this->_db->query($query);
		}

	}

	function listLog($AddrID,$typ='',$user='') {
		$result=array();
		$query="SELECT * FROM AddrLog WHERE FKAddressID=".$this->_db->escape($AddrID)." ";
		if (is_array($typ)) $query.=" AND Type IN (".implode(",",$this->_db->escape($typ)).")";
		elseif ($typ) $query.=" AND Type=".$this->_db->escape($typ);
		if ($user) $query.=" AND FKUserID=".$this->_db->escape($user);
		$query.=' ORDER BY Date DESC';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("LogID")]=array(
				"Text"=>$this->_db->f("Text"),
				"Date"=>$this->_db->f("Date"),
				"User"=>$this->_db->f("FKUserID"),
				"Type"=>$this->_db->f("Type"),
			);
		}
		return $result;
	}
	function insertKmng ($AddrID,$KmngID,$text) {
		$values=array(
			'KmngID'=>$KmngID,
			'FKAddressID'=>$AddrID,
			'FKUserID'=>$this->_uid,
			'Text'=>$text,
			'Date'=>time(),

		);
		$this->_db->insert('AddrKmng',$values,'',1);
	}
	function deleteKmng($ID=0,$AddrID=0,$UserID=0) {
		if ($ID) $where[]="KmngID=".$this->_db->escape($ID);
		if (is_array($AddrID)) $where[]="FKAddressID IN (".implode(",",$this->_db->escape($AddrID)).")";
		elseif ($AddrID) $where[]="FKAddressID=".$this->_db->escape($AddrID);
		if (is_array($UserID)) $where[]="FKUserID IN (".implode(",",$this->_db->escape($UserID)).")";
		elseif ($UserID) $where[]="FKUserID=".$this->_db->escape($UserID);
		if (is_array($where)) {
			$query="DELETE FROM AddrKmng WHERE ".implode(' AND ',$where);
			//debug($query);
			$this->_db->query($query);
		}
	}

	function listKmng($AddrID,$user='') {
		$result=array();
		$query="SELECT * FROM AddrKmng WHERE FKAddressID=".$this->_db->escape($AddrID)." ";
		if ($user) $query.=" AND FKUserID=".$this->_db->escape($user);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("KmngID")]=array(
				"Text"=>$this->_db->f("Text"),
				"Date"=>$this->_db->f("Date"),
				"User"=>$this->_db->f("FKUserID"),
			);
		}
		$query="SELECT * FROM AddrKmng WHERE KmngID=".$this->_db->escape($AddrID)." ";
		if ($user) $query.=" AND FKUserID=".$this->_db->escape($user);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("FKAddressID")]=array(
				"Text"=>$this->_db->f("Text"),
				"Date"=>$this->_db->f("Date"),
				"User"=>$this->_db->f("FKUserID"),
			);
		}
		return $result;
	}



	function getPerms($test=0) {
		if ($this->isRuleUser()) return true;
		if (!isset($this->_perms[$this->_uid])) {
			$this->_setPerms();
		}
		if ($test) {
			return ($this->_perms[$this->_uid]&$test)?true:false;
		} else {
			return $this->_perms[$this->_uid];
		}
	}
	function _setPerms() {
		$query="SELECT BIT_OR(Perms) as uperms FROM AddrPerms WHERE";
		$query.=" UserTyp=".$this->_db->escape('u');
		$query.=" AND UserID=".$this->_db->escape($this->_uid);
		$query.=" GROUP BY UserTyp";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$this->_perms[$this->_uid]=$this->_db->f('uperms');
		} else {
			$query="SELECT BIT_OR(Perms) as uperms FROM AddrPerms WHERE";
			$query.=" UserTyp=".$this->_db->escape('g');
			$query.=" AND UserID IN (".implode(',',$this->_db->escape($this->_gid)).')';
			$query.=" GROUP BY UserTyp";
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				$this->_perms[$this->_uid]=$this->_db->f('uperms');
			} else {
				$this->_perms[$this->_uid]=0;
			}
		}
		/* Geht nicht
		$query="SELECT Users,Groups FROM AddrPermsProfil WHERE (Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$acl=$this->_frm->calcAcl($this->_db->f('Users'),$this->_db->f('Groups'),$this->_uid);
			$this->_perms[$this->_uid]=$this->_perms[$this->_uid]|$acl;
		}*/

	}
	function replacePerms($typ,$id,$Perms) {
		foreach ($Perms as $val) {
			$this->_db->insert('AddrPerms',array('UserID'=>$id,'UserTyp'=>$typ,'Perms'=>$val),'',1);
		}
	}
	function getAllPerms() {
		$result=array();
		$query="SELECT * FROM AddrPerms";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('UserTyp')][$this->_db->f('UserID')][]=$this->_db->f('Perms');
		}
		return $result;
	}
	function deletePerms($typ,$id) {
		$query="DELETE FROM AddrPerms WHERE";
		$query.=" UserTyp=".$this->_db->escape($typ);
		$query.=" AND UserID=".$this->_db->escape($id);
		$this->_db->query($query);
	}

	function listAddrSelect($Type) {
		$result=array();
		$query="SELECT SelID,Name_".$this->_lang." FROM AddrSelect WHERE SelType=".$this->_db->escape($Type)." ORDER BY Sequence,Name_".$this->_lang;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
				$result[$this->_db->f('SelID')]=$this->_db->f('Name_'.$this->_lang);
		}
		return $result;
	}
	function getAddrSelectID($Type,$lang,$info) {
		$query="SELECT SelID FROM AddrSelect WHERE SelType=".$this->_db->escape($Type);
		$subq=array('SelID='.$this->_db->escape($info));
		foreach ($lang as $val) {
			$subq[]="Name_".$val." LIKE ".$this->_db->escape($info);
		}
		$query.=" AND (".implode(' OR ',$subq).')';
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('SelID');
		} else {
			return false;
		}
	}

	function insertAddrSelect($Type,$Data) {
		$query="SELECT max(Sequence) as num FROM AddrSelect WHERE SelType=".$this->_db->escape($Type);
		$this->_db->query($query);
		$this->_db->next_record();
		$Data['Sequence']=$this->_db->f('num') + 1;
		$Data['SelType']=$Type;
		$Data['SelID']=$this->_db->nextid('AddrSelect_'.$Type);
		$this->_db->insert('AddrSelect',$Data,'',1);
		return $Data['SelID'];
	}
	function updateAddrSelect($Type,$ID,$Data) {
		$this->_db->update('AddrSelect',$Data ,'SelID='.$this->_db->escape($ID).' AND SelType='.$this->_db->escape($Type));
	}
	function readAddrSelect($Type,$ID,$lang) {
		$query="SELECT * FROM AddrSelect WHERE SelID=".$this->_db->escape($ID).' AND SelType='.$this->_db->escape($Type);
		$this->_db->query($query);
		$this->_db->next_record();
		foreach ($lang as $val) {
			$result['Name_'.$val]=$this->_db->f("Name_".$val);
		}
		$result['Sequence']=$this->_db->f("Sequence");
		return $result;
	}
	function deleteAddrSelect($Type,$ID=NULL) {
		$query="DELETE FROM AddrSelect WHERE SelType=".$this->_db->escape($Type);
		if (isset($ID)) $query.=" AND SelID=".$this->_db->escape($ID);
		$this->_db->query($query);
	}
	function switchAddrSelect ($Type,$oID,$dir='down') {
		$query="SELECT Sequence FROM AddrSelect WHERE SelType=".$this->_db->escape($Type)." AND SelID=".$this->_db->escape($oID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$oSequence=$this->_db->f('Sequence');
			if ($dir=='up'){
				$sign='<';
				$order='DESC';
			}elseif ($dir=='down') {
				$sign='>';
				$order='ASC';
			} elseif ($dir=='first') {
				$sign='<';
				$order='ASC';
			}
			$query="SELECT SelID,Sequence  FROM AddrSelect WHERE SelType=".$this->_db->escape($Type)." ";
			$query.="AND Sequence $sign ".intval($oSequence);
			$query.=" ORDER BY Sequence $order LIMIT 1";
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				$nID=$this->_db->f('SelID');
				$nSequence=$this->_db->f('Sequence');
				$query="UPDATE AddrSelect SET Sequence=".intval($nSequence)." WHERE SelType=".$this->_db->escape($Type)." ";
				$query.="AND SelID=".$this->_db->escape($oID);
				$this->_db->query($query);
				if ($dir=='first') {
					$query="UPDATE AddrSelect SET Sequence=Sequence+1 WHERE SelType=".$this->_db->escape($Type)." ";
					$query.="AND Sequence<$oSequence AND SelID!=".$this->_db->escape($oID);
					$this->_db->query($query);
				} else {
					$query="UPDATE AddrSelect SET Sequence=".intval($oSequence)." WHERE SelType=".$this->_db->escape($Type)." ";
					$query.="AND SelID=".$this->_db->escape($nID);
					$this->_db->query($query);
				}
			}
		}
	}
	function insertAddrFieldsList($FieldID) {
		$values=array(
			'FKFieldID'=>$FieldID,
			'FKUserID'=>$this->_uid,
		);
		$this->_db->insert('AddrFieldsList',$values,'',1);
	}
	function deleteAddrFieldsList($FieldID=0) {
		$query="DELETE FROM AddrFieldsList WHERE FKUserID=".$this->_db->escape($this->_uid);
		if ($FieldID) $query.=" AND FKFieldID=".$this->_db->escape($FieldID);
		$this->_db->query($query);
	}
	function deleteUser($uid) {
		$this->setLimit(0);

/*
		$searchAddr=array();
		$searchAddr[]=array('Field'=>'UserID','Typ'=>'=','Values'=>$uid);
		$delObj=$this->searchAddr(0,'',$searchAddr,'','','',false,false);
		if (is_array($delObj)) {
			foreach ($delObj as $obj) {
				$this->deleteAddrParentMeta($obj);
				$this->deleteAddrMeta($obj);
				$this->deleteHotMeta($obj);
				$this->deleteLog(0,$obj->getID(),0);
				$this->deleteKmng($ID=0,$obj->getID(),$UserID=0);
			}
		}
*/
		if ($uid) {
			$query="DELETE FROM AddrFieldsList WHERE FKUserID=".$this->_db->escape($uid);
			$this->_db->query($query);
			$query="DELETE FROM AddrNodeMetabase WHERE UserID=".$this->_db->escape($uid);
			$this->_db->query($query);
		}

	}
	function getNextSearchID() {
		$query="SELECT max(SearchID) as num FROM AddrSearch ";
		$this->_db->query($query);
		$this->_db->next_record();
		return (intval($this->_db->f("num")) + 1);

	}
	function insertAddrSearchTemp($sdata) {
		$Data['Sdata']=$sdata;
		$Data['FKUserID']=$this->_uid;
		//debug($Data);
		$this->_db->insert('AddrSearchTemp',$Data,'',1);
		return $ID;
	}
	function insertAddrSearch($Data,$ID=NULL) {
		if (!isset($ID)) $ID=$this->getNextSearchID();
		$Data['SearchID']=$ID;
		$Data['FKUserID']=$this->_uid;
		$this->_db->insert('AddrSearch',$Data,'',1);
		return $ID;
	}
	function updateAddrSearch($ID,$Data) {
		$this->_db->update('AddrSearch',$Data,"SearchID=".$this->_db->escape($ID));
	}
	function readAddrSearch($ID) {
		$query="SELECT * FROM AddrSearch WHERE SearchID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$result=array(
				'Title'=>$this->_db->f("Title"),
				'FKUserID'=>$this->_db->f("FKUserID"),
				'Groups'=>$this->_db->f("Groups"),
				'Users'=>$this->_db->f("Users"),
				'Sdata'=>$this->_db->f("Sdata"),
				'Mlist'=>$this->_db->f("Mlist"),
				'Flist'=>$this->_db->f("Flist"),
				'Slist'=>$this->_db->f("Slist"),
			);
			return $result;
		} else {
			return false;
		}
	}
	function readAddrSearchTemp($onlyVal=false) {
		$query="SELECT * FROM AddrSearchTemp WHERE FKUserID=".$this->_db->escape($this->_uid);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			if ($onlyVal) {
				return unserialize($this->_db->f("Sdata"));
			} else {
				$result=array(
					'FKUserID'=>$this->_db->f("FKUserID"),
					'Sdata'=>$this->_db->f("Sdata"),
				);
				return $result;
			}
		} else {
			return false;
		}
	}
	function listAddrSearch($only_mail=false,$only_fax=false,$only_sms=false) {
		$result=array();
		$query="SELECT SearchID,Title,FKUserID FROM AddrSearch";
		$query.=" WHERE (FKUserID=".$this->_db->escape($this->_uid)." OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
		if ($only_mail) $query.=" AND Mlist=1";
		if ($only_fax) $query.=" AND Flist=1";
		if ($only_sms) $query.=" AND Slist=1";
		$query.=" ORDER BY Title";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("SearchID")]=array(
				'Title'=>$this->_db->f("Title"),
				'FKUserID'=>$this->_db->f("FKUserID"),
			);
		}
		return $result;
	}
	function deleteAddrSearch($ID=NULL,$uid=0) {
		if (!$uid) $uid=$this->_uid;
		$query="DELETE FROM AddrSearch WHERE FKUserID=".$this->_db->escape($uid);
		if (isset($ID)) $query.=" AND SearchID=".$this->_db->escape($ID);
		$this->_db->query($query);
	}
	function getSyncIDs ($user_id=0,$sub=true,$onlyTop=false) {
		if (!$user_id) $user_id=$this->_uid;
		$query="SELECT FKNodeID,TopID FROM AddrSyncNode,AddrNodeMetabase WHERE FKNodeID=NodeID AND AddrSyncNode.FKUserID=".$this->_db->escape($user_id);
		if ($onlyTop) $query.=" AND AddrSyncNode.TopID!=0";
		if ($this->getPerms(1)) $where[]="AddrNodeMetabase.UserID=".$this->_db->escape($user_id);
		if ($this->getPerms(2) || $this->havePermsProfilAcl(2)) $where[]="AddrNodeMetabase.UserID=0";
		if ($where) {
			$query.=' AND ('.implode(' OR ',$where).')';
			$query.=" ORDER BY TopID DESC";
			//debug($query);
			$this->_db->query($query);
			$result=array();
			while ($this->_db->next_record()) {
				$result[]=$this->_db->f('FKNodeID');
			}
			if (count($result)) {
				//debug($this->getSubNodeIDs($result));
				if ($sub) {
					$result=array_merge($result,$this->getSubNodeIDs($result));
				}
				return array_unique($result);
			}
		}
		return 0;
	}
	function insertSyncID ($NodeID,$top=0) {
		$values=array(
			'FKNodeID'=>$NodeID,
			'FKUserID'=>$this->_uid,
			'TopID'=>$top,
		);
		$this->_db->insert('AddrSyncNode',$values,'',1);
	}
	function deleteSyncIDs($user_id=0) {
		if (!$user_id) $user_id=$this->_uid;
		$query="DELETE FROM AddrSyncNode WHERE FKUserID=".$this->_db->escape($user_id);
		$this->_db->query($query);
	}
	function getSubNodeIDs($NodeID,$rule=0) {
		$result=array();
		if (!is_array($NodeID)) $tmp=array($NodeID); else $tmp=$NodeID;
		while (!empty($tmp)) {
			$query="SELECT NodeID FROM AddrNodeMetabase WHERE ParentID IN (".implode(',',$this->_db->escape($tmp)).")";
			$this->_db->query($query);
			$tmp=array();
			while ($this->_db->next_record()) {
				if ($this->_db->f('NodeID')) {
					$result[]=$this->_db->f('NodeID');
					$tmp[]=$this->_db->f('NodeID');
				}
			}
		}
		return $result;
	}
	function getImportFields () {
		$result=array();
		$query="SELECT ID,Name FROM AddrImport ORDER BY Name";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('ID')]=$this->_db->f('Name');
		}
		return $result;
	}
	function readImportFields($ID) {
		$query="SELECT I_Fields FROM AddrImport WHERE ID=".intval($ID);
		$this->_db->query($query);
		if ($this->_db->next_record())
			return explode(',',$this->_db->f('I_Fields'));
		else
			return array();
	}
	function insertImportFields($Name,$Fields) {
		$query="SELECT max(ID) as num FROM AddrImport";
		$this->_db->query($query);
		$this->_db->next_record();
		$ID=$this->_db->f('num') + 1;
		$insert=array(
			'ID'=>$ID,
			'Name'=>$Name,
			'I_Fields'=>implode(',',$Fields),
		);
		$this->_db->insert('AddrImport',$insert);
		return $ID;
	}
	function updateImportFields($ID,$Name,$Fields) {
		$insert=array(
			'ID'=>$ID,
			'Name'=>$Name,
			'I_Fields'=>implode(',',$Fields),
		);
		$this->_db->insert('AddrImport',$insert,0,1);
	}
	function deleteImportFields($ID) {
		$query="DELETE FROM AddrImport ";
		$query.=" WHERE ID=".intval($ID);
		$this->_db->query($query);
	}

	function readAddrUserField($FieldID,$lang) {
		$query="SELECT * FROM AddrFields WHERE FieldID=".$this->_db->escape($FieldID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$result=array(
				'FieldID'=>$this->_db->f('FieldID'),
				'Search'=>$this->_db->f("Search"),
				'Typ'=>$this->_db->f("Typ"),
				'Value'=>$this->_db->f("Value"),
				'Action'=>$this->_db->f("Action"),
				'Multi'=>$this->_db->f("Multi"),
				'Vcard'=>$this->_db->f("Vcard"),
				'Sequence'=>$this->_db->f("Sequence"),
				'Users'=>$this->_db->f("Users"),
				'Groups'=>$this->_db->f("Groups"),
				'Aktiv'=>$this->_db->f("Aktiv"),
				'F_Required'=>$this->_db->f("F_Required"),
				'F_Default'=>$this->_db->f("F_Default"),
				'F_Unique'=>$this->_db->f("F_Unique"),
				'F_Mode'=>$this->_db->f("F_Mode"),
				'RefID'=>$this->_db->f("RefID"),
			);
			foreach ($lang as $val) {
				$result['Title_'.$val]=$this->_db->f("Title_".$val);
			}
			return $result;
		}
	}
	function listAddrUserFields() {
		$query="SELECT * FROM AddrFields WHERE FieldTyp='u' ORDER BY Sequence";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("FieldID")]=array(
				'Typ'=>$this->_db->f("Typ"),
				'Value'=>$this->_db->f("Value"),
				'Action'=>$this->_db->f("Action"),
				'Multi'=>$this->_db->f("Multi"),
				'Vcard'=>$this->_db->f("Vcard"),
				'Sequence'=>$this->_db->f("Sequence"),
				'Users'=>$this->_db->f("Users"),
				'Groups'=>$this->_db->f("Groups"),
				'Aktiv'=>$this->_db->f("Aktiv"),
				'Title'=>$this->_db->f("Title_".$this->_lang),
				'F_Required'=>$this->_db->f("F_Required"),
				'F_Default'=>$this->_db->f("F_Default"),
				'F_Unique'=>$this->_db->f("F_Unique"),
				'F_Mode'=>$this->_db->f("F_Mode"),
				'RefID'=>$this->_db->f("RefID"),
			);
		}
		return $result;
	}
	function insertAddrUserField($Field) {
		$query="SELECT max(Sequence) as num FROM AddrFields";
		$this->_db->query($query);
		$this->_db->next_record();
		$Field['Sequence']=$this->_db->f('num') + 1;
		$ID=$this->_db->nextid('AddrFieldUser');
		$Field['FieldID']='U_'.$ID;
		$Field['FieldTyp']='u';
		$Field['Card']='u';

		$query="ALTER TABLE AddrMetaUser ADD ".$Field['FieldID'];
		switch ($Field['Typ']) {
			case 'chk':
				$query.=" TINYINT NOT NULL ";
			break;
			case 'select':
				$query.=" INT NOT NULL ";
			break;
			case 'mselect':
				$query.=" BLOB NOT NULL ";
			break;
			case 'text':
				$query.=" VARCHAR( 255 ) NOT NULL ";
				$Field['Search']=1;
			break;
			case 'area':
				$query.=" TEXT NOT NULL ";
				$Field['Search']=1;
			break;
			case 'date':
				$query.=" DATE NOT NULL ";
			break;
			case 'fk_user':
				$query.=" BLOB NOT NULL ";
			break;
			case 'password':
				$query.="  VARCHAR( 255 ) NOT NULL ";
			break;
			case 'num':
				$query.=" DOUBLE NULL DEFAULT NULL ";
			break;
			case 'title':
				$query.="  VARCHAR( 255 ) NOT NULL ";
			break;
			default:
				return false;
		}

		$this->_db->query($query);
		$this->_db->insert('AddrFields',$Field);
		return $Field['FieldID'];
	}
	function updateAddrUserField($ID,$Field) {
		$this->_db->update('AddrFields',$Field,'FieldID='.$this->_db->escape($ID));
		return $ID;
	}
	function deleteAddrUserField($ID) {
		if ($ID) {
			$query="DELETE FROM AddrFields WHERE FieldID=".$this->_db->escape($ID);
			$this->_db->query($query);
			$this->deleteAddrSelect($ID);
			$query="ALTER TABLE AddrMetaUser DROP ".$ID;
			$this->_db->query($query);
		}
	}
	function switchAddrUserField ($oID,$dir='down') {
		$query="SELECT Sequence FROM AddrFields WHERE FieldTyp='u' AND FieldID=".$this->_db->escape($oID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$oSequence=$this->_db->f('Sequence');
			if ($dir=='up'){
				$sign='<';
				$order='DESC';
			}elseif ($dir=='down') {
				$sign='>';
				$order='ASC';
			} elseif ($dir=='first') {
				$sign='<';
				$order='ASC';
			}
			$query="SELECT FieldID,Sequence  FROM AddrFields WHERE FieldTyp='u' ";
			$query.="AND Sequence $sign ".intval($oSequence);
			$query.=" ORDER BY Sequence $order LIMIT 1";
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				$nID=$this->_db->f('FieldID');
				$nSequence=$this->_db->f('Sequence');
				$query="UPDATE AddrFields SET Sequence=".intval($nSequence)." WHERE FieldTyp='u' ";
				$query.="AND FieldID=".$this->_db->escape($oID);
				$this->_db->query($query);
				if ($dir=='first') {
					$query="UPDATE AddrFields SET Sequence=Sequence+1 WHERE FieldTyp='u' ";
					$query.="AND Sequence<$oSequence AND FieldID!=".$this->_db->escape($oID);
					$this->_db->query($query);
				} else {
					$query="UPDATE AddrFields SET Sequence=".intval($oSequence)." WHERE FieldTyp='u' ";
					$query.="AND FieldID=".$this->_db->escape($nID);
					$this->_db->query($query);
				}
			}
		}
	}
	function listPermsProfil($lang=NULL) {
		$result=array();
		if (!$lang) $lang=array($this->getLang());
		$query="SELECT * FROM AddrPermsProfil ORDER BY Title_".$this->getLang();
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('ProfilID')]=array(
				'Users'=>$this->_db->f('Users'),
				'Groups'=>$this->_db->f('Groups'),
			);
			foreach ($lang as $val) {
				$result[$this->_db->f('ProfilID')]['Title_'.$val]=$this->_db->f('Title_'.$val);
			}
		}
		return $result;
	}
	function listPermsProfilAcl($AclNeeded) {
		$result=array();
		$query="SELECT ProfilID,Title_".$this->getLang().",Users,Groups FROM AddrPermsProfil ORDER BY Title_".$this->getLang();
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			if ($this->isRuleUser()) {
				$acl=-1;
			} else {
				$acl=$this->_frm->calcAcl($this->_db->f('Users'),$this->_db->f('Groups'),$this->_uid);
			}
			if ($acl==-1 || ($acl&$AclNeeded)) {
				$result[$this->_db->f('ProfilID')]=$this->_db->f("Title_".$this->getLang());
			}
		}
		return $result;
	}
	function setPermsProfilAcl() {
		if ($this->isRuleUser()) {
			$this->_pperms[$this->_uid]=-1;
		} else {
			$this->_pperms[$this->_uid]=0;
			$query="SELECT ProfilID,Users,Groups FROM AddrPermsProfil";
			$query.=" WHERE Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%'";
			$this->_db->query($query);
			while ($this->_db->next_record()) {
				$acl=$this->_frm->calcAcl($this->_db->f('Users'),$this->_db->f('Groups'),$this->_uid);
				$this->_pperms[$this->_uid]=$this->_pperms[$this->_uid]|$acl;
			}
		}
	}
	function havePermsProfilAcl($AclNeeded) {
		if (!isset($this->_pperms[$this->_uid])) {
			$this->setPermsProfilAcl();
		}
		if ($this->_pperms[$this->_uid]==-1 || ($this->_pperms[$this->_uid]&$AclNeeded)) {
			return true;
		} else {
			return false;
		}
	}
	function insertPermsProfil($Data) {
		$Data['ProfilID']=$this->_db->nextid('AddrPermsProfil');
		if ($this->_db->insert('AddrPermsProfil',$Data)) return $Data['ProfilID'];
	}
	function updatePermsProfil($ID,$Data) {
		return $this->_db->update('AddrPermsProfil',$Data ,'ProfilID='.$this->_db->escape($ID));
	}
	function deletePermsProfi($ID) {
		$query="DELETE FROM AddrPermsProfil WHERE ProfilID=".$this->_db->escape($ID);
		$this->_db->query($query);
	}
	function getAddrProjects($AObj) {
		$result=array();
		$query="SELECT FKProjID FROM AddrParentProject WHERE FKAddressID=".$this->_db->escape($AObj->getID());
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('FKProjID');
		}
		return $result;
	}
	function hasProjectEntrys($projID) {
		$query = "SELECT FKAddressID FROM AddrParentProject ";
		$query.=" WHERE FKProjID=".$this->_db->escape($projID);
		$query.=" ".$this->_db->formatLimit(0,1);
		$this->_db->query($query);
		if($this->_db->next_record()) {
			return true;
		} else {
			return false;
		}
	}

	function setAddrProjects(&$AObj,$addrProj,$clear=1) {
		if ($clear) {
			$this->deleteAddrProjects($AObj);
		}
		if (is_array($addrProj) && !empty($addrProj)) {
			foreach ($addrProj as $val) {
				$this->_db->insert('AddrParentProject',array('FKAddressID'=>$AObj->getID(),'FKProjID'=>$val),'',1);
			}
		}
	}
	function deleteAddrProjects(&$AObj,$pojID=0) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKAddressID','Typ'=>'=','Values'=>$AObj->getID());
		if ($pojID) {
			$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$pojID);
		}
		$this->_db->delete('AddrParentProject',$searchQuery);
	}
	function deleteProject($ID) {
		if ($ID) {
			$query = "SELECT FKAddressID FROM AddrParentProject WHERE FKProjID=".$this->_db->escape($ID);
			$this->_db->query($query);
			while ($this->_db->next_record()) {
				$delete[]=$this->_db->f('FKAddressID');
			}
			//debug($delete);
			foreach ($delete as $val) {
				if ($val) {
					$query="DELETE FROM AddrParentProject WHERE FKAddressID=".$this->_db->escape($val);
					$query.=" AND FKProjID=".$this->_db->escape($ID);
					$this->_db->query($query);
				}
			}
		}
	}
	function addProjectsAddr($projID,$addrIDs) {
		foreach ($addrIDs as $val) {
			$this->_db->insert('AddrParentProject',array('FKAddressID'=>$val,'FKProjID'=>$projID),'',1);
		}
	}
	function deleteProjectsAddr($projID,$addrIDs) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$projID);
		$searchQuery[]=array('Field'=>'FKAddressID','Typ'=>'=','Values'=>$addrIDs);
		$this->_db->delete('AddrParentProject',$searchQuery);
	}
	function addRootID($ID,$typ=0) {
		$this->_rootIDs[$ID]=$typ;

	}
	function getRootIDs($typ=0) {
		if ($typ) {
			return array_search($typ, $this->_rootIDs);
		} else {
			return $this->_rootIDs;
		}
	}

	function treeToJson($tree,$start,$prep='',$func='upCpF') {
		//debug($tree);
		$result='';
		foreach ($tree[$start] as $key=>$val) {
			$result.="[null,'".Framework::escapeJs($val->getName())."', ";
			$result.="'javascript:".$func."(\'".$prep.$val->getID()."\')'";
			if (is_array($tree[$val->getID()])) {
				$result.=', '."\n";
				$result.=$this->treeToJson($tree,$val->getID(),$prep);
			}
			$result.='],'."\n";
		}
		return $result;
    }
    function entry2Value(&$fid,&$values,&$nowrap) {
		switch ($this->getFieldData($fid,'Typ',1)) {
			case 'text':
			case 'area':
				$nowrap=0;
			break;
			case 'select':
			case 'mselect':
				if (!isset($this->_cached_select_array[$fid])) {
					$this->_cached_select_array[$fid]=$this->listAddrSelect($fid);
				}
				foreach ($values as $vkey=>$vval) {
					$values[$vkey]=$this->_cached_select_array[$fid][$vval];
				}
			break;
			case 'fk_user':
			case 'user':
				foreach ($values as $vkey=>$vval) {
					$values[$vkey]=$this->_frm->getCachedUserName($vval);
				}
			break;
			case 'password':
				foreach ($values as $vkey=>$vval) {
					$values[$vkey]=$vval?'**********':'';
				}
			break;
			case 'date':
				foreach ($values as $vkey=>$vval) {
					if ($vval=='0000-00-00') {
						$values[$vkey]='';
					} else {
						$values[$vkey]=Framework::dateSql('d.m.Y',$vval);
					}
				}
			break;
			case 'chk':
			case 'check':
				$select_array=array(1=>$this->_T->Lang('[[Ja]]'),-1=>$this->_T->Lang('[[Nein]]'),0=>'');
				foreach ($values as $vkey=>$vval) {
					$values[$vkey]=$select_array[$vval];
				}
			break;
			case 'perm':
				if (!isset($this->_cached['ProfilAcl'])) {
					$this->_cached['ProfilAcl']=$this->listPermsProfilAcl(0);
				}
				foreach ($values as $vkey=>$vval) {
					$values[$vkey]=$vval?$this->_cached['ProfilAcl'][$vval]:'';
				}
			break;
			case 'stamm':
				foreach ($values as $vkey=>$vval) {
					if ($vval && !isset($this->_cached['Addr'][$vval])) {
						$this->_cached['Addr'][$vval]=$this->getAddrObj($vval);
					}
					$values[$vkey]=($vval && is_object($this->_cached['Addr'][$vval]))?$this->_cached['Addr'][$vval]->getName():'';
				}
			break;
			case 'unixdate':
				foreach ($values as $vkey=>$vval) {
					$values[$vkey]=date('d.m.Y H:i',$vval);
				}
			break;
			default:
				//debug($this->getFieldData($fid,'Typ'));
			break;
		}
    }
	function getNextFreeFieldID($Field,$minID=1) {
		$query="SELECT $Field FROM AddrMetaUser WHERE $Field=".intval($minID);
		$this->_db->query($query);
		if (!$this->_db->num_rows()) {
			$found=$minID;
		} else {
			$query="SELECT min(a.$Field) as nextID FROM AddrMetaUser as a LEFT JOIN AddrMetaUser as b ON (b.$Field=a.$Field+1) WHERE a.$Field!=0 AND a.$Field>".intval($minID)." AND b.$Field IS NULL";
			$this->_db->query($query);
			$this->_db->next_record();
			$found=intval($this->_db->f('nextID'))+1;
		}
		return $found;
	}
	function isUsedFieldID($Field,$val,$ignoreID) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'AddrMetaUser.FKAddressID','Typ'=>'F=F','Values'=>'AddrMeta.AddressID');
		$searchQuery[]=array('Field'=>$Field,'Typ'=>'=','Values'=>$val);
		if ($ignoreID) $searchQuery[]=array('Field'=>'FKAddressID','Typ'=>'!=','Values'=>$ignoreID);

		$query="SELECT FKAddressID FROM AddrMetaUser,AddrMeta WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('FKAddressID');
		} else {
			return 0;
		}
	}
	function writeExport($newObj,$oldObj=null,$mNodes=false) {
		if (defined('GE_addrCustomExportFile') && GE_addrCustomExportFile && !$newObj->getMeta('UserID')) {
			if ($newObj->getMeta('Trash') && defined('GE_addrCustomExportNoDelete') && GE_addrCustomExportNoDelete) {
				return 0;
			}
			$charset=defined('GE_addrCustomExportCharset')?GE_addrCustomExportCharset:'WINDOWS-1252';
			$file=strftime(GE_addrCustomExportFile);
			$this->loadExportFields();
			$Typ='';
			if ($newObj->getMeta('Trash')) {
				if (is_object($oldObj) && !$oldObj->getMeta('Trash')) {
					$Typ='D';
				}
			} else {
				if (is_object($oldObj)) {
					if (defined('GE_addrCustomExportFileModified') && GE_addrCustomExportFileModified) {
						$file=strftime(GE_addrCustomExportFileModified);
					}
					foreach ($this->_cExportFields as $val) {
						switch ($val['fieldTyp']) {
							case 'TYP':
							case 'ID':
							case 'DATETIME':
							case 'USERNAME':

							break;
							case 'CATEGORY':
							case 'CATEGORY_ID':
								if ($mNodes) {
									$Typ='A';
									break;
								}
							break;
							default:
								if (is_array($val['intFieldID'])) {
									if ($newObj->getMeta($val['intFieldID'][0])!=$oldObj->getMeta($val['intFieldID'][0])) {
										$Typ='A';
										break;
									}
								} else {
									if ($newObj->getMeta($val['intFieldID'])!=$oldObj->getMeta($val['intFieldID'])) {
										$Typ='A';
										break;
									}
								}
							break;
						}
					}
				} else {
					$Typ='A';
				}
			}
			if ($Typ) {
				$RootID=$this->getRootIDs('s');
				if (!$RootID) {
					$tmp=$this->getSystemObj('s','',0);
					$RootID=$tmp->getID();
				}
				$row=array();
				if (!$newObj->getParentMeta('NodeIDs')) {
					$newObj->setParentMeta('NodeIDs',$this->getAddrNodesIDs($newObj->getID()));
				}
				foreach ($this->_cExportFields as $val) {
					if ($val['extra']['Export']['Condition']) {
						$condition=false;
						foreach ($val['extra']['Export']['Condition'] as $cond) {
							if ($newObj->getMeta($cond['FieldID'])==$cond['FieldVal']) {
								$condition=true;
								break;
							}
						}
						if (!$condition) {
							continue;
						}
					}
					if (is_array($val['extFieldID'])) {
						$extFieldID=$val['extFieldID'][0];
					} else {
						$extFieldID=$val['extFieldID'];
					}
					switch ($val['fieldTyp']) {
						case 'TYP':
							$row[$extFieldID]=$Typ;
						break;
						case 'CATEGORY':
							$tmp=array();
							foreach($newObj->getParentMeta('NodeIDs') as $nid) {
								$tmpCat=array_reverse($this->getObjTree($nid,$RootID,$val['fieldLang']));
								foreach($tmpCat as $tk=>$tv) {
									$tmpCat[$tk]=Framework::escapeVal($tv,array('.',','),'\\');
								}
								$tmp[]=implode('.',$tmpCat);
							}
							$row[$extFieldID]=Framework::convertCharset(implode(',',$tmp),GE_CHARSET,$charset);
						break;
						case 'CATEGORY_ID':
							$row[$extFieldID]=implode(',',$newObj->getParentMeta('NodeIDs'));
						break;
						case 'DATETIME':
							if($val['extFormat']) {
								$row[$extFieldID]=date($val['extFormat'],$newObj->getMeta($val['intFieldID']));
							} else {
								$row[$extFieldID]=$newObj->getMeta($val['intFieldID']);
							}
						break;
						case 'USERNAME':
							switch($val['extFormat']) {
								case 'uname':
									$tmp=$this->_frm->getCachedUser($newObj->getMeta($val['intFieldID']));
									$row[$extFieldID]=Framework::convertCharset($tmp['username'],GE_CHARSET,$charset);
								break;
								default:
									$row[$extFieldID]=$newObj->getMeta($val['intFieldID']);
								break;
							}
						break;
						case 'PARENT_ADDR':
							$tmpFields=explode('/',$val['intFieldID']);
							if ($newObj->getMeta($tmpFields[0]) && ($tmpAddr=$this->getAddrObj($newObj->getMeta($tmpFields[0])))) {
								$row[$extFieldID]=$tmpAddr->getMeta($tmpFields[1]);
							} else {
								$row[$extFieldID]='';
							}
						break;
						case 'ID':
							$row[$extFieldID]=$newObj->getMeta($val['intFieldID'])?$newObj->getMeta($val['intFieldID']):'';
							if (!$row[$extFieldID] && $val['extra']['Default']) {
								$row[$extFieldID]=$val['extra']['Default'];
							}
						break;
						default:
							$subField=array();
							if (is_array($val['intFieldID'])) {
								$tmp=Addr::AddrExplode($newObj->getMeta($val['intFieldID'][0]));
								$row[$extFieldID]=Framework::convertCharset($tmp[$val['intFieldID'][1]],GE_CHARSET,$charset);
							} else {
								$row[$extFieldID]=Framework::convertCharset($newObj->getMeta($val['intFieldID']),GE_CHARSET,$charset);
							}
							if ($val['extra']['Convert']) {
								if (isset($val['extra']['Convert'][$row[$extFieldID]])) {
									$row[$extFieldID]=$val['extra']['Convert'][$row[$extFieldID]];
								}
							}
							if (!$row[$extFieldID] && $val['extra']['Default']) {
								$row[$extFieldID]=$val['extra']['Default'];
							}
						break;
					}
				}
				if (defined('GE_addrCustomExportTyp')) {
					$expTyp=GE_addrCustomExportTyp;
				} else {
					$expTyp='csv';
				}
				//debug('dddd');
				switch($expTyp) {
					case 'xml':
						libxml_use_internal_errors(true);
						$dom = new DomDocument('1.0',$charset);
						if (file_exists($file)) {
							try {
								$dom->load($file,LIBXML_NOBLANKS);
							} catch (Exception $e) {
								debug($e);
								return false;
							}
						} else  {
							if (is_object($oldObj) && defined('GE_addrCustomExportXmlModified')) {
								$dom->loadXML(GE_addrCustomExportXmlModified,LIBXML_NOBLANKS);
							} else {
								$dom->loadXML(GE_addrCustomExportXml,LIBXML_NOBLANKS);
							}
							//$dom->appendChild($dom->createElement(GE_addrCustomExportXmlRoot));
						}
						$domNodes=array();
						foreach ($this->_cExportFields as $val) {
							if (is_array($val['extFieldID'])) {
								$extFieldID=$val['extFieldID'][0];
							} else {
								$extFieldID=$val['extFieldID'];
							}

							if ($row[$extFieldID] || GE_addrCustomExportXmlEmptyValues) {
								$nodes=explode('/',$extFieldID);
								$parentNode=$dom->documentElement;
								foreach ($nodes as $node) {
									$nodeVal=explode('#',$node);
									//debug($nodeVal);

									if (!isset($domNodes[$nodeVal[0]])) {
										$domNodes[$nodeVal[0]]=$dom->createElement($nodeVal[0]);
										$parentNode->appendChild($domNodes[$nodeVal[0]]);
									}
									$parentNode=$domNodes[$nodeVal[0]];
								}
								if ($nodeVal[1]) {
									$parentNode->setAttribute($nodeVal[1],$row[$extFieldID]);
								} else {
									$parentNode->appendChild($dom->createTextNode($row[$extFieldID]));
								}
							}
						}
						//debug(htmlspecialchars($dom->saveXML()));
						$dom->save($file);

					break;
					default:
						$string=$this->_frm->exportCsv(array($row),';',file_exists($file)?false:true);
						$fp=fopen($file,'a+');
						fwrite($fp,$string);
						fclose($fp);
					break;
				}
			}
		}
	}
	function xml2csv($address,$charset='utf-8') {
		$row=array();
		if ($address->hasAttributes()) {
			foreach ($address->attributes as $attribute) {
				if (!isset($row[$address->nodeName.'#'.$attribute->name])) {
					$row[$address->nodeName.'#'.$attribute->name]=Framework::convertCharset($attribute->value,$charset,GE_CHARSET);
				}
			}
		}
		if ($address->hasChildNodes()) {
			foreach ($address->childNodes as $childNode) {
				if ($childNode->hasAttributes()) {
					foreach ($childNode->attributes as $attribute) {
						if (!isset($row[$address->nodeName.'/'.$childNode->nodeName.'#'.$attribute->name])) {
							$row[$address->nodeName.'/'.$childNode->nodeName.'#'.$attribute->name]=Framework::convertCharset($attribute->value,$charset,GE_CHARSET);
						}
					}
				}
				if (trim($childNode->textContent) && !isset($row[$address->nodeName.'/'.$childNode->nodeName])) {
					$row[$address->nodeName.'/'.$childNode->nodeName]=Framework::convertCharset(trim($childNode->textContent),$charset,GE_CHARSET);
				}
			}
		}
		return $row;
	}
	function importExport($impFile,$TEST=false) {
		$this->loadExportFields();
		$charset=defined('GE_addrCustomExportCharset')?GE_addrCustomExportCharset:'WINDOWS-1252';
		if (defined('GE_addrCustomExportTyp')) {
			$expTyp=GE_addrCustomExportTyp;
		} else {
			$expTyp='csv';
		}
		$errors=array();
		switch($expTyp) {
			case 'xml':
				$xmlkeys=array();
				$data=array();
				$dom = new DomDocument;
				$dom->load($impFile,LIBXML_NOBLANKS);
				foreach ($dom->documentElement->childNodes as $address) {
					//$xmlkeys=array_unique(array_merge($xmlkeys,array_keys($row)));
					$data[]=$this->xml2csv($address,$charset);
				}
				//echo '<pre>';print_r($xmlkeys);
				$num=1;
			break;
			default:
				$data=$this->_frm->importCsv($impFile,';',true);
				$num=2;
			break;
		}
		$mCsv=array();
		$aCsv=array();
		if ($data && !empty($data)) {
			$TrashID=$this->getRootIDs('t');
			if (!$TrashID) {
				$tmp=$this->getSystemObj('t','',0);
				$TrashID=$tmp->getID();
			}
			foreach($data as $row) {
				if ($TEST) {
					print_r($row);
				}
				$AObj=false;
				$Typ='A';
				foreach ($this->_cExportFields as $val) {
					if (is_array($val['extFieldID'])) {
						$extFieldID=$val['extFieldID'][1];
					} else {
						$extFieldID=$val['extFieldID'];
					}
					switch ($val['fieldTyp']) {
						case 'TYP':
							$Typ=trim($row[$extFieldID]);
						break;
						case 'ID':
							if (!is_object($AObj) && trim($row[$extFieldID])) {
								$searchAddr=array();
								$searchAddr[]=array('Field'=>$val['intFieldID'],'Typ'=>'=','Values'=>trim($row[$extFieldID]));
								$AObj=$this->searchSingleAddr($searchAddr);
							}
						break;
						default:
							if ($val['extra']['Convert']) {
								$convert=array_flip($val['extra']['Convert']);
								if (isset($convert[$row[$extFieldID]])) {
									$row[$extFieldID]=$convert[$row[$extFieldID]];
								}
							}
						break;
					}
				}
				if ($TEST && $AObj) {
					echo "ADDRESS FOUND:".$AObj->getID()."\n";
				}
				switch($Typ) {
					case 'D':
						if (is_object($AObj)) {
							$error=$this->csv2Addr($AObj,$row);
							$AObj->setMeta('Trash',1);
							$AObj->setMeta('TrashIDs',implode(',',array_keys($this->getAddrNodes($AObj->getID()))));
							$AObj->setParentMeta('NodeIDs',array($TrashID));
							if ($TEST) {
								echo "DELETE\n";
								print_r($AObj);
							} else {
								$this->updateAddrMeta($AObj,false,defined('GE_addrCustomImportUser')?GE_addrCustomImportUser:$AObj->getMeta('UserModify'));
							}
						}
					break;
					case 'A':
						if (!is_object($AObj)) {
							$AObj=new AObj_addr(0);
						}
						$error=$this->csv2Addr($AObj,$row,$TEST);
						if (empty($error)) {
							if ($AObj->getID()) {
								if ($AObj->getMeta('Trash')) {
									$AObj->setMeta('Trash',0);
									$AObj->setMeta('TrashIDs','');
								}
								if ($TEST) {
									echo "MODIFY\n";
									print_r($AObj);
									$mFields=array();
									$oldObj=$this->getAddrObj($AObj->getID());
									$values=$AObj->_meta;
									unset($values['AddressID']);
									foreach ($values as $key=>$val) {
										if (isset($this->_addr_fields[$key]) && strcasecmp(trim($oldObj->getMeta($key)),trim($val))) {
											$mFields[]=array(
												$key,
												$oldObj->getMeta($key),
												$val
											);
										}
									}
									if (!empty($mFields)) {
										foreach($mFields as $i=>$val) {
											$row=array();
											if (!$i) {
												$row=array(
													$AObj->getID(),
													$oldObj->getName(),
													$AObj->getMeta('ExternID'),
												);
											} else {
												$row=array(
													'',
													'',
													'',
												);
											}
											$mCsv[]=array_merge($row,$val);
										}
									}
								} else {
									$this->updateAddrMeta($AObj,false,defined('GE_addrCustomImportUser')?GE_addrCustomImportUser:$AObj->getMeta('UserModify'));
								}
							} else {
								if ($TEST) {
									echo "INSERT\n";
									print_r($AObj);
									$aCsv[]=array(
										0,
										$AObj->getMeta('ExternID'),
										$AObj->getName(),
									);
								} else {
									$this->insertAddrMeta($AObj,false,defined('GE_addrCustomImportUser')?GE_addrCustomImportUser:$AObj->getMeta('UserModify'));
								}
							}
						} else {
							if ($error['noCat']) {
								$errors[]='line:'.$num.' - no category';
							}
							if ($error['parentNotExists']) {
								$errors[]='line:'.$num.' - parent ('.$error['parentNotExists'].') not exists';
							}
						}
					break;
					default:
						$errors[]='line:'.$num.' - no record-type';
					break;
				}
				$num++;
			}
		} else {
			$errors[]='line:0 - no valid import-file';
		}
		if ($TEST && !empty($mCsv)) {
			echo "\n\nModifications CSV\n";
			echo Framework::exportCsv($mCsv,";");
		}
		if ($TEST && !empty($aCsv)) {
			echo "\n\nInsert CSV\n";
			echo Framework::exportCsv($aCsv,";");
		}
		return $errors;
	}
	function csv2Addr(&$AObj,$row,$TEST=0) {
		$error=array();
		$RootID=$this->getRootIDs('s');
		if (!$RootID) {
			$tmp=$this->getSystemObj('s','',0);
			$RootID=$tmp->getID();
			$this->addRootID($RootID,'s');
		}
		$parentObj=false;
		foreach ($this->_cExportFields as $val) {
			if (is_array($val['extFieldID'])) {
				$extFieldID=$val['extFieldID'][1];
			} else {
				$extFieldID=$val['extFieldID'];
			}
			if ($val['extra']['Convert']) {
				$convert=array_flip($val['extra']['Convert']);
				if (isset($convert[$row[$extFieldID]])) {
					$row[$extFieldID]=$convert[$row[$extFieldID]];
				}
			}
			if ($val['extra']['Import']['Condition']) {
				$condition=false;
				foreach ($val['extra']['Import']['Condition'] as $cond) {
					if ($row[$cond['FieldID']]==$cond['FieldVal']) {
						$condition=true;
						break;
					}
				}
				if (!$condition) {
					continue;
				}
			}
	
			switch($val['fieldTyp']) {
				case 'ID':
					$AObj->setMeta($val['intFieldID'],trim($row[$extFieldID]));
				break;
				case 'PARENTID':
					if (trim($row[$extFieldID])) {
						$searchAddr=array();
						$searchAddr[]=array('Field'=>'ExternID','Typ'=>'=','Values'=>trim($row[$extFieldID]));
						if ($parentObj=$this->searchSingleAddr($searchAddr)) {
							$AObj->setMeta($val['intFieldID'],$parentObj->getID());
						} else {
							$error['parentNotExists']=trim($row[$extFieldID]);
						}
					}
				break;
				case 'PARENT_ADDR':
					if (intval($row[$extFieldID]) && !is_object($parentObj)) {
						$tmpFields=explode('/',$val['intFieldID']);
						$searchAddr=array();
						$searchAddr[]=array('Field'=>$tmpFields[1],'Typ'=>'=','Values'=>intval($row[$extFieldID]));
						if ($parentObj=$this->searchSingleAddr($searchAddr)) {
							$AObj->setMeta($tmpFields[0],$parentObj->getID());
							unset($error['parentNotExists']);
						} else {
							$error['parentNotExists']=intval($row[$extFieldID]);
						}
					}
				break;
				case 'CATEGORY':
					$error['noCat']=true;
					$cat=Framework::splitVal($row[$extFieldID],',');
					$catIDs=array();
					$ParentID=$RootID;
					if ($TEST) {
						unset($error['noCat']);
					} else{
						$create=true;
						foreach ($cat as $name) {
							$tmpID=$this->catName2ID(trim($name),$RootID,$ParentID,$val['fieldLang'],$create);
							if ($tmpID && $tmpID!=$RootID) {
								$catIDs[]=$tmpID;
							}
						}
						if (empty($catIDs) && defined('GE_addrCustomImportDefaultCategory') && GE_addrCustomImportDefaultCategory) {
							$catIDs[]=GE_addrCustomImportDefaultCategory;
						}
						if (!empty($catIDs)) {
							unset($error['noCat']);
							$AObj->setParentMeta('NodeIDs',array_unique($catIDs));
						}
					}
				break;
				case 'CATEGORY_ID':
					$error['noCat']=true;
					$cat=Framework::splitVal($row[$extFieldID],',');
					$catIDs=array();
					foreach ($cat as $id) {
						if ($this->getObj($id)) {
							$catIDs[]=$id;
						} elseif($TEST) {
							echo 'Category not exists:'.$id."\n";
						}
					}
					if (empty($catIDs) && defined('GE_addrCustomImportDefaultCategory') && GE_addrCustomImportDefaultCategory) {
						$catIDs[]=GE_addrCustomImportDefaultCategory;
					}
					if (!empty($catIDs)) {
						unset($error['noCat']);
						$AObj->setParentMeta('NodeIDs',array_unique($catIDs));
					}
				break;
				case 'DATETIME':
					if ($this->getFieldData($val['intFieldID'],0,1)) {
						if ($val['extFormat']!=$val['intFormat']) {
							if ($val['extFormat']) {
								$tmpVal=time();
							} else {
								$tmpVal=$row[$extFieldID];
							}
							if ($val['intFormat'] && $tmpVal) {
								$tmpVal=date($val['extFormat'],$tmpVal);
							}
						} else {
							$tmpVal=trim($row[$extFieldID]);
						}
						$AObj->setMeta($val['intFieldID'],$tmpVal);
					}
				break;
				case 'USERNAME':
					if ($this->getFieldData($val['intFieldID'],0,1)) {
						if ($val['extFormat']!=$val['intFormat']) {
							switch($val['extFormat']) {
								case 'uname':
									if (trim($row[$extFieldID])) {
										if (!isset($this->_cacheUname2Id[$row[$extFieldID]])) {
											$tmp=$this->_frm->searchUser($rows,$row[$extFieldID],0,1);
											foreach ($tmp as $tk=>$tv) {
												$this->_cacheUname2Id[$tv['username']]=$tk;
											}
										}
										$tmpVal=intval($this->_cacheUname2Id[$row[$extFieldID]]);
									} else {
										$tmpVal=0;
									}
								break;
								default:
									$tmpVal=intval($row[$extFieldID]);
								break;
							}
							switch($val['intFormat']) {
								case 'uname':
									if ($tmpVal) {
										$tmp=$this->_frm->getCachedUser($tmpVal);
										$tmpVal=$tmp['username'];
									}
								break;
								default:

								break;
							}
						} else {
							$tmpVal=$row[$extFieldID];
						}
						$AObj->setMeta($val['intFieldID'],$tmpVal);
					}
				break;
				default:
					if (is_array($val['intFieldID'])) {
						if ($this->getFieldData($val['intFieldID'][0],0,1)) {
							$tmp=Addr::AddrExplode($AObj->getMeta($val['intFieldID'][0]));
							if (trim($row[$extFieldID])) {
								for($i=0;$i<$val['intFieldID'][1];$i++) {
									if (!$tmp[$i]) $tmp[$i]='-';
								}
								$tmp[$val['intFieldID'][1]]=trim($row[$extFieldID]);
							} elseif ($tmp[$val['intFieldID'][1]]) {
								$tmp[$val['intFieldID'][1]]=trim($row[$extFieldID]);
							}
							$AObj->setMeta($val['intFieldID'][0],$this->AddrImplode($tmp));
						}
					} else {
						if ($this->getFieldData($val['intFieldID'],0,1)) {
							$tmp=Addr::AddrExplode(trim($row[$extFieldID]));
							$tmp=array_map('trim',$tmp);
							$AObj->setMeta($val['intFieldID'],$this->AddrImplode($tmp));
						}
					}

				break;
			}
		}
		$AObj->setMeta('Name',$AObj->getName());
		if (!$AObj->getID() && ($nodes=$AObj->getParentMeta('NodeIDs')) && empty($nodes)) {
			$error['noCat']=true;
		}
		return $error;
	}
	function catName2ID($Name,$RootID,$ParentID,$lang='',$create=true,$sep='.',$escape='\\') {
		if (!$lang) $lang=$this->_lang;
		$pieces=Framework::splitVal($Name,$sep);
		foreach ($pieces as $val) {
			$val=Framework::unescapeVal($val,$escape);
			if ($val) {
				$search=array();
				if ($RootID) {
					$search[]=array('Field'=>'RootID','Typ'=>'=','Values'=>$RootID);
				} elseif (!$ParentID) {
					$subQuery=array();
					$subQuery[]=array(
						array('Field'=>'UserID','Typ'=>'=','Values'=>$this->_frm->getUser()),
						array('Field'=>'System','Typ'=>'=','Values'=>'u'),
					);
					$subQuery[]=array(
						array('Field'=>'UserID','Typ'=>'=','Values'=>0),
						array('Field'=>'System','Typ'=>'=','Values'=>'s'),
					);
					$search[]=array('Typ'=>'OR','Values'=>$subQuery);
				}

				$search[]=array('Field'=>'ParentID','Typ'=>'=','Values'=>$ParentID);
				$search[]=array('Field'=>'Title_'.$lang,'Typ'=>'regexp','Values'=>'^'.str_replace(' ','[,;. ]',preg_quote($val,'')).'$');

				if ($catObj=$this->searchObj($search)) {
					$ParentID=$catObj->getID();
				} elseif ($create) {
					$catObj=new AObj_fol();
					$catObj->setMeta('ParentID',$ParentID);
					$catObj->setMeta('RootID',$RootID);
					$catObj->setMeta('TimeCreate',time());
					$catObj->setMeta('TimeModify',time());
					$catObj->setMeta('UserCreate',0);
					$catObj->setMeta('UserModify',0);
					foreach($this->_frm->getMaLang() as $lval) {
						$catObj->setMeta('Title_'.$lval,trim($val));
					}
					$this->insertMeta($catObj);
					$ParentID=$catObj->getID();
					//print_r($val);
				} else {
					return 0;
				}
			}
		}
		return $ParentID;
	}
	function loadExportFields() {
		if (empty($this->_cExportFields)) {
			$query="SELECT customAddrExport.* FROM customAddrExport ORDER BY Sequence";
			$this->_db->query($query);
			while ($this->_db->next_record()) {
				$subField=array();
				if (preg_match('/^(.+)\[([0-9]+)\]$/',$this->_db->f('intFieldID'),$subField)) {
					$intField=array($subField[1],intval($subField[2]));
				} else {
					$intField=$this->_db->f('intFieldID');
				}
				if (strpos($this->_db->f('extFieldID'),',')===false) {
					$extField=$this->_db->f('extFieldID');
				} else {
					$extField=explode(',',$this->_db->f('extFieldID'));
				}
				$this->_cExportFields[]=array(
					'intFieldID'=>$intField,
					'extFieldID'=>$extField,
					'fieldTyp'=>$this->_db->f('fieldTyp'),
					'fieldLang'=>$this->_db->f('fieldLang'),
					'intFormat'=>$this->_db->f('intFormat'),
					'extFormat'=>$this->_db->f('extFormat'),
					'extra'=>$this->_db->f('extra')?json_decode($this->_db->f('extra'),true):array(),
				);
				//print_r($this->_db->f('extra'));

			}
			//print_r($this->_cExportFields);
			//'Default'
		//	debug($this->_cExportFields);

		//	debug(json_encode(array('Default'=>'X')));
		}
	}
	function xml2addr($node,$AObj=null,&$changes=null) {
		if (!$AObj) {
			$AObj=new AObj_addr();
		}
		$addrSelArray=array();
		foreach ($this->getFields() as $fkey=>$fval) {
			//$fval['RefID']=$fkey;
			if ($fval['RefID'] && isset($node->$fval['RefID'])) {
				$setVal=false;
				switch($fval['Typ']) {
					case 'perm':
					case 'stamm':
					break;
					//getAddrSelectID($Type,$lang,$info)
					case 'select':
					case 'mselect':
						$found=array();
						$values=array();
						if (count($node->$fval['RefID']->children())) {
							foreach ($node->$fval['RefID']->children() as $s_node) {
								if (trim((string)$s_node)) {
									$values[]=trim((string)$s_node);
								}
							}

						} elseif (trim((string)$node->$fval['RefID'])) {
							$values[]=trim((string)$node->$fval['RefID']);
						}
						if (!empty($values)) {
							foreach ($values as $sval) {
								if (!isset($addrSelArray[$fkey][$sval])) {
									$addrSelArray[$fkey][$sval]=$this->getAddrSelectID($fkey,$this->_frm->getAvLang(),$sval);
								}
								if ($addrSelArray[$fkey][$sval]!==false) {
									$found[]=$addrSelArray[$fkey][$sval];
								}
							}
							if (!empty($found)) {
								if ($fval['Typ']=='select') {
									$setVal=$found[0];
								} else {
									$setVal=Addr::AddrImplode(array_unique($found));
								}
							}
						}
					break;
					case 'fk_user':
						$rows=0;
						$allUsers=$this->_frm->searchUser($rows,'',0,0,0,0);
						$found=array();
						$values=array();
						if (count($node->$fval['RefID']->children())) {
							foreach ($node->$fval['RefID']->children() as $s_node) {
								if (trim((string)$s_node)) {
									$values[]=trim((string)$s_node);
								}
							}

						} elseif (trim((string)$node->$fval['RefID'])) {
							$values[]=trim((string)$node->$fval['RefID']);
						}
						if (!empty($values)) {
							foreach ($values as $sval) {
								foreach($allUsers as $v) {
									if ($v['username']==$sval || $v['firstname'].' '.$v['lastname']==$sval || $v['lastname'].' '.$v['firstname']==$sval || $v['email']==$sval) {
										$found[]=$v['uidGroup-e'];
										break;
									}
								}
							}
							if (!empty($found)) {
								$setVal=Addr::AddrImplode(array_unique($found));
							}
						}
					break;
					case 'check':
					case 'chk':
						if ((int)$node->$fval['RefID'] > 0) {
							$setVal=1;
						} else {
							$setVal=-1;
						}
					break;
					case 'password':
						if (trim((string)$node->$fval['RefID'])) {
							$setVal=md5(trim((string)$node->$fval['RefID']));
						} else {
							$setVal='';
						}
					break;
					default:
						$values=array();
						if (count($node->$fval['RefID']->children())) {
							foreach ($node->$fval['RefID']->children() as $s_node) {
								if (trim((string)$s_node)) {
									$values[]=trim((string)$s_node);
								}
							}

						} elseif (trim((string)$node->$fval['RefID'])) {
							$values[]=trim((string)$node->$fval['RefID']);
						}
						$setVal=Addr::AddrImplode(array_unique($values));
					break;
				}
				if ($setVal!==false) {
					if (isset($changes) && $AObj->getMeta($fkey)!=$setVal) {
						$changes[$fkey]=array($AObj->getMeta($fkey),$setVal);
					}
					$AObj->setMeta($fkey,$setVal);
				}
				
			}
		}
		if (!$AObj->getMeta('Nachname') && !$AObj->getMeta('Vorname') && !$AObj->getMeta('Firma') && !$AObj->getMeta('EMail')) {
			return false;
		}
		return $AObj;
	}
	function addr2xml($AObj,$xml) {
		$addrSelArray=array();
		$nowrap=0;
		foreach ($this->getFields() as $fkey=>$fval) {
			$xml->ID=$AObj->getID();
			//$fval['RefID']=$fkey;
			if ($fval['RefID'] && $AObj->getMeta($fkey)) {
				$values=$this->AddrExplode($AObj->getMeta($fkey));
				$this->entry2Value($fkey,$values,$nowrap);
				switch($fval['Typ']) {
					case 'perm':
					case 'stamm':
					break;
					//getAddrSelectID($Type,$lang,$info)
					case 'mselect':
						$n=$xml->addChild($fval['RefID']);
						foreach($values as $v) {
							$n->addChild('array',$v);
						}
					break;
					case 'fk_user':
						if ($fval['F_Mode']==0) {
							$xml->$fval['RefID']=$this->AddrImplode($values);
						} else {
							$n=$xml->addChild($fval['RefID']);
							foreach($values as $v) {
								$n->addChild('array',$v);
							}
						}
					break;
					case 'check':
					case 'chk':
						if ($AObj->getMeta($fkey)) {
							$xml->$fval['RefID']=1;
						} else {
							$xml->$fval['RefID']=0;
						}
					break;
					case 'password':
						if ($AObj->getMeta($fkey)) {
							$xml->$fval['RefID']='**********';
						}
					break;
					default:
						if (count($values)>1) {
							$n=$xml->addChild($fval['RefID']);
							foreach($values as $v) {
								$n->addChild('array',$v);
							}
						} else {
							$xml->$fval['RefID']=$this->AddrImplode($values);
						}
					break;
					
				}
			}
		}
		return $xml;
	}
	
}
?>
