<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class AddrObj {
	var $_meta=array();
	var $_pmeta=array();
	var $_hmeta=array();
	var $_acl;
	var $_ID;
	function getID() {
		return $this->_ID;
	}
	function setID($ID) {
		$this->_ID=$ID;
	}
	function getMeta($key,$explode=false) {
		if ($explode) {
			return Addr::AddrExplode($this->_meta[$key]);
		} else {
			return $this->_meta[$key];
		}
	}
	function setMeta($key,$data) {
		$this->_meta[$key]=$data;
	}
	function getName() {
		return $this->_meta['Title'];
	}
	function getACL($chk=0) {
		$chk=intval($chk);
		if ($chk) {
			return ($this->_acl&$chk)?true:false;
		} else {
			return $this->_acl;
		}
	}
	function setAcl($acl) {
		$this->_acl=$acl;
	}
	function getAction($typ) {
		return $this->_action[$typ];
	}
	function getSite() {
		return $this->_site;
	}

}

class AObj_fol extends AddrObj   {
	var $_site='addr.php';
	var $_action=array('b','b');
	function AObj_fol($ID=0,$meta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		$this->_ID=$ID;
		$this->_acl=$acl;
	}
	function getImage($open=0,$tree=0) {
		$image='obj_img/';
		if ($tree) $image.='_';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.='tree.gif';
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='ldap_fol';
		if ($typ) $ac.='_l';
		return $ac;
	}
	function isFolder() {
		return true;
	}
}
class AObj_addr extends AddrObj   {
	var $_site='addr.php';
	var $_action=array('v','i');
	function AObj_addr($ID=0,$meta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		$this->_acl=2;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($this->_meta['UserID']) {
			$image.='addr_p.gif';
		} else {
			$image.='addr.gif';
		}
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='ldap_addr';
		return $ac;
	}
	function getName($ol_name=0) {
		if ($ol_name) {
			$name=trim($this->_meta['Nachname'].' '.$this->_meta['Vorname']);
			if ($name) return $name;
		}
		if (trim($this->_meta['Name'])) {
			$name=$this->_meta['Name'];
		} else {
			$name=trim($this->_meta['Nachname'].' '.$this->_meta['Vorname']);
			if ($this->_meta['Firma']) {
				if ($name) $name=$this->_meta['Firma'].', '.$name; else $name=$this->_meta['Firma'];
			}
			if (!$name) $name='No Name';
		}
		return $name;
	}
	function isFolder() {
		return false;
	}
}

class Addr {
	var $_db;
	var $_uid;
	var $_lang;
	var $_gid;
	var $_rule=false;
	var $_sadmin=false;
	var $_locked_obj=array();
	var $_clipboard=array();
	var $_modul='addr';
	var $_list_fields=array(
		'ATel',
		'Fax',
		'Email',
		'Mobil',
	);
	var $_user_fields=array();
	var $_int_fields=array(
		'createTimestamp'=>array(
			'Typ'=>'date',
			'Name'=>'[[Erstellt am]]',
			'Ldap'=>'createTimestamp',
		),
		'modifyTimestamp'=>array(
			'Typ'=>'date',
			'Name'=>'[[Geaendert am]]',
			'Ldap'=>'modifyTimestamp',
		),
	);
	var $_k_fields=array();
	var $_addr_fields=array();
	var $_sfields=array();
	var $_limit=20;
	var $_addr_classes=array(
			'inetOrgPerson',
	);
	var $_folder_classes=array(
			'organizationalUnit',
	);
	var $_servers=array();
	var $_serversWrite=array();
	var $_serversPrivat=array();
	var $_avCards=array();
	var $_display=array(
		0=>array(
			'Format'=>'{Nachname} {Vorname}',
			'Title'=>'[[display0]]',
			'Fields'=>array('Nachname','Vorname'),
			'Required'=>array('Nachname'),
		),
		1=>array(
			'Format'=>'{Vorname} {Nachname}',
			'Title'=>'[[display1]]',
			'Fields'=>array('Nachname','Vorname'),
			'Required'=>array('Nachname'),
		),
		2=>array(
			'Format'=>'{Firma}',
			'Title'=>'[[display2]]',
			'Fields'=>array('Firma'),
			'Required'=>array('Firma'),
		),
		3=>array(
			'Format'=>'{Firma}, {Nachname} {Vorname}',
			'Title'=>'[[display3]]',
			'Fields'=>array('Firma','Nachname','Vorname'),
			'Required'=>array('Firma','Nachname'),
		),
	);
	var $_allowed_chars=array(
		'n'=>array('/(\n|\r|\t)/i',' '),
		'p'=>array('/[^a-z0-9"()+,-.\\/:? ]/i','-'),
		'ia5'=>array('/[^a-z0-9!"#$%&\'()*+,-.\\/:;<=>?@[\\]^_{|} ]/i','_'),
	);
	var $_idField='uid';
	var $_Asx=false;
	var $_asxPhone=false;
	function Addr($no_init=false) {
		global $db,$frm,$P,$auth,$T;
		$this->_db=&$db;
		$this->_frm=&$frm;
		$this->_T=&$T;
		$this->_P=&$P;
		//debug('INIT'.$init);
		if (!$no_init) {
			if (isset($auth) && is_object($auth)) {
				$this->_uname=$auth->auth['uname'];
				if ($auth->auth['ldap_password']) $this->_upwd=$auth->auth['ldap_password']; else $this->_upwd=$auth->auth['password'];
			}
			$this->_uid=$frm->getUser();
			$this->_lang=$frm->getLang();
			$this->_gid=$frm->getMyGroups();
			$this->setRule($frm->isRuleUser(array('sysadmin','addr')));
			$this->setSuperAdmin($frm->isSuperAdmin());
			$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
			$this->loadFields();
			$this->loadCrmFields();
			$this->loadListFields();
			$this->initServers();
			if ($this->_frm->getMyApps('asx')) {
				$this->_Asx=$this->_frm->getStaticModul('asx');
				if ($this->_Asx->getCfg('cfg/click2dial/addr')) {
					$this->_asxPhone=$this->_Asx->getPhoneFromIP();
				}
			}
		}
	}
	function initServers() {
		$this->_Server=& $this->_frm->getStaticModul('addr_server');
		//debug('INIT_OK1');
		//debug(print_r($this->_Server,true));
		$this->_Server->setRule(0);
		$this->_Server->setSuperAdmin(0);
		$this->_servers=$this->_Server->listMyServers();
		$tras=array();
		if ($this->_uname) {
			$tras['{USERNAME}']=$this->_uname;
		}
		if (defined('GE_LdapReplace')) {
			$tras['{LDAP_REPLACE}']=GE_LdapReplace;
		}
		if (GE_DOMAIN) {
			$tras['{DOMAIN}']=str_replace('.','_',GE_DOMAIN);
		}
		foreach (array_keys($this->_servers) as $i) {
			$this->_servers[$i]->setMeta('BaseDN',strtr($this->_servers[$i]->getMeta('BaseDN'),$tras));
			$this->_servers[$i]->setMeta('BindDN',strtr($this->_servers[$i]->getMeta('BindDN'),$tras));
			if (!$this->_servers[$i]->getMeta('BindPwd')) {
				$this->_servers[$i]->setMeta('BindPwd',$this->_upwd);
			}
			if($this->_servers[$i]->getACL(2)) {
				$this->_serversWrite[]=$this->_servers[$i]->getID();
			}
			if($this->_servers[$i]->getACL(2) && $this->_servers[$i]->getMeta('isPrivat')) {
				$this->_serversPrivat[]=$this->_servers[$i]->getID();
			}
		}
	}
	function getMyBooks() {
		return $this->_servers;
	}
	function getMyBooksWrite() {
		return $this->_serversWrite;
	}
	function getMyBooksPrivat() {
		return $this->_serversPrivat;
	}
	function getPerms($test=0) {
		return  1;
	}

	function getServerMeta($ID,$key='') {
		return isset($this->_servers[$ID])?$this->_servers[$ID]->getMeta($key):false;
	}
	function getServerAcl($ID,$perms=0) {
		if (isset($this->_servers[$ID])) {
			return  $this->_servers[$ID]->getACL($perms);
		}
		return false;
	}
	function getModul() {
		return $this->_modul;
	}
	function setUser($uid) {
		$this->_uid=$uid;
	}
	function setUserName($uid) {
		$this->_uname=$uid;
		if (is_array($this->_servers)) {
			$tras=array(
				'{USERNAME}'=>$this->_uname,
			);
			foreach (array_keys($this->_servers) as $i) {
				$this->_servers[$i]->setMeta('BaseDN',strtr($this->_servers[$i]->getMeta('BaseDN'),$tras));
				$this->_servers[$i]->setMeta('BindDN',strtr($this->_servers[$i]->getMeta('BindDN'),$tras));
				//debug($this->_servers[$i]->getMeta('BaseDN'));
			}
		}
	}
	function setUserPwd($pwd) {
		$this->_upwd=$pwd;
		if (is_array($this->_servers)) {
			foreach (array_keys($this->_servers) as $i) {
				if (!$this->_servers[$i]->getMeta('BindPwd')) {
					$this->_servers[$i]->setMeta('BindPwd',$this->_upwd);
				}
			}
		}
	}
	function getUser() {
		return $this->_uid;
	}
	function setGroups($gid) {
		$this->_gid=$gid;
	}
	function setLang($lang) {
		$this->_lang=$lang;
	}
	function getLang() {
		return $this->_lang;
	}
	function setRule($bool=false) {
		$this->_rule=$bool;
	}
	function setSuperAdmin($bool=false) {
		$this->_sadmin=$bool;
	}
	function setClipboard($what,$content) {
		$this->_clipboard[$what]=$content;
	}
	function getClipboard($what) {
		return $this->_clipboard[$what];
	}
	function isClipboard($what) {
		if ($this->_clipboard[$what]) {
			return true;
		} else {
			return false;
		}
	}
	function isRuleUser() {
		return $this->_rule;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function setCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}
		}
	}
	function getCfg($key) {
		if (isset($this->_cfg[$key])) {
			return $this->_cfg[$key];
		} else {
			return false;
		}
	}
	function setRootObj(&$obj) {
		$this->_root_obj=&$obj;
	}
	function &getRootObj() {
		return $this->_root_obj;
	}
	function setMode($mode) {
		$this->_mode=$mode;
	}
	function getMode() {
		return $this->_mode;
	}
	function getLimit() {
		return $this->_limit;
	}
	function setLimit($limit) {
		$this->_limit=$limit;
	}
	function getRows() {
		return $this->_rows;
	}
	function setRows($rows) {
		$this->_rows=$rows;
	}
	function getlistFields() {
		return $this->_list_fields;
	}
	function setlistFields($fields) {
		$this->_list_fields=$fields;
	}
	function getKFields() {
		return $this->_k_fields;
	}
	function getFields() {
		return $this->_addr_fields;
	}
	function getUserFields() {
		return $this->_user_fields;
	}
	function hasUserFields() {
		return empty($this->_user_fields)?false:true;
	}
	function getIntFields() {
		return $this->_int_fields;
	}
	function getSearchFields() {
		return $this->_sfields;
	}
	function getAvCards() {
		return $this->_avCards;
	}
	function getFieldData($ID,$key=0) {
		if (isset($this->_addr_fields[$ID])) {
			if ($key) {
				if (isset($this->_addr_fields[$ID][$key])) return $this->_addr_fields[$ID][$key];
			} else {
				return $this->_addr_fields[$ID];
			}
		} elseif (isset($this->_int_fields[$ID])) {
			if ($key) {
				if (isset($this->_int_fields[$ID][$key])) return $this->_int_fields[$ID][$key];
			} else {
				return $this->_int_fields[$ID];
			}
		}
		return false;
	}
	function getAsxPhone() {
		return $this->_asxPhone;
	}
	function getDisplay() {
		return $this->_display;
	}
	function checkDisplay($ID,$meta) {
		if ($this->_display[$ID]) {
			foreach ($this->_display[$ID]['Required'] as $field) {
				if (!trim($meta[$field])) return false;
			}
			return true;

		}
		return false;
	}
	function formatDisplay($ID,$meta) {
		$Name='';
		if ($this->_display[$ID]) {
			$tras_array=array();
			foreach ($this->_display[$ID]['Fields'] as $field) {
				$tras_array['{'.$field.'}']=trim($meta[$field]);
			}
			//debug($tras_array);
			$Name=trim(strtr($this->_display[$ID]['Format'],$tras_array));
		}
		return $Name;
	}
	function whatDisplay(&$AObj) {
		foreach (array_keys($this->_display) as $ID) {
			if (trim($AObj->getMeta('Name')) && $AObj->getMeta('Name')==$this->formatDisplay($ID,$AObj->_meta)) {
				return $ID;
			}
		}
		return 0;
	}
	function isAllowedChar($string,$typ) {
		if ($this->_allowed_chars[$typ] && preg_match($this->_allowed_chars[$typ][0],$string)) {
			return false;
		}
		return true;
	}
	function replaceAllowedChar($string,$typ) {
		if ($this->_allowed_chars[$typ]) {
			$string=preg_replace($this->_allowed_chars[$typ][0],$this->_allowed_chars[$typ][1],$string);
		}
		return $string;
	}

	function loadCrmFields() {
		$this->_user_fields=array();
		$this->_BaseForm=& $this->_frm->getStaticModul('uform');
		$this->_BaseFields=& $this->_frm->getStaticModul('uform_fields');
		$this->_BaseSelect=& $this->_frm->getStaticModul('uform_select');
		$this->_uformObj=$this->_BaseForm->getSystemForm('addrldap');
		if (is_object($this->_uformObj)) {
			$this->_BaseFields->setFormObj($this->_uformObj);
			$crmFields=$this->_BaseFields->listFormFields();
			if (is_array($crmFields[0])) {
				foreach ($crmFields[0] as $gid=>$crmGroup) {
					if (is_array($crmFields[$gid])) {
						$this->_addr_fields['U_'.$gid]=array(
							'FieldTyp'=>'u',
							'Title'=>$crmGroup->getName(),
							'Card'=>'crm',
							'Search'=>0,
							'Typ'=>'title',
							'Value'=>'',
							'Action'=>'',
							'Multi'=>0,
							'Vcard'=>'',
							'Ldap'=>'',
							'LdapMulti'=>0,
							'LdapClass'=>'',
							'AllowedChars'=>'',
							'Sequence'=>$crmGroup->getMeta('Sequence'),
							'FKUserID'=>0,
							'Required'=>0,
							'Disabled'=>0,
							'Hidden'=>0,
						);
						$this->_user_fields[]='U_'.$gid;
						foreach ($crmFields[$gid] as $fid=>$crmField) {
							$ldapMulti=0;
							$ldapChars='n';
							switch ($crmField->getMeta('Typ')) {
								case 'mselect':
									$ldapMulti=1;
								break;
								case 'area':
									$ldapChars='';
								break;
							}
							$this->_addr_fields['U_'.$fid]=array(
								'FieldTyp'=>'u',
								'Title'=>$crmField->getName(),
								'Card'=>'crm',
								'Search'=>$crmField->getMeta('useSearch'),
								'Typ'=>$crmField->getMeta('Typ'),
								'Value'=>$crmField->getMeta('Value'),
								'Action'=>'',
								'Multi'=>0,
								'Vcard'=>'',
								'Ldap'=>$crmField->getMeta('RefID'),
								'LdapMulti'=>$ldapMulti,
								'LdapClass'=>$crmField->getMeta('RefClass'),
								'AllowedChars'=>$ldapChars,
								'Sequence'=>$crmField->getMeta('Sequence'),
								'FKUserID'=>0,
								'Required'=>$crmField->getMeta('Required'),
								'Disabled'=>$crmGroup->getAcl(2)?0:1,
								'Hidden'=>0,
								'Config'=>unserialize($crmField->getMeta('Config')),
							);
							if ($crmField->getMeta('RefClass') && !in_array($crmField->getMeta('RefClass'),$this->_addr_classes)) {
								$this->_addr_classes[]=$crmField->getMeta('RefClass');
							}
							$this->_user_fields[]='U_'.$fid;
							$this->_ldapToAddr[strtolower($crmField->getMeta('RefID'))]='U_'.$fid;
							$this->_addrToLdap['U_'.$fid]=$crmField->getMeta('RefID');
						}
						$this->_avCards['crm']=1;

					}
				}
			}
			//debug($this->_addr_fields);
		}
	}
	function loadListFields() {
		$list_fields=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_uid);
		$query="SELECT * FROM AddrFieldsList WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			if (isset($this->_addr_fields[$this->_db->f("FKFieldID")])) {
				$list_fields[]=$this->_db->f("FKFieldID");
				$this->_addr_fields[$this->_db->f("FKFieldID")]['FKUserID']=$this->_uid;
			}
		}
		if (!empty($list_fields)) {
			$this->_list_fields=$list_fields;
		} else {
			$def=$this->_frm->getDefaults('addr');
			$this->_list_fields=explode('|',$def['lfields']);
		}
		usort($this->_list_fields,array($this,'sortSequence'));
	}
	function sortSequence($fidA,$fidB) {
		if ($this->_addr_fields[$fidA]['FieldTyp']=='u' && $this->_addr_fields[$fidB]['FieldTyp']!='u') {
			return 1;
		}
		if ($this->_addr_fields[$fidA]['FieldTyp']!='u' && $this->_addr_fields[$fidB]['FieldTyp']=='u') {
			return -1;
		}
		return $this->_addr_fields[$fidA]['Sequence']>$this->_addr_fields[$fidB]['Sequence']?1:-1;
	}
	function loadFields($uid=0,$use_perms=true) {
		$this->_k_fields=array();
		$this->_addr_fields=array();
		$this->_sfields=array();

		if (!$uid) $uid=$this->_uid;
		$query="SELECT * FROM AddrFieldsLdap WHERE Aktiv=1";
		//$query="SELECT * FROM AddrFieldsLdapTest WHERE Aktiv=1";
		$query.=" ORDER BY Sequence";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$this->_addr_fields[$this->_db->f("FieldID")]=array(
				'FieldTyp'=>$this->_db->f('FieldTyp'),
				'Title'=>$this->_db->f("Title_".$this->_lang),
				'Card'=>$this->_db->f("Card"),
				'Search'=>$this->_db->f("Search"),
				'Typ'=>$this->_db->f("Typ"),
				'Value'=>$this->_db->f("Value"),
				'Action'=>$this->_db->f("Action"),
				'Multi'=>$this->_db->f("Multi"),
				'Vcard'=>$this->_db->f("Vcard"),
				'Ldap'=>$this->_db->f("Ldap"),
				'LdapMulti'=>$this->_db->f("LdapMulti"),
				'LdapClass'=>$this->_db->f("LdapClass"),
				'AllowedChars'=>$this->_db->f("AllowedChars"),
				'Sequence'=>$this->_db->f("Sequence"),
				'Required'=>0,
				'Disabled'=>0,
				'Hidden'=>$this->_db->f("Hidden"),
				'Config'=>array(
					'default'=>$this->_db->f("Value"),
					'maxlen'=>$this->_db->f("AllowedLen"),
				),
			);
			if ($this->_db->f("LdapClass") && !in_array($this->_db->f("LdapClass"),$this->_addr_classes)) {
				$this->_addr_classes[]=$this->_db->f("LdapClass");
			}
			$this->_ldapToAddr[strtolower($this->_db->f("Ldap"))]=$this->_db->f("FieldID");
			$this->_addrToLdap[$this->_db->f("FieldID")]=$this->_db->f("Ldap");
			if ($this->_db->f('FieldTyp')=='k')	{
				$this->_k_fields[]=$this->_db->f("FieldID");
			}
			if ($this->_db->f('Search')==1) {
				$this->_sfields[]=$this->_db->f("FieldID");
			}
			$this->_avCards[$this->_db->f("Card")]=1;
		}
	}
	function getVcardFields() {
		$result=array();
		foreach ($this->getFields() as $key=>$val) {
			if ($val['Vcard']) {
				$result[$key]=$val['Vcard'];
			}

		}
		return $result;
	}
	function AddrExplode($val) {
		if ($val) {
			return explode('||',$val);
		} else {
			return array();
		}
	}
	function AddrImplode($val) {
		return implode('||',$val);
	}
	function formatMail(&$aobj,$mail) {
		$m_name=trim($aobj->getMeta('Nachname').' '.$aobj->getMeta('Vorname'));
		if (!$m_name) $m_name=$aobj->getMeta('Firma');
		$temp=explode('@',$mail);
		if (function_exists('imap_rfc822_write_address')) {
			return imap_rfc822_write_address ($temp[0],$temp[1],$m_name);
		} else {
			return $m_name.' <'.$mail.'>';
		}
	}
	function formatFax(&$aobj,$fax) {
		$m_name=trim($aobj->getMeta('Nachname').' '.$aobj->getMeta('Vorname'));
		if (!$m_name) $m_name=$aobj->getMeta('Firma');
		if ($m_name) {
			return trim($m_name.'@'.$this->formatTel($fax));
		} else {
			return $fax;
		}
	}
	function formatWeb(&$aobj,$url) {
		$temp=@parse_url($url);
		if (!$temp['scheme']) {
			$url='http://'.$url;
		}
		return $url;
	}
	function formatCallto(&$aobj,$val) {
		if ($this->_asxPhone) {
			$res="javascript:void(sndReq('callto','ajax.php','ajax_modul=asxCall";
			if (is_object($aobj)) $res.="&AddrID=".$aobj->getID();
			$res.="&number=".$this->formatTel($val,false)."'));";
		} elseif ($this->getCfg('cfg/skype')) {
			$res=($this->getCfg('cfg/skype/handler')?$this->getCfg('cfg/skype/handler'):'callto://').$this->formatTel($val);
		} else {
			$res='';
		}
		return $res;
	}

	function formatSms(&$aobj,$sms) {
		return $this->formatTel($sms);
	}
	function formatTel($tel,$useCfg=true) {
        $tel=preg_replace('/[^0-9+]/','',$tel);
        $tel=str_replace('+','00',$tel);
        if ($useCfg && $this->getCfg('cfg/skype/preg_search')) {
			//debug($this->getCfg('cfg/skype/preg_replace'));
			$tel=preg_replace($this->getCfg('cfg/skype/preg_search'),$this->getCfg('cfg/skype/preg_replace'),$tel);
		}
        return $tel;

	}
	function formatViewName(&$AObj) {
		$result=array();
		if ($AObj->getMeta('Firma')) $result[]=$AObj->getMeta('Firma');
		$result_1=array();
		if ($AObj->getMeta('Titel')) $result_1[]=$AObj->getMeta('Titel');
		if ($AObj->getMeta('Nachname')) $result_1[]=$AObj->getMeta('Nachname');
		if ($AObj->getMeta('Vorname')) $result_1[]=$AObj->getMeta('Vorname');
		$result[]=implode(' ',$result_1);
		return implode("\n",$result);
	}
	function formatViewAddress(&$AObj,$mode='A') {
		$result=array();
		if ($AObj->getMeta($mode.'Strasse')) $result[]=$AObj->getMeta($mode.'Strasse');
		$result_1=array();
		if ($AObj->getMeta($mode.'Land')) $result_1[]=$AObj->getMeta($mode.'Land');
		if ($AObj->getMeta($mode.'Plz') || $AObj->getMeta($mode.'Ort')) $result_1[]=trim($AObj->getMeta($mode.'Plz').' '.$AObj->getMeta($mode.'Ort'));
		if (!empty($result_1)) $result[]=implode('-',$result_1);
		if ($AObj->getMeta($mode.'Prov')) $result[]='('.$AObj->getMeta($mode.'Prov').')';
		return !empty($result)?implode("\n",$result):false;
	}

	function getError($ID=0) {
		if (!$ID) $ID=$this->_aktserver;
		$result="LDAP: ".@ldap_error($this->_ds[$ID]);
		if ($this->_errorAdd) $result.=" Debug:".$this->_errorAdd;
		return $result;
	}
	function _bind($ID=0) {
		if (!$ID) $ID=$this->_aktserver;
		//debug(print_r($this->_servers,true));
		if (!isset($this->_servers[$ID])) return false;
		if (!isset($this->_ds[$ID])) {
			//debug($this->_servers[$ID]->getMeta('Server'));
			$this->_ds[$ID]=ldap_connect($this->_servers[$ID]->getMeta('Server'), $this->_servers[$ID]->getMeta('Port'));
			if ($this->_ds[$ID]) {
				@ldap_set_option($this->_ds[$ID], LDAP_OPT_PROTOCOL_VERSION, $this->_servers[$ID]->getMeta('LdapVersion'));
				if ($this->_servers[$ID]->getMeta('Security')) @ldap_start_tls($this->_ds[$ID]);
				if (!$this->_servers[$ID]->getMeta('BindDN')) {
					if (!ldap_bind($this->_ds[$ID])) unset($this->_ds[$ID]);
				} else {
					$binddn=$this->_servers[$ID]->getMeta('BindDN');
					$pwd=$this->_servers[$ID]->getMeta('BindPwd');
					//debug($binddn);
					//debug($pwd);
					if (!ldap_bind($this->_ds[$ID], $this->utf8encode($binddn), $this->utf8encode($pwd))) unset($this->_ds[$ID]);
				}
			} else {
				unset($this->_ds[$ID]);
			}
		}
		return $this->_ds[$ID];
	}
	function _add($dn,$add) {
		$ID=$this->_aktserver;
		//debug(print_r($add,1));
		if (@ldap_add($this->_ds[$ID],$this->utf8encode($dn),$this->utf8encode($add))) {
			return true;
		} else {
			$this->_errorAdd='DN: '.$dn.' ADD:'.print_r($add,1);
			return false;
		}
	}
	function _rename($dn,$newRdn,$newParent,$del=true) {
		$ID=$this->_aktserver;
		if (@ldap_rename($this->_ds[$ID], $this->utf8encode($dn), $this->utf8encode($newRdn), $newParent?$this->utf8encode($newParent):null, $del)) {
			return true;
		} else {
			$this->_errorAdd='DN: '.$dn.' NEWRDN: '.$newRdn.' NEWPARENT:'.$newParent;
			return false;
		}
	}
	function _del($dn) {
		$ID=$this->_aktserver;
		if (@ldap_delete($this->_ds[$ID],$this->utf8encode($dn))) {
			return true;
		} else {
			$this->_errorAdd='DN: '.$dn;
			return false;
		};
	}
	function _mod_add($dn,$add) {
		//debug($dn);
		//debug($add);
		$ID=$this->_aktserver;
		if (@ldap_mod_add($this->_ds[$ID],$this->utf8encode($dn),$this->utf8encode($add))) {
			return true;
		} else {
			$this->_errorAdd='DN: '.$dn.' ADD:'.print_r($add,1);
			return false;
		}
	}
	function _mod_rep($dn,$add) {
		//debug($dn);
		//debug($add);
		$ID=$this->_aktserver;
		if (@ldap_mod_replace($this->_ds[$ID],$this->utf8encode($dn),$this->utf8encode($add))) {
			return true;
		} else {
			$this->_errorAdd='DN: '.$dn.' REP:'.print_r($add,1);
			return false;
		};
	}
	function _mod_del($dn,$del) {
		//debug($dn);
		//debug($del);
		$ID=$this->_aktserver;
		if (@ldap_mod_del($this->_ds[$ID],$this->utf8encode($dn),$this->utf8encode($del))) {
			return true;
		} else {
			$this->_errorAdd='DN: '.$dn.' DEL:'.print_r($del,1);
			return false;
		};
	}
	function _search($basedn,$search,$attr,$sub=0,$dref=0) {
		$ID=$this->_aktserver;
		//debug($this->_ds[$ID]);
		//debug($basedn);
		//debug($search);
		//debug($attr);
		if ($sub) {
			return ldap_search($this->_ds[$ID],$this->utf8encode($basedn),$this->utf8encode($search),$this->utf8encode($attr),0,0,0,$dref);
		} else {
			return ldap_list($this->_ds[$ID],$this->utf8encode($basedn),$this->utf8encode($search),$this->utf8encode($attr),0,0,0,$dref);
		}
	}
	function _read($dn,$search,$attr) {
		$ID=$this->_aktserver;
		//debug($this->_ds[$ID]);
		//debug($dn);
		//debug($search);
		//debug($attr);
		return @ldap_read($this->_ds[$ID],$this->utf8encode($dn),$this->utf8encode($search),$this->utf8encode($attr));
	}

	function _close() {
		$ID=$this->_aktserver;
		@ldap_close($this->_ds[$ID]);
		unset($this->_ds[$ID]);
	}
	function ldapEsc($value) {
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->ldapEsc($val);
			}
		} else {
			$tras=array('*'=>'\\2a','('=> '\\28',')'=>'\\29','\\'=>'\\5c','\0'=>'\\00');
			$value=strtr($value,$tras);
		}
		return $value;
	}
	function ldapEscDN($value) {
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->ldapEscDN($val);
			}
		} else {
			$tras=array(
				','=>'\2c',
				'+'=>'\2b',
				'='=>'\3d',
				'"'=>'\22',
				'\\'=>'\5c',
				'<'=>'\3c',
				'>'=>'\3e',
				';'=>'\3b',
			);
			$value=strtr($value,$tras);
		}
		return $value;
	}
	function ldapUnEscDN($value) {
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->ldapUnEscDN($val);
			}
		} else {
			$tras=array(
				'\2C'=>',','\2c'=>',',
				'\2B'=>'+','\2b'=>'+',
				'\3D'=>'=','\3d'=>'=',
				'\3C'=>'<','\3c'=>'<',
				'\3e'=>'>','\3e'=>'>',
				'\3B'=>';','\3b'=>';',
				'\5c'=>'\\','\5C'=>'\\',
				'\22'=>'"',
			);
			$value=strtr($value,$tras);
		}
		return $value;
	}
	function utf8encode($value) {
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->utf8encode($val);
			}
		} else {
			$value=Framework::convertCharset($value,GE_CHARSET,'UTF-8');
		}
		return $value;
	}
	function utf8decode($value) {
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->utf8decode($val);
			}
		} else {
			$value=Framework::convertCharset($value,'UTF-8',GE_CHARSET);
		}
		return $value;
	}
	function setAktServer($id) {
		$this->_aktserver=$id;
	}
	function setServers(&$sObj) {
		$this->_servers=&$sObj;
	}

	function listSubTree($params,$onlyApps=true) {
		if ($params['sid']) $this->setAktServer($params['sid']);
		//$tmp=$this->getObj($params['ParentID']);
		//debug($params['ParentID']);
		return $this->listSubFolders($params['ParentID'],'ou');
	}

	function isSubTreeLen() {
		return true;
	}
	function listAllTree($server=null) {
		if (is_array($server)) {
			$servers=$server;
		} elseif ($server) {
			$servers=array($server);
		} else {
			$servers=array_keys($this->_servers);
		}
		foreach ($servers as $ID) {
			$this->setAktServer($ID);
			$sObj=$this->getObjbyDN($this->_servers[$ID]->getMeta('BaseDN'));
			if (is_object($sObj)) {
				$sObj->setMeta('Title',$this->_servers[$ID]->getName());
				$result[0][]=$sObj;
				$filter=array('(objectClass=organizationalUnit)');
				if ($this->_bind()) {
					$fields=array('ou','description','entryUUID');
					$sr=$this->_search($this->_servers[$ID]->getMeta('BaseDN'),implode('',$filter),$fields,true);
					if ($order) {
						ldap_sort($this->_ds[$ID],$sr,$order);
					}
					$entrys=ldap_get_entries($this->_ds[$ID],$sr);
					for ($i=0;$i<$entrys['count'];$i++) {
						$nObj=new AObj_fol($ID.'$'.$this->utf8decode($entrys[$i]['entryuuid'][0]),$this->parseObj($entrys[$i]));
						$result[$this->getDnParent($nObj->getMeta('_DN'))][$nObj->getID()]=$nObj;
					}
				} else {
					debug($this->getError());
				}
			}
		}
		return $result;
	}

	function searchFolders($servers=null,$search='',$limit=0,$only_names=false) {
		if (!$servers) $servers=array_keys($this->_servers);
		$fields=array('ou','description','entryUUID');
		$filter=array('(objectClass=organizationalUnit)');
		if ($search['info']) {
			$info_array=explode(' ',$search['info']);
			foreach ($info_array as $info) {
				$tmp=array();
				$tmp[]='(ou=*'.$this->ldapEsc(trim($info)).'*)';
				$filter[]='(|'.implode('',$tmp).')';
			}
		}
		$entrys=array();
		//debug($this->_servers);
		foreach ($servers as $skey) {
			$this->setAktServer($skey);
			$ID=$this->_aktserver;
			if ($this->_bind()) {
				$akt_search=implode('',$filter);
				$sr=$this->_search($this->_servers[$ID]->getMeta('BaseDN'),'(&'.$akt_search.')',$fields,true);
				$tmp_entrys=ldap_get_entries($this->_ds[$ID],$sr);
				@ldap_free_result ($sr);
				unset($tmp_entrys['count']);
				$tmp_entrys=array_map(array($this,'addServerID'),$tmp_entrys);
				$entrys = array_merge($entrys, $tmp_entrys);
				unset($tmp_entrys);
			}
		}
		unset($entrys['count']);
		$rows=count($entrys);
		$this->_sort=array('ou'=>1);
		usort($entrys,array($this,'cmp'));
		if (!$limit) $limit=$rows;
		for ($i=0;$i<$limit;$i++) {
			if (isset($entrys[$i])) {
				if ($only_names) {
					$nObj=new AObj_fol($entrys[$i]['_serverID'].'$'.$this->utf8decode($entrys[$i]['entryuuid'][0]),$this->parseObj($entrys[$i]));
					$tree=$this->getObjTreeNames($nObj);
					$result[$entrys[$i]['_serverID'].'$'.$entrys[$i]['entryuuid'][0]]=implode('->',$tree);
				} else {
					$result[$entrys[$i]['_serverID'].'$'.$entrys[$i]['entryuuid'][0]]=new AObj_fol($entrys[$i]['_serverID'].'$'.$this->utf8decode($entrys[$i]['entryuuid'][0]),$this->parseObj($entrys[$i]));
				}
			}
		}
		return $result;
	}

	function listSubFolders($searchDN,$order='ou') {
		$ID=$this->_aktserver;
		$filter=array('(objectClass=organizationalUnit)');
		if ($this->_bind()) {
			$fields=array('ou','description','entryUUID');
			$sr=$this->_search($searchDN,implode('',$filter),$fields,0);
			if ($order) {
				ldap_sort($this->_ds[$ID],$sr,$order);
			}
			$entrys=ldap_get_entries($this->_ds[$ID],$sr);
			for ($i=0;$i<$entrys['count'];$i++) {
				$result[$this->utf8decode($ID.'$'.$entrys[$i]['entryuuid'][0])]=new AObj_fol($ID.'$'.$this->utf8decode($entrys[$i]['entryuuid'][0]),$this->parseObj($entrys[$i]));
			}
			return $result;
		} else {
			debug($this->getError());
		}
	}
	function getObjbyDN($dn,$raw=false,$fields=null) {
		if ($dn) {
			$ID=$this->_aktserver;
			if ($this->_bind()) {
				$filter="(objectclass=*)";
				if (!is_array($fields)) $fields=array('ou','description','entryUUID','hasSubordinates');
				$sr=$this->_read($dn, $filter, $fields);
				if ($sr) {
					$entry = ldap_get_entries($this->_ds[$ID], $sr);
					//debug($entry);
					if ($entry['count']) {
						if ($raw) {
							return $this->utf8decode($entry[0]);
						} else {
							return new AObj_fol($ID.'$'.$this->utf8decode($entry[0]['entryuuid'][0]),$this->parseObj($entry[0]));
						}
					}
				}
			}
		}
		return false;
	}

	function getObj($oID,$raw=false,$fields=null) {
		if ($oID) {
			$ID=$this->_aktserver=$this->getServerFromAddr($oID);
			$oID=$this->getIDFromAddr($oID);
			if ($this->_bind()) {
				$filter='(entryUUID='.$this->ldapEsc($oID).')';
				if (!is_array($fields)) $fields=array('ou','description','entryUUID','hasSubordinates');


				$sr=$this->_search($this->_servers[$ID]->getMeta('BaseDN'), $filter, $fields,1);
				if ($sr) {
					$entry = ldap_get_entries($this->_ds[$ID], $sr);
					if ($entry['count']) {
						if ($raw) {
							return $this->utf8decode($entry[0]);
						} else {
							return new AObj_fol($ID.'$'.$this->utf8decode($entry[0]['entryuuid'][0]),$this->parseObj($entry[0]));
						}
					}
				}
			}
		}
		return false;
	}
	function parseObj(&$entry) {
		$result=array(
			'_DN'=>$this->utf8decode($entry['dn']),
			/*'_serverID'=>$entry['_serverID'],*/
			'Title'=>$this->utf8decode($entry['ou'][0]),
		);
		if (isset($entry['hassubordinates'])) $result['_hasSub']=$this->utf8decode($entry['hassubordinates'][0]);
		return $result;
	}
	function _copyEntry($oldDN,$newParent,$rdnField,$rdnValue,$rec) {
		$ID=$this->_aktserver;
		$entry=$this->getObjByDN($oldDN,true,array());
		$ldap_add=$this->parseEntry($entry);
		$ldap_add[$rdnField]=array($rdnValue);
		//debug($rdnValue);
		$newDN=$rdnField.'='.$this->ldapEscDN($rdnValue).','.$newParent;
		//debug($newDN);
		//debug($ldap_add);
		if ($this->_bind() && $this->_add($newDN, $ldap_add)) {
			//debug($newDN);
			$result[]=$oldDN;
			if ($rec) {
				$filter="(hasSubordinates=TRUE)";
				$fields=array();
				$sr=$this->_search($oldDN,$filter,$fields,1);
				$entrys=$this->utf8decode(ldap_get_entries($this->_ds[$ID],$sr));
				$ldap_add=array();
				for ($i=0;$i<$entrys['count'];$i++) {
					if ($entrys[$i]['dn']==$oldDN) continue;
					$ldap_add[$entrys[$i]['dn']]=array(
						'ndn'=>str_replace($oldDN,$newDN,$entrys[$i]['dn']),
						'values'=>$this->parseEntry($entrys[$i]),
					);
				}
				$filter="(hasSubordinates=FALSE)";
				$fields=array('dn');
				$sr=$this->_search($oldDN,$filter,$fields,1);
				$entrys=$this->utf8decode(ldap_get_entries($this->_ds[$ID],$sr));
				$ldap_ren=array();
				for ($i=0;$i<$entrys['count'];$i++) {
					if ($entrys[$i]['dn']==$oldDN) continue;
					$ldap_ren[$entrys[$i]['dn']]=array(
						'ndn'=>str_replace($oldDN,$newDN,$entrys[$i]['dn']),
					);
				}

				uksort ($ldap_add,array($this,'sortByLen'));
				foreach($ldap_add as $olddn=>$entry_add) {
					//debug($entry_add['ndn']);
					//debug($entry_add['values']);
					if ($this->_add($entry_add['ndn'], $entry_add['values'])) {
						//debug('OK');
						$result[]=$olddn;
					}
				}
				foreach($ldap_ren as $olddn=>$entry_add) {
					$pos=strpos($entry_add['ndn'],',');
					//debug(substr($entry_add['ndn'],0,$pos));
					//debug(substr($entry_add['ndn'],$pos+1));
					$this->_rename($olddn,substr($entry_add['ndn'],0,$pos),substr($entry_add['ndn'],$pos+1),true);
				}
			}
			return $result;
		} else {
			return false;
		}
	}
	function getObjTree ($DN) {
		$ID=$this->_aktserver;
		$result=array();
		while ($DN!=$this->_servers[$ID]->getMeta('BaseDN')) {
			//debug($DN);
			$Obj=$this->getObjbyDN($DN);
			if (is_object($Obj)) {
				$result[$Obj->getID()]=$Obj;
				$DN=$this->getDnParent($DN);
			} else {
				break;
			}
		}
		return $result;
	}
	function getObjTreeNames (&$Obj) {
		$ID=$this->getServerFromAddr($Obj->getID());
		$DN=$Obj->getMeta('_DN');
		$result=array();
		if (is_object($this->_servers[$ID])) {
			while ($DN!=$this->_servers[$ID]->getMeta('BaseDN')) {
				$entry=$this->getDnEntry($DN);
				if ($entry) {
					$result[]=$this->ldapUnEscDN(substr($entry,strpos($entry,'=')+1));
				} else {
					break;
				}
				$DN=$this->getDnParent($DN);
			}
			$result[]=$this->_servers[$ID]->getName();
		} else {
			$result[]=$Obj->getName();
		}
		return array_reverse($result);
	}
	function sortByLen($a,$b) {
		if ($a==$b) return 0;
		return strlen($a)<strlen($b)?-1:1;
	}
	function parseEntry(&$entry) {
		for ($i=0;$i<$entry['count'];$i++) {
			$key=$entry[$i];
			if ($key=='entryuuid' || $key=='modifytimestamp') continue;
			for ($j=0;$j<$entry[$key]['count'];$j++) {
				$result[$key][]=$this->utf8decode($entry[$key][$j]);
			}
		}
		return $result;
	}
	function getDnParent($dn) {
		$pos=strpos($dn,',');
		if ($pos) {
			return substr($dn,$pos+1);
		} else {
			return '';
		}
	}
	function getDnEntry($dn) {
		$pos=strpos($dn,',');
		if ($pos) {
			return substr($dn,0,$pos);
		} else {
			return '';
		}
	}
	function createRoot(&$rootObj) {
		$parentDN=$this->getDnParent($rootObj->getMeta('BaseDN'));
		$nRdn=$this->getDnEntry($rootObj->getMeta('BaseDN'));
		$nRdnField=substr($nRdn,0,strpos($nRdn,'='));
		$nRdnValue=substr($nRdn,strpos($nRdn,'=')+1);
		$meta=array(
			'_DN'=>$parentDN,
			'Title'=>$nRdnValue,
		);
		$Obj=new AObj_fol(0,$meta);
		if (!$this->insertMeta($Obj)) {
			return $Obj;
		} else {
			return false;
		}
	}

	function insertMeta(&$Obj) {
		$oldData=array();
		$newRdn='ou='.$this->ldapEscDN($Obj->getMeta('Title')).','.$Obj->getMeta('_DN');
		$ldap_add=array();
		$ldap_add['objectClass']=$this->_folder_classes;
		foreach ($ldap_add['objectClass'] as $val) {
			$ldap_add = $ldap_add + $this->_getObjectAdd($val,$Obj->_meta,$oldData);
		}
		//debug($ldap_add);
		//debug($newRdn);
		if ($this->_bind() && $this->_add($newRdn, $ldap_add)) {
			$Obj=$this->getObjbyDN($newRdn);
			return false;
		} else {
			return array('server',$this->getError());
		}
	}
	function updateMeta(&$Obj) {
		$oldData=$this->getObj($Obj->getID(),true,array());
		$DN=$Obj->getMeta('_DN');
		//debug($oldData);
		$temp=explode(',',$DN);
		unset($temp[0]);
		$parentRdn=implode(',',$temp);
		if ($this->_bind()) {
			$ldap_add=array();
			foreach ($this->_folder_classes as $val) {
				if (!in_array($val,$oldData['objectclass']) && !in_array(strtolower($val),$oldData['objectclass'])) {
					$ldap_add['objectClass'][]=$val;
				}
				$ldap_add = $ldap_add + $this->_getObjectAdd($val,$Obj->_meta,$oldData);
			}
			$ldap_rep=array();
			foreach ($this->_folder_classes as $val) {
				if (in_array($val,$oldData['objectclass']) || in_array(strtolower($val),$oldData['objectclass'])) {
					$ldap_rep = $ldap_rep + $this->_getObjectReplace($val,$Obj->_meta,$oldData);
				}
			}
			$ldap_ren='';
			if ($ldap_rep['ou'] && strcasecmp($ldap_rep['ou'],$oldData['ou'])!=0) {
				$ldap_ren=$ldap_rep['ou'];
				unset($ldap_rep['ou']);
			}
			$no_error=true;
			//debug($ldap_add);
			if (!empty($ldap_add) && $this->_bind()) {
				$no_error=$this->_mod_add($DN, $ldap_add);
			}
			//debug($ldap_rep);
			if ($no_error && !empty($ldap_rep) && $this->_bind()) {
				$no_error=$this->_mod_rep($DN, $ldap_rep);
			}
			//debug($ldap_ren);
			if ($no_error && $ldap_ren) {
				$cEntries=$this->_copyEntry($DN,$parentRdn,'ou',$ldap_ren,1);
				if (is_array($cEntries)) {
					if ($this->_bind()) {
						$cEntries=array_reverse($cEntries);
						foreach ($cEntries as $val) {
							$this->_del($val);
						}
					}
				} else {
					$no_error=false;
				}
			}
			if ($no_error) {
				if ($ldap_ren) $Obj=$this->getObjbyDN('ou='.$this->ldapEscDN($ldap_ren).','.$parentRdn);
				return false;
			}

		}
		return array('server',$this->getError());
	}
	function deleteMeta(&$Obj) {
		if ($this->_bind() && $this->_del($Obj->getMeta('_DN'))) {
			return false;
		} else {
			return array('server',$this->getError());
		}
	}
	function catName2ID($Name,$ParentDN,$create=true,$sep='.',$escape='\\') {

		$catArray=explode('.',substr($Name,strlen($this->_catPrepends['A'])));
		$pieces=Framework::splitVal($Name,$sep);
		foreach ($pieces as $val) {
			$val=trim(Framework::unescapeVal($val,$escape));
			if ($val) {
				if (!$ParentDN) {
					foreach($this->getMyBooks() as $sid=>$server) {
						if (strtr($server->getName(),';,.',' ')==$val) {
							$this->setAktServer($sid);
							$ParentDN=$server->getMeta('BaseDN');
							break;
						}
					}
					if ($ParentDN) {
						continue;
					}
				}
				if ($ParentDN && $this->_bind()) {
					$ID=$this->_aktserver;
					$filter='(ou='.str_replace(' ','*',$this->ldapEsc($val)).')';
					$sr=$this->_search($ParentDN, $filter, array('ou'),1);
					if ($sr) {
						$entry = ldap_get_entries($this->_ds[$ID], $sr);
						if ($entry['count']) {
							$ParentDN=$this->utf8decode($entry[0]['dn']);
							continue;
						}
					}
				}
			}
			return false;
		}
		if ($ParentDN && ($catObj=$this->getObjbyDN($ParentDN))) {
			return $catObj;
		}
	}

	function getAddrObjByDN($dn,$raw=0) {
		$ID=$this->_aktserver;
		$fields=array_values($this->_addrToLdap);
		$fields[]='entryUUID';
		$fields[]='modifyTimestamp';
		$fields[]='objectClass';
		$fields[]=$this->_idField;
		if (!in_array('cn',$fields)) $fields[]='cn';
		if ($dn && $this->_bind()) {
			$filter="(objectclass=inetOrgPerson)";
			$sr=$this->_read($dn, $filter, $fields);
			if ($sr) {
				$entry = ldap_get_entries($this->_ds[$ID], $sr);
				if ($entry['count']) {
					if ($raw) {
						return $this->utf8decode($entry[0]);
					} else {
						unset($entry['count']);
						$entry=array_map(array($this,'addServerID'),$entry);
						return new AObj_addr($ID.'$'.$entry[0]['entryuuid'][0],$this->parseAddrEntry($entry[0]));
					}
				}
			}
		}
		return false;
	}
	function getServerFromAddr($ID) {
		return substr($ID,0,strpos($ID,'$'));
	}
	function getIDFromAddr($ID) {
		return substr($ID,strpos($ID,'$')+1);
	}

	function getAddrObj($addrID,$raw=0) {
		$fields=array_values($this->_addrToLdap);
		$fields[]='entryUUID';
		$fields[]='modifyTimestamp';
		$fields[]='objectClass';
		$fields[]=$this->_idField;
		if (!in_array('cn',$fields)) $fields[]='cn';
		//debug($addrID);
		if (is_array($addrID)) {
			$result=array();
			$addrList=array();
			foreach ($addrID as $val) {
				$addrList[$this->getServerFromAddr($val)][]=$this->getIDFromAddr($val);
			}
			foreach ($addrList as $ID=>$aID) {
				$this->_aktserver=$ID;
				if ($this->_bind()) {
					$filter='(|(entryUUID='.implode(')(entryUUID=',$this->ldapEsc($aID)).'))';
					$sr=$this->_search($this->_servers[$ID]->getMeta('BaseDN'), $filter, $fields,1);
					if ($sr) {
						$entry = ldap_get_entries($this->_ds[$ID], $sr);
						if ($entry['count']) {
							if ($raw) {
								return $this->utf8decode($entry);
							} else {
								$count=$entry['count'];
								unset($entry['count']);

								$entry=array_map(array($this,'addServerID'),$entry);
								for ($i=0;$i<$count;$i++) {
									$result[$ID.'$'.$entry[$i]['entryuuid'][0]]=new AObj_addr($ID.'$'.$entry[$i]['entryuuid'][0],$this->parseAddrEntry($entry[$i]));
								}
							}
						}
					}
				}
			}
			return $result;
		} elseif ($addrID) {
			$ID=$this->_aktserver=$this->getServerFromAddr($addrID);
			$aID=$this->getIDFromAddr($addrID);
			//debug($ID);
			$filter='(entryUUID='.$this->ldapEsc($aID).')';
			if ($this->_bind()) {
				$sr=$this->_search($this->_servers[$ID]->getMeta('BaseDN'), $filter, $fields,1);
				if ($sr) {
					$entry = ldap_get_entries($this->_ds[$ID], $sr);
					if ($entry['count']) {
						//debug($entry[0]);
						if ($raw) {
							return $this->utf8decode($entry[0]);
						} else {
							unset($entry['count']);
							$entry=array_map(array($this,'addServerID'),$entry);
							return new AObj_addr($ID.'$'.$entry[0]['entryuuid'][0],$this->parseAddrEntry($entry[0]));
						}
					}
				}
			}
		}

		return false;
	}

	function getAddrParent($dn) {
		$ID=$this->_aktserver;
		$result=array($this->getDnParent($dn));
		$fields=array('aliasedObjectName');
		if ($this->_bind()) {
			$filter='(aliasedObjectName='.$this->ldapEsc($dn).')';
			$sr=$this->_search($this->_servers[$ID]->getMeta('BaseDN'), $filter, $fields,1);
			if ($sr) {
				$entrys = ldap_get_entries($this->_ds[$ID], $sr);
				for ($i=0;$i<$entrys['count'];$i++) {
					$result[]=$this->getDnParent($this->utf8decode($entrys[$i]['dn']));
				}
			}
		}
		return $result;
	}
	function _formatSearchLdap(&$search,$setID=0) {
		if (is_array($search[$setID]['field'])) {
			$searchQuery=array();
			foreach ($search[$setID]['field'] as $fieldID=>$fieldVal) {
				$Typ='';
				switch ($fieldVal['typ']) {
					case 'addr':
					case 'crm':
					case 'int':
							$noEnc=false;
							$matchTyp='';
							switch ($fieldVal['mode']) {
								case 'lk':
									$Typ='=';
									if (!$fieldVal['value']) $Typ='';
									$fieldVal['value']='*'.$this->ldapEsc($fieldVal['value']).'*';
									$noEnc=true;
									//$matchTyp=':caseExactMatch:';
								break;
								case 'nlk':
									$Typ='!=';
									if (!$fieldVal['value']) $Typ='';
									$fieldVal['value']='*'.$this->ldapEsc($fieldVal['value']).'*';
									$noEnc=true;
									//$matchTyp=':caseIgnoreSubstringsMatch:';
								break;
								case 'is':
									$Typ='=';
									//$matchTyp=':dn:';
								break;
								case 'nis':
									$Typ='!=';
								break;
								case 'em':
									$Typ='=';
									$fieldVal['value']='';
								break;
								case 'nem':
									$Typ='!=';
									$fieldVal['value']='';
								break;
								case 'gt':
									$Typ='>=';
								break;
								case 'lt':
									$Typ='<=';
								break;

							}
							if ($Typ) {
								if ($fieldVal['key']=='all') {
									$Field=$this->_addrFieldsToLdap($this->getSearchFields());
									$Val=$fieldVal['value'];
								} else {
									//debug($this->getFieldData($fieldVal['key'],'Typ',1));
									$Field=$this->_addrFieldsToLdap($fieldVal['key']);
									switch ($this->getFieldData($fieldVal['key'],'Typ',1)) {

										case 'chk':
										case 'check':
											if ($fieldVal['value']=='Y') {
												$Val=1;
											} elseif ($fieldVal['value']=='N') {
												$Val=-1;
											} else {
												if ($Typ=='!=') {
													$Val='';
												} else {
													$Val='*';
													$Typ='!=';
													$noEnc=true;
												}
											}
										break;
										case 'num':
										case 'int':
											$Val=floatval(trim($fieldVal['value']));
										break;
										case 'date':
											$Val=Framework::parseDate($fieldVal['value'],0,0,0,true);
											if ($Typ=='>=') {
												$Val=gmdate('YmdHis\Z',Framework::parseDate($fieldVal['value'],0,0,0,true));
											}
											if ($Typ=='<=') {
												$Val=gmdate('YmdHis\Z',Framework::parseDate($fieldVal['value'],23,59,59,true));
											}
											if ($Typ=='=' || $Typ=='!=') {
												$Val=gmdate('YmdHis\Z',Framework::parseDate($fieldVal['value'],0,0,0,true));
												$Val2=gmdate('YmdHis\Z',Framework::parseDate($fieldVal['value'],23,59,59,true));
												if ($Val) {
													if ($Typ=='!=') {
														$Val='('.$Field.'<='.$this->ldapEsc($Val).')('.$Field.'>='.$this->ldapEsc($Val2).')';
														$Typ='|';

													} else {
														$Val='('.$Field.'>='.$this->ldapEsc($Val).')('.$Field.'<='.$this->ldapEsc($Val2).')';
														$Typ='&';
													}
													$Field='';
													$noEnc=true;
												}
											}
											if (!$Val) $Typ='';
										break;
										case 'unixdate':
											if ($Typ=='>=') {
												$Val=Framework::parseDate($fieldVal['value'],0,0,0,true);
											}
											if ($Typ=='<=') {
												$Val=Framework::parseDate($fieldVal['value'],23,59,59,true);
											}
											if ($Typ=='=' || $Typ=='!=') {
												$Val=Framework::parseDate($fieldVal['value'],0,0,0,true);
												$Val2=Framework::parseDate($fieldVal['value'],23,59,59,true);
												if ($Val) {
													if ($Typ=='!=') {
														$Val='('.$Field.'<='.$this->ldapEsc($Val).')('.$Field.'>='.$this->ldapEsc($Val2).')';
														$Typ='|';

													} else {
														$Val='('.$Field.'>='.$this->ldapEsc($Val).')('.$Field.'<='.$this->ldapEsc($Val2).')';
														$Typ='&';
													}
													$Field='';
													$noEnc=true;
												}
											}
											if (!$Val) $Typ='';
										break;
										default:
											$Val=trim((string)$fieldVal['value']);
											if (!strlen($Val)) {
												if ($Typ=='!=') {
													$Val='*';
													$Typ='=';
													$noEnc=true;
												} elseif ($Typ=='=') {
													$Val='*';
													$Typ='!=';
													$noEnc=true;
												}
											}
										break;
									}
								}
								if ($Typ) {
									if (!$noEnc) {
										$Val=$this->ldapEsc($Val);
									}
									if (is_array($Field)) {
										$tmp=array();
										foreach ($Field as $val) {
											if ($Typ=='!=') {
												$tmp[]='(!('.$val.$matchTyp.'='.$Val.'))';
											} else {
												$tmp[]='('.$val.$matchTyp.$Typ.$Val.')';
											}
										}
										$searchQuery[]='(|'.implode('',$tmp).')';
									} else {
										if ($Typ=='!=') {
											$searchQuery[]='(!('.$Field.$matchTyp.'='.$Val.'))';
										} else {
											$searchQuery[]='('.$Field.$matchTyp.$Typ.$Val.')';
										}
									}
								}
							}
					break;
					case 'grp':
						$subQuery=$this->_formatSearchSql($search,$fieldVal['value']);
						if ($subQuery) {
							$searchQuery[]=$subQuery;
						}
					break;
					case 'cat':
						$catObjs=array();
						if (trim($fieldVal['value'])) {
							$tmpIds=explode('|',$fieldVal['value']);
							foreach ($tmpIds as $val) {
								$tmpObj=$this->getObj(substr($val,2));
								if (is_object($tmpObj)) {
									$catObjs[$tmpObj->getID()]=$tmpObj;
								}
							}
							//debug($caTObjs);
							//entryDN
							if ($fieldVal['rec']) {
								//$catIds=array_merge($catIds,$this->getSubNodeIDs($catIds));

							}
							if (!empty($catObjs)) {
								switch ($fieldVal['mode']) {
									case 'is':
										$tmp=array();
										foreach ($catObjs as $val) {
											$tmp[]='(dn='.$this->ldapEsc($val->getMeta('_DN')).')';
										}
										if (count($tmp)>1) {
											$searchQuery[]='(|'.implode('',$tmp).')';
										} else {
											$searchQuery[]=$tmp[0];
										}
									break;
										$tmp=array();
										foreach ($catObjs as $val) {
											$tmp[]='(dn!='.$this->ldapEsc($val->getMeta('_DN')).')';
										}
										if (count($tmp)>1) {
											$searchQuery[]='(&'.implode('',$tmp).')';
										} else {
											$searchQuery[]=$tmp[0];
										}
									break;
								}
							}
						}
					break;
				}
			}
			if (!empty($searchQuery)) {
				if (count($searchQuery)>1) {
					if ($search[$setID]['mode']=='and') {
						return '(&'.implode('',$searchQuery).')';
					} else {
						return '(|'.implode('',$searchQuery).')';
					}
				} else {
					return $searchQuery[0];
				}

			}
		}
	}
	function &searchAddr($b=0,$order='',$search=array(),$all=false,$fields=null) {
		//debug($search);
		$result=array();
		//$time_b=Framework::getmicrotime();
		if (!$fields || empty($fields)) {
			if ($all) {
				$fields=array_keys($this->getFields());
			} else {
				$fields=$this->getlistFields();
			}
			if (!in_array('Name',$fields)) $fields[]='Name';
			if (!in_array('Vorname',$fields)) $fields[]='Vorname';
			if (!in_array('Nachname',$fields)) $fields[]='Nachname';
			if (!in_array('Firma',$fields)) $fields[]='Firma';
			if (!in_array('EMail',$fields)) $fields[]='EMail';
			if (!in_array('Mobil',$fields)) $fields[]='Mobil';
		}
		$ld_fields=$this->_addrFieldsToLdap($fields);
		//debug($ld_fields);
		$ld_fields[]='entryUUID';
		$ld_fields[]='modifyTimestamp';
		$ld_basedn=array();
		$ld_search=array();
		$ld_search[]='(objectClass=inetOrgPerson)';
		$ld_search_server=array();
		$searchBase=array();
		if ($search['search']) {
			$tmpSearch=$this->_formatSearchLdap($search['search']);
			if (empty($tmpSearch) && empty($search['ServerParent'])) {
				$search['searchSub']=0;
			} else {
				$search['searchSub']=1;
				$ld_search[]=$tmpSearch;
			}
		}
		if ($search['info']) {
			$info_array=explode(' ',$search['info']);
			foreach ($info_array as $info) {
				$tmp=array();
				foreach ($this->_addrFieldsToLdap($this->getSearchFields()) as $val) {
					$tmp[]='('.$val.'=*'.$this->ldapEsc(trim($info)).'*)';
				}
				$ld_search[]='(|'.implode('',$tmp).')';
			}

		}
		if (strlen($search['navInfo'])) {
			if (is_array($order)) {
				reset($order);
				$navInfoF=$this->_addrFieldsToLdap(key($order));
			} else {
				$navInfoF='displayName';
			}
			$ld_search[]='('.$navInfoF.'='.$this->ldapEsc(trim($search['navInfo'])).'*)';
		}
		//debug($ld_search);
		if ($search['server']) {
			if (is_array($search['server'])) {
				$servers=$search['server'];
			} else {
				$servers=array($search['server']);
				if ($search['parent']) {
					$searchBase[$search['server']][]=$search['parent'];
				}
			}
		} else {
			$servers=array_keys($this->_servers);
		}
		if (is_array($search['ServerParent'])) {
			foreach ($search['ServerParent'] as $key=>$val) {
				//debug($key);
				$searchBase[$key]=$val;
			}
			$servers=array_keys($searchBase);
		}
		if (is_array($search['AddrID'])) {
			if (empty($search['AddrID'])) return $result;
			$addrList_tmp=array();
			foreach ($search['AddrID'] as $val) {
				$addrList_tmp[$this->getServerFromAddr($val)][]=$this->getIDFromAddr($val);
			}
			$servers=array_keys($addrList_tmp);
			foreach ($addrList_tmp as $key=>$val) {
				$ld_search_server[$key][]='(|(entryUUID='.implode(')(entryUUID=',$this->ldapEsc($val)).'))';
			}
		}
		$entrys=array();
		$this->_clearMyMerge();
		if ($search['searchSub']) {
			$sub=1;
		} else {
			$sub=0;
		}
		foreach ($servers as $skey) {
			//debug($skey);
			$this->setAktServer($skey);
			$ID=$this->_aktserver;
			//$time[]='SERVER:'.$ID;
			if ($this->_bind()) {
				//debug($searchBase[$ID]?$searchBase[$ID]:$this->_servers[$ID]->getMeta('BaseDN'));
				//$time[]=Framework::getmicrotime()-$time_b;
				$akt_search=implode('',$ld_search);
				if ($ld_search_server[$skey]) $akt_search.=implode('',$ld_search_server[$skey]);
				if (!$searchBase[$ID]) $searchBase[$ID][]=$this->_servers[$ID]->getMeta('BaseDN');
				foreach ($searchBase[$ID] as $bases) {
					//debug('Server:'.$bases.' : (&'.$akt_search.')');
					//debug($akt_search);
					//debug($ld_fields);
					$sr=$this->_search($bases,'(&'.$akt_search.')',$ld_fields,$sub,LDAP_DEREF_SEARCHING);
					//$time[]='b'.(Framework::getmicrotime()-$time_b);
					$tmp_entrys=ldap_get_entries($this->_ds[$ID],$sr);
					@ldap_free_result ($sr);
					//unset($tmp_entrys['count']);
					//debug($tmp_entrys);
					$this->_myMerge($entrys,$tmp_entrys,$ID);
					unset($tmp_entrys);
				}
				//$time[]='e'.(Framework::getmicrotime()-$time_b);
			}
		}
		unset($entrys['count']);
		$rows=count($entrys);
		$this->setRows($rows);
		//$time[]=Framework::getmicrotime()-$time_b;
		if (is_array($order)) {
			$this->_sort=array();
			foreach ($order as $key=>$val) {
				$this->_sort[strtolower($this->_addrFieldsToLdap($key))]=$val;
			}
			//debug($this->_sort);
			usort($entrys,array($this,'cmp'));
		}
		//debug($this->_sort);
		while ($b>=$rows) {
			$b-=$this->getLimit();
			if ($b<=0) {
				$b=0;
				break;
			}
		}
		if ($this->getLimit()) $limit=$b+$this->getLimit(); else $limit=$rows;
		if ($limit>$rows) $limit=$rows;
		for ($i=$b;$i<$limit;$i++) {
			if (isset($entrys[$i])) {
				$result[$entrys[$i]['_serverID'].'$'.$entrys[$i]['entryuuid'][0]]=new AObj_addr($entrys[$i]['_serverID'].'$'.$entrys[$i]['entryuuid'][0],$this->parseAddrEntry($entrys[$i]));

			}
		}
		//$time[]=Framework::getmicrotime()-$time_b;
		//debug($time);
		//debug($sfields);
		return $result;
	}
	function _clearMyMerge() {
		$this->_cachedID=array();
	}
	function _myMerge(&$entrys,$new_entrys,$addServerID) {
		for ($i=0;$i<$new_entrys['count'];$i++) {
			if (!isset($this->_cachedID[$new_entrys[$i]['entryuuid'][0]])) {
				if ($addServerID) $new_entrys[$i]['_serverID']=$addServerID;
				$entrys[]=$new_entrys[$i];
				$this->_cachedID[$new_entrys[$i]['entryuuid'][0]]=1;
			}
		}
	}
	function addServerID($val) {
		$val['_serverID']=$this->_aktserver;
		return $val;
	}
	function parseAddrEntry(&$entry) {
		for ($i=0;$i<$entry['count'];$i++) {
			$key=$entry[$i];
			if (isset($this->_ldapToAddr[$key])) {
				if ($this->getFieldData($this->_ldapToAddr[$key],'LdapMulti')) {
					for ($j=0;$j<$entry[$key]['count'];$j++) {
						$result[$this->_ldapToAddr[$key]][]=$entry[$key][$j];
					}
					$result[$this->_ldapToAddr[$key]]=$this->utf8decode($this->AddrImplode($result[$this->_ldapToAddr[$key]]));
				} else {
					$result[$this->_ldapToAddr[$key]]=$this->utf8decode($entry[$key][0]);
				}
			}
		}
		if ($result['Firma']==$result['Nachname'] && !trim($result['Vorname'])) {
			$result['Nachname']='';
		}
		$result['_modifyTimestamp']=$entry['modifytimestamp'][0];
		$result['_DN']=$this->utf8decode($entry['dn']);
		$result['_serverID']=$entry['_serverID'];
		if ($this->_servers[$entry['_serverID']]->getMeta('isPrivat')) {
			$result['UserID']=$this->_uid;
		}
		//debug($result);
		return $result;
	}
	function updateAddrMeta(&$Obj,$setServer=0) {
		if (!trim($Obj->getMeta('Nachname')) && !trim($Obj->getMeta('Vorname')) && trim($Obj->getMeta('Firma'))) {
			$Obj->setMeta('Nachname',$Obj->getMeta('Firma'));
		}
		$DN=$Obj->getMeta('_DN');
		$oldData=$this->getAddrObj($Obj->getID(),true);
		$oldParent=$this->getAddrParent($DN);
		$newParent=$Obj->getMeta('ParentID');
		$Rdn=$this->getDnEntry($DN);
		$RdnField=substr($Rdn,0,strpos($Rdn,'='));
		$parentRdn=$this->getDnParent($DN);
		$newParentRdn=$parentRdn;
		if ($setServer) {
			$this->setAktServer($setServer);
		}
		if ($this->_bind()) {
			$ldap_del=array();
			foreach ($this->_addr_classes as $val) {
				if (in_array($val,$oldData['objectclass']) || in_array(strtolower($val),$oldData['objectclass'])) {
					$ldap_del = $ldap_del + $this->_getObjectDeleteAddr($this->_aktserver,$val,$Obj->_meta,$oldData);
				}
			}
			$ldap_add=array();
			foreach ($this->_addr_classes as $val) {
				if (!in_array($val,$oldData['objectclass']) && !in_array(strtolower($val),$oldData['objectclass'])) {
					$ldap_add['objectClass'][]=$val;
				}
				$ldap_add = $ldap_add + $this->_getObjectAddAddr($this->_aktserver,$val,$Obj->_meta,$oldData);
			}

			$ldap_rep=array();
			foreach ($this->_addr_classes as $val) {
				if (in_array($val,$oldData['objectclass']) || in_array(strtolower($val),$oldData['objectclass'])) {
					$ldap_rep = $ldap_rep + $this->_getObjectReplaceAddr($this->_aktserver,$val,$Obj->_meta,$oldData);
				}
			}
			if (!is_array($oldData[$this->_idField])) {
				$ldap_add[$this->_idField]=$this->_formatID($Obj->_meta);
			} else {
				$newID=$this->_formatID($Obj->_meta);
				if ($oldData[$this->_idField][0]!=$newID) {
					$ldap_rep[$this->_idField]=$newID;
				}
			}
			if ($this->_idField!='cn' && !is_array($oldData['cn'])) {
				if ($RdnField!='cn') {
					$ldap_add['cn']=$this->_formatCN($Obj->_meta);
				} else {
					$ldap_add['cn']=substr($Rdn,strpos($Rdn,'=')+1);
				}
			} elseif ($this->_idField!='cn' && $oldData['cn'][0]!=$this->_formatCN($Obj->_meta)) {
				if ($RdnField!='cn') {
					$ldap_rep['cn']=$this->_formatCN($Obj->_meta);
				} else {
					//$ldap_rep['cn']=substr($Rdn,strpos($Rdn,'=')+1);
				}
			}
			$ldap_ren='';
			$ldap_ren_del=true;
			if ($RdnField!=$this->_idField  || ($ldap_rep[$this->_idField] && (!is_array($oldData[$this->_idField]) || !in_array($ldap_rep[$this->_idField],$oldData[$this->_idField])))) {
				$ldap_ren=$ldap_rep[$this->_idField];
				if ($RdnField==$this->_idField) {
					unset($ldap_rep[$this->_idField]);
				} else {
					$ldap_ren_del=false;
				}
				//if ($this->_idField=='uid') $ldap_del['uid']=array();
			}
			if (!in_array($parentRdn,$newParent)) {
				$newParentRdn=reset($newParent);
				if (!$ldap_ren) {
					$ldap_ren=$Rdn;
				}
			}
			//debug($ldap_ren);

			$no_error=true;
			//$ldap_del=array('facsimileTelephoneNumber'=>array());
			//debug($ldap_del);
			if ($no_error && !empty($ldap_del) && $this->_bind()) {
				$no_error=$this->_mod_del($DN, $ldap_del);
				//debug($this->getError());
			}
			//debug($ldap_add);
			if ($no_error && !empty($ldap_add) && $this->_bind()) {
				$no_error=$this->_mod_add($DN, $ldap_add);
				//debug($this->getError());
			}
			//debug($ldap_rep);
			if ($no_error && !empty($ldap_rep) && $this->_bind()) {
				//echo $DN;
				$no_error=$this->_mod_rep($DN, $ldap_rep);
			}
			//debug($ldap_ren);
			$nDN=$DN;

			//debug($this->getAddrObjByDN($DN,true));

			if ($no_error && $ldap_ren) {
				//echo "www";
				$no_error=$this->_rename($DN,$this->_idField.'='.$this->ldapEscDN($ldap_ren),$newParentRdn,$ldap_ren_del);
				if ($no_error) {
					$nDN=$this->_idField.'='.$this->ldapEscDN($ldap_ren).','.$newParentRdn;
					$Obj->setMeta('_DN',$nDN);
				}
			}
			//debug($DN);
			if ($no_error) {
				$aliases=$this->getAliasedObjects($DN);
				foreach ($aliases as $val) {
					//debug('DEL:'.$val);
					$this->_del($val);
				}
				foreach ($newParent as $val) {
					if ($val!=$newParentRdn) {
						$nRdn=$this->getDnEntry($nDN);
						$nRdnField=substr($nRdn,0,strpos($nRdn,'='));
						$nRdnValue=substr($nRdn,strpos($nRdn,'=')+1);
						$ldap_add=array(
							'objectClass'=>array('alias','extensibleObject'),
							'aliasedObjectName'=>$nDN,
							$nRdnField=>$this->ldapUnEscDN($nRdnValue),
						);
						//debug('ADD:'.$nRdn.','.$val);
						//debug($ldap_add);
						$this->_add($nRdn.','.$val,$ldap_add);
						//debug($this->getError());
					}

				}
				return false;
			}
		}
		return array('server',$this->getError());
	}
	function deleteAddrMeta(&$Obj) {
		$ID=$this->_aktserver=$this->getServerFromAddr($Obj->getID());
		if ($this->_bind()) {
			$DN=$Obj->getMeta('_DN');
			$aliases=$this->getAliasedObjects($DN);
			foreach ($aliases as $val) {
				//debug('DEL:'.$val);
				$this->_del($val);
			}
			if ($this->_del($DN)) {
				return false;
				$this->deleteLog(0,$ID);
			}
		}
		return array('server',$this->getError());
	}
	function insertAddrMeta(&$Obj) {
		if (!trim($Obj->getMeta('Nachname')) && !trim($Obj->getMeta('Vorname')) && trim($Obj->getMeta('Firma'))) {
			$Obj->setMeta('Nachname',$Obj->getMeta('Firma'));
		}
		$oldData=array();
		$newParent=$Obj->getMeta('ParentID');
		$newParentRdn=reset($newParent);
		$RdnField=$this->_idField;
		/*$DN=$RdnField.'='.$this->ldapEscDN($this->_formatCN($Obj->_meta)).','.$newParentRdn;
		if ($oldObj=$this->getAddrObjByDN($DN)) {
			$Obj->setID($oldObj->getID());
			$Obj->setMeta('_DN',$oldObj->getMeta('_DN'));
			//debug($oldObj);
			//debug($Obj);
			return  $this->updateAddrMeta($Obj);
		};*/


		if ($this->_bind()) {
			$ldap_add=array();
			foreach ($this->_addr_classes as $val) {
				$ldap_add['objectClass'][]=$val;
				$ldap_add = $ldap_add + $this->_getObjectAddAddr($this->_aktserver,$val,$Obj->_meta,$oldData);
			}
			$ldap_add[$RdnField]=$this->_formatID($Obj->_meta,true);
			if ($RdnField!='cn') $ldap_add['cn']=$this->_formatCN($Obj->_meta);
			$DN=$RdnField.'='.$this->ldapEscDN($ldap_add[$RdnField]).','.$newParentRdn;
			$no_error=true;
			if ($no_error && !empty($ldap_add) && $this->_bind()) {
				//debug($ldap_add);
				$no_error=$this->_add($DN, $ldap_add);
			}
			if ($no_error) {
				foreach ($newParent as $val) {
					if ($val!=$newParentRdn) {
						$nRdn=$this->getDnEntry($DN);
						$nRdnField=substr($nRdn,0,strpos($nRdn,'='));
						$nRdnValue=substr($nRdn,strpos($nRdn,'=')+1);
						$ldap_add=array(
							'objectClass'=>array('alias','extensibleObject'),
							'aliasedObjectName'=>$DN,
							$nRdnField=>$this->ldapUnEscDN($nRdnValue),
						);
						//debug('ADD:'.$nRdn.','.$val);
						//debug($ldap_add);
						//$this->_add($nRdn.','.$val,$ldap_add);
						//debug($this->getError());
					}

				}
			}
			if ($no_error) {
				$Obj=$this->getAddrObjByDN($DN);
				if ($Obj) {
					return false;
				}
			}

		}
		return array('server',$this->getError());
	}
	function getAliasedObjects($dn) {
		$result=array();
		$ID=$this->_aktserver;
		if ($this->_bind()) {
			$fields=array($this->_idField);
			$filter='(aliasedObjectName='.$this->ldapEsc($dn).')';
			$sr=$this->_search($this->_servers[$ID]->getMeta('BaseDN'), $filter, $fields,1);
			if ($sr) {
				$entrys=ldap_get_entries($this->_ds[$ID], $sr);
				for ($i=0;$i<$entrys['count'];$i++) {
					$result[]=$this->utf8decode($entrys[$i]['dn']);
				}
			}
		}
		return $result;
	}

	function cmp($a, $b) {
		foreach ($this->_sort as $key=>$val) {
			$res=strnatcasecmp($a[$key][0],$b[$key][0]);
			$res=$res*$val;
			if ($res) break;
		}
		return $res;
	}
	function _addrFieldsToLdap($fields) {
		if (is_array($fields)) {
			$result=array();
			foreach ($fields as $val) {
				if ($this->getFieldData($val,'Ldap')) {
					$result[]=$this->getFieldData($val,'Ldap');
				}
			}
			return $result;
		} else {
			$result='';
			if ($this->getFieldData($fields,'Ldap')) {
				$result=$this->getFieldData($fields,'Ldap');
			}
			return $result;
		}
	}

	function _formatID($data,$new=false) {
		//debug($data);
		if ($data['_DN'] && !$new) {
			$Rdn=$this->getDnEntry($data['_DN']);
			$RdnField=substr($Rdn,0,strpos($Rdn,'='));
			$RdnValue=substr($Rdn,strpos($Rdn,'=')+1);
			if ($RdnField==$this->_idField && $RdnValue) {
				//debug($RdnValue);
				return $RdnValue;
			}
		}
		$id='group-e-'.$this->_db->nextid('LdapAddr');

		return $id;

		/*
		$cn=trim($data['Firma']);
		if ($cn) $cn.=' - ';
		if (trim($data['Vorname'])) $cn.=trim($data['Vorname']).' - ';
		$cn.=trim($data['Nachname']);
		if (function_exists('mb_strtolow')) {
			return $this->replaceAllowedChar(mb_strtolower($cn,GE_CHARSET),'n');
		} else {
			return $this->replaceAllowedChar(strtolower($cn),'n');
		}*/
	}
	function _formatCN($data) {
		$cn=trim($data['Firma']);
		if ($cn) $cn.=' - ';
		if (trim($data['Vorname'])) $cn.=trim($data['Vorname']).' - ';
		$cn.=trim($data['Nachname']);
		if (function_exists('mb_strtolow')) {
			return $this->replaceAllowedChar(mb_strtolower($cn,GE_CHARSET),'n');
		} else {
			return $this->replaceAllowedChar(strtolower($cn),'n');
		}
	}

	function _getObjectDeleteAddr($aktServer,$objClass,&$newData,&$oldData) {
		$ldap_del=array();
		foreach ($this->getFields() as $FieldID=>$FieldVal) {
			if ($FieldVal['LdapClass']==$objClass) {
				$newData[$FieldID]=trim($newData[$FieldID]);
				if (is_array($FieldVal['Config']['LdapServer']) && !in_array($aktServer,$FieldVal['Config']['LdapServer'])) {
					unset($newData[$FieldID]);
					//debug('unset:'.$FieldVal['Ldap']);
				}
				$LdapID=$FieldVal['Ldap'];
				$LdapIDold=strtolower($FieldVal['Ldap']);
				if ($LdapID=='facsimileTelephoneNumber') {
					if (isset($oldData[$LdapIDold])) $ldap_del[$LdapID]=array();
				} elseif ($FieldVal['LdapMulti'] && isset($oldData[$LdapIDold]) ) {
					$dataArray=$this->AddrExplode($newData[$FieldID]);
					for ($i=0;$i<$oldData[$LdapIDold]['count'];$i++) {
						if (!in_array($oldData[$LdapIDold][$i],$dataArray)) {
							$ldap_del[$LdapID][]=$oldData[$LdapIDold][$i];
						}
					}
				} else {
					if (!strlen($newData[$FieldID]) && isset($oldData[$LdapIDold])) {
						$ldap_del[$LdapID]=$oldData[$LdapIDold][0];
					}
				}
			}
		}
		return $ldap_del;
	}


	function _getObjectReplaceAddr($aktServer,$objClass,&$newData,&$oldData) {
		$ldap_add=array();
		foreach ($this->getFields() as $FieldID=>$FieldVal) {
			if ($FieldVal['LdapClass']==$objClass) {
				if (is_array($FieldVal['Config']['LdapServer']) && !in_array($aktServer,$FieldVal['Config']['LdapServer'])) continue;
				$LdapID=$FieldVal['Ldap'];
				$LdapIDold=strtolower($FieldVal['Ldap']);
				$newData[$FieldID]=trim($newData[$FieldID]);
				if (strlen($newData[$FieldID])) {
					//echo $oldData[$LdapIDold][0].'-'.$newData[$FieldID].'<br>';
					if (!$FieldVal['LdapMulti'] && isset($oldData[$LdapIDold]) && $oldData[$LdapIDold][0]!=$newData[$FieldID]) {
						$ldap_add[$LdapID]=$newData[$FieldID];
					}
				}
			}
		}
		return $ldap_add;
	}
	function _getObjectReplace($objClass,&$newData,&$oldData) {
		$ldap_add=array();
		switch ($objClass) {
			case 'organizationalUnit':
				if (isset($newData['Text']) && isset($oldData['description']) && $oldData['description'][0]!=$newData['Text']) $ldap_add['description']=$newData['Text'];
				if (isset($newData['Title']) && isset($oldData['ou']) && $oldData['ou'][0]!=$newData['Title']) $ldap_add['ou']=$newData['Title'];
			break;

		}
		return $ldap_add;
	}

	function _getObjectAddAddr($aktServer,$objClass,&$newData,&$oldData) {
		$ldap_add=array();
		foreach ($this->getFields() as $FieldID=>$FieldVal) {
			if ($FieldVal['LdapClass']==$objClass) {
				if (is_array($FieldVal['Config']['LdapServer']) && !in_array($aktServer,$FieldVal['Config']['LdapServer'])) continue;
				$LdapID=$FieldVal['Ldap'];
				$LdapIDold=strtolower($FieldVal['Ldap']);
				$newData[$FieldID]=trim($newData[$FieldID]);
				if (strlen($newData[$FieldID])) {
					if ($FieldVal['LdapMulti']) {
						$dataArray=$this->AddrExplode($newData[$FieldID]);
						foreach ($dataArray as $dataVal) {
							if (!empty($dataVal) && (!isset($oldData[$LdapIDold]) || !in_array($dataVal,$oldData[$LdapIDold]) || $FieldID=='Fax')) {
								$ldap_add[$LdapID][]=$dataVal;
							}
						}
					} else {
						if (!isset($oldData[$LdapIDold]) || $LdapID=='facsimileTelephoneNumber') {
							$ldap_add[$LdapID]=$newData[$FieldID];
						}
					}
				}
			}
		}
		return $ldap_add;
	}
	function _getObjectAdd($objClass,&$newData,&$oldData) {
		$ldap_add=array();
		switch ($objClass) {
			case 'organizationalUnit':
				if (isset($newData['Text']) && !isset($oldData['description'])) $ldap_add['description']=$newData['Text'];
				if (isset($newData['Title']) && !isset($oldData['ou'])) $ldap_add['ou']=$newData['Title'];
			break;

		}
		return $ldap_add;
	}

	function insertLog ($AddrID,$user,$text,$typ,$date=0) {
		$values=array(
			'FKAddressID'=>$AddrID,
			'FKUserID'=>$user,
			'Text'=>$text,
			'Type'=>$typ,
			'Date'=>($date?$date:time()),

		);
		$this->_db->insert('AddrLogLdap',$values);
	}
	function deleteLog($ID=0,$AddrID=0,$UserID=0) {
		if ($ID) $where[]="LogID=".$this->_db->escape($ID);
		if (is_array($AddrID)) $where[]="FKAddressID IN (".implode(",",$this->_db->escape($AddrID)).")";
		elseif ($AddrID) $where[]="FKAddressID=".$this->_db->escape($AddrID);
		if (is_array($UserID)) $where[]="FKUserID IN (".implode(",",$this->_db->escape($UserID)).")";
		elseif ($UserID) $where[]="FKUserID=".$this->_db->escape($UserID);
		if (is_array($where)) {
			$query="DELETE FROM AddrLogLdap WHERE ".implode(' AND ',$where);
			$this->_db->query($query);
		}

	}

	function listLog($AddrID,$typ='',$user='') {
		$result=array();
		$query="SELECT * FROM AddrLogLdap WHERE FKAddressID=".$this->_db->escape($AddrID)." ";
		if (is_array($typ)) $query.=" AND Type IN (".implode(",",$this->_db->escape($typ)).")";
		elseif ($typ) $query.=" AND Type=".$this->_db->escape($typ);
		if ($user) $query.=" AND FKUserID=".$this->_db->escape($user);
		$query.=' ORDER BY Date DESC';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("LogID")]=array(
				"Text"=>$this->_db->f("Text"),
				"Date"=>$this->_db->f("Date"),
				"User"=>$this->_db->f("FKUserID"),
				"Type"=>$this->_db->f("Type"),
			);
		}
		return $result;
	}



	function isAllowedAction(&$obj,&$action,$server=0) {
		if (!is_array($action)) return false;
		if (!$server) $server=$this->_aktserver;

		if (!is_object($this->_servers[$server]) || !$this->_servers[$server]->getAcl($action['Perms'])) return false;
		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkAction($obj,substr($ac_val,1));
				} else {
					$result=$result||$this->_checkAction($obj,$ac_val);
				}
			}
			if (!$result) return false;
		}
		return true;
	}
	function _checkAction(&$obj,$action) {

		switch ($action) {
			case 'sadmin':
				if (!$this->isSuperAdmin()) return false;
			break;
			case 'rule':
				if (!$this->isRuleUser()) return false;
			break;
			case 'root':
				if (is_object($obj) && $obj->getMeta('_DN')!=$this->_servers[$this->_aktserver]->getMeta('BaseDN')) return false;
			break;
			case 'content':
				if (is_object($obj) && $obj->getMeta('_hasSub')=='FALSE') return false;
			break;
			case 'app_msg':
				if (!$GLOBALS['app']['msg']) return false;
			break;
			case 'app_mail':
				if (!$GLOBALS['app']['email']) return false;
			break;
			case 'app_proj':
				if (!$GLOBALS['app']['proj'] || !$this->_P) return false;
			break;
			case 'act_proj':
				 if (!$this->_frm->getPrefs('proj','actualProject')) return false;
			break;
		}
		return true;
	}
	function isAllowedAddrAction(&$obj,&$action,$server=0) {
		if (!is_array($action)) return false;
		if (!$server) $server=$obj->getMeta('_serverID');
		if (!is_object($this->_servers[$server]) || !$this->_servers[$server]->getAcl($action['Perms'])) return false;
		//debug($action);
		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkAddrAction($obj,substr($ac_val,1),$server);
				} else {
					$result=$result||$this->_checkAddrAction($obj,$ac_val,$server);
				}
			}
			if (!$result) return false;
		}
		return true;
	}
	function _checkAddrAction(&$obj,$action,$server=0) {
	//debug($action);
		switch ($action) {
			case 'sadmin':
				if (!$this->isSuperAdmin()) return false;
			break;
			case 'rule':
				if (!$this->isRuleUser()) return false;
			break;
			case 'app_msg':
				if (!$GLOBALS['app']['msg']) return false;
			break;
			case 'app_mail':
				if (!$GLOBALS['app']['email']) return false;
			break;
			case 'app_proj':
				if (!$GLOBALS['app']['proj'] || !$this->_P) return false;
			break;
			case 'a_write':
				if (empty($this->_serversWrite)) return false;
			break;
			case 'user':
				if (!$this->_servers[$server]->getMeta('isPrivat')) return false;
			break;
			case 'act_proj':
				 if (!$this->_frm->getPrefs('proj','actualProject')) return false;
			break;
			case 'proj':
				if (!$this->_P || !$this->_frm->getPrefs('proj','actualProject')) return false;
				$av_proj=$this->getAddrProjects($obj);
				if (!in_array($this->_frm->getPrefs('proj','actualProject'),$av_proj)) return false;
			break;
		}
		return true;
	}

	function getImportFields () {
		$result=array();
		$query="SELECT ID,Name FROM AddrImport ORDER BY Name";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('ID')]=$this->_db->f('Name');
		}
		return $result;
	}
	function readImportFields($ID) {
		$query="SELECT I_Fields FROM AddrImport WHERE ID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record())
			return explode(',',$this->_db->f('I_Fields'));
		else
			return array();
	}
	function insertImportFields($Name,$Fields) {
		$query="SELECT max(ID) as num FROM AddrImport";
		$this->_db->query($query);
		$this->_db->next_record();
		$ID=$this->_db->f('num') + 1;
		$insert=array(
			'ID'=>$ID,
			'Name'=>$Name,
			'I_Fields'=>implode(',',$Fields),
		);
		$this->_db->insert('AddrImport',$insert);
		return $ID;
	}
	function updateImportFields($ID,$Name,$Fields) {
		$insert=array(
			'ID'=>$ID,
			'Name'=>$Name,
			'I_Fields'=>implode(',',$Fields),
		);
		$this->_db->insert('AddrImport',$insert,0,1);
	}
	function deleteImportFields($ID) {
		$query="DELETE FROM AddrImport ";
		$query.=" WHERE ID=".$this->_db->escape($ID);
		$this->_db->query($query);
	}


	function listAddrSelect($Type) {
		$result=array();
		$query="SELECT SelID,Name_".$this->_lang." FROM AddrSelect WHERE SelType=".$this->_db->escape($Type)." ORDER BY Sequence";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
				$result[$this->_db->f('SelID')]=$this->_db->f('Name_'.$this->_lang);
		}
		return $result;
	}
	function insertAddrSelect($Type,$Data) {
		$query="SELECT max(Sequence) as num FROM AddrSelect WHERE SelType=".$this->_db->escape($Type);
		$this->_db->query($query);
		$this->_db->next_record();
		$Data['Sequence']=$this->_db->f('num') + 1;
		$Data['SelType']=$Type;
		$Data['SelID']=$this->_db->nextid('AddrSelect_'.$Type);
		$this->_db->insert('AddrSelect',$Data,'',1);
		return $Data['SelID'];
	}
	function updateAddrSelect($Type,$ID,$Data) {
		$this->_db->update('AddrSelect',$Data ,'SelID='.$this->_db->escape($ID).' AND SelType='.$this->_db->escape($Type));
	}
	function readAddrSelect($Type,$ID,$lang) {
		$query="SELECT * FROM AddrSelect WHERE SelID=".$this->_db->escape($ID).' AND SelType='.$this->_db->escape($Type);
		$this->_db->query($query);
		$this->_db->next_record();
		foreach ($lang as $val) {
			$result['Name_'.$val]=$this->_db->f("Name_".$val);
		}
		$result['Sequence']=$this->_db->f("Sequence");
		return $result;
	}
	function deleteAddrSelect($Type,$ID=NULL) {
		$query="DELETE FROM AddrSelect WHERE SelType=".$this->_db->escape($Type);
		if (isset($ID)) $query.=" AND SelID=".$this->_db->escape($ID);
		$this->_db->query($query);
	}
	function switchAddrSelect ($Type,$oID,$dir='down') {
		$query="SELECT Sequence FROM AddrSelect WHERE SelType=".$this->_db->escape($Type)." AND SelID=".$this->_db->escape($oID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$oSequence=$this->_db->f('Sequence');
			if ($dir=='up'){
				$sign='<';
				$order='DESC';
			}elseif ($dir=='down') {
				$sign='>';
				$order='ASC';
			} elseif ($dir=='first') {
				$sign='<';
				$order='ASC';
			}
			$query="SELECT SelID,Sequence  FROM AddrSelect WHERE SelType=".$this->_db->escape($Type)." ";
			$query.="AND Sequence $sign ".intval($oSequence);
			$query.=" ORDER BY Sequence $order LIMIT 1";
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				$nID=$this->_db->f('SelID');
				$nSequence=$this->_db->f('Sequence');
				$query="UPDATE AddrSelect SET Sequence=".intval($nSequence)." WHERE SelType=".$this->_db->escape($Type)." ";
				$query.="AND SelID=".$this->_db->escape($oID);
				$this->_db->query($query);
				if ($dir=='first') {
					$query="UPDATE AddrSelect SET Sequence=Sequence+1 WHERE SelType=".$this->_db->escape($Type)." ";
					$query.="AND Sequence<$oSequence AND SelID!=".$this->_db->escape($oID);
					$this->_db->query($query);
				} else {
					$query="UPDATE AddrSelect SET Sequence=".intval($oSequence)." WHERE SelType=".$this->_db->escape($Type)." ";
					$query.="AND SelID=".$this->_db->escape($nID);
					$this->_db->query($query);
				}
			}
		}
	}
	function insertAddrFieldsList($FieldID) {
		$values=array(
			'FKFieldID'=>$FieldID,
			'FKUserID'=>$this->_uid,
		);
		$this->_db->insert('AddrFieldsList',$values,'',1);
	}
	function deleteAddrFieldsList($FieldID=0) {
		$query="DELETE FROM AddrFieldsList WHERE FKUserID=".$this->_db->escape($this->_uid);
		if ($FieldID) $query.=" AND FKFieldID=".$this->_db->escape($FieldID);
		$this->_db->query($query);
	}
	function deleteUser($uid) {
		$this->setLimit(0);
		$query="DELETE FROM AddrFieldsList WHERE FKUserID=".$this->_db->escape($uid);
		$this->_db->query($query);
	}

	function treeToJson(&$tree,$start,$prep='',$func='upCpF') {
			//debug($tree[$start]);
		foreach ($tree[$start] as $key=>$val) {
			$result.="[null,'".Framework::escapeJs($val->getName())."', ";
			$result.="'javascript:".$func."(\'".$prep.$val->getID()."\')'";
			if (is_array($tree[$val->getMeta('_DN')])) {
				$result.=', '."\n";
				$result.=$this->treeToJson($tree,$val->getMeta('_DN'),$prep);
			}
			$result.='],'."\n";
		}
		return $result;
    }

    /* For Export OF OLD*/
	function &_listAllTreeOld($rootID,$lang) {
		$result=array();
		$query="SELECT * FROM AddrNodeMetabase WHERE RootID=".intval($rootID)." AND Trash=0 AND System=''";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("ParentID")][$this->_db->f("NodeID")]=$this->_db->f("Title_".$lang);
		}
		return $result;
	}
	function &_listAllAddrOld($parentID) {
		$result=array();
		$query="SELECT * FROM AddrMeta,AddrParent WHERE AddressID=FKAddressID AND FKNodeID=".intval($parentID)." AND Trash=0";
		//if ($parentID=='336') debug($query);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			foreach (array_keys($this->_addrToLdap) as $val) {
				if (trim($this->_db->f($val))) {
					$result[$this->_db->f("AddressID")][$val]=$this->_db->f($val);
				}
			}
		}
		//if ($parentID=='336') debug(array_keys($result));
		return $result;
	}
	function exportOldAddressbook($baseDN,$userID,$lang) {
		$query="SELECT RootID FROM AddrNodeMetabase WHERE System!='' AND UserID=".intval($userID).' LIMIT 1';
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$rootID=$this->_db->f("RootID");
			$folderLdif=$this->_OldAddrToLdif($rootID,$baseDN);
			$folders=$this->_listAllTreeOld($rootID,$lang);
			$folderLdif.=$this->_OldfoldersToLdif($folders,$baseDN,$rootID);
		}
		return $folderLdif;
	}
	function _OldAddrToLdif($parentID,$baseDN) {
		static $parsed_addr;
		//debug($parentID.' - '.$baseDN);
		$result='';
		$Adresses=$this->_listAllAddrOld($parentID);
		$parsed_dn=array();
		foreach ($Adresses as $AddrID=>$meta) {
			if (!isset($parsed_addr[$AddrID])) {
				if (!trim($meta['Nachname'])) $meta['Nachname']='-';
				$id=$this->_formatID($meta);
				$DN=$this->_idField.'='.$this->ldapEscDN($id).','.$baseDN;
				if ($parsed_dn[$DN]) {
					$i=1;
					while($parsed_dn[$DN]) {
						$ncn=$id.' - '.$i;
						$DN=$this->_idField.'='.$this->ldapEscDN($ncn).','.$baseDN;
						$i++;
					}
					$id=$ncn;
				}

				$result.=$this->foldLine("dn: ".$this->utf8encode($DN))."\n";
				$result.=$this->foldLine("objectClass: inetOrgPerson")."\n";
				$result.=$this->foldLine("objectClass: mozillaOrgPerson")."\n";
				$result.=$this->foldLine($this->_idField.": ".$this->utf8encode($id))."\n";
				if ($this->_idField!='cn') $result.=$this->foldLine("cn: ".$this->utf8encode($this->_formatCN($meta)))."\n";
				foreach ($meta as $mkey=>$mval) {
					if ($this->_addrToLdap[$mkey] && trim($mval)) {
						$temp=$this->AddrExplode($mval);
						foreach ($temp as $subval) {
							$subval=trim($subval);
							if ($this->getFieldData($mkey,'AllowedChars') && !$this->isAllowedChar($subval,$this->getFieldData($mkey,'AllowedChars'))) {
								$subval=$this->replaceAllowedChar($subval,$this->getFieldData($mkey,'AllowedChars'));
							}
							if (nl2br($subval)!=$subval) {
								$result.=$this->foldLine($this->_addrToLdap[$mkey].":: ".base64_encode($this->utf8encode($subval)))."\n";
							} else {
								$result.=$this->foldLine($this->_addrToLdap[$mkey].": ".$this->utf8encode($subval))."\n";
							}
						}
					}
				}
				$parsed_addr[$AddrID]=array(
					$this->_idField=>$id,
					'dn'=>$DN,
				);
				$result.="\n";
				$parsed_dn[$DN]=1;
			} else {
				$DN=$this->_idField.'='.$this->ldapEscDN($parsed_addr[$AddrID][$this->_idField]).','.$baseDN;
				if (!$parsed_dn[$DN]) {
					$result.=$this->foldLine("dn: ".$this->utf8encode($DN))."\n";
					$result.=$this->foldLine("objectClass: alias")."\n";
					$result.=$this->foldLine("objectClass: extensibleObject")."\n";
					$result.=$this->foldLine($this->_idField.": ".$this->utf8encode($parsed_addr[$AddrID][$this->_idField]))."\n";
					$result.=$this->foldLine("aliasedObjectName: ".$this->utf8encode($parsed_addr[$AddrID]['dn']))."\n\n";
					$parsed_dn[$DN]=1;
				}
			}
		}
		return $result;
	}
	function _OldfoldersToLdif(&$tree,$baseDN,$start) {
		if (is_array($tree[$start])) {
			$result='';
			foreach ($tree[$start] as $key=>$val) {
				$DN='ou='.$this->ldapEscDN($val).','.$baseDN;
				$result.=$this->foldLine("dn: ".$this->utf8encode($DN))."\n";
				$result.=$this->foldLine("objectClass: organizationalUnit")."\n";
				$result.=$this->foldLine("ou: ".$this->utf8encode($val))."\n\n";
				$result.=$this->_OldAddrToLdif($key,$DN);
				if ($tree[$key]) {
					$result.=$this->_OldfoldersToLdif($tree,$DN,$key);
				}
			}
		}
		return $result;
	}
	function foldLine($value) {
		return $value;
		$len=mb_strlen ($value,GE_CHARSET);
		$chunks=ceil($len/75);
		if ($chunks>1) {
			$result=array();
			for ($i=0;$i<$chunks;$i++) {
				$result[]=mb_substr($value,$i*75,75,GE_CHARSET);
			}
			return implode("\n ",$result);
		} else {
			return $value;
		}
	}
	function getAddrProjects(&$AObj) {
		$result=array();
		$query="SELECT FKProjID FROM AddrParentProjectLdap WHERE FKAddressID=".$this->_db->escape($AObj->getID());
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('FKProjID');
		}
		return $result;
	}
	function hasProjectEntrys($projID) {
		$query = "SELECT FKAddressID FROM AddrParentProjectLdap ";
		$query.=" WHERE FKProjID=".$this->_db->escape($projID);
		$query.=" ".$this->_db->formatLimit(0,1);
		$this->_db->query($query);
		if($this->_db->next_record()) {
			return true;
		} else {
			return false;
		}
	}
	function getProjectsAddr($ID) {
		$result=array();
		$query="SELECT FKAddressID FROM AddrParentProjectLdap WHERE FKProjID=".$this->_db->escape($ID);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('FKAddressID');
		}
		return $result;
	}
	function setAddrProjects(&$AObj,$addrProj,$clear=1) {
		if ($clear) {
			$this->deleteAddrProjects($AObj);
		}
		if (is_array($addrProj) && !empty($addrProj)) {
			foreach ($addrProj as $val) {
				$this->_db->insert('AddrParentProjectLdap',array('FKAddressID'=>$AObj->getID(),'FKProjID'=>$val),'',1);
			}
		}
	}
	function deleteAddrProjects(&$AObj,$pojID=0) {
		$query="DELETE FROM AddrParentProjectLdap WHERE FKAddressID=".$this->_db->escape($AObj->getID());
		if ($pojID) $query.=" AND FKProjID=".$this->_db->escape($pojID);
		$this->_db->query($query);
	}
	function deleteProject($ID) {
		if ($ID) {
			$query = "SELECT FKAddressID FROM AddrParentProjectLdap WHERE FKProjID=".$this->_db->escape($ID);
			$this->_db->query($query);
			while ($this->_db->next_record()) {
				$delete[]=$this->_db->f('FKAddressID');
			}
			foreach ($delete as $val) {
				$query="DELETE FROM AddrParentProjectLdap WHERE FKAddressID=".$this->_db->escape($val);
				$query.=" AND FKProjID=".$this->_db->escape($ID);
				$this->_db->query($query);
			}
		}
	}
	function addProjectsAddr($projID,$addrIDs) {
		foreach ($addrIDs as $val) {
			$this->_db->insert('AddrParentProjectLdap',array('FKAddressID'=>$val,'FKProjID'=>$projID),'',1);
		}
	}
	function deleteProjectsAddr($projID,$addrIDs) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$projID);
		$searchQuery[]=array('Field'=>'FKAddressID','Typ'=>'=','Values'=>$addrIDs);
		$this->_db->delete('AddrParentProjectLdap',$searchQuery);
	}
    function entry2Value(&$fid,&$values,&$nowrap) {
		switch ($this->getFieldData($fid,'Typ')) {
			case 'text':
			case 'area':
				$nowrap=0;
			break;
			case 'select':
			case 'mselect':
				if (!isset($this->_cached_select_array[$fid])) {
					if (($this->getFieldData($fid,'FieldTyp')=='u')) {
						$this->_cached_select_array[$fid]=Framework::extractObjName($this->_BaseSelect->listSelect(substr($fid,2)));
					} else {
						$this->_cached_select_array[$fid]=$this->listAddrSelect($fid);
					}
				}
				foreach ($values as $vkey=>$vval) {
					$values[$vkey]=$this->_cached_select_array[$fid][$vval];
				}
			break;
			case 'date':
				foreach ($values as $vkey=>$vval) {
					$temp=$this->ldap2sqlDate($vval);
					if ($temp!='0000-00-00') $values[$vkey]=Framework::dateSql('d.m.Y',$this->ldap2sqlDate($vval));
				}
			break;
			case 'chk':
			case 'check':
				$select_array=array(1=>$this->_T->Lang('[[Ja]]'),-1=>$this->_T->Lang('[[Nein]]'),0=>'');
				foreach ($values as $vkey=>$vval) {
					$values[$vkey]=$select_array[$vval];
				}
			break;
			case 'int':
			case 'num':
				foreach ($values as $vkey=>$vval) {
					$values[$vkey]=str_replace('.',constDECIMAL,floatval($vval));
				}
			break;
			default:
				//debug($this->_Base->getFieldData($fid,'Typ'));
			break;
		}
    }
    function ldap2sqlDate($val) {
		if (!$val) return '0000-00-00';
		return substr($val,0,4).'-'.substr($val,4,2).'-'.substr($val,6,2).' '.substr($val,8,2).':'.substr($val,10,2).':'.substr($val,12,2);
    }
	function cleanNumber($val) {
		return preg_replace('/[^0-9]/','',str_replace('+','00',$val));
	}
}
?>
