<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class vCard extends Contact_Vcard_Parse {
	var $Fields=array();
	var $num_vCards=0;
	var $Card_num=0;
	var $Address=array();
	var $Pref_order=array('WORK'=>1,'HOME'=>2);
	var $Tel_typ=array('CELL'=>'CELL','FAX'=>'FAX', 'PAGER'=>'PAGER','WORK'=>'WORK','HOME'=>'HOME');
	function vCard($fields=0) {
		if ($fields) $this->loadFields($fields);
	}
	function setPrefs($prefs) {
		$this->_prefs=$prefs;
	}
	function loadFields($fields) {
		foreach ($fields as $key=>$val) {
			$tmp=explode('|',$val);
			foreach ($tmp as $cval) {
				$this->Fields[$cval]=$key;
			}
		}

	}
	function initvCard() {
		$this->num_vCards=0;
		$this->Card_num=0;
		$this->Address=array();
	}
	function parseFile($file) {
		$this->initvCard();
		$this->parseCardList($this->fromFile($file));

	}
	function parseText($text) {
		$this->initvCard();
		$this->parseCardList($this->fromText($text));

	}
	function parseCardList(&$obj) {
		$this->Address=array();
		$this->num_vCards=count($obj);
		//$this->debug($obj);
		foreach ($obj as $Card_num=>$Card) {
			$this->Card_num=$Card_num;
			$this->parseCard($Card);
		}

	}
	function parseCard(&$Card) {
		if (!$Card['N'] && !$Card['ORG'] && $Card['FN']) {
			$Card['ORG']=$Card['FN'];
		}
		foreach ($Card as $Typ=>$Content) {
			switch ($Typ) {
				case 'N':
					if (is_array($Content[0])) $this->parseName($Typ,$Content[0]);
					break;
				case 'ADR':
					$this->parseAddress($Typ,$Content);
					break;
				case 'TEL':
					$this->parseTel($Typ,$Content);
					break;
				case 'URL':
				case 'EMAIL':
					$this->parseMultiField($Typ,$Content);
					break;

				/*
				case 'BIRTHDAY':
					$this->parseBirthday($TYP,$Content);
					break;*/
				default:
					$this->parseSingleField($Typ,$Content);
					break;
			}
		}

	}
	function decode ($value,$enc=false) {
		if (!$enc) return $value;
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->decode($val,$enc);
			}
		} else  {
			if (!is_array($enc)) $enc=array($enc);
			foreach ($enc as $val) {
				switch (strtoupper($val)) {
					case 'QUOTED-PRINTABLE':
						$value=quoted_printable_decode($value);
						break;
					case 'BASE64':
						$value=base64_decode($value);
						break;
					default:
						$value=Framework::convertCharset($value,$val,GE_CHARSET);
						break;
				}
			}
		}
		return $value;
	}
	function parseName($Typ,&$Content) {
		$enc=false;
		if ($Content['param']['ENCODING'][0]) $enc[]=$Content['param']['ENCODING'][0];
		if ($Content['param']['CHARSET'][0]) $enc[]=$Content['param']['CHARSET'][0];
		foreach ($Content['value'] as $field=>$value) {
			if (isset($this->Fields['0:'.$Typ.':'.$field])) {
				$tmp_val=trim($this->decode($value[0],$enc));
				if (!strlen($tmp_val)) continue;
				$this->Address[$this->Card_num][$this->Fields['0:'.$Typ.':'.$field]][0]=$tmp_val;
			}
		}

	}
	function parseAddress($Typ,&$Content) {
		//$this->debug($Content);
		foreach ($Content as $key=>$val) {
			$enc=false;
			$ktyp=reset($this->Pref_order);
			if ($val['param']['ENCODING'][0]) $enc[]=$val['param']['ENCODING'][0];
			if ($val['param']['CHARSET'][0]) $enc[]=$val['param']['CHARSET'][0];
			if (is_array($val['param']['TYPE'])) {
				$val['param']['TYPE']=array_map('strtoupper',$val['param']['TYPE']);
				foreach ($this->Pref_order as $pkey=>$pval) {
					if (in_array($pkey,$val['param']['TYPE'])) {
						$ktyp=$pval;
						break;
					}
				}
			}
				//debug($val);
			foreach ($val['value'] as $field=>$value) {
				if (isset($this->Fields[$ktyp.':'.$Typ.':'.$field])) {
					$tmp_val=trim($this->decode($value[0],$enc));
					if (!strlen($tmp_val) || isset($this->Address[$this->Card_num][$this->Fields[$ktyp.':'.$Typ.':'.$field]])) continue;
					$this->Address[$this->Card_num][$this->Fields[$ktyp.':'.$Typ.':'.$field]][0]=$tmp_val;
				}
			}
		}
	}
	function parseTel($Typ,&$Content) {
		foreach ($Content as $key=>$val) {
			$enc=false;
			$ktyp='';
			if ($val['param']['ENCODING'][0]) $enc[]=$val['param']['ENCODING'][0];
			if ($val['param']['CHARSET'][0]) $enc[]=$val['param']['CHARSET'][0];
			if (is_array($val['param']['TYPE'])) {
				$val['param']['TYPE']=array_map('strtoupper',$val['param']['TYPE']);
				foreach ($this->Tel_typ as $pkey=>$pval) {
					if (in_array($pkey,$val['param']['TYPE'])) {
						$ktyp=$pval;
						break;
					}
				}
			}
			foreach ($val['value'] as $field=>$value) {
				if (isset($this->Fields['0:'.$Typ.':'.$ktyp])) {
					$tmp_val=$this->decode($value,$enc);
					foreach ($tmp_val as $cval) {
						if (!strlen($cval)) continue;
						$this->Address[$this->Card_num][$this->Fields['0:'.$Typ.':'.$ktyp]][]=$cval;
					}
				}
			}
		}
	}
	function parseMultiField($Typ,&$Content) {
		//$this->debug($Content);
		foreach ($Content as $key=>$val) {
			$enc=false;
			if ($val['param']['ENCODING'][0]) $enc[]=$val['param']['ENCODING'][0];
			if ($val['param']['CHARSET'][0]) $enc[]=$val['param']['CHARSET'][0];
			foreach ($val['value'] as $field=>$value) {
				if (isset($this->Fields['0:'.$Typ])) {
					$tmp_val=$this->decode($value,$enc);
					foreach ($tmp_val as $cval) {

						if (!strlen($cval)) continue;
						$this->Address[$this->Card_num][$this->Fields['0:'.$Typ]][]=$cval;
					}
				}
			}
		}
	}
	function parseSingleField($Typ,&$Content) {
		//$this->debug($Content);
		foreach ($Content as $key=>$val) {
			$enc=false;
			if ($val['param']['ENCODING'][0]) $enc[]=$val['param']['ENCODING'][0];
			if ($val['param']['CHARSET'][0]) $enc[]=$val['param']['CHARSET'][0];
			foreach ($val['value'] as $field=>$value) {
				if (isset($this->Fields['0:'.$Typ])) {
					$tmp_val=$this->decode($value[0],$enc);
					if (!strlen($tmp_val)) continue;
					$this->Address[$this->Card_num][$this->Fields['0:'.$Typ]][0]=$tmp_val;
				}
			}
		}
	}

	function fetchAddress($key=-1) {
		if ($key!=-1)
			return isset($this->Address[$key])?$this->Address[$key]:false;
		else
			return isset($this->Address)?$this->Address:false;
	}

	function debug($obj=0) {
		echo "<pre>";
		if ($obj) print_r($obj);
		else print_r($this->Address);
		echo "</pre>";

	}
}
?>
