<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class vCardWrite extends Contact_Vcard_Build {
	var $Fields=array();
	var $Pref_order=array(1=>'WORK',2=>'HOME');
	var $Address;
	var $version;
	var $_nameFormat=0;
	var $_modell='';
	//var $_prefs=array('noType'=>1);
	function vCardWrite($fields=0,$version='2.1') {
		$this->version=$version;
		$this->Contact_Vcard_Build($version);
		if ($fields) $this->loadFields($fields);
	}
	function setPrefs($prefs) {
		$this->_prefs=$prefs;
	}
	function loadFields($fields) {
		foreach ($fields as $key=>$val) {
			$tmp=explode('|',$val);
			foreach ($tmp as $cval) {
				$this->Fields[$key][]=$cval;
			}
		}
	}
	function getAddrName($Address) {
		if ($this->_nameFormat) {
			$name=trim($Address->getMeta('Nachname').' '.$Address->getMeta('Vorname'));
			if ($this->_nameFormat==2 || !$name) {
				if ($Address->getMeta('Firma')) {
					if ($name) $name=$name.', '.$Address->getMeta('Firma'); else $name=$Address->getMeta('Firma');
				}
			}
			if (!$name) $name='No Name';
			return $name;
		} else {
			return $Address->getName();
		}
	}
	function setModell($modell='') {
		$this->_modell=$modell;
	}
	function parseAddress($Address,$version=0,$nameFormat=0) {
		if ($version) $this->version=$version;
		$this->_nameFormat=$nameFormat;
		$this->reset($this->version);
		$this->Address=array();
		foreach ($this->Fields as $fkey=>$fval) {
			if ($Address->getMeta($fkey)) {
				foreach ($fval as $tval) {
					$Typ=$this->getTyp($tval);
					if (empty($Typ[2])) $Typ[2]=0;
					$this->Address[$Typ[1]][$Typ[0]][$Typ[2]]=$Address->getMeta($fkey);
				}
			}
		}
		//debug($Address);
		$this->Address['FN'][1][0]=$this->getAddrName($Address);
		if (!isset($this->Address['N'])) {
			if ($this->_prefs['noEmpyName']) {
				$this->Address['N'][1]=array($Address->getName(),'','','','');
			} else {
				$this->Address['N'][1]=array('','','','','');
			}
		}
		//debug(var_export($this->Address,true));
		//$this->debug($this->Address);
		foreach ($this->Address as $Typ=>$Content) {

			switch ($Typ) {
				case 'N':
					$this->writeName($Typ,$Content);
					break;
				case 'FN':
					$this->writeFullName($Typ,$Content);
					break;
				case 'ADR':
					$this->writeAddress($Typ,$Content);
					break;
				case 'TEL':
					$this->writeTel($Typ,$Content);
					break;
				case 'EMAIL':
					$this->writeEmail($TYP,$Content);
					break;
				case 'ORG':
					$this->writeOrganization($TYP,$Content);
					break;
				case 'URL':
					$this->writeUrl($TYP,$Content);
					break;
				case 'BDAY':
					$this->writeBirthday($TYP,$Content);
					break;
				case 'NICKNAME':
					$this->writeNickname($TYP,$Content);
					break;
				case 'TITLE':
					$this->writeTitle($TYP,$Content);
					break;
				case 'ROLE':
					$this->writeRole($TYP,$Content);
					break;
				case 'NOTE':
					$this->writeNote($TYP,$Content);
					break;
				case 'CATEGORIES':
					$this->writeCategories($TYP,$Content);
					break;
				default:
					echo ($TYP);
					break;
			}

		}
	}
	function encode (&$Content,$no_br=false) {
		$enc=false;
		if (is_array($Content)) {
			foreach ($Content as $key=>$val) {
				$tmp=$this->encode($val,$no_br);
				$Content[$key]=$val;
				if ($tmp) $enc=$tmp;
			}

		} else {
			if (strpos($Content,"\n")) {
				if ($no_br) {
					$Content=str_replace("\n","",$Content);
					$Content=str_replace("\r","",$Content);
				} elseif ($this->version=='3.0') {
					$Content=base64_encode($Content);
					$enc='BASE64';
				} else {
					$Content=$this->quoted_printable_encode($Content);
					$enc='QUOTED-PRINTABLE';
				}
			}
		}
		return $enc;
	}
	function c_encode (&$Content) {
		if (GE_CHARSET=='UTF-8') {
			$enc=true;
		} else {
			$enc=false;
			if (is_array($Content)) {
				foreach ($Content as $key=>$val) {
					$tmp=$this->c_encode($val);
					$Content[$key]=$val;
					if ($tmp) $enc=true;
				}

			} else {
				$tmp=Framework::convertCharset($Content,GE_CHARSET,'UTF-8');
				if ($tmp!=$Content) {
					$enc=true;
					$Content=$tmp;
				}
			}
		}
		return $enc;
	}
	function quoted_printable_encode($input, $line_max = 75) {
		$hex    = array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
		$lines  = preg_split("/(?:\r\n|\r|\n)+/", trim($input));
		$eol    = "\r\n";
		$escape = "=";
		$output = "";
		$len=count($lines);
		for($j=0;$j<$len;$j++) {
			$line=$lines[$j];
			//$line  = rtrim($line); // remove trailing white space -> no =20\r\n necessary
			$linlen  = strlen($line);
			//debug($linlen);
			//debug($line);

			$newline = "";
			for ($i = 0; $i < $linlen; $i++) {
				$c   = substr($line, $i, 1);
				$dec = ord($c);
				if ( ($dec == 32) && ($i == 0)) {  // convert space at begin only
					$c = "=20";
				} elseif (($dec == 61) || ($dec < 32 ) || ($dec > 126)) {  // always encode "\t", which is *not* required
					$h2 = floor($dec/16); $h1 = floor($dec%16);
					$c = $escape.$hex["$h2"].$hex["$h1"];
				}
				if ($i==$linlen-1 && $j!=$len-1) {
					$c.='=0D=0A=';
				}
				if ((strlen($newline) + strlen($c)) >= $line_max) { // CRLF is not counted
					$output .= $newline.$escape.$eol; // soft line break; " =\r\n" is okay
					$newline = "";
				}
				$newline .= $c;
			} // end of for
			$output .= $newline.$eol;
		}
		return trim($output);
	}
	function writeName($Typ,$Content) {
		foreach ($Content as $Param=>$val) {
			$char=$this->c_encode($val);
			$enc=$this->encode($val);
			$this->setName($val[0],$val[1],$val[2],$val[3],$val[4]);
			if ($char) $this->addParam('CHARSET','UTF-8');
			if ($enc) $this->addParam('ENCODING',$enc);
		}
	}
	function writeFullName($Typ,$Content) {
		foreach ($Content as $Param=>$val) {
			$char=$this->c_encode($val[0]);
			$enc=$this->encode($val[0]);
			$this->setFormattedName( $val[0]);
			if ($char) $this->addParam('CHARSET','UTF-8');
			if ($enc) $this->addParam('ENCODING',$enc);
		}
	}
	function writeAddress($Typ,$Content) {
		foreach ($Content as $Param=>$val) {
			$char=$this->c_encode($val);
			$enc=$this->encode($val);
			$this->addAddress($val[0],$val[1],$val[2],$val[3],$val[4],$val[5],$val[6]);
			if (isset($this->Pref_order[$Param])) {
				if ($this->_prefs['noType']) {
					$this->addParam($this->Pref_order[$Param],null);
				} else {
					$this->addParam('TYPE',$this->Pref_order[$Param]);
				}
			}
			if ($char) $this->addParam('CHARSET','UTF-8');
			if ($enc) $this->addParam('ENCODING',$enc);

		}
	}
	function writeTel($Typ,$Content) {
		foreach ($Content as $Param=>$val) {
			foreach ($val as $ttyp=>$values) {
				$tvalues=Addr::AddrExplode($values);
				//debug($values);
				foreach ($tvalues as $tval) {
					$enc=$this->encode($tval);
					$this->addTelephone($tval);
					if ($ttyp) {
						if ($this->_prefs['noType']) {
							$this->addParam($ttyp,null);
							switch($ttyp) {
								case 'FAX':
									$this->addParam('WORK',null);
								break;
								case 'WORK':
									$this->addParam('VOICE',null);
								break;
								case 'HOME':
									$this->addParam('VOICE',null);
								break;
							}
						} else {
							$this->addParam('TYPE',$ttyp);
						}
					} elseif ($this->_prefs['noType']) {
						$this->addParam('VOICE',null);
					}
					if (isset($this->Pref_order[$Param])) {
						if ($this->_prefs['noType']) {
							$this->addParam($this->Pref_order[$Param],null);
						} else {
							$this->addParam('TYPE',$this->Pref_order[$Param]);
						}
					}
					if ($char) $this->addParam('CHARSET','UTF-8');
					if ($enc) $this->addParam('ENCODING',$enc);
				}
			}
		}
	}
	function writeEmail($Typ,$Content) {
		foreach ($Content as $Param=>$val) {
			$tvalues=Addr::AddrExplode($val[0]);
			foreach ($tvalues as $tval) {
				$char=$this->c_encode($tval);
				$enc=$this->encode($tval);
				$this->addEmail($tval);
				if (isset($this->Pref_order[$Param])) {
					if ($this->_prefs['noType']) {
						$this->addParam($this->Pref_order[$Param],null);
					} else {
						$this->addParam('TYPE',$this->Pref_order[$Param]);
					}
				}
				if ($char) $this->addParam('CHARSET','UTF-8');
				if ($enc) $this->addParam('ENCODING',$enc);
			}
		}
	}
	function writeUrl($Typ,$Content) {
		foreach ($Content as $Param=>$val) {
			$tvalues=Addr::AddrExplode($val[0]);
			$char=$this->c_encode($tvalues[0]);
			$enc=$this->encode($tvalues[0]);
			$this->setUrl( $tvalues[0]);
			if ($char) $this->addParam('CHARSET','UTF-8');
			if ($enc) $this->addParam('ENCODING',$enc);
		}
	}
	function writeNickname($Typ,$Content) {
		foreach ($Content as $Param=>$val) {
			$char=$this->c_encode($val[0]);
			$enc=$this->encode($val[0]);
			$this->addNickname($val[0]);
			if ($char) $this->addParam('CHARSET','UTF-8');
			if ($enc) $this->addParam('ENCODING',$enc);
		}
	}
	function writeTitle($Typ,$Content) {
		foreach ($Content as $Param=>$val) {
			$char=$this->c_encode($val[0]);
			$enc=$this->encode($val[0]);
			$this->setTitle( $val[0]);
			if ($char) $this->addParam('CHARSET','UTF-8');
			if ($enc) $this->addParam('ENCODING',$enc);
		}
	}
	function writeRole($Typ,$Content) {
		foreach ($Content as $Param=>$val) {
			$char=$this->c_encode($val[0]);
			$enc=$this->encode($val[0]);
			$this->setRole( $val[0]);
			if ($char) $this->addParam('CHARSET','UTF-8');
			if ($enc) $this->addParam('ENCODING',$enc);
		}
	}
	function writeNote($Typ,$Content) {
		foreach ($Content as $Param=>$val) {
			$char=$this->c_encode($val[0]);
			$enc=$this->encode($val[0]);
			$this->setNote($val[0]);
			if ($char) {
				$this->addParam('CHARSET','UTF-8');
			}
			if ($enc) {
				$this->addParam('ENCODING',$enc);
			}
		}

	}
	function writeBirthday($Typ,$Content) {
		//$char=$this->c_encode($Content[1][0]);
		//$enc=$this->encode($Content[1][0]);
		//$this->setBirthday($Content[1][0]);
		//if ($enc) $this->addParam('CHARSET','UTF-8');
	}
	function writeOrganization($Typ,$Content) {
		foreach ($Content as $Param=>$val) {
			$char=$this->c_encode($val[0]);
			$enc=$this->encode($val[0]);
			$this->addOrganization($val[0]);
			if ($char) $this->addParam('CHARSET','UTF-8');
			if ($enc) $this->addParam('ENCODING',$enc);
		}
	}
	function writeCategories($Typ,$Content) {
		foreach ($Content as $Param=>$val) {
			$char=$this->c_encode($val[0]);
			$enc=$this->encode($val[0]);
			$this->addCategories($val[0]);
			if ($char) $this->addParam('CHARSET','UTF-8');
			if ($enc) $this->addParam('ENCODING',$enc);
		}
	}
	function getTyp($string) {
		$tmp=explode(':',$string);
		return $tmp;
	}

	function debug($obj=0) {

		//echo "<pre>";
		if ($obj) debug(print_r($obj,true));
		else  debug(print_r($this->fetch(),true));
		//echo "</pre>";

	}
	function printVcard($fname='') {
		if ($vcard=$this->fetch()) {
			if (!$fname) $fname=substr(preg_replace('/[. ,]/','_',stripslashes($this->getFormattedName())),3);
			Framework::dumpText($vcard,"$fname.vcf",'text/x-vcard');
			page_close();
			exit;
		} else return false;
	}
	function getVcard() {
		return $this->fetch();
	}




}
?>
