<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

function DeleteObject (&$new_obj) {
	global $frm,$Addr;
	if (is_object($new_obj)) {
		$this_action=$frm->getObjAction ($Addr->getModul(),$new_obj->getActionMode(0),'f_delete');
		if ($Addr->isAllowedAction($new_obj,reset($this_action))) {
			switch ($new_obj->getMeta('DocType')) {
				case 'fol':
					$Addr->deleteOrder($new_obj->getID());
				break;
			}
			$Addr->deleteMeta($new_obj);
		} else {
			return array('no_del_perms',$new_obj->getID());
		}
	}
	return false;
}

function TrashAddrObject (&$trash_obj,&$new_obj) {
	global $frm,$Addr;
	if (is_object($new_obj)) {
		$this_action=$frm->getObjAction ($Addr->getModul(),$new_obj->getActionMode(0),'delete');
		if ($Addr->isAllowedAddrAction($new_obj,reset($this_action))) {
			$ANodes=$Addr->getAddrNodes($new_obj->getID());
			$trash_ids=array_keys($ANodes);
			$new_obj->setMeta('Trash',1);
			$new_obj->setMeta('TrashIDs',implode(',',$trash_ids));
			$new_obj->setParentMeta('NodeIDs',array($trash_obj->getID()));
			$Addr->updateAddrMeta($new_obj);
		} else {
			return array('no_addr_del_perms',$new_obj->getID());
		}
	}
	return false;
}
function DeleteAddrObject (&$new_obj) {
	global $frm,$Addr;
	if (is_object($new_obj)) {
		$this_action=$frm->getObjAction ($Addr->getModul(),$new_obj->getActionMode(0),'f_delete');
		if ($Addr->isAllowedAddrAction($new_obj,reset($this_action))) {
			$Addr->deleteAddrMeta($new_obj);
			$Addr->deleteAddrParentMeta($new_obj);
			$Addr->deleteHotMeta($new_obj);
			$Addr->deleteAddrProjects($new_obj);
		} else {
			return array('no_addr_del_perms',$new_obj->getID());
		}
	}
	return false;
}

function getVcard(&$new_obj,$print=0) {
	global $frm,$Addr;
	require_once('lib/addr/Contact_Vcard_Build.php');
	require_once('lib/addr/ClassVcardWrite.php');
	$vcard=new vCardWrite($Addr->getVcardFields());
	$vcard->parseAddress($new_obj);
	//$vcard->debug();
	if ($print) {
		$vcard->printVcard();
	} else {
		return $vcard->getVcard();
	}
}
