<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class ObjAsx extends baseObj {
	var $_action=array('n','n'); // to owerwrite;
	var $_site='asx.php'; // to owerwrite;
	var $_obj_typ='0';
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		if ($pos=strpos($this->getID(),'/')) {
			return substr($this->getID(),$pos+1);
		} else {
			return $this->getID();
		}
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class Asx extends ObjCore {
	protected $_ModulObj=array();
	public $_modul='asx';
	public $_table='AsteriskPhones';
	public $_cfgObjects=array (
		'IdField'=>'ID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'0'=>array(
			'ClassName'=>'ObjAsx',
			'Fields'=>array(
				'ID'=>array(
					'Typ'=>'core',
				),
				'Server'=>array(
					'Typ'=>'core',
				),
				'TimeCreate'=>array(
					'Typ'=>'core',
					'Extra'=>'cTime',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserCreate'=>array(
					'Typ'=>'core',
					'Extra'=>'cUser',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
				'PcAddress'=>array(
					'Typ'=>'core',
				),
				'CallContext'=>array(
					'Typ'=>'core',
				),
				'FKUserID'=>array(
					'Typ'=>'core',
				),
			),
		),
	);
	public function __construct() {
		global $db,$frm;
		$this->_db=&$db;
		$this->_frm=&$frm;
		$this->setCfg($this->_frm->getCfg($this->getModul(),0,'cfg/%'));
		//$this->setCfg(array('cfg/model/type'=>'siemens'));
		if ($this->getCfg('cfg/model/type')) $this->setCfg($this->_frm->getCfg($this->getModul(),0,$this->getCfg('cfg/model/type').'/%'));
		$this->setRule($this->_frm->isRuleUser(array('sysadmin','asx')));
		$this->setSuperAdmin($this->_frm->isSuperAdmin());
		parent::ObjCore();
	}
	public function listPhones(&$rows,$search,$order='') {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'Server','Typ'=>'=','Values'=>$this->getCfg('cfg/model/type'));
		//SELECT * FROM AsteriskPhones INNER JOIN UserMsg ON (PcAddress like CONCAT('%',UserMsg.IpAdress,'%')) WHERE UserMsg.IpAdress!='' AND UserMsg.uptime>1325780590
		$params=array();
		if ($search['online']) {
			$params['FIELDS']="UserMsg.FKUserID as _FKUserID";
			$params['JOIN']="INNER JOIN UserMsg ON (AsteriskPhones.PcAddress like CONCAT('%,',UserMsg.IpAdress,',%') OR AsteriskPhones.FKUserID like CONCAT('%,',UserMsg.FKUserID,',%'))";
			$searchQuery[]=array('Field'=>'UserMsg.IpAdress','Typ'=>'!=','Values'=>'');
			$searchQuery[]=array('Field'=>'UserMsg.uptime','Typ'=>'>','Values'=>time()-600);
			$params['CALLBACK']=array($this,'_addUserMeta');
		}
		return $this->searchObj($rows,$searchQuery,$order,$search['b'],$search['limit'],true,true,false,$params);
	}
	public function _addUserMeta(&$Obj) {
		$Obj->setMeta('_FKUserID',$this->_db->f('_FKUserID'));
	}
	public function getPhoneFromIP($ipAdress='') {
		if (!$ipAdress) $ipAdress=$_SERVER['REMOTE_ADDR'];
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'Server','Typ'=>'=','Values'=>$this->getCfg('cfg/model/type'));

		$subQuery=array();
		$subQuery[]=array(array('Field'=>'FKUserID','Typ'=>'like','Values'=>'%,'.$this->_frm->getUser().',%'));
		$subQuery[]=array(array('Field'=>'PcAddress','Typ'=>'like','Values'=>'%,'.$ipAdress.',%'));
		$searchQuery[]=array('Typ'=>'OR','Values'=>$subQuery);
		return $this->searchSingleObj($searchQuery);
	}
	public function setDND($val=0) {
		$asxPhone=$this->getPhoneFromIP();
		if (is_object($asxPhone)) {
			$Base=$this->getStaticModul('server');
			try {
				if ($Base->login()) {
					$Base->geSetDND($asxPhone,$val);
				}
			} catch(Exception $E) {
				return false;
			}
		}
	}
	function &getStaticModul($modul='server',$params=null) {
		if (!isset($this->_ModulObj[$modul])) {
			switch($this->getCfg('cfg/model/type')) {
				case 'ajam':
					switch ($modul) {
						case 'server':
							$files=array("add-on/shift8/Shift8.php","lib/asx/class_AsxServerAjam.php");
							$class='AsxServerAjam';
						break;
						case 'poller':
							$files=array("add-on/shift8/Event/Listener.php","lib/asx/class_AsxPollerAjam.php");
							$class='AsxPollerAjam';
						break;
					}
				break;
				case 'siemens':
					switch ($modul) {
						case 'server':
							$files=array("add-on/shift8/Shift8.php","lib/asx/class_AsxServerSiemens.php");
							$class='AsxServerSiemens';
						break;
						case 'poller':
							$files=array("add-on/shift8/Event/Listener.php","lib/asx/class_AsxPollerSiemens.php");
							$class='AsxPollerSiemens';
						break;
					}
				break;
			}
			foreach ($files as $val) {
				if (file_exists($val)) require_once($val);
			}
			if (class_exists($class)) {
				if ($params) {
					$this->_ModulObj[$modul]=new $class($params);
				} else {
					$this->_ModulObj[$modul]=new $class;
				}
			}
		}
		return $this->_ModulObj[$modul];
	}
	public function saveCall($ID,$Status,$data=array()) {
		$values=array(
			'CallID'=>$ID,
			'FKUserID'=>$this->_frm->getUser(),
			'CallStatus'=>$Status,
			'CallData'=>json_encode($data),
			'TimeModify'=>time(),
		);
		$this->_db->insert('AsteriskCalls',$values,'',true);
	}
	public function getCall($Status) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'CallStatus','Typ'=>'=','Values'=>$Status);
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_frm->getUser());

		$query="SELECT * FROM AsteriskCalls WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if($this->_db->next_record()){
			return array(
				'CallID'=>$this->_db->f('CallID'),
				'FKUserID'=>$this->_db->f('FKUserID'),
				'CallStatus'=>$this->_db->f('CallStatus'),
				'CallData'=>json_decode($this->_db->f('CallData'),true),
				'TimeModify'=>$this->_db->f('TimeModify'),
			);
		}
		return false;
	}
	public function clearCall($ID=0) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_frm->getUser());
		if ($ID) $searchQuery[]=array('Field'=>'CallID','Typ'=>'=','Values'=>$ID);
		$this->_db->delete('AsteriskCalls',$searchQuery);
	}
	public function phone2name($phone,$default='') {
		$Addr=& $this->_frm->getStaticModul('addr');
		$Addr->setLimit(1);
		$num=Addr::cleanNumber($phone);
		if (strpos($num,'00')===false && $this->getCfg('cfg/phone/prefix')) {
			$num=$this->getCfg('cfg/phone/prefix').$num;
		}
		if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
			$fields=array('Mobil','ATel','PTel','Fax','Intern','Iptel');
			$searchAddr=array(
				'search'=>array(
					0=>array(
						'mode'=>'or',
						'field'=>array(),
					)
				),
				'searchSub'=>1,
			);
			$searchAddr['searchSub']=1;

			$searchAddr['search'][0]['field']=array();
			foreach ($fields as $fid) {
				$searchAddr['search'][0]['field'][]=array(
					'key' => $fid,
					'typ' => 'addr',
					'mode' => 'lk',
					'value' => $num,
				);
			}
			$data=$Addr->searchAddr(0,array('Name'=>1),$searchAddr);
			if (empty($data) && $this->getCfg('cfg/phone/prefix') && strpos($num,$this->getCfg('cfg/phone/prefix'))===0) {
				$num=substr($num,strlen($this->getCfg('cfg/phone/prefix')));
				$searchAddr['search'][0]['field']=array();
				foreach ($fields as $fid) {
					$searchAddr['search'][0]['field'][]=array(
						'key' => $fid,
						'typ' => 'addr',
						'mode' => 'lk',
						'value' => $num,
					);
				}
				$data=$Addr->searchAddr(0,array(),$searchAddr,null,null,null,false,true,array('AOrt','POrt'));
			}
		} else {
			$searchAddr=array();
			$searchAddr[0]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);
			$searchAddr[1]=array('Field'=>"SearchPhone",'Typ'=>'like','Values'=>'%'.$num.'%');
			//$name=$num;
			//return $num;
			$data=$Addr->searchAddr(0,array(),$searchAddr,null,null,null,false,true,array('AOrt','POrt'));
			if (empty($data) && $this->getCfg('cfg/phone/prefix') && strpos($num,$this->getCfg('cfg/phone/prefix'))===0) {
				$searchAddr[1]=array('Field'=>"SearchPhone",'Typ'=>'like','Values'=>'%'.substr($num,strlen($this->getCfg('cfg/phone/prefix'))).'%');
				$data=$Addr->searchAddr(0,array(),$searchAddr,null,null,null,false,true,array('AOrt','POrt'));
			}
			
		}
		if ($data && !empty($data)) {
			$AObj=reset($data);
			$name=$AObj->getName();
		} else {
			$name=$default;
		}
		return $name;
	}
	public function cleanNumber($val) {
		return preg_replace('/[^0-9]/','',str_replace('+','00',$val));
	}
}