<?php
class AsxAdminGui {
	var $_AppGui;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	function __construct() {
		global $frm,$t,$T,$E,$L;
		$this->_Base=$frm->getStaticModul('asx');
		$this->_Server=$this->_Base->getStaticModul('server');
		//debug($this->_Server);
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_T->loadModul('asx');
	}
	function _handleRequest() {
		try {
			if (!$this->_Server->login()) {
				$this->_E->setError('server');
				$this->_E->setErrorMsg('server','invalid username or password');
				return false;
			}
		} catch(Exception $E) {
			$this->_E->setError('server');
			$this->_E->setErrorMsg('server',$E->getMessage());
			return false;
		}

		$this->_mode=Framework::getParam('mode','phone','G');
		$this->_oid=Framework::getParam('oid','','G');
		switch ($this->_mode) {
			case 'phone':
				$this->_action=Framework::getParam('action','b','G');
				$this->_obj_action='asx_phone';
				if ($this->_oid) {
					$this->_Obj=$this->_Base->getObj($this->_oid);

				}
				if (Framework::getParam('_clTab',0,'G')) {
					$this->setPrefs('showtab',Framework::getParam('_clTab',0,'G'));
				}
				if (Framework::getParam('obj_action_x','0','P') && Framework::getParam('obj_action_val','0','P')) {
					switch (Framework::getParam('obj_action_val','0','P')) {
						case 'new':
							$this->_L->setParam('action','n');
							$this->_L->unsetParam('oid');
							$this->_L->goToLink();
						break;
						case 'delete':
							if (is_object($this->_Obj)) {
								if ($this->_Base->deletePhone($this->_Obj->getID())) {
									$this->_L->unsetParam(array('oid','action'));
									$this->_L->goToLink();
								}
							}
						break;
						default:
							//debug(Framework::getParam('obj_action_val','0','P'));
					}
				}
			break;
		}
		return true;
	}
	function &getAdminHeader() {
		require_once("lib/class_ContentGui.php");
		$hGui=new ContentGui();
		$hGui->setName($this->_frm->getAppName('asx'));
		$hGui->addTab('phone',$this->_T->lang('[[Telefone]]'),"index.php?site=admin.php&ac=asx&mode=phone");
		$hGui->setTabOn($this->_mode);
		require_once('lib/class_FunctionObjActionGui.php');
		$objActionGui=new FunctionObjActionGui();
		if ($this->_obj_action) {
			$obj_action=array();
			switch($this->_obj_action) {
				case 'asx_phone':
					if (!$this->_Server->getFeatures('phonelist')) {
						$obj_action['new']=array(
							'Hidden'=>false,
							'Extra'=>array(),
							'Name'=>$this->_T->lang('Neuer Eintrag'),
						);
					}
				break;
			}
			$parse=false;
			foreach ($obj_action as $key=>$val) {
				if ($val['Hidden']) continue;
				if (!$this->isAllowedAction($this->_Obj,$val)) continue;
				$parse=true;
				$objActionGui->addValue($key,$val['Name']);
			}
			if ($parse) $hGui->addFunction($objActionGui);
		}
		return $hGui;
	}
	function isAllowedAction(&$obj,$action) {
		if ($action['Hidden']) return false;
		if (in_array('ID',$action['Extra']) && !is_object($obj)) return false;
		return true;
	}
	function process(&$AppGui) {
		if ($this->_handleRequest()) {
			$AppGui->addContent($this->getAdminHeader());

			switch ($this->_mode) {
				case 'phone':
					switch ($this->_action) {
						case 'n':
							$AppGui->addContent($this->showEditPhone());
						break;
						case 'b':
							$AppGui->addContent($this->showPhoneList());
						break;
					}

				break;
			}
			$AppGui->setFormAction($this->_L->getLink());
		}
	}

	function showEditPhone() {
		require_once('lib/class_ContentGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		$Gui=new ContentGui();
		$tplContent=new TemplateGui('core/common_template_intern.inc.html');
		$tabs=array();
		$tabs[]='meta';
		$Gui->setName($this->_T->lang('[[Eintrag bearbeiten]]'));
		$btBreak=new FunctionButtons('break','break',array('LINK'=>$this->_L->getTempLink(array('oid'),array('action'=>'b'))));
		$Gui->addFunction($btBreak);

		$box=new BoxGui($this->_Base->getModul().'|sharetab');
		$box->setCallbackOnChange(array(&$this,'setPrefs'),array('sharetab'));
		if (in_array('meta',$tabs)) {
			$box->addTab('meta',$this->_T->lang('[[Metadaten]]'),'#',true);
			$box->setTabContent('meta',$this->getPhoneMetaGui());
		}
		$show_tap=$this->getPrefs('sharetab');
		$box->setTabOn($box->issetTab($show_tap)?$show_tap:reset($tabs));
		$tplContent->addContent('content',$box,'CONTENT');
		$Gui->addContent($tplContent);
		return $Gui;
	}

	function &getPhoneMetaGui() {
		require_once('lib/class_FormGui.php');
		require_once('lib/class_TemplateGui.php');
		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		// BEGIN FORM Metadaten
		//$this->_Server->geSetDisplay($this->_Obj,'Endo7 GmbH, Thaler Manfred <339934987897>');
		//$this->_Server->geRetrieve($this->_Obj);
		
		if ($this->_oid) $req_check=2; else $req_check=1;
		if (!$this->_Server->getFeatures('phonelist')) {
			$key='ID';
			$formGui->addField($key,'text',$this->_T->lang('[[Bezeichnung]]'),$this->_Obj?$this->_Obj->getMeta($key):'','form_fields1');
		}
		$key='FKUserID';
		$Default=array();
		if ($this->_Obj && strlen($this->_Obj->getMeta($key))>2) {
			foreach(explode(',',substr($this->_Obj->getMeta($key),1,-1)) as $v) {
				$Default[]='u_'.$v;
			}
		}
		$mode='u';
		$params=base64_encode(serialize(array('useEmpty'=>$this->_T->lang('[[Ueber IP-Adresse bestimmen]]'))));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[BenutzerInnen]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
		$formGui->addField($key,'ttip',$lb_Invit,implode('|',$Default),'form_fields1');
		$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));
		$formGui->setNoMeta($key);


		$key='PcAddress';
		$formGui->addField($key,'text',$this->_T->lang('[[IP-Adressen der zugewiesenen Arbeitsplaetze]]'),$this->_Obj?substr($this->_Obj->getMeta($key),1,-1):'','form_fields1');

		if ($this->_Server->getFeatures('context')) {
			$key='CallContext';
			$formGui->addField($key,'text',$this->_T->lang('[[Kontext des Telefons (optional)]]'),$this->_Obj?substr($this->_Obj->getMeta($key),1,-1):'','form_fields1');
		}

		$key='meta_save_x';
		$formGui->addField($key,'submit','',$this->_T->lang('[[Speichern]]'),'form_submit');

		if (Framework::getParam('meta_save_x','0','P')) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				if (!is_object($this->_Obj)) {
					$this->_Obj=new ObjAsx();
					$this->_Obj->setMeta('Server',$this->_Base->getCfg('cfg/model/type'));
					if ($this->_oid) $this->_Obj->setMeta('ID',$this->_oid);
				}
				$formGui->addMetaToObj($this->_Obj);
				if (!$this->_Obj->getID() && $this->_Obj->getMeta('ID') && $this->_Base->getObj($this->_Obj->getMeta('ID'))) {
					$this->_E->setError('fields','ID');
				}
				if (!$this->_E->isError()) {
					$tmp=array();
					if (trim($formGui->getFieldVal('FKUserID',1))) {
						foreach (explode('|',$formGui->getFieldVal('FKUserID',1)) as $val) {
							$tmp[]=substr($val,2);
						}
					}
					if (!empty($tmp)) {
						$this->_Obj->setMeta('FKUserID',','.implode(',',$tmp).',');
						$this->_Obj->setMeta('PcAddress','');
					} else {
						$this->_Obj->setMeta('FKUserID','');
						$this->_Obj->setMeta('PcAddress',','.preg_replace('/[^0-9.,]/','',$this->_Obj->getMeta('PcAddress')).',');
					}
	
					if ($this->_Obj->getID()) {
						$this->_Base->updateMeta($this->_Obj);
					} else {
						$this->_Base->insertMeta($this->_Obj);
					}
					$this->_L->unsetParam(array('action','oid'));
					$this->_L->goToLink();
				}
			}
		}
		$tplContent->addContent('form1',$formGui,'FORM1',array('','form_fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','form_fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','form_submit'));
		return $tplContent;

	}


	function &showPhoneList($search= null) {
		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		require_once('lib/class_ApplicationListGui.php');
		$rows=0;
		$entries=$this->_Server->geGetAllPhones();

		$Gui=new ApplicationListGui();
		$Gui->setName($this->_T->lang('[[Telefone]]'));
		$Gui->addHeaderCol('Title',$this->_T->lang('[[Name]]'),'','','',1);
		$Gui->addHeaderCol('IPPhone',$this->_T->lang('[[IP-Adresse]]'),'','','',1);
		if ($this->_Base->getCfg('cfg/phone_mode')=='user') {
			$Gui->addHeaderCol('IPPc',$this->_T->lang('[[Zugewiesene Benutzer]]'),'','','',1);
		} else {
			$Gui->addHeaderCol('IPPc',$this->_T->lang('[[Zugewiesene Arbeitsplaetze]]'),'','','',1);
		}
		if ($this->_Server->getFeatures('context')) {
			$Gui->addHeaderCol('Context',$this->_T->lang('[[Kontext]]'),'','','',1);
		}
		$Gui->addHeaderCol('Status',$this->_T->lang('[[Status]]'),'','','',0,2000);
		//$Gui->addHeaderCol('TimeCreate',$this->_T->lang('[[Erstellt am]]'),'','','',1);
		//$Gui->addHeaderCol('UserCreate',$this->_T->lang('[[Erstellt von]]'),'','','',1);
		foreach ($entries as $val) {
			$Gui->addRow(($hl?$hl=0:$hl=1),'top');
			$Gui->addCol('Title',$val->id,'',$this->_L->getTempLink(null,array('oid'=>$val->id,'action'=>'n')),'','1');
			$Gui->addCol('IPPhone',$val->phoneAddress,'','','',1);
			if ($val->pcUser) {
				$tmp=array();
				$tmp=$this->_frm->getCachedUsername(explode(',',substr($val->pcUser,1,-1)));
				$Gui->addCol('pcAddress',implode(',',$tmp),'','','',1);
			} else {
				$Gui->addCol('pcAddress',$val->pcAddress?substr($val->pcAddress,1,-1):'','','','',1);
			}
			if ($this->_Server->getFeatures('context')) {
				$Gui->addCol('Context',$val->pcContext,'','','',1);
			}
			$Gui->addCol('Status',$val->phoneStatus,'','','',1);
		}
		return $Gui;
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result) $result=$default;
		return $result;
	}

}
?>