<?php
class AsxPollerAjam extends Shift8_Event_Listener {
	private $events=array();
	private $status=array();
	private $_Server;
	private $_cookie;
	private $_Asx;
	private $_frm;
	private $_calls;

	public function __construct() {
		global $frm;
		$this->_frm=$frm;
		$this->_Asx=$this->_frm->getStaticModul('asx');;

		$this->events = array();
		$this->_cookie = FrameWork::getParam('asx_cookie','');
		$this->myPhone=$this->_Asx->getPhoneFromIP();

		$this->_Server = $this->_Asx->getStaticModul('server');
		// Add the event listener
		$this->_Server->addEventListener('Poller', $this);
		//
		// AJAM uses a cookie value to identify a session. In order to keep the session open
		// we pass down the cookie value in the session with the user browser
		//
		if(!$this->_cookie) {
			// No session cookie available. Let's login to the server
			if( !$this->_Server->login() ) {
				throw new Exception("Unable to connect to the remote asterisk");
			}
			$this->_cookie=$this->_Server->getCookie();
		}
		else {
			// Session cookie already exists. Let's use this
			$this->_Server->setCookie($this->_cookie);
		}
	}
	private function getChannel($str) {
		$str=substr($str,0,strrpos($str, "-"));
		if (strrpos($str, "@")) {
			$str=substr($str,0,strrpos($str, "@"));
		}
		$str=str_replace('Local','SIP',$str);
		return $str;
	}

	public function notify( $event ) {
		if (!$this->myPhone) return;
		switch($event->get('event')) {
			case 'Dial':
				$res=new AsxEventAjam();
				$res->event='dial';
				
				$s=$this->getChannel($event->get('source'));
				$d=$this->getChannel($event->get('destination'));
				if ($s!=$d) {
					$redirect=array();
					$rows=0;
					$phones=$this->_Asx->listPhones($rows,array('online'=>1));
					//debug($phones);
					if ($rows) {
						$users=$this->_frm->getCachedUserName(FrameWork::extractObjMeta($phones,'_FKUserID'));
						foreach($phones as $v) {
							if ($v->getMeta('_FKUserID')!=$this->_frm->getUser() && isset($users[$v->getMeta('_FKUserID')])) {
								$redirect[$v->getName()]=$users[$v->getMeta('_FKUserID')];
							}
						}
					}
					$res->callredirect=$redirect;
					if ($this->_Asx->getCfg('ajam/self_redirect')) {
						$res->bt_respond=$this->myPhone->getName();
					} else {
						$res->bt_respond=0;
					}
					$res->bt_close=1;
					$res->bt_redirect=1;
					if ($this->myPhone->getID()==$d) {
						$res->callid=str_replace('.','-',$event->get('destuniqueid'));
						$res->calltype='in';
						$res->callchannel=$event->get('source');
						if ($tmp=$this->_Asx->getObj($s)) {
							$res->callnumber=$tmp->getName();
							$res->calldisp=$s;
						} else {
							$res->callnumber=$event->get('callerid');
							$res->calldisp=$this->_Asx->phone2name($event->get('callerid'),$event->get('calleridname')).' <'.$event->get('callerid').'>';
						}
						$this->events[] = $res->getVariables();
					}
					if ($this->myPhone->getID()==$s) {
						$res->callid=str_replace('.','-',$event->get('srcuniqueid'));
						$res->calltype='out';
						$res->callchannel=$event->get('destination');
						if ($tmp=$this->_Asx->getObj($d)) {
							$res->callnumber=$tmp->getName();
							$res->calldisp=$d;
						} else {
							if (isset($this->_calls[$event->get('srcuniqueid')])) {
								$res->calldisp=$this->_Asx->phone2name($this->_calls[$event->get('srcuniqueid')]['calleridnum'],$this->_calls[$event->get('srcuniqueid')]['calleridname']).' <'.$this->_calls[$event->get('srcuniqueid')].'>';
							} else {
								$res->calldisp=$this->_Asx->phone2name($event->get('callerid'),$event->get('calleridname')).' <'.$event->get('callerid').'>';
							}
						}
						$this->events[] = $res->getVariables();
					}
				}
			break;
			case 'Hangup':
				$d=$this->getChannel($event->get('channel'));
				if ($this->myPhone->getID()==$d) {
					$res=new AsxEventAjam();
					$res->event='down';
					$res->callid=str_replace('.','-',$event->get('uniqueid'));
					$this->events[] = $res->getVariables();
				}
			break;
			case 'Newstate':
				$d=$this->getChannel($event->get('channel'));
				if ($this->myPhone->getID()==$d) {
					if ($event->get('state')=='Up') {
						$res=new AsxEventAjam();
						$res->event='up';
						$res->callid=str_replace('.','-',$event->get('uniqueid'));
						//$res->callchannel=$event->get('channel');
						$res->bt_close=1;
						$res->bt_redirect=1;
						$res->bt_respond=0;
						//$res->origEvent=$event->getVariables();
						$this->events[] = $res->getVariables();
					}
				}
				
			break;
			case 'Newexten':
				if ($event->get('application')=='Dial') {
					$this->_calls[$event->get('uniqueid')]['calleridnum']=$event->get('extension');
					$this->_calls[$event->get('uniqueid')]['calleridname']='';
				}
				//$this->events[] = $event->getVariables();
			break;
			case 'Newchannel':
				/*if ($event->get('calleridnum')!='<unknown>') {
					$this->_calls[$event->get('uniqueid')]=array();
					$this->_calls[$event->get('uniqueid')]['calleridnum']=$event->get('calleridnum');
					$this->_calls[$event->get('uniqueid')]['calleridname']=$event->get('calleridname');
				}
				$this->events[] = $event->getVariables();*/
			break;
			default:
				//$this->events[] = $event->getVariables();
			break;
		}
		//$this->status[] = $this ->_Server->getStatus($event->get('channel'));
	}
	public function getStatus() {
		return $this->status;
	}
	public function getCookie() {
		return $this->_cookie;
	}
	public function getEvents() {
		while (true) {
			if( !$this->_Server->waitEvent() ) {
				//
				// No events received. This could mean that our session has expired. Let's reset the
				// cookie and on next call we will relogin on the remote asterisk
				//
				$this->_cookie='';
				return null;
			}
			if (!empty($this->events)) {
				return $this->events;
			}
		}
	}


}
