<?php
class AsxPollerSiemens {
	private $events=array();
	private $_Asx;
	private $_Server;
	private $_frm;
	private $_myPhone;
	private $_calls=array();

	public function __construct() {
		global $frm;
		$this->_frm=$frm;
		$this->_Asx=$this->_frm->getStaticModul('asx');;

		$this->events = array();
		$this->_cookie = FrameWork::getParam('asx_cookie','');
		$this->_myPhone=$this->_Asx->getPhoneFromIP();

		$this->_Server = $this->_Asx->getStaticModul('server');
		if(!$this->_cookie) {
			// No session cookie available. Let's login to the server
			if( !$this->_Server->login() ) {
				throw new Exception("Unable to connect to the remote server");
			}
			$this->_cookie=$this->_Server->getCookie();
			$this->_Server->geMonitorStart($this->_myPhone);
		}
		else {
			// Session cookie already exists. Let's use this
			$this->_Server->setCookie($this->_cookie);
		}
	}
	protected function normalizeNumber($num) {
		if (strlen($this->_Asx->getCfg('siemens/out_number')) && strpos($num, $this->_Asx->getCfg('siemens/out_number'))===0 ) {
			$num=substr($num,strlen( $this->_Asx->getCfg('siemens/out_number')));
		}
		return $num;
	}
	protected function parseEvent( $event ) {
		$heldCall=$this->_Asx->getCall('held');
		switch($event->type) {
			case 'OriginatedEvent':

				$res=new AsxEventSiemens();
				$res->event='dial';
				$res->callid=$event->callID;
				$res->calltype='out';
				$res->callchannel=$event->callID;
				$res->callnumber=$this->normalizeNumber($event->calledDevice);

				$redirect=array();
				$rows=0;
				$phones=$this->_Asx->listPhones($rows,array('online'=>1));
				//debug($phones);
				if ($rows) {
					$users=$this->_frm->getCachedUserName(FrameWork::extractObjMeta($phones,'_FKUserID'));
					foreach($phones as $v) {
						if ($v->getName()!=$this->_myPhone->getName() && $v->getName()!=$res->callnumber && isset($users[$v->getMeta('_FKUserID')])) {
							$redirect[$v->getName()]=$users[$v->getMeta('_FKUserID')];
						}
					}
				}
				$res->callredirect=$redirect;
				$res->bt_respond=0;
				$res->bt_close=1;
				$res->bt_redirect=0;
				// Tel ist automatisch auf Freiprechen.
				//if ($this->_myPhone) {
				//	$res->autoresponder=$this->_myPhone->getName();
				//} else {
				//	$res->autoresponder=0;
				//}

				if ($s=$this->_Asx->getObj($res->callnumber)) {
					$res->calldisp=$res->callnumber;
				} else {
					$res->calldisp=$this->_Asx->phone2name($res->callnumber,$event->sname).' <'.$res->callnumber.'>';
				}
				$this->events[] = $res->getVariables();
			break;
			case 'DeliveredEvent':
				if ($this->_myPhone->getName()==$event->callingDevice) {
					//Outgoing call;
					//Ignorieren da breits in OriginatedEvent
					break;
				}
				$res=new AsxEventSiemens();
				$res->event='dial';
				$res->callid=$event->callID;
				$res->calltype='in';
				$res->callchannel=$event->callID;
				$res->callnumber=$this->normalizeNumber($event->callingDevice);
				

				$redirect=array();
				$rows=0;
				$phones=$this->_Asx->listPhones($rows,array('online'=>1));
				//debug($phones);
				if ($rows) {
					$users=$this->_frm->getCachedUserName(FrameWork::extractObjMeta($phones,'_FKUserID'));
					foreach($phones as $v) {
						if ($v->getName()!=$this->_myPhone->getName() && $v->getName()!=$res->callnumber && isset($users[$v->getMeta('_FKUserID')])) {
							$redirect[$v->getName()]=$users[$v->getMeta('_FKUserID')];
						}
					}
				}
				$res->callredirect=$redirect;
				$res->bt_respond=$this->_myPhone->getName();
				$res->bt_close=0;
				$res->bt_redirect=1;

				if ($s=$this->_Asx->getObj($res->callnumber)) {
					$res->calldisp=$res->callnumber;
				} else {
					$res->calldisp=$this->_Asx->phone2name($res->callnumber,$event->sname).' <'.$res->callnumber.'>';
				}
				$this->events[] = $res->getVariables();
				//Problem Telefon zeigt Display nich an Wenn eingehender Anruf;
				//Welchen Charset ??
				//$this->_Server->geSetDisplay($this->_myPhone,$res->calldisp);
			break;
			case 'EstablishedEvent':
				$res=new AsxEventSiemens();
				$res->event='up';
				$res->callid=$event->connection->callID;
				$res->callchannel=$event->connection->callID;
				$res->bt_close=1;
				$res->bt_redirect=1;
				$res->bt_respond=0;
				$this->events[] = $res->getVariables();
			break;
			case 'TransferedEvent':
				//UP Call weitergeleitet
				$res=new AsxEventSiemens();
				$res->event='down';
				$res->callid=$event->jsonEvent->TransferedEvent->primaryOldCall->callID;
				//$this->_Server->geClearDisplay($this->_myPhone);
				$this->events[] = $res->getVariables();
			break;
			case 'DivertedEvent':
				//Dial Call weitergeleitet
				$res=new AsxEventSiemens();
				$res->event='down';
				$res->callid=$event->callID;
				$this->events[] = $res->getVariables();
				//$this->_Server->geClearDisplay($this->_myPhone);
			break;
			case 'ConnectionClearedEvent':
				$res=new AsxEventSiemens();
				$res->event='down';
				$res->callid=$event->callID;
				$res->origEvent=$event;
				//$this->_Server->geClearDisplay($this->_myPhone);
				//Falls es noch ein gehaltenes Telefonat gibt;
				
				if ($heldCall) {
					if ($heldCall['CallID']!=$res->callid) {
						//Wieder Herholen
						if ($this->_Server->geRetrieve($this->_myPhone,$heldCall['CallID'])) {
							if ($event->deviceID==$this->_myPhone->getName() && ($toPhone=$this->_Asx->getObj($heldCall['CallData']['exten']))) {
								$res->REDIRECT=$toPhone->getName();
								//Etwas Warten
								sleep(1);
								//$this->_Server->geHangup($toPhone,$res->callid);
								//Ich habe aufgelegt also weiterleiten;
								$xml=$this->_Server->geRedirect($this->_myPhone,$heldCall['CallID'],$toPhone->getName(),'up',true);
								//Abheben
								//$xml=$this->_Server->geRedirect($toPhone,$heldCall['CallID'],$toPhone->getName(),'up',true);

								$res->DEBUG=$xml->asXml();
							} else {
								$this->_Asx->clearCall($heldCall['CallID']);
							}
						} else {
							$this->_Asx->clearCall($heldCall['CallID']);
						}
					} else {
						$this->_Asx->clearCall($heldCall['CallID']);
					}
				}
				$this->events[] = $res->getVariables();
			break;
			case 'HeldEvent':
				$res=new AsxEventSiemens();
				$res->event='hold';
				$res->callid=$event->callID;
				$this->events[] = $res->getVariables();
			break;
			case 'RetrievedEvent':
				$res=new AsxEventSiemens();
				$res->event='retrieve';
				$res->callid=$event->callID;
				if ($heldCall && $heldCall['CallID']==$res->callid) {
					$this->_Asx->clearCall($res->callid);
				}
				$this->events[] = $res->getVariables();
			break;
			default:
				$res=new AsxEventSiemens();
				$res->event='debug';
				$res->debug=$event;
				$this->events[] = $res->getVariables();
			break;
		}
	}


	public function getCookie() {
		return $this->_cookie;
	}
	public function getEvents() {
		while (true) {
			$events=$this->_Server->geWaitEvent($this->_myPhone);
			if (is_array($events)) {
				foreach($events as $v) {
					$this->parseEvent($v);
				}
			} else {
				// No events received. This could mean that our session has expired. Let's reset the
				// cookie and on next call we will relogin on the remote asterisk
				$this->_cookie='';
				return null;
			}
			if (!empty($this->events)) {
				return $this->events;
			}
		}
	}
}
