<?php
class AsxEventSiemens {
	public $variables;
	public function set( $variable, $value ) {
		if( isset($this->variables[$variable]) )
			return false;

		$this->variables[$variable] = $value;
		return true;
	}
	public function get( $variable ) {
		if( !isset($this->variables[$variable]) )
			return null;

		return $this->variables[$variable];
	}
	public function __get( $variable ) {
		return $this->get($variable);
	}
	public function __set( $variable, $value ) {
		return $this->set($variable, $value);
	}
	public function getVariables() {
		return $this->variables;
	}
	public function setVariables( $variables ) {
		$this->variables = $variables;
	}
	public function asXml() {
		$xml = '<event>';
		while (list($key, $value) = each($this->variables))
			$xml .= "<$key>$value</$key>";

		$xml .= '</event>';
		return $xml;
	}
}
class AsxServerSiemens {
	protected $_Asx;
	protected $_frm;
	protected $_cookie='';
	protected $_features=array(
		'context'=>false,
		'phonelist'=>false,
	);
	public function __construct() {
		global $frm;
		$this->_frm=& $frm;
		$this->_Asx=$this->_frm->getStaticModul('asx');
	}
	public function getFeatures($k,$def=false) {
		return isset($this->_features[$k])?$this->_features[$k]:$def;
	}
	public function login() {
		$response = $this->proxy(
			array(
				'gsUser'	=>	$this->_Asx->getCfg('siemens/user'),
				'gsPass'	=>	$this->_Asx->getCfg('siemens/pwd')
			));

		if(isset($response->ID) && (string)$response->ID)  {
			return (string)$response->ID;
		}
		throw new Exception($response->error);
	}
	public function logout() {
		if ($this->_cookie) {
			$response = $this->proxy(
				array(
					'cmd'	=>	'Logout',
				));
			$this->_cookie='';
		}
	}
	public function geSetDND($asxPhone,$val) {
		$response = $this->proxy(
			array(
				'cmd'	=>	'SetDoNotDisturb',
				'device'	=>	$asxPhone->getName(),
				'doNotDisturbOn'	=>	$val?'true':'false',
			));
		return $response;
	}
	public function geCall($asxPhone,$call_number,$call_name='') {
		if (!trim($call_number)) return false;
		if ($this->_Asx->getObj($call_number)) {
			//Interner Anruf;
			$number=$call_number;
		} else {
			$number=$this->_Asx->cleanNumber($call_number);
			if ($this->_Asx->getCfg('cfg/phone/prefix') && !strpos($number,'+')===0) {
				$number=$this->_Asx->getCfg('cfg/phone/prefix').$number;
			}
			if (strlen($this->_Asx->getCfg('siemens/out_number'))) {
				$number=$this->_Asx->getCfg('siemens/out_number').''.$number;
			}
		}

		$response = $this->proxy(
			array(
				'cmd'	=>	'MakeCall',
				'callingDevice'	=>	$asxPhone->getName(),
				'calledDirectoryNumber'	=>	$number,
			));
		return $response;
	}
	public function geRedirect($asxPhone,$channel,$exten,$state='',$direct=false) {
		
		if ($exten==$asxPhone->getName()) {
			//Abheben
			$response = $this->proxy(
				array(
					'cmd'	=>	'AnswerCall',
					'deviceID'	=>	$asxPhone->getName(),
				));
		}elseif($state=='up') {
			//Aktives Gespräch
			//if ($direct) {
				$response = $this->proxy(
					array(
						'cmd'	=>	'TransferCall',
						'deviceID'	=>	$asxPhone->getName(),
						'transferredTo'	=>	$exten,
					));
			/*} else {
				//Auf Hold setzten und Conultation Call anstossen;
				if ($this->geHold($asxPhone,$channel)) {
					$this->geCall($asxPhone,$exten,'');
					$this->_Asx->saveCall($channel,'held',array('exten'=>$exten));
				}
				
			}*/
		} else {
			//Noch nicht aktives Gespräch
			$response = $this->proxy(
				array(
					'cmd'	=>	'DeflectCall',
					'deviceID'	=>	$asxPhone->getName(),
					'newDestination'	=>	$exten,
				));
		}
	/*
		debug($response);*/
		return $response;

	}
	public function geHold($asxPhone,$channel) {
		$response = $this->proxy(
			array(
				'cmd'	=>	'HoldCall',
				'deviceID'	=>	$asxPhone->getName(),
			));
		return $response?false:true;
	}
	public function geRetrieve($asxPhone,$channel) {
		$response = $this->proxy(
			array(
				'cmd'	=>	'RetrieveCall',
				'deviceID'	=>	$asxPhone->getName(),
			));
		return $response?false:true;
	}
	public function geHangup($asxPhone,$channel) {
		$response = $this->proxy(
			array(
				'cmd'	=>	'ClearConnection',
				'deviceID'	=>	$asxPhone->getName(),
			));
		return $response;
	}
	public function geWaitEvent($asxPhone) {
	//	
		$data = $this->proxy(
			array(
				'cmd'	=>	'GetEvents',
				'deviceObject'	=>	$asxPhone->getName(),
			),true);

		if (isset($data->error)) {
			if ($data->error==0) {
				return $data->events;
			}
			if ($data->error==1) {
				throw new Exception('Monitoring not started');
			}
		}
		return false;
	}
	public function geMonitorStart($asxPhone) {
		$data = $this->proxy(
			array(
				'cmd'	=>	'MonitorStart',
				'deviceObject'	=>	$asxPhone->getName(),
			),true);
		if (isset($data->error) && $data->error==0) {
			return true;
		}
		return 0;
	}
	public function geMonitorStop($asxPhone) {
		$data = $this->proxy(
			array(
				'cmd'	=>	'MonitorStop',
				'deviceObject'	=>	$asxPhone->getName(),
			));
		return $data;
	}
	public function geSetDisplay($asxPhone,$text) {
		$response = $this->proxy(
			array(
				'cmd'	=>	'SetDisplay',
				'device'	=>	$asxPhone->getName(),
				'contentsOfDisplay'=>$text,
			));
			
		//debug($response);
		return $response;
	}
	public function geClearDisplay($asxPhone) {
		$response = $this->proxy(
			array(
				'cmd'	=>	'ClearDisplay',
				'device'	=>	$asxPhone->getName(),
			));
		return $response;
	}
	public function geGetAllPhones() {
		$result=array();
		$rows=0;
		$entries=$this->_Asx->listPhones($rows,array());
		foreach ($entries as $v) {
			$obj=new AsxEventSiemens();
			$obj->id=$v->getId();
			$obj->phoneAddress='';
			$obj->phoneStatus='';
			$obj->pcAddress=$v->getMeta('PcAddress');
			$obj->pcUser=$v->getMeta('FKUserID');
			$obj->pcContext=$v->getMeta('CallContext');
			$result[]=$obj;
		}
		return $result;
	}

	public function getCookie() {
		return $this->_cookie;
	}
	public function setCookie($v) {
		$this->_cookie=$v;
	}

	protected function proxy($parameters,$json=0) {
		$getArguments = "";
		if(is_array($parameters) && !empty($parameters) ) {
			$sep= "?";
			foreach ($parameters as $k=>$v) {
				$getArguments .= $sep. $k . "=" . rawurlencode($v);
				$sep='&';
			}
		}
		$url = $this->_Asx->getCfg('siemens/url') . $getArguments;
		//debug($url);
		$_curl = curl_init();
		if( $this->_cookie ) {
			curl_setopt($_curl, CURLOPT_COOKIE, $this->_cookie);
		}
		curl_setopt($_curl, CURLOPT_URL, $url);
		curl_setopt($_curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($_curl, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($_curl, CURLOPT_HEADER, 1);

		$output = curl_exec($_curl);
		$header_size = curl_getinfo($_curl, CURLINFO_HEADER_SIZE);
		curl_close($_curl);

		if( !$this->_cookie ) {
			$cookies=array();
			if(preg_match('/^Set-Cookie: (.*?);/mi', $output, $cookies)) {
				$this->_cookie = $cookies[1];
			}
		}
		$response = substr($output, $header_size);
		//debug(htmlspecialchars($response));
		/*
		$fp=fopen('/tmp/asx.log','a+');
		fwrite($fp,$url."\n");
		fwrite($fp,$response);
		fclose($fp);
		*/
		if ($json) {
			if( !($res = @json_decode($response)) ) {
				$res=(object)array('error'=>'Unable to connect to remote server');
			}
		} else {
			if( ($res = simplexml_load_string($response))===false ) {
				$res=new SimpleXMLElement("<response><error>Unable to connect to remote server</error></response>");
			}
		}
		return($res);
	}	
}

