<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class BmngObj {
	var $_meta=array();
	var $_pmeta=array();
	var $_acl;
	var $_ID;
	function getID() {
		return $this->_ID;
	}
	function setID($ID) {
		$this->_ID=$ID;
	}
	function getMeta($key) {
		return $this->_meta[$key];
	}
	function setMeta($key,$data) {
		$this->_meta[$key]=$data;
	}
	function getParentMeta($key) {
		return $this->_pmeta[$key];
	}
	function setParentMeta($key,$data) {
		$this->_pmeta[$key]=$data;
	}
	function getName() {
		return $this->_meta['Title'];
	}
	function getACL($chk=0) {
		$chk=intval($chk);
		if ($chk) {
			if ($this->_acl==-1) {
				return true;
			} else {
				return ($this->_acl&$chk);
			}
		} else {
			return $this->_acl;
		}
	}
	function setAcl($acl) {
		$this->_acl==$acl;
	}
	function getStatus() {

	}
	function getAction($typ) {
		return $this->_action[$typ];
	}

}

class BObj_pfol extends BmngObj   {
	var $_action=array('b','b');
	function BObj_pfol ($ID=0,$meta=0,$pmeta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.=$this->getMeta('MenuImage');
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='pfol';
		if ($this->getMeta('Trash')) {
			$ac.='_tr';
		}
		if ($typ) $ac.='_l';
		return $ac;
	}
	function isFolder() {
		return true;
	}
}

class BObj_img extends BmngObj   {
	var $_action=array('vo','vo');
	function BObj_img($ID=0,$meta=0,$pmeta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/'.$this->getMeta('MenuImage');
		return $image;
	}
	function getActionMode() {
		$ac='img';
		if ($this->getMeta('Trash')) {
			$ac.='_tr';
		}
		return $ac;
	}
	function isFolder() {
		return false;
	}
}
class BObj_trash extends BmngObj  {
	var $_action=array('bt','bt');
	function BObj_trash($ID=0,$meta=0,$pmeta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.=$this->getMeta('MenuImage');
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='trash';
		if ($typ) {
			$ac.='_l';
		}
		return $ac;
	}
	function isFolder() {
		return true;
	}
}
class Bmng {
	var $_db;
	var $_uid;
	var $_lang;
	var $_gid;
	var $_frm;
	var $_rule=false;
	var $_sadmin=false;
	var $_clipboard=array();
	var $_modul='bmng';

	function Bmng (&$db,$uid=0,$gid=0,$lang=0) {
		global $frm;
		$this->_db=$db;
		$this->_uid=$uid;
		$this->_lang=$lang;
		$this->_gid=$gid;
		$this->_frm=$frm;
	}
	function getModul() {
		return $this->_modul;
	}
	function setCfg($cfg) {
		$this->_cfg=$cfg;
	}
	function getCfg($key) {
		return $this->_cfg[$key];
	}
	function setUser($uid) {
		$this->_uid=$uid;
	}
	function getUser() {
		return $this->_uid;
	}
	function setGroups($gid) {
		$this->_gid=$gid;
	}
	function setLang($lang) {
		$this->_lang=$lang;
	}
	function setRule($bool=false) {
		$this->_rule=$bool;
	}
	function setSuperAdmin($bool=false) {
		$this->_sadmin=$bool;
	}
	function isOwner(&$obj) {
		if ($obj->getMeta('UserCreate')==$this->_uid || $this->isRuleUser()) {
			return true;
		} else {
			return false;
		}
	}
	function setClipboard($what,$content) {
		$this->_clipboard[$what]=$content;
	}
	function getClipboard($what) {
		return $this->_clipboard[$what];
	}
	function isClipboard($what) {
		if ($this->_clipboard[$what]) {
			return true;
		} else {
			return false;
		}
	}
	function isRuleUser() {
		return $this->_rule;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function ListAllTree($RootID=-1,$order_f='Title',$order_d='asc',$app='',$status=0) {
		$result=array();
		if ($order_f) $order_met="ORDER BY $order_f $order_d";
                $where[]="FKImgID=ImgMetabase.ImgID";

		$sql_app=$this->_db->escape($app);
                if (is_array($app)) $where[]="DocType IN (".implode(",",$sql_app).")";
                elseif  ($app) $where[]="DocType=$sql_app";

		$sql_RootID=$this->_db->escape($RootID);
                if (is_array($RootID)) $where[]="RootID IN (".implode(",",$sql_RootID).")";
                elseif ($RootID!=-1)  $where[]="RootID=$sql_RootID";

		if (!$this->isRuleUser()) $where[]="(Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
                $query="SELECT * FROM ImgParent,ImgMetabase ";
		$query.=" WHERE  ".implode(' AND ',$where)." $order_met";
                //echo $query.'<br><br>';
                $this->_db->query($query);
                while ($this->_db->next_record()) {
			$class='BObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl) {
				$result[$this->_db->f("ParentID")][$this->_db->f("ImgID")]=new $class($this->_db->f("ImgID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}

		}
                 return $result;
        }
	function ListSubEntrys($ParentID,$app='',$order_f='Title',$order_d='asc') {
		$result=array();
          	if ($order_f) $order_met="ORDER BY $order_f $order_d";
                $where[]="FKImgID=ImgMetabase.ImgID";
		$where[]="ParentID=".$this->_db->escape($ParentID);

		$sql_app=$this->_db->escape($app);
                if (is_array($app)) $where[]="DocType IN (".implode(",",$sql_app).")";
                elseif  ($app) $where[]="DocType=$sql_app";
		if (!$this->isRuleUser()) $where[]="(Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";

		$query="SELECT * FROM ImgParent,ImgMetabase ";
		$query.=" WHERE  ".implode(' AND ',$where)." $order_met";
		//echo $query;
		$this->_db->query($query);
                while ($this->_db->next_record()) {
			$class='BObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl) {
				$result[$this->_db->f("ImgID")]=new $class($this->_db->f("ImgID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}

		}
                return $result;
	}
	function ListRoots($order_f='Title',$order_d='asc') {
		$result=array();
		if ($order_f) $order_met="ORDER BY $order_f $order_d";
		$where[]="FKImgID=RootID";
                $where[]="FKImgID=ImgMetabase.ImgID";
		if (!$this->isRuleUser()) $where[]="(Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
                $query="SELECT * FROM ImgParent,ImgMetabase ";
		$query.=" WHERE  ".implode(' AND ',$where)." $order_met";

                $this->_db->query($query);
                while ($this->_db->next_record()) {
			$class='BObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl) {
				$result[$this->_db->f("ImgID")]=new $class($this->_db->f("ImgID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}
		}
                return $result;
        }
	function listNumUsed($ParentID=0) {
		$result=array();
		$query="SELECT ImgObjects.FKImgID,count(*) as num FROM ImgObjects";
		$query.=" INNER JOIN ImgParent USING (FKImgID) WHERE ParentID=".$this->_db->escape($ParentID);
		$query.=" GROUP BY ImgObjects.FKImgID";
		$this->_db->query($query);
                while ($this->_db->next_record()) {
			$result[$this->_db->f("FKImgID")]=$this->_db->f("num");
		}
		return $result;
	}
	function getNumUsed($ObjID) {
		$query="SELECT ImgObjects.FKImgID,count(*) as num FROM ImgObjects";
		$query.=" WHERE FKImgID=".$this->_db->escape($ObjID);
		$query.=" GROUP BY ImgObjects.FKImgID";
		//echo $query;
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f("num");
		} else {
			return 0;
		}
	}
	function getUsedObjectIDs($ImgID) {
		$result=array();
		$query="SELECT * FROM ImgObjects";
		$query.=" WHERE FKImgID=".$this->_db->escape($ImgID);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("Modul")][]=$this->_db->f("FKObjID");
		}
		return $result;
	}
	function deleteImgUsed($Modul,$ObjID,$ImgTyp='cont') {
		$query="DELETE FROM ImgObjects";
		$query.=" WHERE Modul=".$this->_db->escape($Modul);
		$query.=" AND FKObjID=".$this->_db->escape($ObjID);
		$query.=" AND ImgTyp=".$this->_db->escape($ImgTyp);
		$this->_db->query($query);
	}
	function insertImgUsed($ImgID,$Modul,$ObjID,$ImgSize,$ImgPath,$ImgTyp='cont') {
		if ($ImgID) {
			$values=array(
				'FKImgID'=>$ImgID,
				'Modul'=>$Modul,
				'FKObjID'=>$ObjID,
				'UsedSize'=>''.$ImgSize,
				'ImgPath'=>$ImgPath,
				'ImgTyp'=>$ImgTyp,
			);
			$this->_db->insert('ImgObjects',$values,0,1);
		}
	}
	function getImgUsed($Modul,$ObjID,$ImgTyp='') {
		$result=array();
		$query="SELECT * FROM ImgObjects";
		$query.=" WHERE Modul=".$this->_db->escape($Modul);
		$query.=" AND FKObjID=".$this->_db->escape($ObjID);
		if ($ImgTyp) $query.=" AND ImgTyp=".$this->_db->escape($ImgTyp);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=array(
				'FKImgID'=>$this->_db->f("FKImgID"),
				'Modul'=>$this->_db->f("Modul"),
				'FKObjID'=>$this->_db->f("FKObjID"),
				'UsedSize'=>$this->_db->f("UsedSize"),
				'ImgPath'=>$this->_db->f("ImgPath"),
			);
		}
		return $result;
	}
	function copyImgUsed($Modul,$oObjID,$nObjID) {
		$used_img=$this->getImgUsed($Modul,$ObjID);
		foreach ($used_img as $val) {
			$this->insertImgUsed($val['FKImgID'],$val['Modul'],$nObjID,$val['UsedSize'],$val['ImgPath'],$val['ImgTyp']);
		}
	}
	function getImgID ($Content) {
		$query="SELECT ImgID FROM ImgMetabase";
		$query.=" WHERE Content=".$this->_db->escape($Content);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f("ImgID");
		} else {
			return 0;
		}
	}
	function insertImgTemp($ImgFile,$Modul,$ImgSize,$ImgPath) {
		if ($ImgFile) {
			$values=array(
				'ImgFile'=>$ImgFile,
				'Modul'=>$Modul,
				'UsedSize'=>''.$ImgSize,
				'ImgPath'=>$ImgPath,

			);
			$this->_db->insert('ImgTemp',$values,0,1);
		}
	}
	function updateMeta(&$obj) {
		$values=$obj->_meta;
		if ($obj->getID()) {
			$this->_db->update('ImgMetabase',$values,"ImgID=".$this->_db->escape($obj->getID()));
			return $obj->getID();
		}
		return false;
	}
	function insertMeta(&$obj) {
		$values=$obj->_meta;
		$values['ImgID']=$this->_db->nextid('ImgMetabase');
		if ($this->_db->insert('ImgMetabase',$values)) {
			$obj->setID($values['ImgID']);
			return $obj->getID();
		}
		return false;
	}
	function deleteMeta(&$obj) {
		$query="DELETE FROM ImgMetabase WHERE ImgID=".$this->_db->escape($obj->getID());
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function updateParentMeta(&$obj) {
		$values=$obj->_pmeta;
		if ($obj->getID()) {
			$this->_db->update('ImgParent',$values,"FKImgID=".$this->_db->escape($obj->getID()));
			return $obj->getID();
		}
		return false;
	}
	function insertParentMeta(&$obj) {
		$values=$obj->_pmeta;
		if ($obj->getID()) {
			$values['FKImgID']=$obj->getID();
			$this->_db->insert('ImgParent',$values);
			return $obj->getID();
		}
		return false;
	}
	function deleteParentMeta(&$obj) {
		$query="DELETE FROM ImgParent WHERE FKImgID=".$this->_db->escape($obj->getID());
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function getObj($ID) {
		$query="SELECT * FROM ImgMetabase,ImgParent WHERE FKImgID=ImgID AND ImgID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='BObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl) {
				return new $class($this->_db->f("ImgID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}
		}
	}
	function getTrashObj() {
		$query="SELECT * FROM ImgMetabase,ImgParent WHERE FKImgID=ImgID AND DocType='trash'";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='BObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl) {
				return new $class($this->_db->f("ImgID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}
		}
	}
	function getSystemFolderObj() {
		$query="SELECT * FROM ImgMetabase,ImgParent WHERE FKImgID=ImgID AND DocType='pfol' AND System=1";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='BObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl) {
				return new $class($this->_db->f("ImgID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}
		}
	}
	function getObjTree ($oid) {
		do {
			$query="SELECT Title,ParentID FROM ImgMetabase,ImgParent WHERE ParentID=ImgID AND FKImgID!=RootID AND FKImgID=".$this->_db->escape($oid);
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				$oid=$this->_db->f('ParentID');
				$result[$this->_db->f('ParentID')]=$this->_db->f('Title');
			} else {
				$oid=0;
			}

		} while ($oid);
		return $result;
	}
	function getObjTreeIDs ($oid,$break=0) {
		if ($oid!=$break) {
			do {
				$query="SELECT ParentID FROM ImgParent WHERE FKImgID=".$this->_db->escape($oid);
				$this->_db->query($query);
				if ($this->_db->next_record()) {
					$oid=$this->_db->f('ParentID');
					$result[]=$this->_db->f('ParentID');
				} else {
					$oid=0;
				}

			} while ($oid && $oid!=$break);
		} else {
			$result[]=$oid;
		}
		return $result;
	}
	function isSubfolder($FolderID,$subFolderID) {
		if ($FolderID==$subFolderID) return true;
		$tree=$this->getObjTreeIDs ($FolderID);
		if (is_array($tree) && in_array($subFolderID,$tree)) {
			return true;
		} else {
			return false;
		}
	}
	function getID_Md5($MD5) {
		if ($MD5) {
			$query="SELECT ImgID FROM ImgMetabase";
			$query.=" WHERE Trash=0 AND Md5Sum=".$this->_db->escape($MD5);
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				return $this->_db->f("ImgID");
			}
		}
		return 0;
	}
	function &fetchACL() {
		if ($this->isRuleUser()) {
			return -1;
		} else {
			return $this->_frm->calcAcl($this->_db->f('Users'),$this->_db->f('Groups'),$this->_uid);
		}
	}
	function &fetchObject() {
		return array(
			'Title'=>$this->_db->f("Title"),
			'Text'=>$this->_db->f("Text"),
			'MenuImage'=>$this->_db->f("MenuImage"),
			'Version'=>$this->_db->f('Version'),
			'TimeCreate'=>$this->_db->f("TimeCreate"),
			'TimeModify'=>$this->_db->f("TimeModify"),
			'UserCreate'=>$this->_db->f("UserCreate"),
			'UserModify'=>$this->_db->f("UserModify"),
			'DocType'=>$this->_db->f("DocType"),
			'Users'=>$this->_db->f("Users"),
			'Groups'=>$this->_db->f("Groups"),
			'Content'=>$this->_db->f('Content'),
			'Size'=>$this->_db->f('Size'),
			'Width'=>$this->_db->f('Width'),
			'Height'=>$this->_db->f('Height'),
			'Trash'=>$this->_db->f('Trash'),
			'Md5Sum'=>$this->_db->f('Md5Sum'),
			'System'=>$this->_db->f('System'),
		);
	}
	function &fetchParent() {
		return array(
			'ParentID'=>$this->_db->f('ParentID'),
			'RootID'=>$this->_db->f('RootID'),
		);
	}

	function isAllowedAction(&$obj,&$action) {
		if (!is_array($action)) return false;
		if (!$obj->getAcl($action['Perms'])) return false;
		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkAction($obj,substr($ac_val,1));
				} else {
					$result=$result||$this->_checkAction($obj,$ac_val);
				}
			}
			if (!$result) return false;
		}
		return true;
	}
	function _checkAction(&$obj,$action) {
		switch ($action) {
			case 'sadmin':
				if (!$this->isSuperAdmin()) return false;
			break;
			case 'rule':
				if (!$this->isRuleUser()) return false;
			break;
			case 'locked':
				if (!$this->isLocked($obj)) return false;
			break;
			case 'owner':
				if (!$this->isOwner($obj)) return false;
			break;
			case 'content':
				if (!$this->isClipboard('bobj')) return false;
			break;
			case 'root':
				if ($obj->getParentMeta('RootID')!=$obj->getID()) return false;
			break;
			case 'used':
				if (!$this->getNumUsed($obj->getID())) return false;
			break;
		}
		return true;
	}

	function copyImage($img,$to_img='') {
		if ($img && file_exists($this->getCfg('OrigPath').'/'.$img) && ($info=getimagesize($this->getCfg('OrigPath').'/'.$img))) {
			if (!$to_img) {
				switch ($info[2]) {
					case 1: $ext='.gif';
						break;
					case 2: $ext='.jpg';
						break;
					case 3: $ext='.png';
						break;
					default: $ext='.jpg';
				}
				$fname=tempnam($this->getCfg('OrigPath'),'img');
				@unlink($fname);
				$fname=basename($fname).$ext;
			}
			copy ($this->getCfg('OrigPath').'/'.$img,$this->getCfg('OrigPath').'/'.$fname);
			copy ($this->getCfg('ThumbPath').'/'.$img,$this->getCfg('ThumbPath').'/'.$fname);
			return $fname;
		} else {
			return '';
		}
	}
	function saveContent($file,$dest='') {
		if (file_exists($file) && ($info=getimagesize($file))) {
			switch ($info[2]) {
				case 1:
					$ext='.gif';
					break;
				case 2:
					$ext='.jpg';
					break;
				case 3:
					$ext='.png';
					break;
				default:
					$ext='.jpg';
   			}
			if (!$dest) {
				$image=tempnam($this->getCfg('OrigPath'),'img');
				@unlink($image);
				$image=$this->getCfg('OrigPath').'/'.basename($image).$ext;
			} else {
				@unlink($this->getCfg('OrigPath').'/'.$dest);
				@unlink($this->getCfg('ThumbPath').'/'.$dest);
				$dest=substr($dest,0,strrpos($dest,'.')).$ext;
				$image=$this->getCfg('OrigPath').'/'.$dest;
			}
			$result=$this->_resize($file,$image,$info,$this->getCfg('OrigSize'),0);
			if (!$result) return false;
			$info=getimagesize($image);
			$result=$this->_resize($image,$this->getCfg('ThumbPath').'/'.basename($image),$info,$this->getCfg('ThumbSize'),$this->getCfg('ThumbSize'));
			if (!$result) return false;
			@unlink($file);
			return $image;
		} else {
			return false;
		}
	}
	function &saveImage(&$parent_obj,$file,$title,$dest=''){
		if (!is_object($parent_obj)) return false;
		$image=$this->saveContent($file,$dest);
		if ($image && ($info=getimagesize($image))) {
			$version=$this->getLastImageVersion($title) + 1;
			if (!$title) $title=basename($image);
			$img_obj=new BObj_img();
			$img_obj->setMeta('Title',$title);
			$img_obj->setMeta('Version',$version);
			$img_obj->setMeta('TimeCreate',time());
			$img_obj->setMeta('TimeModify',time());
			$img_obj->setMeta('UserCreate',$this->getUser());
			$img_obj->setMeta('UserModify',$this->getUser());
			$img_obj->setMeta('DocType','img');
			$img_obj->setMeta('Users',$parent_obj->getMeta('Users'));
			$img_obj->setMeta('Groups',$parent_obj->getMeta('Groups'));
			$img_obj->setMeta('Content',basename($image));
			$img_obj->setMeta('Size',filesize($image));
			$img_obj->setMeta('Width',$info[0]);
			$img_obj->setMeta('Height',$info[1]);
			$img_obj->setMeta('Md5Sum',Framework::getMd5Sum($image));
			if ($this->insertMeta($img_obj)) {
				$img_obj->setParentMeta('ParentID',$parent_obj->getID());
				$img_obj->setParentMeta('RootID',$parent_obj->getParentMeta('RootID'));
				$this->insertParentMeta($img_obj);
			}
			return $img_obj;
		} else return false;
        }
	function updateImage(&$img_obj,$file) {
		$image=$this->saveContent($file,$img_obj->getMeta('Content'));

		if ($image && ($info=getimagesize($image))) {
			$img_obj->setMeta('UserModify',$this->getUser());
			$img_obj->setMeta('TimeModify',time());
			$img_obj->setMeta('Content',basename($image));
			$img_obj->setMeta('Size',filesize($image));
			$img_obj->setMeta('Width',$info[0]);
			$img_obj->setMeta('Height',$info[1]);
			$img_obj->setMeta('Md5Sum',Framework::getMd5Sum($image));
			$this->updateMeta($img_obj);
			return true;
		} else {
			return false;
		}
	}
	function deleteImage (&$obj) {
		$image=$obj->getMeta('Content');
		if ($image) {
			if (file_exists($this->getCfg('OrigPath').'/'.$image)) {
				unlink($this->getCfg('OrigPath').'/'.$image);
			}
			if (file_exists($this->getCfg('ThumbPath').'/'.$image)) {
				unlink($this->getCfg('ThumbPath').'/'.$image);
			}
		}
	}
	function getLastImageVersion($title) {
		$query="SELECT max(Version) as num FROM ImgMetabase WHERE DocType='img' AND Title=".$this->_db->escape($title);
		$this->_db->query($query);
		$this->_db->next_record();
		return intval($this->_db->f('num'));
	}
	function versionExists($title,$version) {
		$query="SELECT ImgID FROM ImgMetabase WHERE DocType='img' AND Version=".$this->_db->escape($version)." AND Title=".$this->_db->escape($title);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('ImgID');
		} else {
			return false;
		}
	}
	function deleteUnusedImg() {
		$i=0;
		$query="SELECT ImgTemp.* FROM ImgTemp LEFT JOIN  ImgMetabase ON (Content=ImgFile) ";
		$query.="LEFT JOIN ImgObjects ON (ImgID=FKImgID AND ImgObjects.UsedSize=ImgTemp.UsedSize AND ImgObjects.ImgPath=ImgTemp.ImgPath) ";
		$query.="WHERE FKImgID IS NULL";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$img_name=$this->_db->f('ImgPath').'/'.$this->_db->f('UsedSize').'_'.$this->_db->f('ImgFile');
			if (file_exists($img_name)) {
				unlink($img_name);
			}
			$where[$i]='(';
			$where[$i].='ImgFile='.$this->_db->escape($this->_db->f('ImgFile'));
			$where[$i].=' AND Modul='.$this->_db->escape($this->_db->f('Modul'));
			$where[$i].=' AND UsedSize='.$this->_db->escape($this->_db->f('UsedSize'));
			$where[$i].=' AND ImgPath='.$this->_db->escape($this->_db->f('ImgPath'));
			$where[$i].=')';
			$i++;
		}
		if ($i) {
			$query="DELETE FROM ImgTemp WHERE ".implode(' OR ',$where);
			$this->_db->query($query);
		}
	}
	function UplaodImage (&$obj,$File,$ImgTitle,&$ActionError,$dest='') {
		$result=array();
		//print_r($File);
		if ($obj->isFolder() && $File['tmp_name'] && file_exists($File['tmp_name'])) {
			$images=$titles=array();
			if (FrameWork::getMimeFile($File['tmp_name'])=="application/x-zip") {
				$images=FrameWork::importZip($File['tmp_name']);
				$titles=array_map('basename',$images);
			} else {
				$images[]=$File['tmp_name'];
				if (!trim($ImgTitle)) {
					$titles[]=$File['name'];
				} else {
					$titles[]=$ImgTitle;
				}
			}
			foreach ($images as $key=>$val) {
				//echo $val.'<br>';
				$nobj=$this->saveImage($obj,$val,$titles[$key],$dest);
				if (!is_object($nobj)) {
					$ActionError['no_img_file'][]=($titles[$key]?$titles[$key]:basename($val));
				} else {
					$result[]=&$nobj;
				}
			}
		} else {
			$ActionError['no_valid_file']=1;
		}
		return $result;
	}
	function _resize($source,$dest,$size=0,$maxwidth=0,$maxheight=0,$force=0){
		if (!$size) {
			$size=@getimagesize($source);
			if (!$size) return 0;
		}
		if (!$maxwidth) $maxwidth=$size[0];
		if (!$maxheight) $maxheight=$size[1];
		if ($force) {
			$geometry=$maxwidth.'x'.$maxheight;
		} else {
			if ($size[0]<=$maxwidth && $size[1]<=$maxheight) {
				$geometry=$size[0]."x".$size[1];
			} else {
				$propx=$maxwidth/$size[0];
				$propy=$maxheight/$size[1];

				$prop=($propx<$propy)?$propx:$propy;
				//echo $prop.'<br>';
				$x=intval($size[0]*$prop);
				$y=intval($size[1]*$prop);
				if (!$x) $x=1;
				if (!$y) $y=1;
				$geometry=$x.'x'.$y;
				//echo $geometry.'<br>';
			}
		}
		if ($size[2]==2) $quality="-quality ".$this->getCfg('JPEGquality');
		/*-limit memory 32 -limit map 64 -limit area 10 -limit disk 500*/
		$exec="convert -geometry ".$geometry."! +profile '*' $quality -colorspace 'RGB' '$source' $dest";
		exec($exec,$res);
		if (file_exists($dest)) {
			return $dest;
		} else {
			return false;
		}

	}
	function filterImage($file,$filter){
		if (file_exists($file) && ($info=getimagesize($file))) {
			$forder=array(
				'resize',
				'crop',
				'modulate',
				'gamma',
				'sharpen',
				'raise',
				'normalize',
			);
			$quality='';
			switch ($info[2]) {
				case 1: $ext='.gif';
					break;
				case 2: $ext='.jpg';
					$quality="-quality ".$this->getCfg('JPEGquality');
					break;
				case 3: $ext='.png';
					break;
				default: $ext='.jpg';
			}

			$fname=tempnam(Framework::getTempPath(),'img');
			@unlink($fname);
			$fname=$fname.$ext;
			foreach ($forder as $key) {
				$val=$filter[$key];
				switch ($key) {
					case 'modulate':
						if ($val[b]!=0 || $val[s]!=0 || $val[h]!=0) {
							$query.=' -modulate '.(100+$val[b]).','.(100+$val[s]).','.(100+$val[h]);
						}
	   				break;
					case 'gamma':
						if ($val) {
							if ($val>0) $val=1+($val/50);
							else $val=1+($val/100);
							$query.=' -gamma '.$val;
						}
					break;
					case 'sharpen':
						if ($val>0) {
							$query.=str_repeat(" -sharpen 0",$val);
						}
						if ($val<0) {
							$query.=str_repeat(" -blur 0",abs($val));
						}
	   				break;
					case 'raise':
						if ($val>0) {
							$query.=" -raise ".$val."x".$val;
						}
	   				break;
					case 'resize':
						if ($val!=$info[0]) {
							$tmp_x=$val/$info[0];
							$info[0]=$val;
							$info[1]=round($tmp_x*$info[1]);
							$query.=" -geometry ".$info[0]."x".$info[1].'!';

						}
					break;
					case 'crop':
						if ($val[l]!=0 || $val[r]!=0 || $val[t]!=0 || $val[b]!=0) {
							$c_w=$info[0]-$val[l]-$val[r];
							$c_h=$info[1]-$val[t]-$val[b];
							$query.=" -crop ".$c_w."x".$c_h."+".$val[l]."+".$val[t];


						}
					break;
					case 'normalize':
						if ($val=='checked') {
							$query.=' -normalize';
						}
					break;
				}
			}
			/*-limit memory 32 -limit map 64 -limit area 10 -limit disk 500*/
			$exec="convert $query $quality $file $fname";
			exec($exec,$res);
			if (file_exists($fname)) {
				return $fname;
			} else return false;
		} else return false;
	}
}
?>
