<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
function CutCopyObject (&$obj,&$new_obj,$mode,$first=true) {
	global $Bmng,$frm,$obj_action;

	if (is_object($new_obj)) {
		$ac_mode=$mode;

		if ($mode!='cut' || $first) {
			$this_action=$frm->getObjAction ($Bmng->getModul(),$new_obj->getActionMode(0),$ac_mode);
			if ($Bmng->isAllowedAction($new_obj,reset($this_action)) && $Bmng->isAllowedAction($obj,$obj_action['n_'.$new_obj->getMeta('DocType')])) {
				if ($new_obj->isFolder() && $Bmng->isSubfolder($obj->getID(),$new_obj->getID())) {
					return array('to_self',$new_obj->getID());
				}
				if ($new_obj->getParentMeta('ParentID')==$obj->getID()) {
					if ($mode=='cut') {
						return;
					} elseif ($mode=='copy') {
						//$new_obj->setMeta('MenuTitle','copy of '.$new_obj->getMeta('MenuTitle'));
					} elseif ($mode=='link' ) {
						//$new_obj->setMeta('MenuTitle','link to '.$new_obj->getMeta('MenuTitle'));
					}
				}
				if (!$new_obj->isFolder() || $mode=='copy') {
					$new_obj->setMeta('Users',$obj->getMeta('Users'));
					$new_obj->setMeta('Groups',$obj->getMeta('Groups'));
				}

				$new_obj->setMeta('TimeModify',time());
				$new_obj->setMeta('UserModify',$Bmng->getUser());
				$new_obj->setMeta('Trash',$obj->getMeta('Trash'));
				$new_obj->setParentMeta('ParentID',$obj->getID());
				$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
				$oldVersion=$new_obj->getMeta('Version');
				$oldID=$new_obj->getID();
				if ($mode=='cut') {
					$Bmng->updateMeta($new_obj);
					$Bmng->updateParentMeta($new_obj);
				} elseif ($mode=='copy') {
					$new_obj->setMeta('TimeCreate',time());
					$new_obj->setMeta('UserCreate',$Bmng->getUser());
					$new_obj->setMeta('Version',1);
					if (!$new_obj->isFolder()) {
						if ($mode=='copy') {
							if ($new_obj->getMeta('DocType')=='img') {
								$content=$Bmng->copyImage($new_obj->getMeta('Content'));
								if ($content) {
									$new_obj->setMeta('Content',$content);
								} else {
									return array("no_".$mode."_perms",$new_obj->getID());
								}

							}
						}
					}
					$Bmng->insertMeta($new_obj);
					$Bmng->insertParentMeta($new_obj);
				}
				if ($new_obj->isFolder()) {
					$sub_entrys=$Bmng->ListSubEntrys($oldID,'');
					foreach ($sub_entrys as $tmp_obj) {
						CutCopyObject($new_obj,$tmp_obj,$mode,false);
					}
				}
			} else {

				return array("no_".$mode."_perms",$new_obj->getID());
			}
		} else {
			$new_obj->setMeta('Trash',$obj->getMeta('Trash'));
			$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
			$Bmng->updateMeta($new_obj);
			$Bmng->updateParentMeta($new_obj);
			$oldID=$new_obj->getID();
			if ($new_obj->isFolder()) {
				$sub_entrys=$Bmng->ListSubEntrys($oldID,'',0);
				foreach ($sub_entrys as $tmp_obj) {
					CutCopyObject($new_obj,$tmp_obj,$mode,false);
				}
			}
		}
	}
	return false;
}


function TrashObject (&$obj,&$new_obj,$first=1) {
	global $Bmng,$frm;
	$error=false;
	if (is_object($new_obj)) {
		$this_action=$frm->getObjAction ($Bmng->getModul(),$new_obj->getActionMode(0),'delete');
		if ($new_obj->getParentMeta('RootID')==$obj->getParentMeta('RootID')) {
			return;
		}
		if ($Bmng->isAllowedAction($new_obj,reset($this_action))) {

			$new_obj->setMeta('TimeModify',time());
			$new_obj->setMeta('UserModify',$Bmng->getUser());
			$new_obj->setMeta('Trash',1);
			$new_obj->setParentMeta('ParentID',$obj->getID());
			$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));

			if ($new_obj->isFolder()) {
				$oldObj=Framework::cloneObj($new_obj);
				$Bmng->insertMeta($new_obj);
				$Bmng->insertParentMeta($new_obj);
				$sub_entrys=$Bmng->ListSubEntrys($oldObj->getID());
				if (!empty($sub_entrys)) {
					$sub_ok=0;
					foreach ($sub_entrys as $tmp_obj) {
						$tmp_error=TrashObject($new_obj,$tmp_obj,0);
						if ($tmp_error) {
							$error=array('no_sub_del_perms',$oldObj->getID());
						} else {
							$sub_ok++;
						}
					}
					if (!$sub_ok) {
						$Bmng->deleteParentMeta($new_obj);
						$Bmng->deleteMeta($new_obj);
					}
				}
				if (!$error) {
					$Bmng->deleteParentMeta($oldObj);
					$Bmng->deleteMeta($oldObj);
				}
			} else {
				$Bmng->updateMeta($new_obj);
				$Bmng->updateParentMeta($new_obj);

			}

		} else {
			return array('no_del_perms',$new_obj->getID());
		}
	}
	return $error;
}
function DeleteObject (&$new_obj) {
	global $Bmng,$frm;
	if (is_object($new_obj)) {
		$this_action=$frm->getObjAction ($Bmng->getModul(),$new_obj->getActionMode(0),'f_delete');
		if ($Bmng->isAllowedAction($new_obj,reset($this_action))) {
			if ($new_obj->isFolder()) {
				$sub_entrys=$Bmng->ListSubEntrys($new_obj->getID(),'');
				foreach ($sub_entrys as $tmp_obj) {
					DeleteObject($tmp_obj);
				}
			}
			switch ($new_obj->getMeta('DocType')) {
				case 'img':
					$Bmng->deleteImage($new_obj);
				break;
			}
			$Bmng->deleteParentMeta($new_obj);
			$Bmng->deleteMeta($new_obj);
		} else {
			return array('no_del_perms',$new_obj->getID());
		}
	}
	return false;
}

?>
