<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class CalEvent {
	var $db;
	var $uid=0;
	var $auth_uid=0;
	var $gid=array();
	var $auth_gid=array();
	var $_modul='cal';

	function CalEvent() {
		global $db,$frm;
		$this->_db=&$db;
		$this->_auth_uid=$this->_uid=$frm->getUser();
		$this->_auth_gid=$this->_gid=$frm->getMyGroups();
		$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
		$this->setRule($frm->isRuleUser(array('sysadmin','cal')));
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->_frm=$frm;
	}
	function getModul() {
		return $this->_modul;
	}
	function setUser($uid) {
		$this->_uid=$uid;
		if ($this->_uid==$this->_frm->getUser()) {
			$this->setGroup($this->_frm->getMyGroups());
		} else {
			$this->setGroup($this->_frm->getUserGroups($this->_uid));
		}
	}
	function setAuthUser($uid) {
		$this->_auth_uid=$uid;
	}
	function setAuthGroup($gid) {
		$this->_auth_gid=$gid;
	}
	function setGroup($gid) {
		$this->_gid=$gid;
	}
	function getGroup() {
		return $this->_gid;
	}
	function getUser() {
		return $this->_uid;
	}
	function getAuthUser() {
		return $this->_auth_uid;
	}
	function setCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}
		}
	}
	function getCfg($key) {
		if (isset($this->_cfg[$key])) {
			return $this->_cfg[$key];
		} else {
			return false;
		}
	}
	function setRule($bool=false) {
		$this->_rule=$bool;
	}
	function isRuleUser() {
		if ($this->_sadmin || $this->_rule) {
			return true;
		} else {
			return false;
		}
	}
	function setSuperAdmin($bool=false) {
		$this->_sadmin=$bool;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function date_dist_cmp ($date1,$date2) {
        	if (date("I",$date1)!=date("I",$date2)) {
                	return date("I",$date1)?-3600:+3600;
         	}
         	return 0;
	}
	function getPerms($ID,$GID=0,$typ=0,$drefGroups=true) {
		$cid=md5($ID.'-'.implode(',',$GID).'-'.$typ.'-'.$drefGroups);
		if (!isset($this->cache[$cid])) {
			$result=array();
			if (!$typ || $typ==='user') {
				$query="SELECT Perms FROM ACL WHERE ID=".$this->_db->escape($ID)." AND Typ='user' AND Modul='cal'";
				$this->_db->query($query);
				while ($this->_db->next_record()) {
					$temp=explode(',',$this->_db->f('Perms'));
					if (!$temp[0]) continue;
					if ($temp[0][0]=='@' && $drefGroups) {
						foreach ($this->_frm->getGroupUsers(substr($temp[0],1)) as $uid) {
							if ($uid==$ID) continue;
							//debug($uid);
							if (!isset($result[$uid])) $result[$uid]=0;
							$result[$uid]=$result[$uid] | intval($temp[1]);
						}
					} else {
						if (!isset($result[$temp[0]])) $result[$temp[0]]=0;
						$result[$temp[0]]=$result[$temp[0]] | intval($temp[1]);
					}
				}
			}
			//debug($result);
			if (!$typ || $typ==='group') {
				if (is_array($GID)) {
					$query="SELECT Perms FROM ACL WHERE ID IN ('".implode("','",$GID)."') AND Typ='group' AND Modul='cal'";
					$this->_db->query($query);
					while ($this->_db->next_record()) {
						$temp=explode(',',$this->_db->f('Perms'));
						if (!$temp[0]) continue;
						if ($temp[0][0]=='@' && $drefGroups) {
							//debug(substr($temp[0],1));
							foreach ($this->_frm->getGroupUsers(substr($temp[0],1)) as $uid) {
								if ($uid==$ID) continue;
								//debug($uid);
								if (!isset($gperms[$uid])) $gperms[$uid]=0;
								$gperms[$uid]=$gperms[$uid] | intval($temp[1]);
							}
						} else {
							if ($temp[0]==$ID) continue;
							if (!isset($gperms[$temp[0]])) $gperms[$temp[0]]=0;
							$gperms[$temp[0]]=$gperms[$temp[0]] | intval($temp[1]);
						}
					}
					if (is_array($gperms)) {
						foreach ($gperms as $key=>$val) {
							if ('group'===$typ || !isset($result[$key])) $result[$key]=intval($val);
						}
					}
				}
			}
			$this->cache[$cid]=$result;
		}
		return $this->cache[$cid];
	}
	function getAllPerms($typ='user') {
		$result=array();
		$query="SELECT * FROM ACL WHERE Modul='cal' AND Typ=".$this->_db->escape($typ);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$temp=explode(',',$this->_db->f('Perms'));
			$result[$this->_db->f('ID')][$temp[0]]=max($result[$this->_db->f('ID')][$temp[0]],$temp[1]);
		}
		return $result;
	}
	function insertPerms($ID,$user,$typ='user') {
		$this->deletePerms($ID,array_keys($user),$typ);
		foreach ($user as $key=>$val) {
			$values=array(
				'ID'=>$ID,
				'Typ'=>$typ,
				'Modul'=>$this->getModul(),
				'Perms'=>$key.','.$val,
			);
			//debug($values);
			$this->_db->insert('ACL',$values);
		}
	}
	function setAllCalPerms($perms) {
		$this->_cpermsAll=$perms;
		//debug($perms);
	}
	function setCalPerms($perms) {
		$this->_cperms=$perms;
	}
	function getCalPerms($perms=0) {
		if ($perms) {
			return ($this->_cperms&$perms);
		} else {
			return $this->_cperms;
		}
	}
	function getAllCalPerms($uid,$perms=0) {
		if ($perms) {
			return ($this->_cpermsAll[$uid]&$perms);
		} else {
			return $this->_cpermsAll;
		}
	}
	function deletePerms($ID,$user,$typ='user') {
		$query="DELETE FROM ACL WHERE Typ=".$this->_db->escape($typ)." AND Modul=".$this->_db->escape($this->getModul());
		$query.=" AND ID=".$this->_db->escape($ID);
		if (is_array($user)) {
			$query.=" AND (Perms LIKE '".implode(",%' OR Perms LIKE '",array_map('addslashes',$user)).",%')";
		} elseif ($user) {
			$query.=" AND (Perms LIKE ".$this->_db->escape("$user,%").")";
		} else return 0;
		//echo $query;
		$this->_db->query($query);
	}
	function hasProjectEntrys($projID) {
		$query = "SELECT EventID FROM CalEvent ";
		$query.=" WHERE FKProjID=".$this->_db->escape($projID);
		$query.=" AND Deleted=0";
		$query.=" ".$this->_db->formatLimit(0,1);
		$this->_db->query($query);
		if($this->_db->next_record()) {
			return true;
		} else {
			return false;
		}
	}
	function getAllInvitationIds($startDate,$endDate,$projID=0) {
		$query = "SELECT CalEvent.EventID FROM CalEvent,CalEventUser as us WHERE EventID=us.FKEventID AND us.UserPerms=0 AND CalEvent.NoInvit=0 AND Deleted=0";
		$query.= "AND (CalEvent.InvitUsers!='' OR  CalEvent.InvitGroups!='')";
		if (is_array($this->_uid)) {
			$query .="AND ((us.UserType='u' AND us.UserID IN (".implode(",",$this->_db->escape($this->_uid)).")) ";
		} else {
			$query .="AND ((us.UserType='u' AND us.UserID=".$this->_db->escape($this->_uid).")  ";
		}
		if (is_array($this->_gid)) {
			$query .="OR (us.UserType='g' AND us.UserID IN (".implode(",",$this->_db->escape($this->_gid))."))) ";
		} else {
			$query .="OR (us.UserType='g' AND us.UserID=".$this->_db->escape($this->_gid)."))  ";
		}
		$query.="AND ((EndDate>=".$this->_db->escape($startDate)." AND StartDate<=".$this->_db->escape($endDate).") OR (RecType!=0 AND (RecEnd>=".$this->_db->escape($startDate)." OR RecEnd=-1)))";
		if ($projID) $query.=" AND FKProjID=".$this->_db->escape($projID);
		$query.=" GROUP BY EventID ";
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$result[]=$this->_db->f('EventID');
		}
		return $result;
	}
	function listGroupEvents($startDate,$endDate,$projID=0) {

		$evtIDs=$this->listEventIDs($startDate,$endDate,$projID);
		if (!empty($evtIDs)) {
			$ingoreUsers=array();
			$sqlQuery=array();
			$sqlQuery[]=array('Field'=>'FKEventID','Typ'=>'=','Values'=>$evtIDs);
			$sqlQuery[]=array('Field'=>'UserType','Typ'=>'=','Values'=>'u');
			$sqlQuery[]=array('Field'=>'UserDone','Typ'=>'=','Values'=>2);
			$query="SELECT FKEventID,UserID FROM CalUserDone WHERE ".$this->_db->getWhere($sqlQuery);
			$this->_db->query($query);
			while ($this->_db->next_record()) {
				$ingoreUsers[$this->_db->f('FKEventID')][]=$this->_db->f('UserID');
			}
			$sqlQuery=array();
			$sqlQuery[]=array('Field'=>'EventID','Typ'=>'F=F','Values'=>'us.FKEventID');
			$sqlQuery[]=array('Field'=>'us.UserPerms','Typ'=>'=','Values'=>0);
			$sqlQuery[]=array('Field'=>'EventID','Typ'=>'=','Values'=>$evtIDs);
			$query = "SELECT CalEvent.*,us.UserType,us.UserID FROM CalEvent,CalEventUser as us WHERE ".$this->_db->getWhere($sqlQuery);
			//debug($query);
			return $this->fetchEvents($startDate,$endDate,$query,3,$ingoreUsers);
		}
	}
	function listEventIDs($startDate,$endDate,$projID=0) {
		$query = "SELECT DISTINCT EventID FROM CalEvent,CalEventUser as us WHERE EventID=us.FKEventID AND Deleted=0 ";
		if (is_array($this->_uid)) {
			$query .="AND (( us.UserType='u' AND us.UserID IN (".implode(",",$this->_db->escape($this->_uid)).")) ";
		} else {
			$query .="AND (( us.UserType='u' AND us.UserID=".$this->_db->escape($this->_uid).")  ";
		}
		if (is_array($this->_gid)) {
			$query .="OR ( us.UserType='g' AND us.UserID IN (".implode(",",$this->_db->escape($this->_gid))."))) ";
		} else {
			$query .="OR ( us.UserType='g' AND us.UserID=".$this->_db->escape($this->_gid)."))  ";
		}
		$query.="AND ((EndDate>=".$this->_db->escape($startDate)." AND StartDate<=".$this->_db->escape($endDate).") OR (RecType!=0 AND (RecEnd>=".$this->_db->escape($startDate)." OR RecEnd=-1)))";
		if ($projID) $query.=" AND FKProjID=".$this->_db->escape($projID);
		$result=array();
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('EventID');
		}
		return $result;
	}


	function listInfos($startDate,$endDate,$projID=0) {
		$query = "SELECT CalEvent.* FROM CalEvent,CalEventUser as us  WHERE EventID=us.FKEventID AND Deleted=0 AND us.UserPerms=1 ";
		if (is_array($this->_uid)) {
			$query .="AND ((us.UserType='u' AND us.UserID IN (".implode(",",$this->_db->escape($this->_uid)).")) ";
		} else {
			$query .="AND ((us.UserType='u' AND us.UserID=".$this->_db->escape($this->_uid).")  ";
		}
		if (is_array($this->_gid)) {
			$query .="OR (us.UserType='g' AND us.UserID IN (".implode(",",$this->_db->escape($this->_gid))."))) ";
		} else {
			$query .="OR (us.UserType='g' AND us.UserID=".$this->_db->escape($this->_gid)."))  ";
		}
		$query.="AND ((EndDate>=".$this->_db->escape($startDate)." AND StartDate<=".$this->_db->escape($endDate).") OR (RecType!=0 AND (RecEnd>=".$this->_db->escape($startDate)." OR RecEnd=-1)))";
		if ($projID) $query.=" AND FKProjID=".$this->_db->escape($projID);
		$query.=" GROUP BY EventID ";
		return $this->fetchEvents($startDate,$endDate,$query);
	}
	function listEvents($startDate,$endDate,$projID=0,$evtID=0,$listDeleted=0) {
		$query = "SELECT CalEvent.*,ud.UserDone FROM CalEventUser as us LEFT JOIN CalUserDone as ud ON  ";
		if (is_array($this->_uid)) {
			$query.="(us.FKEventID=ud.FKEventID AND ud.UserID IN (".implode(",",$this->_db->escape($this->_uid)).") AND ud.UserType='u') ";
		} else {
			$query.="(us.FKEventID=ud.FKEventID AND ud.UserID=".$this->_db->escape($this->_uid)." AND ud.UserType='u')";
		}
		$query.=",CalEvent WHERE EventID=us.FKEventID AND us.UserPerms=0 ";
		if ($listDeleted==-1) {

		} elseif ($listDeleted) {
			$query.="AND Deleted=1 ";
		} else {
			$query.="AND Deleted=0 ";
		}
		$query.= "AND (ud.UserDone IS NULL  OR ud.UserDone!=2) ";
		if (is_array($this->_uid)) {
			$query .="AND ((us.UserType='u' AND us.UserID IN (".implode(",",$this->_db->escape($this->_uid)).")) ";
		} else {
			$query .="AND ((us.UserType='u' AND us.UserID=".$this->_db->escape($this->_uid).")  ";
		}
		if (is_array($this->_gid)) {
			$query .="OR (us.UserType='g' AND us.UserID IN (".implode(",",$this->_db->escape($this->_gid))."))) ";
		} else {
			$query .="OR (us.UserType='g' AND us.UserID=".$this->_db->escape($this->_gid)."))  ";
		}
		$query.="AND ((EndDate>=".$this->_db->escape($startDate)." AND StartDate<=".$this->_db->escape($endDate).") OR (RecType!=0 AND (RecEnd>=".$this->_db->escape($startDate)." OR RecEnd=-1)))";
		if ($projID) $query.=" AND FKProjID=".$this->_db->escape($projID);
		if ($evtID) $query.=" AND EventID=".$this->_db->escape($evtID);
		$query.=" GROUP BY EventID ";
		//debug($query);
		return $this->fetchEvents($startDate,$endDate,$query);
	}
	function searchEvents(&$rows,$search,$b=0,$limit=0) {
		$FIELDS=array('CalEvent.*');
		$JOIN='';
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'EventID','Typ'=>'F=F','Values'=>'us.FKEventID');
		if ($search['Deleted']==-1) {

		} elseif ($search['Deleted']) {
			$searchQuery[]=array('Field'=>'Deleted','Typ'=>'=','Values'=>1);
		} else {
			$searchQuery[]=array('Field'=>'Deleted','Typ'=>'=','Values'=>0);
		}
		if (isset($search['UserPerms'])) {
			if ($search['UserPerms']>=0) {
				$searchQuery[]=array('Field'=>'us.UserPerms','Typ'=>'=','Values'=>$search['UserPerms']);
			}
		} else {
			$searchQuery[]=array('Field'=>'us.UserPerms','Typ'=>'=','Values'=>'0');
		}
		$subQuery=array();

		if ($search['StartDate']) {
			$dateQuery="AND (".
			$dateQuery.="(";
			$dateQuery.="EndDate>=".$this->_db->escape($search['StartDate']);
			if ($search['EndDate']) {
				$dateQuery.=" AND StartDate<=".$this->_db->escape($search['EndDate']);
			}
			$dateQuery.=")";
			if (!$limit) {
				$dateQuery.=" OR (RecType!=0 AND (RecEnd>=".$this->_db->escape($search['StartDate'])." OR RecEnd=-1))";
			}
			$dateQuery.=")";
		}
		//$search['onlyDenied']=1;
		if ($search['UserID']) {
			if (!$search['onlyDenied']) {
				$FIELDS[]='ud.UserDone';
				$joinQuery=array();
				$joinQuery[]=array('Field'=>'us.FKEventID ','Typ'=>'F=F','Values'=>'ud.FKEventID');
				$joinQuery[]=array('Field'=>'ud.UserID ','Typ'=>'=','Values'=>$search['UserID']);
				$JOIN.='LEFT JOIN CalUserDone as ud ON ('.$this->_db->getWhere($joinQuery).')';
				$dateQuery.=' AND (ud.UserDone IS NULL OR ud.UserDone!=2)';
			}
			$subQuery[]=array(
				array('Field'=>'us.UserType','Typ'=>'=','Values'=>'u'),
				array('Field'=>'us.UserID','Typ'=>'=','Values'=>$search['UserID']),
			);
		}
		if ($search['GroupID']) {
			$subQuery[]=array(
				array('Field'=>'us.UserType','Typ'=>'=','Values'=>'g'),
				array('Field'=>'us.UserID','Typ'=>'=','Values'=>$search['GroupID']),
			);
		}
		if ($search['ResourceID']) {
			$subQuery[]=array(
				array('Field'=>'us.UserType','Typ'=>'=','Values'=>'r'),
				array('Field'=>'us.UserID','Typ'=>'=','Values'=>$search['ResourceID']),
			);
		}
		if (!empty($subQuery)) {
			$searchQuery[]=array('Typ'=>'OR','Values'=>$subQuery);
		}
		if ($search['OwnerID']) {
			$searchQuery[]=array('Field'=>'OwnerID','Typ'=>'=','Values'=>$search['OwnerID']);
		}
		if ($search['Info']) {
			$searchQuery[]=array('Field'=>array('Title','Text','Place'),'Typ'=>'concat','Values'=>$search['Info']);
		}
		if ($search['EventID']) {
			$searchQuery[]=array('Field'=>'EventID','Typ'=>'=','Values'=>$search['EventID']);
		}
		if ($search['exEventID']) {
			$searchQuery[]=array('Field'=>'EventID','Typ'=>'!=','Values'=>$search['exEventID']);
		}
		if ($search['ProjID']) {
			$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$search['ProjID']);
		}
		if ($search['CatID']) {
			$searchQuery[]=array('Field'=>'FKCatID','Typ'=>'=','Values'=>$search['CatID']);
		}
		if ($search['invitResource'] && !empty($search['invitResource'])) {
			$relQuery=array();
			$relQuery[]=array('Field'=>'UserPerms','Typ'=>'=','Values'=>0);
			$relQuery[]=array('Field'=>'UserType','Typ'=>'=','Values'=>'r');
			$relQuery[]=array('Field'=>'UserID','Typ'=>'=','Values'=>$search['invitResource']);
			$relQuery[]=array('Field'=>'FKEventID','Typ'=>'F=F','Values'=>'EventID');
			$searchQuery[]=array('Typ'=>'SQL','Values'=>"EXISTS(SELECT * FROM CalEventUser WHERE ".$this->_db->getWhere($relQuery).")");
		}

		if ($search['invitUser'] && !empty($search['invitUser'])) {
			if ($search['onlyDenied']) {
				//Nur abgelehnte
				foreach($search['invitUser'] as $iUsers) {
					$relQuery=array();
					$relQuery[]=array('Field'=>'UserType','Typ'=>'=','Values'=>'u');
					$relQuery[]=array('Field'=>'UserID','Typ'=>'=','Values'=>$iUsers);
					$relQuery[]=array('Field'=>'UserDone','Typ'=>'=','Values'=>2);
					$relQuery[]=array('Field'=>'FKEventID','Typ'=>'F=F','Values'=>'EventID');
					$searchQuery[]=array('Typ'=>'SQL','Values'=>"EXISTS(SELECT * FROM CalUserDone WHERE ".$this->_db->getWhere($relQuery).")");
				}
			} else {
				//UserPerms=0 sind alle Teilnehmer auch "Teilnehmer ohne Einladung"
				foreach($search['invitUser'] as $iUsers) {
					$relQuery=array();
					$relQuery[]=array('Field'=>'FKEventID','Typ'=>'F=F','Values'=>'EventID');
					$relQuery[]=array('Field'=>'UserPerms','Typ'=>'=','Values'=>0);

					$relQueryOr=array();
					$relQueryOr[]=array(
						array('Field'=>'UserType','Typ'=>'=','Values'=>'u'),
						array('Field'=>'UserID','Typ'=>'=','Values'=>$iUsers),
					);
					$tmpGroups=$this->_frm->getMyGroups($iUsers);
					if (!empty($tmpGroups)) {
						$relQueryOr[]=array(
							array('Field'=>'UserType','Typ'=>'=','Values'=>'g'),
							array('Field'=>'UserID','Typ'=>'=','Values'=>$tmpGroups),
						);
					}
					$relQuery[]=array('Typ'=>'OR','Values'=>$relQueryOr);
					//debug("SELECT * FROM CalEventUser WHERE ".$this->_db->getWhere($relQuery));

					$searchQuery[]=array('Typ'=>'SQL','Values'=>"EXISTS(SELECT * FROM CalEventUser WHERE ".$this->_db->getWhere($relQuery).")");
				}
			}
			/*
			foreach($search['invitUser'] as $iUsers) {
				$relQuery=array();
				$relQuery[]=array('Field'=>'UserType','Typ'=>'=','Values'=>'u');
				$relQuery[]=array('Field'=>'UserID','Typ'=>'=','Values'=>$iUsers);
				$relQuery[]=array('Field'=>'FKEventID','Typ'=>'F=F','Values'=>'EventID');
				$searchQuery[]=array('Typ'=>'SQL','Values'=>"EXISTS(SELECT * FROM CalUserDone WHERE ".$this->_db->getWhere($relQuery).")");
			}*/

			
		}

		
		$query = "SELECT ".implode(',',$FIELDS)." FROM CalEventUser as us ".$JOIN." ,CalEvent WHERE ".$this->_db->getWhere($searchQuery).' '.$dateQuery;
		$query.=" GROUP BY EventID ";
		if ($search['Order']) {
			$query.=' '.$this->_db->formatOrder($search['Order']);
		}
		if ($limit) {
			$query.=' '.$this->_db->formatLimit($b,$limit);
			$search['Mode']=1;
		}
		//debug($query);
		if ($search['_fetchSimple']) {
			$result=array();
			$this->_db->query($query);
			while ($this->_db->next_record()) {
				$result[$this->_db->f('EventID')]=$this->getEventArray(0,0);
			}
		} else {
			$result=$this->fetchEvents($search['StartDate'],$search['EndDate'],$query,$search['Mode']);
		}
		$rows=count($result);
		if ($limit && ($b!=0 || $rows>=$limit)) {
			$query = "SELECT count(DISTINCT(EventID)) as num FROM CalEventUser as us ".$JOIN." ,CalEvent WHERE ".$this->_db->getWhere($searchQuery).' '.$dateQuery;
			//$query.=" GROUP BY EventID ";
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
			//echo $query;
		}
		return $result;
	}
	function searchDublicate($fields,$search) {
		$result=array();
		$count=array();
		$JOIN='';
		$searchQuery=array();
		
		$searchQuery[]=array('Field'=>'EventID','Typ'=>'F=F','Values'=>'us.FKEventID');
		$searchQuery[]=array('Field'=>'Deleted','Typ'=>'=','Values'=>0);
		foreach($fields as $fid) {
			foreach($fields as $fid) {
				switch($fid) {
					case 'Place';
					case 'Title';
						$searchQuery[]=array('Field'=>$fid,'Typ'=>'!=','Values'=>'');
					break;
				}
			}
		}
		
		$subQuery=array();
		$subQuery[]=array(
			array('Field'=>'us.UserType','Typ'=>'=','Values'=>'u'),
			array('Field'=>'us.UserID','Typ'=>'=','Values'=>$this->getUser()),
		);
		$subQuery[]=array(
			array('Field'=>'us.UserType','Typ'=>'=','Values'=>'g'),
			array('Field'=>'us.UserID','Typ'=>'=','Values'=>$this->getGroup()),
		);
		$searchQuery[]=array('Typ'=>'OR','Values'=>$subQuery);

		
		if ($search['UserID']) {
			$joinQuery=array();
			$joinQuery[]=array('Field'=>'us.FKEventID ','Typ'=>'F=F','Values'=>'ud.FKEventID');
			$joinQuery[]=array('Field'=>'ud.UserID ','Typ'=>'=','Values'=>$search['UserID']);
			$JOIN.='LEFT JOIN CalUserDone as ud ON ('.$this->_db->getWhere($joinQuery).')';
			$searchQuery[]=array('Typ'=>'SQL','Values'=>'ud.UserDone IS NULL OR ud.UserDone!=2');
			$searchQuery[]=array('Field'=>'us.UserPerms','Typ'=>'=','Values'=>'0');
		}
		
		if ($search['CatID']) {
			$searchQuery[]=array('Field'=>'FKCatID','Typ'=>'=','Values'=>$search['CatID']);
		}
		if (isset($search['TimeMode']) && !empty($search['TimeMode'])) {
			$searchQuery[]=array('Field'=>'TimeMode','Typ'=>'=','Values'=>$search['TimeMode']);
		}
		
		$dateQuery='';
		if ($search['StartDate']) {
			$dateQuery.="(";
			$dateQuery.="(";
			$dateQuery.="EndDate>=".$this->_db->escape($search['StartDate']);
			if ($search['EndDate']) {
				$dateQuery.=" AND StartDate<=".$this->_db->escape($search['EndDate']);
			}
			$dateQuery.=")";
			$dateQuery.=" OR (RecType!=0 AND (RecEnd>=".$this->_db->escape($search['StartDate'])." OR RecEnd=-1))";
			$dateQuery.=")";
			$searchQuery[]=array('Typ'=>'SQL','Values'=>$dateQuery);
		}

		$query="SELECT EventID,StartDate,EndDate,RecType,RecEnd,RecInt,RecCfg,Exception,Place,Title FROM CalEvent,CalEventUser as us $JOIN WHERE ".$this->_db->getWhere($searchQuery);
		//debug($query);
		$events=$this->fetchEvents($search['StartDate'],$search['EndDate'],$query,1);
		//debug($fields);
		foreach ($events as $ev) {
			$values=array();
			foreach($fields as $fid) {
				switch($fid) {
					case 'StartDate';
						$values[]=date('d.m.Y',$ev['StartDate']);
					break;
					case 'EndDate';
						$values[]=date('d.m.Y',$ev['EndDate']);
					break;
					case 'StartTime';
						$values[]=date('H:i',$ev['StartDate']);
					break;
					case 'EndTime';
						$values[]=date('H:i',$ev['EndDate']);
					break;
					case 'Place';
					case 'Title';
						$values[]=preg_replace('/[^\pL\pN]/ui','',$ev[$fid]);
					break;
				}
			}
			$v=implode(' ',$values);
			if (!trim($v)) continue;
			if (!isset($count[$v])) $count[$v]=array();
			$count[$v][]=$ev['EventID'];
		}
		foreach($count as $k=>$v) {
			if (count($v) > 1) {
				$result[$k]=$v;
			}
		}
		return $result;
	}
	function listInvitations($startDate) {
		$query = "SELECT CalEvent.*,ud.UserDone FROM CalEvent,CalEventUser as us LEFT JOIN CalUserDone as ud ON (us.FKEventID=ud.FKEventID AND ud.UserID='".$this->_uid."' AND ud.UserType='u') WHERE EventID=us.FKEventID AND Deleted=0 AND CalEvent.NoInvit=0 AND us.UserPerms=0 ";
		$query.= "AND (ud.UserDone IS NULL) ";
		if (is_array($this->_uid)) {
			$query .="AND ((us.UserType='u' AND us.UserID IN (".implode(",",$this->_db->escape($this->_uid)).")) ";
		} else {
			$query .="AND ((us.UserType='u' AND us.UserID=".$this->_db->escape($this->_uid).")  ";
		}
		if (is_array($this->_gid)) {
			$query .="OR (us.UserType='g' AND us.UserID IN (".implode(",",$this->_db->escape($this->_gid))."))) ";
		} else {
			$query .="OR (us.UserType='g' AND us.UserID=".$this->_db->escape($this->_gid)."))  ";
		}
		$query.="AND (EndDate > ".$this->_db->escape($startDate)." OR (RecType!=0 AND (RecEnd>=".$this->_db->escape($startDate)." OR RecEnd=-1)))";
		$query.=" GROUP BY EventID ";
		return $this->fetchEvents($startDate,0,$query,1);
	}
	function listAlarms($alDate) {
		$query = "SELECT  CalEvent.*,ud.UserDone FROM CalEvent,CalEventUser as us LEFT JOIN CalUserDone as ud ON (us.FKEventID=ud.FKEventID AND ud.UserID='".$this->_uid."' AND ud.UserType='u') WHERE EventID=us.FKEventID AND Deleted=0 AND us.UserPerms=0 ";
		$query.= "AND (ud.UserDone IS NULL  OR ud.UserDone!=2) ";
		if (is_array($this->_uid)) {
			$query .="AND ((us.UserType='u' AND us.UserID IN (".implode(",",$this->_db->escape($this->_uid)).")) ";
		} else {
			$query .="AND ((us.UserType='u' AND us.UserID=".$this->_db->escape($this->_uid).")  ";
		}
		if (is_array($this->_gid)) {
			$query .="OR (us.UserType='g' AND us.UserID IN (".implode(",",$this->_db->escape($this->_gid))."))) ";
		} else {
			$query .="OR (us.UserType='g' AND us.UserID=".$this->_db->escape($this->_gid)."))  ";
		}
		$query.="AND PrevTime!=0 AND ((StartDate-PrevTime<=".$this->_db->escape($alDate)." AND StartDate>".$this->_db->escape($alDate).") OR (RecType!=0 AND (RecEnd>=".$this->_db->escape($alDate)." OR RecEnd=-1)))";
		$query.=" GROUP BY EventID ";
		return $this->fetchAlarms($alDate,$query,'PrevTime');
	}
	function listcronAlarms($alDate) {
		$query = "SELECT  * FROM CalEvent ";
		$query.="WHERE AlarmTime!=0 AND Deleted=0 ";
		$query.="AND ((AlarmSend=0 AND StartDate-AlarmTime<=".$this->_db->escape($alDate)." AND StartDate>".$this->_db->escape($alDate).") OR (RecType!=0 AND (RecEnd>=".$this->_db->escape($alDate)." OR RecEnd=-1)))";
		//echo $query;
		return $this->fetchAlarms($alDate,$query);
	}
	function setSendAlarms($EventIDs) {
		$query="UPDATE CalEvent SET AlarmSend=1 WHERE EventID IN (".implode(',',$this->_db->escape($EventIDs)).")";
		$this->_db->query($query);
	}
	function unsetSendAlarms($EventIDs) {
		$query="UPDATE CalEvent SET AlarmSend=0 WHERE EventID IN (".implode(',',$this->_db->escape($EventIDs)).")";
		$this->_db->query($query);
	}
	function fetchAlarms($alDate,$query,$AlTyp='AlarmTime') {
		$events=array();
		//echo $query.'<br><br>';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			if ($this->_db->f("RecType")) {
				$afterdate=$alDate;
				$rec=array(
					"EndDate"=>$this->_db->f("EndDate"),
					"StartDate"=>$this->_db->f("StartDate"),
					"RecEnd"=>$this->_db->f("RecEnd"),
					"RecType"=>$this->_db->f("RecType"),
					"RecInt"=>$this->_db->f("RecInt"),
					"RecCfg"=>$this->_db->f("RecCfg"),
					'Exception'=>$this->_db->f("Exception"),
				);
				while ($date=$this->nextRecurrence($rec,$afterdate)) {
					if ($date['start']>$alDate) break;
					$afterdate=$date["end"];
				}
				if ($date && (($date["start"]-$this->_db->f($AlTyp))<=$alDate)) {
					if (!$this->_db->f("AlarmSend")) $events[$this->_db->f("EventID")]=$this->getEventArray($date["start"],$date["end"]);
				} elseif($this->_db->f("AlarmSend")) {
					$unsetSend[]=$this->_db->f("EventID");
				}
			} else {
				$events[$this->_db->f("EventID")]=$this->getEventArray(0,0);
			}
		}
		if (is_array($unsetSend)) {
			$this->unsetSendAlarms($unsetSend);
		}
		return $events;
	}
	function fetchEvents($startDate,$endDate,$query,$mode=0,$ignUsers=array()) {
		$events=array();
		//echo $query.'<br><br>';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			if ($this->_db->f("RecType")) {
				$afterdate=$startDate-1;
				$rec=array(
					"EndDate"=>$this->_db->f("EndDate"),
					"StartDate"=>$this->_db->f("StartDate"),
					"RecEnd"=>$this->_db->f("RecEnd"),
					"RecType"=>$this->_db->f("RecType"),
					"RecInt"=>$this->_db->f("RecInt"),
					"RecCfg"=>$this->_db->f("RecCfg"),
					'Exception'=>$this->_db->f("Exception"),
				);
				while ($date=$this->nextRecurrence($rec,$afterdate)) {
					$afterdate=$date["end"];
					//if (!date('hi',$date["end"]))
					if ($mode!=1 && ($date["start"]>$endDate)) break;
					if ($mode!=1 && $mode!=2 && ($date["start"]<$startDate)) $date["start"]=mktime(0,0,0,date("n",$startDate),date("j",$startDate),date("Y",$startDate));
					if ($mode!=1 && $mode!=2  && ($date["end"]>$endDate)) $date["end"]=mktime(23,59,0,date("n",$endDate),date("j",$endDate),date("Y",$endDate));
					if ($mode==1 || $mode==2) {
						$events[$this->_db->f("EventID")]=$this->getEventArray($date["start"],$date["end"]);
						break;
					} elseif ($mode==3) {
							switch($this->_db->f('UserType')) {
								case 'g':
									$evtUsers=$this->_frm->getCachedGroupUsers($this->_db->f('UserID'));
								break;
								case 'u':
									$evtUsers=array($this->_db->f('UserID'));
								break;
							}
							if (!is_array($evtUsers)) $evtUsers=array();
							foreach ($evtUsers as $aktUser) {
								if (is_array($ignUsers[$this->_db->f("EventID")]) && in_array($aktUser,$ignUsers[$this->_db->f("EventID")])) continue;
								$events[$aktUser][date("j",$date["start"])."-".date("n",$date["start"])."-".date("Y",$date["start"])][$this->_db->f("EventID")]=$this->getEventArray($date["start"],$date["end"]);
							}
					} else {
						$events[date("j",$date["start"])."-".date("n",$date["start"])."-".date("Y",$date["start"])][$this->_db->f("EventID")]=$this->getEventArray($date["start"],$date["end"]);
					}
					if (!$endDate) break;
				}
			} else {
				unset($date);
				$date["start"]=$this->_db->f("StartDate");
				$date["end"]=$this->_db->f("EndDate");
				if (!intval(date('Hi',$date["end"])) && date('dmy',$date["start"])!=date('dmy',$date["end"])) {
					//debug(date('Hi',$date["end"]));
					$date["end"]=mktime(23,59,59,date("n",$date["end"]),date("j",$date["end"])-1,date("Y",$date["end"]));
					if ($date["end"]<$startDate) continue;
				}
				if ($mode!=1 && $mode!=2  && ($date["start"]<$startDate)) $date["start"]=mktime(0,0,0,date("n",$startDate),date("j",$startDate),date("Y",$startDate));
				if ($mode!=1 && $mode!=2  && ($date["end"]>$endDate)) $date["end"]=mktime(23,59,0,date("n",$endDate),date("j",$endDate),date("Y",$endDate));
				if ($mode==1 || $mode==2) {
					$events[$this->_db->f("EventID")]=$this->getEventArray($date["start"],$date["end"]);
				} elseif ($mode==3) {
					switch($this->_db->f('UserType')) {
						case 'g':
							$evtUsers=$this->_frm->getCachedGroupUsers($this->_db->f('UserID'));
							if (!is_array($evtUsers)) $evtUsers=array();
						break;
						case 'u':
							$evtUsers=array($this->_db->f('UserID'));
						break;
					}
					foreach ($evtUsers as $aktUser) {
						if (is_array($ignUsers[$this->_db->f("EventID")]) && in_array($aktUser,$ignUsers[$this->_db->f("EventID")])) continue;
						$events[$aktUser][date("j",$date["start"])."-".date("n",$date["start"])."-".date("Y",$date["start"])][$this->_db->f("EventID")]=$this->getEventArray($date["start"],$date["end"]);
					}
				} else {
					$events[date("j",$date["start"])."-".date("n",$date["start"])."-".date("Y",$date["start"])][$this->_db->f("EventID")]=$this->getEventArray($date["start"],$date["end"]);
				}
			}
		}
		return $events;
	}
	function &getEventArray($start,$end) {
		if ($this->_db->f("EvtPrivat") && $this->getAuthUser()) {
			$privat=true;
			if ($this->_db->f("OwnerID")==$this->getAuthUser()) {
				$privat=false;
			} elseif ($this->_db->f("UserModify")==$this->getAuthUser()) {
				$privat=false;
			} elseif ($this->_db->f("InvitUsers") && preg_match('/(^|[,])'.$this->getAuthUser().'([,]|$)/',$this->_db->f("InvitUsers"))) {
				$privat=false;
			} elseif ($this->_db->f("InvitGroups") && count(array_intersect(explode(',',$this->_db->f("InvitGroups")),$this->_auth_gid))) {
				$privat=false;
			}
		} else {
			$privat=false;
		}
		return array(
			"EventID"=>$this->_db->f("EventID"),
			"Title"=>$privat?($GLOBALS['T']?$GLOBALS['T']->lang('[[PRIVAT]]'):'PRIVAT'):$this->_db->f("Title"),
			"FKProjID"=>$this->_db->f("FKProjID"),
			"NoOwner"=>$this->_db->f("NoOwner"),
			"EvtPrivat"=>$this->_db->f("EvtPrivat"),
			"Text"=>$privat?'':$this->_db->f("Text"),
			"Place"=>$privat?'':$this->_db->f("Place"),
			"OwnerID"=>$this->_db->f("OwnerID"),
			"StartDate"=>$start?$start:$this->_db->f("StartDate"),
			"EndDate"=>$end?$end:$this->_db->f("EndDate"),
			"OrigStart"=>$this->_db->f("StartDate"),
			"OrigEnd"=>$this->_db->f("EndDate"),
			"AlarmTime"=>$this->_db->f("AlarmTime"),
			"PrevTime"=>$this->_db->f("PrevTime"),
			"FKCatID"=>$this->_db->f("FKCatID"),
			"RecType"=>$this->_db->f("RecType"),
			"RecEnd"=>$this->_db->f("RecEnd"),
			"RecInt"=>$this->_db->f("RecInt"),
			"RecCfg"=>$this->_db->f("RecCfg"),
			'TimeMode'=>$this->_db->f("TimeMode"),
			'InvitGroups'=>$privat?'':$this->_db->f("InvitGroups"),
			'InvitUsers'=>$privat?'':$this->_db->f("InvitUsers"),
			'InvitAddr'=>$privat?'':$this->_db->f("InvitAddr"),
			'InvitResources'=>$this->_db->f("InvitResources"),
			'GrantGroups'=>$this->_db->f("GrantGroups"),
			'GrantUsers'=>$this->_db->f("GrantUsers"),
			'Unsecure'=>$this->_db->f("Unsecure"),
			'UserDone'=>$this->_db->f("UserDone"),
			'Exception'=>$this->_db->f("Exception"),
			'TimeModify'=>$this->_db->f("TimeModify"),
			'TimeChange'=>$this->_db->f("TimeChange"),
 			'TimeCreate'=>$this->_db->f("TimeCreate"),
			'TimeZone'=>$this->_db->f("TimeZone"),
			"UID"=>$this->_db->f("UID"),
			"Deleted"=>$this->_db->f("Deleted"),
			'_Privat'=>$privat,
  		);

	}
	function isException($ex,$start) {
		if (count($ex)) {
			//echo date('d.m.Y',$start).'--'.intval($start/(3600*24)).'<br>';
			if (in_array($start,$ex) || in_array(mktime(0,0,0,date('m',$start),date('d',$start),date('Y',$start)),$ex)) {
				return true;
			} else {
				return false;
			}
		}
	}
	function nextRecurrence($event, $afterDate = null) {
		if (!$event) return false;
		if (!is_array($event)) {
			$this->_db->query("SELECT  StartDate,EndDate,RecType,RecInt,RecCfg,RecEnd,Exception FROM CalEvent  where EventID=".$this->_db->escape($event));
			$this->_db->next_record();
			$event=array(
				"StartDate"=>$this->_db->f("StartDate"),
				"EndDate"=>$this->_db->f("EndDate"),
				"RecEnd"=>$this->_db->f("RecEnd"),
				"RecType"=>$this->_db->f("RecType"),
				"RecInt"=>$this->_db->f("RecInt"),
				"RecCfg"=>$this->_db->f("RecCfg"),
				'Exception'=>$this->_db->f("Exception"),
			);
		}
		$start=$event["StartDate"];
		$end=$event["EndDate"];
		if ($event["Exception"]) {
			$ex=explode(',',$event["Exception"]);
		} else {
			$ex=array();
		}
		if (!$afterDate) $afterDate=$start;
		if ( $end > $afterDate  && !$this->isException($ex,$start)) return array("start"=>$start,"end"=>$end);
		$rec_end=$event["RecEnd"];
		if ($rec_end==-1) $rec_end=mktime(0,0,0,1,1,2030);
		$int=(int)$event["RecInt"]>0?$event["RecInt"]:1;
		$data=$event["Data"];
		if ($rec_end<$afterDate) return false;
		switch ($event["RecType"]) {
			case 1:
					//debug(date('d.m.Y H:i:s',$afterDate-1));
					$diff=$afterDate-$end;
					$diff=$diff/(3600*24);
					$diff=floor($diff/$int);
					$next_end=$end+($diff*$int*3600*24);
					$next_end+=$this->date_dist_cmp($next_end,$end);
					$next_start=$start+($diff*$int*3600*24);
					//debug(date('d.m.Y H:i:s',$next_end));
					$next_start+=$this->date_dist_cmp($next_start,$start);
					//echo "rec_end".date("d.m.Y H:i",$rec_end);
					while ($next_end<=$afterDate || $this->isException($ex,$next_start)) {
							//debug(date('d.m.Y H:i:s',$next_end));
							$next_end=($next_end+$int*3600*24)+$this->date_dist_cmp($next_end+$int*3600*24,$next_end);
							$next_start=($next_start+$int*3600*24)+$this->date_dist_cmp($next_start+$int*3600*24,$next_start);
							//debug('INT:'.$int);
							//debug(date('d.m.Y H:i:s',$next_end));
							//flush();
							if ($next_start>$rec_end) return false;
							//exit;
					}
					//debug(date('d.m.Y H:i:s',$next_end));
					//exit;
					return array("start"=>$next_start,"end"=>$next_end);
			case 2:
					$diff=$afterDate-$end;
					$diff=$diff/(3600*24*7);
					$diff=floor($diff/$int);
					$next_end=$end+($diff*$int*3600*24*7);
					$next_end+=$this->date_dist_cmp($next_end,$end);
					$next_start=$start+($diff*$int*3600*24*7);
					$next_start+=$this->date_dist_cmp($next_start,$start);
					$start=$start+$lenght;
					$next=$start+($diff*$int*3600*24*7);

					/*debug('AfterDate'.date('d.m.Y',$afterDate));
					debug('EvtEnd'.date('d.m.Y',$end));
					debug('NextEnd'.date('d.m.Y',$next_end));*/

					while ($next_end<=$afterDate || $this->isException($ex,$next_start)) {
							$next_end=($next_end+$int*3600*24*7)+$this->date_dist_cmp($next_end+$int*3600*24*7,$next_end);
							$next_start=($next_start+$int*3600*24*7)+$this->date_dist_cmp($next_start+$int*3600*24*7,$next_start);
							if ($next_start>$rec_end) return false;
					}
					return array("start"=>$next_start,"end"=>$next_end);
			case 3:
					$start_year=date("Y",$start);
					$start_month=date("n",$start);
					$start_day=date("j",$start);
					$start_hour=date("H",$start);
					$start_min=date("i",$start);
					$end_year=date("Y",$end);
					$end_month=date("n",$end);
					$end_day=date("j",$end);
					$end_hour=date("H",$end);
					$end_min=date("i",$end);
					$next_start=mktime($start_hour,$start_min,0,$start_month,$start_day,$start_year);
					$next_end=mktime($end_hour,$end_min,0,$end_month,$end_day,$end_year);
					while ($next_end<=$afterDate || $this->isException($ex,$next_start)) {
							$end_month+=$int;
							$start_month+=$int;
							while($end_month>12) {
								$end_month-=12;$end_year+=1;
							}
							while($start_month>12) {
								$start_month-=12;$start_year+=1;
							}
							if (!checkdate($start_month,$start_day,$start_year)) {
								$month=$start_month+1;
								$year=$start_year;
								if ($month>12) {$month-=12;$year=+1;}
								$next_start=mktime(0,0,0,$month,1,$year);
							}  else {
								$next_start=mktime($start_hour,$start_min,0,$start_month,$start_day,$start_year);
							}
							if (!checkdate($end_month,$end_day,$end_year)) {
								$day=date("t",mktime(0,0,0,$end_month,1,$end_year));
								$next_end=mktime(23,59,0,$end_month,$day,$end_year);
							} else {
								$next_end=mktime($end_hour,$end_min,0,$end_month,$end_day,$end_year);
							}
							if ($next_end>$next_start) continue;
							if ($next_start>$rec_end) return false;
					}
					return array("start"=>$next_start,"end"=>$next_end);
			case 4:
					return false;
			case 5:
					$start_year=date("Y",$start);
					$start_month=date("n",$start);
					$start_day=date("j",$start);
					$start_hour=date("H",$start);
					$start_min=date("i",$start);
					$end_year=date("Y",$end);
					$end_month=date("n",$end);
					$end_day=date("j",$end);
					$end_hour=date("H",$end);
					$end_min=date("i",$end);
					$next_start=mktime($start_hour,$start_min,0,$start_month,$start_day,$start_year);
					$next_end=mktime($end_hour,$end_min,0,$end_month,$end_day,$end_year);
					while ($next_end<=$afterDate || $this->isException($ex,$next_start)) {
							$end_year+=$int;
							$start_year+=$int;
							if (!checkdate($start_month,$start_day,$start_year)) {
									$month=$start_month+1;
									$year=$start_year;
									if ($month>12) {$month-=12;$year=+1;}
									$next_start=mktime(0,0,0,$month,1,$year);
							}  else {
										$next_start=mktime($start_hour,$start_min,0,$start_month,$start_day,$start_year);
							}
							if (!checkdate($end_month,$end_day,$end_year)) {
									$day=date("t",mktime(0,0,0,$end_month,1,$end_year));
									$next_end=mktime(23,59,0,$end_month,$day,$end_year);
							} else {
										$next_end=mktime($end_hour,$end_min,0,$end_month,$end_day,$end_year);
							}
							if ($next_end>$next_start) continue;
							if ($next_start>$rec_end) return false;
					}
					return array("start"=>$next_start,"end"=>$next_end);
		}
		return false;
   	}

	function getByUid($UID) {
		$where="WHERE EventID=us.FKEventID AND Deleted=0 AND us.UserPerms=0 AND UID=".$this->_db->escape($UID);
		$where .=" AND ((us.UserType='u' AND us.UserID=".$this->_db->escape($this->_uid).")  ";
		if (is_array($this->_gid)) {
			$where .="OR (us.UserType='g' AND us.UserID IN (".implode(",",$this->_db->escape($this->_gid))."))) ";
		} else {
			$where .="OR (us.UserType='g' AND us.UserID=".$this->_db->escape($this->_gid)."))  ";
		}
		$query = "SELECT CalEvent.*,ud.UserDone FROM CalEventUser as us LEFT JOIN CalUserDone as ud ON (us.FKEventID=ud.FKEventID AND ud.UserID=".$this->_db->escape($this->_uid)." AND ud.UserType='u'),CalEvent ";
		$query.= $where;
		$query.= " GROUP BY EventID ";
		//debug($query);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$result=$this->_fetchEvent();
			$result['UserDone']=$this->_db->f("UserDone");
		} else {
			$result=0;
		}
		return $result;
	}
	function readEvent($EventID) {
		if (is_array($EventID)) {
			$res=array();
			$this->_db->query("SELECT * FROM CalEvent WHERE EventID IN (".implode(",",$this->_db->escape($EventID)).") ");
			while ($this->_db->next_record()) {
				$res[$this->_db->f("EventID")]=$this->_fetchEvent();
			}
			return $res;
		} else {
			$this->_db->query("SELECT * FROM CalEvent WHERE EventID=".$this->_db->escape($EventID));
			if ($this->_db->next_record()) {
				return $this->_fetchEvent();
			}
		}
		return 0;
	}
	function readEventTpl($TplID) {
		$this->_db->query("SELECT * FROM CalEventTpl WHERE TplID=".$this->_db->escape($TplID));
		if ($this->_db->next_record()) {
			return $this->_fetchEventTpl();
		}
		return 0;
	}
	function listEventTpl($perms=true) {
		$result=array();
		$query="SELECT * FROM CalEventTpl WHERE (TplOwner=".$this->_db->escape($this->getUser());
		if ($perms && $this->getGroup()) {
			$query.=" OR TplGrantGroups	 LIKE '%|".implode("|%' OR TplGrantGroups LIKE '%|",$this->getGroup())."|%'";
		}
		$query.=")";

		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("TplID")]=$this->_fetchEventTpl();
		}
		return $result;
	}

	function checkEventViewPerms(&$val,$mask=false) {
		$uview=0;
		if ($val['OwnerID']==$this->getAuthUser()) {
			$uview=1;
		} elseif ($val['InvitUsers'] && in_array($this->getUser(),explode(',',$val['InvitUsers']))) {
			$uview=1;
		} elseif ($val['InvitGroups'] && ($tmp=array_intersect($this->getGroup(),explode(',',$val['InvitGroups']))) && count($tmp))  {
			$uview=1;
		} elseif ($val['EvtPrivat'] && $val['OwnerID']!=$this->getAuthUser()) {
			$uview=0;
		} elseif ($this->getAllCalPerms($val['OwnerID'],1)) {
			$uview=1;
		} elseif ($val['GrantUsers'] && in_array($this->getUser(),explode(',',$val['GrantUsers']))) {
			$uview=1;
		} elseif ($val['GrantGroups']) {
			$tmp=array_intersect($this->getGroup(),explode(',',$val['GrantGroups']));
			if (count($tmp)) $uview=1;
		}
		if ($mask && !$uview) {
			$val["Title"]=$GLOBALS['T']->lang('[[PRIVAT]]');
			$val["Text"]='';
			$val['Place']='';
			$val['InvitGroups']='';
			$val['InvitUsers']='';
			$val['InvitAddr']='';
			$val['FKProjID']=0;
			$val['_Privat']=true;
		}
		return $uview;
	}
	function _fetchEvent() {
						//debug(date('j-n-Y',$this->_db->f("StartDate")));
		if ($this->_db->f("EvtPrivat") && $this->getAuthUser()) {
			$privat=true;
			if ($this->_db->f("OwnerID")==$this->getAuthUser()) {
				$privat=false;
			} elseif ($this->_db->f("UserModify")==$this->getAuthUser()) {
				$privat=false;
			} elseif ($this->_db->f("InvitUsers") && preg_match('/(^|[,])'.$this->getAuthUser().'([,]|$)/',$this->_db->f("InvitUsers"))) {
				$privat=false;
			} elseif ($this->_db->f("InvitGroups") && count(array_intersect(explode(',',$this->_db->f("InvitGroups")),$this->_auth_gid))) {
				$privat=false;
			}
		} else {
			$privat=false;
		}
		return array(
			"EventID"=>$this->_db->f("EventID"),
			"FKCatID"=>$this->_db->f("FKCatID"),
			"OwnerID"=>$this->_db->f("OwnerID"),
			"Title"=>$privat?$GLOBALS['T']->lang('[[PRIVAT]]'):$this->_db->f("Title"),
			"Text"=>$privat?'':$this->_db->f("Text"),
			"Place"=>$privat?'':$this->_db->f("Place"),
			"StartDate"=>$this->_db->f("StartDate"),
			"EndDate"=>$this->_db->f("EndDate"),
			"AlarmTime"=>$this->_db->f("AlarmTime"),
			"PrevTime"=>$this->_db->f("PrevTime"),
			"RecType"=>$this->_db->f("RecType"),
			"RecInt"=>$this->_db->f("RecInt"),
			"RecCfg"=>$this->_db->f("RecCfg"),
			"RecEnd"=>$this->_db->f("RecEnd"),
			'TimeMode'=>$this->_db->f("TimeMode"),
			'InvitGroups'=>$privat?'':$this->_db->f("InvitGroups"),
			'InvitUsers'=>$privat?'':$this->_db->f("InvitUsers"),
			'InvitAddr'=>$privat?'':$this->_db->f("InvitAddr"),
			'InvitResources'=>$this->_db->f("InvitResources"),
			'GrantGroups'=>$this->_db->f("GrantGroups"),
			'GrantUsers'=>$this->_db->f("GrantUsers"),
			'Unsecure'=>$this->_db->f("Unsecure"),
			'Message'=>$this->_db->f("Message"),
			'TimeModify'=>$this->_db->f("TimeModify"),
			'TimeChange'=>$this->_db->f("TimeChange"),
			'UserModify'=>$this->_db->f("UserModify"),
			'TimeCreate'=>$this->_db->f("TimeCreate"),
			'AlarmSend'=>$this->_db->f("AlarmSend"),
			'Exception'=>$this->_db->f("Exception"),
			"FKProjID"=>$this->_db->f("FKProjID"),
			"NoOwner"=>$this->_db->f("NoOwner"),
			"NoInvit"=>$this->_db->f("NoInvit"),
			"EvtPrivat"=>$this->_db->f("EvtPrivat"),
			'TimeZone'=>$this->_db->f("TimeZone"),
			"UID"=>$this->_db->f("UID"),
			"Sequence"=>$this->_db->f("Sequence"),
			"Deleted"=>$this->_db->f("Deleted"),
			'_Privat'=>$privat,
		);
	}
	function _fetchEventTpl() {
		return array(
			"TplID"=>$this->_db->f("TplID"),
			"TplOwner"=>$this->_db->f("TplOwner"),
			"TplTitle"=>$this->_db->f("TplTitle"),
			"TplGrantGroups"=>$this->_db->f("TplGrantGroups"),
			"FKCatID"=>$this->_db->f("FKCatID"),
			"Title"=>$this->_db->f("Title"),
			"Text"=>$this->_db->f("Text"),
			"Place"=>$this->_db->f("Place"),
			"StartDate"=>$this->_db->f("StartDate"),
			"EndDate"=>$this->_db->f("EndDate"),
			"AlarmTime"=>$this->_db->f("AlarmTime"),
			"RecType"=>$this->_db->f("RecType"),
			"RecInt"=>$this->_db->f("RecInt"),
			"RecCfg"=>$this->_db->f("RecCfg"),
			"RecEnd"=>$this->_db->f("RecEnd"),
			'TimeMode'=>$this->_db->f("TimeMode"),
			'InvitGroups'=>$this->_db->f("InvitGroups"),
			'InvitUsers'=>$this->_db->f("InvitUsers"),
			'InvitAddr'=>$this->_db->f("InvitAddr"),
			'InvitResources'=>$this->_db->f("InvitResources"),
			'GrantGroups'=>$this->_db->f("GrantGroups"),
			'GrantUsers'=>$this->_db->f("GrantUsers"),
			'Unsecure'=>$this->_db->f("Unsecure"),
			'Message'=>$this->_db->f("Message"),
			'TimeModify'=>$this->_db->f("TimeModify"),
			'UserModify'=>$this->_db->f("UserModify"),
			'TimeCreate'=>$this->_db->f("TimeCreate"),
			"FKProjID"=>$this->_db->f("FKProjID"),
			"NoOwner"=>$this->_db->f("NoOwner"),
			"NoInvit"=>$this->_db->f("NoInvit"),
			"EvtPrivat"=>$this->_db->f("EvtPrivat"),
			'TimeZone'=>$this->_db->f("TimeZone"),
		);
	}
	function saveEventTpl($obj) {
		if (!$obj['TimeCreate']) $obj['TimeCreate']=time();
		if (!$obj['TimeModify']) $obj['TimeModify']=time();
		if (!$obj['UserModify']) $obj['UserModify']=$this->_auth_uid;
		$ID=$obj['TplID']=$this->_db->nextid('eventTpl');
		$this->_db->insert('CalEventTpl',$obj);
		return $ID;
	}
	function updateEventTpl($ID,$obj)  {
		if (!$obj['TimeModify']) $obj['TimeModify']=time();
		if (!$obj['UserModify']) $obj['UserModify']=$this->_auth_uid;
		$this->_db->update('CalEventTpl',$obj,"TplID=".$this->_db->escape($ID));
        return $ID;
    }
	function deleteEventTpl($ID)  {
		$this->_db->delete('CalEventTpl',"TplID=".$this->_db->escape($ID));
        return $ID;
    }

    function eventExists($obj) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'OwnerID','Typ'=>'=','Values'=>$obj['OwnerID']);
		$searchQuery[]=array('Field'=>'StartDate','Typ'=>'=','Values'=>$obj['StartDate']);
		$searchQuery[]=array('Field'=>'EndDate','Typ'=>'=','Values'=>$obj['EndDate']);
		$searchQuery[]=array('Field'=>'Title','Typ'=>'=','Values'=>$obj['Title']);
		$searchQuery[]=array('Field'=>'Deleted','Typ'=>'=','Values'=>0);

		$query="SELECT EventID FROM CalEvent WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('EventID');
		}
		return 0;
	}

	function saveEvent($obj) {
		unset($obj['_Privat']);
		if (!$obj['TimeCreate']) $obj['TimeCreate']=time();
		if (!$obj['TimeModify']) $obj['TimeModify']=time();
		if (!$obj['TimeChange']) $obj['TimeChange']=time();
		if (!$obj['UserModify']) $obj['UserModify']=$this->_auth_uid;
		$ID=$obj['EventID']=$this->_db->nextid('event');
		if (!$obj['UID']) {
			$obj['UID']=gmdate('Ymd\THis').'Z-'.$ID.'@'.$_SERVER['SERVER_NAME'];
		}
		$this->_db->insert('CalEvent',$obj);
		$this->insertEventUsers($ID,'u',explode(',',$obj['GrantUsers']),1);
		$this->insertEventUsers($ID,'g',explode(',',$obj['GrantGroups']),1);
		$this->insertEventUsers($ID,'u',array_unique(array_merge(explode(',',$obj['InvitUsers']),array($obj['OwnerID']))),0);
		$this->insertEventUsers($ID,'g',explode(',',$obj['InvitGroups']),0);
		if ($obj['InvitResources']) {
			$values=array();
			foreach(explode(',',$obj['InvitResources']) as $val) {
				if (strpos($val,'@')) {
					$tmp=explode('@',$val);
					for ($i=0;$i<$tmp[1];$i++) {
						$values[]=$tmp[0];
					}
				} else {
					$values[]=$val;
				}
			}
			$this->insertEventUsers($ID,'r',$values,0);
		}
		
		if ($obj['Unsecure']) {
			$this->insertEventDone($ID,'u',$obj['OwnerID'],3);
		} else {
			$this->insertEventDone($ID,'u',$obj['OwnerID'],1);
		}
		return $ID;
	}
	function updateEvent($ID,$obj,$all=1)  {
		unset($obj['_Privat']);
		if (!$obj['TimeModify']) $obj['TimeModify']=time();
		if (!$obj['TimeChange']) $obj['TimeChange']=time();
		if (!$obj['UserModify']) $obj['UserModify']=$this->_auth_uid;
		if (!$obj['UID']) {
			$obj['UID']=gmdate('Ymd\THis').'Z-'.$ID.'@'.$_SERVER['SERVER_NAME'];
		}
		$this->_db->update('CalEvent',$obj,"EventID=".$this->_db->escape($ID));
		if ($all) {
			if ($all!=-1) {
				$this->deleteEventUsers($ID);
				$this->insertEventUsers($ID,'u',explode(',',$obj['GrantUsers']),1);
				$this->insertEventUsers($ID,'g',explode(',',$obj['GrantGroups']),1);
				$this->insertEventUsers($ID,'u',array_unique(array_merge(explode(',',$obj['InvitUsers']),array($obj['OwnerID']))),0);
				$this->insertEventUsers($ID,'g',explode(',',$obj['InvitGroups']),0);
				if ($obj['InvitResources']) {
					$values=array();
					foreach(explode(',',$obj['InvitResources']) as $val) {
						if (strpos($val,'@')) {
							$tmp=explode('@',$val);
							for ($i=0;$i<$tmp[1];$i++) {
								$values[]=$tmp[0];
							}
						} else {
							$values[]=$val;
						}
					}
					$this->insertEventUsers($ID,'r',$values,0);
				}
			}
			$this->deleteEventDone($ID,'u',$obj['OwnerID']);
			if ($obj['Unsecure']) {
				$this->insertEventDone($ID,'u',$obj['OwnerID'],3);
			} else {
				$this->insertEventDone($ID,'u',$obj['OwnerID'],1);
			}
		}
        return $ID;
    }
 	function updateEventModify($ID)  {
		$update=array(
			'TimeModify'=>time(),
		);
		$this->_db->update('CalEvent',$update,"EventID=".$this->_db->escape($ID));
        return $ID;
    }
	function delUnsecure($ID) {
		$values=array(
			'Unsecure'=>0,
			'TimeModify'=>time(),
			'UserModify'=>$this->_auth_uid,
		);
		$this->_db->update('CalEvent',$values,"EventID=".$this->_db->escape($ID));
	}
	function deleteEvent($ID,$final=false) {
		if ($final) {
			$this->deleteEventLog($ID);
			$this->deleteEventUsers($ID);
			$this->deleteEventDone($ID);
			$this->deleteEventFmng($ID);
			$this->deleteEventColor($ID);
			$query="DELETE FROM CalEvent WHERE EventID=".$this->_db->escape($ID);
			$this->_db->query($query);
			return 1;
		} else {
			$this->updateEvent($ID,array('Deleted'=>1),0);
		}
	}
	function undeleteEvent($ID) {
		$this->updateEvent($ID,array('Deleted'=>0),0);
	}
	function deleteEventObject(&$obj,$one=0) {
		if ($obj) {
			$send_user=array();
			if ($obj['StartDate']>time()) {
				if ($obj['Message']) {
					$user_done=$this->readEventDone($obj['EventID'],'u');
					foreach ($user_done as $key=>$val) {
						if ($key!=$this->getAuthUser() && $val!=2) {
							$send_user[]=$key;
						}
					}
				} elseif ($this->getAuthUser()!=$obj['OwnerID']) {
					$send_user[]=$obj['OwnerID'];
				}
			}
			if (!empty($send_user)) {
				$log_tras=array(
					'{EDATE}'=>$this->formatDate($obj['StartDate'],$obj['EndDate'],$obj['TimeMode']),
					'{ETITLE}'=>trim($obj['Title']),
					'{EPLACE}'=>trim($obj['Place']),
					'{ETEXT}'=>trim($obj['Text']),
					'{TEXT}'=>trim($comment),
				);
				$this->_frm->sendmessage($send_user,
						$this->getAuthUser(),
						strtr($GLOBALS['T']->lang('[[action_delete_title]]'),$log_tras),
						strtr($GLOBALS['T']->lang('[[action_delete_text]]'),$log_tras),
						"",
						"",
						$this->getCfg('cfg/img_notes'));

			}
			if ($obj['RecType'] && $one) {
				if ($obj['Exception']) {
					$c_ex=explode(',',$obj['Exception']);
				} else {
					$c_ex=array();
				}
				$c_ex[]=mktime(0,0,0,date('m',$obj['StartDate']),date('d',$obj['StartDate']),date('Y',$obj['StartDate']));
				$this->updateEvent($obj['EventID'],array('UID'=>$obj['UID'],'TimeChange'=>$obj['TimeChange'],'Exception'=>implode(',',$c_ex),'Sequence'=>$obj['Sequence']+1),0);
			} else {
				$this->deleteEvent($obj['EventID']);
			}
		}
		return false;
	}

	function deleteDateEvents($enddate) {
		$delete=array();
		$query="SELECT EventID,StartDate,Title,RecType FROM CalEvent WHERE ";
		$query.="( StartDate < ".$this->_db->escape($enddate)." AND RecType=0) ";
		$query.=" OR ( RecType!=0 AND RecEnd < ".$this->_db->escape($enddate)." AND RecEnd!=-1) ";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$delete[]=$this->_db->f('EventID');
		}
		$num=0;
		foreach ($delete as $cal) {
			$this->deleteEvent($cal,true);
			$num++;
		}
		return $num;
	}
	function insertEventUsers($EventID,$Type,$Users,$Perms) {
		if (is_array($Users)) {
			foreach ($Users as $val) {
				if ($val) {
					$values=array(
						'FKEventID'=>$EventID,
						'UserType'=>$Type,
						'UserID'=>$val,
						'UserPerms'=>$Perms,

					);
					$this->_db->insert('CalEventUser',$values);
				}
			}
		}
	}
	function deleteEventUsers($EventID=0,$Type=0,$Users=0,$Perms=0) {
		$query="DELETE FROM CalEventUser WHERE ";
		if ($EventID) $where[]="FKEventID=".$this->_db->escape($EventID)." ";
		if ($Type) $where[]="UserType=".$this->_db->escape($Type)." ";
		if ($Perms) $where[]="UserPerms=".$this->_db->escape($Perms)." ";
		if (is_array($Users)) $where[]="UserID IN (".implode(",",$this->_db->escape($Users)).") ";
		elseif ($Users) $where[]=" UserID=".$this->_db->escape($Users)." ";
		if (is_array($where)) {
			$this->_db->query($query.implode(' AND ',$where));
		}
	}
	function insertEventDone($EventID,$Type,$Users,$Done) {
		if (!is_array($Users)) $Users=array($Users);
		foreach ($Users as $val) {
			if ($val) {
				$values=array(
					'FKEventID'=>$EventID,
					'UserType'=>$Type,
					'UserID'=>$val,
					'UserDone'=>$Done,
				);
				$this->_db->insert('CalUserDone',$values,0,1);
			}
		}
	}
	function deleteEventDone($EventID,$Type=0,$Users=0,$Done=0) {
		$query="DELETE FROM CalUserDone WHERE ";
		if ($EventID) $where[]="FKEventID=".$this->_db->escape($EventID)." ";
		if ($Type) $where[]="UserType=".$this->_db->escape($Type)." ";
		if ($Done) $where[]="UserPerms=".$this->_db->escape($Done)." ";
		if (is_array($Users)) $where[]="UserID IN (".implode(",",$this->_db->escape($Users)).") ";
		elseif ($Users) $where[]=" UserID=".$this->_db->escape($Users)." ";
		if (is_array($where)) {
			$this->_db->query($query.implode(' AND ',$where));
		}
	}
	function readEventDone($EventID,$Type,$User=0) {
		$result=array();
		$query="SELECT UserID,UserDone FROM CalUserDone WHERE FKEventID=".$this->_db->escape($EventID)." AND UserType=".$this->_db->escape($Type);
		if ($User) $query.=" AND UserID=".$this->_db->escape($User);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("UserID")]=$this->_db->f("UserDone");
		}
		return $User?$result[$User]:$result;
	}
	function insertLog ($EventID,$user,$text,$typ) {
		$values=array(
			'FKEventID'=>$EventID,
			'FKUserID'=>$user,
			'Text'=>$text,
			'Type'=>$typ,
			'Date'=>time(),
		);
		$this->_db->insert('EventLog',$values);
	}
	function deleteEventLog($ID,$user=0) {
		$query="DELETE FROM EventLog WHERE";
		if (is_array($ID)) $where[]=" FKEventID IN (".implode(",",$this->_db->escape($ID)).")";
		elseif ($ID) $where[]=" FKEventID=".$this->_db->escape($ID);
		if (is_array($user)) $where[]=" FKUserID IN (".implode(",",$this->_db->escape($user)).")";
		elseif($user) $where[]=" FKUserID=".$this->_db->escape($user);
		if (is_array($where)) {
			$this->_db->query($query.implode(' AND ',$where));
		}
	}

	function listLog($EventID,$typ='',$user='') {
		$result=array();
		$query="SELECT * FROM EventLog WHERE FKEventID=".$this->_db->escape($EventID)." ";
		if (is_array($typ)) $query.=" AND Type IN (".implode(",",$this->_db->escape($typ)).")";
		elseif ($typ) $query.=" AND Type='$typ'";
		if ($user) $query.=" AND FKUserID=".$this->_db->escape($user);
		$query.=' ORDER BY Date DESC';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("LogID")]=array(
				"Text"=>$this->_db->f("Text"),
				"Date"=>$this->_db->f("Date"),
				"User"=>$this->_db->f("FKUserID"),
				"Type"=>$this->_db->f("Type"),
			);
		}

		return $result;
	}
	function deleteLog($ID) {
		$query="DELETE FROM EventLog WHERE LogID=".$this->_db->escape($ID);
		$this->_db->query($query);
	}

	function array_merge_clobber($a1,$a2) {
		$newarray = $a1;
		if (is_array($a2)) {
			foreach ($a2 as $key=>$val) {
				if (is_array($val)) {
					foreach ($val as $key2=>$val2) {
						$newarray[$key][$key2] = $val2;
					}
				}
			}
		}
		return is_array($newarray)?$newarray:array();
	}
	function daycmp ($a, $b) {
		if ($a['TimeMode']==1 && $b['TimeMode']!=1) return -1;
		if ($a['TimeMode']!=1 && $b['TimeMode']==1) return 1;
		if ($a['TimeMode']==1 && $b['TimeMode']==1) {
			if ($a["_row"]==$b["_row"]) return 0;
			if ($a["_row"]==0) return 1;
			if ($b["_row"]==0) return -1;
			return 	$a["_row"]>$b["_row"]?1:-1;
		}
		
		if ($a["StartDate"] == $b["StartDate"]) {
			if ($a["EndDate"]==$b["EndDate"]) {
				return 0;
			} else {
				return ($a["EndDate"]<$b["EndDate"])?-1:1;
			}
		}
		return ($a["StartDate"] < $b["StartDate"]) ? -1 : 1;
	}
	function deleteProject($ID) {
		if ($ID) {
			$query = "SELECT EventID FROM CalEvent WHERE FKProjID=".$this->_db->escape($ID);
			$this->_db->query($query);
			while ($this->_db->next_record()) {
				$delete[]=$this->_db->f('EventID');
			}
			foreach ($delete as $val) {
				$this->deleteEvent($val);
			}
		}
	}
	function deleteUser($uid) {
		$delete=array();
		$query = "SELECT EventID FROM CalEvent WHERE OwnerID=".$this->_db->escape($uid)." AND InvitUsers='' AND InvitGroups='' ";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$delete[]=$this->_db->f('EventID');
		}
		foreach ($delete as $val) {
			$this->deleteEvent($val,true);
		}
	}
	function formatDate($start,$end=0,$tmode=0,$fs='%d.%m.%Y',$adv=false) {
		$start_date=strftime($fs,$start);
		if ($adv && $end && !$tmode) {
			$end_date=strftime($fs,$end);
			if ($start_date==$end_date) {
				$start_date=date("H:i",$start);
				$end_date=date("- H:i",$end);
			} else {
				$start_date.=date(" H:i",$start);
				$end_date=' - '.$end_date.date(" H:i",$end);
			}
		} else {
			if ($end) {
				$end_date=strftime($fs,$end);
				if ($start_date==$end_date) {
					$end_date='';
				} else {
					$end_date=' - '.$end_date;
				}
			}
			if (($tmp=date("H:i",$start))!='00:00' || $tmode!=1) {
				$start_date.=' '.$tmp;
				if ($end) {
					if (!$end_date) $end_date=' -';
					$end_date.=date(" H:i",$end);
				}
			}
		}
		return $start_date.$end_date;
	}
	function isAllowedAction(&$obj,&$action) {
		if (!is_array($action)) return false;
		//echo $action['Perms'].'-'.$this->getCalPerms($action['Perms']).'<br>';
		if ($action['Perms'] && !$this->getCalPerms($action['Perms'])) return false;
		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkAction($obj,substr($ac_val,1));
				} else {
					$result=$result||$this->_checkAction($obj,$ac_val);
				}
			}
			//echo $ac_val;debug($result);
			if (!$result) return false;
		}
		return true;
	}
	function _checkAction(&$obj,$action) {
		switch ($action) {
			case 'owner':
				if ($obj['OwnerID']!=$this->getUser()) return false;
				if ($obj['EvtPrivat'] && $obj['OwnerID']!=$this->getAuthUser()) return false;
			break;
			case 'u_m_write':
				if ($obj['EvtPrivat'] && $obj['OwnerID']!=$this->getAuthUser()) return false;
				if (!$this->getAllCalPerms($obj['OwnerID'],2)) return false;
			break;
			case 'u_m_delete':
				if ($obj['OwnerID']!=$this->getAuthUser() && $this->isRuleUser() && !$this->_frm->getCachedUserName($obj['OwnerID'],0,array('','system'))) return true;
				if ($obj['EvtPrivat'] && $obj['OwnerID']!=$this->getAuthUser()) return false;
				if (!$this->getAllCalPerms($obj['OwnerID'],4)) return false;
			break;
			case 'rec':
				if (!$obj['RecType']) return false;
			break;
			case 'deleted':
				if (!$obj['Deleted']) return false;
			break;
			case 'app_msg':
				if (!$GLOBALS['app']['msg']) return false;
			break;
			case 'app_mail':
				if (!$GLOBALS['app']['email']) return false;
			break;
			case 'app_rem':
				if (!$GLOBALS['app']['rem']) return false;
			break;
			case 'member':
				if ($obj['OwnerID']==$this->getUser()) return false;
				$status=$this->readEventDone($obj['EventID'],'u',$this->getUser());
				if (!$status || $status==2) {
					return false;
				}
			break;
		}
		return true;
	}
	function insertEventFmng($EvtID,$FmngID) {
		foreach ($FmngID as $val) {
			$insert=array(
				'FKEventID'=>$EvtID,
				'FKFmngID'=>$val,
			);
			$this->_db->insert('CalEventFmng',$insert,'',1);
		}
	}
	function deleteEventFmng($EvtID=0,$FmngID=0) {
		$searchQuery=array();
		if ($EvtID) $searchQuery[]=array('Field'=>'FKEventID','Typ'=>'=','Values'=>$EvtID);
		if ($FmngID) $searchQuery[]=array('Field'=>'FKFmngID','Typ'=>'=','Values'=>$FmngID);
		if (!empty($searchQuery)) {
			$this->_db->delete('CalEventFmng',$searchQuery);
		}
	}
	function listEventFmng($EvtID,$FmngID=0) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKEventID','Typ'=>'=','Values'=>$EvtID);
		if ($FmngID) $searchQuery[]=array('Field'=>'FKFmngID','Typ'=>'=','Values'=>$FmngID);
		$query="SELECT FKFmngID FROM CalEventFmng WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('FKFmngID');
		}
		return $result;
	}
	function insertEventColor($EventID,$color) {
		return $this->_frm->insertObjColor('cal',$EventID,$this->getUser(),$color);
	}
	function deleteEventColor($EventID,$UserID=0) {
		return $this->_frm->deleteObjColor('cal',$EventID,$UserID);
	}
	function listEventColor($EventID) {
		return $this->_frm->listObjColor('cal',$EventID,$this->getUser());
	}

	function calcEntries($dayEvents,$day_b,$day_e) {
		$result=array(
			'events'=>array(),
			'options'=>array('max_cols'=>0),
			'busy'=>array(),
		);
		$hunderPct=round(($day_e-$day_b)/60);
		$calcEntries=array();
		$belegt=array();
		$ck=1;
		foreach ($dayEvents as $key=>$val) {
			$min_b=round((max($day_b,$val['StartDate'])-$day_b)/60);
			$min_e=round((min($day_e,$val['EndDate'])-$day_b)/60);

			//debug($val);
			$result['events'][$key]=array(
				'_min_b'=>$min_b,
				'_min_e'=>$min_e,
				'_left'=>round(($min_b)/($hunderPct/100),3),
				'_width'=>round(($min_e-$min_b)/($hunderPct/100),3),
			);
			if ($val['TimeMode']!=1) {
				$calcEntries[$ck]=array(
					'_min_b'=>$min_b,
					'_min_e'=>$min_e,
					'EvtID'=>$key,
					'key'=>$ck,
				);
				$ck++;
			}
		}
		uasort($calcEntries,array($this,"calOverlapSort"));
		foreach ($calcEntries as $val) {
			if (!isset($calcEntries[$val['key']]['_overlap_r'])) $calcEntries[$val['key']]['_overlap_r']=array();
			$parsed=false;
			if (isset($belegt[$val['_min_b']])) {
				$akt_pos=count($belegt[$val['_min_b']]);
				for ($i=0;$i<=count($belegt[$val['_min_b']]);$i++) {
					if (!isset($belegt[$val['_min_b']][$i])) {
						if (!$parsed) {
							$akt_pos=$i;
							$parsed=true;
						}
					} else {
						if ($parsed) $calcEntries[$val['key']]['_overlap_r'][$i]=1;
					}
				}
			} else {
				$akt_pos=0;
			}
			for ($i=$val['_min_b'];$i<=($val['_min_e']);$i++) {
				if (isset($belegt[$i][$akt_pos-1])) {
					for ($j=$akt_pos-1;$j>=0;$j--) {
						if (isset($calcEntries[$belegt[$i][$j]])) {
							$calcEntries[$belegt[$i][$j]]['_overlap_r'][$akt_pos]=1;
							$tmpVal=$calcEntries[$belegt[$i][$j]];
							$result['events'][$tmpVal['EvtID']]['_overlap_r']=count($tmpVal['_overlap_r']);
						}
					}
				}
				$belegt[$i][$akt_pos]=$val['key'];
			}
			$result['events'][$val['EvtID']]['_overlap_l']=$akt_pos;
			$result['events'][$val['EvtID']]['_overlap_r']=count($calcEntries[$val['key']]['_overlap_r']);
			$result['options']['max_cols']=max($result['options']['max_cols'],$akt_pos+1);
		}
		for ($i=0;$i<=$hunderPct;$i++) {
			if (!isset($belegt[$i])) {
				$result['busy'][$i]=0;
			} else {
				$result['busy'][$i]=count($belegt[$i]);
			}
			//$day_e-$day_b;
		}
		//debug($belegt);
		return $result;
	}
	function calOverlapSort($a, $b) {
		if ($a['_min_b']==$b['_min_b']) return 0;
		return $a['_min_b']>$b['_min_b']?1:0;

	}	

	
}
