<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class Vcal {
	var $_errors=array();
	var $_prefs=array(
		'task'=>array(
		),
		'cal'=>array(
		),
	);
	function Vcal() {

	}
	function setUser($uid) {
		$this->_uid=$uid;
	}
	function setLang($lang) {
		$this->_lang=$lang;
	}
	function getError() {
		if (count($this->_errors)) {
			return $this->_errors;
		} else {
			return false;
		}

	}
	function setPrefs($modul,$prefs) {
		$this->_prefs[$modul]=$prefs;
	}
	function vcal2event(&$Card,$new=false) {
		global $P,$frm;
		$obj=array();
		$this->_errors=array();
		if ($Card['UID']) $obj['UID']=$this->parseText($Card['UID']);
		if ($Card['SUMMARY']) $obj['Title']=$this->parseText($Card['SUMMARY']);
		else $obj['Title']='No Title';
		if ($Card['DESCRIPTION']) $obj['Text']=$this->parseText($Card['DESCRIPTION']);
		else $obj['Text']='';
		if ($Card['LOCATION']) $obj['Place']=$this->parseLocation($Card['LOCATION']);
		$obj['StartDate']=$this->parseDate($Card['DTSTART']);
		$this->RefDate=$obj['StartDate'];
		if ($Card['DTEND']) $obj['EndDate']=$this->parseDate($Card['DTEND']);
		else $obj['EndDate']=$obj['StartDate'];

		if ($this->_prefs['cal']['ical']) {
			if ($Card['VALARM']) $obj['AlarmTime']=$this->parseAlarmIcal($Card['VALARM']);
			else $obj['AlarmTime']=0;

			if ($Card['RRULE']) {
				$tmp=$this->getRecTypeIcal($Card['RRULE']);
				$obj['RecType']=$tmp['RecType'];
				$obj['RecInt']=$tmp['RecInt'];
				$obj['RecEnd']=$tmp['RecEnd'];
			} else {
				$obj['RecType']=0;
			}
		} else {
			if ($Card['DALARM']) $obj['AlarmTime']=$this->parseAlarm($Card['DALARM']);
			else $obj['AlarmTime']=0;

			if ($Card['RRULE']) {
				$tmp=$this->getRecType($Card['RRULE']);
				$obj['RecType']=$tmp['RecType'];
				$obj['RecInt']=$tmp['RecInt'];
				$obj['RecEnd']=$tmp['RecEnd'];
			} else {
				$obj['RecType']=0;
			}
		}
		//debug($Card);
		$obj['TimeMode']=0;
		if ($Card['X-FUNAMBOL-ALLDAY'] && implode(';',$Card['X-FUNAMBOL-ALLDAY']['value'])=='1') {
			$obj['TimeMode']=1;
			$obj['EndDate']-=1;
		} else {
			switch($this->_prefs['cal']['allDayMode']) {
				case 1:
					if (date('H:i:s',$obj['EndDate'])=='00:00:00' && date('H:i:s',$obj['StartDate'])=='00:00:00' && date('Ymd',$obj['StartDate'])!=date('Ymd',$obj['EndDate'])) {
						$obj['TimeMode']=1;
						$obj['EndDate']-=1;
					}
				break;
				default:
					if (date('H:i:s',$obj['EndDate'])=='23:59:59' AND date('H:i:s',$obj['StartDate'])=='00:00:00') {
						$obj['TimeMode']=1;
					}
				break;
			}
		}
		if (trim($Card['CATEGORIES']['value'][0])) {
			if (is_object($P)) {
				$pObj=$P->getPrjByName(trim($Card['CATEGORIES']['value'][0]));
				if (is_object($pObj)) {
					$obj['FKProjID']=$pObj->getID();
				}
			}
		}
		if ($Card['STATUS']) {
			$obj['Unsecure']=$this->parseCalStatus($Card['STATUS']);
		}
		if ($this->_prefs['cal']['x-ms-busy'] && $Card['X-MICROSOFT-CDO-BUSYSTATUS']) {
			$obj['Unsecure']=$this->parseMsCalStatus($Card['X-MICROSOFT-CDO-BUSYSTATUS']);
		}

		if ($Card['EXDATE']) {
			$tmp=array();
			if (is_array($Card['EXDATE']['value'])) {
				foreach ($Card['EXDATE']['value'] as $val) {
					$tmp[]=$this->_getDate(trim($val),$this->RefDate);
				}
				$obj['Exception']=implode(',',$tmp);
			}
		}
		if ($new) {
			if (!isset($Card['CLASS']) || $Card['CLASS']!='PRIVATE') {
				$defGrantUsers=array();
				$defGrantGroups=array();
				if (is_object($P) && is_object($pObj)) {
					$grantPerms=$P->getProjectPerms($pObj->getID(),'cal_grant');
					if (trim($grantPerms['PermsUser'])) $defGrantUsers=explode(',',$grantPerms['PermsUser']);
					if (trim($grantPerms['PermsGroup'])) $defGrantGroups=explode(',',$grantPerms['PermsGroup']);

				} else {
					if (isset($this->_prefs['cal']['grant_g'])) {
						$defGrantGroups=$this->_prefs['cal']['grant_g']?explode('|',$this->_prefs['cal']['grant_g']):array();
					} elseif ($frm->getPrefs('cal','dg')) {
						$defGrantGroups=explode('|',$frm->getPrefs('cal','dg'));
					}
					if (isset($this->_prefs['cal']['grant_u'])) {
						$defGrantUsers=$this->_prefs['cal']['grant_u']?explode('|',$this->_prefs['cal']['grant_u']):array();
					} elseif ($frm->getPrefs('cal','du')) {
						$defGrantUsers=explode('|',$frm->getPrefs('cal','du'));
					}
				}
				$obj['GrantGroups']=implode(',',$defGrantGroups);
				$obj['GrantUsers']=implode(',',$defGrantUsers);
			}
			if ($this->_prefs['cal']['attendee'] && is_array($Card['ATTENDEE'])) {
				$cardInvitUsers=array();
				foreach ($Card['ATTENDEE'] as $subVal) {
					if (!$subVal['param']['CUTYPE'] || $subVal['param']['CUTYPE']=='INDIVIDUAL' || $subVal['param']['CUTYPE']=='GROUP') {
						$mail=preg_replace('/mailto:/i','',$subVal['value'][0]);
						$name=$subVal['param']['CN'];
						$rsvp=$subVal['param']['RSVP']=='TRUE'?1:0;
						$stat=$this->parseCalAtendeeStatus($subVal['param']['PARTSTAT']);
						$cardInvitUsers[]=array(
							'mail'=>$mail,
							'name'=>$name,
							'status'=>$stat,
							'rsvp'=>$rsvp,
						);
					}

				}
				$obj['cardInvitUsers']=$cardInvitUsers;
			}
			if ($this->_prefs['cal']['attendee'] && is_array($Card['ORGANIZER'])) {
				$name=$Card['ORGANIZER']['param']['CN'];
				$mail=preg_replace('/mailto:/i','',$Card['ORGANIZER']['value'][0]);
				$obj['cardOrganizer']=array(
					'mail'=>$mail,
					'name'=>$name,
				);
			}
		}

		return $obj;
	}
	function vcal2todo(&$Card) {
		$obj=array();
		$this->_errors=array();
		if ($Card['DTSTART']) {
			$obj['StartDate']=$this->parseDate($Card['DTSTART']);
			$this->RefDate=$obj['StartDate'];
		} else {
			$this->RefDate=time();
		}
		if ($Card['DUE']) {
			$obj['EndDate']=$this->parseDate($Card['DUE']);
			if ($this->RefDate > $obj['EndDate']) $this->RefDate=$obj['EndDate'];
		}

		if ($Card['SUMMARY']) $obj['Title']=$this->parseText($Card['SUMMARY']);
		if ($Card['DESCRIPTION']) $obj['Text']=$this->parseText($Card['DESCRIPTION']);

		$obj['Priority']=$this->parsePriority($Card['PRIORITY']);

		if ($Card['STATUS']) $obj['UserDone']=$this->parseStatus($Card['STATUS']);
		else $obj['UserDone']=1;

		if ($obj['UserDone']==4 && $Card['COMPLETED']) {
			$obj['StatusDate']=$this->parseDate($Card['COMPLETED']);
		}
		if ($this->_prefs['task']['ical']) {
			if ($Card['VALARM']) {
				$obj['Alarm']=round($this->parseAlarmIcal($Card['VALARM'])/(3600*24));
			}
			if ($Card['RRULE']) {
				$tmp=$this->getRecTypeIcal($Card['RRULE']);
				$obj['RecType']=$tmp['RecType'];
				$obj['RecInt']=$tmp['RecInt'];
				$obj['RecDate']=$tmp['RecEnd'];
			}


		} else {
			if ($Card['DALARM']) {
				$obj['Alarm']=round($this->parseAlarm($Card['DALARM'])/(3600*24),$obj['EndDate']);
			}
			if ($Card['RRULE']) {
				$tmp=$this->getRecType($Card['RRULE']);
				$obj['RecType']=$tmp['RecType'];
				$obj['RecInt']=$tmp['RecInt'];
				$obj['RecDate']=$tmp['RecEnd'];
			}
		}


		if ($Card['EXDATE']) {
			$this->_errors['ExDate']=$this->parseText($Card['SUMMARY']);
		}

		if (trim($Card['CATEGORIES']['value'][0])) {
			global $frm,$P;
			if (is_object($P)) {
				$pObj=$P->getPrjByName(trim($Card['CATEGORIES']['value'][0]));
				if (is_object($pObj)) {
					$obj['FKProjID']=$pObj->getID();
				}
			}
			if (is_object($frm)) {
				$Task=& $frm->getStaticModul('task');
				$tID=$Task->nameExists(trim($Card['CATEGORIES']['value'][0]),$this->_uid,$this->_lang);
				if ($tID) {
					$obj['FKDocID']=$tID;
				}
			}
		}
		return $obj;
	}


	function getRecType ($Content) {
		$value=implode(';',$Content['value']);
		$rec=explode(' ',$value);
		$RecType=0;
		$RecInt=0;
		$RecEnd=0;

		if (preg_match('/([A-Z]+)([0-9]+)/',$rec[0],$result)) {
			switch ($result[1]) {
				case 'D':
					$RecType=1;
					break;
				case 'W':
					$RecType=2;
					break;
				case 'MD':
					$RecType=3;
					break;
				case 'YD':
					$this->_errors['RecType']=1;
					$RecType=5;
					break;
				case 'MP':
					$this->_errors['RecType']=1;
					$RecType=3;
					break;
				case 'YM':
					$RecType=5;
					break;
				default:
					$RecType=0;
			}
			//debug ('RecType:'.$RecType);
			if ($RecType) {
				$RecInt=$result[2];
				$num=count($rec);
				$RecEnd=$this->_getRecEnd($rec[$num-1],$RecType,$RecInt);
				if ($num>3) {
					//debug ('NUM:'.$num);
					$this->_errors['RecType']=1;
				}
			}
		}

		return array(
			'RecType'=>$RecType,
			'RecInt'=>$RecInt,
			'RecEnd'=>$RecEnd,
		);
	}
	function getRecInt ($Content) {
		$value=implode(';',$Content['value']);
		if (preg_match('/[A-Z]+([0-9]+)/',$value,$result)) {
			return $result[1];
		} else {
			return 0;
		}
	}
	function _getRecEnd ($recEnd,$recType,$recInt) {
		if ($recEnd[0]=='#') {
			$len=substr($recEnd,1);
			if ($len) {
				$year=date('Y',$this->RefDate);
				$month=date('m',$this->RefDate);
				$day=date('d',$this->RefDate);
				switch ($recType) {
					case 1:
						return mktime(23,59,59,$month,$day+$recInt*$len,$year);
						break;
					case 2:
						return mktime(23,59,59,$month,$day+$recInt*7*$len,$year);
						break;
					case 3:
						return mktime(23,59,59,$month+$recInt*$len,$day,$year);
						break;
					case 5:
						return mktime(23,59,59,$month,$day,$year+$recInt*$len);
						break;
				}
				return -1;
			} else {
				return -1;
			}
		} else {
			return $this->_getDate($recEnd,$this->RefDate);
		}
	}
	function getRecTypeIcal ($Content) {
		//debug(print_r($Content,true));
		$recType=0;
		$recInt=1;
		$recEnd=-1;
		$recCount=0;
		foreach ($Content['value'] as $val) {
			$tmp=explode('=',$val);
			switch (strtoupper($tmp[0])) {
				case 'FREQ':
					switch (strtoupper($tmp[1])) {
						case 'YEARLY':
							$recType=5;
						break;
						case 'MONTHLY':
							$recType=3;
						break;
						case 'WEEKLY':
							$recType=2;
						break;
						case 'DAILY':
							$recType=1;
						break;
					}
				break;
				case 'INTERVAL':
					$recInt=intval($tmp[1]);
				break;
				case 'UNTIL':
					$recEnd=$this->_getDate($tmp[1],$this->RefDate);
				break;
				case 'COUNT':
					$recCount=intval($tmp[1]);
				break;
			}

		}
		//debug('RecType:'.$recType);
		//debug('RecInt:'.$recInt);
		//debug('RecCount:'.$recCount);
		if ($recCount) {
			$recCount-=1;
			$year=date('Y',$this->RefDate);
			$month=date('m',$this->RefDate);
			$day=date('d',$this->RefDate);
			switch ($recType) {
				case 1:
					$recEnd=mktime(23,59,59,$month,$day+$recInt*$recCount,$year);
					break;
				case 2:
					//debug('REC:'.$year.'-'.$month.'-'.$day);
					//debug($recInt*7*$recCount);
					$recEnd=mktime(23,59,59,$month,$day+$recInt*7*$recCount,$year);
					break;
				case 3:
					$recEnd=mktime(23,59,59,$month+$recInt*$recCount,$day,$year);
					break;
				case 5:
					$recEnd=mktime(23,59,59,$month,$day,$year+$recInt*$recCount);
					break;
			}
		}
		return array(
			'RecType'=>$recType,
			'RecInt'=>$recInt,
			'RecEnd'=>$recEnd,
		);

	}
	function parseAlarm($Content,$refdate=0) {
		if (!$refdate) $refdate=$this->RefDate;
		$date=$this->_getDate($Content['value'][0],$this->RefDate);
		if ($date>0) {
			return abs($refdate-$date);
		} else return 0;
	}
	function parseAlarmIcal($Content,$refdate=0) {
		if (!$refdate) $refdate=$this->RefDate;
		if ($Content['TRIGGER']['param']['VALUE']=='DURATION') {
			return abs($this->_parseDuration($Content['TRIGGER']['value'][0]));
		} else {
			$date=$this->_getDate($Content['TRIGGER']['value'][0],$this->RefDate);
			return abs($refdate-$date);
		}
	}
	function parseLocation($Content) {
		$value=implode(';',$Content['value']);
		if (!$Content['param']['VALUE'] || $Content['param']['VALUE']=='INLINE') {
			return $value;
		} else {
			return '';
		}
	}

	function parseText($Content) {
		return implode(';',$Content['value']);
	}

	function parseDate($Content) {
		$value=implode(';',$Content['value']);
		return $this->_getDate($value,$this->RefDate);
	}
	function parsePriority($Content) {
		$value=intval(implode(';',$Content['value']));
		switch ($this->_prefs['task']['prio']) {
			case 10:
				if ($value<=3 && $value>0) $result=0;
				elseif ($value>=7) $result=2;
				else $result=1;
			break;
			case 5:
				if ($value < 3) $result=0;
				elseif ($value>3) $result=2;
				else $result=1;
			break;
			case 2:
				if ($value>=2) $result=0;
				elseif ($value>=1) $result=1;
				else $result=2;
			break;
			default:
				if ($value<=1) $result=0;
				elseif ($value>=3) $result=2;
				else $result=1;
			break;
		}
		return $result;
	}
	function parseStatus($Content) {
		$value=implode(';',$Content['value']);
		switch ($value) {
			case 'ACCEPTED':
				$result=1;
				break;
			case 'NEEDS ACTION':
				$result=1;
				break;
			case 'SENT':
				$result=1;
				break;
			case 'TENTATIVE':
				$result=1;
				break;
			case 'CONFIRMED':
				$result=1;
				break;
			case 'DECLINED':
				$result=2;
				break;
			case 'COMPLETED':
				$result=4;
				break;
			case 'DELEGATED':
				$result=5;
				break;
			default:
				$result=1;
		}
		return $result;
	}
	function parseMsCalStatus($Content) {
		$value=implode(';',$Content['value']);
		switch ($value) {
			case '1':
				$result=1;
			break;
			default:
				$result=0;
		}
		return $result;
	}
	function parseCalStatus($Content) {
		$value=implode(';',$Content['value']);
		switch ($value) {
			case 'ACCEPTED':
				$result=0;
				break;
			case 'NEEDS ACTION':
				$result=0;
				break;
			case 'SENT':
				$result=0;
				break;
			case 'TENTATIVE':
				$result=1;
				break;
			case 'CONFIRMED':
				$result=0;
				break;
			case 'DECLINED':
				$result=0;
				break;
			case 'COMPLETED':
				$result=0;
				break;
			case 'DELEGATED':
				$result=0;
				break;
			default:
				$result=0;
		}
		return $result;
	}
	function parseCalAtendeeStatus($value) {
		switch ($value) {
			case 'ACCEPTED':
				$result=1;
				break;
			case 'NEEDS ACTION':
				$result=0;
				break;
			case 'TENTATIVE':
				$result=3;
				break;
			case 'DECLINED':
				$result=2;
				break;
			case 'DELEGATED':
				$result=1;
				break;
			default:
				$result=0;
		}
		return $result;

	}
	function _getDate($Content,$RefDate) {
		if ($Content[0]=='-') {
			$mode=-1;
			$Content=substr($Content,1);
		} else {
			$mode=1;
		}
		if ($Content[0]=='P') {
			$year=date('Y',$RefDate);
			$month=date('m',$RefDate);
			$day=date('d',$RefDate);
			$hour=date('H',$RefDate);
			$min=date('i',$RefDate);
			$sec=date('s',$RefDate);
			$tmp=explode('T',$Content);
			if (preg_match_all('/([0-9]+)([A-Z])/',$tmp[0],$date,PREG_SET_ORDER)) {
				foreach ($date as $val) {
					switch ($val[2]) {
						case 'Y':
							$year+=$val[1]*$mode;
							break;
						case 'M':
							$month+=$val[1]*$mode;
							break;
						case 'W':
							$day+=$val[1]*7*$mode;
							break;
						case 'D':
							$day+=$val[1]*$mode;
							break;
					}
				}
			}
			if (preg_match_all('/([0-9]+)([A-Z])/',$tmp[1],$time,PREG_SET_ORDER)) {
				foreach ($time as $val) {
					switch ($val[2]) {
						case 'H':
							$hour+=$val[1]*$mode;
							break;
						case 'M':
							$min+=$val[1]*$mode;
							break;
						case 'S':
							$sec+=$val[1]*7*$mode;
							break;
					}
				}
			}
			return mktime($hour,$min,$sec,$month,$day,$year);
		} else {

			$year=intval(substr($Content,0,4));
			$month=intval(substr($Content,4,2));
			$day=intval(substr($Content,6,2));
			$hour=intval(substr($Content,9,2));
			$min=intval(substr($Content,11,2));
			$sec=intval(substr($Content,13,2));
			$utc=$Content[15]=='Z'?true:false;
			if ($utc) {
				//return mktime($hour,$min,$sec,$month,$day,$year);
				return gmmktime($hour,$min,$sec,$month,$day,$year);
			} else {
				return mktime($hour,$min,$sec,$month,$day,$year);
			}
		}
	}
	function event2vcal(&$obj,$iv_users=array(),$org_user=array()) {
		global $frm,$P;
		$Cal=& $frm->getStaticModul('cal');
		$Card=array();
		if (!$obj['TimeCreate']) $obj['TimeCreate']=time();
		if (!$obj['TimeModify']) $obj['TimeModify']=time();
		if ($obj['TimeMode']==1) {
			switch($this->_prefs['cal']['allDayMode']) {
				case 1:
					$Card['DTSTART'] = $this->setDate($obj['StartDate'],'000000');
					$Card['DTEND'] = $this->setDate(mktime(0,0,0,date('m',$obj['EndDate']),date('d',$obj['EndDate'])+1,date('Y',$obj['EndDate'])),'000000');
				break;
				default:
					$Card['DTSTART'] = $this->setDate($obj['StartDate'],'000000');
					$Card['DTEND'] = $this->setDate($obj['EndDate'],'235959');
				break;
			}
			if ($this->_prefs['cal']['x-funambol-allday']) {
				$Card['X-FUNAMBOL-ALLDAY']=$this->setText('1');
			}
		} else {
			$Card['DTSTART'] = $this->setDate($obj['StartDate'],'',$this->_prefs['cal']['gmdate']?1:0);
			$Card['DTEND'] = $this->setDate($obj['EndDate'],'',$this->_prefs['cal']['gmdate']?1:0);
		}
		if ($this->_prefs['cal']['ical']) {
			$Card['DTSTAMP'] = $this->setDate($obj['TimeModify'],'',1);
		}
		if ($this->_prefs['cal']['ical'] && $obj['UID']) {
			$Card['UID']=$this->setText($obj['UID']);
		}
		if ($this->_prefs['cal']['attendee']) {
			if (empty($org_user)) {
				$tmpUser=$frm->getCachedUser($obj['OwnerID']);
				$org_user=array(
					'mail'=>$tmpUser['email'],
					'name'=>trim($tmpUser['lastname'].' '.$tmpUser['firstname']),
				);
			}
			if (empty($iv_users)) {
				if (trim($obj['InvitGroups']) || trim($obj['InvitUsers'])) {
					$user_done=$Cal->readEventDone($obj['EventID'],'u');
					$InvitGroups=trim($obj['InvitGroups'])?explode(',',$obj['InvitGroups']):array();
					$InvitUsers=trim($obj['InvitUsers'])?explode(',',$obj['InvitUsers']):array();
					$tmpUids=array_unique(array_merge($frm->getGroupUsers($InvitGroups),$InvitUsers,array($obj['OwnerID'])));
					foreach ($tmpUids as $val) {
						$tmpUser=$frm->getCachedUser($val);
						if ($tmpUser['email']) {
							$iv_users[]=array(
								'mail'=>$tmpUser['email'],
								'name'=>trim($tmpUser['lastname'].' '.$tmpUser['firstname']),
								'status'=>$user_done[$val],
								'rsvp'=>1,
							);
						}
					}
				}
				if ($obj['InvitAddr']) {
					$Addr=& $frm->getStaticModul('addr');
					$InvitAddr=explode(',',$obj['InvitAddr']);
					foreach ($InvitAddr as $val) {
						if ($tmpUser=$Addr->getAddrObj($val)) {
							$tmpMail=$Addr->AddrExplode($tmpUser->getMeta('Email'));
							$iv_users[]=array(
								'mail'=>$tmpMail[0],
								'name'=>$tmpUser->getName(),
								'status'=>0,
								'rsvp'=>1,
							);
						}
					}
				}
			}
			if (!empty($org_user)) {
				$Card['ORGANIZER']=$this->setOrganizer($org_user);
			}
			if (!empty($iv_users)) {
				$Card['ATTENDEE']=$this->setAttendee($iv_users);
			}
		}
		if ($this->_prefs['cal']['ical']) {
			$Card['CREATED'] = $this->setDate($obj['TimeCreate']?$obj['TimeCreate']:$obj['TimeModify'],'',1);
			$Card['LAST-MODIFIED'] = $this->setDate($obj['TimeModify'],'',1);
			$Card['TRANSP'] = $this->setText('OPAQUE');
			$Card['SEQUENCE'] = $this->setText($obj['Sequence']?$obj['Sequence']:'0');
		}
		if ($obj['Place']) $Card['LOCATION']=$this->setLocation($obj['Place']);
		$Card['SUMMARY']=$this->setText($obj['Title']);
		if ($obj['Text']) $Card['DESCRIPTION']=$this->setText($obj['Text']);

		if ($this->_prefs['cal']['ical']) {
			if ($obj['AlarmTime']) {
				$Card['ALARM']=$this->setIcalAlarm($obj['AlarmTime'],$Card['SUMMARY']);
			}
			if ($obj['RecType']) {
				$Card['RRULE']=$this->setIcalRec($obj['StartDate'],$obj['RecType'],$obj['RecInt'],$obj['RecEnd']);
				if ($obj['Exception']) {
					$exdates=explode(',',$obj['Exception']);
					$tmpDates=array();
					$Card['EXDATE']['param']['VALUE']='DATE';
					foreach ($exdates as $val) {
						$tmpDates[]=date('Ymd',$val);
					}
					$Card['EXDATE']['value']=implode(',',$tmpDates);
				}
			}
		} else {
			if ($obj['AlarmTime']) {
				$Card['DALARM']=$Card['AALARM']=$this->setAlarm($obj['StartDate']-$obj['AlarmTime'],'','',$this->_prefs['cal']['gmdate']?1:0);
			}
			if ($obj['RecType']) {
				$Card['RRULE']=$this->setRec($obj['StartDate'],$obj['RecType'],$obj['RecInt'],$obj['RecEnd']);
				if ($obj['Exception']) {
					$exdates=explode(',',$obj['Exception']);
					foreach ($exdates as $val) {
						$tmp=$this->setDate($val,'000000');
						$Card['EXDATE']['value'][]=$tmp['value'];
					}
				}
			}
		}

		if ($P && $obj['FKProjID']) {
			$pObj=$P->getObj($obj['FKProjID']);
			if ($pObj) $Card['CATEGORIES']=$this->setText($pObj->getName());
		}
		if ($this->_prefs['cal']['x-ms-busy']) {
			if ($obj['Invitation']) {
				$Card['X-MICROSOFT-CDO-BUSYSTATUS']=$this->setMsCalStatus(1);
			} else {
				$Card['X-MICROSOFT-CDO-BUSYSTATUS']=$this->setMsCalStatus($obj['Unsecure']);
			}
		}
		if (!$this->_prefs['cal']['noStatus']) {
			if ($obj['Invitation']) {
				$Card['STATUS']=$this->setCalStatus(1);
			} else {
				$Card['STATUS']=$this->setCalStatus($obj['Unsecure']);
			}
		}
		if ($obj['EvtPrivat']) {
			$Card['CLASS']=$this->setText('PRIVAT');
		}
		//$Card['CLASS']=$this->setText('');
		return $Card;
	}
	function todo2vcal(&$obj) {
		global $frm,$P;
		$Card=array();
		$Card['SUMMARY']=$this->setText($obj['Title']);
		if ($obj['Text']) $Card['DESCRIPTION']=$this->setText($obj['Text']);
		if ($obj['StartDate']!=$obj['EndDate']) {
			$Card['DTSTART'] = $this->setDate($obj['StartDate']);
			$Card['DUE']=$this->setDate($obj['EndDate'],'000000');
		} elseif($this->_prefs['task']['startdate']) {
			$Card['DTSTART'] = $this->setDate($obj['StartDate']);
		}
		if ($this->_prefs['task']['ical']) {
			if ($obj['Alarm']) {
				$Card['ALARM']=$this->setIcalAlarm($obj['Alarm']*3600*24,$Card['SUMMARY']);
			}
			if ($obj['RecType']) {
				if (!$Card['DTSTART']) $Card['DTSTART'] = $this->setDate($obj['StartDate']);
				$Card['RRULE']=$this->setIcalRec($obj['StartDate'],$obj['RecType'],$obj['RecInt'],$obj['RecDate']);
			}
		} else {
			if ($obj['Alarm']) {
				$Card['DALARM']=$Card['AALARM']=$this->setAlarm($obj['StartDate']-($obj['Alarm']*3600*24),'',$obj['Title']);
			}
			if ($obj['RecType']) {
				if (!$Card['DTSTART']) $Card['DTSTART'] = $this->setDate($obj['StartDate']);
				$Card['RRULE']=$this->setRec($obj['StartDate'],$obj['RecType'],$obj['RecInt'],$obj['RecDate']);
			}
		}


		$Card['PRIORITY']=$this->setPriority($obj['Priority']);
		$Card['STATUS']=$this->setStatus($obj['UserDone']);

		if (!$Card['CATEGORIES'] && $P && $obj['FKProjID']) {
			$pObj=$P->getObj($obj['FKProjID']);
			if ($pObj) $Card['CATEGORIES']=$this->setText($pObj->getName());

		}
		if (!$Card['CATEGORIES'] && $obj['FKDocID']) {
			$Task=& $frm->getStaticModul('task');
			$tObj=$Task->getName($obj['FKDocID'],$this->_lang);
			if ($tObj) $Card['CATEGORIES']=$this->setText($tObj);
		}
		return $Card;
	}
	function setAttendee($attendees) {
		$result=array(
			'isMulti'=>true,
		);
		foreach ($attendees as $IvUser) {
			switch ($IvUser['status']) {
				case 3:
					$status='TENTATIVE';
				break;
				case 2:
					$status='DECLINED';
				break;
				case 1:
					$status='ACCEPTED';
				break;
				default:
					$status='NEEDS-ACTION';
				break;
			}
			$param=array(
				'CUTYPE'=>'INDIVIDUAL',
				'ROLE'=>'REQ-PARTICIPANT',
				'PARTSTAT'=>$status,
			);
			if ($IvUser['rsvp']) $param['RSVP']='TRUE';
			if ($IvUser['name']) $param['CN']=$IvUser['name'];
			$result['value'][]=array(
				'param'=>$param,
				'value'=>'mailto:'.$IvUser['mail'],
			);
		}
		return $result;
	}
	function setOrganizer($orgUser) {
		$param=array();
		if ($orgUser['CN']) $param['CN']=$orgUser['name'];
		$result=array(
			'param'=>$param,
			'value'=>'mailto:'.$orgUser['mail'],
		);

		return $result;
	}
	function setPriority($text) {
		switch ($this->_prefs['task']['prio']) {
			case 10:
				if ($text==0) $result['value']=3;
				if ($text==1) $result['value']=5;
				if ($text==2) $result['value']=7;
			break;
			case 5:
				if ($text==0) $result['value']=1;
				if ($text==1) $result['value']=3;
				if ($text==2) $result['value']=5;
			break;
			case 2:
				if ($text==0) $result['value']=2;
				if ($text==1) $result['value']=1;
				if ($text==2) $result['value']=0;
			break;
			default:
				if ($text==0) $result['value']=1;
				if ($text==1) $result['value']=2;
				if ($text==2) $result['value']=3;
			break;
		}
		return $result;
	}
	function setStatus($status) {
		switch ($status) {
			case 1:
				$result['value']='NEEDS ACTION';
				break;
			case 4:
				$result['value']='COMPLETED';
				break;
			default:
				$result['value']='NEEDS ACTION';
		}
		return $result;
	}
	function setMsCalStatus($status) {
		switch ($status) {
			case 1:
				$result['value']='1';
				break;
			default:
				$result['value']='2';
		}
		return $result;
	}
	function setCalStatus($status) {
		switch ($status) {
			case 1:
				$result['value']='TENTATIVE';
				break;
			default:
				$result['value']='CONFIRMED';
		}
		return $result;
	}
	function setCalTransp($status) {
		switch ($status) {
			case 1:
				$result['value']='1';
				break;
			default:
				$result['value']='0';
		}
		return $result;
	}
	function setText($text) {
		$result['value']=$text;
		return $result;
	}
	function setLocation($text) {
		$result['value']=$text;
		return $result;
	}
	function setDate($stamp,$time=0,$utc=0) {
		if ($time) {
			$stamp=mktime(substr($time,0,2),substr($time,2,2),substr($time,4,2),date('m',$stamp),date('d',$stamp),date('Y',$stamp));
		}
		if ($utc) {
			$result['value']=gmdate('Ymd\THis',$stamp).'Z';
		} else {
			$result['value']=date('Ymd\THis',$stamp);
		}
		return $result;
	}
	function setAlarm($stamp,$time_string='',$msg_string='',$utc=0) {
		if ($time_string) {
			if ($utc) {
				$date=date('Ymd\T',$stamp).$time_string.'Z';
			} else {
				$date=date('Ymd\T',$stamp).$time_string;
			}
		} else {
			if ($utc) {
				$date=gmdate('Ymd\THis',$stamp).'Z';
			} else {
				$date=date('Ymd\THis',$stamp);
			}
		}
		$result['value']=array(
			$date,
			'',
			'',
			$msg_string,
		);
		$this->_escape($result);
		return $result;
	}
	function setIcalAlarm($diff,$msg_string) {
		$result['isSub']='VALARM';
		$result['value']=array(
			'ACTION'=>array(
				'value'=>'DISPLAY',
			),
			'TRIGGER'=>array(
				'param'=>array(
					'VALUE'=>'DURATION',
					'RELATED'=>'START',
				),
				'value'=>$this->_setDuration(abs($diff)*-1),
			),
			'DESCRIPTION'=>array(
				'value'=>$msg_string,
			),
		);
		return $result;
	}
	function _setDuration($seconds) {
		$parsedTime=false;
		$result='P';
		if ($seconds<0) $result='-'.$result;
		$seconds=abs($seconds);
		$start='D';
		$factor=3600*24;
		while ($seconds) {
			$aktVal=floor($seconds/$factor);
			$seconds=$seconds%$factor;
			switch ($start) {
				case 'D':
					if ($aktVal) $result.=$aktVal.'D';
					$factor=3600;
					$start='H';
				break;
				case 'H':
					if ($aktVal) {
						if (!$parsedTime) {
							$result.='T';
							$parsedTime=true;
						}
						$result.=$aktVal.'H';
					}
					$factor=60;
					$start='M';
				break;
				case 'M':
					if ($aktVal) {
						if (!$parsedTime) {
							$result.='T';
							$parsedTime=true;
						}
						$result.=$aktVal.'M';
					}
					$factor=1;
					$start='S';
				break;
				case 'S':
					if ($aktVal) {
						if (!$parsedTime) {
							$result.='T';
							$parsedTime=true;
						}
					}
					$result.=$aktVal.'S';
					$seconds=false;
				break;
			}
		}
		return $result;
	}
	function _parseDuration($value) {
		if ($value[0]=='-') {
			$fac=-1;
			$value=substr($value,1);
		} else {
			$fac=0;
		}
		$tmp=explode('T',$value);

		$valArrayD=$valArrayT=array();
		if (trim($tmp[0])) $valArrayD=preg_split('/([0-9]+)/',$tmp[0],-1,PREG_SPLIT_DELIM_CAPTURE|PREG_SPLIT_NO_EMPTY);
		if (trim($tmp[1])) $valArrayT=preg_split('/([0-9]+)/',$tmp[1],-1,PREG_SPLIT_DELIM_CAPTURE|PREG_SPLIT_NO_EMPTY);

		$result=0;
		$numVal=0;
		foreach ($valArrayD as $val) {
			switch ($val) {
				case 'D':
					$result=$result+$numVal*3600*24;
				break;
				default:
					$numVal=intval($val);
			}
		}
		$numVal=0;
		foreach ($valArrayT as $val) {
			switch ($val) {
				case 'H':
					$result=$result+$numVal*3600;
				break;
				case 'M':
					$result=$result+$numVal*60;
				break;
				case 'S':
					$result=$result+$numVal;
				break;
				default:
					$numVal=intval($val);
			}
		}
		return $result;
	}
	function setRec($Date,$RecType,$RecInt,$RecEnd) {
		switch ($RecType) {
			case 1:
				$rec='D'.$RecInt;
				break;
			case 2:
				$rec='W'.$RecInt.' '.strtoupper(substr(date('D',$Date),0,2));
				break;
			case 3:
				$rec='MD'.$RecInt.' '.date('d',$Date);
				break;
			case 5:
				$rec='YM'.$RecInt.' '.date('m',$Date);
				break;
		}
		if ($RecEnd>0) {
			$rec.=' '.date('Ymd\THis',$RecEnd);

		} else {
			$rec.=' #0';
		}
		$result['value']=$rec;
		return $result;
	}
	function setIcalRec($Date,$RecType,$RecInt,$RecEnd) {
		switch ($RecType) {
			case 1:
				$result['value'][]='FREQ=DAILY';
				break;
			case 2:
				$result['value'][]='FREQ=WEEKLY';
				break;
			case 3:
				$result['value'][]='FREQ=MONTHLY';
				break;
			case 5:
				$result['value'][]='FREQ=YEARLY';
				break;
		}
		$result['value'][]='INTERVAL='.$RecInt;
		if ($RecEnd>0) {
			$result['value'][]='UNTIL='.date('Ymd\THis',$RecEnd);
		}
		return $result;
	}
	function _escape(&$text) {
		if (is_array($text)) {
			foreach ($text as $key=>$val) {
				$this->_escape($val);
				$text[$key]=$val;
			}
		} else {
			// escape semicolons not led by a backslash
			$regex = '(?<!\\\\)(\;)';
			$text = preg_replace("/$regex/i", "\\;", $text);
		}
	}
}

?>
