<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class VcalParse {
	var $_isMultple=array('ATTENDEE'=>1);
	function VcalParse() {

	}
	function setPrefs($modul,$prefs) {
		$this->_prefs[$modul]=$prefs;
	}
	function fromFile($filename)   {
		$text = implode('', file($filename));
		return $this->fromText($text);
	}

	function fromText($text) {
		$this->convertLineEndings($text);
		$fold_regex = '(\n([ ]|\t))';
		$text = preg_replace("/$fold_regex/i", "", $text);
		$fold_regex = '(=\n)';
		$text = preg_replace("/$fold_regex/i", "", $text);
		$lines = explode("\n", $text);
		return $this->_fromArray($lines);
	}

	function convertLineEndings(&$text)  {
		$text = str_replace("\r\n", "\n", $text);
		$text = str_replace("\r", "\n", $text);
	}

	function splitBySemi($text, $getFirst = false) {
		$regex = '(?<!\\\\)(\;)';
		$tmp = preg_split("/$regex/i", $text);
		if ($getFirst) {
			return $tmp[0];
		} else {
			return $tmp;
		}
	}

	function splitByComma($text, $getFirst = false)  {
		$regex = '(?<!\\\\)(\,)';
		$tmp = preg_split("/$regex/i", $text);
		if ($getFirst) {
			return $tmp[0];
		} else {
			return $tmp;
		}
	}

	function unescape(&$text) {
		if (is_array($text)) {
			foreach ($text as $key => $val) {
				$this->unescape($val);
				$text[$key] = $val;
			}
		} else {
			$text = str_replace('\;', ';', $text);
			$text = str_replace('\,', ',', $text);
			$text = str_replace('\n', "\n", $text);
		}
	}


	function _fromArray($source) {
		$info = array();
		$begin = false;
		$begin_event = false;
		$card = array();
		foreach ($source as $line) {
			if (trim($line) == '') {
				continue;
			}
			$ign=false;$pos=false;
			for ($i=0;$i<strlen($line);$i++) {
				if ($line[$i]=='"') $ign=$ign?false:true;
				if (!$ign && $line[$i]==':') {
					$pos=$i;
					break;
				}

			}
			if ($pos === false) {
				continue;
			}
			//debug($line);

			$left = trim(substr($line, 0, $pos));
			$right = trim(substr($line, $pos+1, strlen($line)));
			//debug($left);
			//debug($right);

			if (!$begin) {
				if (strtoupper($left) == 'BEGIN' &&  strtoupper($right) == 'VCALENDAR') {
					$begin = true;
				}
				continue;
			} else {
				if (!$begin_event) {
					if (strtoupper($left) == 'BEGIN' && (strtoupper($right) == 'VEVENT') || strtoupper($right) == 'VTODO') {
						$begin_event = true;
						$card['X-GROUP-E-TYP']=array(
								'param' => array(),
								'value' => array(strtoupper($right)),

						);
					}
					continue;
				} else {
					if (strtoupper($left) == 'END' && (strtoupper($right) == 'VEVENT') || strtoupper($right) == 'VTODO') {
						$info[] = $card;
						$begin_event = false;
						$akt_typ='';
						$card = array();
					} else {
						if (strtoupper($left) == 'BEGIN') {
							$subtyp=strtoupper($right);
							continue;
						}
						if (strtoupper($left) == 'END') {
							$card[$subtyp] = $subcard;
							$subcard=array();
							$subtyp=false;
							continue;
						}
						$typedef = $this->_getTypeDef($left);
						$params = $this->_getParams($left);
						$values=$this->_getValues($right);

						if ($params['ENCODING']) {
							$values=$this->decode($values,$params['ENCODING']);
							unset($params['ENCODING']);
						} elseif (array_key_exists('QUOTED-PRINTABLE',$params)) {
							$values=$this->decode($values,'QUOTED-PRINTABLE');
							unset($params['QUOTED-PRINTABLE']);
						}

						if ($params['CHARSET']) {
							$values=$this->decode($values,$params['CHARSET']);
							unset($params['CHARSET']);
						}
						if ($this->_prefs['cal']['ical'] || $this->_prefs['task']['ical']) {
							$this->decodeIcal($values);
							//debug($values);
						}

						if ($subtyp) {
							if (isset($subcard[$typedef])) {
								foreach ($values as $subval) {
									$subcard[$typedef]['value'][]=$subval;
								}
							} else {
								$subcard[$typedef] = array(
									'param' => $params,
									'value' => $values,
								);
							}

						} else {
							if (isset($this->_isMultple[$typedef])) {
								$card[$typedef][] = array(
									'param' => $params,
									'value' => $values,
								);
							} elseif (isset($card[$typedef])) {
								foreach ($values as $subval) {
									$card[$typedef]['value'][]=$subval;
								}
							} else {
								$card[$typedef] = array(
									'param' => $params,
									'value' => $values,
								);
							}
						}
					}
				}
			}
		}
		$this->unescape($info);
		return $info;
	}

  	function _getTypeDef($text)   {
        return $this->splitBySemi($text,true);
	}

	function _getParams($text)  {
		// split the text by semicolons into an array
		$split = $this->splitBySemi($text);
		// drop the first element of the array (the type-definition)
			array_shift($split);

		// set up an array to retain the parameters, if any
		$params = array();
		foreach ($split as $full) {
			$tmp = explode("=", $full);
			$key = strtoupper(trim($tmp[0]));
			if (preg_match('/^["\'](.+)["\']$/',$tmp[1])) {
				$tmp[1]=substr($tmp[1],1,-1);
			}
			$params[$key]=$tmp[1];
		}

		// return the parameters array.
		return $params;
	}
	function _getValues($text) {
		return $this->splitBySemi($text);
	}
	function decode ($value,$enc=false) {
		if (!$enc) return $value;
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->decode($val,$enc);
			}
		} else  {
			switch (strtoupper($enc)) {
				case 'QUOTED-PRINTABLE':
					$value=quoted_printable_decode($value);
					break;
				case 'BASE64':
					$value=base64_decode($value);
					break;
				default:
					$value=Framework::convertCharset($value,$enc,GE_CHARSET);
					break;
			}
		}
		return $value;
	}
	function decodeIcal ($value) {
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->decodeIcal($val);
			}
		} else  {
			$value=Framework::convertCharset($value,'UTF-8',GE_CHARSET);
			$value=str_replace('\n',"\n",$value);
			$value=str_replace('\\\\','\\',$value);
		}
		return $value;
	}

}
?>