<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class VcalWrite {
	var $newline="\r\n";
	var $globalCard=array();
	function VcalWrite() {

	}
	function setPrefs($modul,$prefs) {
		$this->_prefs[$modul]=$prefs;
	}
	function setGlobalCard($globalCard) {
		$this->globalCard=$globalCard;
	}
	function getVcal ($Card,$ctyp='VEVENT',$version='1.0') {
		$lines[]='BEGIN:VCALENDAR';
		if (!isset($this->globalCard['VERSION'])) {
			$lines[]='VERSION:'.$version;
		}
		if (!empty($this->globalCard)) {
			foreach($this->globalCard as $Typ=>$val) {
				if ($this->_prefs['cal']['ical'] || $this->_prefs['task']['ical']) {
					$this->escapeIcal($val['value']);
				} else {
					if ($this->escape($val['value'])) {
						$val['param']['ENCODING']='QUOTED-PRINTABLE';
						$val['value'].=$this->newline;
					}
					if ($this->encode($val['value'])) {
						$val['param']['CHARSET']='UTF-8';
					}
				}
				if ($val['isMulti']) {
					if (is_array($val['value'])) {
						foreach ($val['value'] as $subVal) {
							$lines[]=$this->_getLine($Typ,$subVal);
						}
					}
				} elseif ($val['isSub']) {
					$lines[]='BEGIN:'.$val['isSub'];
					foreach ($val['value'] as $subTyp=>$subVal) {
						$lines[]=$this->_getLine($subTyp,$subVal);
					}
					$lines[]='END:'.$val['isSub'];
				} else {
					$lines[]=$this->_getLine($Typ,$val);
				}
			}
		}
		if (!array_key_exists(0,$Card)) {
			$Card=array(0=>$Card);
		}
		foreach ($Card as $row) {
			$lines[]='BEGIN:'.$ctyp;
			foreach ($row as $Typ=>$val) {
				//debug ($Typ.':'.$val['value']);
				switch ($Typ) {
					case 'ATTENDEE':
					case 'DESCRIPTION':
					case 'SUMMARY':
					case 'AALARM':
					case 'DALARM':
					case 'CATEGORIES':
					case 'LOCATION':
						if ($this->_prefs['cal']['ical'] || $this->_prefs['task']['ical']) {
							$this->escapeIcal($val['value']);
						} else {
							if ($this->escape($val['value'])) {
								$val['param']['ENCODING']='QUOTED-PRINTABLE';
								$val['value'].=$this->newline;
							}
							if ($this->encode($val['value'])) {
								$val['param']['CHARSET']='UTF-8';
							}
						}
					break;
				}
				if ($val['isMulti']) {
					if (is_array($val['value'])) {
						foreach ($val['value'] as $subVal) {
							$lines[]=$this->_getLine($Typ,$subVal);
						}
					}
				} elseif ($val['isSub']) {
					$lines[]='BEGIN:'.$val['isSub'];
					foreach ($val['value'] as $subTyp=>$subVal) {
						$lines[]=$this->_getLine($subTyp,$subVal);
					}
					$lines[]='END:'.$val['isSub'];
				} else {
					$lines[]=$this->_getLine($Typ,$val);
				}
			}
			$lines[]='END:'.$ctyp;
		}
		$lines[]='END:VCALENDAR';
		return implode($this->newline,$lines);
	}
	function _getLine($Typ,$val) {
		$line=$Typ;
		if (is_array($val['param'])) {
			foreach ($val['param'] as $param_key=>$param_val) {
				if ($this->_prefs['cal']['ical']) {
					$this->escapeParamIcal($param_val);
				} else {
					$this->escape($param_val);
				}
				$line.=';'.$param_key.'='.$param_val;
			}
		}
		$line.=':';
		if (is_array($val['value'])) $line.=implode(';',$val['value']);
		else $line.=$val['value'];
		if (!$val['param']['ENCODING']) $this->foldLine($line);
		return $line;
	}
	function escapeParamIcal(&$text) {
		if (preg_match('/[,:;]/',$text)) {
			$text='"'.$text.'"';
		}
	}
	function escape(&$text) {
		$enc=false;
		if (is_array($text)) {
			foreach ($text as $key => $val) {
				$tmp=$this->escape($val);
				if ($tmp) $enc=true;
				$text[$key] = $val;
			}
		} else {
			// escape newlines
			if (strpos($text,"\n")) {
				$text = $this->quoted_printable_encode($text);
				//$text = str_replace("/$regex/i", "\n ", $text);
				$enc=true;
			}
			/*
			$temp = $this->quoted_printable_encode($text);
			if ($temp!=$text) {
				$enc=true;
				$text=$temp;
			}*/
		}
		return $enc;
	}
	function encode (&$Content) {
		if (GE_CHARSET=='UTF-8') {
			$enc=true;
		} else {
			$enc=false;
			if (is_array($Content)) {
				foreach ($Content as $key=>$val) {
					$tmp=Framework::convertCharset($val,GE_CHARSET,'UTF-8');
					if ($tmp!=$val) {
						$enc=true;
						$Content[$key]=$tmp;
					}
				}

			} else {
				$tmp=Framework::convertCharset($Content,GE_CHARSET,'UTF-8');
				if ($tmp!=$Content) {
					$enc=true;
					$Content=$tmp;
				}
			}
		}
		return $enc;
	}
	function escapeIcal(&$text) {
		if (is_array($text)) {
			//debug($text);
			foreach ($text as $key => $val) {
				$this->escapeIcal($val);
				$text[$key]=$val;
			}
		} else {
			// escape newlines
			$text=str_replace('\\','\\\\',$text);
			$text=str_replace("\n",'\n',$text);
			if (GE_CHARSET!='UTF-8') {
				$text=Framework::convertCharset($text,GE_CHARSET,'UTF-8');
			}
		}
	}
	function foldLine(&$line) {
		if (strlen($line) > 75) {
			$line=wordwrap($line,75,"".$this->newline." ",($this->_prefs['cal']['ical'] || $this->_prefs['task']['ical'])?true:false);
		}
	}
	function quoted_printable_encode($input, $line_max = 75) {
		$hex    = array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
		$lines  = preg_split("/(?:\r\n|\r|\n)+/", $input);
		$eol    = "\r\n";
		$escape = "=";
		$output = "";
		$len=count($lines);
		for($j=0;$j<$len;$j++) {
			$line=$lines[$j];
			//$line  = rtrim($line); // remove trailing white space -> no =20\r\n necessary
			$linlen  = strlen($line);
			$newline = "";
			for ($i = 0; $i < $linlen; $i++) {
				$c   = substr($line, $i, 1);
				$dec = ord($c);
				if ( ($dec == 32) && ($i == 0)) {  // convert space at begin only
					$c = "=20";
				} elseif (($dec == 61) || ($dec < 32 ) || ($dec > 126)) {  // always encode "\t", which is *not* required
					$h2 = floor($dec/16); $h1 = floor($dec%16);
					$c = $escape.$hex["$h2"].$hex["$h1"];
				}
				if ($i==$linlen-1 && $j!=$len-1) {
					$c.='=0D=0A=';
				}
				if ((strlen($newline) + strlen($c)) >= $line_max) { // CRLF is not counted
					$output .= $newline.$escape.$eol; // soft line break; " =\r\n" is okay
					$newline = "";
				}
				$newline .= $c;
			} // end of for
			$output .= $newline.$eol;
		}
		return trim($output);
	}

}

?>
