<?php
class CalImportGui extends ObjCore {
	protected $_Base;
	protected $_BasImp;
	protected $_BaseRes;
	protected $_BaseCat;
	protected $_T;
	protected $_P;
	protected $_E;
	public $_frm;

	protected $_options=array(
		'impCsv'=>true,
		'impIcal'=>true,
		'impRes'=>true,
		'showCategory'=>true,
		'defCategory'=>0,
		'showOwner'=>true,
		'defOwner'=>0,
	);
	function __construct($options=array()) {
		global $frm,$t,$T,$E,$L,$P;
		require_once 'lib/cal/class_CalImport.php';
		$this->_BasImp=new CalImport();
	
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_BaseRes=& $frm->getStaticModul('cal_res');
		$this->_BaseCat=& $frm->getStaticModul('cal_cat');
		$this->_T=&$T;
		$this->_frm=&$frm;
		$this->_P=&$P;
		$this->_L=&$L;
		$this->_E=&$E;
		$this->_options=array_merge($this->_options,$options);
		$this->_T->loadModul('cal');

		$this->_avTabs=array();
	}
	function setOption($key,$val) {
		$this->_options[$key]=$val;
	}
	function getOption($key,$ov=array()) {
		if (isset($ov[$key])) {
			return $ov[$key];
		} else {
			return $this->_options[$key];
		}
	}

	function _handleRequest() {
		$this->_type=Framework::getParam('type','','G');
		if (!$this->_type || !isset($this->_avTabs[$this->_type])) {
			$this->_type=key($this->_avTabs);
		}
		switch($this->_type) {
			case 'events_csv':
			case 'events_ical':
				$this->_impFields=$this->_BasImp->getObjFields('0');
				if (Framework::getParam('imp_list_action_x','0','P') && Framework::getParam('imp_list_action_val','0','P')) {
					switch (Framework::getParam('imp_list_action_val','0','P')) {
						case 'import':
						case 'import_dub':
							$ov_dub=false;
							if (Framework::getParam('imp_list_action_val','0','P')=='import_dub') {
								$ov_dub=true;
							}
							$ListID=Framework::getParam('ListID',array(),'P');
							$result=array(
								'imp'=>0,
								'dub'=>0,
								'err'=>0,
							);
							foreach ($ListID as $id) {
								$Obj=$this->_BasImp->getObj($id);
								$error=unserialize($Obj->getMeta('_error'));
								if (is_array($error['values'])) {
									foreach($error['values'] as $k=>$v) {
										//Remove non Fatal errors;
										switch($k) {
											case 'Visibility':
											case 'Resources':
											case 'Attendees':
											case 'Project':
												unset($error['values'][$k]);
											break;
										}
									}
									if (empty($error['values'])) {
										unset($error['values']);
									}
								}
								if (empty($error)) {
									$evt=array();

									$evt=array(
										"Title"=>$Obj->getMeta('Subject'),
										"FKProjID"=>$Obj->getMeta('Project'),
										"EvtPrivat"=>$Obj->getMeta('Privat'),
										"Text"=>$Obj->getMeta('Body'),
										"Place"=>$Obj->getMeta('Place'),
										"OwnerID"=>$Obj->getMeta('Owner'),
										"StartDate"=>$Obj->getMeta('_startStamp'),
										"EndDate"=>$Obj->getMeta('_endStamp'),
										"FKCatID"=>$Obj->getMeta('Category'),
										"AlarmTime"=>$Obj->getMeta('ReminderDate')!='0000-00-00'?($Obj->getMeta('_startStamp')-GroupieDB::SqlToDate($Obj->getMeta('ReminderDate').' '.$Obj->getMeta('ReminderTime'))):0,
										'InvitResources'=>$Obj->getMeta('Resources'),

										'InvitGroups'=>'',
										'InvitUsers'=>'',
										'InvitAddr'=>'',

										'GrantGroups'=>'',
										'GrantUsers'=>'',

										'TimeMode'=>$Obj->getMeta('AllDayEvent')?1:0,
										'Unsecure'=>$Obj->getMeta('Tentative')?1:0,
										'Message'=>$Obj->getMeta('Notifications')?1:0,
										'NoInvit'=>$Obj->getMeta('NoInvitations')?1:0,
										"NoOwner"=>0,

										"RecType"=>0,
										"RecEnd"=>0,
										"RecInt"=>0,

										//"UID"=>$Obj->getMeta(''),
									);

									if ($Obj->getMeta('RecFreq')) {
										$evt['RecType']=$Obj->getMeta('RecFreq');
										$evt['RecEnd']=$Obj->getMeta('RecUntil')!='0000-00-00'?GroupieDB::SqlToDate($Obj->getMeta('RecUntil').' 23:59:59'):-1;
										$evt['RecInt']=$Obj->getMeta('RecInterval');
									}

									if ($Obj->getMeta('Attendees')) {
										$tmp=array(
											'u'=>array(),
											'g'=>array(),
											'a'=>array(),
										);

										foreach (explode(',',$Obj->getMeta('Attendees')) as $id) {
											$tmp[$id[0]][]=substr($id,2);
										}
										$evt['InvitGroups']=implode(',',$tmp['g']);
										$evt['InvitUsers']=implode(',',$tmp['u']);
										$evt['InvitAddr']=implode(',',$tmp['a']);
									}
									if ($Obj->getMeta('Visibility')) {
										$tmp=array(
											'u'=>array(),
											'g'=>array(),
										);

										foreach (explode(',',$Obj->getMeta('Visibility')) as $id) {
											$tmp[$id[0]][]=substr($id,2);
										}
										$evt['GrantGroups']=implode(',',$tmp['g']);
										$evt['GrantUsers']=implode(',',$tmp['u']);
									}

									if ($id=$this->_Base->eventExists($evt)) {
										$evt['EventID']=$id;
										if ($ov_dub && ($id=$this->_Base->updateEvent($id,$evt))) {
											$Obj->setMeta('_importId',$id);
											$this->_BasImp->updateMeta($Obj);
											$result['imp']++;
										} else {
											$result['dub']++;
										}
										
									} elseif ($id=$this->_Base->saveEvent($evt)) {
										$Obj->setMeta('_importId',$id);
										$this->_BasImp->updateMeta($Obj);
										$result['imp']++;
									}

									//saveEvent
								} else {
									$result['err']++;
								}
							}
							if ($result['imp']) {
								$this->_E->setError('ok');
								$this->_E->setErrorMsg('ok',$this->_T->langStr('[[{NUM} events imported]]',array('{NUM}'=>$result['imp'])));
								$this->_E->setTyp(1);
							}
							if ($result['dub']) {
								$this->_E->setError('dub');
								$this->_E->setErrorMsg('dub',$this->_T->langStr('[[{NUM} dublicate events]]',array('{NUM}'=>$result['dub']))); 
								$this->_E->setTyp(1);
							}
							if ($result['err']) {
								$this->_E->setError('err');
								$this->_E->setErrorMsg('err',$this->_T->langStr('[[{NUM} events with errors]]',array('{NUM}'=>$result['err'])));
								$this->_E->setTyp(0);
							}
						break;
						case 'delete':
							$ListID=Framework::getParam('ListID',array(),'P');
							foreach ($ListID as $id) {
								if ($Obj=$this->_BasImp->getObj($id)) {
									$this->_BasImp->deleteMeta($Obj);
								}
							}
						break;
					}
				}
			break;
			case 'resources':
				$this->_impFields=array();
				foreach ($this->_frm->getMaLang() as $lang) {
					$this->_impFields['Name'.strtoupper($lang)]=array(
						'Typ'=>'text',
						'Req'=>1,
					);
					$this->_impFields['Description'.strtoupper($lang)]=array(
						'Typ'=>'text',
					);
				}
				/*$this->_impFields['Color']=array(
					'Typ'=>'text',
				);*/
				$this->_impFields['Amount']=array(
					'Typ'=>'int',
				);
				$this->_impFields['CheckConflicts']=array(
					'Typ'=>'bool',
				);
				$this->_impFields['DenyConflicts']=array(
					'Typ'=>'bool',
				);
				$this->_impFields['Calendar']=array(
					'Typ'=>'bool',
				);
				$this->_impFields['TimeRecording']=array(
					'Typ'=>'bool',
				);
				$this->_impFields['Permissions']=array(
					'Typ'=>'perms',
				);
				
				/*
					'calResPermsUser'=>array(
						'Typ'=>'core',
					),
					'calResPermsGroup'=>array(
						'Typ'=>'core',
					),
				*/
				if (Framework::getParam('imp_list_action_x','0','P') && Framework::getParam('imp_list_action_val','0','P')) {
					$impEntries=unserialize($this->_frm->getUserData('cal','imp_resources'));
					switch (Framework::getParam('imp_list_action_val','0','P')) {
						case 'import':
							$ListID=Framework::getParam('ListID',array(),'P');
							$result=array(
								'imp'=>0,
								'dub'=>0,
								'err'=>0,
							);
							foreach ($ListID as $id) {
								$row=$impEntries[$id-1];
								$error=$row['_error'];
								if (empty($error)) {
									$Obj=new ObjCalResource();

									$ObjTrans=array();
									foreach ($this->_frm->getMaLang() as $val) {
										$ObjTrans['calResName'][$val]=$row['Name'.strtoupper($val)];
										$ObjTrans['calResText'][$val]=$row['Description'.strtoupper($val)];
									}

									$Obj->setMeta('calResAmount',$row['Amount']>1?$row['Amount']:1);
									$Obj->setMeta('calResCheck',$row['CheckConflicts'] | $row['DenyConflicts']);
									$Obj->setMeta('calResNoConflict',$row['DenyConflicts']);
									$Obj->setMeta('calResUseCal',$row['Calendar']);
									$Obj->setMeta('calResUseZef',$row['TimeRecording']);
									$Obj->setTrans('calResName',$ObjTrans['calResName']);
									$Obj->setTrans('calResText',$ObjTrans['calResText']);

									$permsU=array();$permsG=array();
									if ($row['Permissions']) {
										//debug($row['Permissions']);
										foreach (explode(',',$row['Permissions']) as $perms) {
											switch($perms[0]) {
												case 'u';
													$permsU[substr($perms,2)]=2;
												break;
												case 'g';
													$permsG[substr($perms,2)]=2;
												break;
											}
										}
										$Obj->setMeta('calResPermsUser',Framework::arrayToAcl($permsU));
										$Obj->setMeta('calResPermsGroup',Framework::arrayToAcl($permsG));
									}
														
									if ($resId=$this->_BaseRes->insertObj($Obj)) {
										unset($impEntries[$id-1]);
										$result['imp']++;
									}
									//saveEvent
								} else {
									$result['err']++;
								}
							}
							if ($result['imp']) {
								$this->_E->setError('ok');
								$this->_E->setErrorMsg('ok',$result['imp'].' resources imported');
								$this->_E->setTyp(1);
							}
							if ($result['dub']) {
								$this->_E->setError('dub');
								$this->_E->setErrorMsg('dub',$result['dub'].' dublicate resources');
								$this->_E->setTyp(1);
							}
							if ($result['err']) {
								$this->_E->setError('err');
								$this->_E->setErrorMsg('err',$result['err'].' resources with errors');
								$this->_E->setTyp(0);
							}
							$this->_frm->setUserData('cal','imp_resources',serialize($impEntries));
						break;
						case 'delete':
							$ListID=Framework::getParam('ListID',array(),'P');
							foreach ($ListID as $id) {
								unset($impEntries[$id-1]);
							}
							$this->_frm->setUserData('cal','imp_resources',serialize($impEntries));
						break;
					}
				}
			break;
		}
		return true;
	}
	function &process() {
		if ($this->getOption('impIcal')) {
			$this->_avTabs['events_ical']=$this->_T->lang('[[Termine]]').' - ICAL';
		}
		if ($this->getOption('impCsv')) {
			$this->_avTabs['events_csv']=$this->_T->lang('[[Termine]]').' - CSV';
		}
		if ($this->getOption('impRes')) {
			$this->_avTabs['resources']=$this->_T->lang('[[Resourcen]]');
		}
		if ($this->_handleRequest()) {
			//require_once('lib/class_TemplateGui.php');
			//$TopGui=new TemplateGui('core/common_form.inc.html');

			require_once('lib/class_ApplicationTreeGui.php');
			$TreeGui=new ApplicationTreeGui();

			$mGui=& $this->getTypeGui();
			$TreeGui->addTreeContent($mGui);
			

			$cGui=& $this->getConfigGui();
			$TreeGui->addTreeContent($cGui);
			
			$rGui=& $this->getResultGui();
			$TreeGui->addContent($rGui,null,null);

			//$TopGui->addContent('cont1',$TreeGui,'CONTENT');
			//$TopGui->addContent('faction',$this->_L->getLink(),'FORM_ACTION');
			return $TreeGui;
		}
	}

	function &getTypeGui() {
		require_once('lib/class_ApplicationListGui.php');
		$tabGui=new ApplicationListGui();
		foreach ($this->_avTabs as $key=>$val) {
			if ($key==$this->_type) {
				$hl=2;
			} else {
				$hl=0;
			}
			$tabGui->addRow($hl);
			$tabGui->addCol('IMG','','obj_img/ex_tree.gif');
			$tabGui->addCol('Name',$val,'',$this->_L->getTempLink(array(),array('type'=>$key)),'',0,'2000');
		}
		return $tabGui;
	}
	
	function &getConfigGui() {
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_DateSelectForm.php');
		require_once('lib/class_BoxGui.php');

		
		$boxGui=new BoxGui('cal|showtab_imp');
		$boxGui->setBorderColor(APP_FGCOLOR);
		$boxGui->addTab('file',$this->_T->lang('[[Import]]'),'#',true);
		

		$Gui=new TemplateGui('core/common_content_border.inc.html');

		$formGui=new FormGui();
		$formGui->setFieldClass('ipts','ipts');

		$key="impFile";
		$formGui->addField($key,'file',$this->_T->lang('[[Datei auswaehlen]]'),'','f_file');
		$formGui->setAttribs($key,array('size'=>13));
		

		if ($this->_type=='events_csv') {
			$key="impCsvDelim";
			$formGui->addField($key,'select',$this->_T->lang('[[Trennzeichen]]'),'','f_file');
			$formGui->setValues($key,array(';'=>';',','=>',','tab'=>'TAB'));

			$key="impDateFormat";
			$formGui->addField($key,'select',$this->_T->lang('[[Datumsformat]]'),'','f_file');
			$formGui->setValues($key,array('d/m/y'=>'d/m/y','m/d/y'=>'m/d/y','y/m/d'=>'y/m/d'));

		}

		if ($this->_type=='events_csv' || $this->_type=='events_ical') {
			$showPref=false;
			if ($this->getOption('showOwner')) {
				$key="impOwner";
				$params=base64_encode(serialize(array('MaxEntries'=>0,'useAll'=>1)));

				$lb_params=array('Values'=>array());
				$lb_params['Values'][]=array(
					'Label'=>$this->_T->lang('[[Nur Termine von]]'),
					'LabelSep'=>'',
					'mode'=>'u',
					'app'=>'cal',
					'params'=>$params,
					'FieldVal'=>'_USERS',
				);

				$lb_User=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
				$def=$this->getOption('defOwner')?'u_'.$this->getOption('defOwner'):'';

				$formGui->addField($key,'ttip',$lb_User,$def,'f_file');
				$formGui->setParams($key,array('mode'=>'u','no_width'=>1,'app'=>'cal','params'=>$params));


				$key="defOwner";
				$params=base64_encode(serialize(array('MaxEntries'=>1)));
				$lb_params=array('Values'=>array());
				$lb_params['Values'][]=array(
					'Label'=>$this->_T->lang('[[BesitzerIn]]'),
					'LabelSep'=>'',
					'mode'=>'u',
					'app'=>'cal',
					'params'=>$params,
					'FieldVal'=>'_USERS',
				);

				$lb_User=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
				$def=$this->getOption('defOwner')?'u_'.$this->getOption('defOwner'):'';
				$formGui->addField($key,'ttip',$lb_User,$def,'f_prefs');
				$formGui->setParams($key,array('mode'=>'u','no_width'=>1,'app'=>'cal','params'=>$params));
				$showPref=true;
			} elseif ($this->getOption('defOwner')) {
				$key="impOwner";
				$formGui->addField($key,'hidden','','u_'.$this->getOption('defOwner'),'f_file');
				$key="defOwner";
				$formGui->addField($key,'hidden','','u_'.$this->getOption('defOwner'),'f_file');
			}
			if ($this->getOption('showCategory')) {
				$key="defCategory";
				$formGui->addField($key,'select',$this->_T->lang('[[Art des Termins]]'),$this->getOption('defCategory'),'f_prefs');
				$formGui->setValues($key,array(0=>'-') + $this->_frm->extractObjName($this->_BaseCat->listObj()));
				$showPref=true;
			} elseif ($this->getOption('defCategory')) {
				$key="defCategory";
				$formGui->addField($key,'hidden','',$this->getOption('defCategory'),'f_file');
			}
			

			if ($showPref) {
				$boxGui->addTab('prefs',$this->_T->lang('[[Vorgabewerte]]'),'#',true);
				$boxGui->setTabContent('prefs',$formGui,array('','f_prefs'));
			}
		}
		if ($this->_type=='resources') {
			$key="impCsvDelim";
			$formGui->addField($key,'select',$this->_T->lang('[[Trennzeichen]]'),'','f_file');
			$formGui->setValues($key,array(';'=>';',','=>',','tab'=>'TAB'));
			
			$key='defPermissions';
			$mode='u|g';
			$params='';
			$lb_params=array('Values'=>array());
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[Rechte]]').' '.$this->_T->lang('[[BenutzerInnen]]'),
				'LabelSep'=>'',
				'mode'=>$mode,
				'app'=>'cal',
				'params'=>$params,
				'FieldVal'=>'_USERS',
			);
			$lb_params['Values'][]=array(
				'Label'=>$this->_T->lang('[[Gruppen]]'),
				'LabelSep'=>' / ',
				'mode'=>$mode,
				'app'=>'cal',
				'params'=>$params,
				'FieldVal'=>'_GROUPS',
			);

			$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);
			$formGui->addField($key,'ttip',$lb_Invit,'','f_file');
			$formGui->setParams($key,array('mode'=>$mode,'params'=>$params,'no_width'=>1));
		}

		$submit_array=array(
			'load_x'=>' '.$this->_T->lang('[[Hochladen]]').' ',
		);
		$key='submit';
		$formGui->addField($key,'submit','','','f_file');
		$formGui->setValues($key,$submit_array);

		if (Framework::getParam('load_x',0,'P')) {
			$impData=array();
			$formGui->addMetaToArray($impData);

			if (!$this->saveImportData($impData)) {

				
			}
		}

		$boxGui->setTabContent('file',$formGui,array('','f_file'));
		$boxGui->setTabOn('file');

		//$Gui->addContent('config',$formGui,'CONTENT');
		return $boxGui;
	}
	function saveImportData($impData) {
		//debug($impData);
		if (!isset($impData['impFile']) || !isset($impData['impFile']['tmp_name']) || !file_exists($impData['impFile']['tmp_name'])) {
			$this->_E->setError('fields','impFile');
			return false;
		}

		switch($this->_type) {
			case 'events_ical':
				$this->_BasImp->deleteAll($this->_frm->getUser());

				$onlyOwner=array();
				if (trim($impData['impOwner'])) {
					foreach (explode('|',$impData['impOwner']) as $val) {
						if ($val[0]=='u') {
							$onlyOwner[]=substr($val,2);
						}
					}
				}

				require_once ("lib/cal/ClassVcalParse.php");
				require_once ("lib/cal/ClassVcal.php");
				$cardPrefs=array(
					'ical'=>true,
					'allDayMode'=>1,
					'attendee'=>1,
					'grant_u'=>'',
					'grant_g'=>'',
				);
				$Vcal=new Vcal();
				$Vcal->setUser($this->_Base->getUser());
				$Vcal->setLang($this->_frm->getLang());
				$Vcal->setPrefs('cal',$cardPrefs);

				$VcalParse= new VcalParse();
				$VcalParse->setPrefs('cal',$cardPrefs);
				$card=$VcalParse->fromFile($impData['impFile']['tmp_name']);
				foreach ($card as $cardEvt) {
					$evt=$Vcal->vcal2event($cardEvt,true);
					$error=array();
					$entry=array(
						'FKUserID'=>$this->_frm->getUser(),
						'StartDate'=>date('Y-m-d',$evt['StartDate']),
						'StartTime'=>date('H:i:s',$evt['StartDate']),
						'_startStamp'=>$evt['StartDate'],
						'EndDate'=>date('Y-m-d',$evt['EndDate']),
						'EndTime'=>date('H:i:s',$evt['EndDate']),
						'_endStamp'=>$evt['EndDate'],
						'Subject'=>$evt['Title'],
						'Body'=>$evt['Text'],
						'Place'=>isset($evt['Place'])?$evt['Place']:'',
						'NoInvitations'=>0,
						'AllDayEvent'=>$evt['TimeMode']?1:0,
						'Owner'=>0,
						'Project'=>$evt['FKProjID'],
						'Category'=>0,
						'Privat'=>0,
						'Tentative'=>0,
						'Notifications'=>0,
						'ReminderDate'=>isset($evt['AlarmTime']) && $evt['AlarmTime']?date('Y-m-d',$evt['StartDate']-$evt['AlarmTime']):'0000-00-00',
						'ReminderTime'=>isset($evt['AlarmTime']) && $evt['AlarmTime']?date('H:i:s',$evt['StartDate']-$evt['AlarmTime']):'00:00:00',
						'Visibility'=>'',
							
					);
					if (isset($evt['cardOrganizer'])) {
						if (strpos($evt['cardOrganizer']['mail'],'@')) {
							$entry['Owner']=$this->val2User($evt['cardOrganizer']['mail']);
							if (!$entry['Owner']) {
								$error['values']['Owner']=array($evt['cardOrganizer']['mail']);
							}
						} elseif ($evt['cardOrganizer']['name'] && $evt['cardOrganizer']['name']!='Unknown') {
							$entry['Owner']=$this->val2User($evt['cardOrganizer']['name']);
							if (!$entry['Owner']) {
								$error['values']['Owner']=array($evt['cardOrganizer']['name']);
							}
						} elseif (trim($impData['defOwner'])) {
							$entry['Owner']=substr($impData['defOwner'],2);
						}
					} elseif (trim($impData['defOwner'])) {
						$entry['Owner']=substr($impData['defOwner'],2);
					}
					if ($entry['Owner']) {
						if (!$entry['Category']) {
							if ($impData['defCategory']) {
								$entry['Category']=$impData['defCategory'];
							} else {
								$entry['Category']=$this->_frm->getPrefs('cal','cat_id',$entry['Owner']);
							}
						}
						if (!$entry['Visibility']) {
							$tmp=array();
							$defInvitUsers=array();
							$defInvitGroups=array();
							if ($entry['Project'] && $this->_P) {
								$grantPerms=$this->_P->getProjectPerms($entry['Project'],'cal_grant');
								if (trim($grantPerms['PermsUser'])) $defInvitUsers=explode(',',$grantPerms['PermsUser']);
								if (trim($grantPerms['PermsGroup'])) $defInvitGroups=explode(',',$grantPerms['PermsGroup']);
							} else {
								if ($this->_frm->getPrefs('cal','du',$entry['Owner'])) $defInvitUsers=explode('|',$this->_frm->getPrefs('cal','du'));
								if ($this->_frm->getPrefs('cal','dg',$entry['Owner'])) $defInvitGroups=explode('|',$this->_frm->getPrefs('cal','dg'));
							}
							foreach($defInvitUsers as $v) {
								$tmp[]='u_'.$v;
							}
							foreach($defInvitGroups as $v) {
								$tmp[]='g_'.$v;
							}
							$entry['Visibility']=implode(',',$tmp);
						}
					} else {
						$error['fields'][]='Owner';
					}
					if (isset($evt['cardInvitUsers'])) {
						$tmpA=array();
						$tmpR=array();
						foreach($evt['cardInvitUsers'] as $v) {
							if (strpos($v['mail'],'@') && ($tmpUid=$this->val2User($v['mail']))) {
								$tmpA[]='u_'.$tmpUid;
							} elseif ($v['name'] && ($tmpUid=$this->val2User($v['name']))) {
								$tmpA[]='u_'.$tmpUid;
							} elseif (strpos($v['mail'],'@') && ($tmpUid=$this->val2Addr($v['mail']))) {
								$tmpA[]='a_'.$tmpUid;
							} elseif ($v['name'] && ($tmpUid=$this->val2Resource($v['name']))) {
								$tmpR[]='r_'.$tmpUid;
							} else {
								$error['values']['Attendees'][]=$v['name'];
							}
							//debug($v);
						}
						$entry['Attendees']=implode(',',$tmpA);
						$entry['Resources']=implode(',',$tmpR);
						
					}
					if ($evt['RecType']) {
						$entry['RecFreq']=$evt['RecType'];
						$entry['RecInterval']=$evt['RecInt'];
						$entry['RecUntil']=$evt['RecEnd']>0?date('Y-m-d'):'0000-00-00';
					}
					if (!empty($onlyOwner) && !in_array($entry['Owner'],$onlyOwner)) {
						continue;
					}
					$entry['_error']=serialize($error);
					$obj=new ObjCalImport(0,$entry);
					$this->_BasImp->insertMeta($obj);
				}


				//debug($card);

				
				
			break;
			case 'events_csv':
				$data=Framework::importCsv($impData['impFile']['tmp_name'],$impData['impCsvDelim'],true);
				foreach ($this->_impFields as $fid=>$fval) {
					if ($fval['Req']==1 && !isset($data[0][$fid])) {
						$this->_E->setError('col_'.$fid);
						$this->_E->setErrorMsg('col_'.$fid,'Missing Column: "'.$fid.'"');
					}
				}
				if ($this->_E->isError()) {
					return false;
				}
				$this->_BasImp->deleteAll($this->_frm->getUser());
				if (isset($impData['defOwner']) && $impData['defOwner']) {
					$impData['defOwner']=substr($impData['defOwner'],2);
				}
				$onlyOwner=array();
				if (trim($impData['impOwner'])) {
					foreach (explode('|',$impData['impOwner']) as $val) {
						if ($val[0]=='u') {
							$onlyOwner[]=substr($val,2);
						}
					}
				}
			
				foreach ($data as $row) {
					$error=array();
					if (!$row['EndDate']) $row['EndDate']=$row['StartDate'];

					$entry=$this->csv2entry($row,$error,$impData);
					//debug($entry);
					$entry['FKUserID']=$this->_frm->getUser();
					
					if ($entry['RecFreq']) {
						if ($entry['RecInterval']<1) $entry['RecInterval']=1;
					} else {
						$entry['RecInterval']=0;
					}
					if ($entry['AllDayEvent']) {
						$entry['StartTime']='00:00:00';
						$entry['EndTime']='23:59:59';
					}
					$entry['_startStamp']=GroupieDB::SqlToDate($entry['StartDate'].' '.$entry['StartTime']);
					$entry['_endStamp']=GroupieDB::SqlToDate($entry['EndDate'].' '.$entry['EndTime']);
					if ($entry['_startStamp']>$entry['_endStamp']) {
						$error['fields'][]='EndTime';
					}
					if (!empty($onlyOwner) && !in_array($entry['Owner'],$onlyOwner)) {
						continue;
					}

					$entry['_error']=serialize($error);
					$obj=new ObjCalImport(0,$entry);
					$this->_BasImp->insertMeta($obj);
				}
			break;
			case 'resources':
				$data=Framework::importCsv($impData['impFile']['tmp_name'],$impData['impCsvDelim'],true);
				foreach ($this->_impFields as $fid=>$fval) {
					if ($fval['Req']==1 && !isset($data[0][$fid])) {
						$this->_E->setError('col_'.$fid);
						$this->_E->setErrorMsg('col_'.$fid,'Missing Column: "'.$fid.'"');
					}
				}
				if ($this->_E->isError()) {
					return false;
				}
				$impEntries=array();
				foreach ($data as $row) {
					$entry=array(
						'FKUserID'=>$this->_frm->getUser(),
					);
					$error=array();
					$entry=$this->csv2entry($row,$error,$impData);
					$entry['_error']=$error;
					$impEntries[]=$entry;
				}
				$this->_frm->setUserData('cal','imp_resources',serialize($impEntries));
			break;
		}
		//getTempPath();
	}

	function csv2entry(&$row,&$error,$config=array()) {
		foreach ($this->_impFields  as $k=>$fval) {
			$v=isset($row[$k])?$row[$k]:'';
			$errorReq='';
			$errorValues=array();
			switch($fval['Typ']) {
				case 'text':
					$entry[$k]=$v;
				break;
				case 'int':
					$entry[$k]=(int)$v;
				break;
				case 'date':
					$entry[$k]=$this->val2SqlDate($v,$config['impDateFormat']);
					if ($fval['Req'] && ($entry[$k]=='' || $entry[$k]=='0000-00-00')) $errorReq=1;
				break;
				case 'time':
					$entry[$k]=$this->val2Time($v);
				break;
				case 'user':
					$entry[$k]=$this->val2User($v);
					if (!$entry[$k]) {
						if ($v) {
							$errorValues[]=$v;
						} elseif (isset($config['def'.$k]) && $config['def'.$k]) {
							$entry[$k]=$config['def'.$k];
						}
					}
					if ($fval['Req'] && !$entry[$k]) $errorReq=1;
				break;
				case 'perms':
				case 'invit':
					$tmp=array();
					if (trim($v)) {
						foreach (explode(',',$v) as $test) {
							//Falls Gruppe
							if (preg_match('/^([@]|group:)/i',$test)) {
								$n=$this->val2Group(preg_replace('/^([@]|group:)/i','',$test));
								if ($n) {
									$tmp[]='g_'.$n;
								} else {
									$errorValues[]=$test;
								}
							} else {
								//Benutzer ??
								$n=$this->val2User($test);
								if ($n) {
									$tmp[]='u_'.$n;
								} else {
									$errorValues[]=$test;
								}
							}
						}
					} elseif ($config['defPermissions']) {
						foreach (explode('|',$config['defPermissions']) as $test) {
							if ($test[0]=='g' ||$test[0]=='u') {
								$tmp[]=$test;
							}
						}
					}
					if ($fval['Req'] && empty($tmp)) $errorReq=1;
					$entry[$k]=implode(',',$tmp);
				break;
				case 'grant':
					$tmp=array();
					if (trim($v)) {
						foreach (explode(',',$v) as $test) {
							//Falls Gruppe
							if (preg_match('/^([@]|group:)/i',$test)) {
								$n=$this->val2Group(preg_replace('/^([@]|group:)/i','',$test));
								if ($n) {
									$tmp[]='g_'.$n;
								} else {
									$errorValues[]=$test;
								}
							} else {
								//Benutzer ??
								$n=$this->val2User($test);
								if ($n) {
									$tmp[]='u_'.$n;
								} else {
									$errorValues[]=$test;
								}
							}
						}
					} elseif ($entry['Owner']) {
						$defInvitUsers=array();
						$defInvitUsers=array();
						if ($entry['Project'] && $this->_P) {
							$grantPerms=$this->_P->getProjectPerms($entry['Project'],'cal_grant');
							if (trim($grantPerms['PermsUser'])) $defInvitUsers=explode(',',$grantPerms['PermsUser']);
							if (trim($grantPerms['PermsGroup'])) $defInvitGroups=explode(',',$grantPerms['PermsGroup']);
						} else {
							if ($this->_frm->getPrefs('cal','du',$entry['Owner'])) $defInvitUsers=explode('|',$this->_frm->getPrefs('cal','du'));
							if ($this->_frm->getPrefs('cal','dg',$entry['Owner'])) $defInvitGroups=explode('|',$this->_frm->getPrefs('cal','dg'));
						}
						foreach($defInvitUsers as $v) {
							$tmp[]='u_'.$v;
						}
						foreach($defInvitGroups as $v) {
							$tmp[]='g_'.$v;
						}
					}
					if ($fval['Req'] && empty($tmp)) $errorReq=1;
					$entry[$k]=implode(',',$tmp);
				break;
				case 'res':
					$tmp=array();
					if (trim($v)) {
						foreach (explode(',',$v) as $test) {
							if ($n=$this->val2Resource($test)) {
								$tmp[]=$n;
							} else {
								$errorValues[]=$test;
							}
						}
					}
					if ($fval['Req'] && empty($tmp)) $errorReq=1;
					$entry[$k]=implode(',',$tmp);
				break;
				case 'cat':
					if ($tmp=$this->val2Project($v)) {
						//debug($row);
						if (!isset($row['Project']) || !$row['Project']) {
							$row['Project']=$v;
							$v='';
						}
					} else {
						$entry[$k]=$this->val2Category($v);
					}
					if (!$entry[$k]) {
						if ($v) {
							$errorValues[]=$v;
						} elseif (isset($config['def'.$k]) && $config['def'.$k]) {
							$entry[$k]=$config['def'.$k];
						} elseif ($entry['Owner']) {
							$entry[$k]=$this->_frm->getPrefs('cal','cat_id',$entry['Owner']);
						}
					}
					if ($fval['Req'] && !$entry[$k]) $errorReq=1;
				break;
				case 'prj':
					$entry[$k]=$this->val2Project($v);
					if ($v && !$entry[$k]) {
						$errorValues[]=$v;
					}
					if ($fval['Req'] && !$v) $errorReq=1;
				break;
				case 'bool':
					$entry[$k]=(int)$v?1:0;
				break;
				case 'recf':
					$entry[$k]=$this->val2RecType($v);
					if ($v && !$entry[$k]) {
						$errorValues[]=$v;
					}
					if ($fval['Req'] && !$v) $errorReq=1;
				break;
				case 'reci':
					$entry[$k]=(int)$v;
				break;
			}
			if ($errorReq) {
				$error['fields'][]=$k;
			}
			if ($errorValues) {
				$error['values'][$k]=$errorValues;
			}
		}
		return $entry;
	}
	function val2RecType($val) {
		$res=0;
		switch(strtolower($val)) {
			case 'd':
				$res=1;
			break;
			case 'w':
				$res=2;
			break;
			case 'm':
				$res=3;
			break;
			case 'y':
				$res=5;
			break;
		}
		return $res;
	}
	function val2Resource($val) {
		$res=0;
		if (!trim($val)) return $res;
		if (preg_match('/^[0-9]+$/',$val)) {
			if ($this->_BaseRes->getCachedObj((int)$val)) {
				$res=(int)$val;
			}
		} else {
			if ($temp=$this->_BaseRes->resName2ID($val)) {
				$res=$temp->getID();
			}
		}
		return $res;
	}
	function val2Category($val) {
		$res=0;
		if (!trim($val)) return $res;
		if (preg_match('/^[0-9]+$/',$val)) {
			if ($this->_BaseCat->getCachedObj((int)$val)) {
				$res=(int)$val;
			}
		} else {
			if ($temp=$this->_BaseCat->catName2ID($val)) {
				$res=$temp->getID();
			}
		}
		return $res;
	}
	function val2Project($val) {
		$res=0;
		if (!trim($val)) return $res;
		if (preg_match('/^[0-9]+$/',$val)) {
			if ($this->_P->getCachedObj((int)$val)) {
				$res=(int)$val;
			}
		} else {
			if ($temp=$this->_P->getPrjByName($val)) {
				$res=$temp->getID();
			}
		}
		return $res;
	}
	function val2Group($val) {
		//debug('G:'.$val);
		$res=0;
		if (!trim($val)) return $res;
		if (preg_match('/^[0-9]+$/',$val)) {
			if ($this->_frm->getCachedGroupName((int)$val)) {
				$res=$val;
			}
		} else {
			$temp=$this->_frm->getAllGroups(0,-1,$val,0,true,true);
			if (!empty($temp)) {
				$res=key($temp);
			}
		}
		//debug($res);
		return $res;
	}
	function val2User($val) {
		//debug($val);
		$res=0;
		if (!trim($val)) return $res;
		if (strpos($val,'@')!==false) {
			//debug($val);
			$temp=$this->_frm->searchUserByEmail($val);
			if (!empty($temp)) {
				$res=reset($temp);
			}
		} elseif (preg_match('/^[0-9]+$/',$val)) {
			if ($this->_frm->getCachedUserName($val)) {
				$res=$val;
			}
		} else {
			$temp=$this->_frm->nameToUser($val);
			if (!empty($temp) && count($temp)==1) {
				$res=$temp[0];
			}
		}
		//debug($res);
		return $res;
	}

	function val2Addr($val) {
		$res=0;
		if (!trim($val)) return $res;
		if (!defined('ADDR_MODE') || ADDR_MODE!='ldap') {
			$Addr=& $this->_frm->getStaticModul('addr');
			if (strpos($val,'@')!==false) {
				$searchAddr=array(
					array('Typ'=>'SQL','Values'=>"Email REGEXP '[[:<:]]".addslashes(preg_quote($val,''))."[[:>:]]'"),
					array('Field'=>'UserID','Typ'=>'=','Values'=>0),
				);
					
				$aObj=$Addr->searchSingleAddr($searchAddr);
				if ($aObj) {
					$res=$aObj->getID();
				}
			}
		}
		return $res;
	}
	function val2Time($val) {
		if (preg_match('/[0-9]+[^0-9]+[0-9]+/',$val)) {
			$tmp=preg_split('/[^0-9]+/',$val);
			if (count($tmp)==3) {
				return sprintf('%02d:%02d:%02d',(int)$tmp[0],(int)$tmp[1],(int)$tmp[2]);
			} elseif (count($tmp)==2) {
				return sprintf('%02d:%02d:00',(int)$tmp[0],(int)$tmp[1]);
			}
		}
		return '00:00:00';
	}
	function val2SqlDate($val,$format) {
		switch ($format) {
			case 'd/m/y':
				$tmp=preg_split('/[^0-9]+/',$val);
				$d=(int)$tmp[0];
				$m=(int)$tmp[1];
				$y=(int)$tmp[2];
			break;
			case 'm/d/y':
				$tmp=preg_split('/[^0-9]+/',$val);
				$d=(int)$tmp[1];
				$m=(int)$tmp[0];
				$y=(int)$tmp[2];
			break;
			case 'y/m/d':
				$tmp=preg_split('/[^0-9]+/',$val);
				$d=(int)$tmp[2];
				$m=(int)$tmp[1];
				$y=(int)$tmp[0];
			break;
		}
		if ($y<1970) $y+=2000;
		
		if ($y>2050 || !checkdate($m,$d,$y)) {
			return '0000-00-00';
		} else {
			return sprintf('%04d-%02d-%02d',$y,$m,$d);
		}
	}
	function getResultGui() {
		require_once('lib/class_ApplicationListGui.php');
		require_once('lib/class_FunctionButtons.php');
		require_once('lib/class_FormFieldsCore.php');
		require_once('lib/class_FunctionObjActionGui.php');

		$noEnc=array('NoEnc'=>1,'NoBr'=>1);
		$btnList=new CheckBoxBtn ('ListID[]','');
		$funcSelAll=new FunctionButtons('cal_list','selectall',array('ListID'=>'ListID[]','ListOn'=>false));
		$Gui=new ApplicationListGui();
		$Gui->setRowClass(array('list_l','list_h','list_b','list_hb','list_s','list'));

		$funcAction=new FunctionObjActionGui('imp_list_action',1);
		$funcAction->setName($this->_T->lang('[[Ausgewaehlte Eintraege]]'));
		$funcAction->addValue('import',$this->_T->lang('[[Importieren]]'));
		$funcAction->addValue('import_dub',$this->_T->lang('[[Importieren und ersetzen]]'));
		$funcAction->addValue('nothing','--------');
		$funcAction->addValue('delete',$this->_T->lang('[[Loeschen]]'));
		$Gui->addFunction($funcAction);

		
		$Gui->addHeaderCol('ListID',$funcSelAll->process(),'','','',1,'1%',0,'',$noEnc);


		foreach ($this->_impFields  as $k=>$fval) {
			if ($fval['Typ']=='core') continue;
			$Gui->addHeaderCol($k,$k,'','','',1,'',1);
		}
		
		switch($this->_type) {
			case 'events_ical':
			case 'events_csv':
				$entries=$this->_BasImp->listObj($this->_frm->getUser());
			break;
			case 'resources':
				$entries=unserialize($this->_frm->getUserData('cal','imp_resources'));
			break;
		}
		$hl=0;
		if (is_array($entries)) {
			foreach ($entries as $r_num=>$row) {
				$id=0;
				$Gui->addRow($hl=$hl?0:1,'top');
				foreach ($this->_impFields as $k=>$fval) {
					if ($fval['Typ']=='core') continue;
					switch($this->_type) {
						case 'events_ical':
						case 'events_csv':
							$meta=$row->getMeta($k);
							$error=unserialize($row->getMeta('_error'));
							$id=$row->getID();
						break;
						case 'resources':
							$meta=$row[$k];
							$error=$row['_error'];
							$id=$r_num+1;
						break;
					}
					$Gui->addCol('ListID',$btnList->process($id),'','','',1,'',0,'',$noEnc);
					$extra=array();
					$v='';
					switch($fval['Typ']) {
						case 'text':
						case 'bool':
						case 'int':
							$v=$meta;
						break;
						case 'time':
							if ($k!='ReminderTime' || $meta!='00:00:00') {
								$v=$meta;
							}
						break;
						case 'date':
							if ($meta!='0000-00-00') {
								$v=Framework::dateSql('d.m.Y',$meta);
							}
						break;
						case 'user':
							$v=$meta?'<img src="img/ge/user.gif"> '.$this->_frm->getCachedUserName($meta):'';
							$extra=$noEnc;
						break;
						case 'invit':
						case 'perms':
							$tmp=array();
							if ($meta) {
								foreach (explode(',',$meta) as $id) {
									switch($id[0]) {
										case 'u';
											$tmp[]='<img src="img/ge/user.gif"> '.$this->_frm->getCachedUserName(substr($id,2));
										break;
										case 'g';
											$tmp[]='<img src="img/ge/gruppe.gif"> '.$this->_frm->getCachedGroupName(substr($id,2));
										break;
										case 'a';
											$Addr=& $this->_frm->getStaticModul('addr');
											if (($tmpObj=$Addr->getAddrObj(substr($id,2)))) {
												$tmp[]='<img src="img/ge/l_addr.gif"> '.$tmpObj->getName();
											}
										break;
									}
								}
							}
							$v=implode("<br />",$tmp);
							$extra=$noEnc;
						break;
						case 'grant':
							$tmp=array();
							if ($meta) {
								foreach (explode(',',$meta) as $id) {
									switch($id[0]) {
										case 'u';
											$tmp[]='<img src="img/ge/user.gif"> '.$this->_frm->getCachedUserName(substr($id,2));
										break;
										case 'g';
											$tmp[]='<img src="img/ge/gruppe.gif"> '.$this->_frm->getCachedGroupName(substr($id,2));
										break;
									}
								}
							}
							$v=implode("<br />",$tmp);
							$extra=$noEnc;
							if ($fval['Req'] && empty($tmp)) $errorReq=1;
						break;
						case 'res':
							$tmp=array();
							if ($meta) {
								foreach (explode(',',$meta) as $id) {
									if ($tmpObj=$this->_BaseRes->getCachedObj($id)) {
										$tmp[]='<img src="img/ge/rolle.gif"> '.$tmpObj->getName();
									}
								}
							}
							$v=implode("<br />",$tmp);
							$extra=$noEnc;
						break;
						case 'cat':
							if ($meta && ($tmpObj=$this->_BaseCat->getCachedObj($meta))) {
								$v=$tmpObj->getName();
							}
						break;
						case 'prj':
							if ($meta && ($tmpObj=$this->_P->getCachedObj($meta))) {
								$v=$tmpObj->getName();
							}
						break;
						case 'recf':
							switch ($meta) {
								case 1:
									$v='dayly';
								break;
								case 2:
									$v='weekly';
								break;
								case 3:
									$v='monthly';
								break;
								case 5:
									$v='yearly';
								break;
							}
						break;
						case 'reci':
							$v=$meta;
						break;
					}
					if (is_array($error['values']) && isset($error['values'][$k])) {
						if ($extra['NoEnc']) {
							if ($v) $v.="<br />";
							$v.=implode("<br />",$error['values'][$k]);
						} else {
							if ($v) $v.="\n";
							$v.=implode("\n",$error['values'][$k]);
						}
						$extra['Attribs']['style']='background-color:#feff91;';
					} elseif (is_array($error['fields']) && in_array($k,$error['fields'])) {
						$extra['Attribs']['style']='background-color:#ff6666;';
					}
					$Gui->addCol($k,$v,'','','',1,0,0,'',$extra);
				}
			}
		}

		return $Gui;
	}

}
?>