<?php
class CalLayerGui {
	var $_BaseRes;
	var $_T;
	var $_frm;
	var $_P;
	var $_Y;
	var $_options=array(
		'prepend'=>'evt_',
		'linkAsSting'=>false,
		'showTitle'=>false,
		'showOwner'=>false,
		'showProject'=>true,
		'showText'=>true,
		'showPlace'=>true,
		'showInvitations'=>true,
		'showResources'=>true,
	);
	function CalLayerGui($options=array()) {
		global $frm,$t,$T,$E,$L,$P,$Y;
		$this->_BaseRes=& $frm->getStaticModul('cal_res');
		$this->_T=&$T;
		$this->_frm=&$frm;
		$this->_P=&$P;
		$this->_Y=&$Y;
		$this->_options=array_merge($this->_options,$options);
	}
	function setOption($key,$val) {
		$this->_options[$key]=$val;
	}
	function getOption($key,$ov=array()) {
		if (isset($ov[$key])) {
			return $ov[$key];
		} else {
			return $this->_options[$key];
		}
	}
	function addEventLayer($evtVal,$options=array()) {
		$lay_array=array();
		$lay_title=CalEvent::formatDate($evtVal['OrigStart']?$evtVal['OrigStart']:$evtVal["StartDate"],$evtVal['OrigEnd']?$evtVal['OrigEnd']:$evtVal["EndDate"],$evtVal['TimeMode'],'%d.%m.%Y',1);
		if ($this->getOption('showProject',$options) && $evtVal['FKProjID'] && $this->_P) {
			$pName=$this->_P->getCachedProjectName($evtVal['FKProjID']);
			if ($pName) {
				$lay_array[$this->_T->lang('[[Projekt]]').':']=' '.FrameWork::entities($pName);
			}
		}
		if ($this->getOption('showTitle',$options)) {
			$lay_array[Framework::entities($evtVal["Title"])]='';
		}
		if ($this->getOption('showOwner',$options) && $evtVal["OwnerID"]!=$this->_userID && !$evtVal["NoOwner"]) {
			$lay_title.=' '.Framework::entities($this->_frm->getCachedUserName($evtVal["OwnerID"],0,1));
		}

		if ($this->getOption('showPlace',$options) && $evtVal['Place']) {
			$lay_array[$this->_T->lang('[[Ort]]').':']=' '.Framework::entities($evtVal['Place']);
		}
		if ($this->getOption('showResources',$options) && $evtVal['InvitResources']) {
			$lay_array[$this->_T->lang('[[Resourcen]]').':']=' '.Framework::entities(implode(', ',Framework::extractObjName($this->_BaseRes->getCachedObj(explode(',',$evtVal['InvitResources'])))));
		}
		if ($this->getOption('showInvitations',$options) && ($evtVal['InvitUsers'] || $evtVal['InvitGroups'])) {
			$iusers='';
			$tmp=explode(',',$evtVal['InvitUsers']);
			foreach ($tmp as $i_uid) {
				if (!$i_uid) continue;
				$iusers.='<br>'.Framework::entities($this->_frm->getCachedUserName($i_uid,0,1));
			}
			$tmp=explode(',',$evtVal['InvitGroups']);
			foreach ($tmp as $i_uid) {
				if (!$i_uid) continue;
				$iusers.='<br>'.Framework::entities($this->_frm->getCachedGroupName($i_uid));
			}
			$lay_array[$this->_T->lang('[[Teilnehmer]]').':']=$iusers;
		}
		if ($this->getOption('showText',$options) && $evtVal['Text']) {
			$lay_array[$this->_T->lang('[[Beschreibung]]').':']=' '.Framework::entities($evtVal['Text']);
		}
		$this->_Y->addLayer($this->getOption('prepend',$options).$evtVal["EventID"],$lay_array,'array',0,$lay_title);

		if ($this->getOption('linkAsSting',$options)) {
			return ' onmouseover="'.$this->_Y->getFunctionOn($this->getOption('prepend',$options).$evtVal["EventID"]).'" onmouseout="'.$this->_Y->getFunctionOff($this->getOption('prepend',$options).$evtVal["EventID"]).'"';
		} else {
			return array(
				'onmouseover'=>$this->_Y->getFunctionOn($this->getOption('prepend',$options).$evtVal["EventID"]),
				'onmouseout'=>$this->_Y->getFunctionOff($this->getOption('prepend',$options).$evtVal["EventID"]),
			);
		}
	}

}
?>