<?php
class CalListGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_options=array(
		'loadInvitations'=>true,
		'loadActual'=>true,
		'loadFinder'=>true,
	);
	function CalListGui($options=array()) {
		global $frm,$t,$T,$E,$L,$Y;
		$this->_Base=& $frm->getStaticModul('cal');
		$this->_BaseSearch=& $frm->getStaticModul('core_search');
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_lGui=&$Y;
		$this->_options=array_merge($this->_options,$options);
		$this->_T->loadModul('cal');
		$this->_userID=$this->_frm->getUser();
		if ($this->_frm->getPrefs('cal','nd')) {
			$this->_nd=$this->_frm->getPrefs('cal','nd');
		} else {
			$this->_nd=2;
		}
		$this->_date=Framework::getParam('date',time());
		$this->_day_b=mktime(0,0,0);
		$this->_day_e=mktime(23,59,59,date('m'),date('d')+$this->_nd-1);
		if ($this->getOption('loadActual')) {
			$this->_events=$this->_Base->listEvents($this->_day_b,$this->_day_e);
		}
		if ($this->getOption('loadInvitations')) {
			$this->_invits=$this->_Base->listInvitations($this->_day_b);
		}
		if ($this->getOption('loadFinder')) {
			if (Framework::getParam('_delSid','')) {
				$sObj=$this->_BaseSearch->getObj(Framework::getParam('_delSid',''));
				if ($sObj && $sObj->getMeta('sOwner')==$this->_frm->getUser() || $this->_Base->isRuleUser()) {
					$this->_BaseSearch->deleteObj($sObj);
				}
			}
			$this->_sList=$this->_BaseSearch->listObj('cal_find');
		}

	}
	function setOption($key,$val) {
		$this->_options[$key]=$val;
	}
	function getOption($key,$ov=array()) {
		if (isset($ov[$key])) {
			return $ov[$key];
		} else {
			return $this->_options[$key];
		}
	}
	function setUserID($id) {
		$this->_userID=$id;
	}
	function &getInvitEvents() {
		return $this->_invits;
	}
	function getActualGui() {
		require_once('lib/class_ContentGui.php');
		$Gui=new ContentGui();
		require_once('lib/cal/class_DayListGui.php');
		$dayListGui=new DayListGui();
		$dayListGui->setUserID($this->_Base->getUser());
		$dayListGui->setPrivateEvents($this->_events);
		$dayListGui->setInvitEvents($this->_invits);
		$dayListGui->setIgnoreInvit(true);
		$dayListGui->setAccessLink("index.php?site=cal.php&action=view&view=event&date=".$this->_date);

		$_time=time();
		$_day=date("j",$this->_day_b);
		$_month=date("n",$this->_day_b);
		$_year=date("Y",$this->_day_b);
		$titles=array(
			0=>$this->_T->lang('[[Heute]]'),
			1=>$this->_T->lang('[[Morgen]]'),
			2=>$this->_T->lang('[[Uebermorgen]]'),
		);
		$parsed=false;

		for ($i=0;$i<$this->_nd;$i++) {
			$_day_e=mktime(23,59,59,$_month,$_day+$i,$_year);
			$_day_b=mktime(0,0,0,$_month,$_day+$i,$_year);
			$_day_str=date('j-n-Y',$_day_b);
			if ($this->_events[$_day_str])  {
				$dayListGui->processDay($_day_b,$_day_e,$titles[$i]?$titles[$i]:strftime("%A, %d.%m.%Y",$_day_b));
				if ($dayListGui->dayNumEntries($_day_b)) {
					$Gui->addContent($dayListGui,array($_day_b),'background-color:'.APP_BGCOLOR.';');
					$parsed=true;
				}
			}
		}
		if ($parsed) {
			$Gui->setName($this->_T->lang('[[Aktuelle Termine]]'),'99%');
			return $Gui;
		}
		//return false;
	}
	function getPortalGui() {
		$result='';
		require_once('lib/cal/class_DayListGui.php');
		$dayListGui=new DayListGui();
		$dayListGui->setUserID($this->_Base->getUser());
		$dayListGui->setPrivateEvents($this->_events);
		$dayListGui->setInvitEvents($this->_invits);
		$dayListGui->setIgnoreInvit(true);
		$dayListGui->setAccessLink("index.php?site=cal.php&action=view&view=event&date=".$this->_date);

		$_time=time();
		$_day=date("j",$this->_day_b);
		$_month=date("n",$this->_day_b);
		$_year=date("Y",$this->_day_b);
		$titles=array(
			0=>$this->_T->lang('[[Heute]]'),
			1=>$this->_T->lang('[[Morgen]]'),
			2=>$this->_T->lang('[[Uebermorgen]]'),
		);
		for ($i=0;$i<$this->_nd;$i++) {
			$_day_e=mktime(23,59,59,$_month,$_day+$i,$_year);
			$_day_b=mktime(0,0,0,$_month,$_day+$i,$_year);
			$_day_str=date('j-n-Y',$_day_b);
			if ($this->_events[$_day_str])  {
				$dayListGui->processDay($_day_b,$_day_e,$titles[$i]?$titles[$i]:strftime("%A, %d.%m.%Y",$_day_b));
				if ($dayListGui->dayNumEntries($_day_b)) {
					$result.=$dayListGui->process($_day_b);
				}
			}
		}
		return $result;
	}
	function getInvitGui() {
		if (!empty($this->_invits)) {
			require_once('lib/cal/class_DayListGui.php');
			require_once('lib/class_ContentGui.php');
			$Gui=new ContentGui();
			$dayListGui=new DayListGui();
			$dayListGui->setUserID($this->_Base->getUser());
			$dayListGui->setTimeFormat('full');
			$dayListGui->setAccessLink("index.php?site=cal.php&action=view&view=event&date=".$this->_date);
			foreach ($this->_invits as $key=>$val) {

				$dayListGui->addEventToList($val["StartDate"],$key,$val,1,0,'ivt_');
			}

			$Gui->setName($this->_T->lang('[[Einladungen]]'),'99%');
			$Gui->setColors('#ddc318','#ddc318');
			$Gui->addContent($dayListGui,array(0),'background-color:'.$this->_Base->getCfg('cfg/icolor').';');
			return $Gui;
		}
	}

	function getFinderGui() {
		if (!empty($this->_sList)) {
			require_once('lib/class_ApplicationListGui.php');
			$tabGui=new ApplicationListGui();
			$tabGui->setName($this->_T->lang('[[Uebersicht-cal]]'));
			foreach ($this->_sList as $key=>$val) {
				if ($key==Framework::getParam('sid','')) {
					$hl=2;
				} else {
					$hl=0;
				}
				$tabGui->addRow($hl);
				$tabGui->addCol('IMG','',$val->getImage());
				$tabGui->addCol('Name',$val->getName(),'',$this->_L->getTempLink(null,array('sid'=>$key)),'',0,'2000');
				if ($val->getMeta('sOwner')==$this->_frm->getUser() || $this->_Base->isRuleUser()) {
					$tabGui->addCol('IMG_DEL','','loeschen.gif',$this->_L->getTempLink(array('sid'),array('_delSid'=>$key)));
				} else {
					$tabGui->addCol('IMG_DEL','','tras.gif');
				}

			}
			return $tabGui;
		}
	}


}
?>