<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class mtFastTemplate {
   var $HANDLE = array();
   var $PARSED = array();
   var $PARSED_LANG = array();
   var $MASTER_TPL='';  // root folder debug_prepend templates
   var $PREPEND_TPL='';  // prepend for all filenames
   var $ROOT='';  // root folder of templates
   var $LAST='';  // handle of last parsed template
   var $STATIC = array();  // list of static templates
   var $REGEX_DYN= '/<!--\s*BEGIN\s+DYNAMIC\s+BLOCK:\s*([@A-Za-z][-_A-Za-z0-9.|]+)\s*-->(.*)<!--\s*END\s+DYNAMIC\s+BLOCK:\s*\\1\s*-->/sUS';
   var $REGEX_DEBUG='/<!--\s*(BEGIN|END)\s+DYNAMIC\s+BLOCK:\s*([@A-Za-z][-_A-Za-z0-9.]+)\s*-->/s';
   var $REGEX_VAR = '/\{([@A-Za-z_][-_A-Za-z0-9.|]*)\}/eS';
   var $DEBUG=array();  // what is to debug
   var $VARS=array();  // what is to debug
   var $_T;
   function mtFastTemplate ($pathToTemplates = '.',$master_tpl='') {
		global $T;
		$this->ROOT=$pathToTemplates.'/';
		if ($master_tpl) $this->MASTER_TPL=$master_tpl;
		elseif ($GLOBALS['MASTER_TPL']) $this->MASTER_TPL=$GLOBALS['MASTER_TPL'];
		$this->DEBUG['FILES']=false; // view loaded files
		$this->DEBUG['VARS']=true;   // view all not assigned vars
		$this->DEBUG['TEMPLATES']=false;   // view all not parsed templates
		$this->DEBUG['CHECK_TEMPLATES']=true;  // view malformed dynamic templates
		if (is_object($T)) $this->_T=&$T;
		if (defined('GE_VERSION')) $this->VARS['GE_VERSION']=GE_VERSION;
   }
   function define ($fileList, $dynamic = 0) {
      foreach ($fileList as $handle=>$file) {
		  if (GE_CHARSET=='UTF-8') $file=dirname($file).'/utf8.'.basename($file);
          if ($this->MASTER_TPL && file_exists($this->MASTER_TPL.$this->ROOT.$file)) $tpl=$this->MASTER_TPL.$this->ROOT.$file;
		  elseif (file_exists($this->ROOT.$file)) $tpl=$this->ROOT.$file;
          if ($tpl) {
          	if ($this->DEBUG['FILES']) echo "File:".$tpl." loaded<br>";
          	$this->parse_internal($handle, implode('',file($tpl)));
          } else echo "File:".$this->MASTER_TPL.$this->ROOT.$file." not exists<br>";
          $this->STATIC[$handle]=1;
      }
   }
   function parse_internal ($handle,$text) {
       if (isset($this->HANDLE[$handle])) return 0;
       if ($handle[0]=='@') {
                $this->HANDLE[$handle]=$text;
                return 0;
       }
       if (preg_match_all ($this->REGEX_DYN,$text,$result,PREG_SET_ORDER)) {
           $this->HANDLE[$handle]=preg_replace($this->REGEX_DYN,'{\\1}',$text);
           foreach ($result as $res) {
                $this->parse_internal($res[1],$res[2]);
           }
       } else $this->HANDLE[$handle]=$text;
   }
   function parse ($handle, $tag, $autoload = true) {
		$append = false;
		if (substr($tag,0,1) == '.') {
			$append = true;
			$tag = substr ($tag, 1);
		}
		if (!isset($this->HANDLE[$tag])) {
			echo "Template: $tag not found<br>";
			return 0;
		}
		if ((!isset($this->PARSED_LANG[$tag]) || !$this->PARSED_LANG[$tag]) && is_object($this->_T)) {
			$this->HANDLE[$tag]=$this->_T->replaceString($this->HANDLE[$tag]);
		}
		if ($autoload && (!isset($this->STATIC[$tag]) || !$this->STATIC[$tag])) $handle=$tag;
		if ($append) {
			if (!isset($this->PARSED[$handle])) $this->PARSED[$handle]='';
			$this->PARSED[$handle].=preg_replace($this->REGEX_VAR,'$this->get_assigned(\'\\1\')',$this->HANDLE[$tag]);
		} else $this->PARSED[$handle]=preg_replace($this->REGEX_VAR,'$this->get_assigned(\'\\1\')',$this->HANDLE[$tag]);
		$this->LAST=$handle;
   }
   function get_assigned($handle) {
       if  (isset($this->VARS[$handle])) return $this->VARS[$handle];
       elseif  (isset($this->PARSED[$handle])) return $this->PARSED[$handle];
       elseif (defined('APP_'.$handle)) return constant('APP_'.$handle);
       elseif ($this->DEBUG['TEMPLATES'] && isset($this->HANDLE[$handle])) return '{template:'.$handle.' not parsed}';
       elseif ($this->DEBUG['VARS'] && !isset($this->HANDLE[$handle])) return '{'.$handle.'}';

   }
   function issetkey ($handle = NULL) {
        if  (isset($this->VARS[$handle]) || isset($this->HANDLE[$handle])) return 1;
        return 0;
   }
   function issetHandle ($handle = NULL) {
        if  (isset($this->HANDLE[$handle])) return 1;
        return 0;
   }
   //neu
   function isparsed($handle = NULL) {
       if  (isset($this->PARSED[$handle])) return 1;
       return 0;
   }
   function clear_dynamic ($handle = NULL) {
       $this->clear($handle);
   }
   function unload($handle = NULL) {
       unset ($this->HANDLE[$handle]);
       unset ($this->PARSED[$handle]);
   }
   function unsetkey ($handle = NULL) {
       $this->clear($handle);
   }
   function clear ($handle = NULL) {
      if (isset($this->VARS[$handle])) unset($this->VARS[$handle]);
      if (isset($this->HANDLE[$handle])) unset ($this->PARSED[$handle]);
   }
   function assign ($handle, $rest = '') {
      if (!isset($rest)) $rest='';
      if (is_array ($handle)) {
         foreach($handle as $key=>$val) {
            if (!empty($key)) {
               $this->VARS[$key] = $val;
            }
         }
      } else {
         if (!empty($handle)) {
            $this->VARS[$handle] = $rest;
         }
      }
   }
   function setDebug($debug,$val=true) {
       $this->DEBUG[$debug]=$val;
   }
   function FastPrint ($handle = '',$charset=GE_CHARSET) {
 	  if ($charset) header('Content-Type: text/html; charset='.strtolower($charset));
      if (empty($handle)) {
         $handle = $this->LAST;
      }
      if ($this->DEBUG['CHECK_TEMPLATES']) {
           if (preg_match ($this->REGEX_DEBUG,$this->PARSED[$handle],$result)) {
                   echo "Template: $result[2] missing ".($result[1]=='END'?'BEGIN':'END')."<br>";
           }
      }
      if (!$this->DEBUG['VARS']) {
			$this->PARSED[$handle]=preg_replace($this->REGEX_VAR,'',$this->PARSED[$handle]);
	  }
      echo ($this->PARSED[$handle]);
   }
   function getParsed ($handle = '') {
      if (empty($handle)) {
         $handle = $this->LAST;
      }
      if ($this->DEBUG['CHECK_TEMPLATES']) {
           if (preg_match ($this->REGEX_DEBUG,$this->PARSED[$handle],$result)) {
                   echo "Template: $result[2] missing ".($result[1]=='END'?'BEGIN':'END')."<br>";
           }
      }
      return $this->PARSED[$handle];
   }
    function setRoot($path) {
        $this->ROOT=$path."/";
    }
    function getRoot() {
		return substr($this->ROOT,0,-1);
    }
}
