<?php
class ApplicationErrorGui {
	var $_error_ids=array();
	var $_errors=array();
	var $_error_params=array();
	var $_tpl_error='core/common_application_error.inc.html';
	var $_class=array('error_box','error_box_ok');
	var $_typ=0;
	function ApplicationErrorGui() {
		global $T;
		$this->_T=&$T;
		$this->_t=new mtFastTemplate ('tpl/'.APP_THEME);
	}
	function setTyp($typ) {
		$this->_typ=$typ;
	}
	function isErrorID($id) {
		return isset($this->_error_ids[$id]);
	}
	function setError($error,$id=0,$params = null) {
		$this->_error_ids[$id]=true;
		$this->_error_params[$id]=$params;
		$this->_errors[$error][]=$id;
	}
	function isError() {
		return empty($this->_errors)?false:true;
	}
	function getErrors($type='') {
		if ($type) {
			return $this->_errors[$type];
		} else {
			return $this->_errors;
		}
	}
	function getErrorParam($id) {
		return $this->_error_params[$id];
	}
	function getAllErrorMsg() {
		$result=array();
		foreach ($this->_errors as $error=>$ids) {
			$result[]=$this->getErrorMsg($error);
		}
		return $result;
	}
	function getErrorMsg($error) {
		if (isset($this->_error_msg[$error])) {
			if (is_object($this->_error_msg[$error])) {
				return $this->_error_msg[$error]->process();
			} else {
				return $this->_error_msg[$error];
			}
		} else {
			return $this->_T->lang('[[error_'.$error.']]');
		}
	}
	function setErrorMsg($error,$msg) {
		$this->_error_msg[$error]=$msg;
	}
	function setErrorData($error,$data) {
		$this->_error_data[$error]=$data;
	}
	function addErrorData($error,$data) {
		$this->_error_data[$error][]=$data;
	}
	function process($handle='') {
		if (!$this->isError()) return '';
		if (!$handle) {
			$handle='application_error';
			$return=true;
		} else {
			$return=false;
		}
		$this->_t->setRoot('tpl/'.APP_THEME);
		$this->_t->define (array($handle => $this->_tpl_error));
		foreach ($this->_errors as $error=>$ids) {
			$this->_t->assign('ERROR_MSG',$this->getErrorMsg($error));
			if (is_array($this->_error_data[$error])) {
				$temp=array();
				foreach ($this->_error_data[$error] as $Data) {
					if (is_object($Data)) {
						if (method_exists($Data,'process')) {
							$temp[]=call_user_func_array(array($Data,'process'),array());
						} elseif (method_exists($Data,'getName')) {
							$temp[]=Framework::entities($Data->getName());
						}
					} else {
						$temp[]=Framework::entities($Data);
					}
				}
				$this->_t->assign('ERROR_DATA',implode('<br />',$temp));
				$this->_t->parse('ROW','.common_application_error_row_data');
			} else {
				$this->_t->parse('ROW','.common_application_error_row');
			}
		}
		$this->_t->assign('CLASS',$this->_class[$this->_typ]);
		if ($return) {
			$this->_t->parse('TPL_TEMP',$handle);
			return $this->_t->getParsed();
		}
	}
}