<?php
class ApplicationGui {
	var $_T;
	var $_t;
	var $_tpl_application='core/common_application.inc.html';
	var $_tpl_application_header='core/common_application_header.inc.html';
	var $_tabs=array();
	var $_confirm=array();
	var $_header_alert=false;
	var $_header_functions=array();
	var $_form_action='#';
	var $_params=array();
	function ApplicationGui() {
		global $T,$E,$t,$L;
		$this->_T=&$T;
		$this->_E=&$E;
		$this->_t=&$t;
		$this->_L=&$L;
	}
	function setName($name) {
		$this->_name=$name;
	}
	function setImage($img) {
		$this->_image=$img;
	}
	function setFormAction($link) {
		$this->_form_action=$link;
	}
	function setPostParam() {
		if (func_num_args()==2) {
			$this->_params[func_get_arg(0)]=func_get_arg(1);
		} elseif (is_array(func_get_arg(0))) {
			foreach (func_get_arg(0) as $key=>$val) {
				$this->_params[$key]=$val;
			}
		}
	}
	function getPostParam($key='') {
		if ($key) {
			return $this->_params[$key];
		} else {
			return $this->_params;
		}
	}
	function unsetPostParam($key) {
		if (is_array($key)) {
			foreach ($key as $val) {
				unset($this->_params[$val]);
			}
		} else {
			unset($this->_params[$key]);
		}
	}
	function addConfirm($value) {
		$this->_confirm[]=$value;
	}
	function getConfirm() {
		return $this->_confirm;
	}
	function addFunction(&$obj) {
		$this->_header_functions[]=&$obj;
	}
	function addContent(&$obj,$params= null,$ID=null) {
		if ($params && !is_array($params)) {
			$params=array($params);
		}
		$this->_content[]=array(
			'Content'=>&$obj,
			'Params'=>$params,
			'ID'=>$ID,
		);
	}
	function addContentText($text,$ID=null) {
		$this->_content[]=array(
			'Content'=>$text,
			'ID'=>$ID,
		);
	}
	function setHeaderAlert($alert) {
		$this->_header_alert=&$alert;
	}
	function addTab($ID,$Name='',$Link='',$Image='',$On=false) {
		$this->_tabs[$ID]=array(
			'Name'=>$Name,
			'Link'=>$Link,
			'Image'=>$Image,
			'On'=>$On,
		);
	}
	function addTabSpacer() {
		$this->_tabs[]=1;
	}
	function setTabOn($ID) {
		if (isset($this->_tabs[$ID])) $this->_tabs[$ID]['On']=true;
	}
	function setTabOff($ID) {
		if (isset($this->_tabs[$ID])) $this->_tabs[$ID]['On']=false;
	}
	function processHeader() {
		$this->_t->setRoot('tpl/'.APP_THEME);
		$this->_t->define (array('application_header' => $this->_tpl_application_header));
		$this->_t->clear_dynamic('app_header_tab');
		foreach ($this->_tabs as $ID=>$val) {
			if (is_array($val)) {
				$this->_t->clear_dynamic('app_header_space_tab');
				$this->_t->assign('NAME',Framework::entities($val['Name']));
				if ($val['Image']) {
					$this->_t->assign('IMAGE',$val['Image']);
					$this->_t->parse('ROW','app_header_tab_img');
				} else {
					$this->_t->clear_dynamic('app_header_tab_img');
				}
				if ($val['On']) {
					$this->_t->assign('C_LINK','tab_on');
				} else {
					$this->_t->assign('C_LINK','');
				}
				if ($val['Link']) {
					$this->_t->assign('LINK',htmlspecialchars($val['Link']));
				} else {
					$this->_t->assign('LINK','#');
				}
				$this->_t->parse('ROW','app_header_app_tab');
			} else {
				$this->_t->clear_dynamic('app_header_app_tab');
				$this->_t->parse('ROW','app_header_space_tab');
			}
			$this->_t->parse('ROW','.app_header_tab');
		}
		if (is_array($this->_header_functions)) {
			foreach ($this->_header_functions as $val) {
				$this->_t->assign('HEADER_FUNCTION',$val->process());
				$this->_t->parse('ROW','.app_header_func');
			}

		}
		$this->_t->assign('NAME',Framework::entities($this->_name));
		if ($this->_image) {
			$this->_t->assign('IMAGE',$this->_image);
			$this->_t->parse('ROW','app_header_img');
		} else {
			$this->_t->clear_dynamic('app_header_img');
		}
		if ($this->_header_alert) {
			if (is_object($this->_header_alert)) {
				$this->_t->assign('HEADER_ALERT',$this->_header_alert->process());
			} else {
				$this->_t->assign('HEADER_ALERT',$this->_header_alert);
			}
			$this->_t->parse('ROW','header_alert');
		}
		$this->_t->parse('TPL_APP_HEADER','application_header');
	}
	function processErrors() {
		$this->_t->assign('TPL_APP_ERROR',$this->_E->process());
	}
	function processContent() {
		if (is_array($this->_content)) {
			foreach ($this->_content as $val) {
				if (is_object($val['Content'])) {
					$this->_t->assign('CONTENT',call_user_func_array(array(&$val['Content'],'process'),is_array($val['Params'])?$val['Params']:array()));
				} else {
					$this->_t->assign('CONTENT',$val['Content']);
				}
				if ($val['ID']) {
					$this->_t->assign('ID',$val['ID']);
				} else {
					$this->_t->assign('ID','');
				}
				$this->_t->parse('ROW','.app_content');
			}

		}
		if (!$this->_form_action) {
			$this->_t->assign('FORM_ACTION',htmlspecialchars($this->_L->getLink()));
		} else {
			$this->_t->assign('FORM_ACTION',htmlspecialchars($this->_form_action));
		}
	}
	function processApplication($app_handle='application',$processHeader=true) {
		$this->_t->setRoot('tpl/'.APP_THEME);
		$this->_t->define (array($app_handle => $this->_tpl_application));
		foreach ($this->getConfirm() as $key=>$val) {
			$this->_t->assign('VALUE',$val);
			$this->_t->parse('ROW','.conf_delete_vals');
		}
		if (1) {
			$this->_t->parse('ROW','conf_delete');
		}
		foreach ($this->_params as $key=>$val) {
			$this->_t->assign('KEY',htmlspecialchars($key));
			$this->_t->assign('VAL',htmlspecialchars($val));
			$this->_t->parse('ROW','.app_post_params');
		}
		if ($processHeader) {
			$this->processHeader();
		} else {
			$this->_t->assign('TPL_APP_HEADER','');
		}
		$this->processErrors();
		$this->processContent();
		$this->_t->parse('TPL_APPLICATION',$app_handle);
	}
}
?>