<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class ObjCoreLog extends baseObj {
	var $_action=array(); // to owerwrite;
	var $_site=''; // to owerwrite;
	var $_obj_typ='0';
	/* to owerwrite*/
	function ObjCoreLog($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return '';
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class CoreLog extends ObjCore {
	var $_modul='core';
	var $_table='ObjLog';
	var $_cfgObjects=array (
		'IdField'=>'LogID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'0'=>array(
			'ClassName'=>'ObjCoreLog',
			'Fields'=>array(
				'LogID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'LogDate'=>array(
					'Typ'=>'core',
				),
				'FKUserID'=>array(
					'Typ'=>'core',
				),
				'FKModul'=>array(
					'Typ'=>'core',
				),
				'FKObjID'=>array(
					'Typ'=>'core',
				),
				'LogDesc'=>array(
					'Typ'=>'core',
				),
			),
		),
	);
	function CoreLog() {
		global $db,$frm;
		$this->_db=&$db;
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','custom')));
		$this->setSuperAdmin($frm->isSuperAdmin());
		parent::ObjCore();
	}
	function searchLog(&$rows,$search,$order='LogDate DESC,LogID DESC') {
		$searchQuery=array();
		if ($search['FKModul']) $searchQuery[]=array('Field'=>'FKModul','Typ'=>'=','Values'=>$search['FKModul']);
		if ($search['FKObjID']) $searchQuery[]=array('Field'=>'FKObjID','Typ'=>'=','Values'=>$search['FKObjID']);
		if ($search['FKUserID']) $searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$search['FKUserID']);
		if ($search['LogDesc']) $searchQuery[]=array('Field'=>'LogDesc','Typ'=>'=','Values'=>$search['LogDesc']);
		if ($search['DateB']) $searchQuery[]=array('Field'=>'LogDate','Typ'=>'>=','Values'=>date('Y-m-d 00:00:00',$search['DateB']));
		if ($search['DateE']) $searchQuery[]=array('Field'=>'LogDate','Typ'=>'<=','Values'=>date('Y-m-d 23:00:00',$search['DateE']));
		//debug($searchQuery);
		return $this->searchObj($rows,$searchQuery,$order,$search['b'],$search['limit'],true);
	}
	function deleteObj(&$Obj) {
		if ($this->deleteMeta($Obj)) {
			$this->deleteLogValues($Obj);
		}
	}
	function insertLog($FKModul,$FKObjID,$FKUserID,$LogDesc) {
		$logObj=new ObjCoreLog();
		$logObj->setMeta('FKModul',$FKModul);
		$logObj->setMeta('FKObjID',$FKObjID);
		$logObj->setMeta('FKUserID',$FKUserID);
		$logObj->setMeta('LogDesc',$LogDesc);
		$logObj->setMeta('LogDate',date('Y-m-d H:i:s'));
		return $this->insertMeta($logObj);
	}
	function insertLogValues ($FKID,$FieldID,$OldValue='',$NewValue='') {
		$values=array(
			'FKLogID'=>$FKID,
			'FieldID'=>$FieldID,
			'OldValue'=>$OldValue,
			'NewValue'=>$NewValue,
		);
		return $this->_db->insert('ObjLogValues',$values);
	}
 	function deleteLogValues($FKID) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKLogID','Typ'=>'=','Values'=>$FKID);
		$query="DELETE FROM ObjLogValues WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
	}
	function listLogValues($FKID) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKLogID','Typ'=>'=','Values'=>$FKID);
		$query="SELECT * FROM ObjLogValues WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("FKLogID")][]=array(
				"FKLogID"=>$this->_db->f("FKLogID"),
				"FieldID"=>$this->_db->f("FieldID"),
				"OldValue"=>$this->_db->f("OldValue"),
				"NewValue"=>$this->_db->f("NewValue"),
			);
		}
		return $result;
	}
}