<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class ObjCoreWorkday extends baseObj {
	var $_obj_typ='0';
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['wdName'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class CoreWorkday extends ObjCore {
	var $_modul='cal';
	var $_table='CoreWorkday';
	var $_cfgObjects=array (
		'IdField'=>'wdID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'TranslationFields'=>array('wdName'),
		'0'=>array(
			'ClassName'=>'ObjCoreWorkday',
			'Fields'=>array(
				'wdID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
				'FKCountryID'=>array(
					'Typ'=>'core',
				),
				'wdName'=>array(
					'Typ'=>'core',
				),
				'wdMonth'=>array(
					'Typ'=>'core',
				),
				'wdEaster'=>array(
					'Typ'=>'core',
				),
				'wdDay'=>array(
					'Typ'=>'core',
				),
			),
		),
	);
	public $country=array();
	public $country_id=0;
	function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin')));
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->loadCountry($frm->getPrefs('cal','country'));
	}
	function insertObj(&$Obj) {
		return $this->insertMeta($Obj);
	}
	function updateObj(&$Obj) {
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		return $this->deleteMeta($Obj);
	}
	function getDays($CountryID,$order='') {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKCountryID','Typ'=>'=','Values'=>$CountryID);
		$rows=0;
		return $this->searchObj($rows,$searchQuery,$order);
	}
	function loadCountry($CountryID,$reload=0) {
		if (!isset($this->country[$CountryID]) || $reload) {
			$this->country[$CountryID]=array('a'=>array(),'r'=>array());
			foreach ($this->getDays($CountryID) as $key=>$val) {
				if ($val->getMeta('wdMonth') && $val->getMeta('wdDay') ) {
					$this->country[$CountryID]['a'][$val->getName()]=array($val->getMeta('wdMonth'),$val->getMeta('wdDay'));
				} else {
					$this->country[$CountryID]['r'][$val->getName()]=$val->getMeta('wdEaster');

				}
			}
		}
		$this->country_id=$CountryID;
	}
	function check_date($date,$shift,$weekend=0) {
		$this->hollyday="";
		$ostern=easter_date(date("Y",$date));
		if ($weekend) {
			if (date("w",$date)==0) $this->hollyday="Sonntag";
			if (date("w",$date)==6) $this->hollyday="Samstag";
		}
		foreach($this->country[$this->country_id]['a'] as $key=>$val) {
			if (date("n",$date)==$val[0] && date("j",$date)==$val[1]) $this->hollyday=$key;
		}
		foreach($this->country[$this->country_id]['r'] as $key=>$val) {
			if (date("n",$date)==date("n",$ostern+3600*24*$val) && date("j",$date)==date("j",$ostern+3600*24*$val)) $this->hollyday=$key;
		}
		if ($this->hollyday!="") $date+=$shift;
		return $date;
	}
	function next_workday($date,$weekend=0) {
		while ($ndate!=$date) {
			$ndate=$date;
			$date=$this->check_date($date,3600*24,$weekend);
		}
		return $date;
	}
	function prev_workday($date,$weekend=0) {
		while ($ndate!=$date) {
			$ndate=$date;
			$date=$this->check_date($date,-3600*24,$weekend);
		}
		return $date;
	}
	function is_workday($date,$weekend=0) {
		if ($date==$this->check_date($date,1,$weekend)) {
			return $date;
		} else {
			return 0;
		}
	}
	function get_name() {
		return $this->hollyday;
	}
	function getCountry() {
		return $this->_frm->getSelectData('cou');
	}

}
?>