<?php
class FormField {
	function FormField ($name,$default='',$attribs="",$check_callback='_check') {
		$this->_name=$name;
		$this->_default=$default;
		$this->_attribs[0]=$attribs;
		$this->_check_callback=$check_callback;
    }
    function check() {
		if ($this->_check_callback) {
			if (is_array($this->_check_callback)) {
				return call_user_func($this->_check_callback,$this);
			} else {
				return call_user_func(array(&$this,$this->_check_callback));
			}
		}
		return false;

    }
    function getName() {
		return $this->_name;
    }
    function setName($name) {
		$this->_name=$name;
    }
    function setDefault($val) {
		$this->_default=$val;
    }
    function getDefault() {
		return $this->_default.'';
    }
    function setAttribs($val,$ov=false,$scope=null) {
		if (!$scope) $scope=array(0);
		if ($ov) {
			foreach ($scope as $sval) {
				$this->_attribs[$sval]=$val;
			}
		} else {
			foreach ($val as $fk=>$fv) {
				foreach ($scope as $sval) {
					$this->_attribs[$sval][$fk]=$fv;
				}
			}
		}
    }
    function setCallback($check_callback) {
		$this->_check_callback=$check_callback;
    }
    function setValues($values) {
		$this->_values=$values;
    }
    function getValues() {
		return $this->_values;
    }
    function _check() {
		$chk=$this->getVal();
		if (is_array($chk) && empty($chk)) {
			return 'fields';
		}
		if (!is_array($chk) && !trim($chk)) {
			return 'fields';
		}
    }
    function setParams($val,$ov=false) {
		if ($ov) {
			$this->_params=$val;
		} else {
			foreach ($val as $fk=>$fv) {
				$this->_params[$fk]=$fv;
			}
		}
    }
    function getParams($key='') {
		if ($key) {
			return $this->_params[$key];
		} else {
			return $this->_params;
		}
    }
	function process() {
		return '';
	}
	function getVal($default='') {
		return Framework::getParam($this->_name,$default,'P');
	}
	function encode($val) {
		if (is_array($val)) return '';
		$val=htmlspecialchars($val);
		$val=str_replace('&amp;','&',$val);
		return $val;
	}
}

class TextHtmlBtn extends FormField {
	function TextHtmlBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		$result='';
		/*$result='<textarea name="'.$this->encode($this->_name).'"';
		$result.='>';
		$result.=$this->encode($this->getVal($this->_default));
		$result.='</textarea>';*/

		/*if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}*/
		//debug($this->_attribs[0]);
		if (!$this->_attribs[0]['cols']) $this->_attribs[0]['cols']=30;

		require_once('add-on/tiny_mce/tiny_mce.php');
		$TinyMce = new TinyMce();
		$config=array(
			'script_url'=>'add-on/tiny_mce/tiny_mce.js?t='.TinyMce::timestamp,
			'content_css'=>"tpl/ge/cjs/htmleditor.css",
			'theme_advanced_font_sizes'=>"10px,12px,13px,14px,16px,18px,20px",
			'font_size_style_values'=>"10px,12px,13px,14px,16px,18px,20px",
			//'phpimageUploadUrl'=>'ajax.php?ajax_modul=mail_img_upload&htmleditor=tiny_mce',
			'paste_retain_style_properties'=>'margin, padding, width, height, font-size, font-weight, line-height, color, text-align, ul, ol, li, text-decoration, border, float, display',
			'height'=>$this->_attribs[0]['rows']*20,
			'width'=>isset($this->_attribs[0]['width'])?$this->_attribs[0]['width']:'100%',
			'language'=>'de',
			//'theme_advanced_buttons3'=>"undo,redo,removeformat,code",
		);
		if ($this->_attribs[0]['cols']<50) {
			$config['theme_advanced_buttons1']="fontselect,fontsizeselect,|,forecolor,backcolor,|,pastetext,pasteword";
			$config['theme_advanced_buttons2']="outdent,indent,|,justifyleft,justifycenter,justifyright,justifyfull,hr,|,undo,redo,|,removeformat,code";
			$config['theme_advanced_buttons3']="bold,italic,underline,strikethrough,|,sub,sup,|,bullist,numlist,image,|,link,unlink";
		} else {
			$config['theme_advanced_buttons1']="fontselect,fontsizeselect,|,forecolor,backcolor,|,outdent,indent,|,justifyleft,justifycenter,justifyright,justifyfull,|,pastetext,pasteword,|,code";
			$config['theme_advanced_buttons2']="bold,italic,underline,strikethrough,|,sub,sup,|,bullist,numlist,hr,image,|,link,unlink,|,undo,redo,|,removeformat";
			$config['theme_advanced_buttons3']="";
		}
		$TinyMce->returnOutput=true;
		$TinyMce->basePath='add-on/tiny_mce/';
		unset($this->_attribs[0]['width']);
		$TinyMce->textareaAttributes=$this->_attribs[0];

		$result.=$TinyMce->editor($this->encode($this->_name), $this->getVal($this->_default), $config);

		return $result;
	}
}


class TextFieldBtn extends FormField {
	function TextFieldBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		$result='<input type="text" name="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' value="'.$this->encode($this->getVal($this->_default)).'"';
		$result.=' />';
		return $result;
	}
}
class TextAreaBtn extends FormField {
	function TextAreaBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		$result='<textarea name="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.='>';
		$result.=$this->encode($this->getVal($this->_default));
		$result.='</textarea>';
		return $result;
	}
}
class HiddenFieldBtn extends FormField {
	function HiddenFieldBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		$result='<input type="hidden" name="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' value="'.$this->encode($this->getVal($this->_default)).'"';
		$result.=' />';
		return $result;
	}
}
class PasswordFieldBtn extends FormField {
	function PasswordFieldBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		$result='<input type="password" name="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' value="'.$this->encode($this->getVal($this->_default)).'"';
		$result.=' />';
		return $result;
	}
}
class SelectFieldBtn extends FormField {
	var $_values=array();
	function SelectFieldBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		if (($this->_attribs[0]['multiple'])) {
			$name=$this->_name.'[]';
		} else {
			$name=$this->_name;
		}
		$result='<select name="'.$this->encode($name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.='>';
		$akt_value=$this->getVal($this->_default);
		if (is_object($this->_values)) {
			$result.=$this->_values->process();
		} else {
			foreach ($this->_values as $key=>$val) {
				$result.= '<option value="'.$this->encode($key).'"';
				if ((is_array($akt_value) && in_array($key,$akt_value)) || $akt_value==$key) {
					$result.=' selected="selected"';
				}
				$result.='>';
				$result.= $this->encode($val);
				$result.= '</option>';
			}
		}
		$result.='</select>';
		return $result;
	}
	function getVal($default='') {
		$val=Framework::getParam($this->_name,$default,'P');
		if (!is_array($val) && !array_key_exists((string)$val,$this->_values)) {
			$val=$default;
		}
		return $val;
	}

}
class SelectFieldGroupBtn extends FormField {
	var $_values=array();
	function SelectFieldGroupBtn($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		if (($this->_attribs[0]['multiple'])) {
			$name=$this->_name.'[]';
		} else {
			$name=$this->_name;
		}
		$result='<select name="'.$this->encode($name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.='>';
		$akt_value=$this->getVal($this->_default);
		if (is_object($this->_values)) {
			$result.=$this->_values->process();
		} else {
			foreach ($this->_values as $gkey=>$gval) {
				if ($gkey) $result.= '<optgroup label="'.$this->encode($gkey).'">';
				foreach ($gval as $key=>$val) {
					$result.= '<option value="'.$this->encode($key).'"';
					if ((is_array($akt_value) && in_array($key,$akt_value)) || $akt_value==$key) {
						$result.=' selected="selected"';
					}
					$result.='>';
					$result.= $this->encode($val);
					$result.= '</option>';
				}
				if ($gkey) $result.= '</optgroup>';
			}
		}
		$result.='</select>';
		return $result;
	}
	function getVal($default='') {
		$val=Framework::getParam($this->_name,$default,'P');
		return $val;
	}

}
class RadioButtonBtn extends FormField{
	var $_values=array();
	function RadioButtonBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process($value=1) {
		$result='<input type="radio" name="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' value="'.$value.'"';
	    if ($this->getVal($this->_default)==$value) $result.=' checked="checked"';
		$result.=' />';
		return $result;
	}
}
class CheckBoxBtn extends FormField{
	var $_values=array();
	function CheckBoxBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process($value=1) {
		$result='<input type="checkbox" name="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' value="'.$value.'"';
		if (is_array($this->_attribs[0]) && $this->_attribs[0]['disabled']) {
			$akt_value=$this->_default;
		} else {
			$akt_value=$this->getVal($this->_default);
		}
		if ((is_array($akt_value) && in_array($value,$akt_value)) || $akt_value==$value) {
			$result.=' checked="checked"';
		}
		$result.=' />';
		$result.='<input type="hidden" name="isset_'.$this->encode($this->_name).'" value="1" />';
		return $result;
	}
    function getDefault() {
		return $this->_default;
    }
	function getVal($default='') {
		if (Framework::getParam('isset_'.$this->_name,'','P')) {
			return Framework::getParam($this->_name,'','P');
		} else {
			return $default;
		}
	}
}
class SubmitBtn extends FormField {
	function SubmitBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process($value=1) {
		$result='<input type="submit" name="'.$this->encode($this->_name).'"';
		$result.=' onmouseover="sCl(this,\'sbt_on\')"';
		$result.=' onmouseout="sCl(this,\'sbt_off\')"';
		$result.=' class="sbt_off"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		if (!$this->_attribs[0]['id']) {
			 $result.=' id="'.$this->encode($this->_name).'"';
		}
		$result.=' title="'.$this->encode($this->_default).'"';
		$result.=' value="'.$this->encode($this->_default).'"';
		$result.=' />';
		return $result;
	}
}
class SubmitImgBtn extends FormField {
	function SubmitImgBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process($value=1) {
		$result='<input type="image" name="'.$this->encode($this->_name).'" id="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' src="'.$this->encode($this->_default).'"';
		$result.=' />';
		return $result;
	}
}
class DateFieldBtn extends FormField {
	var $_format='d/m/Y';
	function DateFieldBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		$result='<input type="text" name="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' maxlength="12"';
		$value=$this->getVal($this->_default);
		$result.=' value="'.$this->encode(Framework::isSqlDate($value)?Framework::dateSql($this->_format,$value):'--/--/----').'"';
		$result.=' />';
		return $result;
	}
    function _check() {
		if (!$this->getVal() || !Framework::isSqlDate($this->getVal())) {
			return 'fields';
		}
    }
	function getVal($default=0) {
		$datestr=Framework::getParam($this->_name,'','P');
		$time=Framework::parseDateSql($datestr);
		if (!$time && !Framework::issetParam($this->_name,'P')) $time=$default;
		return $time;
	}
}
class UnixDateFieldBtn extends FormField {
	var $_format='d/m/Y';
	function UnixDateFieldBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		$result='<input type="text" name="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' maxlength="12"';
		$value=$this->getVal($this->_default);
		$result.=' value="'.$this->encode($value?FrameWork::dateTz($this->_format,$value,isset($this->_params['tz'])?$this->_params['tz']:''):'--/--/----').'"';
		$result.=' />';
		return $result;
	}
    function _check() {
		if (!$this->getVal()) {
			return 'fields';
		}
    }
	function getVal($default=0) {
		$datestr=Framework::getParam($this->_name,'','P');
		$time=Framework::parseDate($datestr,0,0,0,false,isset($this->_params['tz'])?$this->_params['tz']:'');
		if (!$time) $time=$default;
		return $time;
	}
}
class DateTimeFieldBtn extends FormField {
	public $_format='d/m/Y';
	function DateTimeFieldBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		$value=$this->getVal($this->_default);
		$result='<input type="text" name="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' maxlength="12"';
		$result.=' value="'.$this->encode(Framework::isSqlDate($value)?Framework::dateSql($this->_format,$value):'--/--/----').'"';
		$result.=' />&nbsp;';
		$result.='<input type="text" name="'.$this->encode($this->_name.'_h').'"';
		if (is_array($this->_attribs[1])) {
			foreach ($this->_attribs[1] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' maxlength="3"';
		$result.=' value="'.$this->encode($value?Framework::dateSql('H',$value):'00').'"';
		$result.=' />';
		$result.=':<input type="text" name="'.$this->encode($this->_name.'_i').'"';
		if (is_array($this->_attribs[2])) {
			foreach ($this->_attribs[2] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' maxlength="3"';
		$result.=' value="'.$this->encode($value?Framework::dateSql('i',$value):'00').'"';
		$result.=' />';
		return $result;
	}
    function _check() {
		if (!$this->getVal() || !Framework::isSqlDate($this->getVal())) {
			return 'fields';
		}
    }
	function getVal($default=0) {
		$datestr=Framework::getParam($this->_name,'','P');
		$hour=Framework::getParam($this->_name.'_h','','P');
		$min=Framework::getParam($this->_name.'_i','','P');
		$time=Framework::parseDateSql($datestr,$hour,$min,0);
		if (!$time && !Framework::issetParam($this->_name,'P')) $time=$default;
		return $time;
	}
}
class UnixDateTimeFieldBtn extends FormField {
	var $_format='d/m/Y';
	function UnixDateTimeFieldBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		$value=$this->getVal($this->_default);
		$result='<input type="text" name="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' maxlength="12"';
		$result.=' value="'.$this->encode($value?FrameWork::dateTz($this->_format,$value,isset($this->_params['tz'])?$this->_params['tz']:''):'--/--/----').'"';
		$result.=' />&nbsp;';
		$result.='<input type="text" name="'.$this->encode($this->_name.'_h').'"';
		if (is_array($this->_attribs[1])) {
			foreach ($this->_attribs[1] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' maxlength="3"';
		$result.=' value="'.$this->encode($value?FrameWork::dateTz('H',$value,isset($this->_params['tz'])?$this->_params['tz']:''):'00').'"';
		$result.=' />';
		$result.=':<input type="text" name="'.$this->encode($this->_name.'_i').'"';
		if (is_array($this->_attribs[2])) {
			foreach ($this->_attribs[2] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' maxlength="3"';
		$result.=' value="'.$this->encode($value?FrameWork::dateTz('i',$value,isset($this->_params['tz'])?$this->_params['tz']:''):'00').'"';
		$result.=' />';
		return $result;
	}
    function _check() {
		if (!$this->getVal()) {
			return 'fields';
		}
    }
	function getVal($default=0) {
		$datestr=Framework::getParam($this->_name,'','P');
		$hour=Framework::getParam($this->_name.'_h','','P');
		$min=Framework::getParam($this->_name.'_i','','P');
		$time=Framework::parseDate($datestr,$hour,$min,0,false,isset($this->_params['tz'])?$this->_params['tz']:'');
		if (!$time) $time=$default;
		return $time;
	}
}
class TimeFieldBtn extends FormField {
	function TimeFieldBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		$value=$this->getVal($this->_default);
		$result='<input type="text" name="'.$this->encode($this->_name.'_h').'"';
		if (is_array($this->_attribs[1])) {
			foreach ($this->_attribs[1] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		if (!$this->_attribs[1]['maxlength']) $result.=' maxlength="3"';
		$result.=' value="'.$this->encode($value?sprintf('%02d',($value/60)):'00').'"';
		$result.=' />';
		$result.=':<input type="text" name="'.$this->encode($this->_name.'_i').'"';
		if (is_array($this->_attribs[2])) {
			foreach ($this->_attribs[2] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		if (!$this->_attribs[2]['maxlength']) $result.=' maxlength="3"';
		$result.=' value="'.$this->encode($value?sprintf('%02d',(abs($value)%60)):'00').'"';
		$result.=' />';
		return $result;
	}
    function _check() {
		if ($this->getVal()>(24*60) || $this->getVal()<0) {
			return 'fields';
		}
    }
	function getVal($default=0) {
		$hour=intval(Framework::getParam($this->_name.'_h','','P'));
		$min=intval(Framework::getParam($this->_name.'_i','','P'));
		$time=$hour*60+$min;
		if (!$time && !Framework::issetParam($this->_name.'_h','P')) $time=$default;
		return $time;
	}
}
class FileFieldBtn extends FormField {
	function FileFieldBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		$result='<input type="file" name="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' />';
		return $result;
	}
    function _check() {
		if (!$this->getVal()) {
			return 'fields';
		}
    }
	function getVal($default='') {
		$value=Framework::getParam($this->_name,$default,'F');
		if (!trim($value['tmp_name']) || $value['tmp_name']=='none' || !trim($value['name'])) {
			return false;
		}
		return $value;
	}
}
class CachedFileFieldBtn extends FormField {
	function CachedFileFieldBtn ($name,$default='',$attribs="",$check_callback='_check') {
		global $frm;
		parent::FormField($name,$default,$attribs,$check_callback);
		$this->_name=str_replace('[','_',$this->_name);
		$this->_name=str_replace(']','_',$this->_name);
    }
	function process() {
		$result='<input type="file" name="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' />';
		$value=$this->getVal($this->_default);
		$result.='<input type="hidden" name="default_'.$this->encode($this->_name).'[tmp_name]" value="'.($value?$this->encode($value['tmp_name']):'').'" />';
		$result.='<input type="hidden" name="default_'.$this->encode($this->_name).'[name]" value="'.($value?$this->encode($value['name']):'').'" />';
		return $result;
	}
    function _check() {
		if (!$this->getVal()) {
			return 'fields';
		}
    }
    function getDefault() {
		return $this->_default;
    }
	function getVal($default=null) {
		if (Framework::getParam('del_'.$this->_name.'_x','','P')) {
   			return false;
		}
		$value=Framework::getParam($this->_name,'','F');
		if (trim($value['tmp_name']) && $value['tmp_name']!='none' && trim($value['name']) && file_exists($value['tmp_name'])) {
			if (file_exists($this->getParams('TmpPath')) && is_writable($this->getParams('TmpPath'))) {
				if (move_uploaded_file($value['tmp_name'],$this->getParams('TmpPath').'/'.basename($this->_name))) {
					$result=array(
						'tmp_name'=>$this->getParams('TmpPath').'/'.basename($this->_name),
						'name'=>$value['name'],
					);
					Framework::importParam(array('default_'.$this->_name=>$result));
					Framework::unsetParam($this->_name,'F');
					return $result;
				}
			}
		}
		$value=Framework::getParam('default_'.$this->_name,$default,'P');
		if (trim($value['tmp_name']) && $value['tmp_name']!='none' && trim($value['name']) && file_exists($value['tmp_name'])) {
			$result=array(
				'tmp_name'=>$value['tmp_name'],
				'name'=>$value['name'],
			);
			return $result;
		}
		return false;
	}
}
class FileFieldBmng extends FormField {
	function FileFieldBmng ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		global $Bmng;
		$imgID=$this->getVal($this->_default);
		if ($imgID && ($imgObj=$Bmng->getObj($imgID)) && file_exists($Bmng->getCfg('ThumbPath').'/'.$imgObj->getMeta('Content'))) {
			$this->_attribs[0]['src']=$Bmng->getCfg('ThumbPath').'/'.$imgObj->getMeta('Content');
		} else {
			$this->_attribs[0]['src']=$Bmng->getCfg('ThumbPath').'/no_img.gif';
		}
		$result='<input type="image" name="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' />';
		$result.='<input type="hidden" name="hid_'.$this->encode($this->_name).'"';
		$result.=' value="'.$this->encode($this->getVal($this->_default)).'"';
		$result.=' />';
		return $result;
	}
	function getVal($default='') {
		$value=Framework::getParam('hid_'.$this->_name,$default,'P');
		return $value;
	}
}
class DecimalFieldBtn extends FormField {
	function DecimalFieldBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
		$this->_params['numdec']=0;
		$this->_params['decpoint']=constDECIMAL;
		$this->_params['thssep']=constTHOUSEND;
    }
    function setNumDec($val) {
		$this->_params['numdec']=$val;
    }
	function process() {
		$result='<input type="text" name="'.$this->encode($this->_name).'"';
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' value="'.number_format((float)$this->getVal($this->_default),$this->_params['numdec'],$this->_params['decpoint'],$this->_params['thssep']).'"';
		$result.=' />';
		return $result;
	}
	function getVal($default=0) {
		$value=Framework::getParam($this->_name,0,'P');
		$value=str_replace($this->_params['thssep'],'',$value);
		$value=str_replace($this->_params['decpoint'],'.',$value);
		if (!$value) return (float)$default;
		return round($value,$this->_params['numdec']);
	}
}
class AjaxTextFieldBtn extends FormField {
	var $_attribs=array();
	var $_params=array('mode'=>'u','limit'=>30,'max_height'=>'250');
	function AjaxTextFieldBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		$result='<input type="text" name="'.$this->encode($this->_name).'_txt"';
		if (!$this->_attribs[0]['id']) $this->_attribs[0]['id']=$this->_name;
		if (!$this->_attribs[0]['AUTOCOMPLETE']) $this->_attribs[0]['AUTOCOMPLETE']="off";
		if (!$this->_attribs[0]['onkeydown']) $this->_attribs[0]['onkeydown']="return startAjaxTip(event,'".$this->_attribs[0]['id']."','".$this->getParams('mode')."','".$this->getParams('app')."','".$this->getParams('params')."','".$this->getParams('limit')."','".$this->getParams('jsSetFunction')."');";
		if (!$this->_attribs[0]['onkeypress']) $this->_attribs[0]['onkeypress']="return preventKey(event);";
		//if (!$this->_attribs[0]['onblur']) $this->_attribs[0]['onblur']="hideItem('ajax_ttip_".$this->_attribs[0]['id']."',300);";
		if (is_array($this->_attribs[0])) {
			foreach ($this->_attribs[0] as $key=>$val) {
				$result.=' '.$key.'="'.$this->encode($val).'"';
			}
		}
		$result.=' />';
		$result.='<input type="hidden" name="hid_'.$this->encode($this->_name).'"';
		$result.=' value="'.$this->encode($this->getVal($this->_default)).'"';
		$result.=' id="'.$this->encode('hid_'.$this->_attribs[0]['id']).'"';
		$result.=' />';
		return $result;
	}
	function getVal($default='') {
		$value=Framework::getParam('hid_'.$this->_name,$default,'P');
		return $value;
	}
}

class ColorFieldBtn extends FormField {
	public $_attribs=array();
	public $_params=array('data'=>array());
	function ColorFieldBtn ($name,$default='',$attribs="",$check_callback='_check') {
		parent::FormField($name,$default,$attribs,$check_callback);
    }
	function process() {
		$result='';
		if (!$this->_attribs[0]['id']) $this->_attribs[0]['id']=$this->_name;
		if (!$this->_attribs[0]['style']) $this->_attribs[0]['style']='';
		$this->_attribs[0]['style'].='background-color:'.$this->getVal($this->_default).';';

		$param=array();
		$param[]="id_val:'".$this->encode($this->_attribs[0]['id'])."'";
		$param[]="id_view:'view_".$this->encode($this->_attribs[0]['id'])."'";
		//debug($this->_params);
		foreach($this->_params['data'] as $k=>$v) {
			$param[]="'".$this->encode($k)."':'".$this->encode($v)."'";
		}
		
		$result.='<div id="view_'.$this->encode($this->_attribs[0]['id']).'" class="ipt_color" onmousedown="sEvt(event);" onclick="showGeColor(event,{'.implode(',',$param).'});" style="'.$this->_attribs[0]['style'].'">&nbsp;</div>';
		$result.='<input type="hidden" name="'.$this->encode($this->_name).'"';
		$result.=' value="'.$this->encode($this->getVal($this->_default)).'"';
		$result.=' id="'.$this->encode(''.$this->_attribs[0]['id']).'"';
		$result.=' />';
		return $result;
	}
	function getVal($default='') {
		$value=Framework::getParam($this->_name,$default,'P');
		return $value;
	}
}
?>
