<?php
class FormGui {
	var $_T;
	var $_t;
	var $_tpl_fields='core/form_fields.inc.html';
	var $_gui_tpl='';
	var $_label_class=array(0=>array('','error'));
	var $_field_class=array('ipt','ipt');
	var $_fields=array();
	var $_customTplValue=array();
	function FormGui($gui_tpl='',$field_tpl='core/form_fields.inc.html') {
		global $T,$E;
		$this->_T=&$T;
		$this->_t=new mtFastTemplate ('tpl/'.APP_THEME);
		$this->_E=&$E;
		$this->_gui_tpl=$gui_tpl;
		$this->_tpl_fields=$field_tpl;
		$this->_t->setRoot('tpl/'.APP_THEME);
		$this->_t->define(array('form_fields' => $this->_tpl_fields));
		require_once('lib/class_FormFieldsCore.php');
	}
	function setGuiTpl($tpl) {
		$this->_gui_tpl=$tpl;
	}
	function setFieldClass($c,$ce) {
		$this->_field_class=array($c,$ce);
	}
	function setLabelClass($c,$ce,$id=0) {
		$this->_label_class[$id]=array($c,$ce);
	}
	function addField($id,$type,$label='',$default='',$handle='',$align='') {
		$this->_fields[$id]['Handle']=$handle;
		$this->_fields[$id]['Label']=$label;
		$this->_fields[$id]['Type']=$type;
		$this->_fields[$id]['Align']=$align;
		switch ($type) {
			case 'label':
				$this->_fields[$id]['NoMeta']=true;
				$this->_fields[$id]['Req']=0;
			break;
			case 'div':
				$this->_fields[$id]['NoMeta']=true;
				$this->_fields[$id]['Req']=0;
				$this->_fields[$id]['Default']=$default;
			break;
			case 'text':
				$this->_fields[$id]['Obj']=new TextFieldBtn($id,$default);
			break;
			case 'file':
				$this->_fields[$id]['Obj']=new FileFieldBtn($id,$default);
			break;
			case 'cached_file':
				$this->_fields[$id]['Obj']=new CachedFileFieldBtn($id,$default);
			break;
			case 'bmng':
				$this->_fields[$id]['Obj']=new FileFieldBmng($id,$default);
			break;
			case 'area':
				$this->_fields[$id]['Obj']=new TextAreaBtn($id,$default);
			break;
			case 'html':
				$this->_fields[$id]['Obj']=new TextHtmlBtn($id,$default);
			break;
			case 'fasttext':
				$this->_fields[$id]['Obj']=new TextAreaBtn($id,$default);
			break;
			case 'select':
				$this->_fields[$id]['Obj']=new SelectFieldBtn($id,$default);
			break;
			case 'select_grp':
				$this->_fields[$id]['Obj']=new SelectFieldGroupBtn($id,$default);
			break;
			case 'date':
				$this->_fields[$id]['Obj']=new DateFieldBtn($id,$default);
			break;
			case 'datetime':
				$this->_fields[$id]['Obj']=new DateTimeFieldBtn($id,$default);
			break;
			case 'unixdate':
				$this->_fields[$id]['Obj']=new UnixDateFieldBtn($id,$default);
			break;
			case 'unixdatetime':
				$this->_fields[$id]['Obj']=new UnixDateTimeFieldBtn($id,$default);
			break;
			case 'time':
				$this->_fields[$id]['Obj']=new TimeFieldBtn($id,$default);
			break;
			case 'mselect':
				$this->_fields[$id]['Obj']=new SelectFieldBtn($id,$default);
				$this->_fields[$id]['Obj']->setAttribs(array('multiple'=>'multiple','size'=>10));
			break;
			case 'check':
				$this->_fields[$id]['Obj']=new CheckBoxBtn($id,$default);
			break;
			case 'checklist_h':
			case 'checklist_v':
				$this->_fields[$id]['Obj']=new CheckBoxBtn($id.'[]',$default);
			break;
			case 'radio':
			case 'radiolist_h':
			case 'radiolist_v':
				$this->_fields[$id]['Obj']=new RadioButtonBtn($id,$default);
			break;
			case 'pwd':
				$this->_fields[$id]['Obj']=new PasswordFieldBtn($id,$default);
			break;
			case 'hidden':
				$this->_fields[$id]['Obj']=new HiddenFieldBtn($id,$default);
			break;
			case 'submit':
				$this->_fields[$id]['Obj']=new SubmitBtn($id,$default);
				$this->_fields[$id]['Req']=0;
				$this->_fields[$id]['NoMeta']=1;
				if (!$align) $this->_fields[$id]['Align']='center';
			break;
			case 'curr':
				$this->_fields[$id]['Obj']=new DecimalFieldBtn($id,$default);
				$this->_fields[$id]['Obj']->setNumDec(2);
			break;
			case 'int':
				$this->_fields[$id]['Obj']=new DecimalFieldBtn($id,$default);
				$this->_fields[$id]['Obj']->setNumDec(0);
			break;
			case 'ttip':
				$this->_fields[$id]['Obj']=new AjaxTextFieldBtn($id,$default);
			break;
			case 'color':
				$this->_fields[$id]['Obj']=new ColorFieldBtn($id,$default);
			break;
			case 'field_array':
				$this->_fields[$id]['Obj']=$default;
				$this->_fields[$id]['NoMeta']=1;
				$this->_fields[$id]['Req']=0;
			break;
		}
	}
	function deleteField($id) {
		unset($this->_fields[$id]);
	}
	function addCustumTplValue($id,$value) {
		$this->_customTplValue[$id]=$value;
	}
	function setRequired($id,$val=true) {
		$this->_fields[$id]['Req']=$val;
	}
	function setDefault($id,$val) {
		$this->_fields[$id]['Obj']->setDefault($val);
    }
    function setAttribs($id,$val,$ov=false,$scope=null) {
		$this->_fields[$id]['Obj']->setAttribs($val,$ov,$scope);
    }
    function setValues($id,$val) {
		$this->_fields[$id]['Obj']->setValues($val);
    }
	function setValuesAttribs($id,$key,$val) {
		$this->_vattribs[$id][$key]=$val;
    }
	function setValuesDesc($id,$val) {
		$this->_vdesc[$id]=$val;
    }
    function setPrependFields($id,$val) {
		$this->_prependFields[$id]=$val;
    }

    function setCallback($id,$check_callback) {
		$this->_fields[$id]['Obj']->setCallback($check_callback);
    }
    function setLabel($id,$val) {
		$this->_fields[$id]['Label']=$val;
    }
    function setIptAttribs($id,$val) {
		$this->_fields[$id]['IptAttribs']=$val;
    }
    function setParams($id,$val,$ov=false) {
		$this->_fields[$id]['Obj']->setParams($val,$ov);
    }
    function getParams($id,$key='') {
		return $this->_fields[$id]['Obj']->getParams($key);
    }
    function setDisabled($id,$val=true) {
		$this->_disabled[$id]=$val;
    }
    function setNoMeta($id) {
		$this->_fields[$id]['NoMeta']=1;
    }
    function setNoParse($id) {
		$this->_fields[$id]['NoParse']=1;
    }
    function &getFieldObj($id) {
		return $this->_fields[$id]['Obj'];
    }
    function getFieldType($id) {
		return $this->_fields[$id]['Type'];
    }
    function fieldExists($id) {
		return isset($this->_fields[$id]);
    }
    function &getFieldVal($id,$use_default=0) {
		//debug($id);
		if ($use_default) {
			return $this->_fields[$id]['Obj']->getVal($this->_fields[$id]['Obj']->getDefault());
		} else {
			//debug($id);
			return $this->_fields[$id]['Obj']->getVal();
		}
    }
    function checkFields($field_handle='') {
		$error=false;
		foreach (array_keys($this->_fields) as $key) {
			if ($this->_checkField($this->_fields[$key],$key,$field_handle)) {
				$error=true;
			}
		}
		return $error?false:true;
    }
	function _checkField(&$field,$id,$field_handle) {
		if ($this->_disabled[$id]) return;
		if ($field_handle && $field_handle!=$field['Handle']) return;
		if ($field['Req']) {
			$error=$field['Obj']->check();
			if ($error) {
				$this->_E->setError($error,$id);
			}
			return $error;
		}
	}
    function addMetaToObj(&$Obj,$field_handle='',$use_default=false) {
		foreach (array_keys($this->_fields) as $key) {
			if (is_array($field_handle) && !in_array($this->_fields[$key]['Handle'],$field_handle)) continue;
			elseif ($field_handle && $field_handle!=$this->_fields[$key]['Handle']) continue;
			if ($this->_fields[$key]['NoMeta']) continue;
			if ($this->_disabled[$key]) continue;
			if ($use_default) {
				$Obj->setMeta($key,$this->_fields[$key]['Obj']->getVal($this->_fields[$key]['Obj']->getDefault()));
			} else {
				$Obj->setMeta($key,$this->_fields[$key]['Obj']->getVal());
			}
		}
    }
    function addMetaToArray(&$Array,$field_handle='',$use_default=false) {
		foreach (array_keys($this->_fields) as $key) {
			if (is_array($field_handle) && !in_array($this->_fields[$key]['Handle'],$field_handle)) continue;
			elseif ($field_handle && $field_handle!=$this->_fields[$key]['Handle']) continue;
			if ($this->_fields[$key]['NoMeta']) continue;
			if ($this->_disabled[$key]) continue;
			$ikey=preg_replace('/^([^[]+)/','[\\1]',str_replace('[]','',$key));
			$ikey=str_replace('[',"['",str_replace(']',"']",$ikey));
			if ($use_default) {
				eval('$Array'.$ikey.'=$this->_fields[$key][\'Obj\']->getVal($this->_fields[$key][\'Obj\']->getDefault());');
				//$Array[$key]=$this->_fields[$key]['Obj']->getVal($this->_fields[$key]['Obj']->getDefault());
			} else {
				eval('$Array'.$ikey.'=$this->_fields[$key][\'Obj\']->getVal();');
				//$Array[$key]=$this->_fields[$key]['Obj']->getVal();
			}
		}
    }
	function process($handle='',$field_handle='') {
		$this->_tmp_result='';
		if (!$handle) {
			$handle='form_content';
			$return=true;
		} else {
			$return=false;
		}
		if ($this->_gui_tpl) {
			$this->_t->setRoot('tpl/'.APP_THEME);
			$this->_t->define(array($handle => $this->_gui_tpl));
		}
		//debug($this);
		foreach (array_keys($this->_fields) as $key) {
			$this->_processField($this->_fields[$key],$key,$field_handle);
		}
		if (!empty($this->_customTplValue)) {
			foreach($this->_customTplValue as $key=>$val) {
				$this->_t->assign($key,$val);
			}
		}
		if ($return) {
			if ($this->_gui_tpl) {
				if ($this->_tmp_result && $this->_t->issetHandle('form_field_content')) {
					$this->_t->assign('FIELD_CONTENT',$this->_tmp_result);
					$this->_t->parse('ROW','form_field_content');
				}
				$this->_t->parse('ROW',$handle);
				return $this->_t->getParsed();
			} else {
				return $this->_tmp_result;
			}
		}
	}
	function clearFields($field_handle='',$fieldID=array()) {
		if (empty($fieldID)) {
			$fieldID=array_keys($this->_fields);
		}
		foreach ($fieldID as $id) {
			//debug($id);
			if (!isset($this->_fields[$id])) continue;
			if ($field_handle && $field_handle!=$this->_fields[$id]['Handle']) continue;
			switch ($this->_fields[$id]['Type']) {
				case 'unixdatetime':
				case 'datetime':
					Framework::unsetParam($id,'P');
					Framework::unsetParam($id.'_h','P');
					Framework::unsetParam($id.'_i','P');
				break;
				case 'time':
					Framework::unsetParam($id.'_h','P');
					Framework::unsetParam($id.'_i','P');
				break;
				case 'ttip':
				case 'bmng':
					Framework::unsetParam($id,'P');
					Framework::unsetParam('hid_'.$id,'P');
				break;
				case 'check':
					Framework::unsetParam($id,'P');
					Framework::unsetParam('isset_'.$id,'P');
				break;
				case 'submit':
					if (is_array($this->_fields[$id]['Values'])) {
						foreach ($this->_fields[$id]['Values'] as $key=>$val) {
							Framework::unsetParam($key,'P');
						}
					} else {
						Framework::unsetParam($id,'P');
					}
				break;
				case 'cached_file':
					$fid=str_replace('[','_',str_replace(']','_',$id));
					Framework::unsetParam($fid,'F');
					Framework::unsetParam('default_'.$fid,'P');
				break;
				default:
					Framework::unsetParam($id,'P');
				break;
			}
		}
	}
	function _processField(&$field,$id,$field_handle) {
		if ($field_handle && $field_handle!=$field['Handle']) return;
		$this->_t->assign('ID',$id);
		if ($this->_E->isErrorID($id)) {
			$fclass=$this->_field_class[1];
			$this->_t->assign('CLASS',isset($this->_label_class[$id])?$this->_label_class[$id][1]:$this->_label_class[0][1]);
		} else {
			$fclass=$this->_field_class[0];
			$this->_t->assign('CLASS',isset($this->_label_class[$id])?$this->_label_class[$id][0]:$this->_label_class[0][0]);
		}
		if ($this->_disabled[$id]) {
			$dclass=$this->_field_class[0].'_dis';
		} else {
			$dclass='';
		}
		$this->_t->assign('ALIGN',$this->_fields[$id]['Align']);
		//debug($field['Obj']);
		switch ($field['Type']) {
			case 'label':
				$tpl='field_label';
			break;
			case 'div':
				$this->_t->assign('DEFAULT',$field['Default']);
				$tpl='field_div';
			break;
			case 'area':
			case 'html':
			case 'text':
			case 'file':
			case 'pwd':
			case 'curr':
			case 'int':
			case 'color':
				if ($this->_disabled[$id]) {
					$attr='';
					$field['Obj']->setAttribs(array('class'=>$dclass));
					if (is_array($field['Obj']->_attribs[0])) {
						foreach ($field['Obj']->_attribs[0] as $key=>$val) {
							$attr.=' '.$key.'="'.htmlspecialchars($val).'"';
						}
					}
					$this->_t->assign('FIELD',"<div $attr>".$field['Obj']->getDefault().'</div>');
					$dclass='';
				} else {
					$field['Obj']->setAttribs(array('class'=>$fclass,'id'=>$id));
					if ($this->_prependFields[$id]) {
						$values=array();
						foreach ($this->_prependFields[$id] as $tmp_fieldID) {
							if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
								$values[]=$this->_fields[$tmp_fieldID]['Obj']->process();
							}
							$values[]=$field['Obj']->process();
						}
						$this->_t->assign('FIELD',implode('',$values));
					} else {
						$this->_t->assign('FIELD',$field['Obj']->process());
					}
				}
				$tpl='field_standard';
			break;
			case 'field_array':
				$values=array();
				foreach ($field['Obj'] as $tmp_fieldID) {
					if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
						$values[]=$this->_fields[$tmp_fieldID]['Obj']->process();
					} else {
						$values[]=$tmp_fieldID;
					}
				}
				$this->_t->assign('FIELD',implode('',$values));
				$tpl='field_standard';
			break;
			case 'select':
			case 'select_grp':
				if ($this->_disabled[$id]) {
					$attr='';
					$field['Obj']->setAttribs(array('class'=>$dclass));
					if (is_array($field['Obj']->_attribs[0])) {
						foreach ($field['Obj']->_attribs[0] as $key=>$val) {
							$attr.=' '.$key.'="'.htmlspecialchars($val).'"';
						}
					}
					$this->_t->assign('FIELD',"<div $attr>".$field['Obj']->_values[$field['Obj']->getDefault()].'</div>');
					$dclass='';
				} else {
					$field['Obj']->setAttribs(array('class'=>$fclass,'id'=>$id));
					if ($this->_prependFields[$id]) {
						$values=array();
						foreach ($this->_prependFields[$id] as $tmp_fieldID) {
							if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
								$values[]=$this->_fields[$tmp_fieldID]['Obj']->process();
							}
							$values[]=$field['Obj']->process();
						}
						$this->_t->assign('FIELD',implode('',$values));
					} else {
						$this->_t->assign('FIELD',$field['Obj']->process());
					}
				}
				$tpl='field_standard';
			break;
			case 'bmng':
				$field['Obj']->setAttribs(array('id'=>$id));
				if ($this->_prependFields[$id]) {
					$values=array();
					foreach ($this->_prependFields[$id] as $tmp_fieldID) {
						if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
							$values[]=$this->_fields[$tmp_fieldID]['Obj']->process();
						}
						$values[]=$field['Obj']->process();
					}
					$this->_t->assign('FIELD',implode('',$values));
				} else {
					$this->_t->assign('FIELD',$field['Obj']->process());
				}
				$tpl='field_standard';
			break;
			case 'fasttext':
				$field['Obj']->setAttribs(array('class'=>$fclass,'id'=>$id));
				if ($this->_prependFields[$id]) {
					$values=array();
					foreach ($this->_prependFields[$id] as $tmp_fieldID) {
						if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
							$values[]=$this->_fields[$tmp_fieldID]['Obj']->process();
						}
						$values[]=$field['Obj']->process();
					}
					$this->_t->assign('FIELD',implode('',$values));
				} else {
					$this->_t->assign('FIELD',$field['Obj']->process());
				}
				$tpl='field_fasttext';
			break;
			case 'date':
				if ($this->_disabled[$id]) {
					$this->_t->assign('FIELD',Framework::dateSql('d.m.Y',$field['Obj']->getDefault()));
					$tpl='field_standard';
					$dclass=$dclass.'_dt';
				} else {
					$field['Obj']->setAttribs(array('class'=>$fclass.'_d','id'=>$id));
					if ($this->_prependFields[$id]) {
						$values=array();
						foreach ($this->_prependFields[$id] as $tmp_fieldID) {
							if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
								$values[]=$this->_fields[$tmp_fieldID]['Obj']->process();
							}
							$values[]=$field['Obj']->process();
						}
						$this->_t->assign('FIELD',implode('',$values));
					} else {
						$this->_t->assign('FIELD',$field['Obj']->process());
					}
					$this->_t->assign('DATE',$field['Obj']->getVal()?Framework::parseSqlDate($field['Obj']->getVal()):time());
					$tpl='field_date';
				}
			break;
			case 'datetime':
				$field['Obj']->setAttribs(array('class'=>$fclass.'_dt','id'=>$id),false,array(0));
				$field['Obj']->setAttribs(array('class'=>'h_'.$fclass.'_dt','id'=>'h_'.$id),false,array(1));
				$field['Obj']->setAttribs(array('class'=>'i_'.$fclass.'_dt','id'=>'i_'.$id),false,array(2));
				if ($this->_prependFields[$id]) {
					$values=array();
					foreach ($this->_prependFields[$id] as $tmp_fieldID) {
						if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
							$values[]=$this->_fields[$tmp_fieldID]['Obj']->process();
						}
						$values[]=$field['Obj']->process();
					}
					$this->_t->assign('FIELD',implode('',$values));
				} else {
					$this->_t->assign('FIELD',$field['Obj']->process());
				}
				$this->_t->assign('DATE',$field['Obj']->getVal()?Framework::parseSqlDate($field['Obj']->getVal()):time());
				$tpl='field_date';
			break;
			case 'unixdate':
				if ($this->_disabled[$id]) {
					$field['Obj']->setAttribs(array('class'=>$dclass.'_dt','id'=>$id));
					$attr='';
					if (is_array($field['Obj']->_attribs[0])) {
						foreach ($field['Obj']->_attribs[0] as $key=>$val) {
							$attr.=' '.$key.'="'.htmlspecialchars($val).'"';
						}
					}

					$this->_t->assign('FIELD',"<div $attr>".($field['Obj']->getDefault()?date('d.m.Y',$field['Obj']->getDefault()):'--.--.----').'</div>');
					$tpl='field_standard';
					$dclass='';
				} else {
					$field['Obj']->setAttribs(array('class'=>$fclass.'_d','id'=>$id));
					if ($this->_prependFields[$id]) {
						$values=array();
						foreach ($this->_prependFields[$id] as $tmp_fieldID) {
							if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
								$values[]=$this->_fields[$tmp_fieldID]['Obj']->process();
							}
							$values[]=$field['Obj']->process();
						}
						$this->_t->assign('FIELD',implode('',$values));
					} else {
						$this->_t->assign('FIELD',$field['Obj']->process());
					}
					$this->_t->assign('DATE',$field['Obj']->getVal()?$field['Obj']->getVal():time());
					$tpl='field_date';
				}
			break;
			case 'unixdatetime':
				$field['Obj']->setAttribs(array('class'=>$fclass.'_dt','id'=>$id),false,array(0));
				$field['Obj']->setAttribs(array('class'=>'h_'.$fclass.'_dt','id'=>'h_'.$id),false,array(1));
				$field['Obj']->setAttribs(array('class'=>'i_'.$fclass.'_dt','id'=>'i_'.$id),false,array(2));
				if ($this->_prependFields[$id]) {
					$values=array();
					foreach ($this->_prependFields[$id] as $tmp_fieldID) {
						if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
							$values[]=$this->_fields[$tmp_fieldID]['Obj']->process();
						}
						$values[]=$field['Obj']->process();
					}
					$this->_t->assign('FIELD',implode('',$values));
				} else {
					$this->_t->assign('FIELD',$field['Obj']->process());
				}
				$this->_t->assign('DATE',$field['Obj']->getVal()?$field['Obj']->getVal():time());
				$tpl='field_date';
			break;
			case 'time':
				if ($this->_disabled[$id]) {
					$this->_t->assign('FIELD',sprintf('%02d',($field['Obj']->getDefault()/60)).':'.sprintf('%02d',($field['Obj']->getDefault()%60)));
					$dclass='h_'.$dclass.'_dt';
					$tpl='field_standard';
				} else {
					$field['Obj']->setAttribs(array('class'=>'h_'.$fclass.'_dt','id'=>'h_'.$id),false,array(1));
					$field['Obj']->setAttribs(array('class'=>'i_'.$fclass.'_dt','id'=>'i_'.$id),false,array(2));
					if ($this->_prependFields[$id]) {
						$values=array();
						foreach ($this->_prependFields[$id] as $tmp_fieldID) {
							if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
								$values[]=$this->_fields[$tmp_fieldID]['Obj']->process();
							}
							$values[]=$field['Obj']->process();
						}
						$this->_t->assign('FIELD',implode('',$values));
					} else {
						$this->_t->assign('FIELD',$field['Obj']->process());
					}
				}
				$tpl='field_standard';
			break;
			case 'mselect':
				$field['Obj']->setAttribs(array('class'=>$fclass,'id'=>$id));
				if ($this->_prependFields[$id]) {
					$values=array();
					foreach ($this->_prependFields[$id] as $tmp_fieldID) {
						if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
							$values[]=$this->_fields[$tmp_fieldID]['Obj']->process();
						}
						$values[]=$field['Obj']->process();
					}
					$this->_t->assign('FIELD',implode('',$values));
				} else {
					$this->_t->assign('FIELD',$field['Obj']->process());
				}
				$this->_t->assign('IPT_CLASS',$this->_field_class[0]);
				$tpl='field_mselect';
			break;
			case 'check':
				$field['Obj']->setAttribs(array('id'=>$id));
				if ($this->_disabled[$id]) $field['Obj']->setAttribs(array('disabled'=>'disabled'));
				if ($this->_prependFields[$id]) {
					$values=array();
					foreach ($this->_prependFields[$id] as $tmp_fieldID) {
						if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
							$values[]=$this->_fields[$tmp_fieldID]['Obj']->process();
						}
						$values[]=$field['Obj']->process();
					}
					$this->_t->assign('FIELD',implode('',$values));
				} else {
					$this->_t->assign('FIELD',$field['Obj']->process());
				}
				$tpl='field_check';
			break;
			case 'radiolist_h':
			case 'checklist_h':
				$this->_t->clear_dynamic('field_list_h_row');
				if ($this->_prependFields[$id]) {
					foreach ($this->_prependFields[$id] as $tmp_fieldID) {
						if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
							$this->_t->assign('FIELD',$this->_fields[$tmp_fieldID]['Obj']->process());
							$this->_t->assign('FIELD_VAL','');
							$this->_t->parse('ROW','.field_list_h_row');
						}
					}
				}
				$j=0;
				foreach ($field['Obj']->getValues() as $key=>$val) {
					$this->_t->assign('LID',$id.'_'.$j);
					$field['Obj']->setAttribs(array('id'=>$id.'_'.$j));
					if ($this->_disabled[$id]) $field['Obj']->setAttribs(array('disabled'=>'disabled'));
					if (isset($this->_vattribs[$id][$key])) $field['Obj']->setAttribs($this->_vattribs[$id][$key]);
					$this->_t->assign('FIELD',$field['Obj']->process($key));
					if (is_object($val)) {
						$this->_t->assign('FIELD_VAL',$val->process());
					} else {
						$this->_t->assign('FIELD_VAL',Framework::entities($val));
					}
					$this->_t->parse('ROW','.field_list_h_row');
					$j++;
				}
				$tpl='field_list_h';
			break;
			case 'radiolist_v':
			case 'checklist_v':
				$this->_t->clear_dynamic('field_list_v_row');
				$j=0;
				foreach ($field['Obj']->getValues() as $key=>$val) {
					$this->_t->assign('LID',$id.'_'.$j);
					$field['Obj']->setAttribs(array('id'=>$id.'_'.$j));
					if (isset($this->_vattribs[$id][$key])) $field['Obj']->setAttribs($this->_vattribs[$id][$key]);
					$this->_t->assign('FIELD',$field['Obj']->process($key));
					if (is_object($val)) {
						$this->_t->assign('FIELD_VAL',$val->process());
					} else {
						$this->_t->assign('FIELD_VAL',Framework::entities($val));
					}
					//debug($this->_vdesc);
					if ($this->_vdesc[$id][$key]) {
						$this->_t->assign('FIELD_DESC',nl2br(Framework::entities($this->_vdesc[$id][$key])));
						$this->_t->parse('ROW','field_list_v_row_desc');
					} else {
						$this->_t->clear_dynamic('field_list_v_row_desc');
					}
					$this->_t->parse('ROW','.field_list_v_row');
					$j++;
				}
				$tpl='field_list_v';
			break;
			case 'hidden':
				$field['Obj']->setAttribs(array('id'=>$id));
				$this->_t->assign('FIELD',$field['Obj']->process());
				$tpl='field_hidden';
			break;
			case 'submit':
				$this->_t->clear_dynamic('field_submit_row');
				$values=$field['Obj']->getValues();
				if (is_array($values)) {
					foreach ($values as $key=>$val) {
						$field['Obj']->setAttribs(array('id'=>$key));
						if (isset($this->_vattribs[$id][$key])) $field['Obj']->setAttribs($this->_vattribs[$id][$key]);
						$field['Obj']->setName($key);
						$field['Obj']->setDefault($val);
						$this->_t->assign('FIELD',$field['Obj']->process());
						$this->_t->parse('ROW','.field_submit_row');
					}
				} else {
					$field['Obj']->setAttribs(array('id'=>$id));
					$this->_t->assign('FIELD',$field['Obj']->process());
					$this->_t->parse('ROW','.field_submit_row');
				}
				$tpl='field_submit';
			break;
			case 'ttip':
				$field['Obj']->setAttribs(array('class'=>$fclass,'id'=>$id));
				$f_value=$field['Obj']->getVal($field['Obj']->getDefault());
				$this->parseAjaxList($id,$f_value,$field['Obj']->getParams());
				$field['Obj']->setDefault($f_value);
				if ($this->_disabled[$id]) {
					$this->_t->assign('FIELD','');
				} else {
					if ($this->_prependFields[$id]) {
						$values=array();
						foreach ($this->_prependFields[$id] as $tmp_fieldID) {
							if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
								$values[]=$this->_fields[$tmp_fieldID]['Obj']->process();
							}
							$values[]=$field['Obj']->process();
						}
						$this->_t->assign('FIELD',implode('',$values));
					} else {
						$this->_t->assign('FIELD',$field['Obj']->process());
					}
				}
				$this->_t->assign('T_STYLE','');
				if ($field['Obj']->getParams('max_height')) {
					$this->_t->assign('T_STYLE','max-height:'.$field['Obj']->getParams('max_height').'px;overflow-y:auto;');
				}
				if ($field['Obj']->getParams('no_width')) {
					$this->_t->assign('T_WIDTH','');
					//debug($field['Obj']->getParams('width'));
					$this->_t->assign('L_WIDTH',$field['Obj']->getParams('width'));
				} elseif ($field['Obj']->getParams('width')) {
					$this->_t->assign('T_WIDTH',$field['Obj']->getParams('width'));
					$this->_t->assign('L_WIDTH',$field['Obj']->getParams('width'));
				} else {
					$this->_t->assign('T_WIDTH','300px;');
					$this->_t->assign('L_WIDTH','300px;');
				}
				//debug($f_value);
				$tpl='field_ajax_list';
			break;
			case 'cached_file':
				$this->_t->clear_dynamic('field_entry_list_content');
				$fid=str_replace('[','_',str_replace(']','_',$id));
				$this->_t->assign('ID',$fid);
				$field['Obj']->setAttribs(array('class'=>$fclass,'id'=>$fid));
				if ($this->_disabled[$id]) {
					$this->_t->assign('FIELD','');
				} else {
					if ($this->_prependFields[$id]) {
						$values=array();
						foreach ($this->_prependFields[$id] as $tmp_fieldID) {
							if (is_object($this->_fields[$tmp_fieldID]['Obj'])) {
								$values[]=$this->_fields[$tmp_fieldID]['Obj']->process();
							}
							$values[]=$field['Obj']->process();
						}
						$this->_t->assign('FIELD',implode('',$values));
					} else {
						$this->_t->assign('FIELD',$field['Obj']->process());
					}
				}
				$aktValue=$field['Obj']->getVal($field['Obj']->getDefault());
				if ($aktValue) {
					$this->_t->assign('N_LIST',$aktValue['name']);
					$this->_t->parse('ROW','field_entry_list_content');
				}

				$tpl='field_entry_list';
			break;
		}
		if (!$field['NoParse']) {
			$this->_t->assign('DCLASS',$dclass);
			$attribs='';
			if ($field['IptAttribs']) {
				foreach ($field['IptAttribs'] as $key=>$val) {
					$attribs.=' '.$key.'="'.$val.'"';
				}
			}
			$this->_t->assign('IPT_ATTRIBS',$attribs);

			if ($field['Label']) {
				$this->_t->assign('LABEL',is_object($field['Label'])?$field['Label']->process():($field['Label']=='&nbsp;'?'&nbsp;':Framework::entities($field['Label'])));
				$this->_t->parse('ROW','lb_'.$tpl);
			} else {
				$this->_t->clear_dynamic('lb_'.$tpl);
			}
			$this->_t->parse('ROW',$tpl);
			if ($this->_t->issetHandle($field['Handle'])) {
				$this->_t->assign('CONTENT',$this->_t->getParsed());
				$this->_t->parse('ROW','.'.$field['Handle']);
			} else {
				$this->_tmp_result.=$this->_t->getParsed();
			}
		}
	}
	function parseAjaxList($id,&$val_txt,$params,$return=false) {
		global $frm,$P;
		$tipParams=unserialize(base64_decode($params['params']));
		$this->_t->clear_dynamic('field_ajax_list_content');
		$this->_t->clear_dynamic('field_ajax_list_content_del');
		$this->_t->clear_dynamic('field_ajax_list_row');
		$this->_t->clear_dynamic('field_ajax_list_row_del');
		$this->_t->assign('ID',$id);
		$mode=explode('|',$params['mode']);
		$values=explode('|',$val_txt);
		$chk_values=array();
		foreach ($values as $valKey) {
			if (in_array($valKey[0],$mode)) {
				$fvals[$valKey[0]][]=substr($valKey,2);
				if ($valKey[0]=='g' && in_array('p',$mode)) {
					$fvals['p'][]=substr($valKey,2);
				}
			}
		}
		$this->_t->assign('MODE_LIST',$params['mode']);
		$this->_t->assign('PARAMS_LIST',$params['params']);
		if ($params['jsSetFunction']) {
			$this->_t->assign('JS_SET_FUNCTION',$params['jsSetFunction']);
		} else {
			$this->_t->assign('JS_SET_FUNCTION','setAjaxTip');
		}
		$i=0;
		foreach ($mode as $fmode) {
			$noEnc=false;
			if (is_array($fvals[$fmode])) {
				$ids=array_unique($fvals[$fmode]);
				$data=array();
				$text=array();
				switch ($fmode) {
					case 'u':
						$data=$frm->getFullName($ids,0,1);
						$img='user.gif';
					break;
					case 'g':
						$data=$frm->getAllGroups($ids,0);
						$img='gruppe.gif';
					break;
					case 'e':
						foreach ($ids as $key) {
							$tmpObj=$frm->readSuperGroup($key);
							if ($tmpObj) {
								$data[$key]=$tmpObj['SGroupName'];
							}
						}
						$img='gruppe.gif';
					break;
					case 'p':
						$img='rolle.gif';
						if ($tipParams['prjID']) {
							$data=$frm->getAllGroups($ids,array($tipParams['prjID']));
						}
					break;
					case 'r':
						$img='rolle.gif';
						foreach ($ids as $key) {
							$data[$key]=$this->_T->lang($P->getAvRules($key));
						}
					break;
					case 'o':
						foreach ($ids as $id_val) {
							if ($P->getCachedProjectName($id_val)) $data[$id_val]=$P->getCachedProjectName($id_val);
						}
						$img='rolle.gif';
					break;
					case 'z':
						$Zef=& $frm->getStaticModul('zef');
						foreach ($ids as $id_val) {
							if ($Zef->getCachedPrjName($id_val)) $data[$id_val]=$Zef->getCachedPrjName($id_val);
						}
						$img='rolle.gif';
					break;
					case 'c':
						$Zef=& $frm->getStaticModul('zef');
						foreach ($ids as $id_val) {
							if ($Zef->getCachedCompanyName($id_val)) $data[$id_val]=$Zef->getCachedCompanyName($id_val);
						}
						$img='rolle.gif';
					break;
					case 's':
						$noEnc=true;
						$calRes=& $frm->getStaticModul('cal_res');
						if ($tipParams['resUser']) $calRes->initUser($tipParams['resUser']);
						$numVal=FrameWork::getParam('val_'.$id,array());
						foreach ($ids as $id_val) {
							$tmpObj=$calRes->getCachedObj($id_val);
							if ($tipParams['resPerms'] && !$tmpObj->getAcl($tipParams['resPerms'])) {
								continue;
							}
							if ($tipParams['resZef'] && !$tmpObj->getMeta('calResUseZef')) {
								continue;
							}
							if ($tipParams['resCal'] && !$tmpObj->getMeta('calResUseCal')) {
								continue;
							}
							if ($tmpObj) {
								if ($tmpObj->getMeta('calResAmount')>1 && $tipParams['showAmount']) {
									$data[$id_val]='<input type="text" name="val_'.$id.'[s_'.$id_val.']" value="'.(isset($numVal['s_'.$id_val])?$numVal['s_'.$id_val]:'1').'" style="width:25px;" />';
									$data[$id_val].=FrameWork::entities($tmpObj->getName());
								} else {
									$data[$id_val]=FrameWork::entities($tmpObj->getName());
								}
								if ($tmpObj->getMeta('calResText')) $text[$id_val]=$tmpObj->getMeta('calResText');
							}
						}
						$img='rolle.gif';
					break;
					case 'a':
						$Addr=& $frm->getStaticModul('addr');
						if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
							$data=$Addr->getAddrObj($ids);
							foreach ($data as $AddrObj) {
								$img[$AddrObj->getID()]=$AddrObj->getMeta('UserID')?'l_addr_p.gif':'l_addr.gif';
							}
						} else {
							foreach ($ids as $addrID) {
								if (isset($tipParams['tempData']) && $tipParams['tempData'][$addrID]) {
									$img[$addrID]='l_addr.gif';
									$data[$addrID]=$tipParams['tempData'][$addrID];
								} else {
									$AddrObj=$Addr->getAddrObj($addrID);
									if (is_object($AddrObj)) {
										if ($tipParams['showPlace']) {
											if ($AddrObj->getMeta('POrt')) {
												$AddrObj->setMeta('Vorname',trim($AddrObj->getMeta('Vorname').' ('.$AddrObj->getMeta('POrt').')'));
											} elseif ($AddrObj->getMeta('AOrt')) {
												$AddrObj->setMeta('Vorname',trim($AddrObj->getMeta('Vorname').' ('.$AddrObj->getMeta('AOrt').')'));
											}
										}
										if ($tipParams['onlyName']) {
											$data[$AddrObj->getID()]=$AddrObj->getName(1);
										} else {
											$data[$AddrObj->getID()]=$AddrObj->getName();
										}
										$img[$AddrObj->getID()]=$AddrObj->getMeta('UserID')?'l_addr_p.gif':'l_addr.gif';
									}
								}
							}
							$Addr->updateAddrMetaVisited($ids);
							natcasesort($data);
						}
					break;
					case 'f':
						$Addr=& $frm->getStaticModul('addr');
						foreach ($ids as $ID) {
							$Obj=$Addr->getObj($ID);
							if (is_object($Obj)) {
								$data[$Obj->getID()]=implode('->',$Addr->getObjTreeNames($Obj));
								//$data[$Obj->getID()]=$Obj->getName();
								$img[$Obj->getID()]=$Obj->getImage();
							}

						}
						natcasesort($data);
					break;
					case 'm':
						$Mail=& $frm->getStaticModul('mail');
						if ($this->startMail($Mail)) {
							foreach ($ids as $mailBox) {
								$BoxObj=$Mail->getObj($mailBox,true,false);
								if (is_object($BoxObj)) {
									$data[$BoxObj->getBox()]=$Mail->trimUser($BoxObj->getBox());
									$img[$BoxObj->getBox()]=$BoxObj->getImage();
								}
							}
							//$img='obj_img/m_folder.gif';
						}
					break;
					case 'd':
						$Fmng=& $frm->getStaticModul('fmng');
						foreach ($ids as $ID) {
							$Obj=$Fmng->getObj($ID,'',false);
							if (is_object($Obj)) {
								$temp=$Fmng->getObjTree($Obj->getID());
								$data[$Obj->getID()]=implode('/',array_reverse($temp)).'/'.$Obj->getName();
								$img[$Obj->getID()]=$Obj->getImage();
							}
						}
						natcasesort($data);
					break;
					case 'x':
						$Custom=& $frm->getStaticModul('custom');
						foreach ($ids as $ID) {
							$data[$ID]=$Custom->getTtip($tipParams,$ID);
						}
						$img='rolle.gif';
					break;
				}

				if (is_array($data)) {
					foreach ($data as $dkey=>$dval) {
						$this->_t->assign('IMG_LIST',is_array($img)?$img[$dkey]:$img);
						if ($noEnc) {
							$this->_t->assign('N_LIST',is_object($dval)?$dval->process():$dval);
						} else {
							$this->_t->assign('N_LIST',Framework::entities(is_object($dval)?$dval->getName():$dval));
						}
						$this->_t->assign('K_LIST',($fmode=='p'?'g':$fmode).'_'.$dkey);
						if (isset($text[$dkey])) {
							$this->_t->assign('T_LIST',Framework::entities($text[$dkey],1));
							$this->_t->parse('ROW','field_ajax_list_row_text');
						}
						if (!$this->_disabled[$id]) $this->_t->parse('ROW','field_ajax_list_row_del');
						$this->_t->parse('ROW','.field_ajax_list_row');
						$this->_t->clear_dynamic('field_ajax_list_row_text');

						switch ($fmode) {
							case 'g':
							case 'p':
								$chk_values[]='g_'.$dkey;
							break;
							default:
								$chk_values[]=$fmode.'_'.$dkey;
							break;
						}
					
						$i++;
					}
				}
			}
		}
		$val_txt=implode('|',$chk_values);
		
		if ($i || $tipParams['useAll'] || $tipParams['useNone'] || $tipParams['useEmpty']) {
			if (!$i) {
				$this->_t->assign('IMG_LIST','rolle.gif');
				if ($tipParams['useEmpty']) {
					$this->_t->assign('N_LIST',Framework::entities($tipParams['useEmpty']));
				} elseif ($tipParams['useNone']) {
					$this->_t->assign('N_LIST',Framework::entities($this->_T->lang('[[Keine]]')));
				} else {
					$this->_t->assign('N_LIST',Framework::entities($this->_T->lang('[[Alle]]')));
				}
				$this->_t->assign('K_LIST','0');
				$this->_t->parse('ROW','.field_ajax_list_row');
			}
			if (!$this->_disabled[$id] && $i>1) $this->_t->parse('ROW','field_ajax_list_content_del');
			$this->_t->parse('ROW','field_ajax_list_content');
			if ($return) return $this->_t->getParsed();
		}
		return '';
	}
	function parseTipList($id,$search,$mode_txt,$mode_app,$params,$limit,$jsSetFunction) {
		global $frm,$P;
		$defSearchs=array(
			'_USERS',
			'_MAIL',
			'_PRULES',
			'_RRULES',
			'_GROUPS',
			'_EGROUPS',
			'_PROJECTS',
			'_ZPROJECTS',
			'_ADDRESS',
			'_RESOURCES',
		);
		$this->_t->clear_dynamic('field_ajax_ttip_row');
		$this->_t->assign('ID',$id);
		$this->_t->assign('MODE_LIST',$mode_txt);
		$this->_t->assign('PARAMS_LIST',$params);

		$mode=explode('|',$mode_txt);
		if ($params) {
			$tipParams=unserialize(base64_decode($params));
		} else {
			$tipParams=array();
		}
		if ($jsSetFunction) {
			$this->_t->assign('JS_SET_FUNCTION',$jsSetFunction);
		} else {
			$this->_t->assign('JS_SET_FUNCTION','setAjaxTip');
		}
		//debug($tipParams);
		$i=0;
		foreach ($mode as $mkey) {
			if ($limit && $i>=$limit) break;
			$data=array();
			$text=array();
			$nameOption=0;
			$showGrouped=false;
			$addStyle='';
			switch ($mkey) {
				case 'u':
					$rows=0;
					if ($mode_app) $app_users=array_keys($frm->getApplicationUsers($mode_app,0,false)); else $app_users=0;
					if ($tipParams['IgnoreUid']) {
						if ($app_users) {
							$kuid=array_search($tipParams['IgnoreUid'],$app_users);
							if ($kuid!==false) unset($app_users[$kuid]);
						} else {

						}
					}
					//$uperms=array('','deleted','system');
					switch ($search) {
						case '_USERS':
							$data=$frm->getFullName($app_users,0,$app_users?array('','system'):'');
						break;
						default:
							if (!in_array($search,$defSearchs)) {
								$data=$frm->getFullName($app_users,0,$app_users?array('','system'):'',$search,$limit);
							}
						break;
					}
					$img='user.gif';
				break;
				case 'g':
					$rows=0;
					switch ($search) {
						case '_GROUPS':
							$data=$frm->getAllGroups(0,0);
						break;
						default:
							if (!in_array($search,$defSearchs)) {
								$data=$frm->getAllGroups(0,0,$search,$limit);
							}
						break;
					}
					$img='gruppe.gif';
				break;
				case 'e':
					$rows=0;
					switch ($search) {
						case '_EGROUPS':
							foreach ($frm->listSuperGroups() as $key=>$val) {
								$data[$key]=$val['SGroupName'];
							}
						break;
						default:
							if (!in_array($search,$defSearchs)) {
								foreach ($frm->listSuperGroups($search,$limit) as $key=>$val) {
									$data[$key]=$val['SGroupName'];
								}
							}
						break;
					}
					$img='gruppe.gif';
				break;
				case 'p':
					$rows=0;
					switch ($search) {
						case '_PRULES':
							$data=$frm->getProjectRules($tipParams['prjID']);
						break;
						default:
							if (!in_array($search,$defSearchs)) {
								$data=$frm->getProjectRules($tipParams['prjID'],0,$search,$limit);
							}
						break;
					}
					$img='rolle.gif';
				break;
				case 'r':
					$rows=0;
					switch ($search) {
						case '_RRULES':
							foreach ($P->getAvRules() as $key=>$val) {
								$data[$key]=$this->_T->lang($val);
							}
						break;
						default:
							if (!in_array($search,$defSearchs)) {
								$search=preg_quote($search,'/');
								$search='/('.str_replace(' ',')|(',$search).')/i';
								foreach ($P->getAvRules() as $key=>$val) {
									if (preg_match($search,$this->_T->lang($val))) {
										$data[$key]=$this->_T->lang($val);
									}
								}
							}
						break;
					}
					$img='rolle.gif';
				break;
				case 'z':
					$Zef=& $frm->getStaticModul('zef');
					$rows=0;
					switch ($search) {
						case '_ZPROJECTS':
							$data=$Zef->listAllPrjNames(isset($tipParams['zefActiv'])?$tipParams['zefActiv']:1,isset($tipParams['zefPerms'])?$tipParams['zefPerms']:1);
							if ($P && $P->getCfg('cfg/useProfilPath') && !empty($data)) {
								$data=$P->prjList2GroupList($data,'zef');
								$showGrouped=true;
							}
						break;
						default:
							if (!in_array($search,$defSearchs)) {
								$data=$Zef->listAllPrjNames(isset($tipParams['zefActiv'])?$tipParams['zefActiv']:1,isset($tipParams['zefPerms'])?$tipParams['zefPerms']:1,$search,$limit);
								if ($P && $P->getCfg('cfg/useProfilPath') && !empty($data)) {
									$data=$P->prjList2GroupList($data,'zef');
									$showGrouped=true;
								}
							}
						break;
					}
					$img='rolle.gif';
				break;
				case 'c':
					$Zef=& $frm->getStaticModul('zef');
					$rows=0;
					switch ($search) {
						case '_ZCOMPANIES':
							$data=$Zef->listAllCompanyNames(isset($tipParams['zefActiv'])?$tipParams['zefActiv']:1);
						break;
						default:
							if (!in_array($search,$defSearchs)) {
								$data=$Zef->listAllCompanyNames(isset($tipParams['zefActiv'])?$tipParams['zefActiv']:1,0,$search,$limit);
							}
						break;
					}
					$img='rolle.gif';
				break;
				case 's':
					$calRes=& $frm->getStaticModul('cal_res',null,true);
					if ($tipParams['resUser']) $calRes->initUser($tipParams['resUser']);
					$rows=0;
					$list=array();
					switch ($search) {
						case '_RESOURCES':
							$tmpQ=array();
							if ($tipParams['resZef']) {
								$tmpQ['use_zef']=1;
							}
							if ($tipParams['resCal']) {
								$tmpQ['use_cal']=1;
							}
							$list=$calRes->listObj($tmpQ);
						break;
						default:
							if (!in_array($search,$defSearchs)) {
								$tmpQ=array('info'=>$search);
								if ($tipParams['resZef']) {
									$tmpQ['use_zef']=1;
								}
								if ($tipParams['resCal']) {
									$tmpQ['use_cal']=1;
								}
								$list=$calRes->listObj($tmpQ,0,$limit);
								//debug($data);
							}
						break;
					}
					foreach ($list as $key=>$val) {
						if (!$tipParams['resPerms'] || $val->getAcl($tipParams['resPerms'])) {
							$data[$key]=$val->getName();
							if ($val->getMeta('calResText')) $text[$key]=$val->getMeta('calResText');
						}
					}


					$img='rolle.gif';
				break;
				case 'o':
					$rows=0;
					switch ($search) {
						case '_PROJECTS':
							$data=$P->getPrjNames(isset($tipParams['onlyIDs'])?$tipParams['onlyIDs']:0,0,'',0,false,isset($tipParams['prjActiv'])?$tipParams['prjActiv']:1,isset($tipParams['prjPerms'])?$tipParams['prjPerms']:1);
							if (!empty($data)) {
								$data=$P->getPrjGroupList(array_keys($data));
								$showGrouped=true;
							}
						break;
						default:
							if (!in_array($search,$defSearchs)) {
								$data=$P->getPrjNames(isset($tipParams['onlyIDs'])?$tipParams['onlyIDs']:0,0,$search,$limit,false,isset($tipParams['prjActiv'])?$tipParams['prjActiv']:1,isset($tipParams['prjPerms'])?$tipParams['prjPerms']:1);
								if (!empty($data)) {
									$data=$P->getPrjGroupList(array_keys($data));
									$showGrouped=true;
								}
							}
						break;
					}
					$img='rolle.gif';
				break;
				case 'a':
					switch ($search) {
						case '_ADDRESS':
							$Addr=& $frm->getStaticModul('addr');
							$Addr->setLimit(100);
							if ($tipParams['searchAddr']) {
								$searchAddr=$tipParams['searchAddr'];
							} else {
								$searchAddr=array();
							}
							$searchNode=null;
							if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
								$data=array();
							} else {
								$searchAddr[]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);
								if ($Addr->getArchivCat()) {
									$searchAddr[]=array('Field'=>'Archiv','Typ'=>'=','Values'=>0);
								}
								if ($tipParams['onlyCat']) {
									if ($tipParams['onlyCatSub']) {
										//debug($tipParams['onlyCatSub']);
										$tmpCat=array_merge($tipParams['onlyCat'],$Addr->getSubNodeIDs($tipParams['onlyCat']));
									} else {
										$tmpCat=$tipParams['onlyCat'];
									}
									$searchNode=array(array('Field'=>'FKNodeID','Typ'=>'=','Values'=>$tmpCat));
								}
								if ($tipParams['onlyName']) {
									$nameOption=1;
									$searchAddrSub=array();
									$searchAddrSub[]=array(array('Field'=>'Nachname','Typ'=>'!=','Values'=>''));
									if ($Addr->getFieldData('MaidenName')) $searchAddrSub[]=array(array('Field'=>'MaidenName','Typ'=>'!=','Values'=>''));
									$searchAddr[]=array('Typ'=>'OR','Values'=>$searchAddrSub);
									$sort=array('Nachname'=>1,'Vorname'=>1);
								} else {
									$sort=array('Name'=>1);
								}
								$data=$Addr->searchAddr(0,$sort,$searchAddr,$searchNode,null,null,false,true,array('AOrt','POrt'));
							}
							$unique=array();
							foreach ($data as $dkey=>$dval) {
								$unique[$dval->getName()][]=$dkey;
							}
							foreach ($unique as $dval) {
								if (count($dval)>1 || $tipParams['showPlace']) {
									foreach ($dval as $dkey) {
										if ($data[$dkey]->getMeta('POrt')) {
											$data[$dkey]->setMeta('Vorname',trim($data[$dkey]->getMeta('Vorname').' ('.$data[$dkey]->getMeta('POrt').')'));
										} elseif ($data[$dkey]->getMeta('AOrt')) {
											$data[$dkey]->setMeta('Vorname',trim($data[$dkey]->getMeta('Vorname').' ('.$data[$dkey]->getMeta('AOrt').')'));
										}
									}
								}
							}
						break;
						default:
							if (!in_array($search,$defSearchs)) {
								$Addr=& $frm->getStaticModul('addr');
								$Addr->setLimit($limit);
								if ($tipParams['searchAddr']) {
									$searchAddr=$tipParams['searchAddr'];
								} else {
									$searchAddr=array();
								}
								$searchNode=null;
								if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
									$searchAddr['info']=$search;
									$searchAddr['searchSub']=1;
									$data=$Addr->searchAddr(0,array('Name'=>1),$searchAddr);
								} else {
									$searchAddr[]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);
									if ($tipParams['simpleSearch']) {
										$concatFields=array('Name');
									} elseif ($tipParams['onlyNameSearch']) {
										$concatFields=array('Nachname','Vorname');
										if ($Addr->getFieldData('MaidenName')) $concatFields[]='MaidenName';
									} else {
										$concatFields=$Addr->getSearchFields();
									}
									$searchAddr[]=array('Field'=>$concatFields,'Typ'=>'concat','Values'=>$search,'UseCase'=>0,'OnlyWords'=>0);
									if ($Addr->getArchivCat()) {
										$searchAddr[]=array('Field'=>'Archiv','Typ'=>'=','Values'=>0);
									}
									if ($tipParams['onlyCat']) {
										if ($tipParams['onlyCatSub']) {
											$tmpCat=array_merge($tipParams['onlyCat'],$Addr->getSubNodeIDs($tipParams['onlyCat']));
										} else {
											$tmpCat=$tipParams['onlyCat'];
										}
										$searchNode=array(array('Field'=>'FKNodeID','Typ'=>'=','Values'=>$tmpCat));
									}
									if ($tipParams['onlyName']) {
										$nameOption=1;
										$searchAddrSub=array();
										$searchAddrSub[]=array(array('Field'=>'Nachname','Typ'=>'!=','Values'=>''));
										if ($Addr->getFieldData('MaidenName')) $searchAddrSub[]=array(array('Field'=>'MaidenName','Typ'=>'!=','Values'=>''));
										$searchAddr[]=array('Typ'=>'OR','Values'=>$searchAddrSub);
										$sort=array('Nachname'=>1,'Vorname'=>1);
									} else {
										$sort=array('Name'=>1);
									}
									$data=$Addr->searchAddr(0,$sort,$searchAddr,$searchNode,null,null,false,true,array('AOrt','POrt'));
								}
								$unique=array();
								if (is_array($data)) {
									foreach ($data as $dkey=>$dval) {
										$unique[$dval->getName()][]=$dkey;
									}
								}
								foreach ($unique as $dval) {
									if (count($dval)>1 || $tipParams['showPlace']) {
										foreach ($dval as $dkey) {
											if ($data[$dkey]->getMeta('POrt')) {
												$data[$dkey]->setMeta('Vorname',trim($data[$dkey]->getMeta('Vorname').' ('.$data[$dkey]->getMeta('POrt').')'));
											} elseif ($data[$dkey]->getMeta('AOrt')) {
												$data[$dkey]->setMeta('Vorname',trim($data[$dkey]->getMeta('Vorname').' ('.$data[$dkey]->getMeta('AOrt').')'));
											}
										}
									}
								}
							}
						break;
					}
					$img='l_addr.gif';
				break;
				case 'f':
					$Addr=& $frm->getStaticModul('addr');
					switch ($search) {
						default:
							if (!in_array($search,$defSearchs)) {
								if (isset($tipParams['AddrServers']) && !empty($tipParams['AddrServers'])) {
									$data=$Addr->searchFolders($tipParams['AddrServers'],array('info'=>$search),$limit,true);
								} else {
									$data=$Addr->searchFolders(null,array('info'=>$search),$limit,true);
								}
							}
							//$data=Framework::extractObjMeta($tmp_data,'Box');
						break;
					}
					$img='rolle.gif';
				break;
				case 'm':
					$Mail=& $frm->getStaticModul('mail');
					if ($this->startMail($Mail)) {
						switch ($search) {
							default:
								if (!in_array($search,$defSearchs)) {
									$data=$Mail->searchFolders('*',$search,$tipParams['skipBox'],$limit,true);

								}
								//$data=Framework::extractObjMeta($tmp_data,'Box');
							break;
						}
					}
					$img='rolle.gif';
				break;
				case 'd':
					$Fmng=& $frm->getStaticModul('fmng');
					switch ($search) {
						default:
							if (!in_array($search,$defSearchs)) {
								$searchQuery=array();
								$searchQuery[]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);
								$searchQuery[]=array('Field'=>'DocType','Typ'=>'=','Values'=>'ext');
								$searchQuery[]=array('Field'=>array("Title_".$frm->getLang()),'Typ'=>'concat','Values'=>$search);
								$rows=0;
								$tmpData=$Fmng->searchObj($rows,0,$limit,$searchQuery,'Title_'.$frm->getLang(),'ASC');
								foreach ($tmpData as $dkey=>$dval) {
									$temp=$Fmng->getObjTree($dkey);
									$data[$dkey]=implode('/',array_reverse($temp)).'/'.$dval->getName();
									$img[$dkey]=$dval->getImage();
								}
								$addStyle='min-height:20px;padding-left:20px;';
							}
							//$data=Framework::extractObjMeta($tmp_data,'Box');
						break;
					}
				break;
				case 'x':
					$Custom=& $frm->getStaticModul('custom');
					switch ($search) {
						default:
							$data=$Custom->searchTtip($tipParams,$search,$limit);
							//$data=Framework::extractObjMeta($tmp_data,'Box');
						break;
					}
					$img='rolle.gif';
				break;

			}
			if (is_array($data)) {
				$this->_t->assign('ADD_STYLE',$addStyle);
				if ($showGrouped) {
					if (is_array($data[0])) {
						foreach ($data[0] as $dkey=>$dval) {
							//debug($dval);
							if ($mkey=='a' && is_object($dval) && $dval->getMeta('UserID')) {
								$this->_t->assign('IMG_LIST','l_addr_p.gif');
							} else {
								$this->_t->assign('IMG_LIST',is_array($img)?$img[$dkey]:$img);
							}
							$this->_t->assign('N_LIST',Framework::entities(is_object($dval)?$dval->getName($nameOption):$dval));
							$this->_t->assign('K_LIST',($mkey=='p'?'g':$mkey).'_'.$dkey);
							if (isset($text[$dkey])) {
								$this->_t->assign('T_LIST',Framework::entities($text[$dkey],1));
								$this->_t->parse('ROW','field_ajax_ttip_row_text');
							}
							$this->_t->parse('ROW','.field_ajax_ttip_row');
							$this->_t->clear_dynamic('field_ajax_ttip_row_text');
							$i++;
							if ($limit && $i>=$limit) break;
						}
					}
					$clear='';
					foreach ($data as $group=>$sub_data) {
						if (!$group) continue;
						if ($this->_t->issetHandle('field_ajax_ttip_row_title')) {
							$this->_t->assign('N_TITLE',Framework::entities($group));
							$this->_t->parse('ROW','field_ajax_ttip_row_title');
							$clear='field_ajax_ttip_row_title';
						}
						foreach ($sub_data as $dkey=>$dval) {
							//debug($dval);
							if ($mkey=='a' && is_object($dval) && $dval->getMeta('UserID')) {
								$this->_t->assign('IMG_LIST','l_addr_p.gif');
							} else {
								$this->_t->assign('IMG_LIST',is_array($img)?$img[$dkey]:$img);
							}
							$this->_t->assign('N_LIST',Framework::entities(is_object($dval)?$dval->getName($nameOption):$dval));
							$this->_t->assign('K_LIST',($mkey=='p'?'g':$mkey).'_'.$dkey);
							if (isset($text[$dkey])) {
								$this->_t->assign('T_LIST',Framework::entities($text[$dkey],1));
								$this->_t->parse('ROW','field_ajax_ttip_row_text');
							}
							$this->_t->parse('ROW','.field_ajax_ttip_row');
							$this->_t->clear_dynamic('field_ajax_ttip_row_text');
							if ($clear) {
								$this->_t->clear_dynamic($clear);
								$clear='';
							}

							$i++;
							if ($limit && $i>=$limit) break;
						}
					}

				} else {
					foreach ($data as $dkey=>$dval) {
						//debug($dval);
						if ($mkey=='a' && is_object($dval) && $dval->getMeta('UserID')) {
							$this->_t->assign('IMG_LIST','l_addr_p.gif');
						} else {
							$this->_t->assign('IMG_LIST',is_array($img)?$img[$dkey]:$img);
						}
						$this->_t->assign('N_LIST',Framework::entities(is_object($dval)?$dval->getName($nameOption):$dval));
						$this->_t->assign('K_LIST',($mkey=='p'?'g':$mkey).'_'.$dkey);
						if (isset($text[$dkey])) {
							$this->_t->assign('T_LIST',Framework::entities($text[$dkey],1));
							$this->_t->parse('ROW','field_ajax_ttip_row_text');
						}

						$this->_t->parse('ROW','.field_ajax_ttip_row');
						$this->_t->clear_dynamic('field_ajax_ttip_row_text');
						$i++;
						if ($limit && $i>=$limit) break;
					}
				}
			}
		}
		if ($i) return $this->_t->getParsed(); else return '';
	}
	function startMail(&$Mail) {
		global $auth,$frm;
		if ($GLOBALS['MACC_ID'] && $GLOBALS['MACC_ID']!=$auth->auth['uid']) {
			$tmp=$frm->read_user($GLOBALS['MACC_ID']);
			if ($tmp) {
				$username=$tmp['username'];
				$password=$tmp['password'];
				$user_id=$GLOBALS['MACC_ID'];
			} else {
				$GLOBALS['MACC_ID']=0;
			}
		}
		if (!$GLOBALS['MACC_ID'] || $GLOBALS['MACC_ID']==$auth->auth['uid'] ) {
			$username=$auth->auth['uname'];
			$password=$auth->auth['password'];
			$user_id=$auth->auth['uid'];
		}
		//debug($auth->auth['uname']);
		$Mail->setUser($user_id);
		$Mail->setUserName($username);
		$Mail->setPassword($password);
		if ($Mail->open()) {
			return true;
		}
		return false;
	}
}
?>