<?php
require_once('lib/smarty/Smarty.class.php');
class MySmartyGui extends Smarty {
	function MySmartyGui() {
		global $T,$frm;
		$this->_T=&$T;
		$this->_frm=&$frm;

		$this->Smarty();
		$this->template_dir=realpath('tpl/ge');
		if ($GLOBALS['MASTER_TPL']) $this->template_dir=realpath($GLOBALS['MASTER_TPL']).'/tpl/ge';
		$dynPath=GE_DYN_PATH.'/'.GE_DOMAIN_PATH;
		if (!file_exists($dynPath)) {
			mkdir($dynPath,0700);
		}
		if (!file_exists($dynPath."smarty")) {
			mkdir($dynPath."smarty",0700);
		}
		$this->compile_dir=realpath($dynPath."smarty");
		$this->register_prefilter(array($this,"myPrefilter"));
		$this->register_modifier("user_format",array(&$this,'myFormatUser'));
		$this->register_modifier("time_format",array(&$this,'myFormatTime'));
		$this->register_modifier("array_sort",array(&$this,'myArraySort'));
		$this->register_modifier("number_format",array('Framework','numberFormat'));
		$this->register_modifier("implode_object",array(&$this,'myImplodeObject'));

		$this->secure_dir=array($this->template_dir,realpath($dynPath));
		$this->security_settings  = array(
			'PHP_HANDLING'    => false,
			'IF_FUNCS'        => array('array', 'list',
										'isset', 'empty',
										'count', 'sizeof',
										'in_array', 'is_array',
										'true', 'false', 'null', 'date'),
			'INCLUDE_ANY'     => false,
			'PHP_TAGS'        => false,
			'MODIFIER_FUNCS'  => array('count','implode','substr','array_reverse','trim',),
			'ALLOW_CONSTANTS'  => false
		);
		$this->security = true;
		$this->assign('CHARSET',GE_CHARSET);
		$this->assign('VERSION',GE_VERSION);
	}
	function fetch($_smarty_tpl_file, $_smarty_cache_id = null, $_smarty_compile_id = null, $_smarty_display = false) {
		// We need to set the cache id and the compile id so a new script will be
		// compiled for each language. This makes things really fast ;-)
		$_smarty_compile_id = $this->_T->getLang().'-'.$_smarty_compile_id;
		$_smarty_cache_id = $_smarty_compile_id;
		// Now call parent method
		return parent::fetch( $_smarty_tpl_file, $_smarty_cache_id, $_smarty_compile_id, $_smarty_display );
    }
	function is_cached($tpl_file, $cache_id = null, $compile_id = null) {
		if (!$this->caching) {
			return false;
		}
		if (!isset($compile_id)) {
			$compile_id = $this->_T->getLang().'-'.$this->compile_id;
			$cache_id = $compile_id;
		}
		return parent::is_cached($tpl_file, $cache_id, $compile_id);
	}
	function myFormatUser($value,$field) {
		if (!isset($this->_myCachedUser[$value])) {
			$this->_myCachedUser[$value]=$this->_frm->read_user($value);
		}
		return isset($this->_myCachedUser[$value][$field])?$this->_myCachedUser[$value][$field]:0;
	}
	function myImplodeObject($value,$implode=', ',$field='') {
		if (is_array($value)) {
			if ($field) {
				$result=implode($implode,Framework::extractObjMeta($value,$field));
			} else {
				$result=implode($implode,Framework::extractObjName($value));
			}
		} else {
			$result='';
		}
		return $result;
	}
	function myFormatTime($value,$format) {
		$result=$format;
		$result=str_replace('%H',sprintf('%02d',$value/3600),$result);
		$result=str_replace('%M',sprintf('%02d',abs(($value%3600)/60)),$result);
		$result=str_replace('%S',sprintf('%02d',($value%3600)%60),$result);
		return $result;
	}
	function myArraySort($value,$format) {
		$this->_sort=array();
		//debug($value);
		if ($format) {
			$tmpSort=explode(',',$format);
			foreach ($tmpSort as $val) {
				$tmp=explode(':',$val);
				$this->_sort[]=explode(':',$val);
			}
		}
		uasort($value,array(&$this, '_sortArray'));
		return $value;
	}
	function _sortArray($a,$b) {
		foreach ($this->_sort as $sort) {
			$ID=$sort[0];
			$DIR=$sort[1]=='DESC'?array(-1,1):array(1,-1);
			if (is_string($a) || is_string($b)) {
				$res=strnatcasecmp($a[$ID],$b[$ID]);
			} else {
				$res=($a[$ID]==$b[$ID]?0:($a[$ID]<$b[$ID]?-1:1));
			}
			if ($res>0) return $DIR[0];
			if ($res<0) return $DIR[1];
		}
		return 0;
	}
	function myPrefilter($tpl_source, &$smarty) {
		return $this->_T->replaceString($tpl_source);
	}
    function display($resource_name, $cache_id = null, $compile_id = null)    {
		header('Content-Type: text/html; charset='.strtolower(GE_CHARSET));
		parent::display($resource_name, $cache_id, $compile_id);
    }
}
?>