<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class ObjTree {
	var $_class=array('it_n','it_s','it_p');
	var $_func_entity=array('Framework','entities');
	var $_func_name;
	var	$_maxlen=30;
	var $_minlen=5;
	var	$_img_split='tree_split.gif';
	var	$_img_split_ex='tree_split_ex.gif';
	var	$_img_split_co='tree_split_co.gif';
	var	$_img_end='tree_end.gif';
	var	$_img_end_ex='tree_end_ex.gif';
	var	$_img_end_co='tree_end_co.gif';
	var	$_img_line='tree_vertline.gif';
	function ObjTree() {

	}
	function setSplitImages($img_split,$img_split_ex,$img_split_co) {
		$this->_img_split=$img_split;
		$this->_img_split_ex=$img_split_ex;
		$this->_img_split_co=$img_split_co;

	}
	function setEndImages($img_end,$img_end_ex,$img_end_co) {
		$this->_img_end=$img_end;
		$this->_img_end_ex=$img_end_ex;
		$this->_img_end_co=$img_end_co;

	}
	function setLineImages($img_line) {
		$this->_img_line=$img_line;
	}
	function setExpand(&$expand) {
		$this->_expand=&$expand;
	}
	function setTree(&$tree) {
		$this->_tree=&$tree;
	}
	function setExLink($ex_link,$mode='l') {
		$this->_ex_link=$ex_link;
		$this->_ex_link_mode=$mode;
	}
	function setAcLink($ac_link) {
		$this->_ac_link=$ac_link;
	}
	function setImgPath($img_path) {
		$this->_img_path=$img_path;
	}
	function setColors($bgcolor,$fg10color) {
		$this->_bgcolor=$bgcolor;
		$this->_fgcolor=$fgcolor;
	}
	function setClass($class,$class_sel) {
		$this->_class[0]=$class;
		$this->_class[1]=$class_sel;
	}
	function setSelectedID($oid) {
		if (!is_array($oid)) {
			$this->_oid=array($oid);
		} else {
			$this->_oid=$oid;
		}
	}
	function getSelectedID() {
		return $this->_oid;
	}
	function setRootID($root_id) {
		$this->_root_id=$root_id;
	}
	function setModul($modul) {
		$this->_modul=$modul;
	}
	function setEntityFunc($func) {
		$this->_func_entity=$func;
	}
	function setNameFunc($func) {
		$this->_func_name=$func;
	}
	function setMaxLen($len) {
		$this->_maxlen=$len;
	}
	function setCheckBox(&$ChkObj,$enablePath=false) {
		$this->_chkobj=$ChkObj;
		$this->_chkEnablePath=$enablePath;
	}
	function parseTree($prev=0,$start=true) {
		if ($start) $this->_depth=0;
		$i=1;
		if (is_array($this->_tree[$prev])) {
			$dplen=$this->_maxlen - $this->_depth*2;
			if ($dplen<$this->_minlen) $dplen=$this->_minlen;

			if (isset($this->_expand[$prev])) {
				$style='style="clear:both;"';
			} else {
				$style='style="clear:both;display:none;"';
			}
			$nav="<table width=\"100%\" bgcolor=\"".$this->_bgcolor."\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\" id=\"nav$prev\" $style>\n";
			$len=count($this->_tree[$prev]);
			foreach ($this->_tree[$prev] as $obj) {
				$ID=$obj->getID();
				$JID=trim($ID);
				if ($this->_func_name) {
					$Title=call_user_func($this->_func_name,$obj);//$this->_func_entity;
				} else {
					$Title=$obj->getName();
				}
				$tTitle=$Title;
				if ($this->_maxlen) {
					$Title=Framework::wordSplit($Title,$dplen);
				}
				if ($this->_func_entity) {
					$Title=call_user_func($this->_func_entity,$Title);//$this->_func_entity;
					//$Title=($Title);
					//$Title=$func($Title);
				}

				if (isset($this->_tree[$ID])) {
					if (isset($this->_expand[$ID])) {
						if ($len==$i) $img=$this->_img_end_co; else $img=$this->_img_split_co;
					} else {
						if ($len==$i) $img=$this->_img_end_ex; else $img=$this->_img_split_ex;
					}

				} else {
					if ($len==$i) {
						$img=$this->_img_end;
					} else {
						$img=$this->_img_split;
					}
				}
				if (in_array($ID,$this->_oid)) {
					$class=$this->_class[1];
				} else {
					$class=$this->_class[0];
				}
				//echo $class.'<br>';
				//unset ($img[0]);
				if ($this->_ac_link) {
					$link=str_replace('{ACTION}',$obj->getAction(0),$this->_ac_link);
					$link=str_replace('{OID}',urlencode($ID),$link);
					if ($obj->getACL(2)) {
						$link_d=str_replace('{ACTION}',$obj->getAction(1),$this->_ac_link);
						$link_d=str_replace('{OID}',urlencode($ID),$link_d);
					} else {
						$link_d="#";
					}
				}
				$chkdiv="";
				if (is_object($this->_chkobj)) {
					if ($obj->getACL(2)) {
						$chkdiv="<div class=\"$class\" id=\"c_$JID\" align=\"right\">".$this->_chkobj->f($ID)."</div>";
					}
				}
				$js_fc="id=\"l:$JID\" nC=\"$class\" oC=\"it_s\" onmouseover=\"setClass('l:$JID', 'over');\" onmouseout=\"setClass('l:$JID', 'out');\"";
				$nav.="<tr>\n";
				$nav.="<td width=\"14\" valign=\"top\"";
				if (isset($this->_tree[$ID])) {
					if ($len==$i) {
						$nav.=">";
					} else {
						$nav.=" background=\"".$this->_img_path.'/'.$this->_img_line."\">";
					}
					if ($this->_chkEnablePath) {
						$onClick="return toggle('$JID','".$this->_modul."','".$this->_root_id."',event,1);";
					} else {
						$onClick="return toggle('$JID','".$this->_modul."','".$this->_root_id."',event);";
					}
					if ($this->_ex_link_mode=='f') {
						$nav.="<input type=\"image\" name=\"".str_replace('{OID}',$ID,$this->_ex_link)."\" onClick=\"$onClick\" src=\"".$this->_img_path.'/'.$img."\" border=\"0\" id=\"i1_$JID\">";
					} else {
						$nav.="<a href=\"".str_replace('{OID}',urlencode($ID),$this->_ex_link)."\" onDblClick=\"return false;\" onClick=\"return false;\" onMouseUp=\"$onClick\"><img src=\"".$this->_img_path.'/'.$img."\" border=\"0\" id=\"i1_$JID\"></a>";
					}
					$nav.="</td>\n";
					$nav.="<td><div class=\"$class\" style=\"float:left\" $js_fc>";
					if ($link_d) $nav.="<a href=\"$link_d\">";
					$nav.="<img src=\"".$this->_img_path.'/'.$obj->getImage(isset($this->_expand[$ID]) && isset($this->_tree[$ID]),1)."\" class=\"nav\" id=\"i2_$JID\">";
					if ($link_d) $nav.="</a>";
					if ($link) {
						$nav.="<a href=\"$link\" class=\"$class\" title=\"".htmlspecialchars($tTitle)."\">".$Title."</a>";
					} else {
						$nav.="<span class=\"$class\" title=\"".htmlspecialchars($tTitle)."\">".$Title."</span>";
					}
					$nav.="</div>\n";
					if ($chkdiv) $nav.=$chkdiv;
				} else {
					$nav.="><img src=\"".$this->_img_path.'/'.$img."\"></td>\n";
					$nav.="<td><div class=\"$class\" style=\"float:left\" $js_fc>";
					if ($link_d) $nav.="<a href=\"$link_d\">";
					$nav.="<img src=\"".$this->_img_path.'/'.$obj->getImage(isset($this->_expand[$ID]) && isset($this->_tree[$ID]),1)."\" class=\"nav\">";
					if ($link_d) $nav.="</a>";
					if ($link) {
						$nav.="<a href=\"$link\" class=\"$class\" title=\"".htmlspecialchars($tTitle)."\">".$Title."</a>";
					} else {
						$nav.="<span class=\"$class\" title=\"".htmlspecialchars($tTitle)."\">".$Title."</span>";
					}
					$nav.="</div>\n";
					if ($chkdiv) $nav.=$chkdiv;
				}
				if (isset($this->_tree[$ID])) {
					$this->_depth++;
					$nav.=$this->parseTree($ID,false);
					$this->_depth--;
				}
				$nav.="</td>\n";
				$nav.="</tr>\n";
				$i++;
			}
			$nav.="</table>\n";
		}
		return $nav;
	}
}
