<?php
class OpenOffice {
	var $_t;
	var $_dir='';
	var $_tplFile='';
	var $_charset=GE_CHARSET;
	var $_textStyle='Standard';
	function OpenOffice($tplFile,$charset=GE_CHARSET) {
		$this->_charset=$charset;
		$this->_t=new mtFastTemplate ('./');
		$this->_t->setRoot('./');
		if (file_exists($tplFile)) {
			$this->_tplFile=$tplFile;
			$exec="unzip -p ".escapeshellarg($this->_tplFile)." content.xml";
			$text=array();
			exec($exec,$text);
			$this->_t->parse_internal ('templateContent',implode('',$text));
		}
	}
	function setTextStyle($s) {
		$this->_textStyle=$s;
	}
	function assign($key,$val,$params=null,$useTags=false) {
		if (is_array($val)) {
			$this->_t->assign($key,$this->encode(call_user_func_array($val,$params),is_array($useTags)?$useTags:array()));
		} elseif (is_object($val)) {
			$this->_t->assign($key,$this->encode($val->process($params),$useTags));
		} else {
			$this->_t->assign($key,$this->encode($val,$useTags));
		}
	}
	function encode($str,$useTags=false) {
		$str=Framework::convertCharset($str,$this->_charset,'UTF-8');
		if ($useTags) {
			$str=$this->encodeTag($str);
		} else {
			$str=htmlspecialchars($str,ENT_QUOTES);
			$str=str_replace("\n",'</text:p><text:p text:style-name="'.$this->_textStyle.'">',$str);
		}
		//$str=str_replace("\n",'</text:p><text:p text:style-name="'.$this->_textStyle.'">',$str);
		return $str;
	}

	function encodeTag($text) {

		//debug(htmlspecialchars($text));
		$_allowed_o_tags=array(
			/*'bi'=>array(
				'rep'=>array('<b><i>','</i></b>'),
				'tag'=>array(array('span','FettKursiv')),
			),
			'ib'=>array(
				'rep'=>array('<i><b>','</b></i>'),
				'tag'=>array(array('span','FettKursiv')),
				'inline'=>true,
			),*/
			'b'=>array(
				'rep'=>array('<b>','</b>'),
				'tag'=>array(array('span','Fett')),
			),
			'i'=>array(
				'rep'=>array('<i>','</i>'),
				'tag'=>array(array('span','Kursiv')),
			),
			'ul'=>array(
				'rep'=>array('<ul>','</ul>'),
				'tag'=>array(array('list','L1')),
			),
			'li'=>array(
				'rep'=>array('<li>','</li>'),
				'tag'=>array(array('list-item',''),array('p',$this->_textStyle)),
			),
			'div'=>array(
				'rep'=>array('<div>','</div>'),
				'tag'=>array(array('p',$this->_textStyle)),
			),
		);
		$text=substr(str_replace("\n","",$text),5,-6);

		foreach ($_allowed_o_tags as $key=>$val) {
			$tag=$this->getTag($val['tag'],$val['inline']);
			$text=str_replace($val['rep'][0],$tag[0],$text);
			$text=str_replace($val['rep'][1],$tag[1],$text);
		}
		//echo htmlspecialchars($text);

		//debug(htmlspecialchars($text));
		/*<text:span xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" text:style-name="T1" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" >fett</text:span>
		<text:span xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" text:style-name="T2" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" >kursiv</text:span>
		<text:span xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" text:style-name="T3" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" >underline</text:span>
		<text:list xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" text:style-name="L1" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" >
			<text:list-item xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0">
			<text:p xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" text:style-name="P1" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" >liste1</text:p>
			</text:list-item>
		</text:list>*/
		return $text;
   	}
   	function getTag($tagCfg) {
		$bTag=$eTag='';
		foreach ($tagCfg as $tag) {
			$tmp=$this->_getTag($tag[0],$tag[1]);
			$bTag.=$tmp[0];
			$eTag=$tmp[1].$eTag;
		}
		return array(
			$bTag,
			$eTag,
		);
   	}
   	function _getTag($name,$style) {
		$bTag='';
		$bTag.='<text:'.$name;
		if ($style) $bTag.=' text:style-name="'.$style.'"';
		$bTag.=' >';

		$eTag='</text:'.$name.'>';
		return array(
			$bTag,
			$eTag,
		);
   	}




	function parse($key,$val) {
		$this->_t->parse($key,$val);
		//debug(htmlspecialchars($this->_t->getParsed()));
	}
	function clear_dynamic($key) {
		$this->_t->clear_dynamic($key);
	}
	function issetkey($key) {
		return $this->_t->issetkey($key);
	}
	function process($outFile) {
		$workingDir=dirname($outFile);
		$zipDir=$outFile.'.zip';
		Framework::deleteFilesRecursive($zipDir,'/.*/',array(),true);
		if (file_exists($outFile)) unlink($outFile);
		mkdir($zipDir,0755);
		//debug($zipDir);
		$exec="unzip ".escapeshellarg($this->_tplFile)." -d ".escapeshellarg($zipDir);
		exec($exec);

		$this->_t->parse('TPL_TEMP','templateContent',false);
		//debug(htmlspecialchars($this->_t->getParsed()));
		$fp=fopen($zipDir.'/content.xml','w+');
		fwrite($fp,$this->_t->getParsed());
		fclose($fp);

		$meta=implode('',file($zipDir.'/meta.xml'));
		$meta=preg_replace('/'.preg_quote('<dc:date>','/').'[^>]*'.preg_quote('</dc:date>','/').'/','<dc:date>'.date('Y-m-d\TH:i:s').'</dc:date>',$meta);
		$fp=fopen($zipDir.'/meta.xml','w+');
		fwrite($fp,$meta);
		fclose($fp);



		$oldDir=getcwd();
		chdir($zipDir);
		$exec="zip -r ".escapeshellarg('../'.basename($outFile))." *";
		exec($exec);
		chdir($oldDir);
		Framework::deleteFilesRecursive($zipDir,'/.*/',array(),true);
		if (file_Exists($outFile)) {
			return true;
		}
		return false;
	}
	function convert($fromFile,$toFile) {

		$fp = @fsockopen("localhost", 8100, $errno, $errstr,1);
		if (!$fp) {
			/*socket von hand starten mit PHP hngt der Prozess"
			/*$exec='/usr/lib/openoffice/program/soffice -headless -nologo -norestore -nofirststartwizard "-accept=socket,host=127.0.0.1,port=8100;urp;"';
			//$exec="add-on/jod/oo_start.sh";
			exec($exec);*/
			$this->_error="Openoffice socket is not running";
			return false;


		}
		$result=array();
		$exec="java -jar add-on/jod/jodconverter-cli-2.2.1.jar ".escapeshellarg($fromFile)." ".escapeshellarg($toFile);
		exec($exec,$result);
		return true;
		//debug($exec);
	}
	function getError() {
		return $this->_error;
	}
}
?>