<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class FrameWork extends GroupieUser {
	var $db;
	var $uid;
	var $lang='en';
	var $_style_sheet='style.css';
	var $_onLoad='';
	var $_useFrame=false;
	var $_onUnLoad='';
	var $_ModulObj=array();
	var $_ModulGuiObj=array();
	var $_avApps=array();
	var $_jscript=array();
	var $_cscript=array();
	var $_script=array(
		'c'=>array(),
		'h'=>array(),
	);
	var $_required_files=array();
	var $_allowedGroups=array(
	);
	var $_allowedUsers=array(

	);
	var $_mySuperGroups=array(

	);
	var $_initExtJs=false;
	function FrameWork() {
		parent::GroupieUser();
	}
	function setDB(&$db) {
		if ($GLOBALS['CFG']['USER_CLASS']!='ldap_full') {
			//Neues DB-Objekt da es sonst zu konflikten kommen kann
			$this->db=new GroupieDB('');
			if (!defined('GE_CHARSET')) define('GE_CHARSET','UTF-8');
			if (GE_CHARSET=='UTF-8') {
				$this->db->query("SET NAMES 'utf8'");
			} else {
				$this->db->query("SET NAMES 'latin1'");
			}
		} else {
			$this->db=&$db;
		}
	}
	function setUser($uid) {
		$this->uid=$uid;
		if (defined('GE_SUPER_GROUPS_ENABLED') && GE_SUPER_GROUPS_ENABLED) {
			$mySuperGroups=$this->getMySuperGroups();
			if (!empty($mySuperGroups)) {
				$this->_allowedGroups=$this->supergroup2Members($mySuperGroups);
				if (!empty($this->_allowedGroups)) {
					$this->_allowedUsers=array_values($this->getGroupUsers($this->_allowedGroups));
				} else {
					$this->_allowedGroups=array(-1);
					$this->_allowedUsers=array($this->uid);
				}
			}
		}
		//debug($this->_allowedGroups);
	}
	function getUser() {
		return $this->uid;
	}
	function setLang($lang) {
		$this->lang=$lang;
	}
	function getLang() {
		return $this->lang;
	}
	function useFrame($set=null) {
		if (isset($set)) $this->_useFrame=$set;
		return $this->_useFrame;
	}
	function getSelfDir($abs=false) {
		$result='';
		if ($abs) {
			$result.=$_SERVER['HTTPS']=='on'?'https://':'http://';
			$result.=$_SERVER['SERVER_NAME'];
		}
		$result.=(dirname($_SERVER['PHP_SELF'])!='/'?dirname($_SERVER['PHP_SELF']):'');
		return $result;
	}
	function setFrmCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}
		}
	}
	function getFrmCfg($key) {
		if (isset($this->_cfg[$key])) {
			return $this->_cfg[$key];
		} else {
			return false;
		}
	}
	function setMyApps($app) {
		$this->_my_apps=$app;
	}
	function getMyApps($app=null) {
		//debug($this->_my_apps);
		if ($app) return (isset($this->_my_apps[$app])?$this->_my_apps[$app]:false); else $this->_my_apps;
	}
	function checkConfigPassword($pwd) {
		$cfg=$this->getCfg('global',0,'cfg/pwd');
		if (md5($pwd)==$cfg['cfg/pwd']) {
			return true;
		} else {
			return false;
		}
	}
	function delete_user($uid) {
		$this->deleteHotList(0,0,$uid);
		$this->deleteUserApps($uid);
		$this->deleteRuleUser(0,$uid);
		$this->deleteObjColor(0,0,$uid);
		$this->db->query("DELETE FROM UserPrefs WHERE FKUserID=".$this->db->escape($uid));
		$this->db->query("DELETE FROM ACL where Typ='user' AND ID=".$this->db->escape($uid));
		return $uid;
	}
	function deleteGroup($uid) {
		$this->deleteGroupApps($uid);
	}
	function deleteUserApps($uid) {
		$this->db->query("DELETE FROM grant_user_application WHERE user_id=".$this->db->escape($uid));
	}
	function insertUserApps($uid,$user_apps) {
		foreach ($user_apps as $val) {
			$this->db->insert('grant_user_application',array('user_id'=>$uid,'app_id'=>$val));
		}
	}
	function deleteGroupApps($uid) {
		$this->db->query("DELETE FROM grant_groups_application WHERE group_id=".$this->db->escape($uid));
	}
	function insertGroupApps($uid,$user_apps) {
		foreach ($user_apps as $val) {
			$this->db->insert('grant_groups_application',array('group_id'=>$uid,'app_id'=>$val));
		}
	}
	function getApplication($perms=0,$parent=-1,$use_enabled=1) {
		$result=array();
		$where=array();
		if (is_array($perms)) {
			$where[]=" app_name IN (".implode(",",$this->db->escape($perms)).")";
		} elseif ($perms) {
			$where[]=" app_name=".$this->db->escape($perms)."";
		}
		if ($parent!=-1) {
			$where[]=" app_parent=".$this->db->escape($parent)."";
		}
		if ($use_enabled) {
			$where[]=" app_enabled='1'";
		}
		$query="SELECT app_id,app_name,app_url,app_order,app_enabled,app_title_".$this->lang." as app_title FROM application ";
		if (!empty($where))  $query.="WHERE ".implode(' AND ',$where);
		$query.=" ORDER BY app_order ";
		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[$this->db->f('app_name')]=array(
				'id'=>$this->db->f('app_id'),
				'url'=>$this->db->f('app_url'),
				'order'=>$this->db->f('app_order'),
				'title'=>$this->db->f('app_title'),
				'enabled'=>$this->db->f('app_enabled'),
			);

		}
		return $result;
	}
	function appExists($app) {
		if (!isset($this->_avApps[$app])) {
			$search=array(
				array('Field'=>'app_enabled','Typ'=>'=','Values'=>1),
				array('Field'=>'app_name','Typ'=>'=','Values'=>$app),
			);
			$query="SELECT app_id FROM application WHERE ".$this->db->getWhere($search);
			$this->db->query($query);
			if ($this->db->next_record()) {
				$this->_avApps[$app]=1;
			} else {
				$this->_avApps[$app]=0;
			}
		}
		return $this->_avApps[$app];
	}
	function getAppName($app) {
		$this->db->query("SELECT app_title_".$this->lang." as app_title FROM application WHERE app_name=".$this->db->escape($app)."");
		if ($this->db->next_record()) {
			return $this->db->f('app_title');
		} else '';
	}
	function setAppEnabled($app,$enabled) {
		$update=array('app_enabled'=>$enabled);
		$this->db->update('application',$update,"app_name=".$this->db->escape($app));
	}
	function getGroupsApplication($GroupID) {
		$result=array();
		$query="SELECT application.app_id FROM grant_groups_application,application WHERE ";
		$query.="grant_groups_application.app_id=application.app_id ";
		$query.="AND app_enabled='1'";
		$query.="AND group_id=".$this->db->escape($GroupID);
		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[]=$this->db->f("app_id");
		}
		return array_unique($result);
	}
	function getUsersApplication($UserID,$useUsers=1,$useGroups=1,$UseName=0) {
		$result=array();
		if ($useUsers) {
			$query="SELECT application.app_id,application.app_name FROM grant_user_application,application WHERE ";
			$query.="grant_user_application.app_id=application.app_id AND app_enabled='1'";
			$query.="AND user_id=".$this->db->escape($UserID);
			//print_r($query);
			$this->db->query($query);
			while ($this->db->next_record()) {
				$result[]=$UseName?$this->db->f("app_name"):$this->db->f("app_id");
			}
		}
		if ($useGroups) {
			$groups=$this->getUserGroups($UserID);
			if (is_array($groups)) {
				$query="SELECT application.app_id,application.app_name FROM grant_groups_application,application WHERE ";
				$query.="grant_groups_application.app_id=application.app_id ";
				$query.="AND app_enabled='1'";
				$query.="AND group_id IN (".implode(',',$this->db->escape($groups)).")";
				$this->db->query($query);
				while ($this->db->next_record()) {
					$result[]=$UseName?$this->db->f("app_name"):$this->db->f("app_id");
				}
			}
		}
		return array_unique($result);
	}
	function getApplicationUsers($App,$UserID=0,$filter=true) {
		$s=microtime(true);
		$app_users=array();
		$query="SELECT user_id FROM grant_user_application,application WHERE ";
		$query.="grant_user_application.app_id=application.app_id AND app_enabled='1' AND app_name=".$this->db->escape($App)." ";
		if (is_array($UserID)) $query.="AND user_id IN (".implode(",",$this->db->escape($UserID)).")";
		$this->db->query($query);
		while ($this->db->next_record()) {
			//Einschraenkung Oberguppen
			if (empty($this->_allowedUsers) || in_array($this->db->f("user_id"),$this->_allowedUsers)) {
				$app_users[$this->db->f("user_id")]=1;
			}
		}
		$groups=array();
		$query="SELECT group_id FROM grant_groups_application,application WHERE ";
		$query.="grant_groups_application.app_id=application.app_id ";
		$query.="AND app_enabled='1' AND app_name=".$this->db->escape($App)." ";
		$this->db->query($query);
		while ($this->db->next_record()) {
			$groups[]=$this->db->f("group_id");
		}
		$users=$this->getGroupUsers($groups);
		if (is_array($users)) {
			foreach ($users as $val) {
				//Einschraenkung Oberguppen
				if (empty($this->_allowedUsers) || in_array($val,$this->_allowedUsers)) {
					if (!is_array($UserID) || in_array($val,$UserID)) {
						$app_users[$val]=1;
					}
				}
			}
		}
		//debug(count($app_users));
		//debug(microtime(true)-$s);
		if (!empty($app_users) && $filter) {
			//debug($app_users);
			$tmp=$this->getFullName(array_keys($app_users),0,array('','system'));
			//debug($tmp);
			$app_users=array();
			foreach ($tmp as $key=>$val) {
				$app_users[$key]=1;
			}

		}
		//debug(microtime(true)-$s);
		return $app_users;
	}
	function getSelectData($Type,$usePerms=false,$perms=0) {
		$result=array();
		$query="SELECT SelID,Name_".$this->lang.",PermsUsers,PermsGroup FROM SelectData WHERE SelType=".$this->db->escape($Type);
		if ($usePerms) {
			$acl_where=array('PermsUsers LIKE '.$this->db->escape('%|'.$this->getUser().',%'));
			if (is_array($this->getMyGroups())) {
				foreach ($this->getMyGroups() as $val) {
					$acl_where[]="PermsGroup LIKE ".$this->db->escape('%|'.$val.',%');
				}
			}
			$query.=' AND ('.implode (' OR ',$acl_where).')';
		}
		$query.=" ORDER BY Name_".$this->lang;
		$this->db->query($query);
		while ($this->db->next_record()) {
			if ($usePerms && $perms) {
				$acl=$this->calcAcl($this->db->f('PermsUsers'),$this->db->f('PermsGroup'));
				if (!$acl || !($acl&$perms)) continue;
			}
			$result[$this->db->f('SelID')]=$this->db->f('Name_'.$this->lang);
		}
		return $result;
	}
	function insertSelectData($Type,$Name) {
		$ID=$this->db->nextid('SelectData');
		$Name['SelID']=$ID;
		$Name['SelType']=$Type;
		$this->db->insert('SelectData',$Name);
		return $ID;
	}
	function updateSelectData ($SelID,$Name) {
		$this->db->update('SelectData',$Name,'SelID='.$this->db->escape($SelID));
	}
	function readSelectData($SelID,$lang=null) {
		if (!is_array($lang)) $lang=$this->getMaLang();
		$query="SELECT * FROM SelectData WHERE SelID=".$this->db->escape($SelID);
		$this->db->query($query);
		$this->db->next_record();
		foreach ($lang as $val) {
			$result['Name_'.$val]=$this->db->f("Name_".$val);
		}
		$result['PermsGroup']=$this->db->f("PermsGroup");
		$result['PermsUsers']=$this->db->f("PermsUsers");
		return $result;
	}
	function deleteSelectData($SelID) {
		$query="DELETE FROM SelectData WHERE SelID=".$this->db->escape($SelID);
		return $this->db->query($query);
	}
	function sendmessage($to,$from,$subject,$body,$link='',$link_title='',$image='') {
		$c_msg=& $this->getStaticModul('msg');

		$msg=new ObjMsgMessage();
		$msg->setMeta('msg_userid',$from);
		$msg->setMeta('msg_sendid',0);
		$msg->setMeta('msg_from',$this->getCachedUsername($from));
		$msg->setMeta('msg_subject',$subject);
		$msg->setMeta('msg_message',$body);
		$msg->setMeta('msg_image',$image);
		$msg->setMeta('msg_to','u_'.implode(',u_',array_unique($to)));
		if ($link) {
			$msg->setMeta('msg_link',json_encode(array(array('N'=>$link_title,'U'=>"index.php".$link))));
		}
		return $c_msg->sendMsgMessage($msg);
	}
	function is_email($email) {
		$regs=array();
		if( preg_match("/.*<(.+)>/", $email, $regs ) ) {
			$email = $regs[1];
		}

		$isValid = true;
		$atIndex = strrpos($email, "@");
		if (is_bool($atIndex) && !$atIndex)   {
			$isValid = false;
		} else {
			$domain = substr($email, $atIndex+1);
			$local = substr($email, 0, $atIndex);
			$localLen = strlen($local);
			$domainLen = strlen($domain);
			if ($localLen < 1 || $localLen > 64)   {
				// local part length exceeded
				$isValid = false;
			} else if ($domainLen < 1 || $domainLen > 255) {
				// domain part length exceeded
				$isValid = false;
			} else if ($local[0] == '.' || $local[$localLen-1] == '.')   {
				// local part starts or ends with '.'
				$isValid = false;
			} else if (preg_match('/\\.\\./', $local))  {
				// local part has two consecutive dots
				$isValid = false;
			} else if (!preg_match('/^[A-Za-z0-9\\-\\.]+$/', $domain))   {
				// character not valid in domain part
				$isValid = false;
			} else if (preg_match('/\\.\\./', $domain)) {
				// domain part has two consecutive dots
				$isValid = false;
			}  else if (!preg_match('/^(\\\\.|[A-Za-z0-9!#%&`_=\\/$\'*+?^{}|~.-])+$/',str_replace("\\\\","",$local)))  {
				// character not valid in local part unless
				// local part is quoted
				if (!preg_match('/^"(\\\\"|[^"])+"$/', str_replace("\\\\","",$local))) {
					$isValid = false;
				}
			}
			/*if ($isValid && !(checkdnsrr($domain,"MX") || checkdnsrr($domain,"A")))   {
				// domain not found in DNS
				$isValid = false;
			}*/
		}
		return $isValid;
	}


	function parseDate($date,$h=0,$i=0,$s=0,$useRel=false,$tz='') {
		if ($useRel) {
			$date=preg_replace('/[^0-9+-]+/',"/",$date);
		} else {
			$date=preg_replace('/[^0-9]+/',"/",$date);
		}
		$h=intval($h);
		$i=intval($i);
		$s=intval($s);
		if ($useRel && !preg_match('/\//',$date) && intval($date)) {
			return FrameWork::timeTz($h,$i,$s,date('m'),date('d')+intval($date),date('Y'),$tz);
		}
		$temp_val=explode("/",$date);
		if (count($temp_val)==1 && strlen($temp_val[0])==8) {
			$tmp=intval(substr($temp_val[0],4,2));
			if ($tmp>0 && $tmp<13) {
				$temp_val[2]=intval(substr($temp_val[0],0,4));
				$temp_val[1]=intval(substr($temp_val[0],4,2));
				$temp_val[0]=intval(substr($temp_val[0],6,2));
			} else {
				$temp_val[2]=intval(substr($temp_val[0],4,4));
				$temp_val[1]=intval(substr($temp_val[0],2,2));
				$temp_val[0]=intval(substr($temp_val[0],0,2));
			}
		}
		if (!intval($temp_val[0])) return false;
		if (!intval($temp_val[1])) return false;
		if (!intval($temp_val[2])) {
				$temp_val[2]=date('Y');
		}
		if($temp_val[2] < 30) $temp_val[2]+=2000;
		if($temp_val[2] < 999) $temp_val[2]+=1900;

		return FrameWork::timeTz($h,$i,$s,$temp_val[1],$temp_val[0],$temp_val[2],$tz);
	}
	function timeTz($h,$i,$s,$m,$d,$y,$tz) {
		if (function_exists('date_create')) {
			$date=new DateTime();
			if ($tz) {
				$date->setTimezone(new DateTimeZone($tz));
			}
			$date->setDate($y,$m,$d);
			$date->setTime($h,$i,$s);
			$res=$date->format('U');
		} else {
			if ($tz) {
				$oldTz=date_default_timezone_get();
				if ($oldTz!=$tz) {
					date_default_timezone_set($tz);
				}
			}
			$res=mktime($h,$i,$s,$m,$d,$y);
			if ($tz) {
				date_default_timezone_set($oldTz);
			}
		}
		return $res;
	}
	function dateTz($format,$time=0,$tz='') {
		if ($tz) {
			$oldTz=date_default_timezone_get();
			if ($oldTz!=$tz) {
				date_default_timezone_set($tz);
			}
		}
		$res=date($format,$time);
		if ($tz && $oldTz!=$tz) {
			date_default_timezone_set($oldTz);
		}
		return $res;
	}
	function formatSize($size) {
		if ($size >= 1048576) return round($size / 1048576 * 100) / 100 ." Mb";
		elseif ($size >= 1024) return round($size / 1024 * 100) / 100 ." Kb";
		else return $size . " b";
	}
	function formatTime($val) {
		return sprintf('%02d:%02d',$val/60,$val%60);
	}
	function insertPrint($app,$typ='html',$text='') {
		$PrintID=$this->db->nextid('Print');
		$values=array(
			'PrintID'=>$PrintID,
			'FKUserID'=>$this->uid,
			'FKApplication'=>$app,
			'PrintTyp'=>$typ,
			'PrintText'=>$text,
		);
		$this->db->insert('Print',$values);
		return $PrintID;
	}
	function getPrint($PrintID,$typ='HtmlText') {
		$query=" SELECT FKApplication,PrintText,PrintTyp FROM Print WHERE PrintID=".$this->db->escape($PrintID)." AND FKUserID=".$this->db->escape($this->uid)."";
		$this->db->query($query);
		if ($this->db->next_record()) {
			$result['text']=$this->db->f('PrintText');
			$result['app']=$this->db->f('FKApplication');
			$result['typ']=$this->db->f('PrintTyp');
			return $result;
		} else return false;
	}
	function clearPrint($date) {
		$query="DELETE FROM Print WHERE FKUserID=".$this->db->escape($this->uid)." AND CreateTime < ".$this->db->escape($date)."";
		$this->db->query($query);
	}
	function getMimeFile($file,$name='') {
		$result='';
		if(function_exists('finfo_open')) {
			$finfo = finfo_open(FILEINFO_MIME_TYPE);
			$result=finfo_file($finfo, $file);
		} elseif (function_exists('mime_content_type')) {
			$result=mime_content_type($file);
		} else {
			global $db;
			if (!$name) $name=basename($file);
			if (preg_match('/\.((tar.)?[a-zA-Z0-9]*)$/',$name,$temp)) {
				$query="SELECT Mime_Type FROM Mime_Types WHERE Extension LIKE '%".$temp[1]."%'";
				$db->query($query);
				if ($db->next_record()) {
					$result=$db->f('Mime_Type');
				}
			}
		}
		if ($result=='application/zip' || $result=='application/x-zip') {
			if (!$name) $name=basename($file);
			switch(substr($name,strrpos($name,'.')+1)) {
				case 'docx':
				case 'doc':
					$result='application/vnd.openxmlformats-officedocument.wordprocessingml.document';
				break;
				case 'dotx':
				case 'dot':
					$result='application/vnd.openxmlformats-officedocument.wordprocessingml.template';
				break;
				case 'potx':
				case 'pot':
					$result='application/vnd.openxmlformats-officedocument.presentationml.template';
				break;
				case 'ppsx':
				case 'pps':
					$result='application/vnd.openxmlformats-officedocument.presentationml.slideshow';
				break;
				case 'pptx':
				case 'ppt':
					$result='application/vnd.openxmlformats-officedocument.presentationml.presentation';
				break;
				case 'xlsx':
				case 'xls':
					$result='application/vnd.openxmlformats-officedocument.spreadsheetml.sheet';
				break;
				case 'xltx':
				case 'xlt':
					$result='application/vnd.openxmlformats-officedocument.spreadsheetml.template';
				break;
				case 'odt':
					$result='application/vnd.oasis.opendocument.text';
				break;
				case 'ods':
					$result='application/vnd.oasis.opendocument.spreadsheet';
				break;
				case 'odp':
					$result='application/vnd.oasis.opendocument.presentation';
				break;
				case 'odg':
					$result='application/vnd.oasis.opendocument.graphics';
				break;
				case 'odc':
					$result='application/vnd.oasis.opendocument.chart';
				break;
				case 'odf':
					$result='application/vnd.oasis.opendocument.formula';
				break;
				case 'odi':
					$result='application/vnd.oasis.opendocument.image';
				break;
				case 'odm':
					$result='application/vnd.oasis.opendocument.text-master';
				break;
				case 'odb':
					$result='application/vnd.oasis.opendocument.database';
				break;
				case 'ott':
					$result='application/vnd.oasis.opendocument.text-template';
				break;
				case 'ots':
					$result='application/vnd.oasis.opendocument.spreadsheet-template';
				break;
				case 'otp':
					$result='application/vnd.oasis.opendocument.presentation-template';
				break;
				case 'otg':
					$result='application/vnd.oasis.opendocument.graphics-template';
				break;
				case 'otc':
					$result='application/vnd.oasis.opendocument.chart-template';
				break;
				case 'otf':
					$result='application/vnd.oasis.opendocument.formula-template';
				break;
				case 'oti':
					$result='application/vnd.oasis.opendocument.image-template';
				break;
				case 'oth':
					$result='application/vnd.oasis.opendocument.text-web';
				break;
			}
		}
		return $result;
    }
	function replaceHref($string) {
		return preg_replace("/([\w]+:\/\/[\w-?&;#~=\.\/\@]+[\w\/])/i","<A TARGET=\"_blank\" HREF=\"$1\">$1</A>",$string);
	}
	function ScanFile($file) {
		if ($GLOBALS['CFG']['VIRUS_PROG'] && file_exists($file)) {
			exec(sprintf($GLOBALS['CFG']['VIRUS_PROG'],$file),$temp,$result);
			//echo "<pre>".sprintf($GLOBALS[CFG][VIRUS_PROG],$file)."<br>$result<br>";var_dump($temp);echo '</pre>';
			if (isset($GLOBALS['CFG']['VIRUS_EXIT_CODE'][$result])) {
				@unlink($file);
				return $GLOBALS['CFG']['VIRUS_EXIT_CODE'][$result];
			}
		} else return 0;
	}
	function updateHotlist($user_id,$modul) {
		if (is_array($user_id)) {
			foreach($user_id as $val) {
				$insert[$val]="(".$this->db->escape($this->uid).",".$this->db->escape($val).",".$this->db->escape($modul).")";
			}
		} elseif ($user_id) {
				$insert[$user_id]="(".$this->db->escape($this->uid).",".$this->db->escape($user_id).",".$this->db->escape($modul).")";
		} else return false;
		if ($this->DBTYPE=="postgres") {
			foreach ($insert as $val) {
				$this->db->query("INSERT IGNORE INTO User_Hotlist (FKuserID,HotUserID,Modul) VALUES $val");
			}
		} else {
			$query="INSERT IGNORE INTO User_Hotlist (FKuserID,HotUserID,Modul) VALUES ".implode(',',$insert);
			$this->db->query($query);
		}
		$query="UPDATE User_Hotlist set `Count`=`Count`+1 WHERE FKUserID=".$this->db->escape($this->uid)." AND Modul=".$this->db->escape($modul)." AND HotUserID IN (".implode(",",$this->db->escape(array_keys($insert))).")";
		$this->db->query($query);
	}
	function getHotlist($modul,$limit,$limit_e=0) {
		$result=array();
		$query="SELECT HotUserID FROM User_Hotlist WHERE FKUserID=".$this->db->escape($this->uid)."";
		if ($modul) $query.=" AND Modul=".$this->db->escape($modul)."";
		$query.=" ORDER BY `Count` Desc, TimeModify Desc LIMIT ".intval($limit);
		//echo $query;
		$this->db->query($query);
		while ($this->db->next_record()) {
		 	$result[]=$this->db->f('HotUserID');
		}
		$num=$this->db->num_rows();
		//echo $num;
		if ($num<$limit || $limit_e) {
			$query="SELECT HotUserID,SUM(`count`) as num_count FROM User_Hotlist WHERE FKUserID=".$this->db->escape($this->uid)."";
			if (count($result)) {
				$query.=" AND HotUserID NOT IN (".implode(",",$this->db->escape($result)).")";
			}
			$query.=" GROUP BY HotUserID ORDER BY num_count Desc LIMIT ".intval($limit-$num+$limit_e);
			$this->db->query($query);
			while ($this->db->next_record()) {
				$result[]=$this->db->f('HotUserID');
			}
		}

		return $result;
	}
	function deleteHotList($modul=0,$HotUser=0,$FKUserID=0) {
  		if (!$FKUserID) $FKUserID=$ths->uid;
		$query="DELETE FROM User_Hotlist WHERE FKUserID=".$this->db->escape($FKUserID)."";
		if ($modul) $query.=" AND Modul=".$this->db->escape($modul)."";
		if ($HotUser) $query.=" AND HotUserID=".$this->db->escape($HotUser)."";
		$this->db->query($query);
	}
	function mail_qenc($string) {
		$res='';
		if (function_exists('iconv_mime_encode')) {
			$preferences = array(
				'input-charset' => GE_CHARSET,
				'output-charset' => GE_CHARSET,
				'line-length' => 76,
				'scheme' => 'Q',
				'line-break-chars' => "\n"
			);
			$res = iconv_mime_encode( 'dummy', $string, $preferences );
			$res = substr($res,7); // "dummy: " + 1
		} else {
			$tmp=imap_8bit($string);
			if ($tmp!=$string) {
				$res="=?".GE_CHARSET."?Q?" .str_replace("\r\n","?==?".GE_CHARSET."?q?",$tmp). "?=";
			} else {
				$res=$string;
			}
		}
		return $res;
	}
	function getmicrotime(){
		list($usec, $sec) = explode(" ",microtime());
		return ((float)$usec + (float)$sec);
	}
	// �nderunge Groupie neu
	function setTree($modul,$root_id,$open) {
		$values=array(
			'UserID'=>$this->uid,
			'Tree'=>$modul,
			'RootID'=>$root_id,
			'OpenID'=>$open,
		);
		$this->db->insert('UserTree',$values,0,1);
	}
	function getTree ($modul,$root_id) {
		$query="SELECT OpenID FROM UserTree WHERE UserID=".$this->db->escape($this->uid)." AND Tree=".$this->db->escape($modul)." AND RootID=".$this->db->escape($root_id);
		$this->db->query($query);
		if ($this->db->next_record()) {
			return $this->db->f('OpenID');
		} else {
			return '';
		}
	}
	function updateTree(&$tree,$id,$sep=',') {
		if ($id) {
			if ($tree) {
				if (strpos($tree,$sep.$id.$sep)!==false) {
					$tree=str_replace($sep.$id.$sep,$sep,$tree);
				} else {
					$tree.=$id.$sep;
				}
			} else {
				$tree=$sep.$id.$sep;
			}
		}
	}

	function getObjAction ($modul,$mode,$action='') {
		$result=array();
		$query="SELECT ObjAction.Action,ObjAction.Name_".$this->lang.",ObjActionModul.* FROM ";
		$query.=" ObjAction,ObjActionModul WHERE ActionID=FKActionID";
		$query.=" AND Modul=".$this->db->escape($modul)." AND Mode=".$this->db->escape($mode);
		if ($action) $query.=' AND Action='.$this->db->escape($action);
		$query.=" ORDER BY Sequenze ASC";
		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[$this->db->f('Action')]['Name']=$this->db->f("Name_".$this->lang);
			$result[$this->db->f('Action')]['Perms']=$this->db->f('Perms');
			$result[$this->db->f('Action')]['Hidden']=$this->db->f('Hidden');
			$result[$this->db->f('Action')]['Custom']=$this->db->f('Custom');
			if ($this->db->f('Extra')) {
				$result[$this->db->f('Action')]['Extra']=explode(',',$this->db->f('Extra'));
			} else {
				$result[$this->db->f('Action')]['Extra']=array();
			}
		}
		return $result;
	}
	function deleteClipboard($ClipboardID=0,$content=0) {
		$query="DELETE FROM Clipboard WHERE FKUserID=".$this->db->escape($this->uid);
		if ($ClipboardID) {
			$query.=" AND ClipboardID=".$this->db->escape($ClipboardID);
		}
		if (is_array($content)) {
			$query.=" AND Content IN (".implode(',',$this->db->escape($content)).")";
		} elseif ($content) {
			$query.=" AND Content=".$this->db->escape($content);
		}
		$this->db->query($query);
	}
	function insertClipboard($ClipboardID,$Content,$Mode='') {
		if ($ClipboardID && $Content) {
			$query="SELECT max(Sequence) as num FROM Clipboard WHERE ";
			$query.="ClipboardID=".$this->db->escape($ClipboardID);
			$query.=" AND FKUserID=".$this->db->escape($this->uid);
			$query.=" GROUP BY ClipboardID";
			$this->db->query($query);
			$this->db->next_record();
			$seq=$this->db->f('num') + 1;

			$values=array(
				'ClipboardID'=>$ClipboardID,
				'FKUserID'=>$this->uid,
				'Content'=>$Content,
				'Mode'=>$Mode,
				'Sequence'=>intval($seq),
			);
			$this->db->insert('Clipboard',$values,0,1);
			return array (
				'Mode'=>$Mode,
				'Content'=>$Content,
			);
		} else return false;
	}
	function getClipboard ($ClipboardID) {
		$query="SELECT Content,Mode FROM Clipboard WHERE FKUserID=".$this->db->escape($this->uid)." AND ClipboardID=".$this->db->escape($ClipboardID);
		$query.=" ORDER BY Sequence ASC ";
		$this->db->query($query);
		if ($this->db->num_rows()) {
			while ($this->db->next_record()) {
				$result[]=array(
					'Mode'=>$this->db->f('Mode'),
					'Content'=>$this->db->f('Content'),
				);
			}
			return $result;
		} else return false;
	}

	function setStylesheet($style) {
		$this->_style_sheet=$style;
	}
	function getStylesheet() {
		return $this->_style_sheet;
	}
	function replaceOpenObjects($modul,$id) {
		$values=array(
			'Modul'=>$modul,
			'FKDocID'=>$id,
			'FKUserID'=>$this->uid,
			'OpenTime'=>time(),
		);
		$this->db->insert ('OpenObjects',$values,0,1);
	}
	function deleteOpenObjects($modul,$id=0) {
		$query="DELETE FROM OpenObjects WHERE Modul=".$this->db->escape($modul);
		$query.=" AND FKUserID=".$this->db->escape($this->uid);
		if ($id) $query.=" AND FKDocID=".$this->db->escape($id);
		$this->db->query($query);
	}
	function getOpenObjects($modul=0) {
		$result=array();
		$query="SELECT Modul,FKDocID,OpenTime FROM OpenObjects WHERE FKUserID=".$this->db->escape($this->uid);
		if ($modul) $query.=" AND Modul=".$this->db->escape($modul);
		$query.=" ORDER BY OpenTime";
		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[$this->db->f('Modul')][$this->db->f('FKDocID')]=array('Time'=>$this->db->f('OpenTime'));
		}
		return $result;
	}

	function &importZip($zip,$dest='') {
		if (!$dest) $dest=Framework::getTempPath();
		$result=false;
		$command="unzip -oja ".escapeshellarg($zip)." -d $dest";
		if (exec($command,$temp)) {
			if (is_array($temp) && preg_match_all('/'.preg_quote($dest,'/')."\/.+\.[a-z1-9]{1,4}/i",implode("\n",$temp),$match)) {
				$result=$match[0];
			}
		}
		return $result;
        }
	function entities($string,$nl2br=0) {
		if (is_array($string)) {
			foreach ($string as $key=>$val) {
				$string[$key]=Framework::entities($val,$nl2br);
			}
		} else {
			$string=htmlspecialchars($string);
		}
		return $nl2br?nl2br($string):$string;
	}

	function importCsv ($file,$del,$header=false) {
		if(file_exists($file)) {
			if ($del=='t') $del="\t";
            $fp=fopen($file, "r");
			if ($header) {
				$keys=fgetcsv ($fp, 1000, $del);
				if (GE_CHARSET=='UTF-8') {
					$keys=Framework::getUtf8Encoded($keys);
				}
			} else {
				$keys=false;
			}
			while ($row=fgetcsv ($fp, 1000, $del)) {
				if (GE_CHARSET=='UTF-8') {
					$row=Framework::getUtf8Encoded($row);
				}
				if (is_array($keys)) {
					foreach ($keys as $key=>$val) {
						$krow[$val]=$row[$key];
					}
					$result[]=$krow;
				} else {
					$result[]=$row;
				}
			}
			return $result;
		} else return false;
	}
	function exportCsv($data,$del,$header=false,$filename='',$allowNl=false,$charset='') {
		if ($header) {
			$csv='"'.implode('"'.$del.'"',Framework::_escapeCsv(array_keys($data[0]),'"','"',$allowNl))."\"\r\n";
		}
		foreach ($data as $row) {
			$csv.='"'.implode('"'.$del.'"',Framework::_escapeCsv($row,'"','"',$allowNl))."\"\r\n";
		}
		if ($charset) {
			$csv=Framework::convertCharset($csv,GE_CHARSET,$charset);
		}
		if ($filename) {
			Framework::dumpText($csv,$filename,'text/csv');
			exit;
		} else {
			return $csv;
		}
	}
	function _escapeCsv($mixed,$enc='"',$esc='"',$allowNl=false) {
		if (is_array($mixed)) {
			foreach ($mixed as $key=>$var) {
				$mixed[$key]=Framework::_escapeCsv($var,$enc,$esc,$allowNl);
			}
		} else {
			$mixed=str_replace($enc,$esc.$enc,$mixed);
			$mixed=str_replace("\r",'',$mixed);
			if (!$allowNl) $mixed=str_replace("\n",'',$mixed);
		}
		return $mixed;
	}
	function getCfg($modul,$id,$key) {
		$query="SELECT * FROM ModulCfg WHERE FKObjID=".$this->db->escape($id);
		$query.=" AND FKModul=".$this->db->escape($modul);
		if (is_array($key)) $query.=' AND (FKCfgKey LIKE '.implode (' OR FKCfgKey LIKE ',$this->db->escape($key)).')';
		elseif ($key) $query.=" AND FKCfgKey LIKE ".$this->db->escape($key);
		//echo $query.'<br>';
		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[$this->db->f('FKCfgKey')]=$this->db->f('CfgVal');
		}
		return $result;
	}
	function setCfg($modul,$id,$Cfg,$key,$ignore="") {
		if ($modul && is_array($Cfg)) {
			$this->deleteCfg($modul,$id,$key,$ignore);
			foreach ($Cfg as $key=>$val) {
				//echo $key.'-'.$val.'<br>';
				$this->db->insert ('ModulCfg',array('FKModul'=>$modul,'FKObjID'=>$id,'FKCfgKey'=>$key,'CfgVal'=>$val));
			}
		}
	}
	function deleteCfg($modul,$id,$key,$ignore="") {
		$query="DELETE FROM ModulCfg WHERE FKObjID=".$this->db->escape($id);
		$query.=" AND FKModul=".$this->db->escape($modul);
		if (is_array($key)) $query.=' AND (FKCfgKey LIKE '.implode (' OR FKCfgKey LIKE ',$this->db->escape($key)).')';
		else $query.=" AND FKCfgKey LIKE ".$this->db->escape($key);
		if (is_array($ignore)) {
			foreach ($ignore as $val) {
				$query.=" AND FKCfgKey!=".$this->db->escape($val);
			}
		}
		//echo $query;
		$this->db->query($query);
	}
	function getCfgKeys($modul,$key='') {
		$query="SELECT *  FROM ModulCfgKeys ";
		$query.=" WHERE FKModul=".$this->db->escape($modul);
		if (is_array($key)) $query.=' AND (CfgKey LIKE '.implode (' OR CfgKey LIKE ',$this->db->escape($key)).')';
		elseif ($key) $query.=" AND CfgKey LIKE ".$this->db->escape($key);
		$query.=" ORDER BY Sequence ";
		//echo $query;
		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[$this->db->f('CfgKey')]=array(
				'Name'=>$this->db->f('Name_'.$this->lang),
				'FieldTyp'=>$this->db->f('FieldTyp'),
				'Size'=>$this->db->f('Size'),
				'CfgVal'=>$this->db->f('CfgVal'),
			);
		}
		return $result;
	}
	function deleteFiles($path,$ereg,$exclude=array()) {
		if (file_exists($path) && is_dir($path)) {
			$dh=opendir($path);
			while ($file=readdir($dh)) {
				if (preg_match($ereg,$file) && !isset($exclude[$file]) && is_file($path.'/'.$file)) {
					//echo $path.'/'.$file.'<br>';
					unlink($path.'/'.$file);
				}
			}
		}
	}
	function deleteFilesRecursive($path,$ereg,$exclude=array(),$del_folder=false) {
		clearstatcache();
		if (file_exists($path) && is_dir($path)) {
			$dh=opendir($path);
			while ($file=readdir($dh)) {
				//echo $file.'<br>';
				if (preg_match($ereg,$file) && !isset($exclude[$file]) &&  $file!='.' && $file!='..') {
					if (is_file($path.'/'.$file)) {
						unlink($path.'/'.$file);
					}
					if (is_dir($path.'/'.$file)) {
						Framework::deleteFilesRecursive($path.'/'.$file,$ereg,$exclude,true);
					}
					//echo $path.'/'.$file.'<br>';
				}
			}
			closedir($dh);
			if ($del_folder) {
				rmdir($path);
			}
		}
	}
	function getUtf8Encoded($param) {
		if (is_array($param)) {
			foreach ($param as $key=>$val) {
				$param[$key]=Framework::getUtf8Encoded($val);
			}
		} else {
			if (!Framework::isUtf8($param)) {
				$param=Framework::convertCharset($param,'ISO-8859-1','UTF-8');
			}
		}
		return $param;
	}

	function isUtf8(&$string) {
		if (empty($string)) return false;
		return preg_match('%(?:
			[\xC2-\xDF][\x80-\xBF]        # non-overlong 2-byte
			|\xE0[\xA0-\xBF][\x80-\xBF]              # excluding overlongs
			|[\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}      # straight 3-byte
			|\xED[\x80-\x9F][\x80-\xBF]              # excluding surrogates
			|\xF0[\x90-\xBF][\x80-\xBF]{2}    # planes 1-3
			|[\xF1-\xF3][\x80-\xBF]{3}                  # planes 4-15
			|\xF4[\x80-\x8F][\x80-\xBF]{2}    # plane 16
			)+%xs', $string);
	}
	function convertCharset($string,$from,$to=GE_CHARSET) {
		$chars=array(
				'UCS-4','UCS-4BE','UCS-4LE','UCS-2','UCS-2BE','UCS-2LE','UTF-32','UTF-32BE',
				'UTF-32LE','UCS-2LE','UTF-16','UTF-16BE','UTF-16LE','UTF-8','UTF-7','ASCII',
				'EUC-JP','SJIS','EUCJP-WIN','SJIS-WIN','ISO-2022-JP','JIS','ISO-8859-1','ISO-8859-2',
				'ISO-8859-3','ISO-8859-4','ISO-8859-5','ISO-8859-6','ISO-8859-7','ISO-8859-8',
				'ISO-8859-9','ISO-8859-10','ISO-8859-13','ISO-8859-14','ISO-8859-15',
				'BYTE2BE','BYTE2LE','BYTE4BE','BYTE4LE','BASE64','7BIT','8BIT','UTF7-IMAP',
				'WINDOWS-1252','WINDOWS-1251','HTML-ENTITIES',
		);
		if (strtoupper($from)!=strtoupper($to)){
			if (!in_array(strtoupper($from),$chars)) {
				$from='ISO-8859-1';
			}
			if (defined('NO_MB_ENTITIES') && NO_MB_ENTITIES && ($from=='HTML-ENTITIES' || $to=='HTML-ENTITIES')) {
				if ($from=='HTML-ENTITIES') {
					$string=html_entity_decode ($string,ENT_NOQUOTES,$to);
				}
				if ($to=='HTML-ENTITIES') {
					$string=htmlentities ($string,ENT_NOQUOTES,$from);
					$string=str_replace('&gt;','>',$string);
					$string=str_replace('&lt;','<',$string);
					$string=str_replace('&amp;','&',$string);
				}
			} else {
				//echo $to.'-'.$from.'<br>';
				//echo $string.'<br>';
				$string=mb_convert_encoding($string,$to,$from);
				//echo $string.'<br>';
			}
		}
		return $string;
	}
	function getUserData($modul,$ID=0) {
		$query="SELECT UserData FROM UserData WHERE FKModul=".$this->db->escape($modul);
		$query.=" AND FKUserID=".$this->db->escape($this->uid);
		if ($ID) $query.=" AND FKID=".$this->db->escape($ID);
		$this->db->query($query);
		if ($this->db->next_record()) {
			return $this->db->f('UserData');
		} else {
			return false;
		}
	}
	function setUserData($modul,$ID,$Data) {
		if ($modul) {
			$this->db->insert ('UserData',array(
				'FKModul'=>$modul,
				'FKUserID'=>$this->uid,
				'FKID'=>$ID,
				'UserData'=>$Data),0,1);
		}
	}
	function deleteUserData($modul,$ID=0) {
		$query="DELETE FROM UserData WHERE FKUserID=".$this->db->escape($this->uid);
		$query.=" AND FKModul=".$this->db->escape($modul);
		if ($ID) $query.=" AND FKID=".$this->db->escape($ID);
		$this->db->query($query);
	}
	function savePostData($modul,$ID,$ignore=array(),$save_data=null) {
		if (!$save_data) $save_data=$_POST;
		if (is_array($ignore)) {
			foreach ($ignore as $val) {
				unset($save_data[$val]);
			}
		}
		$this->setUserData($modul,$ID,serialize($save_data));
		return $ID;
	}
	function loadPostData($modul,$ID,$return=0,$delete=1) {
		$save_data=$this->getUserData($modul,$ID);
		if ($delete) $this->deleteUserData($modul,$ID);
		if ($save_data) {
			if ($return) {
				return unserialize($save_data);
			} else {
				$this->importParam(unserialize($save_data),'P');
			}
		}
	}

	function listUserMsg($users,$uptime) {
		$query="SELECT FKUserID,UpTime,Status,Message,MsgTime,IpAdress FROM UserMsg ";
		$query.=" WHERE FKUserID IN (".implode(',',$this->db->escape($users)).")";
		if ($uptime) $query.=" AND uptime > ".$this->db->escape($uptime);
		$this->db->query($query);
		while ($this->db->next_record()) {
			if ($GLOBALS['CFG']['SUPERADMIN']==$this->db->f("FKUserID") && $this->uid!=$GLOBALS['CFG']['SUPERADMIN']) continue;
			$result[$this->db->f('FKUserID')]=array(
				'Status'=>$this->db->f('Status'),
				'Message'=>$this->db->f('Message'),
				'MsgTime'=>$this->db->f('MsgTime'),
				'UpTime'=>$this->db->f('UpTime'),
				'IpAdress'=>$this->db->f('IpAdress'),
			);
		}
		return $result;
	}
	function insertUserMsg($Status,$Msg,$Time,$UpTime) {
		$values=array(
			'FKUserID'=>$this->uid,
			'Status'=>$Status,
			'Message'=>$Msg,
			'MsgTime'=>$Time,
			'UpTime'=>$UpTime,
			'IpAdress'=>$_SERVER['REMOTE_ADDR'],
		);
		$this->db->insert('UserMsg',$values,0,1);
	}
	function getUserStatus() {
		$query="SELECT Status FROM UserMsg WHERE FKUserID=".$this->db->escape($this->uid);
		$this->db->query($query);
		if ($this->db->next_record()) {
			return ($this->db->f('Status'));
		} else return 0;
	}
	function getPrefs($app,$key='',$user=0) {
		if (!$user) $user=$this->uid;
		if (!isset($this->_pre[$user][$app])) {
			$query="SELECT PrefKey,PrefVal FROM UserPrefs WHERE FKUserID=".$this->db->escape($user)." AND Modul=".$this->db->escape($app)."";
			$this->db->query($query);
			if ($this->db->num_rows()) {
				while ($this->db->next_record()) {
					$this->_pre[$user][$app][$this->db->f('PrefKey')]=$this->db->f('PrefVal');
				}
			} else {
				$this->_pre[$user][$app]=$this->getDefaults($app);
			}
		}
		if ($key) {
			if (!isset($this->_pre[$user][$app][$key])) {
				$this->_pre[$user][$app][$key]=$this->getDefaults($app,$key);
			}
			return $this->_pre[$user][$app][$key];
		} else {
			return $this->_pre[$user][$app];
		}

	}
	function getDefaults($app,$skey='%') {
		$defaults=$this->getCfg($app,0,'def/'.$skey);
		if (is_array($defaults)) {
			foreach ($defaults as $key=>$val) {
				$result[substr($key,4)]=$val;
			}
		}
		if ($skey!='%') {
			return $result[$skey];
		} else {
			return $result;
		}
	}
	function insertPrefs($app,$obj,$suid=0) {
		if(!$suid) $suid=$this->uid;
		foreach ($obj as $key=>$val) {
			$insert=array(
				'FKUserID'=>$suid,
				'Modul'=>$app,
				'PrefKey'=>$key,
				'PrefVal'=>$val,
			);
			//debug($insert);
			$this->db->insert('UserPrefs',$insert,'',1);
		}
		if (isset($this->_pre[$suid][$app])) {
			unset($this->_pre[$suid][$app]);
		}
	}
	function escape($string) {
		$string=str_replace(',','\,',$string);
		$string=str_replace('=','\=',$string);
		return $string;
	}


	function wordSplit($text,$len=0,$add='..') {
		//$text=preg_replace('/(\w)\/(\w)/','\\1/ \\2',$text);
		if ($len && mb_strlen($text,GE_CHARSET)>$len) {
			$text=mb_substr($text,0,$len-1,GE_CHARSET).$add;
		}
		return $text;
	}
	function linkSplit($text) {
		//debug(htmlspecialchars($text));
		//$text=preg_replace('/(^|>)([^<>]+)(<|$)/e','\'\\1\'.strtr(\'\\2\',array("/"=>"/ ","\'.chr(92).\'"=>"\'.chr(92).\' ")).\'\\3\'',$text);
		$text=preg_replace('/(^|>)([^<>]+)(<|$)/e','\'\\1\'.Framework::linkSplit2(\'\\2\').\'\\3\'',$text);
		//debug(htmlspecialchars($text));
		return $text;
	}
	function linkSplit2($text) {
		$text=preg_replace("/([^\/\\\\])([\/\\\\])([^\/\\\\])/",'\\1\\2 \\3',$text);
		$text=preg_replace("/(&amp;)/",'\\1 ',$text);
		return $text;
	}
	function convertLineEndings(&$string,$to="\r\n") {
		$string=str_replace("\r\n","\n",$string);
		$string=str_replace("\r","\n",$string);
		if ($to!="\n") $string=str_replace("\n",$to,$string);
	}
	function getVersion($modul) {
		$query="SELECT * FROM Version WHERE Modul=".$this->db->escape($modul);
		$this->db->query($query);
		if ($this->db->next_record()) {
			return array(
				'UpdateDate'=>$this->db->f('UpdateDate'),
				'Version'=>$this->db->f('Version'),
			);
		} else {
			return false;
		}
	}
	function checkVersionDate($modul,$date) {
		$query="SELECT * FROM Version WHERE Modul=".$this->db->escape($modul);
		$query.=" AND UpdateDate>=".$this->db->escape($date);
		$this->db->query($query);
		if ($this->db->next_record()) {
			return true;
		} else {
			return false;
		}

	}
	function logUser($uid,$action,$logdata) {
		$insert=array(
			'FKUserID'=>$uid,
			'Action'=>$action,
			'Data'=>$logdata,
			'Datum'=>date('Y-m-d H:i'),
		);
		$this->db->insert('LogUser',$insert);
	}
	function getMd5Sum($File) {
		if (file_exists($File)) {
			if (function_exists('md5_file')) {
				return md5_file($File);
			} else {
				$exec="md5sum ".escapeshellarg($File);
				$result=array();
				exec($exec,$result);
				return (substr($result[0],0,strpos($result[0],' ')));
			}
		}
		return '';
	}
	function getMaLang() {
		$result=array();
		foreach ($GLOBALS['CFG']['MA_LANG'] as $val) {
			if ($val==$this->getLang()) {
				$result=array($val=>$val) + $result;
			} else {
				$result=$result + array($val=>$val);
			}
		}
		return $result;
	}
	function getIfLang() {
		$result=array();
		foreach ($GLOBALS['CFG']['IF_LANG'] as $val) {
			$result[$val]=$val;
		}
		return $result;
	}
	function getAvLang() {
		$result=array();
		foreach ($GLOBALS['CFG']['AV_LANG'] as $val) {
			$result[$val]=$val;
		}
		return $result;
	}
	function genAutoUname($ml,$ln,$fn,$pu = NULL) {
		$ln=Framework::replaceAccents($ln);
		$fn=Framework::replaceAccents($fn);
		$len=$ml - strlen($ln);
		if ($len<1) $len=1;
		if ($len>strlen($fn)) {
			$add=str_repeat('0',$len - strlen($fn));
		} else {
			$add='';
		}
		$i=0;
		do {
			$username=preg_replace('/[^a-z0-9-_]/i','-',strtolower(substr($fn,0,$len).$ln.$add.($i?$i:'')));
			$i++;
		} while ($pu[$username] || $this->check_user($username,0));
		return $username;
	}
	function genAutoPwd($length,$strength=0) {
		$vowels = 'aeiouy';
		$consonants = 'bdghjlmnpqrstvwxz';
		if ($strength & 1) {
			$consonants .= 'BDGHJLMNPQRSTVWXZ';
		}
		if ($strength & 2) {
			$vowels .= "AEIOUY";
		}
		if ($strength & 4) {
			$consonants .= '0123456789';
		}
		if ($strength & 8) {
			$consonants .= '@#$%';
		}
		$password = '';
		$alt = time() % 2;
		srand();
		for ($i = 0; $i < $length; $i++) {
			if ($alt == 1) {
				$password .= $consonants[(rand() % strlen($consonants))];
				$alt = 0;
			} else {
				$password .= $vowels[(rand() % strlen($vowels))];
				$alt = 1;
			}
		}
		return $password;
	}
	function dumpFile($file,$filename,$contentType='application/save',$delete=false) {
		//$filename=preg_replace('/\s/','',$filename);
		$filename=str_replace('"','',$filename);
		$filename=trim($filename);
		if (file_exists($file)) {
           	if (strstr($_SERVER['HTTP_USER_AGENT'], "MSIE")) {
				$filename = preg_replace('/\./','%2e', $filename, substr_count($filename, '.') - 1);
				$filename=Framework::convertCharset($filename,GE_CHARSET,'ISO-8859-1');
			}
			header("Pragma: ");
           	header("Cache-control: ");
			header("Content-Disposition: attachment; filename=\"$filename\"");
			header("Content-Type: $contentType");
			header("Content-Length: ".filesize($file));
			readfile($file);
			if ($delete) {
				unlink($file);
			}
			return true;
		}
		return false;
	}
	function dumpText(&$txt,$filename,$contentType='application/save') {
		//$filename=preg_replace('/\s/','',$filename);
		$filename=str_replace('"','',$filename);
		$filename=trim($filename);
		if (strstr($_SERVER['HTTP_USER_AGENT'], "MSIE")) {
			$filename = preg_replace('/\./','%2e', $filename, substr_count($filename, '.') - 1);
			$filename=Framework::convertCharset($filename,GE_CHARSET,'ISO-8859-1');
		}
		//$filename = preg_replace('/[^a-z0-9]/i','_', $filename);
		//debug(headers_list());
		header("Pragma: ");
        header("Cache-control: ");
		header("Content-Disposition: attachment; filename=\"$filename\"");
		header("Content-Type: $contentType");
		header("Content-Length: ".strlen($txt));
		echo($txt);
		return true;
	}
	function getOnLoad() {
		return $this->_onLoad;
	}
	function addOnload($js) {
		$this->_onLoad.=$js;
	}
	function getOnUnLoad() {
		return $this->_onUnLoad;
	}
	function addOnUnload($js) {
		$this->_onUnLoad.=$js;
	}

	function getCachedUser($uid,$key ='') {
		if (!$uid) $uid=$this->getUser();
		if (!isset($this->_cachedUser[$uid])) {
			$this->_cachedUser[$uid]=$this->read_user($uid);
		}
		if ($key) {
			return isset($this->_cachedUser[$uid][$key])?$this->_cachedUser[$uid][$key]:false;
		} else {
			return $this->_cachedUser[$uid];
		}
	}
	function getCachedUserNameAll($uid,$format=0) {
		return  $this->getCachedUserName($uid,$format,1);
	}
	function getCachedUserName($uid,$format=0,$perms=0) {
		if (is_array($uid)) {
			$result=array();
			foreach ($uid as $val) {
				if ($tmp=$this->getCachedUserName($val,$format,$perms)) {
					$result[$val]=$tmp;
				}
			}
			return $result;
		} else {
			if (!isset($this->_cached[$uid.'|'.$perms.'|'.$format])) {
				$tmp=$this->getFullName($uid,$format,$perms);
				if ($tmp[$uid]) $this->_cached[$uid.'|'.$perms.'|'.$format]=$tmp[$uid]; else $this->_cached[$uid.'|'.$perms.'|'.$format]='';
			}
			return $this->_cached[$uid.'|'.$perms.'|'.$format];
		}

	}
	function getCachedGroupName($gid,$perms=-1) {
		if (is_array($gid)) {
			$result=array();
			foreach ($gid as $val) {
				if ($tmp=$this->getCachedGroupName($val,$perms)) {
					$result[$val]=$tmp;
				}
			}
			return $result;
		} else {
			if (!isset($this->_gcached[$gid])) {
				$tmp=$this->getAllGroups($gid,$perms);
				if ($tmp[$gid]) $this->_gcached[$gid]=$tmp[$gid]; else $this->_gcached[$gid]='';
			}
			return $this->_gcached[$gid];
		}

	}
	function getCachedRuleName($id) {
		if (!isset($this->_rcached[$id])) {
			$tmp=$this->getAllRules($id);
			if ($tmp[$id]) $this->_rcached[$id]=$tmp[$id]; else $this->_rcached[$id]='';
		}
		return $this->_rcached[$id];

	}
	function getCachedGroupUsers($id) {
		if (!isset($this->_gucached[$id])) {
			$this->_gucached[$id]=$this->getGroupUsers($id);
		}
		return $this->_gucached[$id];
	}

	function parseDateSql($date,$h=0,$i=0,$s=0) {
		$date=preg_replace('/[^0-9]+/',"/",$date);
		$temp_val=explode("/",$date);
		$dresult="0000-00-00";
		if (intval($temp_val[0]) && intval($temp_val[1])) {
			if (!intval($temp_val[2])) {
				$temp_val[2]=date('Y');
			}
			if($temp_val[2] < 30) $temp_val[2]+=2000;
			if($temp_val[2] < 999) $temp_val[2]+=1900;
			if (checkdate($temp_val[1],intval($temp_val[0]),intval($temp_val[2]))) {
				$dresult=sprintf('%04d-%02d-%02d',$temp_val[2],$temp_val[1],$temp_val[0]);
			}
		}
		$dresult.=sprintf(' %02d:%02d:%02d',$h,$i,$s);
		if ($dresult!='0000-00-00 00:00:00') {
			return $dresult;
		} else {
			return false;
		}
	}
	function formatSearchDate($date) {
		$date=preg_replace('/[^0-9%dmy+-]+/i',"/",$date);
		$temp_val=explode("/",$date);
		$result_val=array();
		if (!trim($temp_val[2])) {
			$temp_val[2]='%';
		}
		if (!trim($temp_val[1])) {
			$temp_val[1]='%';
		}
		foreach ($temp_val as $pos=>$val) {
			$val=strtolower($val);
			$val=preg_replace('/[+]+/','+',$val);
			$val=preg_replace('/[-]+/','-',$val);
			$val=preg_replace('/([-][+])|([+][-])/','+',$val);
			$val=preg_replace('/^[+-]/','',$val);
			$val_add=preg_split('/([+-])/',$val,-1,PREG_SPLIT_DELIM_CAPTURE);
			//debug($val_add);
			for ($j=0;$j<count($val_add);$j++) {
				if ($j==0) {
					$result_val[$pos].=Framework::_parseFormatDateVal($val_add[$j],$pos);
				} else {
					if ($j%2) {
						$result_val[$pos].=$val_add[$j];
					} else {
						$result_val[$pos].=Framework::_parseFormatDateVal($val_add[$j],$pos,false);
					}
				}
			}
		}
		return $result_val[0].'.'.$result_val[1].'.'.$result_val[2];
	}
	function _parseFormatDateVal($val,$pos,$enc=true) {
		//debug($pos);
		//debug($val);
		switch ($val) {
			case '%y':
			case '%m':
			case '%d':
			case '%':
				$result=$val;
			break;
			default:
				$val=intval($val);
				if ($enc) {
					switch ($pos) {
						case 0:
							$result=sprintf('%02d',$val);
						case 1:
							$result=sprintf('%02d',$val);
						break;
						case 2:
							if ($val) {
								if($val < 30) $val+=2000;
								if($val < 999) $val+=1900;
							}
							$result=sprintf('%04d',$val);
						break;
					}
				} else {
					$result=$val;
				}
		}
		//debug($result);
		return $result;
	}
	function dateSql($format,$date=0) {
		if (!$date) $date=date('Y-m-d H:i:s');
		$result='';
		$ignore_next=false;
		for ($i=0;$i<strlen($format);$i++) {
			if ($ignore_next) {
				$ignore_next=false;
				$result.=$format[$i];
			} else {
				switch ($format[$i]) {
					case "\\":
						$ignore_next=true;
					break;
					case 'Y':
						$result.=substr($date,0,4);
					break;
					case 'd':
						$result.=substr($date,8,2);
					break;
					case 'm':
						$result.=substr($date,5,2);
					break;
					case 'H':
						$result.=substr($date,11,2);
					break;
					case 'i':
						$result.=substr($date,14,2);
					break;
					case 's':
						$result.=substr($date,17,2);
					break;
					default:
						$result.=$format[$i];
				}
			}
		}
		return $result;
	}
	function isSqlDate($date) {
		if ($date && Framework::dateSql('Ymd',$date)!='00000000') {
			return true;
		} else {
			return false;
		}

	}
	function parseSqlDate($sql,$check=true) {
		$temp=explode(' ',$sql);
		$temp_d=explode('-',$temp[0]);
		$temp_t=explode(':',$temp[1]);
		if (!$check || checkdate(intval($temp_d[1]),intval($temp_d[2]),intval($temp_d[0]))) {
			return mktime(intval($temp_t[0]),intval($temp_t[1]),intval($temp_t[2]),intval($temp_d[1]),intval($temp_d[2]),intval($temp_d[0]));
		} else {
			return false;
		}
	}
	function issetParam($key,$mode='') {
		$key=preg_replace('/^([^[]+)/','[\\1]',str_replace('[]','',$key));
		$key=str_replace('[',"['",str_replace(']',"']",$key));
		if ((!$mode || $mode=='P') && eval('return isset ($_POST'.$key.');')) {
			return true;
		}
		if ((!$mode || $mode=='G') && eval('return isset ($_GET'.$key.');')) {
			return true;
		}
		if ((!$mode || $mode=='F') && eval('return isset ($_FILES'.$key.');')) {
			return true;
		}
		return false;
	}
	function getParam($key,$default='',$mode='') {
		$key=preg_replace('/^([^[]+)/','[\\1]',str_replace('[]','',$key));
		$key=str_replace('[',"['",str_replace(']',"']",$key));
		if ((!$mode || $mode=='P') && eval('return isset ($_POST'.$key.');')) {
			return eval('return $_POST'.$key.';');
		}
		if ((!$mode || $mode=='G') && eval('return isset ($_GET'.$key.');')) {
			return eval('return $_GET'.$key.';');
		}
		//debug($key);
		if ((!$mode || $mode=='F') && eval('return isset ($_FILES'.$key.');')) {
			return eval('return $_FILES'.$key.';');
		}
		return $default;
	}
	function unsetParam($key,$mode='') {
		$key=preg_replace('/^([^[]+)/','[\\1]',str_replace('[]','',$key));
		$key=str_replace('[',"['",str_replace(']',"']",$key));
		if ((!$mode || $mode=='P') && eval('return isset ($_POST'.$key.');')) {
			return eval('unset ($_POST'.$key.');');
		}
		if ((!$mode || $mode=='G') && eval('return isset ($_GET'.$key.');')) {
			return eval('unset ($_GET'.$key.');');
		}
		if ((!$mode || $mode=='F') && eval('return isset ($_FILES'.$key.');')) {
			return eval('unset ($_FILES'.$key.');');
		}
		return $default;
	}
	function importParam($values,$mode='P') {
		if ($values && is_array($values)) {
			foreach ($values as $key=>$val) {
				$key=preg_replace('/^([^[]+)/','[\\1]',str_replace('[]','',$key));
				$key=str_replace('[',"['",str_replace(']',"']",$key));
				if ((!$mode || $mode=='P')) {
					eval('$_POST'.$key.'=$val;');
				}
				if ((!$mode || $mode=='G')) {
					eval('$_GET'.$key.'=$val;');
				}
			}
		}
	}
	function extractObjMeta(&$obj,$field) {
		if (is_array($obj)) {
			$result=array();
			foreach ($obj as $key=>$objval) {
				$result[$key]=$objval->getMeta($field);
			}
			return $result;
		} else {
			return $obj->getMeta($field);
		}
	}
	function extractObjName(&$obj) {
		if (is_array($obj)) {
			$result=array();
			foreach ($obj as $key=>$objval) {
				if (is_object($objval)) $result[$key]=$objval->getName();
			}
			return $result;
		} elseif (is_object($obj)) {
			return $obj->getName();
		}
	}
	function extractArrayMeta(&$obj,$field) {
		if (is_array($obj)) {
			$result=array();
			foreach ($obj as $key=>$objval) {
				$result[$key]=$objval[$field];
			}
			return $result;
		} else {
			return $obj[$field];
		}
	}
	function isSuperAdmin($uid=0) {
		if (!$uid) $uid=$this->uid;
		if ($uid==$GLOBALS['CFG']['SUPERADMIN']) return true; else return false;
	}
	function isRuleUser($rules,$uid=0) {
		if (!$uid) $uid=$this->uid;
		if (!isset($this->_rules[$uid])) {
			$this->_rules[$uid]=$this->getUserRules($uid);
		}
		if (is_array($this->_rules[$uid])) {
			foreach ($rules as $val) {
				if (isset($this->_rules[$uid][$val])) return true;
			}
		}
		return false;
	}
	function getMyGroups($uid=0) {
		if (!$uid) $uid=$this->uid;
		if (!isset($this->_MyGroups[$uid])) {
			//debug('DDDD');
			$this->_MyGroups[$uid]=$this->getUserGroups($uid,false,true);
			//debug($this->_MyGroups[$uid]);
		}
		return is_array($this->_MyGroups[$uid])?$this->_MyGroups[$uid]:array();
	}
	function getMySuperGroups($uid=0) {
		if (defined('GE_SUPER_GROUPS_ENABLED') && GE_SUPER_GROUPS_ENABLED) {
			if (!$uid) $uid=$this->uid;
			if (!isset($this->_mySuperGroups[$uid])) {
				//debug('DDDD');
				$this->_mySuperGroups[$uid]=$this->members2Supergroup($this->getMyGroups($uid));
				//debug($this->_MyGroups[$uid]);
			}
			return $this->_mySuperGroups[$uid];
		}
		return array();
	}
	function getProjectRules($prjID,$uid=0,$info='',$limit=0,$translate=true) {
		$prj_groups=$this->getAllGroups($uid,array($prjID),'',0,$translate);
		if (is_array($prj_groups)) {
			if (trim($info)) {
				$info=preg_quote($info,'/');
				$info='/('.str_replace(' ',')|(',$info).')/i';
				foreach ($prj_groups as $key=>$val) {
					if (!preg_match($info,$val)) {
						unset($prj_groups[$key]);
					}
				}
			}
			if ($limit && is_array($prj_groups) && count($prj_groups)>$limit) {
				$prj_groups=array_splice($prj_groups,$limit);
			}
		}
		return empty($prj_groups)?false:$prj_groups;
	}
	function &getStaticGuiModul($modul,$class,$param=null) {
		if ($modul && $class) {
			if (!isset($this->_ModulGuiObj[$modul.'/'.$class])) {
				switch ($modul) {
					case 'custom':
						$files=array('lib/custom/'.GE_CUSTOM_APP.'/class_'.basename($class).'.php');
					break;
					case 'core':
						$files=array('lib/class_'.basename($class).'.php');
					break;
					default:
						$files=array('lib/'.basename($modul).'/class_'.basename($class).'.php');
					break;
				}
				foreach ($files as $val) {
					if (file_exists($val)) require_once($val); else debug('File not found:'.$val);
				}
				if (class_exists($class)) {
					if ($param) {
						$this->_ModulGuiObj[$modul.'/'.$class]=new $class($param);
					} else {
						$this->_ModulGuiObj[$modul.'/'.$class]=new $class;
					}
					if (!method_exists ($this->_ModulGuiObj[$modul.'/'.$class],'isCallable') || !call_user_func(array(& $this->_ModulGuiObj[$modul.'/'.$class],'isCallable'))) {
						unset($this->_ModulGuiObj[$modul.'/'.$class]);
						debug('Class not callable:'.$class);
					}
				} else debug('Class not found:'.$class);
			}
			return isset($this->_ModulGuiObj[$modul.'/'.$class])?$this->_ModulGuiObj[$modul.'/'.$class]:false;
		}
	}
	function clearStaticModules() {
		$this->_ModulObj=array();
		$this->_ModulGuiObj=array();
	}
	function &getStaticModul($modul,$params=null,$reload=false) {
		if (!isset($this->_ModulObj[$modul]) || $reload) {
			switch ($modul) {
				case 'addr':
					if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
						$files=array("lib/class_ObjCore.php","lib/addr/AddrClassLdap.php");
						$class='Addr';
					} else {
						$files=array("lib/addr/AddrClass.php");
						$class='Addr';
					}
				break;
				case 'addr_server':
					$files=array("lib/class_ObjCore.php","lib/addr/AddrClassLdapServer.php");
					$class='AddrLdapServer';
				break;
				case 'addr_list':
					$files=array("lib/class_ObjCore.php","lib/addr/AddrClassLdapList.php");
					$class='AddrLdapList';
				break;
				case 'cal':
					$files=array("lib/cal/CalEvent.php");
					$class='CalEvent';
				break;
				case 'cal_cat':
					$files=array("lib/class_ObjCore.php","lib/cal/class_CalCategory.php");
					$class='CalCategory';
				break;
				case 'cal_res':
					$files=array("lib/class_ObjCore.php","lib/cal/class_CalResource.php");
					$class='CalResource';
				break;
				case 'cal_time':
					$files=array("lib/class_ObjCore.php","lib/cal/class_CalTime.php");
					$class='CalTime';
				break;
				case 'fmng':
					$files=array("lib/fmng/FmngClass.php");
					$class='Fmng';
				break;
				case 'zef':
					$files=array("lib/zef/class_Zef.php");
					$class='Zef';
				break;
				case 'mail':
					$files=array("lib/mail/classMail.php");
					$class='Mail';
				break;
				case 'mail_adm':
					$files=array("lib/mail/classCyrAdm.php");
					$class='CyrAdm';
				break;
				case 'proj':
					$files=array("lib/class_ObjCore.php","lib/proj/class_Project.php");
					$class='Project';
				break;
				case 'proj_profiles':
					$files=array("lib/class_ObjCore.php","lib/proj/class_ProjectProfiles.php");
					$class='ProjectProfiles';
				break;
				case 'smb':
					$files=array("lib/smb/class_Samba.php");
					$class='Samba';
				break;
				case 'smb_mnt':
					$files=array("lib/smb/class_Samba.php");
					$class='Samba';
					$params='_mnt';
				break;
				case 'smb_client':
					$smbCfg=$this->getCfg('smb',0,'cfg/usemount');
					if (!$smbCfg['cfg/usemount'] && version_compare(phpversion(), "5.0.0", ">=")) {
						$files=array("lib/smb/class_SambaClient.php","lib/smb/class_SambaClientPipe.php");
						$class='SambaClientPipe';
					} else {
						$files=array("lib/smb/class_SambaClient.php","lib/smb/class_SambaClientMount.php");
						$class='SambaClientMount';
					}
					//$class='SambaClient';
				break;
				case 'smb_client_mnt':
					$files=array("lib/smb/class_SambaClient.php","lib/smb/class_SambaClientMount.php");
					$class='SambaClientMount';
				break;
				case 'smb_client_acl':
					$files=array("lib/smb/class_SambaAclClient.php");
					$class='SambaAclClient';
				break;
				case 'task':
					$files=array("cfg/".APP_THEME."/task/environment.inc.php","lib/task/Task.php");
					$class='Task';
				break;
				case 'workday':
					$files=array("lib/class_ObjCore.php","lib/class_CoreWorkday.php");
					$class='CoreWorkday';
				break;
				case 'custom':
					$files=array("lib/class_ObjCore.php",'lib/custom/'.GE_CUSTOM_APP.'/class_Core_'.GE_CUSTOM_APP.'.php');
					$class='Core_'.GE_CUSTOM_APP;
				break;
				case 'stel':
					$files=array("lib/stel/class_Stel.php");
					$class='Stel';
				break;
				case 'core_log':
					$files=array("lib/class_ObjCore.php","lib/class_CoreLog.php");
					$class='CoreLog';
				break;
				case 'core_search':
					$files=array("lib/class_ObjCore.php","lib/class_CoreSearch.php");
					$class='CoreSearch';
				break;
				case 'uform':
					$files=array("lib/class_ObjCore.php","lib/uform/class_UserForm.php");
					$class='UserForm';
				break;
				case 'uform_fields':
					$files=array("lib/class_ObjCore.php","lib/uform/class_UserFormFields.php");
					$class='UserFormFields';
				break;
				case 'uform_select':
					$files=array("lib/class_ObjCore.php","lib/uform/class_UserFormSelect.php");
					$class='UserFormSelect';
				break;
				case 'print_tpl':
					$files=array("lib/class_ObjCore.php","lib/class_PrintTemplates.php");
					$class='PrintTemplates';
				break;
				case 'active_sync':
					$files=array("lib/sync/class_ActiveSync.php");
					$class='ActiveSync';
				break;
				case 'asx':
					$files=array("lib/class_ObjCore.php","lib/asx/class_Asx.php");
					$class='Asx';
				break;
				case 'imng':
					$files=array("lib/imng/ImngClass.php");
					$class='Imng';
				break;
				case 'prot':
					$files=array("lib/class_ObjCore.php","lib/prot/class_Protocoll.php");
					$class='Protocoll';
				break;
				case 'prot_sel':
					$files=array("lib/class_ObjCore.php","lib/prot/class_ProtSelect.php");
					$class='ProtSelect';
				break;
				case 'prot_slo':
					$files=array("lib/class_ObjCore.php","lib/prot/class_ProtSlot.php");
					$class='ProtSlot';
				break;
				case 'sms':
					$files=array("lib/class_ObjCore.php","lib/sms/model/geSmsModelMessage.php");
					$class='geSmsModelMessage';
				break;
				case 'sms_res':
					$files=array("lib/class_ObjCore.php","lib/sms/model/geSmsModelResponse.php");
					$class='geSmsModelResponse';
				break;
				case 'sms_quota':
					$files=array("lib/class_ObjCore.php","lib/sms/model/geSmsModelQuota.php");
					$class='geSmsModelQuota';
				break;
				case 'msg':
					$files=array("lib/class_ObjCore.php","lib/msg/model/geMsgModelMessage.php");
					$class='geMsgModelMessage';
				break;
				case 'rem':
					$files=array("lib/class_ObjCore.php","lib/rem/model/geRemModelMessage.php");
					$class='geRemModelMessage';
				break;
			}
			foreach ($files as $val) {
				if (file_exists($val)) {
					require_once($val);
				} else {
					//echo $val;
				}
			}
			if (class_exists($class)) {
				if ($params) {
					$this->_ModulObj[$modul]=new $class($params);
				} else {
					$this->_ModulObj[$modul]=new $class;
				}
			}
		}
		return $this->_ModulObj[$modul];
	}


	function insertModulPerms($modul,$typ,$id,$Perms) {
		$this->deleteModulPerms($modul,$typ,$id);
		foreach ($Perms as $val) {
			$this->db->insert('ModulPerms',array('FKModul'=>$modul,'FKID'=>$id,'Typ'=>$typ,'Perms'=>$val));
		}
	}
	function deleteModulPerms($modul,$typ='',$id=0) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKModul','Typ'=>'=','Values'=>$modul);
		if ($typ) $searchQuery[]=array('Field'=>'Typ','Typ'=>'=','Values'=>$typ);
		if ($id) $searchQuery[]=array('Field'=>'FKID','Typ'=>'=','Values'=>$id);
		$query="DELETE FROM ModulPerms WHERE ".$this->db->getWhere($searchQuery);
		$this->db->query($query);
	}
	function getAllModulPerms($modul) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKModul','Typ'=>'=','Values'=>$modul);
		$query="SELECT * FROM ModulPerms";
		$query.=" WHERE ".$this->db->getWhere($searchQuery);
		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[$this->db->f('Typ')][$this->db->f('FKID')][]=$this->db->f('Perms');
		}
		return $result;
	}
	function getModulPerms($modul,$test=0) {
		if (!isset($this->_modulPerms[$modul])) {
			$this->_setModulPerms($modul);
		}
		if ($test) {
			return ($this->_modulPerms[$modul]&$test)?true:false;
		} else {
			return $this->_modulPerms[$modul];
		}
	}
	function _setModulPerms($modul) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKModul','Typ'=>'=','Values'=>$modul);
		$searchQuery[]=array('Field'=>'Typ','Typ'=>'=','Values'=>'u');
		$searchQuery[]=array('Field'=>'FKID','Typ'=>'=','Values'=>$this->uid);
		$query="SELECT BIT_OR(Perms) as uperms FROM ModulPerms";
		$query.=" WHERE ".$this->db->getWhere($searchQuery);
		$query.=" GROUP BY Typ";
		$this->db->query($query);
		if ($this->db->next_record()) {
			$this->_modulPerms[$modul]=$this->db->f('uperms');
		} else {
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'FKModul','Typ'=>'=','Values'=>$modul);
			$searchQuery[]=array('Field'=>'Typ','Typ'=>'=','Values'=>'g');
			$searchQuery[]=array('Field'=>'FKID','Typ'=>'=','Values'=>$this->getMyGroups());
			$query="SELECT BIT_OR(Perms) as uperms FROM ModulPerms";
			$query.=" WHERE ".$this->db->getWhere($searchQuery);
			$query.=" GROUP BY Typ";
			$this->db->query($query);
			if ($this->db->next_record()) {
				$this->_modulPerms[$modul]=$this->db->f('uperms');
			} else {
				$this->_modulPerms[$modul]=0;
			}
		}
	}

	function aclToArray($acl) {
		$result=array();
		if (strlen($acl)>2) {
			$temp=explode('|',substr($acl,1,-1));
			foreach ($temp as $val) {
				$temp2=explode(',',$val);
				$result[$temp2[0]]=intval($temp2[1]);
			}
		}
		return $result;
	}
	function ArrayToAcl($acl_array) {
		$result='';
		if (!empty($acl_array)) {
			ksort($acl_array);
			$temp=array();
			foreach ($acl_array as $key=>$val) {
				$temp[]=$key.','.$val;
			}
			$result=implode('|',$temp);
		}
		return '|'.$result.'|';
	}
	function pwdTimeIsValid($pwd_time=0,$pwd_days=0) {
		if ($this->getFrmCfg('cfg/usr/MaxPassDays') && !$this->getFrmCfg('cfg/usr/FixPassword') && !$this->getFrmCfg('cfg/usr/NoPassword')) {
			if (!$pwd_time) {
				$temp=$this->read_user($this->getUser());
				$pwd_time=$temp['pwd_time'];
				$pwd_days=$temp['shadowMax'];
			}
			if (!$pwd_days) return true;

			if ($pwd_time+$pwd_days*3600*24<time()) {
				return false;
			}
		}
		return true;
	}
	function &cloneObj(&$Obj) {
		return unserialize(serialize($Obj));
	}
	function getTempPath() {
		static $tempPath;
		if (!$tempPath) {
			if (!function_exists('sys_get_temp_dir')) {
				// Try to get from environment variable
				if (!empty($_ENV['TMP'])) {
					$tempPath=realpath( $_ENV['TMP'] );
				} elseif (!empty($_ENV['TMPDIR'])) {
					$tempPath=realpath( $_ENV['TMPDIR'] );
				} elseif (!empty($_ENV['TEMP'])) {
					$tempPath=realpath( $_ENV['TEMP'] );
				} else {
					$temp_file=tempnam( md5(uniqid(rand(), TRUE)), '' );
					if ($temp_file)	{
						$tempPath=realpath(dirname($temp_file));
						unlink( $temp_file );
					}
				}
			} else {
				$tempPath=sys_get_temp_dir();
			}
		}
		return $tempPath?$tempPath:'/tmp';
	}
	function getDynTempPath($fol='') {
		$tempPath=GE_DYN_PATH.'/'.GE_DOMAIN_PATH;
		if (!file_exists($tempPath)) {
			mkdir($tempPath,0700);
		}
		$tempPath.="tmp";
		if (!file_exists($tempPath)) {
			mkdir($tempPath,0700);
		}
		$tempPath.="/".$this->getUser();
		if (!file_exists($tempPath)) {
			mkdir($tempPath,0700);
		}
		if ($fol) {
			$tempPath.="/".$fol;
			if (!file_exists($tempPath)) {
				mkdir($tempPath,0700);
			}
		}
		return $tempPath;
	}
	function stampToTime($Content) {
		$year=intval(substr($Content,0,4));
		$month=intval(substr($Content,4,2));
		$day=intval(substr($Content,6,2));
		$hour=intval(substr($Content,8,2));
		$min=intval(substr($Content,10,2));
		$sec=intval(substr($Content,12,2));
		$utc=$Content[14]=='Z'?true:false;
		if ($utc) {
			//return mktime($hour,$min,$sec,$month,$day,$year);
			return gmmktime($hour,$min,$sec,$month,$day,$year);
		} else {
			return mktime($hour,$min,$sec,$month,$day,$year);
		}
	}
	function checkExec($exec) {
		if (!$exec) return 0;
		exec($exec,$result,$return);
		if ($return==127) return 0; else return 1;
	}
	function getLocale($lang,$charset=GE_CHARSET) {
		switch ($lang) {
			case "de":
				$locale="de_DE";
				if ($charset=='UTF-8') {
					$locale.='.'.$charset;
				} else {
					$locale.="@euro";
				}
				break;
			case "it":
				$locale="it_IT";
				if ($charset=='UTF-8'){
					$locale.='.'.$charset;
				} else {
					$locale.="@euro";
				}
				break;
			default:
				$locale="en_GB";
				if ($charset=='UTF-8') $locale.='.'.$charset;
				break;
		}
		return $locale;
	}
	function getJsScript() {
		return $this->_jscript;
	}
	function addJsScript($val) {
		if (!strpos($val,'?')) $val.='?v='.GE_VERSION;
		if (!in_array($val,$this->_jscript)) {
			$this->_jscript[]=$val;
		}
	}
	function getCssScript() {
		return $this->_cscript;
	}
	function addCssScript($val) {
		if (!in_array($val,$this->_cscript)) {
			$this->_cscript[]=$val;
		}
	}
	function getScript($typ='c') {
		return $this->_script[$typ];
	}
	function addScript($val,$to='c') {
		$this->_script[$to][]=$val;
	}
	function replaceAccents($str,$allowedExtra='') {
		$str = Framework::convertCharset($str,GE_CHARSET,'HTML-ENTITIES');
		//echo htmlspecialchars($str);
		$str = preg_replace('/&([a-zA-Z])(acute|grave|circ|tilde|ring|Elig);/','$1',$str);
		$str = preg_replace('/&([a-zA-Z])(uml);/','$1e',$str);
		$str = preg_replace('/&szlig;/','ss',$str);
		$str = preg_replace('/[^-_+.=?'.$allowedExtra.'a-zA-Z0-9]/','',$str);
		$str = Framework::convertCharset($str,'HTML-ENTITIES',GE_CHARSET);
		return $str;
	}
	function array2json($arr) {
		$parts = array();
		$is_list = false;
		//Find out if the given array is a numerical array
		$keys = array_keys($arr);
		$max_length = count($arr)-1;
		if(preg_match('/^[0-9]+$/',$keys[0]) && ($keys[0] == 0) and ($keys[$max_length] == $max_length)) {//See if the first key is 0 and last key is length - 1
			$is_list = true;
			for($i=0; $i<count($keys); $i++) { //See if each key correspondes to its position
				if($i != $keys[$i]) { //A key fails at position check.
					$is_list = false; //It is an associative array.
					break;
				}
			}
		}

		foreach($arr as $key=>$value) {
			if(is_array($value)) { //Custom handling for arrays
				if($is_list) $parts[] = Framework::array2json($value); /* :RECURSION: */
				else $parts[] = "'" . $key . "':" . Framework::array2json($value); /* :RECURSION: */
			} else {
				$str = '';
				if(!$is_list) $str = "'" . $key . "':";

				//Custom handling for multiple data types
				if(is_numeric($value)) $str .= $value; //Numbers
				elseif($value === false) $str .= 'false'; //The booleans
				elseif($value === true) $str .= 'true';
				else $str .= "'" . Framework::escapeJs($value) . "'"; //All other things
				// :TODO: Is there any more datatype we should be in the lookout for? (Object?)

				$parts[] = $str;
			}
		}
		$json = implode(',',$parts);
		if($is_list) return '[' . $json . ']';//Return numerical JSON
		return '{' . $json . '}';//Return associative JSON
	}
	function escapeJs($val) {
		$val=str_replace('\\','\\\\',$val);
		$val=str_replace("\r\n","\n",$val);
		$val=str_replace("\r","\n",$val);
		$val=str_replace("\n",'\n',$val);
		$val=str_replace("'","\'",$val);
		return $val;
	}
	function numberFormat($num,$dec=2) {
		return number_format($num,$dec,constDECIMAL,constTHOUSEND);

	}
	function sortByLenAsc($a,$b) {
		if (strlen($a)==strlen($b)) return 0;
		return strlen($a)<strlen($b)?-1:1;
	}
	function sortByLenDesc($a,$b) {
		if (strlen($a)==strlen($b)) return 0;
		return strlen($a)<strlen($b)?1:-1;
	}
	function sortByUserName($a,$b) {
		return strnatcasecmp($this->getCachedUserName($a),$this->getCachedUserName($b));
	}
	function code2utf($num){
		if($num<128)return chr($num);
		if($num<1024)return chr(($num>>6)+192).chr(($num&63)+128);
		if($num<32768)return chr(($num>>12)+224).chr((($num>>6)&63)+128).chr(($num&63)+128);
		if($num<2097152)return chr(($num>>18)+240).chr((($num>>12)&63)+128).chr((($num>>6)&63)+128) .chr(($num&63)+128);
		return '';
	}
	function checkUserIpAccess($uid) {
		if ($uid==-1) {
			$mask=$this->getFrmCfg('cfg/config_ip');
		} else {
			$mask=$this->getModulData('global','u',$uid,'restrict_ip');
			if (!trim($mask)) {
				$myGroups=$this->getMyGroups($uid);
				if (!empty($myGroups)) {
					$mask=implode(',',$this->getModulData('global','g',$myGroups,'restrict_ip'));
				}
			}
		}
		return $this->isAllowedIpMask($mask);
	}
	function isAllowedIpMask($mask='*',$ipAdress='') {
		if (!$ipAdress) $ipAdress=$_SERVER['REMOTE_ADDR'];
		$ipmask=array();
		if (trim($mask)) {
			$ipmask=explode(',',$mask);
			foreach ($ipmask as $ipk=>$ipv) {
				$ipmask[$ipk]=str_replace('\*','[0-9]+',preg_quote(trim($ipv),'/'));
			}
		}
		//debug($ipmask);
		if ($ipAdress && (empty($ipmask) || $ipAdress=='127.0.0.1' || preg_match('/('.implode(')|(',$ipmask).')/',$ipAdress))) {
			return true;
		}
		return false;
	}
	function insertModulData($modul,$typ,$id,$key,$Data) {
		$this->db->insert('ModulData',array('FKModul'=>$modul,'FKID'=>$id,'Typ'=>$typ,'ValKey'=>$key,'Data'=>$Data),null,1);
	}
	function deleteModulData($modul,$typ='',$id=0,$key='') {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKModul','Typ'=>'=','Values'=>$modul);
		if ($typ) $searchQuery[]=array('Field'=>'Typ','Typ'=>'=','Values'=>$typ);
		if ($id) $searchQuery[]=array('Field'=>'FKID','Typ'=>'=','Values'=>$id);
		if ($key) $searchQuery[]=array('Field'=>'ValKey','Typ'=>'=','Values'=>$key);
		$query="DELETE FROM ModulData WHERE ".$this->db->getWhere($searchQuery);
		$this->db->query($query);
	}
	function getModulData($modul,$typ,$id,$key) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKModul','Typ'=>'=','Values'=>$modul);
		$searchQuery[]=array('Field'=>'Typ','Typ'=>'=','Values'=>$typ);
		$searchQuery[]=array('Field'=>'FKID','Typ'=>'=','Values'=>$id);
		$searchQuery[]=array('Field'=>'ValKey','Typ'=>'=','Values'=>$key);
		$query="SELECT * FROM ModulData";
		$query.=" WHERE ".$this->db->getWhere($searchQuery);
		$this->db->query($query);
		if (is_array($id)) {
			$result=array();
			while ($this->db->next_record()) {
				$result[]=$this->db->f('Data');
			}
			return $result;
		} else {
			if ($this->db->next_record()) {
				return $this->db->f('Data');
			}
		}
	}
	function listModulData($modul,$typ,$id,$decode=false) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKModul','Typ'=>'=','Values'=>$modul);
		$searchQuery[]=array('Field'=>'Typ','Typ'=>'=','Values'=>$typ);
		$searchQuery[]=array('Field'=>'FKID','Typ'=>'=','Values'=>$id);
		$query="SELECT * FROM ModulData";
		$query.=" WHERE ".$this->db->getWhere($searchQuery);
		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[$this->db->f('ValKey')]=$decode?unserialize($this->db->f('Data')):$this->db->f('Data');
		}
		return $result;
	}
	function insertObjColor($modul,$id,$uid,$color) {
		$values=array(
			'FKModul'=>$modul,
			'FKObjID'=>$id,
			'FKUserID'=>$uid,
			'Color'=>$color,
		);
		return $this->db->insert('CoreColor',$values,0,1);
	}
	function deleteObjColor($modul,$id,$uid=0) {
		$searchQuery=array();
		if ($modul) $searchQuery[]=array('Field'=>'FKModul','Typ'=>'=','Values'=>$modul);
		if ($id) $searchQuery[]=array('Field'=>'FKObjID','Typ'=>'=','Values'=>$id);
		if ($uid) $searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$uid);

		if (!empty($searchQuery)) {
			$this->db->delete('CoreColor',$searchQuery);
		}
	}
	function listObjColor($modul,$id,$uid) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKModul','Typ'=>'=','Values'=>$modul);
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$uid);
		if ($id) $searchQuery[]=array('Field'=>'FKObjID','Typ'=>'=','Values'=>$id);
		$query="SELECT * FROM CoreColor WHERE ".$this->db->getWhere($searchQuery);
		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[$this->db->f("FKObjID")]=$this->db->f("Color");
		}
		if ($id && !is_array($id)) {
		  return isset($result[$id])?$result[$id]:'';
		} else {
		  return $result;
		}
	}
	function initExtJs() {
		if (!$this->_initExtJs) {
			$this->addJsScript('add-on/extjs/adapter/ext/ext-base.js');
			$this->addJsScript('add-on/extjs/ext-all.js');
			$this->addJsScript('add-on/extjs/plugins/js/Spinner.js');
			$this->addJsScript('add-on/extjs/plugins/js/SpinnerStrategy.js');
			$this->addJsScript('add-on/extjs/plugins/js/DateTime.js');
			$this->addJsScript('add-on/extjs/plugins/js/MultiCombo.js');
			$this->addJsScript('add-on/extjs/plugins/js/Ext.ux.BoxSelect.js');
			$this->addJsScript('add-on/extjs/plugins/js/radiogroup.js');
			$this->addJsScript('add-on/extjs/plugins/js/checkgroup.js');
			$this->addJsScript('js/init_ext.js');
			$this->addJsScript('add-on/extjs/build/locale/ext-lang-'.$this->getLang().'-min.js');
			$this->addCssScript('add-on/extjs/resources/css/ext-all.css');
			$this->addCssScript('add-on/extjs/plugins/css/Spinner.css');
			$this->addCssScript('add-on/extjs/plugins/css/boxselect.css');
			$this->addCssScript('add-on/extjs/resources/css/xtheme-gray.css');
			$this->_initExtJs=true;
		}
	}
	function escapeVal($txt,$sign=',',$escape='\\') {
		$txt=str_replace($escape,$escape.$escape,$txt);
		if (is_array($sign)) {
			foreach ($sign as $val) {
				$txt=str_replace($val,$escape.$val,$txt);
			}
		} else {
			$txt=str_replace($sign,$escape.$sign,$txt);
		}
		return $txt;
	}
	function splitVal($txt,$sign=',') {
		$psign=preg_quote($sign,'/');
		$splitter = "/".$psign."((?:[^\\\\".$psign."]|\\\\.)*)/";
		preg_match_all($splitter, $sign.$txt, $aPieces, PREG_PATTERN_ORDER);
		return $aPieces[1];
	}
	function unescapeVal($txt,$escape='\\') {
		if ($escape) {
			return trim(preg_replace("/".preg_quote($escape,'/')."(.)/s", "$1", $txt));
		} else {
			return trim($txt);
		}
	}
	function dateDistCmp ($date1,$date2) {
		if (date("I",$date1)!=date("I",$date2)) {
				return date("I",$date1)?-3600:+3600;
		}
		return 0;
	}

	function listSuperGroups($info='',$limit=0) {
		$result=array();
		$query="SELECT * FROM CoreSupergroups ";
		if ($info) {
			$query.=" WHERE SGroupName LIKE ".$this->db->escape('%'.$info.'%');
		}
		$query.=" ORDER BY SGroupName";
		if ($limit) {
			$query=" LIMIT ".intval($limit);
		}
		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[$this->db->f('SGroupID')]=array(
				'SGroupName'=>$this->db->f('SGroupName'),
			);
		}
		return $result;
	}
	function insertSuperGroup($values) {
		$values['SGroupID']=$this->db->nextid('CoreSupergroups');
		$this->db->insert('CoreSupergroups',$values);
		return $values['SGroupID'];
	}
	function updateSuperGroup($ID,$values) {
		$this->db->update('CoreSupergroups',$values,'SGroupID='.$this->db->escape($ID));
	}
	function readSuperGroup($ID) {
		$query="SELECT * FROM CoreSupergroups WHERE SGroupID=".$this->db->escape($ID);
		$this->db->query($query);
		if ($this->db->next_record()) {
			return array(
				'SGroupID'=>$this->db->f('SGroupID'),
				'SGroupName'=>$this->db->f('SGroupName'),
			);

		}
	}
	function deleteSuperGroup($ID) {
		$query="DELETE FROM CoreSupergroups WHERE SGroupID=".$this->db->escape($ID);
		return $this->db->query($query);
	}
	function insertSuperGroupMembers($ID,$members) {
		$query="DELETE FROM CoreSupergroups2groups WHERE FKSGroupID=".$this->db->escape($ID);
		$this->db->query($query);
		if (is_array($members)) {
			foreach($members as $val) {
				$this->db->insert('CoreSupergroups2groups',array(
					'FKSGroupID'=>$ID,
					'FKGroupID'=>$val,
				));
			}
		}
	}
	function supergroup2Members($ID) {
		$result=array();
		$search=array(
			array('Field'=>'FKSGroupID','Typ'=>'=','Values'=>$ID),
		);
		$query="SELECT * FROM CoreSupergroups2groups WHERE ".$this->db->getWhere($search);

		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[]=$this->db->f('FKGroupID');
		}
		return $result;
	}
	function members2Supergroup($ID) {
		$result=array();
		$search=array(
			array('Field'=>'FKGroupID','Typ'=>'=','Values'=>$ID),
		);
		$query="SELECT * FROM CoreSupergroups2groups WHERE ".$this->db->getWhere($search);

		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[]=$this->db->f('FKSGroupID');
		}
		return $result;
	}
	function isIpBlocked($ipAdress='',$time=600) {
		if (!$ipAdress) $ipAdress=$_SERVER['REMOTE_ADDR'];
		$blocked=unserialize($this->getModulData('global','o',0,'blocked_ip'));
		if ($blocked && isset($blocked[$ipAdress])) {
			if ($blocked[$ipAdress]['cnt']>=5 && ($blocked[$ipAdress]['last']+$time)>time()) {
				return true;
			}
		}
		return false;
	}
	function setIpBlocked($ipAdress='',$time=600) {
		if (!$ipAdress) $ipAdress=$_SERVER['REMOTE_ADDR'];
		$blocked=unserialize($this->getModulData('global','o',0,'blocked_ip'));
		if ($blocked && isset($blocked[$ipAdress])) {
			//Falls letzter Versuch vor 10 Minuten
			if ($blocked[$ipAdress]['last']+$time<time()) {
				$blocked[$ipAdress]['cnt']=1;
			} else {
				$blocked[$ipAdress]['cnt']++;
			}

		} else {
			$blocked[$ipAdress]=array(
				'cnt'=>1,
			);
		}
		$blocked[$ipAdress]['last']=time();
		$this->insertModulData('global','o',0,'blocked_ip',serialize($blocked));
	}
	public function formatPhone($number) {
		$number=str_replace('+','00',trim($number));
		$number=preg_replace('/[^0-9 -()]/','',$number);
		$number=preg_replace('/^00/','+',$number);
		return $number;
	}
	public function getSessionMd5() {
		//Remote_Addr gibt mit mobile-clients Probleme
		$str=md5(/*$_SERVER['REMOTE_ADDR'].*/'*'/*.$_SERVER['HTTP_USER_AGENT']*/);
		return $str;
	}
	function getRule($perms=0,$sadmin=0) {
		$result=array();
		if (is_array($perms)) {
			$where=" Perms IN (".implode(",",$this->db->escape($perms)).")";
		} elseif ($perms) {
			$where=" Perms=".$this->db->escape($perms)."";
		} else $where='';
		if ($sadmin) {
			$query="SELECT Perms FROM Rules ";
			if ($where) $query.=" WHERE $where";
			$this->db->query($query);
		} else {
			$query="SELECT Perms FROM user_rules INNER JOIN Rules ON RuleID=FKRuleID WHERE FKUserID=".$this->db->escape($this->uid);
			if ($where) $query.=" AND $where";
			$this->db->query($query);
		}
		while ($this->db->next_record()) {
			$result[$this->db->f('Perms')]=$this->db->f('Perms');
		}
		return $result;
	}
	function getRuleUser($perms) {
		$this->db->query("SELECT FKUserID FROM user_rules INNER JOIN Rules ON RuleID=FKRuleID WHERE Perms=".$this->db->escape($perms)." AND Activ=1 ORDER BY Priority");
		if ($this->db->next_record()) {
			return $this->db->f('FKUserID');
		} else return 0;
	}
	function getUserRules($user_id) {
		$query="SELECT Perms,Name_".$this->lang." FROM user_rules INNER JOIN Rules ON RuleID=FKRuleID WHERE FKUserID=".$this->db->escape($user_id);
		$this->db->query($query);
		while ($this->db->next_record()) {
			$rules[$this->db->f("Perms")]=$this->db->f("Name_".$this->lang);
		}
		return $rules;
	}
	function insertRuleUser($RuleID,$UserID,$Priority) {
		$insert=array(
			'FKRuleID'=>$RuleID,
			'Priority'=>$Priority,
			'FKUserID'=>$UserID,
			'Activ'=>1,
		);
		$this->db->insert('user_rules',$insert);
	}
	function deleteRuleUser($RuleID=0,$UserID=0,$Priority=-1) {
		$query="DELETE FROM user_rules WHERE ";
		if ($RuleID) {
			$where[]=" FKRuleID=".$this->db->escape($RuleID);
		}
		if ($UserID) {
			$where[]=" FKUserID=".$this->db->escape($UserID);
		}
		if ($Priority!=-1) {
			$where[]=" Priority=".$this->db->escape($Priority);
		}
		if ($where) {
			$this->db->query($query.implode(' AND ',$where));
		}
	}
	function getAllRules($ruleID=0) {
		$query="SELECT Perms,Name_".$this->lang." FROM Rules";
		if ($ruleID) $query.=" WHERE RuleID=".$this->db->escape($ruleID);
		$query.=" ORDER BY Name_".$this->lang;
		$this->db->query($query);
		while ($this->db->next_record()) {
				$rules[$this->db->f("Perms")]=$this->db->f("Name_".$this->lang);
		}
		return $rules;
	}
	function listAllRules() {
		$query="SELECT RuleID,Perms,Name_".$this->lang." FROM Rules";
		$query.=" ORDER BY Name_".$this->lang;
		$this->db->query($query);
		while ($this->db->next_record()) {
				$rules[$this->db->f("RuleID")]=array(
					'Perms'=>$this->db->f("Perms"),
					'Name'=>$this->db->f("Name_".$this->lang),
				);
		}
		return $rules;
	}
	function getRuleUsers($perms,$all=0) {
		$result=array();
		$query="SELECT Perms,FKUserID,Priority FROM user_rules INNER JOIN Rules ON RuleID=FKRuleID ";
		$query.=" WHERE Perms=".$this->db->escape($perms);
		if (!$all) $query.=" AND Activ=1";
		$query.=" ORDER BY Priority";
		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[$this->db->f('Perms')][$this->db->f('Priority')]=$this->db->f('FKUserID');
		}
		return $result;
	}
	function nameToUser($name) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'perms','Typ'=>'!=','Values'=>'deleted');

		$subQuery=array();
		$subQuery[]=array(array('Field'=>'username','Typ'=>'=','Values'=>$name));
		$sql='LOCATE(CONCAT(lastname,firstname),'.$this->db->escape(preg_replace('/[^a-z]/i','',$name)).')!=0';
		$subQuery[]=array(array('Typ'=>'SQL','Values'=>$sql));
		$sql='LOCATE(CONCAT(firstname,lastname),'.$this->db->escape(preg_replace('/[^a-z]/i','',$name)).')!=0';
		$subQuery[]=array(array('Typ'=>'SQL','Values'=>$sql));
		$searchQuery[]=array('Typ'=>'OR','Values'=>$subQuery);

		$query="SELECT user_id FROM auth_user_md5";
		$query.=" WHERE ".$this->db->getWhere($searchQuery);
		$this->db->query($query);
		while ($this->db->next_record()) {
			$result[]=$this->db->f('user_id');
		}
		//debug($result);
		return $result;
	}
	function listTimezones() {
		$locations=array();
		$zones = DateTimeZone::listIdentifiers();
		foreach ($zones as $zone) {
			$zone = explode('/', $zone); // 0 => Continent, 1 => City
			// Only use "friendly" continent names
			if ($zone[0] == 'Africa' || $zone[0] == 'America' || $zone[0] == 'Antarctica' || $zone[0] == 'Arctic' || $zone[0] == 'Asia' || $zone[0] == 'Atlantic' || $zone[0] == 'Australia' || $zone[0] == 'Europe' || $zone[0] == 'Indian' || $zone[0] == 'Pacific')	{
				if (isset($zone[1]) != '')	{
					$locations[$zone[0]][$zone[0]. '/' . $zone[1]] = str_replace('_', ' ', $zone[1]);
				}
			}
		}
		return $locations;
	}
	function getUniqeID() {
		return uniqid();
	}
	function calcAcl($permsU,$permsG,$uid=0) {
		$acl=0;
		if (!$uid) $uid=$this->getUser();
		if (preg_match("/\|".$uid.",([0-9]+)\|/",$permsU,$res)) {
			$acl=intval($res[1]);
		} else {
			$chunks=array_chunk($this->getMyGroups($uid),500);
			foreach($chunks as $grp) {
				if (preg_match_all("/\|(?:".implode('|',$grp)."),([0-9]+)/",$permsG,$res)) {
					foreach ($res[1] as $v) {
						$acl=$acl|intval($v);
					}
				}
			}
		}
		return $acl;
	}
	function normalizeSize($size) {
		if (preg_match('/^([\d\.]+)([KMG])$/i', $size, $match)) {
			$pos = array_search($match[2], array("K", "M", "G"));
			if ($pos !== false) {
				$size = $match[1] * pow(1024, $pos + 1);
			}
		}
		return $size;
	}
	function getMaxUpload() {
		$max_upload = FrameWork::normalizeSize(ini_get('upload_max_filesize'));
		if (ini_get('post_max_size')) {
			$max_upload = min($max_upload,FrameWork::normalizeSize(ini_get('post_max_size')));
		}
		return $max_upload;
	}
}
?>
