<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

class  simpleXls {
	var $ALIGN=array (
		'default'=>0x0,
		'left'=>0x1,
		'center'=>0x2,
		'right'=>0x3,
	);
	var $XLS = array (
			'BOF_REC' => array('ID'=>9,'LEN'=>4,'VERSION'=>7,'TYPE'=>0x10),
	//		'CODEPAGE' => array('ID'=>0x42,'LEN'=>2),
			'COL_WIDTH' => array('ID'=>36,'LEN'=>4),
			'CELL_TEXT' => array('ID'=>4,'LEN'=>8),
			'CELL_NUMBER' => array('ID'=>3,'LEN'=>0xF),
	//		'WINDOW1_REC' => array('ID'=>0x3D,'LEN'=>0xA),
	//		'WINDOW2_REC' => array('ID'=>0x3E,'LEN'=>0xE),
			'EOF_REC' => array('ID'=>0xA),
	);
	var $xls_data=array();
	var $col_width=array();
	var $totalcol=1;
	var $_col=0;
	var $_row=0;
	function simpleXls($maxcol=0) {
		if ($maxcol) $this->totalcol=$maxcol;
	}
 	function  &parseXls()   {
     	$this->xls_data['BOF_REC'] = pack('vvvv', $this->XLS['BOF_REC']['ID'],$this->XLS['BOF_REC']['LEN'],$this->XLS['BOF_REC']['VERSION'], $this->XLS['BOF_REC']['TYPE']);
		$this->xls_data['EOF_REC'] .= pack( "v", $this->XLS['EOF_REC']['ID']);
/*
		$this->xls_data['CODEPAGE']= pack('vvv', $this->XLS['CODEPAGE']['ID'], $this->XLS['CODEPAGE']['LEN'], 0x8001);
		$this->xls_data['WINDOW1_REC']= pack('vvvvvvCC', $this->XLS['WINDOW1_REC']['ID'], $this->XLS['WINDOW1_REC']['LEN'], 30, 30, 800 * 20, 600 * 20, FALSE, 0);
		$this->xls_data['WINDOW2_REC']= pack('vvCCCCCvvCCCCC', $this->XLS['WINDOW2_REC']['ID'], $this->XLS['WINDOW2_REC']['LEN'], FALSE, TRUE, TRUE, FALSE,TRUE,0,0, 1, 0, 0, 0, 0);
*/

		foreach ($this->col_width as $key=>$val) {
			$this->xls_data['COL_WIDTH'].=  pack('vvCCv', $this->XLS['COL_WIDTH']['ID'], $this->XLS['COL_WIDTH']['LEN'], $key, $key, (intval($val) * 256 + 182));
		}
		foreach ($this->XLS as $key=>$val) {
			if ($this->xls_data[$key]) {
				$result.=$this->xls_data[$key];
			}
		}
		return $result;
	}

   // write a Number (double) into row, col
	function WriteNumber_pos( $row, $col, &$value ) {
     		$len = strlen(strval($value));
			$this->col_width[$col]=max($this->col_width[$col],$len);
			$x = pack('d', $value);
			$this->xls_data['CELL_NUMBER'] .= pack( 'vvvvCCC', $this->XLS['CELL_NUMBER']['ID'], $this->XLS['CELL_NUMBER']['LEN'],$row, $col, 0,0,$this->ALIGN['right']).$x;
        	return;
     	}

     // write a label (text) into Row, Col
     	function WriteText_pos( $row, $col, &$value ) {
     		$len = strlen( $value );
			$this->col_width[$col]=max($this->col_width[$col],$len);
        	$this->xls_data['CELL_TEXT'].= pack( "vvvvCCCC", $this->XLS['CELL_TEXT']['ID'], $this->XLS['CELL_TEXT']['LEN'] + $len, $row, $col, 0,0,$this->ALIGN['default'],$len). $value;
        	return;
     	}

     // insert a number, increment row,col automatically
 	function InsertNumber( $value ) {
        	if ( $this->_col == $this->totalcol ) {
           		$this->_col = 0;
           		$this->_row++;
        	}
        	$this->WriteNumber_pos( $this->_row, $this->_col, $value );
        	$this->_col++;
        	return;
     	}
     // insert a text, increment row,col automatically
	function InsertText( $value ){
        	if ( $this->_col == $this->totalcol ) {
           		$this->_col = 0;
           		$this->_row++;
        	}
        	$this->WriteText_pos( $this->_row, $this->_col, $value );
        	$this->_col++;
        	return;
     	}

 	function fetchXls($filename)  {
        header ( "Expires: Mon, 1 Apr 1974 05:00:00 GMT" );
		header ( "Last-Modified: " . gmdate("D,d M YH:i:s") . " GMT" );
		header ( "Cache-Control: no-cache, must-revalidate" );
		header ( "Pragma: no-cache" );
		header ( "Content-type: application/x-msexcel" );
		header ( "Content-Disposition: attachment; filename=\"$filename.xls\"" );
		header ( "Content-Description: PHP Generated XLS Data" );
		print ($this->parseXls());
    }
	function getXls() {
		return $this->parseXls();
	}

}

