<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class FileObj {
	var $_meta=array();
	var $_pmeta=array();
	var $_fmeta=array();
	var $_acl;
	var $_ID;
	function getID() {
		return $this->_ID;
	}
	function setID($ID) {
		$this->_ID=$ID;
	}
	function getMeta($key) {
		return $this->_meta[$key];
	}
	function setMeta($key,$data) {
		$this->_meta[$key]=$data;
	}
	function getParentMeta($key) {
		return $this->_pmeta[$key];
	}
	function setParentMeta($key,$data) {
		$this->_pmeta[$key]=$data;
	}
	function setFileMeta($key,$data='') {
		if (is_array($key)) {
			$this->_fmeta=$key;
		} else {
			$this->_fmeta[$key]=$data;
		}
	}
	function getFileMeta($key) {
		return $this->_fmeta[$key];
	}
	function getName($lang='') {
		if (!$lang) $lang=$GLOBALS['session_lang'];
		return $this->_meta['Title_'.$lang];
	}
	function getACL($chk=0) {
		$chk=intval($chk);
		if ($chk) {
			if ($this->_acl==-1) {
				return true;
			} else {
				return ($this->_acl&$chk);
			}
		} else {
			return $this->_acl;
		}
	}
	function setAcl($acl) {
		$this->_acl=$acl;
	}
	function getAction($typ) {
		return $this->_action[$typ];
	}
	function getSite() {
		return $this->_site;
	}
	function isLink() {
		return false;
	}
	function isFolder() {
		return true;
	}
}

class FObj_fol extends FileObj   {
	var $_site='fmng.php';
	var $_action=array('b','b&edit=1');
	function FObj_fol($ID=0,$meta=0,$pmeta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.=$this->getMeta('MenuImage');
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='fol';
		if ($this->getMeta('Trash')) {
			$ac.='_tr';
		}
		if ($typ) $ac.='_l';
		return $ac;
	}
}

class FObj_ext extends FileObj   {
	var $_site='fmng.php';
	var $_action=array('fu','vo&edit=1');
	function FObj_ext($ID=0,$meta=0,$pmeta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($this->isLink()) {
			$image.='l_';
		}
		$image.=$this->getMeta('MenuImage');
		return $image;
	}
	function getActionMode() {
		$ac='ext';
		if ($this->getMeta('Trash')) {
			$ac.='_tr';
		}
		return $ac;
	}
	function isFolder() {
		return false;
	}
	function isLink() {
		if ($this->getMeta('Content') && $this->getMeta('Content')!=$this->_ID) {
			return true;
		}
	}	
}
class FObj_trash extends FileObj  {
	var $_site='fmng.php';
	var $_action=array('bt','bt');
	function FObj_trash($ID=0,$meta=0,$pmeta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.=$this->getMeta('MenuImage');
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='trash';
		if ($typ) {
			$ac.='_l';
		}
		return $ac;
	}

}
class Fmng {
	var $_db;
	var $_uid;
	var $_lang;
	var $_gid;
	var $_rule=false;
	var $_sadmin=false;
	var $_locked_obj=array();
	var $_clipboard=array();
	var $_modul='fmng';
	var $_dav=false;
	var $_Oss=false;
	var $_saveOssFileData=false;
	var $_maxMd5Size=0;
	function Fmng () {
		global $db,$frm;
		$this->_db=&$db;
		$this->_uid=$frm->getUser();
		$this->_lang=$frm->getLang();
		$this->_gid=$frm->getMyGroups();
		$this->_frm=&$frm;
		$this->_path=GE_DYN_PATH.'/'.GE_DOMAIN_PATH;
		$this->clearRule();
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
		$this->_Log=& $frm->getStaticModul('core_log');
		$this->_maxMd5Size=1024*1024*50;
		if ($this->getCfg('cfg/opensearch/host')) {
			require_once ('class_Opensearch.php');
			$this->_Oss=new Opensearch($this);
		}
	}
	function hasOss() {
		return $this->_Oss?true:false;
	}
	function setDavOn($bool=true) {
		$this->_dav=$bool;
	}
	function getModul() {
		return $this->_modul;
	}
	function setUser($uid) {
		$this->_uid=$uid;
	}
	function getUser() {
		return $this->_uid;
	}
	function setGroups($gid) {
		$this->_gid=$gid;
	}
	function setLang($lang) {
		$this->_lang=$lang;
	}
	function setRule($bool=false) {
		$this->_rule=$bool;
	}
	function clearRule($bool=false) {
		$this->_rule=$this->_frm->isRuleUser(array('sysadmin','fmng'));
	}
	function setSuperAdmin($bool=false) {
		$this->_sadmin=$bool;
	}
	function setLocked($locked) {
		$this->_locked_obj=$locked_obj;
	}
	function isLocked(&$obj) {
		if ($this->_locked_obj[$obj->getID()]) {
			return true;
		} else {
			return false;
		}
	}
	function setClipboard($what,$content) {
		$this->_clipboard[$what]=$content;
	}
	function getClipboard($what) {
		return $this->_clipboard[$what];
	}
	function isClipboard($what) {
		if ($this->_clipboard[$what]) {
			return true;
		} else {
			return false;
		}
	}
	function isRuleUser() {
		return $this->_rule;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function setCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}
		}
	}
	function getCfg($key) {
		if (isset($this->_cfg[$key])) {
			return $this->_cfg[$key];
		} else {
			return false;
		}
	}
	function setRootObj(&$obj) {
		$this->_root_obj=&$obj;
	}
	function &getRootObj() {
		return $this->_root_obj;
	}
	function setMode($mode) {
		$this->_mode=$mode;
	}
	function getMode() {
		return $this->_mode;
	}
	function &searchObj (&$rows,$b=0,$limit=0,$search_sql='',$order='',$use_limit=false,$use_perms=true) {
		$result=array();
		$query="SELECT FileParent.*,FileMetabase.*,Favorite,FileSize,TimeDl,Counter FROM FileParent,FileMetabase ";
		$query.="LEFT JOIN FileObject ON (FileObject.Version=FileMetabase.Version AND FileObject.FileID=Content AND  FileObject.Modul=".$this->_db->escape($this->getModul()).") ";
		$query.="LEFT JOIN FileLastDl ON (FKFileID=FileID AND FileLastDl.FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.="LEFT JOIN FileHotlist ON (FileHotlist.FKDocID=DocID AND FileHotlist.FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.=" WHERE FileParent.FKDocID=DocID ";
		$query.=" AND (UserID=0 OR UserID=".$this->_db->escape($this->_uid).')';
		if (!$this->isRuleUser() && $use_perms) $query.=" AND (UserID='".$this->_uid."' OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
		if (is_array($search_sql)) {
			$query.="AND ".$this->_db->getWhere($search_sql);
		} elseif ($search_sql) {
			$query.="AND $search_sql ";
		}
		if ($order) $query.=" ORDER BY $order ";
		if ($limit) $query.=$this->_db->formatLimit($b,$limit).' ';
		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		while ($this->_db->next_record()) {
			$class='FObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			//echo $acl.'<br>';
			if ($acl || !$use_perms) {
				$result[$this->_db->f("DocID")]=new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
				$result[$this->_db->f("DocID")]->setFileMeta($this->fetchFileMeta());
			}

		}
		if ($use_limit && $limit && ($b!=0 || $limit==$rows)) {
			$query="SELECT count(*) as num FROM FileParent,FileMetabase ";
			$query.="LEFT JOIN FileObject ON (FileObject.Version=FileMetabase.Version AND FileObject.FileID=Content AND FileObject.Modul=".$this->_db->escape($this->getModul()).") ";
			$query.="LEFT JOIN FileLastDl ON (FKFileID=FileID AND FileLastDl.FKUserID=".$this->_db->escape($this->_uid).") ";
			$query.="LEFT JOIN FileHotlist ON (FileHotlist.FKDocID=DocID AND FileHotlist.FKUserID=".$this->_db->escape($this->_uid).") ";
			$query.=" WHERE FileParent.FKDocID=DocID ";
			$query.=" AND (UserID=0 OR UserID=".$this->_db->escape($this->_uid).')';
			if (!$this->isRuleUser() && $use_perms) $query.=" AND (UserID='".$this->_uid."' OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
			if (is_array($search_sql)) {
				$query.="AND ".$this->_db->getWhere($search_sql);
			} elseif ($search_sql) {
				$query.="AND $search_sql ";
			}
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
		}
		return $result;
	}
	function &crawlDocuments($search) {
		$numOk=0;
		if ($this->_Oss) {
			if ($search['reconstruct']) {
				$search['DocType']=false;
				$search['allVersions']=1;
				$search['updateFiles']=1;
				$this->_Oss->init(true);
			}
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'FileParent.FKDocID','Typ'=>'F=F','Values'=>'FileMetabase.DocID');
			if ($search['DocType']) {
				$searchQuery[]=array('Field'=>'FileMetabase.DocType','Typ'=>'=','Values'=>$search['DocType']);
			}

			$query="SELECT FileParent.*,FileMetabase.* FROM FileParent,FileMetabase ";
			$query.="WHERE ".$this->_db->getWhere($searchQuery);


			$this->_db->query($query);
			$result=array();
			while ($this->_db->next_record()) {
				$class='FObj_'.$this->_db->f("DocType");
				$result[$this->_db->f("DocID")]=new $class($this->_db->f("DocID"),$this->fetchObject(array('de','it','en','fr','es')),$this->fetchParent(),-1);
			}
			foreach($result as $doc) {
				//print_r($doc);
				$ok=$this->_Oss->updateDocument($doc,$search['allVersions']?0:$doc->getMeta('Version'),$search['updateFiles'],$search['reconstruct']);
				if ($ok) $numOk++;
			}
		}
		return $numOk;
	}
		
	function &searchDocument(&$rows,$search,$b=0,$limit=0,$order=array()) {
		if ($this->_Oss) {
			if ($search['SortScore']>0) {
				$order=array('_Score'=>-1) + $order;
			}
			return $this->_Oss->searchDocument($rows,$search,$b,$limit,$order);
		} else {
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);
			if ($search['Info']) {
				$searchQuery[]=array('Field'=>array('Title_de','Title_it','Title_en','Title_fr','Title_es','Text'),'Typ'=>'concat','Values'=>'Info');
			}
			if ($search['UserCreate']) {
				$searchQuery[]=array('Field'=>'UserCreate','Typ'=>'=','Values'=>$search['UserCreate']);
			}
			if ($search['UserModify']) {
				$searchQuery[]=array('Field'=>'UserModify','Typ'=>'=','Values'=>$search['UserModify']);
			}
			if ($search['TimeCreateB'] && $search['TimeCreateE']) {
				$searchQuery[]=array('Field'=>'TimeCreate','Typ'=>'>=','Values'=>$search['TimeCreateB']);
				$searchQuery[]=array('Field'=>'TimeCreate','Typ'=>'<=','Values'=>$search['TimeCreateE']);
			}
			if ($search['TimeModifyB'] && $search['TimeModifyE']) {
				$searchQuery[]=array('Field'=>'TimeModify','Typ'=>'>=','Values'=>$search['TimeModifyB']);
				$searchQuery[]=array('Field'=>'TimeModify','Typ'=>'<=','Values'=>$search['TimeModifyE']);
			}
			$sqlOrder='DocType DESC';
			foreach($order as $k=>$v) {
				$sqlOrder.=', '.$k.($k==-1?' DESC':' ASC');
			}

			return $this->searchObj($rows,$b,$limit,$searchQuery,$sqlOrder,true);
		}
	}
	function &searchProfileObj($parentID,$Name) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FileParent.FKDocID','Typ'=>'F=F','Values'=>'FileMetabase.DocID');
		$searchQuery[]=array('Field'=>'FileParent.ParentID','Typ'=>'=','Values'=>$parentID);
		$searchQuery[]=array('Field'=>'FileMetabase.DocType','Typ'=>'=','Values'=>'fol');
		$searchQuery[]=array('Field'=>'FileMetabase.Title_'.$this->_lang,'Typ'=>'=','Values'=>$Name);

		$query="SELECT * FROM FileParent,FileMetabase WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {

			return new FObj_fol($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),0);
		}
	}
	function &ListAllTree($RootID=-1,$ParentID=-1,$order_f='Title_de',$order_d='ASC',$app='',$use_perms=true,$trash=0) {
		$result=array();
		if ($order_f) $order_met="ORDER BY $order_f $order_d";

		$where[]="FileParent.FKDocID=DocID";
		//debug($app);
		if ($app && !empty($app)) {
			$sql_app=$this->_db->escape($app);
			if (is_array($app) && count($app)) $where[]="DocType IN (".implode(",",$sql_app).")";
			elseif  ($app) $where[]="DocType=$sql_app";
		}
		if (!$trash) {
			$where[]="Trash=0";
		} elseif ($trash>0) {
			$where[]="Trash=".(int)$trash;
		}

		$sql_RootID=$this->_db->escape($RootID);
		if (is_array($RootID)) $where[]="RootID IN (".implode(",",$sql_RootID).")";
		elseif ($RootID!=-1)  $where[]="RootID=$sql_RootID";

		$sql_ParentID=$this->_db->escape($ParentID);
		if (is_array($ParentID)) $where[]="ParentID IN (".implode(",",$sql_ParentID).")";
		elseif ($ParentID!=-1)  $where[]="ParentID=$sql_ParentID";


		if (!$this->isRuleUser() && $use_perms) {
			$where[]="(UserID='".$this->_uid."' OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
		}

		$query="SELECT * FROM FileParent,FileMetabase ";
		$query.="LEFT JOIN FileObject ON (FileObject.Version=FileMetabase.Version AND FileObject.FileID=Content AND FileObject.Modul=".$this->_db->escape($this->getModul()).") ";
		$query.=" WHERE  ".implode(' AND ',$where)." $order_met";
		//echo $query.'<br><br>';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='FObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				$result[$this->_db->f("ParentID")][$this->_db->f("DocID")]=new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
				$result[$this->_db->f("ParentID")][$this->_db->f("DocID")]->setFileMeta($this->fetchFileMeta());
			}

		}
		return $result;
	}
	function &ListTrashTree($rootObj,$order_f='Title_de',$order_d='ASC',$app='',$use_perms=true) {
		$tree=$this->ListAllTree(-1,-1,$order_f,$order_d,$app,$use_perms,1);
		//debug($tree);
		unset($tree[0]);
		if (!empty($tree)) {
			$parentIds=array_keys($tree);
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'FileMetabase.DocID','Typ'=>'=','Values'=>$parentIds);
			//$searchQuery[]=array('Field'=>'FileMetabase.Trash','Typ'=>'=','Values'=>0);

			$query="SELECT DocID,Trash FROM FileMetabase WHERE ".$this->_db->getWhere($searchQuery);
			$this->_db->query($query);
			$found=array();
			while($this->_db->next_record()) {
				$found[$this->_db->f('DocID')]=$this->_db->f('Trash');
			}
			if (!isset($tree[$rootObj->getID()])) $tree[$rootObj->getID()]=array();
			foreach($parentIds as $id) {
				if (!isset($found[$id]) || !$found[$id]) {
					foreach($tree[$id] as $k=>$v) {
						$tree[$rootObj->getID()][$k]=$v;
					}
					unset($tree[$id]);
				}
			}
		}
		return $tree;
	}


	function &ListSubEntrys($ParentID,$app='',$order_f='Title_de',$order_d='ASC',$use_perms=true,$trash=0) {
		$result=array();
		if ($order_f) $order_met="ORDER BY $order_f $order_d";

		$where[]="FileParent.FKDocID=DocID";
		$sql_app=$this->_db->escape($app);
		if (is_array($app)) $where[]="DocType IN (".implode(",",$sql_app).")";
		elseif  ($app) $where[]="DocType=$sql_app";
		if (!$trash) {
			$where[]="Trash=0";
		}

		$sql_ParentID=$this->_db->escape($ParentID);
		if (is_array($ParentID)) $where[]="ParentID IN (".implode(",",$sql_ParentID).")";
		else $where[]="ParentID=$sql_ParentID";

		if (!$this->isRuleUser() && $use_perms) $where[]="(UserID='".$this->_uid."' OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";

		$query="SELECT FileParent.*,FileMetabase.*,Favorite,FileSize,FilePath,MimeType,TimeDl,Counter FROM FileParent,FileMetabase ";
		$query.="LEFT JOIN FileObject ON (FileObject.Version=FileMetabase.Version AND FileObject.FileID=Content AND FileObject.Modul=".$this->_db->escape($this->getModul()).") ";
		$query.="LEFT JOIN FileLastDl ON (FKFileID=FileID AND FileLastDl.FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.="LEFT JOIN FileHotlist ON (FileHotlist.FKDocID=DocID AND FileHotlist.FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.=" WHERE  ".implode(' AND ',$where)." $order_met";

		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='FObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				$result[$this->_db->f("DocID")]=new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
				$result[$this->_db->f("DocID")]->setFileMeta($this->fetchFileMeta());

			}

		}
		return $result;
	}
	function &listSubTree($params,$onlyApps=true) {
		//debug($params['ParentID']);
		return $this->ListSubEntrys($params['ParentID'],'fol','','',true);
    }
	function &isSubTreeLen($params,$onlyApps=true) {
		return true;
    }
	function &ListRootObj($use_perms=true) {
		$result=array();
		$query="SELECT * FROM FileParent,FileMetabase WHERE FileParent.FKDocID=DocID";
		$query.=" AND ParentID=0 AND (System='s' OR UserID=".$this->_db->escape($this->_uid).')';
		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='FObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				$result[$this->_db->f("DocID")]=new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}

		}
		return $result;
	}
	function getSystemObj($system,$lang,$user=-1,$use_perms=true) {
		if ($user==-1) $user=$this->_uid;
		$query="SELECT * FROM FileMetabase,FileParent WHERE FileParent.FKDocID=DocID AND System=".$this->_db->escape($system);
		$query.=" AND UserID=".$this->_db->escape($user);
		//echo $query;
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='FObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				return new $class($this->_db->f("DocID"),$this->fetchObject($lang),$this->fetchParent(),$acl);
			}
		}
	}

	function getLinkedObj($ID,$all=false,$trash=0) {
		$result=array();
		$query="SELECT * FROM FileParent,FileMetabase WHERE FileParent.FKDocID=DocID AND Content=".$this->_db->escape($ID);
		if (!$all) $query.=" AND DocID!=".$this->_db->escape($ID);
		if (!$trash) {
			$query.=" AND Trash=0";
		} elseif ($trash>0) {
			$query.=" AND Trash=".(int)$trash;
		}
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='FObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl) {
				$result[$this->_db->f("DocID")]= new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}
		}
		return $result;
	}
	function nameExists($Name,$ParentID,$ObjID,$Lang) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FileParent.FKDocID','Typ'=>'F=F','Values'=>'FileMetabase.DocID');
		$searchQuery[]=array('Field'=>'FileParent.ParentID','Typ'=>'=','Values'=>$ParentID);
		if ($ObjID) $searchQuery[]=array('Field'=>'FileMetabase.DocID','Typ'=>'!=','Values'=>$ObjID);
		$searchQuery[]=array('Field'=>'FileMetabase.Title_'.$Lang,'Typ'=>'=','Values'=>$Name);
		$searchQuery[]=array('Field'=>'FileMetabase.Trash','Typ'=>'=','Values'=>0);
		$query="SELECT FileMetabase.DocID FROM FileParent,FileMetabase WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('DocID');
		}
		return false;
	}
	function getNextName($Name,$ParentID,$ObjID,$Lang) {
		$result='';
		$temp=array();
		if (!trim($Name)) $Name='No Name';
		if (preg_match('@\.((tar.)?[a-zA-Z0-9]*)$@',$Name,$temp)) {
			$ext='.'.$temp[1];
			$result=preg_replace('/\.((tar.)?[a-z0-9]*)$/i','',$Name);
		} else {
			$ext='';
			$result=$Name;
		}
		if ($ParentID) {
			while ($this->nameExists($result.$ext,$ParentID,$ObjID,$Lang)) {
				$temp=array();
				if (preg_match('/_([0-9]+)$/',$result,$temp)) {
					$result=preg_replace('/_([0-9]+)$/','_'.(intval($temp[1])+1),$result);
				} else {
					$result=$result.'_1';
				}
			}
		}
		return $result.$ext;
	}
	
	function updateMeta(&$obj,$update_oss_file=true) {
		if ($obj->getID()) {
			$mFields=array();
			$oldObj=$this->getObj($obj->getID(),'',false);
			if (!is_object($oldObj)) {
				//debugFile('noOldObj:'.print_r($obj,1),1);
			}
			$mFields=array();$mValues=array();
			$mFields[]='Title_'.$this->_lang;
			$mFields[]='Text';
			$mFields[]='Version';

			$defName=$obj->getMeta('Title_'.$this->_frm->getLang());
			foreach ($this->_frm->getAvLang() as $val) {
				$tmpName=$this->getNextName($obj->getMeta('Title_'.$val)?$obj->getMeta('Title_'.$val):$defName,$obj->getParentMeta('ParentID'),$obj->getID(),$val);
				$obj->setMeta('Title_'.$val,$tmpName);
			}
			foreach ($mFields as $key) {
				if ($oldObj->getMeta($key)!=$obj->getMeta($key)) {
					$mValues[$key]=array($oldObj->getMeta($key),$obj->getMeta($key));
				}
			}
			$values=$obj->_meta;
			//debugFile('UpdateMeta:'.print_r($obj,1),1);
			if ($this->_db->update('FileMetabase',$values,"DocID=".$this->_db->escape($obj->getID()))) {
				if (!empty($mValues)) {
					$LogID=$this->_Log->insertLog($this->getModul(),$obj->getID(),$this->getUser(),'update');
					foreach ($mValues as $key=>$val) {
						$this->_Log->insertLogValues($LogID,$key,$val[0],$val[1]);
					}
				}
				if ($obj->getMeta('Trash') && !$oldObj->getMeta('Trash')) {
					$LogID=$this->_Log->insertLog($this->getModul(),$obj->getID(),$this->getUser(),'delete');
				} 

			}
			if ($this->_Oss && $obj->getMeta('DocType')=='ext') {
				$this->_Oss->updateDocument($obj,$obj->getMeta('Version'),$update_oss_file);
			}
			return $obj->getID();
		}
		return false;
	}
	function insertMeta(&$obj) {
		$defName=$obj->getMeta('Title_'.$this->_frm->getLang());
		foreach ($this->_frm->getAvLang() as $val) {
			$tmpName=$this->getNextName($obj->getMeta('Title_'.$val)?$obj->getMeta('Title_'.$val):$defName,$obj->getParentMeta('ParentID'),0,$val);
			$obj->setMeta('Title_'.$val,$tmpName);
		}
		$values=$obj->_meta;
		$values['DocID']=$this->_db->nextid('FileMetabase');
		//debugFile('InsertMeta:'.print_r($obj,1),1);
		if ($this->_db->insert('FileMetabase',$values)) {
			$obj->setID($values['DocID']);
			$LogID=$this->_Log->insertLog($this->getModul(),$obj->getID(),$this->getUser(),'create');
			return $obj->getID();
		}
		return false;
	}
	function deleteMeta(&$obj) {
		if ($this->_Oss && $obj->getMeta('DocType')=='ext') {
			$this->_Oss->deleteDocument($obj,0);
		}
		$query="DELETE FROM FileMetabase WHERE DocID=".$this->_db->escape($obj->getID());
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function updateParentMeta(&$obj) {
		$updateMeta=false;
		if ($obj->getID()) {
			$oldObj=$this->getObj($obj->getID(),'',false);

			$oldNode=$oldObj->getParentMeta('ParentID');
			$newNode=$obj->getParentMeta('ParentID');

			if ($oldNode!=$newNode) {
				$LogID=$this->_Log->insertLog($this->getModul(),$obj->getID(),$this->getUser(),'move');
				$this->_Log->insertLogValues($LogID,'cat',$oldNode,$newNode);
				$updateMeta=true;
			}
			$values=$obj->_pmeta;
			$this->_db->update('FileParent',$values,"FKDocID=".$this->_db->escape($obj->getID()));
			if ($oldObj->getParentMeta('UserID')!=$obj->getParentMeta('UserID') && !$obj->isFolder() && !$obj->isLink()) {
				//Bei move auf andere Root File verschieben.
				$this->moveFile($obj,$this->getModul(),$obj->getID(),$obj->getMeta('Version'));
			}
			if ($updateMeta) {
				//Bei move eventuell Namen aendern falls schon eine Datei existiert.
				$this->updateMeta($obj,false);
				if ($this->_Oss && $obj->getMeta('DocType')=='ext') {
					//Oss updaten, alle Versionen aber ohne File-Content;
					$this->_Oss->updateDocument($obj,0,false);
				}
			}
			return $obj->getID();
		}
		return false;
	}
	function insertParentMeta(&$obj) {
		$values=$obj->_pmeta;
		if ($obj->getID()) {
			$values['FKDocID']=$obj->getID();
			$this->_db->insert('FileParent',$values);
			return $obj->getID();
		}
		return false;
	}
	function deleteParentMeta(&$obj) {
		$query="DELETE FROM FileParent WHERE FKDocID=".$this->_db->escape($obj->getID());
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function getObj($ID,$lang='',$use_perms=true,$Version=0) {
		$query="SELECT FileParent.*,FileMetabase.*,Favorite,FileSize,TimeDl,Counter,FileObject.Version as FileVersion FROM FileParent,FileMetabase ";
		$query.="LEFT JOIN FileObject ON (FileObject.Version=".($Version?(int)$Version:'FileMetabase.Version')." AND FileObject.FileID=Content AND FileObject.Modul=".$this->_db->escape($this->getModul()).") ";

		$query.="LEFT JOIN FileLastDl ON (FKFileID=FileID AND FileLastDl.FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.="LEFT JOIN FileHotlist ON (FileHotlist.FKDocID=DocID AND FileHotlist.FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.=" WHERE FileParent.FKDocID=DocID AND DocID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='FObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				$obj=new $class($this->_db->f("DocID"),$this->fetchObject($lang),$this->fetchParent(),$acl);
				$obj->setFileMeta($this->fetchFileMeta());
				return $obj;
			}
		}
	}
	function getTrashObj() {
		$query="SELECT * FROM FileMetabase,FileParent WHERE FKDocID=DocID AND DocType='trash'";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='FObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl) {
				return new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}
		}
	}

	function getObjTree ($oid) {
		do {
			$query="SELECT Title_".$this->_lang.",ParentID FROM FileMetabase,FileParent WHERE ParentID=DocID AND FKDocID!=RootID AND FKDocID=".$this->_db->escape($oid);
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				$oid=$this->_db->f('ParentID');
				$result[$this->_db->f('ParentID')]=$this->_db->f('Title_'.$this->_lang);
			} else {
				$oid=0;
			}

		} while ($oid);
		return $result;
	}
	function getObjTreeIDs ($oid,$break=0) {
		if ($oid!=$break) {
			do {
				$query="SELECT ParentID FROM FileParent WHERE FKDocID=".$this->_db->escape($oid);
				$this->_db->query($query);
				if ($this->_db->next_record()) {
					$oid=$this->_db->f('ParentID');
					$result[]=$this->_db->f('ParentID');
				} else {
					$oid=0;
				}

			} while ($oid && $oid!=$break);
		} else {
			$result[]=$oid;
		}
		return $result;
	}
	function isSubfolder($FolderID,$subFolderID) {
		if ($FolderID==$subFolderID) return true;
		$tree=$this->getObjTreeIDs ($FolderID);
		if (is_array($tree) && in_array($subFolderID,$tree)) {
			return true;
		} else {
			return false;
		}
	}
	function setOrder($ID,$o,$a) {
		$values=array(
			'FKDocID'=>$ID,
			'FKUserID'=>$this->_uid,
			'FileOrder'=>$o,
			'FileAsc'=>$a,

		);
		$this->_db->insert('FileOrder',$values,'',1);
	}
	function getOrder($ID) {
		$query="SELECT FileOrder,FileAsc FROM FileOrder WHERE FKDocID=".$this->_db->escape($ID);
		$query.=" AND FKUserID=".$this->_db->escape($this->_uid);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return array (
				'FileOrder'=>$this->_db->f('FileOrder'),
				'FileAsc'=>$this->_db->f('FileAsc'),
			);
		}

	}
	function deleteOrder($ID=0,$uid=0) {
		if (!$ID && !$uid) return false;
		if ($ID) $where[]="FKDocID=".$this->_db->escape($ID);
		if ($uid) $where[]="FKUserID=".$this->_db->escape($uid);
		$query="DELETE FROM FileOrder WHERE ".implode(' AND ',$where);
		$this->_db->query($query);
	}

	function getContentACL(&$obj) {
		if (!is_object($obj) || $obj->isFolder()) return 0;
		if ($this->isRuleUser()) {
			return -1;
		} elseif (!$obj->getMeta('Content') || $obj->getID()==$obj->getMeta('Content')) {
			return $obj->getACL();
		} else {
			$query="SELECT Users,Groups,UserID FROM FileMetabase,FileParent WHERE FKDocID=DocID ";
			$query.=" AND  DocID=".intval($obj->getMeta('Content'));
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				return $this->fetchACL();
			} else {
				return 0;
			}
		}
	}
	function fetchACL() {
		//echo $this->_db->f('Title_de').'-'.$this->_db->f('UserID').'<br>';
		if (($this->isRuleUser() && !$this->_db->f('UserID')) || $this->_db->f('UserID')==$this->_uid) {
			return -1;
		} else {
			return $this->_frm->calcAcl($this->_db->f('Users'),$this->_db->f('Groups'),$this->_uid);
		}
	}
	function &fetchObject($lang='') {
		$result=array(
			'Text'=>$this->_db->f("Text"),
			'MenuImage'=>$this->_db->f("MenuImage"),
			'Version'=>$this->_db->f('Version'),
			'TimeCreate'=>$this->_db->f("TimeCreate"),
			'TimeModify'=>$this->_db->f("TimeModify"),
			'UserCreate'=>$this->_db->f("UserCreate"),
			'UserModify'=>$this->_db->f("UserModify"),
			'DocType'=>$this->_db->f("DocType"),
			'DocImage'=>$this->_db->f("DocImage"),
			'DocMode'=>$this->_db->f("DocMode"),
			'Users'=>$this->_db->f("Users"),
			'Groups'=>$this->_db->f("Groups"),
			'Content'=>$this->_db->f('Content'),
			'System'=>$this->_db->f('System'),
			'Trash'=>$this->_db->f('Trash'),
		);
		if (!$lang) $lang=$this->_lang;
		if (is_array($lang)) {
			foreach ($lang as $val) {
				$result['Title_'.$val]=$this->_db->f("Title_".$val);
			}

		} else {
			$result['Title_'.$lang]=$this->_db->f("Title_".$lang);
		}
		if ($this->_dav) {
			$result['DavProperties']=$this->_db->f('DavProperties');
		}
		return $result;
	}
	function fetchParent() {
		return array(
			'ParentID'=>$this->_db->f('ParentID'),
			'RootID'=>$this->_db->f('RootID'),
			'UserID'=>$this->_db->f('UserID'),
		);
	}
	function fetchFileMeta() {
		return array(
			'FileSize'=>$this->_db->f('FileSize'),
			'FilePath'=>$this->_db->f('FilePath')?($this->_path.'other/'.$this->_db->f('FileDir').basename($this->_db->f('FilePath'))):'',
			'MimeType'=>$this->_db->f('MimeType'),
			'Favorite'=>$this->_db->f('Favorite'),
			'TimeDl'=>$this->_db->f('TimeDl'),
			'Counter'=>$this->_db->f('Counter'),
			'Version'=>$this->_db->f('FileVersion'),
			'Md5Sum'=>$this->_db->f('Md5Sum'),
		);
	}
	function isAllowedAction(&$obj,&$action) {
		if (!is_array($action)) return false;
		if (in_array('c_perms',$action['Extra'])) {
			$acl=$this->getContentAcl($obj);
			if (!($acl&$action['Perms']) && $acl!=-1) return false;
		} else {
			if (!$obj->getAcl($action['Perms'])) return false;
		}
		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkAction($obj,substr($ac_val,1));
				} else {
					$result=$result||$this->_checkAction($obj,$ac_val);
				}
			}
			if (!$result) return false;
		}
		return true;
	}
	function _checkAction(&$obj,$action) {
		switch ($action) {
			case 'sadmin':
				if (!$this->isSuperAdmin()) return false;
			break;
			case 'rule':
				if (!$this->isRuleUser()) return false;
			break;
			case 'locked':
				if (!$this->isLocked($obj)) return false;
			break;
			case 'fav':
				if (!$obj->getFileMeta('Favorite')) return false;
			break;
			case 'content':
				if (!$this->isClipboard('fobj')) return false;
			break;
			case 'root':
				if ($obj->getParentMeta('RootID')!=$obj->getID()) return false;
			break;
			case 'no_ext':
				if (!$this->getCfg('fol/no_extl')) return false;
			break;
			case 'no_fol':
				if (!$this->getCfg('fol/no_fol')) return false;
			break;
			case 'root_s':
				if ($this->_root_obj->getMeta('System')!='s') return false;
			break;
			case 'root_d':
				if ($this->_root_obj->getMeta('System')!='d') return false;
			break;
			case 'root_u':
				if ($this->_root_obj->getMeta('System')!='u') return false;
			break;
			case 'app_msg':
				if (!$GLOBALS['app']['msg']) return false;
			break;
			case 'app_mail':
				if (!$GLOBALS['app']['email']) return false;
			break;
		}
		return true;
	}
	function getExt($File) {
		$data=$this->getExtData($File);
		return $data['ext'];
	}
	function getExtData($File) {
		$result=array(
			'ext'=>'',
			'path'=>$this->_path.'other',
			'img'=>'other.gif',
			'mime'=>$File['type']?$File['type']:'application/octet-stream',
		);
		$searchQuery=array();
		if (preg_match('@\.((tar.)?[a-zA-Z0-9]*)$@',$File['name'],$temp)) {
			$ext=$temp[1];
			$searchQuery[]=array('Field'=>'Extension','Typ'=>'like','Values'=>'%'.$ext.'%');
			$result['ext']=$ext;
		} else {
			if ((!$File['type'] || $File['type']=='application/octet-stream') && file_exists($File['tmp_name'])) {
				$File['type']=FrameWork::getMimeFile($File['tmp_name']);
			}
			if($File['type']) {
				$searchQuery[]=array('Field'=>'Mime_Type','Typ'=>'=','Values'=>$File['type']);
			}
		}
		//debug($searchQuery);
		if (!empty($searchQuery)) {
			$query="SELECT Path,Image,Extension,Mime_Type FROM Mime_Types WHERE ".$this->_db->getWhere($searchQuery);
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				if ($this->_db->f('Extension')) {
					$temp=explode(',',$this->_db->f('Extension'));
					$result['ext']=$temp[0];
				}
				if ($this->_db->f('Path')) {
					$result['path']=$this->_path.$this->_db->f('Path');
				}
				if ($this->_db->f('Image')) {
					$result['img']=$this->_db->f('Image');
				}
				if ($this->_db->f('Mime_Type')) {
					$result['mime']=$this->_path.$this->_db->f('Mime_Type');
				}
			}
		}
		//debug($result);exit;
		return $result;
	}
	function replaceExt($Name,$ext) {
		if ($Name) {
			$Name=preg_replace('/\.((tar.)?[a-z0-9]*)$/i','',$Name);
			if ($ext) {
				return $Name.'.'.$ext;
			} else {
				return $Name;
			}
		}
		return '';
	}
	function getUserDir($obj) {
		$dir=$obj->getParentMeta('UserID').'/';
		$dir.=chr(mt_rand(97, 97+25)).'/';
		return $dir;
	}
	function replaceFile($obj,$Modul,$FileID,$File) {
		//debug($File);
		if ($File['tmp_name'] && file_exists($File['tmp_name'])) {
			$verror=FrameWork::scanFile($File['tmp_name']);
			if ($verror) {
				return 'FileVirus';
			} else {
				$extData=$this->getExtData($File);
				//debug($extData);
				//exit;
				$dir=is_object($obj)?$this->getUserDir($obj):'';
				$img=$extData['img'];
				$path=$extData['path'].'/'.$dir;
				$ext=$extData['ext'];
				if (!file_exists($path)) {
					mkdir($path,0755,true);
				}
				//echo $path;
				if (file_exists($path) && is_writable($path)) {
					$FilePath=tempnam($path,'ext');
					unlink($FilePath);
					//echo $FilePath;
					if ($ext) $FilePath.='.'.$ext;
					if (copy($File['tmp_name'],$FilePath)) {
						$replace=1;
						$changed=0;
						$old_version=(is_object($obj) && $obj->getMeta('Version'))?$obj->getMeta('Version'):1;
						$new_version=$old_version;
						$old_values=$this->readFile($this->getModul(),$FileID,$old_version);

						$fsize=filesize($FilePath);
						if ($fsize < $this->_maxMd5Size) {
							$md5=Framework::getMd5Sum($FilePath);
							if ($old_values && $md5!=$old_values['Md5Sum']) {
								$changed=true;
							}
						} else {
							$md5=md5($FilePath);
							if ($old_values && ($old_values['FileSize']!=$fsize || (is_object($obj) && filemtime($FilePath) > $obj->getMeta('TimeModify')))) {
								$changed=true;
							}
						}
						
						if ($old_values) {
							if (is_object($obj) && $this->getCfg('cfg/versioning/active') && !$this->isTempFileName($obj->getName($this->_lang)) && $changed) {
								$new_version=$old_version+=1;
								$replace=0;
								//Versioning alte Datei behalten eventuell umbenenen;
								/*
								if ($old_values['FilePath'] && file_exists($old_values['FilePath'])) {
									copy($old_values['FilePath'],$old_values['FilePath'].'.old');
									DB Update;
								}
								*/
								//
							} elseif ($old_values['FilePath'] && file_exists($old_values['FilePath'])) {
								//Kein Versioning alten Datei loeschen;
								unlink($old_values['FilePath']);
							}
						}
						$values=array(
							'FileID'=>$FileID,
							'Modul'=>$Modul,
							'Version'=>$new_version,
							'UserModify'=>$this->_uid,
							'TimeModify'=>time(),
							'FilePath'=>basename($FilePath),
							'FileDir'=>$dir,
							'FileSize'=>filesize($FilePath),
							'MimeType'=>$File['type'],
							'Md5Sum'=>$md5,
							'FileImg'=>$img,
						);
						$this->_db->insert('FileObject',$values,0,$replace);
						if (is_object($obj)) {
							$obj->setMeta('Content',$FileID);
							$obj->setMeta('Version',$new_version);
							$obj->setMeta('MenuImage',$img);
							if ($old_values) {
								$LogID=$this->_Log->insertLog($this->getModul(),$obj->getID(),$this->getUser(),'upload');
								$this->_Log->insertLogValues($LogID,'Upload',serialize($old_values),serialize($values));
								if (!$replace) {
									//Alle Versionen der verlinkten Files updaten;
									$this->syncLinkedFiles($obj);
									//Alle alten Versionen entfernen.
									$this->deleteOldVersions($obj);
								}
							}
							return false;	
						}
					} else {
						return 'WriteError';
					}
				} else {
					return 'WriteError';
				}

			}
		} else {
			if ($File['error']==1) {
				return 'no_valid_file';
			}
			return 'no_valid_file';
		}
	}
	function readFile($Modul,$FileID,$Version=1) {
		$rows=0;
		$result=$this->searchFile($Modul,$FileID,$rows,0,0,array('Version'=>$Version));
		if (!empty($result)) {
			return $result[count($result)-1];
		} else {
			return false;
		}
	}
	function searchFile($Modul,$FileID,&$rows,$b=0,$limit=0,$search=array(),$order='Version ASC') {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'Modul','Typ'=>'=','Values'=>$Modul);
		$searchQuery[]=array('Field'=>'FileID','Typ'=>'=','Values'=>$FileID);
		if ($search['Version']) {
			$searchQuery[]=array('Field'=>'Version','Typ'=>'=','Values'=>$search['Version']);
		}
		if ($search['VersionFrom']) {
			$searchQuery[]=array('Field'=>'Version','Typ'=>'>=','Values'=>$search['VersionFrom']);
		}
		if ($search['VersionTo']) {
			$searchQuery[]=array('Field'=>'Version','Typ'=>'<=','Values'=>$search['VersionTo']);
		}
		if ($search['TimeFrom']) {
			$searchQuery[]=array('Field'=>'TimeModify','Typ'=>'>=','Values'=>$search['TimeFrom']);
		}
		if ($search['TimeTo']) {
			$searchQuery[]=array('Field'=>'TimeModify','Typ'=>'<=','Values'=>$search['TimeTo']);
		}
		$query="SELECT * FROM FileObject WHERE ".$this->_db->getWhere($searchQuery).' ORDER BY '.$order;
		if ($limit) $query.=' '.$this->_db->formatLimit($b,$limit);
		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		while ($this->_db->next_record()) {
			$result[]=array(
				'FileID'=>$this->_db->f('FileID'),
				'Modul'=>$this->_db->f('Modul'),
				'UserModify'=>$this->_db->f('UserModify'),
				'TimeModify'=>$this->_db->f('TimeModify'),
				'FilePath'=>$this->_db->f('FilePath')?($this->_path.'other/'.$this->_db->f('FileDir').basename($this->_db->f('FilePath'))):'',
				'FileSize'=>$this->_db->f('FileSize'),
				'MimeType'=>$this->_db->f('MimeType'),
				'Md5Sum'=>$this->_db->f('Md5Sum'),
				'FileImg'=>$this->_db->f('FileImg'),
				'Version'=>$this->_db->f('Version'),
			);
		}
		if ($limit && ($b!=0 || $limit==$rows)) {
			$query="SELECT count(*) as num FROM FileObject";
			$query.=' WHERE '.$this->_db->getWhere($searchQuery);
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
		}
		return $result;
	}
	function copyFile($obj,$Modul,$FileID,$Version=1) {
		$File=$this->readFile($Modul,$FileID,$Version);
		if ($File['FilePath'] && file_exists($File['FilePath'])) {
			if (preg_match('@\.((tar.)?[a-zA-Z0-9]*)$@',basename($File['FilePath']),$temp)) {
				$ext=$temp[1];
			} else {
				$ext='';
			}
			$dir=$this->getUserDir($obj);;
			$path=$this->_path.'/other/'.$dir;
			if (!file_exists($path)) {
				mkdir($path,0755,true);
			}
			
			$FilePath=tempnam($path,'ext');
			unlink($FilePath);
			//echo $FilePath;
			if ($ext) $FilePath.='.'.$ext;
			if (copy($File['FilePath'],$FilePath)) {
				$values=array(
					'FileID'=>$obj->getID(),
					'Modul'=>$Modul,
					'Version'=>$obj->getMeta('Version')?$obj->getMeta('Version'):1,
					'UserModify'=>$this->_uid,
					'TimeModify'=>time(),
					'FilePath'=>basename($FilePath),
					'FileDir'=>$dir,
					'FileSize'=>filesize($FilePath),
					'MimeType'=>$File['MimeType'],
					'Md5Sum'=>$File['Md5Sum'],
					'FileImg'=>$File['FileImg'],
				);
				if ($this->_db->insert ('FileObject',$values,0,1)) {
					$obj->setMeta('Content',$values['FileID']);
					$obj->setMeta('Version',$values['Version']);
					$obj->setMeta('MenuImage',$values['FileImg']);
					if (preg_match('@\.((tar.)?[a-zA-Z0-9]*)$@',$values['FilePath'],$temp)) {
						foreach ($this->_frm->getAvLang() as $val) {
							$obj->setMeta('Title_'.$val,$this->replaceExt($obj->getMeta('Title_'.$val),$temp[1]));
						}
					}
					//Alle alten Versionen entfernen.
					$this->deleteOldVersions($obj);
					return false;
				}
			}  else {
				return 'WriteError';
			}
		}
		return 'ReadError';

	}
	function syncLinkedFiles($obj) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'Content','Typ'=>'=','Values'=>$obj->getID());
		$searchQuery[]=array('Field'=>'DocID','Typ'=>'!=','Values'=>$obj->getID());

		$rows=0;
		foreach($this->searchObj($rows,0,0,$searchQuery,'',false,false) as $tmp) {
			$tmp->setMeta('Version',$obj->getMeta('Version'));
			$tmp->setMeta('MenuImage',$obj->getMeta('MenuImage'));
			$this->updateMeta($tmp);
		}
	}
	function moveFile($obj,$Modul,$FileID,$Version=1) {
		$File=$this->readFile($Modul,$FileID,$Version);
		if ($File['FilePath'] && file_exists($File['FilePath'])) {
			$dir=$this->getUserDir($obj);
			if ($File['FileDir']!=$dir) {
				if (preg_match('@\.((tar.)?[a-zA-Z0-9]*)$@',basename($File['FilePath']),$temp)) {
					$ext=$temp[1];
				} else {
					$ext='';
				}
				$path=$this->_path.'/other/'.$dir;
				if (!file_exists($path)) {
					mkdir($path,0755,true);
				}
				$FilePath=tempnam($path,'ext');
				unlink($FilePath);
				//echo $FilePath;
				if ($ext) $FilePath.='.'.$ext;
				if (rename($File['FilePath'],$FilePath)) {
					$values=array(
						'FilePath'=>basename($FilePath),
						'FileDir'=>$dir,
					);
					$searchQuery=array();
					$searchQuery[]=array('Field'=>'Modul','Typ'=>'=','Values'=>$Modul);
					$searchQuery[]=array('Field'=>'FileID','Typ'=>'=','Values'=>$FileID);
					$searchQuery[]=array('Field'=>'Version','Typ'=>'=','Values'=>$Version);
					$this->_db->update('FileObject',$values,$searchQuery);
				}
			}
		}

	}
	function deleteOldVersions($obj) {
		$max=$this->getCfg('cfg/versioning/max');
		if ($max && $obj->getMeta('Version')>$max) {
			$rows=0;$delVersions=array();
			foreach($this->searchFile($this->getModul(),$obj->getMeta('Content'),$rows,$max,10,array(),'Version DESC') as $File) {
				if ($File['FilePath'] && file_exists($File['FilePath'])) {
					unlink($File['FilePath']);
				}
				$delVersions[]=$File['Version'];
			}
			if (!empty($delVersions)) {
				if ($this->_Oss && $obj->getMeta('DocType')=='ext') {
					$this->_Oss->deleteDocument($obj,$delVersions);
				}
				$searchQuery=array();
				$searchQuery[]=array('Field'=>'Modul','Typ'=>'=','Values'=>$this->getModul());
				$searchQuery[]=array('Field'=>'FileID','Typ'=>'=','Values'=>$obj->getMeta('Content'));
				$searchQuery[]=array('Field'=>'Version','Typ'=>'=','Values'=>$delVersions);
				$this->_db->delete('FileObject',$searchQuery);
			}
		}
		
	}
	function deleteFile($Modul,$FileID) {
		$rows=0;
		foreach($this->searchFile($Modul,$FileID,$rows) as $File) {
			if ($File['FilePath'] && file_exists($File['FilePath'])) {
				unlink($File['FilePath']);
			}
		}
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'Modul','Typ'=>'=','Values'=>$Modul);
		$searchQuery[]=array('Field'=>'FileID','Typ'=>'=','Values'=>$FileID);
		$this->_db->delete('FileObject',$searchQuery);
		$this->deleteLastDl($Modul,$FileID,false);
	}
	function readLastDl($Modul,$FileID) {
		$query="SELECT TimeDl FROM FileLastDl WHERE FKFileID=".$this->_db->escape($FileID);
		$query.=" AND FKModul=".$this->_db->escape($Modul);
		$query.=" AND FKUserID=".$this->_db->escape($this->_uid);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('TimeDl');
		} else return 0;
	}
	function setLastDl($Modul,$FileID,$Counter,$ObjID) {
		$values=array(
			'FKFileID'=>$FileID,
			'FKModul'=>$Modul,
			'FKUserID'=>$this->_uid,
			'TimeDl'=>time(),
			'Counter'=>$Counter,
		);


		$this->_db->insert ('FileLastDl',$values,0,1);

		if ($ObjID) {
			$LogID=$this->_Log->insertLog($this->getModul(),$ObjID,$this->getUser(),'download');
		}
		//$this->_Log->insertLogValues($LogID,'Download','',serialize($values));
	}
	function deleteLastDl($Modul,$FileID,$use_user=true) {
		$query="DELETE FROM FileLastDl WHERE FKFileID=".$this->_db->escape($FileID);
		$query.=" AND FKModul=".$this->_db->escape($Modul);
		if ($use_user) $query.=" AND FKUserID=".$this->_db->escape($this->_uid);
		$this->_db->query($query);
	}
	function setFavorite ($obj) {
		$values=array(
			'FKDocID'=>$obj->getID(),
			'FKUserID'=>$this->_uid,
			'Favorite'=>$obj->getFileMeta('Favorite'),
		);
		$this->_db->insert ('FileHotlist',$values,0,1);
	}

	function dumpFile($Modul,$FileID,$Version=1,$Name='',$ContType=false) {
		//echo $Modul.'-'.$FileID;
		$File=$this->readFile($Modul,$FileID,$Version);
		//debug($File);
		//exit;
		if ($File===false || !$File['FileSize'] || !file_exists($File['FilePath'])) {
			return 'NoFile';
		} else {
			//echo "Www";
			if (!$Name) {
				$Name=basename($File['FilePath']);
			} else {
				if (strpos(basename($File['FilePath']),'.')) {
					$Name=preg_replace('/\.((tar.)?[a-z0-9]*)$/i','',$Name);
					$Name.=substr(basename($File['FilePath']),strpos(basename($File['FilePath']),'.'));
				}
			}
			if (!$ContType) {
				if ($File['MimeType']) {
					$ContType=$File['MimeType'];
				} else {
					$ContType="application/save";
				}
			}
			Framework::dumpFile($File['FilePath'],$Name,$ContType);
			return false;
		}
	}
	function getPerms($test=0) {
		if ($this->isRuleUser()) return true;
		if (!isset($this->_perms[$this->_uid])) {
			$this->_setPerms();
		}
		if ($test) {
			return ($this->_perms[$this->_uid]&$test)?true:false;
		} else {
			return $this->_perms[$this->_uid];
		}
	}
	function _setPerms() {
		$query="SELECT BIT_OR(Perms) as uperms FROM FilePerms WHERE";
		$query.=" UserTyp=".$this->_db->escape('u');
		$query.=" AND UserID=".$this->_db->escape($this->_uid);
		$query.=" GROUP BY UserTyp";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$this->_perms[$this->_uid]=$this->_db->f('uperms');
		} else {
			$query="SELECT BIT_OR(Perms) as uperms FROM FilePerms WHERE";
			$query.=" UserTyp=".$this->_db->escape('g');
			$query.=" AND UserID IN (".implode(',',$this->_db->escape($this->_gid)).')';
			$query.=" GROUP BY UserTyp";
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				$this->_perms[$this->_uid]=$this->_db->f('uperms');
			} else {
				$this->_perms[$this->_uid]=0;
			}
		}
	}
	function replacePerms($typ,$id,$Perms) {
		foreach ($Perms as $val) {
			$this->_db->insert('FilePerms',array('UserID'=>$id,'UserTyp'=>$typ,'Perms'=>$val),'',1);
		}
	}
	function getAllPerms() {
		$result=array();
		$query="SELECT * FROM FilePerms";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('UserTyp')][$this->_db->f('UserID')][]=$this->_db->f('Perms');
		}
		return $result;
	}
	function deletePerms($typ,$id) {
		$query="DELETE FROM FilePerms WHERE";
		$query.=" UserTyp=".$this->_db->escape($typ);
		$query.=" AND UserID=".$this->_db->escape($id);
		$this->_db->query($query);
	}
	function getID_Md5($MD5) {
		if ($MD5) {
			$query="SELECT DISTINCT FileID FROM FileObject";
			$query.=" WHERE Md5Sum=".$this->_db->escape($MD5);
			$this->_db->query($query);
			while ($this->_db->next_record()) {
				$result[]=$this->_db->f("FileID");
			}
		}
		return $result;
	}
	function updatePerms(&$obj,$rec=false) {
		$this->updateMeta($obj);
		$sub_entrys=$this->ListSubEntrys($obj->getID());
		foreach ($sub_entrys as $sub_obj) {
			if (!$sub_obj->isFolder()) {
				$sub_obj->setMeta('Users',$obj->getMeta('Users'));
				$sub_obj->setMeta('Groups',$obj->getMeta('Groups'));
				$this->updateMeta($sub_obj,false);
			} elseif ($rec) {
				$sub_obj->setMeta('Users',$obj->getMeta('Users'));
				$sub_obj->setMeta('Groups',$obj->getMeta('Groups'));
				$this->updatePerms($sub_obj,$rec);
			}
		}
	}

	function getLock($username='',$token='') {
		$searchQuery=array();
		if ($username) $searchQuery[]=array('Field'=>'username','Typ'=>'=','Values'=>$username);
		if ($token) $searchQuery[]=array('Field'=>'token','Typ'=>'=','Values'=>$token);
		if (!empty($searchQuery))  {
			$query="SELECT * FROM FileLock WHERE ".$this->_db->getWhere($searchQuery);
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				return true;
			} else {
				return false;
			}
		}
	}
	function deleteLock($username='',$token='') {
		$searchQuery=array();
		if ($username) $searchQuery[]=array('Field'=>'username','Typ'=>'=','Values'=>$username);
		if ($token) $searchQuery[]=array('Field'=>'token','Typ'=>'=','Values'=>$token);
		return $this->_db->delete('FileLock',$searchQuery);
	}
	function insertLock($username='',$token='') {
		$insert=array(
			'username'=>$username,
			'token'=>$token,
		);
		return $this->_db->insert('FileLock',$insert,'',1);
	}
	function getZipPath() {
		$path=GE_DYN_PATH.'/'.GE_DOMAIN_PATH.'attach/'.$this->_uid;
		if (!file_exists($path)) {
			mkdir($path,0700);
		}
		$path.='/zip';
		if (!file_exists($path)) {
			mkdir($path,0700);
		}
		return $path;
	}
	function exportToDir(&$obj_list,$toDir='',$rec=false) {
		$num_files=0;
		if (is_dir($toDir) && is_writable($toDir)) {
			foreach ($obj_list as $obj) {
				//debug($obj->getName());
				if ($obj->isFolder()) {
					if ($rec) {
						$sub_path=$toDir.'/'.$this->escapeFname($obj->getName());
						//debug($sub_path);
						$sub_entries=$this->ListSubEntrys($obj->getID());
						if (mkdir($sub_path,0700)) {
							$num_files++;
							$num_files+=$this->exportToDir($sub_entries,$sub_path,$rec);
						}
					}
				} else {
					$File=$this->readFile($this->getModul(),$obj->getMeta('Content'),$obj->getMeta('Version'));
					if ($File && $File['FileSize'] && file_exists($File['FilePath'])) {
						$Name=$obj->getName();
						if (strpos(basename($File['FilePath']),'.')) {
							$Name=preg_replace('/\.((tar.)?[a-z0-9]*)$/i','',$Name);
							$Name.=substr(basename($File['FilePath']),strpos(basename($File['FilePath']),'.'));
						}
						$Name=$this->escapeFname($Name);
						//debug($Name);
						if (copy($File['FilePath'],$toDir.'/'.$Name)) {
							$num_files++;
						}
					}
				}

			}
		}
		return $num_files;
	}
	function &searchObjByName($parentID,$Name,$Lang='',$Trash=0) {
		if (!$Lang) $Lang=$this->_lang;
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FileParent.FKDocID','Typ'=>'F=F','Values'=>'FileMetabase.DocID');
		$searchQuery[]=array('Field'=>'FileParent.ParentID','Typ'=>'=','Values'=>$parentID);
		if (!$Trash) $searchQuery[]=array('Field'=>'FileMetabase.Trash','Typ'=>'=','Values'=>0);
		if (is_array($Lang)) {
			$subQuery=array();
			foreach ($this->_frm->getAvLang() as $val) {
				$subQuery[]=array(array('Field'=>'FileMetabase.Title_'.$val,'Typ'=>'=','Values'=>$Name));
			}
			$searchQuery[]=array('Typ'=>'OR','Values'=>$subQuery);
		} else {
			$searchQuery[]=array('Field'=>'FileMetabase.Title_'.$Lang,'Typ'=>'=','Values'=>$Name);
		}

		$query="SELECT FileMetabase.*,FileParent.*,FileObject.FileSize,FileObject.FilePath,FileObject.MimeType,FileObject.Md5Sum FROM FileParent,FileMetabase LEFT JOIN FileObject ON (FileObject.Version=FileMetabase.Version AND FileObject.FileID=Content AND FileObject.Modul=".$this->_db->escape($this->getModul()).")  WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		//debugFile($query);
		if ($this->_db->next_record()) {
			$class='FObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl) {
				$result=new $class($this->_db->f("DocID"),$this->fetchObject($Lang),$this->fetchParent(),$acl);
				if (!$result->isFolder()) {
					$result->setFileMeta($this->fetchFileMeta());
				}
				return $result;
			}


		}
		return false;
	}
	
	function syncDocuments($fromPath,$toId,$verbose=0) {
		if (!file_exists($fromPath)) {
			throw new Exception($fromPath.' not exists');
		}
		if (!($startObj=$this->getObj($toId))) {
			throw new Exception($toId.' not exists');
		}
		if (substr($fromPath,-1)=='/') {
			$fromPath=substr($fromPath,0,-1);
		}
		return $this->_syncFolder($fromPath,$startObj,$verbose);
	}
	function _syncFolder($fromPath,$startObj,$verbose) {
		$dh=opendir($fromPath);
		if ($verbose) echo 'load folder: '.$fromPath."\n";
		$oldEntries=$this->ListSubEntrys($startObj->getID(),'','','',false,0);

		while (false !== ($entry = readdir($dh))) {
			if ($entry != "." && $entry != "..") {
				if ($verbose) echo "\n".'processing: '.$fromPath.'/'.$entry."\n";
				if ($verbose) echo 'memoryusage before: '.round(memory_get_usage()/(1024*1024),1)." MB\n";
				if ($this->isTempFileName($entry)) {
					if ($verbose) echo '--temp file'."\n";
					continue;
				}
				if (!is_readable($fromPath.'/'.$entry)) {
					if ($verbose) echo '--error not readable'."\n";
					continue;
				}
				$changeFile=false;
				$changeMeta=false;
				if ($tempObj=$this->searchObjByName($startObj->getID(),$entry,$this->_frm->getAvLang(),1)) {
					//Objekt existiert bereits
					if (is_dir($fromPath.'/'.$entry)) {
						if ($verbose) echo '--folder'."\n";
						if ($tempObj->getMeta('DocType')=='ext') {
							$tempObj=false;
							if ($verbose) echo '--false doctype'."\n";
						}
					} else {
						if ($verbose) echo '--file'."\n";
						if ($tempObj->getMeta('DocType')!='ext') {
							$tempObj=false;
							if ($verbose) echo '--false doctype'."\n";
						} else {
							$fsize=filesize($fromPath.'/'.$entry);
							if ($fsize < $this->_maxMd5Size) {
								if (Framework::getMd5Sum($fromPath.'/'.$entry)!=$tempObj->getFileMeta('Md5Sum')) {
									$changeFile=true;
								}
							} else {
								if ($fsize!=$tempObj->getFileMeta('FileSize') || filemtime($fromPath.'/'.$entry) > $tempObj->getMeta('TimeModify')) {
									$changeFile=true;
								}
							}
							//echo Framework::getMd5Sum($fromPath.'/'.$entry).'::'.$tempObj->getFileMeta('Md5Sum')."\n";
						}
					}
				}
				if ($tempObj) {
					$tempObj->setMeta('TimeModify',time());
					$tempObj->setMeta('UserModify',$this->getUser());
					if ($verbose) echo '--exists'."\n";
					unset($oldEntries[$tempObj->getID()]);
				} else {
					//Datei neu anlegen;
					if (is_dir($fromPath.'/'.$entry)) {
						$tempObj=new FObj_fol();
						$tempObj->setMeta('DocType','fol');
						$tempObj->setMeta('MenuImage','tree.gif');
					} else {
						$tempObj=new FObj_ext();
						$tempObj->setMeta('DocType','ext');
						$tempObj->setMeta('MenuImage','other.gif');
						$changeFile=true;
					}
					$tempObj->setMeta('Version',1);
					$tempObj->setMeta('TimeCreate',time());
					$tempObj->setMeta('TimeModify',time());
					$tempObj->setMeta('UserCreate',$this->getUser());
					$tempObj->setMeta('UserModify',$this->getUser());
					$tempObj->setMeta('Users',$startObj->getMeta('Users'));
					$tempObj->setMeta('Groups',$startObj->getMeta('Groups'));

					$tempObj->setParentMeta('ParentID',$startObj->getID());
					$tempObj->setParentMeta('RootID',$startObj->getParentMeta('RootID'));
					$tempObj->setParentMeta('UserID',$startObj->getParentMeta('UserID'));
					if ($verbose) echo '--new'."\n";
				}
				foreach ($this->_frm->getAvLang() as $val) {
					//echo $tempObj->getMeta('Title_'.$val).'::'.$entry."\n";
					if ($tempObj->getMeta('Title_'.$val)!=$entry) {
						$tempObj->setMeta('Title_'.$val,$entry);
						$changeMeta=true;
					}
				}
				if ($tempObj->getMeta('Trash')) {
					$tempObj->setMeta('Trash',0);
					$changeMeta=true;
				}
				
				if (!$tempObj->getID()) {
					if ($this->insertMeta($tempObj)) {
						$this->insertParentMeta($tempObj);
					}
				}
				if ($changeFile) {
					if ($verbose) echo '--upload file'."\n";
					$file=array(
						'name'=>$entry,
						'tmp_name'=>$fromPath.'/'.$entry,
						'type'=>FrameWork::getMimeFile($fromPath.'/'.$entry),
					);
					$error=$this->replaceFile($tempObj,$this->getModul(),$tempObj->getID(),$file);
					if ($error===false){
						$this->updateMeta($tempObj);
					}
					if ($verbose) echo '--file uploaded'."\n";
				} elseif ($changeMeta) {
					//print_R($tempObj);
					$this->updateMeta($tempObj,false);
					if ($verbose) echo '--only metachange'."\n";
				}
				if ($verbose) echo 'memoryusage after: '.round(memory_get_usage()/(1024*1024),1)." MB\n";
				if (is_dir($fromPath.'/'.$entry)) {
					//recursive updaten;
					$this->_syncFolder($fromPath.'/'.$entry,$tempObj,$verbose);
				}
				flush();
			}
		}
		foreach($oldEntries as $tmpObj) {
			if ($verbose) echo 'deleting: '.$tmpObj->getID().' name:'.$tmpObj->getName()."\n";
			$this->trashObj($tmpObj,false);
		}
	}
	function trashObj($obj,$checkPerms=true) {
		$error=array();
		if (is_object($obj)) {
			if ($checkPerms) {
				$this_action=$this->_frm->getObjAction ($this->getModul(),$obj->getActionMode(0),'delete');
				if (!$this->isAllowedAction($obj,reset($this_action))) {
					$error['no_del_perms'][]=$obj->getID();
				}
			}
			if (empty($error)) {
				$obj->setMeta('TimeModify',time());
				$obj->setMeta('UserModify',$this->getUser());
				$obj->setMeta('Trash',1);
				if ($obj->isFolder()) {
					//alle nicht geloschten auch loeschen
					$sub_entrys=$this->ListSubEntrys($obj->getID(),'','','',false,0);
					foreach ($sub_entrys as $tmp_obj) {
						$tmp_error=$this->trashObj($tmp_obj);
						if ($tmp_error) {
							$error=array_merge_recursive($error,$tmp_error);
							$error['no_sub_del_perms'][]=$obj->getID();
						}
					}
				} else {
					if ($obj->getMeta('Content')==$obj->getID()) {
						$linked_objs=$this->getLinkedObj($obj->getID(),false);
						foreach($linked_objs as $link_obj) {
							//Alle verlinkten objekte loeschen;
							$tmp_error=$this->trashObj($link_obj);
							if ($tmp_error) {
								$error=array_merge_recursive($error,$tmp_error);
								$error['no_sub_del_perms'][]=$obj->getID();
							}
						}
					}
				}
				if (empty($error)) {
					$this->updateMeta($obj);
				}
			}
		}
		return empty($error)?false:$error;
	}
	function isTempFileName($name) {
		if (preg_match('/^[~.]/',$name)) {
			return true;
		}
		if (preg_match('/\.tmp$/i',$name)) {
			return true;
		}
		return false;
	}
	function exportZip(&$obj_list,$zipName,$rec=false) {
		$num_files=0;
		$toDir=$this->getZipPath();
		//debug($toDir);
		if (is_dir($toDir) && is_writable($toDir)) {
			Framework::deleteFilesRecursive($toDir,'/.*/',array());
			$num_files=$this->exportToDir($obj_list,$toDir,$rec);
			if ($num_files && chdir($toDir)) {
				if (!$zipName) $zipName="export";
				$zipFile=basename($this->escapeFname($zipName)).'.zip';
				page_close();
				$exec="zip -rmX '".$zipFile."' *";
				exec($exec);
				Framework::dumpFile($zipFile,$zipFile,'application/x-zip');
				@unlink($zipFile);
				exit;
			}
		}
		return $num_files;
	}
	function escapeFname($txt) {
		$replace=array('/','\\');
		return str_replace($replace,'',$txt);
	}
}

?>
