<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

function CutCopyObject (&$obj,&$new_obj,$mode,$first=true,$unTrash=true) {
	global $Fmng,$frm,$P;

	if (is_object($new_obj)) {
		if ($mode=='link') {
			$ac_mode='copy';
		} else {
			$ac_mode=$mode;
		}
		if ($mode=='cut' && $P && $new_obj->isFolder() && $P->isProjectFmngRootFolder($new_obj->getID())) {
			return array("no_".$mode."_perms",$new_obj->getID());
		}
		if ($mode!='cut' || $first) {
			$nmode='n_';
			if ($mode=='link') $nmode.='l_';
			$nmode.=$new_obj->getMeta('DocType');
			$this_action=$frm->getObjAction ($Fmng->getModul(),$new_obj->getActionMode(0),$ac_mode);
			$obj_action=$frm->getObjAction ($Fmng->getModul(),$obj->getActionMode(0),$nmode);
			if ($Fmng->isAllowedAction($new_obj,reset($this_action)) && $Fmng->isAllowedAction($obj,reset($obj_action))) {
				if ( $new_obj->isFolder() && $Fmng->isSubfolder($obj->getID(),$new_obj->getID())) {
					return array('to_self',$new_obj->getID());
				}
				if ($new_obj->getParentMeta('ParentID')==$obj->getID()) {
					if ($mode=='cut') {
						return;
					} elseif ($mode=='copy' || ($mode=='link' && $new_obj->isFolder())) {
						//$new_obj->setMeta('MenuTitle','copy of '.$new_obj->getMeta('MenuTitle'));
					} elseif ($mode=='link' ) {
						//$new_obj->setMeta('MenuTitle','link to '.$new_obj->getMeta('MenuTitle'));
					}
				}
				if (!$new_obj->isFolder() || $mode=='copy' ||  $mode=='link') {
					$new_obj->setMeta('Users',$obj->getMeta('Users'));
					$new_obj->setMeta('Groups',$obj->getMeta('Groups'));
				}
				$oldID=$new_obj->getID();
				$oldVersion=$new_obj->getMeta('Version');
				$oldIsLink=$new_obj->isLink();

				$new_obj->setMeta('TimeModify',time());
				$new_obj->setMeta('UserModify',$Fmng->getUser());
				if ($unTrash) {
					if ($first && !$new_obj->getMeta('Trash')) {
						$unTrash=false;
					} else {
						$new_obj->setMeta('Trash',$obj->getMeta('Trash'));
					}
				}
				$new_obj->setParentMeta('ParentID',$obj->getID());
				$new_obj->setParentMeta('UserID',$obj->getParentMeta('UserID'));
				$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
				if ($mode=='cut') {
					$Fmng->updateMeta($new_obj);
					$Fmng->updateParentMeta($new_obj);
				} elseif ($mode=='copy' || $mode=='link') {
					$new_obj->setMeta('TimeCreate',time());
					$new_obj->setMeta('UserCreate',$Fmng->getUser());
					if (!$new_obj->isFolder() && ($mode=='link' || $oldIsLink)) {
						$new_obj->setMeta('Version',$oldVersion);
						if (!$new_obj->getMeta('Content')) {
							$new_obj->setMeta('Content',$oldID);
						}
					} else {
						$new_obj->setMeta('Version',1);
					}
					$Fmng->insertMeta($new_obj);
					$Fmng->insertParentMeta($new_obj);
					if ($mode=='copy' && !$oldIsLink) {
						if ($new_obj->getMeta('DocType')=='ext') {
							$Fmng->copyFile($new_obj,$Fmng->getModul(),$oldID,$oldVersion);
							$new_obj->setMeta('Content',$new_obj->getID());
							$Fmng->updateMeta($new_obj);
						}
					}
				}
				if ($new_obj->isFolder()) {
					if ($mode=='cut') {
						//Move Mode
						$sub_entrys=$Fmng->ListSubEntrys($oldID,'','Title_de','ASC',false,-1);
					} else {
						$sub_entrys=$Fmng->ListSubEntrys($oldID,'','Title_de','ASC',true,0);
					}
					foreach ($sub_entrys as $tmp_obj) {
						CutCopyObject($new_obj,$tmp_obj,$mode,false,$unTrash);
					}
				}
			} else {
				return array("no_".$mode."_perms",$new_obj->getID());
			}
		} else {
			//Move Mode
			if ($unTrash) {
				$new_obj->setMeta('Trash',$obj->getMeta('Trash'));
			}
			$new_obj->setParentMeta('UserID',$obj->getParentMeta('UserID'));
			$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
			$Fmng->updateMeta($new_obj);
			$Fmng->updateParentMeta($new_obj);
			$oldID=$new_obj->getID();
			if ($new_obj->isFolder()) {
				$sub_entrys=$Fmng->ListSubEntrys($oldID,'','Title_de','ASC',false,-1);
				foreach ($sub_entrys as $tmp_obj) {
					CutCopyObject($new_obj,$tmp_obj,$mode,false,$unTrash);
				}
			}
		}
	}
	return false;
}

function TrashObject ($obj) {
	global $Fmng,$frm;
	return $Fmng->trashObj($obj);
}
function DeleteObject(&$new_obj) {
	global $frm,$Fmng;
	$error=array();
	if (is_object($new_obj)) {
		$this_action=$frm->getObjAction ($Fmng->getModul(),$new_obj->getActionMode(0),'f_delete');
		if ($Fmng->isAllowedAction($new_obj,reset($this_action))) {
			if ($new_obj->isFolder()) {
				$sub_entrys=$Fmng->ListSubEntrys($new_obj->getID(),'','Title_de','ASC',false,-1);
				foreach ($sub_entrys as $tmp_obj) {
					$tmp_error=DeleteObject($tmp_obj);
					if ($tmp_error) {
						$error=array_merge_recursive($error,$tmp_error);
						$error['no_sub_del_perms'][]=$new_obj->getID();
					}
				}
			}
			if (empty($error)) {
				switch ($new_obj->getMeta('DocType')) {
					case 'ext':
						if ($new_obj->getMeta('Content')==$new_obj->getID()) {
							$Fmng->deleteFile($Fmng->getModul(),$new_obj->getMeta('Content'));
						}
					break;
					case 'fol':
						$Fmng->deleteOrder($new_obj->getID());
					break;
				}
				$Fmng->deleteParentMeta($new_obj);
				$Fmng->deleteMeta($new_obj);
			}
		} else {
			$error['no_del_perms'][]=$new_obj->getID();
		}
	}
	return empty($error)?false:$error;
}
function UndeleteObject($obj,$trash_id=0,$down=true) {
	global $Fmng,$frm;
	$error=array();
	if (!$trash_id) {
		if ($tObj=$Fmng->getSystemObj('t','en',0,false)) {
			$trash_id=$tObj->getID();
		} else {
			$trash_id=-1;
		}
	}
	if (is_object($obj)) {
		$this_action=$frm->getObjAction ($Fmng->getModul(),$obj->getActionMode(0),'undelete');
		if ($obj->getParentMeta('RootID')!=$trash_id && $Fmng->isAllowedAction($obj,reset($this_action))) {
			
			$obj->setMeta('TimeModify',time());
			$obj->setMeta('UserModify',$Fmng->getUser());
			$obj->setMeta('Trash',0);
			$upOk=true;
			if (!$obj->isFolder() && $obj->getMeta('Content')!=$obj->getID()) {
				//Checken ob Velinktes Objekt nicht gelöscht ist
				$linkObj=$Fmng->getObj($obj->getMeta('Content'));
				if ($linkObj->getMeta('Trash')) {
					$tmp_error=UndeleteObject($linkObj,$trash_id,false);
					if ($tmp_error) {
						$error=array_merge_recursive($error,$tmp_error);
						$error['no_undelete_perms'][]=$obj->getID();
						$upOk=false;
					}
				}
			}
			if ($upOk) {
				//Checken ob Parent Verzeichnis existiert
				$parentObj=$Fmng->getObj($obj->getParentMeta('ParentID'));
				if ($parentObj->getMeta('Trash')) {
					$tmp_error=UndeleteObject($parentObj,$trash_id,false);
					if ($tmp_error) {
						$error=array_merge_recursive($error,$tmp_error);
						$error['no_undelete_perms'][]=$obj->getID();
						$upOk=false;
					}
				}
			}
			if ($upOk) {
				$Fmng->updateMeta($obj);
				if ($down && $obj->isFolder()) {
					//alle gelöschten Untereintraeg undeleten
					$sub_entrys=$Fmng->ListSubEntrys($obj->getID(),'','','',true,1);
					if (!empty($sub_entrys)) {
						foreach ($sub_entrys as $tmp_obj) {
							$tmp_error=UndeleteObject($tmp_obj,$trash_id,$down);
							if ($tmp_error) {
								$error=array_merge_recursive($error,$tmp_error);
							}
						}
					}
				}
			}
		} else {
			$error['no_undelete_perms'][]=$obj->getID();
		}
	}
	return empty($error)?false:$error;
}
/*
function TrashObject (&$obj,&$new_obj,$first=1) {
	global $Fmng,$frm;
	$error=false;
	if (is_object($new_obj)) {
		$this_action=$frm->getObjAction ($Fmng->getModul(),$new_obj->getActionMode(0),'delete');
		if ($new_obj->getParentMeta('RootID')==$obj->getParentMeta('RootID')) {
			return;
		}
		if ($Fmng->isAllowedAction($new_obj,reset($this_action))) {
			$new_obj->setMeta('TimeModify',time());
			$new_obj->setMeta('UserModify',$Fmng->getUser());
			$new_obj->setMeta('Trash',1);
			$new_obj->setParentMeta('ParentID',$obj->getID());
			$new_obj->setParentMeta('RootID',$obj->getParentMeta('RootID'));
			if ($new_obj->isFolder()) {
				$oldObj=Framework::cloneObj($new_obj);
				$Fmng->insertMeta($new_obj);
				$Fmng->insertParentMeta($new_obj);
				$sub_entrys=$Fmng->ListSubEntrys($oldObj->getID());
				if (!empty($sub_entrys)) {
					$sub_ok=0;
					foreach ($sub_entrys as $tmp_obj) {
						$tmp_error=TrashObject($new_obj,$tmp_obj,0);
						if ($tmp_error) {
							$error=array('no_sub_del_perms',$oldObj->getID());
						} else {
							$sub_ok++;
						}
					}

					if (!$sub_ok) {
						$Fmng->deleteParentMeta($new_obj);
						$Fmng->deleteMeta($new_obj);
					}
				}
				if (!$error) {
					$Fmng->deleteParentMeta($oldObj);
					$Fmng->deleteMeta($oldObj);
				}
			} else {
				if ($new_obj->getMeta('Content')==$new_obj->getID()) {
					$linked_objs=$Fmng->getLinkedObj($new_obj->getID(),false);
					foreach ($linked_objs as $link_obj) {
						$tmp_error=TrashObject($obj,$link_obj);
					}

				}
				$Fmng->updateMeta($new_obj);
				$Fmng->updateParentMeta($new_obj);
			}
		} else {
			return array('no_del_perms',$new_obj->getID());
		}
	}
	return $error;
}
*/
