<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class Forum {
    var $_NewDate;
	var $_db;
	var $_uid;
	var $_lang;
	var $_gid;
	var $_frm;
	var $_rule=false;
	var $_sadmin=false;
	var $_locked_obj=array();
	var $_clipboard=array();
	var $_modul='forum';

	function Forum (&$db,$uid=0,$gid=0,$lang=0) {
		global $frm;
		$this->_frm=$frm;
		$this->_db=$db;
		$this->_uid=$uid;
		$this->_lang=$lang;
		$this->_gid=$gid;
	}
	function getModul() {
		return $this->_modul;
	}
	function setUser($uid) {
		$this->_uid=$uid;
	}
	function getUser() {
		return $this->_uid;
	}
	function setNewDate($date) {
		$this->_NewDate=$date;
	}
	function getNewDate() {
		return $this->_NewDate;
	}
	function setGroups($gid) {
		$this->_gid=$gid;
	}
	function setLang($lang) {
		$this->_lang=$lang;
	}
	function setRule($bool=false) {
		$this->_rule=$bool;
	}
	function setSuperAdmin($bool=false) {
		$this->_sadmin=$bool;
	}
	function isRuleUser() {
		return $this->_rule;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function setCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}
		}
	}
	function getCfg($key) {
		if (isset($this->_cfg[$key])) {
			return $this->_cfg[$key];
		} else {
			return false;
		}
	}

    function getForumList($Suggestion=0) {
		$result=array();
		if (!$this->isRuleUser()) $where[]="(Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
        if (!$Suggestion) $where[]='Suggestion=0';
		$query="SELECT ForumID,Title,Suggestion,Date FROM Forum";
		if ($where) $query.=' WHERE '.implode(' AND ',$where);
		$query.=" ORDER BY Title";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('ForumID')]=array('Title'=>$this->_db->f('Title'),'Date'=>$this->_db->f('Date'),'Suggestion'=>$this->_db->f('Suggestion'));
		}
		return $result;
    }
	function getNumNodes($ID) {
		if (is_array($ID)) $where="FKForumID IN (".implode(',',$this->_db->escape($ID)).")";
		elseif ($ID)   $where="FKForumID=".$this->_db->escape($ID);
		else return 0;
		$query="SELECT FKForumID,count(NodeID) as Entrys,sum(Date>".$this->_db->escape($this->_NewDate).") as New FROM Forum_Node WHERE $where GROUP BY FKForumID";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('FKForumID')]=array('Entrys'=>$this->_db->f('Entrys'),'New'=>$this->_db->f('New'));
		}
		return $result;
	}
	function getAbboList() {
		$result=array();
		$query="SELECT FKForumID FROM Forum_Abbo WHERE FKUserID=".$this->_db->escape($this->_uid);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('FKForumID')]=$this->_db->f('FKForumID');
		}
		return $result;
	}
	function insertAbbo($ID,$uid=0) {
		if (!$uid) $uid=$this->_uid;
		if (!is_array($ID)) {
			$ID=array($ID);
		}
		foreach ($ID as $val) {
			$insert=array(
				'FKUserID'=>$uid,
				'FKForumID'=>$val,
			);
			$this->_db->insert('Forum_Abbo',$insert,'',1);

		}
	}
	function deleteAbbo($ID) {
		if (is_array($ID)) {
			$where="FKForumID IN (".implode(',',$this->_db->escape($ID)).")";
		} else $where="FKForumID=".$this->_db->escape($ID);
		$query="DELETE FROM Forum_Abbo WHERE FKUserID=".$this->_db->escape($this->_uid)." AND $where";
		$this->_db->query($query);
	 }
	function getMailList($NodeID,$ID=0) {
		$query="SELECT FKUserID FROM Forum_Mail WHERE FKNodeID=".$this->_db->escape($NodeID)." AND FKUserID!=".$this->_db->escape($this->_uid);
		if ($ID) $query.=" AND FKForumID=".$this->_db->escape($ID);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('FKUserID');
		}
		return is_array($result)?$result:0;
	}
	function checkForMail($NodeID) {
		$query="SELECT * FROM Forum_Mail WHERE FKNodeID=".$this->_db->escape($NodeID)." AND FKUserID=".$this->_db->escape($this->_uid);
		$this->_db->query($query);
		if ($this->_db->next_record()) return 1;
		else return 0;
	}
	function insertMail($ID,$NodeID,$uid=0) {
		if (!$uid) $uid=$this->_uid;
		if (!is_array($NodeID)) {
			$NodeID=array($NodeID);
		}
		foreach ($NodeID as $val) {
			$insert=array(
				'FKUserID'=>$uid,
				'FKNodeID'=>$val,
				'FKForumID'=>$ID,
			);
			$this->_db->insert('Forum_Mail',$insert,'',1);

		}
	}
	function deleteMail($ID,$NodeID) {
		if (is_array($NodeID)) {
			$where="AND FKNodeID IN (".implode(',',$this->_db->escape($NodeID)).")";
		} elseif ($NodeID>=0) $where="AND FKNodeID=".$this->_db->escape($NodeID);
		$query="DELETE FROM Forum_Mail WHERE FKForumID=".$this->_db->escape($ID)." AND FKUserID=".$this->_db->escape($this->_uid)." ".$where;
		$this->_db->query($query);
	}

	function readForum($ID) {
		$query="SELECT * FROM Forum LEFT JOIN Forum_Abbo ON (FKForumID=ForumID AND Forum_Abbo.FKUserID=".$this->_db->escape($this->_uid).")";
		$query.=" WHERE ForumID=".$this->_db->escape($ID);
		//echo $query;
		$this->_db->query($query);
		$this->_db->next_record();
		$acl=$this->_frm->calcAcl($this->_db->f('Users'),$this->_db->f('Groups'),$this->_uid);
		return array(
			'Title'=>$this->_db->f('Title'),
			'Text'=>$this->_db->f('Text'),
			'Date'=>$this->_db->f('Date'),
			'Suggestion'=>$this->_db->f('Suggestion'),
			'UserName'=>$this->_db->f('UserName'),
			'FKUserID'=>$this->_db->f('FKUserID'),
			'Users'=>$this->_db->f('Users'),
			'Groups'=>$this->_db->f('Groups'),
			'Access'=>$acl,
			'Fav'=>$this->_db->f('FKForumID')
		);

	}
        function insertForum($obj) {
                $obj=array_map('addslashes',$obj);
                if (!$obj[ForumID]) $obj[ForumID]=$this->_db->nextid('Forum');
                $query="INSERT INTO Forum (".implode(',',array_keys($obj)).") VALUES ('".implode("','",$obj)."')";
                $this->_db->query($query);
                return $obj[ForumID];
        }
        function updateForum($ID,$obj) {
                $obj=array_map('addslashes',$obj);
                foreach ($obj as $key=>$val) $update[]="$key='$val'";
                $query="UPDATE Forum SET ".implode(',',$update)." WHERE ForumID=$ID";
                $this->_db->query($query);
                return $ID;
        }
        function deleteForum($ID) {
                $query="DELETE FROM Forum WHERE ForumID=$ID";
                $this->_db->query($query);
                $query="DELETE FROM Forum_Node WHERE FKForumID=$ID";
                $this->_db->query($query);
                $query="DELETE FROM Forum_Mail WHERE FKForumID=$ID";
                $this->_db->query($query);
                $query="DELETE FROM Forum_Abbo WHERE FKForumID=$ID";
                $this->_db->query($query);
                return $ID;
        }
        function updateNode($NodeID,$ParentID,$Node) {
                foreach ($Node as $key=>$val) {
                        $update[]=$key."='".addslashes($val)."'";
                }
                $this->_db->query("UPDATE Forum_Node SET ".implode(',',$update)." WHERE NodeID=$NodeID");
                $this->moveNode($NodeID,$ParentID);
        }
	function insertNode($ParentID,$Node,$FKForumID=0,$NodeID=0) {
		if (!$Node['FKUserID']) $Node['FKUserID']=$this->_uid;
		if (!$Node['Date']) $Node['Date']=time();
		if (!$NodeID) $Node['NodeID']=$this->_db->nextid('Forum_Node'); else $Node['NodeID']=$NodeID;
		if ($GLOBALS['CFG']['DATABASE_TYPE']=='postgres') {
			$this->_db->query("BEGIN WORK");
			$this->_db->query("LOCK TABLE Forum_Node IN SHARE MODE");
		} else $this->_db->query("LOCK TABLES Forum_Node WRITE");
		if ($ParentID!=0) {
			$this->_db->query("SELECT lft,rgt,RootID,FKForumID FROM Forum_Node WHERE NodeID=".$this->_db->escape($ParentID));
			$this->_db->next_record();
			$v_lft=$this->_db->f('lft');
			$v_rgt=$this->_db->f('rgt');
			$v_RootID=$this->_db->f('RootID');
			$FKForumID=$this->_db->f('FKForumID');
			$this->_db->query("UPDATE Forum_Node SET lft=lft+2 WHERE RootID=".$this->_db->escape($v_RootID)." AND lft>".$this->_db->escape($v_rgt));
			$this->_db->query("UPDATE Forum_Node SET rgt=rgt+2 WHERE RootID=".$this->_db->escape($v_RootID)." AND rgt>=".$this->_db->escape($v_rgt));
		} else {
			$v_rgt=1;
			$v_RootID=$Node['NodeID'];
		}
		$Node['FKForumID']=$FKForumID;
		$Node['RootID']=$v_RootID;
		$Node['ParentID']=$ParentID;
		$Node['lft']=$v_rgt;
		$Node['rgt']=($v_rgt+1);
		$this->_db->insert('Forum_Node',$Node);
		if ($GLOBALS['CFG']['DATABASE_TYPE']=='postgres') {
			$this->_db->query("COMMIT WORK");
		} else $this->_db->query("UNLOCK TABLES");
		return $Node['NodeID'];
	}
        function deleteNode($NodeID) {
                $this->_db->query("SELECT lft,rgt,RootID FROM Forum_Node WHERE NodeID=$NodeID");
                if ($this->_db->next_record()) {
                        $o_rgt=$this->_db->f('rgt');
                        $o_lft=$this->_db->f('lft');
                        $o_RootID=$this->_db->f('RootID');
                        $this->_db->query("SELECT NodeID FROM Forum_Node WHERE RootID=$o_RootID AND lft>=$o_lft AND rgt<=$o_rgt");
                        while ($this->_db->next_record()) $LockNodeID[]=$this->_db->f("NodeID");
                        $SubNodes=($o_rgt-$o_lft+1);
                        if ($GLOBALS[CFG][DATABASE_TYPE]=='postgres') {
                                $this->_db->query("BEGIN WORK");
                                $this->_db->query("LOCK TABLE Forum_Node IN SHARE MODE");
                        }else $this->_db->query("LOCK TABLES Forum_Node WRITE");
                        $this->_db->query("UPDATE Forum_Node SET rgt=rgt-$SubNodes WHERE RootID=$o_RootID AND rgt>$o_rgt");
                        $this->_db->query("UPDATE Forum_Node SET lft=lft-$SubNodes WHERE RootID=$o_RootID AND lft>$o_lft");
                        $this->_db->query("DELETE FROM Forum_Node WHERE NodeID IN (".implode(',',$LockNodeID).")");
                        if ($GLOBALS[CFG][DATABASE_TYPE]=='postgres') {
                                $this->_db->query("COMMIT WORK");
                        } else $this->_db->query("UNLOCK TABLES");
                        $this->_db->query("DELETE FROM Forum_Mail WHERE FKNodeID IN (".implode(',',$LockNodeID).")");
                }
        }
        function moveNode($NodeID,$NewParentID) {
                $this->_db->query("SELECT lft,rgt,RootID,ParentID,FKForumID FROM Forum_Node WHERE NodeID=$NodeID");
                $this->_db->next_record();
                if ($NewParentID!=$this->_db->f('ParentID')) {
                        if ($GLOBALS[CFG][DATABASE_TYPE]=='postgres') {
                                $this->_db->query("BEGIN WORK");
                                $this->_db->query("LOCK TABLE Forum_Node IN SHARE MODE");
                        }else $this->_db->query("LOCK TABLES Forum_Node WRITE");
                        $o_lft=$this->_db->f('lft');
                        $o_rgt=$this->_db->f('rgt');
                        $RootID=$this->_db->f('RootID');
                        $this->_db->query("SELECT NodeID FROM Forum_Node WHERE lft>=$o_lft AND rgt<=$o_rgt");
                        while ($this->_db->next_record()) $LockNodeID[]=$this->_db->f("NodeID");
                        $SubNodes=($o_rgt-$o_lft+1);
                        $this->_db->query("UPDATE Forum_Node SET rgt=rgt-$SubNodes WHERE RootID=$RootID AND NodeID NOT IN (".implode(',',$LockNodeID).") AND rgt>$o_rgt");
                        $this->_db->query("UPDATE Forum_Node SET lft=lft-$SubNodes WHERE RootID=$RootID AND NodeID NOT IN (".implode(',',$LockNodeID).") AND lft>$o_lft");

                        $this->_db->query("SELECT lft,rgt,RootID,FKForumID FROM Forum_Node WHERE NodeID=$NewParentID");
                        $this->_db->next_record();
                        $n_lft=$this->_db->f('lft');
                        $n_rgt=$this->_db->f('rgt');
                        $RootID=$this->_db->f('RootID');
                        $FKForumID=$this->_db->f('FKForumID');
                        $this->_db->query("UPDATE Forum_Node SET lft=lft+$SubNodes WHERE RootID=$RootID AND NodeID NOT IN (".implode(',',$LockNodeID).") AND lft>$n_rgt");
                        $this->_db->query("UPDATE Forum_Node SET rgt=rgt+$SubNodes WHERE RootID=$RootID AND NodeID NOT IN (".implode(',',$LockNodeID).") AND rgt>=$n_rgt");

                        $Diff=$n_rgt-$o_lft;
                        $this->_db->query("UPDATE Forum_Node SET Date=".time().",FKForumID=$FKForumID,RootID=$RootID,rgt=rgt+$Diff,lft=lft+$Diff WHERE NodeID IN (".implode(',',$LockNodeID).")");
                        $this->_db->query("UPDATE Forum_Node SET ParentID=$NewParentID WHERE  NodeID=$NodeID");
                        if ($GLOBALS[CFG][DATABASE_TYPE]=='postgres') {
                                $this->_db->query("COMMIT WORK");
                        } else $this->_db->query("UNLOCK TABLES");
                 }
        }
	function selectNode($NodeID,$fields) {
		$this->_db->query("SELECT NodeID,".implode(',',$fields)." FROM Forum_Node WHERE NodeID=".$this->_db->escape($NodeID));
		$this->_db->next_record();
		foreach ($fields as $val) {
			$result[$val]=$this->_db->f($val);
		}
		return $result;
	}
	function nodeExists($NodeID) {
		$this->_db->query("SELECT NodeID FROM Forum_Node WHERE NodeID=".$this->_db->escape($NodeID));
		if ($this->_db->next_record()) {
			return $NodeID;
		} else {
			return false;
		}
	}
	function getDiscussions($ID) {
			$result=array();
			if (is_array($ID)) $where="WHERE FKForumID IN (".implode(',',$this->_db->escape($ID)).") ";
			elseif ($ID) $where="WHERE FKForumID=".$this->_db->escape($ID)." ";
			else return  $result;
			$query="SELECT RootID,FKForumID,Title,Date,UserName,rgt,FKUserID FROM Forum_Node $where AND NodeID=RootID ";
			$query.="ORDER BY Date DESC";
			$this->_db->query($query);
			while ($this->_db->next_record()) {
					$result[$this->_db->f('FKForumID')][$this->_db->f('RootID')]=array(
						'rgt'=>$this->_db->f('rgt'),
						'Title'=>$this->_db->f('Title'),
						'Date'=>$this->_db->f('Date'),
						'UserName'=>$this->_db->f('UserName'),
						'FKUserID'=>$this->_db->f('FKUserID'),
					);
			}
			$query="SELECT RootID,FKForumID,count(*) as New FROM Forum_Node $where AND NodeID!=RootID AND Date>".$this->_db->escape($this->_NewDate)." ";
			$query.=" GROUP BY RootID,FKForumID";
			$this->_db->query($query);
			while ($this->_db->next_record()) {
					$result[$this->_db->f('FKForumID')][$this->_db->f('RootID')]['New']=$this->_db->f('New');
			}
			return $result;
	}
	function getThread($open,$Root=0,$Text=0) {
		$result=array();
		if (empty($open)) return  $result;
		$query="SELECT RootID,lft,rgt,NodeID,Title,Date,UserName,FKUserID,(Date>".$this->_db->escape($this->_NewDate).") AS New ";
		if ($Text) $query.=",Text ";
		$query.="FROM Forum_Node ";
		$query.="WHERE RootID IN (".implode(',',$this->_db->escape($open)).")";
		if (!$Root) $query.=" AND RootID!=NodeID ";
		$query.="ORDER BY lft";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
				$result[$this->_db->f('RootID')][$this->_db->f('NodeID')]=array(
					'lft'=>$this->_db->f('lft'),
					'rgt'=>$this->_db->f('rgt'),
					'New'=>$this->_db->f('New'),
					'Title'=>$this->_db->f('Title'),
					'Date'=>$this->_db->f('Date'),
					'UserName'=>$this->_db->f('UserName'),
					'FKUserID'=>$this->_db->f('FKUserID'),
				);
				if ($Text) $result[$this->_db->f('RootID')][$this->_db->f('NodeID')]['Text']=$this->_db->f('Text');
		}
		return $result;
	}
	function getMaxDepth($RootID) {
		$query="SELECT count(*) AS Level ";
		$query.="FROM Forum_Node as node1,Forum_Node as node2 ";
		$query.="WHERE node1.RootID=".$this->_db->escape($RootID)." AND node2.RootID=".$this->_db->escape($RootID)." AND node1.lft BETWEEN node2.lft AND node2.rgt ";
		$query.="GROUP BY node1.NodeID";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result=max($result,$this->_db->f('Level'));
		}
		return $result;
	}
	function &searchThread (&$rows,$b=0,$limit=0,$search_sql='',$order,$use_limit=false) {
		$result=array();
		$query="SELECT * FROM Forum_Node ";
		if ($search_sql) $query.="WHERE $search_sql ";
		if ($order) $query.="ORDER BY $order ";
		if ($limit) $query.=$this->_db->formatLimit($b,$limit).' ';
		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		while ($this->_db->next_record()) {
			$result[$this->_db->f('NodeID')]=array(
				'Title'=>$this->_db->f('Title'),
				'Text'=>$this->_db->f('Text'),
				'Date'=>$this->_db->f('Date'),
				'UserName'=>$this->_db->f('UserName'),
				'FKForumID'=>$this->_db->f('FKForumID'),
				'FKUserID'=>$this->_db->f('FKUserID'),
				'RootID'=>$this->_db->f('RootID')
			);

		}
		if ($use_limit && $limit && ($b!=0 || $limit==$rows)) {
			$query="SELECT count(*) as num FROM Forum_Node ";
			if ($search_sql) $query.="WHERE $search_sql ";
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
		}
		return $result;
	}
	function parseSmileys($text) {
		if (is_array($GLOBALS['CFG']['Forum']['smileys'])) {
			return strtr($text,$GLOBALS['CFG']['Forum']['smileys']);
		} else return $text;
	}
	function deleteUser($user_id) {
		$user_id=addslashes($user_id);
		$this->_db->query("DELETE FROM Forum_Abbo WHERE FKUserID='$user_id'");
		$this->_db->query("DELETE FROM Forum_Mail WHERE FKUserID='$user_id'");
	}
	function isAllowedAction(&$obj,&$action) {
		if (!is_array($action)) return false;
		if (!$this->isRuleUser() && $action['Perms'] && !($obj['Access']&$action['Perms'])) return false;

		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkAction($obj,substr($ac_val,1));
				} else {
					$result=$result||$this->_checkAction($obj,$ac_val);
				}
			}
			if (!$result) return false;
		}
		return true;
	}
	function _checkAction(&$obj,$action) {
		switch ($action) {
			case 'sadmin':
				if (!$this->isSuperAdmin()) return false;
			break;
			case 'rule':
				if (!$this->isRuleUser()) return false;
			break;
			case 'app_msg':
				if (!$GLOBALS['app']['msg']) return false;
			break;
			case 'app_mail':
				if (!$GLOBALS['app']['email']) return false;
			break;
			case 'fav':
				if (!$obj['Fav']) return false;
			break;
			case 'sub':
				if (!$obj['Mail']) return false;
			break;
		}
		return true;
	}
}
?>
