<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
defined('PREPEND_FILE')?require(PREPEND_FILE):die('UPS..');
if (!defined('GE_DYN_PATH')) {
	if (file_exists('../dyn') && !file_exists('dyn')) {
		define('GE_DYN_PATH',realpath('../dyn'));
		define('GE_DYN_PATH_OK',1);
	} else {
		define('GE_DYN_PATH',realpath('dyn'));
		define('GE_DYN_PATH_OK',0);
	}
}

require_once('update/version.php');
define('GE_VERSION',$VERSION);
require ("lib/ClassGroupieDB.php");
$db=new GroupieDB();
if ($CFG['USER_CLASS']=='ldap') {
	require ("lib/ClassGroupieUser_Ldap.php");
} elseif ($CFG['USER_CLASS']=='ldap_full') {
	require ("lib/ClassGroupieUser_FullLdap.php");
} else {
	require ("lib/ClassGroupieUser_Mysql.php");
}
require ("lib/class_frame_work.inc.php");
$frm=new FrameWork();
$frm->setDb($db);
$frm->setFrmCfg($frm->getCfg('global',0,array('cfg/%','ldap/%')));
if (!defined('GE_CHARSET')) define('GE_CHARSET','UTF-8');
if (GE_CHARSET=='UTF-8') {
	$db->query("SET NAMES 'utf8'");
} else {
	$db->query("SET NAMES 'latin1'");
}
//echo GE_CHARSET;
page_open(array("sess" => "groupie_Session","auth" =>"groupie_Auth"));
define('APP_THEME',$THEME);
$frm->setUser($auth->auth['uid']);
if ($auth->auth["timezone"]) {
	date_default_timezone_set($auth->auth["timezone"]);
}
if (!$sess->is_registered("session_lang")) {
	$sess->register('session_lang');
}
if (!$sess->is_registered("session_md5")) {
	$sess->register('session_md5');
	$session_md5=$frm->getSessionMd5();
}
if ($session_md5!=$frm->getSessionMd5()) {
	$sess->delete();
	page_close();
	header('Location:main.php');
	exit;
}
if ($auth->auth['uname']!='config') {
	$session_lang=$frm->getPrefs('global','lang');
} else {
	$session_lang=$frm->getDefaults('global','lang');
	if (!$session_lang) $session_lang='en';
}
$frm->setLang($session_lang);
require("lib/class_translation.inc.php");
$T=new Translation($session_lang,$MASTER_TPL);

require ("lib/class.mtFastTemplate.php");
$t=new mtFastTemplate ('.',$MASTER_TPL);

require ("lib/class_ApplicationErrorGui.php");
$E=new ApplicationErrorGui();

require ("lib/class_GlobLinkObj.php");
$L=new GlobLinkObj();

if ($frm->appExists('proj')) {
	$P=& $frm->getStaticModul('proj',true);
	$P->init();
} else {
	$P=false;
}

require_once('lib/class_LayerGui.php');
$Y=new LayerGui();


function debug($var,$always=false) {
	if ($GLOBALS['DEBUG'] || $always) {
		echo '<pre>';print_r($var);echo '</pre>';
	}
}
function debugFile($val) {
	global $frm;
	if (defined('FILE_LOG') && FILE_LOG) {
		$fp=fopen(FILE_LOG,'a+');
		if (!is_string($val)) $val=print_r($val,true);
		fwrite($fp,"\n".date('d.m.y H:i:s ').$frm->getUser()."\n".$val);
		fclose($fp);
	}
}

function debugtime($mode='E',$return=false) {
	static $btime,$etime;
	switch ($mode) {
		case 'B':
			$btime=microtime();
		break;
		case 'E':
			$etime=microtime();
			$temp=explode(" ",$btime);
			$btime=(float)$temp[0]+(float)$temp[1];
			$temp=explode(" ",$etime);
			$etime=(float)$temp[0]+(float)$temp[1];
			if ($return) return ($etime-$btime);
			else debug('TIME: '.($etime-$btime));
		break;
	}
}
function debugmem() {
	global $sadmin;
	if ($sadmin) debug(Framework::formatSize(memory_get_usage()));
}
?>