<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class InfoObj {
	var $_meta=array();
	var $_pmeta=array();
	var $_fmeta=array();
	var $_acl;
	var $_ID;
	function getID() {
		return $this->_ID;
	}
	function setID($ID) {
		$this->_ID=$ID;
	}
	function getMeta($key) {
		return $this->_meta[$key];
	}
	function setMeta($key,$data) {
		$this->_meta[$key]=$data;
	}
	function getParentMeta($key) {
		return $this->_pmeta[$key];
	}
	function setParentMeta($key,$data) {
		$this->_pmeta[$key]=$data;
	}
	function getFavoriteMeta($key) {
		return $this->_fmeta[$key];
	}
	function setFavoriteMeta($key,$data) {
		$this->_fmeta[$key]=$data;
	}
	function getName() {
		if ($this->_pmeta['LangID']!='00') {
			return $this->_meta['Title_'.$this->_pmeta['LangID']];
		} else {
			return $this->_meta['Title_'.$GLOBALS['Imng']->getLangID()];
		}
	}
	function getACL($chk=0) {
		$chk=intval($chk);
		if ($chk) {
			if ($this->_acl==-1) {
				return true;
			} else {
				return ($this->_acl&$chk);
			}
		} else {
			return $this->_acl;
		}
	}
	function getStatus() {
		$time=time();
		if (!str_replace('|','',$this->getMeta('PublishGroups')) && !str_replace('|','',$this->getMeta('PublishUsers'))) {
			return 0;
		}
		if (
			$this->getMeta('Publish')
			&& ($this->getMeta('PublishStart')<$time)
			&& ($this->getMeta('PublishEnd')>$time || $this->getMeta('PublishEnd')<=0)
		) {
			return 3;
		} elseif ($this->getMeta('Publish')) {
			return 4;
		} else {
			return 0;
		}

	}
	function setAcl($acl) {
		$this->_acl=$acl;
	}
	function getAction($typ) {
		return $this->_action[$typ];
	}
	function getSite() {
		return $this->_site;
	}

}
class IObj_doc extends InfoObj  {
	var $_site='imng_r.php';
	var $_action=array('vo','wd');
	function IObj_doc($ID=0,$meta=0,$pmeta=0,$acl=0,$fmeta=0) {
		global $Imng;
		if ($meta) $this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
		if ($fmeta) $this->_fmeta=$fmeta;
		if ($Imng->getPublic()) $this->_site='imng.php';
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage() {
		$image='obj_img/';
		if (!$GLOBALS['Imng']->getPublic()) {
			$image.=$this->getStatus().'_';
			if ($this->getMeta('Content') && $this->getMeta('Content')!=$this->_ID) {
				$image.='l_';
			}
		}
		$image.=$this->getMeta('MenuImage');
		return $image;
	}
	function getActionMode() {
		$ac='doc';
		if ($this->getMeta('Trash')) {
			$ac.='_tr';
		}
		return $ac;
	}
	function isFolder() {
		return false;
	}
}
class IObj_fol extends InfoObj   {
	var $_site='imng_r.php';
	var $_action=array('b','b&edit=1');
	function IObj_fol($ID=0,$meta=0,$pmeta=0,$acl=0,$fmeta=0) {
		global $Imng;
		if ($meta) $this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
		if ($fmeta) $this->_fmeta=$fmeta;
		if ($Imng->getPublic()) $this->_site='imng.php';
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if (!$GLOBALS['Imng']->getPublic()) {
			$image.=$this->getStatus().'_';
		}
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.=$this->getMeta('MenuImage');
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='fol';
		if ($this->getMeta('Trash')) {
			$ac.='_tr';
		}
		if ($typ) $ac.='_l';
		return $ac;
	}
	function isFolder() {
		return true;
	}
}


class IObj_trash extends InfoObj  {
	var $_site='imng_r.php';
	var $_action=array('bt','bt');
	function IObj_trash($ID=0,$meta=0,$pmeta=0,$acl=0,$fmeta=0) {
		if ($meta) $this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
		if ($fmeta) $this->_fmeta=$fmeta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.=$this->getMeta('MenuImage');
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='trash';
		if ($typ) {
			$ac.='_l';
		}
		return $ac;
	}
	function isFolder() {
		return true;
	}
}
class Imng {
	var $_db;
	var $_uid;
	var $_lang;
	var $_gid;
	var $_rule=false;
	var $_sadmin=false;
	var $_locked_obj=array();
	var $_clipboard=array();
	var $_modul='imng';
	var $_status=array(0=>'INTERN',1=>'<font color=red>UPLOAD</font>',2=>'<fontcolor=red>UPDATE</font>',3=>'PUBLIC',4=>'<font color=red>EXPIRED</font>');
	function Imng () {
		global $db,$frm;
		$this->_db=&$db;
		$this->_frm=&$frm;
		$this->_uid=$this->_frm->getUser();
		$this->_lang=$this->_frm->getLang();
		$this->_gid=$this->_frm->getMyGroups();
		$this->_path=GE_DYN_PATH.'/'.GE_DOMAIN_PATH;
		if (!file_exists($this->_path)) {
			mkdir($this->_path,0700);
		}
		if (!file_exists($this->_path."other")) {
			mkdir($this->_path."other",0700);
		}
		if (!file_exists($this->getFilePath())) {
			mkdir($this->getFilePath(),0700);
		}
		$this->setRule($this->_frm->isRuleUser(array('sysadmin','imng')));
		$this->setSuperAdmin($this->_frm->isSuperAdmin());
		$this->setCfg($this->_frm->getCfg($this->getModul(),0,'cfg/%'));
		if ($this->getCfg('cfg/av_lang')) $this->setAvLang(explode('|',$this->getCfg('cfg/av_lang')));
		else $this->setAvLang(array($this->_lang));

		$this->_lang_id=$this->_frm->getLang();
		if (!in_array($this->_lang_id,$this->getAvLang())) {
			$this->_lang_id=reset($this->getAvLang());
		}
	}
	function getModul() {
		return $this->_modul;
	}
	function setUser($uid) {
		$this->_uid=$uid;
	}
	function getUser() {
		return $this->_uid;
	}
	function getFilePath() {
		return $this->_path.'other/imng';
	}
	function setGroups($gid) {
		$this->_gid=$gid;
	}
	function getGroups() {
		return $this->_gid;
	}
	function setLang($lang) {
		$this->_lang=$lang;
	}
	function setRule($bool=false) {
		$this->_rule=$bool;
	}
	function setSuperAdmin($bool=false) {
		$this->_sadmin=$bool;
	}
	function setLocked($locked) {
		$this->_locked_obj=$locked_obj;
	}
	function isLocked(&$obj) {
		if ($this->_locked_obj[$obj->getID()]) {
			return true;
		} else {
			return false;
		}
	}
	function setClipboard($what,$content) {
		$this->_clipboard[$what]=$content;
	}
	function getClipboard($what) {
		return $this->_clipboard[$what];
	}
	function isClipboard($what) {
		if ($this->_clipboard[$what]) {
			return true;
		} else {
			return false;
		}
	}
	function isRuleUser() {
		return $this->_rule;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function setCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}
		}
	}
	function getCfg($key) {
		if (isset($this->_cfg[$key])) {
			return $this->_cfg[$key];
		} else {
			return false;
		}
	}
	function setRootObj(&$obj) {
		$this->_root_obj=&$obj;
	}
	function &getRootObj() {
		return $this->_root_obj;
	}
	function setMode($mode) {
		$this->_mode=$mode;
	}
	function getMode() {
		return $this->_mode;
	}
	function setAvLang($lang) {
		$this->_av_lang=$lang;
	}
	function getAvLang() {
		return $this->_av_lang;
	}
	function setLangID($lang) {
		$this->_lang_id=$lang;
	}
	function getLangID() {
		return $this->_lang_id;
	}
	function getStatusName($key) {
		return $this->_status[$key];
	}
	function setPublic($key) {
		$this->_public=$key;
	}
	function getPublic() {
		return $this->_public;
	}
	function &searchObj (&$rows,$b=0,$limit=0,$search_sql='',$order='',$use_limit=false,$use_perms=true,$full='') {
		$result=array();
		$query="SELECT BlackParent.*,BlackMetabase.*,BlackHotlist.* ";
		$query.="FROM BlackParent,BlackMetabase ";
		if ($full) {
			$query.="LEFT JOIN BlackContent ON (BlackMetabase.Content=BlackContent.DocID) ";
		}
		$query.="LEFT JOIN BlackHotlist ON (BlackHotlist.FKDocID=BlackMetabase.DocID AND BlackHotlist.FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.=" WHERE BlackParent.FKDocID=BlackMetabase.DocID ";
		if ($this->getPublic()) {
			$time=time();
			$query.=" AND Publish=1 AND PublishStart < $time AND (PublishEnd > $time OR PublishEnd<=0)";
			$query.=" AND (PublishUsers LIKE '%|".$this->_uid."|%' OR  PublishGroups LIKE '%|".implode("|%' OR PublishGroups LIKE '%|",$this->_gid)."|%')";
		} elseif (!$this->isRuleUser() && $use_perms) {
			$query.=" AND (Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
		}
		if ($search_sql) $query.=" AND $search_sql ";
		if ($order) $query.="ORDER BY $order ";
		if ($limit) $query.=$this->_db->formatLimit($b,$limit).' ';
		//echo $query;
		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		//debug($rows);
		while ($this->_db->next_record()) {
			$class='IObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				$result[$this->_db->f("DocID")]=new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl,$this->fetchFavorite());
			}
		}
		if ($use_limit && $limit && ($b!=0 || $limit==$rows)) {
			$query="SELECT count(*) as num FROM BlackParent,BlackMetabase ";
			if ($full) {
				$query.="LEFT JOIN BlackContent ON (BlackMetabase.Content=BlackContent.DocID) ";
			}
			$query.="LEFT JOIN BlackHotlist ON (BlackHotlist.FKDocID=BlackMetabase.DocID AND BlackHotlist.FKUserID=".$this->_db->escape($this->_uid).") ";
			$query.=" WHERE BlackParent.FKDocID=BlackMetabase.DocID ";
			if ($this->getPublic()) {
				$time=time();
				$query.=" AND Publish=1 AND PublishStart < $time AND (PublishEnd > $time OR PublishEnd<=0)";
				$query.=" AND (PublishUsers LIKE '%|".$this->_uid."|%' OR  PublishGroups LIKE '%|".implode("|%' OR PublishGroups LIKE '%|",$this->_gid)."|%')";
			} elseif (!$this->isRuleUser() && $use_perms) {
				$query.=" AND (Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
			}

			if ($search_sql) $query.="AND $search_sql ";
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
		}
		return $result;
	}
	function searchEscalationObj(&$rows,$search=array(),$b=0,$limit=0,$order='',$use_limit=true) {
		$result=array();
		$sqlQuery=array();
		$sqlQuery[]=array('Field'=>'FKDocID','Typ'=>'F=F','Values'=>'DocID');
		$sqlQuery[]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);
		$sqlQuery[]=array('Field'=>'DocType','Typ'=>'=','Values'=>'doc');
		$sqlQuery[]=array('Typ'=>'SQL','Values'=>"((EscalationUsers!='' AND EscalationUsers!='||') OR (EscalationGroups !='' AND EscalationGroups !='||'))");
		if ($search['ID']) {
			$sqlQuery[]=array('Field'=>'DocID','Typ'=>'=','Values'=>$search['ID']);
		}
		if ($search['MinEscalationEnd']) {
			$subQuery=array();
			$subQuery[]=array(array('Field'=>'EscalationEnd','Typ'=>'>=','Values'=>$search['MinEscalationEnd']));
			$subQuery[]=array(array('Field'=>'PublishEnd','Typ'=>'>=','Values'=>$search['MinEscalationEnd']));
			$sqlQuery[]=array('Typ'=>'OR','Values'=>$subQuery);
		}
		if ($search['MaxEscalationEnd']) {
			$subQuery=array();
			$subQuery[]=array(
				array('Field'=>'EscalationEnd','Typ'=>'>','Values'=>0),
				array('Field'=>'EscalationEnd','Typ'=>'<=','Values'=>$search['MaxEscalationEnd'])
			);
			$subQuery[]=array(
				array('Field'=>'PublishEnd','Typ'=>'>','Values'=>$search['MinEscalationEnd']),
				array('Field'=>'PublishEnd','Typ'=>'<=','Values'=>$search['MaxEscalationEnd'])
			);
			$sqlQuery[]=array('Typ'=>'OR','Values'=>$subQuery);
		}
		if ($search['NoEscalationEnd']) {
			$sqlQuery[]=array('Field'=>'EscalationEnd','Typ'=>'<','Values'=>1);
			$sqlQuery[]=array('Field'=>'PublishEnd','Typ'=>'<','Values'=>1);
		}
		if ($search['Publish']>0) {
			$sqlQuery[]=array('Field'=>'Publish','Typ'=>'=','Values'=>1);
			$sqlQuery[]=array('Field'=>'PublishStart','Typ'=>'<','Values'=>time());
			$sqlQuery[]=array('Typ'=>'SQL','Values'=>"(PublishUsers!='' AND PublishUsers!='||') OR (PublishGroups!='' AND PublishGroups !='||')");
		}
		if ($search['Publish']<0) {
			$subQuery=array();
			$subQuery[]=array(array('Field'=>'Publish','Typ'=>'=','Values'=>0));
			$subQuery[]=array(
				array('Field'=>'PublishEnd','Typ'=>'>','Values'=>0),
				array('Field'=>'PublishEnd','Typ'=>'<','Values'=>time())
			);
			$sqlQuery[]=array('Typ'=>'OR','Values'=>$subQuery);
		}
		if ($search['EscalationSend']>0) {
			$sqlQuery[]=array('Field'=>'EscalationSend','Typ'=>'>=','Values'=>$search['EscalationSend']);
		}
		if ($search['EscalationSend']<0) {
			$sqlQuery[]=array('Field'=>'EscalationSend','Typ'=>'=','Values'=>0);
		}


		$query="SELECT * FROM BlackParent,BlackMetabase WHERE ".$this->_db->getWhere($sqlQuery);
		if ($order) $query.=" ORDER BY $order";
		if ($limit) $query.=' '.$this->_db->formatLimit($b,$limit);

		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		//debug($rows);
		while ($this->_db->next_record()) {
			$class='IObj_'.$this->_db->f("DocType");
			$acl=-1;
			$result[$this->_db->f("DocID")]=new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
		}
		if ($use_limit && $limit && ($b!=0 || $limit==$rows)) {
			$query="SELECT count(*) as num FROM BlackParent,BlackMetabase WHERE ".$this->_db->getWhere($sqlQuery);
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
		}
		return $result;
	}
	function listEscalationObj($search=array()) {
		$sqlQuery=array();
		$sqlQuery[]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);
		$sqlQuery[]=array('Field'=>'DocType','Typ'=>'=','Values'=>'doc');
		switch($search['Confirmed']) {
			case 1:
				$sqlQuery[]=array('Field'=>'Confirmed','Typ'=>'>','Values'=>0);
			break;
			case -1:

			break;
			default:
				$sqlQuery[]=array('Typ'=>'SQL','Values'=>"Confirmed=0 OR Confirmed IS NULL");
			break;
		}
		$sqlQuery[]=array('Typ'=>'SQL','Values'=>"(EscalationUsers LIKE '%|".$this->getUser()."|%' OR  EscalationGroups LIKE '%|".implode("|%' OR EscalationGroups LIKE '%|",$this->getGroups())."|%')");
		if ($search['ID']) {
			$sqlQuery[]=array('Field'=>'DocID','Typ'=>'=','Values'=>$search['ID']);
		}
		if ($search['EscalationEnd']) {
			$sqlQuery[]=array('Field'=>'EscalationEnd','Typ'=>'>','Values'=>0);
			$sqlQuery[]=array('Field'=>'EscalationEnd','Typ'=>'<','Values'=>$search['EscalationEnd']);
		}
		$rows=0;
		return $this->searchObj ($rows,0,0,$this->_db->getWhere($sqlQuery),'Title_'.$this->getLangID());
	}
	function listEscalationConfirmed($docIDs) {
		$result=array();
		$sqlQuery=array();
		$sqlQuery[]=array('Field'=>'FKDocID','Typ'=>'=','Values'=>$docIDs);
		$sqlQuery[]=array('Field'=>'Confirmed','Typ'=>'>','Values'=>0);

		$query="SELECT FKDocID,FKUserID,Confirmed FROM BlackHotlist WHERE ".$this->_db->getWhere($sqlQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("FKDocID")][$this->_db->f("FKUserID")]=$this->_db->f("Confirmed");
		}

		return $result;
	}


	function &ListAllTree($Lang,$RootID=-1,$ParentID=-1,$order_f='Sequence',$order_d='ASC',$app='',$use_perms=true) {
		$result=array();
		if ($order_f) $order_met="ORDER BY $order_f $order_d";

		$where[]="BlackParent.FKDocID=DocID";
		$where[]="(LangID='00' OR LangID=".$this->_db->escape($Lang).")";
		//debug($app);
		if ($app && !empty($app)) {
			$sql_app=$this->_db->escape($app);
			if (is_array($app) && count($app)) $where[]="DocType IN (".implode(",",$sql_app).")";
			elseif  ($app) $where[]="DocType=$sql_app";
		}

		$sql_RootID=$this->_db->escape($RootID);
		if (is_array($RootID)) $where[]="RootID IN (".implode(",",$sql_RootID).")";
		elseif ($RootID!=-1)  $where[]="RootID=$sql_RootID";

		$sql_ParentID=$this->_db->escape($ParentID);
		if (is_array($ParentID)) $where[]="ParentID IN (".implode(",",$sql_ParentID).")";
		elseif ($ParentID!=-1)  $where[]="ParentID=$sql_ParentID";

		if ($this->getPublic()) {
			$time=time();
			$where[]="Publish=1 AND PublishStart < $time AND (PublishEnd > $time OR PublishEnd<=0) AND (PublishUsers LIKE '%|".$this->_uid."|%' OR  PublishGroups LIKE '%|".implode("|%' OR PublishGroups LIKE '%|",$this->_gid)."|%')";
		} elseif (!$this->isRuleUser() && $use_perms) {
			$where[]="(Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
		}

		$query="SELECT * FROM BlackParent,BlackMetabase ";
		$query.="LEFT JOIN BlackHotlist ON (BlackHotlist.FKDocID=DocID AND BlackHotlist.FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.=" WHERE  ".implode(' AND ',$where)." $order_met";
		//echo $query.'<br><br>';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='IObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				$result[$this->_db->f("ParentID")][$this->_db->f("DocID")]=new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl,$this->fetchFavorite());
			}

		}
		return $result;
	}


	function &ListSubEntrys($ParentID,$Lang='',$app='',$order_f='Sequence',$order_d='asc',$use_perms=true) {
		$result=array();
		$result=array();
		if ($order_f) $order_met="ORDER BY $order_f $order_d";

		$where[]="BlackParent.FKDocID=DocID";
		if ($Lang) $where[]="(LangID='00' OR LangID=".$this->_db->escape($Lang).")";

		$sql_app=$this->_db->escape($app);
		if (is_array($app)) $where[]="DocType IN (".implode(",",$sql_app).")";
		elseif  ($app) $where[]="DocType=$sql_app";

		$sql_ParentID=$this->_db->escape($ParentID);
		if (is_array($ParentID)) $where[]="ParentID IN (".implode(",",$sql_ParentID).")";
		else $where[]="ParentID=$sql_ParentID";

		if ($this->getPublic()) {
			$time=time();
			$where[]="Publish=1 AND PublishStart < $time AND (PublishEnd > $time OR PublishEnd<=0) AND (PublishUsers LIKE '%|".$this->_uid."|%' OR  PublishGroups LIKE '%|".implode("|%' OR PublishGroups LIKE '%|",$this->_gid)."|%')";
		} elseif (!$this->isRuleUser() && $use_perms) {
			$where[]="(Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
		}

		$query="SELECT * FROM BlackParent,BlackMetabase ";
		$query.="LEFT JOIN BlackHotlist ON (BlackHotlist.FKDocID=DocID AND BlackHotlist.FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.=" WHERE  ".implode(' AND ',$where)." $order_met";
		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='IObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				$result[$this->_db->f("DocID")]=new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl,$this->fetchFavorite());
			}

		}
		return $result;
	}
	function &listSubTree($params,$onlyApps=true) {
		//debug($params['ParentID']);
		return $this->ListSubEntrys($params['ParentID'],$this->getLangID(),'','DocType DESC, Title_'.$this->getLangID().' ASC','');
    }
	function &isSubTreeLen($params,$onlyApps=true) {
		return true;
    }

	function getSystemObj($system,$lang,$use_perms=true) {
		$query="SELECT * FROM BlackMetabase,BlackParent WHERE BlackParent.FKDocID=DocID AND System=".$this->_db->escape($system);
		$query.=" AND LangID=".$this->_db->escape($lang);

		//echo $query;
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='IObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				return new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}
		}
	}

	function getLinkedObj($ID,$all=false) {
		$result=array();
		$query="SELECT * FROM BlackMetabase,BlackParent WHERE BlackParent.FKDocID=DocID AND Content=".$this->_db->escape($ID);
		if (!$all) $query.=" AND DocID!=".$this->_db->escape($ID);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='IObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl) {
				$result[$this->_db->f("DocID")]= new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}
		}
		return $result;
	}
	function updateMeta(&$obj) {
		$values=$obj->_meta;
		if ($obj->getID()) {
			$this->_db->update('BlackMetabase',$values,"DocID=".$this->_db->escape($obj->getID()));
			return $obj->getID();
		}
		return false;
	}
	function insertMeta(&$obj) {
		$values=$obj->_meta;
		$values['DocID']=$this->_db->nextid('BlackMetabase');
		if ($this->_db->insert('BlackMetabase',$values)) {
			$obj->setID($values['DocID']);
			return $obj->getID();
		}
		return false;
	}
	function deleteMeta(&$obj) {
		$query="DELETE FROM BlackMetabase WHERE DocID=".$this->_db->escape($obj->getID());
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function updateParentMeta(&$obj) {
		$values=$obj->_pmeta;
		if ($obj->getID()) {
			$this->_db->update('BlackParent',$values,"FKDocID=".$this->_db->escape($obj->getID()));
			return $obj->getID();
		}
		return false;
	}
	function insertParentMeta(&$obj) {
		$values=$obj->_pmeta;
		if ($obj->getID()) {
			$values['FKDocID']=$obj->getID();
			$this->_db->insert('BlackParent',$values,'',1);
			return $obj->getID();
		}
		return false;
	}
	function deleteParentMeta(&$obj) {
		$query="DELETE FROM BlackParent WHERE FKDocID=".$this->_db->escape($obj->getID());
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function insertFavoriteMeta(&$obj) {
		$values=$obj->_fmeta;
		if ($obj->getID()) {
			$values['FKDocID']=$obj->getID();
			$values['FKUserID']=$this->_uid;
			$this->_db->insert('BlackHotlist',$values,'',1);
			return $obj->getID();
		}
		return false;
	}
	function deleteFavoriteMeta(&$obj,$user_id) {
		$query="DELETE FROM BlackHotlist WHERE FKDocID=".$this->_db->escape($obj->getID());
		if ($user_id) $query.=" AND FKUserID=".$this->_db->escape($user_id);
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function getObj($ID,$lang='') {
		$query="SELECT * FROM BlackParent,BlackMetabase ";
		$query.="LEFT JOIN BlackHotlist ON (BlackHotlist.FKDocID=DocID AND BlackHotlist.FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.=" WHERE BlackParent.FKDocID=DocID AND DocID=".$this->_db->escape($ID);
		//echo $query;
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='IObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl) {
				$obj=new $class($this->_db->f("DocID"),$this->fetchObject($lang),$this->fetchParent(),$acl,$this->fetchFavorite());
				return $obj;
			}
		}
	}
	function getTrashObj() {
		$query="SELECT * FROM BlackMetabase,BlackParent WHERE FKDocID=DocID AND DocType='trash'";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='IObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl) {
				return new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}
		}
	}

	function getObjTree ($oid,$lang='') {
		if (!in_array($lang,$this->getAvLang())) $lang=$this->getLangID();
		do {
			$query="SELECT Title_".$lang.",ParentID FROM BlackMetabase,BlackParent WHERE ParentID=DocID AND FKDocID!=RootID AND FKDocID=".$this->_db->escape($oid);
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				$oid=$this->_db->f('ParentID');
				$result[$this->_db->f('ParentID')]=$this->_db->f('Title_'.$lang);
			} else {
				$oid=0;
			}

		} while ($oid);
		return $result;
	}
	function getObjTreeIDs ($oid,$break=0) {
		if ($oid!=$break) {
			do {
				$query="SELECT ParentID FROM BlackParent WHERE FKDocID=".$this->_db->escape($oid);
				$this->_db->query($query);
				if ($this->_db->next_record()) {
					$oid=$this->_db->f('ParentID');
					$result[]=$this->_db->f('ParentID');
				} else {
					$oid=0;
				}

			} while ($oid && $oid!=$break);
		} else {
			$result[]=$oid;
		}
		return $result;
	}
	function isSubfolder($FolderID,$subFolderID) {
		if ($FolderID==$subFolderID) return true;
		$tree=$this->getObjTreeIDs ($FolderID);
		if (is_array($tree) && in_array($subFolderID,$tree)) {
			return true;
		} else {
			return false;
		}
	}

	function getContentACL(&$obj) {
		if (!is_object($obj) || $obj->isFolder()) return 0;
		if ($this->isRuleUser()) {
			return -1;
		} elseif (!$obj->getMeta('Content') || $obj->getID()==$obj->getMeta('Content')) {
			return $obj->getACL();
		} else {
			$query="SELECT Users,Groups FROM BlackMetabase,BlackParent WHERE FKDocID=DocID ";
			$query.=" AND  DocID=".intval($obj->getMeta('Content'));
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				return $this->fetchACL();
			} else {
				return 0;
			}
		}
	}
	function fetchACL() {
		//echo $this->_db->f('Title_de').'-'.$this->_db->f('UserID').'<br>';
		if ($this->isRuleUser()) {
			return -1;
		} else {
			return $this->_frm->calcAcl($this->_db->f('Users'),$this->_db->f('Groups'),$this->_uid);
		}
	}
	function &fetchObject($lang='') {
		$result=array(
			'Text'=>$this->_db->f("Text"),
			'MenuImage'=>$this->_db->f("MenuImage"),
			'Publish'=>$this->_db->f('Publish'),
			'PublishStart'=>$this->_db->f('PublishStart'),
			'PublishEnd'=>$this->_db->f('PublishEnd'),
			'PublishGroups'=>$this->_db->f('PublishGroups'),
			'PublishUsers'=>$this->_db->f('PublishUsers'),
			'Portal'=>$this->_db->f('Portal'),
			'PortalStart'=>$this->_db->f('PortalStart'),
			'PortalEnd'=>$this->_db->f('PortalEnd'),
			'EscalationGroups'=>$this->_db->f('EscalationGroups'),
			'EscalationUsers'=>$this->_db->f('EscalationUsers'),
			'EscalationEnd'=>$this->_db->f('EscalationEnd'),
			'EscalationSend'=>$this->_db->f('EscalationSend'),
			'EscalationNotice'=>$this->_db->f('EscalationNotice'),
			'Version'=>$this->_db->f('Version'),
			'TimeCreate'=>$this->_db->f("TimeCreate"),
			'TimeModify'=>$this->_db->f("TimeModify"),
			'UserCreate'=>$this->_db->f("UserCreate"),
			'UserModify'=>$this->_db->f("UserModify"),
			'DocType'=>$this->_db->f("DocType"),
			'DocImage'=>$this->_db->f("DocImage"),
			'Users'=>$this->_db->f("Users"),
			'Groups'=>$this->_db->f("Groups"),
			'Content'=>$this->_db->f('Content'),
			'System'=>$this->_db->f('System'),
			'Trash'=>$this->_db->f('Trash'),
			'TemplateID'=>$this->_db->f('TemplateID'),
		);
		if (!$lang) $lang=explode('|',$this->getCfg('cfg/av_lang'));
		if (is_array($lang)) {
			foreach ($lang as $val) {
				$result['Title_'.$val]=$this->_db->f("Title_".$val);
			}
		} else {
			$result['Title_'.$lang]=$this->_db->f("Title_".$lang);
		}
		return $result;
	}
	function fetchParent() {
		return array(
			'ParentID'=>$this->_db->f('ParentID'),
			'RootID'=>$this->_db->f('RootID'),
			'LangID'=>$this->_db->f('LangID'),
			'Sequence'=>$this->_db->f('Sequence'),
		);
	}
	function fetchFavorite() {
		return array(
			'Favorite'=>$this->_db->f('Favorite'),
			'Confirmed'=>$this->_db->f('Confirmed'),
			'TimeLast'=>$this->_db->f('TimeLast'),
			'Counter'=>$this->_db->f('Counter'),
		);
	}
	function isAllowedAction(&$obj,&$action) {
		if (!is_array($action)) return false;
		if (in_array('c_perms',$action['Extra'])) {
			$acl=$this->getContentAcl($obj);
			if (!($acl&$action['Perms']) && $acl!=-1) return false;
		} else {
			if ($action['Perms'] && !$obj->getAcl($action['Perms'])) return false;
		}
		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkAction($obj,substr($ac_val,1));
				} else {
					$result=$result||$this->_checkAction($obj,$ac_val);
				}
			}
			//echo $ac_val;debug($result);
			if (!$result) return false;
		}
		return true;
	}
	function _checkAction(&$obj,$action) {
		switch ($action) {
			case 'sadmin':
				if (!$this->isSuperAdmin()) return false;
			break;
			case 'rule':
				if (!$this->isRuleUser()) return false;
			break;
			case 'locked':
				if (!$this->isLocked($obj)) return false;
			break;
			case 'fav':
				if (!$obj->getFavoriteMeta('Favorite')) return false;
			break;
			case 'content':
				if (!$this->isClipboard('iobj')) return false;
			break;
			case 'root':
				if ($obj->getParentMeta('RootID')!=$obj->getID()) return false;
			break;
			case 'en_tpl':
				if (!$this->getCfg('fol/en_tpl')) return false;
			break;
			case 'no_doc':
				if (!$this->getCfg('fol/no_doc')) return false;
			break;
			case 'no_fol':
				if (!$this->getCfg('fol/no_fol')) return false;
			break;
			case 'no_ext':
				if (!$this->getCfg('fol/no_extl')) return false;
			break;
			case 'no_fol':
				if (!$this->getCfg('fol/no_fol')) return false;
			break;
			case 'no_del':
				//echo $this->getCfg($obj->getMeta('DocType').'/no_del');
				if (!$this->getCfg($obj->getMeta('DocType').'/no_del')) return false;
			break;
			case 'root_s':
				if ($this->_root_obj->getMeta('System')!='s') return false;
			break;
			case 'root_d':
				if ($this->_root_obj->getMeta('System')!='d') return false;
			break;
			case 'root_u':
				if ($this->_root_obj->getMeta('System')!='u') return false;
			break;
			case 'pred':
				if (!$this->getPerms(2)) return false;
			break;
			case 'app_msg':
				if (!$GLOBALS['app']['msg']) return false;
			break;
			case 'app_mail':
				if (!$GLOBALS['app']['email']) return false;
			break;
		}
		return true;
	}
	function setFavorite ($obj) {
		$values=array(
			'FKDocID'=>$obj->getID(),
			'FKUserID'=>$this->_uid,
			'Favorite'=>$obj->getFileMeta('Favorite'),
		);
		$this->_db->insert ('BlackParent',$values,0,1);
	}

	function setOrder($ID,$o,$a) {
		$values=array(
			'FKDocID'=>$ID,
			'FKUserID'=>$this->_uid,
			'FileOrder'=>$o,
			'FileAsc'=>$a,

		);
		$this->_db->insert('BlackOrder',$values,'',1);
	}

	function getOrder($ID) {
		$query="SELECT FileOrder,FileAsc FROM BlackOrder WHERE FKDocID=".$this->_db->escape($ID);
		$query.=" AND FKUserID=".$this->_db->escape($this->_uid);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return array (
				'FileOrder'=>$this->_db->f('FileOrder'),
				'FileAsc'=>$this->_db->f('FileAsc'),
			);
		}

	}

	function deleteOrder($ID=0,$uid=0) {
		if (!$ID && !$uid) return false;
		if ($ID) $where[]="FKDocID=".$this->_db->escape($ID);
		if ($uid) $where[]="FKUserID=".$this->_db->escape($uid);
		$query="DELETE FROM BlackOrder WHERE ".implode(' AND ',$where);
		$this->_db->query($query);
	}

	function getContent($ID,$Version) {
		$query="SELECT Content FROM BlackContent WHERE DocID=".$this->_db->escape($ID)." AND Version=".$this->_db->escape($Version);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('Content');
		} else {
			return 0;
		}
	}
	function getMetaContent($ID,$Version) {
		$query="SELECT TimeModify,UserModify FROM BlackContent WHERE DocID=".$this->_db->escape($ID)." AND Version=".$this->_db->escape($Version);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return array(
				'TimeModify'=>$this->_db->f('TimeModify'),
				'UserModify'=>$this->_db->f('UserModify'),
			);
		} else {
			return 0;
		}
	}
	function getContentTemp($ID) {
		$query="SELECT * FROM BlackContentTemp WHERE DocID=".$this->_db->escape($ID)." AND UserModify=".$this->_db->escape($this->_uid);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return array(
				'Content'=>$this->_db->f('Content'),
				'TimeModify'=>$this->_db->f('TimeModify'),
				'UserModify'=>$this->_db->f('UserModify'),
				'ContModified'=>$this->_db->f('ContModified'),
			);
		}
	}
	function saveContent($ID,$Version,$Content) {
		$oldContent=$this->getContent($ID,$Version);
		$values=array(
			'DocID'=>$ID,
			'Version'=>$Version,
			'Content'=>$Content,
			'UserModify'=>$this->_uid,
			'TimeModify'=>time(),
		);
		$this->_db->insert ('BlackContent',$values,0,1);
		if (preg_replace('/\s*/','',strip_tags($oldContent))!=preg_replace('/\s*/','',strip_tags($Content))) {
			$query="UPDATE BlackHotlist SET Confirmed=0 WHERE FKDocID=".intval($ID);
			$this->_db->query($query);
		}

	}
	function saveContentTemp($ID,$Content,$time,$modified=-1) {
		$values=array(
			'DocID'=>$ID,
			'Content'=>$Content,
			'UserModify'=>$this->_uid,
			'TimeModify'=>$time,
		);
		if ($modified!=-1) {
			$values['ContModified']=$modified;
		}
		$this->_db->insert ('BlackContentTemp',$values,0,1);
	}
	function deleteContent($ID,$Version=-1) {
		$query="DELETE FROM BlackContent WHERE DocID=".$this->_db->escape($ID);
		if ($Version!=-1) {
			$query.=" AND Version=".$this->_db->escape($Version);
		}
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function deleteContentTemp($ID,$all=0) {
		$query="DELETE FROM BlackContentTemp WHERE DocID=".$this->_db->escape($ID);
		if (!$all) $query.=" AND UserModify=".$this->_db->escape($this->_uid);
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function deleteStylesValues($TplID) {
		$query="DELETE FROM BlackStylesValues WHERE FKTplID=".$this->_db->escape($TplID);
		$this->_db->query($query);
	}
	function replaceStylesValues($TplID,$values) {
		if (is_array($values)) {
			$query="DELETE FROM BlackStylesValues WHERE FKTplID=".$this->_db->escape($TplID);
			$this->_db->query($query);
			foreach ($values as $key=>$val) {
				$this->_db->insert ('BlackStylesValues',array('FKStyleKey'=>$key,'FKtplID'=>$TplID,'StyleVal'=>$val));
			}
		}
	}
	function getBlackStyles($id) {
		$query="SELECT StyleKey,StyleKeyName,Name_".$this->_lang.",FieldTyp,DefaultVal,Size,TagName,FixAttributes,ClassName,StyleVal ";
		$query.=" FROM BlackStylesKeys LEFT JOIN BlackStylesValues ON (StyleKey=FKStyleKey) AND FKTplID=".$this->_db->escape($id);
		$query.=" ORDER BY Sequence ";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('StyleKey')]=array(
				'StyleKeyName'=>$this->_db->f('StyleKeyName'),
				'Name'=>$this->_db->f('Name_'.$this->_lang),
				'Size'=>$this->_db->f('Size'),
				'FixAttributes'=>$this->_db->f('FixAttributes'),
				'TagName'=>$this->_db->f('TagName'),
				'ClassName'=>$this->_db->f('ClassName'),
				'StyleVal'=>$this->_db->f('StyleVal'),
				'FieldTyp'=>$this->_db->f('FieldTyp'),
				'DefaultVal'=>$this->_db->f('DefaultVal'),
			);
		}
		return $result;
	}
	function switchEntry ($oID,$ParentID,$dir='down') {
		$query="SELECT Sequence FROM BlackParent WHERE ";
		$query.="ParentID=".intval($ParentID)." AND FKDocID=".intval($oID)." AND Status!=9 ";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$oSequence=$this->_db->f('Sequence');
			if ($dir=='up'){
				$sign='<';
				$order='DESC';
			}elseif ($dir=='down') {
				$sign='>';
				$order='ASC';
			} elseif ($dir=='first') {
				$sign='<';
				$order='ASC';
			}
			$query="SELECT FKDocID,Sequence  FROM BlackParent WHERE ";
			$query.="ParentID=".intval($ParentID)." AND Sequence $sign ".intval($oSequence)." AND Status!=9 ";;
			$query.="ORDER BY Sequence $order LIMIT 1";
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				$nID=$this->_db->f('FKDocID');
				$nSequence=$this->_db->f('Sequence');
				$query="UPDATE BlackParent SET Sequence=".intval($nSequence)." WHERE ";
				$query.="ParentID=".intval($ParentID)." AND FKDocID=".intval($oID)." AND Status!=9 ";
				$this->_db->query($query);
				if ($dir=='first') {
					$query="UPDATE BlackParent SET Sequence=Sequence+1 WHERE ";
					$query.="ParentID=".intval($ParentID)." AND Sequence<$oSequence AND FKDocID!=".intval($oID)." AND Status!=9 ";
					$this->_db->query($query);
				} else {
					$query="UPDATE BlackParent SET Sequence=".intval($oSequence)." WHERE ";
					$query.="ParentID=".intval($ParentID)." AND FKDocID=".intval($nID)." AND Status!=9 ";
					$this->_db->query($query);
				}
			}
		}
	}
	function getNextSequence($ID) {
		$query="SELECT max(Sequence) as num FROM BlackParent WHERE ParentID=".$this->_db->escape($ID)." GROUP BY ParentID";
		$this->_db->query($query);
		$this->_db->next_record();
		return (intval($this->_db->f('num')) + 1);
	}
	function getPerms($test=0) {
		if ($this->isRuleUser()) return true;
		if (!isset($this->_perms[$this->_uid])) {
			$this->_setPerms();
		}
		if ($test) {
			return ($this->_perms[$this->_uid]&$test)?true:false;
		} else {
			return $this->_perms[$this->_uid];
		}
	}
	function _setPerms() {
		$query="SELECT BIT_OR(Perms) as uperms FROM BlackPerms WHERE";
		$query.=" UserTyp=".$this->_db->escape('u');
		$query.=" AND UserID=".$this->_db->escape($this->_uid);
		$query.=" GROUP BY UserTyp";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$this->_perms[$this->_uid]=$this->_db->f('uperms');
		} else {
			$query="SELECT BIT_OR(Perms) as uperms FROM BlackPerms WHERE";
			$query.=" UserTyp=".$this->_db->escape('g');
			$query.=" AND UserID IN (".implode(',',$this->_db->escape($this->_gid)).')';
			$query.=" GROUP BY UserTyp";
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				$this->_perms[$this->_uid]=$this->_db->f('uperms');
			} else {
				$this->_perms[$this->_uid]=0;
			}
		}
	}
	function replacePerms($typ,$id,$Perms) {
		foreach ($Perms as $val) {
			$this->_db->insert('BlackPerms',array('UserID'=>$id,'UserTyp'=>$typ,'Perms'=>$val),'',1);
		}
	}
	function getAllPerms() {
		$result=array();
		$query="SELECT * FROM BlackPerms";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('UserTyp')][$this->_db->f('UserID')][]=$this->_db->f('Perms');
		}
		return $result;
	}
	function deletePerms($typ,$id) {
		$query="DELETE FROM BlackPerms WHERE";
		$query.=" UserTyp=".$this->_db->escape($typ);
		$query.=" AND UserID=".$this->_db->escape($id);
		$this->_db->query($query);
	}
	function updatePerms(&$obj,$rec=false) {
		$this->updateMeta($obj);
		$sub_entrys=$this->ListSubEntrys($obj->getID());
		foreach ($sub_entrys as $sub_obj) {
			if (!$sub_obj->isFolder()) {
				$sub_obj->setMeta('Users',$obj->getMeta('Users'));
				$sub_obj->setMeta('Groups',$obj->getMeta('Groups'));
				$this->updateMeta($sub_obj);
			} elseif ($rec) {
				$sub_obj->setMeta('Users',$obj->getMeta('Users'));
				$sub_obj->setMeta('Groups',$obj->getMeta('Groups'));
				$this->updatePerms($sub_obj,$rec);
			}
		}
	}
}
?>
