<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class XmlFastText {
	var $_modul='imng';
	var $_Bmng;
	var $parsertext;
	var $openlist;
	var $closelist;
	var $_allowed_o_tags=array(
		'title1',
		'title2',
		'title3',
		'b',
		'i',
		'u',
		'c',
		'link',
		'list',
	);
 	var $_allowed_c_tags=array(
		'hr',
	);
	var $_preview=false;
	var $_usedImages=array();
	var $_img_src='';

  	function getModul() {
		return $this->_modul;
	}
	function setModul($modul) {
		$this->_modul=$modul;
	}
 	function startElement($parser, $name, $atts) {
        	switch ($name) {
			case "P":
				$this->parsertext .= "";
				break;
			case "TITLE1":
				$this->parsertext .= "<title style=\"h1\" align=\"left\">";
			break;
			case "TITLE2":
				$this->parsertext .= "<title style=\"h2\" align=\"left\">";
			break;
			case "TITLE3":
				$this->parsertext .= "<title style=\"h3\" align=\"left\">";
			break;
			case "U":
				$this->parsertext .= "<text style=\"underline\">";
			break;
			case "B":
				$this->parsertext .= "<text style=\"bold\">";
			break;
			case "I":
				$this->parsertext .= "<text style=\"italic\">";
			break;
			case "C":
				$this->parsertext .= "<text style=\"color\">";
			break;
			case "HR":
				$this->parsertext .= "<line />";
			break;
			case "LINK":
				if ($atts['URL']==''.intval($atts['URL'])) {
					$ltyp='int';
				} else {
					$ltyp='ext';
				}
				$this->parsertext .= "<link type=\"$ltyp\" url=\"".htmlspecialchars($atts['URL'])."\" align=\"inline\">";
			break;
			case "LIST":
				if ($atts['STYLE']) {
					$this->parsertext .= "<list style=\"".$atts['STYLE']."\" align=\"left\">";
				} else {
					$this->parsertext .= "<list style=\"dot\" align=\"left\">";
				}
			break;
			case "ITEM":
				$this->parsertext .= "<item>";
			break;
			default:
				$this->parsertext .=FrameWork::entities('<'.$name.'>');
			break;
        	}

   	}
   	function endElement($parser, $name) {
		switch ($name) {
			case "P":
				$this->parsertext .= "";
				break;
			case "TITLE1":
				$this->parsertext .= "</title>";
			break;
			case "TITLE2":
				$this->parsertext .= "</title>";
			break;
			case "TITLE3":
				$this->parsertext .= "</title>";
			break;
			case "U":
				$this->parsertext .= "</text>";
			break;
			case "B":
				$this->parsertext .= "</text>";
			break;
			case "C":
				$this->parsertext .= "</text>";
			break;
			case "I":
				$this->parsertext .= "</text>";
			break;
			case "HR":
				break;
			case "LINK":
				$this->parsertext .= "</link>";
			break;
			case "LIST":
				$this->parsertext .= "</list>";
			break;
			case "ITEM":
				$this->parsertext .= "</item>";
			break;
			default:
				$this->parsertext .=FrameWork::entities('<'.$name.'>');
			break;
		}
   	}
   	function cdata($parser, $text) {
		$this->parsertext .=htmlspecialchars($text);
   	}

    function encodeText($content){
		$this->parsertext='';
 		$content=preg_replace('/(<\/title[123]{1}>)\s{1,2}(\s*)/is','\\1\\2',$content);
		$content=$this->encode($content);
		//echo FrameWork::entities($content).'<br><br>';
		$content=preg_replace('/(<list[^>]*>)(.*)(<\/list>)/iseU', "stripslashes('\\1').'<item>'.str_replace('\n','</item><item>',stripslashes('\\2')).'</item>\\3'",$content);

		$parser = xml_parser_create('UTF-8');
		xml_parser_set_option ($parser, XML_OPTION_TARGET_ENCODING,GE_CHARSET);
		xml_set_object($parser, $this);
		xml_set_element_handler($parser,"startElement","endElement");
		xml_set_character_data_handler($parser, "cdata");
		if (!xml_parse($parser,'<p>'.Framework::convertCharset($content,GE_CHARSET,'UTF-8').'</p>',true)) {
				$cont_array=explode("\n",$content);
				$error_line=xml_get_current_line_number($parser);
				$error_line_text=$cont_array[$error_line-1];
				if ($error_line==count($cont_array)) $error_code=1;
				else $error_code=2;
				$this->xmlerror=array('line'=>$error_line,'linetext'=>$error_line_text,'code'=>$error_code);
		return false;

		}
		xml_parser_free($parser);
		return $this->parsertext;
   	}
	function decodeText(&$node,$ignore_first=0) {
		if (is_object($node)) {
			$result=$this->_decodeText($node,$ignore_first);
			$replace=array(
				'</b><b>'=>'',
				'</c><c>'=>'',
				'</i><i>'=>'',
				'</title1><title1>'=>'',
				'</title2><title2>'=>'',
				'</title3><title3>'=>'',
			);
			$result=strtr($result,$replace);
			$replace=array(
				'</title1>'=>"</title1>\n",
				'</title2>'=>"</title2>\n",
				'</title3>'=>"</title3>\n",
				'<hr></hr>'=>"<hr/>",
			);
			$result=strtr($result,$replace);
		}
		return $result;
	}
	function _decodeText(&$node,$ignore_first=0,$pos=0) {
		$name=$node->get_name();
		$attribs=$node->get_attribs();
		$tagattr=array();
		$tagname='';
		if (!$ignore_first) {
			switch ($name) {
				case 'title':
					if ($attribs['style']=='h1') {
						$tagname='title1';
					}elseif ($attribs['style']=='h2') {
						$tagname='title2';
					}elseif ($attribs['style']=='h3') {
						$tagname='title3';
					}
					break;
				case 'text':
					if ($attribs['style']=='bold') {
						$tagname='b';
					} elseif ($attribs['style']=='italic') {
						$tagname='i';
					} elseif ($attribs['style']=='underline') {
						$tagname='u';
					}elseif ($attribs['style']=='color') {
						$tagname='c';
					} else {
						$tagname='';
					}
					break;
				case 'list':
					$tagname='list';
					$tagattr['style']=$attribs['style'];
					break;
				case 'item':
					if ($pos!=0 && ($node->children_len() || $node->data_len())) $result.="\n";
					break;
				case 'line':
					$tagname='hr';
					break;
				case 'link':
					$tagname='link';
					$tagattr['url']=$attribs['url'];
					break;
				default:
					$tagname='';
			}
		}
		if ($tagname) {
			$result .="<" . $tagname;
			foreach ($tagattr as $key => $val) {
				$result .= " " . $key . '="' . $val . '"';
			}
			$result .= ">";
		}
		if ($node->children_len() || $node->data_len()) {
			if ($node->children_len()) {
				foreach ($node->get_children() as $pos=>$child) {
					$this->depth++;
					$result .= $this->_decodeText($child,0,$pos);
					$this->depth--;
				}
			}
			if ($node->data_len()) {
				$result .= $node->get_data();
			}
		}
		if ($tagname) {
			$result .= "</" . $tagname . ">";
		}
		return $result;
	}
     	function encode($text) {
		while ($text!=$ntext) {
			$ntext=$text;
			$text=preg_replace('/<\s*(('.implode('|',$this->_allowed_o_tags).')[^>]*)>(.*)<\s*\/\s*\\2\s*>/isU','#||\\1||#\\3#||/\\2||#',$ntext);
		}
		$text=str_replace('||#','>',str_replace('#||','<',htmlspecialchars($text,ENT_NOQUOTES)));
		$text=preg_replace('/&lt;\s*(('.implode('|',$this->_allowed_c_tags).')\s*\/)\s*&gt;/i','<\\1>',$text);
		//echo '<br><br>####'.FrameWork::entities($text).'<br><br>';
		return $text;
   	}
	function setLink($link) {
		$this->_link=$link;
	}
	function init ($mode) {
		$this->_mode=$mode;
		$this->_usedImages=array();
		$this->_anchors=array();
		$this->_cidData=array();
	}
	function getMode() {
		return ($this->_mode);
	}
	function getHtml ($node,$recurse=1,$indent="",$newline="\n",$pos=0,$sub_style='') {
		$this->depth=0;
		$this->_anchors=array();
		$this->_cidData=array();
		return $this->printHtml($node,$recurse,$indent,$newline,$pos,$sub_style);
	}
	function setImgClass(&$class) {
		$this->_Bmng=&$class;
	}
	function setImgFunction($func) {
		$this->_img_function=$func;
	}
	function setImgGalFunction($func) {
		$this->_img_gal_function=$func;
	}

	function setLinkFunction($func) {
		$this->_link_function=$func;
	}
	function getImgSrc($src) {
		if ($this->_img_function) {
			$func=$this->_img_function;
			$src=$func($src);
		}
		return 'fetch_image.php?mode=final&file='.basename($src);
	}
	function getImgGalerie($src) {
		if ($this->_img_gal_function) {
			$func=$this->_img_gal_function;
			return $func($src);
		} else {
			return false;
		}
	}
	function getLink($l_type,$link) {
		if ($this->_link_function) {
			$func=$this->_link_function;
			return $func($l_type,$link);
		} else {
			return false;
		}
	}
	function setTplCfg($cfg) {
		$this->_tpl_cfg=$cfg;
	}
	function getTplCfg($key) {
		return ($this->_tpl_cfg[$key]);
	}
	function setStyle($style,$style_id=0) {
		foreach ($style as $val) {
			//echo $val['StyleKeyName'].'-'.$val['StyleVal'].'<br>';
			$this->tag[$val['StyleKeyName']]=array(
				$val['TagName'],
				$val['ClassName'],
				$val['StyleVal'],
			);
		}
	}
	function getStyle($tag) {
		if (isset($this->tag[$tag][1])) {
			return $this->getValue('prepend').$this->tag[$tag][1];
		} else {
			return false;
		}
	}
	function getTag($tag) {
		return $this->tag[$tag][0];
	}
	function getValue($tag) {
		return $this->tag[$tag][2];
	}
	function getUsedImages() {
		return $this->_usedImages;
	}
	function getUsedFiles() {
		return $this->_usedFiles;
	}
	function getAnchors() {
		return $this->_anchors;
	}
	function getCidData() {
		return $this->_cidData;
	}
	function searchImages(&$node,$path='') {
		$this->_usedImages=array();
		$this->_searchImages($node,$path);
		return $this->getUsedImages();
	}


	function _searchImages(&$node,$path='') {
		if ($node->get_name()=='image') {
			$attribs=$node->get_attribs();
			$attribs['base']=basename($attribs['base']);
			if ($attribs['base']!='space_edit.gif') {
				if ($path) {
					$orig_img=$path.'/'.$attribs['base'];
				} else {
					$orig_img=$this->_Bmng->getCfg('OrigPath').'/'.$attribs['base'];
				}
				//echo $orig_img.'<br>';
				if ((file_exists($orig_img) && ($info=GetImageSize($orig_img)))) {
					$width=round($this->getValue('image|max')/100*(substr($attribs['width'],0,-1)));
					if ($width>$info[0]) $width=$info[0];
					if ($attribs['border']) {
						$width-=2;
					}
					$this->_usedImages[$attribs['base']][]=$width;
				}
			}
		}
		if ($node->children_len()) {
			foreach ($node->get_children() as $pos=>$child) {
				$this->_searchImages($child,$path);
			}
		}
	}
	function searchFiles(&$node) {
		$this->_usedFiles=array();
		$this->_searchFiles($node);
		return $this->getUsedFiles();
	}
	function _searchFiles(&$node) {
		if ($node->get_name()=='download') {
			$attribs=$node->get_attribs();
			if ($attribs['url']) {
				$this->_usedFiles[$node->get_id()]=$attribs['url'];
			}
		}
		if ($node->children_len()) {
			foreach ($node->get_children() as $pos=>$child) {
				$this->_searchFiles($child);
			}
		}
	}
	function getRecurData(&$node) {
		if ($node->data_len()) {
			$data.=$node->get_data();
		}
		if ($node->children_len()) {
			foreach ($node->get_children() as $child) {
				$data.=$this->getRecurData($child);
			}
		}
		return $data;
	}
	function printTplHtml($tp_width=100,&$node,$indent=" ",$newline="\n",$pos=0,$sub_style='') {
		$name=$node->get_name();
		$attribs=$node->get_attribs();
		$id=$node->get_id();
		$parent=$node->get_parent();
		$tagattr=array();
		$tagname='';
		$prepend_a='';
		switch ($name) {
			case 'table':
				$sub_style['row']=array(
					'border'=>$attribs['border'],
					'rowcolor'=>$attribs['rowcolor'],
					'headrow'=>$attribs['headrow'],
				);
				$styleName=$name.'|'.'border'.'|'.$attribs['border'];
				$tagattr['class']=$this->getStyle($styleName);
				$tagname=$this->getTag($styleName);
				if ($this->getValue($name.'|width|'.$attribs['width'])) {
					$tagattr['width']=$this->getValue($name.'|width|'.$attribs['width']);
				}
				$tagattr['align']=$attribs['align'];
				$tagattr['style']='clear:both;';
				break;
			case 'row':
				$tagname='tr';
				$sub_style['col']=array();
				switch ($sub_style['row']['headrow']) {
					case '1':
						if ($pos==0) {
							$sub_style['col']['headrow']='1';
						} else {
							$sub_style['col']['headrow']='0';
						}
						break;
					default:
						$sub_style['col']['headrow']='0';
						break;
				}

				switch ($sub_style['row']['border']) {
					case 'outborder':
						$sub_style['col']['border']='none';
						break;
					case 'border':
						$sub_style['col']['border']='border';
						break;
					default:
						$sub_style['col']['border']='none';
						break;

				}
				switch ($sub_style['row']['rowcolor']) {
     					case 'alternate':
						if ($pos%2) {
							$sub_style['col']['rowcolor']='none';
						} else {
							$sub_style['col']['rowcolor']='color';
						}
						break;
					default:
						$sub_style['col']['rowcolor']='none';
						break;
				}
				break;
			case 'col':
				if (!$node->children_len()) {
					$node->add_data(' ');
				}
				$styleName=$name.'|'.$sub_style['col']['border'].'|'.$sub_style['col']['headrow'].'|'.$sub_style['col']['rowcolor'];
				$tagattr['class']=$this->getStyle($styleName);
				$tagname=$this->getTag($styleName);
				$tagattr['align']=$attribs['align']?$attribs['align']:'left';
				if ($tagattr['align']=='justify') {
					unset($tagattr['align']);
					if (!$sub_style['col']['headrow']) $tagattr['style']="text-align:justify;";
				}
				$tagattr['valign']=$attribs['valign']?$attribs['valign']:'center';
				if ($sub_style['col']['rowspan']) {
					$tagattr['rowspan']=$sub_style['col']['rowspan'];
				}
				if ($sub_style['col']['colspan']) {
					$tagattr['colspan']=$sub_style['col']['colspan'];
				}
				break;
			case 'obj:title':
				if (!$node->children_len() && !$node->data_len()) {
					$node->add_data(' ');
				}
				$tagname='div';
				$tagattr['class']='tp_title';
				break;
			case 'obj:fasttext':
			case 'obj:text':
				if (!$node->children_len() && !$node->data_len()) {
					$node->add_data(' ');
				}
				$tagname='div';
				$tagattr['class']='tp_text';
				break;

			case 'obj:list':
				if (!$node->children_len() && !$node->data_len()) {
					$node->add_data(' ');
				}
				$tagname='div';
				$tagattr['class']='tp_list';
				break;
			case 'image':
				if (!$attribs['align']) $attribs['align']='none';
				if ($attribs['align']!='none' && $attribs['align']!='center') {
					$tagattr['align']=$attribs['align'];
				}
				$tagattr['style']='margin:1px;';
				$attribs['base']=basename($attribs['base']);

				$tagname='img';
				$width=round($this->getValue('image|max')/100*(substr($attribs['width'],0,-1)));
				if ($attribs['base']!='space_edit.gif') {
					$orig_img=$this->_Bmng->getCfg('OrigPath').'/'.$attribs['base'];
					if (file_exists($orig_img) && ($info=GetImageSize($orig_img))) {
						if ($width>$info[0]) $width=$info[0];

						$width=intval($width*$tp_width/$this->getValue('image|max'));
						if ($width==0) $width=1;
						if ($attribs['border']=='1') {
							$width-=2;
							$tagattr['border']='1';
						} else {
							$tagattr['border']='0';
						}
						$src=$this->_Bmng->getCfg('ImgPath').'/'.$width.'_'.$attribs['base'];
						if (!file_exists($src)) {
							$not_exists=true;
						} else {
							$not_exists=false;
						}
						if ($not_exists || filemtime($orig_img) > filemtime($src)) {
							$this->_Bmng->_resize($orig_img,$src,$info,$width);
							if ($not_exists) {
								$this->_Bmng->insertImgTemp($attribs['base'],$this->getModul(),$width,$this->_Bmng->getCfg('ImgPath'));
							}
						}
						$this->_usedImages[$attribs['base']][]=$width;
						$tagattr['src']=$this->getImgSrc($src);
						$tagattr['width']=$width;
						if ($attribs['align']=='center') {
							$prepend='<div align="center" style="clear:both;">';
							$after='</div>';
						}
						//$tagattr['align']=$attribs['align'];
					} else {
						$tagattr['src']=$this->_Bmng->getCfg('ImgPath').'/space.gif';
					}
				} else {
					$width=intval($width*$tp_width/$this->getValue('image|max'));
					if ($width==0) $width=1;
     					$tagattr['width']=$width;
					$tagattr['height']='1';
					$tagattr['src']=$this->_Bmng->getCfg('ImgPath').'/space.gif';
				}
				break;

			case 'paragraph':
				$tagname='div';
				if (!$attribs['align'])  $attribs['align']='left';
				$tagattr['style']='clear:both;margin-bottom:2px;text-align:'.$attribs['align'];
				break;
			default:
				$tagname='';
		}


		if ($tagname) {
			$result.=str_repeat($indent,$this->depth);
			$result .="<" . $tagname;
			foreach ($tagattr as $key => $val) {
				$result .= " " . $key . '="' . $val . '"';
			}
		}
		//echo $name.':'.$tagname.'<br>';
		if ($node->children_len() || $node->data_len() ) {
			if ($tagname) {
				$result .= ">".$prepend_a;
			}
			if ($node->children_len()) {
				$result.=$newline;
				//echo "$name<br>";
				foreach ($node->get_children() as $pos=>$child) {
					$this->depth++;
					$result .= $this->printTplHtml($tp_width,$child,$indent,$newline,$pos,$sub_style);
					$this->depth--;
				}
				$result .=str_repeat($indent,$this->depth);
			} elseif ($name=='col') {
				$result.='<div></div>';
			}
			if ($tagname) {
				$result .= "</" . $tagname . ">";
				$result .=$newline;
			}
		} else {
			if ($tagname) {
				$result .= " />";
				$result .=$newline;
			}
		}
		return $result;
	}
	function printHtml(&$node,$recurse,$indent=" ",$newline="\n",$pos=0,$sub_style='') {
		$name=$node->get_name();
		$attribs=$node->get_attribs();
		$id=$node->get_id();
		$parent=$node->get_parent();
		$tagattr=array();
		$prepend='';
		$prepend_a='';
		$after='';
		$after_a='';
		$link="";
		$tagname='';
		$anewline=$newline;
		if ($attribs['cid']) {
			$this->_cidData[$attribs['cid']]= $node->get_id();
		}
		switch ($name) {
			case 'title':
				$styleName=$name.'|'.$attribs['style'];
				if (($this->_mode=='edit' || $this->_mode=='tpl') && $this->getStyle($styleName.'|edit')) {
					$styleName.='|edit';
				}
				$tagattr['class']=$this->getStyle($styleName);
				$tagname=$this->getTag($styleName);
				if ($attribs['anchor']) {
					if ($this->_mode!='edit' && $this->_mode!='tpl') {
						$prepend="<a name=\"A$id\"></a>";
						$this->_anchors["#A$id"]=$this->getRecurData($node);
						$prepend_a='<a href="#top"><img src="img/top.gif" border="0" vspace="0" hspace="0" align="right"></a>';
					} else {
						$prepend_a='<img src="img/top.gif" border="0" vspace="0" hspace="0" align="right">';
					}
					$after_a='<hr noshade="noshade" class="'.$this->getStyle('line|anchor').'" />';
				}
				if (!$node->children_len() && !$node->data_len()) {
					$prepend_a.='&nbsp;';
				}
				break;
			case 'table':
				$sub_style['row']=array(
					'border'=>$attribs['border'],
					'rowcolor'=>$attribs['rowcolor'],
					'headrow'=>$attribs['headrow'],
				);
				$styleName=$name.'|'.'border'.'|'.$attribs['border'];
				if (($this->_mode=='edit' || $this->_mode=='tpl') && $this->getStyle($styleName.'|edit')) {
					$styleName.='|edit';
				}
				$tagattr['class']=$this->getStyle($styleName);
				$tagname=$this->getTag($styleName);

				if ($this->getValue($name.'|width|'.$attribs['width'])) {
					$tagattr['width']=$this->getValue($name.'|width|'.$attribs['width']);
				}
				$tagattr['cellpadding']='0';
				$tagattr['cellspacing']='0';
				/*
				if ($attribs['width']=='max') {
					//$tagattr['style']='clear:both;';
				} else {
					$clear='';
				}*/
				$clear=' style="clear:both;"';
    				$prepend="<div align=\"".$attribs['align']."\"$clear";
				if ($parent->get_name()=='obj:table' && ($this->_mode=='edit' || $this->_mode=='tpl')) {
     					//$prepend.=' OnMouseOver="viewObject('.$parent->get_id().',true);"';
					//$prepend.=' OnMouseOut="viewObject('.$parent->get_id().',false);"';
					$prepend.=">";
					//$sub_style['row']['view_div']=$parent->get_id();
					$prepend.="<div id=\"".$parent->get_id()."\" class=\"edit_tab\">";
					$prepend.="<a href=\"".$this->_link."&mode=table&cont_id=".$parent->get_id()."\" class=\"edit\">";
					$prepend.="<img src=\"img/".$GLOBALS['THEME']."/rs_table.gif\" border=\"0\" />";
					$prepend.="</a>";
					$prepend.="</div>";
				} else {
					$prepend.=">";
				}
    				$after="</div>";

				break;
			case 'row':
				$tagname='tr';
				$sub_style['col']=array();
				switch ($sub_style['row']['headrow']) {
					case '1':
						if ($pos==0) {
							$sub_style['col']['headrow']='1';
						} else {
							$sub_style['col']['headrow']='0';
						}
						break;
					default:
						$sub_style['col']['headrow']='0';
						break;
				}

				switch ($sub_style['row']['border']) {
					case 'outborder':
						$sub_style['col']['border']='none';
						break;
					case 'border':
						$sub_style['col']['border']='border';
						break;
					default:
						$sub_style['col']['border']='none';
						break;

				}
				switch ($sub_style['row']['rowcolor']) {
     					case 'alternate':
						if ($pos%2) {
							$sub_style['col']['rowcolor']='none';
						} else {
							$sub_style['col']['rowcolor']='color';
						}
						break;
					default:
						$sub_style['col']['rowcolor']='none';
						break;
				}
				break;
			case 'col':
				$styleName=$name.'|'.$sub_style['col']['border'].'|'.$sub_style['col']['headrow'].'|'.$sub_style['col']['rowcolor'];
				if (($this->_mode=='edit' || $this->_mode=='tpl') && $this->getStyle($styleName.'|edit')) {
					$styleName.='|edit';
				}
				$tagattr['class']=$this->getStyle($styleName);
				$tagname=$this->getTag($styleName);
				$tagattr['align']=$attribs['align']?$attribs['align']:'left';
				if ($tagattr['align']=='justify') {
					unset($tagattr['align']);
					if (!$sub_style['col']['headrow']) $tagattr['style']="text-align:justify;";
				}
				$tagattr['valign']=$attribs['valign']?$attribs['valign']:'center';
				if (!$node->children_len()) {
					$prepend_a.='&nbsp;';

				}
				if (($this->_mode=='edit' || $this->_mode=='tpl')) {
						//unset($tagattr['valign']);
						$tagattr['OnMouseOver']="viewBackground($id,true);";
						$tagattr['OnMouseOut']="viewBackground($id,false);";
						$tagattr['context']=":c_insert:c_title:c_text:c_fasttext:c_list:c_link:c_image:c_table:";
						$tagattr['ObjID']=$id;
						$tagattr['OnClick']="showmenuie5(event)";
				}
				if ($sub_style['col']['rowspan']) {
					$tagattr['rowspan']=$sub_style['col']['rowspan'];
				}
				if ($sub_style['col']['colspan']) {
					$tagattr['colspan']=$sub_style['col']['colspan'];
				}
				break;
			case 'obj:image':
				if (($this->_mode=='edit' || $this->_mode=='tpl')) {
					$tagname='span';
					$link=$this->_link."&mode=image&cont_id=".$id;
				}
				if ($parent->get_name()=='col') {
					$sub_style['img']='|tab';
				} else {
					$sub_style['img']='';
				}
				break;
			case 'obj:table':
				if (($this->_mode=='edit' || $this->_mode=='tpl')) {
					$tagname='';
					$prepend="";
				}
				break;
			case 'obj:text':
				if (($this->_mode=='edit' || $this->_mode=='tpl')) {
					$tagname='span';
					$tagattr['OnMouseOver']="viewBackground($id,true);viewObject('add_$id',true);";
					$tagattr['OnMouseOut']="viewBackground($id,false);viewObject('add_$id',false);";
					$link=$this->_link."&mode=text&cont_id=".$id;
				}
				if ($this->_mode=='tpl' && $attribs['edit']) {
					$prepend='<div class="tplbox">';
					if ($attribs['title']) {
						$prepend.=htmlspecialchars($attribs['title']);
					} else {
						$prepend.='Text';
					}
					$prepend.='</div>';
				}
				if (!$node->children_len()) {
					$prepend_a.='&nbsp;';
				}
				break;
			case 'obj:title':
				if (($this->_mode=='edit' || $this->_mode=='tpl')) {
					$tagname='span';
					$tagattr['OnMouseOver']="viewBackground($id,true);";
					$tagattr['OnMouseOut']="viewBackground($id,false);";
					$link=$this->_link."&mode=title&cont_id=".$id;
				}
				if ($this->_mode=='tpl' && $attribs['edit']) {
					$prepend='<div class="tplbox">';
					if ($attribs['title']) {
						$prepend.=htmlspecialchars($attribs['title']);
					} else {
						$prepend.='Title';
					}
					$prepend.='</div>';
				}
				break;
			case 'obj:fasttext':
				if (($this->_mode=='edit' || $this->_mode=='tpl')) {
					$tagname='span';
					$tagattr['OnMouseOver']="viewBackground($id,true);";
					$tagattr['OnMouseOut']="viewBackground($id,false);";
					$link=$this->_link."&mode=fasttext&cont_id=".$id;
				}
				if ($this->_mode=='tpl' && $attribs['edit']) {
					$prepend='<div class="tplbox">';
					if ($attribs['title']) {
						$prepend.=htmlspecialchars($attribs['title']);
					} else {
						$prepend.='FastText';
					}
					$prepend.='</div>';
				}
				//echo  $node->children_len();
				if (!$node->children_len()) {
					$prepend_a.='&nbsp;';
				}
				break;
			case 'obj:link':

				if (($this->_mode=='edit' || $this->_mode=='tpl')) {
					$tagname='span';
					$tagattr['OnMouseOver']="viewBackground($id,true);";
					$tagattr['OnMouseOut']="viewBackground($id,false);";
					$link=$this->_link."&mode=link&cont_id=".$id;
				}
				if ($this->_mode=='tpl' && $attribs['edit']) {
					$prepend='<div class="tplbox">';
					if ($attribs['title']) {
						$prepend.=htmlspecialchars($attribs['title']);
					} else {
						$prepend.='Link';
					}
					$prepend.='</div>';
				}
				break;
			case 'obj:download':
				if (($this->_mode=='edit' || $this->_mode=='tpl')) {
					$tagname='span';
					$tagattr['OnMouseOver']="viewBackground($id,true);";
					$tagattr['OnMouseOut']="viewBackground($id,false);";
					$link=$this->_link."&mode=download&cont_id=".$id;
				}
				if ($this->_mode=='tpl' && $attribs['edit']) {
					$prepend='<div class="tplbox">';
					if ($attribs['title']) {
						$prepend.=htmlspecialchars($attribs['title']);
					} else {
						$prepend.='Download';
					}
					$prepend.='</div>';
				}
				break;
			case 'obj:mmedia':
				if (($this->_mode=='edit' || $this->_mode=='tpl')) {
					$tagname='span';
					$tagattr['OnMouseOver']="viewBackground($id,true);";
					$tagattr['OnMouseOut']="viewBackground($id,false);";
					$link=$this->_link."&mode=mmedia&cont_id=".$id;
				}
				if ($this->_mode=='tpl' && $attribs['edit']) {
					$prepend='<div class="tplbox">';
					if ($attribs['name']) {
						$prepend.=htmlspecialchars($attribs['name']);
					} else {
						$prepend.='Multimedia';
					}
					$prepend.='</div>';
				}
				break;
			case 'obj:list':
				if (($this->_mode=='edit' || $this->_mode=='tpl')) {
					$tagname='span';
					$tagattr['OnMouseOver']="viewBackground($id,true);";
					$tagattr['OnMouseOut']="viewBackground($id,false);";
					$link=$this->_link."&mode=list&cont_id=".$id;
				}
				if ($this->_mode=='tpl' && $attribs['edit']) {
					$prepend='<div class="tplbox">';
					if ($attribs['title']) {
						$prepend.=htmlspecialchars($attribs['title']);
					} else {
						$prepend.='List';
					}
					$prepend.='</div>';
				}
				break;
			case 'text':
				$styleName=$name.'|'.$attribs['style'];
				if (($this->_mode=='edit' || $this->_mode=='tpl') && $this->getStyle($styleName.'|edit')) {
					$styleName.='|edit';
				}
				if ($this->getStyle($styleName)) {
					$tagattr['class']=$this->getStyle($styleName);
				}
				if ($attribs['style']=='bold') {
					$tagname='strong';
				} elseif ($attribs['style']=='italic') {
					$tagname='em';
				} elseif ($attribs['style']=='underline') {
					$tagname='u';
				} elseif ($attribs['style']=='color') {
					$tagname='span';
				}
				if (!$node->children_len() && !$node->data_len()) {
					$prepend_a.='&nbsp;';
				}
				$anewline='';
				break;
			case 'list':
				$styleName=$name.'|'.$attribs['style'];
				if (($this->_mode=='edit' || $this->_mode=='tpl') && $this->getStyle($styleName.'|edit')) {
					$styleName.='|edit';
				}
				$tagname=$this->getTag($styleName);
				$tagattr['class']=$this->getStyle($styleName);
				if (!$node->children_len() && !$node->data_len()) {
					$prepend_a.='&nbsp;';
				}
				break;
			case 'item':
				$styleName=$name;
				if (($this->_mode=='edit' || $this->_mode=='tpl') && $this->getStyle($styleName.'|edit')) {
					$styleName.='|edit';
				}
				$tagname=$this->getTag($styleName);
				$tagattr['class']=$this->getStyle($styleName);
				if (!$node->children_len() && !$node->data_len()) {
					$prepend_a.='&nbsp;';
				}
				break;
			case 'image':
				if (!$attribs['align']) $attribs['align']='none';
				$attribs['base']=basename($attribs['base']);

				$styleName=$name.'|'.$attribs['align'].$sub_style['img'];

				if (($this->_mode=='edit' || $this->_mode=='tpl') && $this->getStyle($styleName.'|edit')) {
					$styleName.='|edit';
				}
				$tagname=$this->getTag($styleName);
				$tagattr['class']=$this->getStyle($styleName);
				$width=round($this->getValue('image|max')/100*(substr($attribs['width'],0,-1)));
				if ($attribs['base']!='space_edit.gif') {

					$orig_img=$this->_Bmng->getCfg('OrigPath').'/'.$attribs['base'];
					//debug($orig_img);
					if ($attribs['base'] && file_exists($orig_img) && ($info=GetImageSize($orig_img))) {
						if ($width>$info[0]) $width=$info[0];
						if ($attribs['border']=='1') {
							$width-=2;
							$tagattr['border']='1';
						} else {
							$tagattr['border']='0';
						}
						$src=$this->_Bmng->getCfg('ImgPath').'/'.$width.'_'.$attribs['base'];
						if (!file_exists($src)) {
							$not_exists=true;
						} else {
							$not_exists=false;
						}
						if ($not_exists || filemtime($orig_img) > filemtime($src)) {
							$this->_Bmng->_resize($orig_img,$src,$info,$width);
							if ($not_exists) {
								$this->_Bmng->insertImgTemp($attribs['base'],$this->getModul(),$width,$this->_Bmng->getCfg('ImgPath'));
							}
						}
						$this->_usedImages[$attribs['base']][]=$width;
						$tagattr['src']=$this->getImgSrc($src);
						$tagattr['width']=$width;
						if ($attribs['title']) {
							$tagattr['alt']=$tagattr['title']=$attribs['title'];
						}
						if ($attribs['align']=='center') {
							$prepend='<div align="center" style="clear:both">';
							$after='</div>';
						}
						if ($attribs['over']) {
							$orig_img=$this->_Bmng->getCfg('OrigPath').'/'.$attribs['over'];
							if (file_exists($orig_img) && ($info=GetImageSize($orig_img))) {
								if ($width>$info[0]) $width=$info[0];
								$src=$this->_Bmng->getCfg('ImgPath').'/'.$width.'_'.$attribs['over'];
								if (!file_exists($src)) {
									$not_exists=true;
								} else {
									$not_exists=false;
								}
								if ($not_exists || filemtime($orig_img) > filemtime($src)) {
									$this->_Bmng->_resize($orig_img,$src,$info,$width);
									if ($not_exists) {
										$this->_Bmng->insertImgTemp($attribs['over'],$this->getModul(),$width,$this->_Bmng->getCfg('ImgPath'));
									}
								}
								$this->_usedImages[$attribs['over']][]=$width;
								$tagattr['name']="over_$id";
								$tagattr['onMouseOut']="MM_swapImgRestore()";
								$tagattr['onMouseOver']="MM_swapImage('".$tagattr['name']."','','".$this->getImgSrc($src)."',1)\"";

							}
						}
						if ($attribs['link:type']  && $attribs['link:type']!='none') {
							if ($attribs['link:type']!='self') {
								$olink=$this->getLink($attribs['link:type'],$attribs['link:url']);
								if ($olink) {
									$prepend.='<a href="'.$olink['href'].'" target="'.$olink['target'].'">';
									$after='</a>'.$after;
								}
							} else {
								$img_gal=$this->getImgGalerie($attribs['base']);
								//debug($img_gal);
								if ($img_gal) {
									$ct_link=$this->getImgSrc($img_gal['src']);
									$this->_usedImages[$attribs['base']][]=$img_gal['size'];
									$this->_Bmng->insertImgTemp($attribs['base'],$this->getModul(),$img_gal['size'],$this->_Bmng->getCfg('ImgPath'));
								} elseif ($this->_link) {
									$ct_link=$this->_link."&mode=image&cont_id=".$parent->get_id();
								} else {
									$ct_link='fetch_image.php?mode=orig&file='.$attribs['base'];
								}
								$cont_tmp=getExtContainer('galerie',$attribs,$ct_link);
								$prepend.=$cont_tmp['prepend'];
								$after=$cont_tmp['after'].$after;
								//$tagattr['border']=0;
								//unset($tagattr['class']);
							}
						}

						//$tagattr['align']=$attribs['align'];
					} else {
						$tagattr['src']=$this->_Bmng->getCfg('ImgPath').'/space.gif';
						if (($this->_mode=='edit' || $this->_mode=='tpl')) {
							$tagattr['border']='1';
							$tagattr['width']=$tagattr['height']=$width-2;
						}
					}
				} else {
					$tagattr['width']=$width;
					if (($this->_mode=='edit' || $this->_mode=='tpl')) {
						$tagattr['border']='0';
						$tagattr['height']='3';
						$tagattr['src']=$this->_Bmng->getCfg('ImgPath').'/space_edit.gif';
					} else {
						$tagattr['height']='1';
						$tagattr['src']=$this->_Bmng->getCfg('ImgPath').'/space.gif';
					}
				}
				break;
			case 'line':
				$styleName=$name;
				if (($this->_mode=='edit' || $this->_mode=='tpl') && $this->getStyle($styleName.'|edit')) {
					$styleName.='|edit';
				}
				$tagname=$this->getTag($styleName);
				$tagattr['class']=$this->getStyle($styleName);
				$tagattr['noshade']="true";
				break;
			case 'link':
				//debug($attribs);
				$styleName=$name;
				if (($this->_mode=='edit' || $this->_mode=='tpl') && $this->getStyle($styleName.'|edit')) {
					$styleName.='|edit';
				}
				$tagname=$this->getTag($styleName);
				$tagattr['class']=$this->getStyle($styleName);
				if ($strrpos=strrpos($tagattr['class'],':')) {
					$tagattr['class']=substr($tagattr['class'],0,$strrpos);
				}

				if ($this->_mode!='edit' && $this->_mode!='tpl') {
					$olink=$this->getLink($attribs['type'],$attribs['url']);
					if ($olink) {
						$tagattr['href']=$olink['href'];
						$tagattr['target']=$olink['target'];
					} else {
						$tagattr['href']='#';
					}
				}
				if (!$node->children_len() && !$node->data_len()) {
					$prepend_a.='&nbsp;';
				}
				$anewline='';
				break;
			case 'download':
				$styleName=$name;
				if (($this->_mode=='edit' || $this->_mode=='tpl') && $this->getStyle($styleName.'|edit')) {
					$styleName.='|edit';
				}

				if (($this->_mode=='edit' || $this->_mode=='tpl')) {
					$tagname='span';
					if ($GLOBALS['app']['fmng']) {
						$ct_link=$this->_link."&mode=download&cont_id=".$parent->get_id();
					} else {
						$ct_link='#';
					}
				} else {
					$tagname='';
					$ct_link='';
				}
				$prepend_a=getExtContainer('download',$attribs['url'],$ct_link);
				$after_a='';
				break;
			case 'address':
				$styleName=$name;
				if (($this->_mode=='edit' || $this->_mode=='tpl') && $this->getStyle($styleName.'|edit')) {
					$styleName.='|edit';
				}

				if (($this->_mode=='edit' || $this->_mode=='tpl')) {
					$tagname='span';
					if ($GLOBALS['app']['faddr']) {
						$ct_link=$this->_link."&mode=address&cont_id=".$parent->get_id();
					} else {
						$ct_link='#';
					}
				} else {
					$tagname='';
					$ct_link='';
				}
				$prepend_a=getExtContainer('address',$attribs['url'],$ct_link);
				$after_a='';
				break;
			case 'mmedia':
				$styleName=$name;
				if (($this->_mode=='edit' || $this->_mode=='tpl') && $this->getStyle($styleName.'|edit')) {
					$styleName.='|edit';
				}
				if (($this->_mode=='edit' || $this->_mode=='tpl')) {
					$prepend.="<div id=\"o_$id\" class=\"\">";
					$prepend.="<a href=\"".$this->_link."&mode=mmedia&cont_id=".$parent->get_id()."#\" class=\"edit\">";
					$prepend.="<img src=\"img/".$GLOBALS['THEME']."/rs_mmedia.gif\" border=\"0\" OnMouseOver=\"viewBackground($id,true);\" OnMouseOut=\"viewBackground($id,false);\" />";
					$prepend.="</a>";
					$prepend.="</div>";
				}
				switch($attribs['type']) {
					case 'text/html':
						$tagname='iframe';
						$tagattr['width']=$attribs['width'];
						$tagattr['height']=$attribs['height'];
						$tagattr['src']='fetch_imng_file.php?file='.urlencode($attribs['file']).'&type='.urlencode($attribs['type']);
						$tagattr['frameborder']='0';
						$prepend_a.='<a href="'.$tagattr['src'].'">'.$tagattr['name'].'</a>';
					break;
					default:
						$tagname='<div>';
						$prepend_a.='&nbsp;';
					break;
				}


				break;
			case 'paragraph':
				if (!$attribs['align'])  $attribs['align']='left';
				$styleName=$name.'|'.$attribs['align'];
				if (($this->_mode=='edit' || $this->_mode=='tpl') && $this->getStyle($styleName.'|edit')) {
					$styleName.='|edit';
				}
				$tagname=$this->getTag($styleName);
				$tagattr['class']=$this->getStyle($styleName);
				if ($attribs['l_indent']) {
					$tagattr['style'].='padding-left:'.($attribs['l_indent']*20).'px;';
				}
				if ($attribs['r_indent']) {
					$tagattr['style'].='padding-right:'.($attribs['r_indent']*20).'px;';
				}

				//$tagattr['OnMouseOver']="viewObject('o_$id',true);";
				//$tagattr['OnMouseOut']="viewObject('o_$id',false);";
				if (($this->_mode=='edit' || $this->_mode=='tpl')) {
					$prepend.="<div id=\"o_$id\" class=\"edit_para\">";
					$prepend.="<a href=\"".$this->_link."&mode=paragraph&cont_id=".$id."#\" class=\"edit\">";
					$prepend.="<img src=\"img/".$GLOBALS['THEME']."/rs_absatz.gif\" border=\"0\" OnMouseOver=\"viewBackground($id,true);\" OnMouseOut=\"viewBackground($id,false);\" />";
					$prepend.="</a>";
					$prepend.="</div>";
				}
				if (!$node->children_len()) {
					$prepend_a.='&nbsp;';
				}
				break;
			case '_text':
				$tagname='';
				break;
			case 'webobj':
				$tagname='';
				break;
			default:
				$tagname=$name;
		}
		if ($tagname) {
			$result.=str_repeat($indent,$this->depth);
			if ($link) $result .="<a href=\"$link\" class=\"edit\">";
			$result .=$prepend."<" . $tagname;
			foreach ($tagattr as $key => $val) {
				$result .= " " . $key . '="' . $val . '"';
			}
			if (($this->_mode=='edit' || $this->_mode=='tpl')) $result .= ' id="'.$id.'"';
		} elseif ($prepend) {
			$result .=str_repeat($indent,$this->depth).$prepend;
		}
		//echo $name.':'.$tagname.'<br>';

		if ($node->children_len() || $node->data_len() || $prepend_a || $after_a) {
			if ($tagname) {
				$result .= ">";
			}
			$result .=$prepend_a;
			if ($node->children_len() && $recurse) {
				$result.=$anewline;
				foreach ($node->get_children() as $pos=>$child) {
					$this->depth++;
					$result .= $this->printHtml($child,$recurse,$indent,$newline,$pos,$sub_style);
					$this->depth--;
				}
				$result .=str_repeat($indent,$this->depth);
			}
			if ($node->data_len()) {
				$result .= str_replace('\_','&nbsp;',str_replace('\ ','&nbsp;',$this->entities($node->get_data(),true)));
			}
			$result .= $after_a;
			if ($tagname) {
				$result .= "</" . $tagname . ">".$after;
				if ($link) $result .="</a>";
				$result .=$anewline;
			} elseif ($after) {
				$result .=$after.$anewline;
			}
		} else {
			if ($tagname) {
				$result .= " />".$after;
				if ($link) $result .="</a>";
				$result .=$anewline;

			} elseif ($after) {
				$result .=$after.$anewline;
			}
		}

		return $result;
	}
	function entities($string,$nl2br=false) {
		if ($nl2br) {
			return nl2br(htmlspecialchars($string));
		} else {
			return htmlspecialchars($string);
		}

	}
}
function getExtContainer($container,$id,$ct_link='') {
	global $Imng,$t,$xmlFastText,$frm;
	switch ($container) {
		case 'download':
			if ($Imng->getCfg('cfg/container/download')) {
				$Fmng=& $frm->getStaticModul('fmng');
				$parse_ok=false;
				$Fmng->setLang($Imng->getLangID());
				//$old_root=$t->getRoot();
				//$t->setRoot(".");
				$t->unload('TmpContainer');
				$t->define(array('TmpContainer'=>$Imng->getCfg('cfg/container/download')));
				$obj=$Fmng->getObj($id);
				if ((is_object($obj) && $obj->getAcl(1) && $obj->getMeta('DocType')=='ext')) {
					if ($ct_link) {
						$t->assign('DL_LINK',$ct_link);
					} else {
						$t->assign('DL_LINK',"index.php?site=".$obj->getSite()."&action=".$obj->getAction(0)."&oid=".$obj->getID());
					}
					$t->assign('DL_IMAGE',$obj->getMeta('MenuImage'));
					$t->assign("DL_TITLE",$xmlFastText->entities($obj->getName($Imng->getLangID())));
					$t->assign("DL_DESC",$xmlFastText->entities($obj->getMeta('Text'),1));
					$t->assign('DL_SIZE',FrameWork::formatsize(intval($obj->getFileMeta('FileSize'))));
					$t->parse('TPL_TMP_CONTAINER','TmpContainer');
					$parse_ok=true;
				}
				if (!$parse_ok && ($xmlFastText->getMode()=='edit' || $xmlFastText->getMode()=='tpl')) {
					$t->assign('DL_IMAGE','other.gif');
					$t->assign("DL_TITLE",'No Name');
					$t->assign("DL_DESC",'');
					$t->assign('DL_SIZE',FrameWork::formatsize(0));
					if ($ct_link) {
						$t->assign('DL_LINK',$ct_link);
					} else {
						$t->assign('DL_LINK','#');
					}
					$t->parse('TPL_TMP_CONTAINER','TmpContainer');
					$parse_ok=true;
				}
				//$t->setRoot($old_root);
				if ($parse_ok) return $t->getParsed();
			}
		break;
		case 'address':
			if ($Imng->getCfg('cfg/container/address')) {
				$Addr=& $frm->getStaticModul('addr');
				$parse_ok=false;
				//$old_root=$t->getRoot();
				//$t->setRoot(".");
				$t->unload('TmpContainer');
				$t->define(array('TmpContainer'=>$Imng->getCfg('cfg/container/address')));
				$Address=$Addr->getAddrObj($id);
				if (is_object($Address)) {

					$t->assign('ADDR_LINK','#');
					$t->assign('ADDR_NAME',$Addr->getName());
					$t->parse('TPL_TMP_CONTAINER','TmpContainer');
					$parse_ok=true;
				}

				if (!$parse_ok && ($xmlFastText->getMode()=='edit' || $xmlFastText->getMode()=='tpl')) {
					$t->assign("ADDR_NAME",'No Name');
					if ($ct_link) {
						$t->assign('ADDR_LINK',$ct_link);
					} else {
						$t->assign('ADDR_LINK','#');
					}
					$t->parse('TPL_TMP_CONTAINER','TmpContainer');
					$parse_ok=true;
				}
				if ($parse_ok) return $t->getParsed();
			}
		break;
		case 'galerie':
			if ($Imng->getCfg('cfg/container/image')) {
				$old_root=$t->getRoot();
				$t->setRoot(".");
				$t->unload('TmpContainer');
				$t->define(array('TmpContainer'=>$Imng->getCfg('cfg/container/image')));
				$t->assign('IMG_LINK',$ct_link);
				if ($id['title']) {
    					$t->assign('IMG_TITLE',$xmlFastText->entities($id['title']));
					$t->parse('ROW','img_title');
				} else {
					$t->clear_dynamic('img_title');
				}
				$t->parse('ROW','img_prepend');
				$result['prepend']=$t->getParsed();
				$t->parse('ROW','img_after');
				$result['after']=$t->getParsed();
				$t->setRoot($old_root);
				return $result;
			} else {
				$result['prepend']='<a href="'.$ct_link.'"';
				if ($ct_link!='#' && $xmlFastText->getMode()!='edit' && $xmlFastText->getMode()!='tpl') {
					$result['prepend'].=' target="_blank"';
				}
				$result['prepend'].='>';
				$result['after']='</a>';
				return $result;
			}
		break;
	}
	return '';
}

function formatLink($l_type,$link,$FileObj='') {
	global $Imng;
	$ref='';
	$target='';
	if ($l_type=='int' || $l_type=='intern') {
		if (!is_object($link)) {
			$link_obj=$Imng->getObj($link);
		} else {
			$link_obj=$link;
		}
		if (is_object($link_obj)) {
			$ref="index.php?site=".$link_obj->getSite()."&oid=".$link_obj->getID();
		}
	}
	if ($l_type=='ext' || $l_type=='extern') {
		if (preg_match('@(http|https|ftp)://@',$link)) {
			$ref=$link;
			$target='_blank';
		} else {
			$ref=$link;
		}
		if (preg_match('/@/',$ref)) {
			$ref=str_replace('@','&#x40;',$ref);
			$ref=str_replace('.','&#x2e;',$ref);
		}
	}
	if ($ref) {
		//echo $ref.'<br>';
		return array(
			'href'=>$ref,
			'target'=>$target,
		);
	} else {
		return false;
	}
}
function formatImgSrc($src) {
	return $src;
}
function getGalerieDE($src) {
	return getGalerie($src,'de');
}
function getGalerieIT($src) {
	return getGalerie($src,'it');
}
function getGalerieEN($src) {
	return getGalerie($src,'en');
}
function getGalerie($src,$prep='') {
	global $Bmng;
	$src=basename($src);
	$orig_img=$Bmng->getCfg('OrigPath').'/'.$src;
	if ($src && file_exists($orig_img)) {
		$final_img=$Bmng->getCfg('ImgPath').'/'.$prep.'_'.$src;
		if (!file_exists($final_img) || filemtime($orig_img) > filemtime($final_img)) {
			copy($orig_img,$final_img);
		}
		$result['src']=$final_img;
		$result['size']=$prep;
		return $result;
	}
	return false;
}
?>
