<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class convert_html {
	var $db;
  	function convert_html($db) {
		$this->db=$db;
 	}
    	function startElement($parser, $name, $atts) {
		if ($this->closelist && $name!='LIST') {
			$this->parsertext.='</list>';
			$this->openlist=0;
			$this->closelist=0;
		}

        	switch ($name) {
                	case "P":
				$this->parsertext .= "";
                        	break;
               		case "TITLE1":
                      		$this->parsertext .= "<title style=\"h1\">";
             		break;
			case "TITLE2":
				$this->parsertext .= "<title style=\"h2\">";
			break;
			case "TITLE3":
				$this->parsertext .= "<title style=\"h3\">";
			break;
			case "U":
				$this->parsertext .= "<text style=\"underline\">";
			break;
			case "B":
				$this->parsertext .= "<text style=\"bold\">";
			break;
			case "I":
				$this->parsertext .= "<text style=\"italic\">";
			break;
			case "HR":
				$this->parsertext .= "<line />";
			break;
			case "LINK":
				$link=$this->format_link($atts[URL]);
				if ($link==''.intval($link)) {
					$ltyp='int';
				}  else {
					$ltyp='ext';
				}

				$this->parsertext .= "<link type=\"$ltyp\" url=\"".$link."\">";
			break;
			case "LIST":
				 if (!$this->closelist) {
					$this->parsertext .= "<list style=\"dot\">";
					$this->openlist=1;
				}
				$this->parsertext .= "<item>";
				$this->closelist=0;
			break;
			default:
				$this->parsertext .=FrameWork::entities('<'.$name.'>');
			break;
        	}

   	}
   	function endElement($parser, $name) {
		if ($this->closelist && $name!='LIST') {
			$this->parsertext.='</list>';
			$this->openlist=0;
			$this->closelist=0;
		}
		switch ($name) {
			case "P":
				$this->parsertext .= "";
				break;
			case "TITLE1":
				$this->parsertext .= "</title>";
			break;
			case "TITLE2":
				$this->parsertext .= "</title>";
			break;
			case "TITLE3":
				$this->parsertext .= "</title>";
			break;
			case "U":
				$this->parsertext .= "</text>";
			break;
			case "B":
				$this->parsertext .= "</text>";
			break;
			case "I":
				$this->parsertext .= "</text>";
			break;
			case "HR":
				break;
			case "LINK":
				$this->parsertext .= "</link>";
			break;
			case "LIST":
				$this->parsertext .= "</item>";
                        	$this->closelist=1;
			break;
			default:
				$this->parsertext .=FrameWork::entities('<'.$name.'>');
			break;
		}
   	}
   	function cdata($parser, $text) {
		if ($this->closelist) {
                	$this->parsertext.='</list>';
                	$this->openlist=0;
                	$this->closelist=0;

        	}
		$this->parsertext .=htmlspecialchars($text);
   	}

    	function sgml_exttext($doc_id,$style,$attribute,$content,$key=0,$parent=0){
		//echo FrameWork::entities($content).'<br><br><br>';
		$style_array=explode("|",$style);
        	$this->parsertext='';
         	$this->openlist=0;
        	$this->closelist=0;
		$content=preg_replace('/<\/list>\s{1,2}(\s*)/is','</list>\\1','<p>'.$content.'</p>');
        	$content=preg_replace('/(<\/title[123]{1}>)\s{1,2}(\s*)/is','\\1\\2',$content);
       		$content=str_replace('&','&amp;',$content);
        	$content=str_replace('\<','&lt;',$content);
        	$content=str_replace('\>','&gt;',$content);
        	$parser = xml_parser_create();
       		xml_set_object($parser, $this);
        	xml_set_element_handler($parser,"startElement","endElement");
        	xml_set_character_data_handler($parser, "cdata");
        	if (!xml_parse($parser,$content,true)) {
                	$cont_array=explode("\n",$content);
                	$error_line=xml_get_current_line_number($parser);
               	 	$error_line_text=preg_replace("/<\/?p>/i","",$cont_array[$error_line-1]);
                	if ($error_line==count($cont_array)) $error_code=1;
                	else $error_code=2;
                	$this->xmlerror[$key]=array('line'=>$error_line,'linetext'=>$error_line_text,'code'=>$error_code);

        	}
		if ($this->closelist) {
                	$this->parsertext.='</list>';
                	$this->openlist=0;
                	$this->closelist=0;
        	}
		//echo FrameWork::entities($this->parsertext).'<br><br><br>';

        	xml_parser_free($parser);
        	$text='<obj:fasttext>'.$this->parsertext.'</obj:fasttext>';
		if (!$parent) {
			if ($style_array[0]=="newline" ) {
				$text.="</paragraph><paragraph>";
			}
		} else {
			//$text="<paragraph>".$text."</paragraph>";
		}
		//echo FrameWork::entities($text);
       		return $text;
   	}
   	function sgml_title($doc_id,$style,$attribute,$content,$key=0,$parent=0){
                 $style_array=explode("|",$style);
                 switch($style_array[0]){
                         case "main":
                                   $title="<obj:title><title style=\"h1\"$para>".$this->encode($content)."</title></obj:title>";
                         break;
                         case "sub":
                                    $title="<obj:title><title style=\"h2\"$para>".$this->encode($content)."</title></obj:title>";
                         break;
                         case "section":
                                    $title="<obj:title><title style=\"h3\"$para>".$this->encode($content)."</title></obj:title>";
                         break;
                }
			//if (!$parent) $title="</paragraph><paragraph>".$title;
      		return $title;
   	}
   	function sgml_text($doc_id,$style,$attribute,$content,$key=0,$parent=0){
		$open=array();
		$close=array();
                $style_array=explode("|",$style);
                if ($style_array[1]=="bold"){
			$open[]="<text style=\"bold\">";
			$close[]="</text>";
                }
                if ($style_array[2]=="italic"){
  			$open[]="<text style=\"italic\">";
			$close[]="</text>";
                }
		$content=$this->encode($content);
		$content="<obj:text>".implode('',$open).$content.implode('',$close)."</obj:text>";

		if (!$parent && $style_array[0]=="newline") {
			$content.="</paragraph><paragraph>";
		}
		return $content;
   	}
   	function sgml_picture($doc_id,$style,$attribute,$content,$key=0,$parent=0){
                $style_array=explode("|",$style);
                $align=$style_array[5];
		$width=$style_array[6];

		$style_array[7]=='self';
		$picture="<obj:image><image";
		$picture.=" base=\"".$this->encode($content)."\"";
		$picture.=" over=\"".$this->encode($style_array[9])."\"";
		$picture.=" width=\"".$style_array[6]."%\"";
		$picture.=" align=\"".$style_array[5]."\"";
		$picture.=" title=\"". htmlspecialchars($style_array[3], ENT_QUOTES)."\"";
		if ($style_array[4]=="border") {
			$picture.=" border=\"1\"";
		} else {
			$picture.=" border=\"0\"";
		}
		$picture.=" link:type=\"".substr($style_array[7],0,3)."\"";
		$picture.=" link:url=\"".$this->format_link($style_array[8])."\"";
		$picture.=" /></obj:image>";
		if (!$parent) {
			if ($style_array[5]=="center") {
				$picture="</paragraph><paragraph>".$picture;
			}
			if ($style_array[1]=="newline") {
				$picture.="</paragraph><paragraph>";
			}
		}
		return $picture;
   	}
    	function sgml_list($doc_id,$style,$attribute,$content,$key=0,$parent=0){
		$style_array=explode("|",$style);
		switch ($style_array[0]){
			case "dot":
				$list="<list style=\"dot\">";
			break;
			case "number":
				$list="<list style=\"number\">";
			break;
			case "alpha":
				$list="<list style=\"alpha\">";
			break;
		}
		$content_array=explode("\n",$content);
		foreach($content_array as $val){
			//echo FrameWork::entities($this->encode($val)).'<br>';
			$list.="<item>".$this->encode($val)."</item>";
		}
		$list.="</list>";
		$list='<obj:list>'.$list.'</obj:list>';

		return $list;
   	}
   	function sgml_link($doc_id,$style,$attribute,$content,$key=0,$parent=0){
        	$style_array=explode("|",$style);
  		$link="<obj:link><link type=\"".substr($style_array[0],0,3)."\" url=\"".$this->format_link($style_array[2])."\">";
		$link.=$this->encode($style_array[3]);
		$link.="</link></obj:link>";
		if (!$parent && $style_array[4]=="newline") {
			$link.="</paragraph><paragraph>";
		}
            	return $link;
   	}
   	function sgml_table($doc_id,$style,$attribute,$content,$key=0,$parent=0){
                $style_array=explode("|",$style);
		$col_align=explode(',',$style_array[4]);
		$row_align=explode(',',$style_array[5]);
		$cell_width=explode(',',$style_array[6]);
		$border=0;

		if ($style_array[1]=="border") {
				$tabclass="border";
				$tdclass=1;
		} elseif ($style_array[1]=="outborder") {
				$tabclass="outborder";
				$tdclass=0;
		}  else {
				$tdclass=0;
				$tabclass="none";
		}
		if ($style_array[2]=="max") {
			$width="max";
		} else  {
			$width="min";
		}
		if ($this->newline || $style_array[2]=="max") {
				$s_attr="style=\"clear:both\"";
				$this->newline=0;

		} else $s_attr="";
		/*if (!$parent) $table="</paragraph><paragraph>";
		else $table='';*/
		$table.="<obj:table><table align=\"".$style_array[3]."\" border=\"$tabclass\" width=\"$width\"";
		if ($style_array[7]) {
			$table.=" rowcolor=\"alternate\"";
		} else {
			$table.=" rowcolor=\"none\"";
		}
		if ($style_array[0]=="head") {
			$table.=" headrow=\"1\"";
		} else {
			$table.=" headrow=\"0\"";
		}
	    	$table.=">";
              	$row_ar=explode("|",$content);
              	$letter=range('A', 'Z');
              	for ($i=0;$i<count($row_ar);$i++){
                           $item=explode(";",$row_ar[$i]);
                           if ($row_align[$i]=='b') $valign="bottom";
                           elseif ($row_align[$i]=='c') $valign="center";
                           else $valign="top";
		           $table.="<row>";
                           for($j=0;$j<count($item);$j++){
                                    $ek=intval($item[$j]);
                                    if ($col_align[$j]=='m') $align="center";
                                    elseif ($col_align[$j]=='r') $align="right";
                                    else $align="left";
                                    if ($entry=$this->entry_array[$doc_id][$ek]) {
                                        $val=$this->{'sgml_'.$entry[1]}($entry[4],$entry[0],$entry[2],$entry[3],$ek,$doc_id);
                                    }else {
                                        $val='';
                                    }
                                    $table.="<col align=\"$align\" valign=\"$valign\">".$val."</col>";
                            }
                            $table.="</row>";
              	}
              	$table.="</table></obj:table>";
		//if ($parent) $table="<paragraph>".$table."</paragraph>";
	    	return $table;
   	}
     	function encode($text) {
		$text=htmlspecialchars($text);
		$text=preg_replace('/&lt;b\s*&gt;/','<text style="bold">',$text);
		$text=preg_replace('/&lt;\/\s*b\s*&gt;/','</text>',$text);
		$text=preg_replace('/&lt;i\s*&gt;/','<text style="italic">',$text);
		$text=preg_replace('/&lt;\/\s*i\s*&gt;/','</text>',$text);
		return $text;
   	}
	function format_link($link) {
		if (preg_match("@^([0-9]+):([0-9]+)$@",$link,$match)) {
			$ref=$match[1];
		} else {
			$ref=$link;
		}
		return $ref;
	}
	function make_para(){
		if (is_array($this->entry_array[0])) {
		 	$i=1;
			$page.="<paragraph>";
			foreach($this->entry_array[0] as $key=>$val){
				if ($val[1]) $page.=$this->{'sgml_'.$val[1]}($val[4],$val[0],$val[2],$val[3],$key,0);
			}
			$page.="</paragraph>";
		}
		$page=str_replace("\r","",$page);
		$page=preg_replace('/<paragraph>\s*<\/paragraph>/','',$page);

		return $page;
	}
	function make_page($entry_array) {
		$this->entry_array=$entry_array;
		if (is_array($this->entry_array)) $page=$this->make_para();
		return $page;
	}
	function read_entry($MetaID) {
    		$this->db->query("SELECT * FROM Doc_Content where fk_meta_id='".$MetaID."' order by sort");
		while ($this->db->next_record()){
			$entry_array[$this->db->f('parentid')][$this->db->f('sort')]=array($this->db->f('stile'),$this->db->f('type'),$this->db->f('attribute'),$this->db->f('content'),$this->db->f('doc_id'));
		}
		//var_Dump($entry_array);
		return $entry_array;
   	}
}
?>
