<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class LinkObj {
	var $_meta=array();
	var $_pmeta=array();
	var $_acl;
	var $_ID;
	function getID() {
		return $this->_ID;
	}
	function setID($ID) {
		$this->_ID=$ID;
	}
	function getMeta($key) {
		return $this->_meta[$key];
	}
	function setMeta($key,$data) {
		$this->_meta[$key]=$data;
	}
	function getParentMeta($key) {
		return $this->_pmeta[$key];
	}
	function setParentMeta($key,$data) {
		$this->_pmeta[$key]=$data;
	}
	function getName($lang='') {
		if (!$lang) $lang=$GLOBALS['session_lang'];
		return $this->_meta['Title_'.$lang];
	}
	function getACL($chk=0) {
		$chk=intval($chk);
		if ($chk) {
			if ($this->_acl==-1) {
				return true;
			} else {
				return ($this->_acl&$chk);
			}
		} else {
			return $this->_acl;
		}
	}
	function setAcl($acl) {
		$this->_acl=$acl;
	}
	function getAction($typ) {
		return $this->_action[$typ];
	}
	function getSite() {
		return $this->_site;
	}

}

class LObj_fol extends LinkObj   {
	var $_site='lmng.php';
	var $_action=array('b','b');
	function LObj_fol($ID=0,$meta=0,$pmeta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.=$this->getMeta('MenuImage');
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='fol';
		if ($this->getMeta('Trash')) {
			$ac.='_tr';
		}
		if ($typ) $ac.='_l';
		return $ac;
	}
	function isFolder() {
		return true;
	}
}

class LObj_link extends LinkObj   {
	var $_site='lmng.php';
	var $_action=array('vo&open_x=1','vo&edit=1');
	function LObj_link($ID=0,$meta=0,$pmeta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		$image.=$this->getMeta('MenuImage');
		return $image;
	}
	function getActionMode() {
		$ac='link';
		if ($this->getMeta('Trash')) {
			$ac.='_tr';
		}
		return $ac;
	}
	function isFolder() {
		return false;
	}
}
class LObj_trash extends LinkObj  {
	var $_site='lmng.php';
	var $_action=array('bt','bt');
	function LObj_trash($ID=0,$meta=0,$pmeta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.=$this->getMeta('MenuImage');
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='trash';
		if ($typ) {
			$ac.='_l';
		}
		return $ac;
	}
	function isFolder() {
		return true;
	}
}
class Lmng {
	var $_db;
	var $_uid;
	var $_lang;
	var $_gid;
	var $_rule=false;
	var $_sadmin=false;
	var $_locked_obj=array();
	var $_clipboard=array();
	var $_modul='lmng';
	var $_frm;

	function Lmng (&$db,$uid=0,$gid=0,$lang=0) {
		global $frm;
		$this->_db=$db;
		$this->_uid=$uid;
		$this->_lang=$lang;
		$this->_gid=$gid;
		$this->_frm=$frm;
	}
	function getModul() {
		return $this->_modul;
	}
	function setUser($uid) {
		$this->_uid=$uid;
		$this->_gid=$gid;
	}
	function getUser() {
		return $this->_uid;
	}
	function setGroups($gid) {
		$this->_gid=$gid;
	}
	function setLang($lang) {
		$this->_lang=$lang;
	}
	function setRule($bool=false) {
		$this->_rule=$bool;
	}
	function setSuperAdmin($bool=false) {
		$this->_sadmin=$bool;
	}
	function setLocked($locked) {
		$this->_locked_obj=$locked_obj;
	}
	function isLocked(&$obj) {
		if ($this->_locked_obj[$obj->getID()]) {
			return true;
		} else {
			return false;
		}
	}
	function setClipboard($what,$content) {
		$this->_clipboard[$what]=$content;
	}
	function getClipboard($what) {
		return $this->_clipboard[$what];
	}
	function isClipboard($what) {
		if ($this->_clipboard[$what]) {
			return true;
		} else {
			return false;
		}
	}
	function isRuleUser() {
		return $this->_rule;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function setCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}
		}
	}
	function getCfg($key) {
		if (isset($this->_cfg[$key])) {
			return $this->_cfg[$key];
		} else {
			return false;
		}
	}
	function setRootObj(&$obj) {
		$this->_root_obj=&$obj;
	}
	function &getRootObj() {
		return $this->_root_obj;
	}
	function setMode($mode) {
		$this->_mode=$mode;
	}
	function getMode() {
		return $this->_mode;
	}
	function &searchObj (&$rows,$b=0,$limit=0,$search_sql='',$order,$use_limit=false,$use_perms=true) {
		$result=array();
		$query="SELECT * FROM LinkMetabase LEFT JOIN LinkHotlist ON (FKDocID=DocID AND FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.="WHERE (UserID=0 OR UserID=".$this->_db->escape($this->_uid).')';
		if (!$this->isRuleUser() && $use_perms) $query.=" AND (UserID='".$this->_uid."' OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
		if ($search_sql) $query.=" AND $search_sql ";
		if ($order) $query.="ORDER BY $order ";
		if ($limit) $query.=$this->_db->formatLimit($b,$limit).' ';
		//echo $query;
		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		while ($this->_db->next_record()) {
			$class='LObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			//echo $acl.'<br>';
			if ($acl || !$use_perms) {
				$result[$this->_db->f("DocID")]=new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}

		}
		if ($use_limit && $limit && ($b!=0 || $limit==$rows)) {
			$query="SELECT count(*) as num FROM LinkMetabase LEFT JOIN LinkHotlist ON (FKDocID=DocID AND FKUserID=".$this->_db->escape($this->_uid).") ";
			$query.="WHERE (UserID=0 OR UserID=".$this->_db->escape($this->_uid).')';
			if (!$this->isRuleUser() && $use_perms) $query.=" AND (UserID='".$this->_uid."' OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
		if ($search_sql) $query.=" AND $search_sql ";
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
		}
		return $result;
	}
	function searchFolderByName($ParentID,$name,$use_perms=ture) {
		$query="SELECT * FROM LinkMetabase WHERE ParentID=".$this->_db->escape($ParentID);
		$query.=" AND Title_".$this->_lang." LIKE ".$this->_db->escape($name);
		$query.=" AND (UserID=0 OR UserID=".$this->_db->escape($this->_uid).')';
		if (!$this->isRuleUser() && $use_perms) $query.=" AND (UserID='".$this->_uid."' OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='LObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				return new $class($this->_db->f("DocID"),$this->fetchObject($lang),$this->fetchParent(),$acl);
			}
		}
	}
	function searchLinkByUrl($ParentID,$url,$use_perms=ture) {
		$query="SELECT * FROM LinkMetabase LEFT JOIN LinkHotlist ON (FKDocID=DocID AND FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.=" WHERE ParentID=".$this->_db->escape($ParentID);
		$query.=" AND Link LIKE ".$this->_db->escape($url);
		$query.=" AND (UserID=0 OR UserID=".$this->_db->escape($this->_uid).')';
		if (!$this->isRuleUser() && $use_perms) $query.=" AND (UserID='".$this->_uid."' OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='LObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				return new $class($this->_db->f("DocID"),$this->fetchObject($lang),$this->fetchParent(),$acl);
			}
		}
	}

	function &ListAllTree($RootID=-1,$ParentID=-1,$order_f='Title_de',$order_d='ASC',$app='',$use_perms=true) {
		$result=array();
		if ($order_f) $order_met="ORDER BY $order_f $order_d";
		//debug($app);
		if ($app && !empty($app)) {
			$sql_app=$this->_db->escape($app);
			if (is_array($app) && count($app)) $where[]="DocType IN (".implode(",",$sql_app).")";
			elseif  ($app) $where[]="DocType=$sql_app";
		}

		$sql_RootID=$this->_db->escape($RootID);
		if (is_array($RootID)) $where[]="RootID IN (".implode(",",$sql_RootID).")";
		elseif ($RootID!=-1)  $where[]="RootID=$sql_RootID";

		$sql_ParentID=$this->_db->escape($ParentID);
		if (is_array($ParentID)) $where[]="ParentID IN (".implode(",",$sql_ParentID).")";
		elseif ($ParentID!=-1)  $where[]="ParentID=$sql_ParentID";

		$where[]="(UserID=0 OR UserID=".$this->_db->escape($this->_uid).')';
		if (!$this->isRuleUser() && $use_perms) $where[]="(UserID='".$this->_uid."' OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";

		$query="SELECT * FROM LinkMetabase LEFT JOIN LinkHotlist ON (FKDocID=DocID AND FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.=" WHERE  ".implode(' AND ',$where)." $order_met";
		//echo $query.'<br><br>';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='LObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				$result[$this->_db->f("ParentID")][$this->_db->f("DocID")]=new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}
		}
		return $result;
	}


	function &ListSubEntrys($ParentID,$app='',$order_f='Title_de',$order_d='ASC',$use_perms=true) {
		$result=array();
		if ($order_f) $order_met="ORDER BY $order_f $order_d";

		$sql_app=$this->_db->escape($app);
		if (is_array($app)) $where[]="DocType IN (".implode(",",$sql_app).")";
		elseif  ($app) $where[]="DocType=$sql_app";

		$sql_ParentID=$this->_db->escape($ParentID);
		if (is_array($ParentID)) $where[]="ParentID IN (".implode(",",$sql_ParentID).")";
		else $where[]="ParentID=$sql_ParentID";

		$where[]="(UserID=0 OR UserID=".$this->_db->escape($this->_uid).')';
		if (!$this->isRuleUser() && $use_perms) $where[]="(UserID='".$this->_uid."' OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";

		$query="SELECT * FROM LinkMetabase LEFT JOIN LinkHotlist ON (FKDocID=DocID AND FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.=" WHERE  ".implode(' AND ',$where)." $order_met";
		//echo $query.'<br><br>';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='LObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				$result[$this->_db->f("DocID")]=new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}
		}
		return $result;
	}
	function getSystemObj($system,$lang,$user=-1,$use_perms=true) {
		if ($user==-1) $user=$this->_uid;
		$query="SELECT * FROM LinkMetabase WHERE System=".$this->_db->escape($system);
		$query.=" AND UserID=".$this->_db->escape($user);
		//echo $query;
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='LObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				return new $class($this->_db->f("DocID"),$this->fetchObject($lang),$this->fetchParent(),$acl);
			}
		}
	}
	function updateMeta(&$obj) {
		$values=$obj->_meta;
		if ($obj->getID()) {
			$this->_db->update('LinkMetabase',$values,"DocID=".$this->_db->escape($obj->getID()));
			return $obj->getID();
		}
		return false;
	}
	function insertMeta(&$obj) {
		$values=$obj->_meta;
		$values['DocID']=$this->_db->nextid('LinkMetabase');
		if ($this->_db->insert('LinkMetabase',$values)) {
			$obj->setID($values['DocID']);
			return $obj->getID();
		}
		return false;
	}
	function deleteMeta(&$obj) {
		$query="DELETE FROM LinkMetabase WHERE DocID=".$this->_db->escape($obj->getID());
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function insertParentMeta(&$obj) {
		$values=$obj->_pmeta;
		if ($obj->getID()) {
			$values['FKDocID']=$obj->getID();
			$values['FKUserID']=$this->_uid;
			$this->_db->insert('LinkHotlist',$values,'',1);
			return $obj->getID();
		}
		return false;
	}
	function deleteParentMeta(&$obj) {
		$query="DELETE FROM LinkHotlist WHERE FKDocID=".$this->_db->escape($obj->getID());
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function getObj($ID,$lang='') {
		$query="SELECT * FROM LinkMetabase LEFT JOIN LinkHotlist ON (FKDocID=DocID AND FKUserID=".$this->_db->escape($this->_uid).") ";
		$query.=" WHERE DocID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='LObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl) {
				return new $class($this->_db->f("DocID"),$this->fetchObject($lang),$this->fetchParent(),$acl);
			}
		}
	}
	function getTrashObj() {
		$query="SELECT * FROM LinkMetabase WHERE DocType='trash'";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='LObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl) {
				return new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}
		}
	}

	function getObjTree ($parent_id) {
		do {
			$query="SELECT Title_".$this->_lang.",ParentID,DocID FROM LinkMetabase WHERE DocID=".$this->_db->escape($parent_id);
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				$parent_id=$this->_db->f('ParentID');
				$result[$this->_db->f('DocID')]=$this->_db->f('Title_'.$this->_lang);
			} else {
				$parent_id=0;
			}

		} while ($parent_id);
		return $result;
	}
	function getObjTreeIDs ($oid,$break=0) {
		if ($oid!=$break) {
			do {
				$query="SELECT ParentID FROM LinkMetabase WHERE DocID=".$this->_db->escape($oid);
				$this->_db->query($query);
				if ($this->_db->next_record()) {
					$oid=$this->_db->f('ParentID');
					$result[]=$this->_db->f('ParentID');
				} else {
					$oid=0;
				}

			} while ($oid && $oid!=$break);
		} else {
			$result[]=$oid;
		}
		return $result;
	}
	function isSubfolder($FolderID,$subFolderID) {
		if ($FolderID==$subFolderID) return true;
		$tree=$this->getObjTreeIDs ($FolderID);
		if (is_array($tree) && in_array($subFolderID,$tree)) {
			return true;
		} else {
			return false;
		}
	}
	function setOrder($ID,$o,$a) {
		$values=array(
			'FKDocID'=>$ID,
			'FKUserID'=>$this->_uid,
			'LinkOrder'=>$o,
			'LinkAsc'=>$a,

		);
		$this->_db->insert('LinkOrder',$values,'',1);
	}
	function getOrder($ID) {
		$query="SELECT LinkOrder,LinkAsc FROM LinkOrder WHERE FKDocID=".$this->_db->escape($ID);
		$query.=" AND FKUserID=".$this->_db->escape($this->_uid);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return array (
				'LinkOrder'=>$this->_db->f('LinkOrder'),
				'LinkAsc'=>$this->_db->f('LinkAsc'),
			);
		}

	}
	function deleteOrder($ID=0,$uid=0) {
		if (!$ID && !$uid) return false;
		if ($ID) $where[]="FKDocID=".$this->_db->escape($ID);
		if ($uid) $where[]="FKUserID=".$this->_db->escape($uid);
		$query="DELETE FROM LinkOrder WHERE ".implode(' AND ',$where);
		$this->_db->query($query);
	}
	function fetchACL() {
		//echo $this->_db->f('Title_de').'-'.$this->_db->f('UserID').'<br>';
		if (($this->isRuleUser() && !$this->_db->f('UserID')) || $this->_db->f('UserID')==$this->_uid) {
			return -1;
		} else {
			return $this->_frm->calcAcl($this->_db->f('Users'),$this->_db->f('Groups'),$this->_uid);;
		}
	}

	function &fetchObject($lang='') {
		$result=array(
			'RootID'=>$this->_db->f('RootID'),
			'ParentID'=>$this->_db->f("ParentID"),
			'Link'=>$this->_db->f("Link"),
			'Text'=>$this->_db->f("Text"),
			'MenuImage'=>$this->_db->f("MenuImage"),
			'TimeCreate'=>$this->_db->f("TimeCreate"),
			'TimeModify'=>$this->_db->f("TimeModify"),
			'UserCreate'=>$this->_db->f("UserCreate"),
			'UserModify'=>$this->_db->f("UserModify"),
			'DocType'=>$this->_db->f("DocType"),
			'Users'=>$this->_db->f("Users"),
			'Groups'=>$this->_db->f("Groups"),
			'UserID'=>$this->_db->f("UserID"),
			'System'=>$this->_db->f('System'),
			'Trash'=>$this->_db->f('Trash'),
		);
		if (!$lang) $lang=$this->_lang;
		if (is_array($lang)) {
			foreach ($lang as $val) {
				$result['Title_'.$val]=$this->_db->f("Title_".$val);
			}

		} else {
			$result['Title_'.$lang]=$this->_db->f("Title_".$lang);
		}
		return $result;
	}
	function &fetchParent() {
		return array(
			'Favorite'=>$this->_db->f('Favorite'),
			'TimeLast'=>$this->_db->f('TimeLast'),
			'Counter'=>$this->_db->f('Counter'),
		);
	}
	function isAllowedAction(&$obj,&$action) {
		if (!is_array($action)) return false;
		if (!$obj->getAcl($action['Perms'])) return false;
		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkAction($obj,substr($ac_val,1));
				} else {
					$result=$result||$this->_checkAction($obj,$ac_val);
				}
			}
			if (!$result) return false;
		}
		return true;
	}
	function _checkAction(&$obj,$action) {
		switch ($action) {
			case 'sadmin':
				if (!$this->isSuperAdmin()) return false;
			break;
			case 'rule':
				if (!$this->isRuleUser()) return false;
			break;
			case 'locked':
				if (!$this->isLocked($obj)) return false;
			break;
			case 'fav':
				if (!$obj->getParentMeta('Favorite')) return false;
			break;
			case 'content':
				if (!$this->isClipboard('lobj')) return false;
			break;
			case 'root':
				if ($obj->getMeta('RootID')!=$obj->getID()) return false;
			break;
			case 'no_ext':
				if (!$this->getCfg('fol/no_extl')) return false;
			break;
			case 'no_fol':
				if (!$this->getCfg('fol/no_fol')) return false;
			break;
			case 'root_s':
				if ($this->_root_obj->getMeta('System')!='s') return false;
			break;
			case 'root_d':
				if ($this->_root_obj->getMeta('System')!='d') return false;
			break;
			case 'root_u':
				if ($this->_root_obj->getMeta('System')!='u') return false;
			break;
			case 'app_msg':
				if (!$GLOBALS['app']['msg']) return false;
			break;
			case 'app_mail':
				if (!$GLOBALS['app']['email']) return false;
			break;

		}
		return true;
	}
	function getPerms($test=0) {
		if ($this->isRuleUser()) return true;
		if (!isset($this->_perms[$this->_uid])) {
			$this->_setPerms();
		}
		if ($test) {
			return ($this->_perms[$this->_uid]&$test)?true:false;
		} else {
			return $this->_perms[$this->_uid];
		}
	}
	function _setPerms() {
		$query="SELECT BIT_OR(Perms) as uperms FROM LinkPerms WHERE";
		$query.=" UserTyp=".$this->_db->escape('u');
		$query.=" AND UserID=".$this->_db->escape($this->_uid);
		$query.=" GROUP BY UserTyp";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$this->_perms[$this->_uid]=$this->_db->f('uperms');
		} else {
			$query="SELECT BIT_OR(Perms) as uperms FROM LinkPerms WHERE";
			$query.=" UserTyp=".$this->_db->escape('g');
			$query.=" AND UserID IN (".implode(',',$this->_db->escape($this->_gid)).')';
			$query.=" GROUP BY UserTyp";
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				$this->_perms[$this->_uid]=$this->_db->f('uperms');
			} else {
				$this->_perms[$this->_uid]=0;
			}
		}
	}
	function replacePerms($typ,$id,$Perms) {
		foreach ($Perms as $val) {
			$this->_db->insert('LinkPerms',array('UserID'=>$id,'UserTyp'=>$typ,'Perms'=>$val),'',1);
		}
	}
	function getAllPerms() {
		$result=array();
		$query="SELECT * FROM LinkPerms";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('UserTyp')][$this->_db->f('UserID')][]=$this->_db->f('Perms');
		}
		return $result;
	}
	function deletePerms($typ,$id) {
		$query="DELETE FROM LinkPerms WHERE";
		$query.=" UserTyp=".$this->_db->escape($typ);
		$query.=" AND UserID=".$this->_db->escape($id);
		$this->_db->query($query);
	}
	function FetchHtml($url,$def_lang){
		$result=array();
		if (function_exists('curl_init')) {
			$curl = curl_init();
			curl_setopt($curl, CURLOPT_URL, $url); 
			curl_setopt($curl, CURLOPT_HEADER, 0);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
			if ($this->getCfg('cfg/proxy/host')) {
				curl_setopt($curl, CURLOPT_PROXY,$this->getCfg('cfg/proxy/host'));
				curl_setopt($curl, CURLOPT_PROXYPORT, $this->getCfg('cfg/proxy/port'));
				curl_setopt($curl, CURLOPT_HTTPPROXYTUNNEL, 1);
			}
			$string = curl_exec($curl);
			

			$charset='ISO-8859-1';
			$char_matches=array();
			if (preg_match('/<.*charset=["\']?([^"\' ]+)["\']?.*>/i',$string,$char_matches)) {
				$charset=strtoupper($char_matches[1]);
			}
			//echo $charset;
			$matches=array();
			if (preg_match_all("/<title>(.*)<\/title>/Ui",$string,$matches, PREG_PATTERN_ORDER)) {
				$result['ObjTitle_'.$def_lang]=Framework::convertCharset($matches[1][0],$charset);
			}
			preg_match_all("/<\s*meta\s+(.*)\s*>/Ui",$string,$matches, PREG_PATTERN_ORDER);
			$k=0;
			$tmp_match_array="";
			if (is_array($matches[1])) {
				foreach ($matches[1] as $meta_val){

					// Getting Language
					preg_match_all("/lang\=\"(.*)\" /Ui",$meta_val,$lang_matches, PREG_PATTERN_ORDER);
					$lang=trim(strtolower($lang_matches[1][0]));
					// Getting name
					preg_match_all("/(name|http-equiv)\=\"(.*)\" /Ui",$meta_val,$name_matches, PREG_PATTERN_ORDER);
					// Checking if entry not exists
					$name=trim(strtolower($name_matches[2][0]));
					if ($name=='dc.title' || $name=='title') {
						preg_match_all("/content\=\"(.*)\"/Ui",$meta_val,$content_matches, PREG_PATTERN_ORDER);
						if ($lang) {
							$result['ObjTitle_'.$lang]=Framework::convertCharset(trim($content_matches[1][0]),$charset);
						} elseif (!$result['ObjTitle_'.$def_lang]) {
							$result['ObjTitle_'.$def_lang]=Framework::convertCharset(trim($content_matches[1][0]),$charset);
						}
					}
					if ($name=='dc.description' || $name=='description') {
						preg_match_all("/content\=\"(.*)\"/Ui",$meta_val,$content_matches, PREG_PATTERN_ORDER);
						$result['ObjText']=Framework::convertCharset(trim($content_matches[1][0]),$charset);
					}
				}
			}
		}
		return $result;
	}
	function updatePerms(&$obj,$rec=false) {
		$this->updateMeta($obj);
		$sub_entrys=$this->ListSubEntrys($obj->getID());
		foreach ($sub_entrys as $sub_obj) {
			if (!$sub_obj->isFolder()) {
				$sub_obj->setMeta('Users',$obj->getMeta('Users'));
				$sub_obj->setMeta('Groups',$obj->getMeta('Groups'));
				$this->updateMeta($sub_obj);
			} elseif ($rec) {
				$sub_obj->setMeta('Users',$obj->getMeta('Users'));
				$sub_obj->setMeta('Groups',$obj->getMeta('Groups'));
				$this->updatePerms($sub_obj,$rec);
			}
		}
	}


}
?>
