<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
function CutCopyObject (&$obj,&$new_obj,$mode,$first=true) {
	global $Lmng,$frm;

	if (is_object($new_obj)) {
		if ($mode=='link') {
			$ac_mode='copy';
		} else {
			$ac_mode=$mode;
		}
		if ($mode!='cut' || $first) {
			$nmode='n_';
			if ($mode=='link') $nmode.='l_';
			$nmode.=$new_obj->getMeta('DocType');
			$this_action=$frm->getObjAction ($Lmng->getModul(),$new_obj->getActionMode(0),$ac_mode);
			$obj_action=$frm->getObjAction ($Lmng->getModul(),$obj->getActionMode(0),$nmode);
			//debug($new_obj);
			if ($Lmng->isAllowedAction($new_obj,reset($this_action)) && $Lmng->isAllowedAction($obj,reset($obj_action))) {
				if ( $new_obj->isFolder() && $Lmng->isSubfolder($obj->getID(),$new_obj->getID())) {
					return array('to_self',$new_obj->getID());
				}
				if ($new_obj->getMeta('ParentID')==$obj->getID()) {
					if ($mode=='cut') {
						return;
					} elseif ($mode=='copy' || ($mode=='link' && $new_obj->isFolder())) {
						//$new_obj->setMeta('MenuTitle','copy of '.$new_obj->getMeta('MenuTitle'));
					} elseif ($mode=='link' ) {
						//$new_obj->setMeta('MenuTitle','link to '.$new_obj->getMeta('MenuTitle'));
					}
				}
				if (!$new_obj->isFolder() || $mode=='copy' ||  $mode=='link') {
					$new_obj->setMeta('Users',$obj->getMeta('Users'));
					$new_obj->setMeta('Groups',$obj->getMeta('Groups'));
				}
				//echo '<br><br>'.$oldID.'<br><br>';
				$oldID=$new_obj->getID();

				$new_obj->setMeta('TimeModify',time());
				$new_obj->setMeta('UserModify',$Lmng->getUser());
				$new_obj->setMeta('Trash',$obj->getMeta('Trash'));
				$new_obj->setMeta('ParentID',$obj->getID());
				$new_obj->setMeta('UserID',$obj->getMeta('UserID'));
				$new_obj->setMeta('RootID',$obj->getMeta('RootID'));
				if ($mode=='cut') {
					$Lmng->updateMeta($new_obj);
				} elseif ($mode=='copy' || $mode=='link') {
					$new_obj->setMeta('TimeCreate',time());
					$new_obj->setMeta('UserCreate',$Lmng->getUser());
					$Lmng->insertMeta($new_obj);
				}
				if ($new_obj->isFolder()) {
					$sub_entrys=$Lmng->ListSubEntrys($oldID,'');
					//debug($sub_entrys);
					foreach ($sub_entrys as $tmp_obj) {
						CutCopyObject($new_obj,$tmp_obj,$mode,false);
					}
				}
			} else {
				return array("no_".$mode."_perms",$new_obj->getID());
			}
		} else {
			$new_obj->setMeta('Trash',$obj->getMeta('Trash'));
			$new_obj->setMeta('UserID',$obj->getMeta('UserID'));
			$new_obj->setMeta('RootID',$obj->getMeta('RootID'));
			$Lmng->updateMeta($new_obj);
			$oldID=$new_obj->getID();
			if ($new_obj->isFolder()) {
				$sub_entrys=$Lmng->ListSubEntrys($oldID,'',0);
				foreach ($sub_entrys as $tmp_obj) {
					CutCopyObject($new_obj,$tmp_obj,$mode,false);
				}
			}
		}
	}
	return false;
}


function TrashObject (&$obj,&$new_obj,$first=1) {
	global $Lmng,$frm;
	$error=false;
	if (is_object($new_obj)) {
		if ($new_obj->getMeta('RootID')==$obj->getMeta('RootID')) {
			return;
		}
		$this_action=$frm->getObjAction ($Lmng->getModul(),$new_obj->getActionMode(0),'delete');
		if ($Lmng->isAllowedAction($new_obj,reset($this_action))) {
			$new_obj->setMeta('TimeModify',time());
			$new_obj->setMeta('UserModify',$Lmng->getUser());
			$new_obj->setMeta('Trash',1);
			$new_obj->setMeta('ParentID',$obj->getID());
			$new_obj->setMeta('RootID',$obj->getMeta('RootID'));
			if ($new_obj->isFolder()) {
				$oldObj=Framework::cloneObj($new_obj);
				$Lmng->insertMeta($new_obj);
				$sub_entrys=$Lmng->ListSubEntrys($oldObj->getID());
				if (!empty($sub_entrys)) {
					$sub_ok=0;
					foreach ($sub_entrys as $tmp_obj) {
						$tmp_error=TrashObject($new_obj,$tmp_obj,0);
						if ($tmp_error) {
							$error=array('no_sub_del_perms',$oldObj->getID());
						} else {
							$sub_ok++;
						}
					}

					if (!$sub_ok) {
						$Lmng->deleteMeta($new_obj);
					}
				}
				if (!$error) {
					$Lmng->deleteMeta($oldObj);
				}
			} else {
				$Lmng->updateMeta($new_obj);
			}
		} else {
			return array('no_del_perms',$new_obj->getID());
		}
	}
	return $error;
}
function DeleteObject (&$new_obj) {
	global $frm,$Lmng;
	if (is_object($new_obj)) {
		$this_action=$frm->getObjAction ($Lmng->getModul(),$new_obj->getActionMode(0),'f_delete');
		if ($Lmng->isAllowedAction($new_obj,reset($this_action))) {
			if ($new_obj->isFolder()) {
				$sub_entrys=$Lmng->ListSubEntrys($new_obj->getID());
				foreach ($sub_entrys as $tmp_obj) {
					DeleteObject($tmp_obj);
				}
			}
			switch ($new_obj->getMeta('DocType')) {
				case 'link':
					$Lmng->deleteParentMeta($new_obj);
				break;
			}
			$Lmng->deleteMeta($new_obj);
		} else {
			return array('no_del_perms',$new_obj->getID());
		}
	}
	return false;
}
