<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class Aliases{
	var $ds;
	var $error;
	var $Mail;
	function Aliases(&$Mail) {
		$this->Mail=$Mail;
		$tras=array();
		if (defined('GE_LdapReplace')) {
			$tras['{LDAP_REPLACE}']=GE_LdapReplace;
		}
		if (GE_DOMAIN) {
			$tras['{DOMAIN}']=str_replace('.','_',GE_DOMAIN);
		}
		$this->ldroot=strtr($Mail->getCfg('ldap/root'),$tras);
		$this->ldadmin=$Mail->getCfg('ldap/admin');
		$this->ldpw=$Mail->getCfg('ldap/passwd');
		$this->ldhost=$Mail->getCfg('ldap/host');;
		$this->userentry=$Mail->getCfg('ldap/userentry');
		$this->useralias=$Mail->getCfg('ldap/useralias');
	}
	function getError() {
		return $this->error;
	}
	function ld_connect(){
		$this->ds=ldap_connect($this->ldhost);
		if (!$this->ds) {
			$this->error="LDAP: Connect failed";
			return false;
		}
		@ldap_set_option($this->ds, LDAP_OPT_PROTOCOL_VERSION, 3);
		if ($this->ldadmin && $this->ldpw ) {
			if (ldap_bind($this->ds,$this->ldadmin,$this->ldpw)) {
				return true;
			}
		} elseif (ldap_bind($this->ds)) {
			return true;
		}
		$this->error="LDAP: ".ldap_error($this->ds);
		return false;
	}
	function ld_close(){
		ldap_close($this->ds);
	}
	function get_user_dn($search_dn) {
		$result=false;
		$sr=ldap_search($this->ds, $this->ldroot, $search_dn);
		if ($sr) {
			$info = ldap_get_entries($this->ds, $sr);
			//debug($info);
			$result=$info[0]["dn"];
		}
		return $result;
	}
	function get_alias_list_user($username) {
		if ($this->ld_connect()) {
			$strtr=array(
				'{USERNAME}'=>$this->ldapEsc($username),
				'{DOMAIN}'=>GE_DOMAIN,
			);
			$search_dn=strtr($this->userentry,$strtr);
			if ($al=ldap_search($this->ds, $this->ldroot, $search_dn,array(strtolower($this->useralias)))) {
				if ($entries=ldap_get_entries($this->ds,$al)) {
					//debug($entries);
					ldap_free_result($al);
					$list=array();
					for($i=0; $i<$entries[0][strtolower($this->useralias)]['count']; $i++){
                        $var=$entries[0][strtolower($this->useralias)][$i];
                        $list[]=array("alias"=>$var,"username"=>$username);
                	}
					return($list);
				}
			}
      	}
	   	$this->error="LDAP: ".ldap_error($this->ds);
		$this->ld_close();
		return false;
	}

	function alias_delete($aliasname, $mailboxname){
		if ($this->ld_connect()) {
			$strtr=array(
				'{USERNAME}'=>$this->ldapEsc($mailboxname),
				'{DOMAIN}'=>GE_DOMAIN,
			);
			$search_dn=strtr($this->userentry,$strtr);
			if ($user_dn=$this->get_user_dn($search_dn)) {
				$entry[$this->useralias][0]=$aliasname;
				if (@ldap_mod_del($this->ds,$this->utf8encode($user_dn),$this->utf8encode($entry))) {
					return true;
				}
			}
		}
	   	$this->error="LDAP: ".ldap_error($this->ds);
		$this->ld_close();
		return false;
	 }
	 function alias_add($aliasname, $mailboxname,$user=NULL){
		if ($this->ld_connect()) {
			$strtr=array(
				'{USERNAME}'=>$this->ldapEsc($mailboxname),
				'{DOMAIN}'=>GE_DOMAIN,
			);
			$search_dn=strtr($this->userentry,$strtr);
			if ($user_dn=$this->get_user_dn($search_dn)) {
				$ldap_add[$this->useralias][]=$aliasname;
				if (!@ldap_mod_add($this->ds,$this->utf8encode($user_dn),$this->utf8encode($ldap_add))) {
					$this->error="LDAP: ".ldap_error($this->ds);
					$this->ld_close();
					return false;
				} else {
					return true;
				}
			}
		}
	   	$this->error="LDAP: ".ldap_error($this->ds);
		$this->ld_close();
		return false;
	 }
	function ldapEsc($value) {
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->ldapEsc($val);
			}
		} else {
			$tras=array('*'=>'\\2a','('=> '\\28',')'=>'\\29','\\'=>'\\5c','\0'=>'\\00');
			$value=strtr($value,$tras);
		}
		return $value;
	}
	function ldapEscDN($value) {
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->ldapEscDN($val);
			}
		} else {
			$tras=array(','=>'\,','+'=>'\+');
			$value=strtr($value,$tras);
		}
		return $value;
	}
	function utf8encode($value) {
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->utf8encode($val);
			}
		} else {
			$value=Framework::convertCharset($value,GE_CHARSET,'UTF-8');
		}
		return $value;
	}
	function utf8decode($value) {
		if (is_array($value)) {
			foreach ($value as $key=>$val) {
				$value[$key]=$this->utf8decode($val);
			}
		} else {
			$value=Framework::convertCharset($value,'UTF-8',GE_CHARSET);
		}
		return $value;
	}}
?>
