<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class Aliases{
	var $ds;
	var $error;
	var $Mail;
	var $domain;
	var $_mail_classes=array(
		'postfixUser',
	);
	function Aliases(&$Mail) {
		$this->Mail=&$Mail;
		if (GE_mailUserSuffix) {
			$this->domain='';
		} else {
			$this->domain=$this->Mail->getCfg('cfg/domain');
			if ($this->domain && strpos($this->domain,'@')===false) {
				$this->domain='@'.$this->domain;
			}
		}
	}
	function getError() {
		return $this->error;
	}
	function alias_add($aliasname,$uid,$user=NULL){
		global $frm;
		$userData['mailacceptinggeneralid']=$aliasname;
		$userData['maildrop']=$uid.$this->domain;
		$no_error=true;
		if ($frm->_bind()) {
			$search_dn="(uid=".$frm->ldapEsc($uid).")";
			//debug($search_dn);
			if ($info=$frm->_listUser($search_dn)) {
				if ($info['count']) {
					//debug($info);
					$ldap_add=array();
					foreach ($this->_mail_classes as $val) {
						if (!in_array($val,$info[0]['objectclass']) && !in_array(strtolower($val),$info[0]['objectclass'])) {
							$ldap_add['objectClass'][]=$val;
						}
						$ldap_add = $ldap_add + $frm->_getObjectAdd($val,$userData,$info[0]);

					}
					$ldap_rep=array();
					foreach ($this->_mail_classes as $val) {
						if (in_array($val,$info[0]['objectclass']) || in_array(strtolower($val),$info[0]['objectclass'])) {
							$ldap_rep = $ldap_rep + $frm->_getObjectReplace($val,$userData,$info[0]);
						}
					}
					if (!empty($ldap_add)) {
						$no_error=$frm->_mod_add($frm->getFrmCfg('ldap/attr/uname').'='.$info[0][$frm->getFrmCfg('ldap/attr/uname')][0].','.$frm->getFrmCfg('ldap/basedn_u').','.$frm->_getBaseDn(), $ldap_add);
					}
					//debug($ldap_rep);
					if ($no_error && !empty($ldap_rep)) {
						$no_error=$frm->_mod_rep($frm->getFrmCfg('ldap/attr/uname').'='.$info[0][$frm->getFrmCfg('ldap/attr/uname')][0].','.$frm->getFrmCfg('ldap/basedn_u').','.$frm->_getBaseDn(), $ldap_rep);
					}
					if ($no_error) return ($no_error);
				} else {
					$this->error="LDAP: USER $uid not exists in LDAP";
				}
			}
		}
		if (!$this->error) $this->error=$frm->getError();
		return false;
	 }
	 function get_alias_list_user($uid) {
		global $frm;
		$result=array();
		$fields=array(
			'mailacceptinggeneralid',
			'maildrop',
		);
		if ($frm->_bind()) {
			$search_dn=array();
			$search_dn[]="(uid=".$frm->ldapEsc($uid).")";
			if ($info=$frm->_listUser('(&'.implode('',$search_dn).')',$fields)) {
				for ($i=0;$i<$info['count'];$i++) {
					for ($j=0;$j<$info[$i]['mailacceptinggeneralid']['count'];$j++) {
						$result[]=array(
							'alias'=>$info[$i]['mailacceptinggeneralid'][$j],
							'username'=>$uid,
						);
					}
				}
				//debug($info);
			}
			$frm->_close();
			$frm->_sort=array('username','alias');
			uasort($result,array($frm,'cmp'));
			return $result;
		}
		$this->error=$frm->getError();
		return false;
	}

	function alias_delete($aliasname, $uid){
		global $frm;
		if ($aliasname && $frm->_bind()) {
			$search_dn="(uid=".$frm->ldapEsc($uid).")";
			if ($info=$frm->_listUser($search_dn)) {
				if ($info['count']) {
					if ($info[0]['mailacceptinggeneralid']['count'] && in_array($aliasname,$info[0]['mailacceptinggeneralid'])) {
					//debug($info[0]['mailacceptinggeneralid']);
						$ldap_del=array('mailacceptinggeneralid'=>$aliasname);
						$no_error=$frm->_mod_del($frm->getFrmCfg('ldap/attr/uname').'='.$info[0][$frm->getFrmCfg('ldap/attr/uname')][0].','.$frm->getFrmCfg('ldap/basedn_u').','.$frm->_getBaseDn(), $ldap_del);
						if ($no_error) return true;
					} else {
						return true;
					}
				}
			}
		}
		$this->error=$frm->getError();
		return false;
	}

}
?>
