<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class CyrAdm {
	public $_perms=array(
		'1'=>"lrs",
		'3'=>"lrswipd",
		'7'=>"lrswipcd",
	);
	public $permsAll="lrswipcda";


	

	function CyrAdm(){
		global $db,$frm;
		$this->setCfg($frm->getCfg('mail',0,'cfg/%'));
		if (preg_match('/\/ssl/',$this->getCfg('cfg/AdminPort'))) {
			$this->host   = 'ssl://'.$this->getCfg('cfg/AdminServer');
		} else {
			$this->host   = $this->getCfg('cfg/AdminServer');
		}
		$this->port   = preg_replace('/\/.*/','',$this->getCfg('cfg/AdminPort'));
		$this->admin  = $this->getCfg('cfg/admin');
		$this->pass   = $this->getAdminPwd();
		$this->fp     = 0;
		$this->line   = "";
		$this->error_msg  = "";
		$this->mbox   = "";
		$this->list   = array();
		$this->version  = $this->getCfg('cfg/ServerTyp')?$this->getCfg('cfg/ServerTyp'):'cyrus_23';
		switch($this->version) {
			case 'cyrus_24':
			case 'cyrus_23':
				$this->_perms=array(
					'1'=>"lrs",
					'3'=>"lrswipted",
					'7'=>"lrswipkxtecd",
				);
				$this->permsAll="lrswipkxtecda";
			break;
			default:

			break;
		}
	}
	function setCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}
			if (defined('GE_IMAPHost')) $this->_cfg['cfg/Server']=GE_IMAPHost;
			if (defined('GE_IMAPPort')) $this->_cfg['cfg/Port']=GE_IMAPPort;
			if (defined('GE_IMAPAdmin')) $this->_cfg['cfg/admin']=GE_IMAPAdmin;
			if (defined('GE_IMAPPassword')) $this->_cfg['cfg/adminpwd']=GE_IMAPPassword;

			if (!isset($this->_cfg['cfg/AdminPort']) && isset($this->_cfg['cfg/Port'])) $this->_cfg['cfg/AdminPort']=$this->_cfg['cfg/Port'];
			if (!isset($this->_cfg['cfg/AdminServer']) && isset($this->_cfg['cfg/Server'])) $this->_cfg['cfg/AdminServer']=$this->_cfg['cfg/Server'];
		}
	}
	function getCfg($key) {
		if ($key=="cfg/domain" && GE_DOMAIN) return GE_DOMAIN;
		if (isset($this->_cfg[$key])) return $this->_cfg[$key];
		return false;
	}
	function getAdminPwd() {
		if ($this->getCfg('cfg/adminpwd')) {
			return $this->getCfg('cfg/adminpwd');
		} else {
			return $GLOBALS['frm']->getUserPwd($this->getCfg('cfg/admin'));
		}
	}
	function getError() {
		return $this->error_msg;
	}
	function getPerms($key=0) {
		if ($key) {
			if ($key==-1) {
				return $this->permsAll;
			} else {
				return $this->_perms[$key];
			}
		} else {
			return $this->_perms;
		}
	}
	function imap_login() {
		$this->fp = @fsockopen($this->host,$this->port, $errno, $errstr);
		$this->error_msg=$errstr;
		if(!$this->fp) {
			//echo $this->host;
			if (!$errno) {
				$this->error_msg=$errno.":connection refused";
			} else {
				$this->error_msg=$errno.":".$errstr;
			}
			return false;
		} else {
			$res=$this->command(". login ".$this->admin." ".$this->pass);
			/*if ($res) {
				$res=$this->command(". version");
				debug('ff'.$res);
				
			}*/
			//debug($res);
			return $res;
		}
		return true;
	}

	function imap_logout() {
		$this->command(". logout");
		fclose($this->fp);
	}

	//Kommando ausfhren
	function command($line) {
		$result = array();
		$i=0; $f=0;
		$returntext="";
		$r = fputs($this->fp,"$line\n");
		//debug($line);
		while (!(strstr($returntext,". OK") || strstr($returntext,". NO") || strstr($returntext,". BAD"))) {
			$returntext=$this->getline();
			//debug($returntext);
			if ($returntext) {
				if (!(strstr($returntext,". OK") || strstr($returntext,". NO") || strstr($returntext,". BAD"))) {
					$result[$i]=$returntext;
				}
  	        	$i++;
	        }
		}
		if (strstr($returntext,". BAD") || strstr($returntext,". NO")) {
			if (( strstr($returntext,". NO Quota") )){
				$result[0]=$returntext;
			} else {
				$this->error_msg="UNEXPECTED IMAP-SERVER-ERROR\n";
				$this->error_msg.="SENT COMMAND:$line\n";
				$this->error_msg.="SERVER RETURNED:\n";
				$this->error_msg.=$returntext;
				return false;
			}

    	}
		if (empty($result)) return true; else return $result;
  	}

	//Server Antwort auslesen
	function getline() {
        $this->line = fgets($this->fp, 2000);
        return $this->line;
	}


	// Aulesen der Quota einer Mailbox
	function getquota($mb_name) {
        if ($output=$this->command(". getquota \"".$this->encBox($mb_name)."\"")) {
			$ret=array();
			if (is_array($output)) {
				if (strstr($output[0],". NO")) {
					$ret["usage"] = "NOT-SET";
					$ret["limit"] = "NOT-SET";
				} else {
					$matches=array();
					if (preg_match('/\(STORAGE ([0-9]+) ([0-9]+)\)/', $output[0],$matches)) {
						$ret["usage"] = $matches[1];
						$ret["limit"] = $matches[2];
					}

					/*$realoutput = str_replace(")", "", $output[0]);
					$tok_list = split(" ",$realoutput);
					//debug($tok_list);
					$si_used=sizeof($tok_list)-2;
					$si_max=sizeof($tok_list)-1;
					$ret["usage"] = $tok_list[$si_used];
					$ret["limit"] = $tok_list[$si_max];*/
				}
			}
       		return $ret;
		} else return false;
	}

	// Quota fr eine Mailbox setzen
	function setmbquota($mb_name, $quota) {
		//debug(". setquota \"".$this->encBox($mb_name)."\" (STORAGE $quota)");
		if (!$quota) {
			$cmd=". setquota \"".$this->encBox($mb_name)."\" ()";
		} else {
			$cmd=". setquota \"".$this->encBox($mb_name)."\" (STORAGE $quota)";
		}
		//debug($cmd);
		if ($this->command($cmd)) {
			return true;
		} else {
			//debug($this->error_msg);
			return false;
		}
	}

	// Neue Mailbox
	function createmb($mb_name) {
		if ($this->command(". create \"".$this->encBox($mb_name)."\"")) {
			return true;
		} else {
			return false;
		}
	}
	// Mailbox lschen
	function deletemb($mb_name) {
		//debug($mb_name);
		$this->setacl($mb_name, $this->admin,$this->permsAll);
		if ($this->command(". delete \"".$this->encBox($mb_name)."\"")) {
			return true;
		} else {
			return false;
		}
	}
	function recdeletemb($mb_name) {
        //$folderarray=$this->EGetFolders($folder);
        //debug($folderarray);
        if (trim($mb_name)) {
			$folderarray=$this->GetFolders($mb_name,'*');
			if (is_array($folderarray)) {
				$folderarray=array_reverse($folderarray);
				foreach ($folderarray as $mbox){
					$result=$this->deletemb($mbox);
				}
			}
			return $result;
		}
	}
	// Mailbox umbenennen
	function renamemb($mb_name, $newmbname) {
		$this->setacl($mb_name, $this->admin,$this->permsAll);
        if ($this->command(". rename \"".$this->encBox($mb_name)."\" \"".$this->encBox($newmbname)."\"")) {
			$this->deleteacl($newmbname, $this->admin);
			return true;
		} else {
			return false;
		}
	}
	// Mail-User umbenennen
	function renameuser($from, $to) {
		$find_out=array();
		$split_res=array();
		$from_mb_name='user'.$this->getCfg('cfg/delim').$from;
		$to_mb_name='user'.$this->getCfg('cfg/delim').$to;

		/* Anlegen und Kopieren der INBOX */
		if (!$this->createmb($to_mb_name)) return false;
		$this->setacl($to_mb_name, $this->admin,$this->permsAll);
		$this->copymailsfromfolder($from_mb_name, $to_mb_name);

		/* Quotas uebernehmen */
		$quota=$this->getquota($from_mb_name);
		$oldquota=trim($quota["limit"]);
		if (strcmp($oldquota,"NOT-SET")!=0) {
			$this->setmbquota($to_mb_name, $oldquota);
		}

		$find_out=$this->GetFolders($from_mb_name);
       	for ($i=0; $i < count($find_out); $i++) {
			$split_res=split($from_mb_name,$find_out[$i]);
			$this->renamemb($find_out[$i], $to_mb_name.$split_res[1]);
			$this->setacl(($to_mb_name.$split_res[1]),$to,$this->permsAll);
			$this->deleteacl(($to_mb_name.$split_res[1]),$from);
		}
        $this->deleteacl($to_mb_name, $this->admin);
        $this->imap_logout();
        $this->imap_login();
        $this->deletemb($from_mb_name);
		return true;
	}
	// Alle Mails von einer Box in die andere
	function copymailsfromfolder($from_mb_name, $to_mb_name) {
		$com_ret=array();
		$find_out=array();
		$mails=0;
		$this->setacl($from_mb_name, $this->admin,$this->permsAll);
		$com_ret=$this->command(". select ".$this->encBox($from_mb_name)."");
		if (is_array($com_ret)) {
			for ($i=0; $i < count($com_ret); $i++) {
				if (strstr( $com_ret[$i], "EXISTS"))   {
					$findout=explode(" ", $com_ret[$i]);
					$mails=$findout[1];
				}
			}
		}
		if ($mails != 0) {
			$com_ret=$this->command(". copy 1:$mails ".$this->encBox($to_mb_name)."");
			/*for ($i=0; $i < count($com_ret); $i++) {
				print "<font color=red>$com_ret[$i]</font><br>";
			}*/
		}
		$this->deleteacl($from_mb_name,$this->admin);
		return true;
	}

	// Rechte setzen
	function setacl($mb_name, $user, $acl,$isgroup=false) {
		if ($isgroup) {
			return $this->command(". setacl \"".$this->encBox($mb_name)."\" \"group:".$user."\" $acl");
		} else {
			return $this->command(". setacl \"".$this->encBox($mb_name)."\" \"$user\" $acl");
		}
	}

	// Rechte lschen
	function deleteacl($mb_name, $user) {
		return $this->command(". deleteacl \"".$this->encBox($mb_name)."\" \"$user\"");
	}
	function get_unencode($val) {
		if (preg_match_all ('/\\\\([0-9A-F][0-9A-F])/',$val, $preg_res)) {
			foreach ($preg_res[1] as $hex) {
				$val=preg_replace('/\\\\'.$hex.'/',chr(hexdec($hex)),$val);
			}
		}
		return '"'.stripslashes($val).'"';
	}

	// Rechte bernehmen
	function getacl($mb_name) {
		$aclflag=1; $tmp_pos=0;
		if ($output = $this->command(". getacl \"".$this->encBox($mb_name)."\"")) {
			$result=array();
			$ret=array();
			if (is_array($output)) {
				$output=array_map('trim',$output);
				$temp=implode('',$output);
				if (preg_match_all ('/\{([0-9]+)\}/',$temp, $preg_res)) {
					foreach ($preg_res[1] as $num) {
						$regex='/\{'.$num.'\}(.{'.($num).'})/e';
						$temp=preg_replace($regex,'$this->get_unencode(\'\\1\')',$temp);
					}
				}
				$j=0;$ignore_spc=false;
				for ($i=0;$i<strlen($temp);$i++) {
					//echo $temp[$i].'<br>';
					if ($temp[$i]=='"') {
						$ignore_spc=$ignore_spc?false:true;
						continue;
					}
					if ($temp[$i]==' ' && !$ignore_spc) {
						$j++;
						continue;
					}
					$ret[$j].=$temp[$i];
				}

				for ($i=count($ret)-1;$i>2;$i-=2) {
					$result[$ret[$i-1]]=$ret[$i];

				}
				//debug($result);
			}
			//echo chr("2b");
			return $result;
        } else {
			return false;
		}
	}

	// Alle Folder eines Users
	function GetFolders($username,$search=".*"){
		if ($output = $this->command(". list \"".$this->encBox($username)."\" ".$search)) {
			//debug($output);
			$result=array();
			if (is_array($output)) {
				$result[0]=$username;
				for ($i=0; $i < count($output); $i++) {
					$splitfolder=split("\"",$output[$i]);
					switch($this->version) {
						case 'cyrus_24':
							$result[$i+1]=$this->decBox(trim($splitfolder[2]));
						break;
						default:
							$result[$i+1]=$this->decBox(trim($splitfolder[3]));
						break;
					}
				}
			}
			//debug($result);
        	return array_unique($result);
       	} else {
			return false;
		}
	}

    function GetUsers($char) {
		$users = array();
		$output=$this->command(". list \"user".$this->getCfg('cfg/delim').$char."\" %");
		if ($output) {
			//debug($output);

			if (is_array($output)) {
				for ($i=0; $i < count($output); $i++) {
					$splitfolder=split("\"",$output[$i]);
					switch($this->version) {
						case 'cyrus_24':
							$output[$i]=str_replace(".","/",trim($splitfolder[2]));
						break;
						default:
							$output[$i]=str_replace(".","/",trim($splitfolder[3]));
						break;
					}
				}
				$j = 0;
				$prev = 0;
				for ($i=0; $i < count($output); $i++) {
					$username = split("/", $output[$i],-1);
					if ((isset($username)) && (isset($users)) && strcmp($username[1], $users[$prev])) {
						if ($username[1]!='cyrus') $users[$j] = $this->decBox($username[1]);
						$j++;
					}
					if ($j != 0) $prev = $j - 1;
				}
			}
        	return $users;
       	} else {
			return false;
		}
	}
	function encBox($name) {
		return Framework::convertCharset($name,GE_CHARSET,"UTF7-IMAP");
	}
	function decBox($name) {
		return Framework::convertCharset($name,"UTF7-IMAP",GE_CHARSET);
	}
}
?>
