<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class MailObj {
	var $_meta=array();
	var $_pmeta=array();
	var $_acl;
	var $_ID;
	function getID() {
		return $this->_meta['ID'];
	}
	function setID($ID) {
		$this->_meta['ID']=$ID;
	}
	function getMeta($key) {
		return $this->_meta[$key];
	}
	function setMeta($key,$data) {
		$this->_meta[$key]=$data;
	}
	function getParentMeta($key) {
		return $this->_pmeta[$key];
	}
	function setParentMeta($key,$data) {
		if (!$key) $this->_pmeta=$data; else $this->_pmeta[$key]=$data;
	}
	function getName($full=0) {
		return $this->_meta['Name'];
	}
	function getACL($chk=0) {
		$chk=intval($chk);
		if ($chk) {
			if ($this->_acl==-1) {
				return true;
			} else {
				return ($this->_acl&$chk);
			}
		} else {
			return $this->_acl;
		}
	}
	function setAcl($acl) {
		$this->_acl=$acl;
	}
	function getAction($typ) {
		return $this->_action[$typ];
	}
	function getSite() {
		return $this->_site;
	}

}

class MObj_fol extends MailObj   {
	var $_site='mail.php';
	var $_action=array('b','b');
	function MObj_fol($meta,$pmeta=NULL) {
		$this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
	}
	function getBox() {
		return $this->_meta['Box'];
	}
	function setBox($Box) {
		$this->_meta['Box']=$Box;
	}
	function getImage($open=0) {
		$image='obj_img/';
		switch ($this->_meta['Type']) {
			case 'D':
				$image.='m_draft.gif';
			break;
			case 'S':
				$image.='m_send.gif';
			break;
			case 'R':
				$image.='m_send.gif';
			break;
			case 'T':
				$image.='m_trash.gif';
			break;
			default:
				/*
				if ($open) {
					$image.='co_';
				} else {
					$image.='ex_';
				}*/
				$image.='m_folder.gif';
		}
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='fol';
		if ($typ) $ac.='_l';
		return $ac;
	}
	function isFolder() {
		return true;
	}
}
class MObj_doc extends MailObj   {
	var $_site='mail.php';
	var $_action=array('v','n&mode=draft');
	function MObj_doc($ID,$meta) {
		$this->_meta=$meta;
		$this->_meta['ID']=$ID;
	}
	function getName($full=0) {
		$name=($this->_meta['Subject']);
		if ($name) {
			return $name;
		} else {
			return 'No Subject';
		}
	}
	function getMail($typ='To',$num=-1) {
		if (is_array($this->_meta[$typ])) {
			if ($num!=-1) {
				return $this->_meta[$typ][$num];
			} else {
				return $this->_meta[$typ];
			}
		}
	}
	function isNew() {
		return $this->_meta['New'];
	}
	function isDraft() {
		return $this->_meta['Draft'];
	}
	function getImage() {
		$image='obj_img/';
		if($this->isDraft()) {
	 		$image.='mail_draft.gif';
		} elseif($this->isNew()) {
			if ($this->_meta['Answered']=="A") {
				$image.='mail_new_re.gif';
			} else {
				$image.='mail_new.gif';
			}
	 	} else {
			if ($this->_meta['Answered']=="A") {
				$image.='mail_old_re.gif';
			} else {
				$image.='mail_old.gif';
			}
		}
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='mail';
		return $ac;
	}
	function getAction($typ) {
		if ($this->isDraft()) {
			return $this->_action[1];
		} else {
			return $this->_action[0];
		}
	}

	function isFolder() {
		return false;
	}
}

class Mail {
   	var $_db;
	var $_uid;
	var $_lang;
	var $_gid;
	var $_rule=false;
	var $_sadmin=false;
	var $_locked_obj=array();
	var $_clipboard=array();
	var $_modul='mail';
	function Mail () {
		global $db,$frm;
		$this->_db=&$db;
		$this->_frm=&$frm;
		$this->_uid=$frm->getUser();
		$this->_lang=$frm->getLang();
		$this->_gid=$frm->getMyGroups();
		$this->_path=GE_DYN_PATH.'/'.GE_DOMAIN_PATH;
		if (!file_exists($this->_path)) {
			mkdir($this->_path,0700);
		}
		if (!file_exists($this->_path."attach")) {
			mkdir($this->_path."attach",0700);
		}
		if (!file_exists($this->_path."export")) {
			mkdir($this->_path."export",0700);
		}
		$this->setRule($frm->isRuleUser(array('sysadmin','mail')));
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
	}
	function init($user_id=0) {
		global $auth;
		if ($user_id && $user_id!=$auth->auth['uid']) {
			$tmp=$this->_frm->read_user($user_id);
			if ($tmp) {
				$username=$tmp['username'];
				$password=$tmp['password'];
			} else {
				$user_id=0;
			}
		}
		if (!$user_id || $user_id==$auth->auth['uid']) {
			$username=$auth->auth['uname'];
			$password=$auth->auth['password'];
			$user_id=$auth->auth['uid'];
		}
		//debug($auth->auth['uname']);
		$this->setUser($user_id);
		$this->setUserName($username);
		$this->setPassword($password);
		return $this->open();
	}
	function getModul() {
		return $this->_modul;
	}
	function setUser($uid) {
		$this->_uid=$uid;
	}
	function getUser() {
		return $this->_uid;
	}
	function getAttachPath() {
		if (!file_exists($this->_path.'attach/'.$this->_uid)) {
			mkdir($this->_path.'attach/'.$this->_uid,0700);
		}
		return $this->_path.'attach/'.$this->_uid;
	}
	function getExportPath() {
		if (!file_exists($this->_path.'export/'.$this->_uid)) {
			mkdir($this->_path.'export/'.$this->_uid,0700);
		}
		return $this->_path.'export/'.$this->_uid;
	}
	function setUserName($uname) {
		$this->_uname=$uname;
	}
	function getUserName() {
		if (GE_mailUserSuffix && $GLOBALS['CFG']['USER_CLASS']!='ldap_full') {
			return $this->_uname.GE_mailUserSuffix;
		} else {
			return $this->_uname;
		}
	}
	function setPassword($pwd) {
		$this->_pwd=$pwd;
	}
	function getPassword() {
		if ($GLOBALS['CFG']['USER_CLASS']=='ldap_full' || $GLOBALS['CFG']['USER_CLASS']=='ldap') {
			return $this->_frm->utf8encode($this->_pwd);
		} else {
			return $this->_pwd;
		}
	}
	function getAdminPwd() {
		$pwd='';
		if ($this->getCfg('cfg/adminpwd')) {
			$pwd=$this->getCfg('cfg/adminpwd');
		} else {
			$pwd=$this->_frm->getUserPwd($this->getCfg('cfg/admin'));
		}
		if ($GLOBALS['CFG']['USER_CLASS']=='ldap_full' || $GLOBALS['CFG']['USER_CLASS']=='ldap') {
			return $this->_frm->utf8encode($pwd);
		} else {
			return $pwd;
		}
	}
	function setGroups($gid) {
		$this->_gid=$gid;
	}
	function setLang($lang) {
		$this->_lang=$lang;
	}
	function setRule($bool=false) {
		$this->_rule=$bool;
	}
	function setSuperAdmin($bool=false) {
		$this->_sadmin=$bool;
	}
	function setLocked($locked) {
		$this->_locked_obj=$locked_obj;
	}
	function isLocked(&$obj) {
		if ($this->_locked_obj[$obj->getID()]) {
			return true;
		} else {
			return false;
		}
	}
	function setClipboard($what,$content) {
		$this->_clipboard[$what]=$content;
	}
	function getClipboard($what) {
		return $this->_clipboard[$what];
	}
	function isClipboard($what) {
		if ($this->_clipboard[$what]) {
			return true;
		} else {
			return false;
		}
	}
	function isRuleUser() {
		return $this->_rule;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function setCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}

			if (defined('GE_IMAPHost')) $this->_cfg['cfg/Server']=GE_IMAPHost;
			if (defined('GE_IMAPPort')) $this->_cfg['cfg/Port']=GE_IMAPPort;
			if (defined('GE_IMAPAdmin')) $this->_cfg['cfg/admin']=GE_IMAPAdmin;
			if (defined('GE_IMAPPassword')) $this->_cfg['cfg/adminpwd']=GE_IMAPPassword;

			if (!isset($this->_cfg['cfg/AdminPort']) && isset($this->_cfg['cfg/Port'])) $this->_cfg['cfg/AdminPort']=$this->_cfg['cfg/Port'];
			if (!isset($this->_cfg['cfg/AdminServer']) && isset($this->_cfg['cfg/Server'])) $this->_cfg['cfg/AdminServer']=$this->_cfg['cfg/Server'];
		}
	}
	function getCfg($key) {
		if ($key=="cfg/domain" && GE_DOMAIN) return GE_DOMAIN;
		if (isset($this->_cfg[$key])) return $this->_cfg[$key];
		return false;
	}
	function setRootObj(&$obj) {
		$this->_root_obj=&$obj;
	}
	function &getRootObj() {
		return $this->_root_obj;
	}
	function setRootIDs($ID,$Typ) {
		$this->_rootIDs[$Typ]=$ID;
	}
	function &getRootIDs($Typ=0) {
		if ($Typ) {
			return $this->_rootIDs[$Typ];
		} else {
			return $this->_rootIDs;
		}
	}
	function setMode($mode) {
		$this->_mode=$mode;
	}
	function getMode() {
		return $this->_mode;
	}
	function setPrefs($pre) {
		if ($pre) $this->pre=$pre; else $this->pre=array();
	}
	function getPrefs($Typ=0) {
		if ($Typ) {
			return $this->pre[$Typ];
		} else {
			return $this->pre;
		}
	}
	function getLimit() {
		return isset($this->pre['limit'])?$this->pre['limit']:20;
	}
	function setLimit($limit) {
		$this->pre['limit']=$limit;
	}

	function isOpen() {
		return $this->_ms;
	}
	function getHost() {
		if ($this->getCfg('cfg/Server') && $this->getCfg('cfg/Port')) {
			return "{".$this->getCfg('cfg/Server').":".$this->getCfg('cfg/Port')."}";
		} else return false;
	}
	function getSpamID() {
		return $this->getCfg('cfg/spam/spam_id');
	}
	function getTrashID() {
		return $this->getCfg('cfg/user/trash_id')?$this->getCfg('cfg/user/trash_id'):'INBOX.Trash';
	}
	function getSentID() {
		return $this->getCfg('cfg/user/sent_id')?$this->getCfg('cfg/user/sent_id'):'INBOX.sent';
	}
	function getReadOnlyID() {
		return $this->getCfg('cfg/user/readonly_id')?$this->getCfg('cfg/user/readonly_id'):'';
	}
	function getDraftID() {
		return $this->getCfg('cfg/user/draft_id')?$this->getCfg('cfg/user/draft_id'):'INBOX.drafts';
	}
	function formatName($obj,$name=true,$addID='n:') {
		if ($name) {
			$name=Framework::entities($obj->getName());
		}
		if ($addID) {
			$name.='<span id="'.$addID.$obj->getBox().'">';
		}
		$name.='('.intval($obj->getParentMeta('NumMsg'));
		if (intval($obj->getParentMeta('NumNew'))) {
			$name.='/<strong>'.intval($obj->getParentMeta('NumNew')).'</strong>';
		}
		$name.=')';
		if ($addID) {
			$name.='</span>';
		}
		return $name;
	}
	function open($box='') {
		if ($this->getHost()) {
			if ($this->_ms) {
				if ($this->_open_box!=$box) {
					imap_reopen ($this->_ms, $this->getHost().$this->encBox($box));
					$this->_open_box=$box;
				}
			} else {
				//echo $this->getHost().$this->encBox($box).'<br>';
				//echo $this->getUserName().'<br>';
				//echo $this->getPassword().'<br>';
				$this->_ms=imap_open($this->getHost().$this->encBox($box),$this->getUserName(),$this->getPassword(),OP_HALFOPEN);
				$this->_open_box=$box;
			}
		} else {
			$this->_ms=false;
		}


		return $this->_ms;
	}
	function close() {
		if ($this->_ms) {
			@imap_close($this->_ms);
			$this->_ms=null;
		}
	}
	function getError () {
		return "IMAP: ".imap_last_error();
	}
	function listTree($start='*',$all=false,$vst=true) {
		$result=array();
		//$t_start[0]=Framework::getmicrotime();
		if ($all) {
			$list = imap_getmailboxes ($this->_ms, $this->getHost(), $this->encBox($start));
		} else {
			$list = imap_getsubscribed ($this->_ms, $this->getHost(), $this->encBox($start));
		}
		//debug($list);
		//$t_end[0]=Framework::getmicrotime();
		if (is_array($list)) {
			//$t_start[1]=Framework::getmicrotime();
			foreach ($list as $val) {
				$obj=new MObj_fol($this->parseMeta($val));
				//echo $obj->getBox().'<br>';
				if ($vst) {
					$obj->setParentMeta(0,$this->getStatus($obj->getBox()));
				}
				$result[$obj->getMeta('ParentID')][$obj->getID()]=$obj;
				$parsed[]=$obj->getBox();
				while(!in_array($obj->getMeta('ParentBox'),$parsed)) {
					$val->name=$obj->getMeta('ParentBox');
					$obj=new MObj_fol($this->parseMeta($val));
					//echo $obj->getBox().'<br>';
					if ($vst) {
						$obj->setParentMeta(0,$this->getStatus($obj->getBox()));
					}
					//debug($obj);
					$result[$obj->getMeta('ParentID')][$obj->getID()]=$obj;
					$parsed[]=$obj->getBox();
				}
			}
			//$t_end[1]=Framework::getmicrotime();
			unset($parsed);
			unset($result[0]);
		}
/*
		foreach ($t_start as $key=>$val) {
			debug('TIME '.$key.' : '.($t_end[$key]-$val));
		}*/
		return $result;
	}
	function listFolders($start='*',$all=false,$vst=true,$quick=true,$limit=0,$b=0,$search='') {
		$result=array();
		if ($all) {
			$list = imap_getmailboxes ($this->_ms, $this->getHost(), $this->encBox($start));
		} else {
			$list = imap_getsubscribed ($this->_ms, $this->getHost(), $this->encBox($start));
		}
		if ($search) {
			$search=preg_quote($this->encBox($search),'/');
		}
		//$limit=5;
		if (is_array($list)) {
			$i=0;
			foreach ($list as $val) {
				if ($search && !preg_match('/'.$search.'/i',$val->name)) continue;
				$obj=new MObj_fol($this->parseMeta($val));
				if (!$quick && $obj->getMeta('RootID')=='QUICK') continue;
				$i++;
				if ($b && $i<=$b) continue;
				//echo $obj->getBox().'<br>';
				if ($vst) {
					$obj->setParentMeta(0,$this->getStatus($obj->getBox()));
				}
				$result[$obj->getID()]=$obj;
				if ($limit && $i>$limit) break;
			}
		}
		return $result;
	}
	function searchFolders($start='*',$search='',$ignore=null,$limit=0,$only_names=false) {
		$result=array();
		$list = imap_list ( $this->_ms, $this->getHost(),$start);
		if ($search) $list = preg_grep('/'.preg_quote($this->encBox($search),'/').'/i', $list);
		if (is_array($list)) {
			$i=0;
			if ($only_names) {
				foreach ($list as $val) {
					$box=str_replace($this->getHost(),'',$this->decBox($val));
					//debug($box);
					if (is_array($ignore) && in_array($box,$ignore)) {
						continue;
					}
					$result[$box]=$this->trimUser($box);
					$i++;
					if ($limit && $i>=$limit) break;
				}
			} else {
				foreach ($list as $val) {
					$obj=new MObj_fol($this->parseSearchMeta($val));
					if (is_array($ignore) && in_array($obj->getBox(),$ignore)) {
						continue;
					}
					//echo $obj->getBox().'<br>';
					$result[$obj->getID()]=$obj;
					$i++;
					if ($limit && $i>$limit) break;
				}
			}
		}
		//debug($list);
		return $result;
	}
	function &parseSearchMeta($box) {
		$result['Box']=$result['ID']=str_replace($this->getHost(),'',$this->decBox($box));
		$temp=explode($this->getCfg('cfg/delim'),$result['ID']);
		$result['RootID']=reset($temp);
		$result['Name']=array_pop($temp);
		if (is_array($temp) && !empty($temp)) {
			$result['ParentBox']=$result['ParentID']=implode($this->getCfg('cfg/delim'),$temp);
		} else {
			$result['ParentBox']=$result['ParentID']=0;
		}
		if ($result['ParentID']=='user' && GE_mailUserSuffix) {
			$result['Name']=preg_replace('/'.preg_quote(GE_mailUserSuffix).'$/','',$result['Name']);
		}

		if (
			$result['RootID']=='INBOX' &&
				(
					$result['ID']==$this->getSpamID() ||
					$result['ID']==$this->getTrashID() ||
					$result['ID']==$this->getSentID() ||
					$result['ID']==$this->getReadOnlyID() ||
					$result['ID']==$this->getDraftID()
				)
			) {
				if ($result['ID']==$this->getSpamID()) $result['Type']='X';
				if ($result['ID']==$this->getTrashID()) $result['Type']='T';
				if ($result['ID']==$this->getSentID()) $result['Type']='S';
				if ($result['ID']==$this->getReadOnlyID()) $result['Type']='R';
				if ($result['ID']==$this->getDraftID()) $result['Type']='D';
				$result['RootID']='QUICK';
				if ($result['ParentID']=='INBOX') $result['ParentID']='QUICK';
				$result['ID']=str_replace('INBOX','QUICK',$result['ID']);

		}
		return $result;
	}
	function listSubTree($params) {
		if ($params['ParentID']) {
			$result=$this->listFolders($params['ParentID'].$this->getCfg('cfg/delim').'%',$params['all'],$params['vst'],$params['quick']);
		}
		return $result;
	}
	function listRoots() {
		$result=array();
		$query="SELECT * FROM MailMetabase WHERE ParentID=0 ORDER BY Sequence";
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$result[$this->_db->f('ID')]=new MObj_fol($this->fetchRoot());
		}
		return $result;
	}
	function getSystemObj($typ) {
		$result=false;
		$query="SELECT * FROM MailMetabase WHERE System=".$this->_db->escape($typ)."";
		$this->_db->query($query);
		if($this->_db->next_record()) {
			$result=new MObj_fol($this->fetchRoot());
		}
		return $result;
	}
	function getQuota() {
		 global $frm;
		 if (function_exists('imap_get_quotaroot')) {
		 	$this->open('INBOX');
		 	return(imap_get_quotaroot ($this->_ms,'INBOX'));
		 } else {
			$CyrAdm=& $frm->getStaticModul('mail_adm');
			if ($CyrAdm->imap_login()) {
				return($CyrAdm->getquota('user'.$this->getCfg('cfg/delim').$this->getUserName()));
			}
		 }
		 return false;
	}
	function getObj($ID,$all=true,$vst=true) {
		//debug($ID);
		if ($ID) {
			if ($all) {
				$list = imap_getmailboxes ($this->_ms, $this->getHost(), $this->encBox($ID));
			} else {
				$list = imap_getsubscribed ($this->_ms, $this->getHost(), $this->encBox($ID));
			}
			if ($list[0]) {
				$obj=new MObj_fol($this->parseMeta($list[0]));
				//debug(imap_status ($this->_ms, $this->getHost().$this->encBox($obj->getBox()), SA_ALL));
				if ($vst) $obj->setParentMeta(0,$this->getStatus($obj->getBox()));
				return $obj;
			}
		}
		return false;
	}
	function fetchRoot() {
		return array(
			'ID'=>$this->_db->f('ID'),
			'Box'=>$this->_db->f('Box'),
			'RootID'=>$this->_db->f('RootID'),
			'ParentID'=>$this->_db->f('ParentID'),
			'Name'=>$this->_db->f('Title_'.$this->_lang),
			'System'=>$this->_db->f('System'),
		);
	}
	function &parseMeta(&$fobj) {
		$result['Box']=$result['ID']=str_replace($this->getHost(),'',$this->decBox($fobj->name));
		$temp=explode($fobj->delimiter,$result['ID']);
		$result['RootID']=reset($temp);
		$result['Name']=array_pop($temp);
		if (is_array($temp) && !empty($temp)) {
			$result['ParentBox']=$result['ParentID']=implode($fobj->delimiter,$temp);
		} else {
			$result['ParentBox']=$result['ParentID']=0;
		}
		if ($result['ParentID']=='user' && GE_mailUserSuffix) {
			$result['Name']=preg_replace('/'.preg_quote(GE_mailUserSuffix).'$/','',$result['Name']);
		}
		if (
			$result['RootID']=='INBOX' &&
				(
					$result['ID']==$this->getSpamID() ||
					$result['ID']==$this->getTrashID() ||
					$result['ID']==$this->getSentID() ||
					$result['ID']==$this->getReadOnlyID() ||
					$result['ID']==$this->getDraftID()
				)
			) {
				if ($result['ID']==$this->getSpamID()) $result['Type']='X';
				if ($result['ID']==$this->getTrashID()) $result['Type']='T';
				if ($result['ID']==$this->getSentID()) $result['Type']='S';
				if ($result['ID']==$this->getReadOnlyID()) $result['Type']='R';
				if ($result['ID']==$this->getDraftID()) $result['Type']='D';
				$result['RootID']='QUICK';
				if ($result['ParentID']=='INBOX') $result['ParentID']='QUICK';
				$result['ID']=str_replace('INBOX','QUICK',$result['ID']);

		}
		$result['Folders']=($fobj->attributes&LATT_NOINFERIORS);
		$result['NoMails']=($fobj->attributes&LATT_NOSELECT);
		return $result;
	}
	function &getStatus($Box) {
		$status=imap_status ($this->_ms, $this->getHost().$this->encBox($Box), SA_ALL);
		if ($status) {
			$result['NumMsg']=$status->messages;
			$result['NumNew']=$status->unseen;
			$result['NumRec']=$status->recent;
			$result['NextUid']=$status->uidnext;
		} else {
			$result=array();
		}
		return $result;
	}
	function &checkBox($box = 'INBOX') {
		$this->open($box);
		$status=imap_check ($this->_ms);
		if ($status) {
			$result['NumMsg']=$status->Nmsgs;
			$result['NumRec']=$status->Recent;
			$result['Date']=$status->Date;
		} else {
			$result=array();
		}
		return $result;
	}
	function encBox($name) {
		return Framework::convertCharset($name,GE_CHARSET,"UTF7-IMAP");
	}
	function decBox($name) {
		return Framework::convertCharset($name,"UTF7-IMAP",GE_CHARSET);
	}
	function listMailIDs($box,$Fo=SORTARRIVAL,$Fa=1) {
		$this->open($box);
		if (defined('USE_MAIL_FROM_DATE') && USE_MAIL_FROM_DATE && $Fo==SORTARRIVAL) {
			//$result=imap_search ($this->_ms,'ALL',SE_UID );
			//if ($result && $Fa==1) $result=array_reverse($result);
			$result=imap_sort($this->_ms,SORTDATE,$Fa,SE_UID);
		} else {
			$result=imap_sort($this->_ms,$Fo,$Fa,SE_UID);
		}
		return $result;
	}
	function listMails(&$rows,$box,$b=0,$limit=0,$Fo=SORTARRIVAL,$Fa=1,$search='',$use_limit=true,$struc=false) {
		//debug($search);
		//debug('HALLO');
		$result=array();
		$this->open($box);
		//debug(imap_thread($this->_ms,SE_UID));
		if (defined('USE_MAIL_FROM_DATE') && USE_MAIL_FROM_DATE && $Fo==SORTARRIVAL) {
			//$sorted_array=imap_search ($this->_ms,$search?$search:'ALL',SE_UID );
			//if (!is_array($sorted_array)) $sorted_array=array();
			//if ($Fa) $sorted_array=array_reverse($sorted_array);
			$sorted_array=imap_sort($this->_ms,SORT,$Fa,SE_UID,$search,GE_CHARSET);
			//debug($sorted_array);

		} else {
			$sorted_array=imap_sort($this->_ms,$Fo,$Fa,SE_UID,$search,GE_CHARSET);
			//debug($rows);
		}
		//debugtime('E');
		$rows=count($sorted_array);
		if (!$limit) $limit=$rows+1;
		if ($rows && $rows > $b) {
			for($i=$b;$i<($b+$limit);$i++) {
				if ($sorted_array[$i]) {
					$num=imap_msgno($this->_ms,$sorted_array[$i]);
					//if ($i>=76) break;
					$result[$sorted_array[$i]]=new MObj_doc($sorted_array[$i],$this->parseMsgHeader($num,$struc));
				} else {
					break;
				}

			}
		}
		return $result;
	}
	function getMailObj($box,$mid,$struc=true,$isNum=false) {
		$this->open($box);
		if ($isNum) {
			$msgNum=$mid;
			$mid=imap_uid($this->_ms,$mid);
		} else {
			$msgNum=imap_msgno($this->_ms,$mid);
		}
		if ($msgNum && ($meta=$this->parseMsgHeader($msgNum,$struc))) {
			$meta['Box']=$box;
			return new MObj_doc($mid,$meta);
		} else {
			return false;
		}
	}
	function parseMsgHeader($num,$get_struc=false) {
		$info=imap_header($this->_ms, $num );
		if ($info) {
			$result['Subject']=$info->subject;
			$result['From']=$info->from;
			$result['To']=$info->to;
			$result['Cc']=$info->cc;
			$result['Bcc']=$info->bcc;
			$result['New']=(($info->Unseen == 'U') || ($info->Recent == 'N'));
			$result['Answered']=trim($info->Answered);
			$result['Flagged']=trim($info->Flagged);
			$result['Draft']=trim($info->Draft);
			$result['Trash']=trim($info->Deleted);
			$result['Size']=$info->Size;
			$result['Msgno']=$info->Msgno;
			if (defined('USE_MAIL_FROM_DATE') && USE_MAIL_FROM_DATE) {
				//$info->date="28 Oct 2004 09:15:20 UT";
				//echo preg_replace('/\s+UT([^C]|$)/','UTC',$info->date);
				$result['Date']=strtotime(preg_replace('/\s+UT([^C]|$)/','UTC',$info->date));
				if ($result['Date']>$info->udate || $result['Date']<=0) $result['Date']=$info->udate;
			} else {
				$result['Date']=$info->udate;
			}
			if ($info->message_id) {
				$result['Md5Id']=md5($info->message_id);
			} else {
				$result['Md5Id']=md5($info->subject.$info->date.$info->fromaddress);
			}

			$struc=imap_fetchstructure($this->_ms,$num);
			if (count($struc->parts)>1 && !preg_match('/alternativ/i',$struc->subtype)) $result['Attachment']=1;
			if ($get_struc) {
				$result['Structure']=$struc;
			}
			unset($struc);
			return $result;
		} else return false;
	}
	function parseFullHeader($box,$mid,$normalize=false){
		$headerar=explode("\r\n",$this->getFullHeader($box,$mid));
		foreach ($headerar as $h) {
			if (preg_match("/^[A-Z]/i", $h )) {
				$header_name = trim(substr($h, 0, $pos = strpos($h, ':')));
				if ($normalize) $header_name=strtolower($header_name);
				$headers[$header_name]=trim(substr($h, $pos+1));
			} else {
				$headers[$header_name].=' '.trim($h);
			}
		}
		return $headers;
	}

	function getFullHeader($box,$mid){
		$this->open($box);
		return @imap_fetchheader ($this->_ms,$mid,FT_UID);
	}
	function addFolder($box) {
		if (imap_createmailbox ( $this->_ms,$this->getHost().$this->encBox($box))) {
			return false;
		} else {
			return array('server'=>imap_last_error());
		}
	}
	function renameFolder($old_box,$new_box) {
		if (imap_renamemailbox ( $this->_ms,$this->getHost().$this->encBox($old_box),$this->getHost().$this->encBox($new_box))) {
			return false;
		} else {
			return array('server'=>imap_last_error());
		}
	}
	function deleteFolder($box) {
		if (imap_deletemailbox ( $this->_ms,$this->getHost().$this->encBox($box))) {
			return false;
		} else {
			return array('server'=>imap_last_error());
		}
	}
	function subscribeFolder($box) {
		if (imap_subscribe ($this->_ms,$this->getHost().$this->encBox($box))) {
			return false;
		} else {
			return array('server'=>imap_last_error());
		}
	}
	function unsubscribeFolder($box) {
		//debug($this->getHost().$this->encBox($box));
		if (imap_unsubscribe ($this->_ms,$this->getHost().$this->encBox($box))) {
			return false;
		} else {
			return array('server'=>imap_last_error());
		}
	}

	function deleteMail($box,$mid) {
		$this->open($box);
		if (imap_delete ($this->_ms,$mid,FT_UID)) {
			return false;
		} else {
			return array('server'=>imap_last_error());
		}
	}
	function searchMails($box,$criteria) {
		$this->open($box);
		$result=imap_search ($this->_ms,$criteria,SE_UID,GE_CHARSET);
		return $result;
	}

	function copyMail($box,$mid,$tobox) {
		$this->open($box);
		if (is_array($mid)) $set=implode(',',$mid); else $set=$mid;
		//debug($set);
		if (imap_mail_copy ($this->_ms,$set,$this->encBox($tobox),CP_UID)) {
			return false;
		} else {
			return array('server'=>imap_last_error());
		}
	}
	function moveMail($box,$mid,$tobox) {
		$mailRecode=array();
		if (!is_array($mid)) $mid=array($mid);
		if ($this->_frm->getMyApps('rem')) {
			$remBase=$this->_frm->getStaticModul('rem');
			$toStat=$this->getStatus($tobox);
			foreach($mid as $v) {
				if ($remBase->isRemObject('mail',$box.'||'.$v)) {
					$tmpObj=$this->getMailObj($box,$v,false);
					$mailRecode[$tmpObj->getMeta('Md5Id')]=$box.'||'.$v;
				}
			}
		}
		$this->open($box);
		if (imap_mail_move($this->_ms,implode(',',$mid),$this->encBox($tobox),CP_UID)) {
			$i=$toStat['NextUid'];
			while(!empty($mailRecode) && ($tmpObj=$this->getMailObj($tobox,$i,false))) {
				//debug($tmpObj);
				if (isset($mailRecode[$tmpObj->getMeta('Md5Id')])) {
					$remBase->moveRemObject('mail',$mailRecode[$tmpObj->getMeta('Md5Id')],$tobox.'||'.$i);
					unset($mailRecode[$tmpObj->getMeta('Md5Id')]);
				}
				$i++;
			}
			return false;
		} else {
			return array('server'=>imap_last_error());
		}
	}
	function appendMail($box,$mail,$flags='',$intDate='') {
		$this->open($box);
		if ($intDate && version_compare(PHP_VERSION, '5.3.2') >= 0) {
			$res=imap_append($this->_ms,$this->getHost().$this->encBox($box),$mail,$flags,$intDate);
		} else {
			$res=imap_append($this->_ms,$this->getHost().$this->encBox($box),$mail,$flags);
		}
		if ($res) {
			return false;
		} else {
			return array('server'=>imap_last_error());
		}
	}
	function expungeBox($box) {
		$this->open($box);
		if (imap_expunge($this->_ms)) {
			return false;
		} else {
			return array('server'=>imap_last_error());
		}
	}
	function setFlag($box,$mid,$flag) {
		$this->open($box);
		if (imap_setflag_full($this->_ms,$mid,$flag,ST_UID)) {
			return false;
		} else {
			return array('server'=>imap_last_error());
		}
	}
	function clearFlag($box,$mid,$flag) {
		$this->open($box);
		if (imap_clearflag_full($this->_ms,$mid,$flag,ST_UID)) {
			return false;
		} else {
			return array('server'=>imap_last_error());
		}
	}
	function fetchBody($box,$mid,$part,$no_seen=false) {
		$this->open($box);
		$flags=FT_UID;
		if ($no_seen) $flags=$flags + FT_PEEK;
		//debug($part);
		return imap_fetchbody($this->_ms,$mid,$part,$flags);
	}
	function fetchFullBody($box,$mid,$no_seen=false) {
		$this->open($box);
		$flags=FT_UID;
		if ($no_seen) $flags=$flags + FT_PEEK;
		return imap_body($this->_ms,$mid,$flags);
	}
	function &getAttachment($box, $mid, $section,$enc,$no_seen=false) {
		if (preg_match('/TNEF:(.+):(.+)/',$section,$result) && $this->getCfg('cfg/tnef')) {
			return $this->parseTnef($box,$mid,$result[2],$enc,$result[1],$no_seen);
		} else {
			return $this->decode($this->fetchBody($box, $mid,$section,$no_seen),'NO',$enc);
		}
	}
	function &parseTnef($box,$mid,$section,$enc,$getfile=0,$no_seen=false) {
		if (!file_exists($this->_path."attach/".$this->_uid)) {
			mkdir($this->_path."attach/".$this->_uid,0700);
		}
		if (!file_exists($this->_path."attach/".$this->_uid.'/tnef')) {
			mkdir($this->_path."attach/".$this->_uid.'/tnef',0700);
		}
		$path=$this->_path."attach/".$this->_uid.'/tnef/';
		$dir = opendir($path);
		while($file = readdir($dir)) {
			if (is_file($path.$file)) unlink($path.$file);
		}
		closedir($dir);
		$fp=fopen($path.'winmail.dat','w');
		//echo $section.'|'.$enc.'|'.$getfile.'<br>';
		fwrite($fp,$this->decode($this->fetchBody($box, $mid,$section,$no_seen),'NO',$enc));
		fclose($fp);
		$exec=$this->getCfg('cfg/tnef')." --overwrite -C $path ".$path."winmail.dat";
		//echo $exec.'<br>';
		$result=exec($exec);
		unlink($path.'winmail.dat');
		$dir = opendir($path);
		$i=0;
		while($file = readdir($dir)) {
			//echo $file;
			if (is_file($path.$file)) {
				if ($getfile) {
					//echo $getfile.'<br>';
					if ($getfile==str_replace(':','_',$file)) {
						$fp=fopen($path.$file,'r');
						$result=fread($fp,filesize($path.$file));
						//echo $path.$file;
						fclose($fp);
					}
				} else {
					$result["TNEF:".str_replace(':','_',$file).":".$section]=array(
						'name'=>$file,
						'size'=>filesize($path.$file),
						'type'=>Framework::getMimeFile($path.$file),
						'enc'=>$enc,
						'part'=>"TNEF:".str_replace(':','_',$file).":".$section
					);

				}
				unlink($path.$file);
			}
			$i++;
		}
		closedir($dir);
		return $result;

	}

	function formatMail($mobj,$len=0,$full=0) {
		if (is_array($mobj)) {
			foreach ($mobj as $key=>$val) {
				$result[$key]=$this->formatMail($val,$len,$full);
			}
		} else {
			$mobj->personal=$this->mail_enc($mobj->personal);
			$result=imap_rfc822_write_address ($mobj->mailbox,$mobj->host,$mobj->personal);
			$result=trim($result);
			if (strpos($result,'<')===0) {
				$result=substr($result,1,-1);
			} elseif (!$full) {
				$result=preg_replace('/[<].+[>]/','',$result);
			}
			$result=Framework::wordSplit($result,$len);
		}
		return $result;

	}
	function mail_enc($string){
		$string=str_replace("\t",'',$string);
		//echo $string.'<br>';
		if(preg_match_all("/=\?(.+)\?(B|Q)\?(.*)=?=?\?=/siU",$string,$mime,PREG_SET_ORDER)){
			//var_dump(mb_detect_order());
			//debug($string);
			//debug($mime);
			foreach ($mime as $val) {
				if (strtolower($val[2])=='b') {
					$val[3]=base64_decode($val[3]);
				} else {
					$val[3]=str_replace('_',' ',quoted_printable_decode($val[3]));
				}
				//debug($val);
				//echo mb_detect_encoding($val[3],$enc).'-'.$val[1].'<br>';
				//echo $val[0].'<br>';
				// echo $string.'<br>';
				$string=str_replace($val[0],Mail::decode($val[3],$val[1]),$string);

			}

		}
		//$string=preg_replace('/\s/','',$string);
		return $string;
	}
	/*function &addWebLink($string) {
		$string=preg_replace("/([\w]+:\/\/[\w-?&;#~=\.\/\@+]+[\w\/])/i","#ALT;A TARGET=\"_blank\" HREF=\"$1\"#GT;$1#ALT;/A#GT;",$string);
		return $string;
	}*/
	public function addWebLink($string) {
		$s=array(
			'/&gt;/i',
			'/(^|\s|>)(www.[^<> \n\r]+)/iexm',
			'/(^|\s|>)([_A-Za-z0-9-]+(\\.[A-Za-z]{2,3})?\\.[A-Za-z]{2,4}\\/[^<> \n\r]+)/iexm',
			'/(?(?=<a[^>]*>.+<\/a>)(?:<a[^>]*>.+<\/a>)|([^="\']?)((?:https?):\/\/([^<> \n\r]+)))/iexm',
			'/ &gt;/i',
		);
		$v=array(
			' &gt;',
			"stripslashes((strlen('\\2')>0?'\\1<a href=\"http://\\2\" target=\"_blank\">\\2</a>\\3':'\\0'))",
			"stripslashes((strlen('\\2')>0?'\\1<a href=\"http://\\2\" target=\"_blank\">\\2</a>\\4':'\\0'))",
			"stripslashes((strlen('\\2')>0?'\\1<a href=\"\\2\" target=\"_blank\">\\3</a>':'\\0'))",
			'&gt;',
		);
		return preg_replace($s,$v,$string);
	}	
	function &addMailLink($string,$link) {
		$string=preg_replace("/([0-9a-z]([-_.]?[0-9a-z])*@[0-9a-z]([-.]?[0-9a-z])*\.[a-z]{1,4})/is","<a href=\"$link\">$1</a>",$string);
		return $string;
	}
	function &clearLink($string) {
		$string=strtr($string,array('#ALT;'=>'<','#GT;'=>'>'));
		return $string;
	}
	function wrap($string) {
		return wordwrap($string,81,"\n",0);
	}
	function decode($string,$char='',$enc='',$decode=1) {
		//debug($char);
		//debug($enc);
		//debug($string);
		if ($enc) {
			if(preg_match("/base64/i",$enc)) {
				//debug($string);
				$string=base64_decode($string);
				//debug('###'.$string);
			} elseif(preg_match("/quoted-printable/i",$enc)) {
				$string=imap_qprint($string);
				//debug($string);
			} else {
				$enc='';
			}
		}
		//debug($decode);
		//debug($string);
		if ($char!='NO') {
			if (!$char) $char='WINDOWS-1252';
			if ($char && $decode) {
				if (strtoupper($char)=='US-ASCII' || strtoupper($char)=='ASCII') $char='WINDOWS-1252';
				if (strtoupper($char)=='ISO-8859-1' || strtoupper($char)=='ISO-8859-15') $char='WINDOWS-1252';
				//echo $char;
				$string=Framework::convertCharset($string,$char,GE_CHARSET);
				//debug($string);
			}
		}
		return $string;
	}
	function mail_qenc($string){
		$tmp=str_replace("=\r\n",'',imap_8bit($string));
		if ($tmp!=$string) {
			$tmp=str_replace("?", "=3F",$tmp);
			$tmp=str_replace(" ", "=20",$tmp);
			return "=?".GE_CHARSET."?Q?" .$tmp. "?=";
		} else {
			return $string;
		}
	}
	function mail_qenc_email($email){
		$tmp=preg_split('/[;,]+/',$email);
		foreach ($tmp as $key=>$mail) {
			if (preg_match('/(.+)(<[^>]+>)/',$mail,$result)) {
				$tmp[$key]=$this->mail_qenc($result[1]).$result[2];
			}
		}
		return implode(',',$tmp);
	}

	function isAllowedAction(&$obj,&$action) {
		if (!is_array($action)) return false;
		if ($action['Perms'] && !$obj->getAcl($action['Perms'])) return false;
		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkAction($obj,substr($ac_val,1));
				} else {
					$result=$result||$this->_checkAction($obj,$ac_val);
				}
			}
			if (!$result) return false;
		}
		return true;
	}
	function isAllowedMailAction(&$obj,&$action) {
		if (!is_array($action)) return false;
		if ($action['Perms'] && !$obj->getAcl($action['Perms'])) return false;
		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkMailAction($obj,substr($ac_val,1));
				} else {
					$result=$result||$this->_checkMailAction($obj,$ac_val);
				}
			}
			if (!$result) return false;
		}
		return true;
	}
	function _checkAction(&$obj,$action) {
		switch ($action) {
			case 'sadmin':
				if (!$this->isSuperAdmin()) return false;
			break;
			case 'rule':
				if (!$this->isRuleUser()) return false;
			break;
			case 'root':
				if ($obj->getMeta('RootID')!=$obj->getID()) return false;
			break;
			case 'root_s':
				if ($this->_root_obj->getMeta('System')!='s') return false;
			break;
			case 'root_d':
				if ($this->_root_obj->getMeta('System')!='d') return false;
			break;
			case 'root_u':
				if ($this->_root_obj->getMeta('System')!='u') return false;
			break;
			case 'root_id_s':
				if ($obj->getMeta('RootID')!=$this->getRootIDs('s')) return false;
			break;
			case 'root_id_u':
				if ($obj->getMeta('RootID')!=$this->getRootIDs('u')) return false;
			break;
			case 'root_id_d':
				if ($obj->getMeta('RootID')!=$this->getRootIDs('d')) return false;
			break;
			case 'empty':
				$subfol=$this->listTree( $obj->getBox().$this->getCfg('cfg/delim').'%',true,false);
				if ($obj->getParentMeta('NumMsg') || count($subfol)) return false;
			break;
			case 'trash':
				if ($obj->getMeta('Type')!='T') return false;
			break;
			case 'spam':
				if ($obj->getMeta('Type')!='X') return false;
			break;
			case 'content':
				if (!$this->isClipboard('mobj')) return false;
			break;
			case 'sync':
				$baseSync=$this->_frm->getStaticModul('active_sync');
				return $baseSync->isSyncFolder($obj->getBox());
			break;

		}
		return true;
	}
	function _checkMailAction(&$obj,$action) {
		switch ($action) {
			case 'app_addr':
				if (!$GLOBALS['app']['addr']) return false;
			break;
			case 'app_rem':
				if (!$GLOBALS['app']['rem']) return false;
			break;
			case 'trash':
				if ($obj->getMeta('Box')!=$this->getTrashID()) return false;
			break;
			case 'spam':
				if ($obj->getMeta('Box')!=$this->getSpamID()) return false;
			break;
		}
		return true;
	}

	function saveEmail($mail) {
		$mail['FKuserID']=$this->_uid;
		$this->_db->insert('Mail_Temp',$mail,'',1);
	}
	function getEmail() {
		$this->_db->query("SELECT * FROM Mail_Temp WHERE FKUserID=".$this->_db->escape($this->_uid));
		if ($this->_db->next_record()) {
			return array(
				'TO'=>$this->_db->f('TO'),
				'CC'=>$this->_db->f('CC'),
				'BCC'=>$this->_db->f('BCC'),
				'Subject'=>$this->_db->f('Subject'),
				'Body'=>$this->_db->f('Body'),
				'Attachment'=>$this->_db->f('Attachment'),
				'identity'=>$this->_db->f('identity'),
				'copyto'=>$this->_db->f('copyto'),
				'read_confirm'=>$this->_db->f('read_confirm'),
				'answered'=>$this->_db->f('answered'),
				'forward'=>$this->_db->f('forward'),
				'mbox'=>$this->_db->f('mbox'),
				'extra'=>$this->_db->f('extra'),
			);
		}  else return 0;
	}
	function deleteEmail() {
		$this->_db->query("DELETE FROM Mail_Temp WHERE FKUserID=".$this->_db->escape($this->_uid));
	}
	function addEmailAttachments($Value) {
		$aktAttach=$this->getEmailAttachments();
		foreach ($aktAttach as $key=>$val) {
			if ($val['Name']==$Value['Name']) {
				$Value['ID']=$key;
				break;
			}
		}
		$Value['FKuserID']=$this->_uid;
		if (!isset($Value['ID'])) $Value['ID']=$this->getNextAttachmentID();
		//debugFile($Value);
		$this->_db->insert('MailTempAttachments',$Value,'',1);
		return $Value;
	}
	function getNextAttachmentID() {
		$this->_db->query("SELECT max(ID) as num FROM MailTempAttachments WHERE FKUserID=".$this->_db->escape($this->_uid));
		if ($this->_db->next_record()) {
			return $this->_db->f('num')+1;
		}
		return 0;
	}
	function getEmailAttachments() {
		$result=array();
		$this->_db->query("SELECT * FROM MailTempAttachments WHERE FKUserID=".$this->_db->escape($this->_uid));
		while ($this->_db->next_record()) {
			$result[$this->_db->f('ID')]=array(
				'ID'=>$this->_db->f('ID'),
				'Name'=>$this->_db->f('Name'),
				'Size'=>$this->_db->f('Size'),
				'Type'=>$this->_db->f('Type'),
				'Cid'=>$this->_db->f('Cid'),
				'Source'=>$this->_db->f('Source'),
			);
		}
		return $result;
	}
	function readEmailAttachment($ID) {
		$this->_db->query("SELECT * FROM MailTempAttachments WHERE FKUserID=".$this->_db->escape($this->_uid)." AND ID=".$this->_db->escape($ID));
		if ($this->_db->next_record()) {
			$result=array(
				'ID'=>$this->_db->f('ID'),
				'Name'=>$this->_db->f('Name'),
				'Size'=>$this->_db->f('Size'),
				'Type'=>$this->_db->f('Type'),
				'Cid'=>$this->_db->f('Cid'),
				'Source'=>$this->_db->f('Source'),
			);
			return $result;
		}
	}
	function deleteEmailAttachments($ID=null) {
		$query="DELETE FROM MailTempAttachments WHERE FKUserID=".$this->_db->escape($this->_uid);
		if (isset($ID)) $query.=" AND ID=".$this->_db->escape($ID);
		$this->_db->query($query);
	}


	function deleteAttachment() {
		$this->deleteEmailAttachments();
		if ($dir = @opendir($this->_path."attach/".$this->_uid)) {
			while($file = readdir($dir)) {
				//echo $file.'<br>';
				if (is_file($this->_path."attach/".$this->_uid.'/'.$file)) unlink($this->_path."attach/".$this->_uid.'/'.$file);
			}
		}
	}
	function updateHotlist($email,$type='hot') {
		$mail_check=imap_rfc822_parse_adrlist($email,'');
		if (!$mail_check || !is_array($mail_check) || count($mail_check) > 5) return 0;
		foreach ($mail_check as $key=>$val) {
			$mail=$val->mailbox.'@'.$val->host;
			$name=$val->personal;
			if (!$name) $name=$mail;
			$insert=array(
				'FKUserID'=>$this->_uid,
				'Email'=>strtolower($mail),
				'Name'=>$name,
				'Type'=>$type,
			);
			$this->_db->insert('Mail_Hotlist',$insert,'',0,1);
			$test[]=$mail;
		}
		if ($type=='hot' && is_array($test)) {
			$query="UPDATE Mail_Hotlist set `Count`=`Count`+1,Date=".time()." WHERE FKUserID='".$this->_uid."' AND Email IN (".implode(",",$this->_db->escape($test)).")";
			$this->_db->query($query);
		}
	}
	function tmpHotlist() {
		/*$query="SELECT * FROM Mail_Hotlist WHERE Type='hot'";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$email=strtolower($this->_db->f('Email'));
			if (!isset($insert[$this->_db->f('FKUserID')][$email])) {
				$insert[$this->_db->f('FKUserID')][$email]=array(
					'FKUserID'=>$this->_db->f('FKUserID'),
					'Email'=>$email,
					'Type'=>'hot',
					'Count'=>0,
					'Date'=>$this->_db->f('Date'),
					'Name'=>$this->_db->f('Name'),
				);
			}
			$insert[$this->_db->f('FKUserID')][$email]['Count']+=$this->_db->f('Count');
			if ($this->_db->f('Date')>$insert[$this->_db->f('FKUserID')][$email]['Date']) {
				$insert[$this->_db->f('FKUserID')][$email]['Date']=$this->_db->f('Date');
				$insert[$this->_db->f('FKUserID')][$email]['Name']=$this->_db->f('Name');
			}
		}
		$query="DELETE FROM Mail_Hotlist2 WHERE Type='hot'";
		$this->_db->query($query);

		foreach ($insert as $insert1) {
			foreach ($insert1 as $insert2) {
				$this->_db->insert('Mail_Hotlist2',$insert2,'',0,1);
			}
		}*/



	}
	function getHotlist($type='hot') {
		$result=array();
		$query="SELECT Email,Name FROM Mail_Hotlist WHERE FKUserID=".$this->_db->escape($this->_uid)." AND Type=".$this->_db->escape($type);
		if ($type=='hot') {
			$query.="ORDER BY `Count` Desc, Date Desc LIMIT 20";
		} else {
			$query.='ORDER BY Name';
		}
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$temp=explode('@',$this->_db->f('Email'));
			if ($this->_db->f('Name')!=$this->_db->f('Email')) {
				$mail=trim(imap_rfc822_write_address ($temp[0],$temp[1],$this->mail_enc($this->_db->f('Name'))));
			} else {
				$mail=trim(imap_rfc822_write_address ($temp[0],$temp[1],''));
			}
			if (strpos($mail,'<')===0) {
				$mail=substr($mail,1,-1);
			}
           	$result[$mail]=$this->_db->f('Name');
		}
		return $result;
	}
	function searchHotlist($name,$limit=5) {
		$result=array();

		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_uid);
		$searchQuery[]=array('Typ'=>'concat','Field'=>array('Name','Email'),'Values'=>trim($name),'OnlyWords'=>'S');

		$query="SELECT Email,Name FROM Mail_Hotlist WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" ORDER BY `Count` Desc, Date Desc";
		$query.=' '.$this->_db->formatLimit(0,$limit);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$temp=explode('@',$this->_db->f('Email'));
			if ($this->_db->f('Name')!=$this->_db->f('Email')) {
				$mail=trim(imap_rfc822_write_address ($temp[0],$temp[1],$this->mail_enc($this->_db->f('Name'))));
			} else {
				$mail=trim(imap_rfc822_write_address ($temp[0],$temp[1],''));
			}
			if (strpos($mail,'<')===0) {
				$mail=substr($mail,1,-1);
			}
           	$result[]=array(
				'Name'=>$this->_db->f('Name'),
				'Email'=>$this->_db->f('Email'),
				'Rfc822'=>$mail
           	);
		}
		return $result;
	}
	function deleteHotList($email=0,$type='hot') {
		if (!$email) return 0;
		foreach ($email as $val) {
			if (preg_match('/^<(.*)>$/',trim($val),$res)) {
				$test[]=trim($res[1]);
			} else {
				$test[]=trim($val);
			}
		}
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_uid);
		$searchQuery[]=array('Field'=>'Email','Typ'=>'=','Values'=>$test);
		if ($type) $searchQuery[]=array('Field'=>'Type','Typ'=>'=','Values'=>$type);

		$this->_db->delete('Mail_Hotlist',$searchQuery);
	}
	function deleteUser($user_id) {
		$query="DELETE FROM Mail_Temp WHERE FKUserID=".$this->_db->escape($user_id);
		$this->_db->query($query);
		$query="DELETE FROM Mail_AutoAbbo WHERE FKUserID=".$this->_db->escape($user_id);
		$this->_db->query($query);
		$query="DELETE FROM Mail_Access WHERE FKUserID=".$this->_db->escape($user_id);
		$this->_db->query($query);
		if ($dir = @opendir($this->_path."attach/".basename($user_id))) {
			while($file = readdir($dir)) {
				//echo $file.'<br>';
				if (is_file($this->_path."attach/".$user_id.'/'.$file)) unlink($this->_path."attach/".$user_id.'/'.$file);
			}
			closedir($dir);
			@rmdir($this->_path."attach/".basename($user_id));
		}

	}
	function getAccess() {
		$query="SELECT * FROM Mail_Access WHERE FKUserID=".$this->_db->escape($this->_uid);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('GrantUserID');
		}
		return $result;
	}
	function getMimeExtension($mime,$first=1) {
		$query="SELECT Extension FROM Mime_Types WHERE Mime_Type LIKE '".addslashes($mime)."'";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$ext=explode(',',$this->_db->f('Extension'));
			if ($first) return trim($ext[0]);
			else return $ext;
		} else {
			return false;
		}
	}
	function getScripts() {
		$result=array();
		$query="SELECT * FROM Mail_Script WHERE ScriptUser='".$this->_uid."' ";
		$query.=" ORDER BY ScriptName";
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$result[$this->_db->f('ScriptID')]=$this->_db->f('ScriptName');
		}
		return $result;
	}
	function insertSearchTemp($sdata) {
		$Data['Sdata']=serialize($sdata);
		$Data['FKUserID']=$this->_uid;
		//debug($Data);
		$this->_db->insert('MailSearchTemp',$Data,'',1);
		return 0;
	}
	function readSearchTemp() {
		$query="SELECT * FROM MailSearchTemp WHERE FKUserID=".$this->_db->escape($this->_uid);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$result=unserialize($this->_db->f("Sdata"));
			return $result;
		} else {
			return false;
		}
	}
	function delteMailAbbo($user_id,$mbox='',$mode='',$limit=0) {
		$query="DELETE FROM Mail_AutoAbbo WHERE FKUserID=".$this->_db->escape($user_id);
		if ($mode) $query.=" AND Mode=".$this->_db->escape($mode);
		if ($mbox) $query.=" AND MailBox=".$this->_db->escape($mbox);
		if ($limit) $query.=' LIMIT '.intval($limit);
		$this->_db->query($query);
	}
	function insertMailAbbo($user_id,$mbox,$mode='abbo') {
		$Data=array(
			'FKUserID'=>$user_id,
			'MailBox'=>$mbox,
			'Mode'=>$mode,
		);
		$this->_db->insert('Mail_AutoAbbo',$Data);
	}
	function getMailAbbo($user_id,$mbox='') {
		$result=array();
		$query="SELECT DISTINCT MailBox,Mode FROM Mail_AutoAbbo WHERE FKUserID=".$this->_db->escape($user_id);
		if ($mbox) $query.=" AND MailBox=".$this->_db->escape($mbox);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('MailBox')]=$this->_db->f('Mode');
		}
		if (!empty($result)) return $result; else return false;
	}
	function listUserAccess($uid) {
		$query="SELECT * FROM Mail_Access WHERE FKUserID=".$this->_db->escape($uid);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('GrantUserID');
		}
		return $result;
	}
	function removeMailSignID($html) {
		return str_replace('id="groupeMailSign"','',$html);
	}
	function getHtmlCharset($body,$charset='') {
		if ($this->_frm->isUtf8($body)) {
			$charset='UTF-8';
		} else		if (!$charset && preg_match_all('/<\s*meta\s*http-equiv=["]?Content-Type["]?\s*content="([^">]+)"/i',$body,$temp) || preg_match_all('/<\s*meta\s*content="([^">]+)"\s*http-equiv=["]?Content-Type["]?/i',$body,$temp)) {
			$temp2=explode('=',end($temp[1]));
			$charset=$temp2[count($temp2)-1];
		}
		if (!$charset || strtolower($charset)=='us-ascii' || strtolower($charset)=='ascii') $charset='windows-1252';
		return $charset;
	}
	function convertHtml($body,$charset='iso-8859-1') {
		require_once('lib/mail/class_Emogrifier.php');
		$body=preg_replace('/\<\!\[([^\x5d]+)\]\>/is','',$body);
		$body=$this->fixHtml($body,strtoupper($charset),false);
		$Emogrifier=new Emogrifier($body);
		if ($Emogrifier->emogrify()) {
			$body=$Emogrifier->getHtml();
		}
		//debug(strlen($body));
		//debug(htmlspecialchars($body));
		$body=preg_replace('/\<\s*head[^>]*\>(.*)\<\s*\/\s*head[^>]*\>/isU','',$body);
		//$body=preg_replace('/\<head\>(.*)\<\/headopo\>/is','',$body);
		//debug(htmlspecialchars($body));
		return $body;
	}
	function formatNewHtmlMail($body,$addBodyB='',$addBodyE='',$charset='iso-8859-1',$addHeader='') {
		$charset=strtoupper($charset);
		$body=preg_replace('/<\s*\/?(html|body)\s*[^>]*>/i','',$body);
		$body=preg_replace('/<\s*head[^>]*>(.*)<\s*\/\s*head[^>]*>/isU','',$body);
		$nBody="<html>";
		if ($addHeader) {
			$nBody.="<head>".$addHeader.'</head>';
		}
		$nBody.="<body style=\"font-family:verdana,geneva,sans-serif;font-size:12px;color:#000;\">".$addBodyB.$body.$addBodyE."</body>";
		$nBody.="</html>";
		$nBody=preg_replace('/<p>/','<p style="padding:0;margin:0;">',$nBody);
		return $this->fixHtml($nBody,$charset,false);
	}
	function fixHtml($html,$charset=GE_CHARSET,$removeHead=true) {
		//Ab und zu in MS-Office Html
		$html=preg_replace('@<\?xml[^>]+>@','',$html);
		if (class_exists('tidy')) {
			$config = array(
				'preserve-entities'=>true,
				'doctype'=>'omit',
				'wrap'=>0,
				'drop-proprietary-attributes'=>true,
				'output-xhtml'=>true,
				'force-output'=>true,
				'output-encoding'=>'latin1',
				'quote-ampersand'=>true,
				'word-2000'=>true,
				//'clean'=>true,
			);
			//debug("\n"."\n".'--------------------------------------------'."\n".htmlspecialchars($html));
			$tidy = new tidy();
			$html = $tidy->repairString($html,$config,$charset=='UTF-8'?'utf8':'win1252');
			if ($removeHead) {
				$html=preg_replace('/<\s*head[^>]*>(.*)<\s*\/\s*head[^>]*>/isU','',$html);
			}
		}
		$html=str_replace("<o:p>",'',$html);
		$html=str_replace("</o:p>",'',$html);

		return Framework::convertCharset($html,$charset,'HTML-ENTITIES');
	}
	function addHtmlImages($body,$cid) {
		if (is_array($cid) && !empty($cid)) {
			$body=preg_replace('/(src|background)=["\']?cid:([^"\'> ]+)["\']?/sie','"\\1=\"".$cid[\'\\2\']."\""',$body);
		}
		return $body;
	}
	function headersToTxt($headers,$n="\r\n")    {
        $ret = '';
        $nl='';
        foreach ($headers as $key => $val) {
			if ($key!='Subject') {
				$val=wordwrap($val,200,$n." ");
			}
            $ret .= $nl."$key: $val";
            $nl=$n;
        }
        return $ret;
    }
    function trimUser($Box) {
		$res=strstr($Box,$this->getCfg('cfg/delim'));
		if ($res===false) $res=$Box;
		if ($res[0]==$this->getCfg('cfg/delim')) $res=substr($res,1);
		if (GE_mailUserSuffix) {
			$res=preg_replace('/'.preg_quote(GE_mailUserSuffix).'/','',$res);
		}
		return $res;
    }
	function treeToJson(&$tree,$start,$prep='',$useStart=false) {
		foreach ($tree[$start] as $key=>$val) {
			$result.="[null,'".Framework::escapeJs($val->getName())."', ";
			if ($start=='0' && !$useStart) {
				$result.="null";
			} else {
				$result.="'javascript:upCpF(\'".Framework::escapeJs($prep.$val->getBox())."\')'";
			}
			if (is_array($tree[$key])) {
				$result.=', '."\n";
				$result.=$this->treeToJson($tree,$key,$prep);
			}
			$result.='],'."\n";
		}
		return $result;
    }
    function encodeAttachment($orig_file) {
		$b64_file=$orig_file.'.b64';
		if (Framework::checkExec('uuencode')) {
			$exec='uuencode -m '.escapeshellarg($orig_file).' '.escapeshellarg(basename($orig_file)).' > '.escapeshellarg($b64_file);
			exec($exec);
		}
   }
   function initColorFilter() {
		$this->_colorMatches=array();
		$cfilter=unserialize($this->getPrefs('cfilter'));
		if (is_array($cfilter) && !empty($cfilter)) {
			foreach ($cfilter as $val) {
				$this->_colorMatches[$val['typ']]['search'][]='/^.*'.str_replace('\*','.*',preg_quote($val['match'],'/')).'.*$/';
				$this->_colorMatches[$val['typ']]['rep'][]=$val['color'];
			}
		}
   }
   function getColor(&$Obj) {
		$color='';
		foreach ($this->_colorMatches as $typ=>$search) {
			$num=0;
			switch ($typ) {
				case 'from':
					//debug($search['search']);
					//debug($search['rep']);
					//debug(implode(',',$this->formatMail($Obj->getMail('From'),0,1)));

					$color=preg_replace($search['search'],$search['rep'],implode(',',$this->formatMail($Obj->getMail('From'),0,1)),1,$num);
				break;
				case 'to':
					$color=preg_replace($search['search'],$search['rep'],implode(',',$this->formatMail($Obj->getMail('To'),0,1)),1,$num);
				break;
				case 'subject':
					$color=preg_replace($search['search'],$search['rep'],$Obj->getName(),1,$num);
				break;
			}
			if ($num) break;
			$color='';
		}
		return $color;
   }
   function setMailColor($MailMd5,$MailColor) {
		$insert=array(
			'FKUserID'=>$this->_uid,
			'FKMailMd5'=>$MailMd5,
			'Color'=>$MailColor,
		);
		$this->_db->insert('MailColor',$insert,'',1);
   }
   function getMailColor($MailMd5='') {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_uid);
		if ($MailMd5) $searchQuery[]=array('Field'=>'FKMailMd5','Typ'=>'=','Values'=>$MailMd5);
		$query="SELECT * FROM MailColor WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('FKMailMd5')]=$this->_db->f('Color');
		}
		return $result;
   }
   function deleteMailColor($MailMd5='') {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_uid);
		if ($MailMd5) $searchQuery[]=array('Field'=>'FKMailMd5','Typ'=>'=','Values'=>$MailMd5);
		$query="DELETE FROM MailColor WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
   }
   function updateMailColor($oldMailMd5,$newMailMd5) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_uid);
		$searchQuery[]=array('Field'=>'FKMailMd5','Typ'=>'=','Values'=>$oldMailMd5);
		$update=array(
			'FKMailMd5'=>$newMailMd5,
		);
		$this->_db->update('MailColor',$update,$this->_db->getWhere($searchQuery));
   }
   function setIntFlag($MailMd5,$Flag) {
		$insert=array(
			'FKUserID'=>$this->_uid,
			'FKMailMd5'=>$MailMd5,
			'Flag'=>$Flag,
		);
		$this->_db->insert('MailFlags',$insert,'',1);
   }
   function getAllIntFlag($MailMd5='') {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_uid);
		if ($MailMd5) $searchQuery[]=array('Field'=>'FKMailMd5','Typ'=>'=','Values'=>$MailMd5);
		$query="SELECT * FROM MailFlags WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('FKMailMd5')][]=$this->_db->f('Flag');
		}
		return $result;
   }
   function issetIntFlag($MailMd5,$Flag) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_uid);
		$searchQuery[]=array('Field'=>'FKMailMd5','Typ'=>'=','Values'=>$MailMd5);
		$searchQuery[]=array('Field'=>'Flag','Typ'=>'=','Values'=>$Flag);
		$query="SELECT * FROM MailFlags WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return true;
		}
		return false;
   }
   function deleteIntFlag($MailMd5='',$Flag='') {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_uid);
		if ($MailMd5) $searchQuery[]=array('Field'=>'FKMailMd5','Typ'=>'=','Values'=>$MailMd5);
		if ($Flag) $searchQuery[]=array('Field'=>'Flag','Typ'=>'=','Values'=>$Flag);
		$query="DELETE FROM MailFlags WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
   }
   function deleteArchiv($Box,$Files,$prep='') {
		$CyrAdm=& $this->_frm->getStaticModul('mail_adm');
		$this->open();
		if ($prep) $Box=$prep.$CyrAdm->getCfg('cfg/delim').$Box;
		if (is_array($Files)) {
			$delMails=array();
			$delFolders=array();
			foreach ($Files as $val) {
				$val=str_replace('./','',$val);
				$res=array();
				if (preg_match('/(.*)\/([0-9]+)\.eml/',$val,$res)) {
					$delMails[$this->decBox(str_replace('/',$CyrAdm->getCfg('cfg/delim'),$res[1]))][]=$res[2];
				} elseif($val && $val[strlen($val)-1]=='/') {
					$delFolders[]=$this->decBox(str_replace('/',$CyrAdm->getCfg('cfg/delim'),substr($val,0,-1)));
				}
			}
			if (!empty($delMails) && $CyrAdm->imap_login()) {
				foreach ($delMails as $sBox=>$mIDs) {
					$actBox=$Box.$CyrAdm->getCfg('cfg/delim').$sBox;
					$boxAcl=$CyrAdm->getacl($actBox);
					if (isset($boxAcl[$this->getUserName()])) {
						$oldAcl=$boxAcl[$this->getUserName()];
					} else {
						$oldAcl='';
					}
					$CyrAdm->setacl($actBox,$this->getUserName(),$CyrAdm->permsAll);
					$this->deleteMail($actBox,implode(',',$mIDs));
					$this->expungeBox($actBox);

					//debug($Filter);
					//$emails=imap_search($this->_ms,$Filter?$Filter:'All',SE_UID);
					if ($oldAcl) {
						$CyrAdm->setacl($actBox,$this->getUserName(),$oldAcl);
					} else {
						$CyrAdm->deleteacl($actBox,$this->getUserName());
					}
				}
			}
			if (!empty($delFolders) && $CyrAdm->imap_login()) {
				uasort ($delFolders,array('Framework','sortByLenDesc'));
				foreach ($delFolders as $sBox) {
					$actBox=$Box.$CyrAdm->getCfg('cfg/delim').$sBox;
					$boxAcl=$CyrAdm->getacl($actBox);
					if (isset($boxAcl[$this->getUserName()])) {
						$oldAcl=$boxAcl[$this->getUserName()];
					} else {
						$oldAcl='';
					}
					$CyrAdm->setacl($actBox,$this->getUserName(),$CyrAdm->permsAll);
					$boxObj=$this->getObj($actBox,true,true);
					if (is_object($boxObj) && !$boxObj->getMeta('Folders') && !$boxObj->getMeta('NoMails') && !$boxObj->getParentMeta('NumMsg')) {
						$this->deleteFolder($actBox);
						//debug($actBox);
					} else {
						if ($oldAcl) {
							$CyrAdm->setacl($actBox,$this->getUserName(),$oldAcl);
						} else {
							$CyrAdm->deleteacl($actBox,$this->getUserName());
						}
					}
				}
			}
		}
   }
   function archivFolder($Box,$search,$resPath,$resFile,$ingnorePerms=true) {
		global $T;
		$T->loadModul('mail');
		require_once('lib/class_ApplicationListGui.php');
		$Gui=new ApplicationListGui('core/common_table_intern_list.inc.html');
		$key='hdSubject';
		$Gui->addHeaderCol($key,$T->lang('[[Betreff]]'),'','','',0,'',0);
		$key='hdFrom';
		$Gui->addHeaderCol($key,$T->lang('[[AbsenderIn]]'),'','','',1);
		$key='hdTo';
		$Gui->addHeaderCol($key,$T->lang('[[EmpfaengerIn]]'),'','','',1);
		$key='hdDate';
		$Gui->addHeaderCol($key,$T->lang('[[Datum]]'),'','','',1);
		$key='hdSize';
		$Gui->addHeaderCol($key,$T->lang('[[Dateigroesse]]'),'','','',1);
		$key='hdName';
		$Gui->addHeaderCol($key,$T->lang('[[Dateiname]]'),'','','',1);

		$htmlPrep='<html><head><style type="text/css">
			* {font-size:12px;font-family: Verdana, Arial, Helvetica;}
			a,a:visited {color:#000;text-decoration:underline;}

			body{margin:10px;}
			div.table_title {
				font-size: 110%;
				font-weight:bold;
				white-space:nowrap;
				margin-bottom:5px;
			}
			table.int_list  {
				border:none;

			}
			th.int_list {
				font-weight:bold;
				background:#cccccc;
				padding:3px;
			}
			td.list_l {
				padding:3px;
				background:#fff;
			}
			td.list_h {
				padding:3px;
				background:#f2f2f2;
			}
			td.list_s {
				padding:3px;
				background:#ffe6cc;
				font-weight:bold;
			}
			</style></head><body>';
		$htmlAfter='</body></html>';

		$CyrAdm=& $this->_frm->getStaticModul('mail_adm');
		$result=array();
		$this->open();
		$tmpPath=$resPath.'/_mail';
		if (!file_exists($tmpPath)) {
			mkdir($tmpPath,0700);
		}
		Framework::deleteFilesRecursive($tmpPath,'/.*/');


		$Filter='';
		if ($search['DateB']) $Filter.='SINCE "'.date("d-M-y 00:00:00",$search['DateB']).'" ';
		if ($search['DateE']) $Filter.='BEFORE "'.date("d-M-y 00:00:00",$search['DateE']+7200).'" ';
		if ($search['Filter']) $Filter.=$search['Filter'].' ';

		if ($CyrAdm->imap_login()) {
			if (is_array($Box)) {
				$boxes=$Box;
				$startPath='.';
				$replacePath='user';
			} else {
				$boxes=$CyrAdm->GetFolders($Box,$CyrAdm->getCfg('cfg/delim').'*');
				if (!in_array($Box,$boxes)) $boxes[]=$Box;

				$tmp=explode($CyrAdm->getCfg('cfg/delim'),$Box);
				$startPath=end($tmp);
				$replacePath=$Box;
			}


			foreach ($boxes as $sBox) {
				if ($ingnorePerms) {
					$boxAcl=$CyrAdm->getacl($sBox);
					if (isset($boxAcl[$this->getUserName()])) {
						$oldAcl=$boxAcl[$this->getUserName()];
					} else {
						$oldAcl='';
					}
					$CyrAdm->setacl($sBox,$this->getUserName(),$CyrAdm->permsAll);
				}
				if (preg_match('/^INBOX/',$sBox)) {
					$dispBox=preg_replace('/^INBOX/',$this->getUserName(),$sBox);
				} else {
					$dispBox=$sBox;
				}
				$dispBox=preg_replace('/^'.preg_quote($replacePath,'/').'('.preg_quote($CyrAdm->getCfg('cfg/delim'),'/').'|$)/','',$dispBox);
				$actFolder=str_replace($CyrAdm->getCfg('cfg/delim'),'/',$dispBox);
				if ($actFolder) {
					$actFolder=$startPath.'/'.$actFolder;
				} else {
					$actFolder=$startPath;
				}
				if (!file_exists($tmpPath.'/'.$this->encBox($actFolder))) {
					mkdir($tmpPath.'/'.$this->encBox($actFolder),0755,true);
				}
				$this->open($sBox);
				//debug($Filter);
				$emails=imap_search($this->_ms,$Filter?$Filter:'All',SE_UID);
				//debug($emails);
				if (is_array($emails)) {
					$sGui=new ApplicationListGui('core/common_table_intern_list.inc.html');
					$sGui->setName($actFolder);
					$key='hdSubject';
					$sGui->addHeaderCol($key,$T->lang('[[Betreff]]'),'','','',0,'',0);
					$key='hdFrom';
					$sGui->addHeaderCol($key,$T->lang('[[AbsenderIn]]'),'','','',1);
					$key='hdTo';
					$sGui->addHeaderCol($key,$T->lang('[[EmpfaengerIn]]'),'','','',1);
					$key='hdDate';
					$sGui->addHeaderCol($key,$T->lang('[[Datum]]'),'','','',1);
					$key='hdSize';
					$sGui->addHeaderCol($key,$T->lang('[[Dateigroesse]]'),'','','',1);
					$key='hdName';
					$sGui->addHeaderCol($key,$T->lang('[[Dateiname]]'),'','','',1);


					$Gui->addRow(2,'top','');
					$Gui->addCol($key,$actFolder,'',str_replace('%2F','/',rawurlencode($this->encBox($actFolder))).'/index.html','',0,'',6,'');
					foreach ($emails as $num) {
						$hObj=imap_headerinfo($this->_ms ,imap_msgno($this->_ms,$num));
						$fp=fopen($tmpPath.'/'.$this->encBox($actFolder).'/'.$num.'.eml','w+');
						fwrite($fp,imap_fetchheader($this->_ms ,$num,FT_INTERNAL|FT_UID));
						fwrite($fp,imap_body($this->_ms ,$num,FT_INTERNAL|FT_UID));
						fclose($fp);
						$link=$this->encBox($actFolder).'/'.$num.'.eml';

						$Gui->addRow($hl?$hl=0:$hl=1,'top','');
						$key='subject';
						$Gui->addCol($key,$this->mail_enc($hObj->subject),'',str_replace('%2F','/',rawurlencode($link)),'',0,'2000',0,'');
						$key='from';
						$Gui->addCol($key,$this->mail_enc($this->formatMail($hObj->from[0],20)),'','','',1);
						$key='to';
						$Gui->addCol($key,$this->mail_enc($this->formatMail($hObj->to[0],20)),'','','',1);
						$key='date';
						$Gui->addCol($key,date("d.m.Y H:i",$hObj->udate),'','','',1);
						$key='size';
						$Gui->addCol($key,Framework::formatSize($hObj->Size),'','','right',1);
						$key='file';
						$Gui->addCol($key,$num.'.eml','','','right',1);

						$sGui->addRow($hl2?$hl2=0:$hl2=1,'top','');
						$key='subject';
						$sGui->addCol($key,$this->mail_enc($hObj->subject),'',str_replace('%2F','/',rawurlencode($num.'.eml')),'',0,'2000',0,'');
						$key='from';
						$sGui->addCol($key,$this->mail_enc($this->formatMail($hObj->from[0],20)),'','','',1);
						$key='to';
						$sGui->addCol($key,$this->mail_enc($this->formatMail($hObj->to[0],20)),'','','',1);
						$key='date';
						$sGui->addCol($key,date("d.m.Y H:i",$hObj->udate),'','','',1);
						$key='size';
						$sGui->addCol($key,Framework::formatSize($hObj->Size),'','','right',1);
						$key='file';
						$sGui->addCol($key,$num.'.eml','','','right',1);


					}
					$fp=fopen($tmpPath.'/'.$this->encBox($actFolder).'/index.html','w+');
					fwrite ($fp,$htmlPrep);
					fwrite ($fp,Framework::convertCharset($sGui->process(),GE_CHARSET,'ISO-8859-15'));
					fwrite ($fp,$htmlAfter);
				}
				if ($ingnorePerms) {
					if ($oldAcl) {
						$CyrAdm->setacl($sBox,$this->getUserName(),$oldAcl);
					} else {
						$CyrAdm->deleteacl($sBox,$this->getUserName());
					}
				}
			}
		}

		$fp=fopen($tmpPath.'/index.html','w+');
		fwrite ($fp,$htmlPrep);
		fwrite ($fp,Framework::convertCharset($Gui->process(),GE_CHARSET,'ISO-8859-15'));
		fwrite ($fp,$htmlAfter);


		$oldDir=realpath('.');
		$result[0]='';

		if (preg_match('/\.zip$/',$resFile)) {
			$exec="zip -rX ".escapeshellarg(realpath($resPath).'/'.$resFile)." *";
		} else {
			$exec='tar -cvz  -f '.escapeshellarg(realpath($resPath).'/'.$resFile). ' .';
		}

		if ($tmpPath && chdir($tmpPath)) {
			exec($exec,$result,$result[0]);
			chdir($oldDir);
		}
		if (file_exists($resPath.'/'.$resFile)) {
			Framework::deleteFilesRecursive($tmpPath,'/.*/');
			rmdir($tmpPath);
		}

		return $result;
    }
    function searchArchiv(&$rows,$search,$order,$b=0,$limit=0,$use_limit=true,$use_perms=true) {
    	$result=array();
		$searchQuery=array();
		if ($search['DateB']) $searchQuery[]=array('Field'=>'MailDate','Typ'=>'>=','Values'=>date('Y-m-d 00:00:00',$search['DateB']));
		if ($search['DateE']) $searchQuery[]=array('Field'=>'MailDate','Typ'=>'<=','Values'=>date('Y-m-d 23:59:59',$search['DateE']));
		if (trim($search['info'])) {
			switch ($search['where']) {
				case 'SUBJECT':
					$Field='Subject';
				break;
				case 'FROM':
					$Field='MailFrom';
				break;
				case 'TO':
					$Field='MailTo';
				break;
				case 'CC':
					$Field='MailCc';
				break;
				case 'TEXT':
					$Field=array('TextBody','HtmlBody');
				break;
				default:
					$Field=array('Subject','MailFrom','MailTo','MailCc');
					if (!defined('GE_mailArchiv_NoBody') || !GE_mailArchiv_NoBody) {
						$Field[]='TextBody';
						$Field[]='HtmlBody';
					}
				break;
			}
			$searchQuery[]=array('Field'=>$Field,'Typ'=>'concat','Values'=>$search['info'],'UseCase'=>0,'OnlyWords'=>0);
		}
		if (defined('GE_mailArchiv_NoPerms') && GE_mailArchiv_NoPerms) $use_perms=false;
		if ($use_perms) {
			if ($this->isRuleUser()) {
				$searchQuery[]=array('Field'=>'PermsOwner','Typ'=>'=','Values'=>array($this->_uid,0));
			} else {
				$searchAclQuery=array();
				$searchAclQuery[]=array(array('Field'=>'PermsOwner','Typ'=>'=','Values'=>array($this->_uid)));
				$searchAclQuery[]=array(array('Field'=>'PermsUser','Typ'=>'like','Values'=>'%|'.$this->_uid.'|%'));
				if (is_array($this->_gid)) {
					foreach ($this->_gid as $val) {
						$searchAclQuery[]=array(array('Field'=>'PermsGroup','Typ'=>'like','Values'=>'%|'.$val.'|%'));
					}
				}
				$searchQuery[]=array('Typ'=>'OR','Values'=>$searchAclQuery);
			}
  		}

		$query="SELECT ID,MailUID,MailDate,MailSize,Subject,MailFrom,MailTo,AttachmentsNum,ArchivPath FROM Mail_Archiv WHERE ".$this->_db->getWhere($searchQuery);
		if ($order) {
			$query.=" ORDER BY $order";
		}
		if ($limit) {
			$query.=' '.$this->_db->formatLimit($b,$limit);
		}
		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		while ($this->_db->next_record()) {
			$result[$this->_db->f('ID')]=array(
				'ID'=>$this->_db->f('ID'),
				'MailUID'=>$this->_db->f('MailUID'),
				'MailDate'=>$this->_db->SqlToDate($this->_db->f('MailDate')),
				'MailSize'=>$this->_db->f('MailSize'),
				'Subject'=>$this->_db->f('Subject'),
				'MailFrom'=>$this->_db->f('MailFrom'),
				'MailTo'=>$this->_db->f('MailTo'),
				'AttachmentsNum'=>$this->_db->f('AttachmentsNum'),
				'ArchivPath'=>$this->_db->f('ArchivPath'),
			);
		}
		if ($use_limit && $limit && ($b!=0 || $limit==$rows)) {
			$query="SELECT count(*) as num FROM Mail_Archiv WHERE ".$this->_db->getWhere($searchQuery);
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
		}
		return $result;
    }
    function getArchivMail($ID,$use_perms=true) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'ID','Typ'=>'=','Values'=>$ID);
		if (defined('GE_mailArchiv_NoPerms') && GE_mailArchiv_NoPerms) $use_perms=false;
		if ($use_perms) {
			if ($this->isRuleUser()) {
				$searchQuery[]=array('Field'=>'PermsOwner','Typ'=>'=','Values'=>array($this->_uid,0));
			} else {
				$searchAclQuery=array();
				$searchAclQuery[]=array(array('Field'=>'PermsOwner','Typ'=>'=','Values'=>array($this->_uid)));
				$searchAclQuery[]=array(array('Field'=>'PermsUser','Typ'=>'like','Values'=>'%|'.$this->_uid.'|%'));
				if (is_array($this->_gid)) {
					foreach ($this->_gid as $val) {
						$searchAclQuery[]=array(array('Field'=>'PermsGroup','Typ'=>'like','Values'=>'%|'.$val.'|%'));
					}
				}
				$searchQuery[]=array('Typ'=>'OR','Values'=>$searchAclQuery);
			}
  		}

		$query="SELECT * FROM Mail_Archiv WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$result=array(
				'ID'=>$this->_db->f('ID'),
				'MailUID'=>$this->_db->f('MailUID'),
				'MailDate'=>$this->_db->SqlToDate($this->_db->f('MailDate')),
				'MailSize'=>$this->_db->f('MailSize'),
				'Subject'=>$this->_db->f('Subject'),
				'MailFrom'=>$this->_db->f('MailFrom'),
				'MailTo'=>$this->_db->f('MailTo'),
				'AttachmentsNum'=>$this->_db->f('AttachmentsNum'),
				'ArchivPath'=>$this->_db->f('ArchivPath'),
			);
			return $result;
		}
		return false;
    }
	function archivMail($box,$mid) {
		if (!is_object($this->MDec)) {
			require_once("lib/mail/classMailDecode.php");
			$this->MDec=new MailDecode($this);
		}


		$Mobj=$this->getMailObj($box,$mid);
		if (!is_object($Mobj)) return array('server'=>'mail '.$box.'->'.$mid.' not exists');

		if (preg_match('/^INBOX/',$box)) {
			$fullBox=str_replace('INBOX','user'.$this->getCfg('cfg/delim').$this->getUserName(),$box);
		} else {
			$fullBox=$box;
		}


		$bodyar=$this->MDec->getBody($box,$Mobj);
		$sqlArchiv=array(
			'ID'=>0,
			'MailUID'=>$mid,
			'MailBox'=>$this->decBox($fullBox),
			'MailUser'=>$this->getUserName(),
			'MailDate'=>date('Y-m-d H:s:i',$Mobj->getMeta('Date')),
			'MailSize'=>$Mobj->getMeta('Size'),
			'Subject'=>$this->mail_enc($Mobj->getName()),
			'MailFrom'=>'',
			'MailTo'=>'',
			'MailCc'=>'',
			'MailBcc'=>'',
			'Attachments'=>array(),
			'AttachmentsNum'=>0,
			'FullHeader'=>'',
			'TextBody'=>'',
			'HtmlBody'=>'',
			'ArchivPath'=>'',
			'ArchivUser'=>$this->_frm->getUser(),
			'ArchivDate'=>date('Y-m-d H:s:i'),
			'PermsUser'=>'',
			'PermsGroup'=>'',
			'PermsOwner'=>0,
		);
		if (!isset($this->cachedBoxAcl[$fullBox])) {
			$this->cachedBoxAcl[$fullBox]=array('u'=>array(),'g'=>array());
			if (!$GLOBALS['CFG']['NoMailAdmin']) {
				$CyrAdm=& $this->_frm->getStaticModul('mail_adm');
				if ($CyrAdm->imap_login()) {
					$acl=$CyrAdm->getacl($fullBox);
					if($acl[$CyrAdm->admin]) unset($acl[$CyrAdm->admin]);
					foreach($acl as $key=>$var){
						if (strpos($var,'r')!==false) {
							if (preg_match('/^group:/',$key)) {
								$tmpData=$this->_frm->getAllGroups(0,-1,str_replace('group:','',$key),0,true,true);
								if (!empty($tmpData)) {
									$this->cachedBoxAcl[$fullBox]['g'][]=key($tmpData);
								}
							} else {
								if (GE_DOMAIN && $GLOBALS['CFG']['USER_CLASS']!='ldap_full') {
									$ukey=str_replace('_'.str_replace('.','_',GE_DOMAIN),'',$key);
								} else {
									$ukey=$key;
								}
								$tmpData=$this->_frm->getFullName(0,0,0,$ukey,0,true);
								if (!empty($tmpData)) {
									$this->cachedBoxAcl[$fullBox]['u'][]=key($tmpData);
								} else {
									$tmpData=$this->_frm->getFullName(0,0,1,$ukey,0,true);
									if (!empty($tmpData)) {
										$this->cachedBoxAcl[$fullBox]['u'][]=key($tmpData);
									}
								}
							}
						}
					}
				}
			}
		}
		$PermsUser=$this->cachedBoxAcl[$fullBox]['u'];
		$PermsGroup=$this->cachedBoxAcl[$fullBox]['g'];
		if (preg_match('/^INBOX/',$box)) {
			if (!in_array($this->getUser(),$PermsUser)) $PermsUser[]=$this->getUser();
			$sqlArchiv['PermsOwner']=$this->getUser();
		}
		$sqlArchiv['PermsUser']='|'.implode('|',array_unique($PermsUser)).'|';
		$sqlArchiv['PermsGroup']='|'.implode('|',array_unique($PermsGroup)).'|';
		if (is_array($Mobj->getMail('From'))) {
			$sqlArchiv['MailFrom']=implode(',',$this->formatMail($Mobj->getMail('From'),0,1));
		}
		if (is_array($Mobj->getMail('To'))) {
			$sqlArchiv['MailTo']=implode(',',$this->formatMail($Mobj->getMail('To'),0,1));
		}
		if (is_array($Mobj->getMail('Cc'))) {
			$sqlArchiv['MailCc']=implode(',',$this->formatMail($Mobj->getMail('Cc'),0,1));
		}
		if (is_array($Mobj->getMail('Bcc'))) {
			$sqlArchiv['MailBcc']=implode(',',$this->formatMail($Mobj->getMail('Bcc'),0,1));
		}

		if($bodyar['att']){
			foreach($bodyar['att'] as $var) {
				if (isset($bodyar['html']) && trim($var['id']) && preg_match('@image/(gif|png|jpeg|jpg)@i',$var['type']) && !($var['att'])) continue;
				$sqlArchiv['Attachments'][]=array(
					'type'=>$var['type'],
					'name'=>$var['name'],
					'size'=>$var['size'],
				);
				$sqlArchiv['AttachmentsNum']++;
			}
		}
		if(isset($bodyar['text'])) {
			$sqlArchiv['TextBody']=$this->mail_enc($bodyar['text']);
		}
		if(isset($bodyar['html'])){
			if (preg_match_all('/<\s*meta\s*http-equiv=["]?Content-Type["]?\s*content="([^">]+)"/i',$bodyar['html'],$charset) || preg_match_all('/<\s*meta\s*content="([^">]+)"\s*http-equiv=["]?Content-Type["]?/i',$bodyar['html'],$charset)) {
				if (preg_match('/unicode/',end($charset[1]))) {
					if (!$bodyar['html_charset']) $bodyar['html_charset']='windows-1252';
				} else {
					$tmp=array();
					if (preg_match('/charset=([^ ].+)/i',end($charset[1]),$tmp)) {
						$bodyar['html_charset']=trim($tmp[1]);
					}
				}
			} else {
				if (!$bodyar['html_charset']) $bodyar['html_charset']='windows-1252';
				if (strtoupper($bodyar['html_charset'])=='US-ASCII' || strtoupper($bodyar['html_charset'])=='ASCII') $bodyar['html_charset']='windows-1252';
			}
			$sqlArchiv['HtmlBody']=Framework::convertCharset($bodyar['html'],$bodyar['html_charset'],GE_CHARSET);
		}
		$sqlArchiv['FullHeader']=imap_fetchheader($this->_ms,$mid,FT_INTERNAL|FT_UID);
		if ($this->getCfg('cfg/archiv/path')) {
			$archivPath=strftime($this->getCfg('cfg/archiv/path'),$Mobj->getMeta('Date'));
			$trasArray=array(
				'{MAIL_UID}'=>$mid,
				'{MAIL_BOX}'=>$fullBox,
				'{MAIL_USER}'=>$this->getUserName(),
				'{USER_ID}'=>$this->_frm->getUser(),
			);
			$archivPath=strtr($archivPath,$trasArray);
			if(substr($archivPath, -1) == "/") $archivPath = substr($archivPath, 0, -1);

			if (!file_exists($archivPath) || !is_dir($archivPath)) {
				mkdir($archivPath,0700,true);
			}
			if (file_exists($archivPath) && is_writable($archivPath)) {
				$sqlArchiv['ID']=$this->_db->nextid('Mail_Archiv');
				$sqlArchiv['ArchivPath']=$archivPath.'/'.$sqlArchiv['ID'].'.eml';

				$fp=fopen($sqlArchiv['ArchivPath'],'w+');
				fwrite($fp,trim($sqlArchiv['FullHeader'])."\r\n");
				fwrite($fp,'X-Archiv-ID: '.$sqlArchiv['ID']."\r\n"."\r\n");
				fwrite($fp,imap_body($this->_ms ,$mid,FT_INTERNAL|FT_UID));
				fclose($fp);

				if ($this->getCfg('cfg/archiv/enable_d3')) {

					$dom = new DOMDocument('1.0', 'iso-8859-1');
					$xml_mail=$dom->appendChild($dom->createElement("e-mail"));

					$xml_mail_header = $xml_mail->appendChild($dom->createElement("e-mail-header"));
					$xml_mail_header->appendChild($dom->createElement("Date"))->appendChild($dom->createCDATASection(Framework::convertCharset(date('r',$Mobj->getMeta('Date')),GE_CHARSET,'UTF-8')));
					$xml_mail_header->appendChild($dom->createElement("From"))->appendChild($dom->createCDATASection(Framework::convertCharset($sqlArchiv['MailFrom'],GE_CHARSET,'UTF-8')));
					$xml_mail_header->appendChild($dom->createElement("To"))->appendChild($dom->createCDATASection(Framework::convertCharset($sqlArchiv['MailTo'],GE_CHARSET,'UTF-8')));
					$xml_mail_header->appendChild($dom->createElement("Cc"))->appendChild($dom->createCDATASection(Framework::convertCharset($sqlArchiv['MailCc'],GE_CHARSET,'UTF-8')));
					$xml_mail_header->appendChild($dom->createElement("Subject"))->appendChild($dom->createCDATASection(Framework::convertCharset($sqlArchiv['Subject'],GE_CHARSET,'UTF-8')));
					$xml_mail_header->appendChild($dom->createElement("X-Archive-ID"))->appendChild($dom->createCDATASection($sqlArchiv['ID']));

					$xml_mail_body = $xml_mail->appendChild($dom->createElement("e-mail-body"));
					$xml_mail_body->appendChild($dom->createElement("body-text"))->appendChild($dom->createCDATASection(Framework::convertCharset($sqlArchiv['TextBody'],GE_CHARSET,'UTF-8')));
					$xml_mail_body->appendChild($dom->createElement("body-html"))->appendChild($dom->createCDATASection(Framework::convertCharset($bodyar['html'],$bodyar['html_charset'],'UTF-8')));

					$xml_mail_user = $xml_mail->appendChild($dom->createElement("group-e-username"));
					$xml_mail_user->appendChild($dom->createCDATASection(Framework::convertCharset($this->getUserName(),GE_CHARSET,'UTF-8')));

					$fp=fopen($archivPath.'/'.$sqlArchiv['ID'].'.xml','w+');
					fwrite($fp,$dom->saveXML());
					//fwrite($fp,iconv("ISO-8859-1//", "ISO-8859-1//IGNORE", $dom->saveXML()));
					fclose($fp);
					//echo $dom->saveXML();

				}
			} else {
				return array('server'=>'No Archiv path defined or no write permissions');
			}
		}
		if (!$sqlArchiv['ID']) {
			$sqlArchiv['ID']=$this->_db->nextid('Mail_Archiv');
		}
		$sqlArchiv['Attachments']=serialize($sqlArchiv['Attachments']);
		$this->_db->insert('Mail_Archiv',$sqlArchiv);

		return false;
	}



}
?>
