<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class MailDecode {
	var $_mime=array(
		"text",
        "multipart",
        "message",
        "application",
        "audio",
        "image",
        "video",
        "other",
	);
	var $_enc=array(
		"7bit",
        "8bit",
        "binary",
        "base64",
        "quoted-printable",
        "other",
	);
	function MailDecode(&$Mail) {
		$this->_Mail=&$Mail;
	}
	function _parseMessage(&$mimeobj, $partno='0') {
        static $mimear;
        if ($partno=='0') {
			$mimear=array();
			$mno='';
			if (!isset($mimeobj->parts)) $partno='1';
        } else $mno=$partno.'.';

        if (!isset( $mimear[$partno])) {
			$mimear[$partno]=array(
					"section"=>$partno,
					"type"=>$this->MimeType($mimeobj->type),
					"subtype"=>$mimeobj->subtype,
					"enc"=>$this->MimeEncoding($mimeobj->encoding),
					"size"=>$mimeobj->bytes,
					"disposition"=>$mimeobj->disposition,
					"name"=>$mimeobj->dparameters[0]->value,
					"id"=>$mimeobj->id,
			);
			if ($mimeobj->ifparameters) {
				foreach ($mimeobj->parameters as $param) {
					$mimear[$partno][strtolower($param->attribute)]=$param->value;
				}

			}
        }
      	if ($mimeobj->type == TYPEMESSAGE  && count($mimeobj->parts[0]->parts)>0) {
			$this->_parseMessage($mimeobj->parts[0], $partno);
        } else {
			if (sizeof($mimeobj->parts) > 0) {
				foreach ($mimeobj->parts as $count=>$p) {
					if ($mimeobj->type == TYPEMESSAGE && $mimeobj->encoding==3) continue;
					$this->_parseMessage($p, $mno.($count+1));
				}
			}
        }
        return $mimear;
	}

	function MimeType($type){
        return $this->_mime[$type];
	}

	function MimeEncoding($type){
         return $this->_enc[$type];
	}
	function getBody($box,&$mobj,$decode=1,$no_seen=false,$no_img_clean=false) {
		//debug($mobj->getMeta('Structure'));
      	$mimear=$this->_parseMessage($mobj->getMeta('Structure'));
		$mailar=array();
		//debug($mimear);
		//exit;
		//debug($mimear[0]['type']."/".$mimear[0]['subtype']);
		if(preg_match("/text\/plain/i",$mimear[0]['type']."/".$mimear[0]['subtype'])){
			$mailar['text'] = $this->_Mail->decode($this->_Mail->fetchBody($box, $mobj->getID(),1,$no_seen),$mimear[0]['charset'],$mimear[0]['enc']);
        } elseif(preg_match('/^text\/html$/i',$mimear[0]['type']."/".$mimear[0]['subtype'])){
			$mailar['html'] = $this->_Mail->decode($this->_Mail->fetchBody($box, $mobj->getID(),1,$no_seen),$mimear[0]['charset'],$mimear[0]['enc'],$decode);
			$mailar['html_charset']=$mimear[0]['charset'];
			//debug($mimear[0]);
        } else {
			foreach($mimear as $var){
				//debug($var);
				$temp=array();
				if ($var['name'] && preg_match('/\.((tar.)?[a-zA-Z0-9]*)$/i',$var['name'],$temp)) {
					switch($temp[1]) {
						case 'pdf':
							$var['type']='application';
							$var['subtype']='pdf';
						break;
					}
				}
				if(preg_match("/multipart\/alternative/i",$var['type']."/".$var['subtype'])) {
					$mailar['alt']=1;
					//Es gibt bereits einen Textteil;
					if (isset($mailar['text'])) {
						//$mailar['html']='<p>'.$mailar['text'].'</p>';
					}
				} elseif(preg_match("/multipart\/REPORT/i",$var['type']."/".$var['subtype'])) {
					$mailar['report']=1;
				} elseif(preg_match("/multipart/i",$var['type'])) {
					continue;
				} elseif(preg_match("/MS-TNEF/i",$var['subtype']) && $this->_Mail->getCfg('cfg/tnef')) {
					if ($tmp=$this->_Mail->parseTnef($box,$mobj->getID(),$var['section'],$var['enc'],0)) {
						$mailar['att']=$tmp;
					} else {
						if (!$var['name']) $var['name']='no_name';
						$mailar['att'][$var['section']]=array('id'=>$var['id'],'name'=>$this->_Mail->mail_enc($var['name']),'size'=>$var['size'],'type'=>$var['type']."/".$var['subtype'],'enc'=>$var['enc'],'part'=>$var['section'],'att'=>1);
					}
				} elseif(preg_match("/attachment/i",$var['disposition'])) {
					if (!$var['name']) $var['name']='no_name';
					$mailar['att'][$var['section']]=array('id'=>$var['id'],'name'=>$this->_Mail->mail_enc($var['name']),'size'=>$var['size'],'type'=>$var['type']."/".$var['subtype'],'enc'=>$var['enc'],'part'=>$var['section'],'att'=>1);
				} elseif(preg_match("/text\/plain/i",$var['type']."/".$var['subtype'])) {
					if ($mailar['report'] && !$mailar['text']) {
						$mailar['report_txt']=$this->_Mail->decode($this->_Mail->fetchBody($box, $mobj->getID(),$var['section'],$no_seen),$var['charset'],$var['enc']);
					}
					if ($mailar['text']) {
						$mailar['text'].="\n\n";
					}
					$mailar['text'].=$this->_Mail->decode($this->_Mail->fetchBody($box, $mobj->getID(),$var['section'],$no_seen),$var['charset'],$var['enc']);
					if ($var['name']) $mailar['att'][$var['section']]=array('id'=>$var['id'],'name'=>$this->_Mail->mail_enc($var['name']),'size'=>$var['size'],'type'=>$var['type']."/".$var['subtype'],'enc'=>$var['enc'],'part'=>$var['section'],'att'=>1);
					//debug($mailar['text']);
				} elseif(preg_match('/^text\/html$/i',$var['type']."/".$var['subtype'])) {
					//echo $var['section'];
					$mailar['html'].=$this->_Mail->decode($this->_Mail->fetchBody($box, $mobj->getID(),$var['section'],$no_seen),$var['charset'],$var['enc'],$decode);
					//debug($this->_Mail->fetchBody($box, $mobj->getID(),$var['section'],$no_seen));
					//debug($var);exit;
					$mailar['html_charset']=$var['charset'];
				} elseif(preg_match("/message\/delivery-status/i",$var['type']."/".$var['subtype'])) {
					$mailar['status'].=$this->_Mail->decode($this->_Mail->fetchBody($box, $mobj->getID(),$var['section'],$no_seen),$var['charset'],$var['enc']);
				} elseif(preg_match("/text\/CALENDAR/i",$var['type']."/".$var['subtype'])) {
					$mailar['cal'][$var['section']]=array(
						'part'=>$var['section'],
						'method'=>$var['method'],
						'enc'=>$var['enc'],
						'charset'=>$var['charset'],
					);
				} else  {
					if (!$var['name']) $var['name']='no_name';
					$mailar['att'][$var['section']]=array('id'=>$var['id'],'name'=>$this->_Mail->mail_enc($var['name']),'size'=>$var['size'],'type'=>$var['type']."/".$var['subtype'],'enc'=>$var['enc'],'part'=>$var['section'],'att'=>0);
				}
			}
        }
        if(!$no_img_clean && $mailar['att'] && $mailar['html']){
			foreach($mailar['att'] as $key=>$var){
				//debug($var);
				$tmpID=str_replace('<','',$var['id']);
				$tmpID=str_replace('>','',$tmpID);
				if ($tmpID && !preg_match('/cid:'.preg_quote($tmpID,'/').'/i',$mailar['html'])) {
					//debug($tmpID);
					$mailar['att'][$key]['id']='';
				}
			}
		}
		//debug($mailar);
		return $mailar;
	}
}
?>
