<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class SieveDB {
	var $db;
	var $uid;
	var $uname;
	var $_alias;
	var $Operators=array(
		'C'=>':contains ["%s"] ["%s"]',
		'I'=>':is ["%s"] ["%s"]',
		'E'=>'exists ["%s"]',
		'G'=>':over %dK',
		'S'=>':under %dK',
	);
	var $require=array();
	function SieveDB(&$db) {
		$this->uid=$GLOBALS['auth']->auth['uid'];
		$this->db=&$db;
		$this->DBTYPE=$GLOBALS['CFG']["DATABASE_TYPE"];
	}
	function setAliasObj(&$alias) {
		$this->_alias=&$alias;
	}
	function setUid($uid) {
		$this->uid=$uid;
	}
	function setUname($uname) {
		$this->uname=$uname;
	}
	function saveFilter($script,$ID,$Name,$Activ,$filter,$faction,$require) {
		if ($ID) {
			$query="UPDATE Mail_Filter SET FilterName='".addslashes($Name)."',ScriptID='".addslashes($script)."',FilterActiv=".intval($Activ);
			$query.=",Filter='".addslashes(serialize($filter))."',Faction='".addslashes(serialize($faction))."'";
			$query.=",	TimeModify=".time();
			$query.=", `Require`='".addslashes($require)."'";
			$query.=", ScriptID='".addslashes($script)."'";
			$query.=" WHERE FilterID=".intval($ID)." AND FilterUser='".$this->uid."'";
		} else {
			$ID=$this->db->nextid('Mail_Filter');
			$query="INSERT INTO Mail_Filter (FilterID,ScriptID,FilterName,FilterUser,FilterActiv,Filter,Faction,TimeCreate,TimeModify,Sequence,`Require`) VALUES ";
			$query.="($ID,'".addslashes($script)."','".addslashes($Name)."','".$this->uid."','".intval($Activ)."'";
			$query.=",'".addslashes(serialize($filter))."','".addslashes(serialize($faction))."',".time().",".time().",$ID";
			$query.=",'".addslashes($require)."')";
		}
		//echo $query;
		 $this->db->query($query);
		 return $ID;

	}
	function saveScript($ID,$Name,$user_id) {
		if ($ID) {
			$query="UPDATE Mail_Script SET ScriptName='".addslashes($Name)."'";
			$query.=" WHERE ScriptID=".intval($ID)." AND ScriptUser='".$user_id."'";
		} else {
			$ID=$this->db->nextid('Mail_Script');
			$query="INSERT INTO Mail_Script (ScriptID,ScriptName,ScriptUser) VALUES ";
			$query.="($ID,'".addslashes($Name)."','".$this->uid."')";
		}
		$this->db->query($query);
		return $ID;
	}
	function readFilter($ID) {
		$query="SELECT * FROM Mail_Filter WHERE FilterID=".intval($ID)." AND FilterUser='".$this->uid."'";
		$this->db->query($query);
		if ($this->db->next_record()) {
			$obj['filter']=unserialize($this->db->f('Filter'));
			$obj['faction']=unserialize($this->db->f('Faction'));
			$obj['filter_name']=$this->db->f('FilterName');
			$obj['filter_activ']=$this->db->f('FilterActiv');
			$obj['filter_user']=$this->db->f('FilterUser');
			$obj['TimeCreate']=$this->db->f('TimeCreate');
			$obj['TimeModfiy']=$this->db->f('TimeModfiy');
			$obj['Sequence']=$this->db->f('Sequence');
			$obj['ScriptID']=$this->db->f('ScriptID');
			return $obj;
		}  else return 0;
	}

	function deleteFilter($ID) {
		$query="DELETE FROM Mail_Filter WHERE FilterID=".intval($ID)." AND FilterUser='".$this->uid."'";
		$this->db->query($query);
	}
	function deleteScript($ID) {
		$filters=$this->getFilters($script);
		if (!count($filters)) {
			$query="DELETE FROM Mail_Script WHERE ScriptID=".intval($ID)." AND ScriptUser='".$this->uid."'";
			$this->db->query($query);
		}
	}
	function getFilters($script) {
		$result=array();
		$query="SELECT ScriptID,FilterID,FilterName,FilterActiv,Sequence FROM Mail_Filter WHERE FilterUser='".$this->uid."' ";
		$query.="AND ScriptID='".addslashes($script)."' ORDER BY Sequence";
		$this->db->query($query);
		while($this->db->next_Record()) {
			$result[$this->db->f('FilterID')]=array(
				'Name'=>$this->db->f('FilterName'),
				'Activ'=>$this->db->f('FilterActiv'),
				'Sequence'=>$this->db->f('Sequence'),
				'ScriptID'=>$this->db->f('ScriptID'),
			);

		}
		return $result;
	}
	function getScripts() {
		$result=array();
		$query="SELECT * FROM Mail_Script WHERE ScriptUser='".$this->uid."' ";
		$query.=" ORDER BY ScriptName";
		$this->db->query($query);
		while($this->db->next_Record()) {
			$result[$this->db->f('ScriptID')]=$this->db->f('ScriptName');
		}
		return $result;
	}

	function SwitchEntry ($oID,$dir='down') {
		$this->db->query("SELECT Sequence,ScriptID FROM Mail_Filter WHERE FilterID=".intval($oID)." AND FilterUser='".$this->uid."'");
		$this->db->next_record();
		$oSequence=$this->db->f('Sequence');
		$script=$this->db->f('ScriptID');
		if ($dir=='up'){
			$sign='<';
			$order='DESC';
		}elseif ($dir=='down') {
			$sign='>';
			$order='ASC';
		} elseif ($dir=='first') {
			$where="";
			$sign='<';
			$order='ASC';
		}
		$this->db->query("SELECT FilterID,Sequence  FROM Mail_Filter WHERE Sequence $sign ".intval($oSequence)." AND FilterUser='".$this->uid."' AND ScriptID='".addslashes($script)."' ORDER BY Sequence $order LIMIT 1");
		if ($this->db->next_record()) {
			$nID=$this->db->f('FilterID');
			$nSequence=$this->db->f('Sequence');
			$this->db->query("UPDATE Mail_Filter SET Sequence='".($nSequence)."' WHERE FilterID=".intval($oID)." AND FilterUser='".$this->uid."'");
			if ($dir=='first') {
				$this->db->query("UPDATE Mail_Filter SET Sequence=Sequence+1 WHERE Sequence<".intval($oSequence)." AND FilterID!=".intval($oID)." AND FilterUser='".$this->uid."' AND ScriptID='".addslashes($script)."'");
			} else {
				$this->db->query("UPDATE Mail_Filter SET Sequence='".intval($oSequence)."' WHERE FilterID=".intval($nID)." AND FilterUser='".$this->uid."' AND ScriptID='".addslashes($script)."'");
			}
			return ($script);
		}
		return 0;

	}

	function generateScript($scriptname,$user_id,$username='') {
		$require=array();

		if (!is_array($scriptname)) $load_scripts=array($scriptname);
		else $load_scripts=$scriptname;
		unset($scriptname);

		foreach ($load_scripts as $scriptname) {
			$query="SELECT FilterID,FilterName,SieveCode,`Require`,Filter,Faction FROM Mail_Filter WHERE FilterUser='".$user_id."' AND FilterActiv=1 AND ScriptID='".addslashes($scriptname)."' ORDER BY Sequence";
			$this->db->query($query);
			while($this->db->next_Record()) {
				if ($this->db->f('Require')) {
					$temp=explode(',',$this->db->f('Require'));
					foreach($temp as $val) $require[$val]=1;
				}
				$script.="## Filter ID:".$this->db->f('FilterID')." Name:".$this->db->f('FilterName')."\n";
				$script.=$this->getScript(unserialize($this->db->f('Filter')),unserialize($this->db->f('Faction')));
			}
		}
		if ($script) {
			$script_head="## Filter for userid:".$user_id." username:$username script:".implode(',',$load_scripts)."\n\n";
			foreach (array_keys($require) as $val) {
				$script_head.="require \"$val\";\n";
			}
			return $script_head."\n".$script;
		} else return 0;
	}
	function generatePhpScript($scriptname,$user_id) {
		$query="SELECT  FilterID,FilterName,PhpCode,`Require`,Filter,Faction FROM Mail_Filter WHERE FilterUser='".$user_id."' AND FilterActiv=1 AND ScriptID='".addslashes($scriptname)."' ORDER BY Sequence";
		$this->db->query($query);
		while($this->db->next_Record()) {
			$script.="## Filter ID:".$this->db->f('FilterID')." Name:".$this->db->f('FilterName')."\n";
			$script.=$this->getPhpScript(unserialize($this->db->f('Filter')),unserialize($this->db->f('Faction')));
		}
		if ($script) {
			return '$result=array();'."\n".$script."\n".'return $result;'."\n";
		} else return 0;
	}
	function getScript($filter=0,$faction=0) {
		//$this->debug($filter);
		$text='';
		$where=array();
		if (is_array($faction)) {
			if ($faction['match']!='NONE' && is_array($filter)) {
				foreach ($filter as $id=>$val) {
					if (!$val['test']) continue;
					if ($val['test'][0]=='N') {
						$tmp_txt='not ';
						$val['test']=substr($val['test'],1);
					} else {
						$tmp_txt='';
					}
					$operator=$this->Operators[$val['test']];
					switch ($val['key']) {
						case 'Subject':
							$field='header ';
							if ($val['test']=='E') $field='';
							$where[]=$tmp_txt.$field.sprintf($operator,'Subject',$this->getValue($val['value']));
							break;
						case 'From':
							$field='address ';
							if ($val['test']=='E') $field='';
							$where[]=$tmp_txt.$field.sprintf($operator,'From',$this->getValue($val['value']));
							break;
						case 'To':
							$field='address ';
							if ($val['test']=='E') $field='';
							$where[]=$tmp_txt.$field.sprintf($operator,'To","TO',$this->getValue($val['value']));
							break;
						case 'Cc':
							$field='address ';
							if ($val['test']=='E') $field='';
							$where[]=$tmp_txt.$field.sprintf($operator,'Cc","CC',$this->getValue($val['value']));
							break;
						case 'Bcc':
							$field='address ';
							if ($val['test']=='E') $field='';
							$where[]=$tmp_txt.$field.sprintf($operator,'Bcc","BCC',$this->getValue($val['value']));
							break;
						case 'Tc':
							$field='address ';
							if ($val['test']=='E') $field='';
							$where[]=$tmp_txt.$field.sprintf($operator,'To","TO","Cc","CC","Bcc","BCC',$this->getValue($val['value']));
							break;
						case 'header':
							$field='header ';
							if ($val['test']=='E') $field='';
							$where[]=$tmp_txt.$field.sprintf($operator,$this->getValue($val[value1]),$this->getValue($val['value']));
							break;
						case 'size':
							$field='size ';
							if ($val['test']=='E') $field='';
							$where[]=$tmp_txt.$field.sprintf($operator,$this->getValue($val['value']));
							break;
					}
				}
				if (count($where)>1) {
					if ($faction['match']=='ONE') {
						$text.="if anyof (".implode(',',$where).") {\n";
					} else {
						$text.="if allof (".implode(',',$where).") {\n";
					}
				} else {
					$text.="if ".$where[0]." {\n";
				}
			}
			switch ($faction['key']) {
				case 'M':
					$text.="\t".'fileinto "'.Framework::convertCharset($this->getValue($faction['value'],0),GE_CHARSET,"UTF7-IMAP").'"'.";\n";
					break;
				case 'F':
					$text.="\t".'redirect "'.$this->getValue($faction['value'],0).'"'.";\n";
					break;
				case 'R':

					$text.="\t".'reject "'.$this->getValue($faction['value'],0).'"'.";\n";
					break;
				case 'D':
					$text.="\t".'discard'.";\n";
					break;
				case 'V':
					//debug($this->_alias);

					$text.="\t".'vacation :days '.intval($faction['value1']);

					$vmails=array();
					if (is_array($faction['value2']) && !empty($faction['value2'])) {
						foreach ($faction['value2'] as $vval) {
							$vmails[]='"'.$vval.'"';
						}
					}
					if (empty($vmails)) {
						$vmails=$this->getMyAliases();
					}
					if (is_array($vmails) && !empty($vmails)) $text.=' :addresses ['.implode(',',$vmails).']';
					$text.=' "';
					if (GE_CHARSET=='UTF-8') {
						$text.=$this->getValue($faction['value'],0);
					} else {
						$text.=Framework::convertCharset($this->getValue($faction['value'],0),GE_CHARSET,'UTF-8');
					}
					$text.='"'.";\n";
					//debug($text);
					break;
			}
			if ($faction['keep']) {
				$text.="\t".'keep'.";\n";
			}
			if ($faction['stop']) {
				$text.="\t".'stop'.";\n";
			}
			if ($faction['match']!='NONE') $text.="}\n";
			//var_Dump($obj[faction]);


		}
		return $text;
	}
	function getMyAliases() {
		if (is_object($this->_alias)) {
			$valias=$this->_alias->get_alias_list_user($this->uname);
			if (!is_array($valias) || empty($valias)) $valias=array(array('alias'=>$this->uname));
			if ($this->_alias->Mail->getCfg('cfg/sieve/domain')) {
				$all_domain=explode(',',$this->_alias->Mail->getCfg('cfg/sieve/domain'));
			} else {
				$all_domain=array($this->_alias->Mail->getCfg('cfg/domain'));
			}
			if (is_array($valias)) {
				foreach ($all_domain as $domain) {
					if (strpos($domain,'@')===false) {
						$domain='@'.$domain;
					}
					foreach ($valias as $vval) {
						if (strpos($vval['alias'],'@')===false && $domain!='@') {
							$vmails[]='"'.$vval['alias'].$domain.'"';
						} else {
							$vmails[]='"'.$vval['alias'].'"';
						}
					}
				}
			}
		}
		return array_unique($vmails);


	}
	function getValue($string,$mult=1) {
		$string=str_replace("\\","\\\\",$string);
		$string=str_replace('"',"\\\\".'"',$string);
		if ($mult) $string=str_replace(',','","',$string);
		return $string;
	}
	function getPhpValue($string) {
		$string=str_replace("'","\'",$string);
		return $string;
	}
	function getPregValue($string,$mult=1) {
		if ($mult) {
			$tmp=explode(',',$string);
			foreach ($tmp as $key=>$val) {
				$tmp[$key]= '('.preg_quote($val,'/').')';
			}
			return implode('|',$tmp);
		}
		return '('.preg_quote($string,'/').')';
	}

	function getPhpScript($filter=0,$faction=0) {
		$text='';
		$where=array();

		if (is_array($faction)) {
			if ($faction['match']!='NONE' && is_array($filter)) {
				foreach ($filter as $id=>$val) {
					if (!$val['test']) continue;
					$field_txt=array();
					$fields=array();
					if ($val['test'][0]=='N') {
						$tmp_txt='!';
						$val['test']=substr($val['test'],1);
					} else {
						$tmp_txt='';
					}

					if ($val['key']=='header') {
						$tmp_fields=explode(',',$val['value1']);
						foreach ($tmp_fields as $tmp_field) {
							$fields[]='$header[\''.$this->getPhpValue($tmp_field).'\']';
						}
					} elseif ($val['key']=='tc') {
						$fields=array(
							'$header[\'To\']',
							'$header[\'Cc\']',
							'$header[\'Bcc\']',
						);
					} else {
						$fields=array(
							'$header[\''.$val['key'].'\']',
						);
					}

					if ($val['test']=='C') {
						foreach ($fields as $field) {
							$field_txt[]='preg_match(\'/'.$this->getPregValue($val['value']).'/i\','.$field.')';
						}
						$where[]=$tmp_txt.'('.implode (' || ',$field_txt).')';
					}
					if ($val['test']=='I') {
						foreach ($fields as $field) {
							$field_txt[]='preg_match(\'/^'.$this->getPregValue($val['value']).'$/i\','.$field.')';
						}
						$where[]=$tmp_txt.'('.implode (' || ',$field_txt).')';
					}
					if ($val['test']=='E') {
						foreach ($fields as $field) {
							$field_txt[]='isset('.$field.')';
						}
						$where[]=$tmp_txt.'('.implode (' || ',$field_txt).')';
					}
					if ($val['test']=='G') {
						foreach ($fields as $field) {
							$field_txt[]=$field.' > '.intval($val['value']);
						}
						$where[]=$tmp_txt.'('.implode (' || ',$field_txt).')';
					}
					if ($val['test']=='S') {
						foreach ($fields as $field) {
							$field_txt[]=$field.' < '.intval($val['value']);
						}
						$where[]=$tmp_txt.'('.implode (' || ',$field_txt).')';
					}
				}
				if (count($where)>1) {
					if ($faction['match']=='ONE') {
						$text.="if  (\n\t".implode("\n\t || ",$where)."\n) {\n";
					} else {
						$text .="if (\n\t".implode("\n\t && ",$where)."\n) {\n";
					}
				} else {
					$text.="if (\n\t".$where[0]."\n) {\n";
				}
			}

			switch ($faction['key']) {
				case 'M':
					$text.="\t".'$result[]=array(\'fileinto\',\''.$this->getPhpValue($faction[value]).'\',\''.intval($faction[keep]).'\');'."\n";
					break;
				case 'F':
					$text.="\t".'$result[]=array(\'redirect\',\''.$this->getPhpValue($faction[value]).'\',\''.intval($faction[keep]).'\');'."\n";
				break;
				/*
				case 'R':
					$text.="\t".'$result[]=array(\'reject\',\''.$this->getPhpValue($faction[value]).'\',\''.intval($faction[keep]).'\');'."\n";
				break;*/
				case 'D':
					$text.="\t".'$result[]=array(\'discard\',\'0\',\'0\');'."\n";
				break;
			}

			if ($faction[stop]) {
				$text.="\t".'return $result;'."\n";
			}
			if ($faction[match]!='NONE') $text.="}\n";
			//var_Dump($obj[faction]);


		}
		return $text;
	}

	function filterMbox(&$Mail,$scriptname,$user_id,$mbox,$trash='') {
		if ($script=$this->generatePhpScript($scriptname,$user_id)) {
			$akt_date=time();
			//$this->debug($script);
			$rows=0;
			$mails=$Mail->listMails($rows,$mbox);
			foreach ($mails as $mid=>$mobj) {
				$header=$Mail->parseFullHeader($mbox,$mid);
				$header['size']=round($mobj->getMeta('Size')/1024);
				$header['days']=intval(($akt_date-$mobj->getMeta('Date'))/(3600*24));
				$header['status']=($mobj->getMeta('New'))?'unread':'read';

				$action=eval($script);
				$keep=0;
				$toTrash=0;
				//debug($header);
				//debug($action);
				if (is_array($action) && count($action)) {
					foreach ($action as $todo) {
						switch ($todo[0]) {
							case 'fileinto':
								if ($todo[2]) $keep=1;
								if ($todo[1]!=$mbox) {
									if ($Mail->copyMail($mbox,$mid,$todo[1])) $keep=1;
								} else $keep=1;
								break;
							case 'discard':
								if ($trash && $trash!=$mbox ) {
									if ($Mail->copyMail($mbox,$mid,$trash)) $keep=1;
								} elseif ($trash) $keep=1;
								break;
							default:
								$keep=1;
								break;
						}
					}
					if (!$keep) {
						if (!$Mail->deleteMail($mbox,$mid)) {
							$Mail->expungeBox($mbox);
						}
					}
				}
			}
		}

	}
	function debug($string) {
		echo '<pre>';
		if (is_array($string)) $string=$string;
		else $string=Framework::entities($string);
		echo var_dump($string);
		echo '</pre>';

	}
	function deleteUser($user_id) {
		$query="DELETE FROM Mail_Filter WHERE FilterUser='".addslashes($user_id)."'";
		$this->db->query($query);
		$query="DELETE FROM Mail_Script WHERE ScriptUser='".addslashes($user_id)."'";
		 $this->db->query($query);
	}
}
?>
