<?php
class MailIcalGui {
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_uid=0;
	var $_cardPrefs=array('ical'=>true,'attendee'=>true,'gmdate'=>1,'allDayMode'=>1);
	function MailIcalGui() {
		global $frm,$t,$T,$E,$L,$P;
		$this->_T=&$T;
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_P=&$P;
		$this->_T->loadModul('mail');
	}
	function initCal() {
		if (!$this->_initCal) {
			require_once ("lib/cal/ClassVcalWrite.php");
			require_once ("lib/cal/ClassVcalParse.php");
			require_once ("lib/cal/ClassVcal.php");
			$this->_Vcal=new Vcal();
			$this->_Vcal->setUser($this->_frm->getUser());
			$this->_Vcal->setLang($this->_frm->getLang());
			$this->_Vcal->setPrefs('cal',$this->_cardPrefs);
			$this->_VcalParse= new VcalParse();
			$this->_VcalParse->setPrefs('cal',$this->_cardPrefs);
			$this->_VcalWrite= new VcalWrite();
			$this->_VcalWrite->setPrefs('cal',$this->_cardPrefs);
			$this->_initCal=true;
		}
	}
	function initMail() {
		if (!$this->_initMail) {
			require_once("lib/mail/classMailDecode.php");
			$this->_Base=& $this->_frm->getStaticModul('mail');
			$this->_BaseDec=new MailDecode($this->_Base);
			$this->_Base->init($this->_uid);
			$this->_Base->setPrefs($this->_frm->getPrefs('email'));
			$this->_initMail=true;
		}
	}
	function parseCard($box,$mid,$part,$cardNum=0) {
		$this->initMail();
		$this->initCal();
		$Mobj=$this->_Base->getMailObj($box,$mid);
		if (is_object($Mobj)) {
			$bodyar=$this->_BaseDec->getBody($box,$Mobj);
			if ($bodyar['cal'][$part]) {
				return $this->parseCardText($this->_Base->getAttachment($box, $Mobj->getID(),$part,$bodyar['cal'][$part]['enc']),$cardNum);
			}
		}
		return false;
	}
	function parseCardText($text,$cardNum=0) {
		$this->initCal();
		$card=$this->_VcalParse->fromText($text);
		if ($cardNum==-1) {
			$result=array();
			foreach ($card as $num=>$subCard) {
				if ($subCard['X-GROUP-E-TYP']['value'][0]=='VEVENT') {
					$result[$num]=$this->_Vcal->vcal2event($subCard,true);
				}
			}
			return empty($result)?false:$result;

		} elseif ($card[$cardNum] && $card[$cardNum]['X-GROUP-E-TYP']['value'][0]=='VEVENT') {
			return $this->_Vcal->vcal2event($card[$cardNum],true);
		}
		return false;
	}
	function findIdentity(&$calObj) {
		$this->initMail();
		if (is_array($calObj['cardInvitUsers'])) {
			foreach ($calObj['cardInvitUsers'] as $invitUser) {
				for($i=1; $i<6; $i++) {
					if ($this->_Base->getPrefs("email".$i)==$invitUser['mail']) {
						return $i;
					}
				}
			}
		}
		if ($this->_Base->getPrefs("defuse")) return $this->_Base->getPrefs("defuse"); else return 1;
	}
	function &createCard(&$calObj,$method='REQUEST',$iv_users=array(),$org_users=array()) {
		$this->initCal();
		$globalCard=array(
			'PRODID'=>array(
				'value'=>'-//Endo7 GmbH//GROUP-E Collaboration Software//EN',
			),
			'VERSION'=>array(
				'value'=>'2.0',
			),
			'CALSCALE'=>array(
				'value'=>'GREGORIAN',
			),
			'METHOD'=>array(
				'value'=>$method,
			),
		);
		$this->_VcalWrite->setGlobalCard($globalCard);
		$tmpCard=$this->_Vcal->event2vcal($calObj,$iv_users,$org_users);
		if ($method=='REPLY') {
			unset($tmpCard['STATUS']);
		}
		return $this->_VcalWrite->getVcal($tmpCard,'VEVENT','2.0');
	}
	function sendCard($identity,$CardTxt,$To,$Subject,$Body,$Fname='invite.ics',$Method='REQUEST') {
		$this->initMail();
		$CardFile=$this->_Base->getAttachPath()."/".$Fname;
		$fp=fopen($CardFile,'w');
		fwrite($fp,$CardTxt);
		fclose($fp);

		require_once('lib/mail/mimePart.php');
		require_once('lib/mail/mime.php');
		$personal=$this->_Base->getPrefs("fullname".$identity);
		$mailbox=substr($this->_Base->getPrefs("email".$identity),0,strpos($this->_Base->getPrefs("email".$identity),'@'));
		$host=substr($this->_Base->getPrefs("email".$identity),strpos($this->_Base->getPrefs("email".$identity),'@')+1);
		if ($this->_Base->getPrefs("replyto".$identity)) $replyto=$this->_Base->getPrefs("replyto".$identity); else $replyto=$this->_Base->getPrefs("email".$identity);
		$smail=new Mail_mime($GLOBALS['CFG']['NL_MAIL']);
		$params=array(
			'text_encoding'=>'8bit',
			'html_charset'=>GE_CHARSET,
			'text_charset'=>GE_CHARSET,
			'head_charset'=>GE_CHARSET,
		);
		$headers=array(
			'From'=>imap_rfc822_write_address($mailbox,$host,$personal),
			'Subject'=>$Subject?$Subject:'no subject',
			'Reply-To'=>$replyto,
			//'To'=>$To,
			'X-Priority'=>'3 (Normal)',
		);
		$smail->addAttachment( $CardFile, 'application/ics');
		$smail->addAlternativeContent($CardTxt,'text/calendar','7bit','UTF-8',$Method);
		$smail->setTXTBody($Body);      // set the body

		$snd_body = $smail->get($params);
		$snd_hdrs = $smail->headers($headers);
		$subject=$snd_hdrs['Subject'];
		unset($snd_hdrs['Subject']);
		if (mail( $To,$subject,$snd_body,$this->_Base->headersToTxt($snd_hdrs,$GLOBALS['CFG']['NL_MAIL']),'-f'.imap_rfc822_write_address($mailbox,$host,''))) {
			$this->_Base->deleteAttachment();
			return true;
		}
	}
	function getCalText(&$calObj,$mode,$log_tras,$addInvit=false) {
		$Cal=& $this->_frm->getStaticModul('cal');
		$this->_T->loadModul('cal');
		if (!$log_tras['{EDATE}']) $log_tras['{EDATE}']=$Cal->formatDate($calObj['StartDate'],$calObj['EndDate'],$calObj['TimeMode']);
		if (!$log_tras['{ETITLE}']) $log_tras['{ETITLE}']=trim($calObj['Title']);
		if (!$log_tras['{EPLACE}']) $log_tras['{EPLACE}']=trim($calObj['Place']);
		if (!$log_tras['{ETEXT}']) $log_tras['{ETEXT}']=trim($calObj['Text']);
		if (!$log_tras['{TEXT}']) $log_tras['{TEXT}']='';

		if ($addInvit && !$log_tras['{EUSER}']) {
			$InvitGroups=explode(',',$calObj['InvitGroups']);
			$InvitUsers=explode(',',$calObj['InvitUsers']);
			$i_users=array_unique(array_merge($this->_frm->getGroupUsers($InvitGroups),$InvitUsers,array($calObj['OwnerID'])));
			$iv_users=$this->_frm->getFullName($i_users);
			if ($calObj['InvitAddr']) {
				$Addr=& $this->_frm->getStaticModul('addr');
				$InvitAddr=explode(',',$calObj['InvitAddr']);
				foreach ($InvitAddr as $val) {
					if ($address=$Addr->getAddrObj($val)) {
						$iv_users[]=$address->getName(1);
					}
				}
			}
			if (!is_array($iv_users)) $iv_users=array();
			$log_tras['{EUSER}']=implode(', ',$iv_users);
		}
		//debug($this->_T->lang('[[action_'.$mode.'_title]]'));
		return array(
			'subject'=>strtr($this->_T->lang('[[action_'.$mode.'_title]]'),$log_tras),
			'body'=>strtr($this->_T->lang('[[action_'.$mode.'_text]]'),$log_tras),
		);
	}
	function sendReply($mode,$box,$mid,$part,$cardNum=0,$message='') {
		 if (!$box || !$mid || !$part) return false;
		 $calObj=$this->parseCard($box,$mid,$part,$cardNum=0);
		 if ($calObj) {
			if (!$calObj['cardOrganizer'] || !$calObj['cardOrganizer']['mail']) {
				$Mobj=$this->_Base->getMailObj($box,$mid);
				if (is_object($Mobj)) {
					$tmpFrom=$Mobj->getMail('From');
					$calObj['cardOrganizer']=array(
						'mail'=>$tmpFrom[0]->mailbox.'@'.$tmpFrom[0]->host,
						'name'=>$tmpFrom[0]->personal,
					);
				}
			}
			return $this->sendReplyFromObj($mode,$calObj,$message='');
		}
		return false;
	}
	function sendReplyFromObj($mode,&$calObj,$message='') {
		 if ($calObj && $calObj['cardOrganizer'] && $calObj['cardOrganizer']['mail']) {
			switch($mode) {
				case 'tentative':
					$mailText=$this->getCalText($calObj,'accept',array('{TEXT}'=>$message));
					$Fname='accept.ics';
					$calObj['Text']=$mailText['subject'];
					$status=3;
				break;
				case 'accept':
					$mailText=$this->getCalText($calObj,'accept',array('{TEXT}'=>$message));
					$Fname='accept.ics';
					$calObj['Text']=$mailText['subject'];
					$status=1;
				break;
				case 'deny':
					$mailText=$this->getCalText($calObj,'deny',array('{TEXT}'=>$message));
					$Fname='deny.ics';
					$calObj['Text']=$mailText['subject'];
					$status=2;
				break;
				default:
					return false;
				break;
			}
			$defIdentity=$this->findIdentity($calObj);
			$iv_users=array(array(
				'mail'=>$this->_Base->getPrefs("email".$defIdentity),
				'name'=>$this->_Base->getPrefs("fullname".$defIdentity),
				'status'=>$status,
				'rsvp'=>0,
			));

			//$calObj['AlarmTime']=0;
			$iCard=$this->createCard($calObj,'REPLY',$iv_users,$calObj['cardOrganizer']);

			return $this->sendCard($defIdentity,$iCard,$calObj['cardOrganizer']['mail'],$mailText['subject'],$mailText['subject'],$Fname,'REPLY');
		}
		return false;
	}
	function isCallable() {
		return true;
	}
	function processAjax($reqData) {
		switch ($reqData['action']) {
			case 'reply':
				if ($this->sendReply($reqData['mode'],$reqData['mbox'],$reqData['mid'],$reqData['part'],$reqData['num'],$reqData['message'])) {
					setAjaxData('alert','reply',$this->_T->lang('[[Benachrichtigungs E-Mail wurde versendet]]'));
				}
			break;
		}
	}
}
?>