<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class geMsgCtrlAjax{
	private $result;
	private $_frm;
	private $T;
	public function __construct() {
		global $frm,$T;
		$this->_frm=$frm;
		$this->_T=$T;
		$this->_Base=$this->_frm->getStaticModul('msg');
	}

	public function searchMsgAddress($search) {
		$result=array();
		if ($search['query_value']) {
			foreach(explode(',',$search['query_value']) as $val) {
				switch($val[0]) {
					case 'u';
						if ($tmp=$this->_frm->getCachedUserName(substr($val,2))) {
							$result[]=array(
								'name'=>$tmp,
								'value'=>$val,
								'img'=>'img/ge/user.gif',
							);
						}
					break;
					case 'g';
						if ($tmp=$this->_frm->getCachedGroupName(substr($val,2))) {
							$result[]=array(
								'name'=>$tmp,
								'value'=>$val,
								'img'=>'img/ge/gruppe.gif',
							);
						}
					break;
					case 'r';
						if ($tmp=$this->_frm->getCachedRuleName(substr($val,2))) {
							$result[]=array(
								'name'=>$tmp,
								'value'=>$val,
								'img'=>'img/ge/rolle.gif',
							);
						}
					break;
				}
			}
		} else {
			switch ($search['query']) {
				case '__GROUPS':
					$limit=0;
				break;
				case '__USERS':
					$limit=0;
				break;
				default:
					$limit=20;
				break;
			}
			if ($limit>0 || $search['query']=='__USERS') {
				$rows=0;
				$data=$this->_frm->searchUser($rows,$search['query']=='__USERS'?'':trim($search['query']),0,0,0,$limit,false,true);
				//debug($data);
				if (!empty($data)) {
					foreach ($data as $key=>$v) {
						$result[]=array(
							'name'=>$v['lastname'].' '.$v['firstname'],
							'value'=>'u_'.$key,
							'img'=>'img/ge/user.gif',
						);
						$limit--;
					}
				}
			}
			if ($limit>0 || $search['query']=='__GROUPS') {
				$data=$this->_frm->getAllGroups(0,0,$search['query']=='__GROUPS'?'':trim($search['query']),$limit);
				if (!empty($data)) {
					foreach ($data as $key=>$v) {
						$result[]=array(
							'name'=>$v,
							'value'=>'g_'.$key,
							'img'=>'img/ge/gruppe.gif',
						);
						$limit--;
					}
				}
			}
		}
		$this->result=$result;
	}

	public function sendMsgMessage($params) {
		$this->result=array(
			'error'=>'',
			'error_msg'=>'',
		);
		if (!$this->_frm->getMyApps('msg')) {
			$this->result['error']='MSG';
			$this->result['error_msg']=$this->_T->lang('[[Keine Berechtigung]]');
			return false;
		}
		$this->_T->loadModul('msg');

		$msg=new ObjMsgMessage();
		$msg->setMeta('msg_userid',$this->_frm->getUser());
		$msg->setMeta('msg_sendid',$this->_frm->getUser());
		$msg->setMeta('msg_from',$this->_frm->getCachedUsername($this->_frm->getUser()));
		$msg->setMeta('msg_subject',$params['msg_subject']);
		$msg->setMeta('msg_message',$params['msg_message']);
		$msg->setMeta('msg_image',$params['msg_image']);
		$msg->setMeta('msg_to',trim($params['msg_to'])?$params['msg_to']:'u_'.$this->_frm->getUser());
		$msg->setMeta('msg_link',$params['msg_link']);
		$result=$this->_Base->sendMsgMessage($msg);
		if ($result===false) {
			$this->result['error']='GENERIC';
			return false;
		} else {
			$this->result['error']='OK';
			$this->result['error_msg']=str_replace('{NUM}',$result,$this->_T->lang('[[Es wurden {NUM} Notes versendet]]'));
		}
		return false;
	}
	public function msgPortalDelete($params) {
		$this->_Base->unlinkMessage($params['msgId']);

		$this->msgPortalUpdate($params);
	}
	public function msgPortalClose($params) {
		if ($this->_Base->getMessageVisited($params['msgId'])==GE_MSG_VISITED_UNREAD) {
			$this->_Base->markVisited($params['msgId']);
		}
		$this->msgPortalUpdate($params);
	}
	public function msgPortalArchiv($params) {
		$this->_BaseMsg->archivMessage($params['msgId']);
		$this->msgPortalUpdate($params);
	}
	public function msgPortalUpdate($params) {
		require_once('lib/msg/ctrl/geMsgCtrlPortal.php');
		$ctrl=new geMsgCtrlPortal();
		$Gui=$ctrl->getPortalGui();
		$this->result=array(
			'error'=>'UPDATE',
			'content'=>$Gui->process(),
		);
	}
	public function getResult() {
		return $this->result;
	}
}
?>