<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
define('GE_MSG_VISITED_NEW',0);
define('GE_MSG_VISITED_UNREAD',1);
define('GE_MSG_VISITED_READ',2);
define('GE_MSG_VISITED_ARCHIV',4);

class ObjMsgMessage extends baseObj {
	public $_action=array('e','e'); // to owerwrite;
	public $_site='msg.php'; // to owerwrite;
	public $_obj_typ='0';
	public $_umeta=array();
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['Title'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
	function getUserMeta($key) {
		return $this->_umeta[$key];
	}
	function setUserMeta($key,$data) {
		$this->_umeta[$key]=$data;
	}
}


class geMsgModelMessage extends ObjCore{
	public $_modul='msg';
	public $_table='MsgMessages';
	public $_cfgObjects=array (
		'IdField'=>'msg_id',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'0'=>array(
			'ClassName'=>'ObjMsgMessage',
			'Fields'=>array(
				'msg_id'=>array(
					'TYP'=>'int',
					'Extra'=>'ID',
				),
				'msg_userid'=>array(
					'TYP'=>'int',
				),
				'msg_sendid'=>array(
					'TYP'=>'int',
				),
				'msg_from'=>array(
					'TYP'=>'text',
				),
				'msg_to'=>array(
					'TYP'=>'text',
				),
				'msg_subject'=>array(
					'TYP'=>'text',
				),
				'msg_message'=>array(
					'TYP'=>'text',
				),
				'msg_link'=>array(
					'TYP'=>'text',
				),
				'msg_image'=>array(
					'TYP'=>'int',
				),
				'msg_time'=>array(
					'TYP'=>'int',
					'Extra'=>'cTime',
				),
			),
		),
	);
	public function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','msg')));
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
	}
	public function sendMsgMessage($msg,$toSelf=false) {
		require_once('lib/core/geCoreMailsimple.php');
		if ($this->insertMeta($msg)) {
			$result=0;
			$toUid=array();
			foreach (explode(',',$msg->getMeta('msg_to')) as $val) {
				switch ($val[0]) {
					case 'g':
						$temp=$this->_frm->getGroupUsers(substr($val,2));
						if (is_array($temp)) {
							foreach ($temp as $id) {
								if ($toSelf || $id!=$msg->getMeta('msg_userid')) {
									$toUid[]=$id;
								}
							}
						}
					break;
					case 'u':
						$toUid[]=substr($val,2);
					break;
					case 'r':
						$id=$this->_frm->getRuleUser(substr($val,2));
						if ($toSelf || $id!=$msg->getMeta('msg_userid')) {
							$toUid[]=$id;
						}
					break;
				}
			}
			//Nur aktive User;
			$toUid=array_keys($this->_frm->getFullName($toUid));
			if (!empty($toUid)) {
				//debug($toUid);
				$msgUid=array_keys($this->_frm->getApplicationUsers('msg',$toUid));
				$mailUid=array_diff($toUid,$msgUid);
				$mailFwdUid=array();

				foreach(array_unique($msgUid) as $uid) {
					//Falls Note forward eingeschalten
					if ($this->_frm->getPrefs('global','nfw',$uid)) {
						$mailFwdUid[]=$uid;
						if ($GLOBALS['CFG']['MSG']['DELETE_FORWARD']) continue;
					}
					$result++;
					$this->linkMessageTo($msg,$uid,$uid==$msg->getMeta('msg_userid')?GE_MSG_VISITED_UNREAD:GE_MSG_VISITED_NEW);
				}
				if (!empty($mailUid) || !empty($mailFwdUid)) {
					$fromUser=$this->_frm->getCachedUser($msg->getMeta('msg_userid'));

					$mail=new geCoreMailsimple();
					$mail->setFrom($fromUser['email'],$msg->getMeta('msg_from'));
					$mail->setReplyto($fromUser['email']);
					$linkBody='';
					if ($msg->getMeta('msg_link')) {
						$links=json_decode($msg->getMeta('msg_link'));
						if (is_object($links) && isset($links->U)) $links=array($links);
						if (is_array($links)) {
							foreach ($links as $val) {
								$linkBody.=$mail->getLf().$mail->getLf().$val->N.$mail->getLf().Framework::getSelfDir(true).'/'.$val->U;
							}
						}
					}
					;
					$mail->setBody(preg_replace("/(\r\n|\r|\n)/",$mail->getLf(),$msg->getMeta('msg_message').$linkBody));
					$mail->setSubject('#NT-FWD#: '.$msg->getMeta('msg_subject'));
					foreach (array_unique($mailFwdUid) as $mailTo) {
						$mailUser=$this->_frm->getCachedUser($mailTo);
						if (trim($this->_frm->getPrefs('global','nfw_mail',$mailTo))) {
							$mailUser['email']=$this->_frm->getPrefs('global','nfw_mail',$mailTo);
						}
						if ($mailUser['email'] && !$mailUser['deleted']) {
							$mail->setTo($mailUser['email'],$mailUser['lastname'].' '.$mailUser['firstname']);
							$mail->send();
							if ($GLOBALS['CFG']['MSG']['DELETE_FORWARD']) $result++;
						}
					}
					$mail->setSubject($msg->getMeta('msg_subject'));
					foreach (array_unique($mailUid) as $mailTo) {
						$mailUser=$this->_frm->getCachedUser($mailTo);
						if ($mailUser['email'] && !$mailUser['deleted']) {
							$mail->setTo($mailUser['email'],$mailUser['lastname'].' '.$mailUser['firstname']);
							$mail->send();
							$result++;
						}
					}
				}
			}
			return $result;
		}
		return false;
	}
	protected function linkMessageTo($msg,$toUid,$visited=0) {
		/*
		 0: Neu fr Benachrichtigung
		 1: Ungelesen
		 2: Gelesen
		 4: Archiviert
		*/
		$insert=array(
			'fk_msg_id'=>$msg->getID(),
			'msg_userid'=>$toUid,
			'msg_visited'=>$visited,
		);
		return $this->_db->insert('MsgMessagesUser',$insert,'',1);
	}
	public function unlinkMessage($msg_id) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'fk_msg_id','Typ'=>'=','Values'=>$msg_id);
		$searchQuery[]=array('Field'=>'msg_userid','Typ'=>'=','Values'=>$this->_frm->getUser());
		$this->_db->delete('MsgMessagesUser',$searchQuery);
	}
	function archivMessage($msg_id=0) {
		$this->markMessage($msg_id,GE_MSG_VISITED_ARCHIV);
	}
	function markVisited($msg_id) {
		$this->markMessage($msg_id,GE_MSG_VISITED_READ);
	}
	function markRecent($msg_id) {
		$this->markMessage($msg_id,GE_MSG_VISITED_UNREAD);
	}
	function markMessage($msg_id,$visited) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'fk_msg_id','Typ'=>'=','Values'=>$msg_id);
		$searchQuery[]=array('Field'=>'msg_userid','Typ'=>'=','Values'=>$this->_frm->getUser());
		$this->_db->update('MsgMessagesUser',array('msg_visited'=>$visited),$searchQuery);
	}
	function getMessageVisited($msg_id) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'fk_msg_id','Typ'=>'=','Values'=>$msg_id);
		$searchQuery[]=array('Field'=>'msg_userid','Typ'=>'=','Values'=>$this->_frm->getUser());
		$query="SELECT msg_visited FROM MsgMessagesUser WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('msg_visited');
		}
	}

	protected function addUserMeta(&$Obj) {
		$Obj->setUserMeta('msg_visited',$this->_db->f('msg_visited'));
	}
	public function listUserMessages(&$rows,$uid,$search,$order='msg_time DESC') {
		$params=array();
		if ($search['msg_visited']) {
			$params['JOIN']='LEFT JOIN MsgMessagesUser ON (MsgMessagesUser.fk_msg_id=MsgMessages.msg_id AND MsgMessagesUser.msg_userid='.$this->_db->escape($uid).')';
			$params['GROUP_FIELD']='MsgMessages.msg_id';
			$params['CALLBACK']=array($this,'addUserMeta');
			$params['FIELDS']='msg_visited';
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'MsgMessagesUser.msg_visited','Typ'=>'=','Values'=>$search['msg_visited']);
		}
		if ($search['msg_sendid']) {
			$searchQuery[]=array('Field'=>'MsgMessages.msg_sendid','Typ'=>'=','Values'=>$search['msg_sendid']);
		}
		if (isset($search['msg_deleted'])) {
			$searchQuery[]=array('Field'=>'MsgMessages.msg_deleted','Typ'=>'=','Values'=>$search['msg_deleted']);
		}
		return $this->searchObj($rows,$searchQuery,$order,$search['b'],$search['limit'],$search['use_limit'],true,false,$params);
	}
	function clearNew() {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'msg_visited','Typ'=>'=','Values'=>GE_MSG_VISITED_NEW);
		$searchQuery[]=array('Field'=>'msg_userid','Typ'=>'=','Values'=>$this->_frm->getUser());
		$this->_db->update('MsgMessagesUser',array('msg_visited'=>GE_MSG_VISITED_UNREAD),$searchQuery);
	}
	function getNew() {
		$result=array();

		$searchQuery=array();
		$searchQuery[]=array('Field'=>'MsgMessages.msg_id','Typ'=>'F=F','Values'=>'MsgMessagesUser.fk_msg_id');
		$searchQuery[]=array('Field'=>'MsgMessagesUser.msg_userid','Typ'=>'=','Values'=>$this->_frm->getUser());
		$searchQuery[]=array('Field'=>'MsgMessagesUser.msg_visited','Typ'=>'=','Values'=>GE_MSG_VISITED_NEW);
		
		$query="SELECT count(*) as num,MsgMessages.msg_userid FROM MsgMessages,MsgMessagesUser WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" GROUP BY MsgMessages.msg_userid ";
		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('msg_userid')]=$this->_db->f('num');
		}
		return $result;
	}
	function getUnread() {

		$searchQuery=array();
		$searchQuery[]=array('Field'=>'MsgMessagesUser.msg_userid','Typ'=>'=','Values'=>$this->_frm->getUser());
		$searchQuery[]=array('Field'=>'MsgMessagesUser.msg_visited','Typ'=>'=','Values'=>GE_MSG_VISITED_UNREAD);

		$query="SELECT count(*) as num FROM MsgMessagesUser WHERE ".$this->_db->getWhere($searchQuery);
		//echo $query;
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('num');
		}
		return 0;
	}
	function markDeleted($msg_id) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'msg_id','Typ'=>'=','Values'=>$msg_id);
		$searchQuery[]=array('Field'=>'msg_sendid','Typ'=>'=','Values'=>$this->_frm->getUser());
		$this->_db->update('MsgMessages',array('msg_deleted'=>1),$searchQuery);
	}
	public function deleteUser($user_id) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'msg_userid','Typ'=>'=','Values'=>$user_id);
		$this->_db->delete('MsgMessagesUser',$searchQuery);
	}
	public function addLink($text) {
		return preg_replace(
		array(
		'/(^|\s|>)(www.[^<> \n\r]+)/iex',
		'/(^|\s|>)([_A-Za-z0-9-]+(\\.[A-Za-z]{2,3})?\\.[A-Za-z]{2,4}\\/[^<> \n\r]+)/iex',
		'/(?(?=<a[^>]*>.+<\/a>)(?:<a[^>]*>.+<\/a>)|([^="\']?)((?:https?):\/\/([^<> \n\r]+)))/iex'
		),
		array(
		"stripslashes((strlen('\\2')>0?'\\1<a href=\"http://\\2\" target=\"_blank\">\\2</a>&nbsp;\\3':'\\0'))",
		"stripslashes((strlen('\\2')>0?'\\1<a href=\"http://\\2\" target=\"_blank\">\\2</a>&nbsp;\\4':'\\0'))",
		"stripslashes((strlen('\\2')>0?'\\1<a href=\"\\2\" target=\"_blank\">'.(strlen('\\3')>102?substr('\\3',0,100).'...':'\\3').'</a>&nbsp;':'\\0'))",
		),
			$text
		);		
	}
}
?>