<?php
class ObjProject extends baseObj {
	var $_action=array('e','e'); // to owerwrite;
	var $_site='proj.php'; // to owerwrite;
	var $_obj_typ='0';
	var $_umeta=array();
	/* to owerwrite*/
	function ObjProject($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['Title'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
	function getUserMeta($key) {
		return $this->_umeta[$key];
	}
	function setUserMeta($key,$data) {
		$this->_umeta[$key]=$data;
	}
}

class Project extends ObjCore {
	var $_modul='proj';
	var $_table='ProjMetabase';
	var $_maxSmbRetrys=5;
	var $_cfgObjects=array (
		'IdField'=>'ProjID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'0'=>array(
			'ClassName'=>'ObjProject',
			'Fields'=>array(
				'ProjID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'TimeCreate'=>array(
					'Typ'=>'core',
					'Extra'=>'cTime',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserCreate'=>array(
					'Typ'=>'core',
					'Extra'=>'cUser',
					'import'=>array(
						'name'=>'fieldProjectowner',
						'typ'=>'fk_user',
					),
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
				'ProjNumTxt'=>array(
					'Typ'=>'text',
					'Name'=>'[[Projektnummer]]',
					'Required'=>3,
					'fGroup'=>1,
					'import'=>array(
						'name'=>'fieldProjectnumber',
						'typ'=>'text',
					),
				),
				'Title'=>array(
					'Typ'=>'text',
					'Name'=>'[[Projektname (max. 30 Zeichen)]]',
					'Required'=>3,
					'Attribs'=>array('maxlength'=>30),
					'fGroup'=>1,
					'import'=>array(
						'name'=>'fieldProjectname',
						'typ'=>'text',
					),
				),
				'FKProfileID'=>array(
					'Typ'=>'select',
					'Name'=>'[[Profil]]',
					'Required'=>3,
					'fGroup'=>1,
					'Values'=>'getProfiles',
					'import'=>array(
						'name'=>'fieldProjectprofile',
						'typ'=>'profile',
					),
				),
				'Text'=>array(
					'Typ'=>'area',
					'Name'=>'[[Beschreibung]]',
					'Required'=>0,
					'Attribs'=>array('rows'=>3),
					'fGroup'=>1,
					'import'=>array(
						'name'=>'fieldNotes',
						'typ'=>'text',
					),
				),
				'Aktiv'=>array(
					'Typ'=>'check',
					'Name'=>'[[Aktiv]]',
					'fGroup'=>1,
					'Default'=>'1',
				),
				'MailFolder'=>array(
					'Typ'=>'core',
				),
				'FmngFolder'=>array(
					'Typ'=>'core',
				),
				'SmbFolder'=>array(
					'Typ'=>'core',
				),
				'ZefFolder'=>array(
					'Typ'=>'core',
				),
				'Deleted'=>array(
					'Typ'=>'core',
					'Extra'=>'Fixed',
					'Default'=>'0',
				),
			),
		),
	);
	var $_prjRules=array(
		1=>'[[prjRule1]]',
		2=>'[[prjRule2]]',
		3=>'[[prjRule3]]',
	);
	var $_searchFields=array(
		'ProjMetabase.ProjNumTxt'=>array('F'=>'ProjNumTxt','T'=>'text','S'=>1,'M'=>'I','N'=>'[[Projektnummer]]'),
		'ProjMetabase.Title'=>array('F'=>'Title','T'=>'text','S'=>1,'M'=>'I','N'=>'[[Projektname]]'),
		'ProjMetabase.Text'=>array('F'=>'Text','T'=>'text','S'=>1,'M'=>'I','N'=>'[[Beschreibung]]'),
		'ProjMetabase.FKProfileID'=>array('F'=>'FKProfileID','T'=>'select','S'=>0,'M'=>'I','N'=>'[[Profil]]'),
		'ProjMetabase.TimeCreate'=>array('F'=>'TimeCreate','T'=>'unixdate','S'=>0,'M'=>'I','N'=>'[[Erstellt am]]'),
		'ProjMetabase.UserCreate'=>array('F'=>'UserCreate','T'=>'user','S'=>0,'M'=>'I','N'=>'[[Erstellt von]]'),
	);
	var $_intError=array();
	function Project ($noInit=false) {
		if (!$noInit) {
			$this->init();
		}
	}
	function init() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','proj')));
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
		//$this->_cfg['cfg/useProfilPath']=1;
	}
	function &initUform($usePerms=false) {
		require_once("lib/uform/class_UserFormData.php");
		$this->_uFormData=new UserFormData();
		if ($usePerms) {
			$this->_uFormData->loadSystemObj('proj',1,$this->listMyAvRules());
			//debug($this->listMyAvRules());
		} else {
			$this->_uFormData->loadSystemObj('proj');
		}
		return $this->_uFormData;
	}
	function initSearchFields() {
		$avRules=$this->getAvRules();
		foreach ($avRules as $rkey=>$rval) {
			$this->_searchFields['ProjRules.FKGroupID|'.$rkey]=array('F'=>'FKRuleID','T'=>'ruser','S'=>0,'M'=>'R','N'=>$rval);
		}


		$formFields=$this->_uFormData->getFormFields();
		if (is_array($formFields[0])) {
			foreach ($formFields[0] as $fGroup) {
				if (!$fGroup->getAcl(1)) continue;
				if ($fGroup->getMeta('Multiple')) {
					$ID='ProjMetabaseUser.F_'.$fGroup->getID();
					$this->_searchFields[$ID]=array(
						'T'=>'blob',
						'F'=>$fGroup->getID(),
						'S'=>1,
						'M'=>'',
						'V'=>0,
					);
					//debug($ID);

				} elseif (is_array($formFields[$fGroup->getID()])) {
					foreach ($formFields[$fGroup->getID()] as $fObj) {
						$ID='ProjMetabaseUser.F_'.$fObj->getID();
						$Values=array();
						$Typ='';
						$Sel=0;
						$Search=0;
						$Cfg=unserialize($fObj->getMeta('Config'));

						switch ($fObj->getMeta('Typ')) {
							case 'check':
							case 'date':
								$Typ=$fObj->getMeta('Typ');
							break;
							case 'select':
							case 'mselect':
								$Typ=$fObj->getMeta('Typ');
								$Sel=$fObj->getID();
							break;
							case 'text':
							case 'area':
								$Typ=$fObj->getMeta('Typ');
								$Search=1;
							break;
							case 'int':
								$Typ='num';
							break;
							case 'fk_user':
								$Typ='fuser';
							break;
							case 'fk_addr':
								$Typ='addr';
							break;
							case 'file':

							break;
							case 'fk_comp':
								$Typ='comp';
							break;
							case 'status':
								$Typ='status';
								$tmp=unserialize($fObj->getMeta('Value'));
								if (is_array($tmp['Status']) && !empty($tmp['Status'])) {
									$Sel=array_unique(Framework::extractArrayMeta($tmp['Status'],'key'));
								} else {
									$Sel=array();
								}
							break;
							case 'status_txt':
								$Typ='status_txt';
								$Sel=$fObj->getID();
							break;
						}
						if ($Typ) {
							$this->_searchFields[$ID]=array(
								'T'=>$Typ,
								'F'=>$fObj->getID(),
								'S'=>$Search,
								'M'=>'U',
								'N'=>$fObj->getName(),
								'V'=>$Sel,
								'G'=>$fGroup->getName(),
								'C'=>$Cfg,
							);
						}
					}
				}
			}
		}
		$this->_searchFieldInit=true;
	}
	function getSearchFields($ID='') {
		if (!$this->_searchFieldInit) $this->initSearchFields();
		if ($ID) {
			return $this->_searchFields[$ID];
		} else {
			return $this->_searchFields;
		}
	}
	function getSearchFieldsVal($ID,$key) {
		if (!$this->_searchFieldInit) $this->initSearchFields();
		return $this->_searchFields[$ID][$key];
	}
	function issetSearchField($ID) {
		if (!$this->_searchFieldInit) $this->initSearchFields();
		return isset($this->_searchFields[$ID]);
	}
	function getAvRules($key=0) {
		if ($key) return $this->_prjRules[$key]; else return $this->_prjRules;
	}
	function &listAllPrj(&$rows,$search=null,$b=0,$limit=0,$order="ProjMetabase.Aktiv Desc,ProjMetabase.Title ASC") {
		$params=array('JOIN'=>'');
		$searchQuery=array();
		if ($search['search']) {
			$params['JOIN'].=" LEFT JOIN ProjMetabaseUser ON (ProjMetabase.ProjID=ProjMetabaseUser.FKObjID AND ProjMetabaseUser.FKModul='proj')";
			$searchQuery=$this->_formatSearchSql($search['search'],$params['JOIN'],0);
		}
		if ($search['info']) {
			$searchQuery[]=array('Field'=>array('Title','Text','ProjNumTxt'),'Typ'=>'concat','Values'=>$search['info']);
		}
		if ($search['trash']) {
			$searchQuery[]=array('Field'=>'Deleted','Typ'=>'=','Values'=>1);
		} else {
			$searchQuery[]=array('Field'=>'Deleted','Typ'=>'=','Values'=>0);
		}
		if ($search['Aktiv']) {
			$searchQuery[]=array('Field'=>'ProjMetabase.Aktiv','Typ'=>'=','Values'=>$search['Aktiv']);
		}
		if ($search['FKProfileID']) {
			$searchQuery[]=array('Field'=>'ProjMetabase.FKProfileID','Typ'=>'=','Values'=>$search['FKProfileID']);
		}
		if ($search['Fav']) {
			$searchQuery[]=array('Field'=>'ProjHotList.FKProjID','Typ'=>'!null');
			$params['JOIN']='LEFT JOIN ProjHotList ON (ProjMetabase.ProjID=ProjHotList.FKProjID AND ProjHotList.FKUserID='.$this->_db->escape($this->_uid).' AND ProjHotList.FavTyp=\'proj\')';
		}
		if ($search['ProjID']) {
			$searchQuery[]=array('Field'=>'ProjID','Typ'=>'=','Values'=>$search['ProjID']);
		}
		if (!$this->isRuleUser()) {
			$orQuery=array();
			$orQuery[]=array(array('Field'=>'UserCreate','Typ'=>'=','Values'=>$this->_frm->getUser()));
			if ($this->getCfg('cfg/AllowAdminEdit')) {
				$subQuery=array();
				$subQuery[]=array('Field'=>'ProjRules.FKProjID','Typ'=>'F=F','Values'=>'ProjMetabase.ProjID');
				$subQuery[]=array('Field'=>'ProjRules.FKGroupID','Typ'=>'=','Values'=>$this->_frm->getMyGroups());
				$subQuery[]=array('Field'=>'ProjRules.FKRuleID','Typ'=>'=','Values'=>1);
				$subSql='EXISTS (SELECT * FROM ProjRules WHERE '.$this->_db->getWhere($subQuery).')';
				$orQuery[]=array(array('Typ'=>'SQL','Values'=>$subSql));
			}
			$searchQuery[]=array('Typ'=>'OR','Values'=>$orQuery);
		}
		//debug($searchQuery);
		return $this->searchObj($rows,$searchQuery,$order,$b,$limit,true,false,false,$params);
	}
	function hasProjEditPerms(&$Obj) {
		if ($this->isRuleUser()) return true;
		if ($Obj->getMeta('UserCreate')==$this->_uid) return true;
		if ($this->getCfg('cfg/AllowAdminEdit')) {

		}
		return false;
	}
	function &searchMyPrj(&$rows,$search=null,$useUserFields='',$b=0,$limit=0,$order="ProjMetabase.Title ASC",$extra=null) {
		$params['JOIN']='INNER JOIN ProjRules ON (ProjMetabase.ProjID=ProjRules.FKProjID)';
		$searchQuery=array(
			array('Field'=>'ProjMetabase.Deleted','Typ'=>'=','Values'=>'0'),
		);
		if (!$extra['listAll'] || !$this->isRuleUser()) {
			$searchQuery[]=array('Field'=>'ProjRules.FKGroupID','Typ'=>'=','Values'=>$this->_gid);
		}
		if (isset($search['Aktiv'])) {
			$searchQuery[]=array('Field'=>'ProjMetabase.Aktiv','Typ'=>'=','Values'=>$search['Aktiv']);
		}
		if ($search['FKProfileID']) {
			$searchQuery[]=array('Field'=>'ProjMetabase.FKProfileID','Typ'=>'=','Values'=>$search['FKProfileID']);
		}
		if (isset($search['ProjID'])) {
			$searchQuery[]=array('Field'=>'ProjMetabase.ProjID','Typ'=>'=','Values'=>$search['ProjID']);
		}
		if ($search['Info']) {
			$extra['addUserJoin']=true;
			$sField=array();
			foreach ($this->getSearchFields() as $sKey=>$sVal) {
				if ($sVal['S']) {
					switch($sVal['T']) {
						case 'blob':
							$sField[]='CONVERT('.$sKey.' USING '.(GE_CHARSET=='UTF-8'?'utf8':'latin1').')';
						break;
						default:
							$sField[]=$sKey;
						break;
					}
				}
			}
			$searchQuery[]=array('Field'=>$sField,'Typ'=>'concat','Values'=>$search['Info']);
		}
		if ($search['Fav']) {
			$searchQuery[]=array('Field'=>'ProjHotList.FKProjID','Typ'=>'!null');
			$params['JOIN'].=' LEFT JOIN ProjHotList ON (ProjMetabase.ProjID=ProjHotList.FKProjID AND ProjHotList.FKUserID='.$this->_db->escape($this->_uid).' AND ProjHotList.FavTyp=\'proj\')';
		}
		if ($useUserFields) {
			if ($useUserFields=='all') {
				$lFields=$this->_uFormData->getMetaFields();
			} else {
				$lFields=$this->_uFormData->getListFields();
			}
			if (!empty($lFields)) {
				$extra['addUserJoin']=true;
				$params['FIELDS']='ProjMetabaseUser.'.implode(',ProjMetabaseUser.',$lFields);
				if ($useUserFields=='all') {
					$params['CALLBACK']=array($this,'addCrmMeta');
				} else {
					$params['CALLBACK']=array($this,'addCrmMetaList');
				}

			}
		}
		if ($extra['addUserJoin']) {
			$params['JOIN'].=" LEFT JOIN ProjMetabaseUser ON (ProjMetabase.ProjID=ProjMetabaseUser.FKObjID AND ProjMetabaseUser.FKModul='proj')";
		}
		if ($extra['addJoin']) {
			$params['JOIN'].=' '.$extra['addJoin'];
		}
		$params['GROUP_FIELD']='ProjMetabase.ProjID';
		return $this->searchObj ($rows,$searchQuery,$order,$b,$limit,true,false,false,$params);
	}

	function &haveOwnedProjects($ID=0) {
		$searchQuery=array(
			array('Field'=>'ProjMetabase.Deleted','Typ'=>'=','Values'=>'0'),
		);
		if ($ID) {
			$searchQuery[]=array('Field'=>'ProjMetabase.ProjID','Typ'=>'=','Values'=>$ID);
		}
		if (!$this->isRuleUser()) {
			$orQuery=array();
			$orQuery[]=array(array('Field'=>'UserCreate','Typ'=>'=','Values'=>$this->_frm->getUser()));
			if ($this->getCfg('cfg/AllowAdminEdit')) {
				$subQuery=array();
				$subQuery[]=array('Field'=>'ProjRules.FKProjID','Typ'=>'F=F','Values'=>'ProjMetabase.ProjID');
				$subQuery[]=array('Field'=>'ProjRules.FKGroupID','Typ'=>'=','Values'=>$this->_frm->getMyGroups());
				$subQuery[]=array('Field'=>'ProjRules.FKRuleID','Typ'=>'=','Values'=>1);
				$subSql='EXISTS (SELECT * FROM ProjRules WHERE '.$this->_db->getWhere($subQuery).')';
				$orQuery[]=array(array('Typ'=>'SQL','Values'=>$subSql));
			}
			$searchQuery[]=array('Typ'=>'OR','Values'=>$orQuery);
		}
		return $this->searchSingleObj($searchQuery)?true:false;
	}


	function &getPrjNames($IDs=0,$uid=0,$info='',$limit=0,$returnObj=false,$activ=true,$usePerms=true) {
		$params=array();
		$searchQuery=array(
			array('Field'=>'Deleted','Typ'=>'=','Values'=>'0'),
		);
		if ($usePerms) {
			if (!$uid) $uid=$this->_uid;
			if ($uid==$this->_uid) {
				$gid=$this->_gid;
			} else {
				$gid=$this->_frm->getUserGroups($uid);
			}
			$searchQuery[]=array('Field'=>'ProjRules.FKGroupID','Typ'=>'=','Values'=>$gid);
			$params['JOIN']='INNER JOIN ProjRules ON (ProjMetabase.ProjID=ProjRules.FKProjID)';
			$params['GROUP_FIELD']='ProjMetabase.ProjID';
		}
		if ($activ) $searchQuery[]=array('Field'=>'ProjMetabase.Aktiv','Typ'=>'=','Values'=>1);
		if ($IDs) {
			$searchQuery[]=array('Field'=>'ProjMetabase.ProjID','Typ'=>'=','Values'=>$IDs);
		}
		if ($info) {
			$searchQuery[]=array('Field'=>array('Title','Text','ProjNumTxt'),'Typ'=>'concat','Values'=>$info);
		}
		//debug($search);
		$rows=0;
		$result=$this->searchObj($rows,$searchQuery,'ProjMetabase.Title',0,$limit,true,false,false,$params);
		if ($returnObj) {
			return $result;
		} else {
			return Framework::extractObjMeta($result,'Title');
		}
	}
	function deleteObj(&$Obj) {
		$Obj->setMeta('Deleted',1);
		$this->updateMeta($Obj);
	}
	function updateObj($Obj) {
		$oldObj=$this->getObj($Obj->getID());
		if ($oldObj->getMeta('Aktiv')!=$Obj->getMeta('Aktiv') || $oldObj->getMeta('MailFolder')!=$Obj->getMeta('MailFolder')) {
			$PrjGroups=$this->getRuleGroups($Obj);
			if (!empty($PrjGroups)) {
				$PrjUsers=$this->_frm->getGroupUsers($PrjGroups);
				if (is_array($PrjUsers)) {
					$Mail=& $this->_frm->getStaticModul('mail');
					$BaseSync=$this->_frm->getStaticModul('active_sync');
					$OldExists=$oldObj->getMeta('MailFolder')?$this->existsMailFolder($oldObj->getMeta('MailFolder')):false;
					if ($Obj->getMeta('MailFolder')==$oldObj->getMeta('MailFolder')) {
						$NewExists=$OldExists;
					} else {
						$NewExists=$Obj->getMeta('MailFolder')?$this->existsMailFolder($Obj->getMeta('MailFolder')):false;
					}
					if ($OldExists) {
						if ($Obj->getMeta('Aktiv') && $NewExists && $oldObj->getMeta('MailFolder')!=$Obj->getMeta('MailFolder')) {
							$BaseSync->renameSyncFolder(-1,-1,$oldObj->getMeta('MailFolder'),$Obj->getMeta('MailFolder'));
						} else {
							$BaseSync->deleteSyncFolders(-1,-1,$Obj->getMeta('MailFolder').'.%');
							$BaseSync->deleteSyncFolders(-1,-1,$Obj->getMeta('MailFolder'));
						}
					}
					
					foreach ($PrjUsers as $val) {
						if ($OldExists && $oldObj->getMeta('MailFolder')!=$Obj->getMeta('MailFolder')) {
							$Mail->delteMailAbbo($val,$oldObj->getMeta('MailFolder'));
							$Mail->insertMailAbbo($val,$oldObj->getMeta('MailFolder'),'un_abbo');
						}
						if ($NewExists) {
							$Mail->delteMailAbbo($val,$Obj->getMeta('MailFolder'));
							if ($Obj->getMeta('Aktiv')) {
								if (!$this->_frm->getPrefs($this->getModul(),'defMailNoAutoAbbo',$val)) {
									$Mail->insertMailAbbo($val,$Obj->getMeta('MailFolder'),'abbo');
								}
							} else {
								$Mail->insertMailAbbo($val,$Obj->getMeta('MailFolder'),'un_abbo');
							}
						}
					}
				}
			}
		}
	
		if ($oldObj->getMeta('Aktiv')!=$Obj->getMeta('Aktiv')) {
			$this->activateProjectRules($Obj,$Obj->getMeta('Aktiv'));
		}
		return $this->updateMeta($Obj);
	}
	
	function nameExists($name,$ExcludeID=0) {
		$search=array();
		$search[]=array('Field'=>'Title','Typ'=>'=','Values'=>$name);
		if ($ExcludeID) $search[]=array('Field'=>'ProjID','Typ'=>'!=','Values'=>$ExcludeID);
		//debug($search);
		return $this->searchSingleObj($search)?true:false;
	}
	function numberExists($name,$ExcludeID=0) {
		$search=array();
		$search[]=array('Field'=>'ProjNumTxt','Typ'=>'=','Values'=>$name);
		if ($ExcludeID) $search[]=array('Field'=>'ProjID','Typ'=>'!=','Values'=>$ExcludeID);
		//debug($search);
		return $this->searchSingleObj($search)?true:false;
	}
	function getPrjByName($name) {
		$search=array();
		$search[]=array('Field'=>'Title','Typ'=>'=','Values'=>$name);
		//debug($search);
		return $this->searchSingleObj($search);
	}
	function activateProjectRules(&$obj,$activ=1) {
		$PrjGroups=$this->getRuleGroups($obj);
		$userData=array(
			'activGroup-e'=>$activ?$obj->getID():-$obj->getID(),
		);
		foreach($PrjGroups as $gid) {
			//debug($gid);
			//debug($userData);
			$this->_frm->update_group($gid,$userData);
		//	debug($this->_frm->getAdminGroups($gid,true,false,false));
		}
	}
	
	function createProjectRules(&$obj) {
		foreach ($this->_prjRules as $key=>$val) {
			if ($GLOBALS['CFG']['USER_CLASS']=='ldap_full') {
				if (GE_groupDomainSuffix) {
					$domain='_'.GE_groupDomainSuffix;
				} else {
					$domain='';
				}
				$group=array(
					'cn'=>'_prj_'.$obj->getID().'_'.$key.$domain,
					'activGroup-e'=>$obj->getID(),
				);
			} else {
				$group=array(
					'group_name'=>'_prj_'.$obj->getID().'_'.$key,
					'activGroup-e'=>$obj->getID(),
				);
			}
			$gid=$this->_frm->insert_group($group);

			if ($gid) {
				$prjPerms=array(
					'FKProjID'=>$obj->getID(),
					'FKGroupID'=>$gid,
					'FKRuleID'=>$key,
				);
				$this->_db->insert('ProjRules',$prjPerms,'',1);
			}
		}
	}
	function getRuleGroupID(&$obj,$rule) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$obj->getID());
		$searchQuery[]=array('Field'=>'FKRuleID','Typ'=>'=','Values'=>$rule);
		$query="SELECT FKGroupID FROM ProjRules WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('FKGroupID');
		}
		return 0;
	}
	function getAllRuleGroupID($prjID,$rule) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$prjID);
		$searchQuery[]=array('Field'=>'FKRuleID','Typ'=>'=','Values'=>$rule);
		$query="SELECT * FROM ProjRules WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('FKProjID')][$this->_db->f('FKRuleID')]=$this->_db->f('FKGroupID');
		}
		return $result;
	}
	function getMyProjectRules($ID) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$ID);
		$searchQuery[]=array('Field'=>'FKGroupID','Typ'=>'=','Values'=>$this->_gid);
		$query="SELECT FKProjID,FKRuleID FROM ProjRules WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('FKProjID')][]=$this->_db->f('FKRuleID');
		}
		if (!is_array($ID)) {
			return isset($result[$ID])?$result[$ID]:array();
		} else {
			return $result;
		}
	}
	function &listMyAvRules() {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'ProjRules.FKProjID','Typ'=>'F=F','Values'=>'ProjMetabase.ProjID');
		$searchQuery[]=array('Field'=>'ProjRules.FKGroupID','Typ'=>'=','Values'=>$this->_gid);
		$searchQuery[]=array('Field'=>'ProjMetabase.Deleted','Typ'=>'=','Values'=>0);
		$searchQuery[]=array('Field'=>'ProjMetabase.Aktiv','Typ'=>'=','Values'=>1);
		$query="SELECT DISTINCT FKRuleID FROM ProjMetabase,ProjRules WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		$result=array();
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('FKRuleID');
		}
		return $result;
	}

	function getRuleGroups(&$obj) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$obj->getID());
		$query="SELECT FKGroupID,FKRuleID FROM ProjRules WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" ORDER BY FKRuleID";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('FKRuleID')]=$this->_db->f('FKGroupID');
		}
		return $result;
	}
	function isRuleGroup($gid,$prjID=0) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKGroupID','Typ'=>'=','Values'=>$gid);
		if ($prjID) $searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$prjID);
		$query="SELECT FKProjID FROM ProjRules WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('FKProjID');
		}
		return 0;
	}
	function getGroupName($gid,$return_num=false) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKGroupID','Typ'=>'=','Values'=>$gid);
		$query="SELECT FKRuleID FROM ProjRules WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			if ($return_num) {
				return $this->_db->f('FKRuleID');
			} else {
				return $this->_prjRules[$this->_db->f('FKRuleID')];
			}
		}
		return '';
	}

	function listMyPrj($activ=1,$uid=0) {
		if (!$uid) $uid=$this->_uid;
		if ($uid==$this->_uid) {
			$gid=$this->_gid;
		} else {
			$gid=$this->_frm->getUserGroups($uid);
		}
		$searchQuery=array(
			array('Field'=>'ProjRules.FKGroupID','Typ'=>'=','Values'=>$gid),
			array('Field'=>'Deleted','Typ'=>'=','Values'=>'0'),
		);
		if ($activ) {
			$searchQuery[]=array('Field'=>'ProjMetabase.Aktiv','Typ'=>'=','Values'=>1);
		}
		$params['JOIN']='INNER JOIN ProjRules ON (ProjMetabase.ProjID=ProjRules.FKProjID)';
		$params['GROUP_FIELD']='ProjMetabase.ProjID';
		//debug($search);
		$rows=0;
		return $this->searchObj ($rows,$searchQuery,'ProjMetabase.Title',0,0,false,false,false,$params);
	}
	function &listMyPrjProfiles($activ=1,$uid=0) {
		$result=array();
		if (!$uid) $uid=$this->_uid;
		if ($uid==$this->_uid) {
			$gid=$this->_gid;
		} else {
			$gid=$this->_frm->getUserGroups($uid);
		}
		$searchQuery=array(
			array('Field'=>'ProjRules.FKGroupID','Typ'=>'=','Values'=>$gid),
			array('Field'=>'Deleted','Typ'=>'=','Values'=>'0'),
		);
		if ($activ) {
			$searchQuery[]=array('Field'=>'ProjMetabase.Aktiv','Typ'=>'=','Values'=>1);
		}
		$query="SELECT DISTINCT FKProfileID FROM ProjMetabase INNER JOIN ProjRules ON (ProjMetabase.ProjID=ProjRules.FKProjID)";
		$query.=" WHERE ".$this->_db->getWhere($searchQuery);

		$this->_db->query($query);
		while($this->_db->next_record()) {
			$result[]=$this->_db->f('FKProfileID');
		}
		return $result;
	}
	function getNonActivProjects($prjIds) {
		$searchQuery=array();
		if ($prjIds) {
			$searchQuery[]=array('Field'=>'ProjMetabase.ProjID','Typ'=>'=','Values'=>$prjIds);
		}
		$searchQuery[]=array('Field'=>'ProjMetabase.Aktiv','Typ'=>'=','Values'=>0);
		$rows=0;
		$result=$this->searchObj($rows,$searchQuery);
		if ($rows) {
			return array_keys($result);
		} else {
			return array();
		}

	}
	function getCachedProjectName($ID,$returnObj=0) {
		if (is_array($ID)) {
			$result=array();
			foreach($ID as $v) {
				if ($tmp=$this->getCachedProjectName($v,$returnObj)) {
					$result[$v]=$tmp;
				}
			}
			return $result;
		} else {
			if (!isset($this->_cached[$ID])) {
				$this->_cached[$ID]=$this->getObj($ID);
			}
			if ($returnObj) {
				return $this->_cached[$ID];
			} elseif (is_object($this->_cached[$ID])) {
				return $this->_cached[$ID]->getName();
			}
		}
	}
	function getPrjGroupList($prjIds) {
		global $T;
		$favKey=$T->lang('[[Favoriten]]');
		if ($this->getCfg('cfg/useProfilPath')) {
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'ProjMetabase.FKProfileID','Typ'=>'F=F','Values'=>'ProjProfiles.ID');
			$searchQuery[]=array('Field'=>'ProjMetabase.ProjID','Typ'=>'=','Values'=>$prjIds);
			$result=array();
			$query="SELECT ProjMetabase.ProjID,ProjMetabase.Title,ProjProfiles.Name,ProjHotList.FavTyp  FROM ProjMetabase";
			$query.=' LEFT JOIN ProjHotList ON (ProjMetabase.ProjID=ProjHotList.FKProjID AND ProjHotList.FKUserID='.$this->_db->escape($this->_uid).' AND ProjHotList.FavTyp=\'proj\')';
			$query.=",ProjProfiles WHERE ".$this->_db->getWhere($searchQuery);
			$query.=" ORDER BY ProjProfiles.System DESC,ProjProfiles.Name,ProjMetabase.Title";
			$this->_db->query($query);
			$result[$favKey]=array();
			while($this->_db->next_record()) {
				if ($this->_db->f('FavTyp')) {
					$result[$T->lang('[[Favoriten]]')][$this->_db->f('ProjID')]=$this->_db->f('Title');
				}
				$result[$this->_db->f('Name')][$this->_db->f('ProjID')]=$this->_db->f('Title');
			}
		} else {
			$prjKey=$T->lang('[[Projekte]]');
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'ProjMetabase.ProjID','Typ'=>'=','Values'=>$prjIds);
			$result=array();
			$query="SELECT ProjMetabase.ProjID,ProjMetabase.Title,ProjHotList.FavTyp  FROM ProjMetabase";
			$query.=' LEFT JOIN ProjHotList ON (ProjMetabase.ProjID=ProjHotList.FKProjID AND ProjHotList.FKUserID='.$this->_db->escape($this->_uid).' AND ProjHotList.FavTyp=\'proj\')';
			$query.=' WHERE '.$this->_db->getWhere($searchQuery);
			$query.=" ORDER BY ProjMetabase.Title";
			$this->_db->query($query);
			$result[$favKey]=array();
			while($this->_db->next_record()) {
				if ($this->_db->f('FavTyp')) {
					$result[$favKey][$this->_db->f('ProjID')]=$this->_db->f('Title');
				} else {
					$result[$prjKey][$this->_db->f('ProjID')]=$this->_db->f('Title');
				}
			}

		}
		if (empty($result[$favKey])) unset($result[$favKey]);
		return $result;
	}
	function prjList2GroupList($prjNames,$Typ='prj') {
		global $T;
		$favKey=$T->lang('[[Favoriten]]');
		if ($Typ=='zef') {
			$kField='ZefFolder';
		} else {
			$kField='ProjID';
		}

		$searchQuery=array();
		$searchQuery[]=array('Field'=>'ProjMetabase.FKProfileID','Typ'=>'F=F','Values'=>'ProjProfiles.ID');
		$searchQuery[]=array('Field'=>'ProjMetabase.'.$kField,'Typ'=>'=','Values'=>array_keys($prjNames));
		$result=array();
		$query="SELECT ProjMetabase.".$kField.",ProjProfiles.Name,ProjHotList.FavTyp  FROM ProjMetabase";
		$query.=' LEFT JOIN ProjHotList ON (ProjMetabase.ProjID=ProjHotList.FKProjID AND ProjHotList.FKUserID='.$this->_db->escape($this->_uid).' AND ProjHotList.FavTyp=\'proj\')';
		$query.=",ProjProfiles WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" ORDER BY ProjProfiles.System DESC,ProjProfiles.Name,ProjMetabase.Title";
		$this->_db->query($query);
		$result[0]=array();
		$result[$favKey]=array();
		while($this->_db->next_record()) {
			if ($prjNames[$this->_db->f($kField)]) {
				if ($this->_db->f('FavTyp')) {
					$result[$T->lang('[[Favoriten]]')][$this->_db->f($kField)]=$prjNames[$this->_db->f($kField)];
				}
				$result[$this->_db->f('Name')][$this->_db->f($kField)]=$prjNames[$this->_db->f($kField)];
				unset($prjNames[$this->_db->f($kField)]);
			}
		}
		if (!empty($prjNames)) {
			$result[0]=$prjNames;
		}
		if (empty($result[$favKey])) unset($result[$favKey]);
		if (empty($result[0])) unset($result[0]);
		return $result;
	}

	function createMailFolder(&$Obj) {
		if ($this->getCfg('cfg/ProjectMailBox')) {
			$CyrAdm=& $this->_frm->getStaticModul('mail_adm');
			$Profile=& $this->_frm->getStaticModul('proj_profiles');
			$headObj=$Profile->getHeadObj($Obj->getMeta('FKProfileID'),'mfol');
			if ($headObj) {
				if (GE_mailUserSuffix) {
					$parentBox='user'.$CyrAdm->getCfg('cfg/delim').$this->getCfg('cfg/ProjectMailBox').GE_mailUserSuffix;
				} else {
					$parentBox='user'.$CyrAdm->getCfg('cfg/delim').$this->getCfg('cfg/ProjectMailBox');
				}
				if ($this->getCfg('cfg/useProfilPath')) {
					$profileObj=$Profile->getObj($Obj->getMeta('FKProfileID'));
					$parentBox.=$CyrAdm->getCfg('cfg/delim').$profileObj->getName();
				}
				//debug($parentBox);
				if (!$this->existsMailFolder($parentBox)) {
					if ($CyrAdm->imap_login()) {
						$CyrAdm->createmb($parentBox);
					}
				}
				$headObj->setMeta('Name',$Obj->getName());
				$result=$this->_createMailBoxes($parentBox,$headObj,$Obj);
			} else {
				$this->_addError('No Profile Object found');
			}
		}
		return $result;
	}
	function _addError($val) {
		$this->_intError[]=$val;

	}
	function getError() {
		return empty($this->_intError)?false:$this->_intError;
	}
	function _createMailBoxes($parentBox,&$Obj,&$prjObj) {
		$result='';
		$CyrAdm=& $this->_frm->getStaticModul('mail_adm');
		$Profile=& $this->_frm->getStaticModul('proj_profiles');
		//debug($parentBox);
		if (is_object($Obj) && $this->existsMailFolder($parentBox)) {
			$box=$parentBox.$CyrAdm->getCfg('cfg/delim').trim($Obj->getName());
			if (!$this->existsMailFolder($box)) {
				if ($CyrAdm->imap_login() && $CyrAdm->createmb($box)) {
					$PermsG=Framework::aclToArray($Obj->getMeta('PermsGroup'));
					$PermsU=Framework::aclToArray($Obj->getMeta('PermsUser'));
					$PermsR=Framework::aclToArray($Obj->getMeta('PermsRules'));
					foreach ($PermsR as $key=>$val) {
						$gid=$this->getRuleGroupID($prjObj,$key);
						if ($gid) {
							$PermsG[$gid]=$val;
						}
					}
					if (!empty($PermsU) || !empty($PermsG)) {
						$tmp_acl=$CyrAdm->getacl($box);
						foreach ($tmp_acl as $akey=>$aval) {
							$CyrAdm->deleteacl($box,$akey);
						}
					}
					if (!empty($PermsU)) {
						$rows=0;
						$pUsers=$this->_frm->searchUser($rows,'',array_keys($PermsU));
						if (is_array($pUsers)) {
							foreach ($pUsers as $key=>$val) {
								$CyrAdm->setacl($box, $val['username'], $CyrAdm->getPerms($PermsU[$key]));
							}
						}
					}
					//debug($PermsG);
					if (!empty($PermsG)) {
						$rows=0;
						$pGroups=$this->_frm->getAllGroups(array_keys($PermsG),$prjObj->getID(),'',0,false);
						if (is_array($pGroups)) {
							foreach ($pGroups as $key=>$val) {
								$CyrAdm->setacl($box,$val,$CyrAdm->getPerms($PermsG[$key]),1);
								//debug($CyrAdm->getError());
							}
						}
					}
					$CyrAdm->imap_logout();
					$result=$box;
				} else {
					$this->_addError('Error creating Box:'.$box."\n".$CyrAdm->getError());
				}
			} else {
				$result=$box;
			}
			$subObjs=$Profile->listSubTree(array('ParentID'=>$Obj->getID()));
			foreach ($subObjs as $listObj) {
				$this->_createMailBoxes($box,$listObj,$prjObj);
			}
		} else {
			$this->_addError('Mailfolder not exists:'.$parentBox);
		}
		return $result;
	}
	function deleteMailFolder(&$Obj) {
		$id=$this->existsMailFolder($Obj->getMeta('MailFolder'));
		$CyrAdm=& $this->_frm->getStaticModul('mail_adm');
		if ($id && $CyrAdm->imap_login()) {
			$result=$CyrAdm->recdeletemb($id);
		}
		return $result;
	}
	function renameMailFolder(&$Obj) {
		$id=$this->existsMailFolder($Obj->getMeta('MailFolder'));
		$CyrAdm=& $this->_frm->getStaticModul('mail_adm');
		$Profile=& $this->_frm->getStaticModul('proj_profiles');
		if ($id && $CyrAdm->imap_login()) {
			if (GE_mailUserSuffix) {
				$parentBox='user'.$CyrAdm->getCfg('cfg/delim').$this->getCfg('cfg/ProjectMailBox').GE_mailUserSuffix;
			} else {
				$parentBox='user'.$CyrAdm->getCfg('cfg/delim').$this->getCfg('cfg/ProjectMailBox');
			}
			if ($this->getCfg('cfg/useProfilPath')) {
				$profileObj=$Profile->getObj($Obj->getMeta('FKProfileID'));
				$parentBox.=$CyrAdm->getCfg('cfg/delim').$profileObj->getName();
			}
			$box=$parentBox.$CyrAdm->getCfg('cfg/delim').trim($Obj->getName());
			if ($CyrAdm->renamemb($id,$box)) return $box;
		}
	}
	function existsMailFolder($id) {
		if (trim($id)) {
			$CyrAdm=& $this->_frm->getStaticModul('mail_adm');
			if (is_object($CyrAdm) && $CyrAdm->imap_login()) {
				$boxes=$CyrAdm->GetFolders($id,'%');
				$CyrAdm->imap_logout();
				if (is_array($boxes) && in_array($id,$boxes)) {
					return $id;
				}
			}
		}
		return false;
	}
	function isProjectMailFolder($id) {
		if ($this->getCfg('cfg/ProjectMailBox')) {
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'MailFolder','Typ'=>'!=','Values'=>'');
			$searchQuery[]=array('Typ'=>'SQL','Values'=>"LOCATE(MailFolder,".$this->_db->escape($id).")=1");
			return $this->searchSingleObj($searchQuery);
		}
		return false;
	}

	function createFmngFolder(&$Obj) {
		if ($this->getCfg('cfg/ProjectFmngBox')) {
			$Fmng=& $this->_frm->getStaticModul('fmng');
			$Fmng->setRule(true);
			$rootObj=$Fmng->getObj($this->getCfg('cfg/ProjectFmngBox'));
			$Profile=& $this->_frm->getStaticModul('proj_profiles');
			$headObj=$Profile->getHeadObj($Obj->getMeta('FKProfileID'),'ffol');
			if (is_object($rootObj) && is_object($headObj)) {
				if ($this->getCfg('cfg/useProfilPath')) {
					$profileObj=$Profile->getObj($Obj->getMeta('FKProfileID'));
					$parentObj=$Fmng->searchProfileObj($rootObj->getID(),$profileObj->getName());
					if (!is_object($parentObj)) {
						$parentObj=new FObj_fol();
						$parentObj->setMeta('DocType','fol');
						$parentObj->setMeta('MenuImage','tree.gif');
						$parentObj->setMeta('Version',1);
						$parentObj->setMeta('TimeCreate',time());
						$parentObj->setMeta('TimeModify',time());
						$parentObj->setMeta('UserCreate',$rootObj->getMeta('UserCreate'));
						$parentObj->setMeta('UserModify',$this->_frm->getUser());
						$parentObj->setMeta('Users',$rootObj->getMeta('Users'));
						$parentObj->setMeta('Groups',$rootObj->getMeta('Groups'));
						$parentObj->setParentMeta('ParentID',$rootObj->getID());
						$parentObj->setParentMeta('RootID',$rootObj->getParentMeta('RootID'));
						$parentObj->setParentMeta('UserID',$rootObj->getParentMeta('UserID'));
						foreach ($this->_frm->getAvLang() as $val) {
							$parentObj->setMeta('Title_'.$val,$profileObj->getName());
						}
						if ($Fmng->insertMeta($parentObj)) {
							$Fmng->insertParentMeta($parentObj);
						}
					}
				} else {
					$parentObj=$rootObj;
				}
				$headObj->setMeta('Name',$Obj->getName());
				$result=$this->_createFmngFolders($parentObj,$headObj,$Obj);
			}
			$Fmng->clearRule();
		}
		return $result;
	}
	function _createFmngFolders($parentObj,&$Obj,&$prjObj) {
		$result='';
		$Profile=& $this->_frm->getStaticModul('proj_profiles');
		$Fmng=& $this->_frm->getStaticModul('fmng');
		if (is_object($Obj) && is_object($parentObj)) {
			$PermsG=Framework::aclToArray($Obj->getMeta('PermsGroup'));
			$PermsU=Framework::aclToArray($Obj->getMeta('PermsUser'));
			$PermsR=Framework::aclToArray($Obj->getMeta('PermsRules'));
			foreach ($PermsR as $key=>$val) {
				$gid=$this->getRuleGroupID($prjObj,$key);
				if ($gid) {
					$PermsG[$gid]=$val;
				}
			}
			$new_obj=new FObj_fol();
			$new_obj->setMeta('DocType','fol');
			$new_obj->setMeta('MenuImage','tree.gif');
			$new_obj->setMeta('Version',1);
			$new_obj->setMeta('TimeCreate',time());
			$new_obj->setMeta('TimeModify',time());
			$new_obj->setMeta('UserCreate',$this->_frm->getUser());
			$new_obj->setMeta('UserModify',$this->_frm->getUser());
			$new_obj->setMeta('Users',Framework::arrayToAcl($PermsU));
			$new_obj->setMeta('Groups',Framework::arrayToAcl($PermsG));
			$new_obj->setParentMeta('ParentID',$parentObj->getID());
			$new_obj->setParentMeta('RootID',$parentObj->getParentMeta('RootID'));
			$new_obj->setParentMeta('UserID',$parentObj->getParentMeta('UserID'));
			foreach ($this->_frm->getAvLang() as $val) {
				$new_obj->setMeta('Title_'.$val,trim($Obj->getName()));
			}
			if ($Fmng->insertMeta($new_obj)) {
				$Fmng->insertParentMeta($new_obj);
				$result=$new_obj->getID();
				$subObjs=$Profile->listSubTree(array('ParentID'=>$Obj->getID()));
				foreach ($subObjs as $listObj) {
					$this->_createFmngFolders($new_obj,$listObj,$prjObj);
				}
			}
		}
		return $result;
	}
	function renameFmngFolder(&$Obj) {
		$result=false;
		$id=$this->existsFmngFolder($Obj->getMeta('FmngFolder'));
		$Profile=& $this->_frm->getStaticModul('proj_profiles');
		$Fmng=& $this->_frm->getStaticModul('fmng');
		$Fmng->setRule(true);
		$rootObj=$Fmng->getObj($this->getCfg('cfg/ProjectFmngBox'));
		$Fobj=$Fmng->getObj($id);
		if (is_object($Fobj)) {
			foreach ($this->_frm->getAvLang() as $val) {
				$Fobj->setMeta('Title_'.$val,trim($Obj->getName()));
			}
			if ($this->getCfg('cfg/useProfilPath')) {
				$profileObj=$Profile->getObj($Obj->getMeta('FKProfileID'));
				$parentObj=$Fmng->searchProfileObj($rootObj->getID(),$profileObj->getName());
				if (!is_object($parentObj)) {
					$parentObj=new FObj_fol();
					$parentObj->setMeta('DocType','fol');
					$parentObj->setMeta('MenuImage','tree.gif');
					$parentObj->setMeta('Version',1);
					$parentObj->setMeta('TimeCreate',time());
					$parentObj->setMeta('TimeModify',time());
					$parentObj->setMeta('UserCreate',$rootObj->getMeta('UserCreate'));
					$parentObj->setMeta('UserModify',$this->_frm->getUser());
					$parentObj->setMeta('Users',$rootObj->getMeta('Users'));
					$parentObj->setMeta('Groups',$rootObj->getMeta('Groups'));
					$parentObj->setParentMeta('ParentID',$rootObj->getID());
					$parentObj->setParentMeta('RootID',$rootObj->getParentMeta('RootID'));
					$parentObj->setParentMeta('UserID',$rootObj->getParentMeta('UserID'));
					foreach ($this->_frm->getAvLang() as $val) {
						$parentObj->setMeta('Title_'.$val,$profileObj->getName());
					}
					if ($Fmng->insertMeta($parentObj)) {
						$Fmng->insertParentMeta($parentObj);
					}
				}
			} else {
				$parentObj=$rootObj;
			}
			$Fobj->setParentMeta('ParentID',$parentObj->getID());
			$Fobj->setParentMeta('RootID',$parentObj->getParentMeta('RootID'));
			$Fobj->setParentMeta('UserID',$parentObj->getParentMeta('UserID'));
			if ($Fmng->updateMeta($Fobj)) {
				$Fmng->updateParentMeta($Fobj);
				$result=$id;
			}
		}
		$Fmng->clearRule();
		return $result;
	}
	function deleteFmngFolder(&$Obj) {
		$id=$this->existsFmngFolder($Obj->getMeta('FmngFolder'));
		return $this->_deleteFmngFolders($id);

	}
	function _deleteFmngFolders($parentID) {
		$result=false;
		$Fmng=& $this->_frm->getStaticModul('fmng');
		$Fmng->setRule(true);
		$Fobj=$Fmng->getObj($parentID);
		//debug($parentBox);
		if (is_object($Fobj)) {
			if ($Fobj->isFolder()) {
				$sub_entrys=$Fmng->ListSubEntrys($Fobj->getID());
				foreach ($sub_entrys as $tmp_obj) {
					$this->_deleteFmngFolders($tmp_obj->getID());
				}
			}
			switch ($Fobj->getMeta('DocType')) {
				case 'ext':
					if ($Fobj->getMeta('Content')==$Fobj->getID()) {
						$Fmng->deleteFile($Fmng->getModul(),$Fobj->getMeta('Content'));
					}
				break;
				case 'fol':
					$Fmng->deleteOrder($Fobj->getID());
				break;
			}
			$Fmng->deleteParentMeta($Fobj);
			$Fmng->deleteMeta($Fobj);
			$result=$parentID;
		}
		$Fmng->clearRule();
		return $result;

	}
	function existsFmngFolder($id) {
		$result=false;
		if (trim($id)) {
			$Fmng=& $this->_frm->getStaticModul('fmng');
			$Fmng->setRule(true);
			$Fobj=$Fmng->getObj($id);
			if (is_object($Fobj)) {
				$result=$id;
			}
			$Fmng->clearRule();
		}
		return $result;
	}
	function isProjectFmngFolder($id) {
		if ($this->getCfg('cfg/ProjectFmngBox')) {
			$Fmng=& $this->_frm->getStaticModul('fmng');
			$tree=$Fmng->getObjTreeIDs ($id,$this->getCfg('cfg/ProjectFmngBox'));
			if (in_array($this->getCfg('cfg/ProjectFmngBox'),$tree)) {
				array_unshift($tree,$id);
				$searchQuery=array();
				$searchQuery[]=array('Field'=>'FmngFolder','Typ'=>'=','Values'=>$tree);
				return $this->searchSingleObj($searchQuery);
			}
		}
		return false;
	}
	function isProjectFmngRootFolder($id) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FmngFolder','Typ'=>'=','Values'=>$id);
		return $this->searchSingleObj($searchQuery);
	}
	function createZefFolder(&$Obj) {
		$result='';
		$Zef=& $this->_frm->getStaticModul('zef');
		$Profile=& $this->_frm->getStaticModul('proj_profiles');
		$headObj=$Profile->getHeadObj($Obj->getMeta('FKProfileID'),'zfol');
		if (is_object($headObj)) {
			$zefPermsG=Framework::aclToArray($headObj->getMeta('PermsGroup'));
			$zefPermsU=Framework::aclToArray($headObj->getMeta('PermsUser'));
			$perms_r=Framework::aclToArray($headObj->getMeta('PermsRules'));
			foreach ($perms_r as $key=>$val) {
				$gid=$this->getRuleGroupID($Obj,$key);
				if ($gid) {
					$zefPermsG[$gid]=$val;
				}
			}
			$zefObj=array(
				'zefName'=>$Obj->getName(),
				'zefAktiv'=>$Obj->getMeta('Aktiv'),
				'zefTimeCreate'=>time(),
				'zefUserCreate'=>$this->_frm->getUser(),
				'PermsGroup'=>Framework::arrayToAcl($zefPermsG),
				'PermsUser'=>Framework::arrayToAcl($zefPermsU),
			);
			if (!$Obj->getMeta('Aktiv')) {
				$zefObj['zefTimeAktiv']=time();
				$zefObj['zefUserAktiv']=$this->_frm->getUser();
			}
			//debug($zefObj);
			if ($zefID=$Zef->insertPrj($zefObj)) {
				$result=$zefID;
				$AddOn=unserialize($headObj->getMeta('AddOn'));
				if (is_array($AddOn['ZefCat']) && !empty($AddOn['ZefCat'])) {
					foreach ($AddOn['ZefCat'] as $cat_id=>$cat_val) {
						$Zef->replacePrjCat($zefID,$cat_id,$cat_val['soll']);
					}
				}
			}
		}
		return $result;
	}
	function deleteZefFolder(&$Obj) {
		$Entry=$this->existsZefFolder($Obj->getMeta('ZefFolder'));
		$Zef=& $this->_frm->getStaticModul('zef');
		if ($Entry['zefPrjID']) {
			$Zef->deleteAllPrjEntries($Entry['zefPrjID']);
			return $Zef->deletePrj($Entry['zefPrjID']);
		}
		return $result;
	}
	function renameZefFolder(&$Obj) {
		$Entry=$this->existsZefFolder($Obj->getMeta('ZefFolder'));
		$Zef=& $this->_frm->getStaticModul('zef');
		if ($Entry['zefPrjID']) {
			$Entry['zefName']=$Obj->getName();
			if ($Zef->updatePrj($Entry['zefPrjID'],$Entry)) {
				return $Entry['zefPrjID'];
			}
		}
	}
	function updateZefFolder(&$Obj) {
		$Entry=$this->existsZefFolder($Obj->getMeta('ZefFolder'));
		$Zef=& $this->_frm->getStaticModul('zef');
		if ($Entry['zefPrjID'] && $Entry['zefAktiv']!=$Obj->getMeta('Aktiv')) {
			$Entry['zefAktiv']=$Obj->getMeta('Aktiv');
			if (!$Obj->getMeta('Aktiv')) {
				$Entry['zefTimeAktiv']=time();
				$Entry['zefUserAktiv']=$this->_frm->getUser();
			}
			if ($Zef->updatePrj($Entry['zefPrjID'],$Entry)) {
				return $Entry['zefPrjID'];
			}
		}
	}
	function existsZefFolder($id) {
		if (trim($id)) {
			$Zef=& $this->_frm->getStaticModul('zef');
			$Entry=$Zef->readPrj($id);
			if ($Entry) {
				return $Entry;
			}
		}
		return false;
	}
	function isProjectZefFolder($id) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'ZefFolder','Typ'=>'=','Values'=>$id);
		return $this->searchSingleObj($searchQuery);
	}

	function saveProjectPerms($prjID,$Modul,$perms,$docID=0) {
		$perms['FKProjID']=$prjID;
		$perms['FKModul']=$Modul;
		$perms['FKDocID']=$docID;
		$this->_db->insert('ProjPerms',$perms,'',1);
	}
	function deleteProjectPerms($prjID,$Modul) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$prjID);
		$searchQuery[]=array('Field'=>'FKModul','Typ'=>'=','Values'=>$Modul);
		$this->_db->delete('ProjPerms',$searchQuery);
	}
	function getProjectPerms($prjID,$Modul,$docID=0) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$prjID);
		$searchQuery[]=array('Field'=>'FKModul','Typ'=>'=','Values'=>$Modul);
		$searchQuery[]=array('Field'=>'FKDocID','Typ'=>'=','Values'=>$docID);
		$query="SELECT * FROM ProjPerms WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$result=array(
				'PermsUser'=>$this->_db->f('PermsUser'),
				'PermsGroup'=>$this->_db->f('PermsGroup'),
			);
		}
		return $result;
	}
	function getAllProjectPerms($prjID,$Modul) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$prjID);
		$searchQuery[]=array('Field'=>'FKModul','Typ'=>'=','Values'=>$Modul);
		$query="SELECT * FROM ProjPerms WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('FKDocID')]=array(
				'PermsUser'=>$this->_db->f('PermsUser'),
				'PermsGroup'=>$this->_db->f('PermsGroup'),
			);
		}
		return $result;
	}
	function checkProjectPerms($prjID,$Modul,$uid=0,$gid=0,$docId=0) {
		if (!$uid) $uid=$this->_uid;
		if (!$gid) $gid=$this->_gid;
		$perms=$this->getProjectPerms($prjID,$Modul,$docId);
		return $this->getProjectPermsAcl($perms,$uid,$gid);
	}
	function getProjectPermsAcl($perms,$uid=0,$gid=0) {
		if (!$uid) $uid=$this->_uid;
		if (!$gid) $gid=$this->_gid;
		$acl=0;
		$perms_u=Framework::aclToArray($perms['PermsUser']);
		if (isset($perms_u[$uid])) {
			$acl=$perms_u[$uid];
		} elseif(is_array($gid)) {
			$perms_g=Framework::aclToArray($perms['PermsGroup']);
			foreach ($gid as $val) {
				if (isset($perms_g[$val])) $acl=$acl|$perms_g[$val];
			}

		}
		return $acl;
	}


	function createSmbFolder(&$Obj) {
		if ($this->getCfg('cfg/ProjectSmbBox')) {
			$Smb=& $this->_frm->getStaticModul('smb');
			$sObj=$Smb->getAdminShareObj($this->getCfg('cfg/ProjectSmbBox'));
			if (is_object($sObj)) {
				$Profile=& $this->_frm->getStaticModul('proj_profiles');
				$headObj=$Profile->getHeadObj($Obj->getMeta('FKProfileID'),'sfol');
				if ($headObj) {
					$Smb->setRule(true);
					$Smb->setRootObj($sObj);
					$Smb->setTempAdmin();

					if ($this->getCfg('cfg/useProfilPath')) {
						$profileObj=$Profile->getObj($Obj->getMeta('FKProfileID'));
						$parentID=$sObj->getID().'/'.$profileObj->getName();
						$parentObj=$Smb->getObj($parentID);
						if (!is_object($parentObj)) {
							for ($i=0;$i<$this->_maxSmbRetrys;$i++) {
								if (!$Smb->createFolder($sObj,$profileObj->getName())) {
									if ($parentObj=$Smb->getObj($parentID)) { 
										$Smb->modifyAcl($parentObj,array('S-1-1-0'),5,0,array(1));
										break;
									}
								}
								sleep(1);
							}
							//debug($i);
						}
					} else {
						$parentObj=$Smb->getObj($sObj->getID());
					}
					if (is_object($parentObj)) {
						$headObj->setMeta('Name',$Obj->getName());
						$result=$this->_createSmbFolders($parentObj,$headObj,$Obj);
					}
					$Smb->delTempAdmin();
					$Smb->clearRule();
				}
			}
		}
		return $result;
	}
	function _createSmbFolders($sObj,&$Obj,&$prjObj) {
		$result='';
		$Profile=& $this->_frm->getStaticModul('proj_profiles');
		$Smb=& $this->_frm->getStaticModul('smb');
		//debug($parentBox);
		if (is_object($Obj) && is_object($sObj)) {
			$PermsG=Framework::aclToArray($Obj->getMeta('PermsGroup'));
			$PermsU=Framework::aclToArray($Obj->getMeta('PermsUser'));
			$PermsR=Framework::aclToArray($Obj->getMeta('PermsRules'));
			foreach ($PermsR as $key=>$val) {
				$gid=$this->getRuleGroupID($prjObj,$key);
				if ($gid) {
					$PermsG[$gid]=$val;
				}
			}
			for ($i=0;$i<$this->_maxSmbRetrys;$i++) {
				if (!$Smb->createFolder($sObj,$Obj->getName())) {
					$newObj=$Smb->getObj($sObj->getID().'/'.$Obj->getName());
					break;
				}
				sleep(1);
			}
			//debug($i);
			if (is_object($newObj)) {
				$result=$newObj->getID();
				if ($GLOBALS['CFG']['USER_CLASS']=='ldap_full') {
					$mAcl=array();
					foreach ($PermsG as $uid=>$acl) {
						$sid=$this->_frm->idToSid($uid,'g');
						if ($sid) {
							$mAcl[$sid][]=array(
								'ACL'=>$acl,
								'Inherit'=>1,
							);
						}
					}
					foreach ($PermsU as $uid=>$acl) {
						$sid=$this->_frm->idToSid($uid,'u');
						if ($sid) {
							$mAcl[$sid][]=array(
								'ACL'=>$acl,
								'Inherit'=>1,
							);
						}
					}
					$Smb->setOnlyExtraAcl($newObj,$mAcl);

					/*$Smb->deleteAllAcl($newObj);
					$mAcl=array();
					foreach ($PermsG as $uid=>$acl) {
						$sid=$this->_frm->idToSid($uid,'g');
						if ($sid) $mAcl[$acl][$sid]=;
					}
					foreach ($PermsU as $uid=>$acl) {
						$sid=$this->_frm->idToSid($uid,'u');
						if ($sid) $mAcl[$acl][]=$sid;
					}
					foreach ($mAcl as $acl=>$Sids) {
						$Smb->modifyAcl($newObj,$Sids,$acl,1,array(1));
					}*/
				}
				$subObjs=$Profile->listSubTree(array('ParentID'=>$Obj->getID()));
				foreach ($subObjs as $listObj) {
					$this->_createSmbFolders($newObj,$listObj,$prjObj);
				}
			}
		}
		return $result;
	}
	function renameSmbFolder(&$Obj) {
		$result=false;
		$id=$this->existsSmbFolder($Obj->getMeta('SmbFolder'));
		$Profile=& $this->_frm->getStaticModul('proj_profiles');
		$Smb=& $this->_frm->getStaticModul('smb');
		$conn=$this->parseSmbFolder($id);
		$sObj=$Smb->getAdminShareObj($conn['CONNECT']);
		if (is_object($sObj)) {
			$Smb->setRule(true);
			$Smb->setRootObj($sObj);
			$Smb->setTempAdmin();
			$smbObj=$Smb->getObj($id);
			if (is_object($smbObj)) {
				if ($this->getCfg('cfg/useProfilPath')) {
					$profileObj=$Profile->getObj($Obj->getMeta('FKProfileID'));
					$parentID=$sObj->getID().'/'.$profileObj->getName();
					$parentObj=$Smb->getObj($parentID);
					if (!is_object($parentObj)) {
						for ($i=0;$i<$this->_maxSmbRetrys;$i++) {
							if (!$Smb->createFolder($sObj,$profileObj->getName())) {
								$parentObj=$Smb->getObj($parentID);
								$Smb->modifyAcl($parentObj,array('S-1-1-0'),5,0,array(1));
								break;
							}
							sleep(1);
						}
						//debug($i);
					}
				} else {
					$parentObj=$Smb->getObj($sObj->getID());
				}
				if (is_object($parentObj)) {
					for ($i=0;$i<$this->_maxSmbRetrys;$i++) {
						if (!$Smb->moveObj($smbObj->getID(),$parentObj->getID().'/'.trim($Obj->getName()))) {
							$result=$parentObj->getID().'/'.trim($Obj->getName());
							break;
						}
						sleep(1);
					}
					//debug($i);
				}

			}
			$Smb->delTempAdmin();
			$Smb->clearRule();
		}
		return $result;
	}
	function deleteSmbFolder(&$Obj) {
		$result=false;
		$id=$this->existsSmbFolder($Obj->getMeta('SmbFolder'));
		if ($id) {
			$Smb=& $this->_frm->getStaticModul('smb');
			$conn=$this->parseSmbFolder($id);
			$sObj=$Smb->getAdminShareObj($conn['CONNECT']);
			if (is_object($sObj)) {
				$Smb->setRule(true);
				$Smb->setRootObj($sObj);
				$Smb->setTempAdmin();
				$smbObj=$Smb->getObj($id);
				if (is_object($smbObj)) {
					for ($i=0;$i<$this->_maxSmbRetrys;$i++) {
						if (!$Smb->deleteObj($smbObj)) {
							$result=$smbObj->getParent();
							break;
						}
						sleep(1);
					}
				}
				$Smb->delTempAdmin();
				$Smb->clearRule();
			}
		}
		return $result;
	}
	function existsSmbFolder($id,$perms=0) {
		if (trim($id)) {
			$Smb=& $this->_frm->getStaticModul('smb');
			$conn=$this->parseSmbFolder($id);
			//debug($conn);
			$sObj=$Smb->getAdminShareObj($conn['CONNECT'],$perms);
			if (is_object($sObj)) {
				$Smb->setRootObj($sObj);
				if (!$perms) {
					$Smb->setRule(true);
					$Smb->setTempAdmin();
				}
				//debug($id);
				$Obj=$Smb->getObj($id);
				//debug($Obj);
				if (!$perms) {
					$Smb->delTempAdmin();
					$Smb->clearRule();
				}

				if (is_object($Obj)) {
					return $id;
				}
			}
		}
		return false;
	}
	function isProjectSmbFolder($id) {
		if ($this->getCfg('cfg/ProjectSmbBox')) {
			$conn=$this->parseSmbFolder($id);
			if ($conn['CONNECT']) {
				$searchQuery=array();
				$searchQuery[]=array('Field'=>'SmbFolder','Typ'=>'!=','Values'=>'');
				$searchQuery[]=array('Typ'=>'SQL','Values'=>"LOCATE(SmbFolder,".$this->_db->escape($id).")=1");

				return $this->searchSingleObj($searchQuery);
			}
		}
		return false;
	}
	function parseSmbFolder($id) {
		$a = ($id <> '') ? split('/',$id) : array();
		for ($i=0, $ap=array(); $i<count($a); $i++) {
			switch ($i) {
				case 0:
					$result['WORKGROUP']=$a[$i];
				break;
				case 1:
					$result['SERVER']=$a[$i];
				break;
				case 2:
					$result['SHARE']=$a[$i];
				break;
				default:
					$ap[] = $a[$i];
			}
		}
		$result['PATH']=join('/', $ap);
		$result['CONNECT']=$result['WORKGROUP'].'/'.$result['SERVER'].'/'.$result['SHARE'];
		return $result;
	}
	function insertFavorite($prjID,$extID,$Typ,$extTxtID='',$uid=0) {
		if (!$uid) $uid=$this->_uid;
		$insert=array(
			'FKProjID'=>$prjID,
			'FKUserID'=>$uid,
			'FavTyp'=>$Typ,
			'FavID'=>$extID,
			'FavTxtID'=>$extTxtID,
		);
		$this->_db->insert('ProjHotList',$insert,'',1);
	}
	function deleteFavorite($prjID,$extID,$Typ,$extTxtID='',$uid=0) {
		if (!$uid) $uid=$this->_uid;
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$prjID);
		if ($uid!=-1) $searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$uid);
		if ($Typ) $searchQuery[]=array('Field'=>'FavTyp','Typ'=>'=','Values'=>$Typ);
		if ($extID) $searchQuery[]=array('Field'=>'FavID','Typ'=>'=','Values'=>$extID);
		if ($extTxtID) $searchQuery[]=array('Field'=>'FavTxtID','Typ'=>'=','Values'=>$extTxtID);
		$this->_db->query('DELETE FROM ProjHotList WHERE '.$this->_db->getWhere($searchQuery));
	}
	function isFavorite($prjID,$extID,$Typ,$uid=0) {
		if (!$uid) $uid=$this->_uid;
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$prjID);
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$uid);
		$searchQuery[]=array('Field'=>'FavTyp','Typ'=>'=','Values'=>$Typ);
		$searchQuery[]=array('Field'=>'FavID','Typ'=>'=','Values'=>$extID);
		$this->_db->query('SELECT FavID,FavTxtID FROM ProjHotList WHERE '.$this->_db->getWhere($searchQuery));
		if ($this->_db->next_record()) {
			return true;
		} else {
			return false;
		}
		return $result;
	}
	function hasTypFavorite($Typ,$prjID=0,$uid=0) {
		if (!$uid) $uid=$this->_uid;
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FavTyp','Typ'=>'=','Values'=>$Typ);
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$uid);
		if ($prjID) $searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$prjID);
		$this->_db->query('SELECT FavID FROM ProjHotList WHERE '.$this->_db->getWhere($searchQuery).' LIMIT 1');
		if ($this->_db->next_record()) {
			return true;
		} else {
			return false;
		}
		return $result;
	}
	function getFavorite($prjID,$Typ,$uid=0) {
		if (!$uid) $uid=$this->_uid;
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$prjID);
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$uid);
		$searchQuery[]=array('Field'=>'FavTyp','Typ'=>'=','Values'=>$Typ);
		$this->_db->query('SELECT FavID,FavTxtID FROM ProjHotList WHERE '.$this->_db->getWhere($searchQuery));
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('FavID')?$this->_db->f('FavID'):$this->_db->f('FavTxtID');
		}
		return $result;
	}
	function insertProjectArchiv($insert) {
		$insert['ID']=$this->_db->nextid('ProjArchiv');
		$insert['UserCreate']=$this->_uid;
		$insert['TimeCreate']=time();
		$this->_db->insert('ProjArchiv',$insert);
	}
	function listProjectArchiv() {
		$result=array();
		$query="SELECT ID,FKPrjID,UserCreate,TimeCreate,ArchivConfig,ArchivModul FROM ProjArchiv ORDER BY TimeCreate DESC";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('ID')]=array(
				'FKPrjID'=>$this->_db->f('FKPrjID'),
				'UserCreate'=>$this->_db->f('UserCreate'),
				'TimeCreate'=>$this->_db->f('TimeCreate'),
				'ArchivConfig'=>$this->_db->f('ArchivConfig'),
				'ArchivModul'=>$this->_db->f('ArchivModul'),
				/*'ArchivLog'=>$this->_db->f('ArchivLog'),*/
			);
		}
		return $result;
	}
	function readProjectArchiv($ID) {
		if ($ID) {
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'ID','Typ'=>'=','Values'=>$ID);
			$this->_db->query('SELECT * FROM ProjArchiv WHERE '.$this->_db->getWhere($searchQuery));
			if ($this->_db->next_record()) {
				return array(
					'ID'=>$this->_db->f('ID'),
					'FKPrjID'=>$this->_db->f('FKPrjID'),
					'UserCreate'=>$this->_db->f('UserCreate'),
					'TimeCreate'=>$this->_db->f('TimeCreate'),
					'ArchivConfig'=>$this->_db->f('ArchivConfig'),
					'ArchivModul'=>$this->_db->f('ArchivModul'),
					'ArchivLog'=>$this->_db->f('ArchivLog'),
				);
			}
		}
	}
	function deleteProjectArchivLog($ID) {
		if ($ID) {
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'ID','Typ'=>'=','Values'=>$ID);
			return $this->_db->query('DELETE FROM ProjArchiv WHERE '.$this->_db->getWhere($searchQuery));
		}
	}
	function addCrmMetaList(&$Obj) {
		foreach ($this->_uFormData->getListFields() as $key=>$val) {
			$Obj->setUserMeta($val,$this->_db->f($val));
		}
	}
	function addCrmMeta(&$Obj) {
		foreach ($this->_uFormData->getMetaFields() as $key=>$val) {
			$Obj->setUserMeta($val,$this->_db->f($val));
		}
	}
	function insertSearchTemp($Data) {
		$this->_frm->setUserData($this->getModul(),'searchTemp',$Data);
	}
	function readSearchTemp($onlyVal=false) {
		$result=$this->_frm->getUserData($this->getModul(),'searchTemp');
		return unserialize($result);
	}


	function getNextSearchID() {
		$query="SELECT max(SearchID) as num FROM ProjSearch ";
		$this->_db->query($query);
		$this->_db->next_record();
		return (intval($this->_db->f("num")) + 1);
	}
	function insertSearch($Data,$ID=NULL) {
		if (!isset($ID)) $ID=$this->getNextSearchID();
		$Data['SearchID']=$ID;
		$Data['FKUserID']=$this->_uid;
		//debug($Data);
		$this->_db->insert('ProjSearch',$Data,'',1);
		return $ID;
	}
	function updatSearch($ID,$Data) {
		$this->_db->update('ProjSearch',$Data,"SearchID=".$this->_db->escape($ID));
	}
	function readSearch($ID) {
		$query="SELECT * FROM ProjSearch WHERE SearchID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$result=array(
				'Title'=>$this->_db->f("Title"),
				'FKUserID'=>$this->_db->f("FKUserID"),
				'Groups'=>$this->_db->f("Groups"),
				'Users'=>$this->_db->f("Users"),
				'Sdata'=>$this->_db->f("Sdata"),
				'Mlist'=>$this->_db->f("Mlist"),
				'Flist'=>$this->_db->f("Flist"),
			);
			return $result;
		} else {
			return false;
		}
	}
	function listSearch($only_mail=false,$only_fax=false) {
		$result=array();
		$query="SELECT SearchID,Title,FKUserID FROM ProjSearch";
		$query.=" WHERE (FKUserID=".$this->_db->escape($this->_uid)." OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";
		if ($only_mail) $query.=" AND Mlist=1";
		if ($only_fax) $query.=" AND Flist=1";
		$query.=" ORDER BY Title";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("SearchID")]=array(
				'Title'=>$this->_db->f("Title"),
				'FKUserID'=>$this->_db->f("FKUserID"),
			);
		}
		return $result;
	}
	function deleteSearch($ID=NULL,$uid=0) {
		if (!$uid) $uid=$this->_uid;
		$query="DELETE FROM ProjSearch WHERE FKUserID=".$this->_db->escape($uid);
		if (isset($ID)) $query.=" AND SearchID=".$this->_db->escape($ID);
		$this->_db->query($query);
	}

	function getNextProjectNumber($Profile,&$tras_array,$formatCode='') {
		if (!$formatCode) $formatCode=$this->getCfg('cfg/prjNumberFormat');
		if (!$formatCode) $formatCode='{C}';
		$numDigits=$this->getCfg('cfg/prjNumberDigits')?$this->getCfg('cfg/prjNumberDigits'):3;
		$tras_array=array(
			'{Y}'=>date('Y'),
			'{y}'=>date('y'),
			'{M}'=>date('m'),
			'{D}'=>date('d'),
			'{P_S}'=>$Profile->getMeta('NameShort'),
		);
		$counters=array();
		if (strpos($formatCode,'{C}')!==false) {
			$query="SELECT count(*) as num FROM ProjMetabase";
			$this->_db->query($query);
			$this->_db->next_record();
			$counters['{C}']=intval($this->_db->f('num'))+1;
			$tras_array['{C}']=sprintf('%0'.$numDigits.'d',$counters['{C}']);
		}
		if (strpos($formatCode,'{YC}')!==false) {
			$query="SELECT count(*) as num FROM ProjMetabase WHERE YEAR(FROM_UNIXTIME(TimeCreate))=".$this->_db->escape(date('Y'));
			$this->_db->query($query);
			$this->_db->next_record();
			$counters['{YC}']=intval($this->_db->f('num'))+1;
			$tras_array['{YC}']=sprintf('%0'.$numDigits.'d',$counters['{YC}']);
		}
		if (strpos($formatCode,'{P_C}')!==false) {
			$query="SELECT count(*) as num FROM ProjMetabase WHERE FKProfileID=".$this->_db->escape($Profile->getID());
			$this->_db->query($query);
			$this->_db->next_record();
			$counters['{P_C}']=intval($this->_db->f('num'))+1;
			$tras_array['{P_C}']=sprintf('%0'.$numDigits.'d',$counters['{P_C}']);
		}
		if (strpos($formatCode,'{P_YC}')!==false) {
			$query="SELECT count(*) as num FROM ProjMetabase WHERE FKProfileID=".$this->_db->escape($Profile->getID())." AND YEAR(FROM_UNIXTIME(TimeCreate))=".$this->_db->escape(date('Y'));
			$this->_db->query($query);
			$this->_db->next_record();
			$counters['{P_YC}']=intval($this->_db->f('num'))+1;
			$tras_array['{P_YC}']=sprintf('%0'.$numDigits.'d',$counters['{P_YC}']);
		}
		$result=strtr($formatCode,$tras_array);
		if (!empty($counters)) {
			while ($this->numberExists($result)) {
				foreach(array_keys($counters) as $key) {
					$counters[$key]++;
					$tras_array[$key]=sprintf('%0'.$numDigits.'d',$counters[$key]);
				}
				$result=strtr($formatCode,$tras_array);
				//debug($result);
			}
		}
		return $result;

	}
	function &searchMyPrjAdv(&$rows,$search=null,$useUserFields='',$b=0,$limit=0,$order="ProjMetabase.Title ASC",$extra=null) {
		if ($useUserFields) {
			if ($useUserFields=='all') {
				$lFields=$this->_uFormData->getMetaFields();
			} else {
				$lFields=$this->_uFormData->getListFields();
			}
			if (!empty($lFields)) {
				$extra['addUserJoin']=true;
				$params['FIELDS']='ProjMetabaseUser.'.implode(',ProjMetabaseUser.',$lFields);
				if ($useUserFields=='all') {
					$params['CALLBACK']=array($this,'addCrmMeta');
				} else {
					$params['CALLBACK']=array($this,'addCrmMetaList');
				}

			}
		}
		if ($extra['addUserJoin']) {
			$params['JOIN'].=" LEFT JOIN ProjMetabaseUser ON (ProjMetabase.ProjID=ProjMetabaseUser.FKObjID AND ProjMetabaseUser.FKModul='proj')";
		}
		if ($extra['addJoin']) {
			$params['JOIN'].=' '.$extra['addJoin'];
		}
		$params['GROUP_FIELD']='ProjMetabase.ProjID';
		$searchQuery=$this->_formatSearchSql($search,$params['JOIN'],0);
		if (!$extra['listAll'] || !$this->isRuleUser()) {
			$params['JOIN'].=' INNER JOIN ProjRules ON (ProjMetabase.ProjID=ProjRules.FKProjID)';
		    if ($extra['use_archiv']==-1) {
			     $this->_gid=$this->_frm->getUserGroups($this->_uid,false,false);
		    }
		    $searchQuery[]=array('Field'=>'ProjRules.FKGroupID','Typ'=>'=','Values'=>$this->_gid);
		} elseif ($extra['use_archiv']!=-1) {
		    $searchQuery[]=array('Field'=>'ProjMetabase.Aktiv','Typ'=>'=','Values'=>1);
		}
		$searchQuery[]=array('Field'=>'ProjMetabase.Deleted','Typ'=>'=','Values'=>'0');
		//debug($searchQuery);
		return $this->searchObj($rows,$searchQuery,$order,$b,$limit,true,false,false,$params);
	}

	function _formatSearchSql(&$search,&$joins,$setID=0) {
		if (!$this->_searchFieldInit) $this->initSearchFields();
		if (is_array($search[$setID]['field'])) {
			$searchQuery=array();
			foreach ($search[$setID]['field'] as $fieldID=>$fieldVal) {
				$Typ='';
				switch ($fieldVal['typ']) {
					case 'global':
						switch ($fieldVal['mode']) {
							case 'lk':
								$Typ='like';
								if (!$fieldVal['value']) $Typ='';
								$fieldVal['value']='%'.$fieldVal['value'].'%';
							break;
							case 'nlk':
								$Typ='!like';
								if (!$fieldVal['value']) $Typ='';
								$fieldVal['value']='%'.$fieldVal['value'].'%';
							break;
							case 'is':
								$Typ='=';
							break;
							case 'nis':
								$Typ='!=';
							break;
							case 'em':
								$Typ='=';
								$fieldVal['value']='';
							break;
							case 'nem':
								$Typ='!=';
								$fieldVal['value']='';
							break;
							case 'gt':
								$Typ='>=';
							break;
							case 'lt':
								$Typ='<=';
							break;
							case 'bg':
								$Typ='like';
								if (!$fieldVal['value']) $Typ='';
								$fieldVal['value']=$fieldVal['value'].'%';
							break;
							case 'nbg':
								$Typ='!like';
								if (!$fieldVal['value']) $Typ='';
								$fieldVal['value']=$fieldVal['value'].'%';
							break;

						}
						if ($Typ) {
							$noEnc=false;
							if ($fieldVal['key']=='all') {
								$Field=array();
								foreach ($this->_searchFields as $sKey=>$sVal) {
									if ($sVal['S']) {
										switch($sVal['T']) {
											case 'blob':
												$Field[]='CONVERT('.$sKey.' USING '.(GE_CHARSET=='UTF-8'?'utf8':'latin1').')';
											break;
											default:
												$Field[]=$sKey;
											break;
										}
									}
								}
								$Val=$fieldVal['value'];
							} else {
								$Field=$fieldVal['key'];
								switch ($this->_searchFields[$fieldVal['key']]['T']) {
									case 'check':
										if ($fieldVal['value']=='Y') {
											$Val=1;
										} elseif ($fieldVal['value']=='N') {
											$Val=-1;
										} else {
											if ($Typ=='!=') {
												$Val='';
											} else {
												$Val=$Field."='' OR ".$Field.' IS NULL';
												$Typ='SQL';
											}
										}
									break;
									case 'num':
										if ($Typ=='like' || $Typ=='!like') {
											$Val=$fieldVal['value'];
										} else {
											$Val=trim($fieldVal['value']);
											$Val=str_replace(constTHOUSEND,'',$Val);
											$Val=str_replace(constDECIMAL,'.',$Val);
											$Val=floatval($Val);
										}
									break;
									case 'date':
										$Val=$this->_db->parseSearchDateSql($fieldVal['value'],$Field,$Typ);
										$noEnc=true;
										//debug($Val);
										//if ($Typ=='=') $Typ='like';
										//if ($Typ=='!=') $Typ='!like';
										//debug($Val);
									break;
									case 'unixdate':
										if ($Typ=='>=') {
											$Val=Framework::parseDate($fieldVal['value'],0,0,0,true);
										}
										if ($Typ=='<=') {
											$Val=Framework::parseDate($fieldVal['value'],23,59,59,true);
										}
										if ($Typ=='=' || $Typ=='!=') {
											$Val1=Framework::parseDate($fieldVal['value'],0,0,0,true);
											$Val2=Framework::parseDate($fieldVal['value'],23,59,59,true);
											if ($Val1) $Val=$Field.'>='.$this->_db->escape($Val1).' AND '.$Field.'<='.$this->_db->escape($Val2);
											$Typ='SQL';
										}
										if (!$Val) $Typ='';

									break;
									case 'select':
									case 'mselect':
									case 'comp':
										if (!$fieldVal['value']) {
											if ($Typ=='!=') {
												$Val='';
											} else {
												$Val=$Field."='' OR ".$Field.' IS NULL';
												$Typ='SQL';
											}
										} else {
											if ($Typ=='!=') $Val='NOT '; else $Val="";
											$Val.=$Field." REGEXP '[[:<:]]".addslashes(preg_quote($fieldVal['value'],''))."[[:>:]]'";
											$Typ='SQL';
										}
										//debug($Val);
									break;
									case 'status':
									case 'status_txt':
										if (!$fieldVal['value']) {
											$Typ='';
										} else {
											//debug($fieldVal);
											$Val=$this->_uFormData->getStatusSql($this->_searchFields[$fieldVal['key']]['F']);
											if ($Val) {
												$Val.=$Typ.$this->_db->escape($fieldVal['value']);
												$Typ='SQL';
											} else {
												$Typ='';
											}

										}
									break;
									case 'fuser':
										if (!$fieldVal['value']) {
											if ($Typ=='!=') {
												$Val='';
											} else {
												$Val=$Field."='' OR ".$Field.' IS NULL';
												$Typ='SQL';
											}
										} else {
											if ($Typ=='!=') $Val='NOT '; else $Val="";
											$Val.=$Field." REGEXP '[[:<:]]u_".addslashes(preg_quote($fieldVal['value'],''))."[[:>:]]'";
											$Typ='SQL';
										}
									break;
									case 'ruser':
										if (!$fieldVal['value']) {
											$Typ='';
										} else {
											$temp=explode('|',$Field);
											$subQuery=array();
											$subQuery[]=array('Field'=>' ProjRules.FKProjID','Typ'=>'F=F','Values'=>'ProjMetabase.ProjID');
											$subQuery[]=array('Field'=>' ProjRules.FKRuleID','Typ'=>'=','Values'=>$temp[1]);
											$subQuery[]=array('Field'=>$temp[0],'Typ'=>$Typ,'Values'=>$this->_frm->getUserGroups($fieldVal['value']));
											$Typ='SQL';
											$Val='EXISTS(SELECT * FROM ProjRules WHERE '.$this->_db->getWhere($subQuery).')';
										}


									break;
									case 'addr':
										if (!$fieldVal['value']) {
											if ($Typ=='!=') {
												$Val='';
											} else {
												$Val=$Field."='' OR ".$Field.' IS NULL';
												$Typ='SQL';
											}
										} else {
											$tmpVal=explode('|',$fieldVal['value']);
											foreach ($tmpVal as $tmpK=>$tmpV) {
												$tmpVal[$tmpK]=$Field." REGEXP '[[:<:]]".addslashes(preg_quote($tmpV,''))."[[:>:]]'";
											}
											if ($Typ=='!=') {
												$Val='NOT '.implode(' AND NOT ',$tmpVal);
											} else {
												$Val=implode(' OR ',$tmpVal);
											}
											//$Val.=$Field." REGEXP '[[:<:]]".addslashes(preg_quote($fieldVal['value'],''))."[[:>:]]'";

											$Typ='SQL';
											//debug($fieldVal['value']);
										}
									break;
									default:
										$Val=$fieldVal['value'];
									break;
								}
							}
							if ($Typ) {
								if (is_array($Field)) {
									if ($Typ=='like' && $fieldVal['mode']!='bg') {
										$searchQuery[]=array('Field'=>$Field,'Typ'=>'concat','Values'=>$Val,'UseCase'=>0,'OnlyWords'=>0);
									} elseif ($Typ=='!like' && $fieldVal['mode']!='nbg') {
										$searchQuery[]=array('Field'=>$Field,'Typ'=>'!concat','Values'=>$Val,'UseCase'=>0,'OnlyWords'=>0);
									} else {
										$subQuery=array();
										foreach ($Field as $Fval) {
											$subQuery[]=array(array('Field'=>$Fval,'Typ'=>$Typ,'Values'=>$Val,'NoEnc'=>$noEnc));
										}
										$searchQuery[]=array('Typ'=>'OR','Values'=>$subQuery);
									}
								} else {
									$searchQuery[]=array('Field'=>$Field,'Typ'=>$Typ,'Values'=>$Val,'NoEnc'=>$noEnc);
								}
							}
						}

					break;
					case 'grp':
						$subQuery=$this->_formatSearchSql($search,$joins,$fieldVal['value']);
						if (!empty($subQuery)) {
							$searchQuery[]=array('Typ'=>'AND','Values'=>$subQuery);
						}
					break;
				}
			}
			if ($search[$setID]['mode']=='and') {
				//debug($searchQuery);
				return $searchQuery;
			} else {
				if (empty($searchQuery)) {
					return $searchQuery;
				} else {
					$subQuery=array();
					foreach ($searchQuery as $val) {
						$subQuery[]=array($val);
					}
					return array(array('Typ'=>'OR','Values'=>$subQuery));
				}

			}
		}
	}


}
?>
