<?php
class ProjectExportGui {
	var $_Base;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_avTables=array();
	var $_cbValue=array();
	var $_statusColors=array(
		'#fff'=>'White',
		'#f00'=>'Red',
		'#0f0'=>'Green',
		'#ff0'=>'Yellow',
		'#00f'=>'Blue',
		'#0ff'=>'Cyan',
		'#ccc'=>'Grey',
		'#000'=>'Black',
	);

	function ProjectExportGui() {
		global $frm,$t,$T,$E,$L;
		$this->_Base=& $frm->getStaticModul('proj');
		$this->_BasePrf=$frm->getStaticModul('proj_profiles');
		$this->_BaseForm=& $frm->getStaticModul('uform');
		$this->_BaseForm->setFormModul('proj');
		$this->_uFormData=$this->_Base->initUform();
		$this->_uFormData->setValueCallBack('date',array(&$this,'formatExcelDate'));
		$this->_uFormData->setValueCallBack('int',array(&$this,'formatNumber'));
		$this->_T=&$T;
		$this->_T->loadModul('uform');
		$this->_t=&$t;
		$this->_frm=&$frm;

		require_once("lib/class_WriteExcel.inc.php");
		$this->_tmp_file=tempnam(Framework::getTempPath(),'xls');
		$this->_Excel =& new writeexcel_workbook($this->_tmp_file);
		$this->_format['date']=& $this->_Excel->addformat(array('num_format' => 'dd.mm.YYYY'));
		$this->_format['bold']=& $this->_Excel->addFormat(array('bold' => 1));
		$this->_format['curr']=& $this->_Excel->addFormat(array('num_format' => '##,#0.00'));
		$this->_format['normal']=& $this->_Excel->addFormat(array('bold' => 0));
	}
	function dump($fname) {
		$this->_Excel->close();
		Framework::dumpFile($this->_tmp_file,$fname,'application/x-msexcel',true);
	}
	function init($config) {
		$this->_config=$config;
		$this->_ExportSheets=array(
			0=>array(
				'Name'=>$this->_T->lang('[[Metadaten]]'),
				'User'=>false,
				'Show'=>true,
				'Multiple'=>false,
			)
		);
		$this->_ExportFields=array(
			0=>array(
				'ProjNumTxt'=>array('User'=>false,'Typ'=>'txt','Vis'=>array()),
				'Title'=>array('User'=>false,'Typ'=>'txt','Vis'=>array()),
				'FKProfileID'=>array('User'=>false,'Typ'=>'prf','Vis'=>array()),
				'Text'=>array('User'=>false,'Typ'=>'txt','Vis'=>array()),
				'Aktiv'=>array('User'=>false,'Typ'=>'txt','Vis'=>array()),
				'TimeCreate'=>array('User'=>false,'Typ'=>'unixdate','Vis'=>array()),
				'UserCreate'=>array('User'=>false,'Typ'=>'user','Vis'=>array()),
				'TimeModify'=>array('User'=>false,'Typ'=>'unixdate','Vis'=>array()),
				'UserModify'=>array('User'=>false,'Typ'=>'user','Vis'=>array()),
			),
		);
		$this->headers=array(
			0=>array(
				'ProjNumTxt'=>array('Name'=>$this->_T->lang('[[Projektnummer]]'),'ExTyp'=>'txt','Show'=>true),
				'Title'=>array('Name'=>$this->_T->lang('[[Projektname]]'),'ExTyp'=>'txt','Show'=>true),
				'FKProfileID'=>array('Name'=>$this->_T->lang('[[Profil]]'),'ExTyp'=>'txt','Show'=>true),
				'Text'=>array('Name'=>$this->_T->lang('[[Beschreibung]]'),'ExTyp'=>'txt','Show'=>true),
				'Aktiv'=>array('Name'=>$this->_T->lang('[[Aktiv]]'),'ExTyp'=>'txt','Show'=>true),
				'TimeCreate'=>array('Name'=>$this->_T->lang('[[Erstellt am]]'),'ExTyp'=>'date','Show'=>true),
				'UserCreate'=>array('Name'=>$this->_T->lang('[[Erstellt von]]'),'ExTyp'=>'txt','Show'=>true),
				'TimeModify'=>array('Name'=>$this->_T->lang('[[Geaendert am]]'),'ExTyp'=>'date','Show'=>true),
				'UserModify'=>array('Name'=>$this->_T->lang('[[Geaendert von]]'),'ExTyp'=>'txt','Show'=>true),
			),
		);
		/*
		 * Dokumentation exportieren
		 * TODO Rechte auf Projekte;
		 * TODO 'OnlyExport'
		 * TODO Daten mssen noch geladen Werden?
		$this->_formFields=$this->_uFormData->getFormFields();
		$this->_BaseFields=& $this->_frm->getStaticModul('uform_fields');
		$QuickForms=$this->_BaseForm->listModulForms();
		foreach ($QuickForms as $FormObj) {
			$this->_BaseFields->setFormObj($FormObj);
			foreach ($this->_BaseFields->listFormFields() as $k=>$v) {
				if (isset($this->_formFields[$k])) {
					foreach($v as $sk=>$sv) {
						$this->_formFields[$k][$sk]=$sv;
					}
					
				} else {
					$this->_formFields[$k]=$v;				}
			};
		}
		*/
		//debug($this->_formFields[0]);
		if (is_array($this->_formFields[0])) {
			foreach ($this->_formFields[0] as $gID=>$gObj) {
				if ($this->_config['onlyExport'] && !$gObj->getMeta('useExport')) continue;
				$this->_ExportSheets[$gID]=array(
					'Name'=>substr($gObj->getName(),0,30),
					'User'=>true,
					'Show'=>$this->_config['showAll']?true:false,
					'Multiple'=>$gObj->getMeta('Multiple'),
					'Vis'=>unserialize($gObj->getMeta('Visibility')),
					'Config'=>unserialize($gObj->getMeta('Config')),
				);
				if ($gObj->getMeta('Multiple')) {
					$this->headers[$gID]['ProjNumTxt']=array(
						'Name'=>$this->_T->lang('[[Projektnummer]]'),
						'ExTyp'=>'txt',
						'Show'=>$this->_config['showAll']?true:false,
					);
				}
				if (is_array($this->_formFields[$gObj->getID()])) {
					foreach ($this->_formFields[$gObj->getID()] as $fID=>$fObj) {
						if ($fObj->getAcl(1)) {
							if ($this->_config['onlyExport'] && !$fObj->getMeta('useExport')) continue;
							$this->headers[$gObj->getMeta('Multiple')?$gID:0][$fID]=array(
								'Name'=>$fObj->getName(),
								'ExTyp'=>$fObj->getMeta('Typ'),
								'Show'=>$this->_config['showAll']?true:false,
							);
							$this->_ExportFields[$gID][$fID]=array(
								'User'=>true,
								'Typ'=>$fObj->getMeta('Typ'),
								'Vis'=>unserialize($fObj->getMeta('Visibility')),
								'Obj'=>$fObj,
							);
						}
					}
				}
			}
		}
			
//debug($this->_formFields);
		
	//	exit;
	}
	function exportList(&$entries) {
		$this->data=array();
		$this->_myPrjRules=$this->_Base->getMyProjectRules(array_keys($entries));
		foreach ($entries as $projVal) {
			$this->formatData($projVal);
		}
		//debug($this->data);
		$hl=0;
		foreach ($this->headers as $tabID=>$headers) {
			if (!$this->_ExportSheets[$tabID]['Show']) continue;
			$worksheet=& $this->_Excel->addworksheet(Framework::convertCharset($this->_ExportSheets[$tabID]['Name'],GE_CHARSET,$this->_config['Charset']));
			$rowNum=0;$colNum=0;
			foreach ($headers as $headVal) {
				if ($headVal['Show']) {
					$worksheet->write($rowNum,$colNum,Framework::convertCharset($headVal['Name'],GE_CHARSET,$this->_config['Charset']),$this->_format['bold']);
					$colNum++;
				}
			}
			if ($colNum && !empty($this->data[$tabID])) {
				foreach ($this->data[$tabID] as $dataRow) {
					$rowNum++;$colNum=0;
					foreach ($headers as $key=>$headVal) {
						if ($headVal['Show']) {
							switch ($headVal['ExTyp']) {
								case 'int':
									$worksheet->write($rowNum,$colNum,$dataRow[$key],$this->_format['curr']);
								break;
								case 'date':
									$worksheet->write($rowNum,$colNum,$dataRow[$key],$this->_format['date']);
								break;
								case 'status':
									if (is_object($dataRow[$key]) && isset($this->_statusColors[$dataRow[$key]->getVal()])) {
										$Color=$this->_statusColors[$dataRow[$key]->getVal()];
										if (!isset($this->_format['status'][$Color])) {
											$this->_format['status'][$Color] =& $this->_Excel->addFormat(array('Align' => 'center','bg_color' =>$Color));
										}
										$worksheet->write($rowNum,$colNum,$Color,$this->_format['status'][$Color]);
									}
								break;
								case 'file':
									if (is_object($dataRow[$key])) {
										$worksheet->write($rowNum,$colNum,Framework::convertCharset($dataRow[$key]->getVal(),GE_CHARSET,$this->_config['Charset']),$this->_format['normal']);
									}
								break;
								default:
									$worksheet->write($rowNum,$colNum,Framework::convertCharset($dataRow[$key],GE_CHARSET,$this->_config['Charset']),$this->_format['normal']);
								break;
							}
							$colNum++;
						}
					}
				}
			}
		}
		//exit;
		//debug($this->data);
	}
	function formatExcelDate($fObj,$val) {
		$result='';
		if ($val && $val!='0000-00-00') {
			$result=$this->_Excel->xl_date_list(Framework::dateSql('Y',$val), Framework::dateSql('m',$val),Framework::dateSql('d',$val));
		}
		return $result;
	}
	function formatNumber($fObj,$val) {
		return $val;
	}
	function formatData(&$projVal) {
		$row=count($this->data[0]);
		foreach ($this->_ExportSheets as $gID=>$gVal) {
			if ($gVal['Multiple']) {
				$gShow=true;
				if ($gVal['Vis']['Field']) {
					$gShow=$this->_uFormData->calcShow(isset($projVal->_meta[$gVal['Vis']['Field']])?$projVal->_meta[$gVal['Vis']['Field']]:$projVal->_umeta['F_'.$gVal['Vis']['Field']],$gVal['Vis']['Mode'],$gVal['Vis']['Value']);
				}
				if ($gShow) {
					$Entries=unserialize($projVal->_umeta['F_'.$gID]);
					if (!is_array($Entries)) $Entries=array();
					if ($gVal['Config']['sortBy'] && is_object($this->_formFields[$gID][$gVal['Config']['sortBy']])) {
						$this->_uFormData->setSort($this->_formFields[$gID][$gVal['Config']['sortBy']],$gVal['Config']['sortDir']);
						uasort($Entries,array($this->_uFormData,'groupSort'));
					}
					foreach ($Entries as $subVal) {
						$subRow=count($this->data[$gID]);
						$this->data[$gID][$subRow]['ProjNumTxt']=$projVal->getMeta('ProjNumTxt');
						if (isset($this->_ExportFields[$gID])) {
							foreach ($this->_ExportFields[$gID] as $fID=>$fVal) {
								$show=true;
								if ($fVal['Vis']['Field']) {
									$show=$this->_uFormData->calcShow(isset($projVal->_meta[$fVal['Vis']['Field']])?$projVal->_meta[$fVal['Vis']['Field']]:$projVal->_umeta['F_'.$fVal['Vis']['Field']],$fVal['Vis']['Mode'],$fVal['Vis']['Value']);
								}
								if ($show) {
									$this->headers[$gID][$fID]['Show']=true;
									$this->headers[$gID]['ProjNumTxt']['Show']=true;
									$this->_ExportSheets[$gID]['Show']=true;
									$this->data[$gID][$subRow][$fID]=$this->_uFormData->Entry2Value($fVal['Obj'],$subVal,'F_'.$fID,'; ');
									if (is_object($this->data[$gID][$subRow][$fID])) {
										$this->data[$gID][$subRow][$fID]=$this->data[$gID][$subRow][$fID]->getVal();
									}
								} else {
									$this->data[$gID][$subRow][$fID]='';
								}
							}
						}
					}
				}
			} else {
				$gShow=true;
				if ($gVal['Vis']['Field']) {
					$gShow=$this->_uFormData->calcShow(isset($projVal->_meta[$gVal['Vis']['Field']])?$projVal->_meta[$gVal['Vis']['Field']]:$projVal->_umeta['F_'.$gVal['Vis']['Field']],$gVal['Vis']['Mode'],$gVal['Vis']['Value']);
				}
				if (isset($this->_ExportFields[$gID])) {
					foreach ($this->_ExportFields[$gID] as $fID=>$fVal) {
						$show=false;
						if ($gShow) {
							$show=true;
							if ($fVal['Vis']['Field']) {
								$show=$this->_uFormData->calcShow(isset($projVal->_meta[$fVal['Vis']['Field']])?$projVal->_meta[$fVal['Vis']['Field']]:$projVal->_umeta['F_'.$fVal['Vis']['Field']],$fVal['Vis']['Mode'],$fVal['Vis']['Value']);
							}
						}
						if ($show) {
							$this->headers[0][$fID]['Show']=true;
							if ($fVal['User']) {
								$this->data[0][$row][$fID]=$this->_uFormData->Entry2Value($fVal['Obj'],$projVal->_umeta,'F_'.$fID,'; ');
								if (is_object($this->data[0][$row][$fID])) {
									$this->data[0][$row][$fID]=$this->data[0][$row][$fID]->getVal();
								}
								//debug($fVal);
								//debug($this->data[0][$row][$fID]);
	
							} else {
								switch($fVal['Typ']) {
									case 'prf':
										$this->data[0][$row][$fID]=$this->_BasePrf->getCachedProfileName($projVal->getMeta($fID));
									break;
									case 'user':
										$this->data[0][$row][$fID]=$this->_frm->getCachedUserName($projVal->getMeta($fID));
									break;
									case 'unixdate':
										$this->data[0][$row][$fID]=$this->_Excel->xl_date_list(date('Y',$projVal->getMeta($fID)),date('m',$projVal->getMeta($fID)),date('d',$projVal->getMeta($fID)));
									break;
									default:
										$this->data[0][$row][$fID]=$projVal->getMeta($fID);
									break;
								}
							}
						} else {
							$this->data[0][$row][$fID]='';
						}
					}
				}
			}
		}
	}
	function addEntry(&$Entry) {
		foreach ($this->_expFields[$Typ] as $key=>$val) {
			//debug($val);
			$worksheet->write($rowNum,$colNum,Framework::convertCharset($val['Title'],GE_CHARSET,$this->_config['Charset']),$this->_format['bold'][0]);
			$colNum++;
		}
		$rowNum++;
		foreach ($entries as $Row=>$Col) {
			$colNum=0;
			if ($this->_config[$Typ]['showMove'] && $Col['zefMoveDate']!='0000-00-00') {
				$hl=1;
			} else {
				$hl=0;
			}

			//if ($rowNum>5) $worksheet->set_row($rowNum,Null,$hlFormat);
			foreach ($this->_expFields[$Typ] as $key=>$val) {
				switch ($val['Typ']) {
					case 'Date':
						if ($Col[$key]!='0000-00-00') {
							$xlsDate=$this->_Excel->xl_date_list(Framework::dateSql('Y',$Col[$key]), Framework::dateSql('m',$Col[$key]),Framework::dateSql('d',$Col[$key]));
							$worksheet->write($rowNum,$colNum,$xlsDate, $this->_format['date'][$hl]);
						}
					break;
					case 'User':
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($this->_frm->getCachedUserName($Col[$key]),GE_CHARSET,$this->_config['Charset']),$this->_format['normal'][$hl]);
					break;
					case 'Comp':
						if ($Col[$key]==-1) {
							$name=$this->_T->lang('[[FIRMENUEBERGREIFEND]]');
						} elseif ($Col[$key]) {
							$name=$this->_Base->getCachedCompanyName($Col[$key]);
						} else {
							$name='-';
						}
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($name,GE_CHARSET,$this->_config['Charset']),$this->_format['normal'][$hl]);
					break;
					case 'Cat':
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($this->_Base->getCachedCatName($Col[$key]),GE_CHARSET,$this->_config['Charset']),$this->_format['normal'][$hl]);
					break;
					case 'Prj':
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($this->_Base->getCachedPrjName($Col[$key]),GE_CHARSET,$this->_config['Charset']),$this->_format['normal'][$hl]);
					break;
					case 'Text':
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($Col[$key],GE_CHARSET,$this->_config['Charset']),$this->_format['normal'][$hl]);
					break;
					case 'Hour':
						$worksheet->write($rowNum,$colNum,$Col[$key]/3600,$this->_format['normal'][$hl]);
					break;
					case 'Cost':
						$worksheet->write($rowNum,$colNum,$Col['zefCosts']*$Col['zefDuration']/3600,$this->_format['curr'][$hl]);
					break;
					case 'Curr':
						$worksheet->write($rowNum,$colNum,$Col[$key],$this->_format['curr'][$hl]);
					break;
					case 'Num':
						$worksheet->write($rowNum,$colNum,$Col[$key],$this->_format['normal'][$hl]);
					break;
					case 'YN':
						$worksheet->write($rowNum,$colNum,$Col[$key]?$this->_T->lang('[[Ja]]'):$this->_T->lang('[[Nein]]'),$this->_format['normal'][$hl]);
					break;
					case 'Deref':
						$worksheet->write($rowNum,$colNum,$Col['FKzefDerefID']?$this->_T->lang('[[Umlage]]'):$this->_T->lang('[[Direkt]]'),$this->_format['normal'][$hl]);
					break;
					case 'cUnit':
						//;
						if ($Col['FKcostTabID']) {
							if (!isset($tabObj[$Col['FKcostTabID']])) {
								$tabObj[$Col['FKcostTabID']]=$this->_Base->readExpensesTable($Col['FKcostTabID']);
							}
							//debug($tabObj[$Col['FKcostTabID']]);
							if ($tabObj[$Col['FKcostTabID']]['tabTyp']==2) {
								if (!isset($tabEntry[$Col['FKcostEntryID']])) {
									$tabEntry[$Col['FKcostEntryID']]=$this->_Base->readExpensesEntry($Col['FKcostEntryID']);
								}
								$Unit=$tabEntry[$Col['FKcostEntryID']]['Unit'];
							} else {
								$Unit=$tabObj[$Col['FKcostTabID']]['tabUnit'];
							}
						} else {
							$Unit='';
						}
						//debug(Framework::convertCharset($Unit,GE_CHARSET,$this->_config['Charset']));
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($Unit,GE_CHARSET,$this->_config['Charset']),$this->_format['normal'][$hl]);

					break;
					default:
						$worksheet->write($rowNum,$colNum,Framework::convertCharset($Col[$key],GE_CHARSET,$this->_config['Charset']),$this->_format['normal'][$hl]);
					break;


				}
				$colNum++;
			}
			$rowNum++;
		}
	}

	function formatEntry(&$Obj) {
		$result=array();

		$result['project']['Number']['Value']=$Obj->getMeta('ProjNumTxt');
		$result['project']['Number']['Show']=1;
		$result['project']['Name']['Value']=$Obj->getMeta('Title');
		$result['project']['Name']['Show']=1;
		$result['project']['Description']['Value']=$Obj->getMeta('Text');
		$result['project']['Description']['Show']=1;
		$result['project']['Profile']['Value']=$this->_BasePrf->getCachedProfileName($Obj->getMeta('FKProfileID'));
		$result['project']['Profile']['Show']=1;
		$result['project']['ProfileID']['Value']=$Obj->getMeta('FKProfileID');
		$result['project']['ProfileID']['Show']=1;
		$result['project']['Owner']['Value']=$this->_frm->getCachedUserName($Obj->getMeta('UserCreate'));
		$result['project']['Owner']['Show']=1;
		$result['project']['OwnerID']['Value']=$Obj->getMeta('UserCreate');
		$result['project']['OwnerID']['Show']=1;
		$avRules=$this->_Base->getAvRules();
		foreach ($avRules as $rkey=>$rval) {
			$userTitles=array();
			$groupID=$this->_Base->getRuleGroupID($Obj,$rkey);
			$users=$this->_frm->getGroupUsers($groupID);
			if (!empty($users)) {
				$userTitles=$this->_frm->getFullName($users);
			}
			$result['project']['Members_'.$rkey]['Value']=$userTitles;
			$result['project']['Members_'.$rkey]['Show']=1;
		}
		return $result;
	}
}
?>