<?php
class ProtokollObjectGui {
	var $_Base;
	var $_Obj;
	var $_T;
	var $_t;
	var $_frm;
	var $_L;
	var $_E;
	var $_avSlots;
	var $_avSelect;
	var $_status='form_view';
	function __construct() {
		global $frm,$t,$T,$E,$L,$Y,$P;
		$this->_Base=& $frm->getStaticModul('prot');
		$this->_BaseSel=$frm->getStaticModul('prot_sel');
		$this->_BaseSlo=$frm->getStaticModul('prot_slo');
		$this->_Fmng=$frm->getStaticModul('fmng');
		$this->_Fmng->setRule(true);
		$this->_T=&$T;
		$this->_T->loadModul('prot');
		$this->_t=&$t;
		$this->_frm=&$frm;
		$this->_E=&$E;
		$this->_L=&$L;
		$this->_lang=$this->_frm->getLang();

	}
	function _handleRequest() {
		$this->_select=array(
			'slo'=>array(),
			'dok'=>array(),
			'inh'=>array(),
			'auf'=>array(),
			'abl'=>array(),
		);
		$this->_select['mode']=array('I'=>$this->_T->lang('[[Eingehend]]'),'O'=>$this->_T->lang('[[Ausgehend]]'));

		$this->_avSlots=$this->_BaseSlo->listObj();
		foreach ($this->_avSlots as $val) {
			if ($val->getACL(2)) {
				$this->_select['slo'][$val->getID()]=$val->getName();
			}
		}
		$this->_avSelect=$this->_BaseSel->listObj();
		foreach ($this->_avSelect as $val) {
			$this->_select[$val->getMeta('protSelTyp')][$val->getID()]=$val->getName();
		}
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->_Base->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->_Base->getModul(),$key);
		if (!$result || empty($result)) $result=$default;
		return $result;
	}
	function setObj($Obj) {
		$this->_Obj=$Obj;
	}
	function getObj() {
		return $this->_Obj;
	}
	function getStatus() {
		return $this->_status;
	}
	function processInsert($mode='') {
		$this->_status='form_view';
		$this->_handleRequest();
		if (empty($this->_select['slo'])) {
			$this->_status='no_slots';
			return false;
		}
		$this->_frm->addJsScript('tpl/'.APP_THEME.'/cjs/applicationProt.js');

		require_once('lib/class_BoxGui.php');
		require_once('lib/class_TemplateGui.php');
		require_once('lib/class_FormGui.php');
		require_once('lib/class_FunctionButtons.php');

		$tplContent=new TemplateGui('core/form_3columns.inc.html');
		$formGui=new FormGui();
		$formGui->setLabelClass('no','error');
		if ($this->_Obj) {
			$disabled=true;
		} else {
			$disabled=false;
		}
		$key="FKprotSlotID";
		if ($disabled) {
			$formGui->addField($key,'text',$this->_T->lang('[[Protokollnummer]]'),$this->_Obj->getMeta('protNumber'),'fields1');
			$formGui->setDisabled($key,$disabled);
		} elseif (count($this->_select['slo'])>1) {
			$formGui->addField($key,'select',$this->_T->lang('[[Protokollslot]]'),$this->getPrefs('defFKprotSlotID',0),'fields1');
			$formGui->setValues($key,$this->_select['slo']);
		} else {
			$formGui->addField($key,'hidden','',key($this->_select['slo']),'fields1');
		}


		$key="protMode";
		$formGui->addField($key,'radiolist_h',$this->_T->lang('[[Protokollart]]'),$this->_Obj?$this->_Obj->getMeta($key):'','fields1');
		$formGui->setValues($key,$this->_select['mode']);
		$formGui->setRequired($key);
		$formGui->setDisabled($key,$disabled);

		$key="FKprotDokID";
		$formGui->addField($key,'select',$this->_T->lang('[[Dokumentart]]'),$this->_Obj?$this->_Obj->getMeta($key):'','fields1');
		$formGui->setValues($key,array(0=>'-') + $this->_select['dok']);
		$formGui->setRequired($key);
		$formGui->setDisabled($key,$disabled);


		$key='_protAddress';
		$mode='a';
		$params=base64_encode(serialize(array()));

		$formGui->addField($key,'ttip',$this->_T->lang('[[Absender/Empfaenger]]'),'','fields1');
		$formGui->setParams($key,array('mode'=>$mode,'params'=>$params,'jsSetFunction'=>'protSetAjaxAddress'));
		$formGui->setNoMeta($key);

		$key="protAddress";
		$formGui->addField($key,'area','',$this->_Obj?$this->_Obj->getMeta($key):'','fields1');
		$formGui->setAttribs($key,array('rows'=>'5'));


		$key="FKprotInhID";
		$formGui->addField($key,'select',$this->_T->lang('[[Ihnaltstyp]]'),$this->_Obj?$this->_Obj->getMeta($key):'','fields1');
		$formGui->setValues($key,array(0=>'-') + $this->_select['inh']);

		$key='FKprotFileID';
		if ($this->_Obj && $this->_Obj->getMeta($key) && ($tmpFile=$this->_Fmng->readFile('prot_FKprotFileID',$this->_Obj->getID()))) {
			$defFKprotFileID=array(
				'tmp_name'=>$tmpFile['FilePath'],
				'name'=>$this->_Obj->getMeta($key),
			);
		} else {
			$defFKprotFileID=array();
		}
		$formGui->addField($key,'cached_file',$this->_T->lang('[[Dateianhang]]'),$defFKprotFileID,'fields1');
		$formGui->setParams($key,array('TmpPath'=>$this->_frm->getDynTempPath()));
		$formGui->setNoMeta($key);

		$key="protSubject";
		$formGui->addField($key,'text',$this->_T->lang('[[Betreff]]'),$this->_Obj?$this->_Obj->getMeta($key):'','fields2');

		$key="protDate";
		$formGui->addField($key,'date',$this->_T->lang('[[Datum Dokument]]'),$this->_Obj?$this->_Obj->getMeta($key):'','fields2');

		$key='FKprotSacID';
		$mode='u';
		$params=base64_encode(serialize(array('MaxEntries'=>1)));
		$lb_params=array('Values'=>array());
		$lb_params['Values'][]=array(
			'Label'=>$this->_T->lang('[[Sachbearbeiter]]'),
			'LabelSep'=>'',
			'mode'=>$mode,
			'app'=>'cal',
			'params'=>$params,
			'FieldVal'=>'_USERS',
		);
		$lb_Invit=new FunctionButtons($key,'ajaxttiplabel',$lb_params);

		$formGui->addField($key,'ttip',$lb_Invit,$this->_Obj?'u_'.$this->_Obj->getMeta($key):'','fields2');
		$formGui->setParams($key,array('mode'=>$mode,'params'=>$params));

		$key="FKprotAufID";
		$formGui->addField($key,'select',$this->_T->lang('[[Auftraggeber]]'),$this->_Obj?$this->_Obj->getMeta($key):'','fields2');
		$formGui->setValues($key,array(0=>'-') + $this->_select['auf']);

		$key="FKprotAblID";
		$formGui->addField($key,'select',$this->_T->lang('[[Ablageort]]'),$this->_Obj?$this->_Obj->getMeta($key):'','fields2');
		$formGui->setValues($key,array(0=>'-') + $this->_select['abl']);

		$key="protNotes";
		$formGui->addField($key,'area',$this->_T->lang('[[Anmerkungen]]'),$this->_Obj?$this->_Obj->getMeta($key):'','fields2');
		$formGui->setAttribs($key,array('rows'=>'5','onkeyup'=>'e7gLimitLen(this,255);'));

		$key="protContent";
		$formGui->addField($key,'html','',$this->_Obj?$this->_Obj->getMeta($key):'','fields4');
		$formGui->setAttribs($key,array('rows'=>20,'cols'=>60,'width'=>'620px'));

		$key='submit';
		$formGui->addField($key,'submit','','','fields3');
		$submitValues=array('insert_x'=>' '.$this->_T->lang('[[Speichern]]').' ');
		if ($this->_Obj && $this->_Base->isRuleUser()) {
			$submitValues['delete_x']=' '.$this->_T->lang('[[Loeschen]]').' ';
			$formGui->setValuesAttribs($key,'delete_x',array('onclick'=>'return lo_form();'));
		}
		$formGui->setValues($key,$submitValues);
		
		if (Framework::getParam('insert_x',0)) {
			$formGui->checkFields();
			if (!$this->_E->isError()) {
				if (!is_object($this->_Obj)) {
					$this->_Obj=new ObjProtocoll();
				}
				$formGui->addMetaToObj($this->_Obj);
				if (!trim($this->_Obj->getMeta('protAddress')) && !trim($_POST['_protAddress_txt'])) {
					$this->_Obj->setMeta('protAddress',trim($_POST['_protAddress_txt']));
				}
				if (trim($this->_Obj->getMeta('protAddress')) && $this->_Obj->getMeta('FKprotInhID')) {
					$this->_Obj->setMeta('protComplete',1);
				} else {
					$this->_Obj->setMeta('protComplete',0);
				}
				if ($this->_Obj->getMeta('FKprotSacID')) $this->_Obj->setMeta('FKprotSacID',substr($this->_Obj->getMeta('FKprotSacID'),2));


				if ($this->_Obj->getID()) {
					$this->_Base->updateObj($this->_Obj);
					$this->_status='update_ok';
				} else {
					$nextID=$this->_Base->getNextID($this->_avSlots[$this->_Obj->getMeta('FKprotSlotID')],true);
					$this->_Obj->setMeta('protNumber',$nextID);
					$this->_Base->insertObj($this->_Obj);
					$this->_status='insert_ok';
				}

				$fileVal=$formGui->getFieldVal('FKprotFileID');
				if (!empty($fileVal)) {
					if ($fileVal['tmp_name']!=$defFKprotFileID['tmp_name'] && !$this->_Fmng->replaceFile(null,'prot_FKprotFileID',$this->_Obj->getID(),$fileVal,0)) {
						$this->_Obj->setMeta('FKprotFileID',$fileVal['name']);
						$this->_Base->updateObj($this->_Obj);
					}
				} else {
					if ($this->_Obj->getMeta('FKprotFileID')) {
						$this->_Fmng->deleteFile('prot_FKprotFileID',$this->_Obj->getID());
						$this->_Obj->setMeta('FKprotFileID','');
						$this->_Base->updateObj($this->_Obj);
					}
				}
				$this->_Obj=$this->_Base->getObj($this->_Obj->getID());

			} else {
				$this->_status='form_error';
			}
		}


		$tplContent->addContent('form1',$formGui,'FORM1',array('','fields1'));
		$tplContent->addContent('form2',$formGui,'FORM2',array('','fields2'));
		$tplContent->addContent('form3',$formGui,'FORM3',array('','fields3'));

		$box=new BoxGui();
		$box->addTab('meta',$this->_T->lang('[[Eintrag erfassen]]'),'#',true);
		$box->setTabContent('meta',$tplContent);
		
		$box->addTab('cont',$this->_T->lang('[[Inhalt]]'),'#',true);
		$box->setTabContent('cont',$formGui,array('','fields4'));
		
		$box->setTabOn('meta');

		return $box;
	}
	function processContent() {
		require_once('lib/class_IFrameGui.php');
		require_once('lib/class_ContentGui.php');
		$Gui=new ContentGui();
		//$this->_status='form_view';
		$permsV=$this->_Base->checkPerms($this->_Obj,4);
		if (!$permsV) {
			$data='PRIVACY';
			$Gui->addContent($data,null,'background:#fff;');
		} else {
			$settings=array();
			$result=new IFrameGui($this->_Obj->getMeta('protContent'),$settings);
			$Gui->addContent($result,null,'padding-top:10px;background:'.APP_BGCOLOR);
		}
		
		return $Gui;
	}
	function processView($mode='') {
		$this->_status='form_view';
		$this->_handleRequest();
		require_once('lib/class_ApplicationListGui.php');

		$permsV=$this->_Base->checkPerms($this->_Obj,4);

		$tabGui=new ApplicationListGui();

		if (!$this->_Obj->getMeta('protComplete')) {
			$tabGui->addRow(2,'top');
			$tabGui->addCol('Title',$this->_T->lang('[[Eintrag unvollstaendig]]'),'','','center',1,'',2);
		}

		$extra=array(
			'Attribs'=>array(
				'style'=>'font-size:20px;',
			),
		);
		$tabGui->addRow($hl=$hl?0:1,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Protokollnummer]]'),'','','',1,'');
		$tabGui->addCol('Name',$this->_Obj->getMeta('protNumber'),'','','',0,'2000',1,'',$extra);

		$tabGui->addRow($hl=$hl?0:1,'');
		$tabGui->addCol('Title',$this->_T->lang('[[Erstellt am]]'),'','','',1,'');
		$tabGui->addCol('Name',date('d.m.Y',$this->_Obj->getMeta('TimeCreate')),'','','',0,'2000',1,'');


		$tabGui->addRow($hl=$hl?0:1,1);
		$tabGui->addCol('Title',$this->_T->lang('[[Protokollart]]'),'','','',1,'');
		$tabGui->addCol('Name',$this->_select['mode'][$this->_Obj->getMeta('protMode')],'','','',0,'2000');

		if (!$permsV) {
			$data='PRIVACY';
		} elseif($this->_Obj->getMeta('FKprotDokID') && ($tmp=$this->_BaseSel->getCachedObj($this->_Obj->getMeta('FKprotDokID')))) {
			$data=$tmp->getName();
		} else {
			$data='-';
		}
		$tabGui->addRow($hl=$hl?0:1,'top');
		$tabGui->addCol('Title',$this->_T->lang('[[Dokumentart]]'),'','','',1,'');
		$tabGui->addCol('Name',$data,'','','',0,'2000');

		$tabGui->addRow($hl=$hl?0:1,'top');
		$tabGui->addCol('Title',$this->_Obj->getMeta('protMode')=='I'?$this->_T->lang('[[Absender]]'):$this->_T->lang('[[Empfaenger]]'),'','','',1,'');
		if (!$permsV) {
			$data='PRIVACY';
		} elseif($this->_Obj->getMeta('protAddress')) {
			$data=$this->_Obj->getMeta('protAddress');
		} else {
			$data='-';
		}
		$tabGui->addCol('Name',$data,'','','',0,'2000');

		if (!$permsV) {
			$data='PRIVACY';
		} elseif($this->_Obj->getMeta('FKprotInhID') && ($tmp=$this->_BaseSel->getCachedObj($this->_Obj->getMeta('FKprotInhID')))) {
			$data=$tmp->getName();
		} else {
			$data='-';
		}
		$tabGui->addRow($hl=$hl?0:1,'top');
		$tabGui->addCol('Title',$this->_T->lang('[[Ihnaltstyp]]'),'','','',1,'');
		$tabGui->addCol('Name',$data,'','','',0,'2000');

		if (!$permsV) {
			$data='PRIVACY';
		} elseif($this->_Obj->getMeta('protSubject')) {
			$data=$this->_Obj->getMeta('protSubject');
		} else {
			$data='-';
		}
		$tabGui->addRow($hl=$hl?0:1,'top');
		$tabGui->addCol('Title',$this->_T->lang('[[Betreff]]'),'','','',1,'');
		$tabGui->addCol('Name',$data,'','','',0,'2000');

		$tabGui->addRow($hl=$hl?0:1,'top');
		$tabGui->addCol('Title',$this->_T->lang('[[Datum Dokument]]'),'','','',1,'');
		$tabGui->addCol('Name',$this->_Obj->getMeta('protDate')!='0000-00-00'?Framework::dateSql('d.m.Y',$this->_Obj->getMeta('protDate')):'-','','','',0,'2000');

		$tabGui->addRow($hl=$hl?0:1,'top');
		$tabGui->addCol('Title',$this->_T->lang('[[Sachbearbeiter]]'),'','','',1,'');
		$tabGui->addCol('Name',$this->_Obj->getMeta('FKprotSacID')?$this->_frm->getCachedUserName($this->_Obj->getMeta('FKprotSacID')):'-','','','',0,'2000');


		if($this->_Obj->getMeta('FKprotAufID') && ($tmp=$this->_BaseSel->getCachedObj($this->_Obj->getMeta('FKprotAufID')))) {
			$data=$tmp->getName();
		} else {
			$data='-';
		}
		$tabGui->addRow($hl=$hl?0:1,'top');
		$tabGui->addCol('Title',$this->_T->lang('[[Auftraggeber]]'),'','','',1,'');
		$tabGui->addCol('Name',$data,'','','',0,'2000');


		$link='';
		$img='';
		if (!$permsV) {
			$data='PRIVACY';
		} elseif($this->_Obj->getMeta('FKprotFileID') && ($tmpFile=$this->_Fmng->readFile('prot_FKprotFileID',$this->_Obj->getID()))) {
			$data=$this->_Obj->getMeta('FKprotFileID');
			if ($mode!='popup') $link=$this->_L->getTempLink(null,array('_dump'=>'FKprotFileID'));
			$img='obj_img/'.$tmpFile['FileImg'];
		} else {
			$data='';
		}
		$tabGui->addRow($hl=$hl?0:1,'top');
		$tabGui->addCol('Title',$this->_T->lang('[[Dateianhang]]'),'','','',1,'');
		$tabGui->addCol('Name',$data,$img,$link,'',0,'2000');



		if($this->_Obj->getMeta('FKprotAblID') && ($tmp=$this->_BaseSel->getCachedObj($this->_Obj->getMeta('FKprotAblID')))) {
			$data=$tmp->getName();
		} else {
			$data='-';
		}
		$tabGui->addRow($hl=$hl?0:1,'top');
		$tabGui->addCol('Title',$this->_T->lang('[[Ablageort]]'),'','','',1,'');
		$tabGui->addCol('Name',$data,'','','',0,'2000');

		if (!$permsV) {
			$data='PRIVACY';
		} elseif($this->_Obj->getMeta('protNotes')) {
			$data=$this->_Obj->getMeta('protNotes');
		} else {
			$data='';
		}
		$tabGui->addRow($hl=$hl?0:1,'top');
		$tabGui->addCol('Title',$this->_T->lang('[[Anmerkungen]]'),'','','',1,'');
		$tabGui->addCol('Name',$data,'','','',0,'2000');

		/*
		*/

		return $tabGui;
	}
}
?>