<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class RegObj {
	var $_meta=array();
	var $_ID;
	var $_action=array('m','m');
	function RegObj ($ID=0,$meta=0,$lang='') {
		if ($meta) $this->_meta=$meta;
		$this->_ID=$ID;
		$this->_lang=$lang;
	}
	function getID() {
		return $this->_ID;
	}
	function setID($ID) {
		$this->_ID=$ID;
	}
	function getMeta($key) {
		return $this->_meta[$key];
	}
	function setMeta($key,$data) {
		$this->_meta[$key]=$data;
	}
	function getName() {
		return $this->_meta['Name_'.$this->_lang];
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.='tree.gif';
		return $image;
	}
	function isFolder() {
		return true;
	}
	function getAction($typ) {
		return $this->_action[$typ];
	}
	function getACL($chk=0) {
		return true;
	}

}
class ActionObj {
	var $_meta=array();
	var $_ID;
	var $_action=array('ov','ov');
	function ActionObj ($ID=0,$meta=0) {
		if ($meta) $this->_meta=$meta;
		$this->_ID=$ID;
	}
	function getID() {
		return $this->_ID;
	}
	function setID($ID) {
		$this->_ID=$ID;
	}
	function getMeta($key) {
		return $this->_meta[$key];
	}
	function setMeta($key,$data) {
		$this->_meta[$key]=$data;
	}
	function getName() {
		return $this->_meta['Name'];
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.='tree.gif';
		return $image;
	}
	function isFolder() {
		return true;
	}
	function getAction($typ) {
		return $this->_action[$typ];
	}
	function getACL($chk=0) {
		return true;
	}

}

class Reg {
	var $_db;
	var $_uid;
	var $_lang;
	var $_gid;
	var $_sadmin=true;
	var $_modul='reg';

	function Reg (&$db,$uid=0,$gid=0,$lang=0) {
		$this->_db=&$db;
		$this->_uid=$uid;
		$this->_lang=$lang;
		$this->_gid=$gid;
	}
	function getModul() {
		return $this->_modul;
	}
	function setUser($uid) {
		$this->_uid=$uid;
	}
	function getUser() {
		return $this->_uid;
	}
	function setGroups($gid) {
		$this->_gid=$gid;
	}
	function setLang($lang) {
		$this->_lang=$lang;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function ListAllTree($modul='',$key='') {
		$query="SELECT *  FROM ModulCfgKeys ";
		$sql_modul=$this->_db->escape($modul);
                if (is_array($modul)) {
			$where[]="FKModul IN (".implode(",",$sql_modul).")";
                } elseif  ($modul) {
			$where[]="FKModul=$sql_modul";
		}
		if ($key) $where.=" CfgKey LIKE ".$this->_db->escape($key);
		if ($where) $query.=" WHERE  ".implode(' AND ',$where);
		$query.=" ORDER BY FKModul,Sequence ";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			if (!$this->_db->f('FKModul')) continue;
			$key=$this->_db->f('FKModul').'/'.$this->_db->f('CfgKey');
			if ($key[strlen($key)-1]=='/') {
				$key=substr($key,0,-1);
			}
			$lastkeypos=strrpos($key,'/');
			$ID=$key;
			$ParentID=substr($key,0,$lastkeypos);
			$result[$ParentID][$ID]=new RegObj($ID,$this->fetchObject(),$this->_lang);


			while ($lastkeypos!==false) {
				$lastkeypos=strrpos($ParentID,'/');
				if ($lastkeypos!==false) {
					$ID=$ParentID;
					$ParentID=substr($ParentID,0,$lastkeypos);
					$Name=substr($ID,$lastkeypos+1);
				} else {
					$ID=$ParentID;
					$Name=$ID;
					$ParentID='1';
				}
				if (!isset($result[$ParentID][$ID])) {
					$values=array('Name_'.$this->_lang=>$Name);
					$result[$ParentID][$ID]=new RegObj($ID,$values,$this->_lang);
				}
			}
		}
		return $result;
	}
	function getObj($Modul,$ID) {
		$query="SELECT * FROM ModulCfgKeys WHERE FKModul=".$this->_db->escape($Modul)." AND ";
		$query.="(CfgKey=".$this->_db->escape($ID)." OR CfgKey=".$this->_db->escape($ID.'/').")";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return new RegObj($this->_db->f('CfgKey'),$this->fetchObject(),$this->_lang);
		}
	}
	function fetchObject() {
		return array(
				'CfgKey'=>$this->_db->f('CfgKey'),
				'Sequence'=>$this->_db->f('Sequence'),
				'FKModul'=>$this->_db->f('FKModul'),
				'Name_de'=>$this->_db->f('Name_de'),
				'Name_it'=>$this->_db->f('Name_it'),
				'Name_en'=>$this->_db->f('Name_en'),
				'Name_fr'=>$this->_db->f('Name_fr'),
				'Name_es'=>$this->_db->f('Name_es'),
				'FieldTyp'=>$this->_db->f('FieldTyp'),
				'Size'=>$this->_db->f('Size'),
				'CfgVal'=>$this->_db->f('CfgVal'),
			);
	}
	function fetchDefault() {
		return array(
				'FKModul'=>$this->_db->f('FKModul'),
				'FKCfgKey'=>$this->_db->f('CfgKey'),
				'FKObjID'=>0,
				'CfgVal'=>$this->_db->f('CfgVal'),
			);
	}
	function update($Modul,$ID,$meta) {
		if ($this->_db->update('ModulCfgKeys',$meta, "FKModul=".$this->_db->escape($Modul)." AND CfgKey=".$this->_db->escape($ID))) {
			return true;
		}
		return false;
	}
	function insert($meta) {
		if ($this->_db->insert('ModulCfgKeys',$meta,0,true)) {
			return true;
		}
		return false;
	}
	function delete($Modul,$ID='') {
		$query="DELETE FROM ModulCfgKeys WHERE FKModul=".$this->_db->escape($Modul)."";
		if ($ID) $query.=" AND (CfgKey=".$this->_db->escape($ID)." OR CfgKey LIKE ".$this->_db->escape($ID.'/%').")";
		//echo $query;
		$this->_db->query($query);
		return true;
	}
	function getData($Modul='',$ID='') {
		$result=array();
		$query="SELECT * FROM ModulCfgKeys ";
		if ($Modul) $where[]="FKModul=".$this->_db->escape($Modul)."";
		if ($ID) $where[]="(CfgKey=".$this->_db->escape($ID)." OR CfgKey LIKE ".$this->_db->escape($ID.'/%').")";
		if (is_array($where)) $query.=" WHERE ".implode(' AND ',$where);
		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->fetchObject();
		}
		return $result;
	}
	function getDefaultData($Modul='',$ID='') {
		$result=array();
		$query="SELECT * FROM ModulCfgKeys ";
		$where[]="CfgVal!=''";
		if ($Modul) $where[]="FKModul=".$this->_db->escape($Modul)."";
		if ($ID) $where[]="(CfgKey=".$this->_db->escape($ID)." OR CfgKey LIKE ".$this->_db->escape($ID.'/%').")";
		if (is_array($where)) $query.=" WHERE ".implode(' AND ',$where);
		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->fetchDefault();
		}
		return $result;
	}

	function ListActions ($lang='') {
		$result=array();
		$query="SELECT * FROM ObjAction ";
		$query.=" ORDER BY ActionID";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			if ($lang) {
				$result[$this->_db->f('ActionID')]=$this->_db->f("Name_".$lang);
			} else {
				$result[$this->_db->f('ActionID')]=array(
					'Action'=>$this->_db->f("Action"),
					'Name_de'=>$this->_db->f("Name_de"),
					'Name_it'=>$this->_db->f("Name_it"),
					'Name_en'=>$this->_db->f("Name_en"),
					'Name_fr'=>$this->_db->f("Name_fr"),
				);
			}

		}
		return $result;
	}
	function getActionData($ID=0) {
		$result=array();
		$query="SELECT * FROM ObjAction ";
		if ($ID) $query.=" WHERE ActionID=".intval($ID);
		$query.=" ORDER BY ActionID";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=array(
				'ActionID'=>$this->_db->f("ActionID"),
				'Action'=>$this->_db->f("Action"),
				'Name_de'=>$this->_db->f("Name_de"),
				'Name_it'=>$this->_db->f("Name_it"),
				'Name_en'=>$this->_db->f("Name_en"),
				'Name_fr'=>$this->_db->f("Name_fr"),
			);
		}
		return $result;
	}
	function updateAction($ID,$meta) {
		if ($this->_db->update('ObjAction',$meta, "ActionID=".$this->_db->escape($ID))) {
			return true;
		}
		return false;
	}
	function insertAction($meta) {
		$query="SELECT max(ActionID) as num FROM ObjAction ";
		$this->_db->query($query);
		$this->_db->next_record();
		$meta['ActionID']=intval($this->_db->f("num")) + 1;
		if ($this->_db->insert('ObjAction',$meta)) {
			return $meta['ActionID'];
		}
		return false;
	}
	function replaceAction($meta) {
		if ($this->_db->insert('ObjAction',$meta,0,true)) {
			return true;
		}
		return false;

	}
	function deleteAction($ActionID) {
		$query="DELETE FROM ObjAction WHERE ActionID=".$this->_db->escape($ActionID)."";
		//echo $query;
		$this->_db->query($query);
		return true;
	}
	function ListAVTree($modul='') {
		$query="SELECT ObjActionModul.*,ObjAction.Name_".$this->_lang." as Name  FROM ObjActionModul LEFT JOIN ObjAction ON (ActionID=FKActionID) ";
		$sql_modul=$this->_db->escape($modul);
                if (is_array($modul)) {
			$where[]="Modul IN (".implode(",",$sql_modul).")";
                } elseif  ($modul) {
			$where[]="Modul=$sql_modul";
		}
		if ($where) $query.=" WHERE  ".implode(' AND ',$where);
		$query.=" ORDER BY Modul,Mode,Sequenze ";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			if (!$this->_db->f('Modul')) continue;
			$key=$this->_db->f('Modul').'/'.$this->_db->f('Mode').'/'.$this->_db->f('FKActionID');
			$lastkeypos=strrpos($key,'/');
			$ID=$key;

			$ParentID=substr($key,0,$lastkeypos);
			$result[$ParentID][$ID]=new ActionObj($ID,$this->fetchAVObject());


			while ($lastkeypos!==false) {
				$lastkeypos=strrpos($ParentID,'/');
				if ($lastkeypos!==false) {
					$ID=$ParentID;
					$ParentID=substr($ParentID,0,$lastkeypos);
					$Name=substr($ID,$lastkeypos+1);
				} else {
					$ID=$ParentID;
					$ParentID='1';
					$Name=$ID;
					//echo $ID.'<br>';
				}
				//echo $ParentID.'|'.$ID.'<br>';
				if (!isset($result[$ParentID][$ID])) {
					$values=array('Name'=>$Name);
					$result[$ParentID][$ID]=new ActionObj($ID,$values);
					//debug($result[$ParentID][$ID]);
				}
			}
		}
		return $result;
	}
	function getActionObj($Modul,$Mode,$Action) {
		$query="SELECT ObjActionModul.*,ObjAction.Name_".$this->_lang." as Name FROM ObjActionModul LEFT JOIN ObjAction ON (ActionID=FKActionID) ";
		$query.=" WHERE Modul=".$this->_db->escape($Modul)." AND ";
		$query.=" Mode=".$this->_db->escape($Mode)." AND FKActionID=".$this->_db->escape($Action)."";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return new ActionObj($Modul.'/'.$Mode.'/'.$Action,$this->fetchAVObject());
		}
	}

	function &fetchAVObject() {
		$result=array(
				'FKActionID'=>$this->_db->f('FKActionID'),
				'Modul'=>$this->_db->f('Modul'),
				'Mode'=>$this->_db->f('Mode'),
				'Perms'=>$this->_db->f('Perms'),
				'Extra'=>$this->_db->f('Extra'),
				'Sequenze'=>$this->_db->f('Sequenze'),
				'Hidden'=>$this->_db->f('Hidden'),
				'Custom'=>$this->_db->f('Custom'),
			);
		if ($this->_db->f('Name'))	$result['Name']=$this->_db->f('Name');
		return $result;
	}
	function updateActionObj($Modul,$Mode,$FKActionID,$meta) {
		if ($this->_db->update('ObjActionModul',$meta, "Modul=".$this->_db->escape($Modul)." AND Mode=".$this->_db->escape($Mode)." AND FKActionID=".$this->_db->escape($FKActionID))) {
			return true;
		}
		return false;
	}
	function insertActionObj($meta) {
		if ($this->_db->insert('ObjActionModul',$meta,0,true)) {
			return true;
		}
		return false;
	}
	function deleteActionObj($Modul,$Mode='',$FKActionID='') {
		$query="DELETE FROM ObjActionModul WHERE Modul=".$this->_db->escape($Modul)."";
		if ($Mode) $query.=" AND Mode=".$this->_db->escape($Mode);
		if ($FKActionID) $query.=" AND FKActionID=".$this->_db->escape($FKActionID);

		//echo $query;
		$this->_db->query($query);
		return true;
	}
	function getActionObjData($Modul='',$Mode='',$FKActionID='') {
		$result=array();
		$query="SELECT * FROM ObjActionModul";
		if ($Modul) $where[]="Modul=".$this->_db->escape($Modul)."";
		if ($Mode) $where[]="Mode=".$this->_db->escape($Mode);
		if ($FKActionID) $where[]="FKActionID=".$this->_db->escape($FKActionID);
		if (is_array($where)) $query.=" WHERE ".implode(' AND ',$where);

		$query.=' ORDER BY Modul,Mode,Sequenze';
		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->fetchAVObject();
		}
		return $result;
	}
	function arrayToSql($table,$values) {
		if (!is_array($values) || !count($values)) return false;
		$values=$this->_db->escape($values);
		/*foreach ($values as $key=>$val) {
			if (Framework::convertCharset($val,'UTF-8','ISO-8859-1')!=$val) {
				$values[$key]="'\".convertBlob(".$val.").\"'";
			}
		}*/
		$query.='$query="';
		$query.="REPLACE INTO $table ";
		$query.="(`".implode('`,`',array_keys($values))."`)";
		$query.=" VALUES (".implode(',',$values).");";
		$query.='";'."\n";
		$query.='$db->query($query);';
		return $query;
	}
}
?>
