<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class geRemCtrlAjax{
	private $result;
	private $_frm;
	private $T;
	public function __construct() {
		global $frm,$T;
		$this->_frm=$frm;
		$this->_T=$T;
		$this->_Base=$this->_frm->getStaticModul('rem');
	}
	public function sendRemMessage($params) {
		$this->_T->loadModul('rem');
		$this->result=array(
			'error'=>'',
			'error_msg'=>'',
		);
		if (!$this->_frm->getMyApps('rem')) {
			$this->result['error']='MSG';
			$this->result['error_msg']=$this->_T->lang('[[error_permissions]]');
			return false;
		}
		$msg=new ObjRemMessage();
		$msg->setMeta('rem_userid',$this->_frm->getUser());
		$msg->setMeta('rem_typ',$params['rem_typ']);
		$msg->setMeta('rem_message',$params['rem_message']);
		$msg->setMeta('rem_obj_typ',$params['rem_obj_typ']);
		$msg->setMeta('rem_obj_id',$params['rem_obj_id']);
		$msg->setMeta('rem_obj_name',$params['rem_obj_name']);

		$rem_time=FrameWork::parseSqlDate($params['rem_senddate']);
		$msg->setUserMeta('rem_time',max($rem_time,time()));
		$msg->setUserMeta('rem_status',GE_REM_NEW);
		if (isset($params['rem_sendby']) && is_array($params['rem_sendby'])) {
			if (in_array('mail',$params['rem_sendby'])) $msg->setUserMeta('rem_mail_send',-1);
			if (in_array('msg',$params['rem_sendby'])) $msg->setUserMeta('rem_msg_send',-1);
			if (in_array('sms',$params['rem_sendby'])) $msg->setUserMeta('rem_sms_send',-1);
		}


		if (isset($params['rem_to'])) {
			$to=$params['rem_to'];
		} else {
			$to=$this->_frm->getUser();
		}
		$result=$this->_Base->insertReminder($msg,$to);
		if (!$result) {
			$this->result['error']='GENERIC';
			return false;
		} else {
			$this->result['error']='OK';
			if ($params['rem_id']) {
				$this->_Base->markMoved($params['rem_id'],$msg->getID());
				$this->result['error_msg']=$this->_T->lang('[[Erinnerung wurde verschoben]]');
			} else {
				$this->result['error_msg']=$this->_T->lang('[[Erinnerung wurde erstellt]]');
			}
			
		}
		return false;
	}
	public function remPortalDelete($params) {
		$this->_Base->markDeleted($params['remId']);
		$this->remPortalUpdate($params);
	}
	public function remPortalUpdate($params) {
		require_once('lib/rem/ctrl/geRemCtrlPortal.php');
		$ctrl=new geRemCtrlPortal();
		$Gui=$ctrl->getPortalGui();
		$this->result=array(
			'error'=>'UPDATE',
			'content'=>$Gui->process(),
		);
	}
	public function getResult() {
		return $this->result;
	}
}
?>