<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
define('GE_REM_NEW',0);
define('GE_REM_DELETED',9);

class ObjRemMessage extends baseObj {
	public $_action=array('e','e'); // to owerwrite;
	public $_site='msg.php'; // to owerwrite;
	public $_obj_typ='0';
	public $_umeta=array();
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['Title'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
	function getUserMeta($key) {
		return $this->_umeta[$key];
	}
	function setUserMeta($key,$data) {
		$this->_umeta[$key]=$data;
	}
}


class geRemModelMessage extends ObjCore{
	public $_modul='rem';
	public $_table='RemMessages';
	public $_cfgObjects=array (
		'IdField'=>'rem_id',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'0'=>array(
			'ClassName'=>'ObjRemMessage',
			'Fields'=>array(
				'rem_id'=>array(
					'TYP'=>'int',
					'Extra'=>'ID',
				),
				'rem_userid'=>array(
					'TYP'=>'int',
				),
				'rem_message'=>array(
					'TYP'=>'text',
				),
				'rem_obj_typ'=>array(
					'TYP'=>'text',
				),
				'rem_obj_id'=>array(
					'TYP'=>'text',
				),
				'rem_obj_name'=>array(
					'TYP'=>'text',
				),
				'rem_timemodify'=>array(
					'TYP'=>'int',
					'Extra'=>'mTime',
				),
				'rem_usermodify'=>array(
					'TYP'=>'int',
					'Extra'=>'mUser',
				),
				'rem_deleted'=>array(
					'TYP'=>'core',
				),
			),
		),
	);
	public function __construct() {
		global $frm;
		parent::__construct();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','rem')));
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
	}
	public function insertReminder($msg,$to) {
		if ($this->insertMeta($msg)) {
			return $this->linkReminderTo($msg,$to);
		}
		return false;
	}
	protected function linkReminderTo($msg,$to = null) {
		$num=0;
		/*
		 * rem_status
		 0: Neu
		 9: gelscht
		*/
		$insert=array(
			'fk_rem_id'=>$msg->getID(),
			'rem_time'=>$msg->getUserMeta('rem_time'),
			'rem_status'=>$msg->getUserMeta('rem_status'),
			'rem_mail_send'=>$msg->getUserMeta('rem_mail_send'),
			'rem_sms_send'=>$msg->getUserMeta('rem_sms_send'),
			'rem_msg_send'=>$msg->getUserMeta('rem_msg_send'),
		);
		if (!$to) {
			$to=array($this->_frm->getUser());
		} elseif (!is_array($to)) {
			$to=array($to);
		}
		foreach($to as $uid) {
			$insert['fk_user_id']=$uid;
			$this->_db->insert('RemMessagesUser',$insert,'',1);
			$num++;
		}
		return $num;
	}
	function markDeleted($id) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'fk_rem_id','Typ'=>'=','Values'=>$id);
		$searchQuery[]=array('Field'=>'fk_user_id','Typ'=>'=','Values'=>$this->_frm->getUser());
		$data=array('rem_status'=>GE_REM_DELETED);
		$this->_db->update('RemMessagesUser',$data,$searchQuery);
	}
	function markMoved($id, $toID) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'fk_rem_id','Typ'=>'=','Values'=>$id);
		$searchQuery[]=array('Field'=>'fk_user_id','Typ'=>'=','Values'=>$this->_frm->getUser());
		$data=array('rem_status'=>GE_REM_DELETED,'rem_status_id'=>$toID);
		$this->_db->update('RemMessagesUser',$data,$searchQuery);
	}
	function markSend($id, $modul, $uid=0) {
		if (!$uid) $uid=$this->_frm->getUser();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'fk_rem_id','Typ'=>'=','Values'=>$id);
		$searchQuery[]=array('Field'=>'fk_user_id','Typ'=>'=','Values'=>$uid);
		$data=array('rem_'.$modul.'_send'=>time());
		$this->_db->update('RemMessagesUser',$data,$searchQuery);
	}
	function getReminderStatus($id) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'fk_rem_id','Typ'=>'=','Values'=>$id);
		$searchQuery[]=array('Field'=>'fk_user_id','Typ'=>'=','Values'=>$this->_frm->getUser());
		$query="SELECT rem_status FROM RemMessagesUser WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('rem_status');
		}
	}

	protected function addUserMeta(&$Obj) {
		$Obj->setUserMeta('rem_time',$this->_db->f('rem_time'));
		$Obj->setUserMeta('rem_status',$this->_db->f('rem_status'));
		$Obj->setUserMeta('rem_mail_send',$this->_db->f('rem_mail_send'));
		$Obj->setUserMeta('rem_sms_send',$this->_db->f('rem_sms_send'));
		$Obj->setUserMeta('rem_msg_send',$this->_db->f('rem_msg_send'));
	}
	public function listUserReminders(&$rows,$search,$order='') {
		$searchQuery=array();
		$params=array();
		$params['JOIN']='INNER JOIN RemMessagesUser ON (RemMessagesUser.fk_rem_id=RemMessages.rem_id AND RemMessagesUser.fk_user_id='.$this->_db->escape($this->_frm->getUser()).')';
		$params['CALLBACK']=array($this,'addUserMeta');
		$params['FIELDS']='RemMessagesUser.*';

		if (isset($search['rem_status'])) {
			$searchQuery[]=array('Field'=>'RemMessagesUser.rem_status','Typ'=>'=','Values'=>$search['rem_status']);
		} else {
			$searchQuery[]=array('Field'=>'RemMessagesUser.rem_status','Typ'=>'!=','Values'=>GE_REM_DELETED);
		}
		if (isset($search['rem_time_from'])) {
			$searchQuery[]=array('Field'=>'RemMessagesUser.rem_time','Typ'=>'>=','Values'=>$search['rem_time_from']);
		}
		if (isset($search['rem_time_to'])) {
			$searchQuery[]=array('Field'=>'RemMessagesUser.rem_time','Typ'=>'<=','Values'=>$search['rem_time_to']);
		}
		return $this->searchObj($rows,$searchQuery,$order,$search['b'],$search['limit'],$search['use_limit'],true,false,$params);
	}

	function listAktivReminders() {
		$search=array(
			'b'=>0,
			'limit'=>0,
			'use_limit'=>0,
			'rem_time_to'=>time(),
		);
		$rows=0;
		return $this->listUserReminders($rows,$search,'RemMessagesUser.rem_time ASC');
	}
	function listAllReminders(&$rows,$b=0,$limit=50) {
		$search=array(
			'b'=>$b,
			'limit'=>0,
			'use_limit'=>0,
		);
		return $this->listUserReminders($rows,$search,'RemMessagesUser.rem_time ASC');
	}
	function listCronReminders() {
		$result=array(
			'msg'=>array(),
			'mail'=>array(),
			'sms'=>array(),
		);
		$searchQuery[]=array('Field'=>'RemMessagesUser.rem_status','Typ'=>'!=','Values'=>GE_REM_DELETED);
		$searchQuery[]=array('Field'=>'RemMessagesUser.rem_time','Typ'=>'<=','Values'=>time());

		$subQuery=array();
		$subQuery[]=array(array('Field'=>'RemMessagesUser.rem_mail_send','Typ'=>'=','Values'=>-1));
		$subQuery[]=array(array('Field'=>'RemMessagesUser.rem_sms_send','Typ'=>'=','Values'=>-1));
		$subQuery[]=array(array('Field'=>'RemMessagesUser.rem_msg_send','Typ'=>'=','Values'=>-1));
		$searchQuery[]=array('Typ'=>'OR','Values'=>$subQuery);
		
		$query="SELECT * FROM RemMessagesUser WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while($this->_db->next_record()) {
			if ($this->_db->f('rem_mail_send')==-1) {
				$result['mail'][]=array(
					'rid'=>$this->_db->f('fk_rem_id'),
					'uid'=>$this->_db->f('fk_user_id'),
				);
			}
			if ($this->_db->f('rem_msg_send')==-1) {
				$result['msg'][]=array(
					'rid'=>$this->_db->f('fk_rem_id'),
					'uid'=>$this->_db->f('fk_user_id'),
				);
			}
			if ($this->_db->f('rem_sms_send')==-1) {
				$result['sms'][]=array(
					'rid'=>$this->_db->f('fk_rem_id'),
					'uid'=>$this->_db->f('fk_user_id'),
				);
			}
		}
		return $result;
	}
	public function deleteUser($user_id) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'fk_user_id','Typ'=>'=','Values'=>$user_id);
		$this->_db->delete('RemMessagesUser',$searchQuery);
	}

	public function deleteOldReminders($time) {
		$query="DELETE RemMessages FROM RemMessages LEFT JOIN RemMessagesUser";
		$query.=" ON (RemMessagesUser.fk_rem_id=RemMessages.rem_id AND (RemMessagesUser.rem_status!=".GE_REM_DELETED." OR RemMessagesUser.rem_time > ".$time."))";
		$query.=" WHERE RemMessagesUser.fk_rem_id IS NULL ";
		$this->_db->query($query);

		$query="DELETE RemMessagesUser FROM RemMessagesUser LEFT JOIN RemMessages";
		$query.=" ON (RemMessagesUser.fk_rem_id=RemMessages.rem_id)";
		$query.=" WHERE RemMessages.rem_id IS NULL ";
		$this->_db->query($query);
	}
	public function isRemObject($modul,$oldID) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'rem_obj_typ','Typ'=>'=','Values'=>$modul);
		$searchQuery[]=array('Field'=>'rem_obj_id','Typ'=>'=','Values'=>$oldID);
		return $this->searchSingleObj($searchQuery);
	}
	public function moveRemObject($modul,$oldID, $newId) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'rem_obj_typ','Typ'=>'=','Values'=>$modul);
		$searchQuery[]=array('Field'=>'rem_obj_id','Typ'=>'=','Values'=>$oldID);
		
		$update=array('rem_obj_id'=>$newId);
		$this->_db->update('RemMessages',$update,$searchQuery);
	}
	
	public function addLink($text) {
		return preg_replace(
			array(
			'/(^|\s|>)(www.[^<> \n\r]+)/iex',
			'/(^|\s|>)([_A-Za-z0-9-]+(\\.[A-Za-z]{2,3})?\\.[A-Za-z]{2,4}\\/[^<> \n\r]+)/iex',
			'/(?(?=<a[^>]*>.+<\/a>)(?:<a[^>]*>.+<\/a>)|([^="\']?)((?:https?):\/\/([^<> \n\r]+)))/iex'
			),
			array(
				"stripslashes((strlen('\\2')>0?'\\1<a href=\"http://\\2\" target=\"_blank\">\\2</a>&nbsp;\\3':'\\0'))",
				"stripslashes((strlen('\\2')>0?'\\1<a href=\"http://\\2\" target=\"_blank\">\\2</a>&nbsp;\\4':'\\0'))",
				"stripslashes((strlen('\\2')>0?'\\1<a href=\"\\2\" target=\"_blank\">\\3</a>&nbsp;':'\\0'))",
			),
			$text
		);		
	}
	public function formatObj($obj) {
		$rem_img='appls_msg.gif';$rem_name='';$rem_link='';
		if ($obj->getMeta('rem_obj_name') && $obj->getMeta('rem_obj_id')) {
			$rem_name=$obj->getMeta('rem_obj_name');
			switch($obj->getMeta('rem_obj_typ')) {
				case 'addr':
					$rem_img='appls_adr.gif';
					$rem_link='index.php?site=addr.php&action=v&aid='.$obj->getMeta('rem_obj_id').'&go_b=1';
				break;
				case 'cal':
					$rem_img='appls_kal.gif';
					$rem_link="index.php?site=cal.php&action=view&view=event&event_id=".$obj->getMeta('rem_obj_id')."&edate=".time()."&go_b=1";
				break;
				case 'task':
					$rem_img='appls_task.gif';
					$rem_link="index.php?site=task.php&action=vo&TaskID=".$obj->getMeta('rem_obj_id')."&go_b=1";
				break;
				case 'proj':
					$rem_img='appls_proj.gif';
					$rem_link="index.php?site=proj.php&action=v&oid=".$obj->getMeta('rem_obj_id').'&go_b=1';
				break;
				case 'mail':
					$rem_img='appls_mail.gif';
					$tmp=explode('||',$obj->getMeta('rem_obj_id'));
					$rem_link="index.php?site=mail.php&action=v&oid=".urlencode($tmp[0])."&mid=".$tmp[1].'&go_b=1';
				break;
				break;
				case 'fmng':
					$rem_img='appls_fmng.gif';
					$rem_link="index.php?site=fmng.php&action=fu&oid=".$obj->getMeta('rem_obj_id').'&go_b=1';
				break;
				case 'imng':
					$rem_img='appls_imng.gif';
					$rem_link="index.php?site=imng.php&action=vo&oid=".$obj->getMeta('rem_obj_id').'&go_b=1';
				break;
				case 'lmng':
					$rem_img='obj_img/bkm.gif';
					$rem_link="index.php?site=lmng.php&action=vo&oid=".$obj->getMeta('rem_obj_id').'&open_x=1go_b=1';
					$rem_target='_blank';
				break;
				case 'forum':
					$rem_img='tree_f_expand.gif';
					$rem_link="index.php?site=forum.php&action=fv&ID=".$obj->getMeta('rem_obj_id').'&go_b=1';
				break;
				case 'disk':
					$rem_img='tree_f_expand.gif';
					$rem_link="index.php?site=forum.php&action=ta&NodeID=".$obj->getMeta('rem_obj_id')."&go_b=1#T".$obj->getMeta('rem_obj_id');
				break;
				default:

				break;
			}
		}
		return array(
			'img'=>$rem_img,
			'name'=>$rem_name,
			'link'=>$rem_link,
			'target'=>$rem_target,
		);
	}
	
}
?>