<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Smarty {clear_assign} compiler function plugin
 *
 * Type:     compiler function<br>
 * Name:     clear_assign<br>
 * Purpose:  clear value of template variable
 * @author Manfred Thaler <mthaler at endo7 dot com> (initial author)
 * @param array containing var-attribute
 * @param Smarty
 */
function smarty_compiler_clear_assign($tag_attrs, &$compiler)
{
    $_params = $compiler->_parse_attrs($tag_attrs);

    if (!isset($_params['var'])) {
        $compiler->_syntax_error("clear_assign: missing 'var' parameter", E_USER_WARNING);
        return;
    }

    return "\$this->clear_assign({$_params['var']});";
}
?>