<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Smarty {array_append} function plugin
 *
 * Type:     function<br>
 * Name:     array_append<br>
 * Purpose:  append values to arrays
 * @author Manfred Thaler <mthaler at endo7 dot com> (initial author)
 * @param array containing var-attribute ,key-attribute and value-attribute
 * @param smarty
 */

function smarty_function_array_append($params, &$smarty)
{
	if (!isset($params['var'])) {
        $smarty->trigger_error("array_append: missing 'var' parameter");
	}
	if (!isset($params['key'])) {
        $smarty->trigger_error("array_append: missing 'key' parameter");
	}
	if (!isset($params['value'])) {
        $smarty->trigger_error("array_append: missing 'value' parameter");
	}
	$smarty->append($params['var'],array($params['key']=>$params['value']),true);
}
?>