<?php
class SmbObj {
	var $_meta=array();
	var $_acl;
	var $_ID;
	function getID() {
		return $this->_ID;
	}
	function setID($ID) {
		$this->_ID=$ID;
	}
	function getMeta($key) {
		return $this->_meta[$key];
	}
	function setMeta($key,$data) {
		$this->_meta[$key]=$data;
	}
	function getName($lang='') {
		return basename($this->_meta['name']);
	}
	function getACL($chk=0) {
		$chk=intval($chk);
		if ($chk) {
			if ($this->_acl==-1) {
				return true;
			} else {
				return ($this->_acl&$chk);
			}
		} else {
			return $this->_acl;
		}
	}
	function setAcl($acl) {
		$this->_acl=$acl;
	}
	function getAction($typ) {
		return $this->_action[$typ];
	}
	function getSite() {
		return $this->_site;
	}
	function getShare() {
		$tmp=explode('/',$this->_ID);
		if (count($tmp)>2) {
			return $tmp[0].'/'.$tmp[1].'/'.$tmp[2];
		}
		return '';
	}
	function getParent() {
		$tmp=explode('/',$this->_ID);
		if (count($tmp)>3) array_pop($tmp);
		return implode('/',$tmp);
	}
	function getIDName($lang='') {
		$tmp=explode('/',$this->_ID);
		return $tmp[count($tmp)-1];
	}

}

class SObj_fol extends SmbObj   {
	var $_site='smb.php';
	var $_action=array('b','b');
	function SObj_fol($ID=0,$meta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.=$this->_meta['img'];
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='fol';
		if ($this->getMeta('Trash')) {
			$ac.='_tr';
		}
		if ($typ) $ac.='_l';
		return $ac;
	}
	function isFolder() {
		return true;
	}
}
class SObj_share extends SmbObj   {
	var $_site='smb.php';
	var $_action=array('b','b');
	function SObj_share($ID=0,$meta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.=$this->_meta['img'];
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='share';
		return $ac;
	}
	function isFolder() {
		return true;
	}
}

class SObj_ext extends SmbObj   {
	var $_site='smb.php';
	var $_action=array('fu','vo&edit=1');
	function SObj_ext($ID=0,$meta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		$image.=$this->_meta['img'];
		return $image;
	}
	function getActionMode() {
		$ac='ext';
		if ($this->getMeta('Trash')) {
			$ac.='_tr';
		}
		return $ac;
	}
	function isFolder() {
		return false;
	}
}
class SObj_trash extends SmbObj  {
	var $_site='smb.php';
	var $_action=array('b','b');
	function SObj_trash($ID=0,$meta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.=$this->_meta['img'];
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='trash';
		if ($typ) {
			$ac.='_l';
		}
		return $ac;
	}
	function isFolder() {
		return true;
	}
}
class Samba  {
	var $_modul='smb';
	var $_allowGroupOwning=true;
	var $_isLocal=false;

	function Samba ($clientMode='') {
		global $frm,$db,$auth;
		$this->_db=&$db;
		$this->_frm=&$frm;
		$this->_lang=$frm->getLang();
		$this->_uid=$frm->getUser();
		$this->_uid_sid='';
		$this->_gid=$frm->getMyGroups();
		$this->_gid_sid=array();
		if ($GLOBALS['CFG']['USER_CLASS']=='ldap_full') {
			$this->_uid_sid=$this->_frm->idToSid($this->_uid,'u');
			foreach ($this->_gid as $val) {
				$sid=$this->_frm->idToSid($val,'g');
				if ($sid) $this->_gid_sid[]=$sid;
			}
		}
		$this->_smb_client=& $this->_frm->getStaticModul('smb_client'.$clientMode);
		$this->_smb_acl_client=& $this->_frm->getStaticModul('smb_client_acl');
		$this->clearRule();
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
		$this->setUserName($auth->auth['uname']);
		$this->setPassword($auth->auth['ldap_password']?$auth->auth['ldap_password']:$auth->auth['password']);
		if ($this->getCfg('cfg/charset')) {
			$this->_smb_client->setCharset($this->getCfg('cfg/charset'));
		} else {
			$this->_smb_client->setCharset(GE_CHARSET);
		}
		$localIP=$this->_frm->getPrefs('smb','localPathIP');
		if (trim($localIP)) {
			$this->_isLocal=$this->_frm->isAllowedIpMask($localIP);
			if ($this->_isLocal) {
				$this->_localPath=unserialize($this->_frm->getPrefs('smb','localPath'));
				if (is_array($this->_localPath)) {
					foreach ($this->_localPath as $key=>$val) {
						if (!trim($val)) {
							unset($this->_localPath[$key]);
						}
					}
				}
				if (!is_array($this->_localPath) || empty($this->_localPath)) {
					$this->_isLocal=false;
				}
			}
		}
		//passthru('locale');
		set_time_limit(0);
		//debug($auth);
	}
	function getModul() {
		return $this->_modul;
	}
	function setUser($uid) {
		$this->_uid=$uid;
	}
	function getUser() {
		return $this->_uid;
	}
	function getUserSid() {
		return $this->_uid_sid;
	}
	function getGroups() {
		return $this->_gid;
	}
	function getGroupsSid() {
		return $this->_gid_sid;
	}
	function setUserName($uname) {
		$this->_uname=$uname;
		$this->_smb_client->setUserName($uname);
		$this->_smb_acl_client->setUserName($uname);
	}
	function setPassword($pwd) {
		$this->_pwd=$pwd;
		$this->_smb_client->setPassword($pwd);
		$this->_smb_acl_client->setPassword($pwd);
	}
	function setGroups($gid) {
		$this->_gid=$gid;
	}
	function setRule($bool=false) {
		$this->_rule=$bool;
	}
	function clearRule($bool=false) {
		$this->_rule=$this->_frm->isRuleUser(array('sysadmin','smb'));
	}
	function setSuperAdmin($bool=false) {
		$this->_sadmin=$bool;
	}
	function isRuleUser() {
		return $this->_rule;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function isShareAdmin() {
		if (!is_object($this->_RootObj)) return false;
		if (!isset($this->_shareAdmin[$this->_RootObj->getID()])) {
			$this->_shareAdmin[$this->_RootObj->getID()]=false;
			if ($this->_RootObj->getMeta('adminGroups')) {
				$group_data=$this->_frm->getAllGroups(0,-1,$this->_RootObj->getMeta('adminGroups'),0,false,true);
				if (is_array($group_data)) {
					$gid=key($group_data);
					if (in_array($gid,$this->_gid)) $this->_shareAdmin[$this->_RootObj->getID()]=true;
				}
			}
		}
		return $this->_shareAdmin[$this->_RootObj->getID()];
	}
	function setCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}
		}
	}
	function getCfg($key) {
		if (isset($this->_cfg[$key])) {
			return $this->_cfg[$key];
		} else {
			return false;
		}
	}
	function listSubEntries($path,$order='NA',$onlyFolders=false) {
		$result=array();
		$this->_smb_client->cfgOnlyFolders=$onlyFolders;
		$this->_smb_client->Go($path);
		$this->_status=$this->_smb_client->Browse($order);
		if (!$this->_status) {
			if (is_array($this->_smb_client->results)) {
				foreach ($this->_smb_client->results as $key=>$val) {
					$id=$path.'/'.$key;
					switch ($val['type']) {
						case 'folder':
							$result[$id]=new SObj_fol($id,$val);
						break;
						case 'file':
							$result[$id]=new SObj_ext($id,$val);
						break;
						case 'disk':
							$result[$id]=new SObj_share($id,$val);
						break;
						case 'trash':
							$result[$id]=new SObj_trash($id,$val);
						break;
					}
				}
			}
		}
		$this->_smb_client->cfgOnlyFolders=false;
		return $result;
	}
	function &listSubTree($params,$onlyApps=true) {
		//debug($params['ParentID']);
		return $this->listSubEntries($params['ParentID'],'NA',true);
    }
	function &isSubTreeLen($params,$onlyApps=true) {
		return true;
    }
	function getObj($ID) {
		$this->_smb_client->Go($ID);
		$this->_status=$this->_smb_client->Read();
		//debug($this->_status);
		if (!$this->_status) {
			switch ($this->_smb_client->results['type']) {
				case 'folder':
					return new SObj_fol($ID,$this->_smb_client->results);
				break;
				case 'file':
					return new SObj_ext($ID,$this->_smb_client->results);
				break;
				case 'share':
					return new SObj_share($ID,$this->_smb_client->results);
				break;
				case 'trash':
					return new SObj_trash($ID,$this->_smb_client->results);
				break;
			}
		}
	}
	function getInternPath($ID) {
		return $this->_smb_client->getInternPath($ID);
	}
	function deleteArchivFolder($Folder,$Files) {
		if (is_array($Files)) {
			$delFiles=array();
			$delFolders=array();
			foreach ($Files as $val) {
				$val=str_replace('./','',$val);
				$val=preg_replace('/\\\\([0-9]+)/e','chr(octdec("\\1"))',$val);

				//$val=preg_replace('/\\\\([0-9]+)/e','Framework::code2utf(hexdec("\\1"))',$val);
				//debug($val);

				if ($val[strlen($val)-1]!='/') {
					$delFiles[]=$val;
				} elseif($val) {
					$delFolders[]=$val;
				}
			}
			if (!empty($delFiles)) {
				foreach ($delFiles as $val) {
					$this->_smb_client->Go($Folder.'/'.$val);
					//debug($Folder.'/'.$val);
					$this->_smb_client->Remove(false);
				}
			}
			if (!empty($delFolders)) {
				uasort ($delFolders,array('Framework','sortByLenDesc'));
				//debug($delFolders);
				foreach ($delFolders as $val) {
					$this->_smb_client->Go($Folder.'/'.$val);
					$this->_smb_client->Remove(false);
				}
			}
		}



	}
	function archivFolder($Folder,$search,$tgzDir,$tgzFile) {
		$this->_smb_client->Go($Folder);
		return $this->_smb_client->ArchivPath($search,$tgzDir,$tgzFile);
	}
	function getStatus() {
		if ($this->_status) {
			return array('server','SAMBA SAID: '.$this->_status);
		}
		return false;
	}
	function setRootObj(&$obj) {
		$this->_RootObj=&$obj;
	}
	function setTempAdmin() {
		if (is_object($this->_RootObj)) {
			$group=$this->_RootObj->getMeta('adminGroups');
			//debug($group);
			if ($group) {
				$group_data=$this->_frm->getAllGroups(0,-1,$group,0,false,true);
				if (is_array($group_data)) {
					//debug('INSERT');
					//debug($group_data);
					$gid=key($group_data);
					$this->_smb_client->logout();
					$this->_frm->insertUserGroups($this->_uid,array($gid),false);
				}
			}
		}
	}
	function delTempAdmin() {
		if (is_object($this->_RootObj)) {
			$group=$this->_RootObj->getMeta('adminGroups');
			if ($group) {
				$group_data=$this->_frm->getAllGroups(0,-1,$group,0,false,true);
				//debug('DEL');
				//debug($group_data);
				if (is_array($group_data)) {
					$gid=key($group_data);
					$this->_smb_client->logout();
					$this->_frm->deleteUserGroups($this->_uid,$gid,false);
				}
			}
		}
	}
	function getAcl(&$Obj) {
		$this->_smb_acl_client->Go($Obj->getID());
		$this->_status=$this->_smb_acl_client->getAcl();
		//debug($this->_smb_acl_client->result);
		return $this->_smb_acl_client->result;
	}
	function getMyAcl($ID) {
		$this->_smb_acl_client->Go($Obj->getID());
		$this->_status=$this->_smb_acl_client->getAcl();
		return $this->_smb_acl_client->result;
	}
	function setAllAcl(&$Obj,$applyMode,$aclObj=null) {
		if (!$aclObj) $aclObj=$this->getAcl($Obj);
		//debug($aclObj);
		$aclD=$this->_smb_acl_client->createAcl($aclObj,'folder');
		$aclF=$this->_smb_acl_client->createAcl($aclObj,'file');
		//debug($aclD);
		//debug($aclF);
		$this->_setAllAcl($Obj,$aclD,$aclF,$applyMode);
	}
	function _setAllAcl(&$Obj,$aclD,$aclF,$applyMode) {
		if ($Obj->isFolder()) {
			if (in_array(1,$applyMode)) {
				$this->_smb_acl_client->Go($Obj->getID());
				$this->_status=$this->_smb_acl_client->setAcl($aclD);
			}
			if (in_array(4,$applyMode) || in_array(2,$applyMode)) {
				$entries=$this->listSubEntries($Obj->getID(),in_array(2,$applyMode)?false:true);
				foreach ($entries as $list_obj) {
					if ($list_obj->isFolder()) {
						if (in_array(4,$applyMode)) {
							$this->_smb_acl_client->Go($list_obj->getID());
							$this->_status=$this->_smb_acl_client->setAcl($aclD);
							$this->_setAllAcl($list_obj,$aclD,$aclF,$applyMode);
						}
					} else {
						if (in_array(2,$applyMode)) {
							$this->_smb_acl_client->Go($list_obj->getID());
							$this->_status=$this->_smb_acl_client->setAcl($aclF);
						}
					}
				}
			}
		} else {
			$this->_smb_acl_client->Go($Obj->getID());
			$this->_status=$this->_smb_acl_client->setAcl($aclF);
		}
	}
	function modifyAcl(&$Obj,$Sids,$Acl,$Inherit=0,$applyMode=null) {
		if ($Obj->isFolder()) {
			if (!is_array($applyMode)) $applyMode=array();
			if (in_array(1,$applyMode)) $this->_modifyAcl($Obj,$Sids,$Acl,$Inherit);
			if (in_array(2,$applyMode) || in_array(4,$applyMode)) {
				$entries=$this->listSubEntries($Obj->getID(),in_array(2,$applyMode)?false:true);
				foreach ($entries as $list_obj) {
					if ($list_obj->isFolder()) {
						if (in_array(4,$applyMode)) {
							$this->_modifyAcl($list_obj,$Sids,$Acl,$Inherit);
							$this->modifyAcl($list_obj,$Sids,$Acl,$Inherit,$applyMode);
						}
					} else {
						if (in_array(2,$applyMode)) {
							$this->_modifyAcl($list_obj,$Sids,$Acl);
						}
					}

				}
			}
		} else {
			$this->_modifyAcl($Obj,$Sids,$Acl);
		}
	}
	function setOnlyExtraAcl($Obj,$mAcl,$Inherit=1) {
		$aclObj=$this->getAcl($Obj);
		if (is_array($aclObj['ACL'])) {
			foreach ($aclObj['ACL'] as $sid=>$acl_val) {
				if ($sid!=$aclObj['OWNER'] && $sid!=$aclObj['GROUP'] && $sid!='S-1-1-0') {
					unset($aclObj['ACL'][$sid]);
				}
			}
		}
		foreach ($mAcl as $sid=>$acls) {
			foreach ($acls as $ACL) {
				$Flags=0;
				if ($ACL['Inherit']==1) $Flags=3;
				if ($ACL['Inherit']==2) $Flags=11;
				$aclObj['ACL'][$sid][]=array(
						'TYPE'=>0,
						'FLAGS'=>$Flags,
						'MASK'=>$ACL['ACL'],
				);
			}
		}
		$aclD=$this->_smb_acl_client->createAcl($aclObj,'folder');
		$this->_setAllAcl($Obj,$aclD,'',array(1));


	}

	function _modifyAcl(&$Obj,$Sids,$Acl,$Inherit=0) {
		$Flags=0;
		if ($Obj->isFolder()) {
			if ($Inherit==1) $Flags=3;
			if ($Inherit==2) $Flags=11;
		}
		$Mask=$this->_smb_acl_client->aclToMask($Acl);
		$this->_smb_acl_client->Go($Obj->getID());
		$this->_smb_acl_client->getAcl();
		$oldAcl=$this->_smb_acl_client->result;
		foreach ($Sids as $val) {
			if (!$Obj->isFolder()) {
				switch ($val) {
					case 'S-1-3-0':
						$val=$oldAcl['OWNER'];
					break;
					case 'S-1-3-1':
						$val=$oldAcl['GROUP'];
					break;
				}
			}
			if (isset($oldAcl['ACL'][$val])) {
				$this->_status=$this->_smb_acl_client->modifyAcl($val,$Mask,$Flags);
			} else {
				$this->_status=$this->_smb_acl_client->addAcl($val,$Mask,$Flags);
			}
		}
		return false;
	}
	function deleteAcl(&$Obj,$Acl) {
		$this->_smb_acl_client->Go($Obj->getID());
		$this->_status=$this->_smb_acl_client->deleteAcl($Acl);
		return false;
	}
	function deleteAllAcl (&$Obj)  {
		$oldPerms=$this->getAcl($Obj);
		//debug($oldPerms);
		if (is_array($oldPerms['ACL'])) {
			foreach ($oldPerms['ACL'] as $sid=>$acl_val) {
				if ($sid!=$oldPerms['OWNER'] && $sid!=$oldPerms['GROUP'] && $sid!='S-1-1-0') {
					foreach ($acl_val as $acl_data) {
						$dkey=$sid.':ALLOWED/'.$acl_data['FLAGS'].'/'.$this->aclToMask($acl_data['MASK']);
						//debug($dkey);
						$this->deleteAcl($Obj,$dkey);
					}
				}
			}
		}
	}
	function aclToMask($acl) {
		return $this->_smb_acl_client->aclToMask($acl);
	}
	function uploadFile(&$Obj,$File) {
		if (FrameWork::scanFile($File['tmp_name'])) return array('virus');
		$ID=$Obj->getID().'/'.$this->_smb_client->encode($File['name']);
		$this->_smb_client->Go($ID);
		$this->_smb_client->UploadFile($File['tmp_name']);
		if ($this->_smb_client->status) {
			return array('server','SAMBA SAID: '.$this->_smb_client->status);
		}
		return false;
	}
	function uploadLocalFile(&$Obj,$File,$name='') {
		if (!$name) $name=basename($File);
		$ID=$Obj->getID().'/'.$this->_smb_client->encode($name);
		//debug($ID);
		$this->_smb_client->Go($ID);
		$this->_smb_client->UploadFile($File);
		if ($this->_smb_client->status) {
			return array('server','SAMBA SAID: '.$this->_smb_client->status);
		}
		return false;
	}
	function createFolder(&$Obj,$Folder) {
		$ID=$Obj->getID().'/'.$this->_smb_client->encode($Folder);
		$this->_smb_client->Go($ID);
		$this->_smb_client->MakeDirectory();
		if ($this->_smb_client->status) {
			return array('server','SAMBA SAID: '.$this->_smb_client->status);
		}
		return false;
	}
	function updateObj(&$Obj,$Name) {
		$ID=$Obj->getID();
		$this->_smb_client->Go($ID);
		$this->_smb_client->RenameFile($Obj->getIDName(),$this->_smb_client->encode($Name));
		if ($this->_smb_client->status) {
			return array('server','SAMBA SAID: '.$this->_smb_client->status);
		} else {
			$Obj->setID($Obj->getParent().'/'.$this->_smb_client->encode($Name));
		}
		return false;
	}
	function moveObj($FromID,$ToID) {
		$fromPath=$this->_smb_client->parsePath($FromID);
		$topPath=$this->_smb_client->parsePath($ToID);
		$this->_smb_client->Go($fromPath['workgroup'].'/'.$fromPath['server'].'/'.$fromPath['share']);
		$this->_smb_client->RenameFile($fromPath['path'],$topPath['path'],true);
		if ($this->_smb_client->status) {
			return array('server','SAMBA SAID: '.$this->_smb_client->status);
		}
		return false;
	}

	function deleteObj(&$Obj) {
		$ID=$Obj->getID();
		$this->_smb_client->Go($ID);//history,reget,translate,vuid
		//$this->_smb_client->_SmbClient ('history',$this->_smb_client->parent);
		$this->_smb_client->Remove();
		if ($this->_smb_client->status) {
			return array('server','SAMBA SAID: '.$this->_smb_client->status);
		}
		return false;
	}
	function dumpFile(&$Obj) {
		if (!$Obj->isFolder()) {
			$this->_smb_client->Go($Obj->getID());
			$this->_smb_client->Get();
			if ($this->_smb_client->status) {
				return array('server','SAMBA SAID: '.$this->_smb_client->status);
			}
			return false;
		}
	}
	function convert2Html(&$Obj) {
		/*
		if (!$Obj->isFolder()) {
			$this->_smb_client->Go($Obj->getID());
			$this->_smb_client->file2Html();
			if ($this->_smb_client->status) {
				return array('server','SAMBA SAID: '.$this->_smb_client->status);
			}
			return false;
		}*/
	}
	function copyFileLocal(&$Obj,$localFile) {
		if (!$Obj->isFolder()) {
			$this->_smb_client->Go($Obj->getID());
			$this->_smb_client->CopyLocal($localFile);
			if ($this->_smb_client->status) {
				return array('server','SAMBA SAID: '.$this->_smb_client->status);
			}
			return false;
		}
	}
	function &_fetchACL() {
		return $this->_frm->calcAcl($this->_db->f('PermsUser'),$this->_db->f('PermsGroup'),$this->_uid);
	}
	function listMyShares($use_perms=true) {
		$tras_array=array(
			'{USER}'=>$this->_uname,
		);
		$result=array();
		$where=array();
		$query="SELECT * FROM SmbMetabase";
		if ($use_perms) {
			$acl_where[]='PermsUser LIKE '.$this->_db->escape('%|'.$this->_uid.',%');
			if (is_array($this->_gid)) {
				foreach ($this->_gid as $val) {
					$acl_where[]="PermsGroup LIKE ".$this->_db->escape('%|'.$val.',%');
				}
			}
			$where[]='('.implode (' OR ',$acl_where).')';
		}
		if (!empty($where)) $query.=" WHERE ".implode(' AND ',$where);
		$query.=' ORDER BY smbID';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$ID=strtr($this->_db->f('smbID'),$tras_array);
			$meta=array(
				'name'=>basename($ID),
				'attr'=>'D',
				'size'=>0,
				'type'=>'share',
				'time'=>0,
				'img'=>'tree.gif',
				'adminGroups'=>$this->_db->f('adminGroups'),
				'rootID'=>$this->_db->f('rootID'),
			);
			$result[$ID]=new SObj_share($ID,$meta);
		}
		return $result;
	}
	function listAdminShares() {
		$result=array();
		$query="SELECT * FROM SmbMetabase";
		$query.=' ORDER BY smbID';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$ID=$this->_db->f('smbID');
			$meta=array(
				'name'=>basename($ID),
				'attr'=>'D',
				'size'=>0,
				'type'=>'share',
				'time'=>0,
				'img'=>'tree.gif',
				'permsUser'=>$this->_db->f('permsUser'),
				'permsGroup'=>$this->_db->f('permsGroup'),
				'adminGroups'=>$this->_db->f('adminGroups'),
				'rootID'=>$this->_db->f('rootID'),
			);
			$result[$ID]=new SObj_share($ID,$meta);
		}
		return $result;
	}
	function getAdminShareObj($ID,$use_perms=0,$transform=false) {
		$tras_array=array(
			'{USER}'=>$this->_uname,
		);
		$result=array();
		$query="SELECT * FROM SmbMetabase";
		$where=array("smbID=".$this->_db->escape($ID));
		if ($use_perms) {
			$acl_where[]='PermsUser LIKE '.$this->_db->escape('%|'.$this->_uid.',%');
			if (is_array($this->_gid)) {
				foreach ($this->_gid as $val) {
					$acl_where[]="PermsGroup LIKE ".$this->_db->escape('%|'.$val.',%');
				}
			}
			$where[]='('.implode (' OR ',$acl_where).')';
		}
		$query.=" WHERE ".implode(' AND ',$where);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			if ($transform) $ID=strtr($this->_db->f('smbID'),$tras_array); else $this->_db->f('smbID');
			$meta=array(
				'name'=>basename($ID),
				'attr'=>'D',
				'size'=>0,
				'type'=>'share',
				'time'=>0,
				'img'=>'tree.gif',
				'permsUser'=>$this->_db->f('permsUser'),
				'permsGroup'=>$this->_db->f('permsGroup'),
				'adminGroups'=>$this->_db->f('adminGroups'),
				'rootID'=>$this->_db->f('rootID'),
			);
			return new SObj_share($ID,$meta);
		}
	}
	function existsAdminShare($ID,$orig_id=0) {
		if ($orig_id && $ID==$orig_id) return false;
		$query="SELECT * FROM SmbMetabase";
		$query.=" WHERE smbID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) return true;
		return false;
	}
	function insertAdminShare(&$Obj) {
		$insert=array(
			'smbID'=>$Obj->getID(),
			'adminGroups'=>$Obj->getMeta('adminGroups'),
			'permsUser'=>'|',
			'permsGroup'=>'|',
			'rootID'=>$this->_db->nextid('SmbMetabase'),
		);
		return $this->_db->insert('SmbMetabase',$insert);
	}
	function updateAdminShare($ID,&$Obj) {
		$update=array(
			'smbID'=>$Obj->getID(),
			'adminGroups'=>$Obj->getMeta('adminGroups'),
			'permsUser'=>$Obj->getMeta('permsUser'),
			'permsGroup'=>$Obj->getMeta('permsGroup'),
		);
		return $this->_db->update('SmbMetabase',$update,'smbID='.$this->_db->escape($ID));
	}
	function deleteAdminShare($ID) {
		$query="DELETE FROM SmbMetabase";
		$query.=" WHERE smbID=".$this->_db->escape($ID);
		$this->_db->query($query);
		return true;
	}
	function isAllowedAction(&$obj,&$action) {
		if (!is_array($action)) return false;
		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkAction($obj,substr($ac_val,1));
				} else {
					$result=$result||$this->_checkAction($obj,$ac_val);
				}
			}
			if (!$result) return false;
		}
		return true;
	}
	function _checkAction(&$obj,$action) {
		//debug($action);
		switch ($action) {
			case 'sadmin':
				if (!$this->isSuperAdmin()) return false;
			break;
			case 'rule':
				if (!$this->isRuleUser()) return false;
			break;
			case 'ldap_full':
				if ($GLOBALS['CFG']['USER_CLASS']!='ldap_full') return false;
			break;
			case 'owner':
				$aclObj=$obj->getMeta('ACL');
				if ($aclObj['OWNER']==$this->_uid_sid) {
					break;
				} elseif ($this->_allowGroupOwning && in_array($aclObj['GROUP'],$this->_gid_sid)) {
					break;
				} else {
					return false;
				}
			break;
			case 'admin':
				if (!$this->isShareAdmin()) return false;
			break;
			case 'av_admin':
				if (!is_object($this->_RootObj) || !trim($this->_RootObj->getMeta('adminGroups'))) return false;
			break;
			case 'app_mail':
				if (!$this->_frm->getMyApps('email')) return false;
			break;
		}
		return true;
	}
	function logout() {
		$this->_smb_client->logout();
	}
	function path2local($path) {
		if ($this->_isLocal) {
			$newPath=strtr($path,$this->_localPath);
			if ($newPath!=$path) {
				return $newPath;
			}
		}
		return false;
	}

}
?>
