<?php
class SambaClientMount extends SambaClient {
	var $_pipes=array();
	var $_resource=array();
	function SambaClientMount() {
		global $frm;
		parent::SambaClient();
		$this->_path=GE_DYN_PATH.'/'.GE_DOMAIN_PATH;
		$this->_uid=$frm->getUser();
		if (!file_exists($this->_path)) {
			mkdir($this->_path,0700);
		}
		if (!file_exists($this->_path."smbmount")) {
			mkdir($this->_path."smbmount",0700);
		}
		//debug($this->getMountPath());
		if (!file_exists($this->getMountPath())) {
			mkdir($this->getMountPath(),0700);
		}
		return true;
	}
	function logout() {
		$this->closeMount();
	}
	function getMountPath() {
		return $this->_path.'smbmount/'.$this->_uid;
	}
	function Read() {
		$this->status = '';
		if ($this->path) {
			$this->_SmbClient('read', $this->path);
			if ($this->status == '') {
				$this->results=$this->files[$this->name];
			}
		} else {
			$this->results=array(
				'name'=>$this->name,
				'attr'=>'D',
				'size'=>0,
				'type'=>'share',
				'time'=>0,
				'img'=>'tree.gif',
			);
		}
		return $this->status;
	}
	function Remove ($rec=true) {

		$this->_SmbClient('del',$this->path);
		//debug($this->status);
		if ($this->status == 'DIR_NOT_EMPTY' && $rec) {
			$share='//'.$this->server."/".$this->share;
			if ($mountDir=$this->openMount($share)) {
				if ($this->path) $mountDir.='/';
				$path=$mountDir.$this->path;
				$this->_DeleteFolder($path);
			}
		}
	}

	# get a file (including a cache)
	function Get () {
		$this->_SmbClient('get', $this->path);
	}
	function DumpFile($file='', $name='') {
		if (!$name) $name=basename($file);
		if (Framework::dumpFile($file,$this->decode($name),'application/save')) {
			return true;
		} else {
			return false;
		}
	}
	function _SmbClient ($command='', $path='', $path2=''){
		$this->status = '';
		$this->_ParseSmbClient ($command,$path,$path2);
		//debug($this->status);
	}
	function _getData($path,$type) {
		$info = $this->getInfo($path,$type);
		$result=array(
			'name' => basename($path),
			'time' => filemtime($path),
			'img' => $info['img'],
			'mime' => $info['mime'],
			'ext' => $info['ext'],
			'type' => $type,
		);

		if ($type=='file') {
			$result['attr']='A';
			$result['size']=filesize($path);
		} else {
			$result['attr']='D';
			$result['size']=0;
		}
		return $result;
	}
	function _DeleteFolder ($path) {
		if (file_Exists($path) && is_dir($path)) {
			$dh=opendir($path);
			while (($file = readdir($dh)) !== false) {
				if ($file !='.' AND $file !='..') {
					$type=is_file($path.'/'.$file)?'file':'folder';
					if ($type=='file') {
						unlink($path.'/'.$file);
					} else {
						$this->_DeleteFolder($path.'/'.$file);
					}
				}
			}
			//debug($this->files);
			closedir($dh);
			rmdir($path);
		}
	}
	function RemoveFolder(){
		$this->_SmbClient('rmdir',$this->path);
	}
	function MakeDirectory (){
		$this->_SmbClient('mkdir',$this->path);
	}

	function UploadFile ($file)	{
	//debug($file);
		$this->_SmbClient('upload',$this->path,$file);
	}
	function RenameFile ($file, $newname,$abs=false) {
		if ($abs) {
			$this->_SmbClient('rename',$file,$newname);
		} else {
			$this->_SmbClient('rename',$this->path,dirname($this->path).'/'.$newname);
		}

	}
	function MoveFile ($file, $newfile) {
		$this->_SmbClient('move',$file,$newfile);
	}
	function CopyLocal($localFile) {
		$this->_SmbClient('copy',$this->path,$localFile);
	}

	function ArchivPath($search,$tgzPath,$tgzFile) {
		$share='//'.$this->server."/".$this->share;
		if ($mountDir=$this->openMount($share)) {
			$findParam='';
			if ($search['DateB']) {
				$exec='touch -d "'.date('Y-m-d 00:00:00',$search['DateB']).'" '.escapeshellarg(realpath($tgzPath).'/TIME');
				exec($exec);
				$findParam.=' -cnewer '.escapeshellarg(realpath($tgzPath).'/TIME');
			}
			if ($search['DateE']) {
				$dayDiff=round((mktime(12,0,0)-mktime(12,0,0,date('m',$search['DateE']),date('d',$search['DateE']),date('Y',$search['DateE'])))/(3600*24));
				if ($dayDiff>0) {
					$findParam.=' -daystart -ctime +'.$dayDiff;
				} else {

				}
			}
			if ($findParam) {
				$exec='find '.escapeshellarg($this->path).' '.$findParam.' -print0 | xargs -0 ';
				$exec.=' tar -cvz --no-recursion -f '.escapeshellarg(realpath($tgzPath).'/'.$tgzFile);
			} else {
				$exec=' tar -cvz -f '.escapeshellarg(realpath($tgzPath).'/'.$tgzFile);
				$exec.=' '.escapeshellarg($this->path);
			}

			$exec.=' 2>&1';
			$result=array();
			$result[0]='';
			$oldDir=realpath('.');
			chdir($mountDir);
			exec($exec,$result,$result[0]);
			chdir($oldDir);

			if (file_exists($tgzPath.'/TIME')) {
				unlink($tgzPath.'/TIME');
			}
			/*debugFile($exec);
			debugFile($result);*/

			//debug($exec);
			//debug($result);
			/*if ($result[0]==123) {
				$result=array(0);
			}*/
			return $result;
		}
	}
	function getInternPath($ID) {
		$this->Go($ID);
		$intPath=$this->getMountPath().'/'.str_replace('/','_','//'.$this->server."/".$this->share).'/'.$this->path;
		return $intPath;
	}

	function _ParseSmbClient ($cmd,$path,$path2='') {
		//debugtime('B');
		$share='//'.$this->server."/".$this->share;
		if ($mountDir=$this->openMount($share)) {
			if ($path) $mountDir.='/';
			$path=$mountDir.$path;
			switch ($cmd) {
				case 'get':
					if (file_exists($path) && is_file($path)) {
						$this->DumpFile ($path, basename($path));
					} else {
						$this->status='NO_SUCH_FILE';
					}
				break;
				case 'rename':
					if (file_exists($path) && !file_exists($mountDir.$path2)) {
						rename($path,$mountDir.$path2);
					} else {
						if (!file_exists($path)) {
							$this->status='NO_SUCH_FILE';
						} elseif (file_exists($mountDir.$path2)) {
							$this->status='FILE_EXIST';
						}
					}
				break;
				case 'upload':
					if ($path2 && file_exists($path2)) {
						//debug($path);
						if (is_writable(dirname($path))) {
							copy($path2,$path);
						} else {
							$this->status='ACCESS_DENIED';
						}
					} else {
						$this->status='NO_SUCH_FILE';
					}
				break;
				case 'copy':
					if (file_exists($path)) {
						copy($path,$path2);
					} else {
						$this->status='NO_SUCH_FILE';
					}
				break;
				case 'mkdir':
					if (!file_exists($path)) {
						if (!@mkdir($path)) {
							$this->status='ACCESS_DENIED';
						}
					} else {
						$this->status='DIR_EXIST';
					}
				break;
				case 'rmdir':
					if (file_exists($path)) {
						if (!@rmdir($path)) {
							$this->status='DIR_NOT_EMPTY';
						}
					} else {
						$this->status='NO_SUCH_DIR';
					}
				break;
				case 'del':
					if (file_exists($path)) {
						$type=is_file($path)?'file':'folder';
						if ($type=='file') {
							unlink($path);
						} else {
							if (!@rmdir($path)) {
								$this->status='DIR_NOT_EMPTY';
							}
						}
					} else {
						$this->status='NO_SUCH_FILE';
					}
				break;
				case 'read':
					if (file_Exists($path)) {
						$type=is_file($path)?'file':'folder';
						if ($this->cfgRecycleName && basename($path)==$this->cfgRecycleName) $type='trash';
						$this->files[basename($path)]=$this->_getData($path,$type);
						//debug($this->files);
					} else {
						$this->status='NO_SUCH_FILE';
					}
				break;
				case 'dir':
					if (file_Exists($path) && is_dir($path)) {
						$dh=opendir($path);
						while (($file = readdir($dh)) !== false) {
							if ($file !='.' AND $file !='..') {
								$type=is_file($path.'/'.$file)?'file':'folder';
								if ($this->cfgRecycleName && $file==$this->cfgRecycleName) $type='trash';
								if ($this->cfgHideDotFiles && $file[0]=='.' && $type!='trash') continue;
								if ($this->cfgOnlyFolders && $type == 'file') continue;
								$this->files[$file]=$this->_getData($path.'/'.$file,$type);
							}
						}
						//debug($this->files);
						closedir($dh);
					} else {
						$this->status='NO_SUCH_DIR';
					}
				break;
			}
		}
	}
	function openMount($share) {
		$mountDir=$this->getMountPath().'/'.str_replace('/','_',$share);
		//echo $mountDir;
		if (!file_exists($mountDir)) {
			mkdir($mountDir,0700);
			$command='smbmount '.escapeshellarg($share).' '.escapeshellarg($mountDir).' -o rw,lfs,codepage=cp850,iocharset='.($this->_smbCharset=='UTF-8'?'utf8':'iso8869-15').',file_mode=0644,dir_mode=0755';
			if ($this->user <> '') {
				# not anonymous
				switch ($this->cfgAuthMode) {
					case 'SMB_AUTH_ENV':
						putenv('USER='.$this->user.'%'.$this->pw);
					break;
					case 'SMB_AUTH_ARG':
						$command.= ',username='.escapeshellarg($this->user.'%'.$this->pw);
				}
				//debug($command);

				$output = shell_exec($command);
				//debug($output);
			}
		}
		return $mountDir;
	}
	function closeMount() {
		$dh=opendir($this->getMountPath());
		while (($file = readdir($dh)) !== false) {
			if ($file !='.' AND $file !='..') {
				$command='smbumount '.escapeshellarg($this->getMountPath().'/'.$file);
				$output = shell_exec($command);
				rmdir($this->getMountPath().'/'.$file);
			}
		}
		return true;
	}
	function readPipe(&$pipe) {
		$retval=array();
		while ($line=fgets($pipe)) {
			//debug('aaa'.$line);
			$retval[]=rtrim(preg_replace('/smb:([^>]*)> /','',$line));
			if (strpos($line,'Current directory')!==false) break;
        }
        return $retval;
	}
	function writePipe(&$pipe,$val) {
		fwrite($pipe,$val."\n");
		fflush($pipe);
	}
}
?>