<?php
class SambaClientPipe extends SambaClient {
	var $_pipes=array();
	var $_resource=array();
	function __construct() {
		parent::SambaClient();
		return true;
	}
	function __destruct()  {
		$this->closePipe();
		return true;
	}
	# get a file (including a cache)
	function Get () {
		$this->tempFile = tempnam(Framework::getTempPath(),$this->user);
		$this->_SmbClient('get "'.$this->name.'" "'.$this->tempFile.'"', $this->parent);
		if ($this->status == '') {
			$this->DumpFile ($this->tempFile, $this->name);
		}
		@unlink($this->tempFile);
	}
	function DumpFile($file='', $name='') {
		if (Framework::dumpFile($file,$this->decode($name),'application/save')) {
			return true;
		} else {
			return false;
		}
	}
	function _SmbClient ($command='', $path='', $message=''){
		//debug($command);
		//debug($path);
		$this->status = '';
		$smbcmd=array();
		$smbpath='';
		if ($command == '') {
			$smbcmd[] = "-L ".escapeshellarg($path);
		} elseif ($command == 'message') {
			$smbcmd[] = "-M ".escapeshellarg($path);
		} elseif ($command == 'compress') {
			$smbcmd[] = escapeshellarg("//{$this->server}/{$this->share}")." -Tqc - ".escapeshellarg($path);
		} else {
			if ($path!='') {
				$smbcmd[]='cd "'.$path.'"';
			}
			$smbcmd[]=$command;
			if ($path!='') {
				$smbcmd[]='cd /';
			}
		}
		return $this->_ParseSmbClient ($smbcmd);
	}
	function _ParseSmbClient ($cmd) {
		//debug($cmd);
		//debugtime('B');
		$share='//'.$this->server."/".$this->share;
		if ($this->openPipe($share)) {
			foreach ($cmd as $val) {
				//debug($val);
				$this->writePipe($this->_pipes[$share][0],$val);

			}
		}
		$this->writePipe($this->_pipes[$share][0],'pwd');
		//fclose($this->_pipes[$share][0]);
		$output=$this->readPipe($this->_pipes[$share][1]);
		//debug($output);

		$lineType = $mode = '';
		foreach ($output as $lnum=>$line) {
			if ($line != '') {
				$regs = array();
				$lineType = 'SKIP';
				$regs = array();
				//$line=$this->decode($line);
				//debug($lnum.':'.trim($line));
				foreach ($this->parser as $regexp => $type) {
					if (preg_match('/'.$regexp.'/', $line, $regs)) {
						$lineType = $type;
						break;
					}
				}
				//debug('TYPE:'.$lineType);
				switch ($lineType) {
					case 'SKIP':
					continue;
					case 'SHARES_MODE':
						$mode = 'shares';
					break;
					case 'SERVERS_MODE':
						$mode = 'servers';
					break;
					case 'WORKGROUPS_MODE':
						$mode = 'workgroups';
					break;
					case 'SHARES':
						$name = trim($regs[1]);
						$type = strtolower($regs[2]);
						if ($this->cfgHideSystemShares == true AND $name[strlen($name)-1] == '$') break;
						if ($this->cfgHidePrinterShares == true AND $type == 'printer') break;
						$this->shares[$name] = array (
							'name' => $name,
							'type' => $type,
							'comment' => $regs[3],
							'img'=>'tree.gif',
						);
					break;
					case 'SERVERS_OR_WORKGROUPS':
						$name = trim(substr($line,1,21));
						$comment = trim(substr($line, 22));
						if ($mode == 'servers') {
							$this->servers[$name] = array ('name' => $name, 'type' => 'server', 'comment' => $comment);
						} else {
							$this->workgroups[$name] = array ('name' => $name, 'type' => 'workgroup', 'comment' => $comment);
						}
					break;
					case 'FILES':
						// with attribute ?
						// Attribut N (ab Samba 4) bisher unbekannt -> hinfugefuegt
						// Stefan Schaefer stefan@invis-server.org
						if (preg_match("/^(.*)[ ]+([D|A|H|S|R|N]+)$/", trim($regs[1]), $regs2)) {
							$attr = trim($regs2[2]);
							$name = trim($regs2[1]);
						} else {
							$attr = '';
							$name = trim($regs[1]);
						}
						if ($name <> '.' AND $name <> '..') {
							$type = (strpos($attr,'D') === false) ? 'file' : 'folder';
							if ($this->cfgRecycleName && $name==$this->cfgRecycleName) $type='trash';
							if ($this->cfgHideDotFiles && $name[0]=='.' && $type!='trash') continue;
							if ($this->cfgOnlyFolders && $type == 'file') continue;
							$info = $this->getInfo($name,$type);
							$this->files[$name] = array (
								'name' => $this->decode($name),
								'attr' => $attr,
								'size' => $regs[2],
								'time' => $this->_ParseTime($regs[4],$regs[5],$regs[7],$regs[6]),
								'type' => $type,
								'img'=>$info['img'],
								'mime'=>$info['mime'],
								'ext'=>$info['ext'],
							);
						}
					break;
					case 'PRINT_JOBS':
						$name = $regs[1].' '.$regs[3];
						$this->printjobs[$name] = array(
							'name'=>$name,
							'type'=>'printjob',
							'id'=>$regs[1],
							'size'=>$regs[2]
						);
					break;
					case 'SIZE':
						$this->size = $regs[1] * $regs[2];
						$this->available = $regs[3] * $regs[2];
					break;
					case 'ERROR':
						$this->status = $regs[1];
					break;
					default:
						$this->status = $lineType;
				}
			}
		}
		//debugtime('E');
		//$this->closePipe($share);
	}
	function openPipe($share) {
		if (!is_resource($this->_resource[$share])) {
			//debugtime('B');
			$this->_pipes[$share]=array();
			$command='smbclient '.escapeshellarg($share);
			if ($this->user <> '') {
				# not anonymous
				switch ($this->cfgAuthMode) {
					case 'SMB_AUTH_ENV':
						putenv('USER='.$this->user.'%'.$this->pw);
					break;
					case 'SMB_AUTH_ARG':
						$command.= ' -U '.escapeshellarg($this->user.'%'.$this->pw);
				}
			}
			if ($this->workgroup <> '') $command.= ' -W '.escapeshellarg($this->workgroup);
			if ($this->socketOptions <> '') $command.= ' -O '.escapeshellarg($this->socketOptions);
			if ($this->blockSize <> '') $command.= ' -b '.$this->blockSize;

			//debug($command);
			if (function_exists('expect_popen')) {
				$this->_resource[$share] = expect_popen($command);
				$this->_pipes[$share]=array(
					0=>$this->_resource[$share],
					1=>$this->_resource[$share],
				);
			} else {
				$descriptorspec = array(
					0 => array("pty",'r'),  // stdin is a pipe that the child will read from
					1 => array("pty",'w'),  // stdout is a pipe that the child will write to
				);
				$this->_resource[$share] = proc_open($command, $descriptorspec,$this->_pipes[$share]);
			}


			if (is_resource($this->_resource[$share])) {
				return true;
			} else {
				return false;
			}
		}
		return true;
	}
	function closePipe() {
		foreach (array_keys($this->_resource) as $share) {
			if (function_exists('expect_popen')) {
				fclose($this->_resource[$share]);
			} else {
				fclose($this->_pipes[$share][0]);
				fclose($this->_pipes[$share][1]);
				proc_close($this->_resource[$share]);
			}
			unset($this->_pipes[$share]);
			unset($this->_resource[$share]);
		}
		return true;
	}
	function readPipe(&$pipe) {
		$retval=array();
		while ($line=fgets($pipe)) {
			//debug('aaa'.$line);
			$retval[]=rtrim(preg_replace('/smb:([^>]*)> /','',$line));
			if (strpos($line,'Current directory')!==false) break;
        }
        return $retval;
	}
	function writePipe(&$pipe,$val) {
		fwrite($pipe,$val."\n");
		fflush($pipe);
	}
}
?>