<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class geSmsCtrlAjax{
	private $result;
	private $_frm;
	private $T;
	public function __construct() {
		global $frm,$T;
		$this->_frm=$frm;
		$this->_T=$T;
		$this->_Base=$this->_frm->getStaticModul('sms');
		$this->_BaseRes=$this->_frm->getStaticModul('sms_res');
		$this->_BaseQuot=$this->_frm->getStaticModul('sms_quota');
	}
	public function searchSmsAddress($search) {
		$result=array();
		$limit=20;
		if ($limit) {
			$rows=0;
			$data=$this->_frm->searchUser($rows,trim($search['query']),0,0,0,$limit,false,true,array('onlyMobil'=>1));
			//debug($data);
			if (!empty($data)) {
				foreach ($data as $key=>$v) {
					$result[]=array(
						'name'=>$this->_Base->formatNumber($v['mobil'],$v['lastname'].' '.$v['firstname']),
						'value'=>$this->_Base->formatNumber($v['mobil'],$v['lastname'].' '.$v['firstname']),
						'img'=>'img/ge/user.gif',
					);
					$limit--;
				}
			}
		}
		if ($limit) {
			$data=$this->_frm->getAllGroups(0,0,trim($search['query']),$limit);
			if (!empty($data)) {
				foreach ($data as $key=>$v) {
					$uids=$this->_frm->getGroupUsers($key);
					if (!empty($uids)) {
						$rows=0;
						$users=$this->_frm->searchUser($rows,'',$uids,0,0,$limit,false,true,array('onlyMobil'=>1));
						$value=array();
						foreach ($users as $uid=>$uv) {
							$value[]=$this->_Base->formatNumber($uv['mobil'],$uv['lastname'].' '.$uv['firstname']);
						}
						if (!empty($value)) {
							$result[]=array(
								'name'=>$v,
								'value'=>implode(',',$value),
								'img'=>'img/ge/gruppe.gif',
							);
							$limit++;
						}
					}
				}
			}
		}
		if ($limit) {
			$Addr=& $this->_frm->getStaticModul('addr');
			$Addr->setLimit($limit);
			if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
				$searchAddr=array(
					'search'=>array(
						0=>array(
							'mode'=>'and',
							'field'=>array(
								0=>array(
									'key' => 'Mobil',
									'typ' => 'addr',
									'mode' => 'nis',
									'value' => '',
								),
							),
						),
					),
					'info'=>trim($search['query']),
					'searchSub'=>1,
				);
				$data=$Addr->searchAddr(0,array('Name'=>1),$searchAddr);
				//debug($data);
			} else {
				$searchNode=null;
				$searchAddr=array();
				$searchAddr[]=array('Field'=>'Trash','Typ'=>'=','Values'=>0);
				if ($Addr->getArchivCat()) {
					$searchAddr[]=array('Field'=>'Archiv','Typ'=>'=','Values'=>0);
				}
				$concatFields=array('Name','Mobil');
				$searchAddr[]=array('Field'=>$concatFields,'Typ'=>'concat','Values'=>$search['query'],'UseCase'=>0,'OnlyWords'=>0);
				$searchAddr[]=array('Field'=>'Mobil','Typ'=>'!=','Values'=>'');
				$sort=array('Name'=>1);
				$data=$Addr->searchAddr(0,$sort,$searchAddr,$searchNode,null,null,false,true,array('AOrt','POrt','Mobil'));
			}

			$unique=array();
			if (is_array($data)) {
				foreach ($data as $dkey=>$dval) {
					$unique[$dval->getName()][]=$dkey;
				}
			}
			foreach ($unique as $dval) {
				if (count($dval)>1) {
					foreach ($dval as $dkey) {
						if ($data[$dkey]->getMeta('POrt')) {
							$data[$dkey]->setMeta('Vorname',trim($data[$dkey]->getMeta('Vorname').' ('.$data[$dkey]->getMeta('POrt').')'));
						} elseif ($data[$dkey]->getMeta('AOrt')) {
							$data[$dkey]->setMeta('Vorname',trim($data[$dkey]->getMeta('Vorname').' ('.$data[$dkey]->getMeta('AOrt').')'));
						}
					}
				}
			}
			if (is_array($data)) {

				foreach ($data as $key=>$v) {
					$tmp=$Addr->AddrExplode($v->getMeta('Mobil'));
					//debug($v);
					if ($tmp[0]) {
						$result[]=array(
							'name'=>$this->_Base->formatNumber($tmp[0],$v->getName()),
							'value'=>$this->_Base->formatNumber($tmp[0],$v->getName(1)),
							'img'=>$v->getMeta('UserID')?'img/ge/l_addr_p.gif':'img/ge/l_addr.gif',
						);
						$limit--;
					}
				}
			}
		}



		$this->result=$result;
	}
	public function sendSmsMessage($params) {
		$this->result=array(
			'error'=>'',
			'error_msg'=>'',
		);
		if (!$this->_frm->getMyApps('sms')) {
			$this->result['error']='MSG';
			$this->result['error_msg']=$this->_T->lang('[[Keine Berechtigung]]');
			return false;
		}
		$msg=new ObjSmsMessage();
		$badNumbers=array();
		$goodNumbers=array();
		if (trim($params['msg_to'])) {
			foreach (explode(',',$params['msg_to']) as $val) {
				$number=$this->_Base->parseNumber($val);
				if (strlen($number[0])<=8) {
					$badNumbers[]=$val;
				} else {
					$goodNumbers[]=$this->_Base->formatNumber($number[0],$number[1]);
				}
			}
		}
		if ($params['msg_bulk'] &&($list=$this->getAddrList($params['msg_bulk']))) {
			$msg->setMeta('sms_bulk',$params['msg_bulk']);
			$msg->setMeta('sms_bulk_list',$list['name']);
			foreach ($list['entries'] as $val) {
				if (strlen($this->_Base->formatNumber($val['data']))<=8) {
					$badNumbers[]=htmlspecialchars($val['name']).' &lt;'.htmlspecialchars($val['data']).'&gt;';
				} else {
					$goodNumbers[]=$this->_Base->formatNumber($val['data'],$val['name']);
				}
			}
		}
		$this->_T->loadModul('sms');
		if (!empty($badNumbers)) {
			$this->result['error']='MSG';
			$this->result['error_msg']='<div><strong>'.$this->_T->lang('[[Fehler_SmsNummern]]').'</strong><br />- '.implode("<br />- ",$badNumbers).'</div>';
			return false;
		}
		if (empty($goodNumbers)) {
			$this->result['error']='OK';
			$this->result['error_msg']=str_replace('{NUM}',0,$this->_T->lang('[[Es wurden {NUM} Nachrichten versendet]]'));
			return false;
		}
		if ($this->_Base->getCfg('cfg/settings/limit_to') && count($goodNumbers)>$this->_Base->getCfg('cfg/settings/limit_to')) {
			$this->result['error']='MSG';
			$this->result['error_msg']=$this->_T->lang('[[Fehler_AnzahlNummern]]');
			return false;
		}
		$quota=$this->_BaseQuot->getMyQuota();

		if ($quota['dayLimit'] && ($this->_BaseRes->countSendDay()+ count($goodNumbers))>$quota['dayLimit']) {
			$this->result['error']='MSG';
			$this->result['error_msg']=$this->_T->lang('[[Fehler_UserTageslimit]]');
			return false;
		}
		if ($quota['weekLimit'] && ($this->_BaseRes->countSendWeek()+ count($goodNumbers))>$quota['weekLimit']) {
			$this->result['error']='MSG';
			$this->result['error_msg']=$this->_T->lang('[[Fehler_UserWochenlimit]]');
			return false;
		}
		if ($quota['monthLimit'] && ($this->_BaseRes->countSendMonth()+ count($goodNumbers))>$quota['monthLimit']) {
			$this->result['error']='MSG';
			$this->result['error_msg']=$this->_T->lang('[[Fehler_UserMonatslimit]]');
			return false;
		}
		if ($quota['yearLimit'] && ($this->_BaseRes->countSendYear()+ count($goodNumbers))>$quota['yearLimit']) {
			$this->result['error']='MSG';
			$this->result['error_msg']=$this->_T->lang('[[Fehler_UserJahreslimit]]');
			return false;
		}


		$msg_senddate=FrameWork::parseSqlDate($params['msg_senddate']);

		//debug(date('d.m.Y H:i:s',$msg_senddate));
		//exit;

		$msg->setMeta('sms_userid',$this->_frm->getUser());
		$msg->setMeta('sms_email',trim($params['msg_from_email'])?$params['msg_from_email']:$this->_frm->getCachedUser(0,'email'));
		$msg->setMeta('sms_from',$params['msg_from']);
		$msg->setMeta('sms_to',implode(',',$goodNumbers));
		$msg->setMeta('sms_senddate',$msg_senddate>time()?$msg_senddate:0);
		$msg->setMeta('sms_message',$params['msg_message']);
		$msg->setMeta('sms_email_alert',1);


		$result=$this->_Base->sendSmsMessage($msg);
		if (!$result) {
			$this->result['error']='MSG';
			$this->result['error_msg']=$this->_T->lang('[[Fehler_SmsServerVerbindung]]');
			return false;
		} else {
			if ($result->status==GE_SMS_CODE_OK) {
				$this->result['error']='OK';
				$this->result['error_msg']=str_replace('{NUM}',count($result->result),$this->_T->lang('[[Es wurden {NUM} Nachrichten versendet]]'));
			} else {
				switch($result->status) {
					case GE_SMS_CODE_NO_CREDITS:
						$this->result['error']='MSG';
						$this->result['error_msg']=$this->_T->lang('[[Fehler_ServerGuthaben]]');
					break;
					case GE_SMS_CODE_LIMIT_DAY:
						$this->result['error']='MSG';
						$this->result['error_msg']=$this->_T->lang('[[Fehler_ServerTageslimit]]');
					break;
					case GE_SMS_CODE_LIMIT_WEEK:
						$this->result['error']='MSG';
						$this->result['error_msg']=$this->_T->lang('[[Fehler_ServerWochenlimit]]');
					break;
					case GE_SMS_CODE_LIMIT_MONTH:
						$this->result['error']='MSG';
						$this->result['error_msg']=$this->_T->lang('[[Fehler_ServerMonatslimit]]');
					break;
					case GE_SMS_CODE_LIMIT_YEAR:
						$this->result['error']='MSG';
						$this->result['error_msg']=$this->_T->lang('[[Fehler_ServerJahreslimit]]');
					break;
					default:
						$this->result['error']='MSG';
						$this->result['error_msg']=$this->_T->lang('[[Fehler_SmsGeneric]]');
					break;
				}
			}
			//$msg->setMeta('msg_status','ERROR');
			//$msg->setMeta('msg_status','ERROR');
		}
		return false;
	}
	public function getBulkList($params) {
		$this->result=array(
			'num'=>0,
		);
		if ($params['vsrid'] && ($result=$this->getAddrList($params['vsrid']))) {
			$this->result['num']=count($result['entries']);
		}
	}
	private function getAddrList($id) {
		$Addr=$this->_frm->getStaticModul('addr');
		if ($sdata=$Addr->readAddrSearch($id)) {
			$result=array(
				'name'=>$sdata['Title'],
				'entries'=>array(),
			);
			if ($Addr->getUser()!=$sdata['FKUserID']) {
				$tmp_rules=$this->_frm->getUserRules($sdata['FKUserID']);
			}
			if ($tmp_rules['addr'] || $tmp_rules['sysadmin']) $Addr->setRule(1);
			$Addr->setUser($sdata['FKUserID']);
			$Addr->setUser($sdata['FKUserID']);
			$Addr->setGroups($this->_frm->getUserGroups($sdata['FKUserID']));
			$Addr->loadFields();

			$list_fields=array();
			foreach ($Addr->getFields() as $key=>$val) {
				if ($val['Action']=='sms') {
					$list_fields[]=$key;
				}
			}
			$Addr->setListFields($list_fields);
			$Addr->setLimit(0);
			$search=unserialize($sdata['Sdata']);

			$sqlOrder=array('Name'=>1);
			$ftree=$Addr->searchAddrAdv(0,$sqlOrder,$search['search'],false,true,$search['use_archiv']);
			if ($Addr->getRows()) {
				foreach ($ftree as $key=>$val) {
					$data='';
					foreach ($Addr->getListFields() as $FieldID) {
						if ($Addr->getFieldData($FieldID,'Action')=='sms') {
							$values=$Addr->AddrExplode($val->getMeta($FieldID));
							if ($values[0]) {
								$data=$values[0];
							}
						}
					}
					if ($data) {
						$result['entries'][]=array(
							'name'=>$val->getName(1),
							'data'=>$data,
						);
					}
				}
			}
			return $result;
		}
		return false;
	}
	public function getResult() {
		return $this->result;

	}



}
?>