<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
define('GE_SMS_CODE_OK',1);
define('GE_SMS_CODE_AUTHENTICATION_ERROR',10);
define('GE_SMS_CODE_GATEWAY_INVALID',20);
define('GE_SMS_CODE_NO_FROM',50);
define('GE_SMS_CODE_NO_TO',60);
define('GE_SMS_CODE_NO_MESSAGE',70);
define('GE_SMS_CODE_NO_MSGID',80);
define('GE_SMS_CODE_NO_USERID',90);
define('GE_SMS_CODE_NO_CREDITS',100);
define('GE_SMS_CODE_LIMIT_DAY',200);
define('GE_SMS_CODE_LIMIT_WEEK',210);
define('GE_SMS_CODE_LIMIT_MONTH',220);
define('GE_SMS_CODE_LIMIT_YEAR',230);

class ObjSmsMessage extends baseObj {
	public $_action=array('e','e'); // to owerwrite;
	public $_site='sms.php'; // to owerwrite;
	public $_obj_typ='0';
	public $_umeta=array();
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['Title'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}


class geSmsModelMessage extends ObjCore{
	public $_modul='sms';
	public $_table='SmsMessages';
	public $_cfgObjects=array (
		'IdField'=>'sms_msgid',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'0'=>array(
			'ClassName'=>'ObjSmsMessage',
			'Fields'=>array(
				'sms_msgid'=>array(
					'TYP'=>'int',
					'Extra'=>'ID',
				),
				'sms_userid'=>array(
					'TYP'=>'int',
				),
				'sms_email'=>array(
					'TYP'=>'text',
				),
				'sms_email_alert'=>array(
					'TYP'=>'int',
				),
				'sms_from'=>array(
					'TYP'=>'text',
				),
				'sms_to'=>array(
					'TYP'=>'text',
				),
				'sms_bulk'=>array(
					'TYP'=>'int',
				),
				'sms_bulk_list'=>array(
					'TYP'=>'text',
				),
				'sms_message'=>array(
					'TYP'=>'text',
				),
				'sms_senddate'=>array(
					'TYP'=>'int',
				),
				'sms_soap_response'=>array(
					'TYP'=>'int',
				),
				'sms_timecreate'=>array(
					'TYP'=>'int',
					'Extra'=>'cTime',
				),
			),
		),
	);
	public function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','sms')));
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
		/*$this->setCfg(array(
			'cfg/server/user'=>'demo',
		));*/
	}
	public function formatNumber($number,$name='') {
		$number=str_replace('+','00',$number);
		$number=preg_replace('/[^0-9]/','',$number);
		//$number=preg_replace('/^00/','+',$number);
		if (!preg_match('/^00/',$number)) {
			$number=$this->getCfg('cfg/settings/prefix').$number;
		}		
		if (trim($name)) {
			$name=preg_replace('/[,<>]/',' ',$name);
			return trim($name).' <'.$number.'>';
		} else {
			return $number;
		}
	}
	public function parseNumber($name='') {
		$matches=array();
		$result=array();
		if (preg_match('/^([^<>]*)<([+0-9 -]+)>/',$name,$matches)) {
			$result[0]=$this->formatNumber(trim($matches[2]));
			$result[1]=trim($matches[1]);
		} else {
			$result[0]=$this->formatNumber(trim($name));
			$result[1]='';
		}
		return $result;
	}
	function listAll(&$rows,$search,$order='Datum ASC') {
		$searchQuery=array();
		if ($search['grp_userid'] && !empty($search['grp_userid'])) {
			$searchQuery[]=array('Field'=>'sms_userid','Typ'=>'=','Values'=>$search['grp_userid']);
		}
		if ($search['StartDate']) {
			$searchQuery[]=array('Field'=>'sms_timecreate','Typ'=>'=>','Values'=>$search['StartDate']);
		}
		if ($search['EndDate']) {
			$searchQuery[]=array('Field'=>'sms_timecreate','Typ'=>'<=','Values'=>$search['EndDate']);
		}
		if ($search['Info']) {
			//msg_to_text

			//sms_from 	sms_to 	sms_message
		}
		$params['FIELDS']='MAX(SmsResponse.msg_lastchange) as msg_lastchange';
		$params['GROUP_FIELD']='sms_msgid';
		$params['JOIN']='LEFT JOIN SmsResponse ON (SmsResponse.grp_msgid=SmsMessages.sms_msgid)';
		$params['CALLBACK']=array($this,'addResponseMeta');

		return $this->searchObj($rows,$searchQuery,$order,$search['b'],$search['limit'],true,true,false,$params);
	}
	function addResponseMeta(&$Obj) {
		$Obj->setMeta('_msg_lastchange',$this->_db->f('msg_lastchange'));
		//$Obj->setMeta('_sms_message',$this->_db->f('sms_message'));
	}
	public function sendSmsMessage($Obj) {
		require_once('lib/sms/soap/geSmsSoapHeaderUsernameToken.php');
		require_once('lib/sms/soap/geSmsSoapRequestSendsms.php');
		require_once('lib/sms/soap/geSmsSoapResponseSendsms.php');
		
		if ($this->insertMeta($Obj)) {
			//debug($Obj);
			$classmap = array(
				'smsRequestSendsms' => 'smsSoapRequestSendsms',
				'smsResponseSendsms' => 'smsSoapResponseSendsms',
			);
			$wsdl=null;
			$soapClient = new SoapClient($wsdl,array(
				'location' => $this->getCfg('cfg/server/url'),
				'uri'      => "http://localhost/SoapServer/",
				'classmap' => $classmap,
				'trace'=>true,
			));
			$function='Sendsms';
			$soapParams=new geSmsSoapRequestSendsms();
			$soapParams->lang=$this->_frm->getLang();
			$soapParams->msgid=$Obj->getID();
			$soapParams->userid=$Obj->getMeta('sms_userid');
			$soapParams->email=$Obj->getMeta('sms_email');
			$soapParams->email_alert=$Obj->getMeta('sms_email_alert');
			$soapParams->from=$Obj->getMeta('sms_from');
			$soapParams->message=$Obj->getMeta('sms_message');
			$soapParams->senddate=$Obj->getMeta('sms_senddate');
			$soapParams->to=$Obj->getMeta('sms_to');
			$soapParams->bulk=$Obj->getMeta('sms_bulk');
			
			
			try {
				$soapHeaders=array(new SoapHeader('http://schemas.xmlsoap.org/ws/2002/07/utility', 'UsernameToken', new geSmsSoapHeaderUsernameToken($this->getCfg('cfg/server/user'),$this->getCfg('cfg/server/pwd'))));
				$soapClient->__setSoapHeaders($soapHeaders);
				//debug($soapParams);
				$result=$soapClient->__soapCall($function,array('parameter'=>$soapParams));
				if (is_object($result)) {
					$Obj->setMeta('sms_soap_response',$result->status);
					$this->updateMeta($Obj);
					if ($result->status==GE_SMS_CODE_OK) {
						$BaseRes=$this->_frm->getStaticModul('sms_res');
						//Detailierter Status pro SMS:
						foreach($result->result as $status) {
							$res=new ObjSmsResponse();
							$res->setMeta('msg_ref',$status['msg_ref']);
							$res->setMeta('msg_date',$status['msg_date']);
							$res->setMeta('msg_from',$status['msg_from']);
							$res->setMeta('msg_to',$status['msg_to']);
							$res->setMeta('msg_senddate',$status['msg_senddate']);
							$res->setMeta('msg_response',$status['msg_response']);
							$res->setMeta('msg_count',$status['msg_count']);
							$res->setMeta('msg_status',$status['msg_status']);
							$res->setMeta('msg_lastchange',$status['msg_lastchange']);
							$res->setMeta('grp_msgid',$status['grp_msgid']);
							$res->setMeta('grp_userid',$status['grp_userid']);
							$BaseRes->insertMeta($res);
							
						}
					}
				} else {
					$result=false;
				}
			} catch (Exception $e) {
				//echo '<h2>Exception:</h2>';
				//debug($e);
				//echo htmlspecialchars($soapClient->__getLastResponse());
				$result=false;
			}
				//debug($result);

			return $result;
		}
	}
	
}
?>