<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

class ObjSmsResponse extends baseObj {
	public $_action=array('e','e'); // to owerwrite;
	public $_site='sms.php'; // to owerwrite;
	public $_obj_typ='0';
	public $_umeta=array();
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['Title'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}


class geSmsModelResponse extends ObjCore{
	public $_modul='sms';
	public $_table='SmsResponse';
	public $_cfgObjects=array (
		'IdField'=>'msg_ref',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'0'=>array(
			'ClassName'=>'ObjSmsResponse',
			'Fields'=>array(
				'msg_date'=>array(
					'TYP'=>'date',
				),
				'msg_ref'=>array(
					'TYP'=>'text',
				),
				'msg_id'=>array(
					'TYP'=>'text',
				),
				'msg_from'=>array(
					'TYP'=>'text',
				),
				'msg_to'=>array(
					'TYP'=>'text',
				),
				'msg_to_text'=>array(
					'TYP'=>'text',
				),
				'msg_senddate'=>array(
					'TYP'=>'int',
				),
				'msg_response'=>array(
					'TYP'=>'int',
				),
				'msg_status'=>array(
					'TYP'=>'text',
				),
				'msg_cost'=>array(
					'TYP'=>'float',
				),
				'msg_count'=>array(
					'TYP'=>'int',
				),
				'msg_send'=>array(
					'TYP'=>'int',
				),
				'msg_receive'=>array(
					'TYP'=>'int',
				),
				'msg_clientip'=>array(
					'TYP'=>'int',
				),
				'msg_lastchange'=>array(
					'TYP'=>'int',
				),
				'grp_msgid'=>array(
					'TYP'=>'int',
				),
				'grp_userid'=>array(
					'TYP'=>'int',
				),
			),
		),
	);
	public function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','sms')));
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
		/*$this->setCfg(array(
			'cfg/server/user'=>'demo',
		));*/
	}
	public function countSendDay($time=null,$uid=0) {
		if (!$time)	$time=time();
		if (!$uid)	$uid=$this->_frm->getUser();

		$searchQuery=array();
		$searchQuery[]=array('Field'=>'msg_response','Typ'=>'=','Values'=>100);
		$searchQuery[]=array('Field'=>'grp_userid','Typ'=>'=','Values'=>$uid);
		$searchQuery[]=array('Field'=>'msg_date','Typ'=>'>=','Values'=>date('Y-m-d 00:00:00',$time));
		$searchQuery[]=array('Field'=>'msg_date','Typ'=>'<=','Values'=>date('Y-m-d 23:59:59',$time));
		$searchQuery[]=array('Field'=>'msg_date','Typ'=>'>=','Values'=>mktime(0,0,0,date('m',$time),date('d',$time),date('Y',$time)));
		$searchQuery[]=array('Field'=>'msg_date','Typ'=>'<=','Values'=>mktime(23,59,59,date('m',$time),date('d',$time),date('Y',$time)));

		$query="SELECT count(*) as num FROM SmsResponse WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('num');
		}
		return 0;
	}
	public function countSendWeek($time=null,$uid=0) {
		if (!$time)	$time=mktime(12,0,0);
		if (!$uid)	$uid=$this->_frm->getUser();

		$dayNum=date('w',$time);
		if (!$dayNum) $dayNum=7;
		$dayNum--; //0: Montag; 6:Sonntag

		
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'msg_response','Typ'=>'=','Values'=>100);
		$searchQuery[]=array('Field'=>'grp_userid','Typ'=>'=','Values'=>$uid);
		$time-=$dayNum*3600*24;
		//debug(date('d.m.Y H:i',$time));
		$searchQuery[]=array('Field'=>'msg_date','Typ'=>'>=','Values'=>mktime(0,0,0,date('m',$time),date('d',$time),date('Y',$time)));
		$time+=6*3600*24;
		//debug(date('d.m.Y H:i',$time));
		$searchQuery[]=array('Field'=>'msg_date','Typ'=>'<=','Values'=>mktime(23,59,59,date('m',$time),date('d',$time),date('Y',$time)));
	

		$query="SELECT count(*) as num FROM SmsResponse WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('num');
		}
		return 0;
	}
	public function countSendMonth($time=null,$uid=0) {
		if (!$time)	$time=time();
		if (!$uid)	$uid=$this->_frm->getUser();

		$searchQuery=array();
		$searchQuery[]=array('Field'=>'msg_response','Typ'=>'=','Values'=>100);
		$searchQuery[]=array('Field'=>'grp_userid','Typ'=>'=','Values'=>$uid);
		$searchQuery[]=array('Field'=>'msg_date','Typ'=>'>=','Values'=>mktime(0,0,0,date('m',$time),1,date('Y',$time)));
		$searchQuery[]=array('Field'=>'msg_date','Typ'=>'<=','Values'=>mktime(23,59,59,date('m',$time),date('t',$time),date('Y',$time)));
		

		$query="SELECT count(*) as num FROM SmsResponse WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('num');
		}
		return 0;
	}
	public function countSendYear($time=null,$uid=0) {
		if (!$time)	$time=time();
		if (!$uid)	$uid=$this->_frm->getUser();

		$searchQuery=array();
		$searchQuery[]=array('Field'=>'msg_response','Typ'=>'=','Values'=>100);
		$searchQuery[]=array('Field'=>'grp_userid','Typ'=>'=','Values'=>$uid);
		$searchQuery[]=array('Field'=>'msg_date','Typ'=>'>=','Values'=>mktime(0,0,0,1,1,date('Y',$time)));
		$searchQuery[]=array('Field'=>'msg_date','Typ'=>'<=','Values'=>mktime(23,59,59,12,31,date('Y',$time)));

		$query="SELECT count(*) as num FROM SmsResponse WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('num');
		}
		return 0;
	}
	function listAll(&$rows,$search,$order='Datum ASC') {
		$searchQuery=array();
		if ($search['grp_userid'] && !empty($search['grp_userid'])) {
			$searchQuery[]=array('Field'=>'SmsResponse.grp_userid','Typ'=>'=','Values'=>$search['grp_userid']);
		}
		if ($search['StartDate']) {
			$searchQuery[]=array('Field'=>'SmsResponse.msg_date','Typ'=>'>=','Values'=>$search['StartDate']);
		}
		if ($search['EndDate']) {
			$searchQuery[]=array('Field'=>'SmsResponse.msg_date','Typ'=>'<=','Values'=>$search['EndDate']);
		}
		if ($search['Status']) {
			$searchQuery[]=array('Field'=>'SmsResponse.msg_status','Typ'=>'=','Values'=>$search['Status']);
			//msg_to_text

			//sms_from 	sms_to 	sms_message
		}
	//	debug(date('d.m.Y',$search['StartDate']));
	//	print_r($searchQuery);
		$params['FIELDS']='SmsMessages.sms_to,SmsMessages.sms_message';
		$params['JOIN']='LEFT JOIN SmsMessages ON (SmsResponse.grp_msgid=SmsMessages.sms_msgid)';
		$params['CALLBACK']=array($this,'addSmsMeta');
		
		return $this->searchObj($rows,$searchQuery,$order,$search['b'],$search['limit'],true,true,false,$params);
	}
	function addSmsMeta(&$Obj) {
		$Obj->setMeta('_sms_to',$this->_db->f('sms_to'));
		$Obj->setMeta('_sms_message',$this->_db->f('sms_message'));
	}
	function getSum($search) {
		$searchQuery=array();
		if ($search['grp_userid'] && !empty($search['grp_userid'])) {
			$searchQuery[]=array('Field'=>'SmsResponse.grp_userid','Typ'=>'=','Values'=>$search['grp_userid']);
		}
		if ($search['StartDate']) {
			$searchQuery[]=array('Field'=>'SmsResponse.msg_date','Typ'=>'>=','Values'=>$search['StartDate']);
		}
		if ($search['EndDate']) {
			$searchQuery[]=array('Field'=>'SmsResponse.msg_date','Typ'=>'<=','Values'=>$search['EndDate']);
		}
		$query="SELECT SUM(msg_count) as msg_count FROM SmsResponse ";
		if (!empty($searchQuery)) $query.=" WHERE ".$this->_db->getWhere($searchQuery);

		$this->_db->query($query);
		$this->_db->next_record();
		return $this->_db->f('msg_count');
	}
	function getResponses($msg_id=array()) {
		$result=array();
		if (!empty($msg_id)) {
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'SmsResponse.grp_msgid','Typ'=>'=','Values'=>$msg_id);

			$query="SELECT grp_msgid,msg_status,count(*) as _rows,SUM(msg_count) as _num FROM SmsResponse GROUP BY grp_msgid,msg_status";
			$this->_db->query($query);
			while($this->_db->next_record()) {
				$result[$this->_db->f('grp_msgid')][$this->_db->f('msg_status')]=array('r'=>$this->_db->f('_rows'),'n'=>$this->_db->f('_num'));
			}
			
		}
		return $result;
	}
	public function synchronize() {
		require_once('lib/sms/soap/geSmsSoapHeaderUsernameToken.php');
		require_once('lib/sms/soap/geSmsSoapRequestGetstatus.php');
		require_once('lib/sms/soap/geSmsSoapResponseGetstatus.php');

		$classmap = array(
			'smsRequestGetstatus' => 'smsSoapRequestGetstatu',
			'smsResponseGetstatu' => 'smsSoapResponseGetstatu',
		);
		$wsdl=null;
		$soapClient = new SoapClient($wsdl,array(
			'location' => $this->getCfg('cfg/server/url'),
			'uri'      => "http://localhost/SoapServer/",
			'classmap' => $classmap,
			'trace'=>true,
		));
		$function='Getstatus';
		$lastchange=$this->_frm->getModulData($this->getModul(),'',0,'smsLastSynchronized');
		$soapParams=new geSmsSoapRequestGetstatus();
		$soapParams->lastchange=$lastchange;

		try {
			$soapHeaders=array(new SoapHeader('http://schemas.xmlsoap.org/ws/2002/07/utility', 'UsernameToken', new geSmsSoapHeaderUsernameToken($this->getCfg('cfg/server/user'),$this->getCfg('cfg/server/pwd'))));
			$soapClient->__setSoapHeaders($soapHeaders);
			//debug($soapParams);
			$result=$soapClient->__soapCall($function,array('parameter'=>$soapParams));
		} catch (Exception $e) {
			//echo '<h2>Exception:</h2>';
			//debug($e);
			//echo htmlspecialchars($soapClient->__getLastResponse());
			$result=false;
		}
		if ($result->status==GE_SMS_CODE_OK) {
			foreach($result->result as $status) {
				//debug($status);
				if ($res=$this->getObj($status['msg_ref'])) {
					$res->setMeta('msg_id',$status['msg_id']);
					$res->setMeta('msg_to',$status['msg_to']);
					$res->setMeta('msg_to_text',$status['msg_to_text']);
					$res->setMeta('msg_status',$status['msg_status']);
					$res->setMeta('msg_lastchange',$status['msg_lastchange']);
					$lastchange=max($lastchange,$status['msg_lastchange']);
					$this->updateMeta($res);
				} else {

					
				}
			}
			$this->_frm->insertModulData($this->getModul(),'',0,'smsLastSynchronized',$lastchange);
			return true;
		}
		return false;
	}
}
?>