<?php
class GroupeSoapServer {
	protected $_authenticated=false;
	protected $_frm;
	protected $_user=0;
	protected $_domain='';
	protected $_user_data=array();
	protected $_groupeSessionId=array();
	protected $_catPrepends=array(
		'P'=>'P.',
		'A'=>'A.',
		'T'=>'T.',
		'C'=>'C.',
	);
    public function __construct() {
   		debug('GroupeSoapServer');
		global $frm;
		$this->_frm=& $frm;
		$this->_domain=GE_DOMAIN?GE_DOMAIN:str_replace('www.','',$_SERVER['SERVER_NAME']);
		/* Eventuell Basic AUTH erlauben
		 * if (isset($_SERVER['PHP_AUTH_USER']) && isset($_SERVER['PHP_AUTH_PW'])) {
			$this->UsernameToken((object)array('Username'=>$_SERVER['PHP_AUTH_USER'],'Password'=>$_SERVER['PHP_AUTH_PW']));
		}*/
    }
    public function __wakeup() {
		debug('GroupeSoapServer::__wakeup');
		global $frm;
		$this->_frm->clearStaticModules();
		$frm=$this->_frm;
    }

    protected function throwSoapFault($error) {
		switch ($error) {
			case 'auth':
 				throw new SoapFault("Auth",'Authentication error');
 			break;
 			default:
 				throw new SoapFault("Generic",$error);
 			break;
		}
    }
    protected function decodeCharset(&$value,$key='') {
		if (GE_CHARSET!='UTF-8') {
			$value=iconv("UTF-8", "WINDOWS-1252//IGNORE", $value);
		}
    }
    protected function encodeCharset(&$value,$key='') {
		if (GE_CHARSET!='UTF-8') {
			$value=iconv("WINDOWS-1252//", "UTF-8//IGNORE", $value);
		} else {
			$value=iconv("UTF-8//", "UTF-8//IGNORE", $value);
		}
    }
	protected function objectToArray($object) {
        if(!is_object( $object ) && !is_array($object))  {
            return $object;
        }
        if(is_object($object)) {
            $object = get_object_vars( $object );
        }
        return array_map(array($this,'objectToArray'),$object);
    }    /*
     * Authentication function
     * This is called by the Soap header of the same name. The function name is a Ws-security standard auth tag
     * and corresponds to the header tag.
     *
     * @param object authObj
     */
    public function UsernameToken($authObj) {
        if (!$this->_frm->getUser() || $this->_user_data['username']!=$authObj->Username) {
       	 	$this->_username = $authObj->Username;
       	 	if (defined('GE_userDomainSuffix') && GE_userDomainSuffix && $GLOBALS['CFG']['USER_CLASS']=='ldap_full') {
				$this->_username=$this->_username.'_'.GE_userDomainSuffix;
			} elseif (GE_DOMAIN && $GLOBALS['CFG']['USER_CLASS']=='ldap_full') {
				$this->_username=$this->_username.'_'.str_replace('.','_',GE_DOMAIN);
			}
      		debug('checkPassword: username='.$this->_username.',password='.preg_replace('/./','*',$authObj->Password));
      		$this->decodeCharset($authObj->Password);
			if($this->_user=$this->_frm->checkPassword($this->_username,$authObj->Password)){
				$this->_user_data=$this->_frm->read_user($this->_user);
      		 	$this->_password = $this->_ldap_password = $authObj->Password;
				if ($GLOBALS['CFG']['USER_CLASS']=='ldap' && $this->_user_data['password']) {
					$this->_password = $this->_user_data['password'];
				}
    			$this->_frm->setUser($this->_user);
    			$lang=$this->_frm->getDefaults('global','lang');
				if (!$lang) $lang='en';
				$this->_frm->setLang($lang);
				$GLOBALS['T']->setLang($lang);
			} else {
				//$this->throwSoapFault( 'auth' );
			}
		}
    }
    public function logon() {
       if(!$this->_frm->getUser()) {
            return false;
       }
       $result=array(
			'uid'=>$this->_user_data['uidGroup-e'],
			'firstname'=>$this->_user_data['firstname'],
			'lastname'=>$this->_user_data['lastname'],
			'username'=>$this->_user_data['username'],
			'title'=>$this->_user_data['title'],
			'email'=>$this->_user_data['email'],
	   );
	   array_walk_recursive($result,array($this, 'encodeCharset'));
       return (object)$result;
    }
    public function readUser($id) {
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		return (object)$this->_user_data;
    }

    /*
     * Test method
     */
    public function test($action){
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
        
        return $action;
    }
    public function getContactByID($id) {
    	debug('getContactByID: id='.$id);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
        if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
			$addr=$this->_frm->getStaticModul('addr');
			$addr->setUserName($this->_username);
			$addr->setUserPwd($this->_ldap_password);
			$AObj=$addr->getAddrObj($id);
			if ($AObj) {
				$result=$AObj->_meta;
				array_walk_recursive($result,array($this, 'encodeCharset'));
				return (object)$result;
			}
		} else {
       		$addr=$this->_frm->getStaticModul('addr');
			$addr->getPerms();
			$AObj=$addr->getAddrObj($id);
			if ($AObj && $AObj->getAcl(2)) {
				$result=$AObj->_meta;
				$result['Name']=$AObj->getName();
				array_walk_recursive($result,array($this, 'encodeCharset'));
				return (object)$result;
			}
		}
		return false;
    }
    public function getContactByEmail($email) {
    	debug('getContactByEmail: email='.$email);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
        if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
			$addr=$this->_frm->getStaticModul('addr');
			$addr->setUserName($this->_username);
			$addr->setUserPwd($this->_ldap_password);
		} else {
       		$addr=$this->_frm->getStaticModul('addr');
			$addr->getPerms();
			$searchAddr[]=array();
			$searchAddr[]=array('Field'=>'Trash','Typ'=>'=','Values'=>'0');
			$searchAddr[]=array('Typ'=>'SQL','Values'=>"Email REGEXP '[[:<:]]".addslashes(preg_quote($email,''))."[[:>:]]'");
			$AObj=$addr->searchSingleAddr($searchAddr);
			if ($AObj && $AObj->getAcl(2)) {
				$result=$AObj->_meta;
				$result['Name']=$AObj->getName();
				array_walk_recursive($result,array($this, 'encodeCharset'));
				return (object)$result;
			}
		}
		return false;
    }
    public function updateContact($id,$contactobj) {
  		debug('updateContact: id='.$id);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$meta=$this->objectToArray($contactobj);
      	array_walk_recursive($meta,array($this, 'decodeCharset'));
		debug(print_r($meta,true));
		$addr=$this->_frm->getStaticModul('addr');
		$addr->getPerms();
		$catID=array();
		if (is_array($meta['_CategoriesID'])) {
			foreach ($meta['_CategoriesID'] as $tmpID) {
				debug('Search Address CatID:'.$tmpID);
				if ($nodeObj=$addr->getObj($tmpID)) {
					$catID[$nodeObj->getMeta('UserID')][]=$tmpID;
					debug('Found CatID:'.$tmpID);
				}
			}
		} elseif (is_array($meta['Categories'])) {
			foreach ($meta['Categories'] as $Name) {
				debug('Search Address CatName:'.$Name);
				if ($tmpID=$addr->catName2ID($Name,0,0,'',false,'.','')) {
					if ($nodeObj=$addr->getObj($tmpID)) {
						$catID[$nodeObj->getMeta('UserID')][]=$tmpID;
						debug('Found CatID:'.$tmpID);
					}
				}
			}
		}
		//debug(print_r($catObj,true));
		$perms=true;
		if ($id && ($AObj=$addr->getAddrObj($id))) {
			debug('Update Contact:'.$id);
			if ($AObj->getMeta('UserID')==$this->_frm->getUser()) {
				if (!empty($catID)) {
					if (isset($catID[$this->_frm->getUser()])) {
						$AObj->setParentMeta('NodeIDs',$catID[$this->_frm->getUser()]);
					} elseif (isset($catID[0]) && $addr->getPerms(4)) {
						$AObj->setParentMeta('NodeIDs',$catID[0]);
						$AObj->setMeta('UserID',0);
					}
				}
			} elseif (!$AObj->getMeta('UserID') && $AObj->getAcl(4)) {
				if (!empty($catID) && isset($catID[0])) {
					$AObj->setParentMeta('NodeIDs',$catID[0]);
				}
			} else {
				$perms=false;
			}
		} else {
			debug('NEW Contact');
			$AObj=new AObj_addr(0);
			$AObj->setMeta('UserCreate',$this->_frm->getUser());
			$AObj->setMeta('TimeCreate',time());
			if (isset($catID[0]) && $addr->getPerms(4)) {
				$AObj->setParentMeta('NodeIDs',$catID[0]);
				$AObj->setMeta('UserID',0);
			} elseif (isset($catID[$this->_frm->getUser()])) {
				$AObj->setMeta('UserID',$this->_frm->getUser());
				$AObj->setParentMeta('NodeIDs',$catID[$this->_frm->getUser()]);
			} else {
				$perms=false;
			}
		}
		if ($perms) {
			foreach ($addr->getFields() as $key=>$val) {
				if (isset($meta[$key])) $AObj->setMeta($key,$meta[$key]);
			}
			$AObj->setMeta('UserModify',$this->_frm->getUser());
			$AObj->setMeta('TimeModify',time());
			$AObj->setMeta('Name',$AObj->getName());
			if ($AObj->getID()) {
				$addr->updateAddrMeta($AObj);
			} else {
				$addr->insertAddrMeta($AObj);
			}
			return $AObj->getID();
		}
		debug('No UPDATE Permissions:'.$id);
		return false;
    }
    public function insertContactLog($id,$logText) {
  		debug('insertContactLog: id='.$id);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$addr=$this->_frm->getStaticModul('addr');
		$addr->getPerms();
		if ($id && ($AObj=$addr->getAddrObj($id)) && $AObj->getAcl(2)) {
			$this->decodeCharset($logText);
			$addr->insertLog($AObj->getID(),$this->_frm->getUser(),$logText,'log');
			return true;
		}
		debug('No View Permissions:'.$id);
		return false;
    }
    public function evtListResources($request) {
		$params=$this->objectToArray($request);
     	debug('evtListResources: request='.print_r($params,1));
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$result=array();
		$cal_res=$this->_frm->getStaticModul('cal_res');
		if ($request['id']) {
			if (!is_array($request['id'])) $request['id']=array($request['id']);
			$entries=$cal_res->getObj($request['id']);
		} else {
			$entries=$cal_res->listObj();
		}
		foreach($entries as $key=>$val) {
			array_walk_recursive($val->_meta,array($this, 'encodeCharset'));
			$result[]=(object)$val->_meta;
		}
		return $result;
	}
    public function evtListCategories($request) {
		$params=$this->objectToArray($request);
     	debug('evtListCategories: request='.print_r($params,1));
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$result=array();
		$cal_cat=$this->_frm->getStaticModul('cal_cat');
		if ($request['id']) {
			if (!is_array($request['id'])) $request['id']=array($request['id']);
			$entries=$cal_cat->getObj($request['id']);
		} else {
			$entries=$cal_cat->listObj();
		}
		foreach($entries as $key=>$val) {
			array_walk_recursive($val->_meta,array($this, 'encodeCharset'));
			$result[]=(object)$val->_meta;
		}
		return $result;
	}

    public function evtListEventsByDay($request) {
		$params=$this->objectToArray($request);
     	debug('evtListEventsByDay: request='.print_r($params,1));
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
        if (!is_array($params['eventDetails'])) $params['eventDetails']=array();
		$result=array();
		$cal=$this->_frm->getStaticModul('cal');
		$cal_res=$this->_frm->getStaticModul('cal_res');
		$cal_cat=$this->_frm->getStaticModul('cal_cat');

		
		$search=array();
		if (isset($params['uid']) && $params['uid']) {
			if ($params['uid']!=$this->_frm->getUser()) {
				$perms=$cal->getPerms($this->_frm->getUser(),$this->_frm->getMyGroups());
				if (!$perms[$params['uid']]) {
					debug('evtListByDay: No permission tu access user:'.$params['uid']);
					return $result;
				}
			}
			$cal->setUser($params['uid']);
			$search['UserID']=$cal->getUser();
			$search['GroupID']=$cal->getGroup();
		}

		$search['Mode']=0;
		$search['StartDate']=$params['timeStart'];
		$search['EndDate']=$params['timeEnd'];
		if (isset($params['searchDeleted'])) {
			$search['Deleted']=$params['searchDeleted'];
		}
		$rows=0;
		$entries=$cal->searchEvents($rows,$search);
		//$entries=$cal->listEvents($params['timeStart'],$params['timeEnd'],isset($params['projID'])?$params['projID']:0,isset($params['evtID'])?$params['evtID']:0,isset($params['searchDeleted'])?$params['searchDeleted']:0);

		foreach($entries as $day=>$events) {
			uasort ($events,array('CalEvent',"daycmp"));
			foreach($events as $event) {
				if ($event['FKCatID'] && in_array('Category',$params['eventDetails'])) {
					if ($tmp=$cal_cat->getCachedObj($event['FKCatID'])) {
						$event['_Category']=array(
							'id'=>$event['FKCatID'],
							'name'=>$tmp->getName(),
						);
					}
				}
				if ($event['InvitResources'] && in_array('InvitResources',$params['eventDetails'])) {
					foreach (explode(',',$event['InvitResources']) as $tmp_id) {
						if ($tmp=$cal_res->getCachedObj($tmp_id)) {
							$event['_InvitResources'][]=array(
								'id'=>$tmp_id,
								'name'=>$tmp->getName(),
							);
						}
					}
				}
				if ($event['InvitUsers'] && in_array('InvitUsers',$params['eventDetails'])) {
					foreach (explode(',',$event['InvitUsers']) as $tmp_id) {
						if ($tmp=$this->_frm->getCachedUser($tmp_id)) {
							$event['_InvitUsers'][]=array(
								'uid'=>$tmp_id,
								'firstname'=>$tmp['firstname'],
								'lastname'=>$tmp['lastname'],
							);
						}
					}
				}
				if ($event['InvitGroups'] && in_array('InvitGroups',$params['eventDetails'])) {
					foreach (explode(',',$event['InvitGroups']) as $tmp_id) {
						if ($tmp=$this->_frm->getCachedGroupName($tmp_id)) {
							$event['_InvitGroups'][]=array(
								'uid'=>$tmp_id,
								'name'=>$tmp,
							);
						}
					}
				}
				array_walk_recursive($event,array($this, 'encodeCharset'));
				$result[$day][]=$event;
			}
		}

		return $result;
	}
    public function evtGetUserPerms($request = null) {
		$params=$request?$this->objectToArray($request):array();
     	debug('evtPerms: request='.print_r($params,1));
       if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$result=array();

		$cal=$this->_frm->getStaticModul('cal');
		$perms=$cal->getPerms($this->_frm->getUser(),$this->_frm->getMyGroups(),0,$params['getGroups']?false:true);
		if (!empty($perms)) {
			foreach ($perms as $k=>$v) {
				if ($k[0]=='@') {
					if ($gname=$this->_frm->getCachedGroupName(substr($k,1))) {
						$result[]=array(
							'typ'=>'group',
							'gid'=>substr($k,1),
							'groupname'=>$gname,
							'cal_perms'=>$v,
						);
					}
				} else {
					if ($user=$this->_frm->getCachedUser($k)) {
						$result[]=array(
							'typ'=>'user',
							'uid'=>$k,
							'firstname'=>$user['firstname'],
							'lastname'=>$user['lastname'],
							'username'=>$user['username'],
							'cal_perms'=>$v,
						);
					}
				}
			}
		}
		//debug('evtPerms: result='.print_r($result,1));
		return $result;
	}
    public function getGroupUsers($request) {
		$params=$request?$this->objectToArray($request):array();
     	debug('getGroupUsers: request='.print_r($params,1));
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$result=array();
		if (isset($params['gid']) && $params['gid']) {
			//debug(print_r($this->_frm->getGroupUsers($params['gid']),1));
			foreach($this->_frm->getGroupUsers($params['gid']) as $uid) {
				if ($user=$this->_frm->getCachedUser($uid)) {
					$result[]=array(
						'uid'=>$uid,
						'firstname'=>$user['firstname'],
						'lastname'=>$user['lastname'],
						'username'=>$user['username'],
					);
				}
			}
		}
		return $result;
	}
    public function getActiveSyncSyncSettings($device_id) {
     	debug('getActiveSyncSyncSettings: device_id='.$device_id);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
        $activeSync=$this->_frm->getStaticModul('active_sync');
        $result=$activeSync->getSyncPrefs($device_id);
        if (is_array($result)) {
			array_walk_recursive($result,array($this, 'encodeCharset'));
		}
		return $result;
    }
    public function getActiveSyncDevicePoperties($device_id) {
     	debug('getActiveSyncDevicePoperties: device_id='.$device_id);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
        $activeSync=$this->_frm->getStaticModul('active_sync');
        $result=$activeSync->getDevicePoperties($device_id);
        if (is_array($result)) {
			array_walk_recursive($result,array($this, 'encodeCharset'));
		}
		return $result;
    }
    public function setActiveSyncDevicePoperties($device_id,$properties) {
     	debug('setActiveSyncDevicePoperties: device_id='.$device_id);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
        $activeSync=$this->_frm->getStaticModul('active_sync');

		$properties=$this->objectToArray($properties);
      	array_walk_recursive($properties,array($this, 'decodeCharset'));
        return $activeSync->setDevicePoperties($device_id,$properties);
    }
    public function getActiveSyncTimeZone() {
        $tz = array(
        	"bias" => -date('O')/100*60 + date('I')*60,
        	"stdbias" => 0,
        	"dstendyear" => 0,
        	"dstendmonth" =>10,
        	"dstendday" =>0,
        	"dstendweek" => 5,
        	"dstendhour" => 3,
        	"dstendminute" => 0,
        	"dstendsecond" => 0,
        	"dstendmillis" => 0,
            "dststartyear" => 0,
            "dststartmonth" =>3,
            "dststartday" =>0,
            "dststartweek" => 5,
            "dststarthour" => 2,
            "dststartminute" => 0,
            "dststartsecond" => 0,
            "dststartmillis" => 0,
        	"dstbias" => -60,
		);
		return $tz;
    }
    public function getActiveSyncContacts($deviceID) {
    	$result=array();
    	debug('getActiveSyncContacts: deviceID='.$deviceID);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
        if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
			$addr=$this->_frm->getStaticModul('addr');
			$addr->setUserName($this->_username);
			$addr->setUserPwd($this->_ldap_password);
			$addr->setLimit(0);

			$syncCat=array();
			$temp=explode('|',$this->_frm->getPrefs('addr','syncCat'));
			foreach($temp as $catID) {
				$tmpObj=$addr->getObj($catID);
				if (is_object($tmpObj)) {
					$syncCat[$addr->getServerFromAddr($tmpObj->getID())][]=$tmpObj->getMeta('_DN');
				}
			}
			$syncCatSub=$this->_frm->getPrefs('addr','syncCatSub');

			if (!empty($syncCat)) {
				$fields=array();
				$search=array();
				$search['searchSub']=$syncCatSub;
				$search['ServerParent']=$syncCat;
				$allAddr=$addr->searchAddr(0,false,$search,false,$fields);
				if (is_array($allAddr)) {
					foreach ($allAddr as $key=>$val) {
						$serverID=$addr->getServerFromAddr($key);
						if (in_array($serverID,$addr->getMyBooksPrivat())) {
							$acl=7;
						} else {
							$acl=1;
							if ($addr->getCfg('cfg/sync/allowTeamEdit') && $addr->getServerAcl($serverID,2)) $acl+=2;
							if ($addr->getCfg('cfg/sync/allowTeamDelete') && $addr->getServerAcl($serverID,2)) $acl+=4;
						}
						$result[]=array(
							'id'=>$key,
							'mod'=>Framework::stampToTime($val->getMeta('_modifyTimestamp')),
							'flags'=>1,
							'acl'=>$acl,
						);
						//debug(date('d.m.Y H:i:s',Framework::stampToTime($val->getMeta('_modifyTimestamp'))));
					}
				}
			}
        } else {
			$addr=$this->_frm->getStaticModul('addr');
			$addr->getPerms();
			$addr->setLimit(0);
			$sync_cat=$addr->getSyncIDs($this->_frm->getUser(),$this->_frm->getPrefs('addr','syncCatSub')==-1?0:1);
			$sync_proj=array();
			foreach (explode(',',$this->_frm->getPrefs('addr','syncProjects')) as $val) {
				if ($val && $val!=-1) $sync_proj[]=$val;
			}
			$sync_proj_mode=$this->_frm->getPrefs('addr','syncPrjMode')?$this->_frm->getPrefs('addr','syncPrjMode'):'e';

			//debug($this->_frm->getUser());
			if ($sync_cat) {
				$searchAddr=array();
				$searchAddr[]=array('Field'=>'Trash','Typ'=>'=','Values'=>'0');
				$searchNode=array();
				$searchProject=array();
				$searchNode[]=array('Field'=>'AddrParent.FKNodeID','Typ'=>'=','Values'=>$sync_cat);
				if (!empty($sync_proj)) {
					$searchProject[]=array('Field'=>'AddrParentProject.FKProjID','Typ'=>'=','Values'=>$sync_proj);
					if ($sync_proj_mode=='a') {
						$searchAddr[]=array('Typ'=>'OR','Values'=>array($searchNode,$searchProject));
						$searchNode=$searchProject=array(array('Typ'=>'SQL','Values'=>'1'));
					}
				}
				$entries=$addr->searchAddr(0,'',$searchAddr,$searchNode,null,$searchProject,false,true);
				if (is_array($entries)) {
					foreach ($entries as $val) {
						if ($val->getMeta('UserID')) {
							$acl=7;
						} else {
							$acl=1;
							if ($addr->getCfg('cfg/sync/allowTeamEdit') && $val->getAcl(4)) $acl+=2;
							if ($addr->getCfg('cfg/sync/allowTeamDelete') && $val->getAcl(4)) $acl+=4;
						}
						$result[]=array(
							'id'=>$val->getID(),
							'mod'=>$val->getMeta('TimeModify'),
							'flags'=>1,
							'acl'=>$acl,
						);
					}
				}
			}
			//debug(print_r($result,1));
		}
		return $result;
    }
    public function getActiveSyncContactByID($id) {
    	debug('getActiveSyncContactByID: id='.$id);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
        if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
			$addr=$this->_frm->getStaticModul('addr');
			$addr->setUserName($this->_username);
			$addr->setUserPwd($this->_ldap_password);
			$AObj=$addr->getAddrObj($id);
			if ($AObj) {
				$addr->setAktServer($AObj->getMeta('_serverID'));
				$AObj->setMeta('ParentID',$addr->getAddrParent($AObj->getMeta('_DN')));
				$result=$AObj->_meta;
				//$result['Name']=$AObj->getName();
				$result['TimeModify']=Framework::stampToTime($AObj->getMeta('_modifyTimestamp'));
				$serverID=$AObj->getMeta('_serverID');
				if (in_array($serverID,$addr->getMyBooksPrivat())) {
					$result['_acl']=7;
				} else {
					$result['_acl']=1;
					if ($addr->getCfg('cfg/sync/allowTeamEdit') && $addr->getServerAcl($serverID,2)) $result['_acl']+=2;
					if ($addr->getCfg('cfg/sync/allowTeamDelete') && $addr->getServerAcl($serverID,2)) $result['_acl']+=4;
				}
				foreach ($AObj->getMeta('ParentID') as $DN) {
					$tmpCat=array_reverse($addr->getObjTree($DN));
					foreach($tmpCat as $tk=>$tv) {
						$tmpCat[$tk]=strtr($tv->getName(),';,.',' ');
					}
					$result['Categories'][]=$this->_catPrepends['A'].strtr($addr->getServerMeta($AObj->getMeta('_serverID'),'Title'),';,.',' ').(!empty($tmpCat)?'.'.implode('.',$tmpCat):'');
				}
				if ($this->_frm->appExists('proj') && ($prjIds=$addr->getAddrProjects($AObj)) && !empty($prjIds)) {
					$P=$this->_frm->getStaticModul('proj');
					foreach ($prjIds as $pid) {
						if ($tmpPrj=$P->getCachedProjectName($pid)) {
							$result['Categories'][]=$this->_catPrepends['P'].strtr($tmpPrj,';,',' ');
						}
					}
				}
				array_walk_recursive($result,array($this, 'encodeCharset'));
				return (object)$result;
			}
		} else {
       		$addr=$this->_frm->getStaticModul('addr');
			$addr->getPerms();
			$AObj=$addr->getAddrObj($id);
			//debug(print_r($AObj,1));
			if ($AObj && $AObj->getAcl(2)) {
				$result=$AObj->_meta;
				$result['Name']=$AObj->getName();
				if ($AObj->getMeta('UserID')) {
					$result['_acl']=7;
				} else {
					$result['_acl']=1;
					if ($addr->getCfg('cfg/sync/allowTeamEdit') && $AObj->getAcl(4)) $result['_acl']+=2;
					if ($addr->getCfg('cfg/sync/allowTeamDelete') && $AObj->getAcl(4)) $result['_acl']+=4;
				}
				foreach($addr->getAddrNodesIDs($AObj->getID()) as $nid) {
					$tmpCat=array_reverse($addr->getObjTree($nid,0));
					foreach($tmpCat as $tk=>$tv) {
						$tmpCat[$tk]=strtr($tv,';,.',' ');
					}
					$result['Categories'][]=$this->_catPrepends['A'].implode('.',$tmpCat);
				}
				if ($this->_frm->appExists('proj') && ($prjIds=$addr->getAddrProjects($AObj)) && !empty($prjIds)) {
					$P=$this->_frm->getStaticModul('proj');
					foreach ($prjIds as $pid) {
						if ($tmpPrj=$P->getCachedProjectName($pid)) {
							$result['Categories'][]=$this->_catPrepends['P'].strtr($tmpPrj,';,',' ');
						}
					}
				}
				array_walk_recursive($result,array($this, 'encodeCharset'));
				return (object)$result;
			}
		}
		return false;
    }
    public function updateActiveSyncContact($id,$contactobj) {
  		debug('updateActiveSyncContact: uid='.$id);
		$result=array(
			'error'=>1,
			'id'=>0,
			'reload'=>0,
		);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$meta=$this->objectToArray($contactobj);
        array_walk_recursive($meta,array($this, 'decodeCharset'));
        if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
			$addr=$this->_frm->getStaticModul('addr');
			$addr->setUserName($this->_username);
			$addr->setUserPwd($this->_ldap_password);

			$catID=array();
			$prjID=array();
			if (is_array($meta['Categories'])) {
				$serverID='';
				foreach ($meta['Categories'] as $Name) {
					if (substr($Name,0,strlen($this->_catPrepends['A']))==$this->_catPrepends['A']) {
						debug('Search Address CatName:'.substr($Name,strlen($this->_catPrepends['A'])));
						if ($tmpObj=$addr->catName2ID(substr($Name,strlen($this->_catPrepends['A'])),'',false,'.','')) {
							$catID[$addr->getServerFromAddr($tmpObj->getID())][]=$tmpObj->getMeta('_DN');
							debug('Found CatID:'.$tmpObj->getMeta('_DN'));
						}
					}
					if (substr($Name,0,strlen($this->_catPrepends['P']))==$this->_catPrepends['P'] && $this->_frm->appExists('proj')) {
						debug('Search Project Name:'.substr($Name,strlen($this->_catPrepends['P'])));
						$P=$this->_frm->getStaticModul('proj');
						if ($pObj=$P->getPrjByName(substr($Name,strlen($this->_catPrepends['P'])))) {
							$prjID[]=$pObj->getID();
							debug('Found ProjID:'.$pObj->getID());
						}
					}
				}
			}
			$newServerID=0;
			$perms=false;
			if (!empty($catID)) {
				if (!$newServerID) {
					foreach ($addr->getMyBooksPrivat() as $tmpID) {
						if (isset($catID[$tmpID])) {
							$newServerID=$tmpID;
							$perms=true;
							break;
						}
					}
				}
				if (!$newServerID && $addr->getCfg('cfg/sync/allowTeamEdit')) {
					foreach ($addr->getMyBooksWrite() as $tmpID) {
						if (isset($catID[$tmpID])) {
							$newServerID=$tmpID;
							$perms=true;
							break;
						}
					}
				}
			}

			if ($id && ($AObj=$addr->getAddrObj($id))) {
				$AObj->setMeta('ParentID',$addr->getAddrParent($AObj->getMeta('_DN')));
				debug('Update Contact:'.$id);
				if (!$perms) {
					$newServerID=$AObj->getMeta('_serverID');
					if (in_array($newServerID,$addr->getMyBooksPrivat()) || (in_array($newServerID,$addr->getMyBooksWrite()) && $addr->getCfg('cfg/sync/allowTeamEdit'))) {
						$perms=true;
					}
				}
			} else {
				debug('NEW Contact');
				$AObj=new AObj_addr(0);
				if (!$perms) {
					if ($temp=$this->_frm->getPrefs('addr','syncCatNew')) {
						if ($tmpObj=$addr->getObj($temp)) {
							$newServerID=$addr->getServerFromAddr($tmpObj->getID());
							if (in_array($newServerID,$addr->getMyBooksPrivat()) || (in_array($newServerID,$addr->getMyBooksWrite()) && $addr->getCfg('cfg/sync/allowTeamEdit'))) {
								$catID[$newServerID][]=$tmpObj->getMeta('_DN');
								$perms=true;
							}
						}
					}
				}
			}
			debug('Categories:'.print_r($catID,1));
			debug('NewServerID:'.$newServerID);
			if ($perms) {
				if (isset($catID[$newServerID])) {
					$AObj->setMeta('ParentID',$catID[$newServerID]);
				}
				debug('Categories:'.print_r($AObj->getMeta('ParentID'),1));
				foreach ($addr->getFields() as $key=>$val) {
					if (isset($meta[$key])) $AObj->setMeta($key,$meta[$key]);
				}
				if (!trim($AObj->getMeta('Nachname')) && !trim($AObj->getMeta('Vorname')) && trim($AObj->getMeta('Firma'))) {
					$AObj->setMeta('Nachname',$AObj->getMeta('Firma'));
				}
				if (!trim($AObj->getMeta('Nachname'))) {
					$AObj->setMeta('Nachname','-');
				}

				$AObj->setMeta('Name',$AObj->getName());
				if ($AObj->getID()) {
					if ($newServerID != $AObj->getMeta('_serverID')) {
						if ($addr->getServerMeta($newServerID,'Server')==$addr->getServerMeta($AObj->getMeta('_serverID'),'Server')) {
							$error=$addr->updateAddrMeta($AObj,$newServerID);
							if (!$error) {
								$addr->setAktServer($newServerID);
								$AObj=$addr->getAddrObjByDN($AObj->getMeta('_DN'));
							}
						} else {
							$addr->setAktServer($newServerID);
							$error=$addr->insertAddrMeta($AObj);
							if (!$error) {
								$addr->setAktServer($AObj->getMeta('_server'));
								$error=$addr->deleteAddrMeta($AObj);
							}
						}
					} else {
						$addr->setAktServer($newServerID);
						$error=$addr->updateAddrMeta($AObj);
					}
				} else {
					$addr->setAktServer($newServerID);
					$error=$addr->insertAddrMeta($AObj);
				}
				if (!$error) {
					if (!empty($prjID)) {
						$addr->setAddrProjects($AObj,$prjID);
					}
					$result['id']=$AObj->getID();
					$result['error']=0;
				} else {
					debug('ERROR LDAP MODIFY'.$id.':'.print_r($error,1));
					$result['error']=1;
				}
			}
        } else {
			//debug(print_r($meta,true));
			$addr=$this->_frm->getStaticModul('addr');
			$addr->getPerms();
			$catID=array();
			$prjID=array();
			if (is_array($meta['Categories'])) {
				foreach ($meta['Categories'] as $Name) {
					if (substr($Name,0,strlen($this->_catPrepends['A']))==$this->_catPrepends['A']) {
						debug('Search Address CatName:'.substr($Name,strlen($this->_catPrepends['A'])));
						if ($tmpID=$addr->catName2ID(substr($Name,strlen($this->_catPrepends['A'])),0,0,'',false,'.','')) {
							if ($nodeObj=$addr->getObj($tmpID)) {
								$catID[$nodeObj->getMeta('UserID')][]=$tmpID;
								debug('Found CatID:'.$tmpID);
							}
						}
					}
					if (substr($Name,0,strlen($this->_catPrepends['P']))==$this->_catPrepends['P'] && $this->_frm->appExists('proj')) {
						debug('Search Project Name:'.substr($Name,strlen($this->_catPrepends['P'])));
						$P=$this->_frm->getStaticModul('proj');
						if ($pObj=$P->getPrjByName(substr($Name,strlen($this->_catPrepends['P'])))) {
							$prjID[]=$pObj->getID();
							debug('Found ProjID:'.$pObj->getID());
						}
					}
				}
			}
			//debug(print_r($catObj,true));
			$perms=true;
			if ($id && ($AObj=$addr->getAddrObj($id))) {
				debug('Update Contact:'.$id);
				if ($AObj->getMeta('UserID')==$this->_frm->getUser()) {
					if (isset($catID[$this->_frm->getUser()])) {
						$AObj->setParentMeta('NodeIDs',$catID[$this->_frm->getUser()]);
					} elseif (isset($catID[0]) && $addr->getCfg('cfg/sync/allowTeamEdit') && $addr->getPerms(4)) {
						$AObj->setParentMeta('NodeIDs',$catID[0]);
						$AObj->setMeta('UserID',0);
					}
				} elseif (!$AObj->getMeta('UserID') && $addr->getCfg('cfg/sync/allowTeamEdit') && $AObj->getAcl(4)) {
					if (isset($catID[0])) {
						$AObj->setParentMeta('NodeIDs',$catID[0]);
					}
				} else {
					$perms=false;
				}
			} else {
				debug('NEW Contact');
				$AObj=new AObj_addr(0);
				$AObj->setMeta('UserCreate',$this->_frm->getUser());
				$AObj->setMeta('TimeCreate',time());
				if (isset($catID[0]) && $addr->getCfg('cfg/sync/allowTeamEdit') && $addr->getPerms(4)) {
					$AObj->setParentMeta('NodeIDs',$catID[0]);
					$AObj->setMeta('UserID',0);
				} else {
					$AObj->setMeta('UserID',$this->_frm->getUser());
					if (isset($catID[$this->_frm->getUser()])) {
						$AObj->setParentMeta('NodeIDs',$catID[$this->_frm->getUser()]);
					} elseif ($catIDs=$addr->getSyncIDs($this->_frm->getUser(),false,true)) {
						$AObj->setParentMeta('NodeIDs',$catIDs);
					} elseif ($catUser=$addr->getSystemObj('u','',$this->_frm->getUser())) {
						$AObj->setParentMeta('NodeIDs',array($catUser->getID()));
					} else {
						$perms=false;
					}
				}
			}
			if ($perms) {
				foreach ($addr->getFields() as $key=>$val) {
					if (isset($meta[$key])) $AObj->setMeta($key,$meta[$key]);
				}
				$AObj->setMeta('Name',$AObj->getName());
				if ($AObj->getID()) {
					$addr->updateAddrMeta($AObj);
				} else {
					$AObj->setMeta('UserModify',$this->_frm->getUser());
					$AObj->setMeta('TimeModify',time());
					$addr->insertAddrMeta($AObj);
				}
				if (!empty($prjID)) {
					$oldprjID=$addr->getAddrProjects($AObj);
					sort($oldprjID);
					sort($prjID);
					if ($oldprjID!=$prjID) {
						$addr->setAddrProjects($AObj,$prjID);
						$addr->updateAddrMetaTime($AObj->getID(),$this->_frm->getUser());
					}
				}
				$result['id']=$AObj->getID();
				$result['error']=0;
			} else {
				$result['error']=1;
				debug('No UPDATE Permissions:'.$id);
			}
		}
		return $result;
    }
    function deleteActiveSyncContact($id) {
  		debug('deleteActiveSyncContact: uid='.$id);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
        if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
			$addr=$this->_frm->getStaticModul('addr');
			$addr->setUserName($this->_username);
			$addr->setUserPwd($this->_ldap_password);

			if ($id && ($AObj=$addr->getAddrObj($id))) {
				$perms=false;
				$serverID=$AObj->getMeta('_serverID');
				if (in_array($serverID,$addr->getMyBooksPrivat())) {
					$perms=true;
				} elseif ($addr->getCfg('cfg/sync/allowTeamEdit') && $addr->getServerAcl($serverID,2)) {
					$perms=true;
				}
				if ($perms) {
					$error=$addr->deleteAddrMeta($AObj);
					if (!$error) {
						return true;
					} else {
						debug('ERROR LDAP DELETE'.$id.':'.print_r($error,1));
					}
				}
			}
        } else {
			$addr=$this->_frm->getStaticModul('addr');
			$addr->getPerms();
			if ($id && ($AObj=$addr->getAddrObj($id))) {
				$perms=false;
				if ($AObj->getMeta('UserID')==$this->_frm->getUser()) {
					$perms=true;
				} elseif ($AObj->getMeta('UserID')==0 && $addr->getCfg('cfg/sync/allowTeamDelete') && $AObj->getAcl(4)) {
					$perms=true;
				}
				if ($perms) {
					if ($TrashObj=$addr->getSystemObj('t','',0)) {
						$AObj->setMeta('Trash',1);
						$AObj->setMeta('TrashIDs',implode(',',array_keys($addr->getAddrNodes($AObj->getID()))));
						$AObj->setParentMeta('NodeIDs',array($TrashObj->getID()));
						$addr->updateAddrMeta($AObj);
						debug('DELETE OK:'.$id);
						return true;
					}

				}
			}
		}
		debug('No DELETE Permissions:'.$id);
		return false;
    }
    public function getActiveSyncAppointments($deviceID,$cutoffdate) {
    	$result=array();
    	debug('getActiveSyncAppointments: deviceID='.$deviceID);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
      	$cal=$this->_frm->getStaticModul('cal');
		$search=array(
			'UserID'=>$this->_frm->getUser(),
			'GroupID'=>$this->_frm->getMyGroups(),
			'StartDate'=>$cutoffdate,
   			'EndDate'=>0,
   			'_fetchSimple'=>true,
   		);
    	//debug(print_r($search,1));
		$rows=0;
      	$entries=$cal->searchEvents($rows,$search,0,0);
		foreach ($entries as $val) {
			
			$result[]=array(
				'id'=>(int)$val['EventID'],
				'mod'=>(int)$val['TimeModify'],
				'flags'=>1,
				'acl'=>$val['OwnerID']==$this->_frm->getUser()?7:1,
			);
		}
    	//debug(print_r($result,1));
		return $result;
    }
    public function getActiveSyncAppointmentByID($id) {
    	debug('getActiveSyncAppointmentsByID: id='.$id);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
        $activeSync=$this->_frm->getStaticModul('active_sync');
		$asPrefs=$activeSync->getSyncPrefs();

        $cal=$this->_frm->getStaticModul('cal');
       	$Event=$cal->readEvent($id);
       	if ($cal->checkEventViewPerms($Event)) {
       		if (!trim($Event['UID'])) {
				$cal->updateEvent($Event['EventID'],array('UID'=>'','TimeChange'=>$Event['TimeChange'],'TimeModify'=>$Event['TimeModify'],'UserModify'=>$Event['UserModify']),false);
       			$Event=$cal->readEvent($Event['EventID']);
			}
 			$user_done=$cal->readEventDone($Event['EventID'],'u');
       		$result=$Event;
			//$result['Title']=


			$result['_acl']=($Event['OwnerID']==$this->_frm->getUser())?7:1;
    		//debug(print_r($result,true));
       		if ($this->_frm->getUser()!=$Event['OwnerID']) {
     			$Owner=$this->_frm->getCachedUser($Event['OwnerID']);
				$result['OwnerName']=$Owner['lastname'].' '.$Owner['firstname'];
				$result['OwnerEmail']=$Owner['email'];

			}
			$result['Attendees']=array();

			$invitGroups=$Event['InvitGroups']?explode(',',$Event['InvitGroups']):array();
			$invitUsers=$Event['InvitUsers']?explode(',',$Event['InvitUsers']):array();
			$invitAddr=$Event['InvitAddr']?explode(',',$Event['InvitAddr']):array();
			$invitResources=$Event['InvitResources']?explode(',',$Event['InvitResources']):array();

			$tpmGusers=empty($invitGroups)?array():$this->_frm->getGroupUsers($invitGroups);
			if (!empty($tpmGusers)) $tpmGusers=array_keys($this->_frm->getApplicationUsers('cal',$tpmGusers));
			$i_users=array_filter(array_unique(array_merge($tpmGusers,$invitUsers,array($Event['OwnerID']))),'intval');

			foreach ($i_users as $val) {
				if ($val!=$Event['OwnerID']) {
       				$Attendee=$this->_frm->getCachedUser($val);
       				if (!$Attendee) continue;
					if (!isset($user_done[$val])) {
						$status=5;
					} elseif($user_done[$val]==2) {
						$status=4;
					} elseif($user_done[$val]==3) {
						$status=2;
					} else {
						$status=3;	
					}
       				$result['Attendees'][]=array(
						'ID'=>$val,
						'Name'=>$Attendee['lastname'].' '.$Attendee['firstname'],
 						'Email'=>$Attendee['email'],
 						'Status'=>$status,
 						'Type'=>'u',
       				);
       				if ($val==$this->_frm->getUser()) {
						$result['MyInvitStatus']=$status;
       				}
				}
			}
			if (!empty($invitResources)) {
				$calRes=& $this->_frm->getStaticModul('cal_res');
				$invitResources=$calRes->getCachedObj($invitResources);
				foreach ($invitResources as $val) {
       				$result['Attendees'][]=array(
						'ID'=>$val->getID(),
						'Name'=>$val->getName(),
 						'Email'=>'resource_'.$val->getID().'@'.$this->_domain,
 						'Status'=>0,
 						'Type'=>'r',
       				);
				}
			}
			if (!empty($invitAddr)) {
				$Addr=& $this->_frm->getStaticModul('addr');
				$Addr->getPerms();
				$address_array=$Addr->getAddrObj($invitAddr);
				foreach ($address_array as $address) {
					$temp=$Addr->addrExplode(trim($address->getMeta('Email')));
       				$result['Attendees'][]=array(
						'ID'=>$address->getID(),
						'Name'=>$address->getName(),
 						'Email'=>$temp[0]?$temp[0]:'contact_'.$address->getID().'@'.$this->_domain,
 						'Status'=>0,
 						'Type'=>'a',
       				);
				}
			}
			$category=$this->_frm->getStaticModul('cal_cat')->getCachedObj($Event['FKCatID']);
			$result['Categories'][]=$this->_catPrepends['C'].strtr($category->getName(),';,',' ');
			if ($Event['FKProjID'] && $this->_frm->appExists('proj')) {
        		$P=$this->_frm->getStaticModul('proj');
				if ($tmpPrj=$P->getCachedProjectName($Event['FKProjID'])) {
					$result['Categories'][]=$this->_catPrepends['P'].strtr($tmpPrj,';,',' ');
				}
			}

			if ($result['RecType']) {
				if ($result['Exception']) {
					$result['Exceptions']=array();
					$exceptions=explode(',',$result['Exception']);
					unset($result['Exception']);
					foreach ($exceptions as $val) {
						$result['Exceptions'][]=array(
							'Deleted'=>1,
							'ExceptionDate'=>mktime(date('H',$result['StartDate']),date('i',$result['StartDate']),0,date('m',$val),date('d',$val),date('y',$val)),
						);
					}
				}
				if ($result['RecCfg']) {
					$result['RecCfg']=unserialize($result['RecCfg']);
				}
			}
			//debug(print_r($result,1));
			//return false;
			array_walk_recursive($result,array($this, 'encodeCharset'));
			//debug(print_r($result,1));
        	return (object)$result;
       	}
		debug('No Permissions on Event:'.$id);
        return false;
    }
    public function updateActiveSyncAppointment($id,$eventobj) {
		$result=array(
			'error'=>1,
			'id'=>0,
			'reload'=>0,
		);
  		debug('updateActiveSyncAppointment: uid='.$id);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$meta=$this->objectToArray($eventobj);
        array_walk_recursive($meta,array($this, 'decodeCharset'));
  		//debug(print_r($contactobj,true));
        $activeSync=$this->_frm->getStaticModul('active_sync');
		$asPrefs=$activeSync->getSyncPrefs();

		$cal=$this->_frm->getStaticModul('cal');
		$calConf=$this->_frm->getStaticGuiModul('cal','CalConflictGui');

      	$perms=false;
      	$reload=false;
      	$oldEvent=0;
		if (!$id || !($oldEvent=$cal->readEvent($id))) {
			if ($meta['UID'] && ($oldEvent=$cal->getByUid($meta['UID']))) {
				unset($oldEvent['UserDone']);
				debug('Get Event by UID:'.$oldEvent['EventID']);
			}
		}

   		if ($oldEvent) {
			debug('Update Event:'.$oldEvent['EventID']);
			if ($oldEvent['OwnerID']==$this->_frm->getUser()) {
				$perms=true;
				$Event=$oldEvent;
				if ($meta['_setDefaultGrant'] && (trim($Event['GrantGroups']) || trim($Event['GrantUsers']))) {
					$meta['_setDefaultGrant']=0;
					debug('ignoreDefaultGrant');
				}
			} else {
				/*
					$user_done=$cal->readEventDone($oldEvent['EventID'],'u');
				*/
			}
   		} else {
			debug('NEW Event');
       		$Event=array(
				'OwnerID'=>$this->_frm->getUser(),
       		);
			$perms=true;
  		}

   		if ($perms) {
			if (is_array($meta['Categories'])) {
				foreach ($meta['Categories'] as $Name) {
					if (substr($Name,0,strlen($this->_catPrepends['C']))==$this->_catPrepends['C']) {
						debug('Search Calendar CatName:'.substr($Name,strlen($this->_catPrepends['C'])));
						if ($cObj=$this->_frm->getStaticModul('cal_cat')->catName2ID(substr($Name,strlen($this->_catPrepends['C'])))) {
							$Event['FKCatID']=$cObj->getID();
							debug('Found CatID:'.$cObj->getID());
						}
					}
					if (substr($Name,0,strlen($this->_catPrepends['P']))==$this->_catPrepends['P'] && $this->_frm->appExists('proj')) {
						debug('Search Project Name:'.substr($Name,strlen($this->_catPrepends['P'])));
						$P=$this->_frm->getStaticModul('proj');
						if ($pObj=$P->getPrjByName(substr($Name,strlen($this->_catPrepends['P'])))) {
							$Event['FKProjID']=$pObj->getID();
							debug('Found ProjID:'.$pObj->getID());
						}
					}
				}
			}
			if (!$Event['FKCatID']) {
				$Event['FKCatID']=2;
			}
			$Event['Title']=$meta['Title'];
			$Event['Text']=$meta['Text'];
			$Event['Place']=$meta['Place'];
			$Event['StartDate']=$meta['StartDate'];
			$Event['EndDate']=$meta['EndDate'];
			$Event['AlarmTime']=$meta['AlarmTime'];
			$Event['TimeMode']=$meta['TimeMode'];
			$Event['Unsecure']=$meta['Unsecure'];
			$Event['EvtPrivat']=$meta['EvtPrivat'];
			$Event['UID']=$meta['UID'];
			if ($meta['_setDefaultGrant']) {
				debug('setDefaultGrant');
				$defGrantUsers=array();
				$defGrantGroups=array();
				if ($Event['FKProjID']) {
					$P=$this->_frm->getStaticModul('proj');
					$grantPerms=$P->getProjectPerms($Event['FKProjID'],'cal_grant');
					if (trim($grantPerms['PermsUser'])) $defGrantUsers=explode(',',$grantPerms['PermsUser']);
					if (trim($grantPerms['PermsGroup'])) $defGrantGroups=explode(',',$grantPerms['PermsGroup']);
				} else {
					if (isset($asPrefs['cal/grant_g'])) {
						$defGrantGroups=$asPrefs['cal/grant_g']?explode('|',$asPrefs['cal/grant_g']):array();
					} elseif ($this->_frm->getPrefs('cal','dg')) {
						$defGrantGroups=explode('|',$this->_frm->getPrefs('cal','dg'));
					}
					if (isset($asPrefs['cal/grant_u'])) {
						$defGrantUsers=$asPrefs['cal/grant_u']?explode('|',$asPrefs['cal/grant_u']):array();
					} elseif ($this->_frm->getPrefs('cal','du')) {
						$defGrantUsers=explode('|',$this->_frm->getPrefs('cal','du'));
					}
				}
				$Event['GrantGroups']=implode(',',$defGrantGroups);
				$Event['GrantUsers']=implode(',',$defGrantUsers);
			}

       		if (!$Event['EventID']) {
				$InvitResources=array();
				$InvitGroups=array();
				$InvitUsers=array();
				$InvitAddr=array();
				if (isset($meta['Attendees']) && !empty($meta['Attendees'])) {
					$Addr=& $this->_frm->getStaticModul('addr');
					$Addr->getPerms();

					foreach ($meta['Attendees'] as $attendee) {
						$matches=array();
						if (preg_match('/^resource_([0-9]+)@'.preg_quote($this->_domain,'/').'/',$attendee['Email'],$matches)) {
							$rObj=& $this->_frm->getStaticModul('cal_res')->getCachedObj($matches[1]);
							if ($rObj) {
								$InvitResources[]=$rObj->getID();
								continue;
							}
						}
						$internID=$this->_frm->searchUserByEmail($attendee['Email']);
						if (!empty($internID)) {
							$InvitUsers[]=reset($internID);
							continue;
						}
						if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {

						} else {
							$searchAddr=array(
								array('Typ'=>'SQL','Values'=>"Email REGEXP '[[:<:]]".addslashes(preg_quote($attendee['Email'],''))."[[:>:]]'"),
							);
							$aObj=$Addr->searchSingleAddr($searchAddr);
							if ($aObj) {
								$InvitAddr[]=$aObj->getID();
								continue;
							}
						}
					}
				}
				$Event['InvitGroups']=implode(',',$InvitGroups);
				$Event['InvitUsers']=implode(',',$InvitUsers);
				$Event['InvitResources']=implode(',',$InvitResources);
				$Event['InvitAddr']=implode(',',$InvitAddr);
			}
			if ($meta['RecType']) {
				$Event['RecType']=$meta['RecType'];
				$Event['RecInt']=$meta['RecInt'];
				$Event['RecEnd']=$meta['RecEnd'];
				$Event['RecCfg']=is_array($meta['RecCfg'])?serialize($meta['RecCfg']):'';
				if (is_array($meta['Exceptions'])) {
					debug('Exceprions');
					debug(print_r($meta['Exceptions'],true));
					$exceptions=array();
					foreach ($meta['Exceptions'] as $val) {
						$exOk=true;
						if (!$val['Deleted']) {
							$nEvent=Framework::cloneObj($Event);
							$nEvent['RecType']=0;
							$nEvent['RecInt']=0;
							$nEvent['RecEnd']=0;
							$nEvent['UID']=0;
							$nEvent['Sequence']=0;
							$nEvent['Exception']='';
							$nEvent['AlarmSend']=0;
							if (isset($val['Title'])) $nEvent['Title']=$val['Title'];
							if (isset($val['Text'])) $nEvent['Text']=$val['Text'];
							if (isset($val['Place'])) $nEvent['Place']=$val['Place'];
							if (isset($val['StartDate'])) $nEvent['StartDate']=$val['StartDate'];
							if (isset($val['EndDate'])) $nEvent['EndDate']=$val['EndDate'];
							if (isset($val['AlarmTime'])) $nEvent['AlarmTime']=$val['AlarmTime'];
							if (isset($val['TimeMode'])) $nEvent['TimeMode']=$val['TimeMode'];
							if (isset($val['Unsecure'])) $nEvent['Unsecure']=$val['Unsecure'];
							if ($calConf->checkConflict($nEvent,0,false)) {
								debug('Conflict New Event from Exceptions');
								debug(print_r($nEvent,true));
								$result['error']=1;
								$exOk=false;
							} else {
								debug('Create New Event from Exceptions');
								debug(print_r($nEvent,true));
								$nevent_id=$cal->saveEvent($nEvent);
							}
							$result['reload']=1;
						}
						if ($exOk) {
							$exceptions[]=mktime(0,0,0,date('m',$val['ExceptionDate']),date('d',$val['ExceptionDate']),date('y',$val['ExceptionDate']));
						}
					}
					$Event['Exception']=implode(',',$exceptions);
				}
			} else {
				$Event['RecType']=0;
				$Event['RecInt']=0;
				$Event['RecEnd']=0;
				$Event['RecCfg']='';
				$Event['Exception']='';
			}
			//Konlikte checken die zwingend incht vorkommen dürfen:
			if ($calConf->checkConflict($Event,$Event['EventID'],false)) {
				debug('Conflict New Event');
				debug(print_r($nEvent,true));
				$result['error']=1;
			} else {
				if ($Event['EventID']) {
					$mTime=false;
					if ($Event['StartDate']!=$oldEvent['StartDate'] || $Event['EndDate']!=$oldEvent['EndDate'] || $Event['RecType']!=$oldEvent['RecType'] || $Event['RecInt']!=$oldEvent['RecInt']) {
						$mTime=true;
						$Event['TimeChange']=0;
					}
					if ($mTime || $Event['Exception']!=$oldEvent['Exception']) {
						$Event['Sequence']+=1;
					}
					//TODO allme
					$Event['TimeModify']=time();
					$Event['UserModify']=$this->_frm->getUser();
					$cal->updateEvent($Event['EventID'],$Event,-1);

					if ($mTime) {
						$GLOBALS['T']->setLang($this->_frm->getLang());
						$GLOBALS['T']->loadModul('cal');
						$log_tras=array(
							'{EDATE}'=>$cal->formatDate($oldEvent['StartDate'],$oldEvent['EndDate'],$oldEvent['TimeMode']),
							'{ETITLE}'=>trim($Event['Title']),
							'{EPLACE}'=>trim($Event['Place']),
							'{ETEXT}'=>trim($Event['Text']),
							'{TEXT}'=>'',
							'{CUSER}'=>'',
							'{OUSER}'=>'',
							'{NDATE}'=>$cal->formatDate($Event['StartDate'],$Event['EndDate'],$Event['TimeMode']),
						);
						$cal->insertLog($Event['EventID'],$this->_frm->getUser(),strtr($GLOBALS['T']->lang('[[action_move_title]]'),$log_tras),'log');
						if ($oldEvent['Message']) {
							$user_done=$cal->readEventDone($Event['EventID'],'u');
							$send_user=array();
							foreach ($user_done as $key=>$val) {
								if ($key!=$this->_frm->getUser() && $val!=2) {
									$send_user[]=$key;
								}
							}
							if (!empty($send_user)) {
								$this->_frm->sendmessage($send_user,
									$this->_frm->getUser(),
									strtr($GLOBALS['T']->lang('[[action_move_title]]'),$log_tras),
									strtr($GLOBALS['T']->lang('[[action_move_text]]'),$log_tras),
									"?site=cal.php&action=view&view=event&edate=".$Event['StartDate']."&event_id=".$Event['EventID'],
									$Event['Title'],
									$cal->getCfg('cfg/img_notes')
								);
							}
						}
					}
				} else {
					$Event['EventID']=$cal->saveEvent($Event);
				}
				$result['id']=(int)$Event['EventID'];
				$result['error']=0;
			}
   		} else {
			debug('NO UPDATE Permissions:'.$id);
			$result['error']=1;
		}
		return $result;
    }
    function deleteActiveSyncAppointment($id) {
  		debug('deleteActiveSyncAppointment: uid='.$id);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
        $cal=$this->_frm->getStaticModul('cal');
  		if ($id && ($Event=$cal->readEvent($id))) {
			if ($Event['OwnerID']==$this->_frm->getUser()) {
				$GLOBALS['T']->setLang($this->_frm->getLang());
				$GLOBALS['T']->loadModul('cal');
				$cal->deleteEventObject($Event);
				return true;
			}
		}
		debug('NO DELETE Permissions:'.$id);
		return false;
    }

    public function getActiveSyncTasks($deviceID,$cutoffdate) {
    	$result=array();
    	debug('getActiveSyncTasks: deviceID='.$deviceID);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
      	$task=$this->_frm->getStaticModul('task');

   		$search=array();
   		$search[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$this->_frm->getUser());
   		$search[]=array('Field'=>'Status','Typ'=>'!=','Values'=>4);
   		$search[]=array('Field'=>'Done','Typ'=>'=','Values'=>1);
   		$search[]=array('Field'=>'StartDate','Typ'=>'>=','Values'=>$cutoffdate);

		$rows=0;
      	$entries=$task->searchTask($rows,0,0,$search,'');
		foreach ($entries as $val) {
			$result[]=array(
				'id'=>$val['TaskID'],
				'mod'=>$val['TimeModify'],
				'flags'=>1,
				'acl'=>$val['OwnerID']==$this->_frm->getUser()?7:3,
			);
		}
    	//debug(print_r($result,1));
		return $result;
    }
    public function getActiveSyncTaskByID($id) {
    	debug('getActiveSyncTaskByID: id='.$id);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
      	$task=$this->_frm->getStaticModul('task');
       	$Task=$task->readTask($id);
       	$TaskUser=$task->readTaskUser($id,$this->_frm->getUser());
      	if ($TaskUser) {
      		$result=$Task;
			$result['_acl']=$Task['OwnerID']==$this->_frm->getUser()?7:3;
			$result['Categories']=array();
			
			$Task['FKDocID']=$task->getSyncID($this->_frm->getUser());

			$catObj=$task->getObj($Task['FKDocID'],'',false);
			if (!$catObj) $catObj=$task->getObj($task->getSyncID($this->_frm->getUser()));
			
			if ($catObj) {
				$rootObj=$task->getObj($catObj->getMeta('RootID'),'',false);
				$result['Categories'][]=$this->_catPrepends['T'].strtr($rootObj->getName().'.'.$catObj->getName(),';,',' ');
			}
			if ($Task['FKProjID'] && $this->_frm->appExists('proj')) {
				$P=$this->_frm->getStaticModul('proj');
				if ($tmpPrj=$P->getCachedProjectName($Task['FKProjID'])) {
					$result['Categories'][]=$this->_catPrepends['P'].strtr($tmpPrj,';,',' ');
				}
			}
			
			$result['UserDone']=$TaskUser['Done'];
			$result['UserTaskType']=$TaskUser['TaskType'];
			if ($result['RecType']) {
				if ($result['RecCfg']) {
					$result['RecCfg']=unserialize($result['RecCfg']);
				}
			}
			//debug(print_r($result,1));
			//return false;
			array_walk_recursive($result,array($this, 'encodeCharset'));
        	return (object)$result;
       	}
		debug('No Permissions on Task:'.$id);
        return false;
    }
    public function updateActiveSyncTask($id,$taskobj) {
  		debug('updateActiveSyncTask: uid='.$id);
		$result=array(
			'error'=>1,
			'id'=>0,
			'reload'=>0,
		);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
  		//debug(print_r($contactobj,true));
      	$task=$this->_frm->getStaticModul('task');
     	$perms=false;
      	$oldTask=0;
		if (!$id || !($oldTask=$task->readTask($id))) {
			/*if ($eventobj->UID && ($oldEvent=$cal->getByUid($eventobj->UID))) {
				debug('Get Event by UID:'.$oldEvent['EventID']);
			}*/
		}
		$meta=$this->objectToArray($taskobj);
        array_walk_recursive($meta,array($this, 'decodeCharset'));

   		if ($oldTask) {
   			$Task=$oldTask;
			debug('Update Task:'.$oldTask['EventID']);
			if ($oldTask['OwnerID']==$this->_frm->getUser()) {
				$perms=true;
			}
   		} else {
			debug('NEW Task');
       		$Task=array(
				'OwnerID'=>$this->_frm->getUser(),
       		);
			$perms=true;
  		}

   		if ($perms) {
			if (is_array($meta['Categories'])) {
				foreach ($meta['Categories'] as $Name) {
					if (substr($Name,0,strlen($this->_catPrepends['T']))==$this->_catPrepends['T']) {
						debug('Search Task CatName:'.substr($Name,strlen($this->_catPrepends['T'])));
						if ($tmpID=$task->catName2ID(substr($Name,strlen($this->_catPrepends['T'])),0,0,'',false,'.','')) {
							$Task['FKDocID']=$tmpID;
							debug('Found CatID:'.$tmpID);
						}
					}
					if (substr($Name,0,strlen($this->_catPrepends['P']))==$this->_catPrepends['P'] && $this->_frm->appExists('proj')) {
						debug('Search Project Name:'.substr($Name,strlen($this->_catPrepends['P'])));
						$P=$this->_frm->getStaticModul('proj');
						if ($pObj=$P->getPrjByName(substr($Name,strlen($this->_catPrepends['P'])))) {
							$Task['FKProjID']=$pObj->getID();
							debug('Found ProjID:'.$pObj->getID());
						}
					}
				}
			}
			if (!$Task['FKDocID']) {
				$Task['FKDocID']=$task->getSyncID($this->_frm->getUser());
			}
			if (!$Task['FKDocID']) {
 				debug('NO Task Categorie: uid='.$id);
				$result['error']=1;
				return $result;
			}

			$Task['Title']=$meta['Title'];
			$Task['Text']=$meta['Text'];
			$Task['EndDate']=$meta['EndDate'];
			$Task['StartDate']=$meta['StartDate'];
			$Task['Priority']=$meta['Priority'];
			$Task['Alarm']=$meta['Alarm'];

			if ($meta['RecType']) {
				$Task['RecType']=$meta['RecType'];
				$Task['RecInt']=$meta['RecInt'];
				$Task['RecDate']=$meta['RecDate'];
				//$Task['RecCfg']=is_array($taskobj->RecCfg)?serialize($taskobj->RecCfg):'';
			} else {
				$Task['RecType']=0;
				$Task['RecInt']=0;
				$Task['RecDate']=0;
				//$Task['RecCfg']='';
			}


			if ($Task['TaskID']) {
 				//debug('UPDAE  Task '.print_r($Task,1));
				$task->updateTask($Task['TaskID'],$Task);
				if (date('d.m.Y',$oldTask['EndDate'])!= date('d.m.Y',$Task['EndDate'])) {
					$log_tras=array(
						'{ESTART}'=>date('d.m.Y',$Task['StartDate']),
						'{ETITLE}'=>trim($Task['Title']),
						'{ETEXT}'=>trim($Task['Text']),
					);
					if ($Task['StartDate']!=$Task['EndDate']) {
						$log_tras['{EEND}']=date('d.m.Y',$Task['EndDate']);
					} else {
						$log_tras['{EEND}']='-';
					}
					$log_tras['{ODATE}']=date('d.m.Y',$oldTask['EndDate']);
					$log_tras['{NDATE}']=date('d.m.Y',$Task['EndDate']);

					$GLOBALS['T']->setLang($this->_frm->getLang());
					$GLOBALS['T']->loadModul('task');
					
					$task->insertLog($Task['TaskID'],$this->_frm->getUser(),strtr($GLOBALS['T']->lang('[[task_action_move_title]]'),$log_tras),'log');
					if ($Task['Notes']) {
						$TaskUsers=$task->getTaskUsers($Task['TaskID']);
						$send_user=array();
						foreach ($TaskUsers as $key=>$val) {
							//echo $key.'-'.$val;
							if ($key!=$this->_frm->getUser() && $val!=3 && $val!=2 && $val!=4) {
								$send_user[]=$key;
							}
						}
						if (!empty($send_user)) {
							$this->_frm->sendmessage($send_user,
								$this->_frm->getUser(),
								strtr($GLOBALS['T']->lang('[[task_action_move_title]]'),$log_tras),
								strtr($GLOBALS['T']->lang('[[task_action_move_text]]'),$log_tras),
								"?site=task.php&action=vo&TaskID=".$Task['TaskID'],
								$Task['Title'],
								'msg_6.gif');
						}
					}
				}
			} else {
				if ($Task['EndDate']==$Task['StartDate']) {
					$Typ='o';
				} else {
					$Typ='p';
				}
				$Task['TimeCreate']=time();
				$Task['Status']=1;
				$Task['TaskID']=$task->saveAllTask($Task,array($this->_frm->getUser()=>1),$Typ);
			}
   		}
   		if ($Task['TaskID'] && ($TaskUser=$task->readTaskUser($Task['TaskID'],$this->_frm->getUser()))) {
			if ($TaskUser && $TaskUser['Done']!=$meta['UserDone']) {
				$task->updateUserStatus($Task['TaskID'],$this->_frm->getUser(),$meta['UserDone']);
				$task->setUnread($Task['TaskID'],$this->_frm->getUser(),0);
				if ($meta['UserDone']==4) {
					$task->insertLog($Task['TaskID'],$this->_frm->getUser(),'','done');
					if ($Task['DoneOne']) $tmp_status=4;
					else $tmp_status=$task->checkTaskStatus($Task['TaskID']);

					if ($Task['Status']!=$tmp_status) {
						$task->updateTask($Task['TaskID'],array('Status'=>$tmp_status,'StatusDate'=>time()));
						if ($tmp_status==4) {
							if ($Task['RecType'] && ($next_recur=$task->nextRecurrence(
									$Task['StartDate'],
									$Task['EndDate'],
									$Task['RecType'],
									$Task['RecInt'],
									$Task['RecDate']))) {
								$Task['StartDate']=$next_recur['start'];
								$Task['EndDate']=$next_recur['end'];
								$task->copyTask($Task['TaskID'],$Task);
							}
						}
					}
					if ($Task['Notes'] && $this->_frm->getUser()!=$Task['OwnerID']) {
						$GLOBALS['T']->setLang($this->_frm->getLang());
						$GLOBALS['T']->loadModul('task');
						$this->_frm->sendmessage(array($Task['OwnerID']),
										$this->_frm->getUser(),
										$GLOBALS['T']->lang('[[task_action_done_title]]'),
										'',
										"?site=task.php&action=v&TaskID=".$Task['TaskID'],
										$Task['Title'],
										'msg_6.gif');
					}
				}
			}
			$result['id']=(int)$Task['TaskID'];
			$result['error']=0;
   		} else {
			$result['error']=1;
			debug('NO UPDATE Permissions:'.$id);
		}
		return $result;
    }
    public function deleteActiveSyncTask($id) {
  		debug('deleteActiveSyncTask: uid='.$id);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
      	$task=$this->_frm->getStaticModul('task');
  		if ($id && ($Task=$task->readTask($id))) {
			if ($Task['OwnerID']==$this->_frm->getUser()) {
				$task->deleteTaskObject($Task);
				return true;
			}
		}
		debug('NO DELETE Permissions:'.$id);
		return false;
    }

    public function getActiveSyncMailPoperties() {
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$Mail=$this->_frm->getStaticModul('mail');
		$Mail->setUserName($this->_username);
		$Mail->setPassword($this->_password);
		$root_obj_d=$Mail->getSystemObj('d');
		$result=array(
			'Host'=>$Mail->getHost(),
			'Username'=>$Mail->getUserName(),
			'INBOX'=>$root_obj_d->getBox(),
			'DraftID'=>$Mail->getDraftID(),
			'SentID'=>$Mail->getSentID(),
			'ReadOnlyID'=>$Mail->getReadOnlyID(),
			'TrashID'=>$Mail->getTrashID(),
			'Delimiter'=>$Mail->getCfg('cfg/delim'),
		);
		array_walk_recursive($result,array($this, 'encodeCharset'));
		return (object)$result;
    }
    public function getActiveSyncMailFolders($devid) {
  		debug('getActiveSyncMailFolders: '.$devid);
		if(!$this->_frm->getUser()) {
			$this->throwSoapFault('auth');
		}
		$result=array();
		$Mail=$this->_frm->getStaticModul('mail');
		$Mail->setUserName($this->_username);
		$Mail->setPassword($this->_password);
		if ($Mail->open()) {
			$GLOBALS['T']->setLang($this->_frm->getLang());
			$GLOBALS['T']->loadModul('mail');

			require_once('lib/sync/SyncDB.php');
			$activeSync=$this->_frm->getStaticModul('active_sync');
			$folders=$activeSync->listSyncFolders($this->_frm->getUser(),'');
			if (!empty($folders)) {
				if (!isset($folders['INBOX'])) $folders['INBOX']=array('ID'=>'INBOX');
				foreach ($folders as $val) {
					if ($tmpObj=$Mail->getObj($val['ID'],true,false)) {
						if ($tmpObj->getMeta('Type')=='R') continue;
						if ($tmpObj->getMeta('Type')=='X') continue;
						//Draft Folder nicht synchronisieren wegen Samsung BUG;
						//if ($tmpObj->getMeta('Type')=='D') continue;
						if ($tmpObj->getMeta('ParentBox')=='user') {
							$tmpObj->setMeta('ParentBox','');
						}
						//if ($val->getMeta('Type')=='T') continue;
						$result[]=$this->_parseActiveSyncMailFolder($tmpObj);
						while ($tmpObj->getMeta('ParentBox') && !isset($folders[$tmpObj->getMeta('ParentBox')]) && ($tmpObj=$Mail->getObj($tmpObj->getMeta('ParentBox'),true,false))) {
							if ($tmpObj->getMeta('ParentBox')=='user') {
								$tmpObj->setMeta('ParentBox','');
							}
							$result[]=$this->_parseActiveSyncMailFolder($tmpObj);
						}
					}
				}
			} else {
				$folders=$Mail->listFolders('INBOX',false,false,true,0);
				foreach ($folders as $val) {
					$result[]=$this->_parseActiveSyncMailFolder($val);
				}
				$folders=$Mail->listFolders('INBOX.%',false,false,true,0);
				foreach ($folders as $val) {
					if ($val->getMeta('Type')=='R') continue;
					if ($val->getMeta('Type')=='X') continue;
					//Draft Folder nicht synchronisieren wegen Samsung BUG;
					//if ($val->getMeta('Type')=='D') continue;
					$result[]=$this->_parseActiveSyncMailFolder($val);
				}
			}
		}
		return $result;
	}
	private function _parseActiveSyncMailFolder($val) {
		$fObj=array(
			'Box'=>$val->getMeta('Box'),
			'ParentBox'=>$val->getMeta('ParentBox'),
			'Name'=>$val->getMeta('Name'),
			'NumMsg'=>$val->getParentMeta('NumMsg'),
			'NumNew'=>$val->getParentMeta('NumNew'),
			'NumRec'=>$val->getParentMeta('NumRec'),
			'Type'=>$val->getMeta('Type'),
		);
		if ($val->getMeta('Box')=='INBOX') {
			$fObj['Type']='I';
		}
		switch($fObj['Type']) {
			case 'I':
				$fObj['Name']=$this->_username;
			break;
			case 'S':
				$fObj['Name']=$GLOBALS['T']->lang('[[M_SENT]]');
				$fObj['ParentBox']=0;
			break;
			case 'D':
				$fObj['Name']=$GLOBALS['T']->lang('[[M_DRAFT]]');
				$fObj['ParentBox']=0;
			break;
			case 'R':
				$fObj['Name']=$GLOBALS['T']->lang('[[M_READONLY]]');
				$fObj['ParentBox']=0;
			break;
			case 'T':
				$fObj['Name']=$GLOBALS['T']->lang('[[M_TRASH]]');
				$fObj['ParentBox']=0;
			break;
			case 'X':
				$fObj['Name']=$GLOBALS['T']->lang('[[M_SPAM]]');
			break;
		}

		array_walk_recursive($fObj,array($this, 'encodeCharset'));
		return (object)$fObj;
	}
    public function getActiveSyncMail($folderid,$cutoffdate,$limit=0) {
    	$result=array();
    	debug('getActiveSyncMail: folderid='.$folderid.', cutoffdate='.$cutoffdate);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$Mail=$this->_frm->getStaticModul('mail');
		$Mail->setUserName($this->_username);
		$Mail->setPassword($this->_password);
		if ($Mail->open()) {
			$rows=0;
			$search='';
			if ($cutoffdate > 0) {
				$search="SINCE ".date("d-M-Y", $cutoffdate);
			}
			//debug($search);
			$entries=$Mail->listMails($rows,$folderid,0,$limit,SORTARRIVAL,1,$search,false,false);
			foreach ($entries as $val) {
				$result[]=array(
					'id'=>trim($val->getMeta('ID')),
					'mod'=>$val->getMeta('Date'),
					'flags'=>$val->getMeta('New')?0:1,
					'olflags'=>0,
					'acl'=>7,
				);
			}
		}
		return $result;
    }
    public function getActiveSyncMailMimeByID($folderid,$mailid) {
    	$result=array();
    	debug('getActiveSyncMailMimeByID: folderid='.$folderid.' mailID:'.$mailid.' getmime:'.$getmime);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$Mail=$this->_frm->getStaticModul('mail');
		$Mail->setUserName($this->_username);
		$Mail->setPassword($this->_password);
		if ($Mail->open() && ($Mobj=$Mail->getMailObj($folderid,$mailid))) {
			$result=array(
				'id'=>$mailid,
				'box'=>$folderid,
				'Date'=>$Mobj->getMeta('Date'),
				'New'=>$Mobj->getMeta('New'),
				'MimeHeader'=>'',
				'MimeBody'=>'',
			);
			$result['MimeHeader']=base64_encode($Mail->getFullHeader($folderid,$mailid));
			$result['MimeBody']=base64_encode($Mail->fetchFullBody($folderid,$mailid,true));
			//$result['Mime']=base64_encode($result['Mime']);
			return (object)$result;
		}
		return false;
	}
 	function sendActiveSyncMail($Headers,$BodyRfc) {
    	debug('sendActiveSyncMail: Headers:'.print_r($Headers,1));
    	//debug(print_r($BodyRfc,1));
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$Mail=$this->_frm->getStaticModul('mail');
		$Mail->setPrefs($this->_frm->getPrefs('email'));
		$Mail->setUserName($this->_username);
		$Mail->setPassword($this->_password);
		if ($Mail->open()) {
			$copyto=$Mail->getSentID();
			if (!isset($Headers['From']) || empty($Headers['From'])) {
				$Headers['From']=$Mail->getPrefs("email".($Mail->getPrefs("defuse")?$Mail->getPrefs("defuse"):1));
			}
			if (!isset($Headers['Reply-To']) || empty($Headers['Reply-To'])) {
				$Headers['Reply-To']=$Headers['From'];
			}

			$subject=$Headers['Subject'];
			$to=$Headers['To'];
			$from=@imap_rfc822_parse_adrlist($Headers['From'],'');
			$mail_hdrs = $Headers;
			unset($mail_hdrs['Subject']);
			unset($mail_hdrs['To']);

			$OK = mail($to,$subject,$BodyRfc,$Mail->headersToTxt($mail_hdrs,"\n"),'-f'.imap_rfc822_write_address($from[0]->mailbox,$from[0]->host,''));

			if ($OK && ($copyto || $Mail->getReadOnlyID())) {
				$Headers["Date"]=date('r');
				$mail_headers=$Mail->headersToTxt($Headers,"\n");
				Framework::convertLineEndings($mail_headers,"\r\n");
				Framework::convertLineEndings($BodyRfc,"\r\n");
				//debugtime('E');
				if ($copyto) $Mail->appendMail($copyto,$mail_headers."\r\n"."\r\n".$BodyRfc."\r\n","\\Seen");
				if ($Mail->getReadOnlyID()) $Mail->appendMail($Mail->getReadOnlyID(),$mail_headers."\r\n"."\r\n".$BodyRfc."\r\n","\\Seen");
				//debugtime('E');
				unset($mail_headers,$BodyRfc,$Headers);
			}
			if ($OK) {
				return true;
			}
		}
		return false;
	}
    public function statMailBox($folderid) {
    	debug('statMailBox: folderid='.$folderid);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$Mail=$this->_frm->getStaticModul('mail');
		$Mail->setUserName($this->_username);
		$Mail->setPassword($this->_password);
		if ($Mail->open()) {
			$result=$Mail->getStatus($folderid);
			if ($result) {
				array_walk_recursive($result,array($this, 'encodeCharset'));
				return (object)$result;
			}
		}
		return false;
	}

    public function setMailFlag($folderid,$mailid,$flag) {
    	$result=array();
    	debug('setMailFlag: folderid='.$folderid.' mailID:'.$mailid.' flag:'.$flag);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$Mail=$this->_frm->getStaticModul('mail');
		$Mail->setUserName($this->_username);
		$Mail->setPassword($this->_password);
		if ($Mail->open()) {
			$error=$Mail->setFlag($folderid,$mailid,$flag);
			if (!$error) return true;
		}
		return false;
	}
    public function clearMailFlag($folderid,$mailid,$flag) {
    	$result=array();
    	debug('clearMailFlag: folderid='.$folderid.' mailID:'.$mailid.' flag:'.$flag);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$Mail=$this->_frm->getStaticModul('mail');
		$Mail->setUserName($this->_username);
		$Mail->setPassword($this->_password);
		if ($Mail->open()) {
			$error=$Mail->clearFlag($folderid,$mailid,$flag);
			if (!$error) return true;
		}
		return false;
	}
    public function deleteMail($folderid,$mailid) {
    	$result=array();
    	debug('deleteMail: folderid='.$folderid.' mailID:'.$mailid);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$Mail=$this->_frm->getStaticModul('mail');
		$Mail->setUserName($this->_username);
		$Mail->setPassword($this->_password);
		if ($Mail->open()) {
			$TrashObj=$Mail->getObj($Mail->getTrashID());
			//debug(print_r($TrashObj,1));
			if (!is_object($TrashObj) || $folderid==$TrashObj->getBox()) {
				$error=$Mail->deleteMail($folderid,$mailid);
			} else {
				$error=$Mail->moveMail($folderid,$mailid,$TrashObj->getBox());
			}
			//debug($error);
			if (!$error) {
				$Mail->expungeBox($folderid);
				return true;
			}
		}
		return false;
	}
    public function moveMail($folderid,$mailid,$tofolderid) {
    	$result=array();
    	debug('moveMail: folderid='.$folderid.' mailID:'.$mailid.' tofolderid='.$tofolderid);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$Mail=$this->_frm->getStaticModul('mail');
		$Mail->setUserName($this->_username);
		$Mail->setPassword($this->_password);
		if ($Mail->open()) {
			$toObj=$Mail->getObj($tofolderid);
			if (is_object($toObj)) {
				$error=$Mail->moveMail($folderid,$mailid,$toObj->getBox());
			}
			if (!$error) {
				$Mail->expungeBox($folderid);
				return true;
			}
		}
		return false;
	}
    public function getMailAttachment($folderid,$mailid,$part) {
    	$result=array();
    	debug('getMailAttachment: folderid='.$folderid.' mailID:'.$mailid.' part:'.$part);
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$Mail=$this->_frm->getStaticModul('mail');
		$Mail->setUserName($this->_username);
		$Mail->setPassword($this->_password);
		if ($Mail->open() && ($Mobj=$Mail->getMailObj($folderid,$mailid))) {
			require_once("lib/mail/classMailDecode.php");
			$MDec=new MailDecode($Mail);
			$Structure=$MDec->getBody($folderid,$Mobj,1,true);
			//debug(print_r($Structure['att'],1));
			if ($part && isset($Structure['att'][$part])) {
				$result=array(
					'body'=>base64_encode($Mail->getAttachment($folderid,$mailid, $part,$Structure['att'][$part]['enc'],true)),
					'type'=>$Structure['att'][$part]['type'],
				);
				return $result;
			}
		}
		return false;
	}


	/**
	* @param object newTempMail $newTempMail
	* @return object newTempMailResponse $newTempMailResponse
	*/
    public function newTempMail($newTempMail) {
  		debug('newTempMail: '.print_r($newTempMail,1));
       	if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$newTempMailResponse=new newTempMailResponse();

		$Mail=$this->_frm->getStaticModul('mail');
		$Mail->setPrefs($this->_frm->getPrefs('email'));
    	$Mail->deleteEmail();
    	$Mail->deleteEmailAttachments();
		$extra=array();
    	$tempMail=array(
			'TO'=>isset($newTempMail->to)?$newTempMail->to:'',
			'CC'=>isset($newTempMail->cc)?$newTempMail->cc:'',
			'BCC'=>isset($newTempMail->bcc)?$newTempMail->bcc:'',
			'Subject'=>isset($newTempMail->subject)?$newTempMail->subject:'',
			'copyto'=>isset($newTempMail->copyto)?$newTempMail->copyto:'',
			'read_confirm'=>isset($newTempMail->read_confirm)?$newTempMail->read_confirm:0,
		);
		if(!isset($newTempMail->identity) || !$newTempMail->identity) {
			if ($Mail->getPrefs("defuse")) $identity=$Mail->getPrefs("defuse"); else $identity=1;
		}
		if ($Mail->getPrefs("use".$identity)) {
			$signatur=$Mail->getPrefs("signatur".$identity);
			if ($use_wysiwyg) {
				$signatur_html=$Mail->getPrefs("signatur_html".$identity);
				if (!strlen($signatur_html)) {
					$signatur_html=nl2br($signatur);
				} else {
					$relImgPath=Framework::getSelfDir().'/fetch_mail_img.php?img=htmlImg/';
					$signatur_html=preg_replace('/(src="?)[^ ]+\/htmlImg\/(.+\.(jpg|gif|jpeg|png))/i','\\1'.$relImgPath.'\\2',$signatur_html);
				}
			}
		} else {
			$signatur='';
			$signatur_html='';
		}
		if ($newTempMail->is_html_email) {
			$emptyRow='<p></p>';
			$extra['wysiwyg']=true;
			$tempMail['Body']=$Mail->formatNewHtmlMail($emptyRow.$newTempMail->body.$emptyRow.$emptyRow.'<!--BEGIN SIGNATUR--><div id="groupeMailSign" class="mceNonEditable">'.$signatur_html.'</div><!--END SIGNATUR-->','','',GE_CHARSET);
		} else {
			$tempMail['Body']="\n\n".$newTempMail->body."\n\n".$signatur;
		}
		$tempMail['extra']=serialize($extra);
		$Mail->saveEmail($tempMail);
		$newTempMailResponse->success=true;
		return $newTempMailResponse;
    }
	/**
	* @param object uploadTempMailAttachment $uploadTempMailAttachment
	* @return object uploadTempMailAttachmentResponse $uploadTempMailAttachmentResponse
	*/
    public function uploadTempMailAttachment($uploadTempMailAttachment) {
		debug('uploadTempMailAttachment');
      	 if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$uploadTempMailAttachmentResponse=new uploadTempMailAttachmentResponse();
		$Mail=$this->_frm->getStaticModul('mail');
		try {
			file_put_contents($Mail->getAttachPath()."/".$uploadTempMailAttachment->filename,base64_decode($uploadTempMailAttachment->filedata));
			if ($this->_frm->scanFile($Mail->getAttachPath()."/".$uploadTempMailAttachment->filename)) {
           	 	$this->throwSoapFault('Virus check failed!');
			} else {
				$F_type=preg_replace('/;.*$/','',$uploadTempMailAttachment->mimetype);
				$F_size=filesize($Mail->getAttachPath()."/".$uploadTempMailAttachment->filename);
				$Mail->addEmailAttachments(array('Name'=>$uploadTempMailAttachment->filename,'Size'=>$F_size,'Type'=>$F_type));
				$uploadTempMailAttachmentResponse->success=true;
			}
		} catch (Exception $e) {
            $this->throwSoapFault($e->getMessage());
		}
		return $uploadTempMailAttachmentResponse;
    }
	/**
	* @param object getTempMailUrl $getTempMailUrl
	* @return object getTempMailUrlResponse $getTempMailUrlResponse
	*/
    public function getTempMailUrl($getTempMailUrl) {
  		debug('getTempMailUrl:'.print_r($getTempMailUrl,1));
      	if (!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$sid=$this->getGroupeSessionID($getTempMailUrl->sid);
		$getTempMailUrlResponse=new getTempMailUrlResponse();
		$getTempMailUrlResponse->url='main.php?site=mail.php&action=n&load=1&groupie_Session='.$sid;
		$getTempMailUrlResponse->sid=$sid;
		return $getTempMailUrlResponse;
    }

    public function getGroupeSessionID($sid='') {
   		global $sess, $auth;
  		debug('getGroupeSessionID');
        if(!$this->_frm->getUser()) {
            $this->throwSoapFault('auth');
        }
		$sess=new groupie_Session();
   		$sess->set_container();
    	$sess->set_tokenname();

		if ($sid && $this->_isValidSessionAuth($sid)) {
			debug('provided sessionID is valid');
			$this->_groupeSessionId[$this->_frm->getUser()]=$sid;
			return $sid;
		}
		if (isset($this->_groupeSessionId[$this->_frm->getUser()]) && $this->_isValidSessionAuth($this->_groupeSessionId[$this->_frm->getUser()])) {
			debug('cached sessionID is valid');
    		return $this->_groupeSessionId[$this->_frm->getUser()];
    	}
		debug('generate new sessionID');
		$sid=$sess->that->ac_newid(md5(uniqid($sess->magic)), $sess->name);
		$sess->id=$sid;

		$auth=new groupie_Auth();
		$auth->auth["uid"] = $this->_frm->getUser();
		$auth->auth["exp"] = time() + (60 * $auth->lifetime);
		$auth->auth["refresh"] = time() + (60 * $auth->refresh);
		$auth->auth["password"]=$this->_password;
		$auth->auth["uname"]=$this->_username;

		$sess->register('auth');
		$sess->freeze();
    	$this->_groupeSessionId[$this->_frm->getUser()]=$sid;
        return $sid;
    }
    private function _isValidSessionAuth($sid) {
   		global $sess, $auth;
		$sess->id=$sid;
		$sess->thaw();
		if (is_object($auth) && $auth->auth["uid"]==$this->_frm->getUser() && $auth->is_authenticated()) {
			$auth->auth["exp"] = time() + (60 * $auth->lifetime);
			$sess->freeze();
			return true;
		}
		return false;
	}

}
class newTempMail {
	/**
	* @var int $identity ID of the identitiy to use / 0 for default.
	*/
	public $identity=0;
	/**
	* @var string $to To
	*/
	public $to='';
	/**
	* @var string $cc Cc
	*/
	public $cc='';
	/**
	* @var string $bcc Bcc
	*/
	public $bcc='';
	/**
	* @var string $subject Subject
	*/
	public $subject='';
	/**
	* @var string $body Body
	*/
	public $body='';
	/**
	* @var string $copyto Mailbox for copy to
	*/
	public $copyto='';
	/**
	* @var boolean $read_confirm Request a read confirm
	*/
	public $read_confirm=false;
	/**
	* @var boolean $is_html_email Specify if the body is a HTML Message
	*/
	public $is_html_email=false;
}

class newTempMailResponse {
	/**
	* @var boolean $success whether the operation successful or not
	*/
	public $success=false;
}

class uploadTempMailAttachment {
	/**
	* @var string $filename Filename
	*/
	public $filename='';
	/**
	* @var string $filedata FileData
	*/
	public $filedata='';
	/**
	* @var string $mimetype MimeTypee
	*/
	public $mimetype='';
}

class uploadTempMailAttachmentResponse {
	/**
	* @var boolean $success whether the operation successful or not
	*/
	public $success=false;
}

class getTempMailUrl {
	/**
	* @var string $sid Group-e session ID if you have one or empty string for new one.
	*/
	public $sid='';
}

class getTempMailUrlResponse {
	/**
	* @var string $sid Group-e session ID
	*/
	public $sid='';
	/**
	* @var string $url Url to access the mail interface
	*/
	public $url='';
}


?>