<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                                  |
	|	  39100 Bozen/Bolzano                                                     |
	|	  ITALIEN/ITALIA                                                          |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
    | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class Stel {
	var $_db;
	var $_uid;
	var $_gid;
	var $_modul='stel';

	function Stel() {
		global $db,$frm;
		$this->_db=&$db;
		$this->_uid=$frm->getUser();
		$this->_gid=$frm->getMyGroups();
		$this->setRule($frm->isRuleUser(array('sysadmin','stel')));
		$this->setSuperAdmin($frm->isSuperAdmin());
		$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
		$this->_lang=$frm->getLang();
	}
	function setUser($uid) {
		$this->_uid=$uid;
	}
	function getUser() {
		return $this->_uid;
	}
	function setGroup($gid) {
		$this->_gid=$gid;
	}
	function getGroups() {
		return $this->_gid;
	}
	function setRule($bool=false) {
		$this->_rule=$bool;
	}
	function setSuperAdmin($bool=false) {
		$this->_sadmin=$bool;
	}
	function isRuleUser() {
		return $this->_rule;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function getModul() {
		return $this->_modul;
	}
	function setCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}
		}
	}
	function getCfg($key) {
		if (isset($this->_cfg[$key])) {
			return $this->_cfg[$key];
		} else {
			return false;
		}
	}
	function getPerms($test=0) {
		if ($this->isRuleUser()) return true;
		if (!isset($this->_perms[$this->_uid])) {
			$this->_setPerms();
		}
		if ($test) {
			return ($this->_perms[$this->_uid]&$test)?true:false;
		} else {
			return $this->_perms[$this->_uid];
		}
	}
	function _setPerms() {
		$query="SELECT BIT_OR(Perms) as uperms FROM StelPerms WHERE";
		$query.=" UserTyp=".$this->_db->escape('u');
		$query.=" AND UserID=".$this->_db->escape($this->_uid);
		$query.=" GROUP BY UserTyp";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$this->_perms[$this->_uid]=$this->_db->f('uperms');
		} else {
			$query="SELECT BIT_OR(Perms) as uperms FROM StelPerms WHERE";
			$query.=" UserTyp=".$this->_db->escape('g');
			$query.=" AND UserID IN (".implode(',',$this->_db->escape($this->_gid)).')';
			$query.=" GROUP BY UserTyp";
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				$this->_perms[$this->_uid]=$this->_db->f('uperms');
			} else {
				$this->_perms[$this->_uid]=0;
			}
		}
	}
	function insertTel($values) {
		$values['TelID']=$this->_db->nextid('StelData');
		if ($this->_db->insert('StelData',$values)) {
			return $values['TelID'];
		}
	}
	function updateTel($ID,$values) {
		return $this->_db->update('StelData',$values,"TelID=".$this->_db->escape($ID));
	}

	function &_fetchTel() {
		$result=array(
			'TelID'=>$this->_db->f('TelID'),
			'TimeCreate'=>$this->_db->f('TimeCreate'),
			'UserCreate'=>$this->_db->f('UserCreate'),
			'TimeModify'=>$this->_db->f('TimeModify'),
			'UserModify'=>$this->_db->f('UserModify'),
			'TelTime'=>$this->_db->f('TelTime'),
			'TelUser'=>$this->_db->f('TelUser'),
			'TelFrom'=>$this->_db->f('TelFrom'),
			'TelCatID'=>$this->_db->f('TelCatID'),
			'FKProjID'=>$this->_db->f('FKProjID'),
			'Description'=>$this->_db->f('Description'),
			'Users'=>$this->_db->f('Users'),
			'Groups'=>$this->_db->f('Groups'),
		);
		return $result;
	}
	function readTel($ID) {
		$query="SELECT * FROM StelData WHERE TelID=".$this->_db->escape($ID);
		$this->_db->query($query);
		$this->_db->next_record();
		return $this->_fetchTel();
	}
	function deleteTel($ID) {
		$query="DELETE FROM StelData WHERE TelID=".$this->_db->escape($ID);
		$this->_db->query($query);
		return 1;
	}
	function listEntries($begin,$end) {
		$result=array();
		$query="SELECT * FROM StelData";
		$query.=" WHERE TelTime >= ".$this->_db->escape($begin);
		$query.=" AND TelTime <= ".$this->_db->escape($end);
		if ($this->getCfg('cfg/modul/visibility')) {
			$query.=" AND (UserCreate='".$this->_uid."' OR Users LIKE '%|".$this->_uid."|%' OR Groups LIKE '%|".implode("|%' OR Groups LIKE '%|",$this->_gid)."|%')";
		}
		$query.=" ORDER BY TelTime ASC";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[date('Y-m-d',$this->_db->f('TelTime'))][$this->_db->f('TelID')]=$this->_fetchTel();
		}
		return $result;
	}
	function listAuswertung(&$rows,&$summe,$search,$OrderBy='',$b=0,$limit=0) {
		$result=array();
		$sqlGroupBy=array();
		if (!is_array($search['GroupBy']) || !count($search['GroupBy'])) {
			$search['GroupBy']=array('TelUser','TelCatID','TelTime');
		}
		$Fields=$search['GroupBy'];
		foreach ($Fields as $val) {
			if ($val=='TelTime') {
				$sqlGroupBy[]="FROM_UNIXTIME(TelTime,'%Y-%M-%D')";
			} else {
				$sqlGroupBy[]=$val;
			}

		}
		$query="SELECT ".implode(',',$Fields).",count(*) as num FROM StelData INNER JOIN StelCat ON(CatID=TelCatID)";
		$searchQuery=$this->getSearchQuery($search);
		if (!empty($searchQuery)) $query.=" WHERE ".$this->_db->getWhere($searchQuery);

		$query.=" GROUP BY ".implode(',',$sqlGroupBy);
		if ($OrderBy) $query.=" ORDER BY $OrderBy";
		if ($limit)  $query.=" ".$this->_db->formatLimit($b,$limit);

		$this->_db->query($query);
		$rows=0;
		while ($this->_db->next_record()) {
			foreach ($Fields as $val) {
				$result[$rows][$val]=$this->_db->f($val);
			}
			$result[$rows]['Num']=$this->_db->f('num');
			$summe+=$this->_db->f('num');
			$rows++;
		}
		return $result;
	}



	/*function listAuswertung(&$rows,&$summe,$Begin,$End,$TelCatID,$sqlUser,$GroupBy,$OrderBy='',$b=0,$limit=0) {

	}*/
	function listDetails($Begin,$End,$TelCatID,$sqlUser,$OrderBy='',$b=0,$limit=0) {
		$result=array();
		$query="SELECT * FROM StelData ";
		if ($Begin) $where[]='TelTime>='.$this->_db->escape($Begin);
		if ($End) $where[]='TelTime<='.$this->_db->escape($End);
		if ($TelCatID) $where[]='TelCatID='.$this->_db->escape($TelCatID);
		if (is_array($sqlUser)) $where[]='TelUser IN ('.implode(',',$this->_db->escape($sqlUser)).')';
		elseif ($sqlUser) $where[]='TelUser='.$this->_db->escape($sqlUser);

		if (is_array($where)) $query.=' WHERE '.implode(' AND ',$where);
		if ($OrderBy) $query.=" ORDER BY $OrderBy";
		if ($b || $limit)  $query.=" ".$this->_db->formatLimit($b,$limit);

		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('TelUser')][$this->_db->f('TelCatID')][date('d.m.Y',$this->_db->f('TelTime'))][$this->_db->f('TelID')]=$this->_fetchTel();
		}
		return $result;
	}
	function getSearchQuery($search) {
		$searchQuery=array();
		if ($search['TimeB']) $searchQuery[]=array('Field'=>'TelTime','Typ'=>'>=','Values'=>$search['TimeB']);
		if ($search['TimeE']) $searchQuery[]=array('Field'=>'TelTime','Typ'=>'<=','Values'=>$search['TimeE']);
		if ($search['TelUser']) $searchQuery[]=array('Field'=>'TelUser','Typ'=>'=','Values'=>$search['TelUser']);
		if ($search['TelCatID']) $searchQuery[]=array('Field'=>'TelCatID','Typ'=>'=','Values'=>$search['TelCatID']);
		if ($search['FKProjID']) $searchQuery[]=array('Field'=>'FKProjID','Typ'=>'=','Values'=>$search['FKProjID']);
		if ($this->getCfg('cfg/modul/visibility') && !$search['noPerms']) {
			 $searchQuery[]=array('Typ'=>'SQL','Values'=>"(UserCreate='".$this->_uid."' OR Users LIKE '%|".$this->_uid."|%' OR Groups LIKE '%|".implode("|%' OR Groups LIKE '%|",$this->_gid)."|%')");
		}
		return $searchQuery;
	}
	function &listAllStelUsers($search) {
		$result=array();
		$searchQuery=$this->getSearchQuery($search);
		$query="SELECT DISTINCT(TelUser) FROM StelData";
		if (!empty($searchQuery)) $query.=" WHERE ".$this->_db->getWhere($searchQuery);


		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('TelUser');
		}
		return $result;
	}
	function searchStel(&$rows,$search,$sqlOrder='',$b=0,$limit=0,$use_limit=true) {
		$result=array();
		$searchQuery=$this->getSearchQuery($search);
		$query="SELECT StelData.* FROM StelData INNER JOIN StelCat ON(CatID=TelCatID)";
		if (!empty($searchQuery)) $query.=" WHERE ".$this->_db->getWhere($searchQuery);
		if ($sqlOrder)  $query.=" ORDER BY ".$sqlOrder;
		if ($limit)  $query.=" ".$this->_db->formatLimit($b,$limit);
		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		while ($this->_db->next_record()) {
			$result[$this->_db->f('TelID')]=$this->_fetchTel();
		}


		if ($use_limit && $limit && ($b!=0 || $rows==$limit)) {
			$query="SELECT count(*) as num FROM StelData";
			if (!empty($searchQuery)) $query.=" WHERE ".$this->_db->getWhere($searchQuery);
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
		}
		return $result;
	}



	function readCat($ID,&$lang) {
		$query="SELECT * FROM StelCat WHERE CatID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_fetchCat($lang);
		} else {
			return false;
		}
	}
	function insertCat($values) {
		$values['CatID']=$this->_db->nextid('StelCat');
		if ($this->_db->insert('StelCat',$values)) {
			return $values['CatID'];
		}
	}
	function updateCat($ID,$values) {
		return $this->_db->update('StelCat',$values,"CatID=".$this->_db->escape($ID));
	}
	function deleteCat($ID) {
		if (!$this->isUsedCat($ID)) {
			$query="DELETE FROM StelCat  WHERE CatID=".$this->_db->escape($ID);
			$this->_db->query($query);
			return true;

		} else {
			return false;
		}
	}
	function isUsedCat($ID) {
		$query="SELECT TelCatID FROM StelData WHERE TelCatID=".$this->_db->escape($ID)." LIMIT 1";
		$this->_db->query($query);
		if ($this->_db->num_rows()) {
			return true;
		} else {
			return false;
		}
	}
	function &listAllCat($lang='') {
		if (!$lang) $lang=$this->_lang;
		$result=array();
		$query="SELECT * FROM StelCat ORDER BY Aktiv DESC,Name_$lang";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('CatID')]=$this->_fetchCat($lang);
		}
		return $result;
	}
	function &listAllCatNames($onlyAktiv=1) {
		$result=array();
		$query="SELECT * FROM StelCat ";
		if ($onlyAktiv) $query.="WHERE Aktiv=1 ";
		$query.="ORDER BY Name_".$this->_lang;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('CatID')]=$this->_db->f('Name_'.$this->_lang);
		}
		return $result;
	}
	function &_fetchCat(&$lang) {
		$result=array(
			'TimeModify'=>$this->_db->f('TimeModify'),
			'UserModify'=>$this->_db->f('UserModify'),
			'Aktiv'=>$this->_db->f('Aktiv'),
		);
		if (is_array($lang)) {
			foreach ($lang as $val) {
				$result['Name_'.$val]=$this->_db->f('Name_'.$val);
			}
		} else {
			$result['Name_'.$lang]=$this->_db->f('Name_'.$lang);
		}
		return $result;
	}
	function getCatName($id,$lang='') {
		if (!$lang) $lang=$this->_lang;
		$query="SELECT Name_$lang FROM StelCat WHERE CatID=".$this->_db->escape($id);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f("Name_$lang");
		} else {
			return '';
		}
	}
	function getCachedCatName($id,$lang='') {
		if (!$lang) $lang=$this->_lang;
		if (!isset($this->_catName[$id])) {

			$this->_catName[$id]=$this->getCatName($id,$lang);
		}
		return $this->_catName[$id];
	}


	function replacePerms($typ,$id,$Perms) {
		foreach ($Perms as $val) {
			$this->_db->insert('StelPerms',array('UserID'=>$id,'UserTyp'=>$typ,'Perms'=>$val),'',1);
		}
	}
	function getAllPerms($typ='') {
		$result=array();
		$query="SELECT * FROM StelPerms";
		if ($typ) $query.=" WHERE UserTyp=".$this->_db->escape($typ);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('UserTyp')][$this->_db->f('UserID')][]=$this->_db->f('Perms');
		}
		return $result;
	}
	function deletePerms($typ,$id) {
		$query="DELETE FROM StelPerms WHERE";
		$query.=" UserTyp=".$this->_db->escape($typ);
		if ($id) $query.=" AND UserID=".$this->_db->escape($id);
		$this->_db->query($query);
	}
	function hasProjectEntrys($projID) {
		$query = "SELECT TelID FROM StelData ";
		$query.=" WHERE FKProjID=".$this->_db->escape($projID);
		$query.=" ".$this->_db->formatLimit(0,1);
		$this->_db->query($query);
		if($this->_db->next_record()) {
			return true;
		} else {
			return false;
		}

	}
	function deleteProject($ID) {
		if ($ID) {
			$query = "DELETE FROM StelData WHERE FKProjID=".$this->_db->escape(intval($ID));
			//echo $query;
			$this->_db->query($query);
		}
	}

}
