<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
/*
 * A syncml-compatible class to handle vcard storage on a MySQL server
 *
 * (c) 2003 Nicolas Bougues, nicolas@bougues.net
 *
 * See the copyright file for licensing information.
 *
 */


class EmailImap  {
	var $_db;
	var $_store;
	var $_device_id;
	var $_user_id;
	var $_fields;
	var $_user_names;
	var $_sp;
	var $_inbox;
	var $_send_folder;
	var $_replyto;
	var $_from;
	var $_MaxGUIDSize=11;
	var $_SyncType=array(1,2);
	var $_caps = array(
		"text/message" => array (
			"VERSION" => array ("V", "1.0"),
		),
	);

	function EmailImap($store,$display,&$db) {
		$this->_db=$db;
		$this->_store=$store;
		$this->_display=$display;
		$this->_mail=new TextMail();
		$this->_sp="{".$GLOBALS[CFG][Mailserver].":".$GLOBALS[CFG][Mailserver_Port]."}";
		$this->_inbox=Framework::convertCharset('INBOX',GE_CHARSET,'UTF7-IMAP');
	}

	function init($user_id,$device_id,$user_lang,$prefs) {
		$this->_device_id=$device_id;
		$this->_user_id=$user_id;
		$this->_user_lang=$user_lang;
		if (!$this->_passwd) {
			$user=$GLOBALS[frm]->read_user($this->_user_id);
			$this->_passwd=$user[password];
			$this->_uname=$user[username];
			if (($pr=$this->_getPrefs()) && $pr["email1"]) {
				$this->_from=$pr["fullname1"].' <'.$pr["email1"].'>';
				if ($pr["replyto1"]) $this->_replyto=$pr["replyto1"]; else $this->_replyto=$pr["email1"];
				$this->_send_folder=Framework::convertCharset($pr["sel_sent"],GE_CHARSET,'UTF7-IMAP');
			} else {
				if ($user[email]) $this->_from=$user[lastname].' '.$user[firstname].' <'.$user[email].'>';
				$this->_send_folder=false;
			}
		}
		//debug('SENTFOLDER'.$this->_send_folder);
		$this->_ms=@imap_open($this->_sp.$this->_inbox,$this->_uname,$this->_passwd);
	}
	function _getPrefs() {


	}

	function get_ct() {
    		return ("text/message");
  	}
	function getVersion() {
    		return $this->_caps[$this->get_ct()][VERSION][1];
  	}

  	function get_datastore_caps () {
		$datastore = & new XmlNode ("DataStore", NULL);
		$datastore->new_child ("SourceRef", NULL, $this->_store);
		$datastore->new_child ("DisplayName", NULL, $this->_display);
		$datastore->new_child ("MaxGUIDSize", NULL, $this->_MaxGUIDSize);
		$type="RxPref";
		foreach ($this->_caps as $CTType => $caps) {
			$rxp = & $datastore->new_child ($type, NULL);
			$rxp->new_child ("CTType", NULL, $CTType);
			$rxp->new_child ("VerCT", NULL, $caps[VERSION][1]);
			$type="Rx";
		}
		$type="TxPref";
		foreach ($this->_caps as $CTType => $caps) {
			$rxp = & $datastore->new_child ($type, NULL);
			$rxp->new_child ("CTType", NULL, $CTType);
			$rxp->new_child ("VerCT", NULL, $caps[VERSION][1]);
			$type="Tx";
		}
		$synccap = & $datastore->new_child ("SyncCap", NULL);
		foreach ($this->_SyncType as $val) {
			$synccap->new_child ("SyncType", NULL, $val);
		}
    		return $datastore;
  	}

  	function get_ctcaps (&$ctcap) {

  	}
	function getModfiyTime($GUID) {
		return 1;
	}
	function getPerms($GUID,$mode='') {
		return 1;
	}
	function getName($ID) {
		return '';

	}

	function compareData($GUID,$item,&$support) {
		return 0;
	}
	function checkData($item) {
		return 1;
	}
	function insertData($item,$LocalNextAnchor,&$support) {
		$mail=$this->_mail->parseText($item);
		if ($this->_from && $mail['X-Sync-Parent-Folder']=='outbox') {
			$mail[From]=$this->_from;
			$headers=$this->_mail->getHeaders($mail);
			debug('Headers:'.$headers);
			debug('Subject:'.$mail['Subject']);
			debug('To:'.$mail['To']);
			debug('Body:'.$mail['Body']);
			if (mail($mail['To'],$mail['Subject'],$mail['Body'], $headers,'-f '.$mail['From'])) {
				if ($this->_ms && $this->_send_folder) {
					$this->_mail->appendMail($mail,$this->_ms,$this->_send_folder,$this->_sp,'');
				}
				return 1;
			} else {
				return -1;
			}
		} else {
			return -1;
		}
	}

	function updateData($GUID,$item,$LocalNextAnchor,&$support) {
		return -1;
	}

	function deleteData($GUID) {
		return -1;
	}

	function getAdd($Anchor,$query) {
		$result=array();
		if ($this->_ms) {
			$body_size=-1;
			if ($query) {
				debug ($query);
				if (preg_match('/li[(]([0-9]+)[)]/i',$query,$match)) {
					$body_size=$match[1];
				}
			}
			$new_mails=imap_search ($this->_ms,'UNSEEN',SE_UID);
			if (is_array($new_mails) && count($new_mails)) {



				$not_new=array();
				$query="SELECT GUID FROM SyncMaps  ";
				$query.=" WHERE SyncMaps.deviceID='".addslashes($this->_device_id)."'";
				$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
				$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
				$query.=" AND GUID IN ('".implode("','",$new_mails)."')";
				$query.=' GROUP BY GUID';
				$this->_db->query($query);
				while($this->_db->next_record()) {
					$not_new[]=$this->_db->f('GUID');
				}
				foreach ($new_mails as $msgno) {
					if (!in_array($msgno,$not_new)) {
						debug('NO:'.$msgno);
						$header=$this->_mail->parseImapHeader(imap_headerinfo ($this->_ms,imap_msgno($this->_ms,$msgno)));
						$header.='X-Sync-Parent-Folder: inbox'."\n";
						$header.='Content-Type: text/plain; charset="utf-8"'."\n";
						$header.='Content-Transfer-Encoding: 8bit'."\n\n";
						if ($body_size) {
							$body=$this->_mail->getImapBody($this->_ms,$msgno);
							if ($body_size!=-1) $body['contenttext']=substr($body['contenttext'],0,$body_size);
						} else {
							$body['contenttext']='';
						}
						$result[$msgno]=Framework::convertCharset($this->_mail->mail_enc($header),GE_CHARSET,'UTF-8').
							Framework::convertCharset($body['contenttext'],GE_CHARSET,'UTF-8');
					}
				}
			}
		}
		return $result;
	}
	function _getStoreApp($store) {
		foreach ($GLOBALS[CFG][SYNC][STORES] as $app=>$val) {
			if ($val[store]==$store) return $app;
		}
		return 0;
	}
	function getReplace($Anchor,$query) {
		$result=array();
		return $result;
	}

	function getDelete($Anchor,$query) {
		$result=array();
		if ($this->_ms) {
			$mails=imap_search ($this->_ms,'UNDELETED',SE_UID);
			$query="SELECT LUID FROM SyncMaps  ";
			$query.=" WHERE SyncMaps.deviceID='".addslashes($this->_device_id)."'";
			$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
			$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
			if (is_array($mails) && count($mails)) $query.=" AND GUID NOT IN ('".implode("','",$mails)."')";
			$query.=' GROUP BY LUID';
			debug($query);
			$this->_db->query($query);
			while($this->_db->next_record()) {
				$result[]=$this->_db->f('LUID');
			}
		}
		return $result;
	}

};

?>
