<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
/*
 * A syncml-compatible class to handle vcard storage on a MySQL server
 *
 * (c) 2003 Nicolas Bougues, nicolas@bougues.net
 *
 * See the copyright file for licensing information.
 *
 */


class NotesMysql  {
	var $_db;
	var $_store;
	var $_device_id;
	var $_user_id;
	var $_fields;
	var $_user_names;
	var $_MaxGUIDSize=11;
	var $_SyncType=array(1,2);
	var $_send_report=2; //0: none 1:allways 2:only if conflict
	var $_caps = array(
		"text/plain" => array (
			"VERSION" => array ("V", "1.0"),
		),
	);
	function  NotesMysql($store,$display,&$db) {
		$this->_db=$db;
		$this->_store=$store;
		$this->_display=$display;
	}

	function init($user_id,$device_id,$user_lang,$prefs) {
		$this->_device_id=$device_id;
		$this->_user_id=$user_id;
		$this->_user_lang=$user_lang;
	}

	function get_ct() {
    		return ("text/plain");
  	}
	function getVersion() {
    		return $this->_caps[$this->get_ct()][VERSION][1];
  	}

  	function get_datastore_caps () {
		$datastore = & new XmlNode ("DataStore", NULL);
		$datastore->new_child ("SourceRef", NULL, $this->_store);
		$datastore->new_child ("DisplayName", NULL, $this->_display);
		$datastore->new_child ("MaxGUIDSize", NULL, $this->_MaxGUIDSize);
		$type="RxPref";
		foreach ($this->_caps as $CTType => $caps) {
			$rxp = & $datastore->new_child ($type, NULL);
			$rxp->new_child ("CTType", NULL, $CTType);
			$rxp->new_child ("VerCT", NULL, $caps[VERSION][1]);
			$type="Rx";
		}
		$type="TxPref";
		foreach ($this->_caps as $CTType => $caps) {
			$rxp = & $datastore->new_child ($type, NULL);
			$rxp->new_child ("CTType", NULL, $CTType);
			$rxp->new_child ("VerCT", NULL, $caps[VERSION][1]);
			$type="Tx";
		}
		$synccap = & $datastore->new_child ("SyncCap", NULL);
		foreach ($this->_SyncType as $val) {
			$synccap->new_child ("SyncType", NULL, $val);
		}
    		return $datastore;
  	}

  	function get_ctcaps (&$ctcap) {

  	}
	function getModfiyTime($GUID) {
		return 1;
	}
	function getPerms($GUID,$mode='') {
		return 1;
	}
	function getName($ID) {
		return '';

	}

	function compareData($GUID,$item,&$support) {
		return 0;
	}
	function checkData($item) {
		return 1;
	}
	function insertData($item,$LocalNextAnchor,&$support) {
		return -1;
	}

	function updateData($GUID,$item,$LocalNextAnchor,&$support) {
		return -1;
	}

	function deleteData($GUID) {
		return -1;
	}

	function getAdd($Anchor,$query) {
		global $t;
		$result=array();
		if ($this->_send_report) {
			$query="SELECT * FROM SyncConflict WHERE ";
			$query.="deviceID='".addslashes($this->_device_id)."' ";
			$query.="AND user_id='".addslashes($this->_user_id)."'";
			$query.="AND anchor=".intval($Anchor[LocalLastAnchor])."";
			$this->_db->query($query);
			while ($this->_db->next_record()) {
				$app=$this->_getStoreApp($this->_db->f('store'));
				if ($app) {
					if ($this->_db->f('conflict')==0) {
						$error=unserialize($this->_db->f('error'));
						if ($error[RecType]) {
							$all_conflicts[$app]['rec'][]=$this->_db->f('title1');
						}
						if ($error[ExDate]) {
							$all_conflicts[$app]['ex'][]=$this->_db->f('title1');
						}
					} elseif ($this->_db->f('conflict')==3) {
						if ($this->_db->f('title1')!=$this->_db->f('title2')) {
							$all_conflicts[$app][$this->_db->f('conflict')][]='1.'.$this->_db->f('title1')."\n2.".$this->_db->f('title2');
						} else {
							$all_conflicts[$app][$this->_db->f('conflict')][]=$this->_db->f('title1');
						}
					} else {
						$all_conflicts[$app][$this->_db->f('conflict')][]=$this->_db->f('title1');
					}
				}
			}
			debug("tpl/".$GLOBALS[THEME]."/sync/".$this->_user_lang);
			$t->setRoot("tpl/".$GLOBALS[THEME]."/sync/".$this->_user_lang);
			$t->define (array('tpl_memo' => "sync_memo.inc.html"));
			$t->assign('SYNC_TIME',date('d.m.Y H:i'));
			if (is_array($all_conflicts)) {
				foreach ($all_conflicts as $app => $conflicts) {
					foreach ($conflicts as $conflict=>$values) {
						$t->assign('VALUES',implode("\n",$values));
						if ($t->issetkey('conflict_'.$app.'_'.$conflict)) $t->parse('ROW','conflict_'.$app.'_'.$conflict);
					}
					if ($t->issetkey('sync_report_'.$app)) $t->parse('ROW','sync_report_'.$app);

				}
				$t->parse('MEMO','tpl_memo');
				$result[]=Framework::convertCharset($t->getParsed(),GE_CHARSET,'UTF-8');
			} elseif ($this->_send_report==1) {
				if ($t->issetkey('sync_report_'.$app)) $t->parse('ROW','sync_no_conflict');
				$t->parse('MEMO','tpl_memo');
				$result[]=Framework::convertCharset($t->getParsed(),GE_CHARSET,'UTF-8');
			}


		}
		return $result;
	}
	function _getStoreApp($store) {
		foreach ($GLOBALS['CFG']['SYNC']['STORES'] as $app=>$val) {
			if ($val['store']==$store) return $app;
		}
		return 0;
	}
	function getReplace($Anchor,$query) {
		$result=array();
		return $result;
	}

	function getDelete($Anchor,$query) {
		$result=array();
		return $result;
	}

};

?>
