<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class SyncDB {
	protected $_db;
	function SyncDB () {
		global $db,$frm;
		$this->_db=$db;
		$this->_frm=$frm;
	}
	function insertConflictResolution($store,$user_id,$resolution) {
		foreach($resolution as $conflict_type=>$conflict_res) {
			$query="REPLACE INTO SyncConflictResolution (store,user_id,conflict_type,conflict_res) VALUES (";
			$query.="'".addslashes($store)."',";
			$query.="'".addslashes($user_id)."',";
			$query.=intval($conflict_type).",";
			$query.=intval($conflict_res).")";
			$this->_db->query($query);
		}
	}
	function getConflictResolution($store,$user_id) {
		$result=array();
		$query="SELECT * FROM SyncConflictResolution WHERE ";
		$query.="store='".addslashes($store)."' ";
		$query.="AND user_id='".addslashes($user_id)."'";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('conflict_type')]=$this->_db->f('conflict_res');
		}
		return $result;
	}
	function insertSyncPrefs($store,$user_id,$prefs) {
		if (is_array($prefs)) {
			foreach($prefs as $key=>$val) {
				$query="REPLACE INTO SyncPrefs (store,user_id,name,value) VALUES (";
				$query.="'".addslashes($store)."',";
				$query.="'".addslashes($user_id)."',";
				$query.="'".addslashes($key)."',";
				$query.="'".addslashes($val)."')";
				$this->_db->query($query);
			}
		} else {
			$query="DELETE FROM SyncPrefs WHERE ";
			$query.="store='".addslashes($store)."' ";
			$query.="AND user_id='".addslashes($user_id)."'";
			$this->_db->query($query);
		}
	}
	function getSyncPrefs($store,$user_id) {
		$result=array();
		$query="SELECT * FROM SyncPrefs WHERE ";
		$query.="store='".addslashes($store)."' ";
		$query.="AND user_id='".addslashes($user_id)."'";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('name')]=$this->_db->f('value');
		}
		return $result;
	}
	function getLastSync($store,$user_id) {
		$query="SELECT LocalLastAnchor,SyncDevices.* FROM SyncAnchors,SyncDevices WHERE ";
		$query.="SyncAnchors.deviceID=SyncDevices.deviceID ";
		$query.="AND store='".addslashes($store)."' ";
		$query.="AND user_id='".addslashes($user_id)."'";
		$query.="AND syncType='ml'";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('deviceID')]=array(
				'anchor'=>	$this->_db->f('LocalLastAnchor'),
				'name'=>	$this->_db->f('deviceName'),
			);
		}
		return $result;
	}
	function getSyncConflicts($device,$store,$user_id) {
		$query="SELECT * FROM SyncConflict WHERE ";
		$query.="deviceID='".addslashes($device)."' ";
		$query.="AND store='".addslashes($store)."' ";
		$query.="AND user_id='".addslashes($user_id)."'";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('conflictID')]=array(
				'conflict'=>$this->_db->f('conflict'),
				'GUID1'=>$this->_db->f('GUID1'),
				'GUID2'=>$this->_db->f('GUID2'),
				'error'=>unserialize($this->_db->f('error')),
			);
		}
		return $result;

	}
	function deleteSyncConflict($conflictID,$user_id) {
		$query="DELETE FROM SyncConflict WHERE ";
		$query.="conflictID=".intval($conflictID)." ";
		$query.="AND user_id='".addslashes($user_id)."'";
		$this->_db->query($query);
	}
	function getFields($store) {
		$result=array();
		$query="SELECT * FROM  SyncFieldMaps WHERE Store='".addslashes($store)."'";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('Field');
		}
		return $result;
	}
	function listDevices($user_id) {
		$query="SELECT SyncDevices.*,MAX(LocalLastAnchor) as _lastSync FROM SyncDevices LEFT JOIN SyncAnchors ON (SyncAnchors.deviceID=SyncDevices.deviceID) WHERE ";
		$query.=" (SyncDevices.FKUserID='".addslashes($user_id)."' OR SyncAnchors.user_id='".addslashes($user_id)."')";
		$query.=" AND SyncDevices.deviceID!=''";
		$query.=" GROUP BY SyncDevices.deviceID,syncType";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$deviceData=unserialize($this->_db->f('deviceData'));
			$result[]=array(
				'id'=>$this->_db->f('deviceID'),
				'type'=>$this->_db->f('syncType'),
				'name'=>$this->_db->f('deviceName'),
				'lastsync'=>$deviceData['LastSync']?$deviceData['LastSync']:$this->_db->f('_lastSync'),
			);
		}
		return $result;
	}

}
?>