<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class SyncMysql {
	var $_data;
	var $_auth;
	var $_datastores;
	var $_db;
	var $_user_id;
	var $_user_lang;
	var $_sync_mode;
	var $anchors;
	var $_resolve_support=1;
	var $_prefs;
	function SyncMysql(&$db,$auth) {
		$this->_db=&$db;
		$this->_auth=$auth;
		//$this->_datastores=$datastores;
	}

	function newNextNonce($device) {
		$next_nonce=base64_encode(pack('H*',md5 (uniqid (rand()))));
		return $next_nonce;
	}
	function getNonce($device) {
		$query="SELECT nonce FROM SyncDevices WHERE deviceID='".addslashes($device)."' AND syncType='ml'";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('nonce');
		} else {
			return false;
		}

	}
	function updateDevice($device,$values) {
		foreach ($values as $key=>$val) {
			$update[]="$key='".addslashes($val)."'";
		}
		$query="UPDATE SyncDevices SET ".implode(',',$update)." WHERE deviceID='".addslashes($device)."'";
		$this->_db->query($query);
	}
	function insertDevice($device,$values) {
		$values=array_map('addslashes',$values);
		$query="REPLACE INTO SyncDevices (deviceID,".implode(',',array_keys($values)).",syncType,FKUserID) VALUES ('".addslashes($device)."','".implode("','",$values)."','ml',0)";
		$this->_db->query($query);
		return $device;
	}
	function getDeviceInfo($device) {
		$query="SELECT * FROM SyncDevices WHERE deviceID='".addslashes($device)."' AND syncType='ml'";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return array(
				'nonce'=>$this->_db->f('nonce'),
				'name'=>$this->_db->f('deviceName'),
				'data'=>unserialize($this->_db->f('deviceData')),
			);
		} else {
			return false;
		}
	}
	function checkAuthBasic($username, $password) {
		return $this->_auth->checkAuthBasic($username, $password);
	}
	function checkAuthMd5($username, $password, $nonce) {
		return $this->_auth->checkAuthMd5($username, $password, $nonce);
	}
	function getUserLang($user_id) {
		return $this->_auth->getUserLang($user_id);
	}

	function existsDatastore($store) {
		global $datastores;
		return isset($datastores[$store]);
	}
	function getAvDatastore($user_id) {
		if ($user_id) {
			$prefs=$this->getUserPrefs('all',$user_id);
			//debug($user_id);
			$result=getModellPrefs($prefs['modell'],'global');
			if (is_array($result['stores'])) return $result['stores'];
		}
		return array();
	}

	function getConflictResolution() {
		$result=array();
		$query="SELECT * FROM SyncConflictResolution WHERE ";
		$query.="store='".addslashes($this->_store)."' ";
		$query.="AND user_id='".addslashes($this->_user_id)."'";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('conflict_type')]=$this->_db->f('conflict_res');
		}
		return $result;
	}

	function getUserPrefs($store=null,$uid=null) {
		$result=array();
		if (!$store) $store=$this->_store;
		if (!$uid) $uid=$this->_user_id;
		$query="SELECT * FROM SyncPrefs WHERE ";
		$query.="(";
		$query.="store='".addslashes($store)."'";
		if ($store!='all') $query.=" OR store='all'";
		$query.=") ";
		$query.="AND user_id='".addslashes($uid)."'";
		//debug($query);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('name')]=$this->_db->f('value');
		}
		return $result;
	}
	function setUserPrefs($prefs,$store=null,$uid=null) {
		if (!$store) $store=$this->_store;
		if (!$uid) $uid=$this->_user_id;
		foreach($prefs as $key=>$val) {
			$query="REPLACE INTO SyncPrefs (store,user_id,name,value) VALUES (";
			$query.="'".addslashes($store)."',";
			$query.="'".addslashes($uid)."',";
			$query.="'".addslashes($key)."',";
			$query.="'".addslashes($val)."')";
			$this->_db->query($query);
			debug('SETPREFS QUERY:'.$query);
		}
	}

	function getCt() {
		global $datastores;
		return $datastores[$this->_store]->get_ct();
	}
 	function startSync ($store, $device_id,$user_id,$user_lang) {
		global $datastores;
		debug ('START_SYNC:'.$store.':'.$device_id.':'.$user_id.':'.$user_lang);
		if ($this->existsDatastore($store) && $user_id) {
			$this->_device_id=$device_id;
			$this->_store=$store;
			$this->_user_id=$user_id;
			$this->_user_lang=$user_lang;
			debug ('START_SYNC_OK:'.$this->_store.':'.$this->_device_id.':'.$this->_user_id);
			if (!isset($this->_resolution[$this->_store])) {
				$this->_resolution[$this->_store]=$this->getConflictResolution();
			}
			if (!isset($this->_prefs[$this->_store])) {
				$this->_prefs[$this->_store]=$this->getUserPrefs();
			}
			$datastores[$this->_store]->init($this->_user_id,$this->_device_id,$this->_user_lang,$this->_prefs[$this->_store]);
			return true;
		} else return false;
    }
	function setSyncMode($sync_mode) {
		debug('SET_SYNC_MODE:'.$sync_mode);
		$this->_sync_mode=$sync_mode;
	}
	function getAnchors($RemoteNextAnchor) {
		$query="SELECT * FROM SyncAnchors WHERE ";
		$query.="deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND store='".addslashes($this->_store)."'";
		$query.=" AND user_id='".addslashes($this->_user_id)."'";
		debug($query);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$LocalLastAnchor=$this->_db->f('LocalLastAnchor');
			$RemoteLastAnchor=$this->_db->f('RemoteLastAnchor');
		} else {
			$LocalLastAnchor=0;
			$RemoteLastAnchor=0;
		}
		$LocalNextAnchor=time();
		$this->anchors[$this->_store]=array(
			'LocalLastAnchor'=>$LocalLastAnchor,
			'RemoteLastAnchor'=>$RemoteLastAnchor,
			'LocalNextAnchor'=>$LocalNextAnchor,
			'RemoteNextAnchor'=>$RemoteNextAnchor,
		);
		return $this->anchors[$this->_store];
	}

	function updateAnchors() {
		$query="REPLACE INTO SyncAnchors (deviceID,store,user_id,LocalLastAnchor,RemoteLastAnchor) VALUES (";
		$query.="'".addslashes($this->_device_id)."',";
		$query.="'".addslashes($this->_store)."',";
		$query.="'".addslashes($this->_user_id)."',";
		$query.="'".addslashes($this->anchors[$this->_store]['LocalNextAnchor'])."',";
		$query.="'".addslashes($this->anchors[$this->_store]['RemoteNextAnchor'])."')";
		debug($query);
		$this->_db->query($query);
    }

	function clearMaps() {
		$query="UPDATE SyncMaps SET OK=0 WHERE ";
		$query.="deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND store='".addslashes($this->_store)."'";
		$query.=" AND user_id='".addslashes($this->_user_id)."'";
		$this->_db->query($query);
	}
 	function _setMapsOK($LUID,$OK=1) {
		$query="UPDATE SyncMaps SET OK=$OK WHERE ";
		$query.="deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND store='".addslashes($this->_store)."'";
		$query.=" AND user_id='".addslashes($this->_user_id)."'";
		$query.=" AND LUID='".addslashes($LUID)."'";
		$this->_db->query($query);
	}
	function _deleteGUID($LUID) {
		$query="DELETE FROM SyncMaps WHERE ";
		$query.="deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND store='".addslashes($this->_store)."'";
		$query.=" AND user_id='".addslashes($this->_user_id)."'";
		if (is_array($LUID)) $query.=" AND LUID IN ('".implode("','",array_map('addslashes',$LUID))."')";
		else $query.=" AND LUID='".addslashes($LUID)."'";
		$this->_db->query($query);
	}
	function _deleteAllGUID() {
		$query="DELETE FROM SyncMaps WHERE ";
		$query.="deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND store='".addslashes($this->_store)."'";
		$query.=" AND user_id='".addslashes($this->_user_id)."'";
		$this->_db->query($query);
	}
	function _deleteNonOK() {
		$query="DELETE FROM SyncMaps WHERE ";
		$query.="deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND store='".addslashes($this->_store)."'";
		$query.=" AND user_id='".addslashes($this->_user_id)."'";
		$query.=" AND OK=0";
		$this->_db->query($query);
	}
	function _deleteLUID($GUID) {
		$query="DELETE FROM SyncMaps WHERE ";
		$query.="deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND store='".addslashes($this->_store)."'";
		$query.=" AND user_id='".addslashes($this->_user_id)."'";
		if (is_array($GUID)) $query.=" AND GUID IN ('".implode("','",array_map('addslashes',$GUID))."')";
		else $query.=" AND GUID='".addslashes($GUID)."'";
		$this->_db->query($query);
	}
	function _insertGUID($LUID,$GUID,$OK=1) {
		$query="REPLACE INTO SyncMaps (deviceID,store,user_id,LUID,GUID,OK) VALUES (";
		$query.="'".addslashes($this->_device_id)."',";
		$query.="'".addslashes($this->_store)."',";
		$query.="'".addslashes($this->_user_id)."',";
		$query.="'".addslashes($LUID)."',";
		$query.="'".addslashes($GUID)."',";
		$query.=$OK.")";
		$this->_db->query($query);
		return 1;
	}
	//return status 0:not exists 1:exists 2:deleted
	function _checkGUID ($LUID,$mode='') {
		global $datastores;
		$query="SELECT GUID FROM SyncMaps WHERE ";
		$query.="deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND store='".addslashes($this->_store)."'";
		$query.=" AND user_id='".addslashes($this->_user_id)."'";
		$query.=" AND LUID='".addslashes($LUID)."'";
		//debug($query);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			// exists
			$GUID=$this->_db->f('GUID');
			if ($modified=$datastores[$this->_store]->getModfiyTime($GUID)) {
				$status=1;
				$perms=$datastores[$this->_store]->getPerms($GUID,$mode);
			} else {
				//deleted on server
				$modified=0;
				$status=2;
				$perms=1;
			}
		} else {
			// not exists
			$perms=1;
			$GUID=0;
			$modified=0;
			$status=0;
		}
		return array(
			'GUID'=>$GUID,
			'Modified'=>$modified,
			'Status'=>$status,
			'Perms'=>$perms,
		);

	}
	function SyncMapItem($GUID,$LUID) {
		 return $this->_insertGUID($LUID,$GUID,1);
	}
	function _deleteConflict($conflict=-1,$GUID1=-1,$GUID2=-1) {
		$query="DELETE FROM SyncConflict WHERE ";
		$query.="deviceID='".addslashes($this->_device_id)."' ";
		$query.="AND store='".addslashes($this->_store)."' ";
		$query.="AND user_id='".addslashes($this->_user_id)."' ";
		if ($conflict!=-1) $query.="AND conflict='".addslashes($conflict)."' ";
		if ($GUD1!=-1) $query.="AND GUID1='".addslashes($GUID1)."' ";
		if ($GUID2!=-1) $query.="AND GUID2='".addslashes($GUID2)."' ";
		$this->_db->query($query);

	}
	function _insertConflict($conflict,$GUID1,$GUID2=0,$error='',$title1='',$title2='') {
		$query="INSERT INTO SyncConflict (deviceID,store,user_id,conflict,GUID1,GUID2,error,title1,title2,anchor) VALUES (";
		$query.="'".addslashes($this->_device_id)."',";
		$query.="'".addslashes($this->_store)."',";
		$query.="'".addslashes($this->_user_id)."',";
		$query.="'".addslashes($conflict)."',";
		$query.="'".addslashes($GUID1)."',";
		$query.="'".addslashes($GUID2)."',";
		$query.="'".addslashes($error)."',";
		$query.="'".addslashes($title1)."',";
		$query.="'".addslashes($title2)."',";
		$query.="'".$this->anchors[$this->_store]['LocalLastAnchor']."')";

		$this->_db->query($query);
		return 1;
	}
	function clearConflicts() {
		$query="DELETE FROM SyncConflict WHERE ";
		$query.="deviceID='".addslashes($this->_device_id)."'";
		$query.="AND store='".addslashes($this->_store)."'";
		$query.="AND user_id='".addslashes($this->_user_id)."'";
		$this->_db->query($query);
	}
	function SyncAdd($LUID,$item,$GUID=false,$isReplace=false) {
		global $datastores;
		if ($this->_sync_mode==10) {
			//Reload Client delete Item on Client
			$this->_deleteItems[$this->_store][]=$LUID;
			return 419;
		}
		if (!$GUID) $GUID=$this->_checkGUID($LUID,'update');
		debug ('ADD:'.$LUID.':Status:'.$GUID['Status'].'Store:'.$this->_store);

		if ($GUID['Status']==1) {
			$this->_deleteConflict(-1,$GUID['GUID'],-1);
			if ($compare=$datastores[$this->_store]->compareData($GUID['GUID'],$item,$support)) {
				if ($GUID['Perms'] && $compare!=2) {
					// conflict  already exists on server
					if ($GUID['Modified'] > $this->anchors[$this->_store]['LocalLastAnchor']) {
						// conflict modified on server to
						//insert client Data - duplicate Entry
						switch (intval($this->_resolution[$this->_store][3])) {
							case '0':
								debug('CONFLICT:duplicate');
								if ($this->_sync_mode!=1 && $this->_sync_mode!=10) {
									$NGUID=$datastores[$this->_store]->insertData($item,$this->anchors[$this->_store]['LocalNextAnchor'],$support);
									if ($NGUID) {
										if ($NGUID!=-1) {
											$this->_deleteGUID($LUID);

											$this->_insertConflict(3,$GUID[GUID],$NGUID,'',$datastores[$this->_store]->getName($GUID['GUID']),$datastores[$this->_store]->getName(-1));
											if ($support) {
												$this->_insertGUID($LUID,$NGUID,$this->_resolve_support);
												$this->_insertConflict(0,$NGUID,0,serialize($support),$datastores[$this->_store]->getName(-1));
											} else {
												$this->_insertGUID($LUID,$NGUID,1);
											}
										}
											//SET CONFLICT
											//duplicate data
										return 209;
									}
								} else {
									$this->_setMapsOK($LUID,-1);
									// Server Wins
									return 419;
								}
							break;
							case '1':
								debug('CONFLICT:client wins update');
								if ($datastores[$this->_store]->updateData($GUID['GUID'],$item,$this->anchors[$this->_store]['LocalNextAnchor'],$support)) {
									if ($support) {
										$this->_insertConflict(0,$GUID[GUID],0,serialize($support),$datastores[$this->_store]->getName(-1));
										$this->_setMapsOK($LUID,$this->_resolve_support);
									} else {
										$this->_setMapsOK($LUID,1);
									}
									//Client Wins
									return 208;
								}
							break;
							case '2':
								debug('CONFLICT:server wins update');
								//Server Wins
								return 419;
							break;
						}
					} else {
						if ($datastores[$this->_store]->updateData($GUID['GUID'],$item,$this->anchors[$this->_store]['LocalNextAnchor'],$support)) {
							if ($support) {
								$this->_insertConflict(0,$GUID[GUID],0,serialize($support),$datastores[$this->_store]->getName(-1));
								$this->_setMapsOK($LUID,$this->_resolve_support);
							} else {
								$this->_setMapsOK($LUID,1);
							}
							//OK
							if ($isReplace) return 200; else return 201;
						}
					}
				} elseif ($compare==2) {
					if ($datastores[$this->_store]->updateData($GUID['GUID'],$item,$this->anchors[$this->_store]['LocalNextAnchor'],$support)) {
						$this->_setMapsOK($LUID,1);
						//Server Wins
						return 419;
					}
				} else {
					$this->_setMapsOK($LUID,-1);
					debug('NO PERMS:reenter on client');
					//Server Wins
					return 419;
				}
			} else {
				if ($support) {
					$this->_insertConflict(0,$GUID['GUID'],0,serialize($support),$datastores[$this->_store]->getName(-1));
					$this->_setMapsOK($LUID,$this->_resolve_support);
				} else {
					$this->_setMapsOK($LUID,1);
				}
				if ($isReplace) return 200; else return 201;
			}

		} elseif ($GUID['Status']==2) {
			if ($datastores[$this->_store]->checkData($item)) {
				//deleted on server
				switch (intval($this->_resolution[$this->_store][2])) {
					case '0':
						debug('CONFLICT:client wins add - manual');
						$GUID=$datastores[$this->_store]->insertData($item,$this->anchors[$this->_store]['LocalNextAnchor'],$support);
						if ($GUID) {
							if ($GUID!=-1) {
								$this->_deleteGUID($LUID);
								//SET CONFLICT
								if ($this->_sync_mode!=1 && $this->_sync_mode!=10) {
									$this->_insertConflict(2,$GUID,0,'',$datastores[$this->_store]->getName(-1));
									// conflict deleted on server modified on client
								}
								if ($support) {
									$this->_insertConflict(0,$GUID,0,serialize($support),$datastores[$this->_store]->getName(-1));
									$this->_insertGUID($LUID,$GUID,$this->_resolve_support);
								} else {
									$this->_insertGUID($LUID,$GUID,1);
								}
							}
							// Client wins
							return 208;
						}
					break;
					case '1':
						debug('CONFLICT:client wins add');
						$GUID=$datastores[$this->_store]->insertData($item,$this->anchors[$this->_store]['LocalNextAnchor'],$support);
						if ($GUID) {
							if ($GUID!=-1) {
								$this->_deleteGUID($LUID);
								if ($support) {
									$this->_insertConflict(0,$GUID,0,serialize($support),$datastores[$this->_store]->getName(-1));
									$this->_insertGUID($LUID,$GUID,$this->_resolve_support);
								} else {
									$this->_insertGUID($LUID,$GUID,1);
								}
							}
							//Client Wins
							return 208;
						}
					break;
					case '2':
						debug('CONFLICT:server wins delete');
						//Server Wins
						return 419;
					break;
				}
			} else {
				return 419;
			}
		} else {
			// not exist
			$GUID=$datastores[$this->_store]->insertData($item,$this->anchors[$this->_store]['LocalNextAnchor'],$support);
			if ($GUID) {
				if ($GUID!=-1) {
					if ($support) {
						$this->_insertConflict(0,$GUID,0,serialize($support),$datastores[$this->_store]->getName(-1));
						$this->_insertGUID($LUID,$GUID,$this->_resolve_support);
					} else {
						$this->_insertGUID($LUID,$GUID,1);
					}
				}
				// OK
				return 201;
			}
		}
		// Failed
		return 500;
	}

	function SyncReplace ($LUID, $item) {
		debug ('REPLACE:'.$LUID);
		return $this->SyncAdd ($LUID, $item,false,true);
	}

	function SyncDelete($LUID,$null=0) {
		global $datastores;
		if ($this->_sync_mode==10) {
			return 419;
		}
		$GUID=$this->_checkGUID($LUID,'delete');
		if ($GUID['Status']==0) {
			// not exists;
			return 211;
		} elseif ($GUID['Status']==1) {
			// exists
			$this->_deleteConflict(-1,$GUID['GUID'],-1);
			debug('MODiFY:'.$GUID['Modified'].'-'.$this->anchors[$this->_store]['LocalLastAnchor']);
			if ($GUID['Perms']) {
				if ($GUID['Modified'] > $this->anchors[$this->_store]['LocalLastAnchor']) {
					// conflict deleted on client modified on server
					switch (intval($this->_resolution[$this->_store][1])) {
						case '0':
							debug('CONFLICT:reenter on client - manual');
							//do not delete update on client
							//SET CONFLICT
							$this->_insertConflict(1,$GUID[GUID],0,$datastores[$this->_store]->getName($GUID[GUID]));
							$this->_deleteGUID($LUID);
							// Server Wins
							return 419;
						break;
						case '1':
							debug('CONFLICT:client wins delete');
							if ($datastores[$this->_store]->deleteData($GUID[GUID])) {
								$this->_deleteGUID($LUID);
								//Client Wins
								return 208;
							}
						break;
						case '2':
							debug('CONFLICT:server wins add');
							$this->_deleteGUID($LUID);
							//do not delete reenter on client
							//Server Wins
							return 419;
						break;
					}

				} else {
					if ($datastores[$this->_store]->deleteData($GUID['GUID'])) {
						$this->_deleteGUID($LUID);
						//OK
						return 200;
					}
				}
			} else {
				$this->_deleteGUID($LUID);
				//Server Wins
				debug('NO PERMS:reenter on client');
				return 419;
			}
		} elseif ($GUID['Status']==2) {
			// deleted on server to
			$this->_deleteGUID($LUID);
			//OK
			return 200;
		}
		// Failed
		return 500;
	}


	function SyncGetAdd($query) {
		global $datastores;
		return $datastores[$this->_store]->getAdd($this->anchors[$this->_store],$query);
	}
	function SyncGetReplace() {
		global $datastores;
		//debug ('REPLACE:'.$this->_store.':'.$this->_device_id.':'.$this->_user_id);
		return $datastores[$this->_store]->getReplace($this->anchors[$this->_store],$query);
	}
	function SyncGetDelete() {
		global $datastores;
		$deleteIds=$datastores[$this->_store]->getDelete($this->anchors[$this->_store],$query);
		if (!empty($this->_deleteItems[$this->_store])) {
			foreach ($this->_deleteItems[$this->_store] as $val) {
				debug('DELETE SYNCMODE 10:'.$val);
				$deleteIds[]=$val;
			}
		}
		return $deleteIds;
	}
	function getNumConflicts() {
		$query="SELECT COUNT(*) as num FROM SyncConflict WHERE ";
		$query.="deviceID='".addslashes($this->_device_id)."'";
		$query.="AND store='".addslashes($this->_store)."'";
		$query.="AND user_id='".addslashes($this->_user_id)."'";
		$this->_db->query($query);
		$this->_db->next_record();
		return $this->_db->f('num');

	}
 	 // Function called when the sync process is over. Save the new anchors.
  	function endSync ($del_items) {
		debug ('SYNC_END:'.$this->_store.':'.$this->_device_id.':'.$this->_user_id);
		$this->updateAnchors();
		if ($del_items) {
			$this->_deleteGUID($del_items);
		}
    }
};

?>
