<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class SyncCred {
  	var $_meta_format;
  	var $_meta_type;
  	var $_data;
  	function SyncCred ($xml) {
    		$this->_data = $xml->get_data ("Data");
    		$this->_meta_format = $xml->get_data ("Meta/Format");
    		$this->_meta_type = $xml->get_data ("Meta/Type");
  	}
  	function getData() {
		if ($this->_meta_format=='b64' || !$this->_meta_format) {
		//if ($this->_meta_format=='b64' ) {
    			return base64_decode($this->_data);
		} else {
			return $this->_data;
		}
  	}
	function getMType() {
		return $this->_meta_type;
	}
};
class SyncHeader {
  	var $_fields;
  	var $_cred;
	function SyncHeader ($xml) {
    		$this->_fields["VerDTD"] = $xml->get_data("VerDTD");
    		$this->_fields["VerProto"] = $xml->get_data("VerProto");
    		$this->_fields["SessionID"] = $xml->get_data("SessionID");
    		$this->_fields["MsgID"] = $xml->get_data("MsgID");
    		$this->_fields["Target_LocURI"] = $xml->get_data("Target/LocURI");
    		$this->_fields["Source_LocURI"] = $xml->get_data("Source/LocURI");
			$this->_fields["Source_LocName"] = $xml->get_data("Source/LocName");
    		$this->_fields["Meta_MaxMsgSize"] = $xml->get_data("Meta/MaxMsgSize");
			$this->_fields["Meta_MaxObjSize"] = $xml->get_data("Meta/MaxObjSize");
    		if ($xml->get_child ("Cred")) {
      			$this->_cred = new SyncCred ($xml->get_child ("Cred"));
    		}
 	}
  	function getField ($name) {
    		return $this->_fields[$name];
  	}
  	function &getCred () {
    		return $this->_cred;
  	}
};

class SyncSession {
  	var $_datastores;
  	var $_rcvd_msg_id;
  	var $_next_msg_id; // ID of the next message we'll send
  	var $_next_cmd_id;
  	var $_syncml_version;
  	var $_authenticated;
  	var $_auth_lang;
  	var $_username;
  	var $_password;
  	var $_session_id;
  	var $_target_uri;
  	var $_source_uri;
	var $_devinf;
	var $_conflicts;
	var $auth_mode=array('syncml:auth-basic');
	var $syncStarted= NULL;
	var $syncmode;
	var $more_messages=0;
	var $maxMsgSize=10000;
	var $maxObjSize=10000;
	var $myMaxMsgSize=100000;
	var $myMaxObjSize=150000;
	var $_max_version='1.1';
	var $_startedStore=array();
	function SyncSession ($Sync) {
		$this->_Sync = $Sync;
		$this->_rcvd_msg_id = 0;
		$this->_next_msg_id = 1;
		$this->_next_cmd_id = 1;
		$this->_authenticated = 0;
		$this->_all_response = 0;
	}
	function getVersion() {
		return ($this->_syncml_version);
	}
	function getUserLang() {
		return $this->_auth_lang;
	}
	function getUserID() {
		return $this->_authenticated;
	}
	function getUserName() {
		return $this->_username;
	}
	function getUserPwd() {
		return $this->_password;
	}
	function getAnchors($store) {
		return $this->anchors[$store];
	}
	function getNumConflicts($store=0) {
		if ($store) {
			return intval($this->_conflicts[$store]);
		} else {
			return $this->_conflicts;
		}
	}
	function setStoreStarted($store) {
		$this->_startedStore[$store]=true;
	}
	function isStoreStarted($store) {
		return $this->_startedStore[$store];
	}

	function makeChal(&$response,$type,$next_nonce='') {
		$chal = &$response->new_child ("Chal", NULL);
		$meta =  &$chal->new_child ("Meta", NULL);
		$meta->new_child ("Type", array('xmlns'=>'syncml:MetInf'), $type);
		$meta->new_child ("Format", array('xmlns'=>'syncml:MetInf'), 'b64');
		if ($next_nonce) {
			$meta->new_child ("NextNonce", array('xmlns'=>'syncml:MetInf'),$next_nonce);
		}
	}
	function parseHeader ($header, &$response_tree) {
		$this->addFinal=false;
		$this->preMsgFinal=false;
		$this->_syncml_version = $header->getField("VerDTD");
		//if ($this->_syncml_version > $this->_max_version) $this->_syncml_version = $this->_max_version;
		$this->_rcvd_msg_id = $header->getField("MsgID");
		$this->_session_id = $header->getField("SessionID");
		$this->_target_uri = $header->getField("Target_LocURI");

		//$this->_target_uri = $_SERVER['SCRIPT_URI'];


		$this->_source_uri = $header->getField("Source_LocURI");
		$this->_loc_name = $header->getField("Source_LocName");
		if ($header->getField("Meta_MaxMsgSize")) $this->maxMsgSize = $header->getField("Meta_MaxMsgSize")-1000;
		$this->_next_cmd_id = 1;
		if (!$this->_devinf) $this->_devinf=$this->_Sync->getDeviceInfo($this->_source_uri);

		$response = & $response_tree->new_child ("Status", NULL);
		$response->new_child ("CmdID", NULL, $this->_next_cmd_id++);
		$response->new_child ("MsgRef", NULL, $this->_rcvd_msg_id);
		$response->new_child ("CmdRef", NULL, 0);
		$response->new_child ("Cmd", NULL, "SyncHdr");
		$response->new_child ("TargetRef", NULL,$header->getField("Target_LocURI"));
		$response->new_child ("SourceRef", NULL, $this->_source_uri);
		$this->_all_response = 0;
		if ($this->_authenticated) {
			$GLOBALS['frm']->setUser($this->_authenticated);
			$response->new_child ("Data", NULL, 200);
		} else {
			$this->more_messages+=1;
			if (!$header->getCred()) {
				if (in_array('syncml:auth-md5',$this->auth_mode)) {
					$next_nonce=$this->_Sync->newNextNonce($this->_source_uri);
					if ($this->_devinf) {
						$this->_Sync->updateDevice($this->_source_uri,array('nonce'=>$next_nonce));
					} else {
						$this->_Sync->insertDevice($this->_source_uri,array('nonce'=>$next_nonce));
					}
					$this->_devinf['nonce']=$next_nonce;
					$mode='syncml:auth-md5';
				} else {
					$next_nonce='';
					$mode='syncml:auth-basic';
				}
				$this->makeChal($response,$mode,$next_nonce);
				$response->new_child ("Data", NULL, 407);
				$this->_all_response=407;
			} else {
				// Try to authenticate
				$cred = & $header->getCred();
				if ($cred->getMType()=='syncml:auth-basic') {
					$colon_ofs = strcspn ($cred->getData(), ":");
					$this->_username = substr ($cred->getData(), 0, $colon_ofs);
					if (GE_userDomainSuffix && $GLOBALS['CFG']['USER_CLASS']=='ldap_full') $this->_username=$this->_username.'_'.GE_userDomainSuffix;
					$this->_password = substr ($cred->getData(), $colon_ofs + 1,strlen ($cred->getData()) - $colon_ofs - 1);
					if ($this->_authenticated = $this->_Sync->checkAuthBasic ($this->_username, $this->_password)) {
						$this->_auth_lang=$this->_Sync->getUserLang($this->_authenticated);
						$this->_syncPrefs=$this->_Sync->getUserPrefs('all',$this->_authenticated);
						$GLOBALS['frm']->setUser($this->_authenticated);
						$response->new_child ("Data", NULL, 212); //Authorized for session
					} else {
						$response->new_child ("Data", NULL, 401); // Unauthorized
						$this->_all_response=401;

					}
				} elseif ($cred->getMType()=='syncml:auth-md5') {
					if (in_array('syncml:auth-md5',$this->auth_mode)) {
						if ($this->_devinf) $next_nonce=$this->_devinf['nonce'];
						else $next_nonce='';
						$mode='syncml:auth-md5';
					} else {
						$next_nonce='';
						$mode='syncml:auth-basic';
					}
					if (!$next_nonce) {
						if (in_array('syncml:auth-md5',$this->auth_mode)) {
							$next_nonce=$this->_Sync->newNextNonce($this->_source_uri);
							if ($this->_devinf) {
								$this->_Sync->updateDevice($this->_source_uri,array('nonce'=>$next_nonce));
							} else {
								$this->_Sync->insertDevice($this->_source_uri,array('nonce'=>$next_nonce));
								$this->_devinf['nonce']=$next_nonce;
							}
						}
						$this->makeChal($response,$mode,$next_nonce);
						$response->new_child ("Data", NULL, 407);
						$this->_all_response=407;
					} else {
						$this->_username =$this->_loc_name;
						if (GE_userDomainSuffix && $GLOBALS['CFG']['USER_CLASS']=='ldap_full') $this->_username=$this->_username.'_'.GE_userDomainSuffix;
						$this->_password =$cred->getData();
						$this->_next_nonce=$next_nonce;
						if ($this->_authenticated = $this->_Sync->checkAuthMd5 ($this->_username, $this->_password,$this->_next_nonce)) {
							$GLOBALS['frm']->setUser($this->_authenticated);
							$this->_auth_lang=$this->_Sync->getUserLang($this->_authenticated);
							$this->_syncPrefs=$this->_Sync->getUserPrefs('all',$this->_authenticated);
							$next_nonce=$this->_Sync->newNextNonce($this->_source_uri);
							$this->_Sync->updateDevice($this->_source_uri,array('nonce'=>$next_nonce));
							$this->_devinf['nonce']=$next_nonce;
							$this->makeChal($response,'syncml:auth-md5',$next_nonce);
							$response->new_child ("Data", NULL, 212); //Authorized for session
						} else {
							$response->new_child ("Data", NULL, 401); // Unauthorized
							$this->_all_response=401;
						}
					}

				} else {
					$response->new_child ("Data", NULL, 401); // Unauthorized
					$this->_all_response=401;
				}
			}
		}
	}

  	function makeHeader (&$header,$session_id=0) {
		//if ($session_id) $this->_target_uri=$_SERVER['SCRIPT_URI'].'?session_id='.$session_id;
		$header->new_child ("VerDTD", NULL, $this->_syncml_version);
		$header->new_child ("VerProto", NULL,"SyncML/" . $this->_syncml_version);
		$header->new_child ("SessionID", NULL, $this->_session_id);
		$header->new_child ("MsgID", NULL, $this->_next_msg_id++);
		$target = &$header->new_child ("Target", NULL);
		$source = &$header->new_child ("Source", NULL);
		$source->new_child ("LocURI", NULL, $this->_target_uri);
		$target->new_child ("LocURI", NULL, $this->_source_uri);
		if ($session_id) {
			$header->new_child ("RespURI", NULL, $this->_target_uri.'?session_id='.$session_id);
		} else {
			$header->new_child ("RespURI", NULL, $this->_target_uri);
		}
		$meta = &$header->new_child ("Meta", NULL);
		$meta->new_child ("MaxMsgSize", array('xmlns'=>'syncml:MetInf'), $this->myMaxMsgSize);

  	}

  	function handleCommand ($xml_command, &$response_tree, $msgsize=0) {
		switch ($xml_command->get_name()) {
			case "Put":
				$this->handleCommandPut ($xml_command, $response_tree);
			break;
			case "Get":
				$this->handleCommandGet ($xml_command, $response_tree);
			break;
			case "Alert":
				$this->handleCommandAlert ($xml_command, $response_tree, $msgsize);
			break;
			case "Sync":
				$this->handleCommandSync ($xml_command, $response_tree, $msgsize);
			break;
			case "Map":
				$this->handleCommandMap ($xml_command, $response_tree);
			break;
			case "Status":
				$this->handleCommandStatus ($xml_command, $response_tree);
			break;
			case "Results":
				$this->handleCommandResults ($xml_command, $response_tree);
			break;
			case "Final":
				$this->handleCommandFinal ($xml_command, $response_tree);
			break;
			default:
				debug ("Unknown SyncML command " . $xml_command->get_name());
		}
  	}
	function handleDevInf(&$data) {

		debug ('DATA_DEVINF');
		if ($this->_devinf) $update=1;

		$this->_devinf['name']=$data->get_data('DevID');
		if ($data->get_child ('SupportNumberOfChanges')) $this->_devinf['data']['SupportNumberOfChanges']=1; else $this->_devinf['data']['SupportNumberOfChanges']=0;
		if ($data->get_child ('SupportLargeObjs')) $this->_devinf['data']['SupportLargeObjs']=1; else $this->_devinf['data']['SupportLargeObjs']=0;

		$dataStores=$GLOBALS['syncxml']->searchNode($data,'DataStore');
		if (is_array($dataStores)) {
			foreach ($dataStores as $child) {
				$store=$child->get_data('SourceRef');
				debug('DEVINF_DATASTORE:'.$store);
				$syncCap=$GLOBALS['syncxml']->searchNode($child,'SyncCap/SyncType');
				if (is_array($syncCap)) {
					foreach ($syncCap as $syncType) {
						debug('SYNCCAP:'.intval($syncType->get_data()));
						 $this->_devinf['data'][$store]['syncCap'][]=intval($syncType->get_data());
					}
				}
			}
		}



		if ($update) {
			$this->_Sync->updateDevice($this->_source_uri,array('deviceName'=>$data->get_data('DevID'),'deviceData'=>serialize($this->_devinf['data'])));
		} else {
			$this->_Sync->insertDevice($this->_source_uri,array('deviceName'=>$data->get_data('DevID'),'deviceData'=>serialize($this->_devinf['data'])));
		}



		foreach ($this->_devinf['data'] as $key=>$val) {
			debug ('DEV_INF:'.$key.'-'.$val);
		}
	}
	function handleCommandPut ($xml_command, &$response_tree) {
		debug ('PUT');
		$this->more_messages+=1;
		$response = & $response_tree->new_child ("Status", NULL);
		$response->new_child ("CmdID", NULL,$this->_next_cmd_id++);
		$response->new_child ("MsgRef", NULL,$this->_rcvd_msg_id);
		$response->new_child ("CmdRef", NULL,$xml_command->get_data ("CmdID"));
		$response->new_child ("Cmd", NULL, "Put");
		if (substr ($xml_command->get_data ("Item/Source/LocURI"),0, 9) == "./devinf1") {
			$data=$xml_command->get_child('Item/Data/DevInf');
			$this->handleDevInf($data);


		}
		if ($this->_all_response) {
			$response->new_child ("Data", NULL, $this->_all_response);
		} else {
			if ($xml_command->get_data ("Item/Target/LocURI"))
				$response->new_child ("TargetRef", NULL,$xml_command->get_data ("Item/Target/LocURI"));

			if ($xml_command->get_data ("Item/Source/LocURI"))
				$response->new_child ("SourceRef", NULL,$xml_command->get_data ("Item/Source/LocURI"));

			$response->new_child ("Data", NULL, 200);
		}

	}
	function handleCommandGet ($xml_command, &$response_tree) {
		$this->more_messages+=1;
		$response = & $response_tree->new_child ("Status", NULL);

		$response->new_child ("CmdID", NULL, $this->_next_cmd_id++);
		$response->new_child ("MsgRef", NULL, $this->_rcvd_msg_id);
		$response->new_child ("CmdRef", NULL,$xml_command->get_data ("CmdID"));
		$response->new_child ("Cmd", NULL, "Get");
		if ($this->_all_response) {
			$response->new_child ("Data", NULL, $this->_all_response);
		} else {
			if ($xml_command->get_data ("Item/Target/LocURI"))
				$response->new_child ("TargetRef", NULL,$xml_command->get_data ("Item/Target/LocURI"));

			if ($xml_command->get_data ("Item/Source/LocURI"))
				$response->new_child ("SourceRef", NULL,$xml_command->get_data ("Item/Source/LocURI"));

			// What does the client want ?

			if (substr ($xml_command->get_data ("Item/Target/LocURI"),0, 9) == "./devinf1") {
				$response->new_child ("Data", NULL, 200);

				$response = & $response_tree->new_child ("Results", NULL);
				$response->new_child ("CmdID", NULL, $this->_next_cmd_id++);
				$response->new_child ("MsgRef", NULL, $this->_rcvd_msg_id);
				$response->new_child ("CmdRef", NULL,$xml_command->get_data ("CmdID"));
				$meta = & $response->new_child ("Meta", NULL);
				if ($GLOBALS['WBXML']) {
					$meta->new_child ("Type", array ("xmlns" => "syncml:MetInf"),"application/vnd.syncml-devinf+wbxml");
				} else {
					$meta->new_child ("Type", array ("xmlns" => "syncml:MetInf"),"application/vnd.syncml-devinf+xml");
				}
				$item = & $response->new_child ("Item", NULL);
				$source = & $item->new_child ("Source", NULL);
				$source->new_child ("LocURI", NULL,$xml_command->get_data ("Item/Target/LocURI"));

				$data = & $item->new_child ("Data", NULL);
				$devinf = & $data->new_child ("DevInf",array ("xmlns" => "syncml:DevInf"));

				$devinf->new_child ("VerDTD", NULL, $this->_syncml_version);
				$devinf->new_child ("Man", NULL, "Endo7 GmbH");
				$devinf->new_child ("Mod", NULL, "Groupie Sync Server 1.0");
				$devinf->new_child ("OEM", NULL, "Endo7 GmbH");
				$devinf->new_child ("SwV", NULL, "1.0");
				$devinf->new_child ("DevID", NULL, "Endo7 SyncServer");
				$devinf->new_child ("DevTyp", NULL, "server");
				if ($this->_syncml_version!='1.0') {
					$devinf->new_child ("UTC", NULL, "");
					$devinf->new_child ("SupportNumberOfChanges", NULL, "");
					//$devinf->new_child ("SupportLargeObjs", NULL, "");
				}
				if ($this->_authenticated) {
					$avStores=$this->_Sync->getAvDatastore($this->_authenticated);
					foreach ($avStores as $store) {
						debug('SEND DEVINF:'.$store);
						$devinf->add_child ($GLOBALS['datastores'][$store]->get_datastore_caps());
					}
				}
				//For all the backends we know, send the caps

			} else {
				$response->new_child ("Data", NULL, 404);
			}
		}
  	}
	function getStore($string) {
		$string=preg_replace('/^\.\//','',$string);
		if ($pos=strpos($string,'?/')) {
			$string=substr($string,0,$pos);
		}
		return $string;
	}
	function getStoreQuery($string) {
		if ($pos=strpos($string,'?/')) {
			return substr($string,$pos+2);
		} else {
			return '';
		}
	}
	function getServerSync($store) {
		if ($store=='calendar') $store='events';
		return isset($this->_syncPrefs[$store.'/mode'])?$this->_syncPrefs[$store.'/mode']:0;
	}
	function setServerSync($store,$mode=0) {
		if ($store=='calendar') {
			$this->_syncPrefs['events/mode']=$mode;
			$update['events/mode']=$mode;
			$this->_syncPrefs['tasks/mode']=$mode;
			$update['tasks/mode']=$mode;
		} else {
			$this->_syncPrefs[$store.'/mode']=$mode;
			$update[$store.'/mode']=$mode;
		}
		$this->_Sync->setUserPrefs($update,'all',$this->_authenticated);
	}
  	function handleCommandAlert ($xml_command, &$response_tree,$msgsize=0) {
    	$this->more_messages+=1;
		$response = & $response_tree->new_child ("Status", NULL);
		$response->new_child ("CmdID", NULL, $this->_next_cmd_id++);
		$response->new_child ("MsgRef", NULL, $this->_rcvd_msg_id);
		$response->new_child ("CmdRef", NULL,$xml_command->get_data ("CmdID"));
    	$response->new_child ("Cmd", NULL, "Alert");
		if ($this->_all_response) {
			$response->new_child ("Data", NULL, $this->_all_response);
		} else {
			$alert_data = $xml_command->get_data ("Data");
			if ($alert_data == 222) {
				$response->new_child ("Data", NULL, 200);
				$this->addStatus($response_tree,$msgsize);
			} else {
				$RemoteNextAnchor = $xml_command->get_data ("Item/Meta/Anchor/Next");
				$RemoteLastAnchor = $xml_command->get_data ("Item/Meta/Anchor/Last");
				$store = $this->getStore($xml_command->get_data ("Item/Target/LocURI"));
				$storeQuery = $this->getStoreQuery($xml_command->get_data ("Item/Target/LocURI"));
				$response->new_child ("TargetRef", NULL, $store);

				if ($xml_command->get_data ("Item/Source/LocURI"))	$response->new_child ("SourceRef", NULL, $xml_command->get_data ("Item/Source/LocURI"));
				if ($this->_Sync->startSync($store,$this->_source_uri,$this->_authenticated,$this->_auth_lang)) {
					$this->anchors[$store]=$this->_Sync->getAnchors($RemoteNextAnchor);
					if ($this->getServerSync($store)==1) {
						$status_data = 508;
						if (is_array($this->_devinf['data'][$store]['syncCap']) && in_array(7,$this->_devinf['data'][$store]['syncCap'])) {
							$alert_data=210;
						} else {
							$alert_data=205;
						}
						debug('SEND ALERT RELOAD CLIENT FROM SERVER:'.$store.' ALERT:'.$alert_data);
						$this->syncmode[$store]=10;
					} else {
						if ($alert_data==201 || $alert_data==205) {
							$status_data = 200;
							$this->syncmode[$store]=1;
							if ($alert_data==205) $this->_Sync->_deleteAllGUID();
						} else {
							if (!strlen($RemoteLastAnchor)) {
								$status_data = 508;
								$alert_data=201;
								$this->syncmode[$store]=1;
							} else {
								$status_data = 200;
								$this->syncmode[$store]=2;
							}
						}
					}
					$this->_Sync->setSyncMode($this->syncmode[$store]);
					$response->new_child ("Data", NULL, $status_data);
					$item = & $response->new_child ("Item", NULL);
					$data = & $item->new_child ("Data", NULL);
					$anchor = & $data->new_child ("Anchor", array ("xmlns" => "syncml:MetInf"));
					$anchor->new_child ("Next", NULL,$RemoteNextAnchor);

					// Create a new Alert for the client
					$response = & $response_tree->new_child ("Alert", NULL);
					$response->new_child ("CmdID", NULL, $this->_next_cmd_id++);
					$response->new_child ("Data", NULL, $alert_data);
					$item = & $response->new_child ("Item", NULL);

					$target = & $item->new_child ("Target", NULL);
					//$target->new_child ("LocURI", NULL,$xml_command->get_data ("Item/Target/LocURI"));
					$target->new_child ("LocURI", NULL,$xml_command->get_data ("Item/Source/LocURI"));
					$source = & $item->new_child ("Source", NULL);
					//$source->new_child ("LocURI", NULL,$xml_command->get_data ("Item/Source/LocURI"));
					$source->new_child ("LocURI", NULL,$xml_command->get_data ("Item/Target/LocURI"));

					$meta = & $item->new_child ("Meta", NULL);

					$anchor = & $meta->new_child ("Anchor",array ("xmlns" => "syncml:MetInf"));
					$anchor->new_child ("Last", NULL, $this->anchors[$store]['LocalLastAnchor']);
					$anchor->new_child ("Next", NULL, $this->anchors[$store]['LocalNextAnchor']);
					if ($this->_devinf['data']['SupportLargeObjs']) $maxobjsize= & $meta->new_child ("MaxObjSize", array('xmlns'=>'syncml:MetInf'), $this->myMaxObjSize);
				} else {
					$response->new_child ("Data", NULL, 410); // Store not found
				}
			}
		}
  	}
	function handleCommandMap ($xml_command, &$response_tree) {
		$response = & $response_tree->new_child ("Status", NULL);
		$response->new_child ("CmdID", NULL, $this->_next_cmd_id++);
		$response->new_child ("MsgRef", NULL, $this->_rcvd_msg_id);
		$response->new_child ("CmdRef", NULL,$xml_command->get_data ("CmdID"));
		$response->new_child ("Cmd", NULL, "Map");
		$store = $this->getStore($xml_command->get_data ("Target/LocURI"));
		$storeQuery = $this->getStoreQuery($xml_command->get_data ("Target/LocURI"));
		if ($xml_command->get_data ("Target/LocURI"))
			$response->new_child ("TargetRef", NULL,$xml_command->get_data ("Target/LocURI"));
		if ($xml_command->get_data ("Source/LocURI"))
			$response->new_child ("SourceRef", NULL,$xml_command->get_data ("Source/LocURI"));

		if ($this->_all_response) {
			$response->new_child ("Data", NULL, $this->_all_response);
		} else {
			if ($this->_Sync->startSync($store,$this->_source_uri,$this->_authenticated,$this->_auth_lang)) {
				$this->_Sync->setSyncMode($this->syncmode[$store]);
				foreach ($xml_command->children() as $cmd) {
					debug($cmd->get_name());
					if ($cmd->get_name() == "MapItem") {
						$this->_Sync->SyncMapItem($cmd->get_data ("Target/LocURI"),$cmd->get_data ("Source/LocURI"));
					}
				}
				$response->new_child ("Data", NULL, 200);
			} else {
				$response->new_child ("Data", NULL, 410);
			}
		}

	}
	function handleCommandSync ($xml_command, &$response_tree, $msgsize=0) {
		$this->more_messages+=1;
		$response = & $response_tree->new_child ("Status", NULL);
		$response->new_child ("CmdID", NULL, $this->_next_cmd_id++);
		$response->new_child ("MsgRef", NULL, $this->_rcvd_msg_id);
		$response->new_child ("CmdRef", NULL,$xml_command->get_data ("CmdID"));
		$response->new_child ("Cmd", NULL, "Sync");
		if ($this->_all_response) {
			$response->new_child ("Data", NULL, $this->_all_response);
		} else {
			$store = $this->getStore($xml_command->get_data ("Target/LocURI"));
			$storeQuery = $this->getStoreQuery($xml_command->get_data ("Target/LocURI"));
			$source_store=$xml_command->get_data ("Source/LocURI");
			if ($xml_command->get_data ("Target/LocURI"))
				$response->new_child ("TargetRef", NULL,$xml_command->get_data ("Target/LocURI"));
			if ($xml_command->get_data ("Source/LocURI"))
				$response->new_child ("SourceRef", NULL,$xml_command->get_data ("Source/LocURI"));
			if ($this->_Sync->startSync($store,$this->_source_uri,$this->_authenticated,$this->_auth_lang)) {
				$this->_Sync->setSyncMode($this->syncmode[$store]);
				$response->new_child ("Data", NULL, 200);
				if (!$this->syncStarted[$source_store]) {
					// clear the OK Fields in Maps on first sync of session
					$this->_Sync->clearMaps();
					//clear the Conflicts
					//$this->_Sync->clearConflicts();
					$this->syncStarted[$source_store]=array('store'=>$store,'query'=>$storeQuery);
				}
				debug($GLOBALS['HTTP_RAW_POST_DATA'],Framework::getTempPath().'/client.wbxml',0,1);
				foreach ($xml_command->children() as $cmd) {
					debug('CMD_NAME:'.$cmd->get_name());
					if (($cmd->get_name() == "Replace") || ($cmd->get_name() == "Add") || ($cmd->get_name() == "Delete")) {
						$i=1;
						$tmp_resp["CmdRef"]=$cmd->get_data ("CmdID");
						$tmp_resp["Cmd"]=$cmd->get_name();
						foreach ($cmd->children() as $ikey=>$item) {
							debug('ITEM_NAME:'.$ikey.'-'.$item->get_name());
							if ($item->get_name()=='Item') {
								$res = $this->_Sync->{"Sync".$tmp_resp["Cmd"]}($item->get_data ("Source/LocURI"),$item->get_data ("Data"));
								$this->_statusList[]=array(
									'MsgRef'=>$this->_rcvd_msg_id,
									'CmdRef'=>$tmp_resp["CmdRef"],
									'Cmd'=>$tmp_resp["Cmd"],
									'SourceRef'=>$item->get_data ("Source/LocURI"),
									'Data'=>$res,
								);

								/*$sub_response = & $response_tree->new_child ("Status", NULL);
								$sub_response->new_child("CmdID", NULL, $this->_next_cmd_id++);
								$sub_response->new_child("MsgRef", NULL, $this->_rcvd_msg_id);
								$sub_response->new_child("CmdRef", NULL,$tmp_resp["CmdRef"]);
								$sub_response->new_child("Cmd", NULL, $tmp_resp["Cmd"]);
								$sub_response->new_child("SourceRef", NULL,$item->get_data ("Source/LocURI"));
								$sub_response->new_child ("Data", NULL, $res);*/
								$i++;
								//if ($i>20) break;
							}
						}
					}
				}
				$this->addStatus($response_tree,$msgsize);
			} else {
				$response->new_child ("Data", NULL, 410);
			}
		}
  	}
  	function addStatus(&$response_tree,$msgsize) {
		if (!empty($this->_statusList)) {
			foreach ($this->_statusList as $key=>$val) {
				$sub_response = new XmlNode ("Status", NULL);
				$sub_response->new_child("CmdID", NULL, $this->_next_cmd_id++);
				$sub_response->new_child("MsgRef", NULL, $val['MsgRef']);
				$sub_response->new_child("CmdRef", NULL,$val["CmdRef"]);
				$sub_response->new_child("Cmd", NULL, $val["Cmd"]);
				$sub_response->new_child("SourceRef", NULL,$val['SourceRef']);
				$sub_response->new_child ("Data", NULL, $val['Data']);

				$msgsize+=$GLOBALS['syncxml']->getSize($sub_response,$GLOBALS['WBXML'],0);
				if ($msgsize>$this->maxMsgSize) {
					$this->size_to_big=true;
					debug ('SIZE TO BIG:'.$msgsize);
					$this->more_messages+=1;
					break;
				} else {
					unset($this->_statusList[$key]);
					$response_tree->add_child ($sub_response);
				}
			}
		}
 	}
	function sendSync(&$response_tree,$size) {

		if (is_array($this->sendSyncStores)) {
			foreach ($this->sendSyncStores as $source_store=>$store) {
				if (!$store) continue;
				debug ('SEND_SYNC:'.$store);
				if ($this->_Sync->startSync($store,$this->_source_uri,$this->_authenticated,$this->_auth_lang)) {
					$this->more_messages+=1;
					$response = new XmlNode ("Sync", NULL);
					$response->new_child ("CmdID", NULL, $this->_next_cmd_id++);
					$target = & $response->new_child ("Target", NULL);
					$target->new_child ("LocURI", NULL,$source_store);
					$source = & $response->new_child ("Source", NULL);
					$source->new_child ("LocURI", NULL,$store);
					if ($this->_devinf['data']['SupportNumberOfChanges']) {
						$num=0;
						if (is_array($this->add_list[$store])) {
							$num+=count($this->add_list[$store]);
						}
						if (is_array($this->replace_list[$store])) {
							$num+=count($this->replace_list[$store]);
						}
						if (is_array($this->delete_list[$store])) {
							$num+=count($this->delete_list[$store]);
						}
						$response->new_child ("NumberOfChanges",NULL,$num);
					}

					$size+=$GLOBALS['syncxml']->getSize($response,$GLOBALS['WBXML'],0);
					if ($size>$this->maxMsgSize) {
						$this->size_to_big=true;
						break;
					}
					debug ('MsxMsgSize:'.$this->maxMsgSize);
					$maxObjSize=$this->maxMsgSize-$size;
					debug('MAX_OBJ_SIZE:'.$maxObjSize);
					if (!$this->size_to_big && is_array($this->delete_list[$store])) {
						foreach ($this->delete_list[$store] as $key=>$delete) {
							$cmd = new XmlNode ("Delete", NULL);
							$cmd->new_child ("CmdID", NULL, $this->_next_cmd_id++);
							$meta = & $cmd->new_child ("Meta", NULL);
							$meta->new_child ("Type", array ("xmlns" => "syncml:MetInf"),$this->_Sync->getCt());
							$item = & $cmd->new_child ("Item", NULL);
							$target = & $item->new_child ("Target", NULL);
							$target->new_child ("LocURI", NULL, $delete);
							$this->deleteItems[$store][]=$delete;
							$size+=$GLOBALS['syncxml']->getSize($cmd,$GLOBALS['WBXML'],0);
							if ($size>$this->maxMsgSize) {
								$this->size_to_big=true;
								break;
							} else {
								unset($this->delete_list[$store][$key]);
								$response->add_child($cmd);
							}
						}
					}

					if (!$this->size_to_big && is_array($this->add_list[$store])) {
						foreach ($this->add_list[$store] as $key=>$add) {
							$cmd = new XmlNode ("Add", NULL);
							$cmd->new_child ("CmdID", NULL, $this->_next_cmd_id++);
							$meta = & $cmd->new_child ("Meta", NULL);
							$meta->new_child ("Type", array ("xmlns" => "syncml:MetInf"),$this->_Sync->getCt());
							$item = & $cmd->new_child ("Item", NULL);
							$source = & $item->new_child ("Source", NULL);
							$source->new_child ("LocURI", NULL, $key);
							$data= & $item->new_child ("Data", NULL, "<![CDATA[]]>");
							$item_size=$GLOBALS['syncxml']->getSize($cmd,$GLOBALS['WBXML'],0);
							if ((strlen($add) + $item_size)>$maxObjSize) {
								$meta->new_child ("Size", array ("xmlns" => "syncml:MetInf"),strlen($add));
								$item->new_child ("MoreData", NULL);
								$item_size=$GLOBALS['syncxml']->getSize($cmd,$GLOBALS['WBXML'],0);
								debug('ITEM_SIZE:'.$item_size);
								$send_size=$maxObjSize-$item_size-10;
								debug('SEND_SIZE:'.$send_size);
								$data->set_data ("<![CDATA[" . substr($add,0,$send_size) . "]]>");
								$item_size+=$send_size;
							} else {
								$data->set_data ("<![CDATA[" . $add . "]]>");
								$send_size=0;
								$item_size+=strlen($add);
							}
							$size+=$item_size;
							if ($size>$this->maxMsgSize) {
								$this->size_to_big=true;
								break;
							} else {
								if ($send_size) {
									$this->add_list[$store][$key]=substr($add,$send_size);
									$this->size_to_big=true;
									$response->add_child($cmd);
									break;
								} else {
									unset($this->add_list[$store][$key]);
									$response->add_child($cmd);
								}

							}
						}
					}

					if (!$this->size_to_big && is_array($this->replace_list[$store])) {
						foreach ($this->replace_list[$store] as $key=>$replace) {
							$cmd = new XmlNode ("Replace", NULL);
							$cmd->new_child ("CmdID", NULL, $this->_next_cmd_id++);
							$meta = & $cmd->new_child ("Meta", NULL);
							$meta->new_child ("Type", array ("xmlns" => "syncml:MetInf"),$this->_Sync->getCt());
							$item = & $cmd->new_child ("Item", NULL);
							$target = & $item->new_child ("Target", NULL);
							$target->new_child ("LocURI", NULL, $key);
							$data= & $item->new_child ("Data", NULL, "<![CDATA[]]>");
							$item_size=$GLOBALS['syncxml']->getSize($cmd,$GLOBALS['WBXML'],0);
							if ((strlen($replace) + $item_size)>$maxObjSize) {
								$meta->new_child ("Size", array ("xmlns" => "syncml:MetInf"),strlen($replace));
								$item->new_child ("MoreData", NULL);
								$item_size=$GLOBALS['syncxml']->getSize($cmd,$GLOBALS['WBXML'],0);
								debug('ITEM_SIZE:'.$item_size);
								$send_size=$maxObjSize-$item_size-10;
								debug('SEND_SIZE:'.$send_size);
								$data->set_data ("<![CDATA[" . substr($replace,0,$send_size) . "]]>");
								$item_size+=$send_size;
							} else {
								$data->set_data ("<![CDATA[" . $replace . "]]>");
								$send_size=0;
								$item_size+=strlen($replace);
							}
							$size+=$item_size;
							if ($size>$this->maxMsgSize) {
								$this->size_to_big=true;
								break;
							} else {
								if ($send_size) {
									$this->replace_list[$store][$key]=substr($replace,$send_size);
									$this->size_to_big=true;
									$response->add_child($cmd);
									break;
								} else {
									unset($this->replace_list[$store][$key]);
									$response->add_child($cmd);
								}

							}
						}
					}

					//debug('SYNC-SERVER:'.$GLOBALS[syncxml]->printXml($response,1,' ',"\n"));
					$response_tree->add_child($response);
					if (!$this->size_to_big) {
						$this->sendSyncStores[$source_store]=0;
					}
				}
			}
			if (!$this->size_to_big) {
				$this->addFinal=true;
			}
		}

	}
	function handleCommandStatus ($xml_command, &$response_tree) {
		debug($xml_command->get_name());
		debug($xml_command->get_data('Cmd'));
		if ($xml_command->get_data('Cmd') == "Alert") {
			$data=$xml_command->get_data('Data');
			$store1=$this->getStore($xml_command->get_data("SourceRef"));
			$store2=$this->getStore($xml_command->get_data("TargetRef"));
			$avStores=$this->_Sync->getAvDatastore($this->_authenticated);

			debug('STATUS FOR ALERT:'.$store1.' - '.$data);
			if (in_array($store1,$avStores) && $this->getServerSync($store1)==1 && $data!='500') {
				if ($this->_Sync->startSync($store1,$this->_source_uri,$this->_authenticated,$this->_auth_lang)) {
					debug('RELOAD CLIENT FROM SERVER:'.$store1.'='.'OK');
					$this->setServerSync($store1,0);
					$this->_Sync->_deleteAllGUID();
				}
			}
			debug('STATUS FOR ALERT:'.$store2.' - '.$data);
			if (in_array($store2,$avStores) && $this->getServerSync($store2)==1 && $data!='500') {
				if ($this->_Sync->startSync($store2,$this->_source_uri,$this->_authenticated,$this->_auth_lang)) {
					debug('RELOAD CLIENT FROM SERVER:'.$store2.'='.'OK');
					$this->setServerSync($store2,0);
					$this->_Sync->_deleteAllGUID();
				}
			}
		}
  	}
	function handleCommandResults ($xml_command, &$response_tree) {
		if (substr ($xml_command->get_data ("Item/Source/LocURI"),0, 9) == "./devinf1") {
			$data=$xml_command->get_child('Item/Data/DevInf');
			$this->handleDevInf($data);
		}
  	}
	function handleCommandFinal ($xml_command, &$response_tree) {
		$this->addFinal=true;
		$this->preMsgFinal=true;
		if (is_array($this->syncStarted)) {
			foreach ($this->syncStarted as $source_store=>$storeval) {
				$store=$storeval['store'];
				$query=$storeval['query'];
				if (!$this->more_messages && $this->_Sync->startSync($store,$this->_source_uri,$this->_authenticated,$this->_auth_lang)) {
					debug('endSync');
					$this->_Sync->endSync($this->deleteItems[$store]);
					$this->_conflicts[$store]=$this->_Sync->getNumConflicts();
				}
				//debug('SendSync:'.$source_store.':'.$this->sendSyncStores[$source_store]);
				if (!isset($this->sendSyncStores[$source_store]) && $this->_Sync->startSync($store,$this->_source_uri,$this->_authenticated,$this->_auth_lang)) {

					// Now create our Synctores
					$this->_Sync->setSyncMode($this->syncmode[$store]);
					$this->sendSyncStores[$source_store]=$store;
					if ($this->syncmode[$store]==1 && $this->syncmode[$store]==10) {
						//if slow sync delete all LUID that are no OK
						$this->_Sync->_deleteNonOK();
					}

					if (!is_array($this->add_list[$store])) $this->add_list[$store] = $this->_Sync->SyncGetAdd($query);
					if (!is_array($this->replace_list[$store])) $this->replace_list[$store] = $this->_Sync->SyncGetReplace($query);
					if (!is_array($this->delete_list[$store])) $this->delete_list[$store] = $this->_Sync->SyncGetDelete($query);
				}
			}
		}

		if (!$this->_all_response && (!$this->_devinf || !$this->_devinf['name'])) {
			$response=& $response_tree->new_child ("Get", NULL, NULL);
			$response->new_child ("CmdID", NULL, $this->_next_cmd_id++);
			$meta = & $response->new_child ("Meta", NULL);
			if ($GLOBALS['WBXML']) {
				$meta->new_child ("Type", array ("xmlns" => "syncml:MetInf"),"application/vnd.syncml-devinf+wbxml");
			} else {
				$meta->new_child ("Type", array ("xmlns" => "syncml:MetInf"),"application/vnd.syncml-devinf+xml");
			}
			$item = & $response->new_child ("Item", NULL);
			$target = & $item->new_child ("Target", NULL);
			$target->new_child ("LocURI", NULL,'./devinf'.str_replace('.','',$this->_syncml_version));
		}

  	}

};
?>
