<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class XmlNode {
	var $_name;
  	var $_children;
  	var $_attribs;
	var $_data;
  	function &XmlNode ($name,$attribs='',$data='') {
		$this->_name = $name;
		$this->_attribs = $attribs;
		$this->_children_len = 0;
		$this->_children = array();
		$this->_data = trim($data);
		$this->_data_len =strlen($this->_data);
		return $this;
  	}

 	function children_len () {
		return $this->_children_len;
  	}

  	function &get_children() {
		return $this->_children;
  	}

  	function &get_child ($name) {
    		$seg = substr ($name, 0, strcspn ($name, "/"));
    		if (is_array ($this->_children)) {
      			foreach ($this->_children as $child) {
					if (strcasecmp($child->get_name(), $seg) == 0) {
						if ($seg == $name) {
								return $child;
						} else {
								return $child->get_child (substr ($name,strcspn ($name, "/") + 1));
						}
					}
      			}
    		}
    		return NULL;
  	}

  	function &get_data ($name='') {
		if ($name) {
			$tmp = $this->get_child ($name);
			if ($tmp)
				return $tmp->get_data();
			else
				return NULL;
		} else {
			return $this->_data;
		}
  	}
	function set_data($data) {
		$this->_data = trim($data);
		$this->_data_len =strlen($this->_data);
	}

	function set_attribs ($attribs) {
		$this->_attribs = $attribs;
	}

	function &add_child ($xml_node) {
		$this->_children_len+=1;
		return ($this->_children[] = &$xml_node);
	}

	function &new_child ($name, $attribs, $data = NULL) {
		$tmp = &$this->add_child (new XmlNode ($name, $attribs, $data));
		return $tmp;
	}

	function get_name () {
		return $this->_name;
	}
	function &children() {
		return $this->_children;
  	}
}
class SyncXml {
	var $WBXML_TOKEN=array();
	var $_WBXML_TOKEN=array();
	var $DTD=array();
	var $_DTD=array();
	var $TABLES=array();
	var $_TABLES=array();
	var $pos=0;
	var $depth=0;
	var $wbxml=0;
	function SyncXml(&$WBXML_TOKEN,&$DTD,&$TABLES) {
		$this->DTD=$DTD;
		$this->TABLES=$TABLES;
		$this->WBXML_TOKEN=$WBXML_TOKEN;
		foreach ($TABLES as $key=>$val) {
			$this->_TABLES[$key]=array_flip($val);
		}
		$this->_DTD=array_flip($DTD);

		$this->_WBXML_TOKEN=array_flip($WBXML_TOKEN);
	}
	function searchNode(&$node,$name) {
		$result=array();
		$this->_searchNode($node,$name,$result);
		return $result;
	}
	function _searchNode(&$node,&$name,&$result) {
		if (is_array ($node->_children)) {
			$seg = substr ($name, 0, strcspn ($name, "/"));
			$sub_seg=substr($name,strcspn ($name, "/") + 1);
			//debug('SEG:'.$seg);
			//debug('SUB_SEG:'.$sub_seg);
			foreach ($node->_children as $child) {
				//debug('CHILD_NAME:'.$child->get_name());
				if (strcasecmp($child->get_name(), $seg) == 0) {
					if ($seg == $name) {
						$result[]=$child;
					} elseif ($sub_seg) {
						$this->_searchNode($child,$sub_seg,$result);
					}

				}
			}
		}

	}
	function _getHex() {
		$hex=strtoupper(bin2hex($this->wbxml[$this->pos]));
		return str_repeat('0',2-strlen($hex)).$hex;
	}
	function _getBin() {
		$bin=decbin($this->_getDec());
		return str_repeat('0',8-strlen($bin)).$bin;
	}
	function _getDec() {
		return ord($this->wbxml[$this->pos]);
	}
	function _getChar($len=1) {
		if ($len==1) {
			return ($this->wbxml[$this->pos]);
		} else {
			if (preg_match('/[\x01-\x09\x0B\x0C\x0E-\x1F]/',substr($this->wbxml,$this->pos,$len))) {
				debug('INVALID CHARACTER:'.substr($this->wbxml,$this->pos,$len));
			}
			return preg_replace('/[\x01-\x09\x0B\x0C\x0E-\x1F]/','',substr($this->wbxml,$this->pos,$len));
		}

	}
	function _parseHeader() {
		$version=$this->_getHex();
		$this->pos++;
		$header['Fpi']=$this->_getHex();
		$this->pos++;
		$header['Index']=$this->_getHex();
		$this->pos++;
		$header['Charset']=$this->_getHex();
		$this->pos++;
		$s_tab_len=$this->_getMultiDec();
		//debug($s_tab_len);
		$this->pos++;
		if ($s_tab_len) {
			$header['STable']=$this->_getChar($s_tab_len);
			/*for ($i=0;$i<strlen($header['STable']);$i++) {
				debug('NUM:'.$i.'-'.$header['STable'][$i]);
			}*/
			$this->pos+=$s_tab_len;
			if (preg_match('/DTD\s+([a-z]+)\s+/i',$header['STable'],$tmp)) {
				$header['DTD']=$tmp[1];
			} else {
				/*if ($header['Fpi']=='A4' && $header['Index']=='01') {
					$header['DTD']='SyncML';
				}
				if ($header['Fpi']=='A4' && $header['Index']=='03') {
					$header['DTD']='DevInf';
				}*/
				if ($header['Fpi']=='9F' && $header['Index']=='53') {
					$header['DTD']='SyncML';
				}
				if ($header['Fpi']=='9F' && $header['Index']=='54') {
					$header['DTD']='DevInf';
				}
			}

		} else {
			/*if ($header['Fpi']=='A4' && $header['Index']=='01') {
				$header['DTD']='SyncML';
			}
			if ($header['Fpi']=='A4' && $header['Index']=='03') {
				$header['DTD']='DevInf';
			}*/
			if ($header['Fpi']=='9F' && $header['Index']=='53') {
				$header['DTD']='SyncML';
			}
			if ($header['Fpi']=='9F' && $header['Index']=='54') {
				$header['DTD']='DevInf';
			}
		}


		foreach ($header as $key=>$val) {
			debug('HEADER:'.$key.':'.$val);
		}
		return $header;
	}
	function _getMultiDec() {
		$st_len=$this->_getBin();
		//debug($st_len);

		while ($st_len[0]) {
			$st_len=substr($st_len,1);
			if (!isset($result)) {
				$result=preg_replace('/$[0]+/','',$st_len);
			} else {
				$result.=$st_len;
			}
			$this->pos++;
			$st_len=$this->_getBin();
		}
		$st_len=substr($st_len,1);
		if (!isset($result)) {
			$result=$st_len;
		} else {
			$result.=$st_len;
		}
		return bindec($result);
	}
	function _getOpaque() {
		$this->pos++;
		$len=$this->_getMultiDec();
		$this->pos++;

		if ($this->_getHex()=='02') {
			debug('OPAQUE:'.$this->pos.':'.$len);
			return $this->_wbxml2xml($this->pos,$len);
		} else {
			//debug($this->_getChar($len));
			$opaque= "<![CDATA[" . $this->_getChar($len) . "]]>";
			$this->pos+=$len-1;
			return $opaque;
		}
	}
	function _getRefText($binRef) {
		$result='';
		$this->pos++;
		$len=$this->_getMultiDec();
		//if ($len>0) $len=intval($len/5);
		$binLen=strlen($binRef);
		//debug('REFTEXT_START:'.$len);
		if ($len<$binLen) {
			for ($i=$len;$i<$binLen;$i++) {
				$hex=strtoupper(bin2hex($binRef[$i]));
				$hex=str_repeat('0',2-strlen($hex)).$hex;
				if ($hex=='00') break;
				$result.=$binRef[$i];
			}
		}
		//debug('REFTEXT:'.$result);
		return $result;
	}
	function _getInline() {
		$this->pos++;
		while($this->_getHex()!='00') {
			$result.=$this->_getChar();
			$this->pos++;
		}
		return ($result);
	}
	function parseWbxml(&$wbxml) {
		$this->wbxml=$wbxml;
		$len=strlen($this->wbxml);
		$text=$this->_wbxml2xml(0,$len);
		//Framework::convertLineEndings($text,"\n");
		//debug($text);
  		return $this->parseText($text);
	}

	function _wbxml2xml($begin=0,$len=0) {
		$dtd='';
		$open_tag=array();

		for($this->pos=$begin;$this->pos<($len+$begin);$this->pos++) {
			//debug('DTD_B:'.$dtd);
			if (!$dtd) {
				$header=$this->_parseHeader();
				$dtd=$header['DTD'];
				$dtd_depth[$dtd]=$this->depth;
				//debug('SUB_DTD:'.$dtd);
			}
			//debug($result);

			$token=$this->_getHex();
			//debug('TOKEN:'.$token);
			if (isset($this->_WBXML_TOKEN[$token])) {
				//debug('WBXML_TOKEN:'.$token);
				switch ($token) {
					case '00':
						$this->pos++;
						$token=$this->_getHex();
						$dtd=$this->_DTD[$token];
						//debug('NEW DTD:'.$dtd);
						if ($token!='00') $dtd_depth[$dtd]=$this->depth;
						break;
					case '01':
						$this->depth-=1;
						$result.=str_repeat("  ",$this->depth)."</".array_pop($open_tag).">\n";
						break;
					case '03':
						$result.=str_repeat("  ",$this->depth).$this->_getInline()."\n";
						break;
					case 'C3':
						$result.=$this->_getOpaque();
						break;
					case '83':
						$result.=$this->_getRefText($header['STable']);
						break;
				}
			} else {
				$bin_token=$this->_getBin();
				if ($bin_token[0]) {
					$tag_attr=1;
					$bin_token[0]=0;
				} else {
					$tag_attr=0;
				}
				if ($bin_token[1]) {
					$tag_cont=1;
					$bin_token[1]=0;
				} else {
					$tag_cont=0;
				}
				$tag=strtoupper(base_convert($bin_token,2,16));
				$tag=str_repeat('0',2-strlen($tag)).$tag;
				//debug('TAG'.$tag);
				if (isset($this->_TABLES[$dtd][$tag])) {
					$attr='';
					if ($dtd_depth[$dtd]==$this->depth) $attr=' xmlns="syncml:'.$dtd.'"';
					if ($tag_cont) {
						$result.=str_repeat("  ",$this->depth)."<".$this->_TABLES[$dtd][$tag]."$attr>\n";
						array_push($open_tag,$this->_TABLES[$dtd][$tag]);
						$this->depth+=1;
					} else {
						$result.=str_repeat("  ",$this->depth)."<".$this->_TABLES[$dtd][$tag]."$attr />\n";
					}
				} else debug('Unknown Token:'.$dtd.' - '.$token.' ');
			}
			//debug('DTD_E:'.$dtd);

		}
		if (is_array($open_tag)) {
			foreach ($open_tag as $val) {
				//$this->depth-=1;
				//$result.=str_repeat("  ",$this->depth)."</".$val.">\n";
			}

		}
		$this->pos--;
		return $result;
	}
	function _formatHex($hex) {
		return str_repeat('0',2-strlen($hex)).$hex;

	}
	function _makeMultiDec($dec) {
		$bin=decbin($dec);
		$len=strlen($bin);
		$bin=str_repeat('0',7-($len%7)).$bin;
		$len+=7-($len%7);
		$pre='0';
		$result='';
		//echo $dec.':';
		for ($i=$len;$i>0;$i-=7) {
			$result=pack('H*',$this->_formatHex(base_convert($pre.substr($bin,$i-7,7),2,16))).$result;
			//echo $pre.substr($bin,$i-7,7).'-';
			$pre='1';
		}
		//echo "\n\n";
		return $result;
	}
	function _makeHeader($st) {
		$result=pack('H*','02');
		$result.=pack('H*','00');
		$result.=pack('H*','00');
		$result.=pack('H*','6A');
		$result.=$this->_makeMultiDec(strlen($st));
		$result.=$st;
		return $result;

	}
	function parseXml (&$xml_obj,$st) {
		$this->depth=0;
		$result=$this->_makeHeader($st);
		return $result.$this->_xml2wbxml($xml_obj,'SyncML');
	}
	function _xml2wbxml(&$obj,$dtd) {

		$tag_dec=base_convert($this->TABLES[$dtd][$obj->_name],16,10);
		//debug('BEGIN:'.$obj->_name.':'.$this->_formatHex(base_convert($tag_dec+64,10,16)).':'.$this->_formatHex(base_convert($tag_dec,10,16)));
		if ($obj->_children_len || $obj->_data_len) {
			//debug( $dtd.'-O:'.$obj->_name.'-'.base_convert($tag_dec+64,10,16)."\n");
			$result.=pack('H*',$this->_formatHex(base_convert($tag_dec+64,10,16)));
			if ($obj->_children_len) {
				$old_dtd=$dtd;
				foreach ($obj->_children as $child) {
					if (isset ($child->_attribs['xmlns'])) {
						$ndtd=substr(strrchr($child->_attribs['xmlns'],':'),1);
    				} elseif ($ndtd) {
						$ndtd='SyncML';
					}
					if ($ndtd && $ndtd!=$dtd) {
						//debug('DTD:'.$ndtd."\n");
						if ($this->DTD[$ndtd]) {
							$result.=pack('H*',$this->WBXML_TOKEN['SWITCH_PAGE']);
							$result.=pack('H*',$this->DTD[$ndtd]);
						} else {
							$version=$child->get_data('VerDTD');
							$opaque=$this->_makeHeader('-//SYNCML//DTD '.$ndtd.' '.$version.'//EN').$this->_xml2wbxml($child,$ndtd);
							$result.=pack('H*',$this->WBXML_TOKEN['OPAQUE']);
							$result.=$this->_makeMultiDec(strlen($opaque));
							$result.=$opaque;
							unset($opaque);
							continue;
						}
						$dtd=$ndtd;
					}
					$depth++;
					//$dtd_array[$depth]=$dtd;
					$result .= $this->_xml2wbxml($child,$dtd);
					$depth--;
				}

			}
			if ($obj->_data_len) {
				if (preg_match('/^<!\[CDATA\[(.+)\]\]>$/s',$obj->_data,$match)){
					$result.=pack('H*',$this->WBXML_TOKEN['OPAQUE']);
					$result.=$this->_makeMultiDec(strlen($match[1]));
					$result.=$match[1];
				} else {
					$result .= pack('H*',$this->WBXML_TOKEN['STR_I']);
					$result .= $obj->_data;
					$result .= pack('H*','00');
				}
			}
			if ($old_dtd && $old_dtd!=$dtd) {
				//debug( 'DTD1:'.$old_dtd."\n");
				$result.=pack('H*',$this->WBXML_TOKEN['SWITCH_PAGE']);
				$result.=pack('H*',$this->DTD[$old_dtd]);
			}
			$result .= pack('H*',$this->WBXML_TOKEN['END']);
			//debug('END:'.$obj->_name);
		} else {
			$result.=pack('H*',$this->_formatHex(base_convert($tag_dec,10,16)));
			//debug('END:'.$obj->_name);
		}
		return $result;

	}

	function _parseText(&$xml_text,&$index,&$values,&$errorTxt) {
		$index=array();
		$values=array();
		$xml_parser = xml_parser_create();
		xml_parser_set_option ($xml_parser, XML_OPTION_CASE_FOLDING, FALSE);
		if (!xml_parse_into_struct ($xml_parser, $xml_text, $values, $index)) {
			$errorCode=xml_get_error_code($xml_parser);
			$errorTxt=sprintf("XML error: %s at line %d column %d",
				xml_error_string($errorCode),
				xml_get_current_line_number($xml_parser),
				xml_get_current_column_number($xml_parser)
			);
			xml_parser_free ($xml_parser);
			return $errorCode;
		}
	}



	function parseText (&$xml_text) {
		$index=array();	$values=array(); $errorTxt='';
		$error=$this->_parseText($xml_text,$index,$values,$errorTxt);
		if ($error==23) {
			$xml_text=preg_replace('/&([^;]{4})/','&lt;\\1',$xml_text);
			$error=$this->_parseText($xml_text,$index,$values,$errorTxt);
		}
		if ($error) {
			debug($errorTxt);
			debug("XML text:\n".$xml_text);
			exit;
		}
		xml_parser_free($xml_parser);
		$stackpos = 0;
		$stack=array();
		$stack[0] = &$this->xml_obj;
		foreach ($values as $val) {
			switch ($val["type"]) {
				case "open":
					if ($stackpos==0) {
						//debug('NEW POS:'.$stackpos.' TAG:'.$val["tag"]);
						$stack[$stackpos] = new XmlNode ($val["tag"],$val["attributes"],$val["value"]);
					} else {
						//debug('ADD POS:'.$stackpos.' TAG:'.$val["tag"]);
						$stack[$stackpos] = & $stack[$stackpos-1]->add_child (new XmlNode ($val["tag"],$val["attributes"],$val["value"]));
					}
					$stackpos++;
					break;
				case "complete":
					if ($stackpos==0) {
						$stack[$stackpos] = new XmlNode ($val["tag"],$val["attributes"],$val["value"]);
					}else {
						$stack[$stackpos] = & $stack[$stackpos-1]->add_child (new XmlNode ($val["tag"],$val["attributes"],$val["value"]));
					}
				break;
				case "close":
					if ($stackpos > 0) {
						$stackpos--;
					}
					break;
				default:
					break;
			}
		}
		//debug(print_r($stack,1));
		return $stack[0];
	}
	function printXml (&$xml_obj,$recurse=1,$indent=" ",$newline="\n") {
		$this->depth=0;
		return $this->printTag($xml_obj,$recurse,$indent,$newline);
	}
	function printTag(&$obj,$recurse,$indent=" ",$newline="\n") {
		if ($obj->_name=='Cred') $this->_isCred=true;
		$result .=str_repeat($indent,$this->depth)."<" . $obj->_name;
    		if (is_array ($obj->_attribs)) {
      			foreach ($obj->_attribs as $key => $val) {
				//$result .= " " . $key . "='" . $val . "'";
				$result .= " " . $key . '="' . $val . '"';
      			}
    		}

		if ($obj->_children_len || $obj->_data_len) {
			$result .= ">";
			if ($obj->_children && $recurse) {
				$result.=$newline;
				foreach ($obj->_children as $child) {
					$this->depth++;
					$result .= $this->printTag($child,$recurse,$indent,$newline);
					$this->depth--;
				}
				$result .=str_repeat($indent,$this->depth);
			} elseif ($obj->_data_len) {
				if ($this->_isCred && $obj->_name=='Data') {
					$result .= '***';
				} else {
					$result .= $obj->_data;
				}
			}
			$result .= "</" . $obj->_name . ">".$newline;
		} else {
			$result .= " />".$newline;
		}
		if ($obj->_name=='Cred') $this->_isCred=false;
		return $result;
	}
	function getSize(&$obj,$type=0,$header=0) {
		$size=0;
		if ($type) {
			if ($header) $size+=35;
			$size+=$this->getWbXmlSize($obj);
			debug ('WB_SIZE:'.$size);
			return $size;
		} else {
			return $size + $this->getXmlSize($obj);
		}
	}


	function getXmlSize(&$obj) {
		$size=strlen($obj->_name)+1;
		if (is_array ($obj->_attribs)) {
			foreach ($obj->_attribs as $key => $val) {
				$size+=strlen($key.$val)+4;
			}
		}
		if ($obj->_children_len || $obj->_data_len) {
			$size+=2;
			if ($obj->_children) {
				foreach ($obj->_children as $child) {
					$size+= $this->getXmlSize($child);
				}
			}
			if ($obj->_data_len) {
				$size+=$obj->_data_len+1;
			}
			$size+=strlen($obj->_name)+4;
		} else {
			$size+=4;

		}
		return $size;
	}
	function getWbXmlSize(&$obj) {
		$size=1;
		if ($obj->_children_len || $obj->_data_len) {
			if (isset ($obj->_attribs['xmlns'])) {
				$dtd=substr(strrchr($obj->_attribs['xmlns'],':'),1);
				if ($this->DTD[$dtd]) $size+=4;
				else $size+=35;
			}
			if ($obj->_children) {
				foreach ($obj->_children as $child) {
					$size+= $this->getWbXmlSize($child);
				}
			}
			if ($obj->_data_len) {
				$size+=$obj->_data_len+2;
			}
			$size+=1;
		}
		return $size;
	}

}
?>
