<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class VcalMysql  {
	var $_db;
	var $_store;
	var $_device_id;
	var $_user_id;
	var $_display;
	var $_cal;
	var $_vcal_write;
	var $_vcal_parse;
	var $_vcal;
	var $_user_names;
	var $_MaxGUIDSize=11;
	var $_SyncType=array(1,2);
	var $_unsecure_prep='?';
	var $_private_prep='#';
	var $_delete=array();
	var $_no_multiday=false;
	var $_event_cat=2;
	var $_useInvit=true;
	var $_caps = array(
		"text/x-vcalendar" => array (
			"BEGIN" => array("V", "VCALENDAR", "VEVENT"),
			"END" => array("V", "VCALENDAR", "VEVENT"),
			"VERSION" => array ("V", "1.0"),
			"TZ" => NULL,
			"DCREATED" => NULL,
			"SUMMARY" => NULL,
			"DESCRIPTION" => NULL,
			"CATEGORIES" => NULL,
			"DTSTART" => NULL,
			"DTEND" => NULL,
			"ATTENDEE" => array ("P", "EXPECT", "ROLE", "RSVP","STATUS"),
			"RRULE" => NULL,
			"EXDATE" => NULL,
			"AALARM" => NULL,
			"DALARM" => NULL,
			"LOCATION" => NULL,
			"DUE" => NULL,
			"PRIORITY" => NULL,
			"STATUS" => NULL,
			"COMPLETED" => NULL,
			"CLASS" => array("V", "PUBLIC", "PRIVATE","CONFIDENTIAL"),
			"DAYLIGHT" => NULL,
			"UID" => NULL,
		),
	);
	function  VcalMysql($store,$display,&$db) {
		global $frm,$T;
		$this->_T=&$T;
		$this->_db=$db;
		$this->_store=$store;
		$this->_display=$display;

		$this->_cal=& $frm->getStaticModul('cal');
		$this->_vcal_parse = new VcalParse();
		$this->_vcal_write = new VcalWrite();
		$this->_vcal=new Vcal();
	}

	function init($user_id,$device_id,$user_lang,$prefs) {
		$this->_device_id=$device_id;
		$this->_user_id=$user_id;
		$this->_user_lang=$user_lang;
		$this->_T->setLang($user_lang);
		$this->_T->loadModul('cal');

		$this->_prefs=$prefs;
		$this->_modellprefs=getModellPrefs($this->_prefs['modell'],'cal');
		if (isset($this->_prefs['cal/no_privat'])) {
			$this->_modellprefs['cal']['privat']=$this->_prefs['cal/no_privat']?0:1;
		}
		if (isset($this->_prefs['cal/no_status'])) {
			$this->_modellprefs['cal']['status']=$this->_prefs['cal/no_status']?0:1;
		}
		if (isset($this->_prefs['cal/grant_g'])) {
			$this->_modellprefs['cal']['grant_g']=$this->_prefs['cal/grant_g'];
		}
		if (isset($this->_prefs['cal/grant_u'])) {
			$this->_modellprefs['cal']['grant_u']=$this->_prefs['cal/grant_u'];
		}
		$this->_vcal->setPrefs('cal',$this->_modellprefs);
		$this->_vcal_parse->setPrefs('cal',$this->_modellprefs);
		$this->_vcal_write->setPrefs('cal',$this->_modellprefs);
		$this->_cal->setUser($this->_user_id);
		$this->_cal->setAuthUser($this->_user_id);
		$this->_group_id=$GLOBALS['frm']->getUserGroups($this->_user_id);
		$GLOBALS['t']->setRoot("tpl/".$GLOBALS['THEME']."/cal/".$this->_user_lang);
		if ($this->_useInvit) {
			$this->loadInvitations();
		}
	}

	function get_ct() {
    		return ("text/x-vcalendar");
  	}
	function getVersion() {
    		return $this->_caps[$this->get_ct()]['VERSION'][1];
  	}

  	function get_datastore_caps () {
		$datastore = new XmlNode ("DataStore", NULL);
		$datastore->new_child ("SourceRef", NULL, $this->_store);
		$datastore->new_child ("DisplayName", NULL, $this->_display);
		$datastore->new_child ("MaxGUIDSize", NULL, $this->_MaxGUIDSize);
		$type="RxPref";
		foreach ($this->_caps as $CTType => $caps) {
			$rxp = & $datastore->new_child ($type, NULL);
			$rxp->new_child ("CTType", NULL, $CTType);
			$rxp->new_child ("VerCT", NULL, $caps[VERSION][1]);
			$type="Rx";
		}
		$type="TxPref";
		foreach ($this->_caps as $CTType => $caps) {
			$rxp = & $datastore->new_child ($type, NULL);
			$rxp->new_child ("CTType", NULL, $CTType);
			$rxp->new_child ("VerCT", NULL, $caps[VERSION][1]);
			$type="Tx";
		}
		$synccap = & $datastore->new_child ("SyncCap", NULL);
		foreach ($this->_SyncType as $val) {
			$synccap->new_child ("SyncType", NULL, $val);
		}
    		return $datastore;
  	}

  	function get_ctcaps (&$ctcap) {
		foreach ($this->_caps as $CTType => $caps) {
			if ($caps) {
				$ctcap->new_child ("CTType", NULL, $CTType);
				foreach ($caps as $key=>$val) {
					$ctcap->new_child ("PropName", NULL, $key);
					if ($val) {
						if ($val[0] == "V") {
							foreach ($val as $param) {
								if ($param != "V") $ctcap->new_child ("ValEnum", NULL, $param);
							}
						} elseif ($val[0] == "P") {
							foreach ($val as $param) {
								if ($param != "P") $ctcap->new_child ("ParamName", NULL, $param);
							}
						}
					}
				}
			}
		}
  	}
	function getModfiyTime($GUID) {
		if ($this->_useInvit && isset($this->_invitIds[$GUID])) {
			$query="SELECT TimeModify FROM CalEvent WHERE ";
			$query.=" EventID='".$GUID."' AND Deleted=0";
			debug($query);
		} else {
			$query="SELECT TimeModify,StartDate,EndDate FROM CalEvent,CalUserDone WHERE FKEventID=EventID AND Deleted=0";
			$query.=" AND UserDone IN (1,3) AND (UserType='u' AND UserID='".$this->_user_id."') ";
			$query.=" AND EventID='".$GUID."'";
			$query.="GROUP BY EventID ";
			debug($query);
		}
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			if (!$this->_no_multiday || date('dmY',$this->_db->f('StartDate'))==date('dmY',$this->_db->f('EndDate'))) {
				return $this->_db->f('TimeModify');
			}
		}
		return 0;
	}
	function getPerms($GUID,$mode='') {
		$Event=$this->_cal->readEvent($GUID);
		if ($Event['OwnerID']==$this->_user_id) {
			return 1;
		} else {
			return 0;
		}
	}
	function getName($ID) {
		if ($ID==-1) {
			return $this->_last_name;
		} elseif (isset($this->_name[$ID])) {
			return $this->_name[$ID];
		} else {
			$Event=$this->_cal->readEvent($ID);
			$this->_name[$ID]=$this->_formatName($Event);
		}

	}
	function _formatName($obj) {
		$name=date('d.m.Y',$obj['StartDate']);
		if ($obj['TimeMode']!=1) {
			$name.=date(' H:i',$obj['StartDate']);
		}
		$name.=' - '.$obj['Title'];
 		return $name;
	}
	function compareData($GUID,$item,&$support) {
		$result=0;
		$card=$this->_vcal_parse->fromText($item);
		$obj=$this->_vcal->vcal2event($card[0]);
		$this->_last_name=$this->_formatName($obj);
		$support=$this->_vcal->getError();
		$Event=$this->_cal->readEvent($GUID);
		$this->_name[$GUID]=$this->_formatName($Event);
		if ($Event['OwnerID']!=$this->_user_id) {
			if (!isset($this->_user_names[$Event["OwnerID"]])) {
					$temp=$GLOBALS['frm']->getFullName($Event['OwnerID'],1,1);
					$this->_user_names[$Event['OwnerID']]=$temp[$Event['OwnerID']];
			}
			$Event['Title']=$this->_user_names[$Event["OwnerID"]].' '.$Event['Title'];
			$user_done=$this->_cal->readEventDone($GUID,'u');
			if (!isset($user_done[$this->_user_id])) {
				$Event['Invitation']=1;
			}
		}
		if (!$this->_modellprefs['cal']['status'] && ($Event['Unsecure'] || $Event['Invitation'])) {
			$Event['Title']=$this->_unsecure_prep.$Event['Title'];
		}
		if (!$this->_modellprefs['privat'] && $Event['EvtPrivat']) {
			$Event['Title']=$this->_private_prep.$Event['Title'];
		}

		debug ('COMPARE');
		foreach($obj as $key=>$val) {
			if (trim($Event[$key])!=trim($val)) {
				debug ('NO_MATCH:'.$key.':'.$Event[$key].':'.$val);
				$result=1;
				break;
			}
		}
		return $result;
	}
	function checkData($item) {
		return 1;
	}

	function insertData($item,$LocalNextAnchor,&$support) {
		$card=$this->_vcal_parse->fromText($item);

		$obj=$this->_vcal->vcal2event($card[0],true);
		$this->_last_name=$this->_formatName($obj);
		debug('EndDate:'.date('d.m.Y',$obj['EndDate']));
		debug('RecType:'.$obj['RecType']);
		debug('RecEnd:'.date('d.m.Y',$obj['RecEnd']));
		//if ($obj['EndDate']<time() && !$obj['RecType']) return -1;
		//if ($obj['RecType'] && $obj['RecEnd']>0 && $obj['RecEnd']<time()) return -1;
		$support=$this->_vcal->getError();
		$obj['TimeModify']=$LocalNextAnchor;
		$obj['UserModify']=$this->_user_id;
		$obj['OwnerID']=$this->_user_id;
		$obj['FKCatID']=$this->_event_cat;
		if (!isset($obj['Unsecure'])) $obj['Unsecure']=0;
		if (!isset($obj['EvtPrivat'])) $obj['EvtPrivat']=0;
		$testTitle=trim($obj['Title']);
		do {
			$check=false;
			if (substr($testTitle,0,1)==$this->_private_prep) {
				$testTitle=substr($testTitle,1);
				$obj['EvtPrivat']=1;
				$check=true;
			}
			if (substr($testTitle,0,1)==$this->_unsecure_prep) {
				$testTitle=substr($testTitle,1);
				$obj['Unsecure']=1;
				$check=true;
			}
		} while ($check);
		$obj['Title']=trim($testTitle);
		debug('INSERT:'.$item);
		return $this->_cal->saveEvent($obj);
	}

	function updateData($GUID,$item,$LocalNextAnchor,&$support) {
		$card=$this->_vcal_parse->fromText($item);
		$obj=$this->_vcal->vcal2event($card[0]);
		$this->_last_name=$this->_formatName($obj);
		$support=$this->_vcal->getError();
		$obj['TimeModify']=$LocalNextAnchor;
		$obj['UserModify']=$this->_user_id;
		$obj['OwnerID']=$this->_user_id;

		if (!isset($obj['Unsecure'])) $obj['Unsecure']=0;
		if (!isset($obj['EvtPrivat'])) $obj['EvtPrivat']=0;
		$testTitle=trim($obj['Title']);
		do {
			$check=false;
			if (substr($testTitle,0,1)==$this->_private_prep) {
				$testTitle=substr($testTitle,1);
				$obj['EvtPrivat']=1;
				$check=true;
			}
			if (substr($testTitle,0,1)==$this->_unsecure_prep) {
				$testTitle=substr($testTitle,1);
				$obj['Unsecure']=1;
				$check=true;
			}
		} while ($check);
		$obj['Title']=trim($testTitle);

		$old_obj=$this->_cal->readEvent($GUID);
		$mTime=false;
		if ($obj['StartDate']!=$old_obj['StartDate'] || $obj['EndDate']!=$old_obj['EndDate'] || $obj['RecType']!=$old_obj['RecType'] || $obj['RecInt']!=$old_obj['RecInt']) {
			$mTime=true;
			$obj['TimeChange']=$obj['TimeModify'];
		}
		if ($mTime || $obj['Exception']!=$old_obj['Exception']) {
			$obj['Sequence']=$old_obj['Sequence']+1;
		}
			
		$result=$this->_cal->updateEvent($GUID,$obj,-1);
		if ($mTime) {
			$log_tras=array(
				'{EDATE}'=>$this->_cal->formatDate($old_obj['StartDate'],$old_obj['EndDate'],$old_obj['TimeMode']),
				'{ETITLE}'=>trim($obj['Title']),
				'{EPLACE}'=>trim($obj['Place']),
				'{ETEXT}'=>trim($obj['Text']),
				'{TEXT}'=>'',
				'{CUSER}'=>'',
				'{OUSER}'=>'',
				'{NDATE}'=>$this->_cal->formatDate($obj['StartDate'],$obj['EndDate'],$obj['TimeMode']),
			);
			$this->_cal->insertLog($GUID,$this->_user_id,strtr($this->_T->lang('[[action_move_title]]'),$log_tras),'log');
			if ($old_obj['Message']) {
				$user_done=$this->_cal->readEventDone($GUID,'u');
				unset($send_user);
				foreach ($user_done as $key=>$val) {
					if ($key!=$this->_user_id && $val!=2) {
						$send_user[]=$key;
					}
				}
				if ($send_user) {
					$GLOBALS['frm']->sendmessage($send_user,
						$this->_user_id,
						strtr($this->_T->lang('[[action_move_title]]'),$log_tras),
						strtr($this->_T->lang('[[action_move_text]]'),$log_tras),
						"?site=$site&action=view&view=event&edate=".$obj['StartDate']."&event_id=".$GUID,
						$obj['Title'],
						$this->_cal->getCfg('cfg/img_notes')
					);
				}
			}
		}

		return $result;
	}

	function deleteData($GUID) {
		$delDate=time();
		$Event=$this->_cal->readEvent($GUID);
		if ($Event['EndDate']>$delDate || $Event['RecEnd']>$delDate || $Event['RecEnd']==-1) {
			$this->_cal->deleteEvent($GUID);
		} else {
			debug("NO DELETE: Event $GUID in Past");
		}
		return $GUID;
	}
	function getInvitations() {
		return $this->_invitIds;
	}
	function loadInvitations() {
		$this->_invitIds=array();
		$startDate=time();
		$query = "SELECT EventID FROM CalEvent,CalEventUser as us LEFT JOIN CalUserDone as ud ON (us.FKEventID=ud.FKEventID AND ud.UserID=".$this->_db->escape($this->_user_id)." AND ud.UserType='u') ";
		$query.= "WHERE EventID=us.FKEventID AND Deleted=0 AND us.UserPerms=0 ";
		$query.= "AND (ud.UserDone IS NULL) ";
		$query .="AND ((us.UserType='u' AND us.UserID=".$this->_db->escape($this->_user_id).")  ";
		if (is_array($this->_group_id)) {
			$query .="OR (us.UserType='g' AND us.UserID IN (".implode(",",$this->_db->escape($this->_group_id))."))) ";
		} else {
			$query .="OR (us.UserType='g' AND us.UserID=".$this->_db->escape($this->_group_id)."))  ";
		}
		$query.=" AND (EndDate>$startDate OR RecEnd>$startDate OR RecEnd=-1)";
		$query.=" GROUP BY EventID ";
		debug($query);
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$this->_invitIds[$this->_db->f('EventID')]=$this->_db->f('EventID');
		}
	}
	function getAdd($Anchor,$query) {
		$result=array();
		$ids=array();
		$startDate=time();
		$query="SELECT EventID FROM CalEvent,CalUserDone LEFT JOIN SyncMaps ON (GUID=FKEventID ";
		$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
		$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."')";
		$query.=" WHERE EventID=FkEventID AND Deleted=0 AND UserDone IN (1,3)";
		$query.=" AND (EndDate>$startDate OR RecEnd>$startDate OR RecEnd=-1)";
		$query.=" AND (UserType='u' AND UserID='".$this->_user_id."') ";
		$query.=" AND LUID IS NULL ";
		$query.=' GROUP BY EventID';
		debug($query);
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$ids[]=$this->_db->f('EventID');
		}
		if ($this->_useInvit) {
			$i_ids=$this->getInvitations();
			if (!empty($i_ids)) {
				$query="SELECT DISTINCT EventID FROM CalEvent LEFT JOIN SyncMaps ON (GUID=EventID ";
				$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
				$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
				$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."')";
				$query.=" WHERE EventID IN (".implode(",",$this->_db->escape($i_ids)).") ";
				$query.=" AND LUID IS NULL ";
				debug($query);
				$this->_db->query($query);
				while($this->_db->next_record()) {
					$ids[]=$this->_db->f('EventID');
				}
			}
		}

		foreach ($ids as $val) {
			$Event=$this->_cal->readEvent($val);
			if ($this->_useInvit && isset($i_ids[$val])) {
				$Event['Invitation']=1;
			}
			if (!$this->_no_multiday || date('dmY',$Event['StartDate'])==date('dmY',$Event['EndDate'])) {
				if ($Event['OwnerID']!=$this->_user_id) {
					if (!isset($this->_user_names[$Event["OwnerID"]])) {
							$temp=$GLOBALS['frm']->getFullName($Event['OwnerID'],1,1);
							$this->_user_names[$Event['OwnerID']]=$temp[$Event['OwnerID']];
					}
					$Event['Title']=$this->_user_names[$Event["OwnerID"]].' '.$Event['Title'];
				}
				if (($Event['Unsecure'] || $Event['Invitation']) && !$this->_modellprefs['cal']['status']) {
					$Event['Title']=$this->_unsecure_prep.$Event['Title'];
				}
				if ($Event['EvtPrivat'] && !$this->_modellprefs['privat']) {
					$Event['Title']=$this->_private_prep.$Event['Title'];
				}
				$card=$this->_vcal->event2vcal($Event);
				$result[$val]=$this->_vcal_write->getVcal($card,'VEVENT','1.0');
			}
		}

		//$result=array();
		return $result;
	}

	function getReplace($Anchor,$query) {
		$result=array();
		$ids=array();
		$query="SELECT LUID,FKEventID FROM CalUserDone,CalEvent,SyncMaps";
		$query.=" WHERE EventID=FKEventID AND Deleted=0 AND FKEventID=GUID AND UserDone IN (1,3)";
		$query.=" AND (UserType='u' AND UserID='".$this->_user_id."') ";
		$query.=" AND (TimeModify > ".intval($Anchor['LocalLastAnchor']).' OR OK=-1) ';
		$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
		$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
		$query.=" AND OK!=1 ";
		$query.=' GROUP BY FKEventID';
		debug($query);
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$ids[$this->_db->f('LUID')]=$this->_db->f('FKEventID');
		}
		if ($this->_useInvit) {
			$i_ids=$this->getInvitations();
			if (!empty($i_ids)) {
				$query="SELECT LUID,EventID FROM CalEvent,SyncMaps";
				$query.=" WHERE EventID=GUID AND EventID IN (".implode(",",$this->_db->escape($i_ids)).") ";
				$query.=" AND (TimeModify > ".intval($Anchor['LocalLastAnchor']).' OR OK=-1) ';
				$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
				$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
				$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
				$query.=" AND OK!=1 ";
				debug($query);
				$this->_db->query($query);
				while($this->_db->next_record()) {
					$ids[$this->_db->f('LUID')]=$this->_db->f('EventID');
				}
			}
		}
		foreach ($ids as $key=>$val) {
			$Event=$this->_cal->readEvent($val);
			if ($this->_useInvit && isset($i_ids[$val])) {
				$Event['Invitation']=1;
			}
			if (!$this->_no_multiday || date('dmY',$Event['StartDate'])==date('dmY',$Event['EndDate'])) {
				if ($Event['OwnerID']!=$this->_user_id) {
					if (!isset($this->_user_names[$Event["OwnerID"]])) {
							$temp=$GLOBALS['frm']->getFullName($Event['OwnerID'],1,1);
							$this->_user_names[$Event['OwnerID']]=$temp[$Event['OwnerID']];
					}
					$Event['Title']=$this->_user_names[$Event["OwnerID"]].' '.$Event['Title'];
				}
				if (($Event['Unsecure'] || $Event['Invitation']) && !$this->_modellprefs['cal']['status']) {
					$Event['Title']=$this->_unsecure_prep.$Event['Title'];
				}
				if ($Event['EvtPrivat'] && !$this->_modellprefs['privat']) {
					$Event['Title']=$this->_private_prep.$Event['Title'];
				}
				$card=$this->_vcal->event2vcal($Event);
				$result[$key]=$this->_vcal_write->getVcal($card,'VEVENT','1.0');
			} else {
				$this->_delete[]=$key;
			}
		}
		return $result;
	}

	function getDelete($Anchor,$query) {
		$result=array();
		$query="SELECT LUID FROM SyncMaps LEFT JOIN CalUserDone ON (GUID=FKEventID ";
		$query.=" AND (UserType='u' AND UserID='".$this->_user_id."') ";
		$query.=" AND UserDone IN (1,3)) WHERE FKEventID IS NULL";
		$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
		$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
		if ($this->_useInvit) {
			$i_ids=$this->getInvitations();
			if (!empty($i_ids)) {
				$query.=" AND GUID NOT IN (".implode(",",$this->_db->escape($i_ids)).") ";
			}
		}
		$query.=' GROUP BY GUID';
		debug($query);
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$result[]=$this->_db->f('LUID');
		}

		$query="SELECT LUID FROM SyncMaps,CalEvent";
		$query.=" WHERE EventID=GUID AND Deleted!=0";
		$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
		$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$result[]=$this->_db->f('LUID');
		}
		
		if ($this->_no_multiday) {
			foreach ($this->_delete as $val) $result[]=$val;
		}
		return array_unique($result);
	}
};

?>
