<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class VcaltaskMysql  {
	var $_db;
	var $_store;
	var $_device_id;
	var $_user_id;
	var $_display;
	var $_cal;
	var $_vcal_write;
	var $_vcal_parse;
	var $_vcal;
	var $_user_names;
	var $_MaxGUIDSize=11;
	var $_SyncType=array(1,2);
	var $_unsecure_prep='?';
	var $_private_prep='#';
	var $_delete=array();
	var $_no_multiday=false;
	var $_event_cat=2;
	var $_prefs;
	var $_caps = array(
		"text/x-vcalendar" => array (
			"BEGIN" => array("V", "VCALENDAR", "VEVENT", "VTODO"),
			"END" => array("V", "VCALENDAR", "VEVENT", "VTODO"),
			"VERSION" => array ("V", "1.0"),
			"TZ" => NULL,
			"DCREATED" => NULL,
			"SUMMARY" => NULL,
			"DESCRIPTION" => NULL,
			"CATEGORIES" => NULL,
			"DTSTART" => NULL,
			"DTEND" => NULL,
			"ATTENDEE" => array ("P", "EXPECT", "ROLE", "RSVP","STATUS"),
			"RRULE" => NULL,
			"EXDATE" => NULL,
			"AALARM" => NULL,
			"DALARM" => NULL,
			"LOCATION" => NULL,
			"DUE" => NULL,
			"PRIORITY" => NULL,
			"STATUS" => NULL,
			"COMPLETED" => NULL,
			"CLASS" => array("V", "PUBLIC", "PRIVATE","CONFIDENTIAL"),
			"DAYLIGHT" => NULL,
			"UID" => NULL,
		),
	);
	function  VcaltaskMysql($store,$display,&$db) {
		global $frm,$T;
		$this->_T=&$T;
		$this->_db=$db;
		$this->_store=$store;
		$this->_display=$display;
		$this->_task=& $frm->getStaticModul('task');
		$this->_cal=& $frm->getStaticModul('cal');
		$this->_vcal_parse = new VcalParse();
		$this->_vcal_write = new VcalWrite();
		$this->_vcal=new Vcal();
	}

	function init($user_id,$device_id,$user_lang,$prefs) {
		$this->_device_id=$device_id;
		$this->_user_id=$user_id;
		$this->_user_lang=$user_lang;
		$this->_T->setLang($user_lang);
		$this->_T->loadModul('cal');
		$this->_T->loadModul('task');
		$this->_task->setUser($this->_user_id);
		$this->_task->setLang($user_lang);
		$this->_cal->setUser($this->_user_id);
		$this->_cal->setAuthUser($this->_user_id);
		$this->_vcal->setUser($this->_user_id);
		$this->_vcal->setLang($user_lang);
		$this->_prefs=$prefs;

		$this->_modellprefs['task']=getModellPrefs($this->_prefs['modell'],'task');
		if ($this->_prefs['task/no_startdate']) {
			$this->_modellprefs['task']['startdate']=0;
		}
		debug('STARTDATE:'.$this->_modellprefs['task']['startdate']);
		if (isset($this->_prefs['cal/no_privat'])) {
			$this->_modellprefs['cal']['privat']=$this->_prefs['cal/no_privat']?0:1;
		}
		if (isset($this->_prefs['cal/no_status'])) {
			$this->_modellprefs['cal']['status']=$this->_prefs['cal/no_status']?0:1;
		}
		if (isset($this->_prefs['cal/grant_g'])) {
			$this->_modellprefs['cal']['grant_g']=$this->_prefs['cal/grant_g'];
		}
		if (isset($this->_prefs['cal/grant_u'])) {
			$this->_modellprefs['cal']['grant_u']=$this->_prefs['cal/grant_u'];
		}

		$this->_vcal->setPrefs('task',$this->_modellprefs['task']);
		$this->_vcal_parse->setPrefs('task',$this->_modellprefs['task']);
		$this->_vcal_write->setPrefs('task',$this->_modellprefs['task']);

		$this->_modellprefs['cal']=getModellPrefs($this->_prefs['modell'],'cal');
		$this->_vcal->setPrefs('cal',$this->_modellprefs['cal']);
		$this->_vcal_parse->setPrefs('cal',$this->_modellprefs['cal']);
		$this->_vcal_write->setPrefs('cal',$this->_modellprefs['cal']);

		$this->_docID=$this->_task->getSyncID($this->_user_id);
	}

	function get_ct() {
    		return ("text/x-vcalendar");
  	}
	function getVersion() {
    		return $this->_caps[$this->get_ct()]['VERSION'][1];
  	}

  	function get_datastore_caps () {
		$datastore = new XmlNode ("DataStore", NULL);
		$datastore->new_child ("SourceRef", NULL, $this->_store);
		$datastore->new_child ("DisplayName", NULL, $this->_display);
		$datastore->new_child ("MaxGUIDSize", NULL, $this->_MaxGUIDSize);
		$type="RxPref";
		foreach ($this->_caps as $CTType => $caps) {
			$rxp = & $datastore->new_child ($type, NULL);
			$rxp->new_child ("CTType", NULL, $CTType);
			$rxp->new_child ("VerCT", NULL, $caps[VERSION][1]);
			$type="Rx";
		}
		$type="TxPref";
		foreach ($this->_caps as $CTType => $caps) {
			$rxp = & $datastore->new_child ($type, NULL);
			$rxp->new_child ("CTType", NULL, $CTType);
			$rxp->new_child ("VerCT", NULL, $caps[VERSION][1]);
			$type="Tx";
		}
		$synccap = & $datastore->new_child ("SyncCap", NULL);
		foreach ($this->_SyncType as $val) {
			$synccap->new_child ("SyncType", NULL, $val);
		}
    	return $datastore;
  	}

  	function get_ctcaps (&$ctcap) {
		foreach ($this->_caps as $CTType => $caps) {
			if ($caps) {
				$ctcap->new_child ("CTType", NULL, $CTType);
				foreach ($caps as $key=>$val) {
					$ctcap->new_child ("PropName", NULL, $key);
					if ($val) {
						if ($val[0] == "V") {
							foreach ($val as $param) {
								if ($param != "V") $ctcap->new_child ("ValEnum", NULL, $param);
							}
						} elseif ($val[0] == "P") {
							foreach ($val as $param) {
								if ($param != "P") $ctcap->new_child ("ParamName", NULL, $param);
							}
						}
					}
				}
			}
		}
  	}
  	function _setGuid($GUID) {
		$this->_mode=substr($GUID,0,1);
		$this->_guid=intval(substr($GUID,1));
		debug ('SETGUID:MODE:'.$this->_mode.':GUID:'.$this->_guid);
  	}
	function getModfiyTime($GUID) {
		$this->_setGuid($GUID);
		switch ($this->_mode) {
			case 'e':
				$query="SELECT TimeModify,StartDate,EndDate FROM CalEvent,CalUserDone WHERE FKEventID=EventID AND Deleted=0";
				$query.=" AND UserDone IN (1,3) AND (UserType='u' AND UserID='".$this->_user_id."') ";
				$query.=" AND EventID='".$this->_guid."'";
				$query.="GROUP BY EventID ";
				debug($query);
				$this->_db->query($query);
				if ($this->_db->next_record()) {
					if (!$this->_no_multiday || date('dmY',$this->_db->f('StartDate'))==date('dmY',$this->_db->f('EndDate'))) {
						return $this->_db->f('TimeModify');
					}
				}
			break;
			case 't':
				$query="SELECT TimeModify FROM TasksObj,TasksObjUser WHERE FKTaskID=TaskID";
				$query.=" AND FKUserID='".$this->_user_id."'";
				$query.=" AND Done IN (1)";
				$query.=" AND TaskID='".$this->_guid."'";
				$query.=" GROUP BY TaskID ";
				debug($query);
				$this->_db->query($query);
				if ($this->_db->next_record()) {
					return $this->_db->f('TimeModify');
				}
			break;
		}
		return 0;
	}
	function getPerms($GUID,$mode='') {
		debug('GETPERMS:'.$GUID);
		$this->_setGuid($GUID);
		switch ($this->_mode) {
			case 'e':
				$Event=$this->_cal->readEvent($this->_guid);
				if ($Event[OwnerID]==$this->_user_id) {
					return 1;
				} else {
					return 0;
				}
			break;
			case 't':
				$Task=$this->_task->readTask($this->_guid);
				debug('OWNER'.$Task['OwnerID']);
				if ($Task['OwnerID']==$this->_user_id) {
					return 1;
				} else {
					return 0;
				}
			break;
		}

	}
	function getName($ID) {
		if ($ID==-1) {
			return $this->_last_name;
		} elseif (isset($this->_name[$ID])) {
			return $this->_name[$ID];
		} else {
			$this->_setGuid($ID);
			switch ($this->_mode) {
				case 'e':
					$Event=$this->_cal->readEvent($this->_guid);
					$this->_name[$ID]=$this->_formatName($Event);
				break;
				case 't':
					$Event=$this->_task->readTask($this->_guid);
					$this->_name[$ID]=$this->_formatName($Event);
				break;
			}
		}

	}
	function _formatName($obj) {
		switch ($this->_mode) {
			case 'e':
				$name=date('d.m.Y',$obj['StartDate']);
				if ($obj['TimeMode']!=1) {
					$name.=date(' H:i',$obj['StartDate']);
				}
				$name.=' - '.$obj['Title'];
			break;
			case 't':
				$name=date('d.m.Y',$obj['StartDate']);
				$name.=' - '.$obj['Title'];
			break;
		}
 		return $name;
	}
	function compareData($GUID,$item,&$support) {
		$result=0;
		$card=$this->_vcal_parse->fromText($item);
		$this->_setGuid($GUID);
		switch ($this->_mode) {
			case 'e':
				$obj=$this->_vcal->vcal2event($card[0]);
				$this->_last_name=$this->_formatName($obj);
				$support=$this->_vcal->getError();
				$Event=$this->_cal->readEvent($this->_guid);
				$this->_name[$GUID]=$this->_formatName($Event);
				if ($Event['OwnerID']!=$this->_user_id) {
					if (!isset($this->_user_names[$Event["OwnerID"]])) {
							$temp=$GLOBALS['frm']->getFullName($Event['OwnerID'],1,1);
							$this->_user_names[$Event['OwnerID']]=$temp[$Event['OwnerID']];
					}
					$Event['Title']=$this->_user_names[$Event["OwnerID"]].' '.$Event['Title'];
				}
				if (!$this->_modellprefs['cal']['status'] && ($Event['Unsecure'] || $Event['Invitation'])) {
					$Event['Title']=$this->_unsecure_prep.$Event['Title'];
				}
				if (!$this->_modellprefs['privat'] && $Event['EvtPrivat']) {
					$Event['Title']=$this->_private_prep.$Event['Title'];
				}
				debug ('COMPARE');
				foreach($obj as $key=>$val) {
					if (trim($Event[$key])!=trim($val)) {
						debug ('NO_MATCH:'.$key.':'.$Event[$key].':'.$val);
						$result=1;
						break;
					}
				}
			break;
			case 't':
				debug('TUID:'.$this->_task->getUser());
				$obj=$this->_vcal->vcal2todo($card[0]);
				$this->_last_name=$this->_formatName($obj);
				$support=$this->_vcal->getError();
				$Task=$this->_task->readTask($this->_guid);
				$TaskUser=$this->_task->readTaskUser($this->_guid,$this->_user_id);
				$Task['UserDone']=$TaskUser[$this->_user_id]["Done"];
				$UserDone=$obj['UserDone'];
				unset($obj['UserDone']);

				if ($obj['EndDate']) {
					$obj['StartDate']=$Task['StartDate'];
					$obj['EndDate']=mktime(23,59,59,date('m',$obj['EndDate']),date('d',$obj['EndDate']),date('Y',$obj['EndDate']));
				} else {
					$obj['StartDate']=$obj['EndDate']=$Task['StartDate'];
				}

				$this->_name[$GUID]=$this->_formatName($Task);
				if ($Task['OwnerID']!=$this->_user_id) {
					if (!isset($this->_user_names[$Task["OwnerID"]])) {
						$temp=$GLOBALS[frm]->getFullName($Task['OwnerID'],1,1);
						$this->_user_names[$Task['OwnerID']]=$temp[$Task['OwnerID']];
					}
					$Task['Title']=$this->_user_names[$Task["OwnerID"]].' '.$Task['Title'];
				}
				debug ('COMPARE');
				foreach($obj as $key=>$val) {
					if (trim($Task[$key])!=trim($val)) {
						debug ('NO_MATCH:'.$key.':'.$Task[$key].':'.$val);
						$result=1;
						break;
					}
				}
				if ($UserDone==4) $result=2;
			break;
		}
		return $result;
	}
	function _setItem($item) {
		Framework::convertLineEndings($item,"\n");
		if (preg_match('/^BEGIN:VTODO$/m',$item)) {
			$this->_mode='t';
		}
		if (preg_match('/^BEGIN:VEVENT$/m',$item)) {
			$this->_mode='e';
		}
		debug ('SETITEM:MODE:'.$this->_mode);
	}
	function checkData($item) {
		$this->_setItem($item);
		switch ($this->_mode) {
			case 'e':
				return 1;
			break;
			case 't':
				$card=$this->_vcal_parse->fromText($item);
				$obj=$this->_vcal->vcal2todo($card[0]);
				if ($obj['UserDone']==4) {
					return 0;
				} else {
					return 1;
				}
			break;
		}
	}

	function insertData($item,$LocalNextAnchor,&$support) {
		$this->_setItem($item);
		switch ($this->_mode) {
			case 'e':
				$card=$this->_vcal_parse->fromText($item);
				$obj=$this->_vcal->vcal2event($card[0],true);
				$this->_last_name=$this->_formatName($obj);
				debug('EndDate:'.date('d.m.Y',$obj['EndDate']));
				debug('RecType:'.$obj['RecType']);
				debug('RecEnd:'.date('d.m.Y',$obj['RecEnd']));
				//if ($obj['EndDate']<time() && !$obj['RecType']) return -1;
				//if ($obj['RecType'] && $obj['RecEnd']>0 && $obj['RecEnd']<time()) return -1;
				$support=$this->_vcal->getError();
				$obj['TimeModify']=$LocalNextAnchor;
				$obj['UserModify']=$this->_user_id;
				$obj['OwnerID']=$this->_user_id;
				$obj['FKCatID']=$this->_event_cat;
				if (!isset($obj['Unsecure'])) $obj['Unsecure']=0;
				if (!isset($obj['EvtPrivat'])) $obj['EvtPrivat']=0;
				$testTitle=trim($obj['Title']);
				do {
					$check=false;
					if (substr($testTitle,0,1)==$this->_private_prep) {
						$testTitle=substr($testTitle,1);
						$obj['EvtPrivat']=1;
						$check=true;
					}
					if (substr($testTitle,0,1)==$this->_unsecure_prep) {
						$testTitle=substr($testTitle,1);
						$obj['Unsecure']=1;
						$check=true;
					}
				} while ($check);
				$obj['Title']=trim($testTitle);
				debug('INSERT:'.$item);
				$ID=$this->_cal->saveEvent($obj);
				if ($ID) return 'e'.$ID;
			break;
			case 't':
				$card=$this->_vcal_parse->fromText($item);
				$obj=$this->_vcal->vcal2todo($card[0]);
				$this->_last_name=$this->_formatName($obj);
				$support=$this->_vcal->getError();
				if ($obj['StartDate']) {
					$obj['StartDate']=mktime(0,0,0,date('m',$obj['StartDate']),date('d',$obj['StartDate']),date('Y',$obj['StartDate']));
				} else {
					$obj['StartDate']=mktime(0,0,0);
				}
				if ($obj['EndDate']) {
					$obj['EndDate']=mktime(23,59,59,date('m',$obj['EndDate']),date('d',$obj['EndDate']),date('Y',$obj['EndDate']));
					if ($obj['EndDate']<$obj['StartDate']) {
						$obj['StartDate']=mktime(0,0,0,date('m',$obj['EndDate']),date('d',$obj['EndDate']),date('Y',$obj['EndDate']));
					}
				} else {
					$obj['EndDate']=$obj['StartDate'];
				}
				$obj['TimeModify']=$obj['TimeCreate']=$LocalNextAnchor;
				$obj['UserModify']=$this->_user_id;
				$obj['OwnerID']=$this->_user_id;
				$obj['Status']=$obj['UserDone'];
				$obj['Users']='';
				$obj['Groups']='';
				if (!$obj['FKDocID']) $obj['FKDocID']=$this->_docID;
				$TaskUsers[$this->_user_id]=$obj['UserDone'];
				if ($obj['StatusDate']) {
					$StatusDate=$obj['StatusDate'];
				} else {
					$StatusDate=$LocalNextAnchor;
				}
				unset($obj['UserDone'],$obj['StatusDate']);
				debug('INSERT:'.$item);
				$TaskID=$this->_task->saveAllTask($obj,$TaskUsers,'p');
				if ($TaskUsers[$this->_user_id]==4) {
					$this->_task->updateUserStatus($TaskID,$this->_user_id,4);
					$this->_task->insertLog($TaskID,$this->_user_id,'','done');
					$this->_task->updateTask($TaskID,array('Status'=>4,'StatusDate'=>$StatusDate));
				}
				if ($TaskID) return 't'.$TaskID;
			break;
		}
	}

	function updateData($GUID,$item,$LocalNextAnchor,&$support) {
		$this->_setGuid($GUID);
		switch ($this->_mode) {
			case 'e':
				$card=$this->_vcal_parse->fromText($item);
				$obj=$this->_vcal->vcal2event($card[0]);
				$this->_last_name=$this->_formatName($obj);
				$support=$this->_vcal->getError();
				$obj['TimeModify']=$LocalNextAnchor;
				$obj['UserModify']=$this->_user_id;
				$obj['OwnerID']=$this->_user_id;

				if (!isset($obj['Unsecure'])) $obj['Unsecure']=0;
				if (!isset($obj['EvtPrivat'])) $obj['EvtPrivat']=0;
				$testTitle=trim($obj['Title']);
				do {
					$check=false;
					if (substr($testTitle,0,1)==$this->_private_prep) {
						$testTitle=substr($testTitle,1);
						$obj['EvtPrivat']=1;
						$check=true;
					}
					if (substr($testTitle,0,1)==$this->_unsecure_prep) {
						$testTitle=substr($testTitle,1);
						$obj['Unsecure']=1;
						$check=true;
					}
				} while ($check);
				$obj['Title']=trim($testTitle);

				$old_obj=$this->_cal->readEvent($this->_guid);
				$mTime=false;
				if ($obj['StartDate']!=$old_obj['StartDate'] || $obj['EndDate']!=$old_obj['EndDate'] || $obj['RecType']!=$old_obj['RecType'] || $obj['RecInt']!=$old_obj['RecInt']) {
					$mTime=true;
					$obj['TimeChange']=$obj['TimeModify'];
				}
				if ($mTime || $obj['Exception']!=$old_obj['Exception']) {
					$obj['Sequence']=$old_obj['Sequence']+1;
				}
				
				$this->_cal->updateEvent($this->_guid,$obj,-1);
				if ($mTime) {
					$log_tras=array(
						'{EDATE}'=>$this->_cal->formatDate($old_obj['StartDate'],$old_obj['EndDate'],$old_obj['TimeMode']),
						'{ETITLE}'=>trim($obj['Title']),
						'{EPLACE}'=>trim($obj['Place']),
						'{ETEXT}'=>trim($obj['Text']),
						'{TEXT}'=>'',
						'{CUSER}'=>'',
						'{OUSER}'=>'',
						'{NDATE}'=>$this->_cal->formatDate($obj['StartDate'],$obj['EndDate'],$obj['TimeMode']),
					);
					$this->_cal->insertLog($this->_guid,$this->_user_id,strtr($this->_T->lang('[[action_move_title]]'),$log_tras),'log');
					if ($old_obj['Message']) {
						$user_done=$this->_cal->readEventDone($this->_guid,'u');
						unset($send_user);
						foreach ($user_done as $key=>$val) {
							if ($key!=$this->_user_id && $val!=2) {
								$send_user[]=$key;
							}
						}
						if ($send_user) {
							$GLOBALS['frm']->sendmessage($send_user,
								$this->_user_id,
								strtr($this->_T->lang('[[action_move_title]]'),$log_tras),
								strtr($this->_T->lang('[[action_move_text]]'),$log_tras),
								"?site=$site&action=view&view=event&event_id=".$this->_guid,
								$obj['Title'],
								$this->_cal->getCfg('cfg/img_notes')
							);
						}
					}
				}
			break;
			case 't':
				$TaskObj=$this->_task->readTask($this->_guid);
				$TaskUser=$this->_task->readTaskUser($this->_guid,$this->_user_id);
				$OldUsers=$this->_task->getTaskUsers($this->_guid);
				$card=$this->_vcal_parse->fromText($item);
				$obj=$this->_vcal->vcal2todo($card[0]);
				$this->_last_name=$this->_formatName($obj);
				$support=$this->_vcal->getError();
				$UserDone=$obj['UserDone'];
				if ($obj['StatusDate']) {
					$StatusDate=$obj['StatusDate'];
				} else {
					$StatusDate=$LocalNextAnchor;
				}
				unset($obj['UserDone'],$obj['StatusDate']);
				if ($TaskObj['OwnerID']==$this->_user_id) {
					$obj['TimeModify']=$LocalNextAnchor;
					$obj['UserModify']=$this->_user_id;
					if ($obj['StartDate']) {
						$obj['StartDate']=mktime(0,0,0,date('m',$obj['StartDate']),date('d',$obj['StartDate']),date('Y',$obj['StartDate']));
					} else {
						$obj['StartDate']=$TaskObj['StartDate'];
					}
					if ($obj['EndDate']) {
						$obj['EndDate']=mktime(23,59,59,date('m',$obj['EndDate']),date('d',$obj['EndDate']),date('Y',$obj['EndDate']));
						if ($obj['EndDate']<$obj['StartDate']) {
							$obj['StartDate']=mktime(0,0,0,date('m',$obj['EndDate']),date('d',$obj['EndDate']),date('Y',$obj['EndDate']));
						}
					} else {
						$obj['EndDate']=$obj['StartDate'];
					}
					$this->_task->updateTask($this->_guid,$obj);
					if ($TaskObj["Users"] || $TaskObj["Groups"]) {
						$Typ='t';
					} else {
						$Typ='p';
					}
					if ($Typ=='t') {
						unset($OldUsers[$TaskObj['OwnerID']]);
					}
					if ($Typ=='t' && $TaskObj["Deleg"]) {
						if (count($OldUsers)==1) $Typ='p';
					}
					if ($Typ=='t' && !$TaskObj["Deleg"]) {
						if ($obj['EndDate']==$obj['StartDate']) $Typ='d';
						$this->_task->updateTaskUsers($this->_guid,array($TaskObj['OwnerID']),array('TaskType'=>$Typ));
					}
					if ($Typ=='p' && $obj['EndDate']==$obj['StartDate']) $Typ='o';
					if ($Typ=='t' && $obj['EndDate']==$obj['StartDate']) $Typ='d';
					if (is_array($OldUsers) && count($OldUsers)) {
						$this->_task->updateTaskUsers($this->_guid,array_keys($OldUsers),array('TaskType'=>$Typ));
					}
					debug('UPDATE');

				}
				if ($UserDone!=$TaskUsers[$this->_user_id]) {
					$this->_task->updateUserStatus($this->_guid,$this->_user_id,$UserDone);
					$this->_task->setUnread($this->_guid,$this->_user_id,0);
					if ($UserDone==4) {
						$this->_task->insertLog($this->_guid,$this->_user_id,'','done');
						if ($TaskObj['DoneOne']) $tmp_status=4;
						else $tmp_status=$this->_task->checkTaskStatus($this->_guid);
						if ($TaskObj['Status']!=$tmp_status) {
							$this->_task->updateTask($this->_guid,array('Status'=>$tmp_status,'StatusDate'=>$StatusDate));
							if ($tmp_status==4) {
								if ($TaskObj['RecType'] && ($next_recur=$this->_task->nextRecurrence(
										$TaskObj['StartDate'],
										$TaskObj['EndDate'],
										$TaskObj['RecType'],
										$TaskObj['RecInt'],
										$TaskObj['RecDate']))) {
									$TaskObj['StartDate']=$next_recur['start'];
									$TaskObj['EndDate']=$next_recur['end'];
									$this->_task->copyTask ($this->_guid,$TaskObj);
								}
							}
						}
						if ($TaskObj['Notes'] && $this->_user_id!=$TaskObj['OwnerID']) {
							$GLOBALS['frm']->sendmessage(array($TaskObj['OwnerID']),
												$this->_user_id,
												$this->_T->lang('[[task_action_done_title]]'),
												'',
												"?site=task.php&action=v&TaskID=".$this->_guid,
												$TaskObj['Title'],
												$GLOBALS['IMG_NOTES']);
						}
					}
				}
			break;
		}
		return $GUID;
	}

	function deleteData($GUID) {
		$this->_setGuid($GUID);
		switch ($this->_mode) {
			case 'e':
				$delDate=time();
				$Event=$this->_cal->readEvent($GUID);
				if ($Event['EndDate']>$delDate || $Event['RecEnd']>$delDate || $Event['RecEnd']==-1) {
					$this->_cal->deleteEvent($GUID);
				} else {
					debug("NO DELETE: Event $GUID in Past");
				}
				return $GUID;
			break;
			case 't':
				$TaskObj=$this->_task->readTask($this->_guid);
				if ($TaskObj && $TaskObj['OwnerID']==$this->_user_id) {
					if ($TaskObj['Notes']) {
						$TaskUsers=$this->_task->getTaskUsers($this->_guid,$mode);
						unset($send_user);
						foreach ($TaskUsers as $key=>$val) {
							if ($key!=$this->_user_id && $val!=3 && $val!=2 && $val!=4) {
								$send_user[]=$key;
							}
						}
						if ($send_user) {
							$log_tras=array(
								'{EBEGIN}'=>date('d.m.Y',$TaskObj['StartDate']),
								'{ETITLE}'=>trim($TaskObj['Title']),
								'{ETEXT}'=>trim($TaskObj['Text']),
							);
							if ($TaskObj['StartDate']!=$TaskObj['EndDate']) $log_tras['{EEND}']=date('d.m.Y',$TaskObj['EndDate']); else $log_tras['{EEND}']='-';

							$GLOBALS['frm']->sendmessage($send_user,
									$this->_user_id,
									strtr($this->_T->lang('[[task_action_delete_title]]'),$log_tras),
									strtr($this->_T->lang('[[task_action_delete_text]]'),$log_tras),
									"",
									"",
									$GLOBALS['IMG_NOTES']);

						}
					}
					$this->_task->deleteTaskUsers($this->_guid);
					$this->_task->deleteTaskLog($this->_guid);
					$this->_task->deleteTask($this->_guid);
					return $GUID;
				}
			break;
		}
	}
	function _getAddIds($Anchor,$startDate=0) {
		$ids=array();
		$query="SELECT TaskID FROM TasksObj,TasksObjUser LEFT JOIN SyncMaps ON (SUBSTRING(GUID,2)=FKTaskID AND SUBSTRING(GUID,1,1)!='e'";
		$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
		$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."')";
		$query.=" WHERE FKTaskID=TaskID AND FKUserID='".addslashes($this->_user_id)."'";
		$query.=" AND Status!=4";
		$query.=" AND Done IN (1)";
		if ($startDate!=-1) {
			$query.=" AND ( StartDate <= $startDate OR ( Alarm!=0 AND (EndDate - 3600*24*Alarm)< $startDate))";
		}
		$query.=" AND LUID IS NULL ";
		$query.=' GROUP BY TaskID';
		//$query.=' ORDER BY StartDate ';
		debug($query);
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$ids[]=$this->_db->f('TaskID');
		}
		return $ids;
	}

	function getAdd($Anchor,$query) {
		$result=array();
		$ids=array();
		$startDate=time();
		$query="SELECT EventID FROM CalEvent,CalUserDone LEFT JOIN SyncMaps ON (SUBSTRING(GUID,2)=FKEventID AND SUBSTRING(GUID,1,1)!='t'";
		$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
		$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."')";
		$query.=" WHERE EventID=FkEventID AND Deleted=0 AND UserDone IN (1,3)";
		$query.=" AND (EndDate>$startDate OR RecEnd>$startDate OR RecEnd=-1)";
		$query.=" AND (UserType='u' AND UserID='".$this->_user_id."') ";
		$query.=" AND LUID IS NULL ";
		$query.=' GROUP BY EventID';
		debug($query);
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$ids[]=$this->_db->f('EventID');
		}
		foreach ($ids as $val) {
			$Event=$this->_cal->readEvent($val);
			if (!$this->_no_multiday || date('dmY',$Event['StartDate'])==date('dmY',$Event['EndDate'])) {
				if ($Event['OwnerID']!=$this->_user_id) {
					if (!isset($this->_user_names[$Event["OwnerID"]])) {
							$temp=$GLOBALS['frm']->getFullName($Event['OwnerID'],1,1);
							$this->_user_names[$Event['OwnerID']]=$temp[$Event['OwnerID']];
					}
					$Event['Title']=$this->_user_names[$Event["OwnerID"]].' '.$Event['Title'];
				}
				if (($Event['Unsecure'] || $Event['Invitation']) && !$this->_modellprefs['cal']['status']) {
					$Event['Title']=$this->_unsecure_prep.$Event['Title'];
				}
				if ($Event['EvtPrivat'] && !$this->_modellprefs['privat']) {
					$Event['Title']=$this->_private_prep.$Event['Title'];
				}
				$card=$this->_vcal->event2vcal($Event);
				$result['e'.$val]=$this->_vcal_write->getVcal($card,'VEVENT','1.0');
			}
		}

		$ids=array();

		if ($this->_modellprefs['task']['startdate']) {
			$ids=$this->_getAddIds($Anchor,-1);
		} else {
			$ids=$this->_getAddIds($Anchor,time());
		}
		if ($this->_modellprefs['task']['noreplace']) {
			$ids = array_merge($ids,$this->_getReplaceIDs($Anchor));
			$ids=array_unique($ids);
		}
		foreach ($ids as $val) {
			$TaskObj=$this->_task->readTask($val);
			if ($TaskObj) {
				$TaskUser=$this->_task->readTaskUser($val,$this->_user_id);
				$Task['UserDone']=$TaskUser[$this->_user_id]["Done"];
				if ($TaskObj['OwnerID']!=$this->_user_id) {
					if (!isset($this->_user_names[$TaskObj["OwnerID"]])) {
							$temp=$GLOBALS['frm']->getFullName($TaskObj['OwnerID'],1,1);
							$this->_user_names[$TaskObj['OwnerID']]=$temp[$TaskObj['OwnerID']];
					}
					$TaskObj['Title']=$this->_user_names[$TaskObj["OwnerID"]].' '.$TaskObj['Title'];
				}
				$card=$this->_vcal->todo2vcal($TaskObj);
				$result['t'.$val]=$this->_vcal_write->getVcal($card,'VTODO','1.0');
			}

		}
		//$result=array();
		return $result;
	}

	function _getReplaceIDs($Anchor) {
		$ids=array();
		$query="SELECT LUID,FKTaskID FROM TasksObj,TasksObjUser,SyncMaps";
		$query.=" WHERE FKTaskID=TaskID AND FKTaskID=SUBSTRING(GUID,2) AND Done IN (1) AND Status!=4";
		$query.=" AND FKUserID='".$this->_user_id."' ";
		$query.=" AND (TimeModify > ".intval($Anchor['LocalLastAnchor']).' OR OK=-1) ';
		$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
		$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
		$query.=" AND OK!=1 ";
		$query.=" AND SUBSTRING(GUID,1,1)='t'";
		$query.=' GROUP BY FKTaskID';
		debug($query);
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$ids[$this->_db->f('LUID')]=$this->_db->f('FKTaskID');
		}
		return $ids;
	}
	function getReplace($Anchor,$query) {
		$result=array();
		$ids=array();
		$query="SELECT LUID,FKEventID FROM CalUserDone,CalEvent,SyncMaps";
		$query.=" WHERE EventID=FKEventID AND Deleted=0 AND FKEventID=SUBSTRING(GUID,2) AND UserDone IN (1,3)";
		$query.=" AND (UserType='u' AND UserID='".$this->_user_id."') ";
		$query.=" AND (TimeModify > ".intval($Anchor[LocalLastAnchor]).' OR OK=-1) ';
		$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
		$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
		$query.=" AND SUBSTRING(GUID,1,1)='e'";
		$query.=" AND OK!=1 ";
		$query.=' GROUP BY FKEventID';
		debug($query);
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$ids[$this->_db->f('LUID')]=$this->_db->f('FKEventID');
		}
		foreach ($ids as $key=>$val) {
			$Event=$this->_cal->readEvent($val);
			if (!$this->_no_multiday || date('dmY',$Event['StartDate'])==date('dmY',$Event['EndDate'])) {
				if ($Event['OwnerID']!=$this->_user_id) {
					if (!isset($this->_user_names[$Event["OwnerID"]])) {
							$temp=$GLOBALS['frm']->getFullName($Event['OwnerID'],1,1);
							$this->_user_names[$Event['OwnerID']]=$temp[$Event['OwnerID']];
					}
					$Event['Title']=$this->_user_names[$Event["OwnerID"]].' '.$Event['Title'];
				}

				if (($Event['Unsecure'] || $Event['Invitation']) && !$this->_modellprefs['cal']['status']) {
					$Event['Title']=$this->_unsecure_prep.$Event['Title'];
				}
				if ($Event['EvtPrivat'] && !$this->_modellprefs['privat']) {
					$Event['Title']=$this->_private_prep.$Event['Title'];
				}
				$card=$this->_vcal->event2vcal($Event);
				$result[$key]=$this->_vcal_write->getVcal($card,'VEVENT','1.0');
			} else {
				$this->_delete[]=$key;
			}
		}

		$ids=array();
		if ($this->_modellprefs['task']['noreplace']) {
			$ids=$this->_getReplaceIDs($Anchor);
			foreach ($ids as $key=>$val) {
				$TaskObj=$this->_task->readTask($val);
				$TaskUser=$this->_task->readTaskUser($val,$this->_user_id);
				if ($TaskObj) {
					$Task[UserDone]=$TaskUser[$this->_user_id]["Done"];
					if ($TaskObj[OwnerID]!=$this->_user_id) {
						if (!isset($this->_user_names[$TaskObj["OwnerID"]])) {
								$temp=$GLOBALS[frm]->getFullName($TaskObj[OwnerID],1,1);
								$this->_user_names[$TaskObj[OwnerID]]=$temp[$TaskObj[OwnerID]];
						}
						$TaskObj[Title]=$this->_user_names[$TaskObj["OwnerID"]].' '.$TaskObj[Title];
					}
					$card=$this->_vcal->todo2vcal($TaskObj);
					$result[$key]=$this->_vcal_write->getVcal($card,'VTODO','1.0');
				}
			}
		}
		return $result;
	}

	function getDelete($Anchor,$query) {
		$result=array();
		$query="SELECT LUID FROM SyncMaps LEFT JOIN CalUserDone ON (SUBSTRING(GUID,2)=FKEventID ";
		$query.=" AND (UserType='u' AND UserID='".$this->_user_id."') ";
		$query.=" AND UserDone IN (1,3)) WHERE FKEventID IS NULL";
		$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
		$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
		$query.=" AND SUBSTRING(GUID,1,1)='e'";
		$query.=' GROUP BY GUID';
		debug($query);
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$result[]=$this->_db->f('LUID');
		}

		$query="SELECT LUID FROM SyncMaps,CalEvent";
		$query.=" WHERE EventID=SUBSTRING(GUID,2) AND Deleted!=0";
		$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
		$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
		$query.=" AND SUBSTRING(GUID,1,1)='e'";
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$result[]=$this->_db->f('LUID');
		}

		if ($this->_no_multiday) {
			foreach ($this->_delete as $val) $result[]=$val;
		}

		$query="SELECT LUID FROM SyncMaps LEFT JOIN TasksObjUser ON (SUBSTRING(GUID,2)=FKTaskID ";
		$query.=" AND FKUserID='".$this->_user_id."' ";
		$query.=" AND Done IN (1)) LEFT JOIN TasksObj ON (GUID=TaskID)";
		$query.=" WHERE (FKTaskID IS NULL OR Status=4)";
		$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
		$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
		$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
		$query.=" AND SUBSTRING(GUID,1,1)='t'";
		$query.=' GROUP BY GUID';
		debug($query);
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$result[]=$this->_db->f('LUID');
		}
		if ($this->_modellprefs['task']['noreplace']) {
			$rp=$this->_getReplaceIDs($Anchor);
			foreach (array_keys($rp) as $val) {
				$result[]=$val;
			}
		}
		return array_unique($result);
	}
};

?>
