<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class VcardLdap  {
	var $_db;
	var $_store;
	var $_device_id;
	var $_user_id;
	var $_addr;
	var $_vcard;
	var $_sync_cat;
	var $_MaxGUIDSize=64;
	var $_SyncType=array(1,2);
	var $_privateBooks=array();

	var $_caps = array(

		"text/x-vcard"=>array (
			"BEGIN" => array("V", "VCARD"),
			"END" => array("V", "VCARD"),
			"VERSION" => array("V", "2.1"),
			"REV" => NULL,
			"N" => NULL,
			"TITLE" => NULL,
			"ORG" => NULL,
			"EMAIL" => array("P", "INTERNET"),
			"URL" => array("P", "HOME", "WORK"),
			"TEL" => array("P", "CELL", "FAX", "HOME","PAGER", "PREF", "VOICE", "WORK"),
			"ADR" => array ("P", "DOM", "HOME", "INTL", "PARCEL","POSTAL", "WORK"),
			"NOTE" => NULL,
		),
		"text/vcard"=>array (
			"BEGIN" => array("V", "VCARD"),
			"END" => array("V", "VCARD"),
			"VERSION" => array("V", "3.0"),
			"REV" => NULL,
			"FN" => NULL,
			"N" => NULL,
			"TITLE" => NULL,
			"ORG" => NULL,
			"EMAIL" => array("P", "INTERNET"),
			"URL" => array("P", "HOME", "WORK"),
			"TEL" => array("P", "CELL", "FAX", "HOME","PAGER", "PREF", "VOICE", "WORK"),
			"ADR" => array ("P", "DOM", "HOME", "INTL", "PARCEL","POSTAL", "WORK"),
			"BDAY" => NULL,
			"NOTE" => NULL,
			"CATEGORIES" => NULL,
		),
	);
	function  VcardLdap($store,$display,&$db) {
		global $frm;
		$this->_db=$db;
		$this->_store=$store;
		$this->_display=$display;
		$this->_addr=& $frm->getStaticModul('addr',true);
		$this->_vcard = new vCard();
		$this->_vcard_w = new vCardWrite(0,$this->_caps[$this->get_ct()]['VERSION'][1]);
	}
	function init($user_id,$device_id,$user_lang,$prefs) {
		debug('INIT');
		global $frm;
		$this->_device_id=$device_id;
		$this->_user_id=$user_id;
		$this->_user_lang=$user_lang;
		$this->_prefs=$prefs;
		$this->_modellprefs['addr']=getModellPrefs($this->_prefs['modell'],'addr');
		$this->_vcard_w->setPrefs($this->_modellprefs['addr']);
		$this->_vcard->setPrefs($this->_modellprefs['addr']);
		//debug($_SESSION["sync_session"]->getUserName());
		//debug($_SESSION["sync_session"]->getUserPwd());
		$this->_addr->setUserName($_SESSION["sync_session"]->getUserName());
		$this->_addr->setUserPwd($_SESSION["sync_session"]->getUserPwd());
		$this->_addr->setLang($this->_user_lang);
		$this->_addr->setUser($this->_user_id);
		$this->_addr->setGroups($frm->getUserGroups($this->_user_id));
		$this->_addr->setRule($frm->isRuleUser(array('sysadmin','addr')));
		$this->_addr->setCfg($frm->getCfg($this->_addr->getModul(),0,'cfg/%'));
		$this->_addr->loadFields();
		//debug('INIT_OK1');
		$this->_addr->initServers();
		//debug('INIT_OK2');
		$this->_addr->setLimit(0);

		$this->_vcard->loadFields($this->_addr->getVcardFields());
		$this->_vcard_w->loadFields($this->_addr->getVcardFields());

		if (!isset($this->_sync_cat[$this->_user_id])) {
			debug('INIT:SYNC_CAT:'.$this->_user_id);
			$this->_sync_cat[$this->_user_id]['syncCat']=array();
			$temp=explode('|',$frm->getPrefs('addr','syncCat'));
			foreach($temp as $catID) {
				//debug($catID);
				$tmpObj=$this->_addr->getObj($catID);
				if (is_object($tmpObj)) {
					$this->_sync_cat[$this->_user_id]['syncCat'][$this->_addr->getServerFromAddr($tmpObj->getID())][]=$tmpObj->getMeta('_DN');
				}
			}
			$this->_sync_cat[$this->_user_id]['syncCatSub']=$frm->getPrefs('addr','syncCatSub');

			$temp=$frm->getPrefs('addr','syncCatNew');
			if ($temp) {
				$tmpObj=$this->_addr->getObj($temp);
				if (is_object($tmpObj)) {
					$this->_sync_cat[$this->_user_id]['syncCatNew']=$tmpObj->getMeta('_DN');
				}
			}
			if (is_array($this->_sync_cat[$this->_user_id]['syncCat'])) {
				foreach ($this->_sync_cat[$this->_user_id]['syncCat'] as $key=>$val) debug('SYNC_CAT: SERVER:'.$key.' CAT:'.implode('|',$val));
			}

		}
		$this->_privateBooks=$this->_addr->getMyBooksPrivat();

		if (!$_SESSION["sync_session"]->isStoreStarted($this->_store)) {
			debug('INIT:ADRESSES:'.$this->_user_id);
			$query="DELETE FROM AddrSyncLdap WHERE FKUserID=".$this->_db->escape($this->_user_id);
			$this->_db->query($query);
			if (!empty($this->_sync_cat[$this->_user_id]['syncCat'])) {
				$fields=array('Name');
				$search=array();
				$search['searchSub']=$this->_sync_cat[$this->_user_id]['syncCatSub'];
				$search['ServerParent']=$this->_sync_cat[$this->_user_id]['syncCat'];
				$allAddr=$this->_addr->searchAddr(0,false,$search,false,$fields);
				foreach ($allAddr as $key=>$val) {
					$this->_db->insert('AddrSyncLdap',array('FKUserID'=>$this->_user_id,'FKAddressID'=>$key,'TimeModify'=>Framework::stampToTime($val->getMeta('_modifyTimestamp'))));
					//debug(date('d.m.Y H:i:s',Framework::stampToTime($val->getMeta('_modifyTimestamp'))));
				}
				debug('NUM ADRESSES:'.count($allAddr));
			}
			$_SESSION["sync_session"]->setStoreStarted($this->_store);
		}
		/*
		if (!isset($this->_sync_proj[$this->_user_id])) {
			$this->_sync_proj[$this->_user_id]=array();
			debug('INIT:SYNC_PROJ:'.$this->_user_id);
			$tmp=explode(',',$GLOBALS['frm']->getPrefs('addr','syncProjects'));
			foreach ($tmp as $val) {
				if ($val && $val!=-1) $this->_sync_proj[$this->_user_id][]=$val;
				debug('SYNC_PROJ:'.$val);
			}
		}
		*/


	}

	function get_ct() {
    		return ("text/x-vcard");
  	}
	function getVersion() {
    		return $this->_caps[$this->get_ct()][VERSION][1];
  	}

  	function get_datastore_caps () {
		$datastore = & new XmlNode ("DataStore", NULL);
		$datastore->new_child ("SourceRef", NULL, $this->_store);
		$datastore->new_child ("DisplayName", NULL, $this->_display);
		$datastore->new_child ("MaxGUIDSize", NULL, $this->_MaxGUIDSize);
		$type="RxPref";
		foreach ($this->_caps as $CTType => $caps) {
			$rxp = & $datastore->new_child ($type, NULL);
			$rxp->new_child ("CTType", NULL, $CTType);
			$rxp->new_child ("VerCT", NULL, $caps[VERSION][1]);
			$type="Rx";
		}
		$type="TxPref";
		foreach ($this->_caps as $CTType => $caps) {
			$rxp = & $datastore->new_child ($type, NULL);
			$rxp->new_child ("CTType", NULL, $CTType);
			$rxp->new_child ("VerCT", NULL, $caps[VERSION][1]);
			$type="Tx";
		}

		$synccap = & $datastore->new_child ("SyncCap", NULL);
		foreach ($this->_SyncType as $val) {
			$synccap->new_child ("SyncType", NULL, $val);
		}
    		return $datastore;
  	}

  	function get_ctcaps (&$ctcap) {
		foreach ($this->_caps as $CTType => $caps) {
			if ($caps) {
				$ctcap->new_child ("CTType", NULL, $CTType);
				foreach ($caps as $key=>$val) {
					$ctcap->new_child ("PropName", NULL, $key);
					if ($val) {
						if ($val[0] == "V") {
							foreach ($val as $param) {
								if ($param != "V") $ctcap->new_child ("ValEnum", NULL, $param);
							}
						} elseif ($val[0] == "P") {
							foreach ($val as $param) {
								if ($param != "P") $ctcap->new_child ("ParamName", NULL, $param);
							}
						}
					}
				}
			}
		}
  	}
	function getModfiyTime($GUID) {
		if (is_array($this->_sync_cat[$this->_user_id]['syncCat'])) {
			$query="SELECT TimeModify FROM  AddrSyncLdap";
			$query.=" WHERE AddrSyncLdap.FKUserID=".$this->_db->escape($this->_user_id);
			$query.=" AND FKAddressID=".$this->_db->escape($GUID);
			/*if (!empty($this->_sync_proj[$this->_user_id])) {
				$query.=" AND (AddrMeta.UserID='".addslashes($this->_user_id)."' OR AddrParentProject.FKProjID IN ('".implode("','",$this->_sync_proj[$this->_user_id])."'))";
			}*/
			//debug($query);
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				return $this->_db->f('TimeModify');
			}
		}
		return 0;
	}
	function getName($ID) {
		if ($ID==-1) {
			return $this->_last_name;
		} elseif (isset($this->_name[$ID])) {
			return $this->_name[$ID];
		} else {
			$Address=$this->_addr->getAddrObj($ID);
			if (is_object($Address)) {
				$this->_name[$ID]=$Address->getName();
				return $this->_name[$ID];
			}
		}

	}
	function _formatName($obj) {
		if (trim($obj['Name'])) {
			$name=$obj['Name'];
		} else {
			$name=trim($obj['Nachname'].' '.$obj['Vorname']);
			if ($obj['Firma']) {
				if ($name) $name=$obj['Firma'].', '.$name; else $name=$obj['Firma'];
			}
			if (!$name) $name='No Name';
		}
		return $name;
	}
	function getPerms($GUID,$mode='') {
		if (in_array($this->_addr->getServerFromAddr($GUID),$this->_privateBooks)) {
			return 1;
		} else {
			return 0;
		}
	}
	function compareData($GUID,$item,&$support) {
		$result=0;
		$this->_vcard->ParseText($item);
		$obj=$this->_vcard->fetchAddress(0);
		foreach ($obj as $key=>$val) {
			$obj[$key]=$this->_addr->AddrImplode($val);
		}
		$this->_last_name=$this->_formatName($obj);
		$fields=array_keys($obj);
		$Address=$this->_addr->getAddrObj($GUID);
		$this->_name[$GUID]=$Address->getName();

		foreach($obj as $key=>$val) {
			if (trim($Address->getMeta($key))!=trim($val)) {
				$result=1;
				break;
			}
		}
		return $result;
	}
	function checkData($item) {
		return 1;
	}

	function insertData($item,$LocalNextAnchor,&$support) {
		$this->_vcard->ParseText($item);
		$AObj=new AObj_addr(0);
		$obj=$this->_vcard->fetchAddress(0);
		foreach($obj as $key=>$val) {
			$subval=$this->_addr->AddrImplode($val);
			if ($this->_addr->getFieldData($key,'AllowedChars') && !$this->_addr->isAllowedChar($subval,$this->_addr->getFieldData($key,'AllowedChars'))) {
				$subval=$this->_addr->replaceAllowedChar($subval,$this->_addr->getFieldData($key,'AllowedChars'));
			}
			$AObj->setMeta($key,$subval);
		}
		$this->_last_name=$AObj->getName();
		debug ('SYNC_CAT:'.$this->_sync_cat[$this->_user_id]['syncCatNew']);
		if (is_array($this->_sync_cat[$this->_user_id])) {
			$AObj->setMeta('ParentID',array($this->_sync_cat[$this->_user_id]['syncCatNew']));
			if (!trim($AObj->getMeta('Nachname'))) $AObj->setMeta('Nachname','-');
			$error=$this->_addr->insertAddrMeta($AObj);
			if (!$error) {
				$this->_db->insert('AddrSyncLdap',array('FKUserID'=>$this->_user_id,'FKAddressID'=>$AObj->getID(),'TimeModify'=>$LocalNextAnchor));
				return $AObj->getID();
			} else {
				debug('ERROR_LDAP:'.$error[1]);
			}
		}
		return 0;
	}

	function updateData($GUID,$item,$LocalNextAnchor,&$support) {
		if ($this->getPerms($GUID,'update')) {
			$this->_vcard->ParseText($item);
			$obj=$this->_vcard->fetchAddress(0);
			$AObj=$this->_addr->getAddrObj($GUID);
			if (is_object($AObj)) {
				$AObj->setMeta('ParentID',$this->_addr->getAddrParent($AObj->getMeta('_DN')));
				foreach($obj as $key=>$val) {
					$subval=$this->_addr->AddrImplode($val);
					if ($this->_addr->getFieldData($key,'AllowedChars') && !$this->_addr->isAllowedChar($subval,$this->_addr->getFieldData($key,'AllowedChars'))) {
						$subval=$this->_addr->replaceAllowedChar($subval,$this->_addr->getFieldData($key,'AllowedChars'));
					}
					$AObj->setMeta($key,$subval);
				}
				if (!trim($AObj->getMeta('Nachname'))) $AObj->setMeta('Nachname','-');
				$this->_last_name=$AObj->getName();
				$error=$this->_addr->updateAddrMeta($AObj);
				if (!$error) {
					return $AObj->getID();
				} else {
					debug('ERROR_LDAP:'.$error[1]);
				}
			}
		}
		return 0;
	}

	function deleteData($GUID) {
		if ($this->getPerms($GUID,'delete')) {
			$new_obj=$this->_addr->getAddrObj($GUID);
			if (is_object($new_obj)) {
				$error=$this->_addr->deleteAddrMeta($new_obj);
				if (!$error) {
					$query="DELETE FROM AddrSyncLdap WHERE FKAddressID=".$this->_db->escape($new_obj->getID());
					$this->_db->query($query);
					return $GUID;
				} else {
					debug('ERROR_LDAP:'.$error[1]);
				}
			}
		}
		return 0;
	}

	function getAdd($Anchor,$query) {
		$result=array();
		$ids=array();
		if (is_array($this->_sync_cat[$this->_user_id]['syncCat'])) {
			$query="SELECT DISTINCT FKAddressID FROM AddrSyncLdap";

			/*if (!empty($this->_sync_proj[$this->_user_id])) {
				$query.=" LEFT JOIN AddrParentProject ON (AddrParentProject.FKAddressID=AddrMeta.AddressID)";
			}*/

			$query.=" LEFT JOIN SyncMaps ON (SyncMaps.GUID=AddrSyncLdap.FKAddressID ";
			$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
			$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
			$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."')";
			$query.=" WHERE AddrSyncLdap.FKUserID=".$this->_db->escape($this->_user_id);
			/*if (!empty($this->_sync_proj[$this->_user_id])) {
				$query.=" AND (AddrMeta.UserID='".addslashes($this->_user_id)."' OR AddrParentProject.FKProjID IN ('".implode("','",$this->_sync_proj[$this->_user_id])."'))";
			}*/
			$query.=" AND SyncMaps.LUID IS NULL";
			debug($query);
			$this->_db->query($query);
			while($this->_db->next_record()) {
				$ids[]=$this->_db->f('FKAddressID');
			}
			foreach ($ids as $val) {
				$Address=$this->_addr->getAddrObj($val);
				if (is_object($Address)) {
					$this->_vcard_w->parseAddress($Address,$this->getVersion(),0);
					$result[$val]=$this->_vcard_w->getVcard();
				}
			}
		}
		//$result=array();
		return $result;
	}

	function getReplace($Anchor,$query) {
		$result=array();
		$ids=array();
		if (is_array($this->_sync_cat[$this->_user_id]['syncCat'])) {
			$query="SELECT LUID,FKAddressID FROM AddrSyncLdap,SyncMaps";
			/*if (!empty($this->_sync_proj[$this->_user_id])) {
				$query.=" LEFT JOIN AddrParentProject ON (AddrParentProject.FKAddressID=AddrMeta.AddressID)";
			}*/
			$query.=" WHERE AddrSyncLdap.FKUserID=".$this->_db->escape($this->_user_id);
			$query.=" AND GUID=AddrSyncLdap.FKAddressID ";
			$query.=" AND (AddrSyncLdap.TimeModify > ".intval($Anchor['LocalLastAnchor']).' OR SyncMaps.OK=-1) ';
			$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
			$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
			$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
			$query.=" AND SyncMaps.OK!=1 ";
			/*if (!empty($this->_sync_proj[$this->_user_id])) {
				$query.=" AND (AddrMeta.UserID='".addslashes($this->_user_id)."' OR AddrParentProject.FKProjID IN ('".implode("','",$this->_sync_proj[$this->_user_id])."'))";
			}*/
			debug($query);
			$this->_db->query($query);
			while($this->_db->next_record()) {
				$ids[$this->_db->f('LUID')]=$this->_db->f('FKAddressID');
			}

			foreach ($ids as $key=>$val) {
				$Address=$this->_addr->getAddrObj($val);
				if (is_object($Address)) {
					$this->_vcard_w->parseAddress($Address,$this->getVersion(),0);
					$result[$key]=$this->_vcard_w->getVcard();
				}
			}
		}
		return $result;
	}

	function getDelete($Anchor,$query) {
		$result=array();
		if (is_array($this->_sync_cat[$this->_user_id]['syncCat'])) {
			$query="SELECT DISTINCT LUID FROM SyncMaps LEFT JOIN AddrSyncLdap ON (GUID=AddrSyncLdap.FKAddressID ";
			$query.=" AND AddrSyncLdap.FKUserID=".$this->_db->escape($this->_user_id);
			$query.=") WHERE AddrSyncLdap.FKAddressID IS NULL";
			$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
			$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
			$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
			debug($query);
			$this->_db->query($query);
			while($this->_db->next_record()) {
				$result[]=$this->_db->f('LUID');
			}
			/*if (!empty($this->_sync_proj[$this->_user_id])) {
				$query=" SELECT DISTINCT LUID FROM SyncMaps,AddrMeta ";
				$query.=" LEFT JOIN AddrParentProject ON (AddrParentProject.FKAddressID=AddrMeta.AddressID";
				$query.=" AND FKProjID IN ('".implode("','",$this->_sync_proj[$this->_user_id])."'))";
				$query.=" WHERE SyncMaps.GUID=AddrMeta.AddressID AND AddrMeta.UserID='0' AND AddrParentProject.FKAddressID IS NULL";
				$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
				$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
				$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
				debug($query);
				$this->_db->query($query);
				while($this->_db->next_record()) {
					$result[]=$this->_db->f('LUID');
				}
			}*/
		}
		return array_unique($result);
	}
};

?>
