<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class VcardMysql  {
	var $_db;
	var $_store;
	var $_device_id;
	var $_user_id;
	var $_addr;
	var $_vcard;
	var $_sync_cat;
	var $_MaxGUIDSize=11;
	var $_SyncType=array(1,2);

	var $_caps = array(

		"text/x-vcard"=>array (
			"BEGIN" => array("V", "VCARD"),
			"END" => array("V", "VCARD"),
			"VERSION" => array("V", "2.1"),
			"REV" => NULL,
			"N" => NULL,
			"TITLE" => NULL,
			"ORG" => NULL,
			"EMAIL" => array("P", "INTERNET"),
			"URL" => array("P", "HOME", "WORK"),
			"TEL" => array("P", "CELL", "FAX", "HOME","PAGER", "PREF", "VOICE", "WORK"),
			"ADR" => array ("P", "DOM", "HOME", "INTL", "PARCEL","POSTAL", "WORK"),
			"NOTE" => NULL,
		),
		"text/vcard"=>array (
			"BEGIN" => array("V", "VCARD"),
			"END" => array("V", "VCARD"),
			"VERSION" => array("V", "3.0"),
			"REV" => NULL,
			"FN" => NULL,
			"N" => NULL,
			"TITLE" => NULL,
			"ORG" => NULL,
			"EMAIL" => array("P", "INTERNET"),
			"URL" => array("P", "HOME", "WORK"),
			"TEL" => array("P", "CELL", "FAX", "HOME","PAGER", "PREF", "VOICE", "WORK"),
			"ADR" => array ("P", "DOM", "HOME", "INTL", "PARCEL","POSTAL", "WORK"),
			"BDAY" => NULL,
			"NOTE" => NULL,
			"CATEGORIES" => NULL,
		),
	);
	function  VcardMysql($store,$display,&$db) {
		global $frm;
		$this->_db=$db;
		$this->_store=$store;
		$this->_display=$display;
		$this->_addr=& $frm->getStaticModul('addr',true);
		$this->_vcard = new vCard();
		$this->_vcard_w = new vCardWrite(0,$this->_caps[$this->get_ct()]['VERSION'][1]);
	}
	function init($user_id,$device_id,$user_lang,$prefs) {
		global $frm;
		debug('INIT');
		$this->_device_id=$device_id;
		$this->_user_id=$user_id;
		$this->_user_lang=$user_lang;
		$this->_prefs=$prefs;
		$this->_modellprefs['addr']=getModellPrefs($this->_prefs['modell'],'addr');
		$this->_vcard_w->setPrefs($this->_modellprefs['addr']);
		$this->_vcard->setPrefs($this->_modellprefs['addr']);

		$this->_addr->setCfg($GLOBALS['frm']->getCfg($this->_addr->getModul(),0,'cfg/%'));
		$this->_addr->setLang($this->_user_lang);
		$this->_addr->setUser($this->_user_id);
		$this->_addr->setGroups($GLOBALS['frm']->getUserGroups($this->_user_id));
		$all_rules=$GLOBALS['frm']->getrule(array('addr','sysadmin'));
		if ($all_rules['addr'] || $all_rules['sysadmin']) $this->_addr->setRule(1);
		$this->_addr->loadFields();
		$this->_vcard->loadFields($this->_addr->getVcardFields());
		$this->_vcard_w->loadFields($this->_addr->getVcardFields());
		$this->_trash_obj=$this->_addr->getSystemObj('t',$this->_user_lang,0,true);
		$this->_addr->getPerms();
		if (!isset($this->_sync_cat[$this->_user_id])) {
			//$this->_sync_cat[$this->_user_id]=$this->_addr->getSubNodeIDs(array($GLOBALS[CFG][AddrPubblicRoot]),1);
			if ($frm->getPrefs('addr','syncCatSub')==-1) {
				$sub=false;
			} else {
				$sub=true;
			}
			debug('INIT:SYNC_CAT:'.$this->_user_id.' SUB:'.$sub);
			$this->_sync_cat[$this->_user_id]=$this->_addr->getSyncIDs($this->_user_id,$sub);
			if (is_array($this->_sync_cat[$this->_user_id])) foreach ($this->_sync_cat[$this->_user_id] as $val) debug('SYNC_CAT:'.$val) ;

		}
		if (!isset($this->_sync_proj[$this->_user_id])) {
			$this->_sync_proj[$this->_user_id]=array();
			debug('INIT:SYNC_PROJ:'.$this->_user_id);
			$tmp=explode(',',$GLOBALS['frm']->getPrefs('addr','syncProjects'));
			foreach ($tmp as $val) {
				if ($val && $val!=-1) $this->_sync_proj[$this->_user_id][]=$val;
				debug('SYNC_PROJ:'.$val);
			}
		}
		if (!isset($this->_sync_proj_mode[$this->_user_id])) {
			$this->_sync_proj_mode[$this->_user_id]=$GLOBALS['frm']->getPrefs('addr','syncPrjMode');
			if (!$this->_sync_proj_mode[$this->_user_id]) $this->_sync_proj_mode[$this->_user_id]='e';
		}


	}

	function get_ct() {
    		return ("text/x-vcard");
  	}
	function getVersion() {
    		return $this->_caps[$this->get_ct()][VERSION][1];
  	}

  	function get_datastore_caps () {
		$datastore = new XmlNode ("DataStore", NULL);
		$datastore->new_child ("SourceRef", NULL, $this->_store);
		$datastore->new_child ("DisplayName", NULL, $this->_display);
		$datastore->new_child ("MaxGUIDSize", NULL, $this->_MaxGUIDSize);
		$type="RxPref";
		foreach ($this->_caps as $CTType => $caps) {
			$rxp = & $datastore->new_child ($type, NULL);
			$rxp->new_child ("CTType", NULL, $CTType);
			$rxp->new_child ("VerCT", NULL, $caps[VERSION][1]);
			$type="Rx";
		}
		$type="TxPref";
		foreach ($this->_caps as $CTType => $caps) {
			$rxp = & $datastore->new_child ($type, NULL);
			$rxp->new_child ("CTType", NULL, $CTType);
			$rxp->new_child ("VerCT", NULL, $caps[VERSION][1]);
			$type="Tx";
		}

		$synccap = & $datastore->new_child ("SyncCap", NULL);
		foreach ($this->_SyncType as $val) {
			$synccap->new_child ("SyncType", NULL, $val);
		}
    	return $datastore;
  	}

  	function get_ctcaps (&$ctcap) {
		foreach ($this->_caps as $CTType => $caps) {
			if ($caps) {
				$ctcap->new_child ("CTType", NULL, $CTType);
				foreach ($caps as $key=>$val) {
					$ctcap->new_child ("PropName", NULL, $key);
					if ($val) {
						if ($val[0] == "V") {
							foreach ($val as $param) {
								if ($param != "V") $ctcap->new_child ("ValEnum", NULL, $param);
							}
						} elseif ($val[0] == "P") {
							foreach ($val as $param) {
								if ($param != "P") $ctcap->new_child ("ParamName", NULL, $param);
							}
						}
					}
				}
			}
		}
  	}
	function getModfiyTime($GUID) {
		if (is_array($this->_sync_cat[$this->_user_id])) {
			$query="SELECT TimeModify FROM  AddrParent,AddrMeta";
			if (!empty($this->_sync_proj[$this->_user_id])) {
				$query.=" LEFT JOIN AddrParentProject ON (AddrParentProject.FKAddressID=AddrMeta.AddressID)";
			}
			$query.=" WHERE AddrParent.FKAddressID=AddressID";
			$query.=" AND AddressID='".$GUID."'";

			if (!empty($this->_sync_proj[$this->_user_id])) {
				if ($this->_sync_proj_mode[$this->_user_id]=='a') {
					$query.=" AND (AddrParent.FKNodeID IN ('".implode("','",$this->_sync_cat[$this->_user_id])."') OR AddrParentProject.FKProjID IN ('".implode("','",$this->_sync_proj[$this->_user_id])."'))";
				} else {
					$query.=" AND FKNodeID IN ('".implode("','",$this->_sync_cat[$this->_user_id])."')";
					$query.=" AND (AddrMeta.UserID='".addslashes($this->_user_id)."' OR AddrParentProject.FKProjID IN ('".implode("','",$this->_sync_proj[$this->_user_id])."'))";
				}
			} else {
				$query.=" AND AddrParent.FKNodeID IN ('".implode("','",$this->_sync_cat[$this->_user_id])."')";
			}

			//debug($query);
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				return $this->_db->f('TimeModify');
			}
		}
		return 0;
	}
	function getName($ID) {
		if ($ID==-1) {
			return $this->_last_name;
		} elseif (isset($this->_name[$ID])) {
			return $this->_name[$ID];
		} else {
			$Address=$this->_addr->getAddrObj($ID);
			if (is_object($Address)) {
				$this->_name[$ID]=$Address->getName();
				return $this->_name[$ID];
			}
		}

	}
	function _formatName($obj) {
		$name=trim($obj['Nachname'].' '.$obj['Vorname']);
		if ($obj['Firma']) {
			if ($name) $name=$obj['Firma'].', '.$name; else $name=$obj['Firma'];
		}
		if (!$name) $name='No Name';
		return $name;
	}
	function getPerms($GUID,$mode='') {
		$Aobj=$this->_addr->getAddrObj($GUID);
		if (is_object($Aobj) && $Aobj->getMeta('UserID')==$this->_user_id) {
			return 1;
		} elseif ($this->_addr->getCfg('cfg/sync/allowTeamEdit') && $mode!='delete' && is_object($Aobj) && $Aobj->getAcl(4)) {
			debug('ALLOW_TEAM_MODIFY:'.$GUID);
			return 1;
		}  elseif ($this->_addr->getCfg('cfg/sync/allowTeamDelete') && $mode=='delete' && is_object($Aobj) && $Aobj->getAcl(4)) {
			debug('ALLOW_TEAM_DELETE:'.$GUID);
			return 1;
		} else {
			return 0;
		}
	}
	function compareData($GUID,$item,&$support) {
		$result=0;
		$this->_vcard->ParseText($item);
		$obj=$this->_vcard->fetchAddress(0);
		foreach ($obj as $key=>$val) {
			$obj[$key]=$this->_addr->AddrImplode($val);
		}
		$this->_last_name=$this->_formatName($obj);
		$fields=array_keys($obj);
		$Address=$this->_addr->getAddrObj($GUID);
		$this->_name[$GUID]=$Address->getName();

		foreach($obj as $key=>$val) {
			if (trim($Address->getMeta($key))!=trim($val)) {
				$result=1;
				break;
			}
		}
		return $result;
	}
	function checkData($item) {
		return 1;
	}

	function insertData($item,$LocalNextAnchor,&$support) {
		$this->_vcard->ParseText($item);
		$AObj=new AObj_addr(0);
		$obj=$this->_vcard->fetchAddress(0);
		foreach($obj as $key=>$val) {
			$AObj->setMeta($key,$this->_addr->AddrImplode($val));
		}
		$AObj->setMeta('UserModify',$this->_user_id);
		$AObj->setMeta('TimeModify',$LocalNextAnchor);
		$AObj->setMeta('Name',$AObj->getName());
		$AObj->setMeta('UserCreate',$this->_user_id);
		$AObj->setMeta('TimeCreate',$LocalNextAnchor);
		$AObj->setMeta('UserID',$this->_user_id);
		$this->_last_name=$AObj->getName();
		//debug ('SYNC_CAT:'.$this->_sync_cat[$this->_user_id][0]);
		if (is_array($this->_sync_cat[$this->_user_id])) {
			$AObj->setParentMeta('NodeIDs',array($this->_sync_cat[$this->_user_id][0]));
			if ($this->_addr->insertAddrMeta($AObj)) {
				return $AObj->getID();
			}
		}
		return 0;
	}

	function updateData($GUID,$item,$LocalNextAnchor,&$support) {
		$this->_vcard->ParseText($item);
		$obj=$this->_vcard->fetchAddress(0);
		$AObj=$this->_addr->getAddrObj($GUID);
		if (is_object($AObj) && $AObj->getAcl(4)) {
			foreach($obj as $key=>$val) {
				$AObj->setMeta($key,$this->_addr->AddrImplode($val));
			}
			$AObj->setMeta('UserModify',$this->_user_id);
			$AObj->setMeta('TimeModify',$LocalNextAnchor);
			$AObj->setMeta('Name',$AObj->getName());
			$this->_last_name=$AObj->getName();
			if (is_array($this->_sync_cat[$this->_user_id])) {
				$this->_addr->updateAddrMeta($AObj);
				return $AObj->getID();
			}
		}
		return 0;
	}

	function deleteData($GUID) {
		if (is_array($this->_sync_cat[$this->_user_id])) {
			$new_obj=$this->_addr->getAddrObj($GUID);
			if (is_object($this->_trash_obj) && is_object($new_obj)) {
				debug('TRASH_OBJ:'.$GUID);
				$ANodes=$this->_addr->getAddrNodes($new_obj->getID());
				$trash_ids=array_keys($ANodes);
				$new_obj->setMeta('Trash',1);
				$new_obj->setMeta('TrashIDs',implode(',',$trash_ids));
				$new_obj->setParentMeta('NodeIDs',array($this->_trash_obj->getID()));
				$this->_addr->updateAddrMeta($new_obj);
				return $GUID;
			}
		}
		return 0;
	}

	function getAdd($Anchor,$query) {
		foreach ($Anchor as $key=>$val) {
			debug($key.': '.date('d.m.Y H:i',$val));
		}
		$result=array();
		$ids=array();
		if (is_array($this->_sync_cat[$this->_user_id])) {
			$query="SELECT DISTINCT AddressID FROM AddrParent,AddrMeta";
			if (!empty($this->_sync_proj[$this->_user_id])) {
				$query.=" LEFT JOIN AddrParentProject ON (AddrParentProject.FKAddressID=AddrMeta.AddressID)";
			}
			$query.=" LEFT JOIN SyncMaps ON (SyncMaps.GUID=AddrMeta.AddressID ";
			$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
			$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
			$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."')";
			$query.=" WHERE AddrMeta.AddressID=AddrParent.FKAddressID";
			$query.=" AND AddrMeta.Trash=0";

			if (!empty($this->_sync_proj[$this->_user_id])) {
				if ($this->_sync_proj_mode[$this->_user_id]=='a') {
					$query.=" AND (AddrParent.FKNodeID IN ('".implode("','",$this->_sync_cat[$this->_user_id])."') OR AddrParentProject.FKProjID IN ('".implode("','",$this->_sync_proj[$this->_user_id])."'))";
				} else {
					$query.=" AND AddrParent.FKNodeID IN ('".implode("','",$this->_sync_cat[$this->_user_id])."')";
					$query.=" AND (AddrMeta.UserID='".addslashes($this->_user_id)."' OR AddrParentProject.FKProjID IN ('".implode("','",$this->_sync_proj[$this->_user_id])."'))";
				}
			} else {
				$query.=" AND AddrParent.FKNodeID IN ('".implode("','",$this->_sync_cat[$this->_user_id])."')";
			}

			$query.=" AND SyncMaps.LUID IS NULL ";
			debug($query);
			$this->_db->query($query);
			while($this->_db->next_record()) {
				$ids[]=$this->_db->f('AddressID');
			}
			foreach ($ids as $val) {
				$Address=$this->_addr->getAddrObj($val);
				if (is_object($Address) && $Address->getAcl(2)) {
					$this->_vcard_w->parseAddress($Address,$this->getVersion(),2);
					$result[$val]=$this->_vcard_w->getVcard();
				}
			}
		}
		//$result=array();
		return $result;
	}

	function getReplace($Anchor,$query) {
		$result=array();
		$ids=array();
		if (is_array($this->_sync_cat[$this->_user_id])) {

			$query="SELECT LUID,AddressID FROM AddrParent,SyncMaps,AddrMeta";
			if (!empty($this->_sync_proj[$this->_user_id])) {
				$query.=" LEFT JOIN AddrParentProject ON (AddrParentProject.FKAddressID=AddrMeta.AddressID)";
			}
			$query.=" WHERE AddrParent.FKAddressID=AddrMeta.AddressID AND GUID=AddrMeta.AddressID ";
			$query.=" AND AddrMeta.Trash=0";
			$query.=" AND (TimeModify > ".intval($Anchor['LocalLastAnchor']).' OR OK=-1) ';
			$query.=" AND SyncMaps.deviceID='".addslashes($this->_device_id)."'";
			$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
			$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
			$query.=" AND OK!=1 ";
			if (!empty($this->_sync_proj[$this->_user_id])) {
				if ($this->_sync_proj_mode[$this->_user_id]=='a') {
					$query.=" AND (AddrParent.FKNodeID IN ('".implode("','",$this->_sync_cat[$this->_user_id])."') OR AddrParentProject.FKProjID IN ('".implode("','",$this->_sync_proj[$this->_user_id])."'))";
				} else {
					$query.=" AND AddrParent.FKNodeID IN ('".implode("','",$this->_sync_cat[$this->_user_id])."')";
					$query.=" AND (AddrMeta.UserID='".addslashes($this->_user_id)."' OR AddrParentProject.FKProjID IN ('".implode("','",$this->_sync_proj[$this->_user_id])."'))";
				}
			} else {
				$query.=" AND AddrParent.FKNodeID IN ('".implode("','",$this->_sync_cat[$this->_user_id])."')";
			}
			debug($query);
			$this->_db->query($query);
			while($this->_db->next_record()) {
				$ids[$this->_db->f('LUID')]=$this->_db->f('AddressID');
			}

			foreach ($ids as $key=>$val) {
				$Address=$this->_addr->getAddrObj($val);
				if (is_object($Address) && $Address->getAcl(2)) {
					$this->_vcard_w->parseAddress($Address,$this->getVersion(),2);
					$result[$key]=$this->_vcard_w->getVcard();
				}
			}
		}
		return $result;
	}

	function getDelete($Anchor,$query) {
		$result=array();
		if (is_array($this->_sync_cat[$this->_user_id])) {
			$query="SELECT DISTINCT LUID FROM SyncMaps WHERE ";
			$query.=" SyncMaps.deviceID='".addslashes($this->_device_id)."'";
			$query.=" AND SyncMaps.store='".addslashes($this->_store)."'";
			$query.=" AND SyncMaps.user_id='".addslashes($this->_user_id)."'";
			$query.=" AND NOT EXISTS (";
			if (!empty($this->_sync_proj[$this->_user_id])) {
				$query.="SELECT AddrMeta.AddressID FROM AddrParent,AddrMeta LEFT JOIN AddrParentProject ON (AddrParentProject.FKAddressID=AddrMeta.AddressID) ";
				$query.="WHERE AddrMeta.AddressID=AddrParent.FKAddressID AND AddrMeta.AddressID=GUID ";
				$query.="AND AddrMeta.Trash=0 ";
				if ($this->_sync_proj_mode[$this->_user_id]=='a') {
					$query.="AND (AddrParentProject.FKProjID IN ('".implode("','",$this->_sync_proj[$this->_user_id])."') OR FKNodeID IN ('".implode("','",$this->_sync_cat[$this->_user_id])."'))";
				} else {
					$query.="AND ((AddrMeta.UserID='".addslashes($this->_user_id)."' OR AddrParentProject.FKProjID IN ('".implode("','",$this->_sync_proj[$this->_user_id])."')) AND FKNodeID IN ('".implode("','",$this->_sync_cat[$this->_user_id])."'))";
				}
			} else {
				$query.="SELECT AddrMeta.AddressID FROM AddrParent,AddrMeta ";
				$query.="WHERE AddrMeta.AddressID=AddrParent.FKAddressID AND AddrMeta.AddressID=GUID ";
				$query.="AND AddrMeta.Trash=0 ";
				$query.="AND AddrParent.FKNodeID IN ('".implode("','",$this->_sync_cat[$this->_user_id])."')";
			}
			$query.=")";
			debug($query);
			$this->_db->query($query);
			while($this->_db->next_record()) {
				$result[]=$this->_db->f('LUID');
			}
		}
		return array_unique($result);
	}
};

?>