<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class ActiveSync {
	function __construct() {
		global $db,$frm;
		$this->_db=&$db;
		$this->_frm=&$frm;
	}
	function getDevicePoperties($ID,$uid=0) {
		if (!$uid) $uid=$this->_frm->getUser();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'deviceID','Typ'=>'=','Values'=>$ID);
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$uid);
		$query="SELECT deviceData FROM SyncDevices WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return unserialize($this->_db->f('deviceData'));
		}
		return false;
	}
	function setDevicePoperties($ID,$Data,$uid=0) {
		if (!$uid) $uid=$this->_frm->getUser();
		$insert=array(
			'deviceID'=>$ID,
			'nonce'=>'',
			'deviceName'=>$Data['Agent'],
			'deviceData'=>serialize($Data),
			'syncType'=>'as',
			'FKUserID'=>$uid,
		);
		$this->_db->insert('SyncDevices',$insert,'',1);
		return true;
	}
	function getSyncPrefs($ID='',$uid=0) {
		if (!$uid) $uid=$this->_frm->getUser();
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'user_id','Typ'=>'=','Values'=>$uid);
		$query="SELECT * FROM SyncPrefs WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('name')]=$this->_db->f('value');
		}
		return $result;
	}
	function listSyncFolders($user_id,$device_id='',$search='') {
		$result=array();
		$sqlQuery=array();
		$sqlQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$user_id);
		$sqlQuery[]=array('Field'=>'FKDeviceID','Typ'=>'=','Values'=>$device_id);
		if ($search) $sqlQuery[]=array('Field'=>'FolderID','Typ'=>'like','Values'=>$search);

		$query="SELECT * FROM  SyncFolders WHERE ".$this->_db->getWhere($sqlQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('FolderID')]=array(
				'ID'=>$this->_db->f('FolderID'),
			);
		}
		return $result;
	}
	function insertSyncFolders($user_id,$device_id,$folders) {
		$insert=array(
			'FKUserID'=>$user_id,
			'FKDeviceID'=>$device_id,
		);
		foreach($folders as $v) {
			$insert['FolderID']=$v;
			$this->_db->insert('SyncFolders',$insert,'',true);
		}
	}
	function isSyncFolder($folder,$device_id='',$user_id=0) {
		if (!$user_id) $user_id=$this->_frm->getUser();
		$sqlQuery=array();
		$sqlQuery[]=array('Field'=>'FolderID','Typ'=>'=','Values'=>$folder);
		$sqlQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$user_id);
		$sqlQuery[]=array('Field'=>'FKDeviceID','Typ'=>'=','Values'=>$device_id);

		$query="SELECT FolderID FROM  SyncFolders WHERE ".$this->_db->getWhere($sqlQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return true;
		}
		return false;

	}
	function deleteSyncFolders($user_id,$device_id,$folders) {
		$sqlQuery=array();
		$sqlQuery[]=array('Field'=>'FolderID','Typ'=>'like','Values'=>$folders);
		if (!$user_id) $user_id=$this->_frm->getUser();
		if ($user_id!=-1) $sqlQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$user_id);
		if ($device_id!=-1) $sqlQuery[]=array('Field'=>'FKDeviceID','Typ'=>'=','Values'=>$device_id);
		return $this->_db->delete('SyncFolders',$sqlQuery);
	}
	function renameSyncFolder($user_id,$device_id,$old_folder,$new_folder) {
		$entries=array();
		$sqlQuery=array();
		$sqlQuery[]=array('Field'=>'FolderID','Typ'=>'like','Values'=>$old_folder.'.%');
		if (!$user_id) $user_id=$this->_frm->getUser();
		if ($user_id!=-1) $sqlQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$user_id);
		if ($device_id!=-1) $sqlQuery[]=array('Field'=>'FKDeviceID','Typ'=>'=','Values'=>$device_id);
		$query="SELECT FolderID FROM  SyncFolders WHERE ".$this->_db->getWhere($sqlQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$entries[]=$this->_db->f('FolderID');
		}
		$entries[]=$old_folder;
		foreach($entries as $folder) {
			$sqlQuery=array();
			$sqlQuery[]=array('Field'=>'FolderID','Typ'=>'=','Values'=>$folder);
			if ($user_id!=-1) $sqlQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$user_id);
			if ($device_id!=-1) $sqlQuery[]=array('Field'=>'FKDeviceID','Typ'=>'=','Values'=>$device_id);
			$update=array(
				'FolderID'=>preg_replace('/^'.preg_quote($old_folder,'/').'/',$new_folder,$folder),
			);
			$this->_db->update('SyncFolders',$update,$sqlQuery);
		}
	}	
};

?>
