<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class TaskObj {
	var $_meta=array();
	var $_pmeta=array();
	var $_acl;
	var $_ID;
	function getID() {
		return $this->_ID;
	}
	function setID($ID) {
		$this->_ID=$ID;
	}
	function getMeta($key) {
		return $this->_meta[$key];
	}
	function setMeta($key,$data) {
		$this->_meta[$key]=$data;
	}
	function getParentMeta($key) {
		return $this->_pmeta[$key];
	}
	function setParentMeta($key,$data) {
		$this->_pmeta[$key]=$data;
	}
	function getName($lang='') {
		if (!$lang) $lang=$GLOBALS['frm']->getLang();
		return $this->_meta['Title_'.$lang];
	}
	function getACL($chk=0) {
		$chk=intval($chk);
		if ($chk) {
			if ($this->_acl==-1) {
				return true;
			} else {
				return ($this->_acl&$chk);
			}
		} else {
			return $this->_acl;
		}
	}
	function setAcl($acl) {
		$this->_acl=$acl;
	}
	function getAction($typ) {
		return $this->_action[$typ];
	}
	function getSite() {
		return $this->_site;
	}

}

class TObj_fol extends TaskObj   {
	var $_site='task.php';
	var $_action=array('b','b');
	function TObj_fol($ID=0,$meta=0,$pmeta=0,$acl=0) {
		if ($meta) $this->_meta=$meta;
		if ($pmeta) $this->_pmeta=$pmeta;
		$this->_acl=$acl;
		$this->_ID=$ID;
	}
	function getImage($open=0) {
		$image='obj_img/';
		if ($open) {
			$image.='co_';
		} else {
			$image.='ex_';
		}
		$image.=$this->getMeta('MenuImage');
		return $image;
	}
	function getActionMode($typ=0) {
		$ac='fol';
		if ($typ) $ac.='_l';
		return $ac;
	}
	function isFolder() {
		return true;
	}
}

class Task {
	var $_db;
	var $_uid;
	var $auth_uid;
	var $_lang;
	var $_gid;
	var $_rule=false;
	var $_sadmin=false;
	var $_modul='task';

	function Task() {
		global $db,$frm;
		$this->_db=&$db;
		$this->_frm=&$frm;
		$this->_auth_uid=$this->_uid=$frm->getUser();
		$this->_gid=$frm->getMyGroups();
		$this->setLang($frm->getLang());
		$this->setRule($frm->isRuleUser(array('sysadmin','task')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}
	function getModul() {
		return $this->_modul;
	}
	function setUser($uid) {
		$this->_uid=$uid;
	}
	function setLang($lang) {
		$this->_lang=$lang;
	}
	function getUser() {
		return $this->_uid;
	}
	function getAuthUser() {
		return $this->auth_uid;
	}
	function setGroups($gid) {
		$this->_gid=$gid;
	}
	function getGroups() {
		return $this->_gid;
	}
	function setRule($bool=false) {
		$this->_rule=$bool;
	}
	function setSuperAdmin($bool=false) {
		$this->_sadmin=$bool;
	}
	function setLocked($locked) {
		$this->_locked_obj=$locked_obj;
	}
	function isRuleUser() {
		return $this->_rule;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function setCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}
		}
	}
	function getCfg($key) {
		if (isset($this->_cfg[$key])) {
			return $this->_cfg[$key];
		} else {
			return false;
		}
	}
	function setRootObj(&$obj) {
		$this->_root_obj=&$obj;
	}
	function &getRootObj() {
		return $this->_root_obj;
	}
	function setMode($mode) {
		$this->_mode=$mode;
	}
	function getMode() {
		return $this->_mode;
	}
	function date_dist_cmp ($date1,$date2) {
        	if (date("I",$date1)!=date("I",$date2)) {
                	return date("I",$date1)?-3600:+3600;
         	}
         	return 0;
	}
	function &ListAllTree($RootID=-1,$ParentID=-1,$order_f='Title_de',$order_d='ASC',$app='',$use_perms=true) {
		$result=array();
		if ($order_f) $order_met="ORDER BY $order_f $order_d";
		//debug($app);
		if ($app && !empty($app)) {
			$sql_app=$this->_db->escape($app);
			if (is_array($app) && count($app)) $where[]="DocType IN (".implode(",",$sql_app).")";
			elseif  ($app) $where[]="DocType=$sql_app";
		}

		$sql_RootID=$this->_db->escape($RootID);
		if (is_array($RootID)) $where[]="RootID IN (".implode(",",$sql_RootID).")";
		elseif ($RootID!=-1)  $where[]="RootID=$sql_RootID";

		$sql_ParentID=$this->_db->escape($ParentID);
		if (is_array($ParentID)) $where[]="ParentID IN (".implode(",",$sql_ParentID).")";
		elseif ($ParentID!=-1)  $where[]="ParentID=$sql_ParentID";

		$where[]="(UserID=0 OR UserID=".$this->_db->escape($this->_uid).')';
		if (!$this->isRuleUser() && $use_perms) $where[]="(UserID=".$this->_db->escape($this->_uid)." OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%|".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";

		$query="SELECT * FROM TasksMetabase ";
		$query.=" WHERE  ".implode(' AND ',$where)." $order_met";
		//echo $query.'<br><br>';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='TObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				$result[$this->_db->f("ParentID")][$this->_db->f("DocID")]=new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}
		}
		return $result;
	}


	function &ListSubEntrys($ParentID,$app='',$order_f='Title_de',$order_d='ASC',$use_perms=true) {
		$result=array();
		if ($order_f) $order_met="ORDER BY $order_f $order_d";

		$sql_app=$this->_db->escape($app);
		if (is_array($app)) $where[]="DocType IN (".implode(",",$sql_app).")";
		elseif  ($app) $where[]="DocType=$sql_app";

		$sql_ParentID=$this->_db->escape($ParentID);
		if (is_array($ParentID)) $where[]="ParentID IN (".implode(",",$sql_ParentID).")";
		else $where[]="ParentID=$sql_ParentID";

		$where[]="(UserID=0 OR UserID=".$this->_db->escape($this->_uid).')';
		if (!$this->isRuleUser() && $use_perms) $where[]="(UserID=".$this->_db->escape($this->_uid)." OR Users LIKE '%|".$this->_uid.",%' OR Groups LIKE '%".implode(",%' OR Groups LIKE '%|",$this->_gid).",%')";

		$query="SELECT * FROM TasksMetabase ";
		$query.=" WHERE  ".implode(' AND ',$where)." $order_met";
		//echo $query.'<br><br>';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$class='TObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				$result[$this->_db->f("DocID")]=new $class($this->_db->f("DocID"),$this->fetchObject(),$this->fetchParent(),$acl);
			}
		}
		return $result;
	}
	function hasProjectEntrys($projID) {
		$query = "SELECT TaskID FROM TasksObj ";
		$query.=" WHERE FKProjID=".$this->_db->escape($projID);
		$query.=" ".$this->_db->formatLimit(0,1);
		$this->_db->query($query);
		if($this->_db->next_record()) {
			return true;
		} else {
			return false;
		}
	}
	function haveTaskEntrys($ParentID) {
		$query="SELECT TaskID FROM TasksObj WHERE FKDocID=".$this->_db->escape($ParentID);
		$query.=" ".$this->_db->formatLimit(0,1);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return true;
		} else {
			return false;
		}

	}
	function getSystemObj($system,$lang,$user=-1,$use_perms=true) {
		if ($user==-1) $user=$this->_uid;
		$query="SELECT * FROM TasksMetabase WHERE System=".$this->_db->escape($system);
		$query.=" AND UserID=".$this->_db->escape($user);
		//echo $query;
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='TObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				return new $class($this->_db->f("DocID"),$this->fetchObject($lang),$this->fetchParent(),$acl);
			}
		}
	}
	function updateMeta(&$obj) {
		$values=$obj->_meta;
		if ($obj->getID()) {
			$this->_db->update('TasksMetabase',$values,"DocID=".$this->_db->escape($obj->getID()));
			return $obj->getID();
		}
		return false;
	}
	function insertMeta(&$obj) {
		$values=$obj->_meta;
		$values['DocID']=$this->_db->nextid('TasksMetabase');
		if ($this->_db->insert('TasksMetabase',$values)) {
			$obj->setID($values['DocID']);
			return $obj->getID();
		}
		return false;
	}
	function deleteMeta(&$obj) {
		$query="DELETE FROM TasksMetabase WHERE DocID=".$this->_db->escape($obj->getID());
		$this->_db->query($query);
		if ($this->_db->affected_rows()) {
			return true;
		}
		return false;
	}
	function getObj($ID,$lang='',$use_perms=true) {
		$query="SELECT * FROM TasksMetabase ";
		$query.=" WHERE DocID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='TObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				return new $class($this->_db->f("DocID"),$this->fetchObject($lang),$this->fetchParent(),$acl);
			}
		}
	}
	function searchObj($search,$use_perms=true) {
		$query="SELECT * FROM TasksMetabase ";
		$query.=" WHERE ".$this->_db->getWhere($search);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$class='TObj_'.$this->_db->f("DocType");
			$acl=$this->fetchACL();
			if ($acl || !$use_perms) {
				return new $class($this->_db->f("DocID"),$this->fetchObject($lang),$this->fetchParent(),$acl);
			}
		}
	}
	function catName2ID($Name,$RootID,$ParentID,$lang='',$create=false,$sep='.',$escape='\\') {
		if (!$lang) $lang=$this->_lang;
		$pieces=Framework::splitVal($Name,$sep);
		foreach ($pieces as $val) {
			$val=Framework::unescapeVal($val,$escape);
			if ($val) {
				$search=array();
				if ($RootID) {
					$search[]=array('Field'=>'RootID','Typ'=>'=','Values'=>$RootID);
				} elseif (!$ParentID) {
					$subQuery=array();
					$subQuery[]=array(
						array('Field'=>'UserID','Typ'=>'=','Values'=>$this->_frm->getUser()),
						array('Field'=>'System','Typ'=>'=','Values'=>'u'),
					);
					$subQuery[]=array(
						array('Field'=>'UserID','Typ'=>'=','Values'=>0),
						array('Field'=>'System','Typ'=>'=','Values'=>'s'),
					);
					$search[]=array('Typ'=>'OR','Values'=>$subQuery);
				}

				$search[]=array('Field'=>'ParentID','Typ'=>'=','Values'=>$ParentID);
				$search[]=array('Field'=>'Title_'.$lang,'Typ'=>'regexp','Values'=>'^'.str_replace(' ','[,;. ]',preg_quote($val,'')).'$');

				if ($catObj=$this->searchObj($search)) {
					$ParentID=$catObj->getID();
				} elseif ($create && $ParentID) {
					$catObj=new TObj_fol();
					$catObj->setMeta('ParentID',$ParentID);
					$catObj->setMeta('RootID',$RootID);
					$catObj->setMeta('TimeCreate',time());
					$catObj->setMeta('TimeModify',time());
					$catObj->setMeta('UserCreate',0);
					$catObj->setMeta('UserModify',0);
					foreach($this->_frm->getMaLang() as $lval) {
						$catObj->setMeta('Title_'.$lval,trim($val));
					}
					$this->insertMeta($catObj);
					$ParentID=$catObj->getID();
					//print_r($val);
				} else {
					return 0;
				}
			}
		}
		return $ParentID;
	}
	function getName($ID,$lang='') {
		if (!$lang) $lang=$this->_lang;
		$query="SELECT Title_".$lang." FROM TasksMetabase ";
		$query.=" WHERE DocID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f("Title_".$lang);
		}
		return '';
	}
	function nameExists($Name,$uid=0,$lang=0) {
		if (!$uid) $uid=$this->_uid;
		if (!$lang) $lang=$this->_lang;
		if ($uid && $lang) {
			$query="SELECT DocID FROM TasksMetabase ";
			$query.=" WHERE Title_".$lang."=".$this->_db->escape($Name);
			$query.=" AND UserID=".$this->_db->escape($uid).'';
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				return $this->_db->f("DocID");
			}
		}
		return false;
	}
	function &fetchACL() {
		//echo $this->_db->f('Title_de').'-'.$this->_db->f('UserID').'<br>';
		if (($this->isRuleUser() && !$this->_db->f('UserID')) || $this->_db->f('UserID')==$this->_uid) {
			return -1;
		} else {
			return $this->_frm->calcAcl($this->_db->f('Users'),$this->_db->f('Groups'),$this->_uid);
		}
	}

	function &fetchObject($lang='') {
		$result=array(
			'RootID'=>$this->_db->f('RootID'),
			'ParentID'=>$this->_db->f("ParentID"),
			'MenuImage'=>$this->_db->f("MenuImage"),
			'TimeCreate'=>$this->_db->f("TimeCreate"),
			'TimeModify'=>$this->_db->f("TimeModify"),
			'UserCreate'=>$this->_db->f("UserCreate"),
			'UserModify'=>$this->_db->f("UserModify"),
			'DocType'=>$this->_db->f("DocType"),
			'Users'=>$this->_db->f("Users"),
			'Groups'=>$this->_db->f("Groups"),
			'UserID'=>$this->_db->f("UserID"),
			'System'=>$this->_db->f('System'),
		);
		if (!$lang) $lang=$this->_lang;
		if (is_array($lang)) {
			foreach ($lang as $val) {
				$result['Title_'.$val]=$this->_db->f("Title_".$val);
			}
		} else {
			$result['Title_'.$lang]=$this->_db->f("Title_".$lang);
		}
		return $result;
	}
	function &fetchParent() {
		return array();
	}
	function isAllowedAction(&$obj,&$action) {
		if (!is_array($action)) return false;
		if (!$obj->getAcl($action['Perms'])) return false;
		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkAction($obj,substr($ac_val,1));
				} else {
					$result=$result||$this->_checkAction($obj,$ac_val);
				}
			}
			if (!$result) return false;
		}
		return true;
	}
	function _checkAction(&$obj,$action) {
		switch ($action) {
			case 'sadmin':
				if (!$this->isSuperAdmin()) return false;
			break;
			case 'rule':
				if (!$this->isRuleUser()) return false;
			break;
			case 'root':
				if ($obj->getMeta('RootID')!=$obj->getID()) return false;
			break;
			case 'root_s':
				if ($this->_root_obj->getMeta('System')!='s') return false;
			break;
			case 'root_d':
				if ($this->_root_obj->getMeta('System')!='d') return false;
			break;
			case 'root_u':
				if ($this->_root_obj->getMeta('System')!='u') return false;
			break;
			case 'root_a':
				if ($this->_root_obj->getMeta('System')!='a') return false;
			break;
			case 'app_msg':
				if (!$GLOBALS['app']['msg']) return false;
			break;
			case 'app_mail':
				if (!$GLOBALS['app']['email']) return false;
			break;
			case 'app_rem':
				if (!$GLOBALS['app']['rem']) return false;
			break;
			case 'content':
				return $this->haveTaskEntrys($obj->getID());
			break;

		}
		return true;
	}
	function isAllowedTAction(&$obj,&$action) {
		if (!is_array($action)) return false;
		//if ($action['Perms'] && !$this->getCalPerms($action['Perms'])) return false;
		foreach ($action['Extra'] as $val) {
			$check=explode('|',$val);
			$result=false;
			foreach ($check as $ac_val) {
				if ($ac_val[0]=='!') {
					$result=$result||!$this->_checkTAction($obj,substr($ac_val,1));
				} else {
					$result=$result||$this->_checkTAction($obj,$ac_val);
				}
			}
			//echo $ac_val;debug($result);
			if (!$result) return false;
		}
		return true;
	}
	function _checkTAction(&$obj,$action) {
		switch ($action) {
			case 'owner':
				if ($obj['OwnerID']!=$this->getUser()) return false;
			break;
			case 'rec':
				if (!$obj['RecType']) return false;
			break;
			case 'stat4':
				if ($obj['Status']!=4) return false;
			break;
			case 'app_msg':
				if (!$GLOBALS['app']['msg']) return false;
			break;
			case 'app_mail':
				if (!$GLOBALS['app']['email']) return false;
			break;
			case 'member':
				if ($obj['OwnerID']==$this->getUser()) return false;
				$staus=$this->getTaskUsers($obj['TaskID']);
				if ($staus[$this->getUser()]!=1) {
					return false;
				}
			break;
		}
		return true;
	}
		     //listTask($rows,$user,0,-1,0,0,$endweek,$startweek,0,0,0,0,0,'EndDate ASC,Priority ASC');
	function listTask(&$rows,$user,$typ,$done,$before,$after,$ebefore,$eafter,$cat,$root,$alarm,$fall,$status,$order,$b=0,$limit=0) {
		$query="SELECT TasksObj.*,TasksObjUser.*,TasksMetabase.Title_".$this->_lang." as Cat FROM TasksObjUser,TasksObj ";
		$query.="LEFT JOIN TasksMetabase ON (FKDocID=DocID) WHERE ";
		$where[]="FKTaskID=TaskID AND FKUserID=".$this->_db->escape($user);
		if (is_array($typ)) $where[]="TaskType IN (".implode(",",$this->_db->escape($typ)).")";
		elseif ($typ) $where[]="TaskType=".$this->_db->escape($typ);
		if ($done==-1) {
			$where[]="(Done=1 OR (OwnerID=".$this->_db->escape($user)." AND Status!=4))";
		} elseif (is_array($done)) $where[]="Done IN (".implode(",",$this->_db->escape($done)).")";
		elseif($done) $where[]="Done=".$this->_db->escape($done);
		if($before) $where[]="StartDate<=".$this->_db->escape($before);
		if($after) $where[]="StartDate>".$this->_db->escape($after);
		if($ebefore) $where[]="EndDate<=".$this->_db->escape($ebefore);
		if($eafter) $where[]="EndDate>".$this->_db->escape($eafter);
		if($alarm) $where[]="(Alarm!=0 AND (EndDate - 3600*24*Alarm)<".$this->_db->escape($alarm).")";
		if ($fall==1) $where[]="StartDate!=Enddate";
		if ($fall==-1) $where[]="StartDate=Enddate";
		if ($status==-1) $where[]="(Status!=4 OR TaskType='c')";
		elseif($status) $where[]="Status=".$this->_db->escape($status);
		if($cat)  $where[]="FKDocID=".$this->_db->escape($cat);
		if($root) $where[]="RootID=".$this->_db->escape($root);
		$query.=implode(' AND ',$where);

		if ($order) $query.=" ORDER BY $order";
		if ($limit) $query.=' '.$this->_db->formatLimit($b,$limit);
		//echo $query;
		$result=array();
		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		while ($this->_db->next_record()) {
			$result[$this->_db->f("TaskID")]=$this->fetchList();
		}
		if ($limit && ($b!=0 || $limit==$rows)) {
			$query="SELECT count(*) as num FROM TasksObj,TasksObjUser WHERE ";
			$query.=implode(' AND ',$where);
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
		}

		return $result;
	}
	function searchTask (&$rows,$b,$limit,$sql_search,$order) {
		$query="SELECT TasksObj.*,TasksObjUser.*,TasksMetabase.Title_".$this->_lang." as Cat FROM TasksObjUser,TasksObj ";
		$query.="LEFT JOIN TasksMetabase ON (FKDocID=DocID) WHERE ";
		$where="FKTaskID=TaskID AND ";
		if (is_array($sql_search)) {
			$where.=$this->_db->getWhere($sql_search);
		} else {
			$where.=$sql_search;
		}
		$query.=$where.' GROUP BY TaskID';

		if ($order) $query.=" ORDER BY $order";
		if ($limit) $query.=' '.$this->_db->formatLimit($b,$limit);
		//echo $query;
		$result=array();
		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		while ($this->_db->next_record()) {
			$result[$this->_db->f("TaskID")]=$this->fetchList();
		}
		if ($limit && ($b!=0 || $limit==$rows)) {
			$query="SELECT count(DISTINCT TaskID) as num FROM TasksObjUser,TasksObj ";
			$query.="LEFT JOIN TasksMetabase ON (FKDocID=DocID) WHERE ".$where;
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
			//echo $rows;
		}

		return $result;
	}
	function searchProjectTask (&$rows,$b,$limit,$sql_search,$order) {
		$query="SELECT TasksObj.*,TasksObjUser.* FROM TasksObjUser,TasksObj ";
		$where="WHERE FKTaskID=TaskID AND $sql_search";
		$query.=$where.' GROUP BY TaskID';

		if ($order) $query.=" ORDER BY $order";
		if ($limit) $query.=' '.$this->_db->formatLimit($b,$limit);
		//echo $query;
		$result=array();
		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		while ($this->_db->next_record()) {
			$result[$this->_db->f("TaskID")]=$this->fetchList();
		}
		if ($limit && ($b!=0 || $limit==$rows)) {
			$query="SELECT count(DISTINCT TaskID) as num FROM TasksObj,TasksObjUser WHERE $where";
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
			//echo $rows;
		}

		return $result;
	}
	function fetchList() {
		return array(
			"TaskID"=>$this->_db->f("TaskID"),
			"Title"=>$this->_db->f("Title"),
			"Text"=>$this->_db->f("Text"),
			"StartDate"=>$this->_db->f("StartDate"),
			"EndDate"=>$this->_db->f("EndDate"),
			"Priority"=>$this->_db->f("Priority"),
			"TaskType"=>$this->_db->f("TaskType"),
			"Done"=>$this->_db->f("Done"),
			"Status"=>$this->_db->f("Status"),
			"Unread"=>$this->_db->f("Unread"),
			'ID'=>$this->_db->f("TaskID"),
			'OwnerID'=>$this->_db->f("OwnerID"),
			'StatusDate'=>$this->_db->f("StatusDate"),
			'Alarm'=>$this->_db->f("Alarm"),
			'FKDocID'=>$this->_db->f("FKDocID"),
			'FKProjID'=>$this->_db->f("FKProjID"),
			'CatName'=>$this->_db->f("Cat"),
			'Users'=>$this->_db->f("Users"),
			'Groups'=>$this->_db->f("Groups"),
			"InvitAddr"=>$this->_db->f("InvitAddr"),
			'Deleg'=>$this->_db->f("Deleg"),
			"TimeModify"=>$this->_db->f("TimeModify"),
		);
	}
	function readTask($TaskID,$archiv=0) {
		$this->_db->query("SELECT * FROM TasksObj WHERE TaskID='$TaskID'");
		if ($this->_db->next_record()) {
				$task["TaskID"]=$this->_db->f("TaskID");
				$task["Title"]=$this->_db->f("Title");
				$task["Text"]=$this->_db->f("Text");
				$task["StartDate"]=$this->_db->f("StartDate");
				$task["EndDate"]=$this->_db->f("EndDate");
				$task["Alarm"]=$this->_db->f("Alarm");
				$task["OwnerID"]=$this->_db->f("OwnerID");
				$task["Users"]=$this->_db->f("Users");
				$task["Groups"]=$this->_db->f("Groups");
				$task["Priority"]=$this->_db->f("Priority");
				$task["TimeCreate"]=$this->_db->f("TimeCreate");
				$task["TimeModify"]=$this->_db->f("TimeModify");
				$task["RecDate"]=$this->_db->f("RecDate");
				$task["RecType"]=$this->_db->f("RecType");
				$task["RecInt"]=$this->_db->f("RecInt");
				$task["Notes"]=$this->_db->f("Notes");
				$task["Deleg"]=$this->_db->f("Deleg");
				$task["Status"]=$this->_db->f("Status");
				$task["DoneOne"]=$this->_db->f("DoneOne");
				$task["StatusDate"]=$this->_db->f("StatusDate");
				$task["FKDocID"]=$this->_db->f("FKDocID");
				$task["FKProjID"]=$this->_db->f("FKProjID");
				$task["InvitAddr"]=$this->_db->f("InvitAddr");
				return $task;
		} return 0;
	}
	function readTaskUser($TaskID,$user,$archiv=0) {
		$query="SELECT * FROM TasksObjUser WHERE FKTaskID=".$this->_db->escape($TaskID);
		if ($user) $query.=" AND FKUserID =".$this->_db->escape($user);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$task[$this->_db->f("FKUserID")]["Done"]=$this->_db->f("Done");
			$task[$this->_db->f("FKUserID")]["Unread"]=$this->_db->f("Unread");
			$task[$this->_db->f("FKUserID")]["TaskType"]=$this->_db->f("TaskType");
		}
		return $user?$task[$user]:$task;
	}
	function saveAllTask($TaskObj,$TaskUsers,$Typ) {
		if ($Typ=='t') {
			$TaskObj['Status']=2;
			unset($TaskUsers[$TaskObj['OwnerID']]);
		} else $TaskObj['Status']=1;
		$task_users=array_keys($TaskUsers);
		$ID=$this->saveTask($TaskObj);
		if ($Typ=='t' && $TaskObj["Deleg"]) {
			$this->saveTaskUsers($ID,array($TaskObj['OwnerID']),'c',5);
			if (count($task_users)==1) $Typ='p';
		}
		if ($Typ=='t' && !$TaskObj["Deleg"]) {
			if ($TaskObj['EndDate']==$TaskObj['StartDate']) $Typ='d';
			$this->saveTaskUsers($ID,array($TaskObj['OwnerID']),$Typ,1);
		}
		if ($Typ=='p' && $TaskObj['EndDate']==$TaskObj['StartDate']) $Typ='o';
		if ($Typ=='t' && $TaskObj['EndDate']==$TaskObj['StartDate']) $Typ='d';
		$this->saveTaskUsers($ID,$task_users,$Typ,$TaskObj['Status']);
		return $ID;
	}
	function saveTask($obj)  {
		$obj['TaskID']=$this->_db->nextid('Tasks');
		if (!$obj['TimeModify']) $obj['TimeModify']=time();
		if (!$obj['UserModify']) $obj['UserModify']=addslashes($this->_uid);
		$this->_db->insert('TasksObj',$obj);
		$this->_db->query($query);
		return $obj['TaskID'];
	}
	function updateTask($ID,$obj)  {
		if (!$obj['TimeModify']) $obj['TimeModify']=time();
		if (!$obj['UserModify']) $obj['UserModify']=addslashes($this->_uid);

		$this->_db->update('TasksObj',$obj,"TaskID=".$this->_db->escape($ID));
		return $ID;
	}
	function checkTaskStatus($ID,$DoneOne=0) {
		$query="SELECT sum(Done=1) as accept, ";
		$query.="sum(Done=2) as wait, ";
		$query.="sum(Done=3) as deny, ";
		$query.="sum(Done=4) as finish FROM TasksObjUser WHERE FKTaskID=".$this->_db->escape($ID)." GROUP BY FKTaskID";
		$this->_db->query($query);
		$this->_db->next_Record();
		if ($DoneOne && $this->_db->f('finish')) return 4;
		if ($this->_db->f('deny')) {
				if ($DoneOne) {
						if ($this->_db->f('wait')) return 2;
						if ($this->_db->f('accept')) return 1;
						return 3;
				} else return 3;
		}
		if ($this->_db->f('wait')) return 2;
		if ($this->_db->f('accept')) return 1;
		if ($this->_db->f('finish')) return 4;


	}
	function updateUserStatus($ID,$user,$done,$archiv='') {
		$query="UPDATE TasksObjUser SET done=".$this->_db->escape($done)." WHERE FKTaskID=".$this->_db->escape($ID)." AND FKUserID=".$this->_db->escape($user);
		$this->_db->query($query);
	}
	function setUnread($ID,$user) {
		$query="UPDATE TasksObjUser SET unread=1 WHERE FKTaskID=".$this->_db->escape($ID)." ";
		$query.="AND FKUserID!=".$this->_db->escape($user);
		$this->_db->query($query);
	}
	function clearUnread($ID,$user,$archiv=0) {
		$query="UPDATE TasksObjUser SET unread=0 WHERE FKTaskID=".$this->_db->escape($ID)." ";
		$query.="AND FKUserID=".$this->_db->escape($user);
		$this->_db->query($query);
	}
	function saveTaskUsers ($ID,$users,$typ,$done=0,$unread=0) {
		foreach ($users as $val) {
			$insert=array(
				'FKTaskID'=>$ID,
				'FKUserID'=>$val,
				'Done'=>$done,
				'TaskType'=>$typ,
				'Unread'=>$unread,

			);
			$this->_db->insert('TasksObjUser',$insert);
		}
	}
	function updateTaskUsers ($ID,$user,$Obj) {
		$where=" FKTaskID=".$this->_db->escape($ID)." ";
		if (is_array($user)) $where.=" AND FKUserID IN (".implode(",",$this->_db->escape($user)).")";
		elseif ($user) $where.=" AND FKUserID=".$this->_db->escape($user);
		$this->_db->update('TasksObjUser',$Obj,$where);
	}

	function copyTask ($TaskID,$TaskObj) {
		//var_dump($TaskObj);
		$ID=$this->saveTask($TaskObj);
		$TaskUsers=$this->readTaskUser($TaskID,0);
		foreach ($TaskUsers as $key=>$val) {
			if ($val["Done"]==4) $val["Done"]=1;
			//echo $key."-".$val["TaskType"]."-".$val["Done"];
			$this->saveTaskUsers($ID,array($key),$val["TaskType"],$val["Done"],0);
		}
		$TaskLog=$this->listLog($TaskID,array('accept','deny'));
		foreach ($TaskLog as $val) {
			$this->insertLog ($ID,$val["User"],$val["Text"],$val["Type"],$val["Date"]);

		}
		$tmp_status=$this->checkTaskStatus($ID);
		if ($tmp_status!=$TaskObj['Status']) {
			$this->updateTask($ID,array('Status'=>$tmp_status,'StatusDate'=>time()));
		}
		return $ID;

	}
	function deleteTaskUsers($ID,$user=0,$archiv=0) {
		$query="DELETE FROM TasksObjUser WHERE";
		if (is_array($ID)) $query.=" FKTaskID IN (".implode(",",$this->_db->escape($ID)).")";
		else $query.=" FKTaskID=".$this->_db->escape($ID);
		if (is_array($user)) $query.=" AND FKUserID IN (".implode(",",$this->_db->escape($user)).")";
		elseif($user) $query.=" AND FKUserID=".$this->_db->escape($user);
		$this->_db->query($query);
	}
	function getNumTaskUsers($ID) {
		$query="SELECT count(*) as num FROM TasksObjUser WHERE FKTaskID=".$this->_db->escape($ID);
		$this->_db->query($query);
		$this->_db->next_Record();
		return $this->_db->f('num');

	}
	function getTaskUsers($ID,$archiv=0) {
		$query="SELECT FKUserID,Done FROM TasksObjUser WHERE FKTaskID=".$this->_db->escape($ID);
		$this->_db->query($query);
		while ($this->_db->next_Record()) {
			$result[$this->_db->f('FKUserID')]=$this->_db->f('Done');
		}
		return $result;

	}
	function getTaskUserData($ID) {
		$query="SELECT * FROM TasksObjUser WHERE FKTaskID=".$this->_db->escape($ID);
		$this->_db->query($query);
		while ($this->_db->next_Record()) {
			$result[$this->_db->f('FKUserID')]=array(
				'Done'=>$this->_db->f('Done'),
				'Unread'=>$this->_db->f('Unread'),

			);;
		}
		return $result;

	}
	function getPrjUsers($ID) {
		$result=array();
		$query="SELECT DISTINCT TasksObjUser.FKUserID FROM TasksObjUser,TasksObj WHERE FKTaskID=TaskID AND FKProjID=".$this->_db->escape($ID);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f("FKUserID");
		}
		return $result;
	}
	function deleteTask($ID,$archiv=0) {
		$query="DELETE FROM TasksObj WHERE";
		if (is_array($ID)) $query.=" TaskID IN (".implode(",",$this->_db->escape($ID)).")";
		else $query.=" TaskID=".$this->_db->escape($ID);
		$this->_db->query($query);
	}
	function deleteTaskObject (&$TaskObj,$one=0) {
		if ($TaskObj) {
			if ($TaskObj['Notes'] && $TaskObj['Satus']!=4) {
				$TaskUsers=$this->getTaskUsers($TaskObj['TaskID']);
				$send_user=array();
				foreach ($TaskUsers as $key=>$val) {
					if ($key!=$this->getAuthUser() && $val!=3 && $val!=2 && $val!=4) {
						$send_user[]=$key;
					}
				}
				if (!empty($send_user)) {
					$log_tras=array(
						'{EBEGIN}'=>date('d.m.Y',$TaskObj['StartDate']),
						'{ETITLE}'=>trim($TaskObj['Title']),
						'{ETEXT}'=>trim($TaskObj['Text']),
					);
					if ($TaskObj['StartDate']!=$TaskObj['EndDate']) $log_tras['{EEND}']=date('d.m.Y',$TaskObj['EndDate']); else $log_tras['{EEND}']='-';

					$this->_frm->sendmessage($send_user,
							$this->getAuthUser(),
							strtr($GLOBALS['T']->lang('[[task_action_delete_title]]'),$log_tras),
							strtr($GLOBALS['T']->lang('[[task_action_delete_text]]'),$log_tras),
							"",
							"",
							$GLOBALS['IMG_NOTES']);
				}

			}
			if ($one) {

			}
			$this->deleteTaskUsers($TaskObj['TaskID'],'');
			$this->deleteTaskLog($TaskObj['TaskID'],'');
			$this->deleteTask($TaskObj['TaskID']);
		}
		return false;
	}


	function insertLog ($TaskID,$user,$text,$typ,$date=0) {
		$values=array(
			'FKTaskID'=>$TaskID,
			'FKUserID'=>$user,
			'Text'=>$text,
			'Type'=>$typ,
			'Date'=>($date?$date:time()),

		);
		if ($typ=='accept' || $typ=='deny' || $typ=='disinvite') {
			$this->deleteUserTaskLog($TaskID,$user);
		}
		$this->_db->insert('TasksObjLog',$values);
	}
	function deleteUserTaskLog($ID,$user) {
		$query="DELETE FROM TasksObjLog WHERE";
		$query.=" FKTaskID=".$this->_db->escape($ID);
		$query.=" AND FKUserID=".$this->_db->escape($user);
		$query.=" AND `Type`!='log'";
		$this->_db->query($query);
	}
	function deleteTaskLog($ID,$user=0,$archiv=0) {
		$query="DELETE FROM TasksObjLog WHERE";
		if (is_array($ID)) $query.=" FKTaskID IN (".implode(",",$this->_db->escape($ID)).")";
		else $query.=" FKTaskID=".$this->_db->escape($ID);
		if (is_array($user)) $query.=" AND FKUserID IN (".implode(",",$this->_db->escape($user)).")";
		elseif($user) $query.=" AND FKUserID=".$this->_db->escape($user);
		$this->_db->query($query);

	}

	function listLog($TaskID,$typ='',$user='',$archiv=0) {
		$result=array();
		$query="SELECT * FROM TasksObjLog WHERE FKTaskID=".$this->_db->escape($TaskID)." ";
		if (is_array($typ)) $query.=" AND Type IN (".implode(",",$this->_db->escape($typ)).")";
		elseif ($typ) $query.=" AND Type=".$this->_db->escape($typ);
		if ($user) $query.=" AND FKUserID=".$this->_db->escape($user);
		$query.=' ORDER BY Date DESC';
		$this->_db->query($query);

		
		while ($this->_db->next_record()) {
			$result[$this->_db->f("LogID")]=array(
				"Text"=>$this->_db->f("Text"),
				"Date"=>$this->_db->f("Date"),
				"User"=>$this->_db->f("FKUserID"),
				"Type"=>$this->_db->f("Type"),
			);
		}

		return $result;
	}
	function listLastLog($TaskID,$typ='',$user='') {
		$result=array();
		$sql_search=$result=array();
		$sql_search[]=array('Field'=>'s2.Date','Typ'=>'null');
		$sql_search[]=array('Field'=>'s1.FKTaskID','Typ'=>'=','Values'=>$TaskID);
		if ($typ) $sql_search[]=array('Field'=>'s1.Type','Typ'=>'=','Values'=>$typ);
		if ($user) $sql_search[]=array('Field'=>'s1.FKUserID','Typ'=>'=','Values'=>$user);
		$query="SELECT s1.* FROM TasksObjLog s1 LEFT JOIN TasksObjLog s2 ON (s1.FKTaskID = s2.FKTaskID AND s1.Date < s2.Date) WHERE ".$this->_db->getWhere($sql_search);
		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f("FKTaskID")]=array(
				"Text"=>$this->_db->f("Text"),
				"Date"=>$this->_db->f("Date"),
				"User"=>$this->_db->f("FKUserID"),
				"Type"=>$this->_db->f("Type"),
				"LogID"=>$this->_db->f("LogID"),
			);
		}
		return $result;
	}

	function deleteLog($ID) {
		$query="DELETE FROM TasksObjLog WHERE LogID=".$this->_db->escape($ID);
		$this->_db->query($query);
	}
	function nextRecurrence($start,$end,$rec_type,$int,$rec_end)    {
		$s_day=date('d',$start);
		$s_month=date('m',$start);
		$s_year=date('Y',$start);
		$s_hour=date('H',$start);
		$s_min=date('i',$start);
		$e_day=date('d',$end);
		$e_month=date('m',$end);
		$e_year=date('Y',$end);
		$e_hour=date('H',$end);
		$e_min=date('i',$end);
		switch ($rec_type) {
				case 1:
						$next_start=mktime($s_hour,$s_min,0,$s_month,$s_day+$int,$s_year);
						$next_end=mktime($e_hour,$e_min,0,$e_month,$e_day+$int,$e_year);
						break;
				case 2:
						$next_start=mktime($s_hour,$s_min,0,$s_month,$s_day+($int*7),$s_year);
						$next_end=mktime($e_hour,$e_min,0,$e_month,$e_day+($int*7),$e_year);
						break;
				case 3:
						$next_start=mktime($s_hour,$s_min,0,$s_month+$int,$s_day,$s_year);
						$next_end=mktime($e_hour,$e_min,0,$e_month+$int,$e_day,$e_year);
						break;
				case 4:
						return false;
						break;
				case 5:
						$next_start=mktime($s_hour,$s_min,0,$s_month,$s_day,$s_year+$int);
						$next_end=mktime($e_hour,$e_min,0,$e_month,$e_day,$e_year+$int);
						break;

		}
		if ($rec_end==-1 || ($next_start<$rec_end && $next_end<$rec_end)) return array("start"=>$next_start,"end"=>$next_end);
		else return false;
	}
	function saveTplTask($name,$users,$obj)  {
		$values=array(
			'TplObject'=>serialize($obj),
			'TplName'=>$name,
			'TplOwnerID'=>$this->_uid,
			'TplUsers'=>$users,
		);
		$this->_db->insert('TasksTpl',$values);
 	}
	function updateTplTask($TplID,$name,$users,$obj) {
		$values=array(
			'TplObject'=>serialize($obj),
			'TplName'=>$name,
			'TplOwnerID'=>$this->_uid,
			'TplUsers'=>$users,
		);
		$this->_db->update('TasksTpl',$values,"TplID=".$this->_db->escape($TplID));
	}
	function listTplTask($users=0) {
		$result=array();
		$query="SELECT TplID,TplName,TplOwnerID,TplUsers FROM TasksTpl WHERE TplOwnerID=".$this->_db->escape($this->_uid)." ";
		if (is_array($users)) $query.=" OR TplUsers IN (".implode(",",$this->_db->escape($users)).") ";
		elseif ($users) $query.=" OR TplUsers=".$this->_db->escape($users)." ";
		$query.="ORDER BY TplName";
		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_Record()) {
			$result[$this->_db->f('TplID')]=array(
				'TplName'=>$this->_db->f('TplName'),
				'TplOwnerID'=>$this->_db->f('TplOwnerID'),
				'TplUsers'=>$this->_db->f('TplUsers'),
			);
		}
		return $result;

	}
	function readTplTask ($TplID) {
		$query="SELECT TplObject FROM TasksTpl WHERE TplID=".$this->_db->escape($TplID);
		$this->_db->query($query);
		if ($this->_db->next_Record()) {
			return unserialize($this->_db->f('TplObject'));
		}

	}
	function readTpl ($TplID) {
		$query="SELECT TplName,TplUsers FROM TasksTpl WHERE TplID=".$this->_db->escape($TplID)." AND TplOwnerID=".$this->_db->escape($this->_uid)."";
		$this->_db->query($query);
		if ($this->_db->next_Record()) {
			return array(
				'TplName'=>$this->_db->f('TplName'),
				'TplUsers'=>$this->_db->f('TplUsers'),
			);
		} else return false;

	}
	function deleteTplTask ($TplID) {
		$query="DELETE FROM TasksTpl WHERE TplOwnerID=".$this->_db->escape($this->_uid)." AND TplID=".$this->_db->escape($TplID);
		//echo $query;
		$this->_db->query($query);
	}
	function deleteProject($ID) {
		if ($ID) {
			$query = "SELECT TaskID FROM TasksObj WHERE FKProjID=".$this->_db->escape($ID);
			$this->_db->query($query);
			while ($this->_db->next_record()) {
				$delete[]=$this->_db->f('TaskID');
			}
			//debug($delete);

			foreach ($delete as $val) {
				$this->deleteTaskUsers($val,'',0);
				$this->deleteTaskLog($val,'',0);
				$this->deleteTask($val,0);
			}
		}
	}

	function deleteUser($uid) {
		$delete=array();
		$query = "SELECT TaskID FROM TasksObj WHERE OwnerID=".$this->_db->escape($uid);
		$query .=" AND Users='' AND Groups='' ";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$delete[]=$this->_db->f('TaskID');
		}
		//var_dump($delete);
		foreach ($delete as $val) {
			$this->deleteTaskUsers($val,'',0);
        	$this->deleteTaskLog($val,'',0);
        	$this->deleteTask($val,0);
		}

	}
	function getSyncID ($user_id=0) {
		if (!$user_id) $user_id=$this->_uid;
		$query="SELECT FKDocID FROM TasksSyncID WHERE FKUserID=".$this->_db->escape($user_id);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('FKDocID');
		} else {
			return 0;
		}
	}
	function insertSyncID ($ID) {
		$values=array(
			'FKDocID'=>$ID,
			'FKUserID'=>$this->_uid,
		);
		$this->_db->insert('TasksSyncID',$values,'',1);
	}
}
