<?php
class ObjUserFormField extends baseObj {
	public $_obj_typ='0';
	/* to owerwrite*/
	function ObjUserFormField($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function getName() {
		return $this->_meta['Name'];
	}
}

class UserFormFields extends ObjCore {
	public $_modul='uform';
	public $_table='UserFormFields';
	public $_cfgObjects=array (
		'IdField'=>'FieldID',
		'ParentField'=>'FKParentID',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'TranslationFields'=>array('Name','NameList'),
		'0'=>array(
			'ClassName'=>'ObjUserFormField',
			'Fields'=>array(
				'FieldID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'FKFormID'=>array(
					'Typ'=>'core',
				),
				'FKParentID'=>array(
					'Typ'=>'core',
				),
				'Typ'=>array(
					'Typ'=>'core',
				),
				'Sequence'=>array(
					'Typ'=>'core',
				),
				'TimeCreate'=>array(
					'Typ'=>'core',
					'Extra'=>'cTime',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserCreate'=>array(
					'Typ'=>'core',
					'Extra'=>'cUser',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
				'RefID'=>array(
					'Typ'=>'core',
				),
				'RefClass'=>array(
					'Typ'=>'core',
				),
				'Name'=>array(
					'Typ'=>'core',
				),
				'NameList'=>array(
					'Typ'=>'core',
				),
				'Value'=>array(
					'Typ'=>'core',
				),
				'Default'=>array(
					'Typ'=>'core',
				),
				'Config'=>array(
					'Typ'=>'core',
				),
				'Visibility'=>array(
					'Typ'=>'core',
				),
				'Aktiv'=>array(
					'Typ'=>'core',
				),
				'Multiple'=>array(
					'Typ'=>'core',
				),
				'Required'=>array(
					'Typ'=>'core',
				),
				'useSearch'=>array(
					'Typ'=>'core',
				),
				'useList'=>array(
					'Typ'=>'core',
				),
				'useQuick'=>array(
					'Typ'=>'core',
				),
				'useExport'=>array(
					'Typ'=>'core',
				),
				'PermsUsers'=>array(
					'Typ'=>'core',
				),
				'PermsGroups'=>array(
					'Typ'=>'core',
				),
				'PermsRules'=>array(
					'Typ'=>'core',
				),
			),
		),
	);

	public $_cfgField=array(
		'text'=>array(
			'name'=>'[[Textfeld (1 Zeile)]]',
			'sql'=>'VARCHAR( 255 ) NOT NULL',
			'ldap'=>1,
		),
		'area'=>array(
			'name'=>'[[Textfeld (mehrere Zeilen)]]',
			'sql'=>'TEXT NOT NULL',
			'ldap'=>1,
		),
		'check'=>array(
			'name'=>'[[ON/OFF (Checkbox)]]',
			'sql'=>'TINYINT NOT NULL',
			'ldap'=>1,
		),
		'select'=>array(
			'name'=>'[[Single-Choice (Dropdown)]]',
			'sql'=>'INT NOT NULL',
			'ldap'=>1,
		),
		'mselect'=>array(
			'name'=>'[[Multiple Choice]]',
			'sql'=>'BLOB NOT NULL',
			'ldap'=>1,
		),
		'date'=>array(
			'name'=>'[[Datum]]',
			'sql'=>'DATE NOT NULL',
			'ldap'=>1,
		),
		'int'=>array(
			'name'=>'[[Zahl]]',
			'sql'=>'DOUBLE NOT NULL',
			'ldap'=>1,
		),
		'file'=>array(
			'name'=>'[[Dateiupload]]',
			'sql'=>'VARCHAR( 255 ) NOT NULL',
			'ldap'=>0,
		),
		'fk_addr'=>array(
			'name'=>'[[Adresse]]',
			'sql'=>'BLOB NOT NULL',
			'ldap'=>0,
		),
		'fk_user'=>array(
			'name'=>'[[BenutzerIn]]',
			'sql'=>'BLOB NOT NULL',
			'ldap'=>0,
		),
		'fk_comp'=>array(
			'name'=>'[[Firma]]',
			'sql'=>'BLOB NOT NULL',
			'extra'=>'zef_comp',
			'ldap'=>0,
		),
		'status'=>array(
			'name'=>'[[Statusfeld - Farbe]]',
			'sql'=>'VARCHAR( 255 ) NOT NULL',
			'ldap'=>0,
		),
		'status_txt'=>array(
			'name'=>'[[Statusfeld - Text]]',
			'sql'=>'INT NOT NULL',
			'ldap'=>0,
		),
		'group'=>array(
			'name'=>'[[Feldgruppe]]',
			'sql'=>'LONGBLOB NOT NULL',
			'isGroup'=>1,
			'ldap'=>1,
		),

	);
	var $_formTable='';
	function UserFormFields() {
		global $frm;
		parent::ObjCore();
		$this->_frm=&$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}
	function setFormObj(&$Obj) {
		if (is_object($Obj)) {
			$this->_formObj=&$Obj;
			$this->_formTable=$this->_formObj->getMeta('Table');
		}
	}

	function insertObj(&$Obj,$usePerms=0) {
		if ($usePerms && $Obj->getMeta('FKParentID')) {
			$parentObj=$this->getObj($Obj->getMeta('FKParentID'));
			if (is_object($parentObj)) {
				$Obj->setMeta('PermsGroups',$parentObj->getMeta('PermsGroups'));
				$Obj->setMeta('PermsUsers',$parentObj->getMeta('PermsUsers'));
				$Obj->setMeta('PermsRules',$parentObj->getMeta('PermsRules'));
			}
		}
		$Obj->setMeta('FKFormID',$this->_formObj->getID());
		$Obj->setMeta('Sequence',$this->getNextSequence($Obj));
		$this->insertMeta($Obj);
		$this->insertSqlField($Obj);
	}
	function insertSqlField(&$Obj) {
		if ($this->_formTable && $this->_cfgField[$Obj->getMeta('Typ')]['sql']) {
			$query="ALTER TABLE `".$this->_formTable."` ADD F_".$Obj->getID();
			$query.=" ".$this->_cfgField[$Obj->getMeta('Typ')]['sql'];
			$this->_db->query($query);
		}
	}
	function updateObj(&$Obj,$usePerms=0) {
		$oldObj=$this->getObj($Obj->getID());
		if ($oldObj->getMeta('FKParentID')!=$Obj->getMeta('FKParentID')) {
			$Obj->setMeta('Sequence',$this->getNextSequence($Obj));
			if ($usePerms && $Obj->getMeta('FKParentID')) {
				$parentObj=$this->getObj($Obj->getMeta('FKParentID'));
				if (is_object($parentObj)) {
					$Obj->setMeta('PermsGroups',$parentObj->getMeta('PermsGroups'));
					$Obj->setMeta('PermsUsers',$parentObj->getMeta('PermsUsers'));
					$Obj->setMeta('PermsRules',$parentObj->getMeta('PermsRules'));
				}
			}
		}
		$this->updateMeta($Obj);
		if ($usePerms && !$Obj->getMeta('FKParentID')) {
			$subFields=$this->listParentFields($Obj->getID());
			foreach ($subFields as $subObj) {
				$subObj->setMeta('PermsGroups',$Obj->getMeta('PermsGroups'));
				$subObj->setMeta('PermsUsers',$Obj->getMeta('PermsUsers'));
				$subObj->setMeta('PermsRules',$Obj->getMeta('PermsRules'));
				$this->updateMeta($subObj);
			}
		}
		if($this->_formTable && !$this->colExists("F_".$Obj->getID())) {
			$this->insertSqlField($Obj);
		}
	}
	function deleteObj(&$Obj) {
		if ($this->_formTable && $this->colExists("F_".$Obj->getID())) {
			$query="ALTER TABLE `".$this->_formTable."` DROP F_".$Obj->getID();
			$this->_db->query($query);
		}
		switch ($Obj->getMeta('Typ')) {
			case 'select':
			case 'mselect':
				$BaseSelect=& $this->_frm->getStaticModul('uform_select');
				$entries=$BaseSelect->listSelect($Obj->getID());
				foreach ($entries as $val) {
					$BaseSelect->deleteObj($val);
				}
			break;
		}
		return $this->deleteMeta($Obj);
	}
	function listFormFields($all=false,$order="Sequence ASC") {
		$searchQuery=array(
			array('Field'=>'FKFormID','Typ'=>'=','Values'=>$this->_formObj->getID()),
		);
		if (!$all) {
			$searchQuery[]=array('Field'=>'Aktiv','Typ'=>'=','Values'=>1);
		}
		$rows=0;
		return $this->searchObj($rows,$searchQuery,$order,0,0,false,false,true);
	}
	function listParentFields($ParentID=0) {
		$searchQuery=array(
			array('Field'=>'FKFormID','Typ'=>'=','Values'=>$this->_formObj->getID()),
			array('Field'=>'FKParentID','Typ'=>'=','Values'=>$ParentID),
		);
		$rows=0;
		return $this->searchObj($rows,$searchQuery,"Sequence ASC",0,0,false,false,false);
	}
	function getFields() {
		return $this->_cfgField;
	}
	function getFieldData($ID,$key=0) {
		if (isset($this->_cfgField[$ID])) {
			if ($key) {
				if (isset($this->_cfgField[$ID][$key])) return $this->_cfgField[$ID][$key];
			} else {
				return $this->_cfgField[$ID];
			}
		}
		return false;
	}
	function getNextSequence(&$Obj) {
		$searchQuery=array(
			array('Field'=>'FKFormID','Typ'=>'=','Values'=>intval($Obj->getMeta('FKFormID'))),
			array('Field'=>'FKParentID','Typ'=>'=','Values'=>intval($Obj->getMeta('FKParentID'))),
		);
		$query="SELECT max(Sequence) as num FROM UserFormFields WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" GROUP BY FKFormID";
		$this->_db->query($query);
		$this->_db->next_record();
		return intval($this->_db->f('num') + 1);
	}
	function moveSequence (&$Obj,$dir='down') {
		$searchQuery=array(
			array('Field'=>'FKFormID','Typ'=>'=','Values'=>intval($Obj->getMeta('FKFormID'))),
			array('Field'=>'FKParentID','Typ'=>'=','Values'=>intval($Obj->getMeta('FKParentID'))),
		);
		return $this->_db->moveEntry ('UserFormFields','FieldID','Sequence',$Obj->getID(),$dir,$searchQuery);
	}
	function refExists($val,$ExcludeID=0) {
		$searchQuery=array(
			array('Field'=>'FKFormID','Typ'=>'=','Values'=>intval($this->_formObj->getID())),
			array('Field'=>'RefID','Typ'=>'=','Values'=>$val),
		);
		if ($ExcludeID) {
			$searchQuery[]=array('Field'=>'FieldID','Typ'=>'!=','Values'=>$ExcludeID);
		}
		return $this->searchSingleObj($searchQuery);
	}
	function getNextRefID() {
		$searchQuery=array(
			array('Field'=>'FKFormID','Typ'=>'=','Values'=>intval($this->_formObj->getID())),
		);
		$query="SELECT count(*) as num FROM UserFormFields WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		$this->_db->next_record();
		$num=intval($this->_db->f('num'));
		do {
			if ($num>25) {
				$result=chr(floor($num/26)+64).chr($num%26+65);
			} else {
				$result=chr($num%26+65);
			}
			$num++;
		} while ($this->refExists($result));
		return $result;
	}
	function colExists($col) {
		if ($this->_formTable) {
			$query="SHOW COLUMNS FROM ".$this->_formTable." LIKE '".$col."';";
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				return true;
			}
		}
		return false;
	}
}
?>