<?php
class ObjVacDep extends baseObj {
	public $_obj_typ='0';
	/* to owerwrite*/
	function __construct($id=0,$meta='',$acl=0) {
		parent::baseObj($id,$meta,$acl);
	}
	function isFolder() {
		return false;
	}
	function getName() {
		return $this->_meta['vacDepName'];
	}
	function getImage($open=0) {
		return 'obj_img/_ex_tree.gif';
	}
}

class Core_vac_dep extends ObjCore {
	public $_modul='vac';
	public $_table='VacDepartment';
	public $_cfgObjects=array (
		'IdField'=>'vacDepID',
		'ParentField'=>'',
		'ObjTypField'=>'',
		'UserField'=>'',
		'GroupField'=>'',
		'OwnerField'=>'',
		'TranslationFields'=>array('vacDepName'),
		'0'=>array(
			'ClassName'=>'ObjVacDep',
			'Fields'=>array(
				'vacDepID'=>array(
					'Typ'=>'core',
					'Extra'=>'ID',
				),
				'vacDepName'=>array(
					'Typ'=>'core',
				),
				'TimeModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mTime',
				),
				'UserModify'=>array(
					'Typ'=>'core',
					'Extra'=>'mUser',
				),
				'vacDepDeleted'=>array(
					'Typ'=>'core',
				),
			),
		),
	);

	function __construct() {
		global $frm;
		parent::ObjCore();
		$this->_frm=$frm;
		$this->setRule($frm->isRuleUser(array('sysadmin','vac')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}
	function insertObj(&$Obj) {
		return $this->insertMeta($Obj);
	}
	function updateObj(&$Obj) {
		return $this->updateMeta($Obj);
	}
	function deleteObj(&$Obj) {
		$Obj->setMeta('vacDepDeleted',1);
		return $this->updateObj($Obj);
	}
	function listObj($search=array(),$b=0,$limit=0) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'VacDepartment.vacDepDeleted','Typ'=>'=','Values'=>0);
		if ($search['info']) {
			$searchQuery[]=array('Field'=>array('VacDepartment.vacDepName'),'Typ'=>'concat','Values'=>$search['info']);
		}
		$rows=0;
		return $this->searchObj($rows,$searchQuery,'VacDepartment.vacDepName ASC',$b,$limit);
	}
	function insertDepUsers($obj,$users=array()) {
		foreach($users as $v) {
			$v['FKVacDepID']=$obj->getID();
			$this->_db->insert('VacDepartmentUsers',$v,'',1);
		}
	}
	function deleteDepUsers($obj,$search=array()) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'VacDepartmentUsers.FKVacDepID','Typ'=>'=','Values'=>$obj->getID());
		if (isset($search['vacDepRule'])) {
			$searchQuery[]=array('Field'=>'VacDepartmentUsers.vacDepRule','Typ'=>'=','Values'=>$search['vacDepRule']);
		}
		if ($search['FKUserType']) {
			$searchQuery[]=array('Field'=>'VacDepartmentUsers.FKUserType','Typ'=>'=','Values'=>$search['FKUserType']);
		}
		if ($search['FKUserID']) {
			$searchQuery[]=array('Field'=>'VacDepartmentUsers.FKUserID','Typ'=>'=','Values'=>$search['FKUserID']);
		}
		$this->_db->delete('VacDepartmentUsers',$searchQuery);
	}
	function listDepUsers($obj,$search=array()) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'VacDepartmentUsers.FKVacDepID','Typ'=>'=','Values'=>$obj->getID());
		if (isset($search['vacDepRule'])) {
			$searchQuery[]=array('Field'=>'VacDepartmentUsers.vacDepRule','Typ'=>'=','Values'=>$search['vacDepRule']);
		}
		$result=array();
		$query="SELECT * FROM VacDepartmentUsers WHERE ".$this->_db->getWhere($searchQuery).' ORDER BY FKUserType ASC';
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=array(
				'FKVacDepID'=>$this->_db->f('FKVacDepID'),
				'vacDepRule'=>$this->_db->f('vacDepRule'),
				'FKUserType'=>$this->_db->f('FKUserType'),
				'FKUserID'=>$this->_db->f('FKUserID'),
			);
		}
		return $result;
	}
	function getMyRules($uid=0) {
		if (!$uid) {
			$uid=$this->_frm->getUser();
		}

		$searchQueryU=array();
		$searchQueryU[]=array('Field'=>'VacDepartmentUsers.FKUserID','Typ'=>'=','Values'=>$uid);
		$searchQueryU[]=array('Field'=>'VacDepartmentUsers.FKUserType','Typ'=>'=','Values'=>'u');
		
		$searchQueryG=array();
		$searchQueryG[]=array('Field'=>'VacDepartmentUsers.FKUserID','Typ'=>'=','Values'=>$this->_frm->getMyGroups($uid));
		$searchQueryG[]=array('Field'=>'VacDepartmentUsers.FKUserType','Typ'=>'=','Values'=>'g');

		$searchQuery=array();
		$searchQuery[]=array('Field'=>'VacDepartment.VacDepID','Typ'=>'F=F','Values'=>'VacDepartmentUsers.FKVacDepID');
		$searchQuery[]=array('Field'=>'VacDepartment.vacDepDeleted','Typ'=>'=','Values'=>0);
		$searchQuery[]=array('Typ'=>'OR','Values'=>array($searchQueryU,$searchQueryG));
		
		$result=array();
		$query="SELECT DISTINCT FKVacDepID,vacDepRule FROM VacDepartment,VacDepartmentUsers WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('vacDepRule')][]=$this->_db->f('FKVacDepID');
		}
		return $result;
		
	}
	function getMyUsers($FKVacDepID,$vacDepRule=0) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'VacDepartmentUsers.FKVacDepID','Typ'=>'=','Values'=>$FKVacDepID);
		$searchQuery[]=array('Field'=>'VacDepartmentUsers.vacDepRule','Typ'=>'=','Values'=>$vacDepRule);

		$result=array(
			'u'=>array(),
			'g'=>array(),
		);
		$groups=array();
		$query="SELECT DISTINCT FKUserID,FKUserType FROM VacDepartmentUsers WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('FKUserType')][]=$this->_db->f('FKUserID');
		}
		if (!empty($result['g'])) {
			$result['u']=array_merge($result['u'],$this->_frm->getGroupUsers($result['g']));
		}
		return array_unique($result['u']);
		
	}
}
?>
