<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class groupeWebDavAuth implements ezcWebdavBasicAuthenticator,groupeWebDavAuthorizer,ezcWebdavLockAuthorizer {
    protected $_frm;
    public function __construct(Framework $frm) {
		$this->_frm=$frm;
		$this->_DavFmng=groupeWebDavFmng::getInstance();
    }
    public function authenticateAnonymous( ezcWebdavAnonymousAuth $data )  {
        return false;
    }
    public function authenticateBasic( ezcWebdavBasicAuth $data ) {
		if (defined('GE_userDomainSuffix') && GE_userDomainSuffix && $GLOBALS['CFG']['USER_CLASS']=='ldap_full') {
			$username=$data->username.'_'.GE_userDomainSuffix;
		} elseif (GE_DOMAIN && $GLOBALS['CFG']['USER_CLASS']=='ldap_full') {
			$username=$data->username.'_'.str_replace('.','_',GE_DOMAIN);
		} else {
			$username=$data->username;
		}
        $password = $data->password;
        if (!$_SESSION['uid']) {
			$_SESSION['uid']=$this->_frm->checkPassword($username,$password);
			$_SESSION['lang']=$this->_frm->getDefaults('global','lang');
		}
		if ($_SESSION['uid']) {
			$this->_frm->setUser($_SESSION['uid']);
			$this->_frm->setLang($_SESSION['lang']);
			$this->_DavFmng->initUser();
		}
        return ($_SESSION['uid']?true:false);
    }
    public function authorize( $user, $path, $access = groupeWebDavAuthorizer::ACCESS_READ )  {
		if (!$this->_DavFmng->exists($path)) {
			$path=$this->_DavFmng->getParentFolder($path);
			//debugFile('Authorize:'.$access.' - parentPath',1);
		}
		if ($this->_DavFmng->exists($path)) {
			debugFile('Authorize:'.$path.':'.$access.' - '.$this->_DavFmng->getAcl($path,$access),1);
			return $this->_DavFmng->getAcl($path,$access);
		}
        return false;
    }
    public function assignLock($user,$lockToken) {
		debugFile('assignLock:'.$user.':'.$lockToken,1);
		$this->_DavFmng->assignLock($user,$lockToken);
    }
    public function ownsLock($user,$lockToken) {
		$result=$this->_DavFmng->ownsLock($user,$lockToken);
		debugFile('ownsLock:'.$user.':'.$lockToken.':'.$result,1);
		return $result;
    }
    public function releaseLock($user,$lockToken) {
		debugFile('releaseLock:'.$user.':'.$lockToken,1);
		$this->_DavFmng->releaseLock($user,$lockToken);
    }
}
?>