<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class groupeWebDavFmng {
    protected static $instance;
    protected $_frm;
    protected $_fmng;
    protected $_P=false;
    protected $_cache;
    protected $_tree;
    protected $outcharset='UTF-8';
    protected $incharset='UTF-8';
    public function __construct() {
		global $frm;
		$this->_frm=$frm;
        $this->incharset=GE_CHARSET;
        if (preg_match('/microsoft/i',$_SERVER['HTTP_USER_AGENT'])) {
			$this->outcharset='WINDOWS-1252';
        }
        if (preg_match('/utf-8/i',$_SERVER['HTTP_ACCEPT_CHARSET'])) {
			$this->outcharset='UTF-8';
        }
        if (preg_match('/utf-8/i',$_SERVER['CONTENT_TYPE'])) {
			$this->outcharset='UTF-8';
        }
    }
    public static function getInstance() {
        if ( self::$instance === null ) {
            self::$instance = new groupeWebDavFmng();
        }
        return self::$instance;
    }
    protected function path2Data($path) {
		//debugFile('issetPath:'.$path.':'.isset($this->_cache[$path]),1);
		if ($path && !isset($this->_cache[$path])) {
			$pathArray=explode('/',substr($path,1));
			$aktPath='';
			$parentPath='/';
			foreach ($pathArray as $val) {
				$aktPath.='/'.$val;
				if (is_object($this->_cache[$parentPath])) {
					if (!isset($this->_cache[$aktPath])) {
						$this->_cache[$aktPath]=$this->_fmng->searchObjByName($this->_cache[$parentPath]->getID(),$this->decode($val));
						if ( is_object($this->_cache[$aktPath])) {
							$this->_cache[$aktPath]->davPath=$aktPath;
							if (!$this->_cache[$parentPath]->getAcl(1)) {
								$this->_cache[$aktPath]->setAcl(0);
								debugFile('No Parent ACL:'.$aktPath,2);
							}
						} else {
							unset($this->_cache[$aktPath]);
						}
					}
					$parentPath=$aktPath;
				}
			}
			debugFile('path2Data - '.$path.' - '.is_object($this->_cache[$path]),1);
		}
		return is_object($this->_cache[$path]);
    }
   public function initUser() {
		$this->_fmng=& $this->_frm->getStaticModul('fmng');
		$this->_fmng->setDavOn(true);
		$this->_cache['/']=new FObj_fol(0,array('TimeCreate'=>time(),'TimeModify'=>time(),'DocType'=>'fol'),array('ParentID'=>0),1);
		$this->_tree[0]=array();
		if ($this->_fmng->getPerms(1)) {
			$root_obj_u=$this->_fmng->getSystemObj('u',$this->_frm->getLang(),$this->_frm->getUser(),true);
			if (is_object($root_obj_u)) {
				$root_obj_u->davPath='/'.$this->encode($root_obj_u->getName($this->_frm->getLang()));
				$this->_cache[$root_obj_u->davPath]=$root_obj_u;
				$this->_tree[0][$root_obj_u->getID()]=$root_obj_u;
			}
		}
		if ($this->_fmng->getPerms(2)) {
			$root_obj_s=$this->_fmng->getSystemObj('s',$this->_frm->getLang(),0,true);
			if (is_object($root_obj_s)) {
				$root_obj_s->davPath='/'.$this->encode($root_obj_s->getName($this->_frm->getLang()));
				$this->_cache[$root_obj_s->davPath]=$root_obj_s;
				$this->_tree[0][$root_obj_s->getID()]=$root_obj_s;
			}
		}
		if ($this->_frm->appExists('proj')) {
			$this->_P=& $this->_frm->getStaticModul('proj',true);
			$this->_P->init();
		}
		debugFile('initUser:'.$this->_frm->getUser(),1);
    }
    public function exists($path) {
		return $this->path2Data($path);
    }
    public function getObj($path) {
		if ($this->path2Data($path)) {
			return $this->_cache[$path];
		} else {
			return false;
		}

    }
    public function getID($path) {
		if ($this->path2Data($path)) {
			return $this->_cache[$path]->getID();
		} else {
			return false;
		}
    }
    public function getAcl($path,$acl=0) {
		if ($this->path2Data($path)) {
			return $this->_cache[$path]->getAcl($acl);
		} else {
			return false;
		}
    }
    public function getName($path) {
		if ($this->path2Data($path)) {
			return $this->_cache[$path]->getName($this->_frm->getLang());
		} else {
			return false;
		}
    }
    public function isFolder($path) {
		if ($this->path2Data($path)) {
			return $this->_cache[$path]->isFolder();
		} else {
			return false;
		}
    }
    public function getMeta($path,$meta) {
		if ($this->path2Data($path)) {
			//debugFile($this->_cache[$path]);
			return $this->_cache[$path]->getMeta($meta);
		} else {
			return false;
		}
    }
    public function getFileMeta($path,$meta) {
		if ($this->path2Data($path)) {
			return $this->_cache[$path]->getFileMeta($meta);
		} else {
			return false;
		}
    }
    public function getParentMeta($path,$meta) {
		if ($this->path2Data($path)) {
			return $this->_cache[$path]->getParentMeta($meta);
		} else {
			return false;
		}
    }
    protected function loadSubEntries($parentID,$use_perms=true,$trash=0) {
		if (!isset($this->_tree[$parentID])) {
			$this->_tree[$parentID]=$this->_fmng->ListSubEntrys($parentID,'','Title_'.$this->_frm->getLang(),'ASC',$use_perms,$trash);
		}
    }
    public function getSubEntries($path) {
		$result=array();
		$parentID=$this->getID($path);
		if ($parentID!==false) {
			$this->loadSubEntries($parentID);
			if ($path=='/') $path='';
			foreach ($this->_tree[$parentID] as $val) {
				$davPath=$path.'/'.$this->encode($val->getName($this->_frm->getLang()));
				if (!isset($this->_cache[$davPath])) {
					$val->davPath=$davPath;
					$this->_cache[$davPath]=$val;
				}
				if ($val->isFolder()) {
					$result[] = new ezcWebdavCollection($davPath);
				} else {
					$result[] = new ezcWebdavResource($davPath);
				}
			}
		}
		return $result;
	}
	public function createFolder($path) {
		$name=$this->getFolderName($path);
		$parent=$this->getParentFolder($path);
		//debugFile($this->getObj($parent),1);
		$new_obj=new FObj_fol();
		$new_obj->setMeta('DocType','fol');
		$new_obj->setMeta('MenuImage','tree.gif');
		$new_obj->setMeta('Version',1);
		$new_obj->setMeta('TimeCreate',time());
		$new_obj->setMeta('TimeModify',time());
		$new_obj->setMeta('UserCreate',$this->_frm->getUser());
		$new_obj->setMeta('UserModify',$this->_frm->getUser());
		$new_obj->setMeta('Users',$this->getMeta($parent,'Users'));
		$new_obj->setMeta('Groups',$this->getMeta($parent,'Groups'));
		$new_obj->setParentMeta('ParentID',$this->getID($parent));
		$new_obj->setParentMeta('RootID',$this->getParentMeta($parent,'RootID'));
		$new_obj->setParentMeta('UserID',$this->getParentMeta($parent,'UserID'));
		foreach ($this->_frm->getAvLang() as $val) {
			$new_obj->setMeta('Title_'.$val,$this->decode($name));
		}
		debugFile($new_obj,8);
		if ($this->_fmng->insertMeta($new_obj)) {
			$this->_fmng->insertParentMeta($new_obj);
			$this->_cache[$path]=$new_obj;
		}
	}
	public function createFile($path,$content=null) {
		$name=$this->getFolderName($path);
		$parent=$this->getParentFolder($path);
		//debugFile($this->getObj($parent),1);
		$new_obj=new FObj_ext();
		$new_obj->setMeta('DocType','ext');
		$new_obj->setMeta('MenuImage','other.gif');
		$new_obj->setMeta('Version',1);
		$new_obj->setMeta('TimeCreate',time());
		$new_obj->setMeta('TimeModify',time());
		$new_obj->setMeta('UserCreate',$this->_frm->getUser());
		$new_obj->setMeta('UserModify',$this->_frm->getUser());
		$new_obj->setMeta('Users',$this->getMeta($parent,'Users'));
		$new_obj->setMeta('Groups',$this->getMeta($parent,'Groups'));
		$new_obj->setParentMeta('ParentID',$this->getID($parent));
		$new_obj->setParentMeta('RootID',$this->getParentMeta($parent,'RootID'));
		$new_obj->setParentMeta('UserID',$this->getParentMeta($parent,'UserID'));
		foreach ($this->_frm->getAvLang() as $val) {
			$new_obj->setMeta('Title_'.$val,$this->decode($name));
		}
		debugFile($new_obj,8);
		if ($this->_fmng->insertMeta($new_obj)) {
			$this->_fmng->insertParentMeta($new_obj);
			$this->_cache[$path]=$new_obj;
			if ($content) {
				$this->replaceContent($path,$content);
			}
		}
	}
	public function replaceContent($path,$content=null) {
		$obj=$this->getObj($path);
		$tmpFile=tempnam($this->_frm->getDynTempPath(),'dav');
		file_put_contents( $tmpFile, $content );
		if ($obj->getMeta('Content')) {
			$FileID=$obj->getMeta('Content');
		} else {
			$FileID=$obj->getID();
		}
		$uplFile=array(
			'tmp_name'=>$tmpFile,
			'name'=>$obj->getName($this->_frm->getLang()),
			'type'=>$this->_getMimeType($tmpFile,$obj->getName($this->_frm->getLang())),
		);
		debugFile($uplFile);
		$img='';
		$error=$this->_fmng->replaceFile($obj,$this->_fmng->getModul(),$FileID,$uplFile);
		if ($error===false){
			$obj->setMeta('TimeModify',time());
			$obj->setMeta('UserModify',$this->_frm->getUser());
			$this->_fmng->updateMeta($obj);
		}
		unlink($tmpFile);
	}
	public function deleteObj($path) {
		if ($this->getMeta($path,'System')) {
			debugFile('delete denied:'.$path,1);
			return array(new ezcWebdavErrorResponse(
                    ezcWebdavResponse::STATUS_403,
                    $path),
            );
		}
		if (!$this->isTempFile($path)) {
			$result=$this->_trashObj($this->getObj($path),$path);
		} else {
			debugFile('deleteFinal:'.$path);
			$result=$this->_finalDeleteObj($this->getObj($path),$path);
		}
		return $result;
	}
	function isTempFile($path) {
		if ($this->isFolder($path)) return false;
		if ($name=$this->getName($path)) {
			return $this->_fmng->isTempFileName($name);
		}
		return false;
	}
	protected function _finalDeleteObj($obj,$fromPath) {
		if ($obj->isFolder()) {
			$this->loadSubEntries($obj->getID());
			if (is_array($this->_tree[$obj->getID()])) {
				foreach ($this->_tree[$obj->getID()] as $val) {
					$this->_finalDeleteObj($val,$fromPath.'/'.$this->encode($val->getName($this->_frm->getLang())));
				}
			}
		}
		switch ($obj->getMeta('DocType')) {
			case 'ext':
				if ($obj->getMeta('Content')==$obj->getID()) {
					$this->_fmng->deleteFile($this->_fmng->getModul(),$obj->getMeta('Content'));
				}
			break;
			case 'fol':
				$this->_fmng->deleteOrder($obj->getID());
			break;
		}
		$this->_fmng->deleteParentMeta($obj);
		$this->_fmng->deleteMeta($obj);
		unset($this->_cache[$fromPath]);
		return false;
	}
	public function moveObj($fromPath,$toPath) {
		$fromName=$this->getFolderName($fromPath);
		$fromParent=$this->getParentFolder($fromPath);
		$toName=$this->getFolderName($toPath);
		$toParent=$this->getParentFolder($toPath);
		$obj=$this->getObj($fromPath);
		if ($fromName!=$toName) {
			unset($this->_cache[$fromPath]);
			$tmpName=$this->decode($toName);
			foreach ($this->_frm->getAvLang() as $val) {
				$obj->setMeta('Title_'.$val,$tmpName);
			}
			if (!$obj->isFolder()) {
				$uplFile=array(
					'tmp_name'=>$obj->getFileMeta('FilePath'),
					'name'=>$obj->getName($this->_frm->getLang()),
					'type'=>$obj->getFileMeta('MimeType'),
				);
				$error=$this->_fmng->replaceFile($obj,$this->_fmng->getModul(),$obj->getMeta('Content'),$uplFile);
			}
			$obj->setMeta('TimeModify',time());
			$obj->setMeta('UserModify',$this->_frm->getUser());
			$this->_fmng->updateMeta($obj);
		}
		if ($fromParent!=$toParent) {
			unset($this->_cache[$fromPath]);
			$objTo=$this->getObj($toParent);
			if ($obj->isFolder() && $this->_fmng->isSubfolder($objTo->getID(),$obj->getID())) {
				debugFile('move to sub of self',1);
				return array(new ezcWebdavErrorResponse(
					ezcWebdavResponse::STATUS_423,
					$fromPath
					),
				);
			}
			return $this->_moveObj($obj,$objTo,$fromPath);
		}
	}

	protected function _moveObj($obj,$objTo,$fromPath) {
		debugFile($obj->getID().' move to'.$objTo->getID(),8);
		if ($obj->getParentMeta('ParentID')!=$objTo->getID() || $obj->getParentMeta('RootID')!=$objTo->getParentMeta('RootID')) {
			$obj->setMeta('TimeModify',time());
			$obj->setMeta('UserModify',$this->_frm->getUser());
			//$obj->setMeta('Trash',$objTo->getMeta('Trash'));
			$obj->setParentMeta('ParentID',$objTo->getID());
			$obj->setParentMeta('RootID',$objTo->getParentMeta('RootID'));
			if (!$obj->getMeta('Trash')) {
				if (!$obj->isFolder()) {
					$obj->setMeta('Users',$objTo->getMeta('Users'));
					$obj->setMeta('Groups',$objTo->getMeta('Groups'));
				}
				$obj->setParentMeta('UserID',$objTo->getParentMeta('UserID'));
			}
			$this->_fmng->updateMeta($obj);
			$this->_fmng->updateParentMeta($obj);
			unset($this->_cache[$fromPath]);
			if ($obj->isFolder()) {
				$this->loadSubEntries($obj->getID());
				if (is_array($this->_tree[$obj->getID()])) {
					foreach ($this->_tree[$obj->getID()] as $val) {
						$this->_moveObj($val,$obj,$fromPath.'/'.$this->encode($val->getName($this->_frm->getLang())));
					}
				}
			}
		}
		return null;
	}
	protected function _trashObj($obj,$fromPath) {
		debugFile($obj->getID().' trash',8);
		if (!$obj->getMeta('Trash')) {
			$obj->setMeta('TimeModify',time());
			$obj->setMeta('UserModify',$this->_frm->getUser());
			$obj->setMeta('Trash',1);
			if ($obj->isFolder()) {
				$this->loadSubEntries($obj->getID());
				if (is_array($this->_tree[$obj->getID()])) {
					foreach ($this->_tree[$obj->getID()] as $val) {
						$this->_trashObj($val,$fromPath.'/'.$this->encode($val->getName($this->_frm->getLang())));
					}
				}
			}
			$this->_fmng->updateMeta($obj);
			unset($this->_cache[$fromPath]);
		}
		return null;
	}
	public function copyObj($fromPath,$toPath,$depth=0) {
		$fromName=$this->getFolderName($fromPath);
		$fromParent=$this->getParentFolder($fromPath);
		$toName=$this->getFolderName($toPath);
		$toParent=$this->getParentFolder($toPath);
		$obj=$this->getObj($fromPath);
		if ($fromName!=$toName) {
			foreach ($this->_frm->getAvLang() as $val) {
				$obj->setMeta('Title_'.$val,$this->decode($toName));
			}
		}
		$objTo=$this->getObj($toParent);
		if ($obj->isFolder() && $this->_fmng->isSubfolder($objTo->getID(),$obj->getID())) {
			debugFile('copy to sub of self',1);
			return array(new ezcWebdavErrorResponse(
				ezcWebdavResponse::STATUS_423,
				$fromPath
				),
			);
		}
		return $this->_copyObj($obj,$objTo,$depth);
	}

	protected function _copyObj($obj,$objTo,$depth=0) {
		$oldID=$obj->getID();
		$oldVersion=$obj->getMeta('Version');
		$obj->setMeta('Users',$objTo->getMeta('Users'));
		$obj->setMeta('Groups',$objTo->getMeta('Groups'));
		$obj->setMeta('TimeModify',time());
		$obj->setMeta('UserModify',$this->_frm->getUser());
		$obj->setMeta('TimeCreate',time());
		$obj->setMeta('UserCreate',$this->_frm->getUser());
		$obj->setMeta('Version',1);
		$obj->setMeta('Content',0);
		//$obj->setMeta('Trash',$objTo->getMeta('Trash'));
		$obj->setMeta('DavProperties','');
		$obj->setParentMeta('ParentID',$objTo->getID());
		$obj->setParentMeta('UserID',$objTo->getParentMeta('UserID'));
		$obj->setParentMeta('RootID',$objTo->getParentMeta('RootID'));

		$this->_fmng->insertMeta($obj);
		$this->_fmng->insertParentMeta($obj);
		if ($obj->isFolder()) {
			if ($depth!==0) {
				$this->loadSubEntries($oldID);
				if (is_array($this->_tree[$oldID])) {
					foreach ($this->_tree[$oldID] as $val) {
						$this->_copyObj($val,$obj,$depth--);
					}
				}
			}
		} else {
			$error=$this->_fmng->copyFile($obj,$this->_fmng->getModul(),$oldID,$oldVersion);
				debugFile('copyFile:'.$error,1);
			if (!$error) {
				$this->_fmng->updateMeta($obj);
			} else {
				$this->_fmng->deleteParentMeta($obj);
				$this->_fmng->deleteMeta($obj);
			}
		}
	}
	public function storeProperties($path,$data) {
		$obj=$this->getObj($path);
		debugFile('DavProperties:'.$data,1);
		$obj->setMeta('DavProperties',$data);
		return $this->_fmng->updateMeta($obj);
	}

	public function getParentFolder($path) {
		$tmp=explode('/',$path);
		$name=array_pop($tmp);
		return implode('/',$tmp);
	}
	public function getFolderName($path) {
		$tmp=explode('/',$path);
		return array_pop($tmp);
	}

    public function getMimeType($path) {
		if ($this->isFolder($path)) {
			return 'httpd/unix-directory';
		} else {
			$mimeType=$this->_getMimeType($this->getFileMeta($path,'FilePath'));
			if ($mimeType) return $mimeType;

			if ($this->getFileMeta($path,'MimeType')) {
				return $this->getFileMeta($path,'MimeType');
			} else {
				return 'application/octet-stream';
			}
		}
    }
    protected function _getMimeType($file,$name='') {
		if (file_exists($file)) {
			$res=$this->_frm->getMimeFile($file,$name);
			debugFile('getMimeFile:'.$file.'-'.$res,1);
			return $res;
			// Check if extension pecl/fileinfo is usable.
			/*if (ezcBaseFeatures::hasExtensionSupport('fileinfo')) {
				$fInfo = new fInfo( FILEINFO_MIME );
				$mimeType = $fInfo->file($file);
				return $mimeType;
			}
			// Check if extension ext/mime-magic is usable.
			if (ezcBaseFeatures::hasExtensionSupport('mime_magic') && ($mimeType = mime_content_type($file)) !== false) {
				return $mimeType;
			}*/
		}
		return false;
    }


    protected function encode($path) {
		return rawurlencode(Framework::convertCharset($path,$this->incharset,$this->outcharset));
    }
    protected function decode($path) {
		return Framework::convertCharset(rawurldecode($path),$this->outcharset,$this->incharset);
    }
    public function assignLock($user,$lockToken) {
		return $this->_fmng->insertLock($user,$lockToken);
    }
    public function ownsLock($user,$lockToken) {
 		return $this->_fmng->getLock($user,$lockToken);
    }
    public function releaseLock($user,$lockToken) {
		return $this->_fmng->deleteLock('',$lockToken);
    }

}
?>