<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
class Zef {
	var $_db;
	var $_uid;
	var $_gid;
	var $_auth_uid;
	var $_modul='zef';
	function Zef() {
		global $db,$frm;
		$this->_db=&$db;
		$this->_frm=&$frm;
		$this->_auth_uid=$frm->getUser();
		$this->setUser($frm->getUser());
		$this->setGroup($frm->getMyGroups());
		$this->_lang=strtoupper($frm->getLang());
		$this->setCfg($frm->getCfg($this->getModul(),0,'cfg/%'));
		$this->setRule($frm->isRuleUser(array('sysadmin','zef')));
		$this->setSuperAdmin($frm->isSuperAdmin());
	}
	function setRule($bool=false) {
		$this->_rule=$bool;
	}
	function isRuleUser() {
		if ($this->_sadmin || $this->_rule) {
			return true;
		} else {
			return false;
		}
	}
	function setSuperAdmin($bool=false) {
		$this->_sadmin=$bool;
	}
	function isSuperAdmin() {
		return $this->_sadmin;
	}
	function setUser($uid) {
		$this->_uid=$uid;
	}
	function getUser() {
		return $this->_uid;
	}
	function getModul() {
		return $this->_modul;
	}
	function setGroup($gid) {
		$this->_gid=$gid;
	}
	function setCfg($cfg) {
		if (is_array($cfg)) {
			foreach ($cfg as $key=>$val) {
				$this->_cfg[$key]=$val;
			}
		}
		if (defined('GE_zefUseComp')) {
			$this->_cfg['cfg/modul/company']=GE_zefUseComp;
		}
	}
	function getCfg($key) {
		if (isset($this->_cfg[$key])) {
			return $this->_cfg[$key];
		} else {
			return false;
		}
	}
	function getLang($bool=false) {
		return $this->_lang;
	}
	function getPerms($test=0) {
		if (!isset($this->_perms[$this->_auth_uid])) {
			$this->_setPerms();
		}
		if ($test) {
			return ($this->_perms[$this->_auth_uid]&$test)?true:false;
		} else {
			return $this->_perms[$this->_auth_uid];
		}
	}
	function _setPerms() {
		$query="SELECT BIT_OR(zefPerms) as uperms FROM zef_perms WHERE";
		$query.=" zefTyp=".$this->_db->escape('u');
		$query.=" AND zefID=".$this->_db->escape($this->_uid);
		$query.=" GROUP BY zefTyp";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			$this->_perms[$this->_uid]=$this->_db->f('uperms');
		} else {
			$query="SELECT BIT_OR(zefPerms) as uperms FROM zef_perms WHERE";
			$query.=" zefTyp=".$this->_db->escape('g');
			$query.=" AND zefID IN (".implode(',',$this->_db->escape($this->_gid)).')';
			$query.=" GROUP BY zefTyp";
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				$this->_perms[$this->_uid]=$this->_db->f('uperms');
			} else {
				$this->_perms[$this->_uid]=0;
			}
		}
	}
	function isOpen() {
		$query="SELECT * FROM zef WHERE zefUser=".$this->_db->escape($this->_auth_uid);
		$query.=" AND zefOpen=1";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_fetchZef();
		} else {
			return false;
		}
	}
	function insertZef($values) {
		$values['zefID']=$this->_db->nextid('zef');
		if ($this->_db->insert('zef',$values)) {
			return $values['zefID'];
		}
	}
	function updateZef($zefID,$values) {
		return $this->_db->update('zef',$values,"zefID=".$this->_db->escape($zefID));
	}

	function &_fetchZef() {
		$result=array(
			'zefID'=>$this->_db->f('zefID'),
			'FKzefCatID'=>$this->_db->f('FKzefCatID'),
			'FKzefPrjID'=>$this->_db->f('FKzefPrjID'),
			'FKcompID'=>$this->_db->f('FKcompID'),
			'compMode'=>$this->_db->f('compMode'),
			'FKCalResID'=>$this->_db->f('FKCalResID'),
			'zefBegin'=>$this->_db->f('zefBegin'),
			'zefEnd'=>$this->_db->f('zefEnd'),
			'zefDuration'=>$this->_db->f('zefDuration'),
			'zefCorrection'=>$this->_db->f('zefCorrection'),
			'zefUser'=>$this->_db->f('zefUser'),
			'zefUserCreate'=>$this->_db->f('zefUserCreate'),
			'zefUserModify'=>$this->_db->f('zefUserModify'),
			'zefTimeCreate'=>$this->_db->f('zefTimeCreate'),
			'zefTimeModify'=>$this->_db->f('zefTimeModify'),
			'zefTimeCreate'=>$this->_db->f('zefTimeCreate'),
			'zefDescription'=>$this->_db->f('zefDescription'),
			'zefOpen'=>$this->_db->f('zefOpen'),
			'zefCosts'=>$this->_db->f('zefCosts'),
			'zefClosed'=>$this->_db->f('zefClosed'),
			'zefDerefed'=>$this->_db->f('zefDerefed'),
			'FKzefDerefID'=>$this->_db->f('FKzefDerefID'),
			'zefMoveDate'=>$this->_db->f('zefMoveDate'),
			'zefCharged'=>$this->_db->f('zefCharged'),
		);
		return $result;
	}
	function readZef($zefID) {
		$query="SELECT * FROM zef WHERE zefID=".$this->_db->escape($zefID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_fetchZef();
		}
	}
	function deleteZef($zefID) {
		$query="DELETE FROM zef WHERE zefUser=".$this->_db->escape($this->_uid);
		$query.=" AND (zefID=".$this->_db->escape($zefID);
		$query.=" OR FKzefDerefID=".$this->_db->escape($zefID).')';
		$this->_db->query($query);

		$query="DELETE FROM zefCosts WHERE FKzefID=".$this->_db->escape($zefID);
		$this->_db->query($query);

		return 1;
	}
	function getLastZef($date) {
		$query="SELECT zefEnd FROM zef WHERE zefUser=".$this->_db->escape($this->_uid);
		$query.=" AND LEFT(zefBegin,10) = ".$this->_db->escape($date);
		$query.=" AND zefOpen=0 AND FKzefDerefID=0 ORDER BY zefBegin DESC ".$this->_db->formatLimit(0,1);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->SqlToDate($this->_db->f('zefEnd'));
		} else {
			return $this->_db->SqlToDate($date);
		}
	}
	function listZef($zefBegin,$zefEnd,$limit=0) {
		$result=array();
		$query="SELECT DATE(zefBegin) as tag ,zef.* FROM zef WHERE zefUser=".$this->_db->escape($this->_uid);
		$query.=" AND zefOpen=0 AND FKzefDerefID=0 ";
		$query.=" AND zefBegin >= ".$this->_db->escape($zefBegin);
		if ($zefEnd) $query.=" AND zefBegin <= ".$this->_db->escape($zefEnd);
		$query.=" ORDER BY tag DESC,zefBegin ASC,zefTimeCreate ASC";
		if ($limit)  $query.=" ".$this->_db->formatLimit(0,$limit);
		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('tag')][$this->_db->f('zefID')]=$this->_fetchZef();
		}
		return $result;
	}
	function searchZef(&$rows,&$sum,$search,$order='zefBegin DESC',$b=0,$limit=0,$use_limit=true,$lang="") {
		$result=array();
		if (!$lang) $lang=$this->_lang;
		$query="SELECT zef.*,zef_cat.zefName$lang FROM zef LEFT JOIN zef_cat ON (FKzefCatID=zefCatID)  WHERE ";
		if (is_array($search)) {
			$query.=$this->_db->getWhere($search);
		} else {
			$query.=$search;
		}
		$query.=" ORDER BY ".$order;
		if ($b || $limit)  $query.=" ".$this->_db->formatLimit($b,$limit);
		//echo $query;
		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		while ($this->_db->next_record()) {
			$result[$this->_db->f('zefID')]=$this->_fetchZef();
			$result[$this->_db->f('zefID')]['zefName']=$this->_db->f("zefName$lang");
			$sum+=$this->_db->f("zefDuration");
		}
		if ($use_limit && $limit && ($b!=0 || $rows==$limit)) {
			$query="SELECT count(*) as num,sum(zefDuration) as summe FROM zef LEFT JOIN zef_cat ON (FKzefCatID=zefCatID) WHERE ";
			if (is_array($search)) {
				$query.=$this->_db->getWhere($search);
			} else {
				$query.=$search;
			}
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
			$sum=$this->_db->f('summe');

		}
		return $result;
	}
	function getPresenz($zefUser,$zefBegin,$zefEnd) {
		$result=array();
		$query="SELECT  DATE(zefBegin) as tag,SUM(zefDuration) as summe ";
		$query.=" FROM zef LEFT JOIN zef_cat ON (FKzefCatID=zefCatID) WHERE";
		$query.=" zefUser=".$this->_db->escape($zefUser);
		$query.=" AND zefPres=0 ";
		$query.=" AND zefOpen=0 ";
		$query.=" AND FKzefDerefID=0";
		$query.=" AND zefBegin >= ".$this->_db->escape($zefBegin);
		$query.=" AND zefBegin <= ".$this->_db->escape($zefEnd);
		$query.=" GROUP BY tag";
		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('tag')][0]=$this->_db->f("summe");
		}

		$query="SELECT zefCatID,DATE(zefBegin) as tag,SUM(zefDuration) as summe ";
		$query.=" FROM zef LEFT JOIN zef_cat ON (FKzefCatID=zefCatID) WHERE";
		$query.=" zefUser=".$this->_db->escape($zefUser);
		$query.=" AND zefPres!=0 ";
		$query.=" AND zefOpen=0 ";
		$query.=" AND FKzefDerefID=0";
		$query.=" AND zefBegin >= ".$this->_db->escape($zefBegin);
		$query.=" AND zefBegin <= ".$this->_db->escape($zefEnd);
		$query.=" GROUP BY tag,zefCatID ORDER By zefPres";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('tag')][$this->_db->f("zefCatID")]=$this->_db->f("summe");
		}
		//debug($result);
		return $result;
	}
	function getPresenzDet($zefUser,$zefBegin,$zefEnd) {
		$result=array();
		$query="SELECT DATE(zefBegin) as tag,zefID,zefDuration,zefBegin,zefEnd,zefCatID,zefDescription ";
		$query.=" FROM zef LEFT JOIN zef_cat ON (FKzefCatID=zefCatID) WHERE";
		$query.=" zefUser=".$this->_db->escape($zefUser);
		$query.=" AND zefOpen=0 ";
		$query.=" AND FKzefDerefID=0";
		$query.=" AND zefBegin >= ".$this->_db->escape($zefBegin);
		$query.=" AND zefBegin <= ".$this->_db->escape($zefEnd);
		$query.=" ORDER BY zefBegin";
		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('tag')][$this->_db->f('zefID')]=array (
				'zefCatID'=>$this->_db->f("zefCatID"),
				'zefBegin'=>$this->_db->f("zefBegin"),
				'zefEnd'=>$this->_db->f("zefEnd"),
				'zefDuration'=>$this->_db->f("zefDuration"),
				'zefDescription'=>$this->_db->f("zefDescription"),

			);
		}
		return $result;
	}
	function listAllZef(&$rows,$search,$OrderBy='',$b=0,$limit=0,$use_limit=false) {
		//debug($search);
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'zefOpen','Typ'=>'=','Values'=>0);
		if ($search['zefDerefed']!=-1) {
			$searchQuery[]=array('Field'=>'zefDerefed','Typ'=>'=','Values'=>intval($search['zefDerefed']));
		}
		if ($search['useMove'] && ($search['DateB'] || $search['DateE'])) {
			$subQuery=array();
			$subQuery[0][]=array('Field'=>'zefMoveDate','Typ'=>'=','Values'=>'0000-00-00');
			if ($search['DateB']) $subQuery[0][]=array('Field'=>'zefBegin','Typ'=>'>=','Values'=>date('Y-m-d H:i:s',$search['DateB']));
			if ($search['DateE']) $subQuery[0][]=array('Field'=>'zefEnd','Typ'=>'<=','Values'=>date('Y-m-d H:i:s',$search['DateE']));

			$subQuery[1][]=array('Field'=>'zefMoveDate','Typ'=>'!=','Values'=>'0000-00-00');
			if ($search['DateB']) $subQuery[1][]=array('Field'=>'zefMoveDate','Typ'=>'>=','Values'=>date('Y-m-d H:i:s',$search['DateB']));
			if ($search['DateE']) $subQuery[1][]=array('Field'=>'zefMoveDate','Typ'=>'<=','Values'=>date('Y-m-d H:i:s',$search['DateE']));

			$searchQuery[]=array('Typ'=>'OR','Values'=>$subQuery);
		} else {
			if ($search['DateB']) $searchQuery[]=array('Field'=>'zefBegin','Typ'=>'>=','Values'=>date('Y-m-d H:i:s',$search['DateB']));
			if ($search['DateE']) $searchQuery[]=array('Field'=>'zefEnd','Typ'=>'<=','Values'=>date('Y-m-d H:i:s',$search['DateE']));
		}
		if ($search['zefPrj']) $searchQuery[]=array('Field'=>'FKzefPrjID','Typ'=>'=','Values'=>$search['zefPrj']);
		if ($search['compID']) $searchQuery[]=array('Field'=>'FKcompID','Typ'=>'=','Values'=>$search['compID']);
		if ($search['zefCalRes']) $searchQuery[]=array('Field'=>'FKCalResID','Typ'=>'=','Values'=>$search['zefCalRes']);
		if ($search['zefCat']) $searchQuery[]=array('Field'=>'FKzefCatID','Typ'=>'=','Values'=>$search['zefCat']);
		if ($search['zefUsers']) $searchQuery[]=array('Field'=>'zefUser','Typ'=>'=','Values'=>$search['zefUsers']);
		if ($search['issetMoveDate']) $searchQuery[]=array('Field'=>'zefMoveDate','Typ'=>'!=','Values'=>'0000-00-00');
		if ($search['zefCharged']) $searchQuery[]=array('Field'=>'zefCharged','Typ'=>'=','Values'=>$search['zefCharged']>0?1:0);


		if ($this->getCfg('cfg/modul/expenses')) {
			$query.="SELECT zef.*,SUM(costCalc) as costSum FROM zef LEFT JOIN zefCosts ON ";
			if ($search['noExp']==2) {
				$query.="(zefID=FKzefID AND zefCosts.FKUseDeref=1)";
			} else {
				$query.="(zefID=FKzefID)";
			}
		} else {
			$query="SELECT * FROM zef";
		}
		if (!empty($searchQuery)) {
			$query.=" WHERE ".$this->_db->getWhere($searchQuery);
		}
		$query.=" GROUP BY zefID";
		if ($OrderBy) $query.=" ORDER BY $OrderBy";
		if ($b || $limit)  $query.=" ".$this->_db->formatLimit($b,$limit);
		//echo $query;
		$this->_db->query($query);
		$rows=0;
		while ($this->_db->next_record()) {
			$result[$this->_db->f('zefID')]=$this->_fetchZef();
			$result[$this->_db->f('zefID')]['costSum']=$this->_db->f('costSum');
			$rows++;
		}
		if ($use_limit && ($b!=0 || $limit==$rows)) {
			$query="SELECT count(*) as num FROM zef WHERE ".$this->_db->getWhere($searchQuery);
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
		}



		return $result;
	}

	function listAuswertung(&$rows,&$sum,$search,$OrderBy='',$b=0,$limit=0) {
		if ($search['useCorr']) {
			$sumField='zefDuration-zefCorrection';
		} else {
			$sumField='zefDuration';
		}
		//debug($search);
		$result=array();
		if (!is_array($search['GroupBy']) || !count($search['GroupBy'])) {
			if ($this->getCfg('cfg/modul/company')) {
				$search['GroupBy']=array('FKcompID','FKzefPrjID','FKzefCatID','zefUser');
			} else {
				$search['GroupBy']=array('FKzefPrjID','FKzefCatID','zefUser');
			}
		}
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'zefOpen','Typ'=>'=','Values'=>0);
		$searchQuery[]=array('Field'=>'zefDerefed','Typ'=>'=','Values'=>0);
		if ($search['useMove'] && ($search['DateB'] || $search['DateE'])) {
			$subQuery=array();
			$subQuery[0][]=array('Field'=>'zefMoveDate','Typ'=>'=','Values'=>'0000-00-00');
			if ($search['DateB']) $subQuery[0][]=array('Field'=>'zefBegin','Typ'=>'>=','Values'=>date('Y-m-d H:i:s',$search['DateB']));
			if ($search['DateE']) $subQuery[0][]=array('Field'=>'zefEnd','Typ'=>'<=','Values'=>date('Y-m-d H:i:s',$search['DateE']));

			$subQuery[1][]=array('Field'=>'zefMoveDate','Typ'=>'!=','Values'=>'0000-00-00');
			if ($search['DateB']) $subQuery[1][]=array('Field'=>'zefMoveDate','Typ'=>'>=','Values'=>date('Y-m-d H:i:s',$search['DateB']));
			if ($search['DateE']) $subQuery[1][]=array('Field'=>'zefMoveDate','Typ'=>'<=','Values'=>date('Y-m-d H:i:s',$search['DateE']));

			$searchQuery[]=array('Typ'=>'OR','Values'=>$subQuery);
		} else {
			if ($search['DateB']) $searchQuery[]=array('Field'=>'zefBegin','Typ'=>'>=','Values'=>date('Y-m-d H:i:s',$search['DateB']));
			if ($search['DateE']) $searchQuery[]=array('Field'=>'zefEnd','Typ'=>'<=','Values'=>date('Y-m-d H:i:s',$search['DateE']));
		}
		if ($search['zefPrj']) $searchQuery[]=array('Field'=>'FKzefPrjID','Typ'=>'=','Values'=>$search['zefPrj']);
		if ($search['compID']) $searchQuery[]=array('Field'=>'FKcompID','Typ'=>'=','Values'=>$search['compID']);
		if ($search['zefCalRes']) $searchQuery[]=array('Field'=>'FKCalResID','Typ'=>'=','Values'=>$search['zefCalRes']);
		if ($search['zefCat']) $searchQuery[]=array('Field'=>'FKzefCatID','Typ'=>'=','Values'=>$search['zefCat']);
		if ($search['zefUsers']) $searchQuery[]=array('Field'=>'zefUser','Typ'=>'=','Values'=>$search['zefUsers']);
		if ($search['zefCharged']) $searchQuery[]=array('Field'=>'zefCharged','Typ'=>'=','Values'=>$search['zefCharged']>0?1:0);
		$query="SELECT ".implode(',',$search['GroupBy']).",SUM($sumField) as hourSum,SUM(zefCosts*($sumField)/3600) as emplSum FROM zef";
		if (!empty($searchQuery)) {
			$query.=" WHERE ".$this->_db->getWhere($searchQuery);
		}


		$query.=" GROUP BY ".implode(',',$search['GroupBy']);
		//debug($query);
		if ($OrderBy) $query.=" ORDER BY $OrderBy";
		if ($b || $limit)  $query.=" ".$this->_db->formatLimit($b,$limit);
		//echo $query;
		$this->_db->query($query);
		$rows=0;
		while ($this->_db->next_record()) {
			//if (!$this->_db->f('hourSum')) continue;
			$ID='';
			foreach ($search['GroupBy']  as $val) {
				$ID.=$val.'_'.$this->_db->f($val);
				$sum[$ID]['H']+=$this->_db->f('hourSum');
				$sum[$ID]['E']+=$this->_db->f('emplSum');
			}
			foreach ($search['GroupBy'] as $val) {
				$result[$ID][$val]=$this->_db->f($val);
			}
			$result[$ID]['hourSum']=$this->_db->f('hourSum');
			$sum['_all']['H']+=$this->_db->f('hourSum');
			$result[$ID]['emplSum']=$this->_db->f('emplSum');
			$sum['_all']['E']+=$this->_db->f('emplSum');
			$rows++;
		}
		if ($this->getCfg('cfg/modul/expenses')) {
			$query="SELECT ".implode(',',$search['GroupBy']).",SUM(costCalc) as costSum FROM zef LEFT JOIN zefCosts ON ";
			if ($search['noExp']==2) {
				$query.="(zefID=FKzefID AND zefCosts.FKUseDeref=1)";
			} else {
				$query.="(zefID=FKzefID)";
			}
			if (!empty($searchQuery)) {
				$query.=" WHERE ".$this->_db->getWhere($searchQuery);
			}
			$query.=" GROUP BY ".implode(',',$search['GroupBy']);
			//if ($OrderBy) $query.=" ORDER BY $OrderBy";
			if ($b || $limit)  $query.=" ".$this->_db->formatLimit($b,$limit);
			$this->_db->query($query);
			$rows=0;
			while ($this->_db->next_record()) {
				$ID='';
				foreach ($search['GroupBy'] as $val) {
					$ID.=$val.'_'.$this->_db->f($val);
					$sum[$ID]['C']+=$this->_db->f('costSum');
				}
				//if (!isset($result[$ID])) continue;
				$result[$ID]['costSum']=$this->_db->f('costSum');
				$sum['_all']['C']+=$this->_db->f('costSum');
				$rows++;
			}
			//debug($result);
		}


		return $result;
	}
	function listDetails($search,$OrderBy='',$b=0,$limit=0) {
		$result=array();

		$searchQuery=array();
		$searchQuery[]=array('Field'=>'zef.zefOpen','Typ'=>'=','Values'=>0);
		$searchQuery[]=array('Field'=>'zef.zefDerefed','Typ'=>'=','Values'=>0);

		if ($search['useMove'] && ($search['DateB'] || $search['DateE'])) {
			$subQuery=array();
			$subQuery[0][]=array('Field'=>'zef.zefMoveDate','Typ'=>'=','Values'=>'0000-00-00');
			if ($search['DateB']) $subQuery[0][]=array('Field'=>'zef.zefBegin','Typ'=>'>=','Values'=>date('Y-m-d H:i:s',$search['DateB']));
			if ($search['DateE']) $subQuery[0][]=array('Field'=>'zef.zefEnd','Typ'=>'<=','Values'=>date('Y-m-d H:i:s',$search['DateE']));

			$subQuery[1][]=array('Field'=>'zef.zefMoveDate','Typ'=>'!=','Values'=>'0000-00-00');
			if ($search['DateB']) $subQuery[1][]=array('Field'=>'zef.zefMoveDate','Typ'=>'>=','Values'=>date('Y-m-d H:i:s',$search['DateB']));
			if ($search['DateE']) $subQuery[1][]=array('Field'=>'zef.zefMoveDate','Typ'=>'<=','Values'=>date('Y-m-d H:i:s',$search['DateE']));

			$searchQuery[]=array('Typ'=>'OR','Values'=>$subQuery);
		} else {
			if ($search['DateB']) $searchQuery[]=array('Field'=>'zef.zefBegin','Typ'=>'>=','Values'=>date('Y-m-d H:i:s',$search['DateB']));
			if ($search['DateE']) $searchQuery[]=array('Field'=>'zef.zefEnd','Typ'=>'<=','Values'=>date('Y-m-d H:i:s',$search['DateE']));
		}
		if ($search['compID']) $searchQuery[]=array('Field'=>'zef.FKcompID','Typ'=>'=','Values'=>$search['compID']);
		if ($search['zefCalRes']) $searchQuery[]=array('Field'=>'zef.FKCalResID','Typ'=>'=','Values'=>$search['zefCalRes']);
		if ($search['zefPrj']) $searchQuery[]=array('Field'=>'zef.FKzefPrjID','Typ'=>'=','Values'=>$search['zefPrj']);
		if ($search['zefCat']) $searchQuery[]=array('Field'=>'zef.FKzefCatID','Typ'=>'=','Values'=>$search['zefCat']);
		if ($search['zefUsers']) $searchQuery[]=array('Field'=>'zef.zefUser','Typ'=>'=','Values'=>$search['zefUsers']);
		if ($search['zefCharged']) $searchQuery[]=array('Field'=>'zefCharged','Typ'=>'=','Values'=>$search['zefCharged']>0?1:0);


		$query="SELECT zef.* FROM zef LEFT JOIN zef_cat ON (zef.FKzefCatID=zefCatID) LEFT JOIN zef_prj ON (zef.FKzefPrjID=zefPrjID) ";
		if (!empty($searchQuery)) {
			$query.=" WHERE ".$this->_db->getWhere($searchQuery);
		}
		if ($OrderBy) $query.=" ORDER BY $OrderBy";
		if ($b || $limit)  $query.=" ".$this->_db->formatLimit($b,$limit);
		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$ID=$this->_db->f('FKzefPrjID').'|'.$this->_db->f('FKzefCatID');
			if ($this->getCfg('cfg/modul/company')) $ID.='|'.$this->_db->f('FKcompID');
			$result[$ID][$this->_db->f('zefUser')][$this->_db->f('zefID')]=$this->_fetchZef();
		}
		return $result;
	}

	function getConflict($zefBegin,$zefEnd,$zefID=0) {
		if ($this->getCfg('cfg/noTime')) {

		} else {
			$query="SELECT * FROM zef WHERE zefUser=".$this->_db->escape($this->_uid);
			$query.=" AND zefOpen=0 AND FKzefDerefID=0 ";
			if ($zefID) $query.=" AND zefID!=".$this->_db->escape($zefID);
			$query.=" AND ((zefBegin < ".$this->_db->escape($zefBegin)." AND zefEnd > ".$this->_db->escape($zefBegin).')';
			$query.=" OR (zefBegin > ".$this->_db->escape($zefBegin)." AND zefBegin < ".$this->_db->escape($zefEnd).')';
			$query.=" OR zefBegin = ".$this->_db->escape($zefBegin)." OR zefEnd = ".$this->_db->escape($zefEnd).')';
			$query.="ORDER BY zefBegin ASC";
			$this->_db->query($query);
			while ($this->_db->next_record()) {
				$result[$this->_db->f('zefID')]=$this->_fetchZef();
			}
		}
		return $result;
	}
	function saveUserTime($bhour,$bmin,$ehour,$emin,$uid=0) {
		if (!$uid) $uid=$this->_auth_uid;
		$query="DELETE FROM zef_usertime WHERE FKUserID=".$this->_db->escape($uid);
		$this->_db->query($query);
		for ($i=1;$i<8;$i++) {
			$insert=array(
				'FKUserID'=>$uid,
				'zefWeekDay'=>$i,
				'zefBTime'=>$bhour[$i][1].':'.$bmin[$i][1].':00',
				'zefETime'=>$ehour[$i][1].':'.$emin[$i][1].':00',
			);
			$this->_db->insert('zef_usertime',$insert);
			$insert=array(
				'FKUserID'=>$uid,
				'zefWeekDay'=>$i,
				'zefBTime'=>$bhour[$i][2].':'.$bmin[$i][2].':00',
				'zefETime'=>$ehour[$i][2].':'.$emin[$i][2].':00',
			);
			$this->_db->insert('zef_usertime',$insert);
		}
	}
	function getUserTime($uid=0) {
		$result=array();
		if (!$uid) $uid=$this->_uid;
		$query="SELECT * FROM zef_usertime WHERE FKUserID=".$this->_db->escape($uid);
		$query.=" AND (TIME_TO_SEC(zefETime)-TIME_TO_SEC(zefBTime)!=0)";
		$query.=" ORDER BY zefWeekDay,zefBTime";
		$this->_db->query($query);
		$num=array();
		while ($this->_db->next_record()) {
			$wday=$this->_db->f('zefWeekDay');
			if (isset($result['bhour'][$wday])) {
				$num[$wday]+=1;
			} else {
				$num[$wday]=1;
			}
			$zefB=explode(':',$this->_db->f('zefBTime'));
			$zefE=explode(':',$this->_db->f('zefETime'));
			$result['bhour'][$wday][$num[$wday]]=$zefB[0];
			$result['ehour'][$wday][$num[$wday]]=$zefE[0];
			$result['bmin'][$wday][$num[$wday]]=$zefB[1];
			$result['emin'][$wday][$num[$wday]]=$zefE[1];
			//echo $wday.'-'.$num[$wday].'-'.$zefB[0].'<br>';
		}

		return $result;

	}
	function getUserDayTime($uid=0) {
		$result=array();
		if (!$uid) $uid=$this->_uid;
		$query="SELECT zefWeekDay,SUM(TIME_TO_SEC(zefETime)-TIME_TO_SEC(zefBTime)) as summe FROM zef_usertime WHERE FKUserID=".$this->_db->escape($uid);
		$query.=" GROUP BY zefWeekDay";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('zefWeekDay')]=$this->_db->f('summe');
		}

		return $result;

	}
	function getUserPreTime($uid=0,$month,$year,$typ='') {
		$result=array();
		if (!$uid) $uid=$this->_uid;
		$query="SELECT * FROM zef_pretime WHERE FKUserID=".$this->_db->escape($uid);
		$query.=" AND preMonth=".$this->_db->escape($month);
		$query.=" AND preYear=".$this->_db->escape($year);
		if ($typ) $query.=" AND preTyp=".$this->_db->escape($typ);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('preTyp')][$this->_db->f('preFKID')]=$this->_db->f('preDuration');
		}
		return $result;

	}
	function insertPreTime($uid=0,$month,$year,$typ,$id,$duration) {
		if (!$uid) $uid=$this->_uid;
		$replace=array(
			'FKUserID'=>$uid,
			'preMonth'=>$month,
			'preYear'=>$year,
			'preTyp'=>$typ,
			'preFKID'=>$id,
			'preDuration'=>$duration,

		);
		$this->_db->insert('zef_pretime',$replace,'',1);
	}

	function readCat($zefCatID,$lang='') {
		if (!$lang) $lang=$this->_lang;
		$query="SELECT * FROM zef_cat WHERE zefCatID=".$this->_db->escape($zefCatID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_fetchCat($lang);
		} else {
			return false;
		}
	}
	function insertCat($values) {
		$values['zefCatID']=$this->_db->nextid('zef_cat');
		$values['zefGroups']='|'.implode('|',$values['zefGroups']).'|';
		$values['zefUsers']='|'.implode('|',$values['zefUsers']).'|';
		if ($this->_db->insert('zef_cat',$values)) {
			return $values['zefCatID'];
		}
	}
	function updateCat($zefCatID,$values) {
		if (isset($values['zefGroups'])) $values['zefGroups']='|'.implode('|',$values['zefGroups']).'|';
		if (isset($values['zefUsers'])) $values['zefUsers']='|'.implode('|',$values['zefUsers']).'|';
		return $this->_db->update('zef_cat',$values,"zefCatID=".$this->_db->escape($zefCatID));
	}
	function deleteCat($zefCatID) {
		if (!$this->isUsedCat($zefCatID)) {
			$query="DELETE FROM zef_cat  WHERE zefCatID=".$this->_db->escape($zefCatID);
			$this->_db->query($query);
			$this->deleteCompanyCalc($zefCatID,'cat');
			return true;

		} else {
			return false;
		}
	}
	function isUsedCat($zefCatID) {
		$query="SELECT FKzefCatID FROM zef WHERE FKzefCatID=".$this->_db->escape($zefCatID)." ".$this->_db->formatLimit(0,1);
		$this->_db->query($query);
		if ($this->_db->num_rows()) {
			return true;
		} else {
			return false;
		}
	}
	function &listAllCat($lang='') {
		if (!$lang) $lang=$this->_lang;
		$result=array();
		$query="SELECT * FROM zef_cat ORDER BY zefName$lang";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('zefCatID')]=$this->_fetchCat($lang);
		}
		return $result;
	}
	function &listAllCatNames($lang='',$aktiv=1,$perms=1,$pres=-1,$catIDs=null) {
		if (!$lang) $lang=$this->_lang;
		$result=array();
		$query="SELECT zefCatID,zefName$lang FROM zef_cat";
		if ($perms) {
			$where[]="(zefGroups REGEXP \"[|](".implode('|',$this->_gid).")[|]\" OR zefUsers LIKE '%|".$this->_uid."|%')";
		}
		if ($aktiv) $where[]="zefAktiv=1";
		if (is_array($pres)) $where[]='zefPres IN ('.implode(',',$this->_db->escape($pres)).')';
		elseif ($pres!=-1) $where[]='zefPres='.$this->_db->escape($pres);
		if (is_array($catIDs)) $where[]='zefCatID IN ('.implode(',',$this->_db->escape($catIDs)).')';
		elseif ($catIDs) $where[]='zefCatID='.$this->_db->escape($catIDs);
		if ($where) $query.=" WHERE ".implode(' AND ',$where);
		$query.=" ORDER BY zefName$lang";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('zefCatID')]=$this->_db->f("zefName$lang");
			$this->_catName[$this->_db->f('zefCatID')]=$this->_db->f("zefName$lang");
		}
		return $result;
	}
	function getCatName($zefCatID,$lang='') {
		if (!$lang) $lang=$this->_lang;
		$query="SELECT zefName$lang FROM zef_cat WHERE zefCatID=".$this->_db->escape($zefCatID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f("zefName$lang");
		} else {
			return '';
		}
	}
	function getCachedCatName($zefCatID,$lang='') {
		if (!$lang) $lang=$this->_lang;
		if (!isset($this->_catName[$zefCatID])) {
			$this->_catName[$zefCatID]=$this->getCatName($zefCatID,$lang);
		}
		return $this->_catName[$zefCatID];
	}
	function &_fetchCat($lang) {
		$result=array(
			'zefCatID'=>$this->_db->f('zefCatID'),
			'zefGroups'=>strlen($this->_db->f('zefGroups'))>2?explode('|',substr($this->_db->f('zefGroups'),1,-1)):array(),
			'zefUsers'=>strlen($this->_db->f('zefUsers'))>2?explode('|',substr($this->_db->f('zefUsers'),1,-1)):array(),
			'zefAktiv'=>$this->_db->f('zefAktiv'),
			'zefPres'=>$this->_db->f('zefPres'),
			'zefTimeCreate'=>$this->_db->f('zefTimeCreate'),
			'zefUserCreate'=>$this->_db->f('zefUserCreate'),
			'zefTimeAktiv'=>$this->_db->f('zefTimeAktiv'),
			'zefUserAktiv'=>$this->_db->f('zefUserAktiv'),
		);
		if (is_array($lang)) {
			foreach ($lang as $val) {
				$result['zefName'.$val]=$this->_db->f('zefName'.$val);
			}
		} else {
			$result['zefName'.$lang]=$this->_db->f('zefName'.$lang);
		}
		return $result;
	}



	function readPrj($zefPrjID) {
		$query="SELECT * FROM zef_prj WHERE zefPrjID=".$this->_db->escape($zefPrjID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_fetchPrj();
		} else {
			return false;
		}
	}
	function insertPrj($values) {
		$values['zefPrjID']=$this->_db->nextid('zef_prj');
		if ($this->_db->insert('zef_prj',$values)) {
			return $values['zefPrjID'];
		}
	}
	function updatePrj($zefPrjID,$values) {
		return $this->_db->update('zef_prj',$values,"zefPrjID=".$this->_db->escape($zefPrjID));
	}
	function deletePrj($zefPrjID) {
		if (!$this->isUsedPrj($zefPrjID)) {
			$query="DELETE FROM zef_prj  WHERE zefPrjID=".$this->_db->escape($zefPrjID);
			$this->_db->query($query);
			return true;

		} else {
			return false;
		}
	}
	function deleteAllPrjEntries($zefPrjID) {
		$query="DELETE FROM zef  WHERE FKzefPrjID=".$this->_db->escape($zefPrjID);
		$this->_db->query($query);
	}
	function isUsedPrj($zefPrjID) {
		$query="SELECT FKzefPrjID FROM zef WHERE FKzefPrjID=".$this->_db->escape($zefPrjID)." ".$this->_db->formatLimit(0,1);
		$this->_db->query($query);
		if ($this->_db->num_rows()) {
			return true;
		} else {
			return false;
		}
	}
	function &listAllPrj(&$rows,$order='zefName',$b=0,$limit=0,$search=0) {
		$result=array();
		$searchQuery=array();
		if ($search['info']) {
			$searchQuery[]=array('Field'=>'zefName','Typ'=>'concat','Values'=>$search['info']);
		}
		$query="SELECT * FROM zef_prj ";
		if (!empty($searchQuery)) {
			$query.=" WHERE ".$this->_db->getWhere($searchQuery);
		}
		$query.=" ORDER BY $order ";
		if ($limit) $query.=$this->_db->formatLimit($b,$limit);
		$this->_db->query($query);
		$rows=$this->_db->num_rows();
		while ($this->_db->next_record()) {
			$result[$this->_db->f('zefPrjID')]=$this->_fetchPrj();
		}
		if ($limit && ($b!=0 || $limit==$rows)) {
			$query="SELECT count(*) as num FROM zef_prj";
			if (!empty($searchQuery)) {
				$query.=" WHERE ".$this->_db->getWhere($searchQuery);
			}
			$this->_db->query($query);
			$this->_db->next_record();
			$rows=$this->_db->f('num');
		}
		return $result;
	}
	function &listAllPrjNames($aktiv=1,$perms=1,$info='',$limit=0) {
		$result=array();

		$query="SELECT zef_prj.zefPrjID,zef_prj.zefName,zef_prj.PermsUser,zef_prj.PermsGroup FROM zef_prj";
		if ($perms && !$this->isRuleUser()) {
			$acl_where[]=' zef_prj.PermsUser LIKE '.$this->_db->escape('%|'.$this->_uid.',%');
			if (is_array($this->_gid)) {
				foreach ($this->_gid as $val) {
					$acl_where[]=" zef_prj.PermsGroup LIKE ".$this->_db->escape('%|'.$val.',%');
				}
			}
			$where[]='('.implode (' OR ',$acl_where).')';
			//echo "www";
		}
		if ($aktiv) $where[]=" zef_prj.zefAktiv=1";
		if ($info) $where[]=" zef_prj.zefName LIKE ".$this->_db->escape('%'.$info.'%',1);
		if ($where) $query.=" WHERE ".implode(' AND ',$where);
		$query.=" ORDER BY zef_prj.zefName";



		if ($limit)  $query.=" ".$this->_db->formatLimit(0,$limit);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			if ($perms) {
				$acl=$this->_fetchACL();
				//debug($acl);
				if (!($acl&$perms)) continue;
			}
			$result[$this->_db->f('zefPrjID')]=$this->_db->f("zefName");
			$this->_prjName[$this->_db->f('zefPrjID')]=$this->_db->f("zefName");
		}
		return $result;
	}




	function getPrjName($prjID) {
		$query="SELECT zefName FROM zef_prj WHERE zefPrjID=".$this->_db->escape($prjID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f("zefName");
		}
		return $result;
	}
	function getCachedPrjName($prjID) {
		if (!isset($this->_prjName[$prjID])) {
			$this->_prjName[$prjID]=$this->getPrjName($prjID);
		}
		return $this->_prjName[$prjID];
	}

	function &_fetchACL() {
		if ($this->isRuleUser()) return 7;
		return $this->_frm->calcAcl($this->_db->f('PermsUser'),$this->_db->f('PermsGroup'),$this->_uid);
	}
	function getPrjPerms($ID) {
		$result=array();
		$query="SELECT PermsUser,PermsGroup FROM zef_prj WHERE zefPrjID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_fetchACL();
		}
		return 0;

	}
	function getPrjUsers($ID) {
		$result=array();
		$query="SELECT DISTINCT zefUser FROM zef WHERE FKzefPrjID=".$this->_db->escape($ID);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f("zefUser");
		}
		return $result;
	}
	function getPrjCatIds($ID) {
		$result=array();
		$query="SELECT DISTINCT FKzefCatID FROM zef WHERE FKzefPrjID=".$this->_db->escape($ID);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f("FKzefCatID");
		}
		return $result;
	}
	function getPrjCompIds($ID) {
		$result=array();
		$query="SELECT DISTINCT FKcompID FROM zef WHERE FKzefPrjID=".$this->_db->escape($ID);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f("FKcompID");
		}
		return $result;
	}
	function getPrjCalResIds($ID) {
		$result=array();
		$query="SELECT DISTINCT FKCalResID FROM zef WHERE FKzefPrjID=".$this->_db->escape($ID);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f("FKCalResID");
		}
		return $result;
	}

	function &_fetchPrj() {
		$result=array(
			'zefPrjID'=>$this->_db->f('zefPrjID'),
			'zefName'=>$this->_db->f('zefName'),
			'zefAktiv'=>$this->_db->f('zefAktiv'),
			'PermsUser'=>$this->_db->f('PermsUser'),
			'PermsGroup'=>$this->_db->f('PermsGroup'),
			'zefTimeCreate'=>$this->_db->f('zefTimeCreate'),
			'zefUserCreate'=>$this->_db->f('zefUserCreate'),
			'zefTimeAktiv'=>$this->_db->f('zefTimeAktiv'),
			'zefUserAktiv'=>$this->_db->f('zefUserAktiv'),
		);
		return $result;
	}

	function replacePerms($typ,$id,$Perms) {
		foreach ($Perms as $val) {
			$this->_db->insert('zef_perms',array('zefID'=>$id,'zefTyp'=>$typ,'zefPerms'=>$val),'',1);
		}
	}
	function getAllPerms() {
		$result=array();
		$query="SELECT * FROM zef_perms";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('zefTyp')][$this->_db->f('zefID')][]=$this->_db->f('zefPerms');
		}
		return $result;
	}
	function deletePerms($typ,$id) {
		$query="DELETE FROM zef_perms WHERE";
		$query.=" zefTyp=".$this->_db->escape($typ);
		$query.=" AND zefID=".$this->_db->escape($id);
		$this->_db->query($query);
	}
	function listExpensesTables() {
		$result=array();
		$query="SELECT * FROM zefExTables WHERE Deleted=0 ";
		$query.=" ORDER BY tabName";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('tabID')]=$this->_db->f('tabName');
		}
		return $result;
	}
	function readExpensesTable($ID) {
		$query="SELECT * FROM zefExTables WHERE tabID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_fetchExpensesTable();
		} else {
			return false;
		}
	}

	function &_fetchExpensesTable() {
		$result=array(
			'tabID'=>$this->_db->f('tabID'),
			'tabName'=>$this->_db->f('tabName'),
			'tabTyp'=>$this->_db->f('tabTyp'),
			'tabUnit'=>$this->_db->f('tabUnit'),
			'TimeCreate'=>$this->_db->f('TimeCreate'),
			'UserCreate'=>$this->_db->f('UserCreate'),
			'TimeModify'=>$this->_db->f('TimeModify'),
			'UserModify'=>$this->_db->f('UserModify'),
			'Deleted'=>$this->_db->f('Deleted'),
		);
		return $result;
	}
	function insertExpensesTable($values) {
		$values['tabID']=$this->_db->nextid('zefExTables');
		$values['TimeCreate']=time();
		$values['TimeModify']=time();
		$values['UserCreate']=$this->_auth_uid;
		$values['UserModify']=$this->_auth_uid;
		if ($this->_db->insert('zefExTables',$values)) {
			return $values['tabID'];
		}
	}
	function updateExpensesTable($ID,$values) {
		$values['TimeModify']=time();
		$values['UserModify']=$this->_auth_uid;
		return $this->_db->update('zefExTables',$values,"tabID=".$this->_db->escape($ID));
	}
	function deleteExpensesTable($ID) {
		if (!$this->hasExpensesEntries($ID)) {
			$values=array(
				'Deleted'=>1,
				'TimeModify'=>time(),
				'UserModify'=>$this->_auth_uid,
			);
			return $this->_db->update('zefExTables',$values,"tabID=".$this->_db->escape($ID));
		} else {
			return false;
		}
	}
	function hasExpensesEntries($ID) {
		$query="SELECT * FROM zefExTableValues WHERE Deleted=0 AND FKTabID=".$this->_db->escape($ID);
		$query.=" ".$this->_db->formatLimit(0,1);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return true;
		} else {
			$query="SELECT * FROM zefExCosts WHERE Deleted=0 AND FKTabID=".$this->_db->escape($ID);
			$query.=" ".$this->_db->formatLimit(0,1);
			$this->_db->query($query);
			if ($this->_db->next_record()) {
				return true;
			} else {
				return false;
			}
		}
	}
	function readExpensesEntry($ID) {
		$query="SELECT * FROM zefExTableValues WHERE ID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_fetchExpensesEntries();
		} else {
			return false;
		}
	}
	function listExpensesEntries($ID,$order='Sequence') {
		$result=array();
		$query="SELECT * FROM zefExTableValues WHERE Deleted=0 AND FKTabID=".$this->_db->escape($ID);
		$query.=" ORDER BY ".$order;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('ID')]=$this->_fetchExpensesEntries();
		}
		return $result;
	}
	function &_fetchExpensesEntries() {
		$result=array(
			'ID'=>$this->_db->f('ID'),
			'FKTabID'=>$this->_db->f('FKTabID'),
			'FKUserID'=>$this->_db->f('FKUserID'),
			'Unit'=>$this->_db->f('Unit'),
			'Calc'=>$this->_db->f('Calc'),
			'TimeCreate'=>$this->_db->f('TimeCreate'),
			'UserCreate'=>$this->_db->f('UserCreate'),
			'TimeModify'=>$this->_db->f('TimeModify'),
			'UserModify'=>$this->_db->f('UserModify'),
			'Deleted'=>$this->_db->f('Deleted'),
			'Sequence'=>$this->_db->f('Sequence'),
		);
		return $result;
	}
	function insertExpensesEntry($values,$tabTyp=0) {
		$ID=0;
		if ($tabTyp==1) {
			$ID=$this->getExpensesUserEntry($values);
			if ($ID) {
				$values['Deleted']=0;
				$this->updateExpensesEntry($ID,$values);
				return $ID;
			}
		}

		$values['ID']=$this->_db->nextid('zefExTableValues');
		$values['Sequence']=$this->getNextExpensesEntrySequence($values['FKTabID']);
		$values['TimeCreate']=time();
		$values['TimeModify']=time();
		$values['UserCreate']=$this->_auth_uid;
		$values['UserModify']=$this->_auth_uid;
		if ($this->_db->insert('zefExTableValues',$values)) {
			return $values['ID'];
		}
	}
	function updateExpensesEntry($ID,$values) {
		if ($tabTyp==1) {
			$this->deleteExpensesUserEntry($values,$ID);
		}
		$values['TimeModify']=time();
		$values['UserModify']=$this->_auth_uid;
		return $this->_db->update('zefExTableValues',$values,"ID=".$this->_db->escape($ID));
	}
	function getExpensesUserEntry($Obj,$ignoreID=0) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKTabID','Typ'=>'=','Values'=>$Obj['FKTabID']);
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$Obj['FKUserID']);
		if ($ignoreID) {
			$searchQuery[]=array('Field'=>'ID','Typ'=>'!=','Values'=>$ignoreID);
		}
		$query="SELECT * FROM zefExTableValues WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('ID');
		}
	}
	function calcUserExpenses($ID,$userID) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKTabID','Typ'=>'=','Values'=>$ID);
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>array(0,$userID));
		$searchQuery[]=array('Field'=>'Deleted','Typ'=>'=','Values'=>0);

		$query="SELECT FKUserID,Calc FROM zefExTableValues WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" ORDER BY FKUserID DESC";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return floatVal($this->_db->f('Calc'));
		} else {
			return 0;
		}
	}
	function deleteExpensesUserEntry($Obj) {
		$values=array(
			'Deleted'=>1,
			'TimeModify'=>time(),
			'UserModify'=>$this->_auth_uid,
		);
		return $this->_db->update('zefExTableValues',$values,"FKTabID=".$this->_db->escape($Obj['FKTabID']).' AND FKUserID='.$this->_db->escape($Obj['FKUserID']));
	}
	function deleteExpensesEntry($ID,$tabTyp=0) {
		$values=array(
			'Deleted'=>1,
			'TimeModify'=>time(),
			'UserModify'=>$this->_auth_uid,
		);
		return $this->_db->update('zefExTableValues',$values,"ID=".$this->_db->escape($ID));
	}


	function readCosts($ID,$lang='') {
		if (!$lang) $lang=$this->_lang;
		$query="SELECT * FROM zefExCosts WHERE ID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_fetchCosts($lang);
		} else {
			return false;
		}
	}
	function listCosts($lang='') {
		if (!$lang) $lang=$this->_lang;
		$result=array();
		$query="SELECT * FROM zefExCosts WHERE Deleted=0";
		$query.=" ORDER BY Sequence";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('ID')]=$this->_fetchCosts($lang);
		}
		return $result;
	}
	function &_fetchCosts($lang) {
		$result=array(
			'ID'=>$this->_db->f('ID'),
			'FKTabID'=>$this->_db->f('FKTabID'),
			'UseCosts'=>$this->_db->f('UseCosts'),
			'UseDeref'=>$this->_db->f('UseDeref'),
			'TimeCreate'=>$this->_db->f('TimeCreate'),
			'UserCreate'=>$this->_db->f('UserCreate'),
			'TimeModify'=>$this->_db->f('TimeModify'),
			'UserModify'=>$this->_db->f('UserModify'),
			'Deleted'=>$this->_db->f('Deleted'),
			'Sequence'=>$this->_db->f('Sequence'),
		);
		if (is_array($lang)) {
			foreach ($lang as $val) {
				$result['Name'.$val]=$this->_db->f('Name'.$val);
			}
		} else {
			$result['Name'.$lang]=$this->_db->f('Name'.$lang);
		}
		return $result;
	}
	function insertCosts($values) {
		$values['ID']=$this->_db->nextid('zefExCosts');
		$values['Sequence']=$this->getNextCostsSequence();
		$values['TimeCreate']=time();
		$values['TimeModify']=time();
		$values['UserCreate']=$this->_auth_uid;
		$values['UserModify']=$this->_auth_uid;
		if ($this->_db->insert('zefExCosts',$values)) {
			return $values['ID'];
		}
	}
	function updateCosts($ID,$values) {
		$values['TimeModify']=time();
		$values['UserModify']=$this->_auth_uid;
		return $this->_db->update('zefExCosts',$values,"ID=".$this->_db->escape($ID));
	}
	function deleteCosts($ID) {
		$values=array(
			'Deleted'=>1,
			'TimeModify'=>time(),
			'UserModify'=>$this->_auth_uid,
		);
		return $this->_db->update('zefExCosts',$values,"ID=".$this->_db->escape($ID));
	}
	function insertZefCosts($ID,$Values) {
		$this->deleteZefCosts($ID);
		foreach ($Values as $insert) {
			$insert['FKzefID']=$ID;
			$this->_db->insert('zefCosts',$insert);
		}
	}
	function deleteZefCosts($ID) {
		$query="DELETE FROM zefCosts WHERE FKzefID=".$this->_db->escape($ID);
		$this->_db->query($query);
	}
	function listZefCosts($ID,$deref=0) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKzefID','Typ'=>'=','Values'=>$ID);
		if ($deref) {
			$searchQuery[]=array('Field'=>'FKUseDeref','Typ'=>'=','Values'=>$deref);
		}
		$query="SELECT * FROM zefCosts WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('AutoID')]=$this->_fetchZefCosts();
		}
		return $result;
	}
	function listAllZefCosts($ID,$deref=0,$lang='') {
		if (!$lang) $lang=$this->_lang;
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'zefCosts.FKcostID','Typ'=>'F=F','Values'=>'zefExCosts.ID');
		$searchQuery[]=array('Field'=>'FKzefID','Typ'=>'=','Values'=>$ID);
		if ($deref) {
			$searchQuery[]=array('Field'=>'FKUseDeref','Typ'=>'=','Values'=>$deref);
		}
		$query="SELECT zefCosts.*,zefExCosts.Name$lang as Name FROM zefCosts,zefExCosts WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" ORDER BY FKzefID";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_fetchZefCosts(array('Name','FKzefID'));
		}
		return $result;
	}
	function getSumCosts($ID) {
		$result=0;
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKzefID','Typ'=>'=','Values'=>$ID);
		$query="SELECT SUM(costCalc) as sumCost FROM zefCosts,zefExCosts WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('sumCost');
		}
		return $result;
	}
	function &_fetchZefCosts($extra=null) {
		$result=array(
			'AutoID'=>$this->_db->f('AutoID'),
			'FKzefID'=>$this->_db->f('FKzefID'),
			'FKcostID'=>$this->_db->f('FKcostID'),
			'FKcostTabID'=>$this->_db->f('FKcostTabID'),
			'FKcostEntryID'=>$this->_db->f('FKcostEntryID'),
			'costValue'=>$this->_db->f('costValue'),
			'costCalc'=>$this->_db->f('costCalc'),
			'costDesc'=>$this->_db->f('costDesc'),
			'FKUseCosts'=>$this->_db->f('FKUseCosts'),
			'FKUseDeref'=>$this->_db->f('FKUseDeref'),
		);
		if ($extra && is_array($extra)) {
			foreach ($extra as $val) {
				$result[$val]=$this->_db->f($val);
			}
		}
		return $result;
	}
	function getNextExpensesEntrySequence($ID) {
		$query="SELECT max(Sequence) as num FROM zefExTableValues";
		$query.=' WHERE Deleted=0 AND FKTabID='.$this->_db->escape($ID);
		$query.=" GROUP BY FKTabID";
		$this->_db->query($query);
		$this->_db->next_record();
		return intval($this->_db->f('num') + 1);
	}
	function getNextCostsSequence() {
		$query="SELECT max(Sequence) as num FROM zefExCosts WHERE Deleted=0";
		$this->_db->query($query);
		$this->_db->next_record();
		return intval($this->_db->f('num') + 1);
	}
	function _moveSequence ($Table,$ID,$dir='down') {
		return $this->_db->moveEntry ($Table,'ID','Sequence',$ID,$dir);
	}
	function moveExpensesEntry($TabId,$ID,$dir='down') {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKTabID','Typ'=>'=','Values'=>$TabId);
		return $this->_db->moveEntry ('zefExTableValues','ID','Sequence',$ID,$dir,$searchQuery);
	}
	function moveCosts($ID,$dir='down') {
		return $this->_db->moveEntry ('zefExCosts','ID','Sequence',$ID,$dir);
	}

	function searchExpenses($search,$lang='') {
		if (!$lang) $lang=$this->_lang;
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'zefCosts.FKzefID','Typ'=>'F=F','Values'=>'zef.zefID');
		$searchQuery[]=array('Field'=>'zefCosts.FKcostID','Typ'=>'F=F','Values'=>'zefExCosts.ID');

		$searchQuery[]=array('Field'=>'FKzefDerefID','Typ'=>'=','Values'=>0);
		if ($search['FKUserID']) $searchQuery[]=array('Field'=>'zefUser','Typ'=>'=','Values'=>$search['FKUserID']);
		if ($search['DateB']) $searchQuery[]=array('Field'=>'zefBegin','Typ'=>'>=','Values'=>date('Y-m-d H:i:s',$search['DateB']));
		if ($search['DateE']) $searchQuery[]=array('Field'=>'zefEnd','Typ'=>'<=','Values'=>date('Y-m-d H:i:s',$search['DateE']));

		$searchQuery[]=array('Field'=>'zefExCosts.UseCosts','Typ'=>'=','Values'=>1);

		$query="SELECT zefCosts.*,zefExCosts.Name$lang,zef.zefBegin,zef.zefEnd,zef.zefUser,zef.FKzefCatID,zef.FKzefPrjID,zef.FKcompID,zef.compMode,zef.FKCalResID FROM zefCosts,zef,zefExCosts ";
		$query.=" WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" ORDER BY zefBegin";
		//echo $query;
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('FKzefID')][$this->_db->f('AutoID')]=array(
				'zefUser'=>$this->_db->f('zefUser'),
				'zefBegin'=>$this->_db->f('zefBegin'),
				'zefEnd'=>$this->_db->f('zefEnd'),
				'FKzefCatID'=>$this->_db->f('FKzefCatID'),
				'FKzefPrjID'=>$this->_db->f('FKzefPrjID'),
				'FKcompID'=>$this->_db->f('FKcompID'),
				'FKCalResID'=>$this->_db->f('FKCalResID'),
				'compMode'=>$this->_db->f('compMode'),
				'FKcostID'=>$this->_db->f('FKcostID'),
				'FKcostTabID'=>$this->_db->f('FKcostTabID'),
				'FKcostEntryID'=>$this->_db->f('FKcostEntryID'),
				'costValue'=>$this->_db->f('costValue'),
				'costCalc'=>$this->_db->f('costCalc'),
				'costDesc'=>$this->_db->f('costDesc'),
				'Name'=>$this->_db->f('Name'.$lang),
			);
		}
		return $result;
	}



	function readEmployee($ID) {
		$query="SELECT * FROM zefEmployee WHERE ID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_fetchEmployee();
		} else {
			return false;
		}
	}
	function listEmployee() {
		$result=array();
		$query="SELECT * FROM zefEmployee WHERE Deleted=0";
		$query.=" ORDER BY FKUserID DESC,IF(FKGroupID,1,0) DESC,FKCompID DESC,FKPrjID DESC,FKCatID DESC";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('ID')]=$this->_fetchEmployee();
		}
		return $result;
	}
	function &_fetchEmployee() {
		$result=array(
			'ID'=>$this->_db->f('ID'),
			'FKUserID'=>$this->_db->f('FKUserID'),
			'FKGroupID'=>$this->_db->f('FKGroupID'),
			'FKCatID'=>$this->_db->f('FKCatID'),
			'FKCompID'=>$this->_db->f('FKCompID'),
			'FKPrjID'=>$this->_db->f('FKPrjID'),
			'Calc'=>$this->_db->f('Calc'),
			'TimeCreate'=>$this->_db->f('TimeCreate'),
			'UserCreate'=>$this->_db->f('UserCreate'),
			'TimeModify'=>$this->_db->f('TimeModify'),
			'UserModify'=>$this->_db->f('UserModify'),
			'Deleted'=>$this->_db->f('Deleted'),
		);
		return $result;
	}
	function insertEmployee($values) {
		$ID=$this->getEmployeeUserEntry($values);
		if ($ID) {
			$values['Deleted']=0;
			$this->updateEmployee($ID,$values);
			return $ID;
		}

		$values['ID']=$this->_db->nextid('zefEmployee');
		$values['TimeCreate']=time();
		$values['TimeModify']=time();
		$values['UserCreate']=$this->_auth_uid;
		$values['UserModify']=$this->_auth_uid;
		if ($this->_db->insert('zefEmployee',$values)) {
			return $values['ID'];
		}
	}
	function updateEmployee($ID,$values) {
		$this->deleteEmployeeUserEntry($values,$ID);
		$values['TimeModify']=time();
		$values['UserModify']=$this->_auth_uid;
		return $this->_db->update('zefEmployee',$values,"ID=".$this->_db->escape($ID));
	}
	function deleteEmployee($ID) {
		$values=array(
			'Deleted'=>1,
			'TimeModify'=>time(),
			'UserModify'=>$this->_auth_uid,
		);
		return $this->_db->update('zefEmployee',$values,"ID=".$this->_db->escape($ID));
	}
	function deleteEmployeeUserEntry($Obj) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$Obj['FKUserID']);
		$searchQuery[]=array('Field'=>'FKGroupID','Typ'=>'=','Values'=>$Obj['FKGroupID']);
		$searchQuery[]=array('Field'=>'FKCatID','Typ'=>'=','Values'=>$Obj['FKCatID']);
		$searchQuery[]=array('Field'=>'FKPrjID','Typ'=>'=','Values'=>$Obj['FKPrjID']);
		$searchQuery[]=array('Field'=>'FKCompID','Typ'=>'=','Values'=>$Obj['FKCompID']);

		$values=array(
			'Deleted'=>1,
			'TimeModify'=>time(),
			'UserModify'=>$this->_auth_uid,
		);
		return $this->_db->update('zefEmployee',$values,$this->_db->getWhere($searchQuery));
	}
	function getEmployeeUserEntry($Obj,$ignoreID=0) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>$Obj['FKUserID']);
		$searchQuery[]=array('Field'=>'FKGroupID','Typ'=>'=','Values'=>$Obj['FKGroupID']);
		$searchQuery[]=array('Field'=>'FKCatID','Typ'=>'=','Values'=>$Obj['FKCatID']);
		$searchQuery[]=array('Field'=>'FKPrjID','Typ'=>'=','Values'=>$Obj['FKPrjID']);
		$searchQuery[]=array('Field'=>'FKCompID','Typ'=>'=','Values'=>$Obj['FKCompID']);
		if ($ignoreID) {
			$searchQuery[]=array('Field'=>'ID','Typ'=>'!=','Values'=>$ignoreID);
		}
		$query="SELECT * FROM zefEmployee WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_db->f('ID');
		}
	}
	function calcUserEmployee($userID,$catID,$compID,$prjID=0) {
		if ($compID==-1) {
			return 0;
		}
		if (!isset($this->_cachedUserGroups[$userID])) {
			$this->_cachedUserGroups[$userID]=$this->_frm->getUserGroups($userID);
		}
		$groups=$this->_cachedUserGroups[$userID];
		$groups[]=0;

		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKGroupID','Typ'=>'=','Values'=>$groups);
		$searchQuery[]=array('Field'=>'FKUserID','Typ'=>'=','Values'=>array(0,$userID));
		$searchQuery[]=array('Field'=>'FKCatID','Typ'=>'=','Values'=>array(0,$catID));
		$searchQuery[]=array('Field'=>'FKCompID','Typ'=>'=','Values'=>array(0,$compID));
		$searchQuery[]=array('Field'=>'FKPrjID','Typ'=>'=','Values'=>array(0,$prjID));
		$searchQuery[]=array('Field'=>'Deleted','Typ'=>'=','Values'=>0);

		$query="SELECT FKUserID,Calc FROM zefEmployee WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" ORDER BY FKUserID DESC,IF(FKGroupID,1,0) DESC,FKCompID DESC,FKPrjID DESC,FKCatID DESC";
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return floatVal($this->_db->f('Calc'));
		} else {
			return 0;
		}
	}
	function readCompany($ID) {
		$query="SELECT * FROM zefCompany WHERE ID=".$this->_db->escape($ID);
		$this->_db->query($query);
		if ($this->_db->next_record()) {
			return $this->_fetchCompany();
		} else {
			return false;
		}
	}
	function listCompanies($aktiv=0) {
		$result=array();
		$query="SELECT * FROM zefCompany WHERE Deleted=0";
		if ($aktiv) $query.=" AND Aktiv=1";
		$query.=" ORDER BY Aktiv DESC,Name";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('ID')]=$this->_fetchCompany();
		}
		return $result;
	}
	function &_fetchCompany() {
		$result=array(
			'ID'=>$this->_db->f('ID'),
			'Name'=>$this->_db->f('Name'),
			'Aktiv'=>$this->_db->f('Aktiv'),
			'TimeCreate'=>$this->_db->f('TimeCreate'),
			'UserCreate'=>$this->_db->f('UserCreate'),
			'TimeModify'=>$this->_db->f('TimeModify'),
			'UserModify'=>$this->_db->f('UserModify'),
			'Deleted'=>$this->_db->f('Deleted'),
		);
		return $result;
	}
	function insertCompany($values) {
		$values['ID']=$this->_db->nextid('zefCompany');
		$values['TimeCreate']=time();
		$values['TimeModify']=time();
		$values['UserCreate']=$this->_auth_uid;
		$values['UserModify']=$this->_auth_uid;
		if ($this->_db->insert('zefCompany',$values)) {
			return $values['ID'];
		}
	}
	function updateCompany($ID,$values) {
		$values['TimeModify']=time();
		$values['UserModify']=$this->_auth_uid;
		return $this->_db->update('zefCompany',$values,"ID=".$this->_db->escape($ID));
	}
	function deleteCompany($ID) {
		if (!$this->isUsedCompany($ID)) {
			$query="DELETE FROM zefCompany  WHERE ID=".$this->_db->escape($ID);
			$this->_db->query($query);
			return true;
		} else {
			return false;
		}
	}
	function &listAllCompanyNames($aktiv=1,$compIds=null,$info=null,$limit=0) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'Deleted','Typ'=>'=','Values'=>0);
		if ($aktiv) $searchQuery[]=array('Field'=>'Aktiv','Typ'=>'=','Values'=>$aktiv);
		if ($compIds) $searchQuery[]=array('Field'=>'ID','Typ'=>'=','Values'=>$compIds);
		if ($info) $searchQuery[]=array('Field'=>'Name','Typ'=>'like=','Values'=>'%'.$info.'%');

		$query="SELECT * FROM zefCompany WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" ORDER BY Aktiv DESC,Name";
		if ($limit)  $query.=" ".$this->_db->formatLimit(0,$limit);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('ID')]=$this->_db->f("Name");
			$this->_compName[$this->_db->f('ID')]=$this->_db->f("Name");
		}
		return $result;
	}
	function getCachedCompanyName($ID) {
		if (!isset($this->_compName[$ID])) {
			$temp=$this->readCompany($ID);
			if ($temp) {
				$this->_compName[$ID]=$temp['Name'];
			}
		}
		return $this->_compName[$ID];
	}
	function isUsedCompany($ID) {
		$query="SELECT FKcompID FROM zef WHERE FKcompID=".$this->_db->escape($ID)." ".$this->_db->formatLimit(0,1);
		$this->_db->query($query);
		if ($this->_db->num_rows()) {
			return true;
		}
		$query="SELECT FKCompID FROM zefEmployee WHERE Deleted=0 AND FKCompID=".$this->_db->escape($ID)." ".$this->_db->formatLimit(0,1);
		$this->_db->query($query);
		if ($this->_db->num_rows()) {
			return true;
		}
		$query="SELECT FKCompID FROM zefCompanyCalc WHERE FKCompID=".$this->_db->escape($ID)." ".$this->_db->formatLimit(0,1);
		$this->_db->query($query);
		if ($this->_db->num_rows()) {
			return true;
		}
		return false;
	}

	function insertCompanyCalc($ID,$ObjTyp,$Values) {
		$this->deleteCompanyCalc($ID,$ObjTyp);
		if (is_array($Values)) {
			foreach ($Values as $insert) {
				$insert['FKObjID']=$ID;
				$insert['ObjTyp']=$ObjTyp;
				$this->_db->insert('zefCompanyCalc',$insert);
			}
		}
	}
	function deleteCompanyCalc($ID,$ObjTyp) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKObjID','Typ'=>'=','Values'=>$ID);
		$searchQuery[]=array('Field'=>'ObjTyp','Typ'=>'=','Values'=>$ObjTyp);
		$query="DELETE FROM zefCompanyCalc WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
	}
	function listCompanyCalc($ID,$ObjTyp) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKObjID','Typ'=>'=','Values'=>$ID);
		$searchQuery[]=array('Field'=>'ObjTyp','Typ'=>'=','Values'=>$ObjTyp);
		$query="SELECT * FROM zefCompanyCalc WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" ORDER BY FKUserID DESC,Percent DESC";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_fetchCompanyCalc();
		}
		return $result;
	}
	function listAllCompanyCalc($ObjTyp,$ObjID=0) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'ObjTyp','Typ'=>'=','Values'=>$ObjTyp);
		if ($ObjID) $searchQuery[]=array('Field'=>'FKObjID','Typ'=>'=','Values'=>$ObjID);
		$query="SELECT * FROM zefCompanyCalc WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" ORDER BY FKUserID DESC";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('FKObjID')][$this->_db->f('FKUserID')][]=$this->_fetchCompanyCalc();
		}
		return $result;
	}
	function &_fetchCompanyCalc() {
		$result=array(
			'FKObjID'=>$this->_db->f('FKObjID'),
			'ObjTyp'=>$this->_db->f('ObjTyp'),
			'FKUserID'=>$this->_db->f('FKUserID'),
			'FKCompID'=>$this->_db->f('FKCompID'),
			'Percent'=>$this->_db->f('Percent'),
		);
		return $result;
	}
	function getOpenQuartals($uid=0) {
		$result=array();
		if (!$uid) $uid=$this->_uid;
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'zefUser','Typ'=>'=','Values'=>$uid);
		$searchQuery[]=array('Field'=>'zefClosed','Typ'=>'=','Values'=>0);
		$query="SELECT DISTINCT QUARTER(zefBegin) as zefQuarter,YEAR(zefBegin) as zefYear FROM zef";
		$query.=" WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" ORDER BY zefYear DESC,zefQuarter DESC";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('zefYear').'-'.$this->_db->f('zefQuarter')]=array(
				'y'=>$this->_db->f('zefYear'),
				'q'=>$this->_db->f('zefQuarter'),
			);
		}
		return $result;
	}
	function checkOpenQuartals($Year,$Quarter,$uid=0,$open=0) {
		$result=array();
		$query="SELECT DISTINCT zefUser FROM zef";
		$query.=" WHERE zefClosed=".$this->_db->escape($open);
		$query.=" AND QUARTER(zefBegin)=".$this->_db->escape($Quarter)." AND YEAR(zefBegin)=".$this->_db->escape($Year);
		if ($uid) $query.=" AND zefUser=".$this->_db->escape($uid);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('zefUser');
		}
		return $result;
	}
	function checkAllOpenQuartals($Year,$Quarter,$uid=0) {
		$result=array();
		$query="SELECT DISTINCT zefUser,zefClosed FROM zef";
		$query.=" WHERE QUARTER(zefBegin)=".$this->_db->escape($Quarter)." AND YEAR(zefBegin)=".$this->_db->escape($Year);
		if ($uid) $query.=" AND zefUser IN (".implode(',',$this->_db->escape($uid)).')';
		$query.=" ORDER BY zefClosed ASC,zefUser";
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[$this->_db->f('zefUser')]=$this->_db->f('zefClosed');
		}
		return $result;
	}
	function updateQuartalsClose($Year,$Quarter,$uid=0,$close=1) {
		if (!$uid) $uid=$this->_uid;
		$query="UPDATE zef SET zefClosed=".$this->_db->escape($close);
		$query.=" WHERE zefUser=".$this->_db->escape($uid)." AND QUARTER(zefBegin)=".$this->_db->escape($Quarter)." AND YEAR(zefBegin)=".$this->_db->escape($Year);
		$this->_db->query($query);
	}

	function checkDerefCat($Year,$Quarter,$uid=0) {
		$result=array();
		$query="SELECT DISTINCT FKzefCatID FROM zef LEFT JOIN zefCompanyCalc ON (FKObjID=FKzefCatID AND ObjTyp='cat' AND (FKUserID=zefUser OR FKUserID=0))";
		$query.=" WHERE zef.FKcompID=-1 AND zef.compMode=0 AND FKObjID IS NULL ";
		$query.=" AND QUARTER(zefBegin)=".$this->_db->escape($Quarter)." AND YEAR(zefBegin)=".$this->_db->escape($Year);
		if ($uid) $query.=" AND zefUser=".$this->_db->escape($this->_uid);
		//debug($query);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('FKzefCatID');
		}
		return $result;
	}
	function checkDerefPrj($Year,$Quarter,$uid=0) {
		$result=array();
		$query="SELECT DISTINCT FKzefPrjID FROM zef LEFT JOIN zefCompanyCalc ON (FKObjID=FKzefPrjID AND ObjTyp='prj')";
		$query.=" WHERE zef.FKcompID=-1 AND zef.compMode=1 AND FKObjID IS NULL ";
		$query.=" AND QUARTER(zefBegin)=".$this->_db->escape($Quarter)." AND YEAR(zefBegin)=".$this->_db->escape($Year);
		if ($uid) $query.=" AND zefUser=".$this->_db->escape($this->_uid);
		//debug($query);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('FKzefPrjID');
		}
		return $result;
	}
	function checkDerefUsr($Year,$Quarter,$uid=0) {
		$result=array();
		$query="SELECT DISTINCT zefID FROM zef LEFT JOIN zefCompanyCalc ON (FKObjID=zefID AND ObjTyp='usr')";
		$query.=" WHERE zef.FKcompID=-1 AND zef.compMode=2 AND FKObjID IS NULL ";
		$query.=" AND QUARTER(zefBegin)=".$this->_db->escape($Quarter)." AND YEAR(zefBegin)=".$this->_db->escape($Year);
		if ($uid) $query.=" AND zefUser=".$this->_db->escape($this->_uid);
		//debug($query);
		$this->_db->query($query);
		while ($this->_db->next_record()) {
			$result[]=$this->_db->f('zefID');
		}
		return $result;
	}
	function deleteDerefed($Begin,$End,$UserID=0) {
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKzefDerefID','Typ'=>'!=','Values'=>0);
		$searchQuery[]=array('Field'=>'zefBegin','Typ'=>'>=','Values'=>date('Y-m-d H:i:s',$Begin));
		$searchQuery[]=array('Field'=>'zefEnd','Typ'=>'<=','Values'=>date('Y-m-d H:i:s',$End));
		if ($UserID) $searchQuery[]=array('Field'=>'zefUser','Typ'=>'=','Values'=>$UserID);

		$query="DELETE FROM zef WHERE ".$this->_db->getWhere($searchQuery);
		//debug($query);
		$this->_db->query($query);
	}
	function calQuartal($Begin,$End,$UserID=0) {
		$this->deleteDerefed($Begin,$End,$UserID);
		$calcCat=$this->listAllCompanyCalc('cat');
		$calcPrj=$this->listAllCompanyCalc('prj');

		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKcompID','Typ'=>'=','Values'=>-1);
		$searchQuery[]=array('Field'=>'zefBegin','Typ'=>'>=','Values'=>date('Y-m-d H:i:s',$Begin));
		$searchQuery[]=array('Field'=>'zefEnd','Typ'=>'<=','Values'=>date('Y-m-d H:i:s',$End));
		$searchQuery[]=array('Field'=>'zefOpen','Typ'=>'=','Values'=>0);
		if ($UserID) $searchQuery[]=array('Field'=>'zefUser','Typ'=>'=','Values'=>$UserID);
		$query="SELECT * FROM zef WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		$entrys=array();
		while ($this->_db->next_record()) {
			$entrys[$this->_db->f('zefID')]=$this->_fetchZef();
		}
		//debug($entrys);
		if (!empty($entrys)) {
			$calcUsr=$this->listAllCompanyCalc('usr',array_keys($entrys));
			foreach ($entrys as $zefID=>$zefObj) {
				if ($zefObj['compMode']==2) {
					$actCalc=$calcUsr[$zefID];
				} elseif ($zefObj['compMode']) {
					$actCalc=$calcPrj[$zefObj['FKzefPrjID']];
				} else {
					$actCalc=$calcCat[$zefObj['FKzefCatID']];
				}
				//debug($actCalc);
				if ($actCalc) {
					if (isset($actCalc[$zefObj['zefUser']])) {
						$calcUser=$zefObj['zefUser'];
					} else {
						$calcUser=0;
					}
					$actData=array(
						'zefBegin'=>$zefObj['zefBegin'],
					);
					//debug(date('d.m.Y H:i',Framework::parseSqlDate($actData['zefBegin'])));
					//debug($actCalc[$calcUser]);
					if (is_array($actCalc[$calcUser])) {
						foreach ($actCalc[$calcUser] as $calcObj) {
							$newZef['FKzefDerefID']=$zefObj['zefID'];
							$newZef['FKcompID']=$calcObj['FKCompID'];
							$newZef['compMode']=0;
							$factor=$calcObj['Percent']/100;
							$newDuration=round($zefObj['zefDuration']*$factor);
							$newCorrection=round($zefObj['zefCorrection']*$factor);

							$newZef=array(
								'FKzefCatID'=>$zefObj['FKzefCatID'],
								'FKzefPrjID'=>$zefObj['FKzefPrjID'],
								'FKcompID'=>$calcObj['FKCompID'],
								'FKCalResID'=>$calcObj['FKCalResID'],
								'compMode'=>0,
								'zefBegin'=>$actData['zefBegin'],
								'zefEnd'=>date('Y-m-d H:i',Framework::parseSqlDate($actData['zefBegin'])+$newDuration),
								'zefDuration'=>$newDuration,
								'zefCorrection'=>$newCorrection,
								'zefUser'=>$zefObj['zefUser'],
								'zefDescription'=>$zefObj['zefDescription'],
								'zefClosed'=>$zefObj['zefClosed'],
								'FKzefDerefID'=>$zefObj['zefID'],
							);
							$newZef['zefCosts']=$this->calcUserEmployee($newZef['zefUser'],$newZef['FKzefCatID'],$newZef['FKcompID'],$newZef['FKzefPrjID']);

							$costInsert=array();
							$entryCosts=$this->listZefCosts($zefID);
							if (!empty($entryCosts)) {
								foreach ($entryCosts as $costVal) {
									$costInsert[]=array(
										'FKcostID'=>$costVal['FKcostID'],
										'FKcostTabID'=>$costVal['FKcostTabID'],
										'FKcostEntryID'=>$costVal['FKcostEntryID'],
										'costValue'=>round($costVal['costValue']*$factor,2),
										'costCalc'=>round($costVal['costCalc']*$factor,2),
										'FKUseCosts'=>$costVal['FKUseCosts'],
										'FKUseDeref'=>$costVal['FKUseDeref'],
										'costDesc'=>$costVal['costDesc'],
									);
								}
							}
							$actData['zefBegin']=$newZef['zefEnd'];
							//debug($newZef);
							//debug($costInsert);
							$newZefID=$this->insertZef($newZef);
							if (!empty($costInsert)) $this->insertZefCosts($newZefID,$costInsert);
						}
						$zefObj['zefDerefed']=1;
						$this->updateZef($zefID,$zefObj);
					}
				}
			}
		}
	}
	function moveZef($ID,$Date) {
		if ($ID && !empty($ID)) {
			$searchQuery=array();
			$searchQuery[]=array('Field'=>'zefID','Typ'=>'=','Values'=>$ID);
			$moveDate=$Date?date('Y-m-d',$Date):'0000-00-00';
			$this->_db->update('zef',array('zefMoveDate'=>$moveDate),$this->_db->getWhere($searchQuery));
		}
	}
	function checkEmpl($search,$update=false) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKcompID','Typ'=>'!=','Values'=>-1);
		if ($search['zefID']) $searchQuery[]=array('Field'=>'zefID','Typ'=>'=','Values'=>$search['zefID']);
		if ($search['DateB']) $searchQuery[]=array('Field'=>'zefBegin','Typ'=>'>=','Values'=>date('Y-m-d H:i:s',$search['DateB']));
		if ($search['DateE']) $searchQuery[]=array('Field'=>'zefEnd','Typ'=>'<=','Values'=>date('Y-m-d H:i:s',$search['DateE']));
		if ($search['zefUsers']) $searchQuery[]=array('Field'=>'zefUser','Typ'=>'=','Values'=>$search['zefUsers']);
		$query="SELECT * FROM zef WHERE ".$this->_db->getWhere($searchQuery);
		$query.=" ORDER BY zefBegin";
		$this->_db->query($query);
		//debug($query);
		//exit;
		while($this->_db->next_record()) {
			$result[$this->_db->f('zefID')]=$this->_fetchZef();
		}
		foreach ($result as $key=>$val) {
			$zefCosts=$this->calcUserEmployee($val['zefUser'],$val['FKzefCatID'],$val['FKcompID'],$val['FKzefPrjID']);
			if ($val['zefCosts']==$zefCosts) {
				unset($result[$key]);
			} else {
				if ($update) {
					$this->updateZef($key,array('zefCosts'=>$zefCosts));
				}
				$result[$key]['zefCosts_new']=$zefCosts;
			}

		}
		return $result;
	}
	function checkCosts($search,$update=false) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'zef.zefID','Typ'=>'F=F','Values'=>'zefCosts.FKzefID');
		//$searchQuery[]=array('Field'=>'zef.FKzefDerefID','Typ'=>'=','Values'=>'0');
		if ($search['zefID']) $searchQuery[]=array('Field'=>'zef.zefID','Typ'=>'=','Values'=>$search['zefID']);
		if ($search['DateB']) $searchQuery[]=array('Field'=>'zef.zefBegin','Typ'=>'>=','Values'=>date('Y-m-d H:i:s',$search['DateB']));
		if ($search['DateE']) $searchQuery[]=array('Field'=>'zef.zefEnd','Typ'=>'<=','Values'=>date('Y-m-d H:i:s',$search['DateE']));



		$query="SELECT zef.*,zefCosts.*";
		$query.=",zefExCosts.Deleted AS exDeleted,zefExCosts.FKTabID as exTabID ";
		$query.=",zefExTables.Deleted AS tabDeleted,zefExTables.tabTyp,zefExTables.tabID ";
		$query.=",zefExTableValues.Deleted AS valDeleted,zefExTableValues.FKTabID valTabID,zefExTableValues.Calc AS valCalc ";
		$query.="FROM zef,zefCosts LEFT JOIN zefExCosts ON (zefCosts.FKcostID=zefExCosts.ID) ";
		$query.="LEFT JOIN zefExTables ON (zefCosts.FKcostTabID=zefExTables.tabID) ";
		$query.="LEFT JOIN zefExTableValues ON (zefCosts.FKcostEntryID=zefExTableValues.ID) ";
		$query.="WHERE ".$this->_db->getWhere($searchQuery).' AND (';
		$query.="zefExCosts.Deleted=1 OR zefExCosts.FKTabID!=zefCosts.FKcostTabID ";
		$query.="OR (zefExTables.tabID IS NOT NULL AND (zefExTables.Deleted=1 OR zefExTables.tabTyp=1)) ";
		$query.="OR (zefExTableValues.ID IS NOT NULL AND (zefExTableValues.Deleted=1 OR zefExTableValues.FKTabID!=zefCosts.FKcostTabID ";
		$query.="OR zefExTableValues.Calc*zefCosts.costValue!=zefCosts.costCalc))";

		$query.=") ORDER BY zefBegin";
		$this->_db->query($query);
		//debug($query);
		//exit;
		while($this->_db->next_record()) {
			if (!isset($result[$this->_db->f('zefID')])) {
				$result[$this->_db->f('zefID')]=$this->_fetchZef();
			}
			$result[$this->_db->f('zefID')]['Exp'][$this->_db->f('AutoID')]=$this->_fetchZefCosts();
			$result[$this->_db->f('zefID')]['Exp'][$this->_db->f('AutoID')]['exDeleted']=$this->_db->f('exDeleted');
			$result[$this->_db->f('zefID')]['Exp'][$this->_db->f('AutoID')]['exTabID']=$this->_db->f('exTabID');
			$result[$this->_db->f('zefID')]['Exp'][$this->_db->f('AutoID')]['tabDeleted']=$this->_db->f('tabDeleted');

			$result[$this->_db->f('zefID')]['Exp'][$this->_db->f('AutoID')]['exDeleted']=$this->_db->f('exDeleted');
			$result[$this->_db->f('zefID')]['Exp'][$this->_db->f('AutoID')]['exTabID']=$this->_db->f('exTabID');
			$result[$this->_db->f('zefID')]['Exp'][$this->_db->f('AutoID')]['tabDeleted']=$this->_db->f('tabDeleted');
			$result[$this->_db->f('zefID')]['Exp'][$this->_db->f('AutoID')]['tabTyp']=$this->_db->f('tabTyp');
			$result[$this->_db->f('zefID')]['Exp'][$this->_db->f('AutoID')]['tabID']=$this->_db->f('tabID');
			$result[$this->_db->f('zefID')]['Exp'][$this->_db->f('AutoID')]['valDeleted']=$this->_db->f('valDeleted');
			$result[$this->_db->f('zefID')]['Exp'][$this->_db->f('AutoID')]['valTabID']=$this->_db->f('valTabID');
			$result[$this->_db->f('zefID')]['Exp'][$this->_db->f('AutoID')]['valCalc']=$this->_db->f('valCalc');
		}
		foreach ($result as $zID=>$zefVal) {
			foreach ($zefVal['Exp'] as $key=>$val) {
				if ($val['tabTyp']==1) {
					$zefCalc=$this->calcUserExpenses($val['tabID'],$zefVal['zefUser']);
					if ($val['costCalc']==$zefCalc*$val['costValue']) {
						unset($result[$zID]['Exp'][$key]);
						if (empty($result[$zID]['Exp'])) {
							unset($result[$zID]);
						}
					} else {
						$result[$zID]['Exp'][$key]['valCalc']=$zefCalc;
					}

				}
			}

		}
		return $result;
	}
	function searchPrjCat($search=null) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'soll','Typ'=>'!=','Values'=>0);
		if ($search['zefPrj']) $searchQuery[]=array('Field'=>'FKPrjID','Typ'=>'=','Values'=>$search['zefPrj']);
		if ($search['zefCat']) $searchQuery[]=array('Field'=>'FKCatID','Typ'=>'=','Values'=>$search['zefCat']);

		$query="SELECT * FROM zef_prj_cat WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$result[$this->_db->f('FKPrjID')][$this->_db->f('FKCatID')]=array(
				'soll'=>$this->_db->f('Soll'),
			);
		}
		return $result;
	}
	function listPrjCat($PrjID) {
		$result=array();
		$searchQuery=array();
		$searchQuery[]=array('Field'=>'FKPrjID','Typ'=>'=','Values'=>$PrjID);

		$query="SELECT * FROM zef_prj_cat WHERE ".$this->_db->getWhere($searchQuery);
		$this->_db->query($query);
		while($this->_db->next_record()) {
			$result[$this->_db->f('FKCatID')]=array(
				'soll'=>$this->_db->f('Soll'),
			);
		}
		return $result;
	}
	function replacePrjCat($PrjID,$CatID,$Soll) {
		$insert=array(
			'FKPrjID'=>$PrjID,
			'FKCatID'=>$CatID,
			'Soll'=>$Soll,
		);
		return $this->_db->insert('zef_prj_cat',$insert,'',1);
	}
	function deletePrjCat($PrjID=0,$CatID=0) {
		$searchQuery=array();
		if ($PrjID) $searchQuery[]=array('Field'=>'FKPrjID','Typ'=>'=','Values'=>$PrjID);
		if ($CatID) $searchQuery[]=array('Field'=>'FKCatID','Typ'=>'=','Values'=>$CatID);
		if (!empty($searchQuery)) {
			return $this->_db->delete('zef_prj_cat',$searchQuery);
		}
	}
	function setPrefs($key,$val) {
		$this->_frm->insertPrefs($this->getModul(),array($key=>$val));
	}
	function getPrefs($key,$default= null) {
		$result=$this->_frm->getPrefs($this->getModul(),$key);
		if (!$result) $result=$default;
		return $result;
	}
}