<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
set_error_handler("myErrorHandler");
ini_set('max_execution_time', 0);
set_time_limit(0);
require("cfg/global.inc.php");
defined('PREPEND_FILE')?require(PREPEND_FILE):die('UPS..');
define('APP_THEME',$THEME);
require ("lib/ClassGroupieDB.php");
$db=new GroupieDB($CFG["DATABASE_TYPE"]);
if ($CFG['USER_CLASS']=='ldap') {
	require ("lib/ClassGroupieUser_Ldap.php");
} elseif ($CFG['USER_CLASS']=='ldap_full') {
	require ("lib/ClassGroupieUser_FullLdap.php");
} else {
	require ("lib/ClassGroupieUser_Mysql.php");
}
require ("lib/class_frame_work.inc.php");

if (!defined('GE_SOAP_DEBUG')) {
    define('GE_SOAP_DEBUG',0);
}  

if (!defined('GE_SOAP_DEBUG_FILE')) {
    define('GE_SOAP_DEBUG_FILE',Framework::getTempPath().'/soap_debug.txt');
}  

$frm=new FrameWork();
$frm->setDb($db);
$frm->setFrmCfg($frm->getCfg('global',0,array('cfg/%','ldap/%')));
if (!defined('GE_CHARSET')) define('GE_CHARSET','UTF-8');
if (GE_CHARSET=='UTF-8') {
	$db->query("SET NAMES 'utf8'");
} else {
	$db->query("SET NAMES 'latin1'");
}

require("lib/class_translation.inc.php");
$T=new Translation('',$MASTER_TPL);

require_once ("cfg/ge/config.inc.php");
require_once ("lib/soap/classGroupeSoapServer.php");
$serverClass='GroupeSoapServer';
if (defined('GE_CUSTOM_APP') && GE_CUSTOM_APP && file_exists('lib/custom/'.GE_CUSTOM_APP.'/class_Soap_'.GE_CUSTOM_APP.'.php')) {
	require_once ('lib/custom/'.GE_CUSTOM_APP.'/class_Soap_'.GE_CUSTOM_APP.'.php');
	$serverClass='Soap_'.GE_CUSTOM_APP;
}
session_start();

$server = new SoapServer(NULL,array('uri' => "http://localhost/SoapServer/"));
$server->setClass($serverClass);
$server->setPersistence(SOAP_PERSISTENCE_SESSION);
$server->handle();


function debug($txt,$file='',$prep=1,$clear=0) {
	if (GE_SOAP_DEBUG) {
		if (!$file) $file=GE_SOAP_DEBUG_FILE;
		$dir=dirname($file);
		if (file_exists($dir) && is_dir($dir) && is_writable($dir)) {
			if (!file_exists($file) || $clear) {
				touch($file);
				chmod($file,0600);
				$openmode='w';
			} else {
				$openmode='a+';
			}
			$fh=fopen($file,$openmode);
			if ($prep) $txt=date('d.m.Y H:i').':'.$txt."\n";
			fwrite($fh,$txt);
			fclose($fh);
		}
	}
}
function myErrorHandler ($errno, $errstr, $errfile, $errline) {
	switch ($errno) {
		case E_ERROR:
			debug ("ERROR error type: [$errno] $errstr in line $errline of file $errfile");
			exit(1);
		break;
		case E_WARNING:
			if (strpos($errstr,'mysql_free_result')===false) {
				debug ("WARNING error type: [$errno] $errstr in line $errline of file $errfile");
			}
		break;
		case E_NOTICE:
			//debug ("NOTICE error type: [$errno] $errstr in line $errline of file $errfile");
		break;
		case 2048:

		break;
		default:
			debug ("Unkown error type: [$errno] $errstr in line $errline of file $errfile");
		break;
	}
}
?>
