<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
set_error_handler("myErrorHandler");
require("cfg/global.inc.php");
defined('PREPEND_FILE')?require(PREPEND_FILE):die('UPS..');
require ("lib/ClassGroupieDB.php");
$db=new GroupieDB($CFG["DATABASE_TYPE"]);
if ($CFG['USER_CLASS']=='ldap') {
	require ("lib/ClassGroupieUser_Ldap.php");
} elseif ($CFG['USER_CLASS']=='ldap_full') {
	require ("lib/ClassGroupieUser_FullLdap.php");
} else {
	require ("lib/ClassGroupieUser_Mysql.php");
}
require ("lib/class_frame_work.inc.php");

$DEBUG_TYP='file'; // file OR html OR none
$DEBUG_FILE_PAHT=Framework::getTempPath().'/';
$DEBUG_FILE=$DEBUG_FILE_PAHT.'syncMl_nosession.txt';

$frm=new FrameWork();
$frm->setDb($db);
$frm->setFrmCfg($frm->getCfg('global',0,array('cfg/%','ldap/%')));
if (!defined('GE_CHARSET')) define('GE_CHARSET','UTF-8');
if (GE_CHARSET=='UTF-8') {
	$db->query("SET NAMES 'utf8'");
} else {
	$db->query("SET NAMES 'latin1'");
}

if ($frm->appExists('proj')) {
	$P=& $frm->getStaticModul('proj');
} else {
	$P=false;
}

require_once ("cfg/$THEME/config.inc.php");
require_once ("cfg/$THEME/sync/environment.php");
require_once ("cfg/$THEME/sync/environment_modell.php");

require ("lib/class.mtFastTemplate.php");
$t=new mtFastTemplate ('.',$MASTER_TPL);

require("lib/class_translation.inc.php");
$T=new Translation('',$MASTER_TPL);

require_once("cfg/$THEME/sync/Tables.php");
require_once('lib/sync/SyncXml.php');
require_once('lib/sync/SyncSession.php');


require ("lib/sync/AuthMysql.php");
require ("lib/sync/SyncMysql.php");

if ($CFG['SYNC']['STORES']['addr']) {
	if (defined('ADDR_MODE') && ADDR_MODE=='ldap') {
		require ("lib/sync/VcardLdap.php");
	} else {
		require ("lib/sync/VcardMysql.php");
	}
	require_once ('lib/addr/Contact_Vcard_Parse.php');
	require_once ("lib/addr/ClassVcard.php");
	require_once ('lib/addr/Contact_Vcard_Build.php');
	require_once ("lib/addr/ClassVcardWrite.php");
}

if ($CFG['SYNC']['STORES']['task'] || $CFG['SYNC']['STORES']['cal'] || $CFG['SYNC']['STORES']['caltask']) {
	require ("lib/cal/ClassVcalParse.php");
	require ("lib/cal/ClassVcalWrite.php");
	require ("lib/cal/ClassVcal.php");
}

if ($CFG['SYNC']['STORES']['cal']) {
	require ("lib/sync/VcalMysql.php");
}

if ($CFG['SYNC']['STORES']['task']) {
	require ("lib/sync/VtodoMysql.php");
}
if ($CFG['SYNC']['STORES']['caltask']) {
	require ("lib/sync/VcaltaskMysql.php");
}

if ($CFG['SYNC']['STORES']['msg']) {
	require ("lib/sync/NotesMysql.php");
}

if ($CFG['SYNC']['STORES']['config']) {
	require ("lib/sync/Configuration.php");
}
/*
if ($CFG[SYNC][STORES]['mail']) {
	require("cfg/$THEME/mail/email.inc.php");
	require("lib/mail/TextMail.php");
	require ("lib/sync/EmailImap.php");
}
*/
foreach ($CFG['SYNC']['STORES'] as $store) {
	$datastores[$store['store']]=new $store['class']($store['store'],$store['display'],$db);
}


if (strpos($_SERVER["CONTENT_TYPE"],"application/vnd.syncml+xml")===false && strpos($_SERVER["CONTENT_TYPE"] ,"application/vnd.syncml+wbxml")===false ) {
	/*debug('I only speak SyncML: '.$_SERVER["CONTENT_TYPE"]."\n".$HTTP_RAW_POST_DATA);
	echo "<html>";
	echo "I only speak SyncML.";
	require_once('update/version.php');
	$DB_version=$frm->getVersion('group-e');
	if ($DB_version['Version']!=$VERSION) {
		echo '<h3 align="center">Wrong Database Version : '.$DB_version['Version'].' - '.$DB_version['UpdateDate'].'<br />Please update your System</h1>';
	}
	echo "</html>";*/

	header('accept-ranges: bytes');
	header('cache-control: private');
	header('content-type: application/vnd.syncml+undefined');
	header('transfer-encoding: chunked');
	echo '0';
	//print_r($_SERVER);

	/*$DEBUG_TYP='html';
	$syncxml=new SyncXml($WBXML_TOKEN,$DTD,$TABLES);
	$fdata=implode('',file('test.wbxml'));
	$xml_request=$syncxml->parseWbxml($fdata);
	debug('CLIENT:'.$syncxml->printXml($xml_request,1,' ',"\n"));*/
	exit();
} else {
	debug('CLIENT:'.$_SERVER["CONTENT_TYPE"]);
	//debug($HTTP_RAW_POST_DATA,Framework::getTempPath().'/client'.time().'.wbxml',$prep=0,$clear=1);
	//exit;
	if (preg_match('/wbxml/i',$_SERVER["CONTENT_TYPE"]))
		$WBXML=1;
	else
		$WBXML=0;
}

$syncxml=new SyncXml($WBXML_TOKEN,$DTD,$TABLES);
if ($WBXML) {
	$xml_request=$syncxml->parseWbxml($HTTP_RAW_POST_DATA);
} else {
	$xml_request=$syncxml->parseText($HTTP_RAW_POST_DATA);
}
//debug('CLIENT:'.$syncxml->printXml($xml_request,1,' ',"\n"),Framework::getTempPath().'/client_server.xml');

//debug($_SERVER['QUERY_STRING'],Framework::getTempPath().'/debug.txt');
$request_sync_hdr = new SyncHeader ($xml_request->get_child ("SyncHdr"));
$request_sync_body = $xml_request->get_child ("SyncBody");
if (preg_match('/\?session_id=([0-9a-z]+)$/',$request_sync_hdr->getField("Target_LocURI"),$id)) {
	$session_key = $id[1];
	debug('SessionID_FromUri:'.$session_key);
} else {
	$session_key=md5($request_sync_hdr->getField('Source_LocURI').'-'.$request_sync_hdr->getField('SessionID'));
	debug('SessionID_FromHeader:'.$session_key);
	/*if ($request_sync_hdr->getField('MsgID')>1 && $request_sync_hdr->getField('SessionID')) {
		//debug('SECOND_NO_SESS');
		$session_key=md5($request_sync_hdr->getField('Source_LocURI').'-'.$request_sync_hdr->getField('SessionID'));
	}
	elseif ($request_sync_hdr->getCred()) {
		$cred = & $request_sync_hdr->getCred();
		if ($cred->getMType()=='syncml:auth-basic') {
			$colon_ofs = strcspn ($cred->getData(), ":");
			$username = substr ($cred->getData(), 0, $colon_ofs);
			if (GE_DOMAIN && $GLOBALS['CFG']['USER_CLASS']=='ldap_full') $username=$username.'_'.str_replace('.','_',GE_DOMAIN);
			$password = substr ($cred->getData(), $colon_ofs + 1,strlen ($cred->getData()) - $colon_ofs - 1);
			//debug('CRED:'.$username.'-'.$password);
			if ($username && $password) {
				$tmp_auth=new AuthMysql();
				if ($authID=$tmp_auth->checkAuthBasic($username,$password)) {
					//debug('AUTH:'.$authID);
					$query="SELECT value FROM SyncPrefs WHERE name='modell' AND store='all' AND user_id='".addslashes($authID)."'";
					$db->query($query);
					if ($db->next_record()) {
						debug('MODELL:'.$db->f('value'));
						$modell_prefs=getModellPrefs($db->f('value'),'global');
						if ($modell_prefs['noSessID'] && $request_sync_hdr->getField('SessionID')) {
							$session_key=md5($request_sync_hdr->getField('Source_LocURI').'-'.$request_sync_hdr->getField('SessionID'));
							debug('FUNAMBOL:'.$request_sync_hdr->getField('Source_LocURI').'-'.$request_sync_hdr->getField('SessionID'));
						}
					}
				}
			}
		}
	}*/
}

session_id ($session_key);
session_start ();
$DEBUG_FILE=$DEBUG_FILE_PAHT.'syncMl_'.$session_key.".txt";
//debug(print_r($_SESSION,true));
$Sync=new SyncMysql($db,new AuthMysql());

if ($_SESSION["started"] != 1) {
	debug('Session Start:'.$session_key,0,1,1);
  	$_SESSION["sync_session"] = new SyncSession ($Sync);
  	$_SESSION["started"] = 1;
	$Respuri=$session_key;
} else {
 	$Respuri=0;
}
debug('CLIENT:'.$syncxml->printXml($xml_request,1));

$response = new XmlNode ("SyncML");
$response_sync_hdr = & $response->new_child ("SyncHdr", NULL);
$response_sync_body = & $response->new_child ("SyncBody", NULL);

$_SESSION["sync_session"]->more_messages=0;
$_SESSION["sync_session"]->parseHeader ($request_sync_hdr,$response_sync_body);
$_SESSION["sync_session"]->makeHeader($response_sync_hdr,$Respuri);

$response->set_attribs(array("xmlns" => "SYNCML:SYNCML".$_SESSION["sync_session"]->getVersion()));

$_SESSION["sync_session"]->size_to_big=false;

foreach ($request_sync_body->children() as $command) {
	debug( $command->get_name());
	//flush();
	$msgsize=$syncxml->getSize($response,$WBXML,1);
	$_SESSION["sync_session"]->handleCommand ($command, $response_sync_body,$msgsize);
}
$msgsize=$syncxml->getSize($response,$WBXML,1);
debug('MSGSIZE:'.$msgsize);
$_SESSION["sync_session"]->sendSync($response_sync_body,$msgsize);
if (!$_SESSION["sync_session"]->size_to_big && $_SESSION["sync_session"]->addFinal) {
	$response_sync_body->add_child (new XmlNode ("Final", NULL));
}


if ($WBXML) {
	$response_xml=$syncxml->parseXml($response,'-//SYNCML//DTD SyncML '.$_SESSION["sync_session"]->getVersion().'//EN');
	$fsize=strlen($response_xml);
	debug('Content-Length::'.$fsize);
	header ("Content-Type: application/vnd.syncml+wbxml");
	header ("Content-Length: ".$fsize);
	echo $response_xml;
	//debug($response_xml,Framework::getTempPath().'/server.wbxml',0,0);
} else {
	$response_xml=$syncxml->printXml($response,1,'',"\r\n");
	header ("Content-Type: application/vnd.syncml+xml");
	header ("Content-Length: ".strlen('<?xml version="1.0" encoding="UTF-8"?>'.$response_xml));
	echo '<?xml version="1.0" encoding="UTF-8"?>';
	echo $response_xml;
}
if (!$_SESSION["sync_session"]->more_messages && !$_SESSION["sync_session"]->size_to_big && $_SESSION["sync_session"]->preMsgFinal) {
	$uid=$_SESSION["sync_session"]->getUserID();
	$lang=$_SESSION["sync_session"]->getUserLang();
	$conflicts=$_SESSION["sync_session"]->getNumConflicts();
	$_SESSION=array();
	// Zum Schlu, lschen der Session.
	debug ('SESSION_DESTROY');
	session_destroy();
}

debug('SERVER:'.$syncxml->printXml($response,1,' ',"\n"));
//debug('SERVER:'.$syncxml->printXml($response,1,' ',"\n"),Framework::getTempPath().'/client_server.xml');
exit;
function debug($txt,$file='',$prep=1,$clear=0) {
	if ($GLOBALS['DEBUG_TYP']=='file') {
		if (!$file) $file=$GLOBALS['DEBUG_FILE'];
		$dir=dirname($file);
		if (file_exists($dir) && is_dir($dir) && is_writable($dir)) {
			if (!file_exists($file) || $clear) {
				touch($file);
				chmod($file,0600);
				$openmode='w';
			} else {
				$openmode='a+';
			}
			$fh=fopen($file,$openmode);
			if ($prep) $txt=date('d.m.Y H:i').':'.$txt."\n";
			fwrite($fh,$txt);
			fclose($fh);
		}
	}
	if ($GLOBALS['DEBUG_TYP']=='html') {
		echo "<pre>";
		print_r(Framework::entities($txt));
		echo "</pre>";

	}
}

function myErrorHandler ($errno, $errstr, $errfile, $errline) {
	switch ($errno) {
		case E_ERROR:
			debug ("ERROR error type: [$errno] $errstr in line $errline of file $errfile");
			exit(1);
		break;
		case E_WARNING:
			if (strpos($errstr,'mysql_free_result')===false) {
				debug ("WARNING error type: [$errno] $errstr in line $errline of file $errfile");
			}
		break;
		case E_NOTICE:
			//debug ("NOTICE error type: [$errno] $errstr in line $errline of file $errfile");
		break;
		case 2048:

		break;
		default:
			debug ("Unkown error type: [$errno] $errstr in line $errline of file $errfile");
		break;
	}
}

function getModellPrefs($modell,$modul) {
	global $MODELL;
	$result=$MODELL['default'][$modul];
	if (isset($MODELL[$modell][$modul])) {
		foreach ($MODELL[$modell][$modul] as $key=>$val) {
			$result[$key]=$val;
		}
	}
	return $result;
}

?>
