<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/

function oldSearch2NewSearch($search) {
	global $Addr;
	$modeConv=array(
		'is'=>'is',
		'ni'=>'nis',
		'mr'=>'gt',
		'le'=>'lt',
		'nk'=>'nlk',
		'lk'=>'lk',
	);
	$num=1;
	if ($search['info']) {
		$sField[$num]=array(
			'typ'=>'addr',
			'mode'=>'lk',
			'value'=>$search['info'],
			'key'=>'all',
		);
		$num++;
	}
	if (is_array($search['crm']['s_function'])) {
		foreach ($search['crm']['s_function'] as $uFID=>$fval) {
			switch ($Addr->getFieldData($uFID,'Typ')) {
				case 'area':
				case 'text':
					if (strlen(trim($search['crm']['crm_data'][$uFID]))) {
						$sField[$num]=array(
							'typ'=>'crm',
							'mode'=>$modeConv[$fval],
							'value'=>$search['crm']['crm_data'][$uFID],
							'key'=>$uFID,
						);
						$num++;
					}
				break;
				case 'mselect':
				case 'select':
					if (is_array($search['crm']['crm_data'][$uFID]) && count($search['crm']['crm_data'][$uFID])) {
						$sField[$num]=array(
							'typ'=>'crm',
							'mode'=>$modeConv[$fval],
							'value'=>$search['crm']['crm_data'][$uFID],
							'key'=>$uFID,
						);
						$num++;
					}
				break;
				case 'chk':
					if ($fval=='Y' || $fval=='N') {
						$sField[$num]=array(
							'typ'=>'crm',
							'mode'=>'is',
							'value'=>$fval,
							'key'=>$uFID,
						);
						$num++;
					}
				break;
				case 'num':
					if (strlen(trim($search['crm']['crm_data'][$uFID][0])) || strlen(trim($search['crm']['crm_data'][$uFID][1]))) {
						if (strlen(trim($search['crm']['crm_data'][$uFID][0]))) {
							$sField[$num]=array(
								'typ'=>'crm',
								'mode'=>$modeConv[$fval[0]],
								'value'=>trim($search['crm']['crm_data'][$uFID][0]),
								'key'=>$uFID,
							);
							$num++;
						}
						if (strlen(trim($search['crm']['crm_data'][$uFID][1]))) {
							$sField[$num]=array(
								'typ'=>'crm',
								'mode'=>$modeConv[$fval[1]],
								'value'=>trim($search['crm']['crm_data'][$uFID][1]),
								'key'=>$uFID,
							);
							$num++;
						}
					}
				break;
				case 'date':
					$tmp_date[0]=sprintf('%04d',$search['crm']['crm_data'][$uFID]['Y'][0]).'-'.sprintf('%02d',$search['crm']['crm_data'][$uFID]['M'][0]).'-'.sprintf('%02d',$search['crm']['crm_data'][$uFID]['D'][0]);
					$tmp_date[1]=sprintf('%04d',$search['crm']['crm_data'][$uFID]['Y'][1]).'-'.sprintf('%02d',$search['crm']['crm_data'][$uFID]['M'][1]).'-'.sprintf('%02d',$search['crm']['crm_data'][$uFID]['D'][1]);
					if ($tmp_date[0]!='0000-00-00' || $tmp_date[1]!='0000-00-00') {
						if ($tmp_date[0]!='0000-00-00') {
							$sField[$num]=array(
								'typ'=>'crm',
								'mode'=>$modeConv[$fval[0]],
								'value'=>Framework::dateSql('d.m.Y',$tmp_date[0]),
								'key'=>$uFID,
							);
							$num++;
						}
						if ($tmp_date[1]!='0000-00-00') {
							$sField[$num]=array(
								'typ'=>'crm',
								'mode'=>$modeConv[$fval[1]],
								'value'=>Framework::dateSql('d.m.Y',$tmp_date[1]),
								'key'=>$uFID,
							);
							$num++;
						}
					}
				break;
			}
		}
	}
	if (empty($search['gRNodeID']) || empty($search['uRNodeID'])) {
		$tmpNodes=array();
		if (!empty($search['gRNodeID'])) {
			$tmpNodes[]='f_'.$search['gRNodeID'];
		} elseif(is_array($search['gNodeID'])) {
			foreach($search['gNodeID'] as $nval) {
				if ($nval) $tmpNodes[]='f_'.$nval;
			}
		}
		if (!empty($search['uRNodeID'])) {
			$tmpNodes[]='f_'.$search['uRNodeID'];
		} elseif(is_array($search['uNodeID'])) {
			foreach($search['uNodeID'] as $nval) {
				if ($nval) $tmpNodes[]='f_'.$nval;
			}
		}
		$sField[$num]=array(
			'typ'=>'cat',
			'mode'=>'is',
			'value'=>implode('|',$tmpNodes),
			'rec'=>1,
		);
		$num++;
	}
	if (is_array($search['pNodeID']) && !empty($search['pNodeID'])) {
		$sField[$num]=array(
			'typ'=>'prj',
			'mode'=>'is',
			'value'=>'o_'.implode('|o_',$search['pNodeID']),
		);
		$num++;
	}
	$newSearch=array(
		'search'=>array (
			0=>array (
				'mode'=> 'and',
				'field' => $sField,
			)
        )
	);
	return $newSearch;
}
?>