<?php
/*
	+-----------------------------------------------------------------------------+
	| GROUP-E collaboration software                                              |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 2002-2005 group-e,                                            |
	|         Endo7 GmbH/Srl                                                      |
	|	  via-Goethe-strasse 34a                                              |
	|	  39100 Bozen/Bolzano                                                 |
	|	  ITALIEN/ITALIA                                                      |
	|         contact@endo7.com                                                   |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
        | http://www.fsf.org/                                                         |
	+-----------------------------------------------------------------------------+
*/
session_start();
define('FILE_LOG','/tmp/webdav.log');
define('DEBUG_LEVEL',1);
require('cfg/global.inc.php');
defined('PREPEND_FILE')?require(PREPEND_FILE):die('UPS..');
require('ezc/Base/ezc_bootstrap.php');
require ("lib/ClassGroupieDB.php");
$db=new GroupieDB($CFG["DATABASE_TYPE"]);
if ($CFG['USER_CLASS']=='ldap') {
	require ("lib/ClassGroupieUser_Ldap.php");
} elseif ($CFG['USER_CLASS']=='ldap_full') {
	require ("lib/ClassGroupieUser_FullLdap.php");
} else {
	require ("lib/ClassGroupieUser_Mysql.php");
}
require ("lib/class_frame_work.inc.php");
$frm=new FrameWork();
$frm->setDb($db);
$frm->setFrmCfg($frm->getCfg('global',0,array('cfg/%','ldap/%')));
if (!defined('GE_CHARSET')) define('GE_CHARSET','UTF-8');
if (GE_CHARSET=='UTF-8') {
	$db->query("SET NAMES 'utf8'");
} else {
	$db->query("SET NAMES 'latin1'");
}

$fmngCfg=$frm->getCfg('fmng',0,'cfg/all/webdav');
if (!$fmngCfg['cfg/all/webdav']) {
	header('HTTP/1.1 403 Access Denied',true,403);
	exit;
}
require("cfg/$THEME/config.inc.php");
require ("lib/webdav/class_groupeWebDavAuthorizer.php");
require ("lib/webdav/class_groupeWebDavAuth.php");
require ("lib/webdav/class_groupeWebDavBackend.php");
require ("lib/webdav/class_groupeWebDavFmng.php");

$server= ezcWebdavServer::getInstance();
$server->options->realm='Group-e WebDAV';
$pathFactory=new ezcWebdavBasicPathFactory(
	($_SERVER['HTTPS']?'https://':'http://').$_SERVER['SERVER_NAME']
);
foreach ($server->configurations as $conf) {
	$conf->pathFactory=$pathFactory;
}
$server->auth = new groupeWebDavAuth($frm);

$server->pluginRegistry->registerPlugin(
    new ezcWebdavLockPluginConfiguration()
);

$backend=new groupeWebDavBackend(
	$frm
);
//debugFile($_SERVER,1);
$server->handle($backend);
function debug($var,$always=false) {
	echo '<pre>';print_r($var);echo '</pre>';
}
function debugFile($val,$level=1) {
	if (defined('FILE_LOG') && FILE_LOG && $level&DEBUG_LEVEL) {
		$fp=fopen(FILE_LOG,'a+');
		if (!is_string($val)) $val=print_r($val,true);
		fwrite($fp,$val."\n");
		fclose($fp);
	}
}

?>