<?php

include_once('lib/default/diffbackend/diffbackend.php');
include_once('include/mime.php');
include_once('include/mimeDecode.php');
include_once('include/z_RFC822.php');

include_once('groupeContact.php');
include_once('groupeAppointment.php');
include_once('groupeMail.php');
include_once('groupeTask.php');

class BackendGroupe extends BackendDiff implements ISearchProvider {
    public $_devid;
	public $_GroupeFolders=array("VIRTUAL/calendar","VIRTUAL/contacts","VIRTUAL/tasks","VIRTUAL/notes");
	public $_deviceProperties=array();
	public $_syncSettings=array();
    public $_statMessages=array();
    public $_soap;
    public $_messages;
	public $_mailLimit=100;
    public function GetSupportedASVersion() {
         return ZPush::ASV_14;
    }
	public function __construct() {
		$this->_soap=new GroupeSoapClient();
       	$this->_map['contact']=new GroupeContact();
       	$this->_map['appointment']=new GroupeAppointment();
       	$this->_map['task']=new GroupeTask();
       	$this->_map['mail']=new GroupeMail();
		if (defined('GROUP_MAIL_LIMIT')) {
			$this->_mailLimit=GROUP_MAIL_LIMIT;
		}
 	}
 	//public function Setup($store, $checkACLonly = false, $folderid = false);
	public function Setup($store, $checkACLonly = false, $folderid = false) {
		parent::Setup($store, $checkACLonly, $folderid);
		debugLog('Groupe::Setup:store:'.$store.' checkACLonly:'.$checkACLonly.' folderid'.$folderid);
		return true;
    }
    // public function Logon($username, $domain, $password);
    public function Logon($username, $domain, $password) {
		$this->_wasteID = false;
		$this->_soap->initUser($username,$password);
		if ($this->_soap->call('logon')) {
			debugLog('Groupe::'.$username.' logged in');
			if (Request::GetDeviceID()) {
				$this->_devid=Request::GetDeviceID();
				$this->_deviceProperties=$this->getDeviceProperties($this->_devid);
				$this->_syncSettings=$this->getSyncSettings($this->_devid);

				//$this->_mailProperties=$this->_soap->call('getActiveSyncMailPoperties',array());
				//debugLog(print_r($this->_mailProperties,true));

				$this->_map['contact']->setDeviceProperties($this->_deviceProperties);
				$this->_map['contact']->setSyncSettings($this->_syncSettings);

				$this->_map['appointment']->setDeviceProperties($this->_deviceProperties);
				$this->_map['appointment']->setSyncSettings($this->_syncSettings);
				$this->_map['appointment']->setTimeZone($this->_soap->call('getActiveSyncTimeZone',array()));

				$this->_map['task']->setDeviceProperties($this->_deviceProperties);
				$this->_map['task']->setSyncSettings($this->_syncSettings);

				$this->_map['mail']->setDeviceProperties($this->_deviceProperties);
				$this->_map['mail']->setSyncSettings($this->_syncSettings);
			}
			
			return true;
		} else {
			debugLog('Groupe::Logon('.$username.','.$domain.',****) failed!!');
			return false;
		}
    }
    // * public function Logoff();
    public function Logoff() {
		$cmd=Request::GetCommand();
		debugLog('Groupe::Logoff / '.$cmd);
		//do not update last sync time on ping and provision
		if ($cmd != '' && $cmd != 'Ping' && $cmd != 'Provision' ) {
			$this->setLastSyncTime();
		}
        return true;
    }
    // public function GetHierarchy();
    public function GetHierarchy() {
        debugLog('Groupe::GetHierarchy()');
        $folders = array();

        $fl = $this->getFolderList();
        foreach($fl as $f){
            $folders[] = $this->GetFolder($f['id']);
        }

        return $folders;
    }
    // public function GetImporter($folderid = false);
    public function GetImporter($folderid = false) {
        debugLog('Groupe::GetImporter('.$folderid.')');
        return parent::GetImporter($folderid);
    }
    // public function GetExporter($folderid = false);
    public function GetExporter($folderid = false) {
        debugLog('Groupe::GetExporter('.$folderid.')');
        return parent::GetExporter($folderid);
    }
    //public function GetAttachmentData($attname);
	public function GetAttachmentData($attname) {
		$attname=BackendGroupe::hexToStr($attname);
		ZLog::Write(LOGLEVEL_DEBUG, sprintf("Groupe->GetAttachmentData('%s')", $attname));
		$data = explode(":", $attname);
		if(!$data[0] || !$data[1]) {
			throw new StatusException(sprintf("Groupe->GetAttachmentData('%s'): Error, attachment requested for non-existing item", $attname), SYNC_ITEMOPERATIONSSTATUS_INVALIDATT);
		}
		$message=$this->_soap->call('getMailAttachment',$data);
        if(!$message || !$message['body']) {
			throw new StatusException(sprintf("Groupe->GetAttachmentData('%s'): Error, unable to open item for attachment", $attname), SYNC_ITEMOPERATIONSSTATUS_INVALIDATT);
		}
		include_once('include/stringstreamwrapper.php');
		$stream=base64_decode($message['body']);
		$attachment = new SyncItemOperationsAttachment();
		$attachment->data = StringStreamWrapper::Open($stream);
		$attachment->contenttype = trim($message['type']);
		return $attachment;
	}
    // public function SendMail($sm);
    function SendMail($sm) {
        ZLog::Write(LOGLEVEL_DEBUG, sprintf("Groupe->SendMail(): RFC822: %d bytes  forward-id: '%s' reply-id: '%s' parent-id: '%s' SaveInSent: '%s' ReplaceMIME: '%s'",
                                            strlen($sm->mime), Utils::PrintAsString($sm->forwardflag), Utils::PrintAsString($sm->replyflag),
                                            Utils::PrintAsString((isset($sm->source->folderid) ? $sm->source->folderid : false)),
                                            Utils::PrintAsString(($sm->saveinsent)), Utils::PrintAsString(isset($sm->replacemime)) ));
		//debugLog("Groupe::SendMail: \n $rfc822" );
		if (preg_match('@Content-Type:\s*text/calendar;\s*charset=[^;]+;\s*name=[a-z]+\.ics;\s*method=(REQUEST|REPLY)@i',$sm->mime)) {
			debugLog("Groupe::SendMail: Ignore Invitations");
			return true;
		}
		if (preg_match('@Content-Type:\s*text/calendar;\s*charset=[^;]+;\s*method=(REQUEST|REPLY)@i',$sm->mime)) {
			debugLog("Groupe::SendMail: Ignore Invitations");
			return true;
		}

		$mailPlain='';
		$mailHtml='';
		$hdrs=array();

		$buildParams = array(
			'eol' => "\n",
			'charset' => 'utf-8',
			'text_encoding' => 'base64',
			'html_encoding' => 'base64',
			'text_charset'  => 'utf-8',
			'html_charset'  => 'utf-8',
			'head_charset'  => 'utf-8',
		);
		$newMail = new Mail_mime($buildParams);
		$newMail->setParam('text_charset','utf-8');

		$mimeParams = array(
			'decode_headers' => true,
			'decode_bodies' => true,
			'include_bodies' => true,
			'charset' => 'utf-8'
		);
		$mailObj = new Mail_mimeDecode($sm->mime);
 
		$mailMsg = $mailObj->decode($mimeParams);

		foreach($mailMsg->headers as $k => $v) {
			$k=strtolower($k);
			if ($k == "sender") continue;
			if ($k == "content-type") continue;
			if ($k == "content-transfer-encoding") continue;
			if ($k == "content-transfer-encoding") continue;
			if ($k == "mime-version") continue;
			// all other headers stay
			$hdrs[ucfirst($k)]=trim($v);
		}
		debugLog("SendMail: parsed message headers: ". print_r($hdrs,1));
		//debugLog("SendMail: parsed message: ". print_r($mailMsg,1));
		$this->combineMessage($mailMsg,$newMail,$mailPlain,$mailHtml,'new');
		if (trim($mailHtml)) {
			$mode='HTML';
		} else {
			$mode='PLAIN';
		}
		debugLog("SendMail Format: ".$mode);
		if (($sm->forwardflag || $sm->replyflag) && $sm->source->folderid && $sm->source->itemid) {
			if ($smartObj=$this->_soap->call('getActiveSyncMailMimeByID',array($sm->source->folderid,$sm->source->itemid))) {
				$origMime=array(base64_decode($smartObj->MimeHeader),base64_decode($smartObj->MimeBody));

				$mimeParams = array(
					'decode_headers' => true,
					'decode_bodies' => true,
					'include_bodies' => true,
					'charset' => 'utf-8'
				);
				$origObj = new Mail_mimeDecode($origMime);
				$origMsg = $origObj->decode($mimeParams);
				//debugLog("IMAP-SendMail: : parsed message Orig: ". print_r($origMsg,1));

				$body_sep= "\r\n\r\n-----Original Message-----\r\n";
				if(isset($origMsg->headers['from'])) {
					$body_sep.= "From: " .$origMsg->headers['from']. "\r\n";
				}
				if(isset($origMsg->headers['to']) && strlen($origMsg->headers['to']) > 0) {
					$body_sep.= "To: " . $origMsg->headers['to'] . "\r\n";
				}
				if(isset($origMsg->headers['cc']) && strlen($origMsg->headers['cc']) > 0) {
					$body_sep.= "Cc: " . $origMsg->headers['cc'] . "\r\n";
				}
				if(isset($origMsg->headers['date'])) {
					$body_sep.= "Sent: " . $origMsg->headers['date'] . "\r\n";
				}
				if(isset($origMsg->headers['subject'])) {
					$body_sep.= "Subject: " . $origMsg->headers['subject'] . "\r\n";
				}
				$body_sep.="\r\n"."\r\n";
				$mailPlain.=$body_sep;

				if ($mode=='HTML') {
					$mailHtml.=nl2br($body_sep);
				}
				$this->combineMessage($origMsg,$newMail,$mailPlain,$mailHtml,$sm->replyflag?'reply':'fwd');
			}
		}
		$newMail->setTXTBody($mailPlain);
		if ($mode=='HTML') {
			$newMail->setHTMLBody($mailHtml);
		}
		$body = $newMail->getMessageBody();
		$hdrs = $newMail->headers($hdrs);
		//advanced debugging
		debugLog("IMAP-SendMail: headers: ".print_r($hdrs,1));
		//debugLog("IMAP-SendMail: body: $body");
		if (!$this->_soap->call('sendActiveSyncMail',array($hdrs,$body))) {
           throw new StatusException(sprintf("BackendIMAP->SendMail(): The email could not be sent. Last IMAP-error: %s", imap_last_error()), SYNC_COMMONSTATUS_MAILSUBMISSIONFAILED);
		}
		return true;
    }    
    // public function GetFolderList(); from DIFFBACKEND
    public function GetFolderList() {
        debugLog('Groupe::GetFolderList() '.$this->_deviceProperties['Type']);
		$folders = array();
        foreach ($this->_GroupeFolders as $val) {
			$folder = $this->StatFolder($val);
			if ($folder) {
				$folders[]=$folder;
			}
        }
        if (defined('GROUP_NO_OUTLOOK_MAIL') && GROUP_NO_OUTLOOK_MAIL && preg_match('/outlook/i',$this->_deviceProperties['Type'])) {
			 debugLog('Mailfolder diabled for outlook');
		} else {
			$mailFolders=$this->_soap->call('getActiveSyncMailFolders',array($this->_devid));
			if (is_array($mailFolders)) {
				foreach ($mailFolders as $val) {
					$this->_mailFolders[$val->Box]=$val;
					$folder = $this->StatFolder($val->Box);
					if ($folder) {
						$folders[]=$folder;
					}
				}
			}
		}

        return $folders;
    }
    // public function GetFolder($id); from DIFFBACKEND
    public function GetFolder($id) {
        debugLog('Groupe::GetFolder('.$id.')');
        $folder = new SyncFolder();
        $folder->serverid = $id;
        switch($id) {
			case "VIRTUAL/calendar":
 				$folder->parentid ="0";
				$folder->displayname = "Calendar";
				$folder->type = SYNC_FOLDER_TYPE_APPOINTMENT;
			break;
			case "VIRTUAL/contacts":
				$folder->parentid ="0";
				$folder->displayname = "Contacts";
				$folder->type = SYNC_FOLDER_TYPE_CONTACT;
			break;
			case "VIRTUAL/tasks":
				$folder->parentid ="0";
				$folder->displayname = "Tasks";
				$folder->type = SYNC_FOLDER_TYPE_TASK;
			break;
			case "VIRTUAL/notes":
				$folder->parentid ="0";
				$folder->displayname = "Notes";
				$folder->type = SYNC_FOLDER_TYPE_NOTE;
			break;
			default:
				if (isset($this->_mailFolders[$id])) {
					$folder->parentid=$this->_mailFolders[$id]->ParentBox?$this->_mailFolders[$id]->ParentBox:'0';
					$folder->displayname=$this->_mailFolders[$id]->Name;
					switch($this->_mailFolders[$id]->Type) {
						case 'I':
							$folder->type = SYNC_FOLDER_TYPE_INBOX;
						break;
						case 'T':
							$folder->type = SYNC_FOLDER_TYPE_WASTEBASKET;
							$this->_wasteID = $id;
						break;
						case 'S':
							$folder->type = SYNC_FOLDER_TYPE_SENTMAIL;
						break;
						case 'D':
							$folder->type = SYNC_FOLDER_TYPE_DRAFTS;
						break;
						default:
							$folder->type = SYNC_FOLDER_TYPE_USER_MAIL;
						break;
					}
				} else {
					return false;
				}
			break;
		}
		return $folder;
    }
	// public function StatFolder($id); from DIFFBACKEND
    function StatFolder($id) {
		debugLog('Groupe::StatFolder('.$id.')');
		$stat = array();
		$folder = $this->GetFolder($id);
		if ($folder) {
			$stat["id"] = $id;
			$stat["parent"] = $folder->parentid;
			$stat["mod"] = $folder->displayname;
		}
		return $stat;
	}
	// public function ChangeFolder($parent, $id, $displayname, $type); from DIFFBACKEND
	function ChangeFolder($parent, $id, $displayname, $type) {
        debugLog('Groupe::ChangeFolder('.$parent.', '.$id.', '.$displayname.', '.$type.')');
		return false;
	}
	// public function DeleteFolder($parent, $id) from DIFFBACKEND
	function DeleteFolder($parent, $id) {
        debugLog('Groupe::DeleteFolder('.$parent.', '.$id.')');
		return false;
	}
	// public function GetMessageList$folderid, $cutoffdate) from DIFFBACKEND
    function GetMessageList($folderid, $cutoffdate) {
        debugLog('Groupe::GetMessageList('.$folderid.','.$cutoffdate.')');
        $messages = array();
        switch($folderid) {
        	case 'VIRTUAL/contacts':
  				$messages=$this->_soap->call('getActiveSyncContacts',array($this->_devid));
  				//debugLog(print_r($messages,1));
       		break;
        	case 'VIRTUAL/calendar':
				if (!intval($cutoffdate)) {
					$cutoffdate=time()-3600*24*30;
					debugLog('SetCutoffDate:'.$cutoffdate);
				}
 				$messages=$this->_soap->call('getActiveSyncAppointments',array($this->_devid,intval($cutoffdate)));
    			//debugLog(var_export($messages,1));
       		break;
        	case 'VIRTUAL/tasks':
				if (!intval($cutoffdate)) {
					$cutoffdate=time()-3600*24*30;
					debugLog('SetCutoffDate:'.$cutoffdate);
				}
   				$messages=$this->_soap->call('getActiveSyncTasks',array($this->_devid,intval($cutoffdate)));
				//debugLog(print_r($messages,1));
       		break;
        	case 'VIRTUAL/notes':
				if (!intval($cutoffdate)) {
					$cutoffdate=time()-3600*24*30;
					debugLog('SetCutoffDate:'.$cutoffdate);
				}
   				$messages=array();
				//debugLog(print_r($messages,1));
       		break;
			default:
				if (preg_match('/outlook/i',$this->_deviceProperties['Type'])) {
					$this->_mailLimit=0;
				} elseif (!intval($cutoffdate)) {
					$cutoffdate=time()-3600*24*30;
					debugLog('SetCutoffDate:'.$cutoffdate);
				}
				debugLog('CutoffDate:'.date('d.m.Y',$cutoffdate));
				debugLog('MailLimit:'.$this->_mailLimit);
				$messages=$this->_soap->call('getActiveSyncMail',array($folderid,intval($cutoffdate),$this->_mailLimit));
				//debugLog(print_r($messages,1));
			break;
        }
        $this->_statMessages[$folderid]=array();
        foreach($messages as $v) {
			 $this->_statMessages[$folderid][$v['id']]=$v;
		}
        return $messages;
    }
 	// public function GetMessage($folderid, $id, $contentparameters) from DIFFBACKEND
    function GetMessage($folderid, $id, $contentparameters) {
        debugLog('Groupe::GetMessage('.$folderid.', '.$id.')');
        switch($folderid) {
        	case 'VIRTUAL/contacts':
				if (!isset($this->_messages[$folderid][$id])) {
					$this->loadMessage($folderid,$id);
				}
        		if ($this->_messages[$folderid][$id]) {
        			return 	$this->_map['contact']->groupe2message($this->_messages[$folderid][$id], $contentparameters);
				}
        	break;
        	case 'VIRTUAL/calendar':
				if (!isset($this->_messages[$folderid][$id])) {
					$this->loadMessage($folderid,$id);
				}
        		if ($this->_messages[$folderid][$id]) {
        			return 	$this->_map['appointment']->groupe2message($this->_messages[$folderid][$id], $contentparameters);
				}
        	break;
        	case 'VIRTUAL/tasks':
				if (!isset($this->_messages[$folderid][$id])) {
					$this->loadMessage($folderid,$id);
				}
        		if ($this->_messages[$folderid][$id]) {
        			return 	$this->_map['task']->groupe2message($this->_messages[$folderid][$id], $contentparameters);
				}
        	break;
         	case 'VIRTUAL/notes':
				/*if (!isset($this->_messages[$folderid][$id])) {
					$this->loadMessage($folderid,$id);
				}
        		if ($this->_messages[$folderid][$id]) {
        			return 	$this->_map['notes']->groupe2message($this->_messages[$folderid][$id], $contentparameters);
				}*/
        	break;
			default:
				if (!isset($this->_messages[$folderid][$id])) {
					$this->loadMessage($folderid,$id);
				}
				//debugLog('MemoryUsage BeforeDecode:'.number_format(memory_get_usage(true)/(1024*1024),2));
				if ($this->_messages[$folderid][$id]) {
					return 	$this->_map['mail']->groupe2message($this->_messages[$folderid][$id], $contentparameters);
				}
        	break;
         }
        return false;
    }
 	// public function StatMessage($folderid, $id) from DIFFBACKEND
    function StatMessage($folderid, $id) {
        debugLog('Groupe::StatMessage('.$folderid.', '.$id.')');
		if (!isset($this->_statMessages[$folderid][$id])) {
			$this->loadMessage($folderid,$id);
		}
		if (isset($this->_statMessages[$folderid][$id])) {
			return $this->_statMessages[$folderid][$id];
		}
        return false;
    }
 	// public function ChangeMessage($folderid, $id, $message)  from DIFFBACKEND
    function ChangeMessage($folderid, $id, $message, $contentParameters) {
        debugLog('Groupe::ChangeMessage('.$folderid.', '.$id.', ..)');
        if ($id) {
    		$stat=$this->StatMessage($folderid, $id);
    	} else {
			$stat=array('acl'=>7);
    	}
    	if ($stat['acl']&2) {
			switch($folderid) {
				case 'VIRTUAL/contacts':
					if ($id && !isset($this->_messages[$folderid][$id])) {
						$this->loadMessage($folderid,$id);
					}
					if ($id && $this->_messages[$folderid][$id]) {
						$groupeMsg=$this->_messages[$folderid][$id];
						$mode='c';
					} else {
						$groupeMsg=(object)array();
						$mode='a';
					}
					$groupeMsg=$this->_map['contact']->message2groupe($message,$groupeMsg);
					$result=$this->_soap->call('updateActiveSyncContact',array($id,$groupeMsg));
					debugLog('updateActiveSyncContact:'.print_r($result,1));
					if (isset($result['error']) && $result['error']==0) {
						if (!$result['reload'] && $result['id'] && isset($this->_messages[$folderid][$result['id']])) {
							unset($this->_messages[$folderid][$result['id']]);
							unset($this->_statMessages[$folderid][$result['id']]);
						}
						return $this->StatMessage($folderid, $result['id']);
					} else {
						return false;
					}
				break;
				case 'VIRTUAL/calendar':
					if ($id && !isset($this->_messages[$folderid][$id])) {
						$this->loadMessage($folderid,$id);
					}
					if ($id && $this->_messages[$folderid][$id]) {
						$groupeMsg=$this->_messages[$folderid][$id];
						$mode='c';
					} else {
						$groupeMsg=(object)array();
						$mode='a';
					}
					$groupeMsg=$this->_map['appointment']->message2groupe($message,$groupeMsg);
					//debugLog(print_r($groupeMsg,1));
					$result=$this->_soap->call('updateActiveSyncAppointment',array($id,$groupeMsg));
					debugLog('updateActiveSyncAppointment:'.print_r($result,1));
					if (isset($result['error']) && $result['error']==0) {
						if (!$result['reload'] && $result['id'] && isset($this->_messages[$folderid][$result['id']])) {
							unset($this->_messages[$folderid][$result['id']]);
							unset($this->_statMessages[$folderid][$result['id']]);
						}
						return $this->StatMessage($folderid, $result['id']);
					} else {
						return false;
					}
				break;
				case 'VIRTUAL/tasks':
					if ($id && !isset($this->_messages[$folderid][$id])) {
						$this->loadMessage($folderid,$id);
					}
					if ($id && $this->_messages[$folderid][$id]) {
						$groupeMsg=$this->_messages[$folderid][$id];
						$mode='c';
					} else {
						$groupeMsg=(object)array();
						$mode='a';
					}
					$groupeMsg=$this->_map['task']->message2groupe($message,$groupeMsg);
					//debugLog(print_r($groupeMsg,1));
					$result=$this->_soap->call('updateActiveSyncTask',array($id,$groupeMsg));
					debugLog('updateActiveSyncTask:'.print_r($result,1));
					if (isset($result['error']) && $result['error']==0) {
						if (!$result['reload'] && $result['id'] && isset($this->_messages[$folderid][$result['id']])) {
							unset($this->_messages[$folderid][$result['id']]);
							unset($this->_statMessages[$folderid][$result['id']]);
						}
						return $this->StatMessage($folderid, $result['id']);
					} else {
						return false;
					}
				break;
				case 'VIRTUAL/notes':
					/*if ($id && !isset($this->_messages[$folderid][$id])) {
						$this->loadMessage($folderid,$id);
					}
					if ($id && $this->_messages[$folderid][$id]) {
						$groupeMsg=$this->_messages[$folderid][$id];
						$mode='c';
					} else {
						$groupeMsg=(object)array();
						$mode='a';
					}
					$groupeMsg=$this->_map['task']->message2groupe($message,$groupeMsg);
					//debugLog(print_r($groupeMsg,1));
					$result=$this->_soap->call('updateActiveSyncTask',array($id,$groupeMsg));
					debugLog('updateActiveSyncTask:'.print_r($result,1));
					if (isset($result['error']) && $result['error']==0) {
						if (!$result['reload'] && $result['id'] && isset($this->_messages[$folderid][$result['id']])) {
							unset($this->_messages[$folderid][$result['id']]);
							unset($this->_statMessages[$folderid][$result['id']]);
						}
						return $this->StatMessage($folderid, $result['id']);
					} else {
						return false;
					}*/
				break;
			}
		} else {
			debugLog('NO CHANGE Permissions:'.$id);
		}
        return false;
    }
    // public function SetReadFlag($folderid, $id, $flags) from DIFFBACKEND
    function SetReadFlag($folderid, $id, $flags, $contentParameters) {
		debugLog('Groupe::SetReadFlag('.$folderid.','.$id.','.$flags.')');
		if ($flags == 0) {
			return $this->_soap->call('clearMailFlag',array($folderid,$id,"\\Seen"));
		} else {
			return $this->_soap->call('setMailFlag',array($folderid,$id,"\\Seen"));
		}
    }
    // public function DeleteMessage($folderid, $id) from DIFFBACKEND
     function DeleteMessage($folderid, $id, $contentParameters) {
        debugLog('Groupe::DeleteMessage('.$folderid.', '.$id.')');
    	$stat=$this->StatMessage($folderid, $id);
       // debugLog(print_r($stat,1));
        if ($stat===false) {
			debugLog('Message not exists:'.$id);
			return true;
		} elseif ($stat['acl']&4) {
			switch($folderid) {
				case 'VIRTUAL/contacts':
					if ($id && $this->_soap->call('deleteActiveSyncContact',array($id))) {
						unset($this->_messages[$folderid][$id]);
						unset($this->_statMessages[$folderid][$id]);
						return true;
					}
				break;
				case 'VIRTUAL/calendar':
					if ($id && $this->_soap->call('deleteActiveSyncAppointment',array($id))) {
						unset($this->_messages[$folderid][$id]);
						unset($this->_statMessages[$folderid][$id]);
						return true;
					}
				break;
				case 'VIRTUAL/tasks':
					if ($id && $this->_soap->call('deleteActiveSyncTask',array($id))) {
						unset($this->_messages[$folderid][$id]);
						unset($this->_statMessages[$folderid][$id]);
						return true;
					}
				break;
				case 'VIRTUAL/notes':
					/*if ($id && $this->_soap->call('deleteActiveSyncTask',array($id))) {
						unset($this->_messages[$folderid][$id]);
						unset($this->_statMessages[$folderid][$id]);
						return true;
					}*/
				break;
				default:
					if ($id && $this->_soap->call('deleteMail',array($folderid,$id))) {
						unset($this->_messages[$folderid][$id]);
						unset($this->_statMessages[$folderid][$id]);
						return true;
					}
				break;
			}
		} else {
			debugLog('NO DELETE Permissions:'.$id);
		}
        return false;
    }
    // public function MoveMessage($folderid, $id, $newfolderid) from DIFFBACKEND
    function MoveMessage($folderid, $id, $newfolderid, $contentParameters) {
        debugLog('Groupe::MoveMessage('.$folderid.', '.$id.', '.$newfolderid.')');
        if ($newfolderid=='_TRASH_') {
			return $this->DeleteMessage($folderid, $id) ;
		}
    	$stat=$this->StatMessage($folderid, $id);
       // debugLog(print_r($stat,1));
    	if ($stat===false) {
			debugLog('Message not exists:'.$id);
			return true;
		} elseif ($stat['acl']&2) {
			switch($folderid) {
				case 'VIRTUAL/contacts':
				case 'VIRTUAL/calendar':
				case 'VIRTUAL/tasks':
				case 'VIRTUAL/notes':
					return false;
				break;
				default:
					if ($id && $newfolderid && $this->_soap->call('moveMail',array($folderid,$id,$newfolderid))) {
						unset($this->_messages[$folderid][$id]);
						unset($this->_statMessages[$folderid][$id]);
						return true;
					}
				break;
			}
		} else {
			debugLog('NO MOVE Permissions:'.$id);
		}
		return false;
    }   
   function LoadMessage($folderid, $id, $contentparameters = null) {
        debugLog('Groupe::LoadMessage('.$folderid.', '.$id.')');
        switch($folderid) {
        	case 'VIRTUAL/contacts':
  				$this->_messages[$folderid][$id]=$this->_soap->call('getActiveSyncContactByID',array($id));
  				if ($this->_messages[$folderid][$id]) {
					$this->_statMessages[$folderid][$id]=array(
						'id'=>$id,
						'mod'=>$this->_messages[$folderid][$id]->TimeModify,
						'flags'=>1,
						'acl'=>$this->_messages[$folderid][$id]->_acl,
					);
				}
  				//debugLog(print_r($messages,1));
       		break;
        	case 'VIRTUAL/calendar':
  				$this->_messages[$folderid][$id]=$this->_soap->call('getActiveSyncAppointmentByID',array($id));
  				if ($this->_messages[$folderid][$id]) {
					$this->_statMessages[$folderid][$id]=array(
						'id'=>$id,
						'mod'=>$this->_messages[$folderid][$id]->TimeModify,
						'flags'=>1,
						'acl'=>$this->_messages[$folderid][$id]->_acl,
					);
				}
  				//debugLog(print_r($this->_messages[$folderid][$id],1));
       		break;
        	case 'VIRTUAL/tasks':
  				$this->_messages[$folderid][$id]=$this->_soap->call('getActiveSyncTaskByID',array($id));
  				if ($this->_messages[$folderid][$id]) {
					$this->_statMessages[$folderid][$id]=array(
						'id'=>$id,
						'mod'=>$this->_messages[$folderid][$id]->TimeModify,
						'flags'=>1,
						'acl'=>$this->_messages[$folderid][$id]->_acl,
					);
				}
  				//debugLog(print_r($messages,1));
       		break;
        	case 'VIRTUAL/notes':
  				/*$this->_messages[$folderid][$id]=$this->_soap->call('getActiveSyncTaskByID',array($id));
  				if ($this->_messages[$folderid][$id]) {
					$this->_statMessages[$folderid][$id]=array(
						'id'=>$id,
						'mod'=>$this->_messages[$folderid][$id]->TimeModify,
						'flags'=>1,
						'acl'=>$this->_messages[$folderid][$id]->_acl,
					);
				}*/
  				//debugLog(print_r($messages,1));
       		break;
			default:
				//debugLog('MemoryUsage BeforeLoad:'.number_format(memory_get_usage(true)/(1024*1024),2));
				$this->_messages[$folderid][$id]=$this->_soap->call('getActiveSyncMailMimeByID',array($folderid,$id));
				//debugLog('MemoryUsage AfterLoad:'.number_format(memory_get_usage(true)/(1024*1024),2));
  				//debugLog('Groupe::LoadMessage: Result:'.substr(print_r($this->_messages[$folderid][$id],1),0,300));
  				if ($this->_messages[$folderid][$id]) {
					$this->_statMessages[$folderid][$id]=array(
						'id'=>$id,
						'mod'=>$this->_messages[$folderid][$id]->Date,
						'flags'=>$this->_messages[$folderid][$id]->New?0:1,
						'acl'=>7,
					);
				}
			break;
        }
    }
 	function combineMessage(&$mailMsg,&$newMail,&$mailPlain,&$mailHtml,$task='') {
		$bodyHtml='';
		$bodyPlain='';
		
		if($mailMsg->ctype_primary == "multipart" && ($mailMsg->ctype_secondary == "mixed" || $mailMsg->ctype_secondary == "alternative" || $mailMsg->ctype_secondary == "related")) {
			$mparts = $mailMsg->parts;
			for($i=0; $i<count($mparts); $i++) {
				$part = $mparts[$i];
				// palm pre & iPhone send forwarded messages in another subpart which are also parsed
				if($part->ctype_primary == "multipart" && ($part->ctype_secondary == "mixed" || $part->ctype_secondary == "alternative"  || $part->ctype_secondary == "related")) {
					foreach($part->parts as $spart) {
						$mparts[] = $spart;
					}
					continue;
				}
				// standard body
				if($part->ctype_primary == "text" && $part->ctype_secondary == "plain" && isset($part->body) && (!isset($part->disposition) || $part->disposition != "attachment")) {
					$bodyPlain.=$part->body; // assume only one text body
				} elseif($part->ctype_primary == "text" && $part->ctype_secondary == "html" && isset($part->body) && (!isset($part->disposition) || $part->disposition != "attachment")) {
					// html body
					$bodyHtml.=nl2br(preg_replace("@>\s+<@", "><", $part->body));
				} elseif ($part->ctype_primary=="image" && $part->headers['content-id'] && (!isset($part->disposition) || $part->disposition != "attachment") && ($part->ctype_secondary == "gif" || $part->ctype_secondary == "png" || $part->ctype_secondary == "jpg"|| $part->ctype_secondary == "jpeg")) {
					if(isset($part->d_parameters['filename']))
						$attname = $part->d_parameters['filename'];
					else if(isset($part->ctype_parameters['name']))
						$attname = $part->ctype_parameters['name'];
					else if(isset($part->headers['content-description']))
						$attname = $part->headers['content-description'];
					else $attname = "unknown attachment";
					// html image
					$newMail->addHTMLImage($part->body,$part->ctype_primary.'/'.$part->ctype_secondary,$attname,false,$part->headers['content-id']	);

				} elseif ($task!='reply') {
					if(isset($part->d_parameters['filename']))
						$attname = $part->d_parameters['filename'];
					else if(isset($part->ctype_parameters['name']))
						$attname = $part->ctype_parameters['name'];
					else if(isset($part->headers['content-description']))
						$attname = $part->headers['content-description'];
					else $attname = "unknown attachment";
					// any other type, store as attachment
					$newMail->addAttachment($part->body,$part->ctype_primary.'/'.$part->ctype_secondary,$attname,false);
				}
			}
		} elseif($mailMsg->ctype_primary == "text" && $mailMsg->ctype_secondary == "html") {
			$bodyHtml.=nl2br(preg_replace("@>\s+<@", "><", $mailMsg->body));
		} elseif (isset($mailMsg->body)) {
			$bodyPlain.=$mailMsg->body;
		}
		if (!trim($bodyPlain)) {	
			$bodyPlain = preg_replace("/<br(\s+)?\/?>/i", "\n", $bodyHtml);
			// remove css-style tags
			$bodyPlain = preg_replace("/<style.*?<\/style>/is", "", $bodyHtml);
			// remove all other html
			$bodyPlain = strip_tags($bodyPlain);
		}
		if (!trim($bodyHtml)) {
			$bodyHtml=nl2br($bodyPlain);
		}
		$mailPlain.=$bodyPlain;
		$mailHtml.=$bodyHtml;
	}   
	// public function GetWasteBasket();
    function GetWasteBasket() {
		debugLog('Groupe::GetWasteBasket');
		// return $this->_wasteID;
        return '_TRASH_';
    }
    // public function Fetch($folderid, $id, $contentparameters);
    function Fetch($folderid, $id, $contentparameters) {
        debugLog('Groupe::Fetch('.$folderid.','.$id.')');
        return parent::Fetch($folderid, $id, $contentparameters);
	}
    // public function MeetingResponse($requestid, $folderid, $response);
    function MeetingResponse($requestid, $folderid, $response) {
		debugLog('Groupe::MeetingResponse('.$requestid.','.$folderid.','.$response.')');
		parent::MeetingResponse($requestid, $folderid, $response);
        return false;
    }
    /**
     * Returns array of items which contain contact information
     *
     * @param string $searchquery
     *
     * @return array
     */
    function getSearchResults($searchquery,$searchname) {
        debugLog('Groupe::getSearchResults('.$searchquery.','.$searchname.')');
        return false;
    }


   	function setLastSyncTime () {
       debugLog('Groupe::setLastSyncTime()');
        if (!empty($this->_deviceProperties)) {
       		$this->_deviceProperties['LastSync']=time();
			if ($this->_soap->call('setActiveSyncDevicePoperties',array($this->_devid,(object)$this->_deviceProperties))) {
				return true;
			}
       }
    }

	function setSettings($request,$devid) {
		if (isset($request["oof"])) {
			if ($request["oof"]["oofstate"] == 1) {
				// in case oof should be switched on do it here
				// store somehow your oofmessage in case your system supports.
				// response["oof"]["status"] = true per default and should be false in case
				// the oof message could not be set
				$response["oof"]["status"] = true;
			} else {
				// in case oof should be switched off do it here
				$response["oof"]["status"] = true;
			}
		}
		if (isset($request["deviceinformation"])) {
			//error_log(print_r($request["deviceinformation"]));
			// in case you'd like to store device informations do it here.
			$response["deviceinformation"]["status"] = true;
		}
		if (isset($request["devicepassword"])) {
			// in case you'd like to store device informations do it here.
			$response["devicepassword"]["status"] = true;
		}

		return $response;
	}

	function getSettings ($request,$devid)	{
		if (isset($request["userinformation"])) {
			$response["userinformation"]["status"] = 1;
			//$response["userinformation"]["emailaddresses"][] = $GLOBALS['egw_info']['user']['email'];
		} else {
			$response["userinformation"]["status"] = false;
		}
		if (isset($request["oof"])) {
			$response["oof"]["status"] 	= 0;
		}
		return $response;
	}
	 static function setMessageBody ($message,$tmpBody,$contentparameters) {
		$bpTypes = $contentparameters->GetBodyPreference();
		if (strlen(trim($tmpBody)) == 0) {
			$tmpBody = " ";
		}
		if ($bpTypes == false || Request::GetProtocolVersion()<12.0) {
			// Override 'body' for truncation
			$message->body = str_replace("\n","\r\n", w2u(str_replace("\r", "", $tmpBody)));
			if (strlen($message->body) == 0) {
				$message->body = " ";
			}
			$message->bodysize = strlen($message->body);
			$message->bodytruncated = 0;
			$truncsize = Utils::GetTruncSize($contentparameters->GetTruncation());
			if($message->bodysize > $truncsize) {
				$message->body = Utils::Utf8_truncate($message->body, $truncsize);
				$message->bodytruncated = 1;
			}
		} else {
            if (($contentparameters->GetMimeSupport() == SYNC_MIMESUPPORT_NEVER) && ($key = array_search(SYNC_BODYPREFERENCE_MIME, $bpTypes)!== false)) {
                unset($bpTypes[$key]);
                ZLog::Write(LOGLEVEL_DEBUG, sprintf("Remove mime body preference type because the device required no mime support. BodyPreference types: %s", implode(', ', $bpTypes)));
            }
            //get the best fitting preference type
            $bpReturnType = BackendGroupe::getBodyPreferenceBestMatch($bpTypes);
            $bpo = $contentparameters->BodyPreference($bpReturnType);
            $message->asbody = new SyncBaseBody();
            $message->nativebodytype=SYNC_BODYPREFERENCE_PLAIN;
            if ($bpReturnType==SYNC_BODYPREFERENCE_HTML) {
				// Send HTML if requested and native type was html
				$message->asbody->type = SYNC_BODYPREFERENCE_HTML;
				$html='<html>';
				$html.='<head>';
				$html.='<meta name="Generator" content="Z-Push">';
				$html.='<meta http-equiv="Content-Type" content="text/html; charset=utf-8">';
				$html.='</head>';
				$html.='<body>';
				$html.=nl2br($tmpBody);
				$html.='</body>';
				$html.='</html>';
				$message->asbody->data = $html;
				$message->asbody->estimatedDataSize = strlen($html);
			} else {
				// Send Plaintext as Fallback or if original body is plaintext
				$message->asbody->type = SYNC_BODYPREFERENCE_PLAIN;
				$message->asbody->estimatedDataSize = strlen($tmpBody);
				$message->asbody->data = $tmpBody;
			}
			//only set the truncation size data if device set it in request
			if ($bpo->GetTruncationSize() != false &&
					$bpReturnType != SYNC_BODYPREFERENCE_MIME &&
					$message->asbody->estimatedDataSize > $bpo->GetTruncationSize() &&
					$contentparameters->GetTruncation() != SYNC_TRUNCATION_ALL // do not truncate message if the whole is requested, e.g. on fetch
				) {
				$message->asbody->data = Utils::Utf8_truncate($message->asbody->data, $bpo->GetTruncationSize());
				$message->asbody->truncated = 1;

			}
			// set the preview or windows phones won't show the preview of an email
			if (Request::GetProtocolVersion() >= 14.0 && $bpo->GetPreview()) {
				$message->asbody->preview = Utils::Utf8_truncate($tmpBody, $bpo->GetPreview());
			}
		}
	}
	static function getBodyPreferenceBestMatch($bpTypes) {
        // The best choice is RTF, then HTML and then MIME in order to save bandwidth
        // because MIME is a complete message including the headers and attachments
        if (in_array(SYNC_BODYPREFERENCE_RTF, $bpTypes))  return SYNC_BODYPREFERENCE_RTF;
        if (in_array(SYNC_BODYPREFERENCE_HTML, $bpTypes)) return SYNC_BODYPREFERENCE_HTML;
        if (in_array(SYNC_BODYPREFERENCE_MIME, $bpTypes)) return SYNC_BODYPREFERENCE_MIME;
        return SYNC_BODYPREFERENCE_PLAIN;
	}
	 static function convertMessageBody($message) {
		if (isset($message->asbody)) {
			switch($message->asbody->type) {
				case SYNC_BODYPREFERENCE_RTF 	: $message->rtf = $message->asbody->data; break;
				case SYNC_BODYPREFERENCE_PLAIN 	: $message->body = $message->asbody->data; break;
			}
		}
		if (isset($message->rtf)) {
			// Nokia MfE 2.9.158 sends contact notes with RTF and Body element.
			// The RTF is empty, the body contains the note therefore we need to unpack the rtf
			// to see if it is realy empty and in case not, take the appointment body.
			$rtf_body = new rtf ();
			$rtf_body->loadrtf(base64_decode($message->rtf));
			$rtf_body->output("ascii");
			$rtf_body->parse();
			if (isset($message->body) &&
				isset($rtf_body->out) &&
				$rtf_body->out == "" && $message->body != "") {
				unset($message->rtf);
			}
			$rtf_body = new rtf ();
			$rtf_body->loadrtf(base64_decode($message->rtf));
			$rtf_body->output("ascii");
			$rtf_body->parse();
			//put rtf into body
			if($rtf_body->out <> "") $message->body=$rtf_body->out;
		}
	}
    public function getDeviceProperties($devid) {
		debugLog('Groupe::getDeviceProperties:'.$devid);
		$soapResult=$this->_soap->call('getActiveSyncDevicePoperties',array($devid));
		if (!$soapResult) {
			$deviceProperties=array(
				'Type'=>$_REQUEST["DeviceType"],
				'Agent'=>$_SERVER["HTTP_USER_AGENT"],
				'LastSync'=>0,
			);
			$this->_soap->call('setActiveSyncDevicePoperties',array($devid,(object)$this->_deviceProperties));
		} else {
			$deviceProperties=(array)$soapResult;
		}
		return 	$deviceProperties;
    }
    public function getSyncSettings($devid) {
		debugLog('Groupe::getSyncSettings:'.$devid);
		$soapResult=$this->_soap->call('getActiveSyncSyncSettings',array($devid));
		if (!$soapResult) {
			$result=array();
		} else {
			$result=(array)$soapResult;
		}
		return 	$result;
    }
   /**
   * @access public
     * @return object       Implementation of ISearchProvider
     */
    public function GetSearchProvider() {
        return $this;
    }
    /**
     * Indicates if a search type is supported by this SearchProvider
     * Currently only the type ISearchProvider::SEARCH_GAL (Global Address List) is implemented
     *
     * @param string        $searchtype
     *
     * @access public
     * @return boolean
     */
    public function SupportsType($searchtype) {
        return ($searchtype == ISearchProvider::SEARCH_GAL) || ($searchtype == ISearchProvider::SEARCH_MAILBOX);
    }

    /**
     * Searches the GAL
     *
     * @param string        $searchquery        string to be searched for
     * @param string        $searchrange        specified searchrange
     *
     * @access public
     * @return array        search results
     * @throws StatusException
     */
    public function GetGALSearchResults($searchquery, $searchrange) {
        $rangestart = 0;
        $rangeend = 50;
        if ($searchrange != '0') {
            $pos = strpos($searchrange, '-');
            $rangestart = substr($searchrange, 0, $pos);
            $rangeend = substr($searchrange, ($pos + 1));
        }
        
		$result=array(
			'searchtotal'=>0,
			'range'=>'0-0'
		);
		
       return $result;
    }
    /**
     * Searches for the emails on the server
     *
     * @param ContentParameter $cpo
     *
     * @return array
     */
    public function GetMailboxSearchResults($cpo) {
		$result=array(
			'searchtotal'=>0,
			'range'=> $cpo->GetSearchRange(),
		);

       return $result;
	}

    /**
    * Terminates a search for a given PID
    *
    * @param int $pid
    *
    * @return boolean
    */
    public function TerminateSearch($pid) {
        return true;
    }

    /**
     * Disconnects from the current search provider
     *
     * @access public
     * @return boolean
     */
    public function Disconnect() {
        return true;
    }
    
    function escape($data){
		if (is_array($data)) {
			foreach ($data as $key => $val) {
				$data[$key] = $this->escape($val);
			}
			return $data;
		}
		$data = str_replace("\r\n", "\n", $data);
		$data = str_replace("\r", "\n", $data);
		$data = str_replace(array('\\', ';', ',', "\n"), array('\\\\', '\\;', '\\,', '\\n'), $data);
		return u2wi($data);
	}

	function unescape($data){
		$data = str_replace(array('\\\\', '\\;', '\\,', '\\n','\\N'),array('\\', ';', ',', "\n", "\n"),$data);
		return $data;
	}
	static function strToHex($string) {
		$hex='';
		for ($i=0; $i < strlen($string); $i++)
		{
			$hex .= dechex(ord($string[$i]));
		}
		return $hex;
	}
	static function hexToStr($hex) {
		$string='';
		for ($i=0; $i < strlen($hex)-1; $i+=2)
		{
			$string .= chr(hexdec($hex[$i].$hex[$i+1]));
		}
		return $string;
	}	
};
class SoapHeaderUsernameToken {
	public $Password;
	public $Username;
	public function __construct($l, $p) {
		$this->Password = $p;
		$this->Username = $l;
	}
}
class GroupeSoapClient {
	private $_soapClient;
	public function __construct() {
		if (defined('GROUP_URL_DOMAIN') && GROUP_URL_DOMAIN) {
			$location=GROUP_URL_DOMAIN.GROUP_URL_PATH;
		} else {
			$location=((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'])?'https://':'http://').$_SERVER['SERVER_NAME'].GROUP_URL_PATH;
		}
        debugLog('Groupe::InitSoap: '.$location);
		$this->_soapClient = new SoapClient(null,array(
			'location' => $location,
			'uri'      => "http://localhost/SoapServer/",
			//'trace'=>true,
		));
	}
	public function initUser($username,$password) {
		$UsernameToken = new SoapHeaderUsernameToken($username, $password);
		$soapHeaders[] = new SoapHeader('http://schemas.xmlsoap.org/ws/2002/07/utility', 'UsernameToken', $UsernameToken);
		$this->_soapClient->__setSoapHeaders($soapHeaders);
	}
	public function call($function,$params=array()) {
		try {
			return $this->_soapClient->__soapCall($function, $params);
		} catch (Exception $e) {
			debugLog(print_r($e,1));
			$this->debug();
		}
	}
	public function debug() {
		//debugLog(print_r($this->_soapClient->__getLastRequest(),1));
		//debugLog(print_r($this->_soapClient->__getLastResponseHeaders(),1));
		//debugLog(print_r($this->_soapClient->__getLastResponse(),1));
	}
}

?>