<?php
class GroupeAppointment {
	public $_mapping = array();
	public $_deviceProperties;
	public $_syncSettings;
	public $_timeZone =array();
	function __construct() {

    }
    function setDeviceProperties($val) {
		$this->_deviceProperties=$val;
   	}
	function setSyncSettings($val) {
		$this->_syncSettings=$val;
	}
    function setTimeZone($val) {
		$this->_timeZone=$val;
   	}

   	function groupe2message($groupe, $contentparameters) {
    	debugLog('groupe2appointment');

		$message=new SyncAppointment();
		$message->uid=bin2hex($groupe->UID);
		$message->starttime=$groupe->StartDate;
		$message->endtime=$groupe->EndDate;
		$message->subject=$groupe->Title;

		BackendGroupe::setMessageBody($message,isset($groupe->Text)?$groupe->Text:'',$contentparameters);
		$message->location=$groupe->Place;
		$message->categories=$groupe->Categories;
		if (isset($groupe->OwnerEmail)) $message->organizeremail=$groupe->OwnerEmail;
		if (isset($groupe->OwnerName)) $message->organizername=$groupe->OwnerName;
		if (isset($groupe->MyInvitStatus) && $groupe->MyInvitStatus==5) {
			$message->busystatus=1;
		} else {
			$message->busystatus=$groupe->Unsecure?1:2;
		}
		$message->alldayevent=($groupe->TimeMode==1?1:0);
		if ($message->alldayevent && date('His',$message->endtime)=='235959') {
			$message->endtime+=1;
		}
		$message->dtstamp=$groupe->TimeModify;
		if ($groupe->AlarmTime) $message->reminder=intval($groupe->AlarmTime/60);
		$message->sensitivity=$groupe->EvtPrivat?2:(($groupe->GrantUsers || $groupe->GrantGroups)?0:1);


		if ($groupe->Unsecure && isset($this->_syncSettings['cal/no_status']) && $this->_syncSettings['cal/no_status']) {
			$message->subject='?'.$message->subject;
		}
		if ($groupe->EvtPrivat && isset($this->_syncSettings['cal/no_privat'])  && $this->_syncSettings['cal/no_privat']) {
			$message->subject='#'.$message->subject;
		}


        $tz = $this->_getLocalTZ();
        $message->timezone = base64_encode($this->_getSyncBlobFromTZ($tz));

    	//debugLog(print_r($groupe->Attendees,1));
		if (!empty($groupe->Attendees)) {
			foreach ($groupe->Attendees as $val) {
				$attendee=new SyncAttendee();
				$attendee->email=$val['Email'];
				$attendee->name=$val['Name'];
				$attendee->status=$val['Status'];
				switch($val['Type']) {
					case 'u':
						$attendee->type=1;
					break;
					case 'a':
						$attendee->type=1;
					break;
					case 'r':
						$attendee->type=3;
					break;
				}
				$message->attendees[]=$attendee;
			}
		}
		if ($groupe->RecType && $groupe->RecInt) {
			$message->recurrence=new SyncRecurrence();
			$message->recurrence->interval=$groupe->RecInt;
			$message->recurrence->until=($groupe->RecEnd==-1)?0:$groupe->RecEnd;
			switch($groupe->RecType) {
				case 1:
					$message->recurrence->type=0;
				break;
				case 2:
					$message->recurrence->type=1;
					$message->recurrence->dayofweek=pow(2,date('w',$groupe->StartDate));
				break;
				case 3:
					$message->recurrence->type=2;
					$message->recurrence->dayofmonth=date('d',$groupe->StartDate);
				break;
				case 5:
					$message->recurrence->type=5;
					$message->recurrence->dayofmonth=date('d',$groupe->StartDate);
					$message->recurrence->monthofyear=date('m',$groupe->StartDate);
				break;
			}
			if (isset($groupe->Exceptions) && !empty($groupe->Exceptions)) {
				$message->exceptions=array();
				foreach ($groupe->Exceptions as $val) {
					$exception=new SyncAppointmentException();
					$exception->deleted=1;
					$exception->exceptionstarttime=$val['ExceptionDate'];

					// set some data from the original appointment
					if (isset($message->uid))
						$exception->uid = $message->uid;
					if (isset($message->organizername))
						$exception->organizername = $message->organizername;
					if (isset($message->organizeremail))
						$exception->organizeremail = $message->organizeremail;

					if(!isset($message->exceptions))
							$message->exceptions = array();
			
					$message->exceptions[]=$exception;
				}
			}
		}
    	//debugLog(print_r($message,1));
   		return $message;
    }

/*
    [RecType] => 2
    [RecInt] => 1
    [RecCfg] =>
    [RecEnd] => -1
    [Exception] =>
    [NoOwner] => 1
*/

    function message2groupe($message,$groupe) {
    	//global $user;
    	debugLog('appointment2groupe');
    	//debugLog(print_r($message,1));
		BackendGroupe::convertMessageBody($message);

        if(isset($message->timezone)) {
        	$binData=base64_decode($message->timezone);
            $tz = $this->_getTZFromSyncBlob($binData);
        } else {
            $tz = false;
        }
		if (isset($message->uid) && trim($message->uid)) $groupe->UID=base64_encode(hex2bin(preg_replace('/[^0-9a-f]/i','',$message->uid)));
		//debugLog('h2b'.preg_replace('/[^0-9a-f]/i','',$message->uid));

		if (isset($message->alldayevent) && $message->alldayevent) {
			if (date('His',$message->endtime)=='000000' && date('d',$message->endtime)!=date('d',$message->starttime)) $message->endtime-=1;
		}
		$groupe->StartDate=$message->starttime;
		$groupe->EndDate=$message->endtime;


		$groupe->Text=isset($message->body)?$message->body:'';
		$groupe->Place=isset($message->location)?$message->location:'';
		$groupe->Categories=isset($message->categories)?$message->categories:array();
		/*$groupe->OwnerEmail=$message->organizeremail;
		$groupe->OwnerName=$message->organizername;*/
		$groupe->TimeMode=(isset($message->alldayevent) && $message->alldayevent)?1:0;
		$groupe->AlarmTime=isset($message->reminder)?$message->reminder*60:0;

		if (isset($this->_syncSettings['cal/no_status']) && $this->_syncSettings['cal/no_status']) {
			$groupe->Unsecure=0;
		} else {
			$groupe->Unsecure=(isset($message->busystatus) && $message->busystatus==1)?1:0;
		}
		if (isset($this->_syncSettings['cal/no_privat']) && $this->_syncSettings['cal/no_privat']) {
			debugLog('NoPrivateSupport');
			$groupe->EvtPrivat=0;
			$groupe->_setDefaultGrant=1;
		} else {
			if (!isset($message->sensitivity)) $message->sensitivity=0;
			debugLog('Sensitivity:'.$message->sensitivity);
			if (isset($message->sensitivity) && in_array($message->sensitivity,array(2,3))) {
				$groupe->EvtPrivat=1;
				debugLog('SetPrivate:'.$message->sensitivity);
			} else {
				$groupe->EvtPrivat=0;
			}
			if (in_array($message->sensitivity,array(0,1,2))) {
				$groupe->_setDefaultGrant=1;
				debugLog('SetDefaultGrant:'.$message->sensitivity);
			} else {
				$groupe->_setDefaultGrant=0;
			}
		}

		$testTitle=trim($message->subject);
		do {
			$check=false;
			if (substr($testTitle,0,1)=='#') {
				$testTitle=substr($testTitle,1);
				$groupe->EvtPrivat=1;
				debugLog('SetPrivate:FromTitle');
				$check=true;
			}
			if (substr($testTitle,0,1)=='?') {
				$testTitle=substr($testTitle,1);
				$groupe->Unsecure=1;
				debugLog('SetUnsure:FromTitle');
				$check=true;
			}
		} while ($check);
		$groupe->Title=trim($testTitle);

		$groupe->Attendees=array();
		if (!empty($message->attendees)) {
			foreach ($message->attendees as $val) {
				if (!trim($val->email)) continue;
				$groupe->Attendees[]=array(
					'Email'=>$val->email,
					'Name'=>trim($val->name),
					'Status'=>isset($val->status)?$val->status:0,
					'Type'=>(isset($val->type) && $val->type==3)?'r':'',
				);
			}
		}
		$groupe->Exceptions=array();
		$groupe->RecType=0;
		$groupe->RecInt=0;
		if (isset($message->recurrence)) {
			$badRecur=false;
			switch($message->recurrence->type) {
				case 0:
					$groupe->RecType=1;
				break;
				case 1:
					$groupe->RecType=2;
					//$message->recurrence->dayofweek=pow(2,date('w',$groupe->StartDate));
				break;
				case 2:
					$groupe->RecType=3;
					//$message->recurrence->dayofmonth=date('d',$groupe->StartDate);
				break;
				case 5:
					$groupe->RecType=5;
					//$message->recurrence->dayofmonth=date('d',$groupe->StartDate);
					//$message->recurrence->monthofyear=date('m',$groupe->StartDate);
				break;
				default:
					$badRecur=true;
				break;
			}
			if (!$badRecur) {
				if (isset($message->recurrence->interval) && $message->recurrence->interval) {
					$groupe->RecInt=$message->recurrence->interval;
				} else {
					$groupe->RecInt=1;
				}
				if (isset($message->recurrence->until) && $message->recurrence->until) {
					$groupe->RecEnd=($message->recurrence->until>=2147385000)?-1:$message->recurrence->until;
				} else {
					$groupe->RecEnd=-1;
					if (isset($message->recurrence->occurrences) && $message->recurrence->occurrences)  {
						$recCount=$message->recurrence->occurrences-1;
						$year=date('Y',$groupe->StartDate);
						$month=date('m',$groupe->StartDate);
						$day=date('d',$groupe->StartDate);
						switch ($groupe->RecType) {
							case 1:
								$groupe->RecEnd=mktime(23,59,59,$month,$day+$groupe->RecInt*$recCount,$year);
							break;
							case 2:
								$groupe->RecEnd=mktime(23,59,59,$month,$day+$groupe->RecInt*7*$recCount,$year);
							break;
							case 3:
								$groupe->RecEnd=mktime(23,59,59,$month+$groupe->RecInt*$recCount,$day,$year);
							break;
							case 5:
								$groupe->RecEnd=mktime(23,59,59,$month,$day,$year+$groupe->RecInt*$recCount);
							break;
						}
					}
				}

				if (isset($message->exceptions) && !empty($message->exceptions)) {
					foreach ($message->exceptions as $val) {
						$exception=array(
							'Deleted'=>$val->deleted,
							'ExceptionDate'=>$val->exceptionstarttime,
						);
						if (!$val->deleted) {
							if (isset($val->subject)) $exception['Title']=$val->subject;
							if (isset($val->body)) $exception['Text']=$val->body;
							if (isset($val->location)) $exception['Place']=$val->location;
							if (isset($val->starttime)) $exception['StartDate']=$val->starttime;
							if (isset($val->endtime)) $exception['EndDate']=$val->endtime;
							if (isset($val->reminder)) $exception['AlarmTime']=$val->reminder*60;
							if (isset($val->alldayevent)) $exception['TimeMode']=$val->alldayevent?1:0;
							if (isset($val->busystatus)) $exception['Unsecure']=$val->busystatus==1?1:0;
						}
						$groupe->Exceptions[]=$exception;
					}
				}
			} else {
				$groupe->RecType=0;
			}
		}

    	//debugLog(print_r($groupe,1));
   		return $groupe;

        //nokia sends an yearly event with 0 mins duration but as all day event,
        //so make it end next day
        /*if ($message->starttime == $message->endtime && isset($message->alldayevent) && $message->alldayevent) {
            $message->endtime = $message->starttime + 24 * 60 * 60;
        }*/

    	//debugLog(print_r($message,1));

    	//return $groupe;
    }

   // Unpack timezone info from Sync
    function _getTZFromSyncBlob($data) {
        $tz = unpack("lbias/a64name/vdstendyear/vdstendmonth/vdstendday/vdstendweek/vdstendhour/vdstendminute/vdstendsecond/vdstendmillis/" .
        	"lstdbias/a64name/vdststartyear/vdststartmonth/vdststartday/vdststartweek/vdststarthour/vdststartminute/vdststartsecond/vdststartmillis/" .
            "ldstbias", $data);
        // Make the structure compatible with class.recurrence.php
        $tz["timezone"] = $tz["bias"];
        $tz["timezonedst"] = $tz["dstbias"];
        return $tz;
    }

    // Pack timezone info for Sync
    function _getSyncBlobFromTZ($tz) {
        $packed = pack("la64vvvvvvvv" . "la64vvvvvvvv" . "l",
                $tz["bias"], "", 0, $tz["dstendmonth"], $tz["dstendday"], $tz["dstendweek"], $tz["dstendhour"], $tz["dstendminute"], $tz["dstendsecond"], $tz["dstendmillis"],
                $tz["stdbias"], "", 0, $tz["dststartmonth"], $tz["dststartday"], $tz["dststartweek"], $tz["dststarthour"], $tz["dststartminute"], $tz["dststartsecond"], $tz["dststartmillis"],
                $tz["dstbias"]);

        return $packed;
    }

    // Checks the date to see if it is in DST, and returns correct GMT date accordingly
    function _getGMTTimeByTZ($localtime, $tz) {
        if(!isset($tz) || !is_array($tz))
            return $localtime;

        if($this->_isDST($localtime, $tz))
            return $localtime + $tz["bias"]*60 + $tz["dstbias"]*60;
        else
            return $localtime + $tz["bias"]*60;
    }

    // Returns the local time for the given GMT time, taking account of the given timezone
    function _getLocaltimeByTZ($gmttime, $tz) {
        if(!isset($tz) || !is_array($tz))
            return $gmttime;

        if($this->_isDST($gmttime - $tz["bias"]*60, $tz)) // may bug around the switch time because it may have to be 'gmttime - bias - dstbias'
            return $gmttime - $tz["bias"]*60 - $tz["dstbias"]*60;
        else
            return $gmttime - $tz["bias"]*60;
    }

    // Returns TRUE if it is the summer and therefore DST is in effect
    function _isDST($localtime, $tz) {
        if(!isset($tz) || !is_array($tz))
            return false;

        $year = gmdate("Y", $localtime);
        $start = $this->_getTimestampOfWeek($year, $tz["dststartmonth"], $tz["dststartweek"], $tz["dststartday"], $tz["dststarthour"], $tz["dststartminute"], $tz["dststartsecond"]);
        $end = $this->_getTimestampOfWeek($year, $tz["dstendmonth"], $tz["dstendweek"], $tz["dstendday"], $tz["dstendhour"], $tz["dstendminute"], $tz["dstendsecond"]);

        if($start < $end) {
            // northern hemisphere (july = dst)
          if($localtime >= $start && $localtime < $end)
              $dst = true;
          else
              $dst = false;
        } else {
            // southern hemisphere (january = dst)
          if($localtime >= $end && $localtime < $start)
              $dst = false;
          else
              $dst = true;
        }

        return $dst;
    }
    function _getGMTTZ() {
        $tz = array(
        	"bias" => 0,
        	"stdbias" => 0,
        	"dstbias" => 0,
        	"dstendyear" => 0,
        	"dstendmonth" =>0,
        	"dstendday" =>0,
        	"dstendweek" => 0,
        	"dstendhour" => 0,
        	"dstendminute" => 0,
        	"dstendsecond" => 0,
        	"dstendmillis" => 0,
            "dststartyear" => 0,
            "dststartmonth" =>0,
            "dststartday" =>0,
            "dststartweek" => 0,
            "dststarthour" => 0,
            "dststartminute" => 0,
            "dststartsecond" => 0,
            "dststartmillis" => 0
        );
        return $tz;
    }
    function _getLocalTZ() {
    	if (is_array($this->_timeZone) && !empty($this->_timeZone)) {
			return $this->_timeZone;
    	} else {
			return $this->_getGMTTZ();
    	}
    }
    // Returns the local timestamp for the $week'th $wday of $month in $year at $hour:$minute:$second
    function _getTimestampOfWeek($year, $month, $week, $wday, $hour, $minute, $second)
    {
        $date = gmmktime($hour, $minute, $second, $month, 1, $year);

        // Find first day in month which matches day of the week
        while(1) {
            $wdaynow = gmdate("w", $date);
            if($wdaynow == $wday)
                break;
            $date += 24 * 60 * 60;
        }

        // Forward $week weeks (may 'overflow' into the next month)
        $date = $date + $week * (24 * 60 * 60 * 7);

        // Reverse 'overflow'. Eg week '10' will always be the last week of the month in which the
        // specified weekday exists
        while(1) {
            $monthnow = gmdate("n", $date) - 1; // gmdate returns 1-12
            if($monthnow > $month)
                $date = $date - (24 * 7 * 60 * 60);
            else
                break;
        }

        return $date;
    }

    // Normalize the given timestamp to the start of the day
    function _getDayStartOfTimestamp($timestamp) {
        return $timestamp - ($timestamp % (60 * 60 * 24));
    }
}
?>