<?php

class GroupeMail {
	public $_mapping = array();
	public $_deviceProperties;
	public $_syncSettings;
	function __construct() {

    }
	function setDeviceProperties($val) {
		$this->_deviceProperties=$val;
	}
	function setSyncSettings($val) {
		$this->_syncSettings=$val;
	}
    function groupe2message($groupe,$contentparameters) {
		$bpTypes = $contentparameters->GetBodyPreference();

		$mail=array(
			base64_decode($groupe->MimeHeader),
			base64_decode($groupe->MimeBody),
		);
		$mobj = new Mail_mimeDecode($mail);
		$message = $mobj->decode(array('decode_headers' => true, 'decode_bodies' => true, 'include_bodies' => true, 'crlf' => "\n", 'charset' => BACKEND_CHARSET));
		//debugLog("RAW Message ".print_r($message,true));
		$output = new SyncMail();
		$msgPlain='';$msgHtml='';
		GroupeMail::getBodyRecursive($message, "plain", $msgPlain);
		GroupeMail::getBodyRecursive($message, "html", $msgHtml);
		
		if ($bpTypes===false || Request::GetProtocolVersion() < 12.0) {
            // Override 'body' for truncation
            $truncsize = Utils::GetTruncSize($contentparameters->GetTruncation());
			$body=trim($msgPlain)===''?$msgPlain:GroupeMail::html2plain($msgHtml);
			$output->bodysize = strlen($body);
			if(strlen($body) > $truncsize) {
				$body = Utils::Utf8_truncate($body, $truncsize);
				$output->bodytruncated = 1;
			} else {
				$body = $body;
				$output->bodytruncated = 0;
			}
			$output->body = $body;
		} else {
			ZLog::Write(LOGLEVEL_DEBUG, sprintf("BodyPreference types: %s", implode(', ', $bpTypes)));
			if (($contentparameters->GetMimeSupport() == SYNC_MIMESUPPORT_NEVER) && ($key = array_search(SYNC_BODYPREFERENCE_MIME, $bpTypes)!== false)) {
               unset($bpTypes[$key]);
               ZLog::Write(LOGLEVEL_DEBUG, sprintf("Remove mime body preference type because the device required no mime support. BodyPreference types: %s", implode(', ', $bpTypes)));
			}
			$bpReturnType = BackendGroupe::getBodyPreferenceBestMatch($bpTypes);

            ZLog::Write(LOGLEVEL_DEBUG, sprintf("getBodyPreferenceBestMatch: %d", $bpReturnType));
            $bpo = $contentparameters->BodyPreference($bpReturnType);
            ZLog::Write(LOGLEVEL_DEBUG, sprintf("bpo: truncation size:'%d', allornone:'%d', preview:'%d', truncation:'%d'", $bpo->GetTruncationSize(), $bpo->GetAllOrNone(), $bpo->GetPreview(), $contentparameters->GetTruncation()));

			$output->asbody = new SyncBaseBody();
			debugLog("SyncBaseBody");

			if (trim($msgHtml)) {
				$output->nativebodytype=SYNC_BODYPREFERENCE_HTML;
			} else {
				$output->nativebodytype=SYNC_BODYPREFERENCE_PLAIN;
			}
			if ($bpReturnType==SYNC_BODYPREFERENCE_MIME) {
				debugLog("MIME Body");
				$output->asbody->type = SYNC_BODYPREFERENCE_MIME;
				$rawmessage = $mobj->decode(array('decode_headers' => false, 'decode_bodies' => false, 'include_bodies' => false, 'crlf' => "\n", 'charset' => BACKEND_CHARSET));
				$body = "";
				foreach($rawmessage->headers as $key=>$value) {
					if ($key != "content-type" && $key != "mime-version" && $key != "content-transfer-encoding" &&
						!is_array($value)) {
						$body .= $key.":";
						$tokens = explode(" ",trim($value));
						$line = "";
						foreach($tokens as $valu) {
							if ((strlen($line)+strlen($valu)+2) > 60) {
								$line .= "\n";
								$body .= $line;
								$line = " ".$valu;
							} else {
								$line .= " ".$valu;
							}
						}
						$body .= $line."\n";
					}
				}
				unset($rawmessage);
				$mimemsg = new Mail_mime(array( 'head_encoding'	=> 'quoted-printable',
												'text_encoding'	=> 'quoted-printable',
												'html_encoding'	=> 'base64',
												'head_charset'	=> 'utf-8',
												'text_charset'	=> 'utf-8',
												'html_charset'	=> 'utf-8',
												'eol'		=> "\n",
												'delay_file_io'	=> false,
											)
										);
				GroupeMail::GetAttachmentsRecursive($message,$mimemsg);
				if ($output->nativebodytype==SYNC_BODYPREFERENCE_PLAIN) {
					if ($msgPlain == "" && $msgHtml == "" && strlen($mobj->_body) != "") {
						$body .= "Content-Type:".$message->headers['content-type']."\r\n";
						$body .= "Content-Transfer-Encoding:".$message->headers['content-transfer-encoding']."\r\n";
						$body .= "\n\n".$mobj->_body;
						$output->asbody->data = $body;
					} else {
						$mimemsg->setTXTBody(str_replace("\n","\r\n", str_replace("\r","",($msgPlain))));
						$html = '<html>'.
								'<head>'.
								'<meta name="Generator" content="Z-Push">'.
								'<meta http-equiv="Content-Type" content="text/html; charset=utf-8">'.
								'</head>'.
								'<body>'.
								str_replace("\n","<BR>",str_replace("\r","", str_replace("\r\n","<BR>",($msgHtml?$msgHtml:$msgPlain)))).
								'</body>'.
								'</html>';
						$mimemsg->setHTMLBody(str_replace("\n","\r\n", str_replace("\r","",$html)));
					}
				}
				if ($output->nativebodytype==SYNC_BODYPREFERENCE_HTML) {
					$plain = trim($msgPlain)===''?$msgPlain:GroupeMail::html2plain($msgHtml);
					$mimemsg->setTXTBody(str_replace("\n","\r\n", str_replace("\r","",($plain))));
					$mimemsg->setHTMLBody(str_replace("\n","\r\n", str_replace("\r","",($msgHtml))));
				}
				if (!isset($output->asbody->data)) {
					$output->asbody->data = $body.$mimemsg->txtheaders()."\n\n".$mimemsg->get();
				}
				//ZLog::Write(LOGLEVEL_DEBUG, sprintf("mimeHeaders: %s", $body));
				  
				$output->asbody->estimatedDataSize = strlen($output->asbody->data);
			} elseif ($bpReturnType==SYNC_BODYPREFERENCE_HTML) {
				debugLog("HTML Body");
				// Send HTML if requested and native type was html
				$output->asbody->type = SYNC_BODYPREFERENCE_HTML;
				$html='';
				if ($msgHtml) {
					$html=$msgHtml;
				} elseif ($msgPlain) {
					$html=$msgPlain;
				} elseif(strlen($mobj->_body) > 0) {
					$html=$mobj->_quotedPrintableDecode($mobj->_body);
				}
				//debugLog(print_r($html,1));
				if ($output->nativebodytype==SYNC_BODYPREFERENCE_HTML) {
					
				} else {
					$html = '<html>'.
							'<head>'.
							'<meta name="Generator" content="Z-Push">'.
							'<meta http-equiv="Content-Type" content="text/html; charset=utf-8">'.
							'</head>'.
							'<body>'.
							str_replace("\n","<BR>",str_replace("\r","<BR>", str_replace("\r\n","<BR>",($html)))).
							'</body>'.
							'</html>';
				}
				$output->asbody->data = $html;
				$output->asbody->estimatedDataSize = strlen($html);
			} else {
				// Send Plaintext as Fallback or if original body is plaintext
				debugLog("Plaintext Body");
				$plain = (str_replace("\n","\r\n",str_replace("\r","",$msgPlain)));
				$output->asbody->type = SYNC_BODYPREFERENCE_PLAIN;
				$output->asbody->estimatedDataSize = strlen($plain);
				$output->asbody->data = $plain;
			}
			// In case we have nothing for the body, send at least a blank...
			// dw2412 but only in case the body is not rtf!
			if ($output->asbody->type != SYNC_BODYPREFERENCE_RTF && (!isset($output->asbody->data) || strlen($output->asbody->data) == 0)) {
				$output->asbody->data = " ";
			}
		//Truncate tthe body
			if ( $bpo->GetTruncationSize() != false &&
					$bpReturnType != SYNC_BODYPREFERENCE_MIME &&
					$output->asbody->estimatedDataSize > $bpo->GetTruncationSize() &&
					$contentparameters->GetTruncation() != SYNC_TRUNCATION_ALL // do not truncate message if the whole is requested, e.g. on fetch
				) {
				$output->asbody->data = Utils::Utf8_truncate($message->asbody->data, $bpo->GetTruncationSize());
				$output->asbody->truncated = 1;
				ZLog::Write(LOGLEVEL_DEBUG, sprintf("Truncate body to: %d",  $bpo->GetTruncationSize()));
			}
			// set the preview or windows phones won't show the preview of an email
			if (Request::GetProtocolVersion() >= 14.0 && $bpo->GetPreview()) {
				$body=trim($msgPlain)===''?$msgPlain:GroupeMail::html2plain($msgHtml);
				$output->asbody->preview = Utils::Utf8_truncate($body, $bpo->GetPreview());
			}
		}
		// small dirty correction for (i.e. Tobit David) since it has the opinion the UTC Timezone abbreviation is UT :-(
		$output->datereceived = isset($message->headers["date"]) ? strtotime($message->headers["date"].(substr($message->headers["date"],-3)==" UT" ? "C" : "")) : null;
		$output->displayto = isset($message->headers["to"]) ? trim(($message->headers["to"])) : null;
		if (isset($message->headers["x-priority"])) {
			switch(trim(strtolower($message->headers["x-priority"]))) {
				case 'high':
					$output->importance = 2;
				break;
				case 'low':
					$output->importance = 0;
				break;
				case 'normal':
					$output->importance = 0;
				break;
				default:
					$mimeImportance =  preg_replace("/\D+/", "", $message->headers["x-priority"]);
					if ($mimeImportance > 3)
						$output->importance = 0;
					if ($mimeImportance == 3)
						$output->importance = 1;
					if ($mimeImportance < 3)
						$output->importance = 2;
				break;
			}
		}
		$output->messageclass = "IPM.Note";
		if (strtolower($message->ctype_primary) == "multipart") {
			switch(strtolower($message->ctype_secondary)) {
				case 'signed'	:
					$output->messageclass = "IPM.Note.SMIME.MultipartSigned"; break;
				default 	:
					$output->messageclass = "IPM.Note";
			}
		}
		if (isset($message->headers["subject"])) {
			if (is_array($message->headers["subject"])) $message->headers["subject"]=$message->headers["subject"][0];
			$output->subject = trim(($message->headers["subject"]));
		} else {
			$output->subject = "";
		}
		$output->read =$groupe->New?0:1;
		$output->to = isset($message->headers["to"]) ? trim(($message->headers["to"])) : null;
		$output->cc = isset($message->headers["cc"]) ? trim(($message->headers["cc"])) : null;
		$output->from = isset($message->headers["from"]) ? trim(($message->headers["from"])) : null;
		$output->reply_to = isset($message->headers["reply-to"]) ? trim(($message->headers["reply-to"])) : null;
		$output->contentclass="urn:content-classes:message";
		// start AS12 Stuff
		if (Request::GetProtocolVersion() >= 12.0 ) {
			$output->flag = new SyncMailFlags();
			$output->flag->flagstatus = 0;
			$output->internetcpid = 65001; //utf-8 codepage;
		}
		// end AS12 Stuff
		ZLog::Write(LOGLEVEL_DEBUG, sprintf("Messag PrimaryCtype: %s",  $message->ctype_primary));
        if(strcasecmp($message->ctype_primary,"multipart")==0 && isset($message->parts) && is_array($message->parts)) {
            GroupeMail::setAttachmentsRecursive($groupe->box . ":" . $groupe->id,$message,$output);
 		}
		// unset mimedecoder & mail
		unset($mobj);
		unset($mail);
		unset($message);
		//debugLog('groupe2mail:'.print_r($output,1));
		return $output;
    }
    function message2groupe($message,$groupe) {
		//debugLog(print_r($groupe,1));
		return $groupe;
    }
	static function getAttachmentsRecursive($message,&$export_msg) {

		if(!isset($message->ctype_primary)) return;

		if(isset($message->body)) {
	//	    debugLog($message->ctype_primary." ".$message->ctype_secondary." ".(isset($message->ctype_parameters['charset']) ? trim($message->ctype_parameters['charset']) : ""));
			if (isset($message->d_parameters['filename'])) {
				$attname = $message->d_parameters['filename'];
			} elseif(isset($message->ctype_parameters['name'])) {
				$attname = $message->ctype_parameters['name'];
			} elseif(isset($message->headers['content-description'])) {
				$attname = $message->headers['content-description'];
			} else {
				$attname = "unknown attachment";
			}
			debugLog(sprintf("getAttachmentsRecursive: disposition:%s, filename:%s, content-id:%s",isset($message->disposition)?$message->disposition:'',$attname,isset($message->headers['content-id'])?$message->headers['content-id']:''));

			if (isset($message->headers['content-id']) &&
				(!isset($message->disposition) || strtolower($message->disposition) == 'inline') && strtolower($message->ctype_primary) == 'image') {
				$export_msg->addHTMLImage($message->body,
						trim($message->headers['content-type']),
						$attname,
						false,
						substr(trim($message->headers['content-id']),1,-1));
			} elseif (isset($message->d_parameters) && $message->d_parameters['filename']) {
				$export_msg->addAttachment($message->body,
						trim($message->ctype_primary)."/".trim($message->ctype_secondary),
						$attname,
						false,
						trim($message->headers['content-transfer-encoding']),
						trim($message->disposition),
						(isset($message->ctype_parameters['charset']) ? trim($message->ctype_parameters['charset']) : ""));
			}
		}
        if(strcasecmp($message->ctype_primary,"multipart")==0 && isset($message->parts) && is_array($message->parts)) {
           	foreach($message->parts as $part) {
               GroupeMail::getAttachmentsRecursive($part,$export_msg);
           	}
 		}
    }
   static function setAttachmentsRecursive($msgid,$message,$output,$partno='0') {
	   ZLog::Write(LOGLEVEL_DEBUG, sprintf("setAttachmentsRecursive: primary:%s, content_id:%s, disposition:%s", $message->ctype_primary,isset($message->headers['content-id'])?$message->headers['content-id']:'',isset($message->disposition)?$message->disposition:''));
        if ($partno=='0') {
			$mno='';
			if (!isset($message->parts)) $partno='1';
        } else $mno=$partno.'.';

        $attType=0;
        if (isset($message->ctype_primary) && isset($message->headers['content-id']) && strcasecmp($message->ctype_primary,"image")==0) {
			//Inline Bild
			$attType=2;
		} elseif(isset($message->disposition) && $message->disposition == "attachment") {
			//Attachment
			$attType=1;
		}

		if ($attType) {
			if (Request::GetProtocolVersion() >= 12.0) {
				$attachment = new SyncBaseAttachment();
			} else {
				$attachment = new SyncAttachment();
			}
			if (isset($message->d_parameters['filename'])) {
				$attname = $message->d_parameters['filename'];
			} elseif(isset($message->ctype_parameters['name'])) {
				$attname = $message->ctype_parameters['name'];
			} elseif(isset($message->headers['content-description'])) {
				$attname = $message->headers['content-description'];
			} else {
				$attname = "unknown attachment";
			}
			$attachment->displayname = ($attname);


			if (Request::GetProtocolVersion() >= 12.0) {
				$attachment->filereference =  BackendGroupe::strToHex($msgid . ":" . $partno);
				$attachment->method = 1;
				$attachment->estimatedDataSize = 0;
				if (isset($message->body)) {
					$attachment->estimatedDataSize = strlen($message->body);
				}
				if ($attType==2) {
					$attachment->contentid=trim($message->headers['content-id']);
					$attachment->isinline=1;
				}
				if(!isset($output->asattachments)) {
					$output->asattachments = array();
				}
				ZLog::Write(LOGLEVEL_DEBUG, sprintf("setAttachmentsRecursive: %s, attType: %d", $attachment->filereference,$attType));
				array_push($output->asattachments, $attachment);
			}
			else {
				$attachment->attmethod=1;
				$attachment->attsize = 0;
				if (isset($message->body)) {
					$attachment->attsize = strlen($message->body);
				}
				$attachment->attname =  BackendGroupe::strToHex($msgid . ":" . $partno);
				if ($attType==2) {
					$attachment->attmethod=6;
				}
				$attachment->attoid = isset($message->headers['content-id']) ? trim($message->headers['content-id']) : "";
				if(!isset($output->attachments)) {
					$output->attachments = array();
				}
				ZLog::Write(LOGLEVEL_DEBUG, sprintf("setAttachmentsRecursive: %s", $attachment->attname));
				array_push($output->attachments, $attachment);
			}
		}
		//debugLog(print_r($message->ctype_primary,1));

        if(isset($message->ctype_primary) && strcasecmp($message->ctype_primary,"multipart")==0 && isset($message->parts) && is_array($message->parts)) {
           	foreach($message->parts as $count=>$part) {
               GroupeMail::setAttachmentsRecursive($msgid,$part,$output,$mno.($count+1));
           	}
 		}

	}
    static function html2plain($html) {
		// remove css-style tags
		$plain = preg_replace("/<style.*?<\/style>/is", "", $html);
		// remove all other html
		$plain = preg_replace("/<br.*>/is","<br>",$plain);
		$plain = preg_replace("/<br >/is","<br>",$plain);
		$plain = preg_replace("/<br\/>/is","<br>",$plain);
		$plain = str_replace("<br>","\r\n",$plain);
		$plain = strip_tags($plain);
		$plain = str_replace("\n","\r\n", str_replace("\r","",$plain));
		return $plain;
	}

    
	
    // Get all parts in the message with specified type and concatenate them together, unless the
    // Content-Disposition is 'attachment', in which case the text is apparently an attachment
    static function getBodyRecursive($message, $subtype, &$body) {
        if(!isset($message->ctype_primary)) return;
        if(strcasecmp($message->ctype_primary,"text")==0 && strcasecmp($message->ctype_secondary,$subtype)==0 && isset($message->body))
            $body .= $message->body;

        if(strcasecmp($message->ctype_primary,"multipart")==0 && isset($message->parts) && is_array($message->parts)) {
            foreach($message->parts as $part) {
                if(!isset($part->disposition) || strcasecmp($part->disposition,"attachment")!=0)  {
                    GroupeMail::getBodyRecursive($part, $subtype, $body);
                }
            }
        }
    }}

?>