<?php
class GroupeTask {
	public $_mapping = array();
	public $_deviceProperties;
	public $_syncSettings;
	function __construct() {

    }
	function setDeviceProperties($val) {
		$this->_deviceProperties=$val;
	}
	function setSyncSettings($val) {
		$this->_syncSettings=$val;
	}
    function groupe2message($groupe,$contentparameters) {
    	debugLog('groupe2task');
		$message=new SyncTask();
		BackendGroupe::setMessageBody($message,isset($groupe->Text)?$groupe->Text:'',$contentparameters);
		$message->subject=$groupe->Title;
		$message->categories=$groupe->Categories;


		$message->utcstartdate=$groupe->StartDate;
		$message->utcduedate=$groupe->EndDate;
		$message->startdate=$groupe->StartDate+date('Z');
		$message->duedate=$groupe->EndDate+date('Z');
		//debugLog('StartDate:'.date('d.m.Y H:i',$message->startdate));

		switch($groupe->Priority) {
			case 0:
				$message->importance=2;
			break;
			case 1:
				$message->importance=1;
			break;
			case 2:
				$message->importance=0;
			break;
		}
		if ($groupe->UserDone==4 || $groupe->Status==4) {
			$message->complete=1;
			$message->datecompleted=$groupe->StatusDate;
		} else {
			$message->complete=0;
		}
		if ($groupe->Alarm) {
			$message->reminderset=0;
			$message->remindertime=$groupe->EndDate-$groupe->Alarm*3600*38;
		}
		switch($groupe->UserTaskType) {
			case 't':
				$message->sensitivity=0;
			break;
			case 'd':
				$message->sensitivity=0;
			break;
			case 'p':
				$message->sensitivity=2;
			break;
			case 'o':
				$message->sensitivity=2;
			break;
		}


		if ($groupe->RecType && $groupe->RecInt) {
			$message->recurrence=new SyncTaskRecurrence();
			$message->recurrence->start=$message->startdate;
			$message->recurrence->interval=$groupe->RecInt;
			//$message->recurrence->regenerate=1;
			if ($groupe->RecDate!=-1) $message->recurrence->until=$groupe->RecDate;
			switch($groupe->RecType) {
				case 1:
					$message->recurrence->type=0;
				break;
				case 2:
					$message->recurrence->type=1;
					$message->recurrence->dayofweek=pow(2,date('w',$groupe->StartDate));
				break;
				case 3:
					$message->recurrence->type=2;
					$message->recurrence->dayofmonth=date('d',$groupe->StartDate);
				break;
				case 5:
					$message->recurrence->type=5;
					$message->recurrence->dayofmonth=date('d',$groupe->StartDate);
					$message->recurrence->monthofyear=date('m',$groupe->StartDate);
				break;
			}
		}
    	//debugLog(print_r($message,1));
   		return $message;
    }
    function message2groupe($message,$groupe) {
    	//global $user;
    	debugLog('task2groupe');

		BackendGroupe::convertMessageBody($message);

  		//debugLog(print_r($message,1));

		if (!isset($message->utcstartdate) || !$message->utcstartdate) {
			$groupe->StartDate=mktime(0,0,0);
		} else {
			$groupe->StartDate=$message->utcstartdate;
		}
		if (!isset($message->utcduedate) || !$message->utcduedate) {
			$groupe->EndDate=$groupe->StartDate;
		} else {
			$groupe->EndDate=$message->utcduedate;
		}
		$groupe->Title=$message->subject;
		$groupe->Text=isset($message->body)?$message->body:'';
		$groupe->Categories=isset($message->categories)?$message->categories:array();

		switch($message->importance) {
			case 0:
				$groupe->Priority=2;
			break;
			case 1:
				$groupe->Priority=1;
			break;
			case 2:
				$groupe->Priority=0;
			break;
		}
		if ($message->complete) {
			$groupe->UserDone=4;
			//$groupe->UserDone=4;
		} else {
			$groupe->UserDone=1;
		}
		if (isset($message->remindertime) && $message->remindertime) {
			$groupe->Alarm=floor(($message->duedate-$message->remindertime)/3600/24);
		} else {
			$groupe->Alarm=0;
		}

		$groupe->RecType=0;
		$groupe->RecInt=0;
		if (isset($message->recurrence)) {
			$badRecur=false;
			switch($message->recurrence->type) {
				case 0:
					$groupe->RecType=1;
				break;
				case 1:
					$groupe->RecType=2;
					//$message->recurrence->dayofweek=pow(2,date('w',$groupe->StartDate));
				break;
				case 2:
					$groupe->RecType=3;
					//$message->recurrence->dayofmonth=date('d',$groupe->StartDate);
				break;
				case 5:
					$groupe->RecType=5;
					//$message->recurrence->dayofmonth=date('d',$groupe->StartDate);
					//$message->recurrence->monthofyear=date('m',$groupe->StartDate);
				break;
				default:
					$badRecur=true;
				break;
			}
			if (!$badRecur) {
				if (isset($message->recurrence->interval) && $message->recurrence->interval) {
					$groupe->RecInt=$message->recurrence->interval;
				} else {
					$groupe->RecInt=0;
				}
				if (isset($message->recurrence->until) && $message->recurrence->until) {
					$groupe->RecDate=$message->recurrence->until;
				} else {
					$groupe->RecDate=-1;
					if (isset($message->recurrence->occurrences) && $message->recurrence->occurrences)  {
						$recCount=$message->recurrence->occurrences-1;
						$year=date('Y',$groupe->StartDate);
						$month=date('m',$groupe->StartDate);
						$day=date('d',$groupe->StartDate);
						switch ($groupe->RecType) {
							case 1:
								$groupe->RecDate=mktime(23,59,59,$month,$day+$groupe->RecInt*$recCount,$year);
							break;
							case 2:
								$groupe->RecDate=mktime(23,59,59,$month,$day+$groupe->RecInt*7*$recCount,$year);
							break;
							case 3:
								$groupe->RecDate=mktime(23,59,59,$month+$groupe->RecInt*$recCount,$day,$year);
							break;
							case 5:
								$groupe->RecDate=mktime(23,59,59,$month,$day,$year+$groupe->RecInt*$recCount);
							break;
						}
					}
				}
			} else {
				$groupe->RecType=0;
			}
		}
    	//debugLog(print_r($groupe,1));
   		return $groupe;
    }

}
?>